;            ͻ
;                   ADLIB.INC       
;                                                               
;                       --== Mod Master v2.2 ==--           
;            ĺ
;               Auteur Freddy Vtel    
;                                                               
;               Dbut d'criture 14/08/1995       
;               Dernire modification 17/01/1996       
;            ͼ

;Sauvegarde des registres pour les voies

Old_KSL_TL1 DB 9 DUP (0)   ;Niveau total des 9 Modulateurs.
Old_KSL_TL2 DB 9 DUP (0)   ;Niveau total des 9 Porteuses.
Old_Key     DB 9 DUP (0)   ;Key et valeurs de frquence des 9 Voies
Old_FB      DB 9 DUP (0)   ;Niveau de rtroaction et type de synthse.

;Offset des modulateurs pour les 9 Voies (+3 pour les porteuses)

Offset_Op DB 00h,01h,02h,08h,09h,0Ah,10h,11h,12h

;Registres Adlib

Reg_AM_VIB EQU 020h
Reg_KSL_TL EQU 040h   ;KSL et Niveau total.
Reg_AR_DR  EQU 060h   ;Vitesse d'attaque et Vitesse de dcroissance.
Reg_SL_RR  EQU 080h   ;Niveau soutenu et vitesse de relachement.
Reg_WS     EQU 0E0h   ;Wave Select.
Reg_FB_FM  EQU 0C0h   ;Feed Back et Type de modulation.

Reg_Key    EQU 0B0h

Offset_Modulateur DB 0

;Ŀ
;  EcrireOPL2: Programmer les registres OPL2                
;                                                           
; Entre: AH, N du registre                                
;         AL, Donne                                        
;

AdlibLoop Proc Near
lp:
  IN AL,DX
  LOOP lp
  RET
AdlibLoop Endp

EcrireOPL2 Proc Near
    PUSH CX DX
    PUSH AX
    MOV DX,388h
    MOV AL,AH
    OUT DX,AL

    MOV CX,10 ;6
    CALL AdLibLoop

    INC DX
    POP AX
    OUT DX,AL

    DEC DX
    MOV CX,40 ;35
    CALL AdLibLoop
    POP DX CX
    RET
EcrireOPL2 Endp

Voie_OPL2 DW 0

Programmer_OPL2 Proc Near

        MOV Voie_OPL2,0
        MOV CL,9                    ;9 voies Adlib
        XOR CH,CH
Commander_OPL2:
        PUSH CX
        MOV BX,Voie_OPL2
        MOV BL,Voies_Adlib[BX]      ;Chercher la voie relle
        CMP BL,0
        JZ  Pas_Changer_Volume_OPL2 ;Voie non alloue => Fin
        DEC BX
        MOV Voie_Reelle,BX

        MOV BX,Voie_OPL2            ;Calcul de l'offset des oprateurs...
        MOV AH,Offset_Op[BX]
        MOV Offset_Modulateur,AH

        MOV BX,Voie_Reelle
        TEST VControle[BX],M_KeyOff       ;KeyOff ?
        JZ OPL2_Pas_KeyOff
        AND VControle[BX],Not M_KeyOff    ;Dsactiver le KeyOff
        OR VControle[BX],M_Pas_Active     ;Dsactiver la voie
        CALL KeyOff_OPL2
        JMP Pas_Changer_Volume_OPL2       ;KeyOff =>Fin
OPL2_Pas_KeyOff:

        MOV BX,Voie_Reelle
        TEST VControle[BX],M_Stoppee
        JE Pas_stop_voie_OPL2
        JMP Pas_Changer_Volume_OPL2 ;Si voie stoppe =>Fin
Pas_stop_voie_OPL2:

        MOV BX,Voie_Reelle
        TEST GUS_Controle[BX],M_ChPeriode    ;Changer la priode ???
        JZ Pas_Changer_Periode_OPL2
        AND GUS_Controle[BX],Not M_ChPeriode ;Efface le Bit

        CALL Changer_Periode_OPL2

Pas_Changer_Periode_OPL2:
        MOV BX,Voie_Reelle
        TEST GUS_Controle[BX],M_ChSample     ;Changer le sample ???
        JZ Pas_Changer_Sample_OPL2
        AND GUS_Controle[BX],Not M_ChSample  ;Efface le Bit
        OR GUS_Controle[BX],M_ChVolume       ;Modifier le volume !!!!

        CALL Changer_Sample_OPL2

Pas_Changer_Sample_OPL2:

        MOV BX,Voie_Reelle                   ;Changer le volume ???
        TEST GUS_Controle[BX],M_ChVolume
        JZ Pas_Changer_Volume_OPL2
        AND GUS_Controle[BX],Not M_ChVolume  ;Efface le Bit

        CALL Changer_Volume_OPL2

Pas_Changer_Volume_OPL2:

        INC Voie_OPL2
        POP CX                      ; Fin des commandes pour la voie
        LOOP Boucle_Commander_OPL2  ; Boucler Nb_de_voies fois
        JMP Fin_Commander_OPL2
Boucle_Commander_OPL2:
        JMP Commander_OPL2
Fin_Commander_OPL2:
        RET
Programmer_OPL2 Endp

KeyOff_OPL2 Proc Near
        MOV BX,Voie_OPL2
        MOV AH,BL
        ADD AH,Reg_Key
        MOV AL,Old_Key[BX]
        AND AL,Not 20h                ;Efface le bit Key => Key Off
        CALL EcrireOPL2
        RET
KeyOff_OPL2 Endp

KeyOff1_OPL2 Proc Near
        MOV AH,Offset_Modulateur      ;Couper la voie...
        ADD AH,Reg_KSL_TL
        MOV AL,0FFh                   ;Niveau du modulateur=63 => Volume 0
        CALL EcrireOPL2

        MOV AH,Offset_Modulateur
        ADD AH,Reg_KSL_TL+3
        MOV AL,0FFh                   ;Niveau de la porteuse=63 => Volume 0
        CALL EcrireOPL2

        MOV BX,Voie_OPL2
        MOV AH,BL
        ADD AH,Reg_Key
        MOV AL,Old_Key[BX]
        AND AL,Not 20h                ;Efface le bit Key => Key Off
        CALL EcrireOPL2
        RET
KeyOff1_OPL2 Endp

;Ŀ
;                  Changer_Sample_OPL2                      
;

Changer_Sample_OPL2 Proc Near

        CALL KeyOff1_OPL2

        MOV BX,Voie_Reelle
        TEST VControle[BX],M_Pas_Active ;Voie active ?
        JNZ Fin_Changer_Sample_OPL2

        SHL BX,2                      ;BX <- 4*Voie
        LES DI,VPtrSample[BX]         ;Pointeur sur le sample
                                      ;* Ecrire l'instrument *


        MOV BX,Voie_OPL2
        MOV AH,Offset_Modulateur
        ADD AH,Reg_AM_VIB
        MOV AL,ES:AM1[DI]
        CALL EcrireOPL2
        MOV AH,Offset_Modulateur
        ADD AH,Reg_AM_VIB+3
        MOV AL,ES:AP1[DI]
        CALL EcrireOPL2

        MOV AH,Offset_Modulateur
        ADD AH,Reg_KSL_TL
        MOV AL,ES:AM2[DI]
        MOV BX,Voie_OPL2
        MOV Old_KSL_TL1[BX],AL        ;Sauvegarde le niveau du modulateur
        CALL EcrireOPL2
        MOV AH,Offset_Modulateur
        ADD AH,Reg_KSL_TL+3
        MOV AL,ES:AP2[DI]
        MOV BX,Voie_OPL2
        MOV Old_KSL_TL2[BX],AL        ;Sauvegarde le niveau de la porteuse
        CALL EcrireOPL2

        MOV AH,Offset_Modulateur
        ADD AH,Reg_AR_DR
        MOV AL,ES:AM3[DI]
        CALL EcrireOPL2
        MOV AH,Offset_Modulateur
        ADD AH,Reg_AR_DR+3
        MOV AL,ES:AP3[DI]
        CALL EcrireOPL2

        MOV AH,Offset_Modulateur
        ADD AH,Reg_SL_RR
        MOV AL,ES:AM4[DI]
        CALL EcrireOPL2
        MOV AH,Offset_Modulateur
        ADD AH,Reg_SL_RR+3
        MOV AL,ES:AP4[DI]
        CALL EcrireOPL2

        MOV AH,Offset_Modulateur
        ADD AH,Reg_WS
        MOV AL,ES:AM5[DI]
        CALL EcrireOPL2
        MOV AH,Offset_Modulateur
        ADD AH,Reg_WS+3
        MOV AL,ES:AP5[DI]
        CALL EcrireOPL2
                     
        MOV AH,Offset_Modulateur
        ADD AH,Reg_FB_FM
        MOV AL,ES:AFeedBack[DI]
        MOV BX,Voie_OPL2
        MOV Old_FB[BX],AL
        CALL EcrireOPL2

        MOV BX,Voie_OPL2
        MOV AL,Old_Key[BX]
        MOV AH,BL
        ADD AH,Reg_Key
        OR  AL,20h                ;bit Key  1 => Key On
        MOV BX,Voie_OPL2          ;Sauver la valeur du registre Key
        MOV Old_Key[BX],AL
        CALL EcrireOPL2

Fin_Changer_Sample_OPL2:

        RET
Changer_Sample_OPL2 Endp

;Entre EAX,Frquence
Fr   DD 0
FNum DW 0
Bloc DB 0

Chercher_FNum Proc Near    ;Augmenter la prcision si ncessaire...
        MOV Fr,EAX
        MOV FNum,0
        MOV Bloc,0
        CMP EAX,0
        JZ Fin_Chercher_FNum
        MOV Bloc,5
        CMP EAX,127*32
        JAE Test_Sup_493
Mul2:
        DEC Bloc
        SHL EAX,1
        CMP EAX,127*32  ;261*32
        JB Mul2
        JMP Calcul_FNum
Test_Sup_493:
        CMP EAX,1023*32 ;493*32
        JBE Calcul_FNum
Div2:
        INC Bloc
        SHR EAX,1
        CMP EAX,1023*32 ;493*32
        JA Div2
Calcul_FNum:
        MOV EAX,Fr
        MOV CL,15  ;20
        SUB CL,Bloc
        SHL EAX,CL
        XOR EDX,EDX
        MOV ECX,49716
        DIV ECX
        MOV FNum,AX    ;FNum = Freq SHL (20-Bloc) /49716
Fin_Chercher_FNum:
        RET
Chercher_FNum Endp

;Ŀ
;                 Changer_Periode_OPL2                      
;

Changer_Periode_OPL2 Proc Near

        MOV BX,Voie_Reelle
        SHL BX,2                 ;Pointeur Double Mot
        MOV EAX,[BX+Frequence_GUS]

        CALL Chercher_FNum

        MOV AX,FNum
        MOV BX,Voie_OPL2
        MOV AH,BL
        ADD AH,0A0h              ;Registre Nb F
        CALL EcrireOPL2

        MOV BX,Voie_OPL2
        MOV BL,Old_Key[BX]
        AND BL,11100000b
        MOV AX,FNum
        OR  BL,AH         ;Ajouter la partie haute de F
        MOV AH,Bloc
        AND AH,00000111b
        SHL AH,2
        OR BL,AH          ;Ajouter Bloc
        MOV AL,BL

        MOV BX,Voie_OPL2
        MOV AH,BL
        ADD AH,Reg_Key    ;Registre Key (Bloc et partie haute de F)
        MOV Old_Key[BX],AL
        CALL EcrireOPL2

        RET
Changer_Periode_OPL2 Endp

;Ŀ
;                 Changer_Volume_OPL2                       
;

; Table de volume...

Vol_OPL2 DB 63,56,48,43,40,37,35,33,32,31,29,28,27,26,25,25
         DB 24,23,23,22,21,21,20,20,19,19,18,18,18,17,17,16
         DB 16,16,15,15,15,14,14,14,13,13,13,13,12,12,12,12
         DB 11,11,11,11,10,10,10,10,10, 9, 9, 9, 9, 9, 8, 8
         DB  8, 8, 8, 7, 7, 7, 7, 7, 7, 6, 6, 6, 6, 6, 6, 5
         DB  5, 5, 5, 5, 5, 5, 4, 4, 4, 4, 4, 4, 4, 4, 3, 3
         DB  3, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 2, 2
         DB  1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0

OldVol DB 0

Modifier_Vol_OPL2 Proc Near
        MOV OldVol,AL
        AND OldVol,11000000b    ;Garder KSL seulement
        AND AL,00111111b
        MOV BX,Voie_Reelle
        MOV BL,VVolume[BX]
        ADD AL,Vol_OPL2[BX]     ;Calcul de TL
        CMP AL,63
        JBE Pas_Couper_Vol_OPL2
        MOV AL,63
Pas_Couper_Vol_OPL2:
        OR AL,OldVol            ;Ajouter KSL  TL
        RET
Modifier_Vol_OPL2 Endp

Changer_Volume_OPL2 Proc Near

        MOV BX,Voie_OPL2
        MOV AL,Old_KSL_TL2[BX]  ;Volume de la porteuse
        CALL Modifier_Vol_OPL2  ;Modifier le volume
        MOV AH,Offset_Modulateur
        ADD AH,Reg_KSL_TL+3
        CALL EcrireOPL2         ;Sauve le volume de la porteuse

        MOV BX,Voie_OPL2

        TEST Old_FB[BX],1
        JZ Vol_FM               ;Si FM, Ne pas changer le modulateur

        MOV BX,Voie_OPL2
        MOV AL,Old_KSL_TL1[BX]  ;Volume de la porteuse
        CALL Modifier_Vol_OPL2  ;Modifier le volume
        MOV AH,Offset_Modulateur
        ADD AH,Reg_KSL_TL
        CALL EcrireOPL2         ;Sauve le volume de la porteuse

Vol_FM:
        RET
Changer_Volume_OPL2 Endp
