
WRITE MACRO x         ;Macro criture
      MOV AL,x        ;      ! Change AX
      MOV AH,0Eh
      INT 10h
ENDM

;Ŀ
;   WriteXY      Affiche un message dans la mmoire vido   
;     Entre:                                               
;            SI=offset du message (ASCIIZ)                  
;            DI=adresse dans la mmoire vido (texte)       
;            AH=attribut couleur                            
;     Sortie: Rien                                          
;     Change                                                
;
WriteXY PROC NEAR
         LODSB
wr_Boucle_aff:
         STOSW
         LODSB
         OR AL,AL
         JNZ wr_boucle_aff
         RET
WriteXY ENDP


;Ŀ
; WriteXY2     Affiche un message de 2 couleurs diffrentes 
;     Entre:                                               
;            SI=offset du message (ASCIIZ, sparateur='^')  
;            DI=adresse dans la mmoire vido (texte)       
;            AH=attribut couleur principal                  
;            BH=attribut couleur secondaire                 
;     Sortie: Rien                                          
;     Change                                                
;
WriteXY2 PROC NEAR
         LODSB
boucle_aff_car:
         CMP AL,'^'             ; caractre de contrle?
         JNE affiche_car        ; non
         XCHG AH,BH             ; change les 2 attributs
         JMP SHORT saute_controle
 affiche_car:
         STOSW
 saute_controle:
         LODSB
         OR AL,AL
         JNZ boucle_aff_car
         RET
WriteXY2 ENDP


;Ŀ
;     Affichedb   Affiche la valeur dans AX en HEXA         
;     Entre      AX                                        
;     Sortie      Rien                                      
;     Change      AX,ES,SI,DI                               
;     Remarque    Utilise Afficheb                          
;
Affichedb PROC NEAR
      PUSH AX
      MOV AL,AH
      CALL AFFICHEB
      POP AX
      CALL AFFICHEB
      RET
Affichedb ENDP


;Ŀ
;     Afficheb   Affiche la valeur dans AL en HEXA          
;     Entre     AL                                         
;     Sortie     Rien                                       
;     Change     AX,ES,SI,DI                                
;
Afficheb PROC NEAR
      PUSH DS
      PUSH AX             ;Valeur  afficher
      SHR AL,4            ;Divise par 16
      ADD AL,90h          ;Remplace
      DAA                 ;AL
      ADC AL,40h          ;par caractre
      DAA                 ;ASCII
      MOV AH,0Eh          ;Sortie de caractre sous BIOS
      INT 10h
      POP AX
      AND AL,0Fh          ;Reste de la division par 2^4
      ADD AL,90h          ;Remplace
      DAA                 ;AL
      ADC AL,40h          ;par caractre
      DAA                 ;ASCII
      MOV AH,0Eh          ;Sortie de caractre sous BIOS
      INT 10h
      POP DS
      RET                 ;Redonne la main
Afficheb ENDP


;Ŀ
;     Affiche_p_xy Affiche la valeur dans AX en HEXA        
;     Entre      AX                                        
;                 DI:Position x,y  (2*x+160*y)              
;     Sortie      Rien                                      
;     Change      AX                                        
;     Remarque    Utilise Affichebxy                        
;
Affiche_p_xy PROC NEAR
      PUSH AX
      MOV AL,AH
      AND AL,0Fh          ;Reste de la division par 2^4
      ADD AL,90h          ;Remplace
      DAA                 ;AL
      ADC AL,40h          ;par caractre
      DAA                 ;ASCII

      MOV AH,7
      STOSW
      POP AX
      MOV BH,7
      CALL Affichebxy
      RET
Affiche_p_xy ENDP


;Ŀ
;     Affichedbxy Affiche la valeur dans AX en HEXA         
;     Entre      AX                                        
;                 DI:Position x,y  (2*x+160*y)              
;     Sortie      Rien                                      
;     Change      AX,BX,DX,ES                               
;     Remarque    Utilise Affichebxy                        
;
Affichedbxy PROC NEAR
        PUSH AX
        MOV AL,AH
        CALL AFFICHEBXY
        POP AX
        CALL AFFICHEBXY
        RET
Affichedbxy ENDP


;Ŀ
;     Affichebxy   Affiche la valeur dans AL en HEXA        
;     Entre     AL:valeur,    BH:attribut couleur          
;                DI:Position x,y  2*(x-1)+160*(y-1)         
;     Sortie     Rien                                       
;     Change     AX                                         
;
Affichebxy PROC NEAR
      PUSH AX             ;Valeur  afficher
      SHR AL,4            ;Divise par 16
      ADD AL,90h          ;Remplace
      DAA                 ;AL
      ADC AL,40h          ;par caractre
      DAA                 ;ASCII

      MOV AH,BH
      STOSW

      POP AX
      AND AL,0Fh          ;Reste de la division par 2^4
      ADD AL,90h          ;Remplace
      DAA                 ;AL
      ADC AL,40h          ;par caractre
      DAA                 ;ASCII

      MOV AH,BH
      STOSW
      RET                 ;Redonne la main
Affichebxy ENDP


;Ŀ
;  BIA8        AFFICHE UN NOMBRE 8 BITS EN DECIMAL          
;  Entres:    AL=nombre  afficher                         
;              BH=0: affiche un ' '  la place du chiffre   
;                    des dizaines s'il est nul (et AL<100)  
;              BH=1: affiche toujours les dizaines          
;              BL=attribut couleur                          
;              DI=adresse dans la mmoire vido (texte)     
;  Sortie:     Rien                                         
;  Change:     AX,BX,CX,DI,Flags                            
;                                                           
;  Remarques:  - Si AL>=100, le chiffre des centaines est   
;                 affich en DI-1                           
;
Bia8      PROC NEAR
          CMP AL,100
          JB inf_cent            ;nombre<100

          MOV BH,1               ;affiche toujours les dizaines si AL>=100
          XOR AH,AH
          MOV CL,100
          DIV CL                 ;AX/100 (AL=quotient, AH=reste)
          ADD AL,'0'             ;convertit en ASCII
          PUSH AX
          MOV AH,BL              ;AH=attribut
          DEC DI
          DEC DI                 ;chiffre des centaines en retrait  gauche
          STOSW                  ;affiche centaines
          POP AX
          MOV AL,AH              ;AL=reste (dizainesunits)

inf_cent:
          XOR AH,AH
          MOV CL,10
          DIV CL                 ;AX/10 (AL=quotient, AH=reste)
          ADD AX,'0'*256+'0'     ;convertit en ASCII
          PUSH AX
          CMP BH,1
          JE affiche_dizaines    ;affiche toujours les dizaines

          CMP AL,'0'
          JNE affiche_dizaines
          MOV AL,' '
affiche_dizaines:
          MOV AH,BL              ;AH=attribut
          STOSW                  ;affiche dizaines (ou ' ')
          POP AX
          MOV AL,AH              ;AL=units
          MOV AH,BL              ;AH=attribut
          STOSW                  ;affiche units
          RET
Bia8      ENDP


;Ŀ
;  BIA16       AFFICHE UN NOMBRE 16 BITS (<999) EN DECIMAL  
;  Entres:    AX=nombre  afficher (999 max)               
;              BH=0: affiche un ' '  la place du chiffre   
;                    des dizaines s'il est nul (et AX<100)  
;              BH=1: affiche toujours les dizaines          
;              BL=attribut couleur                          
;              DI=adresse dans la mmoire vido (texte)     
;  Sortie:     Rien                                         
;  Change:     AX,BX,CX,DI,Flags                            
;                                                           
;  Remarques: - Utilise BIA8                                
;
Bia16     PROC NEAR
          MOV CL,100
          DIV CL                 ;AX/100 (AL=quotient, AH=reste)
          OR AL,AL               ;centaines=0 ?
          JZ affiche_espace      ;oui
          ADD AL,'0'             ;convertit en ASCII
          MOV BH,1               ;affiche toujours les dizaines si AL>=100
          JMP SHORT affiche_centaines
affiche_espace:
          MOV AL,' '             ;espace
affiche_centaines:
          PUSH AX
          MOV AH,BL              ;AH=attribut
          STOSW                  ;affiche centaines (ou ' ')
          POP AX
          MOV AL,AH              ;AL=reste (dizainesunits)
          CALL BIA8
          RET
Bia16     ENDP


;Ŀ
;  Decimal16   AFFICHE UN NOMBRE 16 BITS EN DECIMAL         
;  Entres:    AX=nombre  afficher                         
;              BH=attribut couleur                          
;              DI=adresse dans la mmoire vido (texte)     
;  Sortie:     Rien                                         
;  Change:     AX,BX,CX,DX,DI,Flags                         
;                                                           
;
Decimal16 PROC NEAR
          MOV AX,0B800h           ;ES => Segment video (Texte couleur...)
          MOV ES,AX

          XOR DX,DX
          MOV CX,10
          DIV CX
          MOV BL,AL
          ADD BL,'0'
          MOV ES:[DI],BX
          SUB DI,4

          XOR DX,DX
          MOV CX,10
          DIV CX
          MOV BL,AL
          ADD BL,'0'
          MOV ES:[DI],BX
          SUB DI,4

          XOR DX,DX
          MOV CX,10
          DIV CX
          MOV BL,AL
          ADD BL,'0'
          MOV ES:[DI],BX
          SUB DI,4

          XOR DX,DX
          MOV CX,10
          DIV CX
          MOV BL,AL
          ADD BL,'0'
          MOV ES:[DI],BX

          RET
Decimal16 ENDP

