;Ŀ
;                 **** GESTIONNAIRE D'ALARMES RESIDENT ****                
;                                                                          
;  Auteur: Fabrice COUTEAU            Dbut d'criture 24/02/1996  
;                                     Dernire modification 05/07/1998  
;ĳ
; - installation    : ALARME [<heure>] [+<dlai>] [options]                
; - aprs installation:                                                    
;    affichage liste: ALARME                                               
;    modification   : ALARME [<heure>] [+<dlai>] [-<numro>] [options]    
; - dsinstallation : ALARME /R                                            
;

ASSUME CS:CODE

CODE SEGMENT
     ORG 100h                   ; programme COM

debut:        jmp PROG          ; point d'entre

B EQU BYTE PTR
W EQU WORD PTR

oui EQU 1
non EQU 0

; donnes rsidentes --------------------------------------

ancINT08      DD 0              ; ancienne adresse de int 08h (timer)
compteur_sec  DB 0              ; compteur incrment de 5  chaque int. timer
                                ; (18.2 fois/sec.), dtecte une seconde lorsque
                                ; sa valeur atteint ou dpasse 91
ident         DB "AL"           ; chane d'identification du programme

; notes
Do  EQU 0
Re  EQU 2
Mi  EQU 4
Fa  EQU 5
Sol EQU 7
La  EQU 9
Si_ EQU 11

bemol EQU -1
diese EQU +1

silence EQU 16*9+Do     ; note inaudible !

; format des notes: 16*octave+note[+bemol|diese]
alarme0 DB 16*5+Mi,16*5+Do,16*5+Mi,16*5+Do,16*5+Mi,16*5+Do
alarme1 DB 16*3+La,16*4+Mi,16*4+La,16*5+Mi,16*5+La,16*6+La
alarme2 DB 16*6+Mi,silence,16*6+Mi,silence,16*6+Mi,silence,16*6+Mi,silence
alarme3 DB 16*4+Do,16*4+Do,16*4+Do,16*4+Sol,16*4+Sol,16*4+Sol,16*4+Mi,16*4+Mi
alarme4 DB 16*5+Si_,16*4+Si_,16*5+Si_,16*4+Si_,16*5+Si_,16*4+Si_
alarme5 DB 16*6+Do,16*6+Mi,16*6+Sol,16*6+Do,16*6+Mi,16*6+Sol,16*6+Do,16*6+Mi,16*6+Sol
alarme6 DB 16*3+La,16*4+Fa,16*4+La,16*4+Fa,16*3+La,16*4+Fa,16*4+La
alarme7 DB 16*5+Do,16*4+Sol,silence,16*5+Do,16*4+Sol,silence,16*5+Do,16*4+Sol,silence
alarme8 EQU $

s_notes_alarme STRUC
 nbr_notes DB ?
 ofs_notes DW ?
s_notes_alarme ENDS     ; 3 octets

notes_alarme s_notes_alarme <alarme1-alarme0,alarme0>
             s_notes_alarme <alarme2-alarme1,alarme1>
             s_notes_alarme <alarme3-alarme2,alarme2>
             s_notes_alarme <alarme4-alarme3,alarme3>
             s_notes_alarme <alarme5-alarme4,alarme4>
             s_notes_alarme <alarme6-alarme5,alarme5>
             s_notes_alarme <alarme7-alarme6,alarme6>
             s_notes_alarme <alarme8-alarme7,alarme7>

;valeurs pour l'octave 0: Do  Si avec # et b (12 notes)
FreqTimer0 DW 36485,34437,32505,30680,28958,27333,25799,24351,22984,21694,20477,19327

s_HMS STRUC
 heure DB ?
 min   DB ?
 sec   DB ?
s_HMS ENDS      ; 3 octets

; nombre de secondes max autoris: compteur_max = 60*60*24 = 86400 (1 jour)
compteur_max_H EQU 1
compteur_max_L EQU 20864

utilisee EQU 10000000b
active   EQU 01000000b
type_al  EQU 00000111b

s_alarme STRUC
 etat       DB 0        ; octet d'tat au format suivant:
;  7   6   5   4   3   2   1   0
;Ŀ
; U  A  0  0  0 type alarme
;
;     
;      alarme active: oui/non
;   alarme utilise: oui/non
 index_note DB 0        ; index de la note joue
 compteur   DD 0        ; nombre de secondes avant activation (1..compteur_max)
 progr s_HMS <?,?,?>    ; heure de programmation
 activ s_HMS <?,?,?>    ; heure d'activation
s_alarme ENDS   ; 12 octets

max_alarmes EQU 20
alarme s_alarme max_alarmes DUP(<>)

;----------------------------------------------------------

.386

INT08 PROC FAR
        pushf
        call ancINT08

        add compteur_sec,5
        cmp compteur_sec,91
        jb pas_nouvelle_seconde
        sub compteur_sec,91     ; corrige le dtecteur de seconde
pas_nouvelle_seconde:
        pusha

        xor BP,BP               ; offset dans tableau alarme
teste_alarme_utilisee:
        test alarme[BP].etat,utilisee
        jz  alarme_suivante     ; alarme non utilise
        test alarme[BP].etat,active
        jz  alarme_pas_active   ; alarme non active, mais activable
        call JoueNote
        cmp alarme[BP].index_note,CH    ; toutes les notes ont t joues?
        jne alarme_suivante             ; non, continue
        in  AL,61h
        and AL,11111100b
        out 61h,AL                      ; dsactive le haut-parleur
        and alarme[BP].etat,not (utilisee+active)
        jmp short alarme_suivante
    alarme_pas_active:
        cmp compteur_sec,4
        ja  alarme_suivante     ; si compteur_sec>4, pas de nouvelle seconde
        dec W alarme[BP].compteur
        jnz alarme_suivante
        cmp W alarme[BP].compteur+2,0
        jz  active_alarme
        dec W alarme[BP].compteur+2
        jmp short alarme_suivante
    active_alarme:
        or  alarme[BP].etat,active
        mov alarme[BP].index_note,0
        call JoueNote
        in  AL,61h
        or  AL,00000011b
        out 61h,AL              ; active le haut-parleur
    alarme_suivante:
        add BP,Size s_alarme
        cmp BP,max_alarmes*(Size s_alarme)
        jne teste_alarme_utilisee

        popa
        iret
INT08 ENDP


JoueNote PROC NEAR
; entres: BP=offset dans tableau alarme (=nalarme<0..max-1>*(Size s_alarme))
; sorties: CH=nombre de notes du type d'alarme
; modifie: AX CX

        push BX SI

        mov CL,Size s_notes_alarme
        mov AL,alarme[BP].etat
        and AL,type_al
        mul CL                  ; AX=offset dans tableau notes_alarme
        mov BX,AX
        mov CH,notes_alarme[BX].nbr_notes  ; CH=nombre de notes de l'alarme
        mov SI,notes_alarme[BX].ofs_notes  ; SI=offset 1re note de l'alarme
        mov BL,alarme[BP].index_note
        mov BL,CS:[SI+BX]       ; BX=16*octave+note
        mov CL,BL
        shr CL,4                ; CL=octave
        and BL,00001111b        ; BL=note
        shl BX,1
        mov AX,FreqTimer0[BX]
        shr AX,CL               ; dcale de la valeur de l'octave
        out 42h,AL              ; poids faible
        mov AL,AH
        out 42h,AL              ; poids fort
        inc alarme[BP].index_note

        pop SI BX
        ret
JoueNote ENDP

;----------------------------------------------------------

LitINT MACRO numero
        mov AX,3500h+numero
        int 21h
ENDM

EcritINT MACRO numero,routine
        mov AX,2500h+numero
        lea DX,routine
        int 21h
ENDM

TesteINT MACRO numero
        LitINT numero
        cmp W ES:ident,"LA"
ENDM

SauveINT MACRO numero,ancINT
        LitINT numero
        mov W [ancINT],BX
        mov W [ancINT+2],ES
ENDM

RestaureINT MACRO numero,ancINT
        lds DX,ES:ancINT
        mov AX,2500h+numero
        int 21h
ENDM

EchangeINT MACRO numero,ancINT,routine
        SauveINT numero,ancINT
        EcritINT numero,routine
ENDM

Print MACRO chaine
        lea DX,chaine
        mov AH,09h
        int 21h
ENDM

;----------------------------------------------------------
ASSUME DS:CODE

PROG PROC NEAR
        push CS
        pop DS
        TesteINT 08h            ; programme dj install?
        jne init_segment_ES
        mov prog_installe,oui   ; ES=segment TSR
        jmp short teste_presence_parametres
init_segment_ES:
        push CS
        pop ES

teste_presence_parametres:
        mov BL,CS:[128]         ; lit la longueur des paramtres de la ligne de commande
        or BL,BL
        jnz init_heure_courante ; il y a des paramtres

        mov etat_analyse,ok
        cmp prog_installe,oui
        jne affiche_syntaxe
        jmp affiche_titre_liste_alarmes
affiche_syntaxe:
        Print syntaxe_msg
        jmp fin_prog

init_heure_courante:
        mov AH,2Ch
        int 21h                 ; lit l'heure du DOS
        mov heure_courante,CH
        mov min_courante,CL
        mov sec_courante,DH

        cld
        mov SI,130              ; offset du 1er caractre ligne de commande
        xor BH,BH
        mov B [BX+SI-1],' '     ; ajoute un espace  la fin (ncessaire pour l'analyse)
        mov car_et_groupe,256*separateur+' '
analyse_parametres:
        mov AX,car_et_groupe
        mov anc_car_et_groupe,AX
        lodsb
        cmp AL,'0'
        jb  pas_chiffre
        cmp AL,'9'
        ja  pas_chiffre
        mov AH,chiffre
        jmp short groupe_car_trouve
    pas_chiffre:
        cmp AL,'a'
        jb  pas_lettre_min
        cmp AL,'z'
        ja  pas_lettre_min
        sub AL,'a'-'A'                  ; convertit en majuscule
    pas_lettre_min:
        mov AH,lettre_HMS
        cmp AL,'H'
        je  groupe_car_trouve
        cmp AL,'M'
        je  groupe_car_trouve
        cmp AL,'S'
        je  groupe_car_trouve           ; H,M,S
        mov AH,plus_moins
        cmp AL,'+'
        je  groupe_car_trouve
        cmp AL,'-'
        je  groupe_car_trouve           ; +,-
        mov AH,slash
        cmp AL,'/'
        je  groupe_car_trouve           ; /
        mov AH,lettre_opt
        cmp AL,'N'
        je  groupe_car_trouve
        cmp AL,'R'
        je  groupe_car_trouve           ; N,R
        mov AH,separateur
        cmp AL,' '
        je  groupe_car_trouve
        cmp AL,TAB                      ; ' ',TAB
        je  groupe_car_trouve
        mov etat_analyse,err_syntaxe    ; caractre invalide
        jmp erreur_param
    groupe_car_trouve:
        mov car_et_groupe,AX
        push AX
        mov AL,nombre_groupes
        mul groupe_anc_car
        add AL,groupe_car
        xor AH,AH               ; AX=groupe_anc_car*nombre_groupes+groupe_car
        mov DI,AX
        pop AX                  ; AH=groupe, AL=caractre
        shl DI,1                ; DI=offset action dans matrice (base 1,1)
    ; !! NE PAS MODIFIER BX 
        call action[DI-2*nombre_groupes-2]      ; excute l'action (base 0,0)
        cmp etat_analyse,ok
        je  etat_analyse_ok
        jmp erreur_param
    etat_analyse_ok:
        dec BL
        jz  fin_analyse
        jmp analyse_parametres

fin_analyse:
        cmp retire_prog,oui     ; option /R ?
        jne pas_retire_prog
        cmp prog_installe,oui
        jne impossible_retirer_prog
        jmp desinstalle
    impossible_retirer_prog:
        Print err_inst_msg
        jmp fin_prog
    pas_retire_prog:
        cmp prog_installe,oui
        je  teste_aff_liste
        Print ok_inst_msg       ; affiche message d'installation (va tre faite...)
    teste_aff_liste:
        cmp aff_liste,oui
        je  affiche_titre_liste_alarmes
        jmp fin_prog_teste_installe

affiche_titre_liste_alarmes:
        Print titre_liste_msg
        xor AL,AL               ; numro alarme
        xor BP,BP               ; offset dans tableau alarme
affiche_liste_alarmes:
        test ES:alarme[BP].etat,utilisee
        jnz affiche_alarme      ; alarme utilise
        jmp affiche_pas_alarme
    affiche_alarme:
        push AX                 ; sauvegarde nalarme

        inc AL
        aam
        add AX,'00'             ; convertit <nalarme>-1 en ASCII
        mov B [ofs_numero],AL   ; crit units
        cmp AH,'0'
        je  dizaines_num_zero
        mov B [ofs_numero-1],AH ; crit dizaines si <>0
    dizaines_num_zero:
        mov AL,ES:alarme[BP].progr.heure
        mov CH,ES:alarme[BP].progr.min
        mov CL,ES:alarme[BP].progr.sec
        lea DI,ofs_HMS_progr
        call Conv_HMS_ascii     ; crit heure programmation
        mov AL,ES:alarme[BP].activ.heure
        mov CH,ES:alarme[BP].activ.min
        mov CL,ES:alarme[BP].activ.sec
        lea DI,ofs_HMS_activ
        call Conv_HMS_ascii     ; crit heure activation
        mov DX,W ES:alarme[BP].compteur+2
        mov AX,W ES:alarme[BP].compteur
        call Compteur_to_HMS    ; calcule heure,min,sec
        mov CH,AH
        mov CL,DL
        lea DI,ofs_HMS_delai
        call Conv_HMS_ascii     ; crit dlai activation
        mov AL,ES:alarme[BP].etat
        and AL,type_al
        add AL,'0'
        mov B [ofs_type],AL     ; crit type d'alarme
        Print alarme_msg        ; affiche une ligne entire de la liste

        pop AX                  ; rcupre nalarme
    affiche_pas_alarme:
        inc AL
        add BP,Size s_alarme
        cmp BP,max_alarmes*(Size s_alarme)
        je  fin_prog_teste_installe
        jmp affiche_liste_alarmes

erreur_param:
        cmp etat_analyse,err_syntaxe
        jne pas_erreur_syntaxe
        Print err_param_msg
        jmp affiche_syntaxe
    pas_erreur_syntaxe:
        cmp etat_analyse,err_alarme
        jne fin_prog
        Print err_alarme_msg

fin_prog:
        mov AL,etat_analyse
        mov AH,4Ch
        int 21h                 ; fin programme

fin_prog_teste_installe:
        cmp prog_installe,oui
        jne installe            ; non install -> installe
        jmp short fin_prog

installe:
        EchangeINT 08h,ancINT08,INT08

        lea DX,PROG
        add DX,15               ; taille du module rsident
        shr DX,4                ; taille en paragraphes
        mov AX,3100h
        int 21h                 ; termine en laissant rsident

desinstalle:
        RestaureINT 08h,ancINT08

        push CS
        pop DS                  ; DS=CS pour les messages

        push ES                 ; sauvegarde le segment TSR
        mov ES,ES:[002Ch]       ; segment de l'environnement PSP
        mov AH,49h
        int 21h                 ; libre la mmoire
        pop ES                  ; restaure le segment TSR
        jc erreur_desinstalle

        mov AH,49h
        int 21h                 ; libre la mmoire (segment TSR)
        lea DX,ok_desinst_msg   ; tout va bien
        xor AL,AL               ; code de sortie normale=0
        jnc ok_desinstalle

erreur_desinstalle:
        lea DX,err_desinst_msg  ; erreur  la dsallocation mmoire
        mov AL,1                ; code de sortie 1
ok_desinstalle:
        push AX
        mov AH,09h
        int 21h                 ; affiche un message
        pop AX
        mov AH,4Ch
        int 21h                 ; fin


; actions associes aux groupes de caractres -------------

init_val_HM:
        cmp anc_caractere,'S'
        je  interdit                    ; pas de chiffre aprs un 'S' !
init_val:
        mov valeur,0
calcule_val:
        sub AL,'0'                      ; convertit caractre en dcimal
        mov AH,valeur
        aad
        mov valeur,AL                   ; valeur=10*valeur+chiffre
        ret

init_prog_h:
        mov type_param_num,prog_heure
        mov prog_delai,non
        jmp short init_val              ; programmation HHh heure

init_pH_ouN:
        mov type_param_num,prog_numero
        cmp AL,'-'                      ; annulation d'alarme
        je retour
        mov type_param_num,prog_heure   ; programmation HHh dlai ('+' est implicite)
        mov prog_delai,oui
    retour:
        ret

teste_type1:
        cmp type_param_num,prog_numero
        je  interdit                    ; pas de H,M,S dans numro d'alarme !
init_HMS:
        mov AH,valeur
        cmp AL,'H'
        jne pas_H
        mov heure_param,AH              ; heure_param = valeur
        mov type_param_num,prog_min     ; MMm attendu
        ret
    pas_H:
        cmp AL,'M'
        jne pas_M
        mov min_param,AH                ; min_param = valeur
        mov type_param_num,prog_sec     ; SSs attendu
        ret
    pas_M:
        mov sec_param,AH                ; sec_param = valeur ('S' est implicite)
        ret

interdit:
        mov etat_analyse,err_syntaxe
rien:
        ret

teste_type2:
        cmp type_param_num,prog_numero
        je  teste_numero
        mov AL,valeur
        cmp type_param_num,prog_heure
        jne pas_prog_heure
        mov heure_param,AL
        jmp short teste_HMS
    pas_prog_heure:
        cmp type_param_num,prog_min
        jne pas_prog_min
        mov min_param,AL
        jmp short teste_HMS
    pas_prog_min:
        mov sec_param,AL                ; type_param_num=prog_sec implicite
        jmp short teste_HMS
    teste_numero:
        mov AH,valeur
        dec AH                          ; numro alarme (0..max-1)
        cmp AH,max_alarmes-1
        ja  interdit                    ; valeur hors domaine
        mov AL,Size s_alarme
        mul AH
        mov BP,AX                       ; BP=offset (nalarme-1) dans tableau
        and ES:alarme[BP].etat,not (utilisee+active)
        ret

plus_alarme_libre:
        mov etat_analyse,err_alarme
        ret

teste_type3:
        mov AL,anc_caractere            ; teste H,M,S avec caractre prcdent
        call init_HMS
teste_HMS:
        cmp heure_param,23
        ja  interdit
        cmp min_param,59
        ja  interdit
        cmp sec_param,59
        ja  interdit
        xor BP,BP               ; offset dans tableau alarme
cherche_alarme_libre:
        test ES:alarme[BP].etat,utilisee
        jz  alarme_libre        ; alarme non utilise
        add BP,Size s_alarme
        cmp BP,max_alarmes*(Size s_alarme)
        jne cherche_alarme_libre
        jmp short plus_alarme_libre
alarme_libre:
        push BX
        or  ES:alarme[BP].etat,utilisee
      ;****** BIDON 
        xor BX,BP
        add BL,sec_courante
        and BL,type_al
        or  ES:alarme[BP].etat,BL       ; type d'alarme pseudo-alatoire
      ;****** BIDON 
        mov AL,heure_courante
        mov ES:alarme[BP].progr.heure,AL
        mov CH,min_courante
        mov ES:alarme[BP].progr.min,CH
        mov CL,sec_courante
        mov ES:alarme[BP].progr.sec,CL  ; init. heure programmation
        call HMS_to_Compteur            ; [DX,AX]=compteur heure courante
        push DX AX                      ; sauvegarde compteur heure courante
        cmp prog_delai,oui
        jne pas_prog_delai              ; programmation d'une heure

        mov AL,heure_param
        mov CH,min_param
        mov CL,sec_param
        call HMS_to_Compteur            ; [DX,AX]=compteur dlai indiqu
        mov W ES:alarme[BP].compteur+2,DX
        mov W ES:alarme[BP].compteur,AX
        pop BX CX                       ; [CX,BX]=compteur heure courante
        add AX,BX
        adc DX,CX                       ; calcule compteur heure courante+dlai
        call Compteur_to_HMS            ; calcule heure,min,sec activation
        cmp AL,23
        jbe heure_activ_ok
        sub AL,23                       ; corrige heure si dpasse minuit
    heure_activ_ok:
        mov ES:alarme[BP].activ.heure,AL
        mov ES:alarme[BP].activ.min,AH
        mov ES:alarme[BP].activ.sec,DL  ; init. heure activation
        jmp short fin_init_alarme

    pas_prog_delai:
        mov AL,heure_param
        mov ES:alarme[BP].activ.heure,AL
        mov CH,min_param
        mov ES:alarme[BP].activ.min,CH
        mov CL,sec_param
        mov ES:alarme[BP].activ.sec,CL  ; init. heure activation
        call HMS_to_Compteur            ; [DX,AX]=compteur heure activation
        pop BX CX                       ; [CX,BX]=compteur heure courante
        sub AX,BX
        sbb DX,CX                       ; calcule compteur heure activation-courante
        jns compteur_positif
        add AX,compteur_max_L           ; ajoute compteur_max si heure activation
        adc DX,compteur_max_H           ; est antrieure  heure courante
    compteur_positif:
        mov W ES:alarme[BP].compteur+2,DX
        mov W ES:alarme[BP].compteur,AX

    fin_init_alarme:
        mov heure_param,0               ; RAZ heure,min,sec pour la suite...
        mov min_param,0
        mov sec_param,0
        pop BX
        ret

teste_opt:
        cmp caractere,'N'
        jne pas_option_N
        mov aff_liste,non               ; dsactive l'affichage de la liste
        ret
    pas_option_N:
        mov retire_prog,oui             ; active la dsinstallation
        ret


; fonctions de conversion heure,min,sec <-> compteur ------

; entres: AL=heure, CH=minute, CL=seconde
; sorties: [DX,AX]=compteur
; modifie: -
HMS_to_Compteur PROC NEAR
        push BX
        mov BX,60
        mul BL
        add AL,CH
        adc AH,0
        mul BX
        add AL,CL
        adc AH,0
        adc DL,0       ; [DX,AX]=60*(60*heure+minute)+seconde
        pop BX
        ret
HMS_to_Compteur ENDP


; entres: [DX,AX]=compteur
; sorties: AL=heure, AH=minute, DL=seconde
; modifie: -
Compteur_to_HMS PROC NEAR
        push BX
        mov BX,60
        div BX
        div BL
        pop BX
        ret
Compteur_to_HMS ENDP


; fonction de conversion heure,min,sec dcimal->ASCII

; entres: AL=heure, CH=minute, CL=seconde
;          DI=offset de la chane "  h  m  s"
; sorties: -
; modifie: AX
Conv_HMS_ascii PROC NEAR
        aam
        add AX,'00'             ; convertit heure en ASCII
        xchg AH,AL
        mov W [DI],AX           ; crit heure
        mov AL,CH
        aam
        add AX,'00'             ; convertit minute en ASCII
        xchg AH,AL
        mov W [DI+3],AX         ; crit minute
        mov AL,CL
        aam
        add AX,'00'             ; convertit seconde en ASCII
        xchg AH,AL
        mov W [DI+6],AX         ; crit seconde
        ret
Conv_HMS_ascii ENDP


PROG ENDP

; donnes non rsidentes ----------------------------------

prog_installe   DB non  ; indique si le programme est dj install

CRLF EQU 13,10
nom_prog EQU "ALARME"

ok_inst_msg     DB nom_prog," v1.1 (c) 1998 Fabrice Couteau. Gestionnaire d'alarmes charg.",CRLF,"$"
ok_desinst_msg  DB nom_prog," a t retir de la mmoire.",CRLF,"$"
err_desinst_msg DB nom_prog," n'a pas pu tre retir de la mmoire !",7,CRLF,"$"
err_inst_msg    DB "Erreur: ",nom_prog," non install, impossible de retirer.",CRLF,"$"
err_param_msg   DB "Erreur: syntaxe incorrecte, paramtre invalide ou valeur hors domaine.",CRLF,"$"
err_alarme_msg  DB "Erreur: plus d'alarme libre !",CRLF,"$"

syntaxe_msg     DB "Syntaxe: ",nom_prog," [<heure>...] [+<dlai>...] [-<numro>...] [options]",CRLF
                DB "  <heure>   : HHh, HHhMM, HHhMMm, HHhMMmSS, HHhMMmSSs -> programme l'heure",CRLF
                DB "  +<dlai>  : mme format que <heure>, prcd de '+' -> programme le dlai",CRLF
                DB "         o : HH=0..23, MM=0..59, SS=0..59",CRLF
                DB "  -<numro> : annule l'alarme indique (1  numro  ",(max_alarmes/10)+"0",(max_alarmes MOD 10)+"0",")",CRLF
                DB "  options   : /N n'affiche pas la liste des alarmes",CRLF
                DB "              /R retire ",nom_prog," de la mmoire.",CRLF
                DB "  exemples  : ",nom_prog," 12h +10m 23h45  -> programme 3 alarmes",CRLF
                DB "                (une  12h00m00, une  23h45m00 et une dans 10 minutes)",CRLF
                DB "              ",nom_prog," -3 23h30 /N -> annule l'alarme n3 (23h45), programme",CRLF
                DB "                une alarme  23h30m00 et n'affiche pas la liste des alarmes.",CRLF
                DB "$"

titre_liste_msg DB "Alarme n   Heure           Heure        Dlai       type",CRLF
                DB "            programmation   activation   activation"      ,CRLF
                DB "---------   -------------   ----------   ----------  ----",CRLF,"$"
; affichage        "        N   HHhMMmSSs       HHhMMmSSs    HHhMMhSSs      N"
; justification                                                         
alarme_msg      DB "        "
  ofs_numero    DB " "                  ; numro
                DB "   "
  ofs_HMS_progr DB "  h  m  s"          ; HHhMMmSSs heure programmation
                DB "       "
  ofs_HMS_activ DB "  h  m  s"          ; HHhMMmSSs heure activation
                DB "    "
  ofs_HMS_delai DB "  h  m  s"          ; HHhMMmSSs dlai activation
                DB "      "
  ofs_type      DB " "                  ; type
                DB CRLF,"$"

TAB        EQU 9        ; caractre tabulation

; groupes de caractres autoriss dans les paramtres de la ligne de commande
chiffre    EQU 1        ; 0..9
lettre_HMS EQU 2        ; H,M,S
plus_moins EQU 3        ; +,-
slash      EQU 4        ; /
lettre_opt EQU 5        ; lettre d'option (N,R)
separateur EQU 6        ; ' ' ou TAB
nombre_groupes EQU 6

car_et_groupe EQU THIS WORD
caractere       DB 0    ; caractre lu dans la ligne de commande
groupe_car      DB 0    ; groupe de caractres du caractre lu
anc_car_et_groupe EQU THIS WORD
anc_caractere   DB 0    ; ancien ...
groupe_anc_car  DB 0    ; ancien ...

; types des paramtres numriques
prog_heure  EQU 1       ; HHh  \
prog_min    EQU 2       ; MMm   > heure et dlai
prog_sec    EQU 3       ; SSs  /
prog_numero EQU 4       ; NN      annule alarme
type_param_num DB 0     ; type du paramtre numrique courant

prog_delai  DB non      ; indique si on programme une heure ou un dlai

; tats de l'analyse des paramtres
ok          EQU 0       ; tout va bien
err_syntaxe EQU 1       ; syntaxe incorrecte, paramtre invalide ou valeur hors domaine
err_alarme  EQU 2       ; plus d'alarme libre
etat_analyse DB ok      ; indique l'tat de l'analyse des paramtres
                        ; sert de code de sortie du programme

aff_liste   DB oui      ; afficher la liste des alarmes  la fin de l'analyse?
retire_prog DB non      ; retirer le programme de la mmoire?

; matrice des actions associes aux groupes de caractres
; nouveau                                                                              ancien
; groupe :  1: 0..9    2: H,M,S   3: +,-     4: /       5: N,R     6: ' ',TAB    groupe 
action  DW  calcule_val,teste_type1,interdit   ,interdit   ,interdit   ,teste_type2 ; 1: 0..9
        DW  init_val_HM,interdit   ,interdit   ,interdit   ,interdit   ,teste_type3 ; 2: H,M,S
        DW  init_val   ,interdit   ,interdit   ,interdit   ,interdit   ,interdit    ; 3: +,-
        DW  interdit   ,interdit   ,interdit   ,interdit   ,teste_opt  ,interdit    ; 4: /
        DW  interdit   ,interdit   ,interdit   ,interdit   ,interdit   ,rien        ; 5: N,R
        DW  init_prog_h,interdit   ,init_pH_ouN,rien       ,interdit   ,rien        ; 6: ' ',TAB

valeur          DB 0    ; valeur pour calculer un paramtre numrique

heure_param     DB 0    ; heure/min/sec entres en paramtre
min_param       DB 0
sec_param       DB 0

heure_courante  DB 0    ; heure/min/sec du DOS au lancement du programme
min_courante    DB 0
sec_courante    DB 0

CODE ENDS
END debut
