;Ŀ
;           **** CAPTUREUR D'ECRAN TEXTE/GRAPHIQUE RESIDENT ****           
;                                                                          
;  Auteur: Fabrice COUTEAU            Date d'criture 08/01/1994  
;                                     Dernire modification 04/07/1998  
;ĳ
; - EN MODE TEXTE:                                                         
;    Sauvegarde la page n0 du mode texte couleur dans le rpertoire       
;    courant au format SCR (CATCH???.SCR) pour utiliser avec SCREENER.     
;    S'il y a une carte VGA, la palette courante et le jeu de caractres   
;    sont galement sauvegards (.PAL et .FNT) simultanment.              
; - EN MODE GRAPHIQUE:                                                     
;    Sauvegarde l'cran du mode graphique 320x200 256 couleurs dans le     
;    rpertoire courant au format BitMap RGB 8 bits (CATCH???.BMP).        
;                                                                          
; - Activation: Alt+C                                                      
;                                                                          
;  Remarque: en mode texte, le curseur de la souris est cach en rcrivant
;             dessus, car on ne peut pas savoir s'il est masqu ou non!    
;                                                                          
;     - premier appel : installation                                       
;     - deuxime appel: dsinstallation                                    
;

ASSUME CS:CODE

CODE SEGMENT
     ORG 100h                   ; programme COM

start:
        jmp PROG                ; point d'entre

; donnes rsidentes

ancint09    DD 0                ; ancienne adresse de int 09h (clavier)
ancint13    DD 0                ; ancienne adresse de int 13h (disque/disquette)

INDOS_ptr   DD 0                ; pointeur sur l'indicateur INDOS
BIOS_actif  DB 0                ; tmoin d'activit de int 13h

capture_active DB 0             ; tmoin d'activit de la capture
mode_video  DB 0                ; mode vido courant

xsouris     DW 0                ; coordonne x du curseur de la souris
ysouris     DW 0                ; coordonne y du curseur de la souris

handle      DW 0                ; handle du fichier

nom_fichier DB "CATCH   .   ",0 ; masque pour le nom du fichier
ext_SCR     DB "SCR"            ; extension SCR
ext_BMP     DB "BMP"            ; extension BMP
ext_PAL     DB "PAL"            ; extension PAL
ext_FNT     DB "FNT"            ; extension FNT
jokers      DB "???"            ; jokers pour la recherche des fichiers

numero_max  DW 000              ; numro maximal des fichiers SCR ou BMP

entete_SCR  DW 1,1,80,25        ; entte du fichier SCR (coordonnes texte)
entete_BMP  DB "BM",54,254,0,0,0,0,0,0,54,4,0,0,40,0,0,0,64,1,0,0,200,0,0
            DB 0,1,0,8,0,0,0,0,0,0,250,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0

buffer      DB 4096 DUP (0)     ; buffer pour les palettes, la fonte...

DAC_texte   DB 0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63 ; couleur<->n reg. DAC

carteVGA    DB 0                ; tmoin de prsence d'une carte VGA
nbr_lignes  DB 25               ; nombre de lignes par page (25/28/50)
hauteur_car DB 16               ; hauteur des caractres en pixels (16/14/8)

ident       DB "CT"             ; chane d'identification du programme

AltC        EQU 2E00h           ; code de la touche d'activation


B EQU BYTE PTR
W EQU WORD PTR

.386

INT09 PROC FAR

        pushf
        call ancint09           ; appelle l'ancien gestionnaire int 09h

        pusha
        push DS ES

        push 0040h
        pop  DS                 ; DS=segment buffer clavier
        mov  DX,W DS:[001Ch]
        mov  BX,W DS:[001Ah]
        cmp  DX,BX              ; buffer vide?
        jz   fin                ; oui, on quitte
        mov  AX,[BX]
        cmp  AX,AltC            ; touche=Alt+C?
        jne  fin                ; non, on quitte

        cmp  capture_active,1   ; capture dj active?
        je   fin                ; oui, on quitte

        cmp  BIOS_actif,0       ; interruption disque active?
        jnz  fin                ; oui, impossible d'interrompre
        les  BX,INDOS_ptr
        cmp  B ES:[BX],0        ; fonction de DOS active?
        jnz  fin                ; oui, impossible d'interrompre
        mov  DS:[001Ah],DX      ; efface buffer clavier
        call CAPTURE            ; capture l'cran

fin:
        pop ES DS
        popa

        iret                    ; retour  l'appelant

INT09 ENDP


INT13 PROC FAR

        inc  BIOS_actif         ; incrmente le compteur d'accs disque
        pushf
        call ancint13           ; appelle l'ancien gestionnaire int 13h
        dec  BIOS_actif         ; dcrmente le compteur d'accs disque
        sti                     ; autorise les interruptions
        ret  2                  ; retour  l'appelant

INT13 ENDP



CAPTURE PROC NEAR

        mov capture_active,1

        push 0040h
        pop  ES
        mov  AL,ES:[0049h]      ; AL=mode vido courant en 0040:0049
        mov  mode_video,AL      ; mmorise le mode vido courant
        cmp  AL,03h             ; mode texte couleur?
        je   mode_texte         ; oui, on continue
        cmp  AL,13h             ; mode graphique 320x200 256 couleurs?
        je   mode_graphique     ; oui, on continue
        jmp  bip                ; sinon, fait bip et quitte

mode_texte:
        cmp  carteVGA,1
        jne  init_segment_texte ; pas VGA -> ne teste pas nombre de lignes/page
        mov  AX,1130h
        xor  BH,BH
        int  10h                ; fonction du BIOS VGA
        inc  DL
        mov  nbr_lignes,DL      ; nombre de lignes par page
 init_segment_texte:
        mov  AX,0B800h          ; segment RAM vido texte couleur
        lea  SI,ext_SCR         ; extension SCR
        jmp short suite_mode

mode_graphique:
        mov AX,0A000h           ; segment RAM vido graphique couleur
        lea SI,ext_BMP          ; extension BMP

suite_mode:
        cld                     ; copies en sens croissant pour toute la suite

        push CS
        pop  DS
        push CS
        pop  ES                 ; DS=ES=CS
        mov  DI,OFFSET nom_fichier+9
        movsw
        movsb                   ; copie l'extension du fichier (SCR ou BMP)

        mov DS,AX               ; segment RAM vido
        push W DS:[0000h]       ; sauvegarde le caractre en (1,1)
        mov AX,0003h
        int 33h
        mov xsouris,CX
        mov ysouris,DX          ; sauvegarde les coordonnes du curseur souris
        mov AX,0004h
        xor CX,CX
        xor DX,DX
        int 33h                 ; bouge le curseur souris en (1,1)
        pop W DS:[0000h]        ; raffiche le caractre en (1,1)

        mov numero_max,0        ; rinitialise le numro maximal

        push CS
        pop  DS
        lea  SI,jokers
        mov  DI,OFFSET nom_fichier+5
        movsw
        movsb                   ; copie les jokers (???)

        mov AH,4Eh
        lea DX,nom_fichier
        int 21h                 ; recherche le premier fichier
        jc pas_de_fichier       ; erreur -> saute la recherche

        mov AH,2Fh
        int 21h                 ; dtermine l'adresse de la DTA (ES:BX)
        add BX,30               ; ES:BX -> premier caractre du nom de fichier

fichier_suivant:
        xor DX,DX
        mov AL,ES:[BX+5]        ; chiffre des centaines
        sub AL,"0"              ; convertit ASCII en dcimal
        mov CL,100
        mul CL
        mov DX,AX
        mov AL,ES:[BX+6]        ; chiffre des dizaines
        sub AL,"0"              ; convertit ASCII en dcimal
        mov CL,10
        mul CL
        add DX,AX
        mov AL,ES:[BX+7]        ; chiffre des units
        sub AL,"0"              ; convertit ASCII en dcimal
        xor AH,AH
        add DX,AX               ; DX=numro ??? du fichier CATCH???.ext

        cmp DX,numero_max       ; DX>numero_max?
        jbe suite               ; non
        mov numero_max,DX
suite:
        mov AH,4Fh
        int 21h                 ; recherche le fichier suivant
        jnc fichier_suivant     ; boucle si trouv

pas_de_fichier:
        lea DI,nom_fichier
        mov AX,numero_max
        inc AX                  ; numro immdiatement suprieur
        mov CL,100
        div CL
        add AL,"0"              ; convertit dcimal en ASCII
        mov [DI+5],AL           ; stocke le chiffre des centaines
        mov AL,AH
        xor AH,AH
        mov CL,10
        div CL
        add AL,"0"              ; convertit dcimal en ASCII
        mov [DI+6],AL           ; stocke le chiffre des dizaines
        add AH,"0"              ; convertit dcimal en ASCII
        mov [DI+7],AH           ; stocke le chiffre des units

        mov AH,3Ch
        xor CX,CX
        mov DX,DI
        int 21h                 ; cre le nouveau fichier SCR ou BMP
        mov handle,AX
        jnc teste_mode          ; continue si pas d'erreur
        jmp bip                 ; sinon, bip

teste_mode:
        cmp mode_video,03h      ; est-on en mode texte?
        je  cree_fichier_SCR    ; oui
        jmp cree_fichier_BMP

cree_fichier_SCR:
        xor AH,AH
        mov AL,nbr_lignes
        mov [entete_SCR+2*3],AX ; crit le nombre de lignes dans l'entte (yb)

        mov AH,40h
        mov BX,handle
        mov CX,4*2              ; 4 mots  crire
        lea DX,entete_SCR
        int 21h                 ; crit l'entte du fichier SCR

        mov AX,80*2
        mul nbr_lignes
        mov CX,AX               ; 80x(nbr_lignes) mots  copier
        mov AH,40h
        push 0B800h
        pop DS                  ; DS=B800
        xor DX,DX
        int 21h                 ; sauvegarde l'cran texte dans le fichier SCR

        mov AH,3Eh
        int 21h                 ; ferme le fichier SCR

        cmp carteVGA,1
        je  cree_fichier_PAL
        jmp fin_ecrit_fichier   ; pas VGA -> ne sauvegarde pas PAL et FNT

cree_fichier_PAL:
        push CS
        pop  DS
        push CS
        pop  ES                 ; DS=ES=CS

        lea SI,ext_PAL
        mov DI,OFFSET nom_fichier+9
        movsw
        movsb                   ; copie l'extension du fichier PAL

        mov AH,3Ch
        xor CX,CX
        lea DX,nom_fichier
        int 21h                 ; cre le nouveau fichier PAL
        mov handle,AX
        jnc charge_palette      ; continue si pas d'erreur
        jmp bip                 ; sinon, bip

charge_palette:
        lea SI,DAC_texte
        lea DI,buffer
        mov CX,16               ; 16 couleurs  charger
 charge_couleur:
        lodsb                   ; AL=n registre DAC correspondant  la couleur
        mov DX,3C7h
        out DX,AL               ; charge n de registre dans Pel Read Address
        mov DX,3C9h             ; registre Pel Data
        in  AL,DX
        stosb                   ; R
        in  AL,DX
        stosb                   ; V
        in  AL,DX
        stosb                   ; B
        loop charge_couleur

        mov AH,40h
        mov BX,handle
        mov CX,16*3             ; 16*(R,V,B)  crire
        lea DX,buffer
        int 21h                 ; crit la palette 16 couleurs

        mov AH,3Eh
        int 21h                 ; ferme le fichier PAL

cree_fichier_FNT:
        call AccedeCar

        push 0A000h
        pop DS
        mov SI,4000h*0          ; DS:SI -> table de caractres n0
        lea DI,buffer

        mov hauteur_car,16
        cmp nbr_lignes,25       ; 25 lignes -> hauteur_car=16 pixels
        je  fin_init_hauteur
        mov hauteur_car,14
        cmp nbr_lignes,28       ; 28 lignes -> hauteur_car=14 pixels
        je  fin_init_hauteur
        mov hauteur_car,8       ; 50 lignes -> hauteur_car=8  pixels

 fin_init_hauteur:
        xor BH,BH
        mov BL,hauteur_car
        mov AX,32
        sub AX,BX               ; AX=32-hauteur_car: incrment SI
        shr BX,1                ; BX=hauteur_car/2

        mov DX,256
 copie_fonte_buffer:
        mov CX,BX               ; CX=hauteur_car/2
        rep movsw               ; copie un caractre dans le buffer
        add SI,AX               ; DS:SI -> ligne 0 du caractre suivant
        dec DX
        jnz copie_fonte_buffer

        call AccedeMem

        push CS
        pop DS

        lea SI,ext_FNT
        mov DI,OFFSET nom_fichier+9
        movsw
        movsb                   ; copie l'extension du fichier FNT

        mov AH,3Ch
        xor CX,CX
        lea DX,nom_fichier
        int 21h                 ; cre le nouveau fichier FNT
        mov handle,AX
        jnc sauve_fonte         ; continue si pas d'erreur
        jmp bip                 ; sinon, bip

 sauve_fonte:
        mov AH,40h
        mov BX,handle
        xor CL,CL
        mov CH,hauteur_car      ; 256*hauteur_car  crire
        lea DX,buffer
        int 21h                 ; crit la fonte texte 256 caractres

        mov AH,3Eh
        int 21h                 ; ferme le fichier FNT

        jmp short fin_ecrit_fichier

cree_fichier_BMP:
        mov AH,40h
        mov BX,handle
        mov CX,54               ; 54 octets  crire
        lea DX,entete_BMP
        int 21h                 ; crit l'entte du fichier BMP

        mov AX,1017h
        xor BX,BX
        mov CX,256
        push CS
        pop ES
        lea DX,buffer
        int 10h                 ; charge les 256 registres DAC (BIOS VGA)

        mov CX,256              ; 256x(3 composantes  dcaler)
        std                     ; sens dcroissant
        mov SI,3*256-1
        add SI,DX               ; DS:SI -> B du dernier R,G,B
        add DX,8                ; dcale le pointeur de buffer pour viter le
                                ; recouvrement des couleurs 0 et 1  la fin de la copie
        mov DI,4*256-1
        add DI,DX               ; ES:DI -> ? du dernier B,G,R,?
 decale:
        xor AL,AL
        stosb                   ; met 0 dans ?
        lodsb
        shl AL,2
        mov [DI-2],AL           ; copie la composante B
        dec DI
        lodsb
        shl AL,2
        stosb                   ; copie la composante G
        lodsb
        shl AL,2
        mov [DI+2],AL           ; copie la composante R
        dec DI
        loop decale

        mov AH,40h
        mov BX,handle
        mov CX,256*4            ; 256*(B,G,R,?)  crire
        int 21h                 ; crit la palette de 256 couleurs

        push 0A000h
        pop DS                  ; DS=A000
        mov DX,0+320*199        ; DS:DX -> dernire ligne (0,199)
        mov CX,200
 ecrit_ligne:
        push CX
        mov AH,40h
        mov CX,320              ; 320 octets  copier (1 ligne)
        int 21h                 ; sauvegarde une ligne dans le fichier BMP
        sub DX,320              ; ligne prcdente
        pop CX
        loop ecrit_ligne

        mov AH,3Eh
        int 21h                 ; ferme le fichier BMP

fin_ecrit_fichier:
        mov AX,0004h
        mov CX,xsouris
        mov DX,ysouris
        int 33h                 ; bouge le curseur souris en (xsouris,ysouris)
        jmp short fin_capture

bip:
        mov AX,256*0Eh+7
        int 10h                 ; fait bip! (une erreur s'est produite)

fin_capture:
        mov capture_active,0

        ret

CAPTURE ENDP


; fonctions d'accs aux tables de caractres/mmoire vido
INCLUDE_CAR EQU 1
INCLUDE_DAC EQU 0
INCLUDE VGA.inc


PROG PROC NEAR

        mov AX,3509h
        int 21h                 ; lit le vecteur INT 09h
        cmp W ES:[ident],"TC"   ; INT 09h dtourne?
        jne installe            ; non, on installe

        mov AX,3513h
        int 21h                 ; lit le vecteur INT 13h
        cmp W ES:[ident],"TC"   ; INT 13h dtourne?
        je desinstalle          ; oui, on dsinstalle

installe:
        push CS
        pop DS

        mov AH,34h
        int 21h                 ; lit le pointeur sur l'indicateur INDOS
        mov W [INDOS_ptr],BX
        mov W [INDOS_ptr+2],ES  ; mmorise l'adresse

        mov AX,3509h
        int 21h                 ; lit le vecteur de INT 09h
        mov W [ancint09],BX
        mov W [ancint09+2],ES   ; mmorise l'adresse

        mov AX,3513h
        int 21h                 ; lit le vecteur de INT 13h
        mov W [ancint13],BX
        mov W [ancint13+2],ES   ; mmorise l'adresse

        mov AX,2509h
        lea DX,INT09
        int 21h                 ; installe nouvelle INT 09h (clavier)

        mov AX,2513h
        lea DX,INT13
        int 21h                 ; installe nouvelle INT 13h (disque)

        lea DX,ok_installe
        mov AH,09h
        int 21h                 ; affiche le message d'installation

        mov AX,1A00h
        int 10h                 ; int. du BIOS VGA pour tester la carte
        cmp AL,1Ah
        jne pas_carte_VGA
        mov carteVGA,1

pas_carte_VGA:
        lea DX,PROG
        add DX,15               ; taille du module rsident
        shr DX,4                ; taille en paragraphes
        mov AX,3100h
        int 21h                 ; termine en laissant rsident

desinstalle:
        lds DX,ES:[ancint09]
        mov AX,2509h
        int 21h                 ; restaure ancienne int 09h

        lds DX,ES:[ancint13]
        mov AX,2513h
        int 21h                 ; restaure ancienne int 13h

        push CS
        pop DS

        push ES                 ; sauvegarde le segment TSR-PSP
        mov ES,ES:[002Ch]       ; segment de l'environnement PSP
        mov AH,49h
        int 21h                 ; libre la mmoire
        pop ES                  ; restaure le segment TSR-PSP
        jc erreur_desinstalle

        mov AH,49h
        int 21h                 ; libre la mmoire
        lea DX,ok_desinstalle   ; tout va bien
        xor AL,AL               ; code de sortie normale=0
        jnc ok

erreur_desinstalle:
        lea DX,erreur_desinst   ; erreur  la dsallocation mmoire
        mov AL,1                ; code de sortie 1
ok:
        push AX
        mov AH,09h
        int 21h                 ; affiche un message
        pop AX
        mov AH,4Ch
        int 21h                 ; fin

PROG ENDP

; donnes d'installation

CRLF   EQU 13,10

ok_installe    DB CRLF,"CATCHER v1.1 (c) 1998 Fabrice Couteau - Captureur d'cran charg.",CRLF
               DB CRLF,"Alt+C pour capturer l'cran en mode texte ou graphique 320x200 256 (VGA)",CRLF,"$"
ok_desinstalle DB CRLF,"CATCHER est dsinstall",CRLF,"$"
erreur_desinst DB CRLF,"CATCHER n'a pas pu tre dsinstall",CRLF,"$"

CODE ENDS
END start
