;            ͻ
;                  CONSTMM.INC      
;                                                               
;                      --== Mod Master v2.2 ==--           
;            ĺ
;               Auteur Freddy Vtel    
;                                                               
;               Dernire modification 16/04/1996       
;            ͼ
;                ** Tableaux de constantes pour Mod Master **

b Equ Byte Ptr
w Equ Word Ptr
d Equ DWord Ptr

Sampl struc
      SInfo          DB ?
      SNom           DB 32 DUP (?)
      SLen           DD ?
      SRep           DD ?
      SRep_len       DD ?
      SVolume        DB ?
      SFine_Tune     DB ?
      SDadj          DW ?
      SAdresse_GUS   DD ?
      SSegment       DW ?   ;\
      SHandle_EMS    DW ?   ; |-- Bloc de Mmoire...
      SNb_Pages_EMS  DB ?   ;/
Sampl ends

Adlb struc
      AInfo          DB ?
      ANom           DB 32 DUP (?)
      AVolume        DB ?
      ADadj          DW ?
      AM1            DB ?    ; Modulateur (1  Paramtre)
      AP1            DB ?    ; Porteuse   (1  Paramtre)
      AM2            DB ?
      AP2            DB ?
      AM3            DB ?
      AP3            DB ?
      AM4            DB ?
      AP4            DB ?
      AM5            DB ?    ; Modulateur (5  Paramtre)
      AP5            DB ?    ; Porteuse   (5  Paramtre)
      AFeedBack      DB ?
      AFill          DB 11 DUP (?)
Adlb ends

; Masque pour les Infos sur le sample

M_Adlib  EQU 1
M_NSigne EQU 2
M_16bit  EQU 4
M_Boucle EQU 8
M_Bidi   EQU 16
M_Charge EQU 128

; Masques pour les modifications des voies (Pour GUS et Adlib)

M_ChSample  EQU 1
M_ChPeriode EQU 2
M_ChVolume  EQU 4
M_ChPanning EQU 8

; Masques pour le contrle des voies

M_Pas_Active  EQU 1
M_Stoppee     EQU 2
M_KeyOff      EQU 4

;Erreurs Mod Master...

Err_Sortie_Introuvable   EQU 1
Err_Frequence_Incorrecte EQU 2
Err_PC_Lent              EQU 3
Err_Musique_Pas_Charge   EQU 4  ;Gre dans la partie pascal
Err_SB                   EQU 5
Err_Adlib                EQU 6  ;Gre dans la partie pascal

;sorties sonores

HPint   EQU 0
CNA     EQU 1
DSS     EQU 2
SMaster EQU 3
Adlib   EQU 4
SB      EQU 5
SBPro   EQU 6
SB16    EQU 7
GUS     EQU 8

;Type de module

T_MOD   EQU 0
T_STM   EQU 2
T_S3M   EQU 3
T_669   EQU 4
T_MTM   EQU 5
T_DTM   EQU 6
T_PTM   EQU 7
T_SAT   EQU 8

Ta_vib   DB   0, 24, 49, 74, 97,120,141,161,180,197,212,224,235,244,250,253
         DB 255,253,250,244,235,224,212,197,180,161,141,120, 97, 74, 49, 24
         ;Partie negative du sinus
         DB   0, 24, 49, 74, 97,120,141,161,180,197,212,224,235,244,250,253
         DB 255,253,250,244,235,224,212,197,180,161,141,120, 97, 74, 49, 24

Ta_rampe DB 255,247,239,231,223,215,207,199,191,183,175,167,159,151,143,135
         DB 127,120,112,104, 96, 88, 79, 72, 64, 56, 47, 40, 32, 24, 16,  8
         DB 0  ,  8, 16, 24, 32, 40, 47, 56, 64, 72, 79, 88, 96,104,112,120
         DB 127,135,143,151,159,167,175,183,191,199,207,210,223,231,239,247

Ta_carre DB 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255
         DB 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255
         DB 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255
         DB 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255

Nb_Octaves_Total EQU 10

Mini_Octaves DW 0E28h*2,0714h*2,038Ah*2,01C5h*2,00E2h*2,0071h*2,0038h*2,001Ch*2,001Ch,07h
Maxi_Octaves DW 1AC0h*2,0D60h*2,06B0h*2,0358h*2,01ACh*2,00D6h*2,006Bh*2,0035h*2,0035h,0Dh

;Tableaux de priodes (Conforme  Fast Tracker 2.0 )

Max_Notes EQU 12*10

T_per  DW 1AC0h,1940h,17D0h,1680h,1530h,1400h,12E0h,11D0h,10D0h,0FE0h,0F00h,0E28h ;0
       DW 0D60h,0CA0h,0BE8h,0B40h,0A98h,0A00h,0970h,08E8h,0868h,07F0h,0780h,0714h ;1
       DW 6B0h,650h,5F4h,5A0h,54Ch,500h,4B8h,474h,434h,3F8h,3C0h,38Ah   ;2
       DW 358h,328h,2FAh,2D0h,2A6h,280h,25Ch,23Ah,21Ah,1FCh,1E0h,1C5h   ;3
       DW 1ACh,194h,17Dh,168h,153h,140h,12Eh,11Dh,10Dh,0FEh,0F0h,0E2h   ;4
       DW 0D6h,0CAh,0BEh,0B4h,0AAh,0A0h,097h,08Fh,087h,07Fh,078h,071h   ;5
       DW 06Bh,065h,05Fh,05Ah,055h,050h,04Bh,047h,043h,03Fh,03Ch,038h   ;6
       DW 035h,032h,02Fh,02Dh,02Ah,028h,025h,023h,021h,01Fh,01Eh,01Ch   ;7
       DW 01Ah,019h,017h,016h,015h,014h,012h,011h,010h,00Fh,00Fh,00Eh   ;8
       DW 00Dh,00Ch,00Bh,00Bh,00Bh,00Ah,009h,008h,008h,007h,007h,007h,0 ;9

; Table de conversion pour le HP interne

T_bep DB 20h,1Fh,1Eh,1Dh,1Ch,1Bh,1Ah,19h,18h,17h,16h,15h,14h,13h,12h,11h
      DB 11h,10h,10h,0Fh,0Fh,0Eh,0Eh,0Dh,0Dh,0Dh,0Ch,0Ch,0Ch,0Ch,0Bh,0Bh
      DB 0Bh,0Bh,0Ah,0Ah,0Ah,0Ah,0Ah,09h,09h,09h,09h,09h,09h,09h,09h,09h
      DB 08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,07h,07h,07h,07h
      DB 07h,07h,07h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,05h,05h
      DB 05h,05h,05h,05h,05h,05h,05h,05h,04h,04h,04h,04h,04h,04h,04h,04h
      DB 04h,04h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,02h,02h,02h,02h
      DB 02h,02h,02h,02h,02h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h

      DB 40h,40h,40h,40h,40h,40h,40h,40h,40h,40h,3Fh,3Fh,3Fh,3Fh,3Fh,3Fh
      DB 3Fh,3Fh,3Fh,3Fh,3Fh,3Fh,3Eh,3Eh,3Eh,3Eh,3Eh,3Eh,3Eh,3Eh,3Eh,3Eh
      DB 3Dh,3Dh,3Dh,3Dh,3Dh,3Dh,3Dh,3Dh,3Dh,3Ch,3Ch,3Ch,3Ch,3Ch,3Ch,3Ch
      DB 3Ch,3Ch,3Ch,3Bh,3Bh,3Bh,3Bh,3Bh,3Bh,3Bh,3Bh,3Bh,3Bh,3Ah,3Ah,3Ah
      DB 3Ah,3Ah,3Ah,3Ah,3Ah,3Ah,3Ah,39h,39h,39h,39h,39h,39h,39h,39h,39h
      DB 39h,38h,38h,38h,38h,38h,38h,38h,38h,37h,37h,37h,37h,37h,36h,36h
      DB 36h,36h,35h,35h,35h,35h,34h,34h,34h,33h,33h,32h,32h,31h,31h,30h
      DB 30h,2Fh,2Eh,2Dh,2Ch,2Bh,2Ah,29h,28h,27h,26h,25h,24h,23h,22h,21h

; Table de conversion pour la carte Adlib (Synt OPL 2)

T_Adlib DB 63,56,51,48,45,43,41,40,38,37,36,35,34,34,33,32
        DB 31,31,30,29,29,28,28,27,27,26,26,26,25,25,24,24
        DB 24,23,23,23,22,22,22,21,21,21,21,20,20,20,20,19
        DB 19,19,19,18,18,18,18,18,17,17,17,17,17,16,16,16
        DB 16,16,15,15,15,15,15,15,14,14,14,14,14,14,14,13
        DB 13,13,13,13,13,13,12,12,12,12,12,12,12,12,11,11
        DB 11,11,11,11,11,11,11,10,10,10,10,10,10,10,10,10
        DB 10, 9, 9, 9, 9, 9, 9, 9, 9, 9, 8, 8, 8, 8, 8, 8
        DB  8, 8, 8, 8, 8, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7
        DB  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 5, 5, 5, 5
        DB  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 4, 4, 4, 4, 4
        DB  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 3, 3, 3, 3, 3
        DB  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 2, 2
        DB  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2
        DB  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
        DB  1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
