; Ŀ
;               **** MODIFIEUR DE DATE/HEURE D'UN FICHIER ****               
;                                                                            
;   Auteur: Fabrice COUTEAU            Dbut d'criture 30/11/1996   
;                                      Dernire modification 01/12/1996   
; ĳ
;  - syntaxe:                                                                
;       DATETIME nom_fichier [JJ/MM/AA] [HH:MM[.SS]] {<source} {>destination}
;                                                                            
;  Si aucun paramtre n'est prsent, les date & heure du fichier sont        
;  affiches sur l'cran (ou dans 'destination' si la sortie est redirige). 
;  Si un paramtre JJ/MM/AA et/ou HH:MM est prsent, le fichier est mis     
;  jour avec ces nouvelles valeurs.                                          
;  Si l'entre est redirige, les paramtres JJ/MM/AA et/ou HH:MM sont lus   
;  depuis 'source', et le fichier est mis  jour.                            
;                                                                            
;  REM: 'nom_fichier' ne doit pas contenir de caractres jokers (?,*)        
; 

.MODEL TINY

B EQU BYTE PTR
W EQU WORD PTR

msq_heure EQU 1111100000000000b
msq_min   EQU 0000011111100000b
msq_sec   EQU 0000000000011111b

msq_annee EQU 1111111000000000b
msq_mois  EQU 0000000111100000b
msq_jour  EQU 0000000000011111b


.CODE
        ORG 100h                ; programme COM

Write MACRO msg
        MOV AH,09h
        LEA DX,msg
        INT 21h                 ; affiche un message  l'cran
ENDM

ReadCar MACRO
        PUSH DX
        MOV AH,06h
        MOV DL,255
        INT 21h                 ; lit un caractre sur le priphrique d'entre
        POP DX
ENDM

prog:
        PUSH CS
        POP DS

        MOV BL,B DS:[128]       ; lit dans le PSP
        XOR BH,BH               ; BX=longueur de la liste de paramtres+1
        OR  BL,BL               ; longueur>=1 ?
        JNZ analyse_parametres  ; oui
        JMP SHORT affiche_syntaxe; erreur de paramtre

analyse_parametres:
        DEC BL                  ; BX=longueur de la liste de paramtres
        MOV SI,130
        MOV B [SI][BX],0        ; termine le paramtre par un 0 (ASCIIZ)

        MOV BH,BL
boucle_nom_fichier:
        CMP B [SI],' '
        JNE pas_espace
        MOV B [SI],0            ; remplace sparateur ' ' par #0
        INC SI
        MOV offset_date_heure,SI; offset du paramtre JJ/MM/AA et/ou HH:MM = SI+1
        JMP SHORT ouvre_fichier
    pas_espace:
        INC SI
        DEC BH
        JNZ boucle_nom_fichier

ouvre_fichier:
        MOV AX,256*3Dh+00010000b
        MOV DX,130              ; offset du nom de fichier dans le PSP
        INT 21h                 ; ouvre le fichier en lecture
        JC  erreur_fichier
        MOV BX,AX               ; handle (ne pas modifier !!)

        MOV AX,256*57h+0        ; dtermine la date & heure de modification
        INT 21h                 ; CX=HHHHHMMMMMMSSSSS   DX=AAAAAAAMMMMJJJJJ

        ReadCar                 ; y a-t-il une redirection d'entre ?
        JZ test_param_date_heure; non

boucle_lit_car_f:
        CALL teste_car
        MOV AL,car
        MOV anc_car,AL
        JNC lit_car_f
    affiche_syntaxe:
        Write syntaxe
        JMP SHORT fin
    lit_car_f:
        ReadCar
        JNZ boucle_lit_car_f    ; lit jusqu' la fin du fichier
        JMP SHORT modifie_date_heure

test_param_date_heure:
        MOV SI,offset_date_heure
        OR  SI,SI               ; y a-t-il des paramtres date/heure ?
        JZ  aff_date_heure      ; non

        CLD
    boucle_lit_car_param:
        LODSB
        OR  AL,AL               ; fin des paramtres ?
        JZ  modifie_date_heure  ; oui
        CALL teste_car
        MOV AL,car
        MOV anc_car,AL
        JNC boucle_lit_car_param
        JMP SHORT affiche_syntaxe; erreur de paramtre

modifie_date_heure:
        MOV AH,valeur
        CALL separ_date_heure   ; analyse dernier caractre
        JNC dernier_car_ok
        JMP SHORT affiche_syntaxe; erreur de paramtre
    dernier_car_ok:
        CALL verifie_valeurs
        JNC valeurs_ok
        Write valeur_incorrecte
        JMP SHORT ferme_fichier
    valeurs_ok:
        CALL modifie_fichier
        JMP SHORT ferme_fichier

aff_date_heure:
        CALL affiche_date_heure ; affiche date & heure du fichier  l'cran
        Write date_heure
        JMP SHORT ferme_fichier

erreur_fichier:
        LEA DX,fichier_introuvable
        CMP AX,2
        JE  affiche_message
        LEA DX,chemin_introuvable
        CMP AX,3
        JE  affiche_message
        LEA DX,autre_erreur
affiche_message:
        MOV AH,09h
        INT 21h                 ; affiche un message (@=DS:DX)
        JMP SHORT fin

ferme_fichier:
        MOV AH,3Eh
        INT 21h                 ; ferme le fichier

fin:
        MOV AX,4C00h
        INT 21h                 ; fin

;----------------------------------------------------------
car_ok MACRO
        CLC
        RETN
ENDM

erreur_car MACRO
        STC
        RETN
ENDM

RAZ_valeur MACRO
        MOV valeur,0
        car_ok
ENDM

;----------------------------------------------------------
teste_car:
; flag carry=1 si erreur de paramtre

        MOV AH,valeur
        MOV car,AL

        CMP AL,'0'
        JB  pas_chiffre
        CMP AL,'9'
        JA  pas_chiffre
        SUB AL,'0'              ; convertit caractre en dcimal
        AAD
        MOV valeur,AL           ; valeur=10*valeur+chiffre
        car_ok

    pas_chiffre:
        CMP AL,'/'
        JE  separ_date
        CMP AL,'-'
        JE  separ_date
        CMP AL,':'
        JE  separ_heure
        CMP AL,'.'
        JE  separ_heure
        CMP AL,' '
        JE  separ_date_heure
        CMP AL,13
        JBE separ_inf_13
        erreur_car              ; caractre interdit

    separ_inf_13:
        car_ok                  ; ignore les codes ASCII<13 (CR, LF, ...)

    separ_date:
        INC nbr_separ_date
        MOV AL,nbr_separ_date
        CMP AL,1                ; premier sparateur de date ?
        JNE pas_jour            ; non
        MOV jour,AH             ; crit le jour
        RAZ_valeur
      pas_jour:
        CMP AL,2                ; deuxime sparateur de date ?
        JNE pas_mois            ; non
        MOV mois,AH             ; crit le mois
        RAZ_valeur
      pas_mois:
        erreur_car              ; trop de sparateurs de date

    separ_heure:
        INC nbr_separ_heure
        MOV AL,nbr_separ_heure
        CMP AL,1                ; premier sparateur d'heure ?
        JNE pas_heures          ; non
        MOV heure,AH            ; crit les heures
        RAZ_valeur
      pas_heures:
        CMP AL,2                ; deuxime sparateur d'heure ?
        JNE pas_minutes         ; non
        MOV min,AH              ; crit les minutes
        RAZ_valeur
      pas_minutes:
        erreur_car              ; trop de sparateurs d'heure

    separ_date_heure:
        CMP anc_car,' '         ; deux sparateurs conscutifs ?
        JNE nouveau_separ       ; non
        car_ok
      nouveau_separ:
        MOV AL,nbr_separ_heure
        OR  AL,AL               ; est-ce un paramtre heure ?
        JZ  teste_separ_date    ; non
        CMP AL,1                ; un seul sparateur d'heure ?
        JNE heure_complete      ; non
        MOV min,AH              ; crit les minutes (format HH:MM)
        MOV sec,0               ; efface les secondes
        RAZ_valeur
      heure_complete:
        MOV sec,AH              ; crit les secondes (format HH:MM.SS)
        RAZ_valeur
      teste_separ_date:
        CMP nbr_separ_date,2
        JNE pas_minutes         ; pas assez de sparateurs de date
        MOV annee,AH            ; crit l'anne
        RAZ_valeur

;----------------------------------------------------------
val_ok MACRO
        CLC
        RETN
ENDM

erreur_val MACRO
        STC
        RETN
ENDM

;----------------------------------------------------------
verifie_valeurs:
; flag carry=1 si valeur incorrecte

        CMP nbr_separ_date,0    ; y a-t-il un paramtre date ?
        JZ  verifie_heure       ; non

        MOV AL,jour
        OR  AL,AL
        JNZ jour_non_nul
        erreur_val              ; jour=0
    jour_non_nul:
        CMP AL,31
        JBE jour_ok
        erreur_val              ; jour>31
    jour_ok:
        MOV AL,mois
        OR  AL,AL
        JNZ mois_non_nul
        erreur_val              ; mois=0
    mois_non_nul:
        CMP AL,12
        JBE mois_ok
        erreur_val              ; mois>12
    mois_ok:
        MOV AL,annee
        CMP AL,99
        JBE annee_ok
        erreur_val              ; annee>99
              
    annee_ok:
        CMP nbr_separ_heure,0   ; y a-t-il un paramtre heure ?
        JNZ verifie_heure       ; oui
        val_ok

    verifie_heure:
        MOV AL,heure
        CMP AL,23
        JBE heure_ok
        erreur_val              ; heure>23
    heure_ok:
        MOV AL,min
        CMP AL,59
        JBE minute_ok
        erreur_val              ; minute>59
    minute_ok:
        CMP nbr_separ_heure,1   ; paramtre heure au format HH:MM ?
        JA  verifie_seconde     ; non
        val_ok
    verifie_seconde:
        MOV AL,sec
        CMP AL,59
        JBE seconde_ok
        erreur_val              ; seconde>59
     seconde_ok:
        val_ok

;----------------------------------------------------------
modifie_fichier:
; flag carry=1 si erreur fichier

        CMP nbr_separ_date,0    ; y a-t-il un paramtre date ?
        JZ  modifie_heure       ; non

        MOV DI,DX               ; DI=AAAAAAAMMMMJJJJJ d'origine
        MOV AL,jour
        MOV SI,NOT msq_jour
        CALL decale_gauche      ; modifie le jour dans DI
        MOV AL,mois
        MOV SI,NOT msq_mois
        CALL decale_gauche      ; modifie le mois dans DI
        MOV AL,annee
        SUB AL,80               ; anne par rapport  1980
        JNS annee_sup_80        ; anne>=80 -> 1980..1999
        ADD AL,80+20            ; anne<80  -> 2000..2079
    annee_sup_80:
        MOV SI,NOT msq_annee
        CALL decale_gauche      ; modifie l'annee dans DI
        MOV DX,DI               ; DX=AAAAAAAMMMMJJJJJ modifi

    modifie_heure:
        CMP nbr_separ_heure,0   ; y a-t-il un paramtre heure ?
        JZ  modifie_date_heure_f; non

        MOV DI,CX               ; DI=HHHHHMMMMMMSSSSS d'origine
        MOV AL,heure
        MOV SI,NOT msq_heure
        CALL decale_gauche      ; modifie les heures dans DI
        MOV AL,min
        MOV SI,NOT msq_min
        CALL decale_gauche      ; modifie les minutes dans DI
        CMP nbr_separ_heure,1   ; paramtre heure au format HH:MM ?
        JE  modifie_pas_seconde ; oui
        MOV AL,sec
        SHR AL,1                ; secondes par unit de 2
        MOV SI,NOT msq_sec
        CALL decale_gauche      ; modifie les secondes dans DI
    modifie_pas_seconde:
        MOV CX,DI               ; CX=HHHHHMMMMMMSSSSS modifi

    modifie_date_heure_f:
        MOV AX,256*57h+1        ; fixe la date & heure de modification
        INT 21h

        RETN

;----------------------------------------------------------
decale_gauche:
; dcale un nombre  gauche (8 bits maximum)
; entres: AL=nombre  dcaler
;          SI=masque d'insertion du nombre
;          DI=valeur 16 bits contenant le nombre dcal
; sortie : DI=nouvelle valeur
; modifie: AX

        PUSH SI
        XOR AH,AH
boucle_decale_g:
        SHR SI,1
        JNC fin_decale_g
        SHL AX,1                ; dcale le nombre masqu  gauche
        JMP SHORT boucle_decale_g
fin_decale_g:
        POP SI
        AND DI,SI
        OR  DI,AX
        RETN

;----------------------------------------------------------
affiche_date_heure:
        MOV DI,offset_date

        MOV AX,DX
        MOV SI,msq_jour
        CALL decale_droite
        CALL bin_asc8           ; crit le jour
        MOV AX,DX
        MOV SI,msq_mois
        CALL decale_droite
        CALL bin_asc8           ; crit le mois
        MOV AX,DX
        MOV SI,msq_annee
        CALL decale_droite
        CMP AL,19               ; anne par rapport  1980
        JBE annee_inf_99        ; anne<=99 -> 1980..1999
        SUB AL,20+80            ; anne>99  -> 2000..2079
    annee_inf_99:
        ADD AL,80
        CALL bin_asc8           ; crit l'anne

        MOV DI,offset_heure

        MOV AX,CX
        MOV SI,msq_heure
        CALL decale_droite
        CALL bin_asc8           ; crit les heures
        MOV AX,CX
        MOV SI,msq_min
        CALL decale_droite
        CALL bin_asc8           ; crit les minutes
        MOV AX,CX
        MOV SI,msq_sec
        CALL decale_droite
        SHL AL,1                ; secondes par unit de 2
        CALL bin_asc8           ; crit les secondes

        RETN

;----------------------------------------------------------
decale_droite:
; dcale un nombre  droite (16 bits maximum)
; entres: AX=valeur contenant le nombre  dcaler
;          SI=masque d'extraction du nombre
; sortie : AX=nombre extrait
; modifie: AX, SI

        AND AX,SI               ; masque les bits utiles
boucle_decale_d:
        SHR SI,1
        JC  fin_decale_d
        SHR AX,1                ; dcale le nombre masqu  droite
        JMP SHORT boucle_decale_d
fin_decale_d:
        RETN

;----------------------------------------------------------
bin_asc8:
; convertit binaire 8 bits -> ascii 2 caractres (0..99)
; entres: AL=nombre  convertir
;          DS:DI=@tampon rsultat
; sortie : -
; modifie: AX, DI -> DI+3

        AAM
        XCHG AH,AL
        ADD W [DI],AX           ; crit le nombre converti
        ADD DI,3
        RETN

;----------------------------------------------------------
CRLF EQU 13,10
             
valeur_incorrecte DB "Valeur incorrecte",CRLF
syntaxe DB "Syntaxe: DATETIME nom_fichier [JJ/MM/AA] [HH:MM[.SS]] {<source} {>destination}",CRLF,'$'

fichier_introuvable DB 'Fichier introuvable',CRLF,'$'
chemin_introuvable  DB 'Chemin introuvable',CRLF,'$'
autre_erreur        DB 'Erreur!',CRLF,'$'

offset_date_heure DW 0

valeur DB 0
nbr_separ_date  DB 0
nbr_separ_heure DB 0

date_heure DB '00/00/00  00:00.00',CRLF,'$'     ;variable partage
offset_date  EQU OFFSET date_heure
offset_heure EQU OFFSET date_heure+10

jour   EQU B [date_heure  ]
mois   EQU B [date_heure+1]
annee  EQU B [date_heure+2]
heure  EQU B [date_heure+3]
min    EQU B [date_heure+4]
sec    EQU B [date_heure+5]

car     EQU B [date_heure+6]
anc_car EQU B [date_heure+7]

END prog
