;Ŀ
; Routines pour l'chantillonnage 8 bits en mono ou stro (64ko max)    
;
; (c) Fabrice Couteau - 10/11/1995 - Dernire modification le 13/02/1997 
;
.MODEL SMALL,PASCAL
.386

.CODE

;------------------------------------------------------------------------------
;PROCEDURE EchantTampon(Var source,destination; long_source,long_dest: Word);
;chantillonnage 8 bits: source (long_source) -> destination (long_dest)

PUBLIC EchantTampon
EchantTampon PROC FAR source_ET: DWORD, destination_ET: DWORD, long_source_ET: WORD, long_dest_ET: WORD

  PUSH DS

  LDS SI,source_ET
  LES DI,destination_ET
  MOVZX EAX,long_source_ET
  MOVZX ECX,long_dest_ET

  XOR EDX,EDX
  SHL EAX,8             ;(EDX,EAX)=256*long_source
  DIV ECX               ;EAX=256*long_source/long_dest
  SHL EDX,1
  CMP EDX,ECX           ;reste >= long_dest/2 ?
  JNAE suite_ET         ;non
  INC EAX               ;incrmente quotient (arrondit  l'entier suprieur)
suite_ET:
  MOV EDX,EAX           ;EDX=incrment (partie entire,partie dcimale)
  XOR EBX,EBX           ;EBX=cumul des incrments

boucle_ET:
  ROR EBX,8             ;BX=partie haute du cumul (partie entire)=dcalage source
  MOV AL,[SI][BX]       ;AL=valeur source
  ROL EBX,8             ;rcupre cumul
  MOV ES:[DI],AL        ;copie valeur dans destination
  INC DI
  ADD EBX,EDX           ;cumul=cumul+incrment
  DEC CX
  JNZ boucle_ET

  POP DS
  RET

EchantTampon ENDP

;------------------------------------------------------------------------------
;PROCEDURE EchantTamponStereo(Var source,dest_gauche,dest_droite; long_source,long_dest: Word);
;chantillonnage 8 bits: source (long_source) -> dest_gauche,dest_droite (long_dest chacun)
;!! ATTENTION !! dest_gauche et dest_droite doivent tre dans le mme segment !!
;format du tampon source: offset pair  =valeur gauche
;                         offset impair=valeur droite

PUBLIC EchantTamponStereo
EchantTamponStereo PROC FAR source_ETS: DWORD, dest_gauche_ETS: DWORD, dest_droite_ETS: DWORD, long_source_ETS: WORD, long_dest_ETS: WORD

  PUSH DS BP

  LDS SI,source_ETS
  LES DI,dest_gauche_ETS
  MOVZX EAX,long_source_ETS
  MOVZX ECX,long_dest_ETS
  LES BP,dest_droite_ETS;!! initialiser BP en dernier (utilis dans long_dest_ETS)

  XOR EDX,EDX
  SHL EAX,8             ;(EDX,EAX)=256*long_source
  DIV ECX               ;EAX=256*long_source/long_dest
  SHL EDX,1
  CMP EDX,ECX           ;reste >= long_dest/2 ?
  JNAE suite_ETS        ;non
  INC EAX               ;incrmente quotient (arrondit  l'entier suprieur)
suite_ETS:
  SHR EAX,1
  MOV EDX,EAX           ;EDX=incrment (partie entire,partie dcimale)
  XOR EBX,EBX           ;EBX=cumul des incrments

boucle_ETS:
  ROR EBX,8             ;BX=partie haute du cumul (partie entire)=dcalage source
  PUSH BX
  SHL BX,1              ;aligne sur un offset pair
  MOV AX,[SI][BX]       ;AL=valeur source gauche, AH=valeur source droite
  POP BX
  ROL EBX,8             ;rcupre cumul
  MOV ES:[DI],AL        ;copie valeur gauche dans dest_gauche
  MOV ES:[BP],AH        ;copie valeur droite dans dest_droite
  INC DI
  INC BP
  ADD EBX,EDX           ;cumul=cumul+incrment
  DEC CX
  JNZ boucle_ETS

  POP BP DS
  RET

EchantTamponStereo ENDP

;------------------------------------------------------------------------------
;PROCEDURE ConvSigne(Var tampon; taille: Word);
;conversion du tampon en 8 bits signs

PUBLIC ConvSigne
ConvSigne PROC FAR tampon_CS: DWORD, taille_CS: WORD

  PUSH DS

  LDS SI,tampon_CS
  MOV CX,taille_CS
  MOV EAX,80808080h
  MOV DL,CL                              
  SHR CX,2              ; CX=taille/4
  AND DL,3              ; DL=taille MOD 4

  JCXZ boucle_fin_CS
  MOV DI,4
boucle_CS:
  XOR [SI],EAX          ; tampon[] = tampon[] XOR 80808080h
  ADD SI,DI
  DEC CX
  JNZ boucle_CS

boucle_fin_CS:
  OR DL,DL
  JZ fin_CS
  XOR [SI],AL           ; tampon[] = tampon[] XOR 80h
  INC SI
  DEC DL
  JMP SHORT boucle_fin_CS

fin_CS:
  POP DS
  RET

ConvSigne ENDP

;------------------------------------------------------------------------------
;PROCEDURE Extension16(Var source,destination; taille: Word; amplification: Byte);
;extension: source 8 bits signs -> destination 16 bits signs, avec amplification

PUBLIC Extension16
Extension16 PROC FAR source_EX: DWORD, destination_EX: DWORD, taille_EX: WORD, amplification_EX: BYTE

  PUSH DS

  LDS SI,source_EX
  LES DI,destination_EX
  MOV CX,taille_EX
  MOV BL,amplification_EX
  MOV DL,CL                              
  SHR CX,2              ; CX=taille/4
  AND DL,3              ; DL=taille MOD 4

  JCXZ boucle_fin_EX
boucle_EX:
  i=0
  REPT 4
   MOV AL,[SI+i]
   IMUL BL
   MOV ES:[DI+2*i],AX   ; destination[] = source[]*amplification
   i=i+1
  ENDM
  ADD SI,4
  ADD DI,4*2
  DEC CX
  JNZ boucle_EX

boucle_fin_EX:
  OR DL,DL
  JZ fin_EX
  MOV AL,[SI]
  IMUL BL
  MOV ES:[DI],AX        ; destination[] = source[]*amplification
  INC SI
  ADD DI,2
  DEC DL
  JMP SHORT boucle_fin_EX

fin_EX:
  POP DS
  RET

Extension16 ENDP

END
