; ͻ
;                                                                   
;  FreeText  Nouveau mode texte 80x50 redfini au dmarrage du PC   
;  ~~~~~~~~  et  chaque changement de mode vido texte             
;                                                                   
;  compilation: modle EXE, ne pas compacter l'excutable!          
;                                                                   
;  utilisation: ajouter "DEVICE=FREETEXT.EXE" dans le CONFIG.SYS    
;                                                                   
; Ķ
;  auteur: Fabrice Couteau          date d'criture      : 31/05/98 
;                                   dernire modification: 04/07/98 
; ͼ

.MODEL TINY

.386

.CODE
        ORG 0                   ; pas de PSP

;== Constantes =========================================================

CRLF EQU 13,10

B EQU BYTE  PTR
W EQU WORD  PTR
D EQU DWORD PTR

car8x16 EQU 14h
car8x14 EQU 11h
car8x8  EQU 12h

; offsets dans le bloc de donnes du driver
ofs_instr EQU 2                 ; octet d'instruction
ofs_etat  EQU 3                 ; mot d'tat
ofs_fin   EQU 14                ; adresse de fin

;== Donnes ============================================================

; entte du driver
    DW -1,-1                    ; lien avec le driver suivant
    DW 1010000000000000b        ; attribut du driver
    DW OFFSET Strategie         ; pointeur sur la routine de stratgie
    DW OFFSET Interruption      ; pointeur sur la routine d'interruption
    DB "$FREETX$"               ; nom du driver

mode_EXE        DB 0            ; mode d'excution EXE
adr_bloc        DD 0            ; adresse du bloc de donnes transmis
anc_INT10       DD 0            ; adresse de l'ancienne INT 10h (BIOS vido)
anc_hauteur     DB 0            ; ancienne hauteur fonte

texte           DB "FreeText v1.0 - (c) 1998 Fabrice Couteau",CRLF,'$'
erreur_VGA      DB "Ce programme ncessite une carte VGA.",CRLF,'$'

; fontes
premier_car EQU "!"
dernier_car EQU ""
nbr_car     EQU dernier_car-premier_car+1

INCLUDE SSerif8.inc

;== Point d'entre =====================================================

start:

;== Routines du programme EXE ==========================================
; excute lorsque le programme est appel depuis la ligne de commande

PROG PROC NEAR

    mov  CS:mode_EXE,1
    call Initialisation         ; appelle la routine d'init en mode EXE

    mov  AX,4C00h               ; fin normale
    int  21h

PROG ENDP

;== Routines et fonctions du driver ====================================

Strategie PROC FAR

    mov  W CS:adr_bloc,BX       ; mmorise l'adresse du bloc de donnes
    mov  W CS:adr_bloc+2,ES

    ret

Strategie ENDP

;-----------------------------------------------------------------------

Interruption PROC FAR

    pusha
    push DS ES
    pushf

    les  DI,D CS:adr_bloc       ; ES:DI -> bloc de donnes
    mov  AX,8003h               ; initialise le mot d'tat
    cmp  B ES:[DI+ofs_instr],00h; seule la fonction Initialisation (00h)
    jne  retour                 ; est autorise

    call Initialisation         ; initialise le driver

retour:
    or   AX,0100h               ; bit "Termin" = 1
    mov  ES:[DI+ofs_etat],AX    ; met  jour le mot d'tat du driver

    popf
    pop  ES DS
    popa

    ret

Interruption ENDP

;-----------------------------------------------------------------------

; fonctions d'accs  la mmoire vido texte
INCLUDE_CAR EQU 1
INCLUDE_DAC EQU 0
INCLUDE VGA.inc

;-----------------------------------------------------------------------

ChangeFonte PROC NEAR

    pusha
    push DS ES

    push 0040h
    pop  ES
    mov  AL,ES:[0085h]          ; AL=hauteur fonte courante (16,14 ou 8)

    cmp  AL,8
    jne  fin_ChangeFonte        ; hauteur fonte <> 8

    push CS
    pop  DS
    lea  SI,SSerif8             ; DS:SI -> fonte SSERIF8

    push AX
    call AccedeCar
    pop  AX                     ; AL=(hauteur fonte)

    push 0A000h
    pop  ES                     ; ES=A000: segment fonte texte en RAM
    mov  DI,32*premier_car      ; offset du premier caractre  redfinir

    xor  AH,AH
    mov  BX,AX
    mov  DX,32
    sub  DX,AX                  ; DX=32-(hauteur fonte): incrment DI
    shr  BL,1                   ; BL=(hauteur fonte)/2

    mov  BH,nbr_car             ; nombre de caractres  redfinir
    xor  CH,CH

    cld
redef_fonte:
    mov  CL,BL                  ; CX=hauteur_car/2
    rep  movsw                  ; redfinit un caractre
    add  DI,DX                  ; ES:DI -> ligne 0 du caractre suivant
    dec  BH
    jnz  redef_fonte

    call AccedeMem

fin_ChangeFonte:
    pop  ES DS
    popa

    ret

ChangeFonte ENDP

;-----------------------------------------------------------------------

NettoieEcran PROC NEAR

    pusha
    push ES

    push 0B800h
    pop  ES
    mov  DI,2*((1-1)+80*(26-1)) ; ES:DI -> B800:(x=1,y=26)
    mov  AX,256*(7+16*0)+" "    ; espace, blanc/noir
    mov  CX,2*80*25             ; 80x25 caractres  effacer
    cld
    rep  stosw                  ; efface la moiti infrieure de l'cran

    pop  ES
    popa
    ret

NettoieEcran ENDP

;-----------------------------------------------------------------------

INT10 PROC FAR

    cmp  AX,0003h               ; fonction 00h (init mode vido) + mode texte (03h) ?
    je   suite_INT10            ; oui

    cmp  AX,256*11h+car8x8      ; fonction 11h (changement hauteur de fonte) + fonte 8x8 ?
    je   suite_INT10            ; oui

    jmp  CS:anc_INT10           ; sinon, excute l'ancienne INT 10h

suite_INT10:
    push AX ES

    push 0040h
    pop  ES
    mov  AL,ES:[0085h]          ; AL=hauteur fonte courante (16,14 ou 8)
    mov  CS:anc_hauteur,AL

    pop  ES AX

    pushf
    call CS:anc_INT10           ; appelle l'ancienne INT 10h

    call ChangeFonte            ; redfinit la fonte courante

    cmp  CS:anc_hauteur,8       ; l'ancienne fonte tait dj 8x8 ?
    je   fin_INT10              ; oui, ne nettoie pas l'cran

    call NettoieEcran

fin_INT10:
    iret                        ; retour  l'appelant

INT10 ENDP

;-- Lorsque le driver est appel en tant que fichier systme (CONFIG.SYS)
;-- la mmoire est libre  partir d'ici

Initialisation PROC NEAR

    push CS
    pop  DS

    mov  W ES:[DI+ofs_fin],OFFSET Initialisation
    mov  ES:[DI+ofs_fin+2],CS   ; fixe l'adresse de fin du driver

    mov  AH,09h
    lea  DX,texte
    int  21h                    ; affiche un message

    mov  AX,1A00h
    int  10h                    ; int. du BIOS VGA pour tester la carte
    cmp  AL,1Ah
    je   ok_carte_VGA           ; carte VGA dtecte -> on continue

    mov  AH,09h
    lea  DX,erreur_VGA
    int  21h                    ; affiche un message

    mov  AX,1
    ret                         ; fin, code de sortie=1 (pas de carte VGA)

ok_carte_VGA:
    mov  AX,0040h
    mov  ES,AX
    mov  AL,ES:[0085h]          ; AL=hauteur fonte courante (16,14 ou 8)
    mov  anc_hauteur,AL

    mov  AX,256*11h+car8x8
    xor  BL,BL                  ; table de caractres n0
    int  10h                    ; charge la fonte 8x8 -> mode 80x50

    call ChangeFonte            ; redfinit la fonte courante

    cmp  anc_hauteur,8          ; l'ancienne fonte tait dj 8x8 ?
    je   suite_init             ; oui, ne nettoie pas l'cran

    call NettoieEcran

suite_init:
    cmp  mode_EXE,1             ; mode d'excution EXE ?
    je   fin_init               ; oui, ne dtourne pas INT 10 (dj fait!)

; dtourne l'interruption 10h: attention! ne pas utiliser la fonction 35h
; de l'interruption 21h, car  ce stade de l'excution, le systme DOS
; n'est pas encore totalement charg; cette fonction n'est pas active...

    cli
    xor  AX,AX
    mov  ES,AX
    lea  AX,INT10
    xchg AX,ES:[4*10h]
    mov  W anc_INT10,AX
    mov  AX,CS
    xchg AX,ES:[4*10h+2]
    mov  W anc_INT10+2,AX       ; mmorise l'adresse de l'ancienne INT 10h
    sti

fin_init:
    xor  AX,AX
    ret                         ; fin, code de sortie=0 (normal)

Initialisation ENDP

;-- Donnes non ncessaires aprs initialisation -----------------------

END start
