;            ͻ
;                  GUSCMD.INC     
;                                                               
;                       --== Mod Master v2.1 ==--           
;            ĺ
;               Auteur Freddy Vtel    
;                                        ( et Joshua C. Jensen) 
;                                                               
;               Dernire modification 01/01/1995       
;            ͼ


; UltraSound Ports

StatusPort      Equ 6h
TimerCtrlPort   Equ 8h
TimerDataPort   Equ 9h
MidiCtrlPort    Equ 100h
MidiDataPort    Equ 101h
ActiveVoicePort Equ 102h
CommandPort     Equ 103h
DataLowPort     Equ 104h
DataHighPort    Equ 105h
DRAMIOPort      Equ 107h

; UltraSound Commands

WriteVoiceMode  Equ 00h
SetVoiceFreq    Equ 01h         ; Value=Freq/Divisor
LoopStartLo     Equ 02h
LoopStartHi     Equ 03h
SampleEndLo     Equ 04h
SampleEndHi     Equ 05h
VolRampRate     Equ 06h
VolRampStart    Equ 07h
VolRampEnd      Equ 08h
SetVolume       Equ 09h
SampleStartLo   Equ 0Ah
SampleStartHi   Equ 0Bh
VoiceBalance    Equ 0Ch
VolumeCtrl      Equ 0Dh
VoicesActive    Equ 0Eh
DMACtrl         Equ 41h
DRAMAddrLo      Equ 43h
DRAMAddrHi      Equ 44h
TimerCtrl       Equ 45h
TimerCount1     Equ 46h
TimerCount2     Equ 47h
SampleFreq      Equ 48h
SampleCtrl      Equ 49h
Initialize      Equ 4Ch
Read            Equ 80h
ReadVolume      Equ Read+SetVolume      ; 89h
VoicePosLo      Equ Read+SampleStartLo  ; 8Ah
VoicePosHi      Equ Read+SampleStartHi  ; 8Bh
ReadVolCtrl     Equ Read+VolumeCtrl     ; 8Dh
IRQStatus       Equ 8Fh

; Divisors

Voices14        DW 43
Voices15        DW 40
Voices16        DW 37
Voices17        DW 35
Voices18        DW 33
Voices19        DW 31
Voices20        DW 30
Voices21        DW 28
Voices22        DW 27
Voices23        DW 26
Voices24        DW 25
Voices25        DW 24
Voices26        DW 23
Voices27        DW 22
Voices28        DW 21
Voices29        DW 20
Voices30        DW 20
Voices31        DW 19
Voices32        DW 18

; Number of voices to use

DivVoices       DW  43

U_TimerMask    DB 0
U_TimerControl DB 0
U_Adlibcontrol DB 0

UInit_Play Proc Near

        MOV AX,Voices14
        MOV DivVoices,AX
        CMP Nb_de_Voies,14
        JB Pas_Modif_Diviseur
        XOR AX,AX
        MOV AL,Nb_de_voies
        CMP AX,32
        JBE Init_Div
        MOV AX,32
        MOV Nb_de_Voies,AL
Init_Div:
        MOV SI,Offset Voices14
        SUB AX,14
        SHL AX,1
        ADD SI,AX
        MOV AX,Word Ptr [SI]
        MOV DivVoices,AX
Pas_Modif_Diviseur:
        MOV U_TimerMask,0
        MOV U_TimerControl,0
        MOV U_Adlibcontrol,0

        RET
UInit_Play Endp


; bx - Speed (0-255)  (* 80 microseconds)
U_TurnOnUserInt  Proc Near
        CLI
        OR    CS:[U_Adlibcontrol],4
        OR    CS:[U_Timermask],1
        MOV   DX,CS:[GUSBasePort]
        ADD   DX,CommandPort
        MOV   AL,TimerCount1   ;Registre TimerCount1
        OUT   DX,AL
        ADD   DX,2
        MOV   AL,BL
        OUT   DX,AL            ;DataHighPort <- bl
        SUB   DX,2
        MOV   AL,TimerCtrl     ;Registre TimerCtrl
        OUT   DX,AL
        ADD   DX,2
        MOV   AL,CS:[U_Adlibcontrol]
        OUT   DX,AL            ;DataHighPort  <- AdlibControl
        MOV   DX,CS:[GUSBasePort]
        ADD   DX,TimerCtrlPort
        MOV   AL,4
        OUT   DX,AL            ;TimerCtrlPort <- 4
        INC   DX
        MOV   AL,CS:[U_Timermask]
        OUT   DX,AL            ;TimerDataPort <- TimerMask
        STI
        RET
U_TurnOnUserInt Endp

U_TurnOffUserInt Proc Near
        CLI
        AND   CS:[u_adlibcontrol],0FBh
        AND   CS:[u_timermask],0FEh
        MOV   DX,CS:[GUSBasePort]
        ADD   DX,CommandPort
        MOV   AL,TimerCtrl     ;Registre TimerCtrl
        OUT   DX,AL
        ADD   DX,2
        MOV   AL,CS:[U_adlibcontrol]
        OUT   DX,AL            ;DataHighPort  <- AdlibControl

        MOV   DX,CS:[GUSBasePort]
        ADD   DX,TimerCtrlPort
        MOV   AL,4
        OUT   DX,AL            ;TimerCtrlPort <- 04h
        INC   DX
        MOV   AL,CS:[U_timermask]
        OR    AL,80h
        OUT   DX,AL            ;TimerDataPort <- TimerMask OR 80h
;        call    u_Reset
        STI
        RET
U_TurnOffUserInt Endp

; AL - Voice
U_SetVoice Proc Near
        MOV  DX,CS:[GUSBasePort]
        ADD  DX,ActiveVoicePort
        OUT  DX,AL
        RET
U_SetVoice Endp

UDelay          Proc    Near
        PUSH DX
        PUSH AX
        MOV DX,CS:[GUSBasePort]
        ADD DX,CommandPort
        IN  AL,DX
        IN  AL,DX
        IN  AL,DX
        IN  AL,DX
        IN  AL,DX
        IN  AL,DX
        IN  AL,DX
        POP AX
        POP DX
        ret
UDelay          EndP

; CX:AX  - Number
; Destroys BX
RShift          Proc    Near

        mov     bx,cx
        shr     ax,7
        shr     cx,7
        shl     bx,9
        or      AX,bx
        ret

RShift          EndP

; BX:CX Set to whatever.
; AL Set set to value at BX:CX
; AH Destroyed
U_Peek  Proc Near
        push    DX
        MOV     DX,CS:[GUSBasePort]
        ADD     DX,CommandPort
        MOV     AL,DRAMAddrLo
        OUT     DX,AL
        inc     DX                      ; DataLowPort
        MOV     AX,cx
        OUT     DX,AX
        dec     DX                      ; CommandPort
        MOV     AL,DRAMAddrHi
        OUT     DX,AL
        ADD     DX,2
        MOV     AL,bl
        OUT     DX,AL
        ADD     DX,2
        IN      AL,DX
        pop     DX
        ret
U_Peek  EndP

; BX:CX Set to whatever.
; AX Value to poke
U_Poke  Proc  Near
        push    DX
        push    AX
        MOV     DX,CS:[GUSBasePort]
        ADD     DX,CommandPort  ; Select Register (3x3)
        MOV     AL,DRAMAddrLo
        OUT     DX,AL
        inc     DX              ; DataLowPort     (3x4)
        MOV     AX,cx
        OUT     DX,AX
        dec     DX              ; CommandPort     (3x3)
        MOV     AL,DRAMAddrHi
        OUT     DX,AL
        ADD     DX,2            ; DataHighPort    (3x5)
        MOV     AL,bl
        OUT     DX,AL
        ADD     DX,2            ; DRAMIOPort      (3x7)
        pop     AX
        OUT     DX,AL
        pop     DX
        ret
U_Poke EndP

; DX/AX - Frequency * 100
; Destroys CX, DX
U_SetFreq Proc Near     ; Close enough for me...
        MOV     CX,DivVoices
        DIV     CX
        PUSH    AX
        MOV     DX,CS:[GUSBasePort]
        ADD     DX,CommandPort
        MOV     AL,1
        OUT     DX,AL
        INC     DX              ; DataLowPort
        POP     AX
        OUT     DX,AX
        RET
U_SetFreq       EndP

; BX - Balance (0-f) 7 is middle
; Destroys DX
U_SetBalance Proc Near
        MOV  DX,CS:[GUSBasePort]
        ADD  DX,CommandPort
        MOV  AL,VoiceBalance
        OUT  DX,AL
        ADD  DX,2
        MOV  AX,BX
        OUT  DX,AL
        RET
U_SetBalance EndP

; BX - Volume
; Destroys DX,SI

U_SetVolume Proc Near
        MOV SI,Offset GUSVOL
        SHL BX,1
        ADD SI,BX
        MOV BX,[SI]             ; Cherche le volume en log...
        MOV DX,CS:[GUSBasePort]
        ADD DX,CommandPort
        MOV AL,SetVolume
        OUT DX,AL
        INC DX              ; DataLowPort
        MOV AX,BX
        OUT DX,AX
        RET
U_SetVolume Endp

; BX - Volume  atteindre

DoRamp Proc Near

        MOV SI,Offset GUSVOL
        SHL BX,1
        ADD SI,BX
        MOV BX,[SI]             ; Cherche le volume en log...

        MOV  SI,BX
        MOV  DX,CS:[GUSBasePort]
        ADD  DX,CommandPort
        MOV  AL,VolumeCtrl
        OUT  DX,AL
        ADD  DL,2
        MOV  AL,3
        OUT  DX,AL
        SUB  DL,2
        MOV  AL,ReadVolume
        OUT  DX,AL
        INC  DX
        IN   AX,DX
        PUSH SI
        PUSH AX
        SHR  AX,8
        SHR  SI,8
        CMP  AX,SI
        JZ   @@Done2
        JB   @@OK
        XCHG SI,AX
@@OK:
        PUSH AX
        MOV  DX,CS:[GUSBasePort]
        ADD  DX,CommandPort
        MOV  AL,VolRampStart
        OUT  DX,AL
        ADD  DX,2
        POP  AX
        OUT  DX,AL
        MOV  DX,CS:[GUSBasePort]
        ADD  DX,CommandPort
        MOV  AL,VolRampEnd
        OUT  DX,AL
        ADD  DX,2
        MOV  AX,SI
        OUT  DX,AL
        MOV  DX,CS:[GUSBasePort]
        ADD  DX,CommandPort
        MOV  AL,VolRampRate
        OUT  DX,AL
        ADD  DX,2
        MOV  AL,00111111b
        OUT  DX,AL
        MOV  BL,00000000b
        POP  AX
        POP  SI
        CMP  AX,SI
        JB   @@OK2
        OR   BL,01000000b
@@OK2:
        MOV  DX,CS:[GUSBasePort]
        ADD  DX,CommandPort
        MOV  AL,0Dh
        OUT  DX,AL
        ADD  DX,2
        MOV  AL,BL
        OUT  DX,AL
        JMP  @@Done

@@Done2:
        POP AX
        POP AX
@@Done:
        RET
DoRamp  Endp

; BX - Mode
;          bit 0: 0=voice on (along with bit 1)
;          bit 1: 0=voice on (along with bit 0)
;          bit 2: 0=8 bit data, 1=16 bit data
;          bit 3: 0=No loop, 1=Loop
;          bit 4: 0=Go forward, 1=Go backward
U_SetLoopMode   Proc    Far
        MOV     DX,CS:[GUSBasePort]
        ADD     DX,CommandPort
        MOV     AL,80h
        ADD     DX,2            ; DataHighPort
        IN      AL,DX
        MOV     BH,AL
        SUB     DX,2            ; CommandPort
        XOR     AL,AL
        OUT     DX,AL
        ADD     DX,2            ; DataHighPort
        AND     bh,0E7h
        OR      BH,BL
        MOV     AL,bh
        OUT     DX,AL
        RET
U_SetLoopMode   EndP

; Destroys DX, BX
U_StopVoice     Proc    Far
        MOV DX,CS:[GUSBasePort]
        ADD DX,CommandPort
        XOR AL,AL
        OUT DX,AL           ; Commande 0 => Write Voice Mode
        ADD DX,2            ; DataHighPort
        MOV AL,2            ; 00000010b =>Stopper la voie
        OUT DX,AL           ; Stop -> Mode de la voie
        CALL UDelay
        SUB DX,2            ; CommandPort
        XOR AL,AL
        OUT DX,AL
        ADD DX,2            ; DataHighPort
        MOV AL,2
        OUT DX,AL           ; Ecrire une deuxime fois
        RET
U_StopVoice  EndP


_SampleBegin    dd      0       ; Start location in DRAM
                                ; (apparently 32-byte aligned) NOT!
_SampleStart    dd      0       ; Start location of loop
_SampleEnd      dd      0       ; End of sample

; BX - Mode
U_StartVoice    Proc    Near
        PUSH    BX
; ***** Send sample begin
        MOV     DX,CS:[GUSBasePort]
        ADD     DX,CommandPort
        MOV     AL,SampleStartLo
        OUT     DX,AL
        INC     DX              ; DataLowPort (3x4h)
        MOV AX,Word Ptr cs:[_SampleBegin]
        MOV CX,Word Ptr cs:[_SampleBegin+2]
        CALL RShift
        OUT DX,AX
        DEC DX                  ; CommandPort (3x3h)
        MOV AL,SampleStartHi
        OUT DX,AL
        INC DX                  ; DataLowPort (3x4h)
        MOV AX,Word Ptr CS:[_SampleBegin]
        SHL AX,9
        OUT     DX,AX
; ***** Send sample start
        DEC DX                  ; CommandPort (3x3h)
        MOV AL,2
        OUT DX,AL
        INC DX                  ; DataLowPort (3x4h)
        MOV AX,Word Ptr CS:[_SampleStart]
        MOV CX,Word Ptr CS:[_SampleStart+2]
        CALL RShift
        OUT DX,AX
        DEC DX                  ; CommandPort (3x3h)
        MOV AL,3
        OUT DX,AL
        INC DX                  ; DataLowPort (3x4h)
        MOV AX,Word Ptr CS:[_SampleStart]
        SHL AX,9
        OUT DX,AX
; ***** Send sample end
        DEC DX                  ; CommandPort (3x3h)
        MOV AL,4
        OUT DX,AL
        INC DX                  ; DataLowPort (3x4h)
        MOV AX,Word Ptr CS:[_SampleEnd]
        MOV CX,Word Ptr CS:[_SampleEnd+2]
        CALL RShift
        OUT DX,AX
        DEC DX                  ; CommandPort (3x3h)
        MOV AL,5
        OUT DX,AL
        INC DX              ; DataLowPort 104h
        MOV AX,Word Ptr CS:[_SampleEnd]
        SHL AX,9
        OUT DX,AX
        DEC DX              ; CommandPort 103h
; ***** Play it!  (I hope)
        MOV AL,0
        OUT DX,AL
        POP AX              ; AL <- Mode
        ADD DX,2            ; DataHighPort 105h
        OUT DX,AL
        RET

endp    U_StartVoice

;U_StartVoice    Proc  Near
;        MOV     AX,Word Ptr [StartP]
;        MOV     BX,Word Ptr [StartP+2]
;        MOV     Word Ptr cs:[_SampleBegin  ],AX
;        MOV     Word Ptr cs:[_SampleBegin+2],bx
;        RET
;U_StartVoice    EndP

; Returns:  DX:AX - Position
; Wastes CX
U_ReadPos  Proc Near
        MOV     DX,CS:[GUSBasePort]
        ADD     DX,CommandPort
        MOV     AL,VoicePosLo
        OUT     DX,AL
        INC     DX              ; DataLowPort 104h
        IN      AX,DX           ; TEMP0
        MOV     CX,AX
        DEC     DX              ; CommandPort 103h
        MOV     AL,VoicePosHi
        OUT     DX,AL
        INC     DX              ; DataLowPort 104h
        IN      AX,DX           ; TEMP1
        SHL     CX,7
        SHR     AX,9
        AND     AX,7Fh
        MOV     DX,AX
        AND     DX,0Fh
        MOV     AX,CX
        RET
U_ReadPos       EndP

; AX - Mixer control
;  bit 0: 0=linein on, 1=linein off
;  bit 1: 0=OUTput on, 1=OUTput off
;  bit 2: 0=micin off, 1=micin on

U_ChangeInOUT   Proc    Far
        MOV     DX,CS:[GUSBasePort]
        OUT     DX,AL
        RET
U_ChangeInOUT   EndP

U_Changer_Sample Proc Near
        TEST VControle[BX],M_Pas_Active ;Voie active ?
        JNZ GUS_Sample_VIDE

;        MOV BL,[BX+VSample]      ;BL <-Sample
;        SHL BX,2
;        LES DI,VPtrSample[BX]    ;Pointeur sur le sample

        MOV BX,Voie_Reelle
        SHL BX,2                 ;BX <- 4*Voie
        LES DI,VPtrSample[BX]    ;Pointeur sur le sample
        SHR BX,1                 ;BX <- 2*Voie

        MOVZX ECX,VOffset_Actuel[BX] ; ECX <- Offset de dbut
        CMP ECX,ES:SLen[DI]
        JA GUS_Sample_VIDE           ; Offset Dbut > Taille => Ne pas jouer

        MOV EAX,ES:SAdresse_GUS[DI]  ; Adresse du sample dans la GUS
        PUSH EAX
        ADD ECX,EAX              ; Dbut=Dbut sample+Offset de dpart
        MOV [_SampleBegin],ECX   ; Dbut du sample
        ADD EAX,ES:SLen[DI]      ; Fin=Dbut+Taille
        MOV [_SampleEnd],EAX     ; Fin du sample
        POP EAX

        MOV ECX,ES:SRep[DI]
        ADD EAX,ECX
        MOV [_SampleStart],EAX   ; Dbut du bouclage

                                 ; *** Mode de sortie du sample ***
        MOV AL,ES:SInfo[DI]      ; Lire les Infos du sample
        AND AL,00011100b
        MOV Mode_GUS,AL          ; Mode GUS<-Info AND 00011100b

        XOR BX,BX                ; Volume  zro !!!
        CALL U_SetVolume         ; ( Pour la rampe )
        CALL U_StopVoice         ; Stopper la voie avant modifications

        XOR BX,BX
        MOV BL,Mode_GUS
        CALL U_StartVoice      ; Lancer le sample
        JMP Fin_U_Changer_Sample
GUS_Sample_Vide:               ; Stopper la voie => Volume 0

        CALL U_StopVoice       ; Stopper la voie avant modifications
        XOR BX,BX              ; BX Volume
;        CALL U_SetVolume       ;*** Regler le volume ***
        CALL DoRamp
Fin_U_Changer_Sample:
        RET
U_Changer_Sample Endp

U_Changer_Periode Proc Near

        SHL BX,2                             ; Pointeur Double Mot
        MOV AX,Word Ptr [BX+Frequence_GUS]
        MOV DX,Word Ptr [BX+Frequence_GUS+2]
        SHR BX,2
        CALL U_SetFreq
        RET
U_Changer_Periode EndP

U_Changer_Volume_GUS  Proc Near
        MOV BL,VVolume[BX]
        SHR BL,1
        XOR BH,BH             ;BX Volume
        CALL DoRamp
        RET
U_Changer_Volume_GUS  EndP

KeyOff_GUS PROC NEAR
        XOR BX,BX             ;BX Volume=0
        CALL DoRamp
        RET
KeyOff_GUS ENDP
