TITLE HORLOGE.ASM
; Programme rsident qui affiche une horloge en coordonnes (75,1) en page n0
; noir/blanc dans la RAM vido couleur (raffichage deux fois par seconde).
; Peut tre cache/affiche en appuyant sur les deux touches Shift.
; L'horloge peut tre ractualise (aprs un TIME par ex.) en appuyant
;  sur les touches Ctrl et Shift gauche.

; premier  appel -> installation
; deuxime appel -> dsinstallation


ASSUME CS:CODE

CODE SEGMENT
        ORG 100h                ; programme COM
start:
        JMP PROG                ; contourne les variables et NOUVINT

; donnes rsidentes

ancint1C DD 0                   ; ancienne adresse de INT 1Ch (timer)
ancint09 DD 0                   ; ancienne adresse de INT 09h (clavier)
compteur DB 0                   ; compteur incrment de 5  chaque appel
                                ; de INT 1Ch tous les 18.2me de seconde
                                ; une seconde s'est coule s'il vaut 91
heures   DB 0
minutes  DB 0
secondes DB 0
clignote DB 0                   ; tmoin pour le clignotement de ":"
cache    DB 1                   ; tmoin pour cacher/afficher l'horloge
                                ; (par dfaut, l'horloge est cache au
                                ;  lancement du programme)
fond_horloge DW 0,0,0,0,0       ; fond de l'horloge (5 caractres recouverts)
ident    DB "HR"                ; chane d'identification du programme

; programme

NOUVINT1C PROC FAR

        ADD compteur,5          ; incrmente le compteur de 5
        CMP compteur,91         ; compteur<91?
        JB suite                ; oui, pas de correction  faire
        SUB compteur,91         ; corrige le compteur
        INC secondes            ; incrmente les secondes
        CMP secondes,60         ; secondes<60?
        JB suite                ; oui, pas de correction  faire
        MOV secondes,0          ; rinitialise les secondes  0
        INC minutes             ; incrmente les minutes
        CMP minutes,60          ; minutes<60?
        JB suite                ; oui, pas de correction  faire
        MOV minutes,0           ; rinitialise les minutes  0
        INC heures              ; incrmente les heures
        CMP heures,24           ; heures<24?
        JB suite                ; oui, pas de correction  faire
        MOV heures,0            ; rinitialise les heures  0
suite:
        CMP cache,1             ; l'horloge est-elle cache?
        JE quitte               ; oui
        CMP compteur,4          ; compteur<=4? (premire demi-seconde)
        JBE affiche             ; oui, il faut rafficher l'horloge
        CMP compteur,43         ; compteur<=43? (deuxime demi-seconde)
        JBE quitte              ; oui, il ne faut pas rafficher l'horloge
        CMP compteur,48         ; compteur<=48? (deuxime demi-seconde)
        JNBE quitte             ; non, il ne faut pas rafficher l'horloge
affiche:
        PUSH AX                 ; sauvegarde les registres modifis
        PUSH CX
        PUSH ES
        PUSH DI
        
        MOV AX,0B800h
        MOV ES,AX               ; ES=B800: segment RAM vido couleur
        MOV DI,2*74+160*0       ; coordonnes (75,1) sur la page n0

        CLD                     ; sens croissant

        MOV AL,heures
        CALL divise             ; spare dizaines et units d'heures
        OR AL,AL                ; dizaines d'heures=0?
        JNZ suite1              ; non, on continue
        MOV AL,240              ; il faut afficher un espace au lieu de "0"
                                ; astuce: 240+48=32 sur un octet
suite1:
        CALL affichenombre      ; affiche les heures
        XOR clignote,1          ; inverse le tmoin de clignotement
        MOV AL,":"              ; par dfaut, il faut afficher ":"
        JZ suite2               ; si clignote=0, il faut afficher ":"
        MOV AL," "              ; sinon, il faut afficher un espace
suite2:
        STOSW                   ; affiche ":" ou espace (clignotement)

        MOV AL,minutes
        CALL divise             ; spare dizaines et units de minutes
        CALL affichenombre      ; affiche les minutes

        POP DI                  ; restaure les registres
        POP ES
        POP CX
        POP AX
quitte:               
        JMP ancint1C            ; excute l'ancien gestionnaire INT 1Ch

divise:
        XOR AH,AH               ; AX=nombre  diviser par 10
        MOV CL,10
        DIV CL                  ; AL=dizaines, AH=units
        MOV CH,AH               ; sauvegarde les units
        MOV AH,112              ; attribut noir/blanc
        RETN                    ; retour NEAR

affichenombre:
        ADD AL,48               ; convertit dcimal en ASCII
        STOSW                   ; affiche les dizaines
        MOV AL,CH               ; restaure les units
        ADD AL,48               ; convertit dcimal en ASCII
        STOSW                   ; affiche les units
        RETN                    ; retour NEAR

NOUVINT1C ENDP


NOUVINT09 PROC FAR

        PUSHF
        CALL ancint09           ; appelle l'ancien gestionnaire INT 09h

        PUSH AX                 ; sauve les registres modifis
        PUSH CX
        PUSH DX
        PUSH SI
        PUSH DI
        PUSH DS
        PUSH ES

        MOV AX,40h
        MOV DS,AX
        MOV AL,DS:[17h]         ; AL=tat du clavier
        MOV CL,AL

        AND AL,00000011b
        CMP AL,00000011b        ; les 2 touches Shift sont-elles appuyes?
        JNE pas_2_shift         ; non

        MOV AX,0B800h
        MOV DS,AX               ; DS=B800: segment RAM vido couleur
        MOV SI,2*74+160*0
        PUSH CS
        POP ES
        MOV DI,OFFSET fond_horloge

        XOR cache,1             ; inverse le tmoin d'affichage de l'horloge

        JZ sauve_fond_horloge   ; si cache=0 (raffiche l'horloge), sauve les
                                ; 5 caractres qui vont tre recouverts

        XCHG SI,DI              ; inverse le sens de la copie
        PUSH CS
        POP DS
        MOV ES,AX
sauve_fond_horloge:                                    
        CLD                     ; sens croissant
        MOV CX,5
        REP MOVSW               ; copie 5 caractres

pas_2_shift:
        AND CL,00000110b
        CMP CL,00000110b        ; les touches Ctrl et Shift gauche sont-elles appuyes?
        JNE pas_ctrl_shift      ; non

        MOV AH,2Ch
        INT 21h                 ; lit l'heure
        MOV heures,CH
        MOV minutes,CL
        MOV secondes,DH

pas_ctrl_shift:
        POP ES                  ; restaure les registres
        POP DS
        POP DI
        POP SI
        POP DX
        POP CX
        POP AX

        IRET                    ; retour  l'appelant

NOUVINT09 ENDP


PROG PROC NEAR

        MOV AX,351Ch
        INT 21h                 ; lit le vecteur INT 1Ch
        CMP WORD PTR ES:[ident],"RH"    ; INT 1Ch dtourne?
        JNE installe            ; non, on installe

        MOV AX,3509h
        INT 21h                 ; lit le vecteur INT 09h
        CMP WORD PTR ES:[ident],"RH"    ; INT 09h dtourne?
        JE desinstalle          ; oui, on dsinstalle

installe:
        MOV AX,351Ch
        INT 21h                 ; lit le vecteur de INT 1Ch
        MOV WORD PTR [ancint1C],BX
        MOV WORD PTR [ancint1C+2],ES    ; mmorise l'adresse

        MOV AX,3509h
        INT 21h                 ; lit le vecteur de INT 09h
        MOV WORD PTR [ancint09],BX
        MOV WORD PTR [ancint09+2],ES    ; mmorise l'adresse

        MOV AX,251Ch
        MOV DX,OFFSET NOUVINT1C
        INT 21h                 ; installe nouvelle INT 1Ch

        MOV AX,2509h
        MOV DX,OFFSET NOUVINT09
        INT 21h                 ; installe nouvelle INT 09h

        MOV AH,2Ch
        INT 21h                 ; lit l'heure
        MOV heures,CH
        MOV minutes,CL
        MOV secondes,DH

        LEA DX,PROG
        ADD DX,15               ; taille du module rsident
        MOV CL,4
        SHR DX,CL               ; divise par 16
        MOV AX,3100h
        INT 21h                 ; termine en laissant rsident

desinstalle:               
        LDS DX,ES:[ancint1C]
        MOV AX,251Ch
        INT 21h                 ; restaure ancienne INT 1Ch

        LDS DX,ES:[ancint09]
        MOV AX,2509h
        INT 21h                 ; restaure ancienne INT 09h

        PUSH ES                 ; sauvegarde le segment TSR-PSP
        MOV ES,ES:[02Ch]        ; segment de l'environnement PSP
        MOV AH,49h
        INT 21h                 ; libre la mmoire
        POP ES
        MOV AH,49h
        INT 21h                 ; libre la mmoire

        MOV AX,4C00h
        INT 21h                 ; fin

PROG ENDP

CODE ENDS
END start

