; Petit programme qui remplace la chane 'LZ91' d'un fichier EXE compact
; avec LZEXE par une chane alatoire (dpend de l'heure)
; - syntaxe: LZ91 nom_fichier_EXE (sans l'extension!)

ASSUME CS:CODE

CODE SEGMENT
        ORG 100h        ; programme COM

start:
        JMP debut       ; contourne les variables
             
CRLF EQU 13,10
             
syntaxe DB "Syntaxe: LZ91 nom_fichier_EXE (sans l'extension!)",CRLF,'$'
offset_LZ91 EQU OFFSET syntaxe+9

fichier_introuvable DB 'Fichier introuvable',CRLF,'$'
chemin_introuvable  DB 'Chemin introuvable',CRLF,'$'
autre_erreur        DB 'Erreur!',CRLF,'$'

pas_LZ91 DB 'Chane LZ91 introuvable',CRLF,'$'
ok       DB 'Ok!',CRLF,'$'

buffer DB 0,0,0,0


debut:
        PUSH CS
        POP DS
        MOV BL,BYTE PTR DS:[128]; lit dans le PSP
        XOR BH,BH               ; BX=longueur de la liste de paramtres+1
        OR BL,BL                ; longueur=1?
        JNZ ouvre_fichier       ; oui (il y a un paramtre)
        MOV DX,OFFSET syntaxe
        JMP affiche_message

ouvre_fichier:
        DEC BL                  ; BX=longueur de la liste de paramtres
        MOV WORD PTR [130+BX],'E.' ; ajoute l'extension .EXE
        MOV WORD PTR [132+BX],'EX' ;
        MOV BYTE PTR [134+BX],0 ; termine le paramtre par un 0 (ASCIIZ)

        MOV AX,256*3Dh+00010010b
        MOV DX,130              ; offset des paramtres dans le PSP
        INT 21h                 ; ouvre le fichier en lecture et criture
        JNC pas_erreur_fichier
        JMP erreur_fichier
pas_erreur_fichier:
        MOV BX,AX               ; handle

        MOV AX,256*42h+0        ; distance par rapport au dbut du fichier
        XOR CX,CX
        MOV DX,28               ; position du dbut de la chane 'LZ91'
        INT 21h                 ; dplace le pointeur

        MOV AH,3Fh
        MOV CX,4                ; 4 octets  lire
        MOV DX,OFFSET buffer
        INT 21h                 ; lit la chane

        MOV SI,OFFSET buffer
        PUSH DS
        POP ES
        MOV DI,offset_LZ91
        CLD
        REPE CMPSB              ; compare les deux chanes
        JE LZ91_trouvee         ; chane 'LZ91' trouve!
        MOV DX,OFFSET pas_LZ91
        JMP affiche_message

LZ91_trouvee:                     
        MOV DI,OFFSET buffer

        MOV AH,2Ch
        INT 21h                 ; lit l'heure
        MOV AL,DL
        SHR AL,1
        SHR AL,1                ; divise les centimes par 4
        STOSB                   ; stocke le premier caractre
        XOR AL,AL
        STOSB                   ; stocke le deuxime caractre
        MOV AL,DH
        ADD AL,128              ; incrmente les secondes
        STOSB                   ; stocke le troisime caractre
        MOV AL,DL
        ADD AL,128              ; incrmente les centimes
        STOSB                   ; stocke le quatrime caractre

        MOV AX,256*42h+0        ; distance par rapport au dbut du fichier
        XOR CX,CX
        MOV DX,28               ; position du dbut de la nouvelle chane
        INT 21h                 ; dplace le pointeur

        MOV AH,40h
        MOV CX,4                ; 4 octets  crire
        MOV DX,OFFSET buffer
        INT 21h                 ; crit la nouvelle chane
        JC erreur_fichier

        MOV AH,3Eh
        INT 21h                 ; ferme le fichier

        MOV DX,OFFSET ok
        JMP affiche_message

erreur_fichier:
        MOV DX,OFFSET fichier_introuvable
        CMP AX,2
        JE affiche_message
        MOV DX,OFFSET chemin_introuvable
        CMP AX,3
        JE affiche_message
        MOV DX,OFFSET autre_erreur

affiche_message:
        MOV AH,9
        INT 21h                 ; affiche un message

        MOV AX,4C00h
        INT 21h                 ; fin

CODE ENDS
END start

