;            ͻ
;                  MIXAGE.INC       
;                                                               
;                       --== Mod Master v2.2 ==--           
;            ĺ
;               Auteur Freddy Vtel    
;                                                               
;               Dbut d'criture ???              
;               Dernire modification 18/04/1996       
;            ͼ

;   !!!! A faire => Memes calculs pour avec ou sans bouclage !!!!!

NB_Repetitions EQU 64

showborder = 0           ; 'Raster' pour le %machine
setborder MACRO no
      if showborder
      PUSH dx ax
      MOV  dx,03dah
      IN   al,dx
      MOV  dx,03c0h
      MOV  al,31h
      OUT  dx,al
      MOV  al,no
      OUT  dx,al
      POP  ax dx
      endif
ENDM

;Ŀ
;                  Chargement du sample                     
;                                                           
; Entre: BX,BP N de voie                                  
;                                                           
; Sortie: ES:DI, Pointeur sur la structure du sample        
;         Carry, ne pas jouer le sample                     
;                                                           
; Attention: ne pas modifier BX,CX,BP !                     
;

Acceder_au_sample PROC Near
        CMP Type_Voie[BX],1   ;Voie Digitale et active ?
        JNE Smp_Pas_Charge    ;Non => Fin

        TEST VControle[BX],M_KeyOff       ;KeyOff ?
        JZ AS_Pas_KeyOff
        AND VControle[BX],Not M_KeyOff    ;Dsactiver le KeyOff
        OR VControle[BX],M_Pas_Active     ;Dsactiver la voie
        JMP Smp_Pas_Charge
AS_Pas_KeyOff:

        MOV AL,VControle[BX]  ;Voie active et pas stoppe ?
        AND AL,00000011b
        JNZ Smp_Pas_Charge    ;Non => Sample pas charg

        VPointer_Sample BX    ;Pointer le sample

        CMP AL,Max_Samples    ;Eviter les poblmes (si pas d'EMS installe)
        JAE Smp_Pas_Charge    ; ??????????????????????????????????????????

        MOV AX,ES:SHandle_EMS[DI]
        MOV Handle_EMS,AX            ;Charge le handle EMS
        MOV AL,ES:SNb_Pages_EMS[DI]
        MOV Nb_Pages_EMS,AL          ;Charge le nombre de pages EMS utilis

        CALL Placer_Pages_EMS        ;Placer les pages EMS en mmoire basse

Smp_Charge:
        CLC
        RET
Smp_Pas_Charge:
        STC
        RET
Acceder_au_sample Endp

;Ŀ
;                   Calcul du tampon DMA                    
;

Debut_Tampon DW 0         ;offset de dpart du tampon  calculer

Calcul_tampon PROC NEAR

        CMP DMA_Continu,1
        JE CT_Pas_Echanger_Tampons  ;DMA Continu => Ne pas changer les tampons
        CALL Echanger_Tampons
CT_Pas_Echanger_Tampons:

        setborder 1

        CALL Effacer_Tampon  ;********** Effacer le tampon ***************

        setborder 2

        CMP Utilise_Stereo,1      ;Stro avec panning !!!
        JE Calculer_Tampon_8Panning

Calculer_Tampon_8:
        XOR CH,CH                 ;**** Calcul Mono/Stro ****
        MOV CL,Nb_de_voies
        XOR BX,BX
        XOR BP,BP
Boucle_calculer_samples_8:
        CALL Acceder_au_sample
        JC Voie_Suivante_8        ;Carry => Ne pas calculer...
        PUSH CX BX BP
        CALL Calculer_sample_8
        POP BP BX CX
Voie_Suivante_8:
        INC BX
        ADD BP,2
        DEC CX
        JNZ Boucle_calculer_samples_8

        JMP Convertir_Tampon

Calculer_Tampon_8Panning:

        MOV Utilise_Mixage,0

        ; ********* Calculer en Stereo avec Panning !!! *********

        XOR CH,CH
        MOV CL,Nb_de_voies
        XOR BX,BX
        XOR BP,BP
Boucle_calculer_samples_8Panning:
        CALL Acceder_au_sample
        JC Voie_Suivante_8Panning  ;Carry => Ne pas calculer...
        PUSH CX BX BP
        CALL Calculer_sample_8Panning
        POP BP BX CX
Voie_Suivante_8Panning:
        INC BX
        ADD BP,2
        DEC CX
        JNZ Boucle_calculer_samples_8Panning

        JMP Convertir_Tampon

Convertir_Tampon:

        CALL Convertir_NS

Fin_Calcul_Tampon:

        ;*** Calcul des adresses pour le contrleur DMA ***

        CMP DMA_Continu,1
        JE Pas_Calcul_Adresse_DMA
        CALL Calcul_Adresse_DMA
Pas_Calcul_Adresse_DMA:

        setborder 0
        RET
Calcul_tampon ENDP

;Ŀ
;         -= Calculer les adresses des tampons =-           
;

Calcul_Adresse_DMA Proc Near
        MOV AX,Debut_Tampon          ;Le Tampon  jouer est le tampon
        MOV Pointeur_Tampon_Joue,AX  ;calcul !!

        MOV BX,Pointeur_Tampon_Joue  ;Calcul Adresses Tampon
        SHR BX,4                     ;Pour le DMA
        MOV AX,Seg_Volume
        ADD AX,BX
        SHR AX,4

        XCHG AH,AL
        MOV Page_Tampon_DMA,AX       ;Page pour le DMA

        MOV AX,Seg_Volume
        MOV BX,Pointeur_Tampon_Joue
        SHL AX,4
        ADD AX,BX
        MOV Offset_Tampon_DMA,AX     ;offset pour le DMA

        RET
Calcul_Adresse_DMA Endp

;Ŀ
;               -= Echanger les tampons =-                  
;

Echanger_Tampons Proc Near
        MOV AX,Offset_Tampon1          ;Echange les tampons
        CMP Tampon_Actif,1
        MOV Tampon_Actif,0
        JZ Debut_Calculs
        MOV Tampon_Actif,1
        MOV AX,Offset_Tampon2
Debut_Calculs:
        MOV Debut_Tampon,AX
        RET
Echanger_Tampons Endp

;Ŀ
;                 -= Effacer le tampon =-                   
;

Effacer_Tampon Proc Near
        XOR EAX,EAX
        MOV CX,Taille_Tampon
        SHR CX,1
        CMP Utilise_Stereo,1
        JE ET_Pas_Diviser_CX
        SHR CX,1             ;si Mono 2 fois plus petit
ET_Pas_Diviser_CX:
        ES_ASM
        MOV DI,Debut_Tampon
        MOV ES,Seg_Volume    ;ES=Segment de la table de volume
        CLD
        REP STOSD            ;Efface le tampon
        ES_ASM
        RET
Effacer_Tampon Endp

;Ŀ
;          -= Convertir le tampon en non sign =-           
;             (Avec ou sans mixage des voies)               
;

Convertir_NS Proc Near

        MOV CX,Taille_Tampon
        SHR CX,1
        CMP Utilise_Stereo,1
        JE Convertir_Stereo_8
        SHR CX,1                 ;Mono => Tampon 2 fois plus petit
Convertir_Stereo_8:
        MOV SI,Debut_Tampon
        MOV EAX,80808080h
        MOV DS,Seg_Volume        ;DS=Segment de la table de volume
ALIGN 4
Boucle_Convertir_8:
        XOR D [SI],EAX           ;Sign => Non Sign
        ADD SI,4
        DEC CX
        JNZ Boucle_Convertir_8
        DS_ASM
        JMP Fin_Convertir_NS

Fin_Convertir_NS:
        RET
Convertir_NS ENDP

;Ŀ
;      -= Initialiser les registres pour le mixage =-       
;

Init_Registres_Mixage PROC Near
        DS_ASM
        MOV SI,CS:VOffset_Actuel[BP]  ;-Init SI-   ( Pointeur vers        )
        MOV ES,ES:SSegment[DI]        ;-Init ES-   ( le sample            )

        MOV AL,VPart_Decimale[BX]     ;-Init AL-   ( Incrment dcimal    )
        MOV AH,VAccumulateur[BX]      ;-Init AH-   ( Accumulateur dcimal )
        XOR DX,DX
        MOV DL,VPart_Entiere[BX]
        MOV BP,DX                     ;-Init BP-   ( Incrment entier     )

        MOV CX,Taille_Tampon          ;-Init CX-   ( Nb d'chantillons    )
        MOV BH,VVolume[BX]            ;-Init BH-   ( Volume               )
        MOV Volume_S,BH

        MOV DI,Debut_Tampon           ;-Init DI-   ( Offset du tampon     )
        MOV DS,Seg_Volume             ;-Init DS-   ( Table de volume et tampon )
        RET
Init_Registres_Mixage Endp

Interpol Macro
        PUSH AX            ;** Interpolation ! **
        XOR DX,DX
        MOVSX BX,ES:[SI]   ;BL=Sample sans volume
        MOV DL,AH          ;Partie dcimale dans CX
	MOVSX AX,ES:[SI+1]
        SUB AX,BX          ;AX=Sample[SI+1]-Sample[SI]
        IMUL DX            ;AX=(Sample[SI+1]-Sample[SI])/Partie dcimale
        MOV AL,AH
        MOV AH,DL
        ADD BX,AX          ;AX, valeur de l'interpolation
        POP AX
Endm

;Ŀ
;            -= Calcul du sample 8 Bits Mono =-             
;                                                           
;  Entre: ES:DI Pointeur sur le sample.                    
;                                                           
;

Volume_S DB 0              ;Volume pour l'interpolation...

Fin_Sample DW 0
Taille_Boucle_Sample DW 0

Calculer_sample_8 Proc Near

        TEST ES:SInfo[DI],M_Boucle
        JNZ Sample_Bouclage_8
        JMP Sample_Sans_Bouclage_8

Sample_Bouclage_8:    ;**** Calcul du sample avec bouclage ****

        MOV AX,w ES:SRep_Len[DI]      ;Taille du bouclage
        MOV Taille_Boucle_Sample,AX
        MOV AX,w ES:SLen[DI]
        MOV Fin_Sample,AX             ;Taille du sample

        PUSH BX BP

        CALL Init_Registres_Mixage

        CMP CS:Utiliser_Interpol,1   ;Interpolation ???????
        JE Lancer_8BI
        CALL Mixage_8B               ;Mixage 8 bit avec bouclage...
        JMP Fin_8B
Lancer_8BI:
        CALL Mixage_8BI              ;Mixage 8 bit avec bouclage et interp
Fin_8B:
        POP BP BX
        DS_ASM

        ;- Restaurer les valeurs -

        MOV DS:VOffset_Actuel[BP],SI
        MOV DS:VAccumulateur[BX],AH

        RET

Sample_Sans_Bouclage_8:   ;**** Calcul du sample sans bouclage ****

        MOV DX,w ES:SLen[DI]          ;Sample termin ?
        CMP DX,DS:VOffset_Actuel[BP]
        JBE Sample_Vide_8

        MOV W [OFFSET AM_Fin_8-2],DX  ;Initialise
        MOV W [OFFSET AM_Fin_8I-2],DX ;la fin
        MOV Fin_Sample,DX             ;du sample

        PUSH BX BP

        CALL Init_Registres_Mixage   ;Initialise les registres pour le mixage

        CMP CS:Utiliser_Interpol,1   ;Interpolation ???????
        JE Lancer_8I
        CALL Mixage_8                ;Mixage 8 bit avec bouclage...
        JMP Fin_8
Lancer_8I:
        CALL Mixage_8I               ;Mixage 8 bit avec bouclage et interp
Fin_8:
        POP BP BX
        DS_ASM

          ;- Restaurer les valeurs -

        MOV DS:VOffset_Actuel[BP],SI
        MOV DS:VAccumulateur[BX],AH
Sample_Vide_8:
        CMP SI,Fin_Sample
        JBE Pas_Desactiver_Voie_8
        OR VControle[BX],M_Pas_Active  ;Sample termin => Dsactiver la voie
Pas_Desactiver_Voie_8:
        RET

Calculer_sample_8 Endp

;Ŀ
;             -= Mixage 8 Bits avec bouclage =-             
;                                                           
; Entre:  AH:Accumulateur de la partie dcimale            
;          AL:Incrment de la partie dcimale               
;          BP:Incrmnt de la partie entire                
;          SI:Position entire dans le sample               
;          BH:Volume                                        
;          DS:Segment table de volume                       
;

;Calcul_Rapide8 PROC NEAR   ;**** Bloc de calcul rapide **** (DX libre !)
;        ALIGN 4
;        i=0
;    rept Nb_Repetitions    ; Copier ce bloc Nb_Repetitions fois
;        MOV BL,ES:[SI]     ;BL=Sample sans volume                        (2)
;        MOV BL,[BX]        ;DH=Sample avec le volume et BX offset Volume (2)
;        ADD [DI+i],BL      ;                                             (1)
;        ADD AH,AL          ;Partie dcimale                              (1)
;        ADC SI,BP          ;Partie Entire                               (1)
;        i=i+1
;    endm
;    	ADD DI,Nb_Repetitions
;	RET
;Calcul_Rapide8 Endp

Calcul_Rapide8 PROC NEAR   ;**** Bloc de calcul rapide **** (DX libre !)
        ALIGN 4
        i=0
    rept Nb_Repetitions    ; Copier ce bloc Nb_Repetitions fois
        MOV BL,ES:[SI]     ;BL=Sample sans volume                         (1)
        ADD AH,AL          ;Partie dcimale                               (1)
        MOV BL,[BX]        ;DH=Sample avec le volume et BX offset Volume  (1)
        ADC SI,BP          ;Partie Entire                                (1)
        ADD [DI+i],BL      ;                                              (1)
        i=i+1
    endm
    	ADD DI,Nb_Repetitions
	RET
Calcul_Rapide8 Endp

Mixage_8B Proc Near

Boucle_8RapideB:
        PUSH CX                       ;*** Boucle rapide ***
        CALL Calcul_Rapide8           ;Calcul de 100 Valeurs sans boucle !!!
        POP CX
Test_Pos8B:
        CMP SI,CS:[Fin_Sample]        ;Bouclage ?
        JBE Boucler_8RapideB
        SUB SI,CS:[Taille_Boucle_Sample]
        JMP Test_Pos8B
Boucler_8RapideB:
        SUB CX,Nb_Repetitions
        CMP CX,Nb_Repetitions
        JAE Boucle_8RapideB

        SHR CX,1
        JCXZ Fin_Sample_8B ;Le sample est termin => Stopper la voie
        ALIGN 2
Boucle_sample_8B:          ;Nb de boucles divis par deux
        MOV BL,ES:[SI]     ;BL=Sample sans volume
        MOV DH,[BX]        ;DH=Sample avec le volume et BX offset Volume
        ADD [DI],DH
        INC DI
        ADD AH,AL          ;Partie dcimale
        ADC SI,BP          ;Partie Entire
        MOV BL,ES:[SI]     ;BL=Sample sans volume    (2 fois)
        MOV DH,[BX]        ;DH=Sample avec le volume et BX offset Volume
        ADD [DI],DH
        INC DI
        ADD AH,AL          ;Partie dcimale
        ADC SI,BP          ;Partie Entire
        DEC CX
        JNZ Boucle_sample_8B

Fin_Sample_8B:
        RET
Mixage_8B Endp

;Ŀ
;                  -= Mixage 8 Bits =-                      
;                                                           
; Entre:  AH:Accumulateur de la partie dcimale            
;          AL:Incrment de la partie dcimale               
;          BP:Incrmnt de la partie entire                
;          SI:Position entire dans le sample               
;          BH:Volume                                        
;          DS:Segment table de volume                       
;

Mixage_8 Proc Near
Boucle_8Rapide:
        PUSH CX
        CALL Calcul_Rapide8      ;Calcul de 100 Valeurs sans boucle !!!
        POP CX
        CMP SI,CS:Fin_Sample
        JAE Fin_Sample_8
        SUB CX,Nb_Repetitions
        CMP CX,Nb_Repetitions
        JAE Boucle_8Rapide

        SHR CX,1
        JCXZ Fin_Sample_8 ;Le sample est termin => Stopper la voie
        ALIGN 2
Boucle_sample_8:          ;Diviser le Nb de boucles par deux
        MOV BL,ES:[SI]    ;BL=Sample sans volume
        MOV BL,[BX]       ;DH=Sample avec le volume et BX offset Volume
        ADD [DI],BL
        INC DI
        ADD AH,AL         ;Partie dcimale    (2 fois)
        ADC SI,BP         ;Partie Entire
        MOV BL,ES:[SI]    ;BL=Sample sans volume
        MOV BL,[BX]       ;DH=Sample avec le volume et BX offset Volume
        ADD [DI],BL
        INC DI
        ADD AH,AL         ;Partie dcimale
        ADC SI,BP         ;Partie Entire
        CMP SI,1234h
AM_Fin_8:
        JNB Fin_Sample_8
        DEC CX
        JNZ Boucle_sample_8
Fin_Sample_8:
        RET
Mixage_8 Endp

;Ŀ
;     -= Mixage 8 Bits avec bouclage et interpolation =-    
;                                                           
; Entre:  AH:Accumulateur de la partie dcimale            
;          AL:Incrment de la partie dcimale               
;          BP:Incrmnt de la partie entire                
;          SI:Position entire dans le sample               
;          DS:Segment table de volume                       
;          BH:Volume (et CS:S_Volume)                       
;

Calcul_Rapide8I PROC NEAR   ;**** Bloc de calcul rapide **** (DX libre !)
        ALIGN 2
        PUSH BX
    rept Nb_Repetitions     ; Copier ce bloc Nb_Repetitions fois
        Interpol

        MOV BH,CS:Volume_S ;Rcupre le volume...
        MOV BL,[BX]        ;DH=Sample avec le volume et BX offset Volume
        ADD [DI],BL
        INC DI
        ADD AH,AL          ;Partie dcimale
        ADC SI,BP          ;Partie Entire
    endm
        POP BX
        RET
Calcul_Rapide8I Endp

Mixage_8BI Proc Near

        PUSH BX
Boucle_8RapideBI:
        PUSH CX                       ;*** Boucle rapide ***
        CALL Calcul_Rapide8I          ;Calcul de 100 Valeurs sans boucle !!!
        POP CX
Test_Pos8BI:
        CMP SI,CS:Fin_Sample
        JBE Boucler_8RapideBI
        SUB SI,CS:Taille_Boucle_Sample
        JMP Test_Pos8BI
Boucler_8RapideBI:
        SUB CX,Nb_Repetitions
        CMP CX,Nb_Repetitions
        JAE Boucle_8RapideBI

        SHR CX,1
        JCXZ Fin_Sample_8BI  ;Le sample est termin => Stopper la voie
        ALIGN 2
Boucle_sample_8BI:           ;Nb de boucles divis par deux

        Interpol
        MOV BH,CS:Volume_S   ;Rcupre le volume...

        MOV BL,[BX]          ;DH=Sample avec le volume et BX offset Volume
        ADD [DI],BL
        INC DI
        ADD AH,AL            ;Partie dcimale
        ADC SI,BP            ;Partie Entire

        Interpol
        MOV BH,CS:Volume_S   ;Rcupre le volume...

        MOV BL,[BX]          ;DH=Sample avec le volume et BX offset Volume
        ADD [DI],BL
        INC DI
        ADD AH,AL            ;Partie dcimale
        ADC SI,BP            ;Partie Entire
        DEC CX
        JNZ Boucle_sample_8BI
Fin_Sample_8BI:
        POP BX
        RET
Mixage_8BI Endp

;Ŀ
;          -= Mixage 8 Bits avec interpolation =-           
;                                                           
; Entre:  AH:Accumulateur de la partie dcimale            
;          AL:Incrment de la partie dcimale               
;          BP:Incrmnt de la partie entire                
;          SI:Position entire dans le sample               
;          DS:Segment table de volume                       
;          BH:Volume (et CS:S_Volume)                       
;

Mixage_8I Proc Near

Boucle_8RapideI:

        PUSH CX
        CALL Calcul_Rapide8I     ;Calcul de 100 Valeurs sans boucle !!!
        POP CX

        CMP SI,CS:[Fin_Sample]
        JAE Fin_Sample_8I

        SUB CX,Nb_Repetitions
        CMP CX,Nb_Repetitions
        JAE Boucle_8RapideI

        SHR CX,1
        JCXZ Fin_Sample_8I ;Le sample est termin => Stopper la voie
        ALIGN 2
Boucle_sample_8I:          ;Diviser le Nb de boucles par deux

        Interpol

        MOV BH,CS:Volume_S ;Rcupre le volume...
        MOV BL,[BX]        ;DH=Sample avec le volume et BX offset Volume
        ADD [DI],BL
        INC DI
        ADD AH,AL          ;Partie dcimale    (2 fois)
        ADC SI,BP          ;Partie Entire

        Interpol

        MOV BH,CS:Volume_S ;Rcupre le volume...
        MOV BL,[BX]        ;DH=Sample avec le volume et BX offset Volume
        ADD [DI],BL
        INC DI
        ADD AH,AL          ;Partie dcimale
        ADC SI,BP          ;Partie Entire
        CMP SI,1234h
AM_Fin_8I:
        JNB Fin_Sample_8I
        DEC CX
        JNZ Boucle_sample_8I
Fin_Sample_8I:
        RET
Mixage_8I Endp

;Ŀ
;        -= Calcul du sample 8 Bits avec panning =-         
;                                                           
;  Entre: ES:DI Pointeur sur le sample.                    
;                                                           
;

Droite_Panning DB 0
Gauche_Panning DB 0

Calculer_sample_8Panning Proc Near

        MOV AL,Volume_Droite[BX]       ;Charger les valeurs du volume
        MOV Droite_Panning,AL
        MOV AL,Volume_Gauche[BX]
        MOV Gauche_Panning,AL

        TEST ES:SInfo[DI],M_Boucle
        JNZ Sample_Bouclage_8P
        JMP Sample_Sans_Bouclage_8P
Sample_Bouclage_8P:

        MOV AX,w ES:SRep_Len[DI]      ;Taille du bouclage
        MOV Taille_Boucle_Sample,AX
        MOV AX,w ES:SLen[DI]          ;Taille du sample
        MOV Fin_Sample,AX

        MOV AL,Gauche_Panning
        MOV Byte Ptr CS:[Offset GaucheB-1],AL
        MOV Byte Ptr CS:[Offset GaucheBI-1],AL
        MOV AL,Droite_Panning
        MOV Byte Ptr CS:[Offset DroiteB-1],AL
        MOV Byte Ptr CS:[Offset DroiteBI-1],AL

        PUSH BX BP

        CALL Init_Registres_Mixage   ;Initialise les registres pour le mixage

        CMP CS:Utiliser_Interpol,1   ;Interpolation ???????
        JE Boucle_8RapideBPI

Boucle_8RapideBP:
        PUSH CX
        MOV CX,w CS:Droite_Panning
        CALL Calcul_Rapide8P           ;Calcul de 100 Valeurs sans boucle !!!
        POP CX
Test_Pos8BP:

        CMP SI,CS:[Fin_Sample]
        JBE Boucler_8RapideBP
        SUB SI,CS:[Taille_Boucle_Sample]
        JMP Test_Pos8BP
Boucler_8RapideBP:
        SUB CX,Nb_Repetitions

        CMP CX,Nb_Repetitions
        JA  Boucle_8RapideBP

        JCXZ Fin_Sample_8BP ;Le sample est termin => Stopper la voie
        ALIGN 2
Boucle_sample_8BP:     ;DH et DL ??????
         MOV BH,12h        ;Volume Gauche
GaucheB: MOV BL,ES:[SI]    ;BL=Sample sans volume
         MOV DH,[BX]       ;DH=Sample avec le volume et BX offset Volume
         ADD [DI],DH       ; (Gauche)
         MOV BH,12h        ;Volume Droite
DroiteB:  MOV DH,[BX]      ;DH=Sample avec le volume et BX offset Volume
         ADD [DI+1],DH       ; (Droite)
         ADD DI,2
         ADD AH,AL         ;Partie dcimale (se dplacer dans le sample)
         ADC SI,BP         ;Partie Entire
         DEC CX
         JNZ Boucle_sample_8BP

Fin_Sample_8BP:
        POP BP BX
        DS_ASM

          ;- Restaurer les valeurs -

        MOV DS:VOffset_Actuel[BP],SI
        MOV DS:VAccumulateur[BX],AH
        RET

Boucle_8RapideBPI:
        PUSH CX
        MOV CX,w CS:Droite_Panning
        CALL Calcul_Rapide8PI           ;Calcul de 100 Valeurs sans boucle !!!
        POP CX
Test_Pos8BPI:

        CMP SI,CS:[Fin_Sample]
        JBE Boucler_8RapideBPI
        SUB SI,CS:[Taille_Boucle_Sample]
        JMP Test_Pos8BPI
Boucler_8RapideBPI:
        SUB CX,Nb_Repetitions
        CMP CX,Nb_Repetitions
        JA  Boucle_8RapideBPI

        JCXZ Fin_Sample_8BPI ;Le sample est termin => Stopper la voie
        ALIGN 2
Boucle_sample_8BPI:        ;DH et DL ??????

        Interpol           ;Interpolation

         MOV BH,12h        ;Volume Gauche
GaucheBI: MOV DH,[BX]      ;DH=Sample avec le volume et BX offset Volume
         ADD [DI],DH       ; (Gauche)
         MOV BH,12h        ;Volume Droite
DroiteBI: MOV DH,[BX]      ;DH=Sample avec le volume et BX offset Volume
         ADD [DI+1],DH     ; (Droite)
         ADD DI,2
         ADD AH,AL         ;Partie dcimale (se dplacer dans le sample)
         ADC SI,BP         ;Partie Entire
         DEC CX
         JNZ Boucle_sample_8BPI

Fin_Sample_8BPI:
        POP BP
        POP BX
        DS_ASM

          ;- Restaurer les valeurs -

        MOV DS:VOffset_Actuel[BP],SI
        MOV DS:VAccumulateur[BX],AH
        RET

Sample_Sans_Bouclage_8P:
        MOV DX,w ES:SLen[DI]
        CMP DX,DS:VOffset_Actuel[BP]
        JBE Sample_Vide_8P

        MOV W [OFFSET AM_Fin_8P-2],DX
        MOV Fin_Sample,DX

        MOV AL,Gauche_Panning
        MOV Byte Ptr CS:[Offset GaucheP-1],AL
        MOV Byte Ptr CS:[Offset GauchePI-1],AL
        MOV AL,Droite_Panning
        MOV Byte Ptr CS:[Offset DroiteP-1],AL
        MOV Byte Ptr CS:[Offset DroitePI-1],AL

        PUSH BX BP

        CALL Init_Registres_Mixage   ;Initialise les registres pour le mixage

        CMP CS:Utiliser_Interpol,1   ;Interpolation ???????
        JE Boucle_8RapidePI

Boucle_8RapideP:

        PUSH CX
        MOV CX,w CS:Droite_Panning
        CALL Calcul_Rapide8P     ;Calcul de 100 Valeur sans boucle !!!
        POP CX

        CMP SI,CS:[Fin_Sample]
        JAE Fin_Sample_8P

        SUB CX,Nb_Repetitions
        CMP CX,Nb_Repetitions
        JA  Boucle_8RapideP

        JCXZ Fin_Sample_8P ;Le sample est termin => Stopper la voie
        ALIGN 2
Boucle_sample_8P:
         MOV BH,12h        ;Volume Gauche
GaucheP: MOV BL,ES:[SI]    ;BL=Sample sans volume
         MOV DH,[BX]       ;DH=Sample avec le volume et BX offset Volume
         ADD [DI],DH       ; (Gauche)
         MOV BH,12h        ;Volume Droite
DroiteP: MOV DH,[BX]       ;DH=Sample avec le volume et BX offset Volume
         ADD [DI+1],DH     ; (Droite)
         ADD DI,2
         ADD AH,AL         ;Partie dcimale (se dplacer dans le sample)
         ADC SI,BP         ;Partie Entire
         CMP SI,1234h
AM_Fin_8P:
         JNB Fin_Sample_8P
         DEC CX
         JNZ Boucle_sample_8P
Fin_Sample_8P:
         POP BP BX
         DS_ASM

          ;- Restaurer les valeurs -

        MOV DS:VOffset_Actuel[BP],SI
        MOV DS:VAccumulateur[BX],AH
Sample_Vide_8P:
        CMP SI,Fin_Sample
        JBE Pas_Desactiver_Voie_8P
        OR VControle[BX],M_Pas_Active  ;Sample termin => Dsactiver la voie
Pas_Desactiver_Voie_8P:
        RET

Boucle_8RapidePI:

        PUSH CX
        MOV CX,w CS:Droite_Panning
        CALL Calcul_Rapide8PI     ;Calcul de 100 Valeur sans boucle !!!
        POP CX

        CMP SI,CS:[Fin_Sample]
        JAE Fin_Sample_8PI

        SUB CX,Nb_Repetitions
        CMP CX,Nb_Repetitions
        JA  Boucle_8RapidePI

        JCXZ Fin_Sample_8PI ;Le sample est termin => Stopper la voie
        ALIGN 2
Boucle_sample_8PI:

         Interpol          ;Interpolation !

         MOV BH,12h        ;Volume Gauche
GauchePI: MOV DH,[BX]      ;DH=Sample avec le volume et BX offset Volume
         ADD [DI],DH       ; (Gauche)
         MOV BH,12h        ;Volume Droite
DroitePI: MOV DH,[BX]      ;DH=Sample avec le volume et BX offset Volume
         ADD [DI+1],DH     ; (Droite)
         ADD DI,2
         ADD AH,AL         ;Partie dcimale (se dplacer dans le sample)
         ADC SI,BP         ;Partie Entire
         CMP SI,1234h
AM_Fin_8PI:
         JNB Fin_Sample_8PI
         DEC CX
         JNZ Boucle_sample_8PI
Fin_Sample_8PI:
         POP BP BX
         DS_ASM

        ;- Restaurer les valeurs -

        MOV DS:VOffset_Actuel[BP],SI
        MOV DS:VAccumulateur[BX],AH
Sample_Vide_8PI:
        CMP SI,Fin_Sample
        JBE Pas_Desactiver_Voie_8PI
        OR VControle[BX],M_Pas_Active  ;Sample termin => Dsactiver la voie
Pas_Desactiver_Voie_8PI:
        RET
Calculer_sample_8Panning Endp

;Calcul_Rapide8P PROC NEAR ;11 cycles (normalemment)
;    i=0
;    rept Nb_Repetitions          ;Copier ce bloc Nb_Repetitions fois
;        MOV BH,CH         ;Volume Gauche
;        MOV BL,ES:[SI]    ;BL=Sample sans volume
;        MOV DH,[BX]       ;DH=Sample avec le volume et BX offset Volume
;        ADD [DI+i],DH     ; (Gauche)
;        MOV BH,CL         ;Volume Droite
;        MOV DH,[BX]       ;DH=Sample avec le volume et BX offset Volume
;        ADD [DI+(i+1)],DH ; (Droite)
;        ADD AH,AL         ;Partie dcimale (se dplacer dans le sample)
;        ADC SI,BP         ;Partie Entire
;    i=i+2
;    endm
;        ADD DI,2*Nb_Repetitions
;        RET
;Calcul_Rapide8P Endp

Calcul_Rapide8P PROC NEAR
    i=0
        rept Nb_Repetitions          ;Copier ce bloc Nb_Repetitions fois
        MOV BH,CH         ;Volume Gauche                                (1)
        MOV BL,ES:[SI]    ;BL=Sample sans volume                        (1)
        ADD AH,AL         ;Partie dcimale (se dplacer dans le sample) (1)
        ADC SI,BP         ;Partie Entire                               (1)
        MOV DH,[BX]       ;DH=Sample avec le volume et BX offset Volume (1)
        MOV BH,CL         ;Volume Droite                                (1)
        ADD [DI+i],DH     ; (Gauche)                                    (1)
        MOV DH,[BX]       ;DH=Sample avec le volume et BX offset Volume (1)
        ADD [DI+(i+1)],DH ; (Droite)                                    (1)
        i=i+2
        endm
        ADD DI,2*Nb_Repetitions
        RET
Calcul_Rapide8P Endp

Calcul_Rapide8PI PROC NEAR
    i=0
    rept Nb_Repetitions          ;Copier ce bloc Nb_Repetitions fois
        Interpol

        MOV BH,CH         ;Volume Gauche
        MOV DH,[BX]       ;DH=Sample avec le volume et BX offset Volume
        ADD [DI+i],DH     ; (Gauche)
        MOV BH,CL         ;Volume Droite
        ADD AH,AL         ;Partie dcimale (se dplacer dans le sample)
        MOV DH,[BX]       ;DH=Sample avec le volume et BX offset Volume
        ADC SI,BP         ;Partie Entire
        ADD [DI+(i+1)],DH ; (Droite)
    i=i+2
    endm
        ADD DI,2*Nb_Repetitions

        RET
Calcul_Rapide8PI Endp
