;            ͻ
;                  MODMPAS.ASM      
;                                                               
;              --== Routines sonores pour Mod Master ==--   
;            ĺ
;               Auteur Freddy Vtel    
;               Avec l'aide de Fabrice Couteau  
;                                                               
;               Dbut d'criture 03/05/1993       
;               Dernire modification 21/02/1997       
;            ͼ

; ! Adresse_Table_Periode est +- inutile maintenant !!

YES Equ 0
NO  Equ -1

Mod_Master Equ YES          ;YES => Gestion clavier en plus
                            ;NO  => Musique seulement (pour les dmos)

DS_TP MACRO                 ;pour accder  une variable EXTRN par DS
      MOV DS,CS:DS_TurboPascal
ENDM

DS_ASM MACRO                    ;CS -> DS
      PUSH CS
      POP DS
ENDM

ES_ASM MACRO                    ;CS -> ES
      PUSH CS
      POP ES
ENDM

;Donne un pointeur (ES:DI) sur le sample

Pointer_Sample MACRO N_Smp
      PUSH BX
      MOV BX,N_Smp
      SHL BX,2
      LES DI,PtrSamples[BX]
      POP BX
ENDM

VPointer_Sample MACRO N_Voie
      PUSH BX
      MOV BX,N_Voie
      SHL BX,2
      LES DI,VPtrSample[BX]
      POP BX
ENDM

CODE SEGMENT
     ASSUME CS:CODE, DS:CODE

.386

;ͻ
;                    Constantes principales                    
;ͼ

Max_voies    EQU 32
Max_Samples  EQU 99
Max_Pattern  EQU 256


;ͻ
;                    Variables principales                     
;ͼ

DS_TurboPascal DW 0         ;segment DATA de Turbo Pascal

Erreur_Modm DW 0
Voie_Reelle DW 0

Test_en_cours DB 0          ;Pour le test de vitesse...

Mini_Notes  DW 0
Moyen_Notes DW 0
Maxi_Notes  DW 0

Mini_Notes_Act  DW 0
Moyen_Notes_Act DW 0
Maxi_Notes_Act  DW 0

INCLUDE CONSTMM.INC         ;Les tableaux (Vibrato,Periodes,...)
INCLUDE EMS.INC             ;Gestion EMS (Appeler Init_EMS au dpart)
INCLUDE ADLIB.INC           ;Commandes Adlib
INCLUDE GUSCMD.INC          ;Commandes GUS...
INCLUDE SBCMD.INC           ;Commandes pour la Sound Blaster


;ͻ
;         Variables/Procdures externes ou publiques           
;ͼ

EXTRN Boucler_MOD         :BYTE

EXTRN Duree_min           :BYTE
EXTRN Duree_sec           :BYTE
EXTRN Duree_50            :BYTE

EXTRN Chrono_min          :BYTE
EXTRN Chrono_sec          :BYTE
EXTRN Chrono_50           :BYTE

EXTRN Volume_total        :BYTE

EXTRN Test_Periodique     :BYTE  ; le 50me de seconde pour l'affichage

PUBLIC Cree_variable
PUBLIC Test_vitesse
PUBLIC PLancer_Sortie     ;Lancer la sortie sonore
PUBLIC PLancer_Musique    ;Lancer la musique

;***** dbut structure Variables^ TP
TPVariables:

Frequence           DW 0             ;Frquence de sortie en Hz
OPL2_Present        DB 0             ;Circuit OPL2 ? (Pour S3M)
PSortie_sonore      DB HPint         ;Type de sortie sonore (Disney,SB,GUS...)
nb_de_boucles       DB 0
Num_Port_LPT        DB 1             ;n port parallle 1,2,3,4
Port_LPT            DW 0             ;@ port parallle utilis par CNA, Disney
PPort_de_base       DW 220h          ;Port de base de la Sound Blaster
PGUSBasePort        DW 220h          ;Port de base de la GUS
PUtilise_DMA        DB 0             ;=1 si sortie SB avec le DMA
PUtilise_Stereo     DB 0             ;=1 si sortie SBPro Stro
PUtilise_Mixage     DB 0
PUtilise_Filtre     DB 0
Utiliser_BPM        DB 1
Utiliser_Fine       DB 1             ;Gestion des FineTune ?
Utiliser_Panning    DB 0             ;Executer la commande Panning ?
Utiliser_Interpol   DB 0             ;Utiliser l'interpolation linaire 8 bits?
PIRQ_SB             DB 7             ;N IRQ Sound Blaster
PIRQ_GUS            DB 7             ;N IRQ GUS
PDMA_SB8            DB 1             ;N DMA Sound Blaster
PDMA_SB16           DB 5             ;N DMA Sound Blaster 16  (Sortie 16 Bits)
PType_SB            DB 1             ;Type de Sound Blaster
PDMA_Continu        DB 0             ;Lecture DMA continue ???
Seg_Volume          DW 0             ;Segment de la table de volume
Offset_tampon1      DW 0             ;et des tampons DMA
Offset_tampon2      DW 0
Vitesse_calculs_H   DW 0
Vitesse_calculs_L   DW 0
Musique_Terminee    DB 0             ;Activer/Dsactiver la musique
Sortie_Stoppee      DB 0             ;Vrai quand la musique est termine
Stopper_Sortie      DB 0             ;Pour arrter la sortie sonore
BPM_Base            DW 0
Commande_SB16       DB 0             ;=1 si Sound Blaster 16 prsente...
GusVol              DW 00E00h,0B000h,0B800h,0BC00h,0BE00h,0C000h,0C400h,0C800h,0CC00h
                    DW 0D000h,0D200h,0D400h,0D600h,0D800h,0DA00h,0DC00h,0DE00h
                    DW 0E000h,0E100h,0E200h,0E300h,0E400h,0E500h,0E600h,0E700h
                    DW 0E800h,0E900h,0EA00h,0EB00h,0EC00h,0ED00h,0EE00h,0EF00h
                    DW 0F080h,0F100h,0F180h,0F200h,0F280h,0F300h,0F380h,0F400h
                    DW 0F480h,0F500h,0F580h,0F600h,0F680h,0F700h,0F780h,0F800h
                    DW 0F880h,0F900h,0F980h,0FA00h,0FA80h,0FB00h,0FB80h,0FC00h
                    DW 0FC80h,0FD00h,0FD80h,0FE00h,0FE80h,0FF00h,0FF80h,0FFF0h
ContrVar            DB 73            ;Variable de Contrle !!!

;***** fin structure Variables^ TP

;***** dbut structure Musique^ TP
TPMusique:

Titre               DB 32 DUP (0)
Nb_de_voies         DB 0    ; de 1  32 !!!
Nb_de_voies_patt    DB 0
Nb_voies_Digit      DB 0
Nb_Voies_Adlib      DB 0
Nb_Total_Samples    DB 0    ; Nombre total de samples (Vides ou non)
Nb_Samples          DB 0    ; Nombre de samples non vide (normalement)
Nb_Reel_Samples     DB 0    ; Nombre de samples rellement chargs
Sequence_Len        DB 0
Pos_de_restart      DB 0
Tempo_depart        DB 6
BPM_depart          DB 7Dh
Vol_Gene_depart     DB 40h
Octave_Min          DB 0
Octave_Max          DB 7
Type_Module         DB 0    ; Type du module (MOD, STM, S3M, MTM ...)
Type_Module_Etendu  DB 0    ; Type du module tendu (MOD)
Volume_Sl_Rapide    DB 0
Vitesse_ticks       DB 50   ; Nb de ticks par seconde
ContrMus            DB 73   ; Variable de Contrle !!!

;***** fin structure Musique^ TP

;***** dbut structure Table^ TP
TPTable:

Table_Pattern     DW Max_Pattern DUP (0)     ; Table d'adresse des pattern
Table_Taille_Patt DB Max_Pattern DUP (0)
Table_Tempo       DB Max_Pattern DUP (0)
Table_sequence    DB Max_Pattern DUP (0)

PtrSamples        DD Max_Samples DUP (0)    ; Pointeurs vers les samples du module.
Type_Voie         DB Max_Voies DUP (0)      ; Type de la voie (Vide,N,Adlib)
Voies_Adlib       DB 11 DUP (0)             ; 'Position' des voies adlib.

ContrTable        DB 73   ; Variable de Contrle !!!

;***** fin structure Table^ TP

;Ŀ
;    Variables de gestion de la musique.                    
;

;*** Bloc d'informations pour le Turbo Pascal ***
TPInfo:

Calcul_fini       DB 0
Taille_Tampon     DW 0   ; Taille du tampon en octets (*2 si Stro)
Taille_Sortie_DMA DW 0   ; !!!!!!!!!!!!! TEST TEST TEST
Tampon_Actif      DB 0
Pointeur_Tampon_Joue DW 0

Pause           DB 0     ; =1 si musique en pause
Pos_note        DB 0     ; Note actuelle dans le pattern.
Pos_sequence    DB 0     ; Position dans la squence.
Num_pattern     DB 0     ; Numro du pattern actuel.
Segment_Pattern DW 0     ; Segment du pattern actuel.
ModifierPattern DB 0     ; 1 => Changer de pattern
Compt_50        DW 0
Tempo           DB 6     ; Tempo actuel.
Cmpt_tempo      DB 0     ; Compteur pour le tempo.
BPM             DB 125   ; BPM Actuel.
Cmpt_BPM        DW 0     ; Compteur pour le BPM.
Volume_General  DB 40h   ; Volume de la musique.

VControle     DB Max_Voies DUP (0)
VPanning      DB Max_Voies DUP (0)
VCommande     DW Max_Voies DUP (0)   ; Offset de la routine de commande
VPeriode_part DW Max_Voies DUP (0)   ; Periode de la voie (partition)
VPeriode_re   DW Max_Voies DUP (0)   ; Periode de la voie (joue relement)

VSample       DB Max_voies DUP (0)   ; Sample utilis sur la voie.
VPtrSample    DD Max_voies DUP (0)   ; Pointeur sur le sample.
VVolume_Part  DB Max_voies DUP (0)   ; Volume (dans la partition)
VVolume_re    DB Max_voies DUP (0)   ; Volume (jou rellement)
VVolume       DB Max_Voies DUP (0)   ; Volume avec GVol et Volume (+/-)
Volume_Gauche DB Max_voies DUP (0)
Volume_Droite DB Max_voies DUP (0)

VOffset_actuel DW Max_voies DUP (0)

VPart_decimale DB Max_Voies DUP (0)  ; Variables pour le mixage.
VPart_entiere  DB Max_Voies DUP (0)  ;            ''
VAccumulateur  DB Max_Voies DUP (0)  ;            ''

VDadj                 DW Max_voies DUP (0) ; Ajustement de la priode.
Adresse_Table_periode DW Max_voies DUP (0) ;          ''
VFineTune             DB Max_voies DUP (0) ;          ''

Frequence_GUS        DD Max_voies DUP (0)

GUS_Controle         DB Max_voies DUP (0)  ; Octet de contrle pour GUS et Adlib
ContrInfo            DB 73   ; Variable de Contrle !!!

;*** Fin du Bloc d'informations pour le Turbo Pascal ***

;
;                                                              
;                     DEBUT DU PROGRAMME                       
;                                                              
;

Page_Tampon_DMA    DW 0
Offset_Tampon_DMA  DW 0

;Ŀ
;   Test_vitesse:  Tester la vitesse des calculs...         
;     Entre  Rien                                          
;     Sortie  Rien                                          
;     Change                                                
;

Test_vitesse PROC FAR
      PUSH DS BP
      DS_ASM

      CALL Init_variables       ;pour une lecture normale
      CALL InitDevice
      CALL Init_Variables_Freq
      MOV Test_en_cours,1

      MOV Vitesse_calculs_H,0
      MOV Vitesse_calculs_L,0
      DS_TP
      MOV Boucler_MOD,0
      DS_ASM

      CLI
      XOR AX,AX
      MOV ES,AX
      MOV EAX,ES:[4*08h]
      MOV oldvect_Timer,EAX           ;sauve adresse interruption Timer
      MOV WORD PTR ES:[4*08h],OFFSET Timer_test_calculs
      MOV WORD PTR ES:[4*08h+2],CS

      MOV AL,34h
      OUT 43h,AL      ;Change la frquence
      MOV AL,37h
      OUT 40h,AL      ;du Timer
      MOV AL,5Dh
      OUT 40h,AL      ;50 Hz
      STI

      ;Timer pour mesure du temps en place...

      MOV Sortie_Stoppee,0
Boucle_vitesse_calculs:
      CALL Gestion_Sonore         ;Calcul du sample
      CMP Sortie_Stoppee,1
      JNE Boucle_vitesse_calculs
      MOV Musique_Terminee,1      ;Musique termine !!!

      CLI
      MOV AL,00110110b
      OUT 43h,AL
      XOR AL,AL
      OUT 40h,AL    ;Fixe la frquence
      OUT 40h,AL    ;  18,2 Hz

      XOR AX,AX
      MOV ES,AX
      MOV EAX,oldvect_Timer
      MOV ES:[4*08h],EAX   ;Restaure l'ancienne IRQ Timer
      STI

      MOV Test_en_cours,0

      POP BP DS
      RET
Test_vitesse ENDP


Timer_test_calculs:    ;Timer de mesure de la performance
        PUSH DS AX
        DS_ASM
        CLI
        ADD Vitesse_calculs_L,1
        ADC Vitesse_calculs_H,0
        STI
        MOV AL,20h
        OUT 20h,AL
        POP AX DS
        IRET

;Ŀ
;   Crer Timer                                             
;   Ajuster les blocs suivant le type de sortie             
;   (Code auto gnr)                                      
;

Long_bl_init_SB  DW (OFFSET Fin_Bloc_init_SB   )-(OFFSET Bloc_init_SB )
Long_bl_Sort_SB  DW (OFFSET Fin_Bloc_Sort_SB   )-(OFFSET Bloc_Sort_SB )
Long_bl_Beep     DW (OFFSET Fin_Bloc_Beep      )-(OFFSET Bloc_Beep    )
Long_bl_LPT      DW (OFFSET Fin_Bloc_lpt       )-(OFFSET Bloc_lpt     )
Long_bl_disney   DW (OFFSET Fin_Bloc_disney    )-(OFFSET Bloc_disney  )
Long_bl_Adlib    DW (OFFSET Fin_Bloc_Adlib     )-(OFFSET Bloc_Adlib   )
Long_bl_S_Master DW (OFFSET Fin_Bloc_S_Master  )-(OFFSET Bloc_S_Master)
Long_bl_Fin      DW (OFFSET Fin_Bloc_Fin       )-(OFFSET Bloc_Fin     )
Long_bl_Tampon   DW (OFFSET Fin_Bloc_Utilise_tampon)-(OFFSET Bloc_Utilise_tampon)

Creer_timer PROC NEAR

       PUSH ES
       DS_ASM
       ES_ASM

       CLD
       MOV DI,OFFSET Debut_construction_timer
                                 ;Initialisation Sound Blaster
       CMP Sortie_sonore,SB      ;Sound Blaster?
       JE c_init_SB              ;oui
       CMP Sortie_sonore,SBPro   ;Sound Blaster Pro?
       JNE Pas_c_init_SB         ;non
c_init_SB:
       MOV CX,Long_bl_init_SB
       MOV SI,OFFSET Bloc_init_SB
       REP MOVSB
Pas_c_init_SB:

       MOV CX,Long_bl_Tampon
       MOV SI,OFFSET Bloc_Utilise_tampon
       REP MOVSB
                                 ;Type de sortie (SB, Beeper ...)
       CMP Sortie_sonore,HPint
       JNZ Pas_c_beeper          ;HP Interne
       MOV CX,Long_bl_beep
       MOV SI,OFFSET Bloc_beep
       REP MOVSB
       JMP Fin_const_sortie
Pas_c_beeper:                    ;CNA sur port parallele
       CMP Sortie_sonore,CNA
       JNZ Pas_c_CNA
       CMP Port_LPT,0
       JNZ Port_CNA_bon
       MOV Erreur_Modm,Err_Sortie_Introuvable
Port_CNA_Bon:
       MOV CX,Long_bl_LPT
       MOV SI,OFFSET Bloc_lpt
       REP MOVSB
       JMP Fin_const_sortie
Pas_c_CNA:                       ;Sound Blaster
       CMP Sortie_sonore,SB
       JNZ Pas_c_SBlaster
       MOV CX,Long_bl_sort_SB
       MOV SI,OFFSET Bloc_sort_SB
       REP MOVSB
       JMP Fin_const_sortie
Pas_c_SBlaster:                  ;Sound Blaster Pro
       CMP Sortie_sonore,SBPro
       JNZ Pas_c_SBlasterPro
       MOV CX,Long_bl_sort_SB
       MOV SI,OFFSET Bloc_sort_SB
       REP MOVSB
       JMP Fin_const_sortie
Pas_c_SBlasterPro:               ;Sound Master
       CMP Sortie_sonore,SMaster
       JNZ Pas_c_Soundmaster
       MOV CX,Long_bl_S_Master
       MOV SI,OFFSET Bloc_S_Master
       REP MOVSB
       JMP Fin_const_sortie
Pas_c_Soundmaster:               ;Adlib
       CMP Sortie_sonore,Adlib
       JNZ Pas_c_Adlib
       MOV CX,Long_bl_Adlib
       MOV SI,OFFSET Bloc_Adlib
       REP MOVSB
       JMP Fin_const_sortie
Pas_c_Adlib:                     ;Disney SS
       CMP Sortie_sonore,DSS
       JNZ Pas_de_sortie
       CMP Port_LPT,0
       JNZ Port_Disney_bon
       MOV Erreur_Modm,Err_Sortie_Introuvable
Port_Disney_Bon:
       MOV CX,Long_bl_disney
       MOV SI,OFFSET Bloc_disney
       REP MOVSB
       JMP Fin_const_sortie
Fin_const_sortie:       ;Bloc de fin (Dtecte le Tick)
       MOV CX,Long_bl_fin
       MOV SI,OFFSET Bloc_fin
       REP MOVSB

       POP ES
       RET

Pas_de_sortie:
       MOV Erreur_Modm,Err_Sortie_Introuvable
       POP ES
       RET
Creer_timer ENDP

;Ŀ
;  Ajuster_Position_DMA: Ajuster la position des tampons DMA    
;             ( Pour la sortie continue )                       
;                                                               
;

Ajuster_Position_DMA Proc Near

       MOV AX,Offset_tampon1  ; Mettre les deux tampons  la suite...
       MOV BX,Taille_Tampon
       CMP Utilise_Stereo,1
       JNE Pas_Doubler_Taille
       SHL BX,1
Pas_Doubler_Taille:
       ADD AX,BX
       MOV Offset_tampon2,AX

       CMP DMA_Continu,1
       JNE Fin_Aj_Pos_DMA
       MOV AX,Offset_Tampon1
       MOV Debut_Tampon,AX
       CALL Calcul_Adresse_DMA

Fin_Aj_Pos_DMA:
       CALL Effacer_Tampons_DMA

       RET
Ajuster_Position_DMA Endp

;Ŀ
;  Effacer_Tampons_DMA: Effacer les deux tampons DMA            
;             ( Pour la pause en sortie continue )              
;
Effacer_Tampons_DMA Proc Near
        PUSH ES
        MOV EAX,80808080h
        MOV CX,Taille_Tampon
        CMP Utilise_Stereo,1
        JE Pas_Diviser_CX
        SHR CX,1              ; si Mono 2 fois plus petit
Pas_Diviser_CX:
        MOV DI,Offset_Tampon1
        MOV ES,Seg_Volume     ; ES=Segment de la table de volume
        CLD
        REP STOSD             ; Efface le tampon
        POP ES
        RET
Effacer_Tampons_DMA Endp

;Ŀ
;   Lancer_Sortie     Lancer la sortie sonore               
;                                                           
;     Entre      Rien                                      
;     Sortie:     AX<>0 => Erreur !!!                       
;

oldvect_Timer   DD 0
;oldvect_clavier DD 0
Ancien_int    DB 0
Frequence_DMA DB 0   ;Valeur  envoyer  la Sound Blaster

  ; Caractristiques de la sortie sonore
  ; (Pas accessible au Pascal pour viter les problmes)

Sortie_Sonore  DB 0
Utilise_DMA    DB 0
Utilise_Stereo DB 0
Utilise_Mixage DB 0
Utilise_Filtre DB 0
Type_SB  DB 1
IRQ_SB   DB 7
IRQ_GUS  DB 0
DMA_SB8  DB 0
DMA_SB16 DB 0
DMA_Continu  DB 0
Port_de_base DW 220h
GUSBasePort  DW 220h

PLancer_Sortie PROC FAR    ;Appel du Pascal (Fonction, renvoie l'Erreur )
        PUSH DS BP
        DS_ASM

        CALL InitDevice            ;Init la sortie sonore (Variables IRQ, DMA...)
        CALL Init_EMS

        MOV Tampon_Actif,0         ;Dbut 2 Tampon
        MOV Erreur_Modm,0
        MOV AX,Frequence
        MOV Frequence_reelle,AX
        CALL Init_Variables_Freq   ;Initialise les variables pour la frquence

        CALL Lancer_Sortie
        MOV AX,Erreur_Modm         ; Renvoyer le code d'erreur
        POP BP DS
        RET
PLancer_Sortie ENDP

Lancer_Sortie PROC NEAR
                                   ;*** Choix de la sortie sonore **
        CMP Sortie_sonore,SB       ;teste SB sur DMA
        JE Lancer_DMA_SB
        CMP Sortie_sonore,SBpro    ;teste SBpro sur DMA
        JE Lancer_DMA_SBpro
        CMP Sortie_sonore,SB16     ;teste SBpro sur DMA
        JE Lancer_DMA_SB16
        CMP Sortie_sonore,GUS      ;teste GUS
        JE Lancer_GUS
                                   ;Sinon => Sortie Timer
Lancer_timer:
        MOV Utilise_DMA,0
        MOV DMA_Continu,0
        MOV Utilise_Stereo,0

        CALL Creer_timer           ;Crer la nouvelle interruption
        CMP Erreur_Modm,0
        JNZ Fin_Lancer_Timer       ;Erreur => Fin !!!!

        CALL Gestion_Sonore             ;Calculer le premier tampon

        MOV BX,Pointeur_Tampon_Joue
        MOV Offset_Pointeur_Tampon,BX
        MOV Tampon_Fini,0

        CALL Init_timer_debut

Fin_Lancer_Timer:
        RET

Lancer_DMA_SB:
        ; Lancer la sortie DMA sur SB en Mono

        MOV Utilise_DMA,1
        MOV Utilise_stereo,0

        CALL Calcul_freq_SB
        CALL Echanger_Tampons
        CALL Gestion_Sonore         ; Calcul le premier tampon
        MOV AL,IRQ_SB               ; AL <- N de L'IRQ SB
        MOV DX,OFFSET IRQ_Sound_Blaster
        CALL Detourne_IRQ
;        CALL Init_SB
        CALL Init_DMA               ; Initialise les variables pour le DMA
        CALL Ajuster_Position_DMA
        CALL Programmer_DMA8        ; Programmer le controleur DMA
        CALL COMMANDE_DMA_SB        ; Lancer la Commande SB de sortie DMA

        CMP Erreur_Modm,Err_SB ; Si Erreur Sound Blaster, Stopper Immdiatement
        JNE Fin_Lancer_DMA_SB
        CALL StopSB
        RET
Fin_Lancer_DMA_SB:
        RET

Lancer_DMA_SBpro:
        CALL Stop_stereo            ;Dsactiver la stro
        CMP Utilise_stereo,1
        JNE Lancer_DMA_SBpro_M      ;test si Stro
        CALL Fixer_stereo           ;Activer la stro
Lancer_DMA_SBpro_M:

        ; Lancer la sortie DMA sur SBPro.

        MOV Utilise_DMA,1
        CALL Calcul_freq_SB
        CALL Echanger_Tampons
        CALL Gestion_Sonore         ;Calcul du 1 tampon DMA
        MOV AL,IRQ_SB               ;AL <- N de L'IRQ SB
        MOV DX,OFFSET IRQ_Sound_Blaster
        CALL Detourne_IRQ
;        CALL Init_SB
        CALL Init_DMA               ;Initialise les variables pour le DMA
        CALL Ajuster_Position_DMA
        CALL Programmer_DMA8        ;Programmer le controleur DMA
        CALL COMMANDE_DMA_SBpro     ;Lancer la Commande SB de sortie DMA

        CMP Erreur_Modm,Err_SB ;Si Erreur Sound Blaster, Stopper Immdiatement
        JNE Fin_Lancer_DMA_SBpro
        CALL StopSB
        RET
Fin_Lancer_DMA_SBpro:
        RET

Lancer_DMA_SB16:
        CMP Utilise_stereo,1
        JE Lancer_DMA_SB16_Stereo  ; test si Stereo

        ; Lancer la sortie DMA sur SBPro en Mono

        MOV Utilise_DMA,1
        CALL Calcul_freq_SB
        CALL Echanger_Tampons
        CALL Gestion_Sonore         ;Calcul du 1 tampon DMA
        CALL Stop_stereo            ;Dsactiver la stro
        MOV AL,IRQ_SB               ;AL <- N de L'IRQ SB
        MOV DX,OFFSET IRQ_Sound_Blaster
        CALL Detourne_IRQ
;        CALL Init_SB
        CALL Init_DMA               ;Initialise les variables pour le DMA
        CALL Ajuster_Position_DMA
        CALL Programmer_DMA8        ;Programmer le controleur DMA
        CALL COMMANDE_DMA_SB16     ;Lancer la Commande SB de sortie DMA

        CMP Erreur_Modm,Err_SB ;Si Erreur Sound Blaster, Stopper Immdiatement
        JNE Fin_Lancer_DMA_SB16
        CALL StopSB
        RET
Fin_Lancer_DMA_SB16:
        RET

Lancer_DMA_SB16_Stereo:

        ; Lancer la sortie DMA sur SBPro en Stereo

        MOV Utilise_DMA,1
        CALL Calcul_freq_SB
        CALL Echanger_Tampons
        CALL Gestion_Sonore
        CALL Fixer_stereo           ;Activer la stro
        MOV AL,IRQ_SB               ;AL <- N de L'IRQ SB
        MOV DX,OFFSET IRQ_Sound_Blaster
        CALL Detourne_IRQ           ;Dtourner l'IRQ SB
;        CALL Init_SB
        CALL Init_DMA               ;Initialise les variables pour le DMA
        CALL Ajuster_Position_DMA
        CALL Programmer_DMA8        ;Programmer le controleur DMA
        CALL COMMANDE_DMA_SB16     ;Lancer la Commande SB de sortie DMA

        CMP Erreur_Modm,Err_SB ;Si Erreur Sound Blaster, Stopper Immdiatement
        JNE Fin_Lancer_DMA_SB16_Stereo
        CALL StopSB
        RET
Fin_Lancer_DMA_SB16_Stereo:
        RET

Valeur_18 DW 0
Cpt_appel_ancien_int DW 0

Lancer_GUS:
        CALL UInit_Play

        CALL Gestion_Sonore

        MOV AL,IRQ_GUS
        MOV DX,OFFSET IRQ_Gravis
        CALL Detourne_IRQ           ;Dtourner l'IRQ GUS

        XOR AH,AH
        MOV AL,Vitesse_Ticks        ;Test Test Test Test !!!!!
        MOV BL,8
        DIV BL                      ;50/8 => 6
        MOV BH,0
        CALL U_TurnOnUserInt

        RET
Lancer_Sortie ENDP

InitDevice PROC NEAR                ;Initialise les variables pour la sortie Sonore
        MOV AL,PSortie_Sonore
        MOV Sortie_Sonore,AL
        MOV AL,PUtilise_DMA
        MOV Utilise_DMA,AL
        MOV AL,PUtilise_Stereo
        MOV Utilise_Stereo,AL
        MOV AL,PUtilise_Mixage
        MOV Utilise_Mixage,AL
        MOV AL,PUtilise_Filtre
        MOV Utilise_Filtre,AL
        MOV AL,PIRQ_SB
        MOV IRQ_SB,AL
        MOV AL,PIRQ_GUS
        MOV IRQ_GUS,AL
        MOV AL,PDMA_SB8
        MOV DMA_SB8,AL
        MOV AL,PDMA_SB16
        MOV DMA_SB16,AL
        MOV AX,PPort_de_base
        MOV Port_de_base,AX
        MOV AX,PGUSBasePort
        MOV GUSBasePort,AX
        MOV AL,PType_SB
        MOV Type_SB,AL
        MOV AL,PDMA_Continu
        MOV DMA_Continu,AL

        MOV Calcul_fini,1
        MOV Stopper_IRQ_SB,0
        MOV Stopper_Sortie,0
        MOV Sortie_Stoppee,0
        MOV Test_en_cours,0        ;Pas de test en cours.
        RET
InitDevice ENDP


PLancer_Musique PROC FAR    ;Appel du Pascal (Fonction, renvoie l'Erreur )
        PUSH DS BP
        DS_ASM
        CALL Init_Variables
        MOV AX,Erreur_Modm         ; Renvoyer le code d'erreur
        POP BP DS
        RET
PLancer_Musique ENDP

;Ŀ
;              Initialisation de la musique                 
;

Init_Variables PROC NEAR
        CLI
        CLD                       ; toutes les copies en sens croissant
        DS_ASM
        ES_ASM

        MOV Erreur_Modm,0

        XOR CH,CH                 ; annule partie haute compteur

        MOV DI,OFFSET VSample
        MOV AL,0FFh
        MOV CL,Max_voies
        REP STOSB                 ; initialise les Max_voies Sample  0FFh

        MOV DI,OFFSET VVolume_Part
        XOR AL,AL
        MOV CL,Max_voies
        REP STOSB                 ; annule les Max_voies VVolume_Part

        MOV DI,OFFSET VControle
        MOV CX,Max_voies
        MOV AL,M_Stoppee          ; Voies stoppes et non actives
        REP STOSB                 ; Initialise le contrle des voies

        MOV DI,OFFSET VControle
        MOV AL,M_Pas_Active
        MOV CL,Nb_de_voies
        REP STOSB                 ; "Active" les Nb_de_voies premires voies

        MOV DI,OFFSET VCommande
        MOV AX,OFFSET Rien
        MOV CL,Max_voies
        REP STOSW                 ; initialise les Max_voies VCommande  'Rien'

        MOV DI,OFFSET VDadj
        XOR EAX,EAX
        MOV CL,Max_voies
        REP STOSW                 ; annule les Max_voies VDadj

        MOV DI,OFFSET VPart_entiere
        MOV CL,Max_voies
        REP STOSW                 ; annule les Max_voies Partie_entiere

        MOV DI,OFFSET VAccumulateur
        MOV CL,Max_voies
        REP STOSW                 ; annule les Max_voies Accumulateur

        MOV DI,OFFSET VVolume
        XOR AL,AL
        MOV CL,Max_voies
        REP STOSB                 ; initialise les Max_voies VVolume  0

        MOV DI,OFFSET VVolume_re
        XOR AL,AL
        MOV CL,Max_voies
        REP STOSB                 ; initialise les Max_voies VVolume_re  0

        MOV DI,OFFSET VPeriode_re
        MOV AX,0FFFFh
        MOV CL,Max_voies
        REP STOSW                 ; initialise les Max_voies Periode_V  FFFFh

        MOV DI,OFFSET VPeriode_Part
        MOV AX,0FFFFh
        MOV CL,Max_voies
        REP STOSW                 ; initialise les Max_voies Periode_V  FFFFh

        MOV DI,OFFSET Adresse_Table_periode
        MOV AX,T_Per              ; Table de priodes MOD
        MOV CL,Max_voies
        REP STOSW                 ; initialise les Max_voies Table_periode

        MOV DI,OFFSET VFineTune
        XOR AX,AX
        MOV CL,Max_voies
        REP STOSB                 ; initialise les Max_voies VFineTune  0

        MOV DI,OFFSET Frequence_GUS
        XOR EAX,EAX
        MOV CL,Max_voies
        REP STOSD                 ; initialise les Max_voies Frequence_GUS  0

        MOV DI,OFFSET GUS_Controle
        XOR AX,AX
        MOV CL,Max_voies
        REP STOSB                 ; initialise les Max_voies GUS_Controle  0

        MOV DI,Offset Table_Vibrato
        MOV AX,Offset Ta_vib
        MOV CL,Max_voies
        REP STOSW                 ; initialise les Max_voies Table_Vibrato  Ta_vib

        MOV DI,Offset Table_Tremolo
        MOV AX,Offset Ta_vib
        MOV CL,Max_voies
        REP STOSW                 ; initialise les Max_voies Table_Tremolo  Ta_vib

        MOV DI,OFFSET Retrig_Vibr
        XOR AL,AL
        MOV CL,Max_voies
        REP STOSB                 ; initialise les Max_voies Retrig_Vibr  0

        MOV DI,OFFSET Retrig_Trem
        XOR AL,AL
        MOV CL,Max_voies
        REP STOSB                 ; initialise les Max_voies Retrig_Trem  0

        MOV DI,OFFSET TSmp_Offs
        XOR AL,AL
        MOV CL,Max_voies
        REP STOSB                 ; initialise les Max_voies TSmp_Offs  0

        ;Initialisation des variables Adlib

        XOR AL,AL
        MOV DI,OFFSET Old_KSL_TL1
        MOV CL,9
        REP STOSB                 ; initialise les 9 Old_KSL_TL1  0

        MOV DI,OFFSET Old_KSL_TL2
        MOV CL,9
        REP STOSB                 ; initialise les 9 Old_KSL_TL2  0

        MOV DI,OFFSET Old_Key
        MOV CL,9
        REP STOSB                 ; initialise les 9 Old_Key  0

        MOV DI,OFFSET Old_FB
        MOV CL,9
        REP STOSB                 ; initialise les 9 Old_FB  0

        MOV Cmpt_Boucles,0
        MOV Bouclage_en_cours,0
        MOV Boucler_Pattern,0
        MOV ModifierPattern,0

        MOV Premier_appel,1       ; Initialisation des BPM...
        MOV AL,Tempo_depart
        MOV Tempo,AL              ; Initialise la Tempo de dpart.
        MOV AL,BPM_depart
        MOV BPM,AL                ; BPM de dpart.
        MOV Cmpt_BPM,0
        MOV AL,Vol_Gene_Depart
        MOV Volume_General,AL     ; Volume Gnral dpart.

        MOV NotePatternSuiv,0
        MOV PJumpPattern,0
        MOV Debut_Boucle_Pattern,0 ; Pour JumpLoop
        MOV Taille_Pattern_actuel,1
        MOV Pos_note,0            ; => Chercher le 1er pattern  la 1note
        MOV Pos_sequence,0
        MOV PatternBreak,0
        MOV Pause_IRQ,0
        MOV Pattern_Vide,0        ; Pattern non vide

        ;-- Mise en place des octaves --
        XOR BX,BX
        MOV BL,Octave_Min
        SHL BX,1
        MOV AX,Maxi_Octaves[BX]
        MOV Maxi_Notes,AX
        MOV BL,Octave_Max
        SHL BX,1
        MOV DX,Mini_Octaves[BX]
        MOV Mini_Notes,DX
        SUB AX,DX
        MOV Moyen_Notes,AX

        MOV AL,Pos_de_restart     ; Initialisation du bouclage du module
        DEC AL
        CMP AL,Sequence_Len
        JBE Ajuster_Bouclage
        MOV Pos_de_restart,1
Ajuster_Bouclage:

If Mod_Master Eq YES              ;#### Seulement pour Mod Master ####
        MOV Pause,0
        DS_TP
        MOV Chrono_50,0
        MOV Chrono_sec,0
        MOV Chrono_min,0
        DS_ASM
EndIf
        MOV Musique_Terminee,0    ; Activer la lecture de la partition
        STI
        RET

Init_Variables ENDP

;Ŀ
;  Init_Variables_Freq  Initialise les variables            
;                       qui dpendent de la frquence       
;                                                           
;

Frequence_reelle DW 16000
Periode_timer DW 0
P_Amiga_h DW 0
P_Amiga_l DW 0

Init_Variables_Freq Proc Near

        XOR DX,DX
        MOV AX,Frequence_reelle
        MOV BH,0
        MOV BL,Vitesse_Ticks
        DIV BX
        AND AX,0FFFCh            ; Taille Multiple de 4 !!!
        MOV Taille_Tampon,AX

        MOV Compt_50,1
        MOV AL,Tempo_depart
        MOV Cmpt_Tempo,0
        MOV Tempo,AL              ; dbut et fin du tampon pour le Timer

        MOV BX,Frequence_Reelle

        MOV DX,(1193182  /  65536)
        MOV AX,(1193182 MOD 65536)
        DIV BX               ;1193182/F -> AX
        MOV Periode_timer,AX

        MOV CX,600h          ;AX*600h -> DX-AX (Normalement 300h)
        MUL CX               ;Mais on a doubl les priodes... !!!!!
        MOV P_Amiga_h,DX
        MOV P_Amiga_l,AX     ;Pour calculer les priodes
        SHRD AX,DX,1         ;DX-AX/2 -> DX-AX

        MOV AX,0FFFFh
        XOR DX,DX
        MOV BX,Periode_timer
        DIV BX
        MOV Valeur_18,AX
        MOV Cpt_appel_ancien_int,1 ;Calculs pour appeler l'IRQ 18,2 fois/sec.

If Mod_Master eq YES               ;#### Bloc Mod Master ####
        MOV AX,Taille_Tampon
        MOV DL,AH
        MOV AH,AL
        XOR AL,AL
        XOR DH,DH
        MOV BX,100
        DIV BX
EndIf
        MOV AX,Taille_Tampon
        MOV Taille_Sortie_DMA,AX
        CMP DMA_Continu,1
        JNE Pas_Doubler_Tampon1
        SHL Taille_Sortie_DMA,1
Pas_Doubler_Tampon1:
        CMP Utilise_Stereo,1
        JNE Pas_Doubler_Tampon2
        SHL Taille_Sortie_DMA,1     ; Doubler la tampon pour la sortie continue
Pas_Doubler_Tampon2:
        RET
Init_Variables_Freq EndP

Ajuster_Frequence Proc Far     ;Appel du Pascal...
        PUSH DS
        DS_ASM
        MOV AX,Frequence
        MOV Frequence_reelle,AX
        CALL Init_Variables_Freq
        POP DS
        RET
Ajuster_Frequence Endp

;Ŀ
;   Calcul_freq_SB   Calculs pour sortie DMA                
;                    sur Sound Blaster                      
;

Calcul_freq_SB PROC NEAR            ;Calculer l'octet a envoyer  la SB

        MOV DX,(1000000  /  65536)  ; Valeurs pour Mono
        MOV AX,(1000000 MOD 65536)
        CMP Utilise_Stereo,1
        JNE  Pas_Calc_Stereo1
        MOV DX,(500000  /  65536)   ; Valeurs pour Stereo
        MOV AX,(500000 MOD 65536)
Pas_Calc_Stereo1:
        MOV BX,Frequence
        DIV BX
        MOV BX,256                  ; BX=256-1000000/frquence
        SUB BX,AX
        MOV Frequence_DMA,BL        ;Valeurs pour calculer la frquence
                                    ;des samples (Utilise la frquence relle SB)
        XOR BH,BH
        MOV AX,BX
        MOV BX,256                  ; BX=Freq_DMA
        SUB BX,AX
        MOV DX,(1000000  /  65536)  ; Valeurs pour Mono
        MOV AX,(1000000 MOD 65536)
        CMP Utilise_Stereo,1
        JNE  Pas_Calc_Stereo2
        MOV DX,(500000  /  65536)   ; Valeurs pour Stereo
        MOV AX,(500000 MOD 65536)
Pas_Calc_Stereo2:
        DIV BX               ;AX=1000000/256-Freq_DMA

        MOV Frequence_Reelle,AX
        CALL Init_Variables_Freq
        RET

Calcul_freq_SB ENDP

;Ŀ
;            Routines pour lancer la sortie DMA                 
;                       (Canaux 0  4)                          
;

WRITEMASK EQU 0Ah
WRITEMODE EQU 0Bh
CLEARFLIPFLOP EQU 0Ch

Table_Adresses_Page DW 87h,83h,81h,82h

Adresse_Page_DMA DW 0

Init_DMA PROC NEAR           ;Initialiser l'adresse du port de page
        XOR BX,BX
        MOV BL,DMA_SB8
        SHL BX,1
        MOV AX,Table_Adresses_Page[BX]
        MOV Adresse_Page_DMA,AX
        RET
Init_DMA Endp


Programmer_DMA8 PROC NEAR

        XOR BX,BX
        MOV BL,DMA_SB8

        MOV AL,BL
        ADD AL,4                      ;Port[$0A]:=4+DMA
        OUT WRITEMASK,AL
        XOR AL,AL
        OUT CLEARFLIPFLOP,AL          ;Efface le Flip Flop

        MOV AL,58h                    ;Mode DMA (Sortie par Bloc)
        ADD AL,BL                     ;=58h+DMA
        OUT WRITEMODE,AL

        MOV AX,Page_Tampon_DMA
        MOV DX,Adresse_Page_DMA
        OUT DX,AL                    ;Chargement page vers canal 1
        MOV DX,BX
        SHL DX,1
        MOV AX,Offset_Tampon_DMA
        OUT DX,AL                    ;Chargement partie basse adresse
        XCHG AH,AL
        OUT DX,AL

        MOV AX,Taille_Sortie_DMA     ;Taille relle  envoyer
        DEC AX
        INC DX
        OUT DX,AL          ;Charge la taille du tampon
        XCHG AH,AL
        OUT DX,AL

        MOV AL,BL          ;Active le DMA
        OUT 0Ah,AL

        RET
Programmer_DMA8 ENDP

;Ŀ
;                                                               
;          Routines pour la gestion des interruptions           
;                                                               
;

Anc_21 DB 0
Anc_A1 DB 0

;Ŀ
; Activer l'Irq  l'aide des ports 21h et A1h                   
;

Activer_IRQ PROC NEAR      ;Autoriser l'IRQ grce au contrleur d'IRQ
        CLI
        IN AL,21h     ;Activer l'IRQ
        MOV anc_21,AL

        CMP IRQ_SB,7
        JA Activer_IRQ8
        MOV CL,IRQ_SB
        MOV AH,1
        SHL AH,CL
        NOT AH       ;Si IRQ7 => 01111111b
        AND AL,AH    ;01111111b
        OUT 21h,AL
        STI
        RET
Activer_IRQ8:
        IN AL,0A1h
        MOV Anc_A1,AL
        MOV CL,IRQ_SB
        SUB CL,8
        MOV AH,1
        SHL AH,CL
        NOT AH       ;Si IRQ8 => 11111110b
        AND AL,AH    ;Port[$A1] AND (NOT (1 SHL (IRQ_SB-8))
        OUT 0A1h,AL
        IN AL,21h
        MOV AH,11111011b ;IRQ 2 Cascade
        AND AL,AH
        OUT 21h,AL
        STI
        RET
Activer_IRQ ENDP

;Ŀ
; Dsactiver l'Irq  l'aide des ports 21h et A1h                
;

Desactiver_IRQ PROC NEAR   ;Rendre au contrleur d'IRQ son tat originel
        CLI
        PUSH AX
        MOV AL,anc_21
        OUT 21h,AL
        POP AX
        CMP IRQ_SB,7
        JBE Fin_Rest_Port
        MOV AL,Anc_A1
        OUT 0A1h,AL
Fin_Rest_Port:
        STI
        RET
Desactiver_IRQ ENDP

;Ŀ
; Detourne_IRQ  Dtourner une Interruption                      
;                                                               
; Entre: AL: N de l'IRQ (matrielle)                          
;         DX: Offset de la nouvelle IRQ (Segment CS)            
;                                                               
;

IRQ_Logicielle DB 0

Calculer_IRQ_Logicielle MACRO
  Local Det_7
        CMP AL,7
        JBE Det_7
        ADD AL,60h           ;IRQ au niveau logiciel = IRQ+68h
Det_7:                       ;( Deuxime contrleur d'IRQ)
        ADD AL,8             ;IRQ au niveau logiciel = IRQ+8
        MOV IRQ_Logicielle,AL
ENDM

oldvect_IRQ DD 0   ;Sauvegarde de l'ancienne IRQ


Detourne_IRQ PROC NEAR       ;Interruption pour le DMA

        PUSH AX              ;Sauve le N de l'IRQ materielle
        PUSH DX              ;Sauve l'adresse de l'IRQ

        Calculer_IRQ_Logicielle ;IRQ logicielle dans AL

        XOR AH,AH            ;( Premier contrleur d'IRQ)
        SHL AX,2
        MOV DI,AX            ;SI=(IRQ+8 ou 68h)*4 (@ dans la table des vect. IRQ)

        XOR AX,AX            ;Rcuperer le vecteur d'interruption
        MOV ES,AX            ;segment vecteur d'interruption
        MOV EAX,ES:[DI]
        MOV Oldvect_IRQ,EAX

        POP DX
        DS_ASM
        MOV AL,IRQ_logicielle
        MOV AH,25h           ;fixer vecteur d'interruption sur DS:[DX]
        INT 21h

        POP AX              ;Recupere le N de l'IRQ
        CALL Activer_IRQ

        RET

Detourne_IRQ ENDP


;Ŀ
; Restaurer_IRQ  Restaurer l'Interruption dtourne             
;                par Detourne_IRQ                                                
;                                                               
; Entre: AL: N de l'IRQ (matrielle)                          
;                                                               
;

Restaurer_IRQ PROC NEAR
        PUSH AX                  ;IRQ matrielle dans AL

        CLI
        Calculer_IRQ_Logicielle  ;IRQ logicielle dans AL
        XOR AH,AH
        SHL AX,2
        MOV DI,AX                ;DI=(IRQ+8)*4
        XOR AX,AX
        MOV ES,AX
        MOV EAX,oldvect_IRQ
        MOV ES:[DI],EAX
        STI

        POP AX
        CALL Desactiver_IRQ

        RET
Restaurer_IRQ ENDP


;Ŀ
; Modifier_Freq_Timer0  Modifier la frquence du timer 0        
;                                                               
; Entre: AX: Priode Timer (=1193182/Frquence)                
;         Si AX=0 => Valeur par dfaut (18,2/S)                 
;                                                               
;

Modifier_Freq_Timer0 Proc Near
        CLI
        PUSH AX
        MOV  AL,54       ;Timer 0, accs squenciel, mode continu
        OUT  43h,AL
        POP  AX
        OUT  40h,AL      ;Partie basse de la frquence
        XCHG AH,AL
        OUT  40h,AL      ;Partie haute de la frquence
        STI
        RET
Modifier_Freq_Timer0 Endp


Init_timer_debut PROC NEAR

        IN AL,61h             ;Active le haut-parleur
        OR AL,03h
        OUT 61h,AL

        MOV AL,0B6h
        OUT 43h,AL
        MOV AL,0B0h
        OUT 43h,AL
        MOV AL,034h
        OUT 43h,AL

        CLI
        XOR AL,AL
        OUT 42h,AL
        OUT 42h,AL
        MOV AL,10010000b
        OUT 43h,AL

        XOR AX,AX
        MOV ES,AX
        MOV EAX,ES:[4*08h]
        MOV oldvect_Timer,EAX
        MOV WORD PTR ES:[4*08h],OFFSET Bloc_de_debut
        MOV WORD PTR ES:[4*08h+2],CS
        STI

        MOV AX,Periode_timer
        CALL Modifier_Freq_Timer0

        RET
Init_timer_debut ENDP


Init_timer PROC NEAR   ;Utilise pour la pause
        PUSH EAX ES
        CLI
        XOR AX,AX
        MOV ES,AX
        MOV EAX,ES:[4*08h]
        MOV oldvect_Timer,EAX
        MOV WORD PTR ES:[4*08h],OFFSET Bloc_de_debut
        MOV WORD PTR ES:[4*08h+2],CS
        STI

        MOV AX,Periode_timer
        CALL Modifier_Freq_Timer0

        POP ES EAX
        RET
Init_timer ENDP


Restaurer_timer PROC NEAR
        PUSH EAX ES
        CLI
        XOR AX,AX
        CALL Modifier_Freq_Timer0
        XOR AX,AX
        MOV ES,AX
        MOV EAX,oldvect_Timer
        MOV ES:[4*08h],EAX
        STI
        POP ES EAX
        RET
Restaurer_timer ENDP


StopTimer PROC NEAR
        IN AL,61h        ;Stopper le H.P. Interne
        AND AL,0FCh
        OUT 61h,AL

        CLI
        XOR AX,AX
        CALL Modifier_Freq_Timer0
        XOR AX,AX
        MOV ES,AX
        MOV EAX,oldvect_Timer
        MOV ES:[4*08h],EAX      ;restaure ancienne IRQ Timer
        STI

        MOV Sortie_Stoppee,1
        RET
StopTimer ENDP


;Ŀ
;                                                               
;                  Nouvelles Interruptions                      
;                                                               
;

Taille_DMA Proc Near ;Routine pour le test
    XOR  AL,AL
    OUT  0Ch,AL           ; clear flipflop
    MOV  dl,1             ; DMA 1
    XOR  DH,DH
    SHL  DX,1
    INC  DX               ; DX = Channel * 2 + 1 = base counter
    IN   AL,DX            ; AL = Lower byte
    MOV  BL,AL
    IN   AL,DX            ; AL = Higher byte
    MOV  BH,AL
    MOV  AX,BX            ; AX = high and low part together ;) - return that
                          ; bytes left to send = ax + 1
    RET
Taille_DMA Endp


Position_DMA Proc Near
    XOR  al,al
    OUT  0Ch,al           ; clear flipflop
    MOV  dl,1             ; DMA 1
    XOR  dh,dh
    SHL  DX,1
                          ; DX = channel * 2 = Offset
    IN   AL,DX            ; AL = lower byte
    MOV  BL,AL
    IN   AL,DX            ; AL = higher byte
    MOV  BH,AL
    MOV  AX,BX            ; AX = high and low part together ;) - return that
                          ; bytes left to send = ax + 1
    RET
Position_DMA Endp
        
;******************* Interruption Sound Blaster **********************

Pause_IRQ      DB 0
Stopper_IRQ_SB DB 0

IRQ_Sound_Blaster Proc Near
        PUSHAD
        PUSH DS ES
        DS_ASM

        MOV DX,Port_de_base
        ADD DX,0Eh             ;Port 2xE, Acquittement de l'IRQ
        IN AL,DX

        MOV AL,20h
        OUT 20h,AL
        OUT 0A0h,AL

        CMP Pause_IRQ,1
        JE Pause_SB_IRQ
        CMP Stopper_IRQ_SB,1
        JE Fin_IRQ_SB         ; Modifier l'adresse du tampon DMA

        CMP DMA_Continu,1     
        JNE IRQ_Relancer_DMA_SB
                              ; Mode Continu => Ne pas le relancer :)
        CALL Echanger_Tampons
        JMP Exec_Partition
IRQ_Relancer_DMA_SB:          ; Mode non continu => Relancer la SB
        CALL Relancer_DMA_SB

Exec_Partition:
        CMP Calcul_fini,1     ; Calcul non termin =>ne pas calculer
        JNE Pas_calc_part

        CALL Gestion_Sonore   ; Lire la partition et calculer le tampon

Pas_calc_part:

        CMP Stopper_Sortie,1  ; Stopper la sortie sonore ?
        JNE Pas_Stopper_IRQ_SB
        MOV Stopper_IRQ_SB,1  ; Lancer l'arrt de l'IRQ au prochain appel
Pas_Stopper_IRQ_SB:
        CMP Erreur_Modm,Err_SB ;Si Erreur Sound Blaster, Stopper Immdiatement
        JE  Fin_IRQ_SB
        POP ES DS
        POPAD
        IRET

Fin_IRQ_SB:                   ; Pause ou fin de la sortie...
        CMP DMA_Continu,1
        JNE Pas_Fin_DMA_Continu
        CALL Init_Sb

Pas_Fin_DMA_Continu:
        CALL StopSB

        POP ES
        POP DS
        POPAD
        IRET

Pause_SB_IRQ:
        CALL Echanger_Tampons
        POP ES
        POP DS
        POPAD
        IRET
IRQ_Sound_Blaster Endp

StopSB Proc Near
        MOV AL,IRQ_SB
        CALL Restaurer_IRQ    ; Fin de la sortie
        MOV Sortie_Stoppee,1
        RET
StopSB Endp

;****************** Interruption Gravis UltraSound ********************

IRQstatus1 DB 0

IRQ_Gravis Proc Near
        PUSHAD
        PUSH DS ES
        DS_ASM

        MOV   DX,GUSBasePort
        ADD   DX,StatusPort
        IN    AL,DX
        MOV   IRQstatus1,AL
        TEST  IRQstatus1,4
        JZ    Fin_IRQ_Gravis
        MOV   DX,GUSBasePort
        ADD   DX,CommandPort
        MOV   AL,45h
        OUT   DX,AL
        AND   U_Adlibcontrol,0FBh
        ADD   DX,2
        MOV   AL,U_Adlibcontrol
        OUT   DX,AL
        OR    U_Adlibcontrol,4
        MOV   AL,U_Adlibcontrol
        OUT   DX,AL

        CMP Pause,1
        JE Fin_IRQ_Gravis

        CALL Gestion_Sonore        ; Appel de la partition

        CMP Stopper_Sortie,1
        JNE Fin_IRQ_Gravis

        CALL StopGUS

Fin_IRQ_Gravis:
        MOV   DX,GUSBasePort
        ADD   DX,CommandPort
        MOV   AL,IRQstatus         ; Registre IRQstatus
        OUT   DX,AL
        ADD   DX,2
        IN    AL,DX

        MOV AL,20h
        OUT 20h,AL
        OUT 0A0h,AL

        POP ES DS
        POPAD
        IRET                       ; Fin de l'IRQ

IRQ_Gravis Endp

StopGUS Proc Near
        CALL U_TurnOffUserInt
        MOV AL,IRQ_GUS
        CALL Restaurer_IRQ         ; Fin de la sortie
        MOV Sortie_Stoppee,1
        RET
StopGUS Endp

GUS_Timer_Cmpt DB 0
Voie_GUS DW 0
MODE_GUS DB 0
Cpt_appel_ancien_int_GUS DB 0

Programmer_GUS Proc Near
        MOV Voie_GUS,-1
        MOV CL,Nb_de_voies
        XOR CH,CH
        XOR BX,BX
Commander_GUS:
        PUSH CX
        PUSH BX
        CMP Type_Voie[BX],1
        JE  Voie_Digit_GUS
        JMP Boucler_GUS             ;Si voie Adlib ou non active => Fin
Voie_Digit_GUS:
        MOV Voie_Reelle,BX          ;Init les voies relles.

        INC Voie_GUS                ;Incrmenter la voie Gravis.
        MOV AX,Voie_GUS
        CALL U_SetVoice             ;Positionner la voie.

        MOV BX,Voie_Reelle
        TEST VControle[BX],M_KeyOff       ;KeyOff ?
        JZ GUS_Pas_KeyOff
        AND VControle[BX],Not M_KeyOff    ;Dsactiver le KeyOff
        OR VControle[BX],M_Pas_Active     ;Dsactiver la voie
        CALL KeyOff_GUS
        JMP Boucler_GUS                   ;KeyOff =>Fin

GUS_Pas_KeyOff:
        MOV BX,Voie_Reelle
        TEST VControle[BX],M_Stoppee
        JE Pas_stop_voie_GUS
        JMP Boucler_GUS             ;Si voie stoppe =>Fin
Pas_stop_voie_GUS:

        TEST GUS_Controle[BX],M_ChSample     ;Changer le sample ?
        JZ Pas_Changer_Sample_GUS
        AND GUS_Controle[BX],Not M_ChSample  ;Efface le Bit
        OR GUS_Controle[BX],M_ChVolume       ;Modifier le volume !

        CALL U_Changer_Sample

Pas_Changer_Sample_GUS:
        MOV BX,Voie_Reelle
        TEST GUS_Controle[BX],M_ChPeriode    ;Changer la priode ?
        JZ Pas_Changer_Periode_GUS
        AND GUS_Controle[BX],Not M_ChPeriode ;Efface le Bit

        CALL U_Changer_Periode

Pas_Changer_Periode_GUS:
        MOV BX,Voie_Reelle
        TEST GUS_Controle[BX],M_ChVolume     ;Changer le volume ?
        JZ Pas_Changer_Volume_GUS
        AND GUS_Controle[BX],Not M_ChVolume  ;Efface le Bit

        CALL U_Changer_Volume_GUS

Pas_Changer_Volume_GUS:
        MOV BX,Voie_Reelle
        TEST GUS_Controle[BX],M_ChPanning     ;Changer le Panning ?
        JZ Pas_Changer_Panning_GUS
        AND GUS_Controle[BX],Not M_ChPanning  ;Efface le Bit

        MOV BL,VPanning[BX]       ; BX 0 -> 80h
        SHR BX,3                  ;    0 -> 16
        CMP BX,15
        JBE Pas_Ajuster_Panning
        MOV BX,15

Pas_Ajuster_Panning:              ; BX 0-> 15
        CALL U_SetBalance

Pas_Changer_Panning_GUS:
Boucler_GUS:
        POP BX
        INC BX                     ; Incrmenter l'index des voies "relles"
        POP CX                     ; Fin des commandes pour la voie
        LOOP Boucle_Commander_GUS  ; Boucler Nb_de_voies fois
        JMP Fin_Commander_GUS
Boucle_Commander_GUS:
        JMP Commander_GUS
Fin_Commander_GUS:
        RET
Programmer_GUS Endp

IRQ_Timer Proc Near    ;Pour GUS et Adlib.
        PUSHAD
        PUSH DS ES
        DS_ASM

        CMP Pause,1
        JE Fin_IRQ_Timer
        CALL Gestion_Sonore             ; Appel de la partition

        CMP Stopper_Sortie,1
        JNE Fin_IRQ_Timer

;        CALL StopIRQTimer

Fin_IRQ_Timer:
        MOV AL,20h
        OUT 20h,AL

        POP ES DS
        POPAD
        IRET
IRQ_Timer Endp


;StopIRQTimer Proc Near
;
;StopIRQTimer Endp


;Ŀ
;  Dsactive voies: Couper les samples                          
;

Desactive_voies Proc Near              ;Dsactive les voies
       PUSH BX CX

       MOV CL,Nb_de_voies
       XOR CH,CH
       XOR BX,BX
Boucle_desac_voies:
       OR VControle[BX],M_Pas_Active  ;Dsactiver la voie
       INC BX
       DEC CX
       JNZ Boucle_desac_voies

       CMP Sortie_sonore,GUS
       JNE Pas_Desact_voies_GUS
       MOV CL,0
       XOR CH,CH
Eff_Voies_GUS:                     ; Boucle de 0  Nb_de_voies-1
       PUSH CX
       MOV AX,CX
                                   ; AX Numero de voie
       CALL U_SetVoice             ; Choix de la voie...
       XOR BX,BX                   ; BX <= Volume=0
       CALL U_SetVolume            ; *** Regler le volume ***
       POP CX
       INC CX
       CMP CL,Nb_de_voies
       JNE Eff_Voies_GUS

Pas_Desact_voies_GUS:
       POP CX BX
       RET
Desactive_voies Endp


;Ŀ
;  Changer_le_volume: Mise  jours du volume des voies          
;

Changer_le_volume Proc Near
        PUSH BX BP
        MOV CL,Nb_de_voies
        XOR CH,CH

        XOR BX,BX
        XOR BP,BP
Boucle_ajuste_volume:
        MOV AL,VVolume_re[BX]
        CALL Changer_Volume
        ADD BP,2
        INC BX
        LOOP Boucle_ajuste_volume

        POP BP BX
        RET
Changer_le_volume Endp


;Ŀ
;              Dfinition des blocs du timer                
;                                                           
;   (HP Interne, DAC, Disney Sound Source, Sound Master)    
;

Saut_part DW Gestion_Sonore
Saut_Fin_Timer DW StopTimer

Bloc_init_SB:                     ;Sortir la commande vers la Sound Blaster
        MOV DX,Port_de_base
        ADD DX,0Ch
BL_Boucle1_sort_SB_8:
        IN AL,DX
        OR AL,AL
        JS BL_Boucle1_sort_SB_8
        MOV AL,10h                ;Commande sortie directe
        OUT DX,AL
Fin_Bloc_init_SB:

Bloc_sort_SB:                     ;Envoyer l'octet vers la Sound Blaster
        MOV AH,AL
        MOV DX,Port_de_base
        ADD DX,0Ch
BL_Boucle_sort_SB_8:
        IN AL,DX
        OR AL,AL
        JS BL_Boucle_sort_SB_8
        MOV AL,AH
        OUT DX,AL
Fin_bloc_sort_SB:

Bloc_beep:                        ;Sortie vers le HP interne
        XOR AL,80h
        MOV BX,OFFSET T_bep
        XLAT                      ;Lire la table Log
        OUT 42h,AL
Fin_bloc_beep:

Bloc_lpt:                         ;Sortie vers le port parallle
        MOV DX,Port_LPT
        OUT DX,AL
Fin_bloc_lpt:

SSOff EQU 0Ch
SSon  EQU 04h

Bloc_disney:                      ;Disney Sound Source
        MOV DX,Port_LPT
        OUT DX,AL
        ADD DX,2
        MOV AL,SSOff
        OUT DX,AL
        PUSH AX
        POP AX
        MOV AL,SSOn
        OUT DX,AL
Fin_bloc_disney:

Bloc_Adlib:                       ;Adlib
        PUSH AX
        MOV DX,388h
        MOV AL,43h                ;Porteuse de la voie 1
        OUT DX,AL
        IN  AL,DX
        IN  AL,DX
        IN  AL,DX
        IN  AL,DX
        IN  AL,DX
        IN  AL,DX

        INC DX
        POP AX
        MOV BX,OFFSET T_Adlib
        XLAT                      ;Lire la table Log
        OUT DX,AL                 ;AL, Niveau total
Fin_bloc_Adlib:

Bloc_S_Master:                    ;Sound master
        MOV DX,0388h
        OUT DX,AL
Fin_bloc_S_Master:

Offset_Pointeur_Tampon DW 0
Tampon_Fini            DB 0

Bloc_Utilise_tampon:
        MOV SI,Offset_Pointeur_Tampon
        MOV AX,Seg_Volume               ;DS=Segment de la table de volume
        MOV DS,AX
        MOV AL,[SI]
        DS_ASM
        INC Offset_Pointeur_tampon
Fin_Bloc_Utilise_tampon:

Bloc_fin:
        STI
        DEC Cpt_appel_ancien_int
        JNZ Continuer_Int
        MOV AX,Valeur_18
        MOV Cpt_appel_ancien_int,AX
        PUSHF
        CALL oldvect_Timer            ;Appel  l'IRQ Timer
        JMP Sauter_OUT20
Continuer_Int:
        MOV AL,20h
        OUT 20h,AL
Sauter_OUT20:
        DEC Compt_50
        JNZ BFin_IRQ_Timer       ;Fin du tampon ???

        MOV AX,Taille_Tampon    ;Incrmente le Chrono
        MOV Compt_50,AX         ;    (50 ou 32 de seconde)

        CMP Calcul_fini,1       ;Calcul non termin =>ne pas calculer
        MOV BX,Pointeur_Tampon_Joue
        MOV Offset_Pointeur_Tampon,BX
        JNE BFin_IRQ_Timer
        CALL [Saut_part]        ;Appel de la partition

        CMP Stopper_Sortie,1
        JNE BFin_IRQ_Timer
        CALL [Saut_Fin_Timer]   ;Fin de la sortie Timer

BFin_IRQ_Timer:
        POPAD
        POP ES DS
        IRET
Fin_bloc_fin:

Bloc_de_debut:
        PUSH DS ES       ;Dbut rel de l'IRQ timer
        PUSHAD
        CLI
        DS_ASM
Debut_construction_timer:

Reserve DW 400 DUP (0)   ;Rserve de la place pour construire le Timer ici.

Gestion_Sonore Proc Near
       MOV Calcul_Fini,0     ; Tampon non calcul.

       CMP Test_en_cours,1   ; Test en cours => pas de sortie sonore !!!
       JE  Pas_MAJ_OPL2

       CMP Sortie_Sonore,GUS
       JNE Pas_MAJ_GUS
       CALL Programmer_GUS
Pas_MAJ_GUS:

       CMP OPL2_Present,1
       JNE Pas_MAJ_OPL2
       CMP Nb_Voies_Adlib,0
       JE  Pas_MAJ_OPL2
       CALL Programmer_OPL2
Pas_MAJ_OPL2:

       CMP Musique_Terminee,1
       JE  Seulement_Sortie_Sonore
       CALL Partition        ; Lancer la partition (si ncessaire...)
Seulement_Sortie_Sonore:

       CMP Sortie_sonore,GUS ; Si GUS, ne pas calculer le tampon...
       JE Pas_calcul_t
       CALL Calcul_tampon
Pas_calcul_t:

        CALL Recuperer_EMS  ; Au cas ou on utilise l'EMS...

       MOV Calcul_Fini,1    ; Tampon calcul.
       RET
Gestion_Sonore Endp


;Ŀ
;                 Lecture de la partition                   
;

Partition_en_cours DB 0   ; 1 si lecture de la partition en cours
Premier_appel DB 1
Pattern_Vide  DB 0

Partition Proc near

       MOV Partition_en_cours,1

       DS_TP
       INC Chrono_50           ;Incrementer les 50 ou 32 de seconde
       MOV AL,Chrono_50
       CMP AL,CS:Vitesse_Ticks
       JNE Stop_chrono
       MOV Chrono_50,0
       INC Chrono_sec
       CMP Chrono_sec,60
       JNE Stop_Chrono
       MOV Chrono_sec,0
       INC Chrono_min
Stop_chrono:
       DS_ASM

       CMP Premier_appel,1   ; 1er appel  la partition...
       JNE Calcul_BPM
       MOV Premier_appel,0
       CALL Partition_personnelle  ; Lire la partition...
       JMP Pas_Boucle_BPM

Calcul_BPM:
       MOV AX,0              ; ******* BPM *******
       MOV AL,BPM
       ADD Cmpt_BPM,AX
Boucle_BPM:
       MOV AX,Cmpt_BPM
       CMP AX,BPM_Base       ; Cmpt_BPM >= BPM_Base ?
       JB  Pas_Boucle_BPM    ; Non => Ne pas ajuster le compteur BPM
       SUB AX,BPM_Base       ; Ajuster le compteur BPM
       MOV Cmpt_BPM,AX

       INC Cmpt_Tempo        ; ******* Tempo *******
       MOV AL,Tempo
       CMP Cmpt_Tempo,AL     ; Cmpt_tempo < tempo
       JB Pas_Lire_Part      ; Oui => Executer les commandes
       SUB Cmpt_Tempo,AL     ; Mettre  jour le compteur Tempo.
       CALL Partition_personnelle  ; Non => Lire la partition...
       JMP Boucle_BPM
Pas_Lire_Part:
       CALL Executer_Commandes
       JMP Boucle_BPM

Pas_Boucle_BPM:
       CMP Musique_Terminee,1
       JE Fin_player

Pas_fin_mus:
       DS_TP
       MOV Test_Periodique,1    ; Pour l'affichage (Dtecte le 50 ou 32 )
       DS_ASM
       MOV Partition_en_cours,0
       RET

Fin_Player:
       CMP Test_en_cours,1
       JNE Fixer_Stop_Sortie    ;Si c'est le test de vitesse...
       MOV Sortie_Stoppee,1
       JMP Fin_Fin_Player

Fixer_Stop_Sortie:
       MOV Stopper_Sortie,1     ;Stopper la sortie sonore

Fin_Fin_Player:
       MOV Partition_en_cours,0
       RET
Partition Endp

Executer_Commandes Proc Near
       PUSH BP               ; *** Boucle pour les commandes ***
       MOV CL,Nb_de_voies
       XOR CH,CH
       XOR BX,BX
       XOR BP,BP
Boucle_comm_voies:
       PUSH CX
       MOV CX,Mini_Notes            ;Ajustement des limites de notes
       CALL Ajuster_Periode         ;pour les commandes.
       MOV Mini_Notes_Act,CX
       MOV CX,Maxi_Notes
       CALL Ajuster_Periode
       MOV Maxi_Notes_Act,CX
       SUB CX,Mini_Notes_Act
       MOV Moyen_Notes_Act,CX
       CALL VCommande[BP]
       POP CX
Pas_exec_commande:
       INC BX                ; Incrmente le compteur de voies
       ADD BP,2              ; BP=2*BX (Index Mots)
       DEC CX
       JNZ Boucle_comm_voies
       POP BP
       RET
Executer_Commandes Endp


;Ŀ
;      Partition_personnelle: Gestion de la partition       
;      ( Tempo, BMP, Squence ... )                         
;      Entre: Rien                                         
;                                                           
;

Taille_note EQU 5 ; Plus de periode !!!!!!

Taille_pattern_actuel DB 0
PJumpPattern    DB 0          ; 1 => Sauter au pattern JumpParam
JumpParam       DB 0          ; Pattern pour Jump Pattern


Partition_personnelle Proc Near
        MOV Test_Jump_Loop,0             ; Eviter 2 Loop sur la mme ligne

        CMP ModifierPattern,1            ; **** Changer de pattern ****
        JNE Pas_ModifierPattern          ; (Touche droite ou gauche...)
        MOV ModifierPattern,0
        MOV AL,Pos_Sequence

If Mod_Master eq YES
        CALL Cherche_Chrono_Tempo  ;TEST
EndIf
        CALL Desactive_voies
        MOV AL,Pos_Sequence
        DEC AL
        JMP Modifier_N_Pattern
Pas_ModifierPattern:

        CMP PJumpPattern,1               ; ** Jump Pattern ???
        JNE Pas_JPattern
        MOV AL,JumpParam
        JMP Modifier_N_Pattern
Pas_JPattern:

        CMP PatternBreak,1               ; ** Pattern Break?
        JE  pattern_suivant              ; Oui => Pattern suivant

        MOV NotePatternSuiv,0
        INC Pos_note                    ; Incrmenter la position de la note
        CMP Boucler_Pattern,1           ; Commande Jump Loop ?
        JNE Pas_Exec_Jump_Loop
        MOV Boucler_Pattern,0
        MOV AL,Debut_Boucle_Pattern
        MOV Pos_note,AL                 ; Initialiser au dbut de la boucle
Pas_Exec_Jump_Loop:

        MOV AL,Taille_pattern_actuel
        CMP pos_note,AL                 ; Fin de Pattern? (Compare avec Taille_Pattern)
        JNE P_Lire_Voies
pattern_suivant:                        ; Oui -> Pattern suivant

        MOV AL,pos_sequence
        MOV AH,Sequence_Len
        CMP AL,AH                       ; Fin de la squence ?
        JNE Modifier_N_Pattern          ; Non -> Nouveau pattern
                                        ; Oui => Gestion du bouclage
        DS_TP                       ; Boucler le module ?????
        CMP Boucler_MOD,1
        DS_ASM
        JE Boucler_Module
        DS_TP
        CMP Boucler_MOD,2
        DS_ASM
        JE Boucler_Module_n
Pas_boucler:
        MOV Musique_Terminee,1          ; Pas de bouclage -> Fin
        RET
Boucler_Module_n:
        DEC nb_de_boucles
        JZ Pas_boucler
Boucler_Module:
        MOV AL,Pos_de_restart
        MOV Pos_sequence,AL             ; Boucler le module...

If Mod_Master eq YES
        CALL Cherche_Chrono_Tempo
EndIf
        CALL Desactive_voies

        MOV NotePatternSuiv,0
        MOV AL,Pos_sequence
        DEC AL
Modifier_N_Pattern:
        CALL Nouveau_Pattern

P_Lire_Voies:                    ;Debut du dcodage de la partition.

        MOV ES,Segment_Pattern   ;Segment_Pattern Segment du pattern actuel.
        MOV AL,Pos_note
        XOR AH,AH
        XOR BH,BH
        MOV BL,Taille_note
        MUL BL
        MOV BL,Nb_de_voies_patt
        MUL BX             ;Position dans la partition
                           ;=Taille_note*Pos_note*Nb_de_voies_patt
                           ;(6 octets par voie)

        MOV SI,AX          ;SI <= Offset de la premire voie

                             ;*********************************
        PUSH BP              ;** Boucle de lecture des voies **
        MOV CL,Nb_de_voies   ;*********************************
        XOR CH,CH
        XOR BX,BX
        XOR BP,BP
Boucle_part_voies:
        PUSH CX ES SI
        CALL Lire_Partition  ;Lire la voie BX
        CALL Lire_Voie       ;Traiter la voie BX
        POP SI ES CX
        ADD SI,Taille_note
        INC BX               ;Incrmente le compteur de voie
        ADD BP,2             ;BP=2*BX (Index Mots)
        DEC CX
        JNZ Boucle_part_voies
        POP BP

        RET
Partition_personnelle Endp

;Ŀ
;      Nouveau_Pattern: Placer la musique au pattern AL     
;                       de la squence                      
;                                                           
;

Nouveau_Pattern Proc Near
        MOV Pos_Sequence,AL
        INC Pos_Sequence
        XOR AH,AH                       ; AX, Position dans la squence
        MOV BX,AX
        PUSH BX                         ; Sauve la position
        MOV AL,Table_Tempo[BX]
        OR AL,AL                        ; Tempo pour le Pattern>0 ?? (669)
        JZ Pas_Modif_Tempo_Pattern
        MOV Tempo,AL                    ; Oui, Modifier le Tempo
        MOV Cmpt_Tempo,0
Pas_Modif_Tempo_Pattern:
        POP BX
        MOV AL,Table_Sequence[BX]       ; AL <- N de pattern
        MOV Num_pattern,AL

        XOR BX,BX
        MOV BL,AL
        MOV AL,Table_taille_patt[BX]
        MOV Taille_pattern_actuel,AL    ; Chercher le nombre de notes par pattern

        XOR AX,AX
        MOV AL,Num_Pattern
        MOV SI,OFFSET table_pattern
        SHL AX,1
        ADD SI,AX
        MOV AX,[SI]
        CMP AX,0
        MOV Pattern_Vide,0
        JNE Pattern_Non_Vide
        MOV Pattern_Vide,1
Pattern_Non_Vide:
        MOV Segment_Pattern,AX          ; Init le segment du pattern
        MOV AL,NotePatternSuiv          ; Pos_note  NotePatternSuiv !
        MOV Pos_note,AL

        MOV NotePatternSuiv,0
        MOV PJumpPattern,0
        MOV PatternBreak,0
        MOV Debut_Boucle_Pattern,0
        RET
Nouveau_Pattern Endp

;Ŀ
;      Lire_Partition: Lecture de la partition              
;                                                           
;      entre: BX Numro de la voie                         
;              BP=BX*2   (Index pour les mots)              
;              ES:[SI]   Pointeur sur la partition          
;
;! Ne pas modifier BX et BP !

PNote        EQU B ES:[SI]
PInstrument  EQU B ES:[SI+1]
PCommande    EQU B ES:[SI+2]
PParametre   EQU B ES:[SI+3]
PVolume_part EQU B ES:[SI+4]   ;Total => 5 Octets !!!

Periode_Partition    DW 0
Instrument_Partition DB 0
Volume_Partition     DB 0
Commande_Partition   DB 0
Parametre_Partition  DB 0

Lire_Partition Proc Near
        PUSH BX

        CMP Pattern_Vide,1
        JNE Lire_Part
        MOV Instrument_Partition,0  ;Pattern vide => tout  0 !!!
        MOV Volume_Partition,0
        MOV Commande_Partition,0
        MOV Parametre_Partition,0
        MOV Periode_Partition,0
        MOV Note_KeyOff,0
        JMP Fin_Lire_Partition
Lire_Part:
        MOV AL,PVolume_Part
        INC AL
        CMP AL,41h
        JBE LP_Volume_Ok
        MOV AL,1
LP_Volume_Ok:
        DEC AL
        MOV Volume_Partition,AL

        MOV AL,PCommande
        MOV AH,PParametre
        MOV Commande_Partition,AL   ; Initialise la commande
        MOV Parametre_Partition,AH  ; Initialise le paramtre
        MOV Periode_Partition,0

        MOV Note_KeyOff,0
        CMP PNote,0FFh              ; Note=FFh => Key Off.
        JNE LP_Pas_Note_KeyOff
        MOV Note_KeyOff,1
LP_Pas_Note_KeyOff:

        MOV Periode_Partition,0
        XOR BX,BX
        MOV BL,PNote                ; Lire la note
        DEC BX
        CMP BX,Max_Notes
        JA  Periode_incorrecte
        SHL BX,1
        MOV CX,T_Per[BX]            ; Lire la priode correspondante...
        SHL CX,1

        MOV DX,CX                   ; Verifier la validite de la priode...
        SUB DX,Mini_Notes
        CMP DX,Moyen_Notes
        JA Periode_incorrecte       ; Priode incorrecte=>Periode_Partition=0
        MOV Periode_Partition,CX    ; Initialise la priode

Periode_incorrecte:
        MOV CL,PInstrument          ; Instrument  partir de 0 !!!
        DEC CL
        MOV Instrument_Partition,CL ; Initialise l'instrument
                                    ; Partition actuelle charge
Fin_Lire_Partition:
        POP BX
        RET
Lire_Partition EndP

;Ŀ
;      Lire_voie:  Traiter une note                         
;                                                           
;      entre: BX Numro de la voie                         
;              BP=BX*2   (Index pour les mots)              
;              Periode_Partition, Instrument_Partition...   
;                                                           
;

Nouv_per          DB 0

PatternBreak      DB 0  ; 0 ou 1, pour activer/dsactiver
NotePatternSuiv   DB 0
Routine_commande  DW 0
Sauter_modif_instruments DB 0
Sauter_modif_volume      DB 0
Modifier_Instr    DB 0
Modifier_Volume   DB 0
Modifier_Periode  DB 0
Sauver_Periode    DB 0

Note_Sample   DB 0
Note_Volume   DB 0
Note_Periode  DW 0
Note_Offs_Actuel  DW 0
Note_KeyOff   DB 0        ; 1 si KeyOff

; Lgende: O, Oui
;          N, Non
;          I, Impossible
;          x, Pas de commande

None         EQU 0   ;x   ;Pas de commande.
CArpeggio    EQU 1   ;O   ;Arpeggio.
PortUp       EQU 2   ;O   ;Portamento Up.
PortDown     EQU 3   ;O   ;Portamento down.
TonePort     EQU 4   ;O   ;Tone portamento.
CVibrato     EQU 5   ;O   ;Vibrato.
T_VSlide     EQU 6   ;O   ;Tone portamento+Volume slide.
Vib_VSlide   EQU 7   ;O   ;Vibrato+Volume slide.
CTremolo     EQU 8   ;O   ;Trmolo. (Vibrato pour le volume)
CPanning     EQU 9   ;O   ;Panning. (Normalement, Commande 8 non utilise)
SampleOffs   EQU 10  ;O   ;Fixer l'offset de l'chantillon.
VolSlide     EQU 11  ;O   ;Volume slide.
JumpPattern  EQU 12  ;O   ;Sauter vers la position xx.
CSetVolume   EQU 13  ;O   ;Dfinir le volume.
EndPattern   EQU 14  ;O   ;Fin du pattern.
Extended     EQU 15  ;x   ;Commandes tendues. (17...)
SetTempo     EQU 16  ;O   ;Dfinir le tempo.

CSetFilter   EQU 17  ;I   ;Activer le filtre. (Amiga)
CFinePortaUp EQU 18  ;O   ;Portamento Up Lent.
CFinePortaDn EQU 19  ;O   ;Portamento Down lent.
CGlissCtrl   EQU 20  ;N   ;Contrle du glissando.  (pour le Tone portamento)
CVibCtrl     EQU 21  ;O   ;Dfinir la table du vibrato.
CFineTune    EQU 22  ;O   ;Modifier la priode d'un son.
CJumpLoop    EQU 23  ;O   ;Bouclage de pattern.
CTremCtrl    EQU 24  ;O   ;Dfinir la table du tremolo.
CRien2       EQU 25  ;x
CRetrigNote  EQU 26  ;O   ;Rattaque aprs x 50 de secondes.
CVolFineUp   EQU 27  ;O   ;Augmente le volume lentement.
CVolFineDown EQU 28  ;O   ;Diminue le volume lentement.
CNoteCut     EQU 29  ;O   ;Couper la note aprs xx 50 de secondes.
CNoteDelay   EQU 30  ;O   ;Lancer la note aprs xx 50 de secondes.
CPattDelay   EQU 31  ;O   ;Retarde le dbut du pattern suivant.
CFunkIt      EQU 32  ;N,I ;Jouer la note  l'envers.

CSetBPM      EQU 33  ;O   ;Fixer les BPM.
CSetGVolume  EQU 34  ;O   ;Fixer le volume general. (S3M)
CTremor      EQU 35  ;    ;Tremor (Note ON/OFF Alternativement)
CFreqAdj     EQU 36  ;O   ;Ajustement de la frquence. (669)
CULTSpecial  EQU 37  ;N   ;Commande spciale ULT. (Stop Loop,...)
CVibSweep    EQU 38  ;N   ;'Profondeur du vibrato.

Lire_voie PROC NEAR       ; Traiter la partition

        MOV Sauter_modif_instruments,0
        MOV Sauter_modif_volume,0
        MOV Modifier_Instr,0
        MOV Modifier_Volume,0
        MOV Modifier_Periode,0
        MOV Sauver_Periode,0
                              ; ----- Lire les anciennes valeurs -----
                              ;Note_xxxx Anciennes valeurs...

        MOV CX,VPeriode_Part[BP]
        CALL Ajuster_Periode_Inv   ;Lecture de part => Priode MOD
        MOV Note_Periode,CX

        MOV AL,VSample[BX]
        MOV Note_sample,AL
        MOV AL,VVolume_Part[BX]
        MOV Note_Volume,AL
                              ; ----- Dcoder la partition -----
        MOV CL,Instrument_Partition   ; ***** Test du sample *****
        CMP CL,0FFh
        JE Instrument_nul

        CMP CL,Note_Sample         ;Si Samples diffrents => Relancer
        JE  S_Pas_Relancer_Sample  ;Sinon, relancer seulement le volume...
        MOV CL,Instrument_Partition; (Relancer seulement si la priode
        MOV Note_Sample,CL         ;  est correcte )
        MOV VSample[BX],CL
        CMP Note_Periode,0FFFFh    ; Priode Incorrecte => Pas Modif instrument
        JE  S_Pas_Relancer_Sample
        MOV Modifier_Instr,1       ;--  Modifier l'instrument  --
S_Pas_Relancer_Sample:

        MOV Modifier_Volume,1      ;-- Modifier le volume      --

Instrument_nul:

        MOV AL,Commande_Partition   ;Commande 3 ou 5 => Garde priode !!!!!
        CMP AL,TonePort
        JE Periode_nulle
        CMP AL,T_VSlide            
        JE Periode_nulle

        MOV CX,Periode_Partition   ; ***** Test de la priode *****
        OR CX,CX                   ; Nouvelle priode et relancer le sample
        JE Periode_nulle           

        MOV Sauver_Periode,1       ;Sauver la valeur sans le jouer...

        MOV CL,Note_Sample         ;Sample Incorrect ?
        CMP CL,0FFh
        JE Periode_nulle           ;Oui => Pas Relancer Sample...

        MOV Modifier_periode,1     ;--  Modifier la priode    --
        MOV Modifier_Instr,1       ;--  Modifier l'instrument  --

Periode_nulle:                ; ----- Mise  jours des valeurs -----

        CMP Modifier_Volume,1      ; ***** Modifier le volume ????
        JNE Pas_Modif_Volume

        MOV AL,Note_Sample
        XOR AH,AH
        Pointer_Sample AX

        TEST ES:SInfo[DI],M_Adlib  ;'Sample' Adlib ?
        JNZ Charge_Volume_Adlib

        MOV AL,ES:SVolume[DI]      ;Volume
        MOV Note_Volume,AL
        JMP Pas_Modif_Volume

Charge_Volume_Adlib:

        MOV AL,ES:AVolume[DI]      ;Volume Adlib
        MOV Note_Volume,AL

Pas_Modif_Volume:                  ; ***** Modifier l'instrument ????

        CMP Modifier_Instr,1
        JNE Pas_Modifier_Instr

        ;Tester le Retrig pour le Vibrato et le Tremolo
        CMP Retrig_Vibr[BX],0
        JNZ Pas_Retrig_Vibrato
        MOV indice_vib[BX],0
Pas_Retrig_Vibrato:
        CMP Retrig_Trem[BX],0
        JNZ Pas_Retrig_Tremolo
        MOV indice_trem[BX],0
Pas_Retrig_Tremolo:

        MOV AL,Note_Sample
        XOR AH,AH
        Pointer_Sample AX

        MOV Note_Offs_Actuel,0

        TEST ES:SInfo[DI],M_Adlib  ;'Sample' Adlib ?
        JNZ Charge_Dadj_Adlib

        MOV AX,ES:SDadj[DI]        ;Dadj
        MOV VDadj[BP],AX
        MOV AL,ES:SFine_Tune[DI]
        MOV VFineTune[BX],AL
        JMP Pas_Modifier_Instr

Charge_Dadj_Adlib:                 ;Adlib => Position du Dadj diffrente !!!
        MOV AX,ES:ADadj[DI]        ;Dadj
        MOV VDadj[BP],AX

Pas_Modifier_Instr:
        CMP Sauver_Periode,1          ; ***** Modifier la priode ???
        JNE Pas_Nouvelle_Periode
        MOV AX,Periode_Partition
        MOV Note_Periode,AX
Pas_Nouvelle_Periode:
        CMP Volume_Partition,255      ;- Lecture du volume -
        JE Pas_Volume_Partition
        MOV AH,Volume_Partition       ;Volume de la partition
        MOV Note_Volume,AH
        MOV Modifier_Volume,1

Pas_Volume_Partition:
        CMP Note_KeyOff,1             ;Execution du KeyOff
        JNE Pas_KeyOff
        OR VControle[BX],M_KeyOff     ;Bit KeyOff  1 !!!!!
Pas_KeyOff:
        MOV Routine_commande,OFFSET rien

        CMP Commande_Partition,CSetVolume
        JNE Pas_eff_C
        MOV AH,Parametre_Partition    ;Set Volume
        XOR AL,AL
        CMP AX,4000h
        JB Volume_correct
        MOV AX,4000h
Volume_correct:
        MOV Note_Volume,AH
        MOV Modifier_Volume,1
        JMP Fin_Commandes
Pas_eff_C:
        CMP Commande_Partition,SetTempo
        JNE Pas_eff_F
        CALL Exec_set_tempo
        JMP Fin_Commandes
Pas_eff_F:
        CMP Commande_Partition,CArpeggio
        JNZ Pas_eff_0
        CALL Exec_Arpeggio
        JMP Fin_Commandes
Pas_eff_0:
        CMP Commande_Partition,PortDown
        JNE Pas_eff_2
        CALL Exec_Port_DN
        JMP Fin_Commandes
Pas_eff_2:
        CMP Commande_Partition,PortUp
        JNE Pas_eff_1
        CALL Exec_Port_UP
        JMP Fin_Commandes
Pas_eff_1:
        CMP Commande_Partition,CFinePortaUp
        JNE Pas_eff_FinePortUp
        CALL Exec_FinePortaUp
        JMP Fin_Commandes
Pas_eff_FinePortUp:
        CMP Commande_Partition,CFinePortaDn
        JNE Pas_eff_FinePortDown
        CALL Exec_FinePortaDown
        JMP Fin_Commandes
Pas_eff_FinePortDown:
        CMP Commande_Partition,VolSlide
        JNE Pas_eff_A
        CALL Exec_Vol_slide
        JMP Fin_Commandes
Pas_eff_A:
        CMP Commande_Partition,EndPattern
        JNE Pas_eff_D
        CALL Exec_EndPattern
        JMP Fin_Commandes
Pas_eff_D:
        CMP Commande_Partition,TonePort
        JNE Pas_eff_3
        CALL Exec_Tone_prt
        JMP Fin_Commandes
Pas_eff_3:
        CMP Commande_Partition,CVibrato
        JNE Pas_eff_4
        CALL Execute_vibrato
        JMP Fin_Commandes
Pas_eff_4:
        CMP Commande_Partition,Vib_Vslide
        JNE Pas_eff_6
        CALL Exec_Vib_vs
        JMP Fin_Commandes
Pas_eff_6:
        CMP Commande_Partition,T_Vslide
        JNE Pas_eff_5
        CALL Exec_Tone_vs
        JMP Fin_Commandes
Pas_eff_5:
        CMP Commande_Partition,JumpPattern
        JNE Pas_eff_B
        CALL Exec_JumpPattern
        JMP Fin_Commandes
Pas_eff_B:
        CMP Commande_Partition,CVolFineUp
        JNE Pas_VlFUp
        CALL Exec_VolFineUp
        JMP Fin_Commandes
Pas_VlFUp:
        CMP Commande_Partition,CVolFineDown
        JNE Pas_VlFDown
        CALL Exec_VolFineDown
        JMP Fin_Commandes
Pas_VlFDown:
        CMP Commande_Partition,CTremolo
        JNE Pas_Tremolo
        CALL Exec_Tremolo
        JMP Fin_Commandes
Pas_Tremolo:
        CMP Commande_Partition,CNoteCut
        JNE Pas_NoteCut
        CALL Exec_NoteCut
        JMP Fin_Commandes
Pas_NoteCut:
        CMP Commande_Partition,CRetrigNote
        JNE Pas_RetrigNote
        CALL Exec_RetrigNote
        JMP Fin_Commandes
Pas_RetrigNote:
        CMP Commande_Partition,SampleOffs
        JNE Pas_SampleOffs
        CALL Exec_SampleOffs
        JMP Fin_Commandes
Pas_SampleOffs:
        CMP Commande_Partition,CJumpLoop
        JNE Pas_JumpLoop
        CALL Exec_JumpLoop
        JMP Fin_Commandes
Pas_JumpLoop:
        CMP Commande_Partition,CFineTune
        JNE Pas_FineTune
        CALL Exec_FineTune
        JMP Fin_Commandes
Pas_FineTune:
        CMP Commande_Partition,CVibCtrl
        JNE Pas_VibCtrl
        CALL Exec_VibCtrl
        JMP Fin_Commandes
Pas_VibCtrl:
        CMP Commande_Partition,CTremCtrl
        JNE Pas_TremCtrl
        CALL Exec_TremCtrl
        JMP Fin_Commandes
Pas_TremCtrl:
        CMP Commande_Partition,CSetBPM
        JNE Pas_SetBPM
        CALL Exec_SetBPM
        JMP Fin_Commandes
Pas_SetBPM:
        CMP Commande_Partition,CSetGVolume
        JNE Pas_SetGVolume
        CALL Exec_SetGVolume
        JMP Fin_Commandes
Pas_SetGVolume:
        CMP Commande_Partition,CPanning
        JNE Pas_Panning
        CALL Exec_Panning
        JMP Fin_Commandes
Pas_Panning:
        CMP Commande_Partition,CPattDelay
        JNE Pas_PattDelay
        CALL Exec_PattDelay
        JMP Fin_Commandes
Pas_PattDelay:
        CMP Commande_Partition,CNoteDelay
        JNE Pas_NoteDelay
        CALL Exec_NoteDelay
        JMP Fin_Commandes
Pas_NoteDelay:
        CMP Commande_Partition,CTremor
        JNE Pas_Tremor
        CALL Exec_Tremor
        JMP Fin_Commandes
Pas_Tremor:

Fin_Commandes:
        CMP Modifier_Instr,1      ;Modifier l'instrument ?
        JNE Pas_Modifier_Instrument

        CALL Changer_Sample

Pas_Modifier_Instrument:
        CMP Modifier_volume,1     ;Modifier le volume ?
        JNE Pas_Modifier_Volume
        MOV AL,Note_volume
        MOV VVolume_Part[BX],AL   ;Sauvegarde du volume.
        CALL Changer_Volume

Pas_Modifier_Volume:
        CMP Sauver_Periode,1      ;Modifier la priode ?
        JNE Pas_Sauver_Periode
        MOV CX,Note_Periode
        CALL Ajuster_Periode      ;Ajuster la priode !!!!!
        MOV VPeriode_Part[BP],CX  ;Sauver la valeur de la priode
        CMP Modifier_Periode,1    ;Modifier "rellement la priode"
        JNE Pas_Sauver_Periode
        CALL Changer_periode      ;Fixer la priode de la voie
Pas_Sauver_Periode:

Fin_Lire_voie:
        MOV AX,Routine_commande
        MOV VCommande[BP],AX
        RET

Lire_voie ENDP

;Ŀ
;   Changer_Sample:  Change le sample pour une voie         
;                                                           
;   Entres: Note_Sample, Le N de sample.                  
;            BX, N de voie.                                
;

Changer_Sample Proc Near
        MOV AL,Note_Sample
        INC AL                       ;Note_Sample=(N du Sample-1)
        CMP AL,Nb_Total_Samples
        JA Pas_de_sample             ;N du sample trop grand !!!

        PUSH BX
        MOV BL,Note_Sample
        XOR BH,BH
        SHL BX,2
        LES DI,PtrSamples[BX]        ;Pointeur sur le sample
        POP BX

        TEST ES:SInfo[DI],M_Charge   ;Charge dans VInfo ?
        JZ  Pas_de_sample            ;Non => Sample vide !!!

        TEST ES:SInfo[DI],M_Adlib    ;'Sample' Adlib ?
        JNZ Sample_Adlib

        CMP Type_Voie[BX],1          ;Voie digitale ?
        JNE Pas_de_sample            ;Non => Ne pas changer !!!

        MOV AL,Note_Sample           ;Copier les valeurs pour le Sample
        MOV VSample[BX],AL
        SHL BP,1                     ;Pointeur sur le sample
        MOV W VPtrSample[BP],DI
        MOV W VPtrSample[BP+2],ES
        SHR BP,1
        MOV AX,Note_Offs_Actuel      ;Position de dpart
        MOV VOffset_actuel[BP],AX
        MOV VAccumulateur[BX],0

        MOV AL,ES:SFine_Tune[DI]     ;Copie des valeurs d'ajustement des
        MOV VFineTune[BX],AL         ;priodes
        MOV AX,ES:SDadj[DI]
        MOV VDadj[BP],AX

        AND VControle[BX],Not M_Pas_Active  ; Bit  0 => Voie active
        JMP Fin_Changer_Sample

Sample_Adlib:
        CMP Type_Voie[BX],2          ;Voie Adlib ?
        JNE Pas_de_sample            ;Non => Ne pas changer !!!

        MOV AL,Note_Sample           ;Copier les valeurs pour le Sample
        MOV VSample[BX],AL
        MOV AX,ES:ADadj[DI]
        MOV VDadj[BP],AX

        AND VControle[BX],Not M_Pas_Active  ; Bit  0 => Voie active
        JMP Fin_Changer_Sample

Pas_de_sample:
        OR VControle[BX],M_Pas_Active       ; Bit  1 => Voie dsactive
Fin_Changer_Sample:
        OR GUS_Controle[BX],M_ChSample     ; Changer le Sample
        RET
Changer_Sample Endp

;Ŀ
;   Changer_Volume:  Change le volume pour une voie         
;                    avec vrification de la valeur         
;                                                           
;   Entres: BX=N de voie;BP=2*CX                          
;            AL=Le volume                                   
;

Changer_Volume Proc near
        XOR AH,AH
        MOV VVolume_re[BX],AL
        SHL AL,1                 ; Volume entre 0 et 80h !!!!
        PUSH BX

        MOV BL,40h
        DS_TP
        SUB BL,Volume_total
        DS_ASM
        CMP BL,40h
        JE Pas_diminuer_VolTot
        MUL BL                   ; Volume "Manuel"
        SHR AX,6
Pas_Diminuer_VolTot:

        MOV BL,Volume_General
        CMP BL,40h
        JE Pas_diminuer_GVol
        MUL BL
        SHR AX,6
Pas_Diminuer_GVol:

        POP BX

        MOV VVolume[BX],AL              ;Ajuste le volume (Voie BX)
        OR  GUS_Controle[BX],M_ChVolume ;Pour la Gravis UltraSound

        CALL Ajuster_Volumes_Panning ;Calculer les volumes pour le panning

        RET
Changer_Volume EndP

;Ŀ
;   Ajuster_Volumes_Panning : Calcul du volume gauche et    
;                             du volume droit               
;                                                           
;   Entres: BX=N de voie;BP=2*CX                          
;            AL=Le volume                                   
;

Ajuster_Volumes_Panning Proc near
        MOV AL,VVolume[BX]

        PUSH AX
        MOV DL,VPanning[BX]
        MUL DL
        SHR AX,7
        MOV Volume_Droite[BX],AL    ;80h -> Volume Maxi
        POP AX

        MOV DH,80h
        SUB DH,DL
        MUL DH
        SHR AX,7
        MOV Volume_Gauche[BX],AL    ;80h -> Volume Mini
        OR GUS_Controle[BX],M_ChPanning  ;Efface le Bit
        RET
Ajuster_Volumes_Panning Endp

;Ŀ
;   Ajuster_periode: Ajuster la priode pour le C-4         
;                                                           
;   Entres: CX=La priode                                  
;            CX=la priode ajuste                          
;

Ajuster_Periode Proc Near
        PUSH BX

        MOV BX,DS:VDadj[BP]
        CMP BX,100               ; Marge de 100 (qui digitalise  100 Hz ?)
        JB Pas_ajuster_periode
        CMP BX,8363
        JE Pas_ajuster_periode
                                 ; - Ajuster la priode - ( Frq pour C-4 )
        PUSH AX
        PUSH DX
        MOV AX,8363
        MUL CX
        DIV BX
        MOV CX,AX               ;AX=Periode*8363/Dadj
        POP DX
        POP AX

Pas_ajuster_periode:
        POP BX
        RET
Ajuster_Periode Endp

;Ŀ
;   Ajuster_periode_Inv: Ajustement inverse !               
;                                                           
;   Entres: CX=La priode                                  
;            CX=la priode ajuste                          
;

Ajuster_Periode_Inv Proc Near
        PUSH AX
        PUSH BX
        PUSH DX
        MOV BX,DS:VDadj[BP]
        CMP BX,100               ; Marge de 100 (qui digitalise  100 Hz ?)
        JB Pas_ajuster_periode_Inv
        CMP BX,8363
        JE Pas_ajuster_periode_Inv
                                 ; - Ajuster la priode - ( Frq pour C-4 )
        MOV AX,VDadj[BP]
        MUL CX                  ;DX-AX=Periode*Dadj
        MOV BX,8363
        DIV BX
        MOV CX,AX               ;AX=Periode*Dadj/8363

Pas_ajuster_periode_Inv:
        POP DX
        POP BX
        POP AX
        RET
Ajuster_Periode_Inv Endp

;Ŀ
;   Changer_periode: Change la priode pour une voie        
;                    avec vrification de la valeur         
;                                                           
;   Entres: BX=N de voie                                  
;            BP=2*BX                                        
;            CX=La priode                                  
;

Changer_periode PROC NEAR
        PUSH CX                 ;Calcul de la priode amiga "brute" joue
        CALL Ajuster_Periode_Inv
        MOV VPeriode_re[BP],CX
        POP CX

        MOV DX,CX
        SUB DX,Mini_Notes
        CMP DX,Moyen_Notes
        JA Pas_changer_Periode  ;Periode incorrecte=>Periode=0

        PUSH CX
        MOV DX,P_Amiga_h        ;Calcul des incrments pour le mixage.
        MOV AX,P_Amiga_l
        JCXZ Pas_DIV4
        DIV CX
Pas_DIV4:
        MOV VPart_entiere[BX],AH
        MOV VPart_decimale[BX],AL
        POP CX

                                ;Calcul de la frquence en Hz pour la GUS
        PUSH CX
        XOR ECX,ECX
        POP CX

        XOR EDX,EDX
        MOV EAX,7093789         ;(7093789)/2*Periode => F (Hz)
        OR ECX,ECX              ;Plus de SHL ECX,1 car priode double !!!
        JZ Pas_DIV5
        DIV ECX
Pas_DIV5:
        SHL BP,1
        MOV Frequence_GUS[BP],EAX
        SHR BP,1
        OR GUS_Controle[BX],M_ChPeriode  ;Changer la priode

Pas_changer_periode:
        RET

Changer_periode ENDP

;Ŀ
;              Installation des commandes                   
;

;Ŀ
;   Set General Volume   
;

Exec_SetGVolume PROC NEAR
        MOV AL,Parametre_Partition
        CMP AL,40h
        JBE Pas_Ajuster_GVol   ; si >40h mettre 40h
        MOV AL,40h
Pas_Ajuster_GVol:
        MOV Volume_General,AL
        CALL Changer_le_volume ; Ajuster le volume pour toutes les voies !!
        RET
Exec_SetGVolume Endp

;Ŀ
;       Set Tempo        
;

Exec_set_tempo PROC NEAR

        MOV AH,Parametre_Partition
        OR AH,AH
        JZ Fin_Exec_set_tempo
        MOV Tempo,AH
        MOV Cmpt_Tempo,0
Fin_Exec_set_tempo:
        RET

Exec_set_tempo ENDP

;Ŀ
;     Pattern Break      
;

Exec_EndPattern Proc Near
        MOV AH,Parametre_Partition
        MOV AL,AH
        AND AH,0Fh                 ;Convertir de BCD  Hexa
        AND AL,0F0h
        SHR AL,1
        ADD AH,AL
        SHR AL,2
        ADD AH,AL
        CMP AH,Taille_pattern_actuel
        JAE Fin_EndPattern
        MOV PatternBreak,1
        MOV NotePatternSuiv,AH
Fin_EndPattern:
        RET
Exec_EndPattern Endp

;Ŀ
;      Jump Pattern      
;

Exec_JumpPattern Proc Near
        MOV AH,Parametre_Partition
        DS_TP
        MOV AL,Boucler_MOD
        DS_ASM
        OR AL,AL
        JZ Fin_JumpPattern

        CMP AH,Sequence_Len
        JA Fin_JumpPattern
        MOV PJumpPattern,1
        MOV JumpParam,AH

Fin_JumpPattern:
        RET
Exec_JumpPattern Endp

;Ŀ
;       PattDelay        
;

Exec_PattDelay Proc Near
        MOV AL,Parametre_Partition
        OR AL,AL
        JZ Fin_PattDelay
        MOV CL,Tempo
        XOR AH,AH
        MUL CL
        MOV Cmpt_Tempo,0   ;Attendre Tempo*Parametre 50 de secondes...
Fin_PattDelay:
        RET
Exec_PattDelay EndP

;Ŀ
;       Arpeggio         
;

Exec_Arpeggio PROC NEAR

        MOV DX,Note_Periode
        MOV Per0_arp[BP],DX       ;Priode 0 arpeggio
        SHR DX,1                  ;Priode/2 !!!
        OR DX,DX
        JZ Fin_Exec_Arpeggio      ;Priode nulle => Fin

        PUSH SI                   ;Cherche l'indice de la priode
        XOR CX,CX                 ;Actuelle dans la table
        MOV SI,Offset T_per       ;*** Adresse_Table_periode[BP] ***
Arp_Boucle_cherche_per:
        LODSW
        CMP AX,DX
        JBE Arp_Periode_trouvee
        INC CX
        OR AX,AX                  ;Priode 0 => Fin de la recherche
        JNZ Arp_Boucle_cherche_per
        POP SI
        JMP Fin_Exec_Arpeggio     ;Note non trouve => Fin de la commande
Arp_Periode_trouvee:

        XOR AH,AH
        PUSH CX
        MOV AL,Parametre_Partition
        SHR AL,4
        ADD CX,AX
        CMP CX,12*Nb_Octaves_Total
        JA Pas_modif_per1
        MOV SI,Offset T_per              ; *** Adresse_Table_periode[BP] ***
        SHL CX,1
        ADD SI,CX
        MOV DX,[SI]
Pas_modif_per1:
        SHL DX,1                  ;Priode*2 !!!
        MOV Per1_arp[BP],DX       ;Priode 1 arpeggio
        POP CX

        MOV DX,Note_Periode
        MOV AL,Parametre_Partition
        AND AL,00001111b
        ADD CX,AX
        CMP CX,12*Nb_Octaves_Total
        JA Pas_modif_per2
        MOV SI,Offset T_per              ; *** Adresse_Table_periode[BP] ***
        SHL CX,1
        ADD SI,CX
        MOV DX,[SI]
Pas_modif_per2:
        SHL DX,1                  ;Priode*2 !!!
        MOV Per2_arp[BP],DX       ;Priode 2 arpeggio

        POP SI
        MOV Compt_arp[BX],0
        MOV Routine_commande,OFFSET arpeggio
Fin_Exec_Arpeggio:
        RET

Exec_Arpeggio ENDP

;Ŀ
;    Portamento Down     
;

Exec_port_DN PROC NEAR

        MOV AH,Parametre_Partition
        OR AH,AH
        JZ Pas_modif_Port_Dn
        MOV Param_pr_dn[BX],AH
Pas_modif_Port_Dn:
        MOV Routine_commande,OFFSET Port_down
        RET

Exec_port_DN ENDP

;Ŀ
;    Portamento Up       
;

Exec_Port_up PROC NEAR

        MOV AH,Parametre_Partition
        OR AH,AH
        JZ Pas_modif_Port_Up
        MOV Param_pr_up[BX],AH
Pas_modif_Port_Up:
        MOV Routine_commande,OFFSET Port_up
        RET

Exec_Port_up ENDP

;Ŀ
;  Fine Portamento Up    
;

Exec_FinePortaUp PROC NEAR
        MOV AH,Parametre_Partition
        OR AH,AH
        JZ Pas_modif_PortFineUp
        MOV Param_pr_up[BX],AH
Pas_modif_PortFineUp:
        MOV Cmpt_Commande[BX],0
        MOV Routine_commande,OFFSET Fine_Portamento_Up
        RET
Exec_FinePortaUp ENDP

;Ŀ
;  Fine Portamento Down  
;

Exec_FinePortaDown PROC NEAR
        MOV AH,Parametre_Partition
        OR AH,AH
        JZ Pas_modif_PortFineDown
        MOV Param_pr_Dn[BX],AH
Pas_modif_PortFineDown:
        MOV Cmpt_Commande[BX],0
        MOV Routine_commande,OFFSET Fine_Portamento_Down
        RET
Exec_FinePortaDown ENDP

;Ŀ
;     Volume slide       
;

Exec_Vol_slide PROC NEAR

        MOV AH,Parametre_Partition
        OR AH,AH
        JE Garde_vs
        MOV Param_vs[BX],AH
Garde_vs:
        MOV Routine_commande,OFFSET volume_slide
        CMP Volume_Sl_Rapide,1
        JNE Pas_Volume_Sl_Rapide
        CALL Volume_Slide
Pas_Volume_Sl_Rapide:
        RET

Exec_Vol_slide ENDP

;Ŀ
;    Volume Fine Up      
;

Exec_VolFineUp PROC NEAR

        MOV AH,Parametre_Partition
        OR AH,AH
        JE Garde_vfUp
        SHL AH,4              ;Paramtre  gauche pour +
        MOV param_vs[BX],AH
Garde_VFUp:
        MOV Cmpt_Commande[BX],0
        MOV Routine_commande,OFFSET volume_fine
        RET

Exec_VolFineUp ENDP

;Ŀ
;    Volume Fine Down    
;

Exec_VolFineDown PROC NEAR

        MOV AH,Parametre_Partition
        OR AH,AH
        JE Garde_vfDown
        MOV param_vs[BX],AH
Garde_VFDown:
        MOV Cmpt_Commande[BX],0
        MOV Routine_commande,OFFSET volume_fine
        RET

Exec_VolFineDown ENDP

;Ŀ
;    Tone portamento     
;

Exec_Tone_prt PROC NEAR

        MOV AH,Parametre_Partition
        MOV CX,Periode_Partition
        OR CX,CX                   ;Priode=0 => Execute ancien T Prt
        JNZ Cont_Exec_3
        CMP Per_tone_prt[BP],0
        JZ  Fin_exec_Tone_prt
        JMP Exec_ancien_3          ;Ancien Tone Prt incorrect => Fin
Cont_exec_3:
        MOV DX,CX
        MOV Per_tone_prt[BP],DX
        MOV dir_tone_prt[BX],0

        MOV CX,Note_Periode

        CMP DX,CX
        JA  Exec_ancien_3          ;Choisir la direction du Tone
        MOV dir_tone_prt[BX],1     ;Portamento
Exec_ancien_3:
        OR AH,AH
        JZ utilise_anc_param       ;Utilise l'ancien paramtre si=0
        MOV param_tone_prt[BX],AH
utilise_anc_param:
        MOV Routine_commande,OFFSET Tone_portamento
Fin_Exec_Tone_prt:
        RET

Exec_Tone_prt ENDP

;Ŀ
;        Vibrato         
;

Execute_vibrato PROC NEAR

        MOV AH,Parametre_Partition
        OR AH,AH
        JZ Garde_val           ;Paramtre=0 =>on conserve les valeurs
                               ;Prcdentes
        MOV AL,AH
        AND AL,0Fh
        MOV Amplitude_vib[BX],AL
        SHR AH,4
        MOV Vitesse_vib[BX],AH
        MOV Indice_vib[BX],0
Garde_val:
        MOV Routine_commande,OFFSET Vibrato
        RET

Execute_vibrato ENDP

;Ŀ
;        Tremolo         
;

Exec_Tremolo PROC NEAR
        MOV AH,Parametre_Partition
        OR AH,AH
        JZ Garde_val_tre        ;Paramtre=0 =>on conserve les valeurs
                                ;Prcdentes
        MOV AL,AH
        AND AL,0Fh
        MOV Amplitude_trem[BX],AL
        SHR AH,4
        MOV Vitesse_trem[BX],AH

Garde_val_tre:
        CMP Modifier_volume,1
        JNE Pas_modif_vol_tremolo
        MOV Indice_trem[BX],0
Pas_modif_vol_tremolo:
        MOV Routine_commande,OFFSET Tremolo
        RET

Exec_Tremolo ENDP

;Ŀ
;      Tremor      
;

Exec_Tremor PROC NEAR
        MOV AH,Parametre_Partition
        CMP AH,0
        JE Garde_Val_Tremor
        MOV Param_Tremor[BX],AH
        MOV Partie_Tremor[BX],0     ;0 Note On, 1 Note Off
Garde_Val_Tremor:
        MOV Cmpt_Commande[BX],0
        MOV Routine_commande,OFFSET Tremor
        RET
Exec_Tremor ENDP

;Ŀ
;    Vibrato Controle    
;

Exec_VibCtrl Proc near
        MOV AH,Parametre_Partition
        MOV Retrig_Vibr[BX],0
        CMP AH,4
        JB  ERetrig_Vib
        MOV Retrig_Vibr[BX],1
        SUB AH,4
ERetrig_Vib:

        CMP AH,0
        JNE Pas_Vib_Sinus
        MOV DS:Table_Vibrato[BP],Offset Ta_vib      ;Sinus
        JMP Fin_Exec_VibCtrl
Pas_Vib_Sinus:
        CMP AH,1
        JNE Pas_Vib_Rampe
        MOV DS:Table_Vibrato[BP],Offset Ta_rampe
        JMP Fin_Exec_VibCtrl
Pas_Vib_Rampe:
        CMP AH,2
        JNE Pas_Vib_Carre
        MOV DS:Table_Vibrato[BP],Offset Ta_carre
Pas_Vib_Carre:                      ;4 => Hazard (Garde la meme valeur )

Fin_Exec_VibCtrl:
        RET
Exec_VibCtrl Endp

;Ŀ
;    Tremolo Controle    
;

Exec_TremCtrl PROC NEAR
        MOV AH,Parametre_Partition
        MOV Retrig_Trem[BX],0
        CMP AH,4
        JB  ERetrig_Trem
        MOV Retrig_Trem[BX],1
        SUB AH,4
ERetrig_Trem:

        CMP AH,0
        JNE Pas_Trem_Sinus
        MOV DS:Table_Tremolo[BP],Offset Ta_vib      ;Sinus
        JMP Fin_Exec_TremCtrl
Pas_Trem_Sinus:
        CMP AH,1
        JNE Pas_Trem_Rampe
        MOV DS:Table_Tremolo[BP],Offset Ta_rampe
        JMP Fin_Exec_TremCtrl
Pas_Trem_Rampe:
        CMP AH,2
        JNE Pas_Trem_Carre
        MOV DS:Table_Tremolo[BP],Offset Ta_carre
Pas_Trem_Carre:                      ;4 => Hazard (Garde la meme valeur )

Fin_Exec_TremCtrl:
        RET
Exec_TremCtrl Endp

;Ŀ
;    Vibrato+Vol Slide   
;

Exec_vib_vs PROC NEAR
        CALL Exec_vol_slide
        MOV Routine_commande,OFFSET Vibrato_vs
        RET
Exec_vib_vs ENDP

;Ŀ
;  Tone port+Vol Slide   
;

Exec_tone_vs PROC NEAR

        CALL Exec_vol_slide
        MOV Parametre_Partition,0
        CALL Exec_Tone_prt
        MOV Routine_commande,OFFSET Tone_vs
        RET

Exec_tone_vs ENDP

;Ŀ
;     Note Cut     
;

Exec_NoteCut PROC NEAR
        MOV AH,Parametre_Partition
        MOV Delai_NC[BX],AH
        MOV Cmpt_Commande[BX],0
        MOV Routine_commande,OFFSET NoteCut
        RET
Exec_NoteCut ENDP

;Ŀ
;   Note Delay     
;

Exec_NoteDelay PROC NEAR
        MOV AH,Parametre_Partition
        MOV Delai_ND[BX],AH
        MOV Cmpt_Commande[BX],0
        MOV Routine_commande,OFFSET NoteDelay

        CMP Modifier_Instr,1      ;Modifier l'instrument ?
        JNE NDPas_Modifier_Instrument
        MOV AL,Note_Sample
        MOV VSample[BX],AL
        MOV Modifier_Instr,0
NDPas_Modifier_Instrument:
;        CMP Modifier_volume,1     ;Modifier le volume ?
;        JNE NDPas_Modifier_Volume
;        MOV AL,Note_volume
;        MOV VVolume_Part[BX],AL
;NDPas_Modifier_Volume:
        CMP Sauver_Periode,1      ;Modifier la priode ?
        JNE NDPas_Sauver_Periode
        MOV CX,Note_Periode
        CALL Ajuster_Periode      ;Ajuster la priode !!!!!
        MOV VPeriode_Part[BP],CX  ;Sauver la valeur de la priode
        MOV Sauver_Periode,0
NDPas_Sauver_Periode:
        CALL NoteDelay            ;Si Delay=0, lancer tout de suite !!!
        RET
Exec_NoteDelay ENDP

;Ŀ
;    Retrig Note    
;

Exec_RetrigNote PROC NEAR
        MOV AH,Parametre_Partition
        CMP Type_Module,T_S3M
        JNE Pas_Retrig_S3M      ; Si S3M, relancer le retrig si param 0
        OR AH,AH
        JZ Retrig_Idem
Pas_Retrig_S3M:
        OR AH,AH
        JZ Pas_Retrig
        MOV AL,AH
        AND AH,0Fh
        MOV Delai_Ret[BX],AH
        SHR AL,4
        MOV Param_Ret[BX],AL
Retrig_Idem:
        MOV AH,Delai_Ret[BX]    ; Copier Delai Retr dans Cmpt_Commande
        MOV Cmpt_Commande[BX],AH
        MOV Routine_commande,OFFSET RetrigNote
Pas_Retrig:
        RET
Exec_RetrigNote ENDP

;Ŀ
;    Sample Offset   
;

TSmp_Offs DB Max_Voies DUP (0)

Exec_SampleOffs PROC NEAR
        XOR AL,AL
        MOV AH,Parametre_Partition
        OR AH,AH
        JNZ Pas_Smp_Offs0
        MOV AH,TSmp_Offs[BX]      ; Si Paramtre=0, valeur prcdente.
Pas_Smp_Offs0:
        MOV TSmp_Offs[BX],AH
        CMP Modifier_Instr,1
        JNE Suite_Smp_Offs
        MOV Note_Offs_Actuel,AX
Suite_Smp_Offs:
        RET

Exec_SampleOffs Endp

;Ŀ
;      Set BPM       
;

Exec_SetBPM Proc Near
        MOV AL,Parametre_Partition
        MOV BPM,AL
        RET
Exec_SetBPM Endp

;Ŀ
;     Jump Loop      
;

Debut_Boucle_Pattern DB 0
Cmpt_Boucles         DB 0
Bouclage_en_cours    DB 0
Boucler_Pattern      DB 0
Test_Jump_Loop       DB 0

Exec_JumpLoop PROC NEAR
        CMP Test_Jump_Loop,1
        JE Fin_Exec_JumpLoop         ;Dj utilis sur la mme ligne ?

        MOV Test_Jump_Loop,1
        MOV AH,Parametre_Partition
        OR AH,AH
        JNZ Pas_debut_Bouclage
        MOV AL,Pos_Note
        MOV Debut_Boucle_Pattern,AL  ;Fixer le dbut du bouclage
        JMP Fin_Exec_JumpLoop
Pas_debut_Bouclage:
        CMP Bouclage_en_cours,1      ;Bouclage en cours ?
        JNE Lancer_Bouclage
        DEC Cmpt_Boucles             ;Fin du bouclage ?
        JE Stopper_Bouclage
        MOV Boucler_Pattern,1        ;Boucler
        JMP Fin_Exec_JumpLoop
Stopper_Bouclage:
        MOV Bouclage_en_cours,0      ;Stopper le bouclage
        JMP Fin_Exec_JumpLoop
Lancer_Bouclage:
        MOV Bouclage_en_cours,1      ;Lancer le bouclage
        MOV Cmpt_Boucles,AH
        MOV Boucler_Pattern,1
Fin_Exec_JumpLoop:
        RET
Exec_JumpLoop Endp

;Ŀ
;     FineTune       
;

Exec_FineTune PROC Near
;        MOV AL,Note_Sample         ;du sample
;        XOR AH,AH
;        Pointer_Sample AX
;        MOV AL,Parametre_Partition
;        CMP AL,0Fh
;        JAE Fin_Exec_FineTune
;        MOV ES:SFine_Tune[DI],AL
;        MOV VFineTune[BX],AL
;        CALL Changer_periode_Fine
;Fin_Exec_FineTune:
        RET
Exec_FineTune Endp

;Ŀ
;      Panning       
;

Exec_Panning Proc Near
        CMP Utiliser_Panning,1
        JNE EP_Pas_Modif_Panning
        MOV AL,Parametre_Partition
        CMP Sortie_Sonore,SB
        JNE EP_Ajuster_Panning
        CMP AL,40h
        JE EP_Pas_Modif_Panning
EP_Ajuster_Panning:     
        MOV VPanning[BX],AL
        CALL Ajuster_Volumes_Panning
EP_Pas_Modif_Panning:

        RET
Exec_Panning Endp

;Ŀ
;                      COMMANDES                            
;

Cmpt_Commande DB Max_voies DUP (0)  ;Compteur pour VolFine, FinePorta
                                    ;Retrig, NoteCut, NoteDelay...

Rien:
        RET

;Ŀ
;     - Arpeggio -       
;

Compt_arp DB Max_voies DUP (0)
Per0_arp  DW Max_voies DUP (0)
Per1_arp  DW Max_voies DUP (0)
Per2_arp  DW Max_voies DUP (0)

Arpeggio PROC NEAR
        INC Compt_arp[BX]
        MOV AL,Compt_arp[BX]
        DEC AL
        JNZ arp2
        MOV CX,Per0_arp[BP]
        JMP Fin_arp
arp2:
        DEC AL
        JNZ arp3
        MOV CX,Per1_arp[BP]
        JMP Fin_arp
arp3:
        MOV CX,Per2_arp[BP]
        MOV compt_arp[BX],0
Fin_arp:
        CALL Ajuster_Periode          ;Periodes Arpeggio pas relles => Ajuster
        CALL Changer_periode
        RET
Arpeggio Endp

;Ŀ
;  - Portamento Down -   
;
                 
Param_pr_dn DB Max_voies DUP (0)

Port_down Proc Near
        MOV CX,VPeriode_Part[BP]
        XOR AH,AH
        MOV AL,Param_pr_dn[BX]
        SHL AX,1                      ;Paramtre *2 !!!
        ADD CX,AX
        CMP CX,Maxi_Notes_Act
        JB Port_dn_inf
        MOV CX,Maxi_Notes_Act         ;Priode au maximum
Port_dn_inf:

        MOV VPeriode_Part[BP],CX
        CALL Changer_periode
        RET
Port_down Endp

;Ŀ
;   - Portamento Up -    
;

Param_pr_up DB Max_voies DUP (0)

Port_up Proc Near
        MOV CX,VPeriode_Part[BP]
        XOR AH,AH
        MOV AL,Param_pr_up[BX]
        SHL AX,1                          ;Paramtre*2 !!!
        SUB CX,AX
        MOV DX,CX
        SUB DX,Mini_notes_Act
        CMP DX,Moyen_Notes_Act
        JB Pru_Periode_correcte

        CMP Type_Module,T_S3M             ;S3M => Couper le Sample !!!
        JNE Pas_Couper_PrtUp              ;(Emulation d'un bug de ST3  8-)
        OR VControle[BX],M_Pas_Active     ;Dsactiver la voie
        OR GUS_Controle[BX],M_ChSample

Pas_Couper_PrtUp:
        MOV CX,Mini_notes_Act             ;Priode au minimum
Pru_Periode_correcte:

        MOV VPeriode_Part[BP],CX
        CALL Changer_periode
        RET
Port_up ENDP

;Ŀ
; - Fine Portamento Up - 
;

Fine_Portamento_Up PROC NEAR
        CMP Cmpt_Commande[BX],0
        JNE Pas_exec_Port_Up
        CALL Port_up
        MOV Cmpt_Commande[BX],1
Pas_exec_Port_Up:
        RET
Fine_Portamento_Up ENDP

;Ŀ
; - Fine Portamento Down - 
;

Fine_Portamento_Down PROC NEAR
        CMP Cmpt_Commande[BX],0
        JNE Pas_exec_Port_Down
        CALL Port_Down
        MOV Cmpt_Commande[BX],1
Pas_exec_Port_Down:
        RET
Fine_Portamento_Down ENDP

;Ŀ
;    - Volume Slide -    
;

Param_VS DB Max_voies DUP (0)

Volume_slide PROC NEAR
        MOV AL,Param_VS[BX]
        OR AL,AL                  ; AL=0?
        JE Fin_volume_slide
        MOV DL,AL
        AND DL,0Fh                ; DL <- 2 partie
        OR DL,DL                  ; Volume Slide Down ???
        JZ Vol_sl_add
        MOV CL,VVolume_Part[BX]   ; Volume Slide Down ...
        SUB CL,DL
        CMP CL,40h
        JB Fin_vs
        XOR CL,CL
        JMP Fin_vs
Vol_sl_add:
        SHR AL,4                  ; Volume Slide Up ...
        MOV CL,VVolume_Part[BX]
        ADD CL,AL
        CMP CL,40h
        JB Fin_vs
        MOV CL,40h
        JMP Fin_vs
Fin_vs:
        MOV AL,CL
        MOV VVolume_Part[BX],AL
        CALL Changer_Volume
Fin_volume_slide:
        RET
Volume_slide ENDP

;Ŀ
;  - Volume fine (Up et Down) -   
;

Volume_fine PROC NEAR
        CMP Cmpt_Commande[BX],0
        JNE Pas_exec_VolFine
        CALL VOLUME_Slide
        MOV Cmpt_Commande[BX],1
Pas_exec_VolFine:
        RET
Volume_fine ENDP

;Ŀ
;  - Tone Portamento -   
;

Per_tone_prt   DW Max_voies DUP (0)
Param_tone_prt DB Max_voies DUP (0)
dir_tone_prt   DB Max_voies DUP (0)

Tone_portamento PROC NEAR
        MOV CX,Per_tone_prt[BP]
        CALL Ajuster_Periode
        MOV DX,CX                      ;DX=Priode de fin.

        MOV CX,VPeriode_Part[BP]       ;CX=Priode actuelle

        XOR AH,AH
        MOV AL,Param_tone_prt[BX]
        SHL AX,1                       ;Paramtre*2 !!!
        OR AX,AX
        JNZ Cont_t_pr
        MOV CX,DX
        JMP Fin_t_pr
Cont_t_pr:
        CMP dir_tone_prt[BX],0
        JZ t_pr_monte
        SUB CX,AX
        CMP CX,DX
        JA Test_si_Grand
        MOV CX,DX
        JMP Fin_t_pr
Test_si_grand:
        MOV AX,CX
        SUB AX,Mini_notes_Act
        CMP AX,Moyen_notes_Act
        JB Fin_t_pr
        MOV CX,DX
        JMP Fin_t_pr
t_pr_monte:
        ADD CX,AX
        CMP CX,DX
        JB Fin_t_pr
        MOV CX,DX
Fin_t_pr:
        MOV VPeriode_Part[BP],CX      ; Periode dans CX
        CALL Changer_periode
        RET
Tone_portamento ENDP

;Ŀ
;      - Vibrato -       
;

Table_Vibrato DW Max_voies DUP (0)
Retrig_Vibr   DB Max_Voies DUP (0)    ;0 Retrig 1 Pas de retrig

Vitesse_vib   DB Max_voies DUP (0)
Amplitude_vib DB Max_voies DUP (0)
indice_vib    DB Max_voies DUP (0)

Vibrato PROC NEAR                     ;Ne pas changer VPeriode_Part !!!
         CMP indice_vib[BX],63
         JB Pas_per_vib
         SUB indice_vib[BX],64
Pas_per_vib:
         MOV SI,DS:Table_Vibrato[BP]
         MOV CL,indice_vib[BX]
         XOR CH,CH
         ADD SI,CX
         MOV AL,[SI]
         MUL Amplitude_vib[BX]
         SHR AX,6
         MOV CX,DS:VPeriode_Part[BP]
         CMP indice_vib[BX],32
         JNA Pas_neg_v
         SUB CX,AX
         JMP Fin_vib
Pas_neg_v:
         ADD CX,AX
Fin_vib:
         MOV AL,Vitesse_vib[BX]
         ADD Indice_vib[BX],AL

         CALL Changer_periode
         RET
Vibrato ENDP

;Ŀ
;      - Tremolo -       
;

Table_Tremolo  DW Max_voies DUP (0)
Retrig_Trem    DB Max_Voies DUP (0)       ;0: Retrig, 1: Pas de retrig

Vitesse_Trem   DB Max_voies DUP (0)
Amplitude_Trem DB Max_voies DUP (0)
indice_Trem    DB Max_voies DUP (0)

Tremolo PROC NEAR
         CMP indice_Trem[BX],63
         JB Pas_per_Trem
         SUB indice_Trem[BX],64
Pas_per_Trem:
         MOV SI,Table_Tremolo[BP]         ;Table du tremolo (sinus,rampe,carr)
         MOV CL,indice_Trem[BX]
         XOR CH,CH
         ADD SI,CX
         MOV AL,[SI]
         MUL Byte Ptr Amplitude_Trem[BX]  ;Valeur dans AH   (Amplitude*Sin(...))
         SHL AX,2         ;Amplitude*4

         MOV CL,VVolume_Part[BX]
         CMP indice_Trem[BX],32
         JNA Pas_neg_Trem
         SUB CL,AH        ;Modifier le volume
         CMP CL,40h
         JBE Fin_Trem     ;Volume <0 ???
         MOV CL,0
         JMP Fin_Trem
Pas_neg_Trem:
         ADD CL,AH
         CMP CL,40h
         JBE Fin_Trem
         MOV CL,40h
Fin_Trem:
         MOV AL,vitesse_Trem[BX]
         ADD indice_Trem[BX],AL
                               ;***  Modifier le volume ***
         MOV AL,CL                  ;Volume dans CL
         CALL Changer_Volume
         RET
Tremolo ENDP

;Ŀ
;      - Tremor -        
;

Param_Tremor   DB Max_Voies DUP (0)
Partie_Tremor  DB Max_Voies DUP (0)

Tremor PROC NEAR

         INC Cmpt_Commande[BX]
         MOV AL,Param_Tremor[BX]
         CMP Partie_Tremor[BX],0
         JNE Partie_Off
         SHR AL,4
         CMP AL,Cmpt_Commande[BX]
         JA  Fin_Tremor
         MOV AL,0                   ;Couper le volume.
         CALL Changer_Volume
         MOV Partie_Tremor[BX],1
         MOV Cmpt_Commande[BX],0
         JMP Fin_Tremor
Partie_Off:
         AND AL,0Fh
         CMP AL,Cmpt_Commande[BX]
         JA  Fin_Tremor
         MOV AL,VVolume_Part[BX]    ;Remettre le volume normal.
         CALL Changer_Volume
         MOV Partie_Tremor[BX],0
         MOV Cmpt_Commande[BX],0
Fin_Tremor:
         RET
Tremor ENDP

;Ŀ
; - Vibrato+Vol Slide -  
;

Vibrato_vs PROC NEAR
        CALL Vibrato
        JMP Volume_slide
Vibrato_vs ENDP

;Ŀ
;- Tone port+Vol Slide - 
;

Tone_vs PROC NEAR
        CALL Tone_portamento
        JMP Volume_slide
Tone_vs ENDP

;Ŀ
;     - Note Cut -     
;

Delai_NC DB Max_Voies DUP (0)

NoteCut:
        MOV AL,Delai_NC[BX]
        CMP AL,Cmpt_Commande[BX]
        JE Couper_NC
        INC Cmpt_Commande[BX]
        JMP Fin_NC
Couper_NC:
        MOV AL,0               ;Volume 0 => Couper la voie
        MOV VVolume_Part[BX],AL
        CALL Changer_Volume
Fin_NC:
        RET

;Ŀ
;    - Note Delay -    
;

Delai_ND DB Max_Voies DUP (0)

NoteDelay PROC NEAR
        MOV AL,Delai_ND[BX]
        CMP AL,Cmpt_Commande[BX]
        JNE Fin_ND

        MOV AL,VVolume_Part[BX]
        CALL Changer_Volume       ;Changer le volume
        MOV CX,VPeriode_Part[BP]
        CALL Changer_periode      ;Changer la priode de la voie
        MOV AL,VSample[BX]
        MOV Note_Sample,AL
        MOV Note_Offs_Actuel,0
        CALL Changer_Sample       ;Changer le sample
Fin_ND:
        INC Cmpt_Commande[BX]
        RET
NoteDelay ENDP

;Ŀ
;   - Retrig Note -    
;

Delai_Ret DB Max_Voies DUP (0)
Param_Ret DB Max_Voies DUP (0)

RetrigNote PROC NEAR
        DEC Cmpt_Commande[BX]
        JZ Couper_Ret
        JMP Fin_Ret
Couper_Ret:
        MOV AL,VSample[BX]
        MOV Note_Sample,AL
        MOV Note_Offs_Actuel,0
        CALL Changer_Sample
        MOV AL,Delai_Ret[BX]
        MOV Cmpt_Commande[BX],AL
        MOV CL,Param_Ret[BX]

        OR CL,CL
        JZ Fin_Ret

        MOV AL,VVolume_Part[BX]
        CMP CL,8
        JAE R_Augmenter_Vol
                               ;Diminuer le volume
        MOV CH,1
        CMP CL,1               ; 1 => Volume=Volume-1
        JE Decrementer_Volume
        MOV CH,2
        CMP CL,2               ; 2 => Volume=Volume-2
        JE Decrementer_Volume
        MOV CH,4
        CMP CL,3               ; 3 => Volume=Volume-4
        JE Decrementer_Volume
        MOV CH,8
        CMP CL,4               ; 4 => Volume=Volume-8
        JE Decrementer_Volume
        MOV CH,16
        CMP CL,5               ; 5 => Volume=Volume-16
        JE Decrementer_Volume
        CMP CL,7
        JNE Diviser_Volume
        XOR AH,AH              ; 7 => Volume=Volume*2/3
        SHL AX,1               ; Vol*2
        MOV CH,3
        DIV CH                 ; Vol/3 => Vol*2/3
        JMP Fin_Diminuer_Vol
Diviser_Volume:                ; 6 => Volume=Volume/2
        SHR AL,1
        JMP Fin_Diminuer_vol
Decrementer_Volume:
        SUB AL,CL
Fin_Diminuer_vol:
        CMP AL,40h
        JBE Fin_R_Modif_Vol
        MOV AL,0
        JMP Fin_R_Modif_Vol

R_Augmenter_Vol:               ;Augmenter le volume
        MOV CH,1
        CMP CL,9               ; 9 => Volume=Volume+1
        JE Incrementer_Volume
        MOV CH,2
        CMP CL,0Ah             ; A => Volume=Volume+2
        JE Incrementer_Volume
        MOV CH,4
        CMP CL,0Bh             ; B => Volume=Volume+4
        JE Incrementer_Volume
        MOV CH,8
        CMP CL,0Ch             ; C => Volume=Volume+8
        JE Incrementer_Volume
        MOV CH,16
        CMP CL,0Dh             ; D => Volume=Volume+16
        JE Incrementer_Volume
        CMP CL,0Eh
        JNE Doubler_Volume
        MOV AH,AL              ; F => Volume=Volume*3/2
        SHL AL,1
        ADD AL,AH
        SHR AL,1
        JMP Fin_Augmente_Vol

Doubler_Volume:                ; E => Volume=Volume*2
        SHL AL,1
        JMP Fin_Augmente_vol
Incrementer_Volume:
        ADD AL,CL
Fin_Augmente_vol:
        CMP AL,40h
        JBE Fin_R_Modif_Vol
        MOV AL,40h
Fin_R_Modif_Vol:
        MOV VVolume_Part[BX],AL
        CALL Changer_Volume  ;Modifier le volume (il est dans AL)

Fin_Ret:
        RET
RetrigNote ENDP

;Ŀ
;   Cree_variable  Fournir les pointeurs au Pascal          
;   Change:      ES,DI                                      
;

Cree_variable PROC FAR
      PUSH BP
      MOV BP,SP
      MOV AX,DS
      MOV CS:DS_TurboPascal,AX

      LES DI,DWORD PTR SS:[BP+6]

      CLD
      MOV AX,CS
      SHL EAX,16
      MOV AX,OFFSET TPTable
      STOSD
      MOV AX,OFFSET TPVariables
      STOSD
      MOV AX,OFFSET TPInfo
      STOSD
      MOV AX,OFFSET TPMusique
      STOSD

      POP BP
      RET 4
Cree_variable ENDP

INCLUDE MIXAGE.INC           ;Mixage du son...

If Mod_Master eq YES
 INCLUDE MODMUTIL.INC        ;IRQ Clavier, Calcul dure...
EndIf

CODE ENDS
END
