;            ͻ
;                       --== Mod Master v2.3 ==--           
;            ĺ
;               Auteur Freddy Vtel    
;               Avec l'aide de Fabrice Couteau  
;                                                               
;               Dernire modification 20/02/1997       
;            ͼ

PUBLIC Pause_Module
PUBLIC Calcul_duree_Module
PUBLIC Changer_Volume_Total

;Ŀ
;   Pause module (active/dsactive la pause)                
;   appele par Turbo Pascal                                
;
Pause_Module PROC FAR
        PUSH DS BP
        DS_ASM

        XOR Pause,1
        JNZ Activer_Pause

Desact_pause:
        CALL Desactiver_Pause
        JMP fin_pause

Activer_Pause:
        CMP Sortie_sonore,GUS
        JE Activer_Pause_GUS    ; GUS => Fin

        CMP Utilise_DMA,1
        JE Activer_pause_DMA    ; Sortie DMA => Pause SB

        CALL Restaurer_timer    ; Activer la pause avec le timer
        JMP fin_pause
Activer_Pause_GUS:              ; Activer la pause avec la GUS
        CALL Desactive_voies
        JMP fin_pause
Activer_pause_DMA:
        MOV Pause_IRQ,1         ; Activer la pause avec SB
        CALL Effacer_Tampons_DMA

fin_pause:
        POP BP DS
        RET
Pause_Module ENDP


;Ŀ
;   Dsactiver Pause                                        
;
Desactiver_Pause PROC NEAR
       CMP Utilise_DMA,1
       JE Desact_p_DMA

       CMP Sortie_sonore,GUS
       JNE Desact_p_timer       ; Dsactiver pause GUS
       RET

Desact_p_timer:                 ; Dsactiver Pause Timer
       CALL Init_timer
       RET

Desact_p_DMA:
       MOV Pause_IRQ,0
       CMP DMA_Continu,1
       JNE Stop_Pause_DMA       ; Relancer la sortie DMA Continue
       RET
Stop_Pause_DMA:
       CALL Programmer_DMA8

       CMP Sortie_sonore,SB
       JE Stop_pause_SB
       CALL Commande_DMA_SBpro  ; Relancer la sortie DMA SBpro
       RET
Stop_pause_SB:
       CALL Commande_DMA_SB     ; Relancer la sortie DMA SB
       RET
Desactiver_Pause ENDP


;Ŀ
;   Calcul_duree_Module                                     
;     Entre                                                
;     Sortie                                                
;     Change                                                
;

Sauvegarde_Min   DB Max_Pattern+1 DUP (0)
Sauvegarde_Sec   DB Max_Pattern+1 DUP (0)
Sauvegarde_Tempo DB Max_Pattern+1 DUP (0)
Sauvegarde_BPM   DB Max_Pattern+1 DUP (0)
Sauvegarde_GVol  DB Max_Pattern+1 DUP (0)

CT_pos_sequence DB 0

Calcul_duree_Module PROC FAR
        PUSH DS BP

        DS_TP
        MOV Duree_min,0
        MOV Duree_sec,0
        MOV Duree_50,0
        DS_ASM

        MOV Cmpt_Boucles,0
        MOV Bouclage_en_cours,0
        MOV Boucler_Pattern,0

        MOV Cmpt_Tempo,6
        MOV AL,Tempo_depart
        MOV Tempo,AL
        MOV Premier_appel,1         ; Initialisation des BPM...
        MOV AL,BPM_depart
        MOV BPM,AL
        MOV Cmpt_BPM,0
        MOV Volume_General,40h      ; 40h => Volume maximum

        MOV NotePatternSuiv,0
        MOV PJumpPattern,0
        MOV Debut_Boucle_Pattern,0 ; Pour JumpLoop
        MOV Taille_Pattern_actuel,1
        MOV Pos_note,0             ; => Chercher le 1er pattern  la 1note
        MOV Musique_Terminee,0
        MOV Pos_sequence,0
        MOV PatternBreak,0

        MOV Taille_pattern_actuel,1
        MOV pos_note,0                  ;Pos_note=Taille_pattern-1
        MOV Pos_sequence,0
        MOV CT_pos_sequence,0
boucle_temps:
        MOV Test_Jump_Loop,0            ;Eviter 2 Loop sur la mme ligne
        INC Pos_note
        CMP Boucler_Pattern,1           ;Boucler le pattern ?
        JNE CT_Pas_Modifier_Pos_note
        MOV Boucler_Pattern,0
        MOV AL,Debut_Boucle_Pattern
        MOV Pos_note,AL                 ;Initialiser au dbut de la boucle
CT_Pas_Modifier_Pos_note:
        MOV BL,Taille_pattern_actuel
        CMP pos_note,BL                 ;Pattern termin ???
        JNE CT_lire_part_p

        MOV Debut_Boucle_Pattern,0      ;Init la position du bouclage

        MOV AL,Pos_sequence
        INC Pos_sequence
        MOV AH,Sequence_Len
        CMP AL,AH
        JNE CT_Cont_part_p
        JMP Fin_CT

CT_Cont_part_p:
        ;AL, N de pattern
        CALL Nouveau_Pattern

CT_Lire_part_p:
        MOV ES,Segment_Pattern
        MOV AL,Pos_note
        XOR AH,AH
        XOR BH,BH
        MOV BL,Taille_note
        MUL BL
        MOV BL,Nb_de_voies_Patt
        MUL BX                ;Position dans la partition
                              ;=Taille_note*Nb_de_voies (6 octets par voie)
        MOV SI,AX

        MOV CL,Nb_de_voies    ;Nb_de_voies boucles
        XOR CH,CH
Boucle_calcul_duree:
        PUSH CX
        XOR AX,AX
        CMP Pattern_Vide,1
        JE  CT_Pas_Lire_Note
        MOV AL,PCommande       ;Pointeur ES:[SI+3]
        MOV AH,PParametre      ;Pointeur ES:[SI+4]
                               ;AL<-Commande
                               ;AH<-Paramtre
CT_Pas_Lire_Note:
        MOV Commande_Partition,AL
        MOV Parametre_Partition,AH

        CMP AL,SetTempo
        JNE CT_Pas_eff_F
        OR AH,AH
        JZ CT_Pas_eff_F
        MOV Tempo,AH
        MOV Cmpt_Tempo,AH
CT_Pas_eff_F:
        CMP AL,EndPattern
        JNE CT_Pas_EndPattern
        MOV BL,Taille_pattern_actuel
        DEC BL
        MOV Pos_note,BL
CT_Pas_EndPattern:
        CMP Commande_Partition,CJumpLoop
        JNE CT_Pas_JumpLoop
        CALL Exec_JumpLoop
        JMP SHORT CT_Fin_eff
CT_Pas_JumpLoop:
        CMP Commande_Partition,CSetBPM
        JNE CT_Pas_SetBPM
        CALL Exec_SetBPM
        JMP SHORT CT_Fin_eff
CT_Pas_SetBPM:
        CMP Commande_Partition,CSetGVolume
        JNE CT_Pas_SetGVolume
        MOV AL,Parametre_Partition    ; Modifier le volume general
        CMP AL,40h
        JBE CT_Pas_Ajuster_GVol       ; si >40h mettre 40h
        MOV AL,40h
CT_Pas_Ajuster_GVol:
        MOV Volume_General,AL
        JMP CT_Fin_eff
CT_Pas_SetGVolume:
        CMP Commande_Partition,CPattDelay
        JNE CT_Pas_PattDelay
        CALL Exec_PattDelay
        JMP CT_Fin_eff
CT_Pas_PattDelay:

CT_Fin_eff:
        POP CX
        ADD SI,Taille_note            ;Nouvelle voie
        DEC CX
        JNZ Boucle_calcul_duree       ;Boucler le Nb de voies...

        MOV AL,Pos_sequence           ;Sauvegarder les valeurs ???
        CMP AL,CT_pos_sequence
        JE CT_Pas_ecrire_tableau
        MOV CT_pos_sequence,AL

        PUSH BX                       ;Sauvegarde des valeurs
        XOR AH,AH
        MOV BX,AX
        DS_TP
        MOV AL,Duree_Min
        MOV CS:Sauvegarde_Min[BX],AL
        MOV AL,Duree_Sec
        MOV CS:Sauvegarde_Sec[BX],AL
        DS_ASM
        MOV AL,Tempo
        MOV Sauvegarde_Tempo[BX],AL   ;Sauvegarde le Tempo
        MOV AL,BPM
        MOV Sauvegarde_BPM[BX],AL     ;Sauvegarde les BPM
        MOV AL,Volume_General
        MOV Sauvegarde_GVol[BX],AL    ;Sauvegarde le volume general
        POP BX

CT_Pas_ecrire_tableau:
        DS_TP
        INC Duree_50
        MOV AL,Duree_50
        CMP AL,CS:Vitesse_Ticks
        JNE CT_Fin_ch
        MOV Duree_50,0
        INC Duree_sec
        CMP Duree_sec,60
        JNE CT_Fin_ch
        MOV Duree_sec,0
        INC Duree_min
CT_Fin_ch:
        DS_ASM

        XOR AH,AH             ; ******* BPM *******
        MOV AL,BPM
        ADD Cmpt_BPM,AX
        MOV AX,Cmpt_BPM

        MOV BX,BPM_Base
        DIV BL
        XOR AH,AH
                                ; AL=Cmpt_BPM DIV BPM_Div
        CMP Cmpt_Tempo,AL       ; Cmpt_tempo > Incrment tempo
        JA CTPas_Lire_Part      ; Oui => Executer les commandes
        MOV BX,BPM_Base
        MUL BL
        SUB Cmpt_BPM,AX          ; Mise  jour du compteur BPM
        JMP SHORT CTCalculer_Part; Non => Lire la partition...
CTPas_Lire_Part:                 ; Mise  jour des compteurs
        SUB Cmpt_Tempo,AL
        XOR BH,BH
        MOV BX,BPM_Base
        MUL BL
        SUB Cmpt_BPM,AX         ; Mise  jour du compteur BPM
        JMP CT_Pas_ecrire_tableau

CTCalculer_Part:
        MOV AL,Tempo
        MOV Cmpt_Tempo,AL
        JMP boucle_temps
Fin_CT:
        POP BP DS
        RET
Calcul_duree_Module ENDP


;Ŀ
;   Cherche_Chrono_Tempo                                    
;     Entre: AL=position                                   
;     Sortie: aucune                                        
;     Change: rien                                          
;
Cherche_Chrono_Tempo PROC NEAR
        PUSH AX BX
        XOR AH,AH
        MOV BX,AX
        MOV AH,Sauvegarde_Min[BX]
        MOV AL,Sauvegarde_Sec[BX]
        DS_TP
        MOV Chrono_Min,AH
        MOV Chrono_Sec,AL
        DS_ASM
        MOV AL,Sauvegarde_Tempo[BX]
        MOV Tempo,AL
        MOV AL,Sauvegarde_BPM[BX]
        MOV BPM,AL
        MOV AL,Sauvegarde_GVol[BX]
        MOV Volume_General,AL
        POP BX AX
        RET
Cherche_Chrono_Tempo ENDP


;Ŀ
;   Changer_Volume_Total                                    
;     Entre: aucune                                        
;     Sortie: aucune                                        
;     Change: rien                                          
;
Changer_Volume_Total PROC FAR
        PUSH DS BP
        DS_ASM

        CALL Changer_le_Volume

        POP BP DS
        RET
Changer_Volume_Total ENDP

