;            ͻ
;                  SBCMD.INC      
;                                                               
;                       --== Mod Master v2.1 ==--           
;            ĺ
;               Auteur Freddy Vtel    
;                                                               
;               Dernire modification 10/04/1995       
;            ͼ

;Ŀ
;                                                               
;              Routines pour la Sound Blaster                   
;                                                               
;

Init_SB PROC NEAR

        MOV DX,Port_de_base
        ADD DX,6
        MOV AL,1
        OUT DX,AL
        IN AL,DX
        IN AL,DX
        IN AL,DX
        IN AL,DX
        IN AL,DX
        IN AL,DX
        IN AL,DX
        IN AL,DX
        IN AL,DX
        IN AL,DX
        XOR AL,AL
        OUT DX,AL
        MOV AL,0D1h       ; Active le HP
        CALL Ecrire_DSP
        RET
Init_SB ENDP

Fixer_stereo PROC NEAR

        MOV AL,0Eh
        MOV DX,Port_de_base
        ADD DX,4
        OUT DX,AL          ; Slectionner le registre 0Eh
        INC DX
        IN AL,DX           ; Lecture registre 0Eh
        OR AL,2            ; Bit 1  1
        MOV AH,AL
        MOV AL,0Eh
        DEC DX
        OUT DX,AL
        INC DX
        MOV AL,AH
        OUT DX,AL          ; Sortie registre 0Eh
        RET
Fixer_stereo ENDP

Stop_stereo PROC NEAR

        MOV AL,0Eh
        MOV DX,Port_de_base
        ADD DX,4           ; MixAddrPort  (2x4h)
        OUT DX,AL
        INC DX
        IN AL,DX
        AND AL,11111101b   ; Bit 1  0
        MOV AH,AL
        MOV AL,0Eh
        DEC DX
        OUT DX,AL
        INC DX
        MOV AL,AH
        OUT DX,AL
        RET
Stop_stereo ENDP

Attendre_SB PROC NEAR

        MOV DX,Port_de_base
        ADD DX,0Ch          ;DSPWritePort
        MOV CX,400
bo_att_SB:
        IN AL,DX
        OR AL,AL
        JNS Fin_bo_att_SB
        LOOP bo_att_SB
        MOV Erreur_Modm,Err_SB  ;Erreur Sound Blaster...
        MOV Stopper_Sortie,1    ;Stopper la musique.
        CALL Init_SB
Fin_bo_att_SB:
        RET
Attendre_SB ENDP

;Ŀ
;    Ecrire_DSP    Sortie d'une commande vers le DSP            
;                                                               
;    Entre: AL Commande                                        
;

Ecrire_DSP PROC Near
        CMP Erreur_Modm,Err_SB
        JE Pas_Ecrire_DSP
        PUSH CX
        PUSH AX
        CALL Attendre_SB
        MOV DX,Port_de_base
        ADD DX,0Ah          ;DSPLifePort
        IN AL,DX
        CALL Attendre_SB
        POP AX
        OUT DX,AL
        POP CX
Pas_Ecrire_DSP:
        RET
Ecrire_DSP Endp

;Ŀ
;    Commande_DMA_SB                                            
;

; Type de commande en fonction de la carte :
;
;           Non continu    Continu
; SB 1.0       14h           1Ch
; SB 2.0       91h           90h
; SBPro        91h           90h
; SB 16

Commande_DMA_SB PROC NEAR

        CMP Type_SB,2
        JAE Commande_DMA_SBPro  ; Sound blaster 2.0 => Comme la SBpro :)
        CMP DMA_Continu,1       ; Mode Continu => SBPro
        JE Commande_DMA_SBPro   ; ( Car envoi de la taille avec 48h )

        MOV AL,40h               ;Fixer la frquence
        CALL Ecrire_DSP

        MOV AL,Frequence_DMA     ;Envoyer la frquence
        CALL Ecrire_DSP

        MOV AL,14h               ;Fixer la longueur du Tampon
        CALL Ecrire_DSP          ;(Sortie lente 14h)

        MOV AX,Taille_Tampon
        CMP Utilise_Stereo,1
        JNE Pas_Stereo_LSb
        SHL AX,1
Pas_Stereo_LSb:
        DEC AX
        MOV AX,CX
        CALL Ecrire_DSP          ;Envoyer Taille_Tampon-1

        XCHG AH,AL
        CALL Ecrire_DSP
        RET
Commande_DMA_SB ENDP

;Ŀ
;    Commande_DMA_SBpro                                         
;

Commande_DSP DB 0

Commande_DMA_SBpro PROC NEAR

        MOV CX,Taille_Tampon
        CMP Utilise_Stereo,1
        JNE Pas_Stereo_LSbPro
        SHL CX,1             ; Stereo => Taille du tampon double
Pas_Stereo_LSbPro:
        DEC CX               ; CX, Taille du tampon...

        CMP DMA_Continu,1          ; Sortie DMA Continue ???
        JNE Pas_Continu_SBPro
                                   ; DMA Continu
        MOV Commande_DSP,1Ch       ; Commande DMA SB1.0
        CMP Type_SB,1
        JE Lancer_Commande_AutoInit
        MOV Commande_DSP,90h       ; Commande DMA SB2.0 SBPro

Lancer_Commande_AutoInit:
        MOV AL,40h           ; Commande 40h => Envoyer la frquence
        CALL Ecrire_DSP      ; (SB 2.0/SB Pro)
        MOV AL,Frequence_DMA
        CALL Ecrire_DSP      ; Ecrire la frquence

        MOV AL,48h           ; Envoyer la long (Sortie rapide 48h)
        CALL Ecrire_DSP
        MOV AX,CX
        CALL Ecrire_DSP      ; Partie basse de la taille
        XCHG AH,AL
        CALL Ecrire_DSP      ; Partie haute de la taille

        MOV  AL,Commande_DSP
        CALL Ecrire_DSP            ; Lancer la commande Sortie DMA
                                   ; Auto Initialise (Sortie continue)
        JMP Fin_Commande_DMA_SBPro

Pas_Continu_SBPro:
        MOV AL,40h           ; Commande 40h => Envoyer la frquence
        CALL Ecrire_DSP      ; (SB 2.0/SB Pro)
        MOV AL,Frequence_DMA
        CALL Ecrire_DSP      ; Ecrire la frquence

        MOV AL,48h           ; Envoyer la long (Sortie rapide 48h)
        CALL Ecrire_DSP
        MOV AX,CX
        CALL Ecrire_DSP      ; Partie basse de la taille
        XCHG AH,AL
        CALL Ecrire_DSP      ; Partie haute de la taille

        MOV AL,91h                 ; Commande de dbut de sortie
        CALL Ecrire_DSP

Fin_Commande_DMA_SBPro:
        RET
Commande_DMA_SBpro ENDP

Commande_DMA_SB16 Proc Near

        MOV  AL,041h             ; Commande 41h => Envoyer la frquence
        CALL Ecrire_DSP          ; (SB 16)
        MOV  AX,Frequence_reelle
        XCHG AL,AH
        CALL Ecrire_DSP
        MOV  AL,AH
        CALL Ecrire_DSP          ; Fin, Frquence envoye.

        MOV  AL,0C6h             ; DSP C6h -Sortie 8 bit autoinit
        CALL Ecrire_DSP
        XOR AL,AL                ; Bit 4  0 => Non sign
        CMP  Utilise_Stereo,1
        JNE  @@nostereo
        MOV  AL,020h             ; 2nd command byte: bit 5 = 1 - stereo data
@@nostereo:
        CALL Ecrire_DSP          ; write 2nd command byte
        MOV  AL,CL               ; lower part of size
        CALL Ecrire_DSP
        MOV  AL,CH               ; higher part of size
        CALL Ecrire_DSP

        RET
Commande_DMA_SB16 Endp

;Ŀ
;    Relancer_DMA_SB                                            
;

Relancer_DMA_SB Proc Near

        CALL Programmer_DMA8

        CMP Sortie_sonore,SB
        JNE IRQ_SBpro           ; Sound Blaster Pro => Transfert Rapide

        MOV AL,14h
        CALL Ecrire_DSP

        MOV AX,Taille_Tampon    ; Commande 14h => Pas Stro (Taille simple)
        DEC AX
        CALL Ecrire_DSP
        XCHG AH,AL
        CALL Ecrire_DSP
        JMP Pas_Relancer_Sb_Pro
IRQ_SBpro:                      ; Relancer le transfert rapide (SBPro)
        MOV AL,91h
        CALL Ecrire_DSP
Pas_Relancer_Sb_Pro:

        RET
Relancer_DMA_SB Endp
