;Ŀ
; Module pour l'unit SOURIS: routines pour le gestionnaire d'vnements 
;
; (c) Fabrice Couteau - 01/02/1995 - Dernire modification le 08/10/1995 
;

.MODEL SMALL,PASCAL

.DATA
EXTRN valide_gest_even: BYTE    ;boolen

.CODE
addr_gest_TP DD 0       ;adresse du gestionnaire d'vnements Turbo-Pascal
actif        DB 0       ;tmoin d'activit de AppelGestEvenSouris

;INDOS_ptr    DD 0       ;pointeur sur l'indicateur INDOS


;***** donnes envoyes par le driver  la procdure AppelGestEvenSouris *****
; AX=masque d'vnements
; BX=tat des boutons
; CX=position horizontale
; DX=position verticale
; SI=longueur du dernier dplacement horizontal
; DI=longueur du dernier dplacement vertical
; DS=segment de donnes du driver

AppelGestEvenSouris PROC FAR

        PUSH AX BX CX DX SI DI DS ES BP

        CMP actif,1             ;appel dj actif?
        JE fin                  ;oui

        PUSH AX
        MOV AX,@DATA
        MOV DS,AX               ;DS de Turbo-Pascal
        POP AX
        CMP valide_gest_even,1  ;le gestionnaire est-il valid?
        JNE fin                 ;non -> ne pas l'appeler

        MOV actif,1

        PUSH AX                 ;met le masque d'vnements sur la pile
        PUSH BX                 ;met l'tat des boutons sur la pile
        PUSH CX                 ;met la position horizontale sur la pile
        PUSH DX                 ;met la position verticale sur la pile
        PUSH SI                 ;met le dplacement horizontal sur la pile
        PUSH DI                 ;met le dplacement vertical sur la pile
        CALL addr_gest_TP       ;appelle le gestionnaire d'vnements TP

        MOV actif,0
fin:
        POP BP ES DS DI SI DX CX BX AX
        RET

AppelGestEvenSouris ENDP


;PROCEDURE InstalleGestEvenSouris(evenements: Byte; addr_gest: Pointer)
; la procdure pointe par addr_gest doit tre dclare comme suit:
; PROCEDURE GestEvenSouris(evenements,boutons: Byte; posx,posy: Word; dx,dy: Integer); FAR;

PUBLIC InstalleGestEvenSouris
InstalleGestEvenSouris PROC FAR evenements: BYTE, addr_gest: DWORD

        CLI

        MOV AX,000Ch
        XOR CH,CH
        MOV CL,evenements
        PUSH CS
        POP ES
        LEA DX,AppelGestEvenSouris
        INT 33h                 ;installe le gestionnaire d'vnements

        LES DX,addr_gest
        MOV WORD PTR [addr_gest_TP],DX
        MOV WORD PTR [addr_gest_TP+2],ES  ;stocke l'adresse du gestionnaire TP

        MOV valide_gest_even,1  ;par dfaut, le gestionnaire est valid

        STI
        RET

InstalleGestEvenSouris ENDP


PUBLIC DesinstGestEvenSouris
DesinstGestEvenSouris PROC FAR
        CLI
        MOV valide_gest_even,0  ;inhibe le gestionnaire
        MOV AX,0021h
        INT 33h                 ;retire le gestionnaire
        STI    
        RET
DesinstGestEvenSouris ENDP


END
