;Ŀ
;           **** ECONOMISEUR D'ECRAN EN MODE TEXTE RESIDENT ****           
;                                                                          
;  Auteur: Fabrice COUTEAU            Dbut d'criture 10/08/1993  
;                                     Dernire modification 04/07/1998  
;ĳ
;                                                                          
; L'conomiseur est activ deux minutes (dlai rglable) aprs la dernire 
; frappe d'une touche ou aprs le dernier mouvement de la souris, ou aprs 
; le dernier accs disque/disquette, ou aprs le dernier changement de mode
; vido.                                                                   
;   -> affiche une balle qui rebondit sur les bords de l'cran, avec un    
;      effet de trane...  (mode texte couleur, page n0 seulement)       
;                                                                          
;     - premier appel : installation                                       
;     - deuxime appel: dsinstallation                                    
;

ASSUME CS:CODE

CODE SEGMENT
     ORG 100h                   ; programme COM

debut:        jmp PROG          ; point d'entre

cinq_secondes EQU 91            ; 5*18.2 (pour test)
dix_secondes  EQU 2*cinq_secondes
une_minute    EQU 6*dix_secondes
deux_minutes  EQU 2*une_minute

delai_eco     EQU deux_minutes  ; dlai d'activation

ancINT08      DD 0              ; ancienne adresse de int 08h (timer)
ancINT09      DD 0              ; ancienne adresse de int 09h (clavier)
ancINTCOMx    DD 0              ; ancienne adresse de int COM1 ou COM2 (port souris srie)
ancINT10      DD 0              ; ancienne adresse de int 10h (BIOS vido)
ancINT13      DD 0              ; ancienne adresse de int 13h (disque/disquette)
ancINT33      DD 0              ; ancienne adresse de int 33h (souris)

IRQsouris     DB 0              ; IRQ matrielle souris srie (COM1, COM2, ...)
compteur      DW delai_eco      ; compteur pour l'activation
eco_actif     DB 0              ; tmoin d'activit

taille_ecran  EQU 80*50         ; taille d'un cran texte 50 lignes (en mots)
tampon_ecran  DW taille_ecran DUP(0)

xy STRUC
 x DB 0
 y DB 0
ENDS

nombre_balles EQU 8
balle xy nombre_balles DUP(<0,0>)
couleur       DB '',15,'',15,'',7,'',7,'',8,'',8,'',8,' ',0
pas_x         DB +1
pas_y         DB +1

carteVGA      DB 0              ; tmoin de prsence d'une carte VGA

ident         DB "SW"           ; chane d'identification du programme


B EQU BYTE PTR
W EQU WORD PTR


.386

INT08 PROC FAR
        pushf
        call ancINT08

        cmp eco_actif,1         ; conomiseur actif?
        jne eco_pas_actif
        call AFFICHE_ECO
        iret
eco_pas_actif:
        dec compteur
        jnz fin_08              ; si compteur<>0, on quitte
        call INIT_ECO
fin_08:
        iret
INT08 ENDP


INT09 PROC FAR
        pushf
        call ancINT09

        mov compteur,delai_eco  ; rinitialise le compteur
        cmp eco_actif,1         ; conomiseur actif?
        jne fin_09
        call FIN_ECO
        push DX DS
        push 0040h
        pop DS
        mov DX,DS:[001Ch]
        mov DS:[001Ah],DX       ; vide buffer clavier
        pop DS DX
fin_09:
        iret
INT09 ENDP


INTCOMx PROC FAR
        mov compteur,delai_eco  ; rinitialise le compteur
        cmp eco_actif,1         ; conomiseur actif?
        jne fin_COMx
        call FIN_ECO
fin_COMx:
        jmp ancINTCOMx
INTCOMx ENDP


INT10 PROC FAR
        or  AH,AH               ; fixe mode vido?
        jnz fin_10
        mov compteur,delai_eco  ; rinitialise le compteur
        mov eco_actif,0         ; dsactive l'conomiseur
fin_10:
        jmp ancINT10
INT10 ENDP


INT13 PROC FAR
        mov compteur,delai_eco  ; rinitialise le compteur
        jmp ancINT13
INT13 ENDP


INT33 PROC FAR
        cmp IRQsouris,0
        jz  fin_33
        cmp AL,00h              ; initialise driver + test?
        je  reinit_IRQ_souris
        cmp AL,0Ch              ; installe gest. vnements?
        je  reinit_IRQ_souris
        cmp AL,14h              ; change gest. vnements?
        je  reinit_IRQ_souris
        cmp AL,17h              ; restaure tat?
        je  reinit_IRQ_souris
        cmp AL,18h              ; installe gest. v. altern?
        je  reinit_IRQ_souris
        cmp AL,1Fh              ; dsactive driver?
        je  reinit_IRQ_souris
        cmp AL,20h              ; active driver?
        je  reinit_IRQ_souris
        cmp AL,21h              ; rinit. driver?
        je  reinit_IRQ_souris
fin_33:
        jmp ancINT33

reinit_IRQ_souris:
        pushf
        call ancINT33
        push AX DX DS
        mov AX,2508h
        add AL,IRQsouris
        push CS
        pop DS
        lea DX,INTCOMx
        int 21h                 ; rinstalle l'interruption souris srie
        pop DS DX AX
        iret
INT33 ENDP


INIT_ECO PROC NEAR
        pusha
        push DS ES

        push 0040h
        pop DS
        cmp B DS:[0049h],03h    ; mode vido courant=mode texte couleur?
        jne fin_init_eco        ; non, n'active pas l'conomiseur

        mov eco_actif,1         ; conomiseur actif

        mov AX,0002h
        int 33h                 ; cache le curseur souris

        cld
        push CS
        pop ES
        xor AX,AX
        lea DI,balle
        mov CX,nombre_balles
        rep stosw               ; toutes les balles en haut  gauche

        mov pas_x,+1
        mov pas_y,+1            ; direction = en bas,  droite

        push 0B800h
        pop DS                  ; DS=B800
        xor SI,SI
        lea DI,tampon_ecran
        mov CX,taille_ecran
        rep movsw               ; sauve l'cran
        push DS
        pop ES                  ; ES=B800
        xor DI,DI
        xor AX,AX
        mov CX,taille_ecran
        rep stosw               ; efface l'cran

        cmp carteVGA,1
        jne fin_init_eco
        push 0040h
        pop DS
        mov AL,DS:[0084h]       ; lit (nombre de lignes/page)-1
        mov B CS:nombre_lignes-1,AL

fin_init_eco:
        pop ES DS
        popa
        ret
INIT_ECO ENDP


AFFICHE_ECO PROC NEAR
        pusha
        push DS ES

        push 0B800h
        pop ES                  ; ES=B800

        xor SI,SI
        mov CX,nombre_balles
affiche_balle:
        mov AH,balle[SI].y
        xor AL,AL
        mov DI,AX               ; DI=256*y
        shr AX,2
        add DI,AX               ; DI=320*y
        shr DI,1                ; DI=160*y
        xor AH,AH
        mov AL,balle[SI].x
        shl AL,1
        add DI,AX               ; DI=2*(x+80*y)
        mov AX,W couleur[SI]
        stosw
        inc SI
        inc SI
        dec CL
        jnz affiche_balle

        std
        push CS
        pop DS
        push CS
        pop ES
        mov DI,OFFSET balle+2*(nombre_balles-1)
        mov SI,OFFSET balle+2*(nombre_balles-1)-2
        mov CL,nombre_balles-1
        rep movsw               ; dcale les [x,y]  droite

        mov AL,pas_x
        add balle[0].x,AL
        mov AL,pas_y
        add balle[0].y,AL       ; dplace la premire balle

        cmp balle[0].x,0        ; bord gauche?
        jz inverse_pas_x
        cmp balle[0].x,79       ; bord droit?
        jne teste_y
inverse_pas_x:
        neg pas_x
teste_y:
        cmp balle[0].y,0        ; bord haut?
        jz inverse_pas_y
        cmp balle[0].y,25-1     ; bord bas? (valeur auto-modifie)
    nombre_lignes:
        jne fin_teste_y
inverse_pas_y:
        neg pas_y
fin_teste_y:
        pop ES DS
        popa
        ret
AFFICHE_ECO ENDP


FIN_ECO PROC NEAR
        pusha
        push DS ES

        mov eco_actif,0         ; fin d'activit de l'conomiseur

        cld
        push CS
        pop DS
        lea SI,tampon_ecran
        push 0B800h
        pop ES                  ; ES=B800
        xor DI,DI
        mov CX,taille_ecran
        rep movsw               ; restaure l'cran

        mov AX,0001h
        int 33h                 ; raffiche le curseur souris

        pop ES DS
        popa
        ret
FIN_ECO ENDP


LitINT MACRO numero
        mov AX,3500h+numero
        int 21h
ENDM

EcritINT MACRO numero,routine
        mov AX,2500h+numero
        lea DX,routine
        int 21h
ENDM

TesteINT MACRO numero
        LitINT numero
        cmp W ES:ident,"WS"
ENDM

SauveINT MACRO numero,ancINT
        LitINT numero
        mov W [ancINT],BX
        mov W [ancINT+2],ES
ENDM

RestaureINT MACRO numero,ancINT
        lds DX,ES:ancINT
        mov AX,2500h+numero
        int 21h
ENDM

EchangeINT MACRO numero,ancINT,routine
        SauveINT numero,ancINT
        EcritINT numero,routine
ENDM


PROG PROC NEAR
        TesteINT 08h
        jne installe
        TesteINT 09h
        jne installe
        TesteINT 10h
        jne installe
        TesteINT 13h
        jne installe
        TesteINT 33h
        jne installe
        jmp desinstalle         ; ES=segment du TSR !! (code+donnes)

installe:
        EchangeINT 08h,ancINT08,INT08
        EchangeINT 09h,ancINT09,INT09
        EchangeINT 10h,ancINT10,INT10
        EchangeINT 13h,ancINT13,INT13
        EchangeINT 33h,ancINT33,INT33

        mov AX,24h
        int 33h                 ; cherche le port srie souris
        mov IRQsouris,CL
        or  CL,CL
        jz  souris_PS2          ; souris PS/2 -> on n'installe pas la routine

        mov AX,3508h
        add AL,CL
        int 21h                 ; lit le vecteur de int COMx
        mov W [ancINTCOMx],BX
        mov W [ancINTCOMx+2],ES ; mmorise l'adresse

        mov AX,2508h
        add AL,CL               ; IRQ logicielle=IRQ matrielle+08h
        lea DX,INTCOMx
        int 21h                 ; installe nouvelle int COMx

souris_PS2:
        lea DX,ok_inst_msg
        mov AH,09h
        int 21h                 ; affiche le message d'installation

        mov AX,1A00h
        int 10h                 ; int. du BIOS VGA pour tester la carte
        cmp AL,1Ah
        jne pas_carte_VGA
        mov carteVGA,1

pas_carte_VGA:
        lea DX,PROG
        add DX,15               ; taille du module rsident
        shr DX,4                ; taille en paragraphes
        mov AX,3100h
        int 21h                 ; termine en laissant rsident

desinstalle:
        RestaureINT 08h,ancINT08
        RestaureINT 09h,ancINT09
        RestaureINT 10h,ancINT10
        RestaureINT 13h,ancINT13
        RestaureINT 33h,ancINT33

        mov CL,ES:IRQsouris
        or  CL,CL
        jz  souris_PS2_         ; pas de souris srie

        lds DX,ES:ancINTCOMx
        mov AX,2508h
        add AL,CL
        int 21h                 ; restaure ancienne int COMx

souris_PS2_:
        push CS
        pop DS

        push ES                 ; sauvegarde le segment TSR
        mov ES,ES:[002Ch]       ; segment de l'environnement PSP
        mov AH,49h
        int 21h                 ; libre la mmoire
        pop ES                  ; restaure le segment TSR
        jc erreur_desinstalle

        mov AH,49h
        int 21h                 ; libre la mmoire (segment TSR)
        lea DX,ok_desinst_msg   ; tout va bien
        xor AL,AL               ; code de sortie normale=0
        jnc ok

erreur_desinstalle:
        lea DX,err_desinst_msg  ; erreur  la dsallocation mmoire
        mov AL,1                ; code de sortie 1
ok:
        push AX
        mov AH,09h
        int 21h                 ; affiche un message
        pop AX
        mov AH,4Ch
        int 21h                 ; fin
PROG ENDP

CRLF EQU 13,10
nom_eco EQU "SWITCH"
ok_inst_msg     DB CRLF," ",nom_eco," v1.1 (c) 1998 Fabrice Couteau - Economiseur d'cran texte charg.","$"
ok_desinst_msg  DB CRLF,nom_eco," a t retir de la mmoire.",CRLF,"$"
err_desinst_msg DB CRLF,nom_eco," n'a pas pu tre retir de la mmoire !",7,CRLF,"$"

CODE ENDS
END debut
