ASSUME CS:CODE

CODE SEGMENT
     ORG 100h                   ; programme COM

start:
        JMP PROG                ; contourne les variables et NOUVINT08

ancint08    DD 0                ; ancienne adresse de INT 08h (timer)
ancint13    DD 0                ; ancienne adresse de INT 13h (BIOS disque)
BIOS_actif  DB 0                ; tmoin d'activit de INT 13h
INDOS_ptr   DD 0                ; pointeur sur l'indicateur INDOS
ident       DB "TS"             ; chane d'identification du programme


NOUVINT08 PROC FAR

        PUSH AX
        PUSH SI
        PUSH DS
        PUSH ES

        MOV AX,0B800h
        MOV ES,AX
        MOV AH,15
        LDS SI,INDOS_ptr
        LODSB    
        ADD AL,"0"
        MOV WORD PTR ES:[0],AX
        MOV AL,BIOS_actif
        ADD AL,"0"
        MOV WORD PTR ES:[160],AX

        POP ES
        POP DS
        POP SI
        POP AX

        JMP ancint08            ; excute l'ancien gestionnaire INT 08h

NOUVINT08 ENDP


NOUVINT13 PROC FAR

        INC BIOS_actif          ;incrmente le compteur d'accs disque
        PUSHF
        CALL ancint13           ;appelle l'ancien gestionnaire INT 13h
        DEC BIOS_actif          ;dcrmente le compteur d'accs disque
        STI                     ;autorise les interruptions
        RET 2                   ;retour  l'appelant

NOUVINT13 ENDP


PROG PROC NEAR

        MOV AX,3508h
        INT 21h                 ; lit le vecteur INT 08h
        CMP WORD PTR ES:[ident],"ST"    ; INT 08h dtourne?
        JNE installe            ; non, on installe

        MOV AX,3513h
        INT 21h                         ;lit le vecteur de INT 13h
        CMP WORD PTR ES:[ident],"ST"    ; INT 13h dtourne?
        JE desinstalle          ; oui, on dsisntalle

installe:
        PUSH CS
        POP DS

        MOV AH,34h
        INT 21h                 ; lit le pointeur sur l'indicateur INDOS
        MOV WORD PTR [INDOS_ptr],BX
        MOV WORD PTR [INDOS_ptr+2],ES    ; mmorise l'adresse

        MOV AX,3508h
        INT 21h                 ; lit le vecteur de INT 08h
        MOV WORD PTR [ancint08],BX
        MOV WORD PTR [ancint08+2],ES    ; mmorise l'adresse

        MOV AX,3513h
        INT 21h                 ; lit le vecteur de INT 13h
        MOV WORD PTR [ancint13],BX
        MOV WORD PTR [ancint13+2],ES    ; mmorise l'adresse
                             
        MOV AX,2508h
        MOV DX,OFFSET NOUVINT08
        INT 21h                 ; installe nouvelle INT 08h

        MOV AX,2513h
        MOV DX,OFFSET NOUVINT13
        INT 21h                 ; installe nouvelle INT 13h

        LEA DX,PROG
        ADD DX,15               ; taille du module rsident
        MOV CL,4
        SHR DX,CL               ; divise par 16
        MOV AX,3100h
        INT 21h                 ; termine en laissant rsident

desinstalle:
        LDS DX,ES:[ancint08]
        MOV AX,2508h
        INT 21h                 ; restaure ancienne INT 08h

        LDS DX,ES:[ancint13]
        MOV AX,2513h
        INT 21h                 ; restaure ancienne INT 13h

        PUSH ES                 ; sauvegarde le segment TSR-PSP
        MOV ES,ES:[02Ch]        ; segment de l'environnement PSP
        MOV AH,49h
        INT 21h                 ; libre la mmoire
        POP ES                  ; restaure le segment TSR-PSP
        MOV AH,49h
        INT 21h                 ; libre la mmoire

        MOV AX,4C00h
        INT 21h                 ; fin

PROG ENDP

CODE ENDS
END start

