;Ŀ
;                           **** TETRIS ****                               
;           Le plus petit "Ttris" du monde!!  (enfin, je crois)           
;                                                                          
;  Auteur: Fabrice COUTEAU            Dbut d'criture 17/04/1997  
;                                     Dernire modification 04/07/1998  
;ĳ
;  touches:      dplacement du bloc    Espace  place le bloc          
;                  rotation du bloc       Echap   quitte                 
;

.MODEL TINY

.386

B EQU BYTE  PTR
W EQU WORD  PTR
D EQU DWORD PTR

TRUE  EQU 1
FALSE EQU 0

; modes vido texte
TXT40_mono   EQU 00h
TXT40_16c    EQU 01h
TXT80_mono   EQU 02h
TXT80_16c    EQU 03h
TXT_STANDARD EQU TXT80_16c

; formes du curseur clignotant pour Curseur
PLAT  EQU 0607h ; standard
RECT  EQU 0007h ; rectangle
CARRE EQU 0105h ; carr
OFF   EQU 1000h ; invisible

; touches
ECHAP EQU 27
SPACE EQU 32
LEFT  EQU 331
RIGHT EQU 333
UP    EQU 328
DOWN  EQU 336

; sens de rotation
SANS   EQU 0
GAUCHE EQU 1
DROITE EQU 2

; dimensions de la grille
HAUTEUR_GRILLE EQU 25
LARGEUR_GRILLE EQU 10

X_GAUCHE EQU (20-(LARGEUR_GRILLE/2))

; mode d'affichage d'un bloc
AFFICHE EQU 1
EFFACE  EQU 2

; couleurs standard
BLACK        EQU  0
BLUE         EQU  1
GREEN        EQU  2
CYAN         EQU  3
RED          EQU  4
MAGENTA      EQU  5
BROWN        EQU  6
GRAY         EQU  7
LIGHTGRAY    EQU  8
LIGHTBLUE    EQU  9
LIGHTGREEN   EQU 10
LIGHTCYAN    EQU 11
LIGHTRED     EQU 12
LIGHTMAGENTA EQU 13
YELLOW       EQU 14
WHITE        EQU 15

BLINK        EQU 80h    ; clignotement

;----------------------------------------------------------
; InitMode: initialise le mode vido
; entre : -
; sortie : -
; modifie: AX,?

InitMode MACRO mode
        mov AX,mode
        int 10h
ENDM    ; InitMode

;----------------------------------------------------------
; Curseur: change la forme du curseur clignotant en mode texte
; entre : -
; sortie : -
; modifie: AH,CX,?

Curseur MACRO forme
        mov AH,01h
        mov CX,forme
        int 10h
ENDM    ; Curseur

;----------------------------------------------------------
; AttendVBL: attend le retour vertical du faisceau
; entre : -
; sortie : -
; modifie: AX,DX

AttendVBL MACRO
Local boucle,boucle2

        mov DX,3DAh
boucle:
        in  AL,DX
        and AL,00001000b
        jnz  boucle
boucle2:
        in  AL,DX
        and AL,00001000b
        jz  boucle2
ENDM    ; AttendVBL

;----------------------------------------------------------
; Randomize: initialise le gnrateur de nombres alatoires (source: Timer)
; entre : -
; sortie : -
; modifie: EAX

Randomize MACRO
        call Timer
        xor RandSeed,AX ; RandSeed = RandSeed xor Timer
ENDM    ; Randomize

;==========================================================

.CODE
        ORG 100h                ; programme COM

start:                          ; point d'entre

PROG PROC NEAR
        push CS
        pop DS

        cld

        InitMode TXT40_16c
        Curseur OFF

        call Timer
        mov temps_partie,EAX
        Randomize

        call AfficheGrille
        call InitBlocTest

PROG_boucle_principale:
        mov AX,lignes
        mov BL,15
        div BL
        cmp AL,niveau           ; lignes/15 >= niveau ?
        jnae PROG_aff_etat

        inc niveau              ; oui, incrmente le niveau
        cmp delai_chute,1
        jna PROG_test_delai_place
        dec delai_chute         ; dcrmente le dlai de chute
  PROG_test_delai_place:
        cmp delai_place,1
        jna PROG_aff_etat
        dec delai_place         ; dcrmente le dlai de mise en place

  PROG_aff_etat:
        call AfficheEtat

        call Timer
        movzx EBX,delai_chute
        add EBX,temps_chute
        cmp EAX,EBX             ; TIMER>temps_chute+delai_chute ?
        ja  PROG_fin_place      ; oui

        cmp fin_place,TRUE      ; fin mise en place ?
        jne PROG_test_deplacement;non

  PROG_fin_place:
        call Timer
        mov temps_chute,EAX     ; temps_chute=TIMER

        lea SI,bloc_test
        mov BX,+1*256+0
        mov DH,SANS
        call DeplacementPossible; le bloc peut-il descendre ?
        jnc PROG_test_fin_chute ; non

        inc bloc_test.ligne
        mov reaffiche_bloc,TRUE
        mov fin_chute,FALSE
        jmp short PROG_test_fin_place

  PROG_test_fin_chute:
        cmp fin_chute,TRUE      ; fin chute ?
        je  PROG_test_fin_place
        mov fin_chute,TRUE
        call Timer
        mov temps_place,EAX     ; temps_place=TIMER

  PROG_test_fin_place:
        cmp fin_chute,TRUE      ; fin chute ?
        jne PROG_test_deplacement;non

        call Timer
        movzx EBX,delai_place
        add EBX,temps_place
        cmp EAX,EBX             ; TIMER>temps_place+delai_place ?
        jna PROG_test_deplacement;non

        lea SI,bloc_test
        call CopieBlocDansGrille
        call SupprimeLignes
        call AfficheGrille
        call InitBlocTest

  PROG_test_deplacement:
        lea SI,bloc_test
        xor BX,BX
        mov DH,SANS
        call DeplacementPossible; le nouveau bloc est-il affichable ?
        jc  PROG_test_reaffiche ; oui, on continue
        mov fin_jeu,TRUE        ; non, la partie est termine

  PROG_test_reaffiche:
        cmp reaffiche_bloc,TRUE ; reaffiche bloc ?
        jne PROG_test_touche    ; non

        mov reaffiche_bloc,FALSE
        AttendVBL
        lea SI,anc_bloc
        mov AL,EFFACE
        call AfficheBloc        ; efface l'ancien bloc
        lea SI,bloc_test
        mov AL,AFFICHE
        call AfficheBloc        ; affiche le nouveau bloc

        push CS
        pop ES
        lea DI,anc_bloc
        mov CX,Size bloc
        rep movsb               ; anc_bloc <- bloc_test

  PROG_test_touche:
        call KeyPressed
        jnc PROG_test_fin_boucle
        call ReadKey

        cmp AX,ECHAP
        je  PROG_quitte         ; ECHAP: arrt du programme

        lea SI,bloc_test        ; prpare tests de dplacement gauche/droite
        xor BH,BH
        mov DH,SANS

  PROG_test_left:
        mov BL,-1               ; prpare tests dplacement  gauche/droite

        cmp AX,LEFT             ; LEFT: test dplacement du bloc  gauche
        je  PROG_left_right

  PROG_test_right:
        neg BL                  ; BL=+1

        cmp AX,RIGHT            ; RIGHT: test dplacement du bloc  droite
        jne PROG_test_up

    PROG_left_right:
        call DeplacementPossible
        jnc PROG_test_fin_boucle; dplacement pas possible

        add bloc_test.colonne,BL; incrmente/dcrmente la colonne du bloc
        mov reaffiche_bloc,TRUE
        jmp short PROG_test_fin_boucle

  PROG_test_up:
        xor BX,BX               ; prpare tests rotation  gauche/droite
        mov temp,GAUCHE

        cmp AX,UP               ; UP: test rotation du bloc  gauche
        je  PROG_up_down

  PROG_test_down:
        inc temp                ; temp=DROITE

        cmp AX,DOWN             ; DOWN: test rotation du bloc  droite
        jne PROG_test_space

    PROG_up_down:
        mov DH,temp
        call DeplacementPossible
        jnc PROG_test_fin_boucle; rotation pas possible

        mov AL,EFFACE
        call AfficheBloc        ; efface le bloc
        mov DH,temp
        call RotationBloc       ; rotation du bloc  gauche/droite
        mov reaffiche_bloc,TRUE
        jmp short PROG_test_fin_boucle

  PROG_test_space:
        cmp AX,SPACE            ; SPACE: fait tomber le bloc
        jne PROG_test_fin_boucle

        mov BX,+1*256+0
        mov DH,SANS
        call DeplacementPossible; le bloc peut-il encore descendre ?
        jnc PROG_vide_clavier   ; non

  PROG_vide_clavier:
        call KeyPressed         ; touche appuye ?
        jnc  PROG_fin_chute
        call ReadKey            ; oui, on la lit
        jmp short PROG_vide_clavier

  PROG_fin_chute:
        mov fin_chute,TRUE
        mov fin_place,TRUE

  PROG_test_fin_boucle:
        cmp fin_jeu,TRUE
        je  PROG_fin_jeu
        jmp PROG_boucle_principale

PROG_fin_jeu:
        mov AX,(X_GAUCHE+(LARGEUR_GRILLE/2)-3) + 256*(25-(HAUTEUR_GRILLE/2))
        call GotoXY

        mov AH,16*BLACK+WHITE+BLINK
        lea SI,txt_fin
        call WriteStr           ; affiche "FIN !"

PROG_attend_echap:
        call ReadKey
        cmp AX,ECHAP
        jne PROG_attend_echap   ; ECHAP pour terminer

PROG_quitte:
        InitMode TXT_STANDARD

        mov AX,4C00h
        int 21h                 ; fin

PROG ENDP

;----------------------------------------------------------
; Timer: renvoie la valeur du compteur horaire (horloge systme 18.2 Hz)
; entre : -
; sortie : EAX=valeur
; modifie: -

Timer PROC NEAR
        push DS
        push 0040h
        pop DS
        mov EAX,DS:[006Ch]
        pop DS
        ret
Timer ENDP

;----------------------------------------------------------
; KeyPressed: renvoie TRUE si une touche a t appuye
; entre : -
; sortie : flag Carry=1 si une touche a t appuye
; modifie: AH,?

KeyPressed PROC NEAR
        mov AH,01h
        int 16h
        stc
        jnz KP_fin
        clc
KP_fin:
        ret
KeyPressed ENDP

;----------------------------------------------------------
; ReadKey: attend et lit une touche au clavier
; entre : -
; sortie : AX=code ASCII ou code tendu (>256)
; modifie: ?

ReadKey PROC NEAR
        mov AH,00h
        int 16h
        or  AL,AL
        jz  RK_code_etendu
        xor AH,AH
        jmp short RK_fin
RK_code_etendu:
        mov AL,AH
        mov AH,1
RK_fin:
        ret
ReadKey ENDP

;----------------------------------------------------------
; GotoXY: dplace le pointeur vido texte dans la page n0
; entres: AL=x
;          AH=y
; sortie : ES:DI = B800:2*((x-1)+40*(y-1))
; modifie: AX

GotoXY PROC NEAR
        dec AL
        mov DI,AX
        and DI,00FFh            ; DI=x-1

        mov AL,40
        dec AH
        mul AH                  ; AX=40*(y-1)

        add DI,AX
        shl DI,1

        push 0B800h
        pop ES

        ret
GotoXY ENDP

;----------------------------------------------------------
; WriteStr: affiche une chane de caractres ASCIIZ
; entres: DS:SI -> chane
;          ES:DI -> vido
;          AH=attribut couleur
; sortie : -
; modifie: AX, SI, DI (=position du dernier caractre affich)

WriteStr PROC NEAR

WS_affiche:
        lodsb
        or  AL,AL
        jz  WS_fin
        stosw
        jmp short WS_affiche

WS_fin:
        ret
WriteStr ENDP

;----------------------------------------------------------
; Random: gnre un nombre alatoire 16 bits (source: RandSeed)
; entre : AX=modulo
; sortie : AX=nombre (valeur min=0, valeur max=modulo-1)
; modifie: DX

Random PROC NEAR
        push AX
        mov AX,RandMult
        mul RandSeed
        mov RandSeed,AX ; RandSeed = RandMult*RandSeed
        pop DX

R_ajuste:
        cmp AX,DX
        jb  R_fin
        sub AX,DX
        jmp short R_ajuste
R_fin:
        ret
Random ENDP

;----------------------------------------------------------

; BinAsc: convertit une valeur binaire 16 bits en ASCII et l'affiche
; entres: AX=valeur  convertir
;          CH=nombre de chiffres
;          BH=attribut couleur
;          ES:DI -> mmoire vido texte (justification  droite)
; sortie : -
; modifie: AX

BinAsc PROC NEAR
        pusha

        mov SI,10
BA_divise:
        xor DX,DX
        div SI
        mov BL,DL
        add BL,'0'
        mov W ES:[DI],BX
        dec DI
        dec DI
        dec CH
        or  AX,AX
        jnz BA_divise

        mov BL,' '
BA_espaces:
        cmp CH,0
        jle BA_fin
        mov W ES:[DI],BX
        dec DI
        dec DI
        dec CH
        jmp short BA_espaces

BA_fin:
        popa
        ret
BinAsc ENDP

;----------------------------------------------------------
; RotationBloc: effectue une rotation de bloc
; entres: DS:SI -> bloc
;          DH=sens de rotation (SANS, GAUCHE, DROITE)
; sortie : -
; modifie: -

RotationBloc PROC NEAR
        cmp DH,GAUCHE
        je  RB_gauche
        cmp DH,DROITE
        je  RB_droite
        ret

RB_gauche:
        rol [SI].position,1     ; rotation du masque de position  gauche
        ret

RB_droite:
        ror [SI].position,1     ; rotation du masque de position  droite

RB_fin:
        ret
RotationBloc ENDP

;----------------------------------------------------------
; DeplacementPossible: renvoie TRUE si le dplacement du bloc est possible dans la direction donne
; entres: DS:SI -> bloc
;          BH=dplacement en lignes (sign)
;          BL=dplacement en colonnes (sign)
;          DH=sens de rotation (SANS, GAUCHE, DROITE)
; sortie : flag Carry=1 si le dplacement est possible
; modifie: AX, CX, DX, DI, ES (=CS)

DeplacementPossible PROC NEAR
        push SI

        push CS
        pop ES
        lea DI,bloc_temp        ; ES:DI -> bloc_temp

        push SI
        mov CX,Size bloc
        rep movsb               ; bloc_temp <- bloc
        pop SI

        lea DI,matrice_temp     ; ES:DI -> matrice_temp
        mov bloc_temp.matrice,DI; bloc_temp.matrice = matrice_temp

        mov AL,[SI].taille
        mul AL
        mov CX,AX               ; CX=bloc.taille
        mov SI,[SI].matrice
        rep movsb               ; matrice_temp <- bloc.matrice

        lea SI,bloc_temp
        call RotationBloc       ; rotation du bloc temporaire

        mov DH,[SI].position    ; DH=masque de position
        mov SI,bloc_temp.matrice
        mov DL,bloc_temp.taille

        xor CH,CH               ; compteur lignes (lig)
  DP_boucle_lig:
          xor CL,CL             ; compteur colonnes (col)

    DP_boucle_col:
            test B [SI],DH      ; y a-t-il un carr? (bit=1)
            jz  DP_fin_col      ; non

            mov AH,CH
            add AH,bloc_temp.ligne
            add AH,BH           ; AH=lig+bloc_temp.ligne+delta_lig
            js  DP_non          ; si <0 , dplacement impossible
            cmp AH,HAUTEUR_GRILLE
            jae DP_non          ; si >=HAUTEUR_GRILLE, dplacement impossible

            mov AL,CL
            add AL,bloc_temp.colonne
            add AL,BL           ; AL=col+bloc_temp.colonne+delta_col
            js  DP_non          ; si <0 , dplacement impossible
            cmp AL,LARGEUR_GRILLE
            jae DP_non          ; si >=LARGEUR_GRILLE, dplacement impossible

            mov DI,AX
            and DI,00FFh        ; DI=AL

            mov AL,LARGEUR_GRILLE
            mul AH
            add DI,AX
            ; DI=(lig+bloc_temp.ligne+delta_lig)*LARGEUR_GRILLE + (col+bloc_temp.colonne+delta_col)

            cmp grille[DI],BLACK
            jne DP_non          ; si grille[][] <> BLACK, dplacement impossible

      DP_fin_col:
          inc SI                ; avance dans bloc_temp.matrice

          inc CL
          cmp CL,DL
          jb  DP_boucle_col

        inc CH
        cmp CH,DL
        jb  DP_boucle_lig

DP_oui: stc
        jmp short DP_fin

DP_non: clc

DP_fin:
        pop SI
        ret
DeplacementPossible ENDP

;----------------------------------------------------------
; CopieBlocDansGrille: copie un bloc dans la grille
; entre : DS:SI -> bloc
; sortie : -
; modifie: AX, BX, CX, DX, DI

CopieBlocDansGrille PROC NEAR
        mov DH,[SI].position    ; DH=masque de position
        mov BX,[SI].matrice     ; DS:BX -> bloc.matrice
        mov DL,[SI].taille

        xor CH,CH               ; compteur lignes (lig)
CB_boucle_lig:
          xor CL,CL             ; compteur colonnes (col)

  CB_boucle_col:
            test B [BX],DH      ; y a-t-il un carr? (bit=1)
            jz  CB_fin_col      ; non

            mov AH,[SI].ligne
            add AH,CH
            mov AL,LARGEUR_GRILLE
            mul AH              ; AX=(bloc.ligne+lig)*LARGEUR_GRILLE
            mov DI,AX

            xor AH,AH
            mov AL,[SI].colonne
            add AL,CL
            add DI,AX           ; DI=(bloc.ligne+lig)*LARGEUR_GRILLE + (bloc.colonne+col)

            mov AL,[SI].couleur
            mov grille[DI],AL   ; grille[][]=bloc.couleur

  CB_fin_col:
          inc BX                ; avance dans bloc.matrice

          inc CL
          cmp CL,DL
          jb  CB_boucle_col

        inc CH
        cmp CH,DL
        jb  CB_boucle_lig

        ret
CopieBlocDansGrille ENDP

;----------------------------------------------------------
; SupprimeLignes: supprime les lignes pleines dans la grille et met  jour le score
; entres: -
; sortie : -
; modifie: AX, BX, CX, DX, SI, DI

SupprimeLignes PROC NEAR
        mov DX,lignes

        xor CH,CH               ; compteur lignes (lig)
SL_boucle_lig:
          mov CL,LARGEUR_GRILLE

          mov AL,LARGEUR_GRILLE
          mul CH
          mov SI,AX             ; SI=LARGEUR_GRILLE*lig

  SL_boucle_col:
          cmp grille[SI],BLACK
          je  SL_fin_lig        ; si grille[lig][col]=BLACK, on ignore cette ligne
          inc SI
          dec CL
          jnz SL_boucle_col

          inc lignes            ; nouvelle ligne pleine

          push CX

  SL_boucle_lig_sup:
            mov CL,LARGEUR_GRILLE

            mov AL,LARGEUR_GRILLE
            mul CH
            mov DI,AX           ; DI=LARGEUR_GRILLE*lig

    SL_boucle_col_sup:
              mov AL,grille[DI-LARGEUR_GRILLE]
              mov grille[DI],AL ; grille[lig_sup][col]=grille[lig_sup-1][col]
              inc DI
              dec CL
              jnz SL_boucle_col_sup

          dec CH
          jnz SL_boucle_lig_sup

          push CS
          pop ES
          lea DI,grille
          mov CL,LARGEUR_GRILLE
          xor AL,AL
          rep stosb             ; grille[0][]=0...0

          pop CX

SL_fin_lig:
        inc CH
        cmp CH,HAUTEUR_GRILLE
        jb  SL_boucle_lig

        mov BX,lignes
        sub BX,DX               ; BX=lignes-anc_lignes

        xor AH,AH
        mov AL,niveau
        shl AX,4
        mul BX                  ; AX=bonus=(lignes-anc_lignes)*16*niveau

        cmp BL,4
        jne SL_maj_score
        shl AX,1                ; si 4 lignes pleines (tetris), bonus double
SL_maj_score:
        add score,AX            ; score=score+bonus

        ret
SupprimeLignes ENDP

;----------------------------------------------------------
; AfficheBloc: affiche un bloc  l'cran
; entres: DS:SI -> bloc
;          AL=mode d'affichage (AFFICHE ou EFFACE)
; sortie : -
; modifie: AX, BX, CX, DX, DI

AfficheBloc PROC NEAR
        mov AH,''
        cmp AL,AFFICHE
        je  AB_affiche
        mov AH,' '
AB_affiche:
        mov AL,AH

        mov DH,[SI].position    ; DH=masque de position
        mov DL,[SI].taille      ; DL=bloc.taille
        mov BX,[SI].matrice     ; BX=bloc.matrice
        mov AH,[SI].couleur     ; AH=bloc.couleur

        xor CH,CH               ; compteur lignes (lig)
AB_boucle_lig:

          xor CL,CL             ; compteur colonnes (col)
  AB_boucle_col:
          test B [BX],DH        ; faut-il afficher un carr? (bit=1)
          jz  AB_fin_col        ; non

          push AX
          mov AL,X_GAUCHE
          add AL,CL
          add AL,[SI].colonne   ; x=X_GAUCHE+col+bloc.colonne

          mov AH,CH
          add AH,[SI].ligne
          inc AH                ; y=1+lig+bloc.ligne

          call GotoXY
          pop AX

          stosw                 ; affiche ' ' ou ''

  AB_fin_col:
          inc BX                ; avance dans bloc.matrice

          inc CL
          cmp CL,DL
          jb  AB_boucle_col

        inc CH
        cmp CH,DL
        jb  AB_boucle_lig

        ret
AfficheBloc ENDP

;----------------------------------------------------------
; AfficheGrille: affiche la grille  l'cran
; entre : -
; sortie : -
; modifie: AX, BX, CX, DI, ES

AfficheGrille PROC NEAR
        xor BX,BX               ; index grille

        mov CH,HAUTEUR_GRILLE
AG_boucle_lig:
          mov AX,(X_GAUCHE-1) + 256*(25+1)
          sub AH,CH
          call GotoXY

          mov AX,256*WHITE+''
          stosw
          push AX

          mov CL,LARGEUR_GRILLE
  AG_boucle_col:
          mov AL,''
          mov AH,grille[BX]     ; couleur=grille[lig][col]
          stosw

          inc BX                ; avance dans grille

          dec CL
          jnz AG_boucle_col

          pop AX
          stosw

        dec CH
        jnz AG_boucle_lig

        ret
AfficheGrille ENDP

;----------------------------------------------------------
; InitBlocTest: initialise un nouveau bloc alatoirement
; entre : DS=CS
; sortie : -
; modifie: EAX, BX, CX, SI, DI, ES

InitBlocTest PROC NEAR
        mov AX,N_BLOCS
        call Random
        mov BL,AL
        mov AL,Size bloc
        mul BL
        lea SI,blocs
        add SI,AX               ; DS:SI -> blocs[random(N_BLOCS)]

        push CS
        pop ES
        lea DI,bloc_test        ; ES:DI -> bloc_test

        mov CX,Size bloc
        push DS ES DI CX
        rep movsb               ; bloc_test <- blocs[]

        mov bloc_test.ligne,0   ; bloc_test.ligne=0
        mov AL,LARGEUR_GRILLE
        sub AL,bloc_test.taille
        shr AL,1
        mov bloc_test.colonne,AL; bloc_test.colonne=(LARGEUR_GRILLE-bloc_test.taille)/2

        pop CX SI DS ES         ; DS:SI -> bloc_test
        lea DI,anc_bloc         ; ES:DI -> anc_bloc
        rep movsb               ; anc_bloc <- bloc_test

        call Timer
        mov temps_chute,EAX
        mov fin_chute,FALSE
        mov fin_place,FALSE
        mov reaffiche_bloc,TRUE

        ret
InitBlocTest ENDP

;----------------------------------------------------------
; AfficheEtat: affiche l'tat de la partie (temps, niveau, lignes, score)
; entre : -
; sortie : -
; modifie: EAX, EBX, EDX, SI, DI, ES

AfficheEtat PROC NEAR
        mov AX,(X_GAUCHE-8) + 256*2
        call GotoXY

        call Timer
        sub EAX,temps_partie
        mov EBX,EAX
        shl EAX,2
        add EAX,EBX             ; EAX=(TIMER-temps_partie)*5
        mov EDX,EAX
        shr EDX,16              ; (DX,AX)=(TIMER-temps_partie)*5
        mov BX,91
        div BX                  ; AX=(TIMER-temps_partie)/(91/5)=(...)/18.2
        mov BL,60
        div BL                  ; AL=minutes, AH=secondes

        mov BH,16*BLACK+WHITE
        mov CH,2

        push AX
        xor AH,AH
        call BinAsc             ; affiche minutes
        add DI,2*3
        pop AX
        shr AX,8
        call BinAsc             ; affiche secondes
        mov B ES:[DI-2*2],':'

        mov AX,2+256*4
        call GotoXY             ; (2,4)

        lea SI,txt_niveau
        mov AH,BH
        call WriteStr           ; affiche "Niveau"
        add DI,2*4
        xor AH,AH
        mov AL,niveau
        call BinAsc             ; affiche niveau

        mov AX,2+256*6
        call GotoXY             ; (2,6)

        mov AH,BH
        call WriteStr           ; affiche "Lignes"
        add DI,2*4
        mov AX,lignes
        call BinAsc             ; affiche lignes

        mov AX,2+256*8
        call GotoXY             ; (2,8)

        mov AH,BH
        call WriteStr           ; affiche "Score"
        add DI,2*4
        mov AX,score
        call BinAsc             ; affiche score

        ret
AfficheEtat ENDP

;----------------------------------------------------------

; structure d'un bloc
bloc STRUC
        position DB ?           ; masque de position
        taille   DB ?           ; taille de la matrice carre (largeur)
        matrice  DW ?           ; offset de la matrice
        couleur  DB ?           ; couleur
        ligne    DB ?           ; ligne courante
        colonne  DB ?           ; colonne courante
bloc ENDS


; dfinition des matrices-blocs (sens de rotation anti-horaire)
; codage des bits: 76543210
;                         1re position (min): 0=rien 1=carr
;                       ...
;                       4me position (max): 0=rien 1=carr

; ¿
;  : 2 positions
bloc_long DB 0,2,0,0
          DB 0,2,0,0
          DB 1,3,1,1
          DB 0,2,0,0
;  ¿
;   : 2 positions
; 
bloc_S1 DB 2,0,0
        DB 2,3,1
        DB 1,3,0
; ¿
; ſ  : 2 positions
;  
bloc_S2 DB 0,2,0
        DB 3,3,0
        DB 2,1,1
;  ڿ
; ſ  : 4 positions
; 
bloc_T DB 0,11, 0
       DB 7,15,13
       DB 0,14, 0
;   ڿ
; Ŵ  : 4 positions
; 
bloc_L1 DB 2,10,1
        DB 5,15,5
        DB 4,10,8
; ڿ
; ¿  : 4 positions
; 
bloc_L2 DB 1,10,8
        DB 5,15,5
        DB 2,10,4
; ¿
; Ŵ   : 1 position
; 
bloc_carre DB 1,1
           DB 1,1


; masques de position
masque1 EQU 11111111b
masque2 EQU 01010101b
masque4 EQU 00010001b

; dfinition des blocs
N_BLOCS EQU 7
blocs bloc <masque2,4,bloc_long ,LIGHTRED    ,0,0>
      bloc <masque2,3,bloc_S1   ,LIGHTGREEN  ,0,0>
      bloc <masque2,3,bloc_S2   ,LIGHTBLUE   ,0,0>
      bloc <masque4,3,bloc_T    ,GRAY        ,0,0>
      bloc <masque4,3,bloc_L1   ,LIGHTMAGENTA,0,0>
      bloc <masque4,3,bloc_L2   ,YELLOW      ,0,0>
      bloc <masque1,2,bloc_carre,LIGHTCYAN   ,0,0>

bloc_test bloc <>
anc_bloc  bloc <>

grille DB HAUTEUR_GRILLE*LARGEUR_GRILLE DUP(0)

matrice_temp   DB 4*4 DUP(0)
bloc_temp bloc <>
temp DB 0

temps_chute  DD 0
temps_place  DD 0
temps_partie DD 0

reaffiche_bloc DB FALSE
fin_chute      DB FALSE
fin_place      DB FALSE
fin_jeu        DB FALSE

lignes DW 0
score  DW 0
niveau DB 1

delai_chute DB 6        ; 1/3 seconde
delai_place DB 4        ; 1/4 seconde

RandSeed DW 12345       ; base du gnrateur de nombres alatoires
RandMult EQU 1997       ; multiplicateur du gnrateur de nombres alatoires

txt_niveau DB "Niveau",0
txt_lignes DB "Lignes",0
txt_score  DB "Score ",0
txt_fin    DB " FIN ! ",0

END start
