;*****************************************************************************
;*****************************************************************************
;*                                                                           *
;* Sujet : Mise en veille automatique de l'cran au bout d'un temps donn    *
;* Rq : le temps d'attente avant le mise en veille est dfini dans compt     *
;*                                                                           *
;* ITs dtournes : IT 08, IT 09 et IT souris (COM1 ou COM2)                 *
;*                                                                           *
;* Dvelopp le 08/06/1995  22 h et des poussires...                       *
;* Dernire mise  jour : 09/11/95  12:20                                   *
;*                                                                           *
;*****************************************************************************
;*****************************************************************************

.MODEL SMALL
.CODE
        ORG 100h
Debut:
        JMP INSTAL

CSR       EQU 3DAh                      ; registre d'tat couleur EGA/VGA
MSR       EQU 3BAh                      ; registre d'tat monochrome EGA/VGA
ACR       EQU 3C0h                      ; registe contrleur d'attribut
Dix_sec   EQU 182
Une_min   EQU 1092
Duree     EQU Dix_sec                   ; dure avant mise en veille
                                        ; valeur par dfaut = 2 min

ancint08  DD 0                          ; zone sauvegarde vecteur ancien 08h
ancint09  DD 0                          ; id. pour gestionnaire 09h
ancintMS  DD 0                          ; id. pour IT souris (OBh ou OCh...)

compt     DW Duree                      ; compteur de temps activation veille
veille    DB 0                          ; indicateur de veille
MouseIRQ  DB 0                          ; n IRQ de la souris


INTMS PROC FAR
        PUSHF
        MOV WORD PTR compt,Duree        ; IT souris => il a eu un evenement
        CMP veille,1                    ; tait-on en veille ?
        JNZ Suite_INTMS
        XOR veille,1
        PUSH AX DX
        CLI                             ; DO NOT DISTURB !
        MOV DX,CSR
        IN AL,DX
        MOV DX,MSR
        IN AL,DX                        ; reset des registres d'tat
        MOV DX,ACR
        MOV AL,20h
        OUT DX,AL                       ; debout l-dedans !!!
        POP DX AX
Suite_INTMS:
        POPF
        JMP ancintMS                    ; Hello, l'ancien !
INTMS ENDP

INT08 PROC FAR
        PUSH AX DX
        PUSHF
        CALL ancint08
        CMP veille,1                    ; est-on dj en veille ?
        JZ Fin_08                       ; oui, on ne fait rien
        DEC compt                       ; on se rapproche de la mise en veille
        JNZ Fin_08                      ; c'est pas pour cette fois !
        XOR veille,1                    ; on commute en veille
        CLI                             ; foutez-moi la paix !
        MOV DX,CSR
        IN AL,DX                        ; reset du registre d'tat couleur
        MOV DX,MSR
        IN AL,DX                        ; reset du registre d'tat monochrome
        MOV DX,ACR                      ; a se prcise...
        XOR AL,AL
        OUT DX,AL                       ; bonne nuit les petits...
Fin_08:
        POP DX AX
        IRET                            ; salut !!!

PREUVE  DB "MR"

INT08 ENDP


INT09 PROC FAR
        PUSHF                           ; pour le JMP CS:[ancint09]
        MOV compt,Duree                 ; on rinitialise le compteur
        CMP veille,1                    ; est-on en veille ?
        JZ Reveil_09
        POPF                            ; Flags modifis par le CMP ci-dessus
        JMP ancint09                    ; salut l'ancien !
Reveil_09:
        PUSH AX DX
        XOR veille,1                    ; on commute en mode "non veille"
        CLI
        MOV DX,CSR
        IN AL,DX
        MOV DX,MSR
        IN AL,DX                        ; reset des registres d'tat
        MOV DX,ACR
        MOV AL,20h
        OUT DX,AL                       ; debout l-dedans !!!
        IN AL,60h                       ; clavier qu'as-tu  me dire ?
        MOV AL,20h
        OUT 20h,AL                      ; oui, oui, je sais qu'y a une IT !
        POP DX AX
        POPF
        IRET                            ; allez... Au revoir !
INT09 ENDP


;****************************************
;*            INSTALLATION              *
;****************************************

INSTAL PROC NEAR
        PUSH CS
        POP DS
        XOR AX,AX                       ; t'es vraiment nul AX !
        INT 33h                         ; y'en a t-il un driver souris ?
        OR AX,AX
        JZ Suite_Instal                 ; non, alors passons a la suite !
        MOV AX,0024h
        INT 33h                         ; oui, quelle est l'IRQ utilise ?
        OR CL,CL
        JZ Suite_Instal                 ; CL = 0 => souris PS/2
        MOV MouseIRQ,CL
        XOR CH,CH
        MOV AX,3508h
        ADD AX,CX                       ; AX = 35xx, xx = n vecteur IT souris
        INT 21h
        MOV WORD PTR [ancintMS],BX
        MOV WORD PTR [ancintMS+2],ES
Suite_Instal:
        MOV AX,3508h
        INT 21h
        MOV WORD PTR [ancint08],BX
        MOV WORD PTR [ancint08+2],ES
        MOV AX,3509h
        INT 21h
        MOV WORD PTR [ancint09],BX
        MOV WORD PTR [ancint09+2],ES
        CMP WORD PTR ES:[PREUVE],"RM"   ; dj install
        JZ DESINST                      ; oui alors on reinstalle l'ancien
        MOV AX,2508h                    ; il est temps de dtourner!
        MOV DX,OFFSET INT08
        INT 21h                         ; et voil!
        MOV AX,2509h
        MOV DX,OFFSET INT09         ; id. pour IT clavelard
        INT 21h
        MOV AH,25h
        MOV AL,MouseIRQ
        ADD AL,08h
        MOV DX,OFFSET INTMS         ; id. pour IT souris
        INT 21h
        MOV AH,09h
        MOV DX,OFFSET TEXTINST          ; message installation
        INT 21h
        LEA DX,INSTAL
        ADD DX,15
        MOV CL,4
        SHR DX,CL
        MOV AX,3100h
        INT 21h                         ;TSR
INSTAL ENDP

DESINST PROC NEAR
        PUSH DS
        LDS DX,ES:[ancint08]            ; ES contient le seg. du TSR
        MOV AX,2508h
        INT 21h                         ; on restaure le vieux!
        LDS DX,ES:[ancint09]
        MOV AX,2509h
        INT 21h
        LDS DX,ES:[ancintMS]
        XOR AX,AX
        MOV AL,CS:[MouseIRQ]
        ADD AX,2508h
        INT 21h
        POP DS
        PUSH ES
        MOV ES,ES:[02Ch]
        MOV AH,49h
        INT 21h
        POP ES
        MOV AH,49h
        INT 21h
        MOV AH,09h
        LEA DX,TEXTDESINST
        INT 21h
        MOV AX,4C00h
        INT 21h
DESINST ENDP

TEXTINST        DB "La mise en veille est maintenant rsidente...",13,10
                DB "Au bout de 2 minutes d'inactivit l'cran se met en veille.",13,10
                DB "Appuyez alors sur n'importe quelle touche pour le ractiver.",13,10
                DB "Relancez le COM pour retirer le rsident de la mmoire.",13,10
                DB "(c) Romaric MAILLARD - 1995 -",13,10,"$"
TEXTDESINST     DB "La mise en veille a t retire de la mmoire...",13,10,"$"

END Debut                  
