;Ŀ
;                    **** RETARDATEUR DE LANCEMENT ****                    
;                                                                          
;  Auteur: Fabrice COUTEAU            Dbut d'criture 19/10/1996  
;                                     Dernire modification 14/06/1998  
;ĳ
; - appel : WAIT <dure_en_secondes>                                       
;           0  dure_en_secondes  255                                    
; - codes de retour:  0 = fin normale (dure coule)                      
;                     1 = interruption par appui sur une touche <> ECHAP   
;                     2 = annulation par appui sur la touche ECHAP         
;                    32 = erreur (caractre invalide en paramtre)         
; - exemple d'utilisation dans un fichier Batch:                           
;           wait 5                                                         
;           if errorlevel 1 goto suite                                     
;           win                                                            
;           :suite                                                         
;           ...                                                            
;

.MODEL TINY

.CODE
        ORG 100h                ; programme COM

W EQU WORD PTR

; codes de retour
code_fin_normale  EQU 0
code_interruption EQU 1
code_annulation   EQU 2
code_erreur_param EQU 32

; macros -------------------------------------------------------------

; VideTamponClavier: vide le tampon clavier (BIOS)
; entre : -
; sortie : -
; modifie: BX,ES
VideTamponClavier MACRO
        cli
        mov BX,0040h
        mov ES,BX
        mov BL,ES:[001Ch]
        mov ES:[001Ah],BL
        sti                     ; vide le tampon clavier
ENDM

; ActiveHP: active le haut-parleur interne
; entre : -
; sortie : -
; modifie: AL
ActiveHP MACRO
        in  AL,61h
        or  AL,00000011b
        out 61h,AL              ; active le haut-parleur
ENDM

; DesactiveHP: dsactive le haut-parleur interne
; entre : -
; sortie : -
; modifie: AL
DesactiveHP MACRO
        in  AL,61h
        and AL,11111100b
        out 61h,AL              ; dsactive le haut-parleur
ENDM

; NoteHP: joue une note sur le haut-parleur interne
; entre : -
; sortie : -
; modifie: AL
NoteHP MACRO valeur
        mov AX,valeur           ; AX = (1193180/frquence)
        out 42h,AL              ; poids faible
        mov AL,AH
        out 42h,AL              ; poids fort
ENDM

;---------------------------------------------------------------------

start:                          ; point d'entre

PROG PROC NEAR

        push CS
        pop DS

        xor AH,AH               ; dure par dfaut (en secondes)
        mov SI,80h
        mov BL,[SI]             ; lit la longueur des paramtres de la ligne de commande
        or  BL,BL
        jz  pas_parametre       ; pas de paramtre
        dec BL
        inc SI                  ; premier caractre  l'offset 80h+2

analyse_parametre:
        inc SI
        mov AL,[SI]             ; lit un caractre dans la ligne de commande
        sub AL,'0'              ; convertit caractre en dcimal
        js  erreur_param
        cmp AL,9
        ja  erreur_param
        aad
        mov AH,AL               ; AH = 10*AH + chiffre (dure en secondes)
        dec BL
        jnz analyse_parametre

pas_parametre:
        mov AL,18
        mul AH                  ; AX = dure en 1/18me de seconde
        mov BX,0040h
        mov ES,BX
        mov BX,ES:[006Ch]       ; lit le timer en 0040:006C
        push BX
        add BX,AX
        mov timer_fin,BX        ; timer_fin = valeur  atteindre
        pop AX
        jmp short seconde

attend:
        mov AX,ES:[006Ch]       ; lit le timer
        cmp AX,timer_fin        ; dlai coul?
        jae delai_ecoule        ; oui

        cmp AX,timer_1sec       ; une seconde coule?
        jb  teste_bip           ; non

     seconde:
        add AX,18
        mov timer_1sec,AX       ; timer_1sec = timer + (1 seconde)
        sub ax,18-1
        mov timer_bip,AX        ; timer_bip = timer + (1 tick)

        NoteHP 1355             ; rgle la frquence du "bip"
        ActiveHP                ; met un "bip"

     teste_bip:
        cmp AX,timer_bip        ; un tick coul?
        jb  teste_touche        ; non

        DesactiveHP             ; arrte le "bip"

     teste_touche:
        mov AH,01h
        int 16h                 ; touche appuye?
        jz  attend              ; non

        cmp AL,27               ; appui sur ECHAP?
        jne interruption        ; non

        mov AL,code_annulation
        jmp short fin

interruption:
        mov AL,code_interruption
        jmp short fin

delai_ecoule:
        mov AL,code_fin_normale
        jmp short fin

erreur_param:
        lea DX,msg_erreur_param
        mov AH,09h
        int 21h                 ; affiche un message
        mov AL,code_erreur_param

fin:
        push AX
        VideTamponClavier
        DesactiveHP
        pop AX

        mov AH,4Ch
        int 21h                 ; fin, code de sortie = AL

PROG ENDP

; donnes ------------------------------------------------------------

CRLF EQU 13,10
msg_erreur_param DB "syntaxe: WAIT <dure_en_secondes>",CRLF,'$'

timer_fin        DW 0           ; valeur du timer  atteindre
timer_1sec       DW 0           ; valeur du timer + (1 seconde)
timer_bip        DW 0           ; valeur du timer + (1 tick)

END start
