PROGRAM AnaFich;
{Analyseur de fichiers (rpartition frquentielle des caractres)}

{$A+,G+,Q-,R-,S-}

USES Fichiers,Util,Texte,Clavier;

CONST MODE_DEC=1;
      MODE_HEX=2;

      mode: byte=MODE_HEX;

VAR Frequence: array[byte] of record car: char; freq: word; end;


procedure Affiche(mode: byte);
var i: byte;
begin
 for i:=0 to 255 do with Frequence[i] do begin
  AdrTexte :=PtrVRAM(0,1+13*(i div 50),1+(i mod 50));
  AttrTexte:=16*0+7;
  case mode of
   MODE_DEC: AffCh(EntierTexte2(BYTE(car),3));
   MODE_HEX: AffCh(' '+EntierHexa(BYTE(car),2));
  end;
  AttrTexte:=16*0+11;
  AffCh(' '+car+' ');
  if Frequence[i].freq<>0 then AttrTexte:=16*0+15 else AttrTexte:=16*0+8;
  AffCh(EntierTexte2(freq,6));
  AttrTexte:=16*0+3;
  AffCar('');
 end;
end; {Affiche}


procedure QuickSort(debut,fin: byte);
var i,j: word;
    aux: word;
begin
 i:=debut; j:=fin; aux:=Frequence[(debut+fin) div 2].freq;
 repeat
  while Frequence[i].freq>aux do inc(i);
  while aux>Frequence[j].freq do dec(j);
  if i<=j then begin
   SwapVar(Frequence[i],Frequence[j],sizeof(Frequence[0]));
   inc(i); if j>0 then dec(j);
  end;
 until i>j;
 if debut<j then QuickSort(debut,j);
 if i<fin   then QuickSort(i,fin);
end; {QuickSort}


CONST un_kilo=1024;
      long_tampon=8*un_kilo;

VAR f: Fichier;
    nombre_lignes: byte;
    longueur: longint;
    tampon: array[1..8*un_kilo] of byte;
    nbr_tampons,i,j,long_reste: word;

BEGIN
 if ParamCount<>1 then WriteLn('Analyseur de fichiers - Usage: ANAFICH nom_fichier')
 else with f do begin
  Ouvre(lecture,ParamStr(1));
  case f_erreur of
   f_ok: begin
          for i:=0 to 255 do with Frequence[i] do begin
           car:=CHAR(i);
           freq:=0;
          end;

          longueur:=Taille;
          nbr_tampons:=1+((longueur-1) div long_tampon);
          for i:=1 to nbr_tampons-1 do begin
           Lit(tampon,long_tampon);
           for j:=1 to long_tampon do inc(Frequence[tampon[j]].freq);
          end;
          long_reste:=1+((longueur-1) mod long_tampon);
          Lit(tampon,long_reste);
          for j:=1 to long_reste do inc(Frequence[tampon[j]].freq);
          Ferme;

          nombre_lignes:=NombreLignes+1;
          InitTexte(50);

          repeat
           Affiche(mode);
           AffChXY(0,67,20,'Espace: mode',16*0+14);
           AffChXY(0,67,22,'   : tri' ,16*0+14);
           AffChXY(0,67,24,'Echap : fin' ,16*0+14);

           case ReadKey of
            Space: case mode of
                    MODE_DEC: mode:=MODE_HEX;
                    MODE_HEX: mode:=MODE_DEC;
                   end;

            Enter: QuickSort(0,255);

            Esc: break;
           end;
          until FALSE;

          InitTexte(nombre_lignes);
         end;
   f_err_fich_intr: WriteLn('Fichier introuvable');
   f_err_ch_intr  : WriteLn('Chemin introuvable');
   f_err_pas_pret : WriteLn('Lecteur pas prt');
   f_err_CRC..f_err_secteur: WriteLn('Erreur de lecture');
  end;
 end;
END.