PROGRAM BIN_C; {convertit des fichiers binaires en donnes C}
{$A+,G+,Q-,R-,S-}

USES Crt,Dos,Util,Fichiers;

TYPE t_type_conv=(Uchar_,char_,Uint_,int_);

CONST CRLF: array[1..2] of char=#13#10; {retour chariot}

      type_conv_txt: array[t_type_conv] of string[13]=
                      ('unsigned char','char','unsigned int','int');

VAR parametre: String80;
    nom_fichier: array[1..512] of String12;
    nbr_fichiers: word;

    type_conv: t_type_conv;
    echange: boolean;
    type_aff: (Decimal,Hexa);
    nbr_elem_par_lig,nbr_car_par_elem: byte;

{==========================================================}

procedure Aide;
begin
 WriteLn(CRLF,'syntaxe: BIN_C nom_fichier [options]',CRLF,
              'options: B,C,W,I   convertit en Uchar (byte), char, Uint (word) ou int',CRLF,
              '               E   change poids faible <-> poids fort (avec W ou I)',CRLF,
              '             D,H   affiche en Dcimal ou Hexa',CRLF,
              '             <n>   n lments par ligne (1..32)',CRLF,
              '(par dfaut: B H 20)');
end; {Aide}

{----------------------------------------------------------}

procedure Convertit;

const un_kilo=1024;
      long_tampon=8*un_kilo;

      tab='          ';

type tranche=array[1..long_tampon] of byte;

var tampon: ^tranche;
    longueur: LongInt;
    repert: String80;
    pos_point,nbr_elem: byte;
    elem_ch: String12;
    elem,index: word;
    fBIN,fC: Fichier;
    n_fich,nbr_fichiers_traites,
    i,j,nbr_tampons,long_reste: word;
    ligneC: string[128];


function Nbr: word;
begin
 if i<nbr_tampons then Nbr:=long_tampon else Nbr:=long_reste;
end; {Nbr}

procedure Affiche(chaine: String80);
begin
 GotoXY(35,WhereY); ClrEol;
 GotoXY(35,WhereY); Write(chaine);
end; {Affiche}

procedure EcritLigne;
begin
 with fC do begin Ecrit(ligneC[1],Length(ligneC)); Ecrit(CRLF,2) end;
end; {EcritLigne}


begin  {Convertit}
 repert:=RepertoireSeul(parametre);
 nbr_fichiers_traites:=0;
 for n_fich:=1 to nbr_fichiers do begin
  Write(CRLF,nom_fichier[n_fich]); GotoXY(15,WhereY);
  fBIN.Ouvre(lecture,repert+nom_fichier[n_fich]);
  case f_erreur of
   f_ok: begin
          longueur:=fBIN.Taille;
          if longueur<=32*un_kilo then begin
           pos_point:=Pos('.',nom_fichier[n_fich]);
           if pos_point>0 then
            nom_fichier[n_fich][0]:=Chr(pos_point-1); {efface extension}
           nom_fichier[n_fich]:=nom_fichier[n_fich]+'.C'; {ajoute C}
           Write('->  ',nom_fichier[n_fich]);
           fC.Cree(not(teste_existe),repert+nom_fichier[n_fich]);
           case f_erreur of
            f_ok: begin
                   New(tampon);
                   nbr_tampons:=1+((longueur-1) div long_tampon);
                   long_reste:=1+((longueur-1) mod long_tampon);
                   i:=longueur;  {nombre d'lments du tableau}
                   if (type_conv in [Uint_,int_]) then i:=i div 2;
                   ligneC:='const '+type_conv_txt[type_conv]+' '+
                           CopyL(nom_fichier[n_fich],Length(nom_fichier[n_fich])-2)+
                           '['+EntierTexte2(i,2)+'] = {';
                   EcritLigne;
                   ligneC:=tab;
                   nbr_elem:=0;
                   elem:=0; index:=0;
                   for i:=1 to nbr_tampons do begin
                    fBIN.Lit(tampon^,Nbr);
                    for j:=1 to Nbr do begin
                     if (type_conv in [Uchar_,char_]) then elem:=tampon^[j]
                     else begin elem:=(elem*256)+tampon^[j]; inc(index) end; {poids fort & faible inverss}
                     if (index=0) or  {conversion en byte ou shortint}
                        ((index and $01)=0) then begin  {conversion en Uint ou int aprs 2 lectures}
                      if (type_conv in [Uint_,int_]) and not(echange) then elem:=Swap(elem);
                      case type_aff of
                       Decimal: case type_conv of
                                 Uchar_,Uint_: elem_ch:=EntierTexte2(elem,nbr_car_par_elem);
                                 char_: elem_ch:=EntierTexte2(SHORTINT(elem),nbr_car_par_elem);
                                 int_: elem_ch:=EntierTexte2(INTEGER(elem),nbr_car_par_elem);
                                end;
                       Hexa: elem_ch:='0x'+EntierHexa(elem,nbr_car_par_elem);
                      end;
                      elem_ch:=elem_ch+','; elem:=0;
                      if (Length(ligneC)+Length(elem_ch)<=122) and (nbr_elem<nbr_elem_par_lig) then
                       begin ligneC:=ligneC+elem_ch; inc(nbr_elem) end
                      else begin
                       EcritLigne; ligneC:=tab+elem_ch;
                       if nbr_elem=nbr_elem_par_lig then nbr_elem:=1;
                      end;
                     end;
                    end;
                   end;
                   dec(ligneC[0]); {efface ','}
                   ligneC:=ligneC+'};';
                   EcritLigne;
                   fC.Ferme;
                   if (index and $01)=0 then Affiche('ok')
                                        else Affiche('longueur impaire, dernier octet ignor');
                   inc(nbr_fichiers_traites);
                   Dispose(tampon);
                  end;
            f_err_acces_ref: Affiche('Accs au fichier refus');
            f_err_protect  : begin Affiche('Disquette protge en criture'); break end;
            f_err_pas_pret : begin Affiche('Lecteur pas prt'); break end;
            f_err_CRC..f_err_secteur: Affiche('Erreur d''criture');
           end;
          end
          else Affiche('Fichier trop important (32ko max)');
          fBIN.Ferme;
         end;
   f_err_fich_intr: Write('Fichier introuvable');
   f_err_ch_intr  : begin Write('Chemin introuvable'); break end;
   f_err_acces_ref: Write('Accs au fichier refus');
   f_err_pas_pret : begin Write('Lecteur pas prt'); break end;
   f_err_CRC..f_err_secteur: Write('Erreur de lecture');
  end;
 end;
 Write(CRLF,CRLF,nbr_fichiers_traites,' fichier');
 if nbr_fichiers_traites>1 then Write('s');
 Write(' converti');
 if nbr_fichiers_traites>1 then Write('s');
 if nbr_fichiers>1 then Write(' sur ',nbr_fichiers);
 WriteLn;
end; {Convertit}

{----------------------------------------------------------}

procedure ChercheFichiers;
var fichier: SearchRec;
begin
 nbr_fichiers:=0;
 FindFirst(parametre,Archive,fichier);
 case DosError of
  0 : repeat
       inc(nbr_fichiers);
       nom_fichier[nbr_fichiers]:=fichier.Name;
       FindNext(fichier)
      until DosError=18;
  2,18: WriteLn(CRLF,'Fichier introuvable');
  3   : WriteLn(CRLF,'Chemin introuvable');
  8   : WriteLn(CRLF,'Mmoire insuffisante');
  100 : WriteLn(CRLF,'Erreur de lecture');
  152 : WriteLn(CRLF,'Lecteur pas prt');
 end;
end; {ChercheFichiers}

{----------------------------------------------------------}

function SyntaxeOk: boolean;
var p,i: byte;
    ch: String12;
    erreur: word;
begin
 SyntaxeOk:=FALSE;
 p:=ParamCount;
 if (p=0) or (p>5) then exit;

 parametre:=ParamStr(1);
 if (parametre[1] in ['/','-']) or (parametre='?') then exit;

 SyntaxeOk:=TRUE;
 type_conv:=Uchar_;
 echange:=FALSE;
 type_aff:=Hexa;
 nbr_elem_par_lig:=20;

 for i:=2 to p do begin
  ch:=Maj(ParamStr(i));
  case ch[1] of
   'B': type_conv:=Uchar_;
   'C': type_conv:=char_;
   'W': type_conv:=Uint_;
   'I': type_conv:=int_;
   'E': echange:=TRUE;
   'D': type_aff:=Decimal;
   'H': type_aff:=Hexa;
   '0'..'9': begin
              Val(ch,nbr_elem_par_lig,erreur);
              SyntaxeOk:=(erreur=0) and (nbr_elem_par_lig in [1..32]);
             end
   else begin SyntaxeOk:=FALSE; break end;
  end;
 end;

 if type_aff=Hexa then
  case type_conv of
   char_: type_conv:=Uchar_;
   int_ : type_conv:=Uint_;
  end;

 case type_conv of
  Uchar_: case type_aff of
           Decimal: nbr_car_par_elem:=3;
           Hexa   : nbr_car_par_elem:=2;
          end;
  char_: nbr_car_par_elem:=4;
  Uint_: case type_aff of
          Decimal: nbr_car_par_elem:=5;
          Hexa   : nbr_car_par_elem:=4;
         end;
  int_: nbr_car_par_elem:=6;
 end;
end; {SyntaxeOk}

{==========================================================}

BEGIN
 WriteLn(CRLF,'BIN_C v1.1  -  (c) 1998 Fabrice Couteau',CRLF,
         'Convertisseur de fichiers binaires en donnes C (32ko max)');
 if SyntaxeOk then begin
  ChercheFichiers;
  if nbr_fichiers>0 then Convertit;
 end
 else Aide;
END.
