USES Crt;

CONST {familles pour Processeur}
      _8086  =1;
      _286   =2;
      _386   =3;
      _486   =4;
      Pentium=5;
      Futur  =6;

const CPUType: array[_8086..Futur] of string[7]
               =('8086','286','386','486','Pentium','Future');

      speed_486DX33=46880;

VAR CPU: byte;
    speed_test: longint;


function Processeur: byte; assembler;
{renvoie le type de processeur identifi (8086,286,386,486,Pentium ou futur)}
asm
 mov DL,_8086
 push SP
 pop AX
 cmp SP,AX
 jne @fin       {8086}

 mov DL,_286
 pushf
 pop AX
 or AX,0100000000000000b
 push AX
 popf
 pushf
 pop AX
 test AX,0100000000000000b
 jz @fin        {286}

 mov DL,_386
 mov BX,SP
 and SP,1111111111111100b  { vite une erreur d'alignement }
 DB 66h; pushf             { PUSHFD }
 DB 66h; pop AX            { pop EAX }
 DB 66h; mov CX,AX         { mov ECX,EAX }
 DB 66h,35h; DD 00040000h  { xor EAX,00040000h : inverse bit Alignment Check }
 DB 66h; push AX           { push EAX }
 DB 66h; popf              { POPFD }
 DB 66h; pushf             { PUSHFD }
 DB 66h; pop AX            { pop EAX }
 DB 66h; xor AX,CX         { xor EAX,ECX : teste bit AC }
 jz @fin        {386}

 mov DL,_486
 and SP,1111111111111100b  { vite une erreur d'alignement }
 DB 66h; push CX           { push ECX }
 DB 66h; popf              { POPFD }
 mov SP,BX
 DB 66h; mov AX,CX         { mov EAX,ECX }
 DB 66h,35h; DD 00200000h  { xor EAX,00200000h : inverse bit CPUID }
 DB 66h; push AX           { push EAX }
 DB 66h; popf              { POPFD }
 DB 66h; pushf             { PUSHFD }
 DB 66h; pop AX            { pop EAX }
 DB 66h; xor AX,CX         { xor EAX,ECX : teste bit CPUID }
 jz @fin        {486}

 DB 66h; xor AX,AX         { xor EAX,EAX }
 DB 0Fh,0A2h               { CPUID, AX=0 (CPUID caps) }
 DB 66h; cmp AX,1          { cmp EAX,1 }
 jl @fin
 DB 66h; xor AX,AX         { xor EAX,EAX }
 DB 66h; inc AX
 DB 0Fh,0A2h               { CPUID, AX=1 (CPU info) }
 and AH,00001111b          { masque n de famille }
 mov DL,AH      {Pentium (P5) ou suprieur (P6)...}

@fin:
 mov AL,DL
end; {Processeur}

{----------------------------------------------------------}

function Coprocesseur: boolean; assembler;
{renvoie TRUE si le PC dispose d'un coprocesseur mathmatique}
var cw: word;
asm
 mov AL,FALSE
 DB 0DBh,0E3h         {FINIT : initialise le coprocesseur}
 mov BYTE ptr cw+1,0  {Hi-byte Control-word = 0}
 DB 36h,0D9h,7Eh,0FEh {FSTCW cw : sauvegarde Status Control word}
 cmp BYTE ptr cw+1,3  {Hi-byte Control-word = 3? (ready)}
 jne @fin             {non -> pas de coprocesseur}
 mov AL,TRUE
@fin:
end; {Coprocesseur}

{----------------------------------------------------------}

function IndicePerformance: longint; assembler;
{renvoie un entier proportionnel  la vitesse du processeur}
asm
 mov DX,40h
 mov ES,DX

 mov CL,ES:[6Ch]
 inc CL
@synchronise:
 mov CH,ES:[6Ch]
 inc CH
 cmp CH,CL
 je @synchronise

 mov CL,CH
 xor DX,DX
 xor AX,AX
 mov BX,1234h
@calcule:
 push AX
 push DX
 mov DX,BX
 mov AX,BX
 imul BX
 pop DX
 pop AX
 add AX,1
 adc DX,0
 mov CH,ES:[6Ch]
 inc CH
 cmp CH,CL
 je @calcule
end; {IndicePerformance}


BEGIN
 Writeln;
 CPU:=Processeur;
 if CPU in [_8086..Futur] then Write(CPUType[CPU]) else Write('unknown');
 Write(' CPU');
 if Coprocesseur then Write(' with math-coprocessor');
 Writeln(' detected.');

 repeat
  Writeln('<Espace> Performance test         <Esc> exit');
  case Readkey of
   ' ': begin
         speed_test:=IndicePerformance;
         Writeln('Speed test=',speed_test:6,
                 ', ',speed_test/speed_486DX33:5:2,
                 ' (',100*(speed_test/speed_486DX33-1):5:2,'%) faster than 486DX-33.');
        end;
   #27: break;
  end;
 until FALSE;

END.
