PROGRAM Degroupf; {Dgroupeur de fichiers}
{$A+,G+,Q-,R-,S-}

USES Crt,Fichiers,Util;

{=========================================================}

CONST max_fich=512;
      taille_max=12345678; {valeur arbitraire pour la taille max d'un fichier group}

      cum_ofs: longint=0;
      nbr_err: word=0;
      nbr_fich_crees: word=0;

      mode_creation: boolean=teste_existe;
      ecrase_tout: boolean=FALSE;

      taille_tampon=16*1024;

TYPE T_entete=record
               Nom: String12;
               offset, longueur: longint;
              end;

VAR f_grp,f: Fichier;
    repert: String80;

    nbr_fich,i: word;
    taille_fichier,taille_a_lire,taille_lue: longint;
    j: byte;

    Liste: array[1..max_fich] of T_entete;

    tampon: array[0..taille_tampon-1] of byte;

    touche: char;

LABEL creation;

BEGIN
 Writeln('DEGROUPF v1.0 - (c) 1998 Fabrice Couteau. Dgroupeur de fichiers.');
 if ParamCount=0 then begin Writeln('usage: DEGROUPF <nom_fichier>'); halt end;

 f_grp.Ouvre(lecture,ParamStr(1));
 if f_erreur<>f_ok then begin Writeln('Impossible de lire le fichier ',Maj(ParamStr(1))); halt end;

 taille_fichier:=f_grp.Taille;

 f_grp.Lit(nbr_fich,sizeof(nbr_fich));

 if f_grp.Taille<sizeof(nbr_fich)+nbr_fich*sizeof(T_entete) then
  nbr_fich:=1+((f_grp.Taille-sizeof(nbr_fich)) div sizeof(T_entete));

 Writeln(Maj(NomFichierSeul(ParamStr(1))),': ',nbr_fich,' fichiers');
 if nbr_fich>max_fich then begin
  Writeln('Nombre de fichiers suprieur  ',max_fich,' -> limitation');
  nbr_fich:=max_fich;
 end;

 f_grp.Lit(Liste,nbr_fich*sizeof(T_entete));
 if f_erreur<>f_ok then begin
  f_grp.Ferme;
  Writeln('Erreur de format dans la liste d''enttes');
  halt;
 end;

 {contrle la validit des offsets/longueurs}
 for i:=1 to nbr_fich do begin
  if i=1 then cum_ofs:=Liste[1].offset else inc(cum_ofs,Liste[i-1].longueur);
  with Liste[i] do
   if (cum_ofs<>offset) or (offset<=0) or (longueur>taille_fichier) then inc(nbr_err);
 end;

 if nbr_err<>0 then begin
  Writeln(nbr_err,' erreur(s) dans la liste d''enttes');
  if nbr_err>=nbr_fich-1 then Writeln('Le fichier ',Maj(ParamStr(1)),' n''est pas un fichier group');
  f_grp.Ferme;
  halt;
 end;

 repert:=RepertoireSeul(ParamStr(1));
 Write('Cration des fichiers dans ');
 if repert<>'' then Write(Maj(repert)) else Write('le rpertoire courant');
 Writeln;

 for i:=1 to nbr_fich do with Liste[i] do begin
  Write(i:3,'  ',XString(Nom,' ',12),'  ');

  if not(ecrase_tout) then mode_creation:=teste_existe;

 creation:
  f.Cree(mode_creation,repert+Nom);
  if f_erreur<>f_ok then
   if f_erreur=f_err_existe then begin
    GotoXY(20,WhereY);
    Write('fichier existe dj, craser (Oui/Non/Tout)?');
    repeat
     touche:=UpCase(ReadKey);
    until touche in ['O','N','T',#27];
    GotoXY(20,WhereY); ClrEol;
    case touche of
     'O': mode_creation:=ecrase;
     'N': begin Writeln('ignor'); continue end;
     'T': begin mode_creation:=ecrase; ecrase_tout:=TRUE end;
     #27: begin
           Writeln('abandon.');
           f_grp.Ferme;
           halt;
          end;
    end;
    goto creation; {dsol!...}
   end
   else begin
    Writeln('erreur en cration de fichier: ',f_erreur);
    continue;
   end;

  taille_a_lire:=taille_tampon;
  taille_lue:=0;
  repeat
   GotoXY(20,WhereY); Write(Round(100*taille_lue/taille_fichier):3,'%');

   if taille_lue+taille_a_lire>longueur then taille_a_lire:=longueur-taille_lue;
   f_grp.Lit(tampon,taille_a_lire);
   inc(taille_lue,taille_a_lire);

   f.Ecrit(tampon,taille_a_lire);
  until taille_lue>=longueur;

  f.Ferme;

  GotoXY(20,WhereY); ClrEol;
  GotoXY(20,WhereY); Writeln('Ok');

  inc(nbr_fich_crees);
 end;

 Writeln('---  ------------');
 Writeln(nbr_fich_crees:3,' fichier(s) cr(s) sur ',nbr_fich);
 Writeln;

 f_grp.Ferme;
END.