PROGRAM Demineur; {comme sous Windows, mais sans Windows ;-) }
{$A+,G+,Q-,R-,S-}

{$UNDEF Musique}

{$IFDEF Musique}
USES Crt,Graph256,Souris,SourisG,Util,Var_Mus,SBUnit,ModmDemo,ChS3M,BMP256;
{$M 16384,0,130000}
{***$M 16384,0,56000}
{$ELSE}
USES Crt,Graph256,Souris,SourisG,Util,BMP256;
{$ENDIF}

CONST largeur_max=28; hauteur_max=22;

      largeur: byte=25; hauteur: byte=16;
      nombre_mines_total: byte=60;

      DebutJeu       =1;
      FinJeu         =2;
      Attente        =3;
      AttenteLongue  =4;
      TesteCase      =5;
      DecouvreTerrain=6;
      MarqueCase     =7;
      PartieGagnee   =8;
      PartiePerdue   =9;

      sens_palette: shortint=+1;

      image_fond: boolean=TRUE;
      bruits    : boolean=TRUE;
      quitte    : boolean=FALSE;


TYPE T_Case=record
             Decouverte: boolean;
             Minee: boolean;
             Marquee: boolean;
             NombreMinesAutour: byte;
            end;


VAR Case_: array[1..hauteur_max,1..largeur_max] of T_Case;
    gagne,perdu,recommence,affiche_case: boolean;

    lig,col,bt,y: byte;
    i,x: word;

    erreur: word;

    timer_actif: boolean;
    timer_debut,timer_attente,timer_attente_longue: longint;
    ancINT1C: pointer;

    image: BMP;
    p: Palette256;

    parametre: string[80];


procedure InitGrille;
const case_vide: T_Case=(Decouverte: FALSE;
                         Minee: FALSE;
                         Marquee: FALSE;
                         NombreMinesAutour: 0);
var lig,col: byte;
    nombre_mines: byte;
begin
 for lig:=1 to hauteur do
  for col:=1 to largeur do Case_[lig,col]:=case_vide;

 Randomize;
 nombre_mines:=0;
 repeat
  lig:=1+Random(hauteur); col:=1+Random(largeur);
  with Case_[lig,col] do
   if not(Minee) then begin Minee:=TRUE; inc(nombre_mines) end;
 until nombre_mines=nombre_mines_total;

 for lig:=1 to hauteur do
  for col:=1 to largeur do begin
   nombre_mines:=0;
   if (lig>1)       and (col>1)       then inc(nombre_mines,BYTE(Case_[lig-1,col-1].Minee));
   if (lig>1)                         then inc(nombre_mines,BYTE(Case_[lig-1,col  ].Minee));
   if (lig>1)       and (col<largeur) then inc(nombre_mines,BYTE(Case_[lig-1,col+1].Minee));
   if                   (col>1)       then inc(nombre_mines,BYTE(Case_[lig  ,col-1].Minee));
   if                   (col<largeur) then inc(nombre_mines,BYTE(Case_[lig  ,col+1].Minee));
   if (lig<hauteur) and (col>1)       then inc(nombre_mines,BYTE(Case_[lig+1,col-1].Minee));
   if (lig<hauteur)                   then inc(nombre_mines,BYTE(Case_[lig+1,col  ].Minee));
   if (lig<hauteur) and (col<largeur) then inc(nombre_mines,BYTE(Case_[lig+1,col+1].Minee));
   Case_[lig,col].NombreMinesAutour:=nombre_mines;
  end;
end; {InitGrille}


procedure AfficheCase(lig,col: byte);
const couleur_nombre: array[1..8] of byte=(0,1,10,12,14,11,15,13);

const mine: array[1..7,1..8] of byte=(
             (3,3,8,8,8,3,4,0),
             (3,8,0,0,0,0,3,3),
             (8,0,7,0,0,0,8,3),
             (8,0,0,0,0,0,8,3),
             (8,0,0,0,0,0,8,3),
             (3,8,0,0,0,8,3,3),
             (3,3,8,8,8,3,3,3)
            );

const drapeau: array[1..7,1..5] of byte=(
                (7,4,4,0,7),
                (4,4,4,0,7),
                (7,4,4,0,7),
                (7,7,7,0,7),
                (7,7,7,0,7),
                (7,7,7,0,7),
                (7,7,0,0,0)
               );

var couleur_fond: byte;
begin
 with Case_[lig,col] do begin
  if Decouverte then couleur_fond:=3 else couleur_fond:=7;
  if not(image_fond) then
   EffaceZoneCadreOmbre($A000,9*(col-1),9*(lig-1),9*(col-1)+8,9*(lig-1)+8,couleur_fond,Decouverte)
  else
   if Decouverte then image.AfficheLimite($A000,0,0,FALSE,9*(col-1),9*(lig-1),9*(col-1)+8,9*(lig-1)+8)
                 else EffaceZoneCadreOmbre($A000,9*(col-1),9*(lig-1),9*(col-1)+8,9*(lig-1)+8,couleur_fond,FALSE);
  if Decouverte then begin
   if Minee then TransfereZone($A000,mine,te,9*(col-1)+1,9*(lig-1)+1,9*(col-1)+8,9*(lig-1)+7)
    else if NombreMinesAutour>0 then
          AffCar5x6($A000,9*(col-1)+2,9*(lig-1)+2,
                          Chr(48+NombreMinesAutour),couleur_nombre[NombreMinesAutour],FALSE,0);
  end
  else
   if Marquee then TransfereZone($A000,drapeau,te,9*(col-1)+2,9*(lig-1)+1,9*(col-1)+6,9*(lig-1)+7);
 end;
end; {AfficheCase}


procedure AfficheGrille;
var lig,col: byte;
begin
 CacheCursSouris;
 for lig:=1 to hauteur do
  for col:=1 to largeur do AfficheCase(lig,col);
 AffCursSouris;
end; {AfficheGrille}


function NombreCasesMarquees: byte;
var nombre,lig,col: byte;
begin
 nombre:=0;
 for lig:=1 to hauteur do
  for col:=1 to largeur do with Case_[lig,col] do
   inc(nombre,BYTE(Marquee));
 NombreCasesMarquees:=nombre;
end; {NombreCasesMarquees}


function NombreCasesMarqueesMinees: byte;
var nombre,lig,col: byte;
begin
 nombre:=0;
 for lig:=1 to hauteur do
  for col:=1 to largeur do with Case_[lig,col] do
   inc(nombre,BYTE(Marquee and Minee));
 NombreCasesMarqueesMinees:=nombre;
end; {NombreCasesMarqueesMinees}


procedure AfficheNombreMines;
begin
 AffCh5x6($A000,9*largeur+10+4,0+3,EntierTexte(NombreCasesMarquees,3)+
                               '/'+EntierTexte(nombre_mines_total,3),7,TRUE,0);
end; {AfficheNombreMines}


procedure DecouvreTerrainNonMine(lig,col,nombre_mines_autour: byte);
begin
 with Case_[lig,col] do
  if not(Decouverte) and not(Minee) and (nombre_mines_autour=0) then begin
   Decouverte:=TRUE; Marquee:=FALSE;
   if (lig>1)       and (col>1)       then DecouvreTerrainNonMine(lig-1,col-1,NombreMinesAutour);
   if (lig>1)                         then DecouvreTerrainNonMine(lig-1,col  ,NombreMinesAutour);
   if (lig>1)       and (col<largeur) then DecouvreTerrainNonMine(lig-1,col+1,NombreMinesAutour);
   if                   (col>1)       then DecouvreTerrainNonMine(lig  ,col-1,NombreMinesAutour);
   if                   (col<largeur) then DecouvreTerrainNonMine(lig  ,col+1,NombreMinesAutour);
   if (lig<hauteur) and (col>1)       then DecouvreTerrainNonMine(lig+1,col-1,NombreMinesAutour);
   if (lig<hauteur)                   then DecouvreTerrainNonMine(lig+1,col  ,NombreMinesAutour);
   if (lig<hauteur) and (col<largeur) then DecouvreTerrainNonMine(lig+1,col+1,NombreMinesAutour);
  end;
end; {DecouvreTerrainNonMine}


{$IFDEF Musique}
procedure Bruit(action: byte);

const nombre_SMP_max_par_action=13;

      Liste_SMP: array[DebutJeu..PartiePerdue] of
                  record
                   nombre_SMP: byte;
                   SMP: array[1..nombre_SMP_max_par_action] of byte;
                  end
                =((nombre_SMP: 1; SMP:( 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)),
                  (nombre_SMP: 1; SMP:(20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)),
                  (nombre_SMP: 2; SMP:( 8, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)),
                  (nombre_SMP: 1; SMP:(37, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)),
                  (nombre_SMP:10; SMP:(12,19,22,23,28,34,36,40,43,53, 0, 0, 0)),
                  (nombre_SMP:10; SMP:(11,14,30,38,39,41,42,45,48,49, 0, 0, 0)),
                  (nombre_SMP: 9; SMP:(13,18,24,29,31,32,35,44,54, 0, 0, 0, 0)),
                  (nombre_SMP: 7; SMP:( 1, 2, 6,26,50,51,52, 0, 0, 0, 0, 0, 0)),
                  (nombre_SMP:13; SMP:( 3, 4, 5,10,15,16,17,21,25,27,33,46,47)));

procedure Saute(sequence: byte);
begin
 with Info^ do begin Pos_Sequence:=sequence; Pos_Note:=0; Modifier_Pattern:=TRUE end;
end;

begin
 if bruits then begin
  case action of
   DebutJeu,FinJeu: Saute(1+Liste_SMP[action].SMP[1]);
   Attente: with Liste_SMP[Attente] do Saute(1+SMP[1+Random(nombre_SMP)]);
   AttenteLongue: Saute(1+Liste_SMP[AttenteLongue].SMP[1]);
   TesteCase..PartiePerdue: with Liste_SMP[action] do Saute(1+SMP[1+Random(nombre_SMP)]);
  end;
 end;
end; {Bruit}
{$ELSE}
procedure Bruit(action: byte);
begin
end; {Bruit}
{$ENDIF}


procedure ChangePalette;
var p: Palette256;
begin
 with p do begin
  Charge(16,240);
  Intensite(16,240,sens_palette,bleu);
  Fixe(16,240);
 end;
end; {ChangePalette}


procedure INT1C; interrupt;
var duree: word;
    min,sec: byte;
    min_ch,sec_ch: string[2];
    couleur: RVB;
begin
 asm
  pushf
  call ancINT1C
 end;
 if not(timer_actif) then exit;

 if image_fond then begin
  ChargeDAC(16,couleur);
  FixeDAC(3,couleur);
  if (Timer and $07)=0 then ChangePalette;
  if (Timer and $7F)=0 then sens_palette:=-sens_palette;
 end;

 if Timer>timer_attente_longue+418 then
  begin if (Timer and $1F)=0 then Bruit(AttenteLongue) end
 else
  if Timer>timer_attente+145 then begin Bruit(Attente); timer_attente:=Timer end;

 if (Timer and $03)=0 then begin
  duree:=Round((Timer-timer_debut)/18.2);
  min:=duree div 60;
  sec:=duree mod 60;
  Str(min,min_ch);
  Str(sec,sec_ch);
  AffCh5x6($A000,9*largeur+10+4,20+3,CopyR('0'+min_ch,2)+':'+CopyR('0'+sec_ch,2),10,TRUE,0);
 end;
end; {INT1C}

(*
procedure JeuAutomatique;
var lig,col: byte;
    nombre_cases_marquees,nombre_cases_non_decouvertes: byte;
begin
 for lig:=1 to hauteur do
  for col:=1 to largeur do with Case_[lig,col] do
   if Decouverte and (NombreMinesAutour>0) then begin
    nombre_cases_non_decouvertes:=0;
    if (lig>1)       and (col>1)       then inc(nombre_cases_non_decouvertes,BYTE(not Case_[lig-1,col-1].Decouverte));
    if (lig>1)                         then inc(nombre_cases_non_decouvertes,BYTE(not Case_[lig-1,col  ].Decouverte));
    if (lig>1)       and (col<largeur) then inc(nombre_cases_non_decouvertes,BYTE(not Case_[lig-1,col+1].Decouverte));
    if                   (col>1)       then inc(nombre_cases_non_decouvertes,BYTE(not Case_[lig  ,col-1].Decouverte));
    if                   (col<largeur) then inc(nombre_cases_non_decouvertes,BYTE(not Case_[lig  ,col+1].Decouverte));
    if (lig<hauteur) and (col>1)       then inc(nombre_cases_non_decouvertes,BYTE(not Case_[lig+1,col-1].Decouverte));
    if (lig<hauteur)                   then inc(nombre_cases_non_decouvertes,BYTE(not Case_[lig+1,col  ].Decouverte));
    if (lig<hauteur) and (col<largeur) then inc(nombre_cases_non_decouvertes,BYTE(not Case_[lig+1,col+1].Decouverte));

    nombre_cases_marquees:=0;
    if (lig>1)       and (col>1)       then inc(nombre_cases_marquees,BYTE(Case_[lig-1,col-1].Marquee));
    if (lig>1)                         then inc(nombre_cases_marquees,BYTE(Case_[lig-1,col  ].Marquee));
    if (lig>1)       and (col<largeur) then inc(nombre_cases_marquees,BYTE(Case_[lig-1,col+1].Marquee));
    if                   (col>1)       then inc(nombre_cases_marquees,BYTE(Case_[lig  ,col-1].Marquee));
    if                   (col<largeur) then inc(nombre_cases_marquees,BYTE(Case_[lig  ,col+1].Marquee));
    if (lig<hauteur) and (col>1)       then inc(nombre_cases_marquees,BYTE(Case_[lig+1,col-1].Marquee));
    if (lig<hauteur)                   then inc(nombre_cases_marquees,BYTE(Case_[lig+1,col  ].Marquee));
    if (lig<hauteur) and (col<largeur) then inc(nombre_cases_marquees,BYTE(Case_[lig+1,col+1].Marquee));

    if (NombreMinesAutour=nombre_cases_non_decouvertes) and
       (nombre_cases_non_decouvertes<>nombre_cases_marquees) then begin
     if (lig>1)       and (col>1)       then with Case_[lig-1,col-1] do if not(Decouverte) then Marquee:=TRUE;
     if (lig>1)                         then with Case_[lig-1,col  ] do if not(Decouverte) then Marquee:=TRUE;
     if (lig>1)       and (col<largeur) then with Case_[lig-1,col+1] do if not(Decouverte) then Marquee:=TRUE;
     if                   (col>1)       then with Case_[lig  ,col-1] do if not(Decouverte) then Marquee:=TRUE;
     if                   (col<largeur) then with Case_[lig  ,col+1] do if not(Decouverte) then Marquee:=TRUE;
     if (lig<hauteur) and (col>1)       then with Case_[lig+1,col-1] do if not(Decouverte) then Marquee:=TRUE;
     if (lig<hauteur)                   then with Case_[lig+1,col  ] do if not(Decouverte) then Marquee:=TRUE;
     if (lig<hauteur) and (col<largeur) then with Case_[lig+1,col+1] do if not(Decouverte) then Marquee:=TRUE;
     AfficheGrille; exit;
    end;

    if (NombreMinesAutour=nombre_cases_marquees) and
       (nombre_cases_marquees<>nombre_cases_non_decouvertes) then begin
     if (lig>1)       and (col>1)       then with Case_[lig-1,col-1] do
      if not(Marquee) then begin DecouvreTerrainNonMine(lig-1,col-1,NombreMinesAutour); Decouverte:=TRUE end;
     if (lig>1)                         then with Case_[lig-1,col  ] do
      if not(Marquee) then begin DecouvreTerrainNonMine(lig-1,col  ,NombreMinesAutour); Decouverte:=TRUE end;
     if (lig>1)       and (col<largeur) then with Case_[lig-1,col+1] do
      if not(Marquee) then begin DecouvreTerrainNonMine(lig-1,col+1,NombreMinesAutour); Decouverte:=TRUE end;
     if                   (col>1)       then with Case_[lig  ,col-1] do
      if not(Marquee) then begin DecouvreTerrainNonMine(lig  ,col-1,NombreMinesAutour); Decouverte:=TRUE end;
     if                   (col<largeur) then with Case_[lig  ,col+1] do
      if not(Marquee) then begin DecouvreTerrainNonMine(lig  ,col+1,NombreMinesAutour); Decouverte:=TRUE end;
     if (lig<hauteur) and (col>1)       then with Case_[lig+1,col-1] do
      if not(Marquee) then begin DecouvreTerrainNonMine(lig+1,col-1,NombreMinesAutour); Decouverte:=TRUE end;
     if (lig<hauteur)                   then with Case_[lig+1,col  ] do
      if not(Marquee) then begin DecouvreTerrainNonMine(lig+1,col  ,NombreMinesAutour); Decouverte:=TRUE end;
     if (lig<hauteur) and (col<largeur) then with Case_[lig+1,col+1] do
      if not(Marquee) then begin DecouvreTerrainNonMine(lig+1,col+1,NombreMinesAutour); Decouverte:=TRUE end;
     AfficheGrille; exit;
    end;
   end;
end; {JeuAutomatique}
*)

procedure ChercheCFG;

const nbr_options_config=10;
      config_txt: array[1..nbr_options_config] of string[10]=
                   ('LARGEUR','HAUTEUR','MINES','IMAGEFOND','BRUITS',
                    'FREQUENCE','VOLUME','STEREO','DMACONTINU','FORCESBV1');

var f: Text;
    ligne,ligne_param: string[80];
    option: string[10];
    valeur: string[5];
    valeur_oui: boolean;
    erreur: word;
    p: byte;

begin
 Assign(f,'Demineur.CFG');
 {$I-}
 Reset(f);
 {$I+}
 if IOResult=0 then begin
  while not(Eof(f)) do begin
   Readln(f,ligne);
   p:=Pos(';',ligne);
   if p>0 then ligne:=CopyL(ligne,p-1);
   ligne:=Maj(ligne);

   ligne_param:='';
   for i:=1 to Length(ligne) do
    if ligne[i] in ['A'..'Z','0'..'9','='] then ligne_param:=ligne_param+ligne[i];

   p:=Pos('=',ligne_param);
   if p>0 then begin
    option:=CopyL(ligne_param,p-1);
    valeur:=CopyR(ligne_param,Length(ligne_param)-p);
    valeur_oui:=(valeur='OUI') or (valeur='1');
    for i:=1 to nbr_options_config do if option=config_txt[i] then begin
     case i of
      1 : Val(valeur,largeur,erreur);
      2 : Val(valeur,hauteur,erreur);
      3 : Val(valeur,nombre_mines_total,erreur);
      4 : image_fond:=valeur_oui;
      5 : bruits:=valeur_oui;
      {$IFDEF Musique}
      6 : Val(valeur,Variables^.Frequence,erreur);
      7 : Val(valeur,Volume_Principal,erreur);
      8 : Variables^.Utilise_Stereo:=valeur_oui;
      9 : Variables^.Utilise_DC:=valeur_oui;
      10: if valeur_oui then Variables^.MMType_SB:=1;
      {$ENDIF}
     end;
     break;
    end;
   end;
  end;
  largeur:=LimiteEntier(largeur,8,largeur_max);
  hauteur:=LimiteEntier(hauteur,8,hauteur_max);
  nombre_mines_total:=LimiteEntier(nombre_mines_total,10,Round(0.6*largeur*hauteur));
  {$IFDEF Musique}
  with Variables^ do Frequence:=LimiteEntier(Frequence,6000,22700);
  Volume_Principal:=MinEntier(Volume_Principal,250);
  {$ENDIF}
  Close(f);
 end;
end; {ChercheCFG}



BEGIN
 {$IFDEF Musique}
 with Variables^ do begin
  Utilise_DC:=TRUE;
  Frequence:=22700;
  Utiliser_Interpolation:=TRUE;
 end;
 Volume_Principal:=250;
 Boucler_MOD:=TRUE;

 ChercheCFG;

 if bruits then begin
  Charge_S3M('Demineur.S3M',erreur);
  bruits:=(erreur=0);
 end;
 {$ENDIF}

 Init320x200;

 if image_fond then with image do begin
  Charge('Demineur.BMP',erreur);
  image_fond:=(erreur=0);
  if image_fond then
   begin
    p.Charge(0,16);
    for i:=1 to ResX*ResY do if image^[i]<16 then image^[i]:=32-image^[i];
    FixePalette;
    p.Fixe(0,16);
   end;
 end;

 InitSouris;
 BougeCursSourisXY(9*largeur div 2,9*hauteur div 2);
 ZoneSouris(0,0,9*largeur-1,9*hauteur-1);
 AffCursSouris;

 {$IFDEF Musique}
 if bruits then Play(erreur);
 {$ENDIF}

 timer_actif:=FALSE;
 SwapIntVec($1C,ancINT1C,@INT1C);

 CadreOmbre($A000,9*largeur+10, 0,9*largeur+10+8*6,10,FALSE);
 CadreOmbre($A000,9*largeur+10,20,9*largeur+10+6*6,30,FALSE);

 repeat
  perdu:=FALSE;
  recommence:=FALSE;

  InitGrille;
  AfficheGrille;
  AfficheNombreMines;

  Bruit(DebutJeu);

  timer_debut:=Timer;
  timer_attente:=timer_debut; timer_attente_longue:=timer_attente;
  timer_actif:=TRUE;

  repeat
   EtatSouris(x,y,bt);
   lig:=1+(y div 9);
   col:=1+(x div 9);
   affiche_case:=FALSE;

   with Case_[lig,col] do
    case bt of
     gauche: if not(Marquee) then begin
              if not(Decouverte) then
               if NombreMinesAutour=0 then begin
                DecouvreTerrainNonMine(lig,col,NombreMinesAutour);
                Bruit(DecouvreTerrain);
                AfficheNombreMines;
                timer_attente:=Timer; timer_attente_longue:=timer_attente;
                repeat until BoutonSouris=aucun;
                AfficheGrille;
               end
               else begin
                Decouverte:=TRUE; affiche_case:=TRUE;
                Bruit(TesteCase);
               end;
              perdu:=Minee;
             end;
     droite: if not(Decouverte) then begin
              Marquee:=not(Marquee); affiche_case:=TRUE;
              Bruit(MarqueCase);
             end;
    end;

   if affiche_case then begin
    CacheCursSouris; AfficheCase(lig,col); AffCursSouris;
    AfficheNombreMines;
    timer_attente:=Timer; timer_attente_longue:=timer_attente;
    repeat until BoutonSouris=aucun;
   end;

   if Keypressed then
    case Readkey of
{     'a': begin
           JeuAutomatique;
           Bruit(TesteCase+Random(3));
           AfficheNombreMines;
           timer_attente:=Timer; timer_attente_longue:=timer_attente;
          end;}
     #27: quitte:=TRUE;
     #13: recommence:=TRUE;
    end;

   gagne:=(NombreCasesMarqueesMinees=nombre_mines_total) and
          (NombreCasesMarquees=nombre_mines_total);
  until gagne or perdu or recommence or quitte;

  timer_actif:=FALSE;

  if gagne then begin
   AffCh5x6($A000,9*largeur+10+4,0+3,' GAGNE!',15,TRUE,0);
   Bruit(PartieGagnee);
   quitte:=(Readkey=#27);
  end;

  if perdu then begin
   for lig:=1 to hauteur do
    for col:=1 to largeur do with Case_[lig,col] do
     if Minee then Decouverte:=TRUE;
   AfficheGrille;
   Bruit(PartiePerdue);
   quitte:=(Readkey=#27);
  end;
 until quitte;

 SwapIntVec($1C,ancINT1C,ancINT1C);

 {$IFDEF Musique}
 Bruit(FinJeu);
 if bruits then begin Pause(28); Stop_Modm; Init_DSP end;
 {$ENDIF}

 if image_fond then image.Supprime;

 CacheCursSouris;
 TextMode(LastMode);
END.
