USES Crt,Dos,Clavier,Texte;

CONST nbr_secteurs=18;

VAR buffer: array[1..nbr_secteurs*512] of byte;
    num_face,num_piste,num_secteur: byte;
    i: word;
    erreur: byte;
    quitte: boolean;


procedure OptimiseVitesseLecteur;
type DDPT_buf=array[$00..$0A] of byte;
var DDPT: ^DDPT_buf;
    test: byte;
begin
 GetIntVec($1E,pointer(DDPT));
 test:=DDPT^[$00];
 DDPT^[$00]:=not(DDPT^[$00]);
 if DDPT^[$00]<>test then begin  {valeur modifie -> DDPT en RAM}
  DDPT^[$00]:=test;
  {valeurs standard: $DF,$02,$25,$02,$12,$19,$FF,$54,$F6,$0F,$08}

  DDPT^[$00]:=$F8;
  DDPT^[$01]:=$02;
  DDPT^[$02]:=$10;
  DDPT^[$09]:=$04;
  DDPT^[$0A]:=$04;
 end;
end; {OptimiseVitesseLecteur}


procedure LitSecteur(lecteur,face,piste,secteur,nombre_secteurs: byte;
                     var buffer; var erreur: byte); assembler;
asm
 mov AH,02h
 mov DL,lecteur
 mov DH,face
 mov CH,piste
 mov CL,secteur
 mov AL,nombre_secteurs
 les BX,buffer
 int 13h
 les DI,erreur
 jc @fin
 xor AH,AH
@fin:
 mov ES:[DI],AH
end; {LitSecteur}


procedure TesteErreur(erreur: byte);
begin
 case erreur of
  $01: WriteLn('Numro de fonction non autoris');
  $02: WriteLn('Marque d''adresse non trouve');
  $03: WriteLn('Disquette protge en criture');
  $04: WriteLn('Secteur non trouv');
  $08: WriteLn('Dbordement DMA');
  $09: WriteLn('Transfert de donnes au-del du segment (?)');
  $10: WriteLn('Erreur de lecture');
  $20: WriteLn('Erreur contrleur disque');
  $40: WriteLn('Piste non trouve');
  $80: WriteLn('Erreur de Time-out');
 end;
 if erreur>0 then halt;
end; {TesteErreur}



procedure AfficheBuffer; assembler;
asm
 push DS
 cld

 mov AX,0B800h
 mov ES,AX
 mov DI,2*(1-1)+160*(3-1)
 mov DX,SEG buffer
 mov DS,DX
 mov SI,OFFSET buffer

 xor CL,CL
 mov CH,nbr_secteurs
 shl CH,1            {CX=nbr_secteurs*512}

 mov AH,7*16
@boucle:
 lodsb
 stosw
 loop @boucle

 pop DS
end;



BEGIN
 InitTexte(50);

 OptimiseVitesseLecteur;

{ quitte:=FALSE;
 num_face:=0;
 num_piste:=0;
 num_secteur:=1;
 repeat
  FillChar(buffer,sizeof(buffer),0);
  LitSecteur(0,num_face,num_piste,num_secteur,nbr_secteurs,buffer,erreur);
  ClrScr;
  WriteLn('Face ',num_face,', Piste ',num_piste,', Secteurs ',num_secteur,'  ',num_secteur+nbr_secteurs-1,':');
  TesteErreur(erreur);

  AfficheBuffer;

  case ReadKey of
   Key(Esc): quitte:=TRUE;
   Key('0'): num_face:=0;
   Key('1'): num_face:=1;
   Key('-'): if num_piste>0 then dec(num_piste);
   Key('+'): if num_piste<79 then inc(num_piste);
   Left,Down: if num_secteur>nbr_secteurs then dec(num_secteur,nbr_secteurs);
   Right,Up : if num_secteur<18-nbr_secteurs then inc(num_secteur,nbr_secteurs);
  end;
 until quitte;}

 writeln('taille d''un buffer=',sizeof(buffer));
 writeln('nombre de buffers ncessaires=',1440*1024 div sizeof(buffer));
 writeln('nombre de buffers disponibles=',memavail div sizeof(buffer));
 writeln('mmoire disponible=',memavail);
 writeln('nombre de buffers dans un bloc de 64ko=',(64*1024) div sizeof(buffer));
 writeln('nombre de blocs de 64ko ncessaires=',1+(1440*1024) div (64*1024));
 writeln('nombre de blocs de 64ko disponibles=',memavail div (64*1024));
 writeln('nombre d''accs disque=',1+(1+(1440*1024)) div memavail);
 repeat until readkey=Space;

 for num_face:=0 to 1 do
  for num_piste:=0 to 79 do begin
   FillChar(buffer,sizeof(buffer),0);
   LitSecteur(0,num_face,num_piste,1,nbr_secteurs,buffer,erreur);
   ClrScr;
   WriteLn('Face ',num_face,', Piste ',num_piste,', Secteurs ',num_secteur,'  ',num_secteur+nbr_secteurs-1,':');
   TesteErreur(erreur);
   AfficheBuffer;
   if Keypressed then break;
  end;
END.
