{$A+,G+,Q-,R-,S-}

USES Crt,Clavier,Util,Graph256; {diteur de loupe}

CONST diametre_max=96; {diametre doit tre multiple de 4 !!}
      blanc='';

VAR Tabedit: array[1..diametre_max,1..diametre_max] of string[3];
    Taboffset: array[1..diametre_max,1..diametre_max] of integer;
    diametre,milieu,ligne,colonne: byte;
    quitte: boolean;
    touche: Key;
    fichier: Text;
    ligne_fich: string;


procedure InitModeTexte; assembler;
asm
 mov AX,0003h
 int 10h                {mode texte 80x25}
 mov AX,14h
 int 10h                {mode texte 132 colonnes}
 mov AX,1112h
 mov BL,0
 int 10h                {mode texte 50 lignes}
end;


procedure GotoXY(x,y: byte); assembler;
asm
 mov AH,02h
 mov BH,0
 mov DH,y
 dec DH
 mov DL,x
 dec DL
 int 10h
end;


procedure WriteXY(x,y: byte; chaine: string; attr: byte); assembler;
asm
 push BP
 mov AX,1301h
 mov BH,0
 mov BL,attr
 mov DH,y
 dec DH
 mov DL,x
 dec DL
 les BP,chaine
 xor CH,CH
 mov CL,ES:[BP]
 inc BP
 int 10h
 pop BP
end;


procedure AfficheCase(lig,col: byte);
begin
 WriteXY(2+2*col,lig,Tabedit[lig,col][1],112);
 GotoXY(2+2*col,lig);
end;


procedure AfficheTableau(quart: byte);
var lig,col: byte;
    lig_debut,lig_fin,col_debut,col_fin: byte;
    ligne: string;
begin
 case quart of
  1: begin
      lig_debut:=1; lig_fin:=milieu;
      col_debut:=1; col_fin:=milieu;
     end;
  2: begin
      lig_debut:=1; lig_fin:=milieu;
      col_debut:=diametre-milieu+1; col_fin:=diametre;
     end;
  3: begin
      lig_debut:=diametre-milieu+1; lig_fin:=diametre;
      col_debut:=1; col_fin:=milieu;
     end;
  4: begin
      lig_debut:=diametre-milieu+1; lig_fin:=diametre;
      col_debut:=diametre-milieu+1; col_fin:=diametre;
     end;
 end;
 for lig:=lig_debut to lig_fin do begin
  WriteXY(1,lig-lig_debut+1,EntierTexte(lig,2),10);
  ligne:='';
  for col:=col_debut to col_fin do
   ligne:=ligne+Tabedit[lig,col][1]+' ';
  WriteXY(4,lig-lig_debut+1,ligne,7);
 end;
 ligne:='';
 for col:=1 to milieu do
  ligne:=ligne+Chr(64+col+col_debut-1)+' ';
 WriteXY(4,milieu+1,ligne,10);
 WriteXY(8+2*milieu,1,'Ŀ',3);
 WriteXY(8+2*milieu,2,'      ',3);
 WriteXY(8+2*milieu,3,'Ĵ',3);
 WriteXY(8+2*milieu,4,'      ',3);
 WriteXY(8+2*milieu,5,'',3);
 case quart of
  1: WriteXY( 9+2*milieu,2,'',3);
  2: WriteXY(13+2*milieu,2,'',3);
  3: WriteXY( 9+2*milieu,4,'',3);
  4: WriteXY(13+2*milieu,4,'',3);
 end;
 WriteXY(6+2*milieu,10,'Dplacement: flches',15);
 WriteXY(6+2*milieu,11,'Modif. case: '+#17+' (ligne '+EntierTexte(milieu,2)+')',15);
 WriteXY(6+2*milieu,12,'Valeur par dfaut: =',15);
 WriteXY(6+2*milieu,13,'Effacer une case: 0',15);
 WriteXY(6+2*milieu,14,'Changement de quart: 5',15);
 WriteXY(6+2*milieu,15,'Rotation ligne '+EntierTexte(milieu,2)+': F1',15);
 WriteXY(6+2*milieu,16,'Visualisation: Espace',15);
 WriteXY(6+2*milieu,17,'Fin: Esc',15);
end;


function CaseOK(lig,col: byte): boolean;
var test: string[3];
    nombre,erreur: integer;
begin
 test:=Tabedit[lig,col];
 if (Length(test) in [2,3]) then begin
  if (test[1] in ['A'..Chr(64+diametre)]) then begin
   if Length(test)=2 then begin
    test:=test+test[2];
    test[2]:='0';
   end;
   Val(Copy(test,2,2),nombre,erreur);
   if erreur=0 then CaseOK:=(nombre in [1..diametre])
               else CaseOK:=FALSE;
  end
  else CaseOK:=FALSE;
 end
 else CaseOK:=FALSE;
 Tabedit[lig,col]:=test;
end;


procedure CalculeRotations;
var lig,col,x,y,xp,yp,dist_inf,dist_sup: byte;
    nombre_destination: integer;
    lettre_destination: char;
    alpha,distance,lettre,delta: real;
begin
 {calculs bourrins pour le 1/8 infrieur}
 for lig:=2 to milieu-1 do
  for col:=1 to lig do begin
   x:=milieu-col;
   y:=milieu-lig;
   alpha:=Arctan(y/x);
   distance:=Sqrt(Sqr(x)+Sqr(y));
   dist_inf:=Trunc(distance); dist_sup:=dist_inf+1;
   if dist_sup<=milieu then begin
    if dist_sup<=milieu-1 then
     lettre:=Ord(Tabedit[milieu,milieu-dist_inf][1])*(1-Frac(distance))
            +Ord(Tabedit[milieu,milieu-dist_sup][1])*Frac(distance)
    else
     lettre:=Ord(Tabedit[milieu,1][1]);
    delta:=distance-(milieu+64-lettre);
    xp:=Round(x-delta*Cos(alpha));
    yp:=Round(y-delta*Sin(alpha));
    lettre_destination:=Chr(milieu+64-xp);
    nombre_destination:=milieu-yp;
    Tabedit[lig,col]:=lettre_destination+Chr(48+(nombre_destination div 10))+Chr(48+(nombre_destination mod 10));
   end;
  end;
end;


procedure Symetrise;
var lig,col: byte;
    dx,dy,nombre_source,nombre_destination,erreur: integer;
    lettre_source,lettre_destination: char;
begin
 {symtrie 1/8 infrieur -> 1/8 suprieur}
 for lig:=2 to milieu do
  for col:=1 to lig-1 do
   if CaseOK(lig,col) then begin
    lettre_source:=Tabedit[lig,col][1];
    Val(Copy(Tabedit[lig,col],2,2),nombre_source,erreur);
    lettre_destination:=Chr(64+nombre_source);
    nombre_destination:=Ord(lettre_source)-64;
    Tabedit[col,lig]:=lettre_destination+Chr(48+(nombre_destination div 10))+Chr(48+(nombre_destination mod 10));
   end
   else Tabedit[col,lig]:=blanc;
 {symtrie 1/4 gauche -> 1/4 droite}
 for lig:=1 to milieu do
  for col:=1 to (diametre shr 1) do
   if CaseOK(lig,col) then begin
    lettre_source:=Tabedit[lig,col][1];
    Val(Copy(Tabedit[lig,col],2,2),nombre_source,erreur);
    dx:=Ord(lettre_source)-(64+col);
    lettre_destination:=Chr(64+(diametre+1-col)-dx);
    nombre_destination:=nombre_source;
    Tabedit[lig,diametre+1-col]:=lettre_destination+Chr(48+(nombre_destination div 10))+Chr(48+(nombre_destination mod 10));
   end
   else Tabedit[lig,diametre+1-col]:=blanc;
 {symtrie 1/2 suprieure -> 1/2 infrieure}
 for lig:=1 to (diametre shr 1) do
  for col:=1 to diametre do
   if CaseOK(lig,col) then begin
    lettre_source:=Tabedit[lig,col][1];
    Val(Copy(Tabedit[lig,col],2,2),nombre_source,erreur);
    lettre_destination:=lettre_source;
    dy:=nombre_source-lig;
    nombre_destination:=(diametre+1-lig)-dy;
    Tabedit[diametre+1-lig,col]:=lettre_destination+Chr(48+(nombre_destination div 10))+Chr(48+(nombre_destination mod 10));
   end
   else Tabedit[diametre+1-lig,col]:=blanc;
end;


procedure CalculeOffsets;
var nombre_source,nombre_destination,dx,dy,erreur: integer;
    lettre_source,lettre_destination: char;
    lig,col: byte;
begin
 for lig:=1 to diametre do
  for col:=1 to diametre do
   if Tabedit[lig,col]<>blanc then begin
    lettre_destination:=Chr(64+col);
    nombre_destination:=lig;
    lettre_source:=Tabedit[lig,col][1];
    Val(Copy(Tabedit[lig,col],2,2),nombre_source,erreur);
    dx:=Ord(lettre_source)-Ord(lettre_destination);
    dy:=nombre_source-nombre_destination;
    Taboffset[lig,col]:=dx+320*dy;
   end
   else Taboffset[lig,col]:=0;
end;


procedure AfficheCarreNormal;
var x,y: byte;
begin
 for y:=1 to diametre do
  for x:=1 to diametre do
   Point($A000,x,y,x+y);
 AffChXY($A000,milieu shr 1,2*milieu shr 2,'AB',14,FALSE,0);
end;


procedure AfficheCarreDeforme;
var x,y: byte;
begin
 for y:=1 to diametre do
  for x:=1 to diametre do
   Point($A000,x+diametre+20,y,Mem[$A000:x+320*y+Taboffset[y,x]]);
end;



BEGIN
 ClrScr;

 repeat
  Write('Entrez la diametre de la loupe (12..',diametre_max,'): diametre=');
  ReadLn(diametre);
 until (diametre in [12..diametre_max]);
 diametre:=4*(diametre div 4);

 InitModeTexte;

 milieu:=(diametre+1) shr 1;

 for ligne:=1 to diametre do
  for colonne:=1 to diametre do begin
   Tabedit[ligne,colonne]:=blanc;
   Taboffset[ligne,colonne]:=0;
  end;

 quitte:=FALSE;
 ligne:=milieu; colonne:=milieu;
 repeat
  AfficheTableau(1);
  AfficheCase(ligne,colonne);
  touche:=UpCase(ReadKey);
  case touche of
   F1: CalculeRotations;
   Left : if colonne>1 then dec(colonne);
   Right: if colonne<ligne then inc(colonne);
   Up   : if ligne>colonne then dec(ligne);
   Down : if ligne<milieu then inc(ligne);
   Home: begin
          if colonne>1 then dec(colonne);
          if ligne>colonne then dec(ligne);
         end;
   End_: begin
          if ligne<milieu then inc(ligne);
          if colonne>1 then dec(colonne);
         end;
   PgUp: begin
          if ligne>colonne then dec(ligne);
          if colonne<ligne then inc(colonne);
         end;
   PgDn: begin
          if ligne<milieu then inc(ligne);
          if colonne<ligne then inc(colonne);
         end;
   Esc: quitte:=TRUE;
   Key('4'): if colonne>1 then dec(colonne);
   Key('6'): if colonne<ligne then inc(colonne);
   Key('8'): if ligne>colonne then dec(ligne);
   Key('2'): if ligne<milieu then inc(ligne);
   Key('7'): begin
              if colonne>1 then dec(colonne);
              if ligne>colonne then dec(ligne);
             end;
   Key('1'): begin
              if ligne<milieu then inc(ligne);
              if colonne>1 then dec(colonne);
             end;
   Key('9'): begin
              if ligne>colonne then dec(ligne);
              if colonne<ligne then inc(colonne);
             end;
   Key('3'): begin
              if ligne<milieu then inc(ligne);
              if colonne<ligne then inc(colonne);
             end;
   Key('0'): Tabedit[ligne,colonne]:=blanc;
   Enter: if ligne=milieu then begin
           WriteXY(2+2*colonne,ligne,' ',15);
           GotoXY(2+2*colonne,ligne);
           ReadLn(Tabedit[ligne,colonne]);
           TabEdit[ligne,colonne]:=TabEdit[ligne,colonne][1]+Chr(48+(ligne div 10))+Chr(48+(ligne mod 10));
           if not CaseOK(ligne,colonne) then Tabedit[ligne,colonne]:=blanc;
          end;
   Space: begin
           Init320x200;
           Symetrise;
           CalculeOffsets;
           AfficheCarreNormal;
           AfficheCarreDeforme;
           repeat until ReadKey=Space;
           InitModeTexte;
          end;
   Key('='): Tabedit[ligne,colonne]:=Chr(64+colonne)+Chr(48+(ligne div 10))+Chr(48+(ligne mod 10));
   Key('5'): begin
              AfficheTableau(2);
              repeat until ReadKey=Key('5');
              AfficheTableau(3);
              repeat until ReadKey=Key('5');
              AfficheTableau(4);
              repeat until ReadKey=Key('5');
             end;
  end;
 until quitte;

 TextMode(LastMode);
 Write('Sauvegarder? (Pascal, Assembleur, Non)');
 repeat
  touche:=UpCase(ReadKey)
 until touche in [Key('P'),Key('A'),Key('N'),Esc];

 if touche=Key('P') then begin
  Assign(fichier,'Loupe'+Chr(48+(diametre div 10))+Chr(48+(diametre mod 10))+'.PAS');
  ReWrite(fichier);
  WriteLn(fichier,'CONST diametre=',diametre,';');
  WriteLn(fichier,'Loupe: array[1..diametre,1..diametre] of integer');
  WriteLn(fichier,'   =(');
  for ligne:=1 to diametre do begin
   ligne_fich:='      (';
   for colonne:=1 to diametre-1 do begin
    if Length(ligne_fich)<120 then
     ligne_fich:=ligne_fich+EntierTexte(Taboffset[ligne,colonne],1)+','
    else begin
     WriteLn(fichier,ligne_fich);
     ligne_fich:='       '+EntierTexte(Taboffset[ligne,colonne],1)+',';
    end;
   end;
   if Length(ligne_fich)<120 then
    ligne_fich:=ligne_fich+EntierTexte(Taboffset[ligne,diametre],1)+'),'
   else begin
    WriteLn(fichier,ligne_fich);
    ligne_fich:='       '+EntierTexte(Taboffset[ligne,diametre],1)+'),';
   end;
   if ligne=diametre then dec(ligne_fich[0]);
   WriteLn(fichier,ligne_fich);
  end;
  WriteLn(fichier,'    );');
  Close(fichier);
 end;

 if touche=Key('A') then begin
  Assign(fichier,'Loupe'+Chr(48+(diametre div 10))+Chr(48+(diametre mod 10))+'.asm');
  ReWrite(fichier);
  WriteLn(fichier,'diametre EQU ',diametre);
  Write(fichier,'Loupe DW ');
  for ligne:=1 to diametre do begin
   for colonne:=1 to diametre-1 do
    Write(fichier,Taboffset[ligne,colonne],',');
   WriteLn(fichier,Taboffset[ligne,diametre]);
   if ligne<diametre then Write(fichier,'      DW ');
  end;
  Close(fichier);
 end;
END.
