PROGRAM Edit; {diteur de textes ASCII}
{$A+,G+,Q-,R-,S-}

USES Crt,Clavier,Texte,Util,UtilT,Souris,SourisT;

CONST LigneMax=6000; {nombre de lignes maxi. limit uniquement par la RAM!}
      LongMax =128;  {nombre maxi. de caractres par ligne}

      separateurs=[' '..'/',':'..'?','@','['..']','^','{'..'}'];

      CtrlZ=26; CtrlW=23; CtrlL=12; CtrlT=20; CtrlY=25;

      InsTxt: array[boolean] of string[3]=('   ','INS');
      MajTxt: array[boolean] of string[3]=('Min','MAJ');
      NumTxt: array[boolean] of string[3]=('   ','NUM');
      AltTxt: array[boolean] of string[3]=('   ','Alt');

      MemoireCar: array[0..9] of char='          ';
      lig_car: byte=7; col_car: byte=7;

TYPE String45=string[45];
     Enreg=string[LongMax];

VAR Ligne: array[1..LigneMax] of ^Enreg;

    modification: boolean;
    nbr_lig,lig_haut,col_gauche,lig,col: integer;

    longueur: byte;

    nom_fichier: String80;
    chaine_rech: String45;

CONST anc_chaine_rech: String45='';
      chaine_remp    : String45='';
      anc_chaine_remp: String45='';

{==========================================================}

procedure AfficheEtatClavier;
begin
 AffChXY(0,42,1,InsTxt[(EtatClavier and InsMode)=InsMode]+' '+
                MajTxt[(EtatClavier and MajMode)=MajMode]+' '+
                NumTxt[(EtatClavier and NumMode)=NumMode]+' '+
                AltTxt[(EtatClavier and Alt)=Alt],63);
end; {AfficheEtatClavier}

{----------------------------------------------------------}

function MemoireDisp: boolean;
begin
 MemoireDisp:=(MemAvail>4000);
end; {MemoireDisp}

{----------------------------------------------------------}

procedure AfficheNomFichier;
begin
 AffChXY(0,8,1,XString(Min(NomFichierSeul(nom_fichier)),' ',13),48);
end; {AfficheNomFichier}

{----------------------------------------------------------}

procedure AfficheMemoire;
begin
 AffChXY(0,25,1,'Mmoire: ',48);
 if MemoireDisp then AffChXY(0,33,1,EntierTexte2(MemAvail-4000,7),48)
                else AffChXY(0,33,1,EntierTexte2(0,7),48);
end; {AfficheMemoire}

{----------------------------------------------------------}

procedure AfficheLigColCode;
const EOLF: array[boolean] of string[3]=('EOL','EOF');
begin
 AffChXY(0,59,1,'Lig '+EntierTexte2(lig,4)+' Col '+EntierTexte2(col,3),48);
 if col=longueur+1 then AffChXY(0,77,1,EOLF[lig=nbr_lig],58)
                   else AffChXY(0,77,1,EntierTexte2(CodeXY(0,col-col_gauche+2,lig-lig_haut+2),3),56);
end; {AfficheLigColCode}

{----------------------------------------------------------}

procedure AfficheMemoiresCar;
var i: byte;
begin
 AffChXY(0,1,hauteur_ecran_txt,' Mmoires caractres:',48);
 for i:=0 to 9 do AffChXY(0,22+6*i,hauteur_ecran_txt,' '+Chr(48+i)+':'+MemoireCar[i]+' ',49);
end; {AfficheMemoiresCar}

{----------------------------------------------------------}

procedure AfficheLigne(nligne: integer);
const Car: array[1..2,boolean] of char=(('',' '),('',' '));
begin
 AffChXY(0,2,nligne-lig_haut+2,XString(Copy(Ligne[nligne]^,col_gauche,78),' ',79),27);
 AffCarXY(0,1,nligne-lig_haut+2,Car[1,col_gauche=1],30);
 AffCarXY(0,80,nligne-lig_haut+2,Car[2,Length(Ligne[nligne]^)<col_gauche+77],30);
end; {AfficheLigne}

{----------------------------------------------------------}

procedure AffichePage;
var y: integer;
begin
 for y:=lig_haut to lig_haut+hauteur_ecran_txt-3 do
  if y<=nbr_lig then AfficheLigne(y)
                else EffaceZone(0,1,y-lig_haut+2,80,y-lig_haut+2,27);
end; {AffichePage}

{----------------------------------------------------------}

procedure AfficheCar(c: char);
begin
 modification:=TRUE;
 if (EtatClavier and InsMode)=0 then Delete(Ligne[lig]^,col,1);
 Insert(c,Ligne[lig]^,col);
 inc(col);
 if col>LongMax+1 then col:=LongMax+1;
 CacheCursSouris;
 if col>col_gauche+77 then
  begin inc(col_gauche); AffichePage end else AfficheLigne(lig);
 AffCursSouris;
end; {AfficheCar}

{----------------------------------------------------------}

procedure EffaceMemoire;
var i: integer;
begin
 for i:=1 to nbr_lig do Dispose(Ligne[i]);
end; {EffaceMemoire}

{----------------------------------------------------------}

function LitFichier: integer;
var fichier: Text;
    erreur: integer;
begin
 repeat
  Assign(fichier,nom_fichier);
  {$I-}
  ReSet(fichier);
  {$I+}
  erreur:=IOResult;
  case erreur of
   0: begin
       EffaceMemoire;
       nbr_lig:=0;
       while not(Eof(fichier)) and (nbr_lig<LigneMax) and MemoireDisp do begin
        inc(nbr_lig); New(Ligne[nbr_lig]);
        ReadLn(fichier,Ligne[nbr_lig]^);
       end;
       Close(fichier);
       VideBufferClavier;
       if nbr_lig>=LigneMax then begin
        AfficheErreur('Trop de lignes','Fichier tronqu!');
        modification:=TRUE;
       end;
       if not(MemoireDisp) then begin
        AfficheErreur('Mmoire insuffisante','Fichier tronqu!');
        modification:=TRUE;
       end;
       if (nbr_lig<LigneMax) and MemoireDisp then begin
        inc(nbr_lig); New(Ligne[nbr_lig]); Ligne[nbr_lig]^:='';
        modification:=FALSE;
       end;
       lig_haut:=1; col_gauche:=1;
       lig:=1; col:=1;
       EffaceZone(0,1,2,80,hauteur_ecran_txt-1,27);
      end;
   152: AfficheErreur('Lecteur pas prt','Insrez une disquette');
   100,153..255: AfficheErreur('Erreur de lecture','Changez de disquette');
  end;
 until erreur<>152;
 LitFichier:=erreur;
end; {LitFichier}

{----------------------------------------------------------}

procedure EcritFichier;
var fichier: Text;
    i,erreur: integer;
begin
 for i:=1 to nbr_lig do
  while Ligne[i]^[Length(Ligne[i]^)]=' ' do dec(Ligne[i]^[0]); {supprime les espaces en fin de ligne}
 repeat
  Assign(fichier,nom_fichier);
  {$I-}
  Rewrite(fichier);
  {$I+}
  erreur:=IOResult;
  case erreur of
   0: begin
       for i:=1 to nbr_lig-1 do WriteLn(fichier,Ligne[i]^);
       if (Ligne[nbr_lig]^<>'') or (nbr_lig=1) then WriteLn(fichier,Ligne[nbr_lig]^);
       Close(fichier);
       VideBufferClavier;
       modification:=FALSE;
      end;
   3: AfficheErreur('Chemin introuvable','Vrifiez la syntaxe');
   5: AfficheErreur('Accs au fichier refus','Changez son attribut');
   150: AfficheErreur('Protection en criture','Enlevez la protection');
   152: AfficheErreur('Lecteur pas prt','Insrez une disquette');
   101,153..255: AfficheErreur('Erreur d''criture','Changez de disquette');
  end;
 until not(erreur in [150,152]);
end; {EcritFichier}

{----------------------------------------------------------}

function LitChaine(y: byte; chaine_init: String45; var abandon: boolean): String45;
const x=17;
var position: byte;
    bouge: boolean;
    chaine: String45;
    touche: Key;

procedure LitCar(caractere: char);
begin
 if not(bouge) then begin chaine:=''; position:=1; bouge:=TRUE end;
 if position<=45 then begin Insert(caractere,chaine,position); inc(position) end;
end; {LitCar}

begin {LitChaine}
 Curseur(plat);
 position:=1; bouge:=FALSE; chaine:=chaine_init;
 repeat
  CacheCursSouris;
  AffChXY(0,x,y,XString(chaine,' ',46),113);
  AffCursSouris;
  CursXY(0,x+position-1,y);
  if position>1 then bouge:=TRUE;
  touche:=ReadKey;
  case touche of
   Space..255: LitCar(CHAR(touche));
   Bdel : if position>1 then begin Delete(chaine,position-1,1); dec(position) end;
   Left : if position>1 then dec(position);
   Right: if position<Length(chaine)+1 then inc(position);
   Home : position:=1;
   End_ : position:=Length(chaine)+1;
   Del  : begin bouge:=TRUE; Delete(chaine,position,1) end;
   Alt1..Alt0: LitCar(MemoireCar[ChiffreAlt[touche]]);
  end;
 until touche in [Enter,Esc];
 LitChaine:=chaine;
 abandon:=(touche=Esc);
 Curseur(off);
end; {LitChaine}

{----------------------------------------------------------}

procedure SauveFichier; {F2}
var z: Zone;
    chaine: String45;
    abandon: boolean;
begin
 CacheCursSouris;
 z.Ombre(0,14,10,65,14,48);
 Cadre(0,1,15,10,64,14,49,' Sauver le fichier courant ',112,'');
 AffCursSouris;
 chaine:=LitChaine(12,nom_fichier,abandon);
 if not(abandon) and (chaine<>'') then begin
  nom_fichier:=chaine;
  AfficheNomFichier; EcritFichier
 end;
 RestaureZoneSuppr(0,z);
end; {SauveFichier}

{----------------------------------------------------------}

procedure Nouveau; {F4}
begin
 nom_fichier:='SANS_NOM'; AfficheNomFichier;
 lig_haut:=1; col_gauche:=1;
 lig:=1; col:=1;
 nbr_lig:=1; New(Ligne[nbr_lig]); Ligne[nbr_lig]^:='';
 modification:=FALSE;
 AffichePage;
 VideBufferClavier;
end; {Nouveau}

{----------------------------------------------------------}

function Confirmation: boolean;
var z: Zone;
    touche: Key;
    boutonSauve,boutonNeSauvePas,boutonAnnuler: Bouton;
    confirme,sauve,sortie: boolean;
begin
 Curseur(off);
 CacheCursSouris;
 z.Ombre(0,19,9,60,15,64);
 Cadre(0,2,20,9,59,15,79,' Confirmation ',79,'');
 AffChXY(0,23,11,NomFichierSeul(nom_fichier)+' modifi.  Sauve (O/N)?',71);
 boutonSauve.Definit(0,23,13,' Sauve ',116,124,0,128);
 boutonNeSauvePas.Definit(0,32,13,' Ne Sauve Pas ',116,124,0,128);
 boutonAnnuler.Definit(0,48,13,' Annuler ',112,120,0,128);
 AffCursSouris;
 boutonSauve.Affiche; boutonNeSauvePas.Affiche; boutonAnnuler.Affiche;

 sortie:=FALSE;
 repeat
  if KeyPressed then begin
   touche:=UpCase(ReadKey);
   sauve:=(touche=Key('O'));
   confirme:=sauve or (touche=Key('N'));
   sortie:=confirme or (touche=Esc);
  end
  else begin
   if boutonSauve.Clique      then begin sauve:=TRUE ; confirme:=TRUE ; sortie:=TRUE end;
   if boutonNeSauvePas.Clique then begin sauve:=FALSE; confirme:=TRUE ; sortie:=TRUE end;
   if boutonAnnuler.Clique    then begin sauve:=FALSE; confirme:=FALSE; sortie:=TRUE end;
  end;
 until sortie;

 RestaureZoneSuppr(0,z);
 Confirmation:=confirme;
 if sauve then EcritFichier;
end; {Confirmation}

{----------------------------------------------------------}

procedure ChargeFichier; {F3}
var nf,anc_repert,anc_nom_fich: String80;
    continue: boolean;
begin
 nf:=SelectionneFichier('Charger un fichier','*',hauteur_ecran_txt-11);
 if nf='' then exit;

 anc_repert:=repert;
 if modification then continue:=Confirmation;
 if not(modification) or continue then begin
  repert:=anc_repert; anc_nom_fich:=nom_fichier;
  nom_fichier:=nf;
  if LitFichier=0 then begin
   CacheCursSouris;
   AfficheNomFichier; AffichePage;
   AffCursSouris;
  end
  else nom_fichier:=anc_nom_fich;
  VideBufferClavier;
 end;
end; {ChargeFichier}

{----------------------------------------------------------}

procedure Aide; {F1}
var z: Zone;
begin
 Curseur(off);
 CacheCursSouris;
 z.Ombre(0,8,4,73,21,48);
 Cadre(0,1,9,4,72,21,49,' Aide ',112,'');
 LigneHorizontale(0,1,6,10,71,49);
 AffChXY2(0,11, 5,'EDIT v1.1 (c) Fab 1998 - ^Editeur de textes '+EntierTexte2(LigneMax,4)+' lignes maxi.^',62,63);
 AffChXY2(0,11, 7,'^F1^: Affiche cette page d''aide    ^'#27#26#24#25'^     : Curseur',49,48);
 AffChXY2(0,11, 8,'^F2^: Sauve le fichier courant     ^Home/End^ : Dbut/Fin ligne',49,48);
 AffChXY2(0,11, 9,'^F3^: Charge un fichier existant   ^PgUp/PgDn^: Page prc./suiv.',49,48);
 AffChXY2(0,11,10,'^F4^: Ouvre un nouveau fichier     ^Ctrl+'#27'^   : Mot prcdent',49,48);
 AffChXY2(0,11,11,'^F5^: Mmorise un caractre        ^Ctrl+'#26'^   : Mot suivant',49,48);
 AffChXY2(0,11,12,'^F6^: Recherche une chane         ^Ctrl+Z/W^ : Dfilement /',49,48);
 AffChXY2(0,11,13,'^F7^: Recherche et remplace        ^Ctrl+Home^: Haut de l''cran',49,48);
 AffChXY2(0,11,14,'^  ^                               ^Ctrl+End^ : Bas de l''cran',49,48);
 AffChXY2(0,11,15,'^Ctrl+Y^: Efface une ligne         ^Ctrl+PgUp^: Dbut de fichier',49,48);
 AffChXY2(0,11,16,'^Ctrl+T^: Efface le mot  droite   ^Ctrl+PgDn^: Fin de fichier',49,48);
 AffChXY2(0,11,17,'^Ctrl+L^: Recherche suivante',49,48);
 AffChXY2(0,11,18,'^Tab^: Indente le texte            ^Esc^: Quitte EDIT',49,48);
 AffChXY2(0,11,20,'^Alt-0^^Alt-9^: Affiche le caractre mmoris',49,48);
 AffCursSouris;
 repeat until ReadKey in [Space,Enter,Esc];
 RestaureZoneSuppr(0,z);
end; {Aide}

{----------------------------------------------------------}

procedure MemoriseCaractere; {F5}

var z: Zone;
    touche: Key;
    anc_col,anc_lig,i,j: byte;
    boutonOK: Bouton;
    sortie,ok: boolean;


procedure AfficheMemoires;
var i: byte;
begin
 CacheCursSouris;
 for i:=0 to 9 do
  AffChXY(0,52,i+8,' Alt-'+Chr(48+i)+': '+MemoireCar[i]+' ',112);
 AfficheMemoiresCar;
 AffCursSouris;
end; {AfficheMemoires}


begin {MemoriseCaractere}
 Curseur(off);
 CacheCursSouris;
 z.Ombre(0,14,4,65,21,48);
 Cadre(0,1,15,4,64,21,49,' Mmoriser un caractre ',112,'');
 for i:=0 to 15 do
  for j:=0 to 15 do AffCarXY(0,2*i+18,j+5,CHAR(16*i+j),49);
 boutonOK.Definit(0,55,19,' OK ',113,115,0,128);
 AffCursSouris; boutonOK.Affiche;
 AfficheMemoires;
 anc_col:=col_car; anc_lig:=lig_car;

 sortie:=FALSE; ok:=FALSE;
 repeat
  CacheCursSouris;
  AffCarXY(0,2*anc_col+18,anc_lig+5,CHAR(16*anc_col+anc_lig),49);
  AffCarXY(0,2*col_car+18,lig_car+5,CHAR(16*col_car+lig_car),62);
  AffChXY(0,52,6,EntierTexte2(16*col_car+lig_car,3)+'  ('+EntierHexa(16*col_car+lig_car,2)+'h)',63);
  anc_col:=col_car; anc_lig:=lig_car;

  AttendClavierSouris(TRUE,FALSE,i,j);
  if KeyPressed then begin
   touche:=ReadKey;
   case touche of
    Left : col_car:=(col_car+15) mod 16;
    Right: col_car:=(col_car+1 ) mod 16;
    Up   : lig_car:=(lig_car+15) mod 16;
    Down : lig_car:=(lig_car+1 ) mod 16;
    Home : col_car:=0;
    End_ : col_car:=15;
    PgUp : lig_car:=0;
    PgDn : lig_car:=15;
    Key('0')..Key('9'): begin
                         MemoireCar[touche-48]:=Chr(16*col_car+lig_car);
                         AfficheMemoires;
                        end;
    Enter: ok:=TRUE;
    Esc: sortie:=TRUE;
   end;
  end
  else begin
   if (i in [18..48]) and (j in [5..20]) then
    begin col_car:=(i shr 1)-9; lig_car:=j-5 end;
   if (i in [52..61]) and (j in [8..17]) then begin
    MemoireCar[j-8]:=Chr(16*col_car+lig_car); AfficheMemoires;
   end;
   ok:=boutonOK.Clique;
  end;
 until sortie or ok;
 RestaureZoneSuppr(0,z);
end; {MemoriseCaractere}

{----------------------------------------------------------}

procedure ChercheChaine(chaine: String45; var trouve: boolean; aff_non_trouve: boolean);
var anclig: integer;
    i,p: byte;
    chainetest: Enreg;
    reaffiche: boolean;
    z: Zone;

begin
 Curseur(off);
 chaine:=Min(chaine);
 anclig:=lig;
 repeat
  chainetest:=Min(Ligne[lig]^);
  if lig=anclig then Delete(chainetest,1,col);
  p:=Pos(chaine,chainetest);
  inc(lig);
 until (lig>nbr_lig) or (p>0);
 trouve:=(p>0);

 if trouve then begin
   dec(lig);
   if lig=anclig then inc(col,p) else col:=p;
   reaffiche:=FALSE;
   if (lig<lig_haut) or (lig>lig_haut+hauteur_ecran_txt-3) then begin
    lig_haut:=lig-6;
    if lig_haut<1 then lig_haut:=1;
    if lig_haut>nbr_lig-hauteur_ecran_txt+3 then lig_haut:=nbr_lig-hauteur_ecran_txt+3;
    reaffiche:=TRUE;
   end;
   if col+Length(chaine)>col_gauche+78 then begin col_gauche:=col+Length(chaine)-78; reaffiche:=TRUE end;
   if col<col_gauche then begin col_gauche:=col; reaffiche:=TRUE end;
   CacheCursSouris;
   if reaffiche and aff_non_trouve then AffichePage;
   AfficheLigColCode;
   if aff_non_trouve then
    AffChXY(0,col-col_gauche+2,lig-lig_haut+2,Copy(Ligne[lig]^,col,Length(chaine_rech)),112);
   AffCursSouris;
  end
 else begin
  lig:=anclig;
  if aff_non_trouve then begin
   CacheCursSouris;
   z.Ombre(0,28,11,53,13,48);
   Cadre(0,1,29,11,52,13,49,'',112,'Esc');
   AffChXY(0,32,12,'Chane non trouve',63);
   AffCursSouris;
   repeat until ReadKey=Esc;
   RestaureZoneSuppr(0,z);
  end;
 end;
end; {ChercheChaine}

{----------------------------------------------------------}

procedure Recherche; {F6}
var chaine: String45;
    abandon,trouve: boolean;
    z: Zone;
begin
 CacheCursSouris;
 z.Ombre(0,14,10,65,14,48);
 Cadre(0,1,15,10,64,14,49,' Chercher une chane de caractres ',112,'');
 AffCursSouris;

 chaine:=LitChaine(12,anc_chaine_rech,abandon);
 RestaureZoneSuppr(0,z);
 if not(abandon) and (chaine<>'') then begin
  chaine_rech:=chaine; anc_chaine_rech:=chaine_rech;
  ChercheChaine(chaine_rech,trouve,TRUE);
 end;
end; {Recherche}

{----------------------------------------------------------}

procedure Remplace; {F7}
var decale: ShortInt;
    chaine: String45;
    abandon,trouve,remplace_tout: boolean;
    touche: Key;
    z: Zone;
begin
 CacheCursSouris;
 z.Ombre(0,14,9,65,15,48);
 Cadre(0,1,15,9,64,15,49,' Remplacer une chane de caractres ',112,'');
 AffChXY(0,17,12,'Remplace par:',63);
 AffChXY(0,17,13,XString(anc_chaine_remp,' ',46),113);
 AffCursSouris;

 chaine:=LitChaine(11,anc_chaine_rech,abandon);
 if not(abandon) and (chaine<>'') then begin
  chaine_rech:=chaine; anc_chaine_rech:=chaine_rech;
  chaine:=LitChaine(13,anc_chaine_remp,abandon);
  if not(abandon) and (chaine<>'') then
   begin chaine_remp:=chaine; anc_chaine_remp:=chaine_remp end
 end;
 RestaureZoneSuppr(0,z);
 remplace_tout:=FALSE;

 if not(abandon) and (chaine<>'') then
  repeat
   ChercheChaine(chaine_rech,trouve,not(remplace_tout));
   if trouve then begin
    if not(remplace_tout) then begin
     CacheCursSouris;
     if lig-lig_haut in [9..12] then decale:=-4 else decale:=0;
     z.Ombre(0,26,11+decale,57,13+decale,48);
     Cadre(0,1,27,11+decale,56,13+decale,49,'',112,'Esc');
     AffChXY(0,29,12+decale,'Remplace (Oui/Non/Tout)? ',63);
     AffCursSouris;
     CursXY(0,53,12+decale);
     Curseur(plat);
     repeat
      touche:=UpCase(ReadKey);
     until touche in [Key('O'),Key('N'),Key('T'),Esc];
     RestaureZoneSuppr(0,z);
    end;
    remplace_tout:=(touche=Key('T'));
    if (touche=Key('O')) or remplace_tout then begin
     Delete(Ligne[lig]^,col,Length(chaine_rech)); Insert(chaine_remp,Ligne[lig]^,col);
     inc(col,Length(chaine_remp)-1);
     modification:=TRUE;
    end;
    if not(remplace_tout) then AffichePage;
   end;
  until not(trouve) or (touche=Esc);
 AffichePage;
end; {Remplace}

{----------------------------------------------------------}

procedure ControleDecalage(reaffiche: boolean);
begin
 if col_gauche>Length(Ligne[lig]^)+1 then begin
  col_gauche:=Length(Ligne[lig]^)+1;
  if reaffiche then AffichePage;
 end;
end; {ControleDecalage}

{----------------------------------------------------------}

procedure DeplaceHaut;
begin
 if lig>1 then begin
  dec(lig);
  if lig<lig_haut then begin
   CacheCursSouris;
   dec(lig_haut);
   ScrolleZoneBas(0,1,2,80,hauteur_ecran_txt-1);
   AfficheLigne(lig);
   AffCursSouris;
  end;
  ControleDecalage(TRUE);
 end;
end; {DeplaceHaut}

{----------------------------------------------------------}

procedure DeplaceBas;
begin
 if lig<nbr_lig then begin
  inc(lig);
  if lig>lig_haut+hauteur_ecran_txt-3 then begin
   CacheCursSouris;
   inc(lig_haut);
   ScrolleZoneHaut(0,1,2,80,hauteur_ecran_txt-1);
   AfficheLigne(lig);
   AffCursSouris;
  end;
  ControleDecalage(TRUE);
 end;
end; {DeplaceBas}

{----------------------------------------------------------}

procedure MotPrecedent;
var p,chPos: byte;
    chainetest: Enreg;
    trouve: boolean;
begin
 chainetest:=Ligne[lig]^;
 Delete(chainetest,col-1,Length(chainetest)+1);
 trouve:=FALSE;

 if (Length(chainetest)>1) and (col>1) then begin
  p:=Length(chainetest);
  repeat
   dec(p);
   if not(trouve) and
      (chainetest[p] in separateurs) and not(chainetest[p+1] in separateurs) then
    begin trouve:=TRUE; chPos:=p end;
  until (p=1) or trouve;
 end;

 if trouve then col:=chPos+1
 else
  if (Ligne[lig]^[1]<>' ') and (col>1) then col:=1
   else begin col:=LongMax+1; DeplaceHaut end;
end; {MotPrecedent}

{----------------------------------------------------------}

procedure MotSuivant;
var p,chPos: byte;
    chainetest: Enreg;
    trouve: boolean;
begin
 chainetest:=Ligne[lig]^;
 Delete(chainetest,1,col-1);
 trouve:=FALSE;

 if Length(chainetest)>0 then begin
  p:=0;
  repeat
   inc(p);
   if not(trouve) and
     (chainetest[p] in separateurs) and not(chainetest[p+1] in separateurs) then
    begin trouve:=TRUE; chPos:=p end;
  until (p=Length(chainetest)) or trouve;
 end;

 if trouve then inc(col,chPos)
 else begin
  col:=1;
  if lig<nbr_lig then begin
   p:=0;
   repeat inc(p) until (Ligne[lig+1]^[p]<>' ') or (p>Length(Ligne[lig+1]^));
   col:=p;
  end;
  DeplaceBas;
 end;
end; {MotSuivant}

{----------------------------------------------------------}

procedure GestionEditeur; {Procdure principale}

const Car: array[boolean] of char=(' ','*'); {pour modification}

var i,j: integer;
    touche: Key;
    quitte,defile,continue,trouve: boolean;
    chaine_dessus: Enreg;
    x,y: byte;


procedure Bip;
begin
 NoSound; Sound(880); Delay(30); NoSound;
end; {Bip}


procedure InsereLigne;
var i: integer;
begin
 CacheCursSouris;
 modification:=TRUE;
 inc(nbr_lig); New(Ligne[nbr_lig]);
 for i:=nbr_lig downto lig+1 do Ligne[i]^:=Ligne[i-1]^;
 Ligne[lig]^:=CopyL(Ligne[lig]^,col-1);
 Delete(Ligne[lig+1]^,1,col-1);
 if lig=lig_haut+hauteur_ecran_txt-3 then inc(lig_haut);
 AffichePage;
 AffCursSouris;
end; {InsereLigne}


procedure EffaceLigne;
var i: integer;
begin
 CacheCursSouris;
 modification:=TRUE;
 if lig=nbr_lig then Ligne[nbr_lig]^:=''
 else begin
  for i:=lig to nbr_lig-1 do Ligne[i]^:=Ligne[i+1]^;
  Dispose(Ligne[nbr_lig]); dec(nbr_lig);
 end;
 if (nbr_lig>hauteur_ecran_txt-3) and (lig_haut>nbr_lig-hauteur_ecran_txt+3) then lig_haut:=nbr_lig-hauteur_ecran_txt+3;
 AffichePage;
 AffCursSouris;
end; {EffaceLigne}


procedure ColleLignes(ligne1,ligne2: integer);
var i: integer;
begin
 CacheCursSouris;
 modification:=TRUE;
 lig:=ligne1; col:=Length(Ligne[lig]^)+1;
 Ligne[ligne1]^:=Ligne[ligne1]^+Ligne[ligne2]^;
 for i:=ligne2 to nbr_lig-1 do Ligne[i]^:=Ligne[i+1]^;
 Dispose(Ligne[nbr_lig]); dec(nbr_lig);
 if lig<lig_haut then dec(lig_haut);
 if (nbr_lig>hauteur_ecran_txt-3) and (lig_haut>nbr_lig-hauteur_ecran_txt+3) then lig_haut:=nbr_lig-hauteur_ecran_txt+3;
 AffichePage;
 AffCursSouris;
end; {ColleLignes}


begin {GestionEditeur}
 quitte:=FALSE; defile:=FALSE;

 repeat
  if not(defile) or (BoutonSouris=aucun) then begin
   CacheCursSouris;
   AfficheMemoire;
   if (EtatClavier and InsMode)=InsMode then Curseur(plat) else Curseur(rect);
   AffCarXY(0,22,1,Car[modification],62); {' ' ou '*'}
   if hauteur_ecran_txt=25 then DefCursSouris(standard,0,0,#0) else CursSourisFleche(#255);
  end;

  longueur:=Length(Ligne[lig]^);
  if col>longueur+1 then col:=longueur+1;
  if col<col_gauche then begin col_gauche:=col; AffichePage end;
  if col>col_gauche+77 then begin col_gauche:=col-77; AffichePage end;

  AfficheLigColCode;

  CursXY(0,col-col_gauche+2,lig-lig_haut+2);

  AttendClavierSouris(not(defile),FALSE,x,y);
  defile:=FALSE;

  if KeyPressed then begin
   touche:=ReadKey;

   case touche of
    Esc      : if modification then quitte:=Confirmation else quitte:=TRUE;

    Enter    : if (EtatClavier and InsMode)=0 then begin
                col:=1; DeplaceBas;
                if col_gauche>1 then begin col_gauche:=1; AffichePage end;
               end
               else
                if (nbr_lig<LigneMax) and MemoireDisp then
                 begin InsereLigne; col:=1; inc(lig) end
                else Bip;

    Space..255: AfficheCar(CHAR(touche));

    Bdel     : if col>1 then begin
                modification:=TRUE;
                Delete(Ligne[lig]^,col-1,1);
                dec(col);
                if col<col_gauche then begin dec(col_gauche); AffichePage end
                else AfficheLigne(lig)
               end
               else if lig>1 then ColleLignes(lig-1,lig);

    Tab      : if lig>1 then begin
                chaine_dessus:=Ligne[lig-1]^;
                if col<=Length(chaine_dessus) then begin
                 if chaine_dessus[col]=' ' then
                  repeat AfficheCar(' ') until (chaine_dessus[col]<>' ') or (col>Length(chaine_dessus))
                  else begin
                   repeat AfficheCar(' ') until (chaine_dessus[col]=' ') or (col>Length(chaine_dessus));
                   if chaine_dessus[col]=' ' then AfficheCar(' ');
                  end;
                 end
                 else for i:=1 to 8 do AfficheCar(' ');
                end
               else for i:=1 to 8 do AfficheCar(' ');

    CtrlL    : if chaine_rech<>'' then ChercheChaine(chaine_rech,trouve,TRUE);

    CtrlT    : if col<longueur+1 then begin
                modification:=TRUE;
                repeat
                 Delete(Ligne[lig]^,col,1);
                 trouve:=(Ligne[lig]^[col] in separateurs) and (Ligne[lig]^[col+1]<>Ligne[lig]^[col]);
                until trouve or (col>Length(Ligne[lig]^));
                if Ligne[lig]^[col]=' ' then Delete(Ligne[lig]^,col,1);
                AfficheLigne(lig);
               end
               else if lig<nbr_lig then ColleLignes(lig,lig+1);

    CtrlW    : begin
                if lig_haut>1 then dec(lig_haut);
                if lig>lig_haut+hauteur_ecran_txt-3 then dec(lig);
                if lig_haut=1 then DeplaceHaut;
                AffichePage;
               end;

    CtrlZ    : if nbr_lig>hauteur_ecran_txt-2 then
                if lig_haut<nbr_lig-hauteur_ecran_txt+3 then begin
                 inc(lig_haut); if lig<lig_haut then inc(lig);
                 AffichePage;
                end
                else DeplaceBas
               else DeplaceBas;

    CtrlY    : EffaceLigne;

    Left      : if col>1 then begin
                 dec(col);
                 if col<col_gauche then begin dec(col_gauche); AffichePage end;
                end;

    Right     : if col<longueur+1 then begin
                 inc(col);
                 if col>col_gauche+77 then begin inc(col_gauche); AffichePage end;
                end;

    Up        : DeplaceHaut;
    Down      : DeplaceBas;

    Home      : begin
                 col:=1;
                 if col_gauche>1 then begin col_gauche:=1; AffichePage end;
                end;

    End_      : begin
                 col:=longueur+1;
                 if col_gauche<col-77 then begin col_gauche:=col-77; AffichePage end;
                end;

    CtrlLeft  : MotPrecedent;
    CtrlRight : MotSuivant;

    PgUp      : if lig_haut>1 then begin
                 dec(lig_haut,hauteur_ecran_txt-2);
                 if lig_haut<1 then lig_haut:=1;
                 dec(lig,hauteur_ecran_txt-2);
                 if lig<1 then lig:=1;
                 ControleDecalage(FALSE);
                 AffichePage;
                end
                else begin lig:=1; ControleDecalage(TRUE) end;

    PgDn      : if lig_haut<nbr_lig-hauteur_ecran_txt+3 then begin
                 inc(lig_haut,hauteur_ecran_txt-2);
                 if lig_haut>nbr_lig-hauteur_ecran_txt+3 then lig_haut:=nbr_lig-hauteur_ecran_txt+3;
                 inc(lig,hauteur_ecran_txt-2);
                 if lig>nbr_lig then lig:=nbr_lig;
                 ControleDecalage(FALSE);
                 AffichePage;
                end
                else begin lig:=nbr_lig; ControleDecalage(TRUE) end;

    CtrlHome  : begin
                 lig:=lig_haut; ControleDecalage(TRUE);
                end;

    CtrlEnd   : begin
                 if nbr_lig>=hauteur_ecran_txt-2 then lig:=lig_haut+hauteur_ecran_txt-3 else lig:=nbr_lig;
                 ControleDecalage(TRUE);
                end;

    CtrlPgUp  : begin
                 lig:=1; col:=1;
                 lig_haut:=1; col_gauche:=1;
                 AffichePage;
                end;

    CtrlPgDn  : begin
                 lig:=nbr_lig;
                 col:=Length(Ligne[nbr_lig]^)+1;
                 lig_haut:=nbr_lig-hauteur_ecran_txt+3;
                 if lig_haut<1 then lig_haut:=1;
                 col_gauche:=col-76;
                 if col_gauche<1 then col_gauche:=1;
                 AffichePage;
                end;

    Del       : if col<longueur+1 then begin
                 modification:=TRUE;
                 Delete(Ligne[lig]^,col,1);
                 AfficheLigne(lig);
                end
                else if lig<nbr_lig then ColleLignes(lig,lig+1);

    F1        : Aide;
    F2        : SauveFichier;
    F3        : ChargeFichier;

    F4        : begin
                 if modification then continue:=Confirmation;
                 if not(modification) or continue then begin
                  EffaceMemoire;
                  CacheCursSouris; Nouveau; AffCursSouris;
                 end;
                end;

    F5        : MemoriseCaractere;
    F6        : Recherche;
    F7        : Remplace;

    Alt1..Alt0: AfficheCar(MemoireCar[ChiffreAlt[touche]]);
   end;
  end
 else begin
  if y=1 then begin
   DeplaceHaut; DelaiBoutonSouris(4);
   DefCursSouris(garde_fond,0,15,'');
   defile:=TRUE;
  end;
  if y=hauteur_ecran_txt then begin
   DeplaceBas; DelaiBoutonSouris(4);
   DefCursSouris(garde_fond,0,15,'');
   defile:=TRUE;
  end;
  if (y in [2..hauteur_ecran_txt-1]) then
   case x of
    1 : if col_gauche>1 then begin
         dec(col_gauche); if col>col_gauche+77 then dec(col);
         CacheCursSouris; AffichePage; AffCursSouris;
         DefCursSouris(garde_fond,0,15,'');
         DelaiBoutonSouris(4);
         defile:=TRUE;
        end;
    80: begin
         i:=lig_haut+y-2;
         if i>nbr_lig then i:=nbr_lig;
         j:=Length(Ligne[i]^);
         if (j>77) and (col_gauche<j-76) then begin
          lig:=i;
          inc(col_gauche); if col<col_gauche then inc(col);
          CacheCursSouris; AffichePage; AffCursSouris;
          DefCursSouris(garde_fond,0,15,'');
          DelaiBoutonSouris(4);
          defile:=TRUE;
         end;
        end;
    2..79: begin
            lig:=lig_haut+y-2; col:=col_gauche+x-2;
            if lig>nbr_lig then lig:=nbr_lig;
           end;
   end;
  end;
 until quitte;
end; {GestionEditeur}

{==========================================================}

VAR anc_nbr_lignes: byte;
    ancINT09: pointer;

procedure INT09; interrupt;
begin
 asm
  pushf
  call ancINT09
 end;

 CacheCursSouris;
 AfficheEtatClavier;
 AffCursSouris;
end; {INT09}


BEGIN
 anc_nbr_lignes:=NombreLignes+1;

 CheckBreak:=FALSE;

 InitRepert;
 InitTexte(50);
 AffChXY(0,1,1,' EDIT:'+RepeteCar(' ',74),48);
 ActiveMode(InsMode);  {active le mode insertion}
 AfficheEtatClavier;
 AfficheMemoiresCar;

 if lig_haut<1 then lig_haut:=1;
 if lig_haut>nbr_lig-hauteur_ecran_txt+3 then
  if nbr_lig-hauteur_ecran_txt+3>=1 then lig_haut:=nbr_lig-hauteur_ecran_txt+3;

 InitSourisFleche(#255,FALSE);
 Nouveau;

 AffCursSouris;
 VitesseClavier(1,0);
 SwapIntVec($09,ancINT09,@INT09);

 GestionEditeur;

 SwapIntVec($09,ancINT09,ancINT09);
 VitesseClavier(1,3);
 CacheCursSouris;

 InitTexte(anc_nbr_lignes);
END.