{$A+,G+,Q-,R-,S-}

USES Crt,SinCos;

CONST maxarraysize=128;  {doit tre une puissance de 2 !!}
      halfmaxsize =maxarraysize div 2;
      maxfreqsize =halfmaxsize-1;

TYPE complex=record re,im: integer end;
     dataarraytype=record case integer of
                    0:(rp: array[1..maxarraysize] of integer);
                    1:(cp: array[1..halfmaxsize] of complex)
                   end;
     fouriertype=record
                  dcterm: integer;
                  noiseterm: integer;
                  freqterms: array[1..maxfreqsize] of record costerm, sinterm: integer end;
                 end;
     mixedtype=record case integer of
                0:(dataslot: dataarraytype);
                1:(coefslot: fouriertype);
               end;


procedure FFTI(var mixed: mixedtype; integerpoints: word);
var index,minusindex,lowindex,highindex: byte;
    temp1,temp2,w: complex;
    baseangle,tempre: integer;
    complexpoints,angle: word;
    partitionsize,halfsize,offset,bits: byte;

function Log2(n: word): byte; assembler;
asm
 mov BX,n
 mov CX,15
@boucle:
 rcl BX,1
 jc @fin
 loop @boucle
@fin:
 mov AL,CL
end; {Log2}

function Bitreverse(index: word; bits: byte): word; assembler;
asm
 xor AX,AX
 mov BX,index
 dec BX
 mov CL,bits
@boucle:
 shr BX,1
 rcl AX,1
 dec CL
 jnz @boucle
 inc AX
end; {Bitreverse}

procedure Swap(var a,b: complex);
var temp: complex;
begin
 temp:=a; a:=b; b:=temp;
end; {Swap}

begin  {FFTI}
 with mixed do begin
  complexpoints:=integerpoints div 2;
  partitionsize:=complexpoints;

  repeat
   halfsize:=partitionsize div 2;
   baseangle:=32768 div partitionsize;
   for offset:=1 to halfsize do with dataslot do begin
    angle:=baseangle*(offset-1); {0  angle <   ->  0..16383}
    w.re:= Cos(angle);
    w.im:=-Sin(angle);
    lowindex:=offset;
    repeat
     highindex:=lowindex+halfsize;
     temp1.re:=cp[lowindex].re-cp[highindex].re;
     temp1.im:=cp[lowindex].im-cp[highindex].im;
     inc(cp[lowindex].re,cp[highindex].re);
     inc(cp[lowindex].im,cp[highindex].im);
     cp[highindex].re:=(temp1.re*LONGINT(w.re)-temp1.im*LONGINT(w.im)) div 32768;
     cp[highindex].im:=(temp1.re*LONGINT(w.im)+temp1.im*LONGINT(w.re)) div 32768;
     inc(lowindex,partitionsize);
    until lowindex>=complexpoints;
   end;
   partitionsize:=partitionsize div 2;
  until partitionsize=1;

  bits:=Log2(complexpoints);
  for lowindex:=1 to complexpoints do with dataslot do begin
   highindex:=Bitreverse(lowindex,bits);
   if highindex>lowindex then Swap(cp[lowindex],cp[highindex]);
  end;

  temp1:=dataslot.cp[1];
  with coefslot,temp1 do begin
   dcterm   :=(re+im) div 2;
   noiseterm:=(re-im) div 2;
  end;
  baseangle:=-32768 div integerpoints;

  for index:=1 to (integerpoints div 4) do begin
   minusindex:=(integerpoints div 2)-index;
   with dataslot do begin
    temp1.re:=cp[index+1].re+cp[minusindex+1].re;
    temp1.im:=cp[index+1].im-cp[minusindex+1].im;
    temp2.re:=cp[index+1].re-cp[minusindex+1].re;
    temp2.im:=cp[index+1].im+cp[minusindex+1].im;
   end;
   angle:=baseangle*index;
   w.re:= Sin(angle);
   w.im:=-Cos(angle);
   tempre:=temp2.re;
   temp2.re:=(temp2.re*LONGINT(w.re)-temp2.im*LONGINT(w.im)) div 32768;
   temp2.im:=(tempre*LONGINT(w.im)+temp2.im*LONGINT(w.re)) div 32768;
   with coefslot.freqterms[index] do begin
    costerm:= (LONGINT(temp1.re)+temp2.re) div 2;
    sinterm:=-(LONGINT(temp1.im)+temp2.im) div 2;
   end;
   with coefslot.freqterms[minusindex] do begin
    costerm:= (LONGINT(temp1.re)-temp2.re) div 2;
    sinterm:=-(LONGINT(temp1.im)-temp2.im) div 2;
   end;
  end;

  for index:=1 to complexpoints do with dataslot.cp[index] do begin
   re:=re div complexpoints;
   im:=im div complexpoints;
  end;
 end;
end; {FFTI}


VAR i: byte;
    DC: integer;
    comp: array[1..3] of record ampl: byte; freq: word end;
    norm: word;
    buffer: mixedtype;

BEGIN
 repeat
  Window(1,1,80,25);
  ClrScr;
  Window(60,1,80,25);
  Write('DC='); ReadLn(DC);
  for i:=1 to 3 do begin
   WriteLn; WriteLn('comp. ',i,':');
   Write('  ampl='); ReadLn(comp[i].ampl);
   Write('  freq='); ReadLn(comp[i].freq);
  end;
  Window(1,1,80,25);
  Writeln('init... ');
  with buffer.dataslot do
   for i:=1 to maxarraysize do
    rp[i]:=Round(
            DC
           + comp[1].ampl*System.Sin(2*pi*comp[1].freq*(i-1)/maxarraysize+1)
           - comp[2].ampl*System.Cos(2*pi*comp[2].freq*(i-1)/maxarraysize)
           + comp[3].ampl*System.Sin(2*pi*comp[3].freq*(i-1)/maxarraysize)
           );
  Writeln('calcul... ');
  FFTI(buffer,maxarraysize);
  Writeln;
  with buffer.coefslot do Writeln('DC = ',dcterm,' ,   Noise = ',noiseterm);
  Writeln; Writeln('harm  norm');
  Write(0:2);
  with buffer.coefslot do norm:=Round(Sqrt(Sqr(LONGINT(dcterm))+Sqr(LONGINT(noiseterm))));
  if norm=0 then TextColor(7) else TextColor(15);
  Write(norm:6,'  '); TextColor(7);
  for i:=1 to maxfreqsize do begin
   Write(i:2);
   with buffer.coefslot.freqterms[i] do
    norm:=Round(Sqrt(Sqr(LONGINT(costerm))+Sqr(LONGINT(sinterm))));
   if norm=0 then TextColor(7) else TextColor(15);
   Write(norm:6); TextColor(7);
   if (i mod 4)=3 then Writeln else Write('  ');
  end;
  WriteLn; Writeln; Write('Esc: fin');
 until ReadKey=#27;
END.
