PROGRAM Filtre;
{$A+,G+,Q-,R-,S-}

USES Fichiers;

TYPE tab=array[1..65000] of shortint;

VAR f: Fichier;
    erreur,f0,f1,f2: word;
    taille_sample: longint;
    sample: ^tab;
    param: string[15];
    lettre: char;
    p: byte;
    type_filtre: (inconnu,passe_bas,passe_haut,passe_bande);



procedure AfficheSyntaxe;
begin
 WriteLn('Usage: FILTRE nom_fichier_source nom_fichier_destination type_filtre');
 WriteLn('       exemples: type_filtre    description');
 WriteLn('                   B1000     -> filtre passe-bas  1kHz');
 WriteLn('                   H3500     -> filtre passe-haut  3.5kHz');
 WriteLn('                   D800-2000 -> filtre passe-bande 800Hz  2kHz');
 WriteLn;
 halt;
end;


procedure FiltrePasseBas(f0: word);
const T=1/16000;
var w0,A,B: real;
    i: word;
begin
 w0:=2*Pi*f0;
 A:=Exp(-w0*T); B:=1-A;
 for i:=2 to taille_sample do sample^[i]:=Round(A*sample^[i-1]+B*sample^[i]);
end;


procedure FiltrePasseHaut(f0: word);
var i: word;
    temp: ^tab;
begin
 GetMem(temp,taille_sample);
 Move(sample^,temp^,taille_sample);
 FiltrePasseBas(f0);
 for i:=1 to taille_sample do sample^[i]:=temp^[i]-sample^[i];
 FreeMem(temp,taille_sample);
end;


procedure FiltrePasseBande(f1,f2: word);
begin
 FiltrePasseHaut(f1);
 FiltrePasseBas(f2);
end;



BEGIN
 if ParamCount<3 then AfficheSyntaxe;

 param:=ParamStr(3); lettre:=UpCase(param[1]); Delete(param,1,1);
 type_filtre:=inconnu;
 case lettre of
  'B': begin
        Val(param,f0,erreur);
        if erreur=0 then type_filtre:=passe_bas;
       end;
  'H': begin
        Val(param,f0,erreur);
        if erreur=0 then type_filtre:=passe_haut;
       end;
  'D': begin
        p:=Pos('-',param);
        if p in [2..Length(param)-1] then begin
         Val(Copy(param,1,p-1),f1,erreur);
         if erreur=0 then begin
          Val(Copy(param,p+1,Length(param)-p),f2,erreur);
          if erreur=0 then type_filtre:=passe_bande;
         end;
        end;
       end;
 end;

 if type_filtre=inconnu then AfficheSyntaxe;

 with f do begin
  Ouvre(lecture,ParamStr(1));
  if f_erreur<>f_ok then begin WriteLn('Fichier introuvable'); halt(1) end;

  taille_sample:=Taille;
  if taille_sample>65000 then
   begin WriteLn('Fichier trop important !'); Ferme; halt(2) end;

  GetMem(sample,taille_sample);
  Lit(sample^,taille_sample);
  Ferme;
 end;

 Write('Filtrage ');
 case type_filtre of
  passe_bas: Write('passe-bas  ',f0);
  passe_haut: Write('passe-haut  ',f0);
  passe_bande: Write('passe-bande ',f1,'Hz  ',f2);
 end;
 Write('Hz en cours...');

 case type_filtre of
  passe_bas: FiltrePasseBas(f0);
  passe_haut: FiltrePasseHaut(f0);
  passe_bande: FiltrePasseBande(f1,f2);
 end;

 WriteLn;
 with f do begin
  Cree(not(teste_existe),ParamStr(2));
  if f_erreur<>0 then begin WriteLn('Impossible de crer ',ParamStr(2)); halt(3) end;

  Ecrit(sample^,taille_sample);
  Ferme;
 end;

 WriteLn('ok!'); WriteLn;
 FreeMem(sample,taille_sample);
END.
