PROGRAM FNT_PAS;
{convertit les fichiers FNT (fonte texte 256 caractres) en donnes Turbo-Pascal}

{$A+,G+,Q-,R-,S-}

USES Crt,Dos,Util,Fichiers;

CONST CRLF: array[1..2] of char=#13#10; {retour chariot}

VAR parametre: String80;
    nom_fichier: array[1..512] of String12;
    nbr_fichiers: word;

{==========================================================}

procedure Aide;
begin
 WriteLn(CRLF,'syntaxe: FNT_PAS nom_fichier[.FNT]');
end; {Aide}

{----------------------------------------------------------}

procedure Convertit;

var repert: String80;
    fFNT,fPAS: Fichier;
    n_fich,nbr_fichiers_traites: word;
    hauteur,i,j: byte;
    fonte: array[1..256*16] of byte;
    ligne: String80;


procedure Affiche(chaine: String80);
begin
 GotoXY(35,WhereY); ClrEol;
 GotoXY(35,WhereY); Write(chaine);
end; {Affiche}

procedure EcritLigne;
begin
 with fPAS do begin Ecrit(ligne[1],Length(ligne)); Ecrit(CRLF,2) end;
end; {EcritLigne}


begin  {Convertit}
 repert:=RepertoireSeul(parametre);
 nbr_fichiers_traites:=0;

 for n_fich:=1 to nbr_fichiers do begin
  Write(CRLF,nom_fichier[n_fich]); GotoXY(15,WhereY);
  fFNT.Ouvre(lecture,repert+nom_fichier[n_fich]);

  case f_erreur of
   f_ok: begin
          hauteur:=fFNT.Taille div 256;
          if hauteur in [8,14,16] then begin
           fFNT.Lit(fonte,256*hauteur);
           dec(nom_fichier[n_fich][0],3); {efface FNT}
           nom_fichier[n_fich]:=nom_fichier[n_fich]+'PAS'; {ajoute PAS}
           Write('->  ',nom_fichier[n_fich]);
           fPAS.Cree(not(teste_existe),repert+nom_fichier[n_fich]);
           case f_erreur of
            f_ok: begin
                   ligne:='CONST '+CopyL(nom_fichier[n_fich],Length(nom_fichier[n_fich])-4)+
                          ': Fonte'+EntierTexte2(hauteur,1)+'=(fonte:(';
                   EcritLigne;
                   for i:=0 to 255 do begin
                    ligne:='       (';
                    for j:=1 to hauteur do
                     ligne:=ligne+'$'+EntierHexa(fonte[i*hauteur+j],2)+',';
                    dec(ligne[0]); {efface ','}
                    if i<255 then ligne:=ligne+'),' else ligne:=ligne+') ';
                    ligne:=ligne+'  {';
                    if i<32 then ligne:=ligne+'#'+EntierTexte2(i,1)
                    else begin
                     if i=36 then ligne:=ligne+' '; {dcale le $  droite}
                     if i<>125 then ligne:=ligne+Chr(i);
                    end;
                    ligne:=ligne+'}';
                    EcritLigne;
                   end;
                   ligne:='      ));';
                   EcritLigne;
                   fPAS.Ferme;
                   Affiche('ok');
                   inc(nbr_fichiers_traites);
                  end;
            f_err_acces_ref: Affiche('Accs au fichier refus');
            f_err_protect  : begin Affiche('Disquette protge en criture'); break end;
            f_err_pas_pret : begin Affiche('Lecteur pas prt'); break end;
            f_err_CRC..f_err_secteur: Affiche('Erreur d''criture');
           end;
          end
          else Write('Format FNT incorrect (2048, 3584 ou 4096 octets)');
          fFNT.Ferme;
         end;
   f_err_fich_intr: Write('Fichier introuvable');
   f_err_ch_intr  : begin Write('Chemin introuvable'); break end;
   f_err_acces_ref: Write('Accs au fichier refus');
   f_err_pas_pret : begin Write('Lecteur pas prt'); break end;
   f_err_CRC..f_err_secteur: Write('Erreur de lecture');
  end;
 end;
 Write(CRLF,CRLF,nbr_fichiers_traites,' fichier');
 if nbr_fichiers_traites>1 then Write('s');
 Write(' converti');
 if nbr_fichiers_traites>1 then Write('s');
 if nbr_fichiers>1 then Write(' sur ',nbr_fichiers);
 WriteLn;
end; {Convertit}

{----------------------------------------------------------}

procedure ChercheFichiers;
var fichier: SearchRec;
begin
 nbr_fichiers:=0;
 FindFirst(parametre,Archive,fichier);
 case DosError of
  0 : repeat
       inc(nbr_fichiers);
       nom_fichier[nbr_fichiers]:=fichier.Name;
       FindNext(fichier);
      until DosError=18;
  2,18: WriteLn(CRLF,'Fichier introuvable');
  3   : WriteLn(CRLF,'Chemin introuvable');
  8   : WriteLn(CRLF,'Mmoire insuffisante');
  100 : WriteLn(CRLF,'Erreur de lecture');
  152 : WriteLn(CRLF,'Lecteur pas prt');
 end;
end; {ChercheFichiers}

{==========================================================}

BEGIN
 WriteLn(CRLF,'FNT_PAS v1.1 - (c) 1998 Fabrice Couteau',CRLF,
         'Convertisseur de fichiers FNT (fonte texte 256 car.) en donnes Turbo-Pascal');
 if ParamCount<>1 then Aide
 else begin
  parametre:=ParamStr(1);
  if Pos('.',parametre)=0 then parametre:=parametre+'.FNT';
  ChercheFichiers;
  if nbr_fichiers>0 then Convertit;
 end;
END.
