PROGRAM Fract;

{$A+,G+,N+,Q-,R-,S-}

USES Crt,Graph,VESA;

CONST nbranches=5;

TYPE point=record
            Re,Im: real
           end;

     tabreel=array[1..nbranches] of real;
	 tabpoint=array[1..nbranches] of point;

CONST u0=000; v0=480;
      unx=1.00; uny=1.00;

      coeff: tabreel=(0.55,0.50,0.52,0.55,0.50);
      angle: tabreel=(1.3,0.6,-0.1,-0.7,-1.2);

VAR O,A,B: point;
    ordre: byte;

    cosinus,sinus: tabreel;


PROCEDURE InitPoint(var P: point; x,y: integer);
begin
 P.Re:=x; P.Im:=y;
end;


FUNCTION ConvX(x: real): integer;
begin
 ConvX:=u0+Round(unx*x);
end;


FUNCTION ConvY(y: real): integer;
begin
 ConvY:=v0-Round(uny*y);
end;


FUNCTION Distance(A,B: point): integer;
begin
 Distance:=Round(Sqrt(Sqr(B.Re-A.Re)+Sqr(B.Im-A.Im)));
end;


PROCEDURE Cercle(O,A: point);
begin
 Circle(ConvX(O.Re),ConvY(O.Im),Distance(O,A));
end;


PROCEDURE BCDEFG(O,A: point; var B,C,D,E,F,G: point);
begin
 B.Re:=O.Re-A.Im+O.Im;
 B.Im:=O.Im+A.Re-O.Re;
 C.Re:=(3*B.Re-O.Re)/2;
 C.Im:=(3*B.Im-O.Im)/2;
 D.Re:=2*O.Re-A.Re;
 D.Im:=2*O.Im-A.Im;
 E.Re:=(3*D.Re-O.Re)/2;
 E.Im:=(3*D.Im-O.Im)/2;
 F.Re:=2*O.Re-B.Re;
 F.Im:=2*O.Im-B.Im;
 G.Re:=(3*F.Re-O.Re)/2;
 G.Im:=(3*F.Im-O.Im)/2;
end;


PROCEDURE Grouik(ordre: byte; O,A: point);
var B,C,D,E,F,G: point;
begin
 if ordre=0 Then Cercle(O,A)
 Else
 begin
  BCDEFG(O,A,B,C,D,E,F,G);
  Cercle(O,A);
  Grouik(ordre-1,C,B);
  Cercle(C,B);
  Grouik(ordre-1,E,D);
  Cercle(E,D);
  Grouik(ordre-1,G,F);
  Cercle(G,F);
 end;
end;


PROCEDURE CDE(A,B: point; var C,D,E: point);
begin
 C.Re:=(B.Re+2*A.Re)/3;
 C.Im:=(B.Im+2*A.Im)/3;
 E.Re:=(A.Re+2*B.Re)/3;
 E.Im:=(A.Im+2*B.Im)/3;
 D.Re:=C.Re+((B.Re-A.Re)*Cos(Pi/3)+(A.Im-B.Im)*Sin(Pi/3))/3;
 D.Im:=C.Im+((B.Im-A.Im)*Cos(Pi/3)+(B.Re-A.Re)*Sin(Pi/3))/3;
end;


PROCEDURE Segment(M,N: point);
begin
 Line(ConvX(M.Re),ConvY(M.Im),ConvX(N.Re),ConvY(N.Im));
end;


PROCEDURE Koch(ordre: byte; A,B: point);
var C,D,E: point;
begin
 if ordre=0 then Segment(A,B)
 else begin
  CDE(A,B,C,D,E);
  Koch(ordre-1,A,C);
  Koch(ordre-1,C,D);
  Koch(ordre-1,D,E);
  Koch(ordre-1,E,B);
 end;
end;


PROCEDURE CalculeCosSin;
var i: byte;
begin
 for i:=1 to nbranches do begin
  cosinus[i]:=Cos(angle[i]);
  sinus[i]:=Sin(angle[i]);
 end;
end;


PROCEDURE CalculeBranches(A,B: point; var br: tabpoint);
var i: byte;
begin
 for i:=1 to nbranches do begin
  br[i].Re:=B.Re+coeff[i]*((B.Re-A.Re)*cosinus[i]-(B.Im-A.Im)*sinus[i]);
  br[i].Im:=B.Im+coeff[i]*((B.Im-A.Im)*cosinus[i]+(B.Re-A.Re)*sinus[i]);
 end;
end;


PROCEDURE Arbre(ordre: byte; A,B: point);
var br: tabpoint;
    i: byte;
begin
 if ordre>0 then SetColor(6) else SetColor(2);
 Segment(A,B);
 if ordre>0 then begin
  CalculeBranches(A,B,br);
  for i:=1 to nbranches do Arbre(ordre-1,B,br[i]);
 end;
end;


PROCEDURE Pause;
begin
 repeat until ReadKey=#32;
 ClearViewPort;
end;


BEGIN
 if not(VESAOk) then begin
  Writeln('Cette carte graphique ne supporte pas les modes vido VESA.');
  halt;
 end;

 TextAttr:=7; ClrScr;
 Write('Ordre='); Read(ordre);

 InitVESA(VESA_1024x768_16,'C:\BP7\BGI','VESA16');
 SetColor(3);

 InitPoint(A,100,360); InitPoint(B,500,360); Koch(ordre,A,B);
 InitPoint(A,500,360); InitPoint(B,300, 10); Koch(ordre,A,B);
 InitPoint(A,300, 10); InitPoint(B,100,360); Koch(ordre,A,B);

 Pause;

 InitPoint(O,320,320); InitPoint(A,320,420); Grouik(ordre,O,A);

 Pause;

 CalculeCosSin;
 InitPoint(A,300,80); InitPoint(B,320,260); Arbre(ordre,A,B);

 Pause;

 CloseGraph; RestoreCrtMode;
END.