{$A+,G+,N+,Q-,R-,S-}

USES Crt,Graph,VESA;

CONST NbrPoints=32;

VAR xMin,xMax,yMin,yMax,PasX,PasY,
    xeMin,xeMax,yeMin,yeMax,CoefX,CoefY: real;


FUNCTION f(x,y:real): real;
begin
 f:=x*x+y*y;
end;


PROCEDURE ConvCoord(x,y,z: real; var xe,ye: real);
begin
 xe:=(y-0.7*x)*CoefX;
 ye:=(z-0.4*x)*CoefY;
end;


PROCEDURE Init;
begin
 xMin:=-5.0; xMax:=+5.0;
 yMin:=-5.0; yMax:=+5.0;
 PasX:=(xMax-xMin)/NbrPoints;
 PasY:=(yMax-yMin)/NbrPoints;
end;


PROCEDURE CalculeMax;
var x,y,z,xe,ye: real;
    i,j: integer;
begin
 CoefX:=1.1; CoefY:=1.0;
 x:=xMin; y:=yMin;
 z:=f(x,y);
 ConvCoord(x,y,z,xe,ye);
 xeMin:=xe; xeMax:=xe;
 yeMin:=ye; yeMax:=ye;
 for i:=1 to NbrPoints do begin
  y:=yMin;
  for j:=1 to NbrPoints do begin
   z:=f(x,y);
   ConvCoord(x,y,z,xe,ye);
   if xe<xeMin then xeMin:=xe;
   if xe>xeMax then xeMax:=xe;
   if ye<yeMin then yeMin:=xe;
   if ye>yeMax then yeMax:=xe;
   y:=y+PasY;
  end;
  x:=x+PasX;
 end;
 CoefX:=GetMaxX/(xeMax-xeMin);
 CoefY:=GetMaxY/(yeMax-yeMin);
end;


PROCEDURE Trace;
var   i,j: integer;
      xc,yc: real;
      xhg,xhd,xbg,xbd,yhg,yhd,ybg,ybd,zhg,zhd,zbg,zbd: real;
      Poly: array[1..4] of PointType;
      X,Y: real;
begin
 SetFillStyle(1,3);
 SetLineStyle(0,1,0);
 xc:=xMin;
 for i:=1 to NbrPoints do begin
  yc:=yMin;
  for j:=1 to NbrPoints do begin
   zhg:=f(xc     ,yc     ); ConvCoord(xc     ,yc     ,zhg,xhg,yhg);
   zhd:=f(xc     ,yc+PasY); ConvCoord(xc     ,yc+PasY,zhd,xhd,yhd);
   zbg:=f(xc+PasX,yc     ); ConvCoord(xc+PasX,yc     ,zbg,xbg,ybg);
   zbd:=f(xc+PasX,yc+PasY); ConvCoord(xc+PasX,yc+PasY,zbd,xbd,ybd);
   Poly[1].X:=Trunc(xbg-xeMin*CoefX); Poly[1].Y:=Trunc(yeMax*CoefY-ybg-yeMin*CoefY);
   Poly[2].X:=Trunc(xhg-xeMin*CoefX); Poly[2].Y:=Trunc(yeMax*CoefY-yhg-yeMin*CoefY);
   Poly[3].X:=Trunc(xhd-xeMin*CoefX); Poly[3].Y:=Trunc(yeMax*CoefY-yhd-yeMin*CoefY);
   Poly[4].X:=Trunc(xbd-xeMin*CoefX); Poly[4].Y:=Trunc(yeMax*CoefY-ybd-yeMin*CoefY);
   FillPoly(4, Poly);
   yc:=yc+PasY;
  end;
  xc:=xc+PasX;
 end;
end;


BEGIN
 InitVESA(VESA_1024x768_16,'C:\BP7\BGI','VESA16');
 SetColor(3);

 Init;
 CalculeMax;
 Trace;

 repeat until KeyPressed;

 CloseGraph;
 TextMode(LastMode);
END.