{$A+,G+,N+,Q-,R-,S-}

USES Crt,Texte,Graph,Vesa;

CONST {coordonnes limites}
	  x_min=-PI; x_max=+PI;
	  y_min=-PI; y_max=+PI;

	  {nombre de polygones par ligne}
	  N=128;

	  dx=(x_max-x_min)/N;
	  dy=(y_max-y_min)/N;

	  {coefficients de projection 3D}
	  proj_x=0.4;
	  proj_y=1-proj_x;

	  {coefficients d'chelle}
	  echX: real=1.0;
	  echY: real=1.0;

	  {vecteur lumire}
	  x_lum=-1.0;
	  y_lum=+3.0;
	  z_lum=-4.0;

	  norme_lum=x_lum*x_lum+y_lum*y_lum+z_lum*z_lum;

	  {dimensions de l'cran}
	  XMAX=799;
	  YMAX=599;

VAR xe_min,ye_min,xe_max,ye_max: real;


function z(x,y:real): real;
begin
 z:=Cos(Sqr(x)+Sqr(y));
end;


procedure ConvCoord(x,y,z: real; var xe,ye: real);
begin
 xe:=(y-proj_x*x)*echX;
 ye:=(z-proj_y*x)*echY;
end;


procedure CalculeMax;
var x,y,xe,ye: real;
	px,py: byte;
begin
 x:=x_min; y:=y_min;
 ConvCoord(x,y,z(x,y),xe,ye);
 xe_min:=xe; xe_max:=xe;
 ye_min:=ye; ye_max:=ye;

 for px:=1 to N do begin
  y:=y_min;
  for py:=1 to N do begin
   ConvCoord(x,y,z(x,y),xe,ye);
   if xe<xe_min then xe_min:=xe;
   if xe>xe_max then xe_max:=xe;
   if ye<ye_min then ye_min:=ye;
   if ye>ye_max then ye_max:=ye;
   y:=y+dy;
  end;
  x:=x+dx;
 end;

 echX:=XMAX/(xe_max-xe_min);
 echY:=YMAX/(ye_max-ye_min);
end;


procedure CalcProdVect(x1,y1,z1,x2,y2,z2: real; var xpv,ypv,zpv: real);
{                         
  x1    x2   y1.z2 - z1.y2
  y1 /\ y2 = z1.x2 - x1.z2
  z1    z2   x1.y2 - y1.x2
                            }
begin
 xpv:=y1*z2-z1*y2;
 ypv:=z1*x2-x1*z2;
 zpv:=x1*y2-y1*x2;
end;


function CalcProdScal(x1,y1,z1,x2,y2,z2: real): real;
{        
  x1   x2
  y1 . y2 = x1.x2 + y1.y2 + z1.z2
  z1   z2
           }
begin
 CalcProdScal:=x1*x2+y1*y2+z1*z2;
end;


procedure Trace;

var c,px,py: byte;
    xc,yc: real;
    xhg,xhd,xbg,xbd,yhg,yhd,ybg,ybd,zhg,zhd,zbg,zbd: real;
    Poly: array[1..4] of PointType;

    xpv,ypv,zpv,ps: real;
    comp: RVB;

begin
 for c:=1 to 15 do with comp do begin
  R:=16+c;
  V:=16+c;
  B:=32+2*c;
  FixeDAC(c,comp);
 end;

 SetLineStyle(4,0,0);
 xc:=x_min;
 for px:=1 to N do begin
  yc:=y_min;
  zhg:=z(xc   ,yc   ); ConvCoord(xc   ,yc   ,zhg,xhg,yhg);
  zhd:=z(xc   ,yc+dy); ConvCoord(xc   ,yc+dy,zhd,xhd,yhd);
  zbg:=z(xc+dx,yc   ); ConvCoord(xc+dx,yc   ,zbg,xbg,ybg);
  zbd:=z(xc+dx,yc+dy); ConvCoord(xc+dx,yc+dy,zbd,xbd,ybd);
  Poly[1].X:=Round(xbg-xe_min*echX); Poly[1].Y:=Round(ye_max*echY-ybg);
  Poly[2].X:=Round(xhg-xe_min*echX); Poly[2].Y:=Round(ye_max*echY-yhg);

  for py:=1 to N do begin
   {produit vectoriel entre (coin hg,coin hd) et (coin hg,coin bg)}
   CalcProdVect(0,dy,zhd-zhg,dx,0,zbg-zhg,xpv,ypv,zpv);
   ps:=CalcProdScal(xpv,ypv,zpv,x_lum,y_lum,z_lum)*norme_lum;

   c:=Abs(Round(10*ps));
   if c<1 then c:=1 else if c>15 then c:=15;
   SetFillStyle(1,c);
   Poly[3].X:=Round(xhd-xe_min*echX); Poly[3].Y:=Round(ye_max*echY-yhd);
   Poly[4].X:=Round(xbd-xe_min*echX); Poly[4].Y:=Round(ye_max*echY-ybd);
   FillPoly(4,Poly);

   yc:=yc+dy;
   xhg:=xhd; yhg:=yhd; zhg:=zhd;
   xbg:=xbd; ybg:=ybd; zbg:=zbd;
   zhd:=z(xc   ,yc); ConvCoord(xc   ,yc,zhd,xhd,yhd);
   zbd:=z(xc+dx,yc); ConvCoord(xc+dx,yc,zbd,xbd,ybd);
   Poly[1]:=Poly[4];
   Poly[2]:=Poly[3];
  end;

  xc:=xc+dx;
 end;
end;


BEGIN
 CalculeMax;

 InitVESA(VESA_800x600_16,'C:\BP7\BGI','VESA16');

 Trace;
 repeat until KeyPressed;

 TextMode(LastMode);
END.
