PROGRAM Groupf; {Regroupeur de fichiers}
{$A+,G+,Q-,R-,S-}

USES Dos,Clavier,Fichiers,Texte,Util,UtilT;

TYPE T_fichier=record
                Nom: String12;
                Taille: longint;
                Selectionne: boolean;
               end;

CONST max_fich=512;

VAR Liste: array[1..max_fich] of T_fichier;
    fich_dest: String12;
    taille_totale: longint;
    nbr_fich, nbr_fich_select: word;
    abandon: boolean;

{=========================================================}

function SelectionneFichiers: boolean;

type typecoul=(normal,inverse);

const hauteur_fenetre=50-2; {nombre de fichiers affichables simultanment}

var i,premier,choix_fich: word;
    fich: SearchRec;
    touche: Key;
    ok: boolean;


procedure AfficheChoix(ch: word; coul: typecoul);
const Couleur: array[boolean,typecoul] of byte=((7,112),(15,127));
begin
 if nbr_fich>0 then with Liste[ch] do
  AffChXY(0,3,ch-premier+2,XString(Nom,' ',12),Couleur[Selectionne,coul]);
end; {AfficheChoix}


procedure DefileHaut;
begin
 if choix_fich>1 then dec(choix_fich);
 if choix_fich<premier then dec(premier);
end; {DefileHaut}


procedure DefileBas;
begin
 if choix_fich<nbr_fich then inc(choix_fich);
 if choix_fich>premier+hauteur_fenetre-1 then inc(premier);
end; {DefileBas}


procedure DefilePageHaut;
begin
 if choix_fich>hauteur_fenetre then begin
  dec(choix_fich,hauteur_fenetre);
  if premier>hauteur_fenetre then dec(premier,hauteur_fenetre) else premier:=1;
 end
 else begin choix_fich:=1; premier:=1 end;
end; {DefilePageHaut}


procedure DefilePageBas;
begin
 inc(choix_fich,hauteur_fenetre); inc(premier,hauteur_fenetre);
 if choix_fich>nbr_fich then choix_fich:=nbr_fich;
 if nbr_fich>=hauteur_fenetre then
  if premier>nbr_fich-hauteur_fenetre+1 then premier:=nbr_fich-hauteur_fenetre+1;
 if nbr_fich<hauteur_fenetre then premier:=1;
end; {DefilePageBas}


procedure QuickSort(debut,fin: word);
var i,j: word;
    aux: String12;
begin
 i:=debut; j:=fin; aux:=Liste[(debut+fin) div 2].Nom;
 repeat
  while Liste[i].Nom<aux do inc(i);
  while aux<Liste[j].Nom do dec(j);
  if i<=j then begin
   SwapVar(Liste[i],Liste[j],sizeof(Liste[1]));
   inc(i); if j>0 then dec(j);
  end;
 until i>j;
 if debut<j then QuickSort(debut,j);
 if i<fin   then QuickSort(i,fin);
end; {QuickSort}


procedure SelectionneFichier;
begin
 with Liste[choix_fich] do
  case Selectionne of
   FALSE: begin
           Selectionne:=TRUE;
           inc(nbr_fich_select);
           inc(taille_totale,Taille);
          end;
   TRUE : begin
           Selectionne:=FALSE;
           dec(nbr_fich_select);
           dec(taille_totale,Taille);
          end;
  end;
end; {SelectionneFichier}


begin {SelectionneFichiers}
 Cadre(0,1,1,1,16,50,15,'',15,'');
 nbr_fich:=0;
 nbr_fich_select:=0; taille_totale:=0;

 FindFirst('*.*',ReadOnly+Hidden+Archive,fich);

 while DosError=0 do begin
  if fich.Attr<>Directory then begin
   inc(nbr_fich);
   with Liste[nbr_fich],fich do begin
    Nom:=Name; Taille:=Size; Selectionne:=FALSE;
   end;
   if nbr_fich=max_fich then break;
  end;
  FindNext(fich);
 end;

 choix_fich:=1; premier:=1;
 if nbr_fich>0 then QuickSort(1,nbr_fich);

 ok:=FALSE;
 AffChXY(0,20,1,'Espace ou '#27#26' pour slectionner,  pour regrouper',7);
 AffChXY(0,20,3,EntierTexte(DiskFree(0),8)+' octets libres',7);

 repeat
  AffChXY(0,18,50,EntierTexte2(choix_fich,3)+'/'+EntierTexte2(nbr_fich,3),7);
  if nbr_fich_select>0 then
   AffChXY(0,18,5,
    EntierTexte2(nbr_fich_select,3)+' fichier(s) slectionn(s)='+EntierTexte(taille_totale,8)+' octets',7)
  else
   AffChXY(0,18,5,RepeteCar(' ',80-18),7);
  for i:=premier to premier+hauteur_fenetre-1 do
   if (i<=nbr_fich) and (i<>choix_fich) then AfficheChoix(i,normal);
  AfficheChoix(choix_fich,inverse);

  touche:=ReadKey;
  case touche of
   Enter: if taille_totale+1024<DiskFree(0) then ok:=TRUE
          else begin
           AffChXY(0,20,6,'Espace disque insuffisant!    ',12+128);
           repeat until ReadKey=Enter;
           AffChXY(0,20,6,RepeteCar(' ',35),0);
          end;
   Space: SelectionneFichier;
   Up   : DefileHaut;
   Down : DefileBas;
   PgUp : DefilePageHaut;
   PgDn : DefilePageBas;
   Home : begin choix_fich:=1; premier:=1 end;
   end_ : begin
           choix_fich:=nbr_fich;
           if nbr_fich>hauteur_fenetre then premier:=nbr_fich-hauteur_fenetre+1;
          end;
   Left : begin SelectionneFichier; DefileHaut end;
   Right: begin SelectionneFichier; DefileBas  end
  end
 until ok or (touche=Esc);

 AfficheChoix(choix_fich,normal);
 SelectionneFichiers:=ok and (nbr_fich_select<>0);
end; {SelectionneFichiers}

{---------------------------------------------------------}

procedure RegroupeFichiers;

const un_kilo=1024;
      long_tampon=8*un_kilo;

type T_entete=record
               Nom: String12;
               offset, longueur: longint;
              end;

     tranche=array[1..8*un_kilo] of byte;

var Tampon: array[1..128] of ^tranche;
    f: Fichier;
    i,j,nbr_tampons,long_reste: word;
    Indice: array[1..max_fich] of word;
    Entete: array[1..max_fich] of T_entete;
    offset,longueur: longint;
    memoire_ok: boolean;
    p: pointer;


procedure AfficheErreur(chaine: String64);
begin
 AffChXY(0,22,23,chaine+'   ',79);
 repeat until ReadKey=Enter;
 AffChXY(0,22,23,RepeteCar(' ',80-22),0);
end; {AfficheErreur}


begin {RegroupeFichiers}
 j:=1;
 for i:=1 to nbr_fich do
  if Liste[i].Selectionne then begin Indice[j]:=i; inc(j) end;

 memoire_ok:=TRUE;
 for i:=1 to nbr_fich_select do
  if Liste[Indice[i]].Taille>MemAvail then memoire_ok:=FALSE;

 if not(memoire_ok) then
  begin AfficheErreur('Mmoire insuffisante!'); exit end;

 offset:=2+nbr_fich_select*sizeof(T_entete); {dbut premier fichier}
 for i:=1 to nbr_fich_select do begin
  Entete[i].Nom:=Liste[Indice[i]].Nom;
  Entete[i].offset:=offset;
  Entete[i].longueur:=Liste[Indice[i]].Taille;
  inc(offset,Entete[i].longueur);
 end;

 with f do begin
  Cree(ecrase,fich_dest);
  if f_erreur<>f_ok then
   begin AfficheErreur('Impossible de crer le fichier '+fich_dest); exit end;

  Ecrit(nbr_fich_select,2);
  Ecrit(Entete,nbr_fich_select*sizeof(T_entete));
  Ferme;

  for i:=1 to nbr_fich_select do begin
   Ouvre(lecture,Liste[Indice[i]].Nom);
   if f_erreur<>f_ok then
    begin AfficheErreur('Impossible de lire le fichier '+Liste[i].Nom); continue end;

   Mark(p); {sauvegarde le tas}
   AffChXY(0,25,18,'Lit le fichier '+Liste[Indice[i]].Nom+'...         ',14);
   longueur:=Taille;
   nbr_tampons:=1+((longueur-1) div long_tampon);
   for j:=1 to nbr_tampons-1 do
    begin New(Tampon[j]); Lit(Tampon[j]^,long_tampon) end;
   long_reste:=1+((longueur-1) mod long_tampon);
   New(Tampon[nbr_tampons]);
   Lit(Tampon[nbr_tampons]^,long_reste);
   Ferme;
   AffChXY(0,25,18,'Ajoute le fichier '+Liste[Indice[i]].Nom+'...         ',14);
   Ouvre(ecriture,fich_dest); {normalement, pas d'erreur}
   PlacePointeur(Taille);
   for j:=1 to nbr_tampons-1 do Ecrit(Tampon[j]^,long_tampon);
   Ecrit(Tampon[nbr_tampons]^,long_reste);
   Ferme;
   Release(p); {restaure le tas}
  end;
 end;
end; {RegroupeFichiers}

{=========================================================}

BEGIN
 InitTexte(50);
 Curseur(off);

 if SelectionneFichiers then begin
  Cadre(0,1,25,8,65,11,15,' Nom du fichier destination ',15,'');
  fich_dest:=LitChaine('',40,10,14,12,FALSE,alpha+['.','_'],TRUE,15,15,abandon);
  if not(abandon) then RegroupeFichiers;
 end;

 EffacePage(0,7);
 CursXY(0,1,1);
 Curseur(plat);
END.
