{$A+,G+,N-,Q-,R-,S-}

USES Crt,Dos,Util,Fichiers,BMP256;

CONST CRLF=#13#10;

VAR info: SearchRec;
    rep: DirStr;
    nom: NameStr;
    ext: ExtStr;

    nom_groupe : string[80];
    nom_fichier: string[12];

    f: Fichier;

    image: BMP;

    erreur: word;

    n_couleurs,index: word;


{ Regroupe plusieurs images BMP de taille identique
  en un seul fichier simplifi (pas d'entte, longueur
  d'un enregistrement fixe)

  Chaque enregistrement possde un index de groupe pour
  identifier le groupe d'images lorsque plusieurs groupes
  sont concatns.

  format du fichier
  =================

  enregistrement 1

    index  :WORD
    palette:(R:BYTE,V:BYTE,B:BYTE)*n_couleurs
    image  :BYTE*taille

  enregistrement 2

    ...
}

Procedure Syntaxe;
begin
  Writeln('syntaxe: GrpBMP nom_groupe nom_image[.BMP] n_couleurs index',CRLF,
          '         2  n_couleurs  256, 0  index  65535',CRLF);
end; {Syntaxe}


BEGIN
  Writeln(CRLF,
          'GrpBMP v1.0 - (c) 1999 Fabrice Couteau',CRLF,
          'Regroupeur d''images BitMap RGB 8 bits',CRLF);

  if ParamCount<>4 then begin Syntaxe; halt(1); end;

  Val(ParamStr(3),n_couleurs,erreur);
  if (n_couleurs<2) or (n_couleurs>256) or (erreur<>0) then begin Syntaxe; halt(1); end;

  Val(ParamStr(4),index,erreur);
  if erreur<>0 then begin Syntaxe; halt(1); end;

  nom_groupe:=ParamStr(1);
  f.Cree(ecrase,nom_groupe);

  FSplit(ParamStr(2),rep,nom,ext);
  if ext='' then ext:='.BMP';

  FindFirst(rep+nom+ext,Archive,info);
  while DosError=0 do begin
    nom_fichier:=info.Name;
    Write(nom_fichier+' ':15);

    with image do begin
      Charge(rep+nom_fichier,erreur);
      if erreur=0 then begin
        f.Ecrit(index,sizeof(index));
        f.Ecrit(palette,n_couleurs*sizeof(palette.palette[0]));
        f.Ecrit(image^,ResX*ResY);

        if f_erreur=f_ok then Writeln('ok')
                         else Writeln('Erreur d''criture (',erreur,')');

        Supprime;
      end
      else case erreur of
          1: Writeln('Format non support');
          2: Writeln('Fichier introuvable');
          3: Writeln('Chemin introuvable');
          6: Writeln('Mmoire insuffisante');
        else Writeln('Erreur de lecture (',erreur,')');
      end;
    end;

    FindNext(info);
  end;

  f.Ferme;
END.
