PROGRAM History; {sauvegarde l'historique de chaque date & heure de dmarrage}
{$A+,G+,Q-,R-,S-}

USES Fichiers,Util;

CONST Lundi=1; Dimanche=7;
      NomJour: array[Lundi..Dimanche] of String8=
                ('Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi','Dimanche');

      Janvier=1; Decembre=12;
      NomMois: array[Janvier..Decembre] of string[9]=
                ('Janvier','Fvrier','Mars','Avril','Mai','Juin','Juillet',
                 'Aot','Septembre','Octobre','Novembre','Dcembre');

{ 31           24 23           16 15            8 7             0
 Ŀ
                                                          
 
 \jour /\ date  /\ mois /\  anne  /\ heures /\ minutes  /\ sec. /

  1=Lun   1..31    1..12    0=1990     0..23     0..59      0=0
  .                         .                               .
  .                         .                               .
  7=Dim                    31=2021                         14=56   }

{=========================================================}

function Compacte(jour,date,mois: byte; annee: word; heures,minutes,secondes: byte): longint;
begin
 Compacte:=(LONGINT(jour) shl 29)+
           (LONGINT(date) shl 24)+
           (LONGINT(mois) shl 20)+
           ((LONGINT(annee)-1990) shl 15)+
           (LONGINT(heures)  shl 10)+
           (LONGINT(minutes) shl  4)+
           (secondes div 4);
end; {Compacte}

{---------------------------------------------------------}

procedure Decompacte(date_heure: longint; var jour,date,mois: byte; var annee: word; var heures,minutes,secondes: byte);
begin
 jour    :=(date_heure shr 29) and $07;
 date    :=(date_heure shr 24) and $1F;
 mois    :=(date_heure shr 20) and $0F;
 annee   :=1990+((date_heure shr 15) and $1F);
 heures  :=(date_heure shr 10) and $1F;
 minutes :=(date_heure shr  4) and $3F;
 secondes:=4*(date_heure and $0F);
end; {Decompacte}

{---------------------------------------------------------}

function DateComplete(date_heure: longint; avec_heure: boolean): String80;
var jour,date,mois,heures,minutes,secondes: byte;
    annee: word;
    chaine: String80;
begin
 Decompacte(date_heure,jour,date,mois,annee,heures,minutes,secondes);
 chaine:=NomJour[jour]+' '+EntierTexte2(date,1)+' '+NomMois[mois]+' '+EntierTexte2(annee,4);
 if avec_heure then
  chaine:=chaine+'  '+EntierTexte2(heures,2+et_zeros)+':'+
                       EntierTexte2(minutes,2+et_zeros)+':'+
                       EntierTexte2(secondes,2+et_zeros);
 DateComplete:=chaine;
end; {DateComplete}

{=========================================================}

CONST nom_fichier='C:\HISTORY.DAT';

VAR f: Fichier;
    taille_fichier: longint;

    jour,date,mois,heures,minutes,secondes: byte;
    annee: word;
    derniere_date,nouvelle_date: longint;

BEGIN
 asm
  mov AH,2Ah
  int 21h       {lit la date actuelle}
  or AL,AL
  jnz @pas_dimanche
  mov AL,Dimanche
 @pas_dimanche:
  mov jour,AL
  mov date,DL
  mov mois,DH
  mov annee,CX

  mov AH,2Ch
  int 21h       {lit l'heure actuelle}
  mov heures,CH
  mov minutes,CL
  mov secondes,DH
 end;
 nouvelle_date:=Compacte(jour,date,mois,annee,heures,minutes,secondes);

 with f do begin
  Ouvre(lecture_ecriture,nom_fichier);
  case f_erreur of
   f_ok: begin
          taille_fichier:=Taille;
          if (taille_fichier=0) or (taille_fichier and $03<>0) then
           begin WriteLn('Format du fichier ',nom_fichier,' incorrect!'); halt(2) end;
          LitPos(taille_fichier-4,derniere_date,4);
          Writeln('Dernier dmarrage le ',DateComplete(derniere_date,TRUE));
          Ecrit(nouvelle_date,4); Ferme;
         end;
   f_err_fich_intr: begin
                     Cree(not(teste_existe),nom_fichier);
                     if f_erreur<>f_ok then
                      begin WriteLn('Impossible de crer ',nom_fichier); halt(1) end;
                     Ecrit(nouvelle_date,4); Ferme; halt(0); {fin normale}
                    end;
   else begin WriteLn('Fichier ',nom_fichier,' introuvable!'); halt(1) end;
  end;
 end;
END.
