PROGRAM MenuJeux; {Gestion des jeux par menu configurable dans JEUX.LIS}
{$A+,G+,Q-,R-,S-}

{$M 2500,0,0}

USES Crt,Dos,Clavier,Texte,Util;

CONST nbr_jeux_max=200; {200 jeux maximum!}

      nbr_jeux: byte=0;

      n_jeu: byte=1;
      premier: integer=1;

      coul: byte=1;
      ok: boolean=FALSE;

VAR TitreJeu: array[1..nbr_jeux_max] of string[22];
    FichierLanceurJeu: array[1..nbr_jeux_max] of string[42];


procedure AffichePage;
begin
 EffaceZone(0,2,1,79,5,48);
 Cadre(0,2,4,2,77,4,63,'',0,''); AffChXY(0,28,3,'M E N U   D E S   J E U X',63);
 EffaceZone(0,2,7,79,20,16);
 Cadre(0,1,3,7,78,20,27,'',0,'');
 LigneVerticale(0,1,28,8,19,27); LigneVerticale(0,1,53,8,19,27);
 EffaceZone(0,2,22,79,25,64);
 Cadre(0,1,3,22,78,25,71,'',0,'');
 AffChXY2(0,5,23,'Dplacez la surbrillance avec ^'#27#26'^ et validez avec ^^',71,79);
 AffChXY2(0,5,24,'ou appuyez sur l''^initiale^ du jeu de votre choix.',71,79);
 AffChXY(0,66,23,'Esc: Quitte',78);
end; {AffichePage}


procedure AfficheTitres;
var c,n: byte;
begin
 for c:=1 to 3 do
  for n:=1 to 10 do
   if 10*(c-1)+n<=nbr_jeux then
    AffChXY(0,c*25-20,8+n,TitreJeu[10*(c-1)+n+premier-1],19);
end; {AfficheTitres}


procedure AfficheAscenseur;
begin
 if premier>1 then AffChXY(0,5,7,' Suite ',27) else AffChXY(0,5,7,'',27);
 if premier<nbr_jeux-29 then AffChXY(0,55,20,' Suite ',27) else AffChXY(0,55,20,'',27);
end; {AfficheAscenseur}


procedure Normal(n_jeu: byte);
begin
 AffChXY(0,4+25*((n_jeu-premier) div 10),9+((n_jeu-premier) mod 10),' '+TitreJeu[n_jeu]+' ',19);
end; {Normal}


procedure Inverse(n_jeu: byte);
const couleur: array[1..12] of byte=(0,1,9,2,10,14,15,14,10,2,9,1);
begin
 AffChXY(0,4+25*((n_jeu-premier) div 10),9+((n_jeu-premier) mod 10),' '+TitreJeu[n_jeu]+' ',couleur[coul]);
 Delay(60);
 inc(coul); if coul>12 then coul:=1;
end; {Inverse}


procedure QuickSort(debut,fin: byte);
var i,j: byte;
    aux1,aux2: string[22];
    aux3: string[42];
begin
 i:=debut; j:=fin; aux1:=TitreJeu[(debut+fin) shr 1];
 repeat
  while TitreJeu[i]<aux1 do inc(i);
  while aux1<TitreJeu[j] do dec(j);
  if i<=j then begin
   aux2:=TitreJeu[i]; TitreJeu[i]:=TitreJeu[j]; TitreJeu[j]:=aux2;
   aux3:=FichierLanceurJeu[i]; FichierLanceurJeu[i]:=FichierLanceurJeu[j]; FichierLanceurJeu[j]:=aux3;
   inc(i); if j>0 then dec(j);
  end;
 until i>j;
 if debut<j then QuickSort(debut,j);
 if i<fin   then QuickSort(i,fin);
end; {QuickSort}


procedure ChercheInitiale(lettre: char);
var i,j,nbr: byte;
begin
 nbr:=0;
 for i:=1 to nbr_jeux do
  if System.UpCase(TitreJeu[i][1])=lettre then begin inc(nbr); j:=i end;
 if nbr>0 then begin
  {j-nbr+1: indice du premier jeu qui commence par l'initiale}
  {j      : indice du dernier jeu qui commence par l'initiale}
  Normal(n_jeu);
  if (n_jeu>=j-nbr+1) and (n_jeu<j) then inc(n_jeu) else n_jeu:=j-nbr+1;
  if (n_jeu<premier) or (n_jeu>premier+29) then begin
   premier:=n_jeu;
   if premier>nbr_jeux-29 then premier:=nbr_jeux-29;
   AfficheTitres;
  end;
 end;
end; {ChercheInitiale}


procedure SelectionneJeu;
var touche: Key;
begin
 repeat
  AfficheAscenseur;
  repeat Inverse(n_jeu) until KeyPressed;

  touche:=UpCase(ReadKey);
  case touche of
   Key('A')..Key('Z'): ChercheInitiale(CHAR(touche));
   Left : if n_jeu>9+premier then begin Normal(n_jeu); dec(n_jeu,10) end;
   Right: if n_jeu<20+premier then begin
           Normal(n_jeu); inc(n_jeu,10);
           if n_jeu>nbr_jeux then n_jeu:=nbr_jeux;
          end;
   Up   : if n_jeu>1 then begin
           Normal(n_jeu); dec(n_jeu);
           if n_jeu<premier then begin
            dec(premier);
            AfficheTitres;
           end;
          end;
   Down : if n_jeu<nbr_jeux then begin
           Normal(n_jeu); inc(n_jeu);
           if n_jeu>premier+29 then begin
            inc(premier);
            AfficheTitres;
           end;
          end;
   Enter: ok:=TRUE;
  end;
 until ok or (touche=Esc);
end; {SelectionneJeu}


procedure ChercheFichierJeux;
const CRLF=#13#10;
var fichier: Text;
    ligne: string[64];
    pos_dollar,pos_point: byte;
    erreur: boolean;

procedure AfficheSyntaxe;
begin
 WriteLn('  Chaque ligne correspond  un jeu du menu, et doit respecter la syntaxe:',CRLF,
         '   NOM DU JEU    $fichier_de_lancement.ext',CRLF,
         '  .ext peut tre .BAT, .COM ou .EXE');
end; {AfficheSyntaxe}

begin  {ChercheFichierJeux}
 Assign(fichier,'JEUX.LIS');
 {$I-}
 Reset(fichier);
 {$I+}
 if IOResult=0 then begin
  erreur:=FALSE;
  while not Eof(fichier) do begin
   ReadLn(fichier,ligne);
   pos_dollar:=Pos('$',ligne);
   pos_point:=Pos('.',ligne);
   if (pos_dollar<3) or (pos_point<5) or (pos_point<>Length(ligne)-3) then begin
    if not(erreur) then WriteLn('Erreur de syntaxe dans la ligne:');
    erreur:=TRUE; WriteLn(ligne);
   end
   else begin
    inc(nbr_jeux);
    TitreJeu[nbr_jeux]:=XString(CopyL(ligne,pos_dollar-1),' ',22);
    FichierLanceurJeu[nbr_jeux]:=Copy(ligne,pos_dollar+1,pos_point+3);
   end;
  end;
  if erreur then begin AfficheSyntaxe; nbr_jeux:=0 end;
  Close(fichier);
 end
 else begin WriteLn('Fichier JEUX.LIS introuvable!'); AfficheSyntaxe end;
end; {ChercheFichierJeux}


BEGIN
 ChercheFichierJeux;
 if nbr_jeux>0 then begin
  Curseur(off);
  CopiePage(0,1); EffacePage(0,7);
  QuickSort(1,nbr_jeux);
  AffichePage; AfficheTitres;
  SelectionneJeu;
  EffacePage(0,7); CopiePage(1,0);
  Curseur(plat);
  if ok then begin
   SwapVectors;
   Exec(GetEnv('COMSPEC'),'/C '+FichierLanceurJeu[n_jeu]);
   SwapVectors;
  end;
 end;
END.
