PROGRAM PAL_PAS;
{convertit les fichiers PAL (palette 16 couleurs) en donnes Turbo-Pascal}

{$A+,G+,Q-,R-,S-}

USES Crt,Dos,Util,Fichiers;

CONST CRLF: array[1..2] of char=#13#10; {retour chariot}

VAR parametre: String80;
    nom_fichier: array[1..512] of String12;
    nbr_fichiers: word;

{==========================================================}

procedure Aide;
begin
 WriteLn(CRLF,'syntaxe: PAL_PAS nom_fichier[.PAL]');
end; {Aide}

{----------------------------------------------------------}

procedure Convertit;

var repert: String80;
    fPAL,fPAS: Fichier;
    n_fich,nbr_fichiers_traites: word;
    i: byte;
    palette: array[1..3*16] of byte;
    ligne: String80;


procedure Affiche(chaine: String80);
begin
 GotoXY(35,WhereY); ClrEol;
 GotoXY(35,WhereY); Write(chaine);
end; {Affiche}

procedure EcritLigne;
begin
 with fPAS do begin Ecrit(ligne[1],Length(ligne)); Ecrit(CRLF,2) end;
end; {EcritLigne}


begin  {Convertit}
 repert:=RepertoireSeul(parametre);
 nbr_fichiers_traites:=0;
 for n_fich:=1 to nbr_fichiers do begin
  Write(CRLF,nom_fichier[n_fich]); GotoXY(15,WhereY);
  fPAL.Ouvre(lecture,repert+nom_fichier[n_fich]);
  case f_erreur of
   f_ok: begin
          if fPAL.Taille=48 then begin
           fPAL.Lit(palette,48);
           dec(nom_fichier[n_fich][0],3); {efface PAL}
           nom_fichier[n_fich]:=nom_fichier[n_fich]+'PAS'; {ajoute PAS}
           Write('->  ',nom_fichier[n_fich]);
           fPAS.Cree(not(teste_existe),repert+nom_fichier[n_fich]);
           case f_erreur of
            f_ok: begin
                   ligne:='CONST '+CopyL(nom_fichier[n_fich],Length(nom_fichier[n_fich])-4)+
                          ': Palette16=(palette:(';
                   EcritLigne;
                   for i:=1 to 16 do begin
                    ligne:='             ('+
                           'R:'+EntierTexte2(palette[3*(i-1)+1],2)+'; '+
                           'V:'+EntierTexte2(palette[3*(i-1)+2],2)+'; '+
                           'B:'+EntierTexte2(palette[3*(i-1)+3],2)+'),';
                    if i=16 then dec(ligne[0]); {efface ','}
                    EcritLigne;
                   end;
                   ligne:='            ));';
                   EcritLigne;
                   fPAS.Ferme;
                   Affiche('ok');
                   inc(nbr_fichiers_traites);
                  end;
            f_err_acces_ref: Affiche('Accs au fichier refus');
            f_err_protect  : begin Affiche('Disquette protge en criture'); break end;
            f_err_pas_pret : begin Affiche('Lecteur pas prt'); break end;
            f_err_CRC..f_err_secteur: Affiche('Erreur d''criture');
           end;
          end
          else Write('Format PAL incorrect: le fichier doit faire 48 octets');
          fPAL.Ferme;
         end;
   f_err_fich_intr: Write('Fichier introuvable');
   f_err_ch_intr  : begin Write('Chemin introuvable'); break end;
   f_err_acces_ref: Write('Accs au fichier refus');
   f_err_pas_pret : begin Write('Lecteur pas prt'); break end;
   f_err_CRC..f_err_secteur: Write('Erreur de lecture');
  end;
 end;
 Write(CRLF,CRLF,nbr_fichiers_traites,' fichier');
 if nbr_fichiers_traites>1 then Write('s');
 Write(' converti');
 if nbr_fichiers_traites>1 then Write('s');
 if nbr_fichiers>1 then Write(' sur ',nbr_fichiers);
 WriteLn;
end; {Convertit}

{----------------------------------------------------------}

procedure ChercheFichiers;
var fichier: SearchRec;
begin
 nbr_fichiers:=0;
 FindFirst(parametre,Archive,fichier);
 case DosError of
  0 : repeat
       inc(nbr_fichiers);
       nom_fichier[nbr_fichiers]:=fichier.Name;
       FindNext(fichier);
      until DosError=18;
  2,18: WriteLn(CRLF,'Fichier introuvable');
  3   : WriteLn(CRLF,'Chemin introuvable');
  8   : WriteLn(CRLF,'Mmoire insuffisante');
  100 : WriteLn(CRLF,'Erreur de lecture');
  152 : WriteLn(CRLF,'Lecteur pas prt');
 end;
end; {ChercheFichiers}

{==========================================================}

BEGIN
 WriteLn(CRLF,'PAL_PAS v1.1 - (c) 1998 Fabrice Couteau',CRLF,
         'Convertisseur de fichiers PAL (palette 16 couleurs) en donnes Turbo-Pascal');
 if ParamCount<>1 then Aide
 else begin
  parametre:=ParamStr(1);
  if Pos('.',parametre)=0 then parametre:=parametre+'.PAL';
  ChercheFichiers;
  if nbr_fichiers>0 then Convertit;
 end;
END.
