PROGRAM Paroles;
{$A+,G+,Q-,R-,S-}

USES Crt,Dos,Util,Fichiers;

CONST CRLF=#13#10;

VAR rep: string[80];

{ format de PAROLES.TXT
  =====================

  :auteur 1
  citation 1
  citation 2
  

  :auteur 2
  
  
  

  caractres spciaux dans une citation
  =====================================

  /  provoque un retour  la ligne  l'affichage
  \  prolongateur de citation>255 caractres (un en fin de ligne+un en dbut de ligne suivante)
  $  indicateur de nom d'oeuvre ( placer aprs la citation et avant le nom de l'oeuvre)


  format de PAROLES.DAT
  =====================

  Ŀ
  4 3 2 1   table     liste d'auteurs  
  
   \_____/
      
       date&heure du fichier PAROLES.TXT au moment de la conversion (LONGINT)

  table (1024 entres):
  Ŀ
  4 3 2 1        4 3 2 1
  
   \_____/             \_____/
                          offset dans le fichier de l'lment de liste d'auteur n1024 (LONGINT)
       offset dans le fichier de l'lment de liste d'auteur n1 (LONGINT)

  lment de liste d'auteurs:
  Ŀ
  11 nom auteur  liste de citations 
  
   V V
     longueur du nom de l'auteur (BYTE)
    nombre de citations de l'auteur (BYTE)

  lment de liste de citations:
  Ŀ
  2 1 citation 
  
   \_/
    
     longueur de la citation (WORD)
}


procedure Aide;
begin
 Write('PAROLES v1.1 - Gnrateur de paroles alatoires - (c) 1998 Fabrice Couteau',CRLF,
       'usage: PAROLES         Affiche une parole (mise  jour automatique)',CRLF,
       '       PAROLES /MAJ    Mise  jour de PAROLES.DAT  partir de PAROLES.TXT',CRLF,
       '       PAROLES /REG    Regnration de PAROLES.TXT  partir de PAROLES.DAT',CRLF);
end; {Aide}


procedure TXT_DAT;

var f_in: Text;
    f_out: Fichier;
    t: longint;

    ligne: string;
    tampon: array[0..1023] of char;

    table: array[1..1024] of longint;
    nbr_auteurs,total_citations: word;
    p,nbr_citations: byte;
    taille_enreg,long_citation: word;


procedure MAJ_enreg;
var p: longint;
begin
 if taille_enreg<>0 then begin
  p:=f_out.Pointeur;
  f_out.DeplacePointeur(-taille_enreg);
  f_out.Ecrit(nbr_citations,sizeof(nbr_citations)); {nombre de citations de l'auteur}
  f_out.PlacePointeur(p);
 end;
end;


begin
 Assign(f_in,rep+'PAROLES.TXT');
 {$I-}
 Reset(f_in);
 {$I+}
 if IOResult<>0 then begin Writeln('Fichier PAROLES.TXT introuvable'); halt end;

 f_out.Cree(ecrase,rep+'PAROLES.DAT');
 if f_erreur<>f_ok then begin Writeln('Impossible de crer PAROLES.DAT'); halt end;

 Write('Mise  jour...');

 GetFTime(f_in,t);
 f_out.Ecrit(t,sizeof(t)); {date&heure du fichier PAROLES.TXT}

 FillChar(table,sizeof(table),0);
 f_out.Ecrit(table,sizeof(table)); {table d'offsets auteurs (nulle pour l'instant...)}

 nbr_auteurs:=0;
 total_citations:=0;
 taille_enreg:=0;

 t:=Timer;

 while not eof(f_in) do begin
  if Timer>t+3 then
   begin t:=Timer; GotoXY(16,WhereY); Write(nbr_auteurs,' auteurs') end;

  Readln(f_in,ligne);
  if ligne='' then continue;

  if ligne[1]=':' then begin  {nom d'auteur}
   inc(nbr_auteurs);
   table[nbr_auteurs]:=f_out.Pointeur;

   Delete(ligne,1,1);

   MAJ_enreg;

   taille_enreg:=0;
   nbr_citations:=0;
   long_citation:=0;
   f_out.Ecrit(nbr_citations,sizeof(nbr_citations)); {nombre de citations de l'auteur=0 car pas encore comptes}
   f_out.Ecrit(ligne,1+Length(ligne)); {longueur+nom de l'auteur}

   inc(taille_enreg,sizeof(nbr_citations)+1+Length(ligne));
  end
  else begin
   if ligne[1]='\' then Delete(ligne,1,1); {poursuite de la citation}

   p:=Pos('\',ligne);
   if p<>0 then ligne:=Copy(ligne,1,p-1); {tronque la ligne avant le '\'}

   Move(ligne[1],tampon[long_citation],Length(ligne)); {ajoute la ligne dans le tampon-citation}
   inc(long_citation,Length(ligne));

   if p=0 then begin  {fin de citation, vide le tampon}
    inc(nbr_citations); inc(total_citations);

    f_out.Ecrit(long_citation,sizeof(long_citation));
    f_out.Ecrit(tampon,long_citation);

    inc(taille_enreg,sizeof(long_citation)+long_citation);
    long_citation:=0;
   end;
  end;
 end;

 MAJ_enreg;

 f_out.PlacePointeur(sizeof(t));
 f_out.Ecrit(table,sizeof(table)); {table d'offsets auteurs}

 f_out.Ferme;
 Close(f_in);

 GotoXY(1,WhereY); ClrEol; Writeln(nbr_auteurs,' auteurs / ',total_citations,' citations.');
end; {TXT_DAT}



procedure DAT_TXT;

var f_in: Fichier;
    f_out: Text;
    t: longint;

    ligne: string;
    tampon: array[0..1023] of char;

    table: array[1..1024] of longint;
    nbr_auteurs,auteur,total_citations: word;
    nbr_citations,citation: byte;
    long_citation,i,p: word;

begin
 f_in.Ouvre(lecture,rep+'PAROLES.DAT');
 if f_erreur<>f_ok then begin Writeln('Fichier PAROLES.DAT introuvable'); halt end;

 Assign(f_out,rep+'PAROLES.TXT');
 {$I-}
 Rewrite(f_out);
 {$I+}
 if IOResult<>0 then begin Writeln('Impossible de crer PAROLES.TXT'); halt end;

 Write('Regnration...');

 f_in.LitPos(sizeof(t),table,sizeof(table)); {table d'offsets auteurs}
 nbr_auteurs:=0;
 while table[nbr_auteurs+1]<>0 do inc(nbr_auteurs); {compte le nombre d'auteurs}

 auteur:=0;
 total_citations:=0;

 t:=Timer;

 for auteur:=1 to nbr_auteurs do begin
  if Timer>t+3 then
   begin t:=Timer; GotoXY(17,WhereY); Write(auteur,'/',nbr_auteurs,' auteurs') end;

  f_in.Lit(nbr_citations,sizeof(nbr_citations)); {nombre de citations de l'auteur}
  inc(total_citations,nbr_citations);

  f_in.Lit(ligne[0],1); {longueur du nom de l'auteur}
  f_in.Lit(ligne[1],BYTE(ligne[0])); {nom de l'auteur}
  Writeln(f_out,':'+ligne); {longueur+nom de l'auteur}

  for citation:=1 to nbr_citations do begin
   f_in.Lit(long_citation,sizeof(long_citation)); {longueur de la citation}
   f_in.Lit(tampon,long_citation); {longueur de la citation}
   p:=0; {compteur de caractres}
   for i:=0 to long_citation-1 do begin  {citation}
    if (i>0) and (i<long_citation-1) then
     if (p mod 254)=0 then
      begin Write(f_out,'\'+CRLF+'\'); inc(p,2) end; {retour  la ligne et poursuite}
     Write(f_out,tampon[i]);
     inc(p);
   end;
   Writeln(f_out);
  end;

  Writeln(f_out);
 end;

 Close(f_out);
 f_in.Ferme;

 GotoXY(1,WhereY); ClrEol; Writeln(nbr_auteurs,' auteurs / ',total_citations,' citations.');
end; {DAT_TXT}



procedure AfficheParole;

var f: Fichier;
    f_txt: Text;
    t,t_txt: longint;

    table: array[1..1024] of longint;
    nbr_auteurs,auteur: word;
    nbr_citations,citation: byte;
    long_citation,i,j: word;

    tampon: array[0..1023] of char;
    nom_auteur,nom_oeuvre: string[50];
    mot: string[25];


procedure Ecrit(mot: string);
begin
 if WhereX+Length(mot)-1>80 then Writeln;
 Write(mot);
end; {Ecrit}


begin  {AfficheParoles}
 repeat
  repeat
   f.Ouvre(lecture,rep+'PAROLES.DAT');
   if f_erreur=f_ok then break else TXT_DAT; {PAROLES.DAT introuvable -> cration}
  until false;
  f.Lit(t,sizeof(t)); {date&heure du fichier PAROLES.TXT au moment de la cration de PAROLES.DAT}

  Assign(f_txt,rep+'PAROLES.TXT');
  {$I-}
  Reset(f_txt);
  {$I+}
  if IOResult=0 then begin  {si PAROLES.TXT existe, contrle des date&heure}
   GetFTime(f_txt,t_txt); {date&heure du fichier PAROLES.TXT actuel}
   Close(f_txt);

   if t<>t_txt then begin  {date&heure diffrentes -> mise  jour automatique de PAROLES.DAT}
    f.Ferme;
    TXT_DAT;
    continue; {rouvre le fichier PAROLES.DAT}
   end
   else break;
  end
  else break;
 until false;

 f.Lit(table,sizeof(table)); {table d'offsets auteurs}
 nbr_auteurs:=0;
 while table[nbr_auteurs+1]<>0 do inc(nbr_auteurs); {compte le nombre d'auteurs}

 Randomize;
 auteur:=1+Random(nbr_auteurs); {choix d'un auteur}
 f.PlacePointeur(table[auteur]);

 f.Lit(nbr_citations,sizeof(nbr_citations));
 citation:=1+Random(nbr_citations); {choix d'une citation}

 f.Lit(nom_auteur[0],1); {longueur du nom de l'auteur}
 f.Lit(nom_auteur[1],BYTE(nom_auteur[0])); {nom de l'auteur}

 {positionnement sur la citation}
 for i:=1 to citation-1 do begin
  f.Lit(long_citation,sizeof(long_citation));
  f.DeplacePointeur(long_citation); {saute la citation}
 end;

 f.Lit(long_citation,sizeof(long_citation)); {longueur de la citation}
 f.Lit(tampon,long_citation); {texte de la citation}

 f.Ferme;

 nom_oeuvre:='';

 {affichage de la citation mot par mot}
 TextColor(LIGHTGRAY); Writeln;
 mot:='';
 for i:=0 to long_citation-1 do
  case tampon[i] of
   ' ': begin Ecrit(mot+' '); mot:='' end;
   '/': begin Ecrit(mot+CRLF); mot:='' end;
   '\': break;
   '$': begin
         for j:=i+1 to long_citation-1 do nom_oeuvre:=nom_oeuvre+tampon[j];
         break;
        end;
   else mot:=mot+tampon[i];
  end;
 Ecrit(mot);

 {affiche la citation, son auteur et son oeuvre}
 Write(CRLF,'':(80-Length(nom_auteur)-2-Length(nom_oeuvre)) div 2);
 TextColor(WHITE); Write(nom_auteur);
 TextColor(YELLOW); Write('  ',nom_oeuvre);
 TextColor(LIGHTGRAY); Writeln;
end; {AfficheParole}



VAR p: string[5];

BEGIN
 rep:=RepertoireSeul(ParamStr(0))+'\'; {rpertoire de l'excutable}

 case ParamCount of
  0: AfficheParole;
  1: begin
      p:=Maj(ParamStr(1));
      if p[1]='/' then Delete(p,1,1);
      if p='MAJ' then TXT_DAT
      else if p='REG' then DAT_TXT else Aide;
     end;
  else Aide;
 end;
END.
