{$A+,G+,N+,Q-,R-,S-}

USES Clavier,Util,Graph;

CONST {longueur de l'chantillon}
      long_ech=640*5;

      {frquences du signal test}
      fondamental=11;
      harmonique1=10*fondamental;
      harmonique2=50*fondamental;

      nbr_pages=1+((long_ech-1) div 640);

TYPE T_int  =array[0..long_ech-1] of integer;
     T_short=array[0..long_ech-1] of shortint;

VAR calcul: ^T_int;
    sample: ^T_short;


procedure Ecretage;
var i: word;
begin
 SetColor(WHITE);
 OutTextXY(100,20,'Ecretage...');

 for i:=0 to long_ech-1 do begin
  if calcul^[i]>+127 then sample^[i]:=+127
  else
   if calcul^[i]<-128 then sample^[i]:=-128
    else sample^[i]:=calcul^[i];
 end;
end;


procedure GenereSon;
var i: word;
begin
 SetColor(WHITE);
 OutTextXY(0,20,'Calcul...');

 New(calcul);

 for i:=0 to long_ech-1 do
  calcul^[i]:=Round(80*sin(2*PI*fondamental*i/long_ech)+
                    30*sin(2*PI*harmonique1*i/long_ech)+
                    15*sin(2*PI*harmonique2*i/long_ech));

 Ecretage;
 Dispose(calcul);
end;


procedure Echo(periode_echo: word; amplitude_echo: real);
var i: word;
begin
 SetColor(WHITE);
 OutTextXY(0,20,'Echo...');

 New(calcul);

 for i:=0 to long_ech-1 do calcul^[i]:=sample^[i];
 i:=periode_echo;
 repeat
  calcul^[i]:=Round(amplitude_echo*calcul^[i-periode_echo+1]);
  inc(i,2)
 until i>long_ech-1;

{ for i:=long_ech-1 downto periode_echo do
  inc(calcul^[i],Round(amplitude_echo*calcul^[i-periode_echo]));}

 Ecretage;
 Dispose(calcul);
end;


procedure FiltrePasseBas(f0: word);
{         K
  F(p)=
       1+(p/w0)

        -w0.T
  S  = e     .S    + K.w0.E
   k           k-1         k

   -w0.T
  e      + K.w0 = 1
}
const T=1/16000; {priode d'chantillonnage}

var w0,A,B: real;
    i: word;

begin
 SetColor(WHITE);
 OutTextXY(0,20,'Filtrage...');

 New(calcul);

 for i:=0 to long_ech-1 do calcul^[i]:=sample^[i];
 w0:=2*PI*f0;
 A:=exp(-w0*T); B:=1-A;
 for i:=1 to long_ech-1 do
  calcul^[i]:=Round(A*calcul^[i-1]+B*calcul^[i]);

 Ecretage;
 Dispose(calcul);
end;


procedure FiltrePasseHaut(f0: word);
{c'est un 'faux' filtre qui calcule simplement la diffrence entre le
 signal d'origine et le mme signal filtr passe-bas :) }
var i: word;
    temp: ^T_short;
begin
 New(temp);

 Move(sample^,temp^,long_ech);
 FiltrePasseBas(f0);
 for i:=0 to long_ech-1 do sample^[i]:=temp^[i]-sample^[i];

 Dispose(temp);
end;


procedure FiltrePasseBande(f1,f2: word);
begin
 FiltrePasseHaut(f1);
 FiltrePasseBas(f2);
end;


procedure Lissage;
var i: word;
begin
 SetColor(WHITE);
 OutTextXY(0,20,'Lissage...');

 for i:=1 to long_ech-1 do sample^[i]:=(sample^[i-1]+sample^[i]) div 2;
end;


CONST page: byte=1;

VAR gd,gm: integer;

    i,j: word;
    touche: Key;

BEGIN
 gd:=VGA;
 gm:=VGAHi;
 InitGraph(gd,gm,'C:\BP7\BGI');

 New(sample);

 GenereSon;

 repeat
  {efface la zone de texte}
  SetFillStyle(SolidFill,BLACK);
  Bar(0,0,GetMaxX,30);

  {affiche ligne horizontale niveau 0}
  SetColor(LIGHTGRAY);
  Line(0,GetMaxY div 2,GetMaxX,GetMaxY div 2);

  {affiche l'onde}
  SetColor(LIGHTGREEN);
  MoveTo(0,GetMaxY div 2+sample^[0+GetMaxX*(page-1)]);
  for i:=1 to GetMaxX do
   LineTo(i,GetMaxY div 2+sample^[i+GetMaxX*(page-1)]);

  {affiche le n de page}
  SetColor(WHITE);
  OutTextXY(560,20,EntierTexte2(page,3)+'/'+EntierTexte2(nbr_pages,3));

  touche:=Upcase(Readkey);

  {efface l'onde}
  SetColor(BLACK);
  MoveTo(0,GetMaxY div 2+sample^[0+GetMaxX*(page-1)]);
  for i:=1 to GetMaxX do
   LineTo(i,GetMaxY div 2+sample^[i+GetMaxX*(page-1)]);

  case touche of
   Esc: break;

   Key('E'): Echo(160,0.25);
   Key('B'): FiltrePasseBas(20*fondamental);
   Key('H'): FiltrePasseHaut((harmonique1+harmonique2) div 2);
   Key('P'): FiltrePasseBande(harmonique1,harmonique1*2);
   Key('L'): Lissage;

   Left : if page>1 then dec(page);
   Right: if page<nbr_pages then inc(page);

   Enter: begin GenereSon; page:=1 end;
  end;

 until FALSE;

 Dispose(sample);

 CloseGraph;
END.
