PROGRAM SCR_TXT; {convertit les fichiers SCREENER en ASCII}
{$A+,G+,Q-,R-,S-}

USES Crt,Dos,Util,Fichiers;

CONST CRLF: array[1..2] of char=#13#10; {retour chariot}

      car_imprimables: boolean=FALSE; {par dfaut, utilise tous les codes ASCII}

VAR parametre: String80;
    nom_fichier: array[1..512] of String12;
    nbr_fichiers: word;

{==========================================================}

procedure Aide;
begin
 WriteLn(CRLF,'syntaxe: SCR_TXT nom_fichier[.SCR] [options]',
         CRLF,'options: /I  ne gnre que des caractres imprimables',
         CRLF,'             (codes ASCII 7  15 et 27 ignors)');
end; {Aide}

{----------------------------------------------------------}

procedure Convertit;

var repert: String80;
    fSCR,fTXT: Fichier;
    n_fich,nbr_fichiers_traites: word;
    entete: record
             xg,yh,xd,yb: word;
            end;
    x,y,largeur: byte;
    ligneSCR: array[1..80] of word;
    ligneTXT: array[1..80] of char;


procedure Affiche(chaine: String80);
begin
 GotoXY(35,WhereY); ClrEol;
 GotoXY(35,WhereY); Write(chaine);
end; {Affiche}

procedure EcritLigne;
begin
 with fTXT do begin Ecrit(ligneTXT[1],largeur); Ecrit(CRLF,2) end;
end; {EcritLigne}


begin  {Convertit}
 repert:=RepertoireSeul(parametre);
 nbr_fichiers_traites:=0;
 for n_fich:=1 to nbr_fichiers do begin
  Write(CRLF,nom_fichier[n_fich]); GotoXY(15,WhereY);
  fSCR.Ouvre(lecture,repert+nom_fichier[n_fich]);
  case f_erreur of
   f_ok: begin
          fSCR.Lit(entete,4*2);
          with entete do begin
           largeur:=xd-xg+1;
           if (2*largeur*(yb-yh+1)+4*2<>fSCR.Taille) or
              (xg>xd) or (yh>yb) or (xd>80) or (yb>50) then
            Write('Format SCR incorrect!')
           else begin
            dec(nom_fichier[n_fich][0],3); {efface SCR}
            nom_fichier[n_fich]:=nom_fichier[n_fich]+'TXT'; {ajoute TXT}
            Write('->  ',nom_fichier[n_fich]);
            fTXT.Cree(not(teste_existe),repert+nom_fichier[n_fich]);
            case f_erreur of
             f_ok: begin
                    fSCR.PlacePointeur(4*2);
                    for y:=yh to yb do begin
                     fSCR.Lit(ligneSCR,2*largeur);
                     if not(car_imprimables) then
                      for x:=1 to largeur do ligneTXT[x]:=CHAR(ligneSCR[x])
                     else
                      for x:=1 to largeur do
                       if (ligneSCR[x] in [7..15,27]) then ligneTXT[x]:=' '
                                                      else ligneTXT[x]:=CHAR(ligneSCR[x]);
                     EcritLigne;
                    end;
                    fTXT.Ferme;
                    Affiche('ok');
                    inc(nbr_fichiers_traites);
                   end;
             f_err_acces_ref: Affiche('Accs au fichier refus');
             f_err_protect  : begin Affiche('Disquette protge en criture'); break end;
             f_err_pas_pret : begin Affiche('Lecteur pas prt'); break end;
             f_err_CRC..f_err_secteur: Affiche('Erreur d''criture');
            end;
           end;
          end;
          fSCR.Ferme;
         end;
   f_err_fich_intr: Write('Fichier introuvable');
   f_err_ch_intr  : begin Write('Chemin introuvable'); break end;
   f_err_acces_ref: Write('Accs au fichier refus');
   f_err_pas_pret : begin Write('Lecteur pas prt'); break end;
   f_err_CRC..f_err_secteur: Write('Erreur de lecture');
  end;
 end;
 Write(CRLF,CRLF,nbr_fichiers_traites,' fichier');
 if nbr_fichiers_traites>1 then Write('s');
 Write(' converti');
 if nbr_fichiers_traites>1 then Write('s');
 if nbr_fichiers>1 then Write(' sur ',nbr_fichiers);
 WriteLn;
end; {Convertit}

{----------------------------------------------------------}

procedure ChercheFichiers;
var fichier: SearchRec;
begin
 nbr_fichiers:=0;
 FindFirst(parametre,Archive,fichier);
 case DosError of
  0 : repeat
       inc(nbr_fichiers);
       nom_fichier[nbr_fichiers]:=fichier.Name;
       FindNext(fichier);
      until DosError=18;
  2,18: WriteLn(CRLF,'Fichier introuvable');
  3   : WriteLn(CRLF,'Chemin introuvable');
  8   : WriteLn(CRLF,'Mmoire insuffisante');
  100 : WriteLn(CRLF,'Erreur de lecture');
  152 : WriteLn(CRLF,'Lecteur pas prt');
 end;
end; {ChercheFichiers}

{==========================================================}

BEGIN
 WriteLn(CRLF,'SCR_TXT v1.1 - (c) 1998 Fabrice Couteau',CRLF,
              'Convertisseur de fichiers Screener en ASCII');
 if not(ParamCount in [1,2]) then Aide
 else begin
  if ParamCount=2 then begin
   parametre:=ParamStr(2);
   if (parametre[1] in ['/','-']) then Delete(parametre,1,1);
   case UpCase(parametre[1]) of
    'I': car_imprimables:=TRUE;
    else begin Aide; halt end;
   end;
  end;
  parametre:=ParamStr(1);
  if Pos('.',parametre)=0 then parametre:=parametre+'.SCR';
  ChercheFichiers;
  if nbr_fichiers>0 then Convertit;
 end;
END.
