PROGRAM Stat; {Affiche des statistiques de dmarrage}
{$A+,G+,Q-,R-,S-}

USES Clavier,Fichiers,Texte,Util;

CONST max_dem =10000;         {nombre maxi de dmarrages}

      max_annees=20;          {nombre maxi d'annes}
      max_sem =52*max_annees; {nombre maxi de semaines}
      max_mois=12*max_annees; {nombre maxi de mois}

      LUNDI   =1;
      MARDI   =2;
      MERCREDI=3;
      JEUDI   =4;
      VENDREDI=5;
      SAMEDI  =6;
      DIMANCHE=7;
      NomJour: array[LUNDI..DIMANCHE] of STRING[8]=
                ('Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi','Dimanche');

      JANVIER  =1;
      FEVRIER  =2;
      MARS     =3;
      AVRIL    =4;
      MAI      =5;
      JUIN     =6;
      JUILLET  =7;
      AOUT     =8;
      SEPTEMBRE=9;
      OCTOBRE  =10;
      NOVEMBRE =11;
      DECEMBRE =12;
      NomMois: array[JANVIER..DECEMBRE] of STRING[9]=
                ('Janvier','Fvrier','Mars','Avril','Mai','Juin','Juillet',
                 'Aot','Septembre','Octobre','Novembre','Dcembre');

      NombreJoursDansMois: array[JANVIER..DECEMBRE] of BYTE=
                            (31,29,31,30,31,30,31,31,30,31,30,31);

TYPE DateHeure=LONGINT;

VAR date_dem: array[1..max_dem] of DateHeure;
    couleur_dem: array[1..max_dem] of BYTE;
    mois_dem: array[1..max_mois] of WORD;

    nombre_demarrages: WORD;

CONST {formats de date/heure}
      jour_complet  =$01; {<nom_jour>}
      jour_reduit   =$02; {<nom_jour> sur 3 caractres}
      date_complete =$04; {<date> <mois> <anne>}
      date_reduite  =$08; {DD/MM/AA}
      heure_complete=$10; {HH:MM:SS}
      heure_reduite =$20; {HHhMM}

      {masques}
      masque_date =$FFFF8000; {jour+date+mois+anne}
      masque_heure=$00007FFF; {heures+minutes+secondes}

{ 31           24 23           16 15            8 7             0
 Ŀ
                                                          
 
 \jour /\ date  /\ mois /\  anne  /\ heures /\ minutes  /\ sec. /

  1=Lun   1..31    1..12    0=1990     0..23     0..59      0=0
  .                         .                               .
  .                         .                               .
  7=Dim                    31=2021                         14=56   }

{=========================================================}

function Compacte(jour,date,mois: BYTE; annee: WORD; heures,minutes,secondes: BYTE): DateHeure;
begin
 Compacte:=(LONGINT(jour) shl 29)+
           (LONGINT(date) shl 24)+
           (LONGINT(mois) shl 20)+
           ((LONGINT(annee)-1990) shl 15)+
           (LONGINT(heures)  shl 10)+
           (LONGINT(minutes) shl  4)+
           (secondes div 4);
end; {Compacte}

{---------------------------------------------------------}

function Decompacte(date_heure: DateHeure;
                    var jour,date,mois: BYTE; var annee: WORD; var heures,minutes,secondes: BYTE): BOOLEAN;
begin
 jour    :=(date_heure shr 29) and $07;
 date    :=(date_heure shr 24) and $1F;
 mois    :=(date_heure shr 20) and $0F;
 annee   :=1990+((date_heure shr 15) and $1F);
 heures  :=(date_heure shr 10) and $1F;
 minutes :=(date_heure shr  4) and $3F;
 secondes:=4*(date_heure and $0F);

 Decompacte:=(jour>=LUNDI) and (jour<=DIMANCHE) and
             (date>=1) and (date<=31) and
             (mois>=JANVIER) and (mois<=DECEMBRE) and
             (date<=NombreJoursDansMois[mois]) and
             (heures<=23) and (minutes<=59) and (secondes<=59);
end; {Decompacte}

{---------------------------------------------------------}

function DateASCII(date_heure: DateHeure; format_date: BYTE): string80;
var jour,date,mois,heures,minutes,secondes: BYTE;
    annee: WORD;
    chaine: string80;
begin
 Decompacte(date_heure,jour,date,mois,annee,heures,minutes,secondes);
 chaine:='';

 case format_date and (jour_complet or jour_reduit) of
  jour_complet: chaine:=chaine+NomJour[jour]+' ';
  jour_reduit : chaine:=chaine+Copy(NomJour[jour],1,3)+' ';
 end;

 case format_date and (date_complete or date_reduite) of
  date_complete: chaine:=chaine+EntierTexte2(date,1)+' '+NomMois[mois]+' '+EntierTexte2(annee,4);
  date_reduite : chaine:=chaine+EntierTexte2(date,2+et_zeros)+'/'+
                                EntierTexte2(mois,2+et_zeros)+'/'+
                                EntierTexte2(annee mod 100,2+et_zeros);
 end;

 case format_date and (heure_complete or heure_reduite) of
  heure_complete: chaine:=chaine+'  '+EntierTexte2(heures,2+et_zeros)+':'+
                                       EntierTexte2(minutes,2+et_zeros)+':'+
                                       EntierTexte2(secondes,2+et_zeros);
  heure_reduite : chaine:=chaine+'  '+EntierTexte2(heures,2+et_zeros)+'h'+
                                       EntierTexte2(minutes,2+et_zeros);
 end;

 DateASCII:=chaine;
end; {DateASCII}

{---------------------------------------------------------}

function NombreJoursEntre(date_heure_inf, date_heure_sup: DateHeure): WORD;
{renvoie le nombre de jours sparant les deux dates}
var jour,date_inf,date_sup,mois_inf,mois_sup,heures,minutes,secondes: BYTE;
    annee_inf,annee_sup,nombre_jours: WORD;
begin
 Decompacte(date_heure_inf,jour,date_inf,mois_inf,annee_inf,heures,minutes,secondes);
 Decompacte(date_heure_sup,jour,date_sup,mois_sup,annee_sup,heures,minutes,secondes);
 nombre_jours:=0;

 while not((date_inf=date_sup) and (mois_inf=mois_sup) and (annee_inf=annee_sup)) do begin
  inc(nombre_jours);
  inc(date_inf);
  if date_inf>NombreJoursDansMois[mois_inf] then begin
   date_inf:=1;
   inc(mois_inf);
   if mois_inf>DECEMBRE then begin mois_inf:=JANVIER; inc(annee_inf) end;
  end;
 end;

 NombreJoursEntre:=nombre_jours;
end; {NombreJoursEntre}

{---------------------------------------------------------}

function DatePlusJours(date_heure: DateHeure; nombre_jours: SHORTINT): DateHeure;
{renvoie la date = 'date_heure'+'nombre_jours'}
var j,jour,date,mois,heures,minutes,secondes: BYTE;
    annee: WORD;
begin
 Decompacte(date_heure,jour,date,mois,annee,heures,minutes,secondes);

 if nombre_jours>0 then
  for j:=1 to nombre_jours do begin
   jour:=1+(jour mod 7);
   inc(date);
   if date>NombreJoursDansMois[mois] then begin
    date:=1;
    inc(mois);
    if mois>DECEMBRE then begin mois:=JANVIER; inc(annee) end;
   end;
  end
 else
  for j:=1 to -nombre_jours do begin
   jour:=1+((jour+5) mod 7);
   dec(date);
   if date<1 then begin
    dec(mois);
    if mois<JANVIER then begin mois:=DECEMBRE; dec(annee) end;
    date:=NombreJoursDansMois[mois];
   end;
  end;

 DatePlusJours:=Compacte(jour,date,mois,annee,heures,minutes,secondes);
end; {DatePlusJours}

{---------------------------------------------------------}

procedure AfficheStatistiques;

const premiere_heure=5;

      {hauteur de la fentre de liste}
      hauteur_fen=24;

      {modes d'affichage des statistiques}
      aff_liste_dem=1; {liste des dmarrages}
      aff_dem_heure=2; {histogramme dmarrages par heure}
      aff_dem_mois =3; {histogramme/liste dmarrages par mois}

      {noms des modes}
      nom_mode: array[aff_liste_dem..aff_dem_mois] of STRING[20]=
                ('Liste des dmarrages',
                 'Dmarrages par heure',
                 'Dmarrages par mois');

      {modes d'affichage des bargraphs}
      bg_plein=1; {plein '' avec demi-caractre ''}
      bg_trans=2; {transparent (conserve le caractre et change la couleur)}

var date_courante,date_precedente,dernier_lundi,ancien_dernier_lundi,
    date_record_demarrages,lundi_semaine_record_demarrages,
    date_fin_record_activite,date_fin_record_inactivite: DateHeure;

    nombre_jours_total,nombre_jours_demarrages,nombre_semaines_demarrages,
    nombre_max_dem_par_jour,nombre_max_dem_par_heure,
    nombre_jours,compteur_dem_par_jour,compteur_dem_par_semaine,
    nombre_record_dem_par_semaine,nombre_record_dem_par_jour,
    nombre_record_jours_activite,compteur_jours_activite,
    nombre_record_jours_inactivite: WORD;

    nombre_dem_par_jour: array[LUNDI..DIMANCHE] of WORD;
    nombre_dem_par_heure: array[0..23] of WORD;

    h,jour,date,mois,heures,minutes,secondes,couleur,
    mois_premier_dem,mois_dernier_dem: BYTE;

    i,annee,premiere_date,premier_mois,nombre_mois,
    annee_premier_dem,annee_dernier_dem,nombre_max_dem_par_mois: WORD;
    m: INTEGER;

    mode_aff,anc_mode: BYTE;
    z: Zone;


procedure Fenetre(xg,yh,xd,yb: BYTE; titre: string25);
begin
 LigneHorizontale(0,1,yh,xg,xd,16*7);
 EffaceZone(0,xg,yh+1,xd,yb,16*8);
 AffChXY(0,(xg+xd-Length(titre)-1) div 2,yh,' '+titre+' ',16*7);
end; {Fenetre}


procedure AfficheAscenseur(x_asc,y_asc,hauteur_fenetre: BYTE; longueur_liste,index_premier: WORD; attribut: BYTE);
{conditions: hauteur_fenetre>5
             longueur_liste>hauteur_fenetre
             1  index_premier  longueur_liste-hauteur_fenetre+1}
var h_asc,pos_asc: BYTE;
    ptr_VRAM: POINTER;
begin
 h_asc:=1+Round((hauteur_fenetre-4)*(hauteur_fenetre-1)/(longueur_liste-2)); {hauteur barre ascenseur}
 pos_asc:=1+Round(LONGINT((index_premier-1))*(hauteur_fenetre-2-h_asc)/(longueur_liste-hauteur_fenetre)); {position ascenseur}
 ptr_VRAM:=PtrVRAM(0,x_asc,y_asc); {pointeur sur la page n0}

 asm
  cld
  les DI,ptr_VRAM

  mov WORD(ES:[DI]),256*(16*8+14)+''
  add DI,2*80

  xor CH,CH
  mov CL,pos_asc
  dec CL
  mov BL,CL         {BL=CL=pos_asc-1}
  jcxz @barre_ascenseur
  mov AX,256*(16*8+7)+''
 @affiche_zone_sombre_sup:
  stosw
  add DI,2*79
  loop @affiche_zone_sombre_sup

 @barre_ascenseur:
  mov AH,attribut
  mov AL,''
  mov CL,h_asc
 @affiche_barre_ascenseur:
  stosw
  add DI,2*79
  loop @affiche_barre_ascenseur

  mov CL,hauteur_fenetre
  dec CL
  dec CL
  sub CL,h_asc
  sub CL,BL         {CL=(hauteur_fenetre-2)-h_asc-(pos_asc-1)}
  jcxz @fleche_bas

  mov AX,256*(16*8+7)+''
 @affiche_zone_sombre_inf:
  stosw
  add DI,2*79
  loop @affiche_zone_sombre_inf

 @fleche_bas:
  mov WORD(ES:[DI]),256*(16*8+14)+''
 end;
end; {AfficheAscenseur}


procedure BarGraph(mode,x,y,largeur: BYTE; curseur,maxi: WORD);
var nombre_points,couleur,i: BYTE;
begin
 if maxi<>0 then begin
  nombre_points:=(2*largeur*curseur) div maxi;
  if (nombre_points=0) and (curseur<>0) then nombre_points:=1;
 end
 else nombre_points:=0;

 if curseur<=(maxi div 3) then couleur:=10
 else if curseur<=(2*maxi div 3) then couleur:=14 else couleur:=12;

 AdrTexte:=PtrVRAM(0,x,y);
 case mode of
  bg_plein: begin
             AttrTexte:=16*8+couleur;
             for i:=1 to (nombre_points div 2) do AffCar('');
             if Odd(nombre_points) then AffCar('');
            end;

  bg_trans: begin
             inc(BytePtr(AdrTexte));
             for i:=1 to (nombre_points div 2) do
              begin BytePtr(AdrTexte)^:=16*couleur+8; inc(AdrTexte) end;
             dec(BytePtr(AdrTexte));
             if Odd(nombre_points) and (CharPtr(AdrTexte)^=' ') then begin
              AttrTexte:=16*8+couleur;
              AffCar('');
             end;
            end;
 end;
end; {BarGraph}


function PourCentReel(valeur,valeur_max: WORD): REAL;
begin
 if valeur<=valeur_max then PourCentReel:=100*LONGINT(valeur)/valeur_max
                       else PourCentReel:=100*LONGINT(valeur_max)/valeur;
end; {PourCentReel}


begin {AfficheStatistiques}
 InitTexte(25);
 Curseur(off);
 Clignotement(FALSE);

 AffChXY(0, 1,1,' Statistiques de dmarrages ',14);
 Fenetre( 1, 3,50, 6,'Bilan');
 Fenetre( 1, 8,50,15,'Dmarrages par jour');
 Fenetre( 1,17,50,19,'Moyennes');
 Fenetre( 1,21,50,25,'Records');

 nombre_jours_total:=MaxEntier(NombreJoursEntre(date_dem[1],date_dem[nombre_demarrages]),1);
 AffChXY(0,21,4,DateASCII(date_dem[1],jour_complet+date_complete),16*8+7);
 AffChXY(0,21,5,DateASCII(date_dem[nombre_demarrages],jour_complet+date_complete),16*8+7);

 AffChXY(0,1,4,'Premier dmarrage :',16*8+3);
 AffChXY(0,1,5,'Dernier dmarrage :',16*8+3);
 AffChXY2(0,1,6,'Total : ^'+EntierTexte2(nombre_demarrages,4),16*8+3,143);
 AffChXY(0,18,6,EntierTexte2(nombre_jours_total,3)+' j. / '+
                ReelTexte(nombre_jours_total/7,5,1)+' sem. / '+
                ReelTexte(nombre_jours_total/30.5,4,1)+' mois',135);

 AffChXY(0,1,18,'Dmarrages par jour   :',16*8+3);
 AffChXY(0,1,19,'Dmarrages par semaine:',16*8+3);

 AffChXY(0,1,22,'Dmarrages par jour   :',16*8+3);
 AffChXY(0,1,23,'Dmarrages par semaine:',16*8+3);
 AffChXY(0,1,24,'Priode d''activit  :',16*8+3);
 AffChXY(0,1,25,'Priode d''inactivit:',16*8+3);

 for jour:=LUNDI to DIMANCHE do AffChXY(0,1,jour-LUNDI+9,NomJour[jour],16*8+3);

 z.Ombre(0,25,11,55,13,16*15);
 Cadre(0,2,26,11,54,13,16*15,'',0,'');
 AffChXY(0,30,12,'Analyse des donnes...',16*15+8);

 FillChar(nombre_dem_par_jour,sizeof(nombre_dem_par_jour),0);
 FillChar(nombre_dem_par_heure,sizeof(nombre_dem_par_heure),0);

 nombre_jours_demarrages:=1;
 nombre_semaines_demarrages:=0;
 date_courante:=date_dem[1];
 dernier_lundi:=DatePlusJours(date_courante,1-((date_courante shr 29) and $07)) and masque_date;

 compteur_dem_par_jour:=0; nombre_record_dem_par_jour:=1;
 compteur_dem_par_semaine:=0; nombre_record_dem_par_semaine:=1;
 date_record_demarrages:=date_courante; lundi_semaine_record_demarrages:=dernier_lundi;
 compteur_jours_activite:=1; nombre_record_jours_activite:=1;
 nombre_record_jours_inactivite:=0;
 date_fin_record_activite:=date_courante; date_fin_record_inactivite:=0;

 Decompacte(date_dem[1],jour,date,mois_premier_dem,annee_premier_dem,heures,minutes,secondes);
 Decompacte(date_dem[nombre_demarrages],jour,date,mois_dernier_dem,annee_dernier_dem,heures,minutes,secondes);
 nombre_mois:=(12-mois_premier_dem+1)+12*(annee_dernier_dem-annee_premier_dem-1)+mois_dernier_dem;

 couleur:=7;

 {boucle principale...}
 for i:=1 to nombre_demarrages do begin
  date_precedente:=date_courante;
  date_courante:=date_dem[i];
  if not Decompacte(date_courante,jour,date,mois,annee,heures,minutes,secondes) then begin
   date_courante:=date_precedente;
   continue;
  end;

  inc(nombre_dem_par_jour[jour]);
  inc(nombre_dem_par_heure[heures]);

  nombre_jours:=NombreJoursEntre(date_precedente,date_courante);
  if nombre_jours=0 then begin  {mme jour que prcdent}
   inc(compteur_dem_par_jour);
   if compteur_dem_par_jour>=nombre_record_dem_par_jour then begin
    nombre_record_dem_par_jour:=compteur_dem_par_jour;
    date_record_demarrages:=date_courante;
   end;

   inc(compteur_dem_par_semaine);
   if compteur_dem_par_semaine>=nombre_record_dem_par_semaine then begin
    nombre_record_dem_par_semaine:=compteur_dem_par_semaine;
    lundi_semaine_record_demarrages:=dernier_lundi;
   end;
  end
  else begin  {nouveau jour}
   compteur_dem_par_jour:=1;
   inc(nombre_jours_demarrages);

   if nombre_jours=1 then begin  {lendemain}
    inc(compteur_jours_activite);
    if compteur_jours_activite>=nombre_record_jours_activite then begin
     nombre_record_jours_activite:=compteur_jours_activite;
     date_fin_record_activite:=date_courante; {aujourd'hui}
    end;
   end
   else begin  {surlendemain ou plus tard}
    compteur_jours_activite:=1;
    couleur:=10-couleur;
    if (nombre_jours-1)>=nombre_record_jours_inactivite then begin
     nombre_record_jours_inactivite:=nombre_jours-1;
     date_fin_record_inactivite:=DatePlusJours(date_courante,-1); {hier}
    end;
   end;

   ancien_dernier_lundi:=dernier_lundi;
   dernier_lundi:=DatePlusJours(date_courante,1-((date_courante shr 29) and $07)) and masque_date;

   if dernier_lundi=ancien_dernier_lundi then begin
    inc(compteur_dem_par_semaine);
    if compteur_dem_par_semaine>=nombre_record_dem_par_semaine then begin
     nombre_record_dem_par_semaine:=compteur_dem_par_semaine;
     lundi_semaine_record_demarrages:=dernier_lundi;
    end;
   end
   else begin inc(nombre_semaines_demarrages); compteur_dem_par_semaine:=1 end;
  end;

  m:=1+(mois-mois_premier_dem)+12*(annee-annee_premier_dem);
  if (m>=1) and (m<=max_mois) then inc(mois_dem[m]);

  couleur_dem[i]:=couleur;
 end;

 nombre_max_dem_par_jour:=0;
 for jour:=LUNDI to DIMANCHE do
  if nombre_dem_par_jour[jour]>nombre_max_dem_par_jour then nombre_max_dem_par_jour:=nombre_dem_par_jour[jour];

 nombre_max_dem_par_heure:=0;
 for h:=0 to 23 do
  if nombre_dem_par_heure[h]>nombre_max_dem_par_heure then nombre_max_dem_par_heure:=nombre_dem_par_heure[h];

 nombre_max_dem_par_mois:=0;
 for m:=1 to nombre_mois do
  if mois_dem[m]>nombre_max_dem_par_mois then nombre_max_dem_par_mois:=mois_dem[m];

 nombre_semaines_demarrages:=MaxEntier(nombre_semaines_demarrages,1);

 with z do begin Restaure(0,0,0,0); Supprime end;

 AffChXY(0,25,18,ReelTexte(nombre_demarrages/nombre_jours_total,5,2)+' ('+
                 ReelTexte(nombre_demarrages/nombre_jours_demarrages,5,2)+' rels)',16*8+7);
 AffChXY(0,45,18,ReelTexte(PourCentReel(nombre_jours_demarrages,nombre_jours_total),5,1)+'%',16*8+15);
 AffChXY(0,25,19,ReelTexte(7*nombre_demarrages/nombre_jours_total,5,2)+' ('+
                 ReelTexte(nombre_demarrages/nombre_semaines_demarrages,5,2)+' rels)',16*8+7);
 AffChXY(0,45,19,ReelTexte(PourCentReel(7*nombre_semaines_demarrages,nombre_jours_total),5,1)+'%',16*8+15);

 for jour:=LUNDI to DIMANCHE do begin
  BarGraph(bg_plein,10,jour-LUNDI+9,30,nombre_dem_par_jour[jour],nombre_max_dem_par_jour);
  AffChXY2(0,42,jour-LUNDI+9,EntierTexte2(nombre_dem_par_jour[jour],4)+' ^'+
                             EntierTexte2((100*LONGINT(nombre_dem_par_jour[jour])) div nombre_demarrages,3)+'%',
           16*8+15,16*8+7);
 end;

 AffChXY(0,25,22,EntierTexte2(nombre_record_dem_par_jour,3)+'  ('+
                 DateASCII(date_record_demarrages,jour_complet+date_reduite)+')',16*8+7);

 AffChXY(0,25,23,EntierTexte2(nombre_record_dem_par_semaine,3)+'  ('+
                 DateASCII(lundi_semaine_record_demarrages,date_reduite)+'..'+
                 DateASCII(DatePlusJours(lundi_semaine_record_demarrages,6),date_reduite)+')',16*8+7);

 AffChXY(0,22,24,EntierTexte2(nombre_record_jours_activite,4)+' j. ('+
                 DateASCII(DatePlusJours(date_fin_record_activite,1-nombre_record_jours_activite),date_reduite)+'..'+
                 DateASCII(date_fin_record_activite,date_reduite)+')',16*8+7);

 if nombre_record_jours_inactivite<>0 then
  AffChXY(0,22,25,EntierTexte2(nombre_record_jours_inactivite,4)+' j. ('+
                  DateASCII(DatePlusJours(date_fin_record_inactivite,1-nombre_record_jours_inactivite),date_reduite)+'..'+
                  DateASCII(date_fin_record_inactivite,date_reduite)+')',16*8+7);

 premiere_date:=MaxEntier(nombre_demarrages-hauteur_fen+1,1);
 premier_mois:=MaxEntier(nombre_mois-hauteur_fen+1,1);;

 {affichage}
 AffChXY(0,38,1,'<Espace>:mode',7);
 mode_aff:=aff_liste_dem; anc_mode:=0;

 repeat
  if mode_aff<>anc_mode then Fenetre(53, 1,80,25,nom_mode[mode_aff]);
  anc_mode:=mode_aff;

  AttendVBL;
  case mode_aff of
   aff_liste_dem: begin
                   if nombre_demarrages>hauteur_fen then AfficheAscenseur(80,2,hauteur_fen,nombre_demarrages,premiere_date,15);
                   for i:=1 to MinEntier(hauteur_fen,nombre_demarrages) do
                    AffChXY2(0,54,i+1,EntierTexte2(premiere_date+i-1,4)+' ^'+
                                      DateASCII(date_dem[premiere_date+i-1],jour_reduit+date_reduite+heure_reduite),
                                      16*8+15,16*8+couleur_dem[premiere_date+i-1]);

                   case Readkey of
                    Up   : if premiere_date>1 then dec(premiere_date);
                    Down : if nombre_demarrages>hauteur_fen then
                            premiere_date:=MinEntier(premiere_date+1,nombre_demarrages-hauteur_fen+1);
                    PgUp : premiere_date:=MaxEntier(premiere_date-hauteur_fen,1);
                    PgDn : if nombre_demarrages>hauteur_fen then
                            premiere_date:=MinEntier(premiere_date+hauteur_fen,nombre_demarrages-hauteur_fen+1);
                    Home : premiere_date:=1;
                    End_ : premiere_date:=MaxEntier(nombre_demarrages-hauteur_fen+1,1);
                    Space: mode_aff:=aff_dem_heure;
                    Esc  : break;
                   end;
                  end;

   aff_dem_heure: begin
                   for h:=0 to 23 do begin
                    i:=(h+premiere_heure) mod hauteur_fen;
                    AffChXY(0,53,2+h,EntierTexte2(i,2)+'h',16*8+3);
                    AffChXY2(0,72,2+h,EntierTexte2(nombre_dem_par_heure[i],3)+'^'+
                                      ReelTexte(100*nombre_dem_par_heure[i]/nombre_demarrages,5,1)+'%',16*8+15,16*8+7);
                    BarGraph(bg_trans,56,2+h,25,nombre_dem_par_heure[i],nombre_max_dem_par_heure);
                   end;

                   case Readkey of
                    Space: mode_aff:=aff_dem_mois;
                    Esc  : break;
                   end;
                  end;

   aff_dem_mois : begin
                   if nombre_mois>hauteur_fen then AfficheAscenseur(80,2,hauteur_fen,nombre_mois,premier_mois,15);
                   for i:=1 to MinEntier(hauteur_fen,nombre_mois) do begin
                    AffChXY2(0,53,i+1,' '+XString(NomMois[1+(((mois_premier_dem+(premier_mois+i-1)-1)-1) mod 12)],' ',10)+
                                      EntierTexte2(annee_premier_dem+((mois_premier_dem+(premier_mois+i-1)-1)-1) div 12,4)+
                                      ' ^'+EntierTexte2(mois_dem[premier_mois+i-1],3)+'^ '+
                                      ReelTexte(100*mois_dem[premier_mois+i-1]/nombre_demarrages,5,1)+'% ',16*8+7,16*8+15);
                    BarGraph(bg_trans,53,i+1,27,mois_dem[premier_mois+i-1],nombre_max_dem_par_mois);
                   end;

                   case Readkey of
                    Up   : if premier_mois>1 then dec(premier_mois);
                    Down : if nombre_mois>hauteur_fen then
                            premier_mois:=MinEntier(premier_mois+1,nombre_mois-hauteur_fen+1);
                    PgUp : premier_mois:=MaxEntier(premier_mois-hauteur_fen,1);
                    PgDn : if nombre_mois>hauteur_fen then
                            premier_mois:=MinEntier(premier_mois+hauteur_fen,nombre_mois-hauteur_fen+1);
                    Home : premier_mois:=1;
                    End_ : premier_mois:=MaxEntier(nombre_mois-hauteur_fen+1,1);
                    Space: mode_aff:=aff_liste_dem;
                    Esc  : break;
                   end;
                  end;
  end;
 until FALSE;
end; {AfficheStatistiques}

{=========================================================}

CONST nom_fichier='C:\HISTORY.DAT';

VAR f: Fichier;
    taille_fichier: LONGINT;
    anc_nbr_lignes: BYTE;

begin
 f.Ouvre(lecture,nom_fichier);
 if f_erreur<>f_ok then begin WriteLn('Fichier ',nom_fichier,' introuvable!'); halt(1) end;

 taille_fichier:=f.Taille;
 if (taille_fichier=0) or (taille_fichier and $03<>0) or (taille_fichier>sizeof(date_dem)) then
  begin WriteLn('Format du fichier ',nom_fichier,' incorrect!'); halt(2) end;

 f.Lit(date_dem,taille_fichier);
 f.Ferme;

 nombre_demarrages:=taille_fichier div 4;
 anc_nbr_lignes:=NombreLignes+1;
 AfficheStatistiques;
 InitTexte(anc_nbr_lignes);
END.
