{$A+,G+,Q-,R-,S-}

USES Dos,Clavier,Texte,Util;

TYPE repertoire=^t_repertoire;
     t_repertoire=record
                   nom: String8;

                   pere,fils,frere_prec,frere_suiv,
                   anc_pere,anc_frere_prec,anc_frere_suiv: repertoire;

                   taille_rep,taille_branche: longint;

                   nbr_fich_rep,nbr_fich_branche: word;

                   taille_moy_fich_rep,taille_moy_fich_branche: longint;
                  end;

CONST mode_taille  =1;
      mode_fichiers=2;
      mode_moyenne =3;

      mode_branche  : boolean=TRUE;
      mode_affichage: byte=mode_taille;

      niveau_max: byte=4;

VAR taille_rep_max,taille_branche_max: longint;

    nbr_fich_rep_max,nbr_fich_branche_max: word;

    taille_moy_fich_rep_max,taille_moy_fich_branche_max: longint;


function NouveauFils(nom_rep: String8; rep_pere: repertoire): repertoire;
var rep: repertoire;
begin
 New(rep);
 FillChar(rep^,sizeof(t_repertoire),0);
 with rep^ do begin nom:=nom_rep; pere:=rep_pere end;
 NouveauFils:=rep;
end; {NouveauFils}


function Niveau(rep: repertoire): byte;
var n: byte;
begin
 n:=0;
 if rep<>nil then while rep^.pere<>nil do begin rep:=rep^.pere; inc(n) end;
 Niveau:=n;
end; {Niveau}


function Ancetre(rep: repertoire): repertoire;
begin
 if rep<>nil then while rep^.pere<>nil do rep:=rep^.pere;
 Ancetre:=rep;
end; {Ancetre}


function ProchainOncle(rep: repertoire): repertoire;
begin
 if rep<>nil then begin
  while (rep^.frere_suiv=nil) and (rep^.pere<>nil) do rep:=rep^.pere;
  if rep^.frere_suiv<>nil then rep:=rep^.frere_suiv else rep:=nil;
 end;
 ProchainOncle:=rep;
end; {ProchainOncle}


function DernierFrere(rep: repertoire): repertoire;
begin
 if rep<>nil then while rep^.frere_suiv<>nil do rep:=rep^.frere_suiv;
 DernierFrere:=rep
end; {DernierFrere}



function Arborescence(chemin: String80): repertoire;

var arbre,dernier_frere: repertoire;
    sous_rep: String12;

procedure ChercheArborescence(rep: repertoire);

var dir: SearchRec;
    nouveau_fils: repertoire;

begin
 FindFirst(chemin+'*.*',AnyFile,dir);
 while DosError=0 do begin
  with rep^,dir do begin
   inc(taille_rep,Size); inc(taille_branche,Size);
   if Attr<>Directory then begin inc(nbr_fich_rep); inc(nbr_fich_branche) end;

   if (Attr=Directory) and (Name[1]<>'.') then begin
    Write('');
    nouveau_fils:=NouveauFils(Name,rep);
    if fils=nil then fils:=nouveau_fils
    else begin
     dernier_frere:=DernierFrere(fils);
     dernier_frere^.frere_suiv:=nouveau_fils;
     nouveau_fils^.frere_prec:=dernier_frere;
    end;

    chemin:=chemin+Name+'\';
    ChercheArborescence(nouveau_fils);

    inc(taille_branche,nouveau_fils^.taille_branche);
    inc(nbr_fich_branche,nouveau_fils^.nbr_fich_branche);
   end;
  end;
  FindNext(dir);
 end;

 case DosError of
  3  : Writeln('Chemin introuvable');
  100: Writeln('Erreur de lecture');
  152: Writeln('Lecteur pas prt');
  154,156,157,158: Writeln('Erreur de donnes')
 end;
 if DosError<>18 then halt(1);

 chemin:=FExpand(chemin+'..\');
end; {ChercheArborescence}


begin {Arborescence}
 if chemin[Length(chemin)]<>'\' then chemin:=chemin+'\';
 sous_rep:=SousRepertoire(chemin);
 if sous_rep='' then sous_rep:=chemin;

 arbre:=NouveauFils(sous_rep,nil);
 ChercheArborescence(arbre);
 Arborescence:=arbre
end; {Arborescence}


procedure ChercheValeursMax(rep: repertoire);
begin
 taille_rep_max    :=0;
 taille_branche_max:=0;
 nbr_fich_rep_max    :=0;
 nbr_fich_branche_max:=0;
 taille_moy_fich_rep_max    :=0;
 taille_moy_fich_branche_max:=0;

 while rep<>nil do with rep^ do begin
  if taille_rep>taille_rep_max then taille_rep_max:=taille_rep;
  if taille_branche>taille_branche_max then taille_branche_max:=taille_branche;
  if nbr_fich_rep>nbr_fich_rep_max then nbr_fich_rep_max:=nbr_fich_rep;
  if nbr_fich_branche>nbr_fich_branche_max then nbr_fich_branche_max:=nbr_fich_branche;
  if nbr_fich_rep<>0 then taille_moy_fich_rep:=taille_rep div nbr_fich_rep;
  if nbr_fich_branche<>0 then taille_moy_fich_branche:=taille_branche div nbr_fich_branche;
  if taille_moy_fich_rep>taille_moy_fich_rep_max then taille_moy_fich_rep_max:=taille_moy_fich_rep;
  if taille_moy_fich_branche>taille_moy_fich_branche_max then taille_moy_fich_branche_max:=taille_moy_fich_branche;

  if fils<>nil then rep:=fils
  else if frere_suiv<>nil then rep:=frere_suiv else rep:=ProchainOncle(rep);
 end;
end; {ChercheValeursMax}



procedure AfficheArbre(rep,rep_choisi: repertoire);

var niveau_base,niveau_rep,x,y: byte;
    valeur_rep,valeur_branche,valeur_rep_max,valeur_branche_max: longint;
    ratio: real;

begin
 y:=1;
 niveau_base:=MaxEntier(0,Niveau(rep)-niveau_max);

 while (rep<>nil) and (y<=hauteur_ecran_txt) do with rep^ do begin
  AdrTexte:=PtrVRAM(0,1,y);
  AttrTexte:=16*0+15;

  niveau_rep:=Niveau(rep);
  if niveau_rep>niveau_base then begin
   for x:=1 to niveau_rep-niveau_base-1 do AffCh('   ');
   AffCh('');
  end;

  if rep=rep_choisi then AttrTexte:=16*7+15 else AttrTexte:=16*0+15;
  if niveau_rep>=niveau_base then AffCh(nom);

  case mode_affichage of
   mode_taille: begin
                 valeur_rep:=taille_rep; valeur_branche:=taille_branche;
                 valeur_rep_max:=taille_rep_max; valeur_branche_max:=taille_branche_max;
                 AttrTexte:=3;
                end;

   mode_fichiers: begin
                   valeur_rep:=nbr_fich_rep; valeur_branche:=nbr_fich_branche;
                   valeur_rep_max:=nbr_fich_rep_max; valeur_branche_max:=nbr_fich_branche_max;
                   AttrTexte:=2;
                  end;

   mode_moyenne: begin
                  valeur_rep:=taille_moy_fich_rep; valeur_branche:=taille_moy_fich_branche;
                  valeur_rep_max:=taille_moy_fich_rep_max; valeur_branche_max:=taille_moy_fich_branche_max;
                  AttrTexte:=1;
                 end;
  end;

  x:=10+4*niveau_max;
  AffChXY2(0,x,y,EntierTexte(valeur_rep,10)+'^'+EntierTexte(valeur_branche,10)+' ',
           7+BYTE(mode_branche),8-BYTE(mode_branche));

  ratio:=0;
  if mode_branche then begin
   if valeur_branche_max<>0 then ratio:=valeur_branche/valeur_branche_max;
  end else if valeur_rep_max<>0 then ratio:=valeur_rep/valeur_rep_max;

  AffChXY(0,20+x+1,y,XString(RepeteCar('',Round((80-(20+x))*ratio)),' ',80-(20+x)),AttrTexte);

  inc(y);
  if fils<>nil then rep:=fils
  else if frere_suiv<>nil then rep:=frere_suiv else rep:=ProchainOncle(rep);
 end;
end; {AfficheArbre}


CONST quitte: boolean=FALSE;

VAR anc_nbr_lignes: byte;
    racine: String80;
    arbre,rep_choix,prochain_oncle: repertoire;
    p: pointer;

BEGIN
 if ParamCount>=1 then racine:=Maj(ParamStr(1)) else GetDir(0,racine);
 Writeln('Analyse du rpertoire '+racine+' ...'+#13#10);

 Mark(p);

 arbre:=Arborescence(racine);
 ChercheValeursMax(arbre);

 anc_nbr_lignes:=NombreLignes+1;
 InitTexte(50);
 Curseur(off);

 VideBufferClavier;
 VitesseClavier(0,0);

 rep_choix:=arbre;
 repeat
  AttendVBL;
  EffacePage(0,7);
  AfficheArbre(rep_choix,rep_choix);

  with rep_choix^ do
   case UpCase(Readkey) of
    Up  : if frere_prec<>nil then rep_choix:=frere_prec
          else if pere<>nil then rep_choix:=pere;

    Down: if frere_suiv<>nil then rep_choix:=frere_suiv
          else if fils<>nil then rep_choix:=fils
               else begin
                prochain_oncle:=ProchainOncle(rep_choix);
                if prochain_oncle<>nil then rep_choix:=prochain_oncle;
               end;

    Left : if pere<>nil then rep_choix:=pere;

    Right: if fils<>nil then rep_choix:=fils
           else if frere_suiv<>nil then rep_choix:=frere_suiv
                else begin
                 prochain_oncle:=ProchainOncle(rep_choix);
                 if prochain_oncle<>nil then rep_choix:=prochain_oncle;
                end;

    Home : rep_choix:=Ancetre(rep_choix);

    End_ : begin
            rep_choix:=Ancetre(rep_choix);
            if rep_choix^.fils<>nil then begin
             rep_choix:=rep_choix^.fils;
             while rep_choix^.frere_suiv<>nil do rep_choix:=rep_choix^.frere_suiv;
            end;
           end;

    Key('R'): mode_branche:=FALSE;
    Key('B'): mode_branche:=TRUE;

    Space: mode_branche:=not(mode_branche);

    Key('T'): mode_affichage:=mode_taille;
    Key('F'): mode_affichage:=mode_fichiers;
    Key('M'): mode_affichage:=mode_moyenne;

    Key('-'): if niveau_max>1 then dec(niveau_max);
    Key('+'): if niveau_max<8 then inc(niveau_max);

    Enter: with rep_choix^ do begin
            if pere<>nil then begin
             anc_pere:=pere; pere:=nil;
             anc_frere_prec:=frere_prec; frere_prec:=nil;
             anc_frere_suiv:=frere_suiv; frere_suiv:=nil;
             ChercheValeursMax(rep_choix);
            end
            else if anc_pere<>nil then begin
                  pere:=anc_pere; anc_pere:=nil;
                  frere_prec:=anc_frere_prec; anc_frere_prec:=nil;
                  frere_suiv:=anc_frere_suiv; anc_frere_suiv:=nil;
                  ChercheValeursMax(Ancetre(pere));
                 end;
            end;

    F1 : begin
          EffacePage(0,7);
          AffChXY(0,1,1,' STree v1.1 - (c) 1998 Fabrice Couteau ',15);
          AffChXY(0,1,3,'type d''analyse',14);
          AffChXY(0,3,4,'R: rpertoire (valeur  gauche)',7);
          AffChXY(0,3,5,'B: branche    (valeur  droite)',7);
          AffChXY(0,3,6,'Espace: branche <-> rpertoire',7);
          AffChXY(0,1,8,'Donnes  afficher',14);
          AffChXY2(0,3, 9,'T: taille des fichiers         (^^)',7,3);
          AffChXY2(0,3,10,'F: nombre de fichiers          (^^)',7,2);
          AffChXY2(0,3,11,'M: taille moyenne des fichiers (^^)',7,1);
          AffChXY(0,1,13,'Dplacement',14);
          AffChXY(0,3,14,''#27#26' Home end',7);
          AffChXY(0,3,15,'-,+: Modifie la profondeur d''arborescence visible',7);
          AffChXY(0,3,16,': Zoom avant/arrire (sauf sur racine)',7);
          repeat until ReadKey<>0;
         end;
    Esc: quitte:=TRUE;
   end;
 until quitte;

 Release(p);

 VitesseClavier(1,3);
 InitTexte(anc_nbr_lignes);
END.
