{$A+,G+,N-,Q-,R-,S-}

USES Crt,Util,EMS,Graph256,BMP256;

CONST cpt_18 : byte=0;
      cpt_sec: byte=0;

VAR anc_INT08: pointer;
    palette: Palette256;
    res_x,res_y: word;
    pages_EMS,p: byte;
    handle_EMS: word;


procedure Timer; interrupt;
var y: byte;
begin
 asm pushf; call anc_INT08 end;

 inc(cpt_18,5);
 if cpt_18>91 then begin
  dec(cpt_18,91);
  inc(cpt_sec);
  write(cpt_sec,',');

  case cpt_sec of
    3: begin
        Init320x200;
        palette.Fixe(0,256);
        for p:=0 to pages_EMS-1 do EMSMap(handle_EMS,p,p);
        for y:=0 to res_y-1 do
         Move(Mem[EMSPageFrameSeg:res_x*y],Mem[$A000:320*y],res_x);
       end;

    6: begin
        TextMode(CO80);
       end;
  end;
 end;
end;


VAR image: BMP;
    erreur: word;

BEGIN
 clrscr;
 if not(EMSInit) then begin writeln('EMM needed !'); halt end;

 writeln('EMM v',EMMVersion div 10,'.',EMMVersion mod 10,
         ' @',EntierHexa(EMSPageFrameSeg,4),'h (',EMSPagesFree,'/',EMSPageAvail,' pages available)');

 if ParamCount=0 then image.Charge('C:\Projets\tests\sq4_.bmp',erreur)
                 else image.Charge(ParamStr(1),erreur);
 if erreur<>0 then begin writeln('BMP error: ',erreur); halt end;

 res_x:=image.ResX;
 res_y:=image.ResY;
 writeln('bitmap size: ',res_x,'x',res_y,' = ',res_x*res_y,' bytes');

 pages_EMS:=1+((res_x*res_y-1) div 16384);
 writeln(pages_EMS,' page(s) needed to store bitmap');

 if EMSPagesFree<pages_EMS then begin writeln('No EMS free !'); halt end;

 EMSGet(handle_EMS,pages_EMS);
 EMSTestError;
 for p:=0 to pages_EMS-1 do EMSMap(handle_EMS,p,p);
 Move(image.palette,palette,sizeof(Palette256));
 Move(image.image^,Mem[EMSPageFrameSeg:0],res_x*res_y);
 image.Supprime;

 SwapIntVec($08,anc_INT08,@Timer);
 repeat until KeyPressed;
 SwapIntVec($08,anc_INT08,anc_INT08);

 EMSFree(handle_EMS);
 EMSTestError;

 if ModeVideo<>txt_standard then TextMode(CO80);
END.
