PROGRAM TDBL; {Traqueur de doublons}
{$A+,G+,Q-,R-,S-}

USES Crt,Dos,Fichiers,Clavier,Texte,Util,UtilT,SourisT;

TYPE chemin=^o_chemin;
     o_chemin=object
               constructor Init(nom_: String80);
               destructor  Done;

              private
               nom: ^string;
              end;

     chemin_fichier=^o_chemin_fichier;
     o_chemin_fichier=object
                       constructor Init(info_fichier: SearchRec; p_chemin: chemin;
                                        chemin_fichier_precedent: chemin_fichier);
                      private
                       elem: chemin;
                       taille,date_heure: longint;
                       attribut,attribut_DOS: byte;
                       precedent,suivant: chemin_fichier;
                      end;

     chemin_doublon=chemin_fichier;

     fichier=^o_fichier;
     o_fichier=object
                constructor Init(info_fichier: SearchRec; p_chemin: chemin; fichier_precedent: fichier);

                function Premier: fichier;
                function ChercheSuivant: fichier;
                function CherchePrecedent: fichier;
                function EstDoublon: boolean;

               private
                nom: String12;
                premier_chemin: chemin_fichier;
                precedent,suivant: fichier;
               end;

     doublon=^o_doublon;
     o_doublon=object(o_fichier)
                function Premier: doublon;
                function ChercheSuivant: doublon;
                function CherchePrecedent: doublon;
                procedure Infos(var nombre_fichiers,nombre_fichiers_marques: word;
                                var taille_fichiers,taille_fichiers_marques: longint);
               end;


CONST titre_prog: array[1..27] of char='Traqueur de doublons - v1.1';
      copyright : array[1..24] of char='(c) 1998 Fabrice Couteau';

      memoire_min=20000; {taille minimale de mmoire sur le 'tas' ncessaire pour
                          stocker tout ce qui n'est pas fichiers,chemins (fentres...)}

      {codes d'erreur pour erreur_sortie}
      erreur_memoire=1;
      erreur_DOS    =2;

      erreur_sortie: byte=0;

      {attributs des doublons}
      aucun         =$00;
      taille_min    =$01;
      taille_max    =$02;
      date_heure_min=$04;
      date_heure_max=$08;
      marque        =$10;
      traite        =$20;
      erreur        =$40;

      autre=Pred('A'); {premier caractre n'est pas A..Z}

      y_haut=3; {ordonne du premier doublon/chemin de doublon affich}

      nombre_fichiers: word=0;
      nombre_chemins : word=0;
      nombre_doublons: word=0;
      taille_fichiers: longint=0;
      taille_doublons: longint=0;

      nom_doublon=nil; {valeur pour 'chemin_doublon_haut' quand la premire ligne affiche en haut
                        de l'cran n'est pas le premier chemin du doublon, mais le nom du doublon}

      nom_recherche: String12=''; {nom du fichier  rechercher}

      taille_tampon=16*1024;


VAR lecteur: char;

    Dictionnaire: array[autre..'Z'] of fichier;

    nombre_fichiers_marques,nombre_doublons_marques: word;
    taille_fichiers_marques,taille_doublons_marques: longint;

    choix_doublon: doublon; {doublon slectionn}
    doublon_haut : doublon; {doublon en haut de l'cran}
    choix_chemin_doublon: chemin_doublon; {chemin slectionn du doublon}
    chemin_doublon_haut : chemin_doublon; {chemin du doublon en haut de l'cran}

    numero_doublon: word;        {numro du doublon slectionn}

    y_choix: byte; {ordonne du chemin slectionn du doublon}
    y_bas  : byte; {ordonne du dernier doublon/chemin de doublon affich}

    tampon: array[1..taille_tampon] of byte;

{====================================================================}

procedure InitEcran;
begin
 EffaceZone(0,2,y_haut,79,y_bas,16);
 AffChXY2(0,1,hauteur_ecran_txt-1,
          ' Dplacement: ^^, ^'#27#26'^, ^Page^, ^Dbut^, ^Fin^                  Recherche: ^A^..^Z^, ^?^, ^*^',240,244);
 AffChXY2(0,1,hauteur_ecran_txt,
          ' ^Espace^:Marque/Dmarque  ^Suppr^:Efface  ^^:Duplique    ^Ins^:Affiche/Cache rsum',240,244);
 CopiePage(0,1);
end; {InitEcran}

{--------------------------------------------------------------------}

procedure AfficheBarre(x,y: byte; valeur,valeur_max: longint);
var pour_cent: byte;
    demi_car: string[1];
begin
 if valeur_max<>0 then pour_cent:=Round(valeur/valeur_max*100) else pour_cent:=0;
 if (pour_cent mod 4)<2 then demi_car:='' else demi_car:='';
 AffChXY2(0,x,y,RepeteCar(' ',pour_cent div 4)+demi_car+'^'+
                RepeteCar(' ',25-(pour_cent div 4)-Length(demi_car)),168,128);
 AffChXY(0,x+25+1,y,EntierTexte2(pour_cent,3)+'%',48);
end; {AfficheBarre}

{--------------------------------------------------------------------}

procedure AfficheMessageEtat(message: String64; pause: boolean);
const touche='Appuyez sur une touche...';
var i: byte;
begin
 EffaceZone(0,1,hauteur_ecran_txt-1,80,hauteur_ecran_txt,240);
 AffChXY(0,40-(Length(message) div 2),hauteur_ecran_txt-1,message,240);

 if pause then begin
  for i:=1 to 3 do begin Sound(440*i); Delay(20) end;
  NoSound;

  AffChXY(0,40-(Length(touche) div 2),hauteur_ecran_txt,touche,240);
  VideBufferClavier;
  repeat until ReadKey<>0;
 end;
end; {AfficheMessageEtat}

{--------------------------------------------------------------------}

function Confirme(message: String64): boolean;

const xg=26; yh=10; largeur=28; hauteur=6; {fentre confirmation}
      xd=xg+largeur-1; yb=yh+hauteur-1;

var z: Zone;
    bt_Oui,bt_Non: Bouton;
    touche: Key;

begin
 z.Ombre(0,xg,yh,xd,yb,112);
 Cadre(0,1,xg,yh,xd,yb,112+4,'Confirmation',112+4,'');

 message:=message+' '+EntierTexte2(nombre_doublons_marques,1)+' doublons?';
 AffChXY(0,xg+((largeur-Length(message)) div 2),yh+1,message,112);
 with bt_Oui do
  begin Definit(0,xg+(largeur div 2)-2-6,yh+3,' ^O^ui ',240,240+8,240+12,0); Affiche end;
 with bt_Non do
  begin Definit(0,xg+(largeur div 2)+2,yh+3,' ^N^on ',240,240+8,240+12,0); Affiche end;

 repeat
  touche:=ReadKey;
  if bt_Oui.Appuye(CHAR(touche)) then begin Confirme:=TRUE; break end;
  if (bt_Non.Appuye(CHAR(touche))) or (touche=Esc) then begin Confirme:=FALSE; break end;
 until FALSE;

 with z do begin Restaure(0,0,0,0); Supprime end;
end; {Confirme}

{--------------------------------------------------------------------}

procedure CopieDateHeure(handle_source,handle_destination: word); assembler;
asm
 mov AX,5700h
 mov BX,handle_source
 int 21h        {dtermine date et heure du fichier source}
 mov AX,5701h
 mov BX,handle_destination
 int 21h        {fixe date et heure du fichier destination}
end; {CopieDateHeure}

{--------------------------------------------------------------------}

constructor o_chemin.Init(nom_: String80);
begin
 GetMem(nom,Length(nom_)+1);
 nom^:=nom_;
end; {o_chemin.Init}

{--------------------------------------------------------------------}

destructor o_chemin.Done;
begin
 FreeMem(nom,Length(nom^)+1);
 nom:=nil;
end; {o_chemin.Done}

{--------------------------------------------------------------------}

constructor o_chemin_fichier.Init(info_fichier: SearchRec; p_chemin: chemin;
                                  chemin_fichier_precedent: chemin_fichier);
begin
 elem:=p_chemin;
 taille:=info_fichier.Size;
 date_heure:=info_fichier.Time;
 attribut:=aucun;
 attribut_DOS:=info_fichier.Attr;
 precedent:=chemin_fichier_precedent;
 suivant:=nil;
end; {o_chemin_fichier.Init}

{--------------------------------------------------------------------}

constructor o_fichier.Init(info_fichier: SearchRec; p_chemin: chemin; fichier_precedent: fichier);
begin
 inc(nombre_fichiers);
 inc(taille_fichiers,info_fichier.Size);
 nom:=info_fichier.Name;
 New(premier_chemin,Init(info_fichier,p_chemin,nil));
 precedent:=fichier_precedent;
 suivant:=nil;
end; {o_fichier.Init}

{--------------------------------------------------------------------}

function o_fichier.Premier: fichier;
var car: char;
begin
 Premier:=nil;
 for car:=autre to 'Z' do
  if Dictionnaire[car]<>nil then begin Premier:=Dictionnaire[car]; exit end;
end; {o_fichier.Premier}

{--------------------------------------------------------------------}

function o_fichier.ChercheSuivant: fichier;
var car: char;
begin
 if suivant<>nil then ChercheSuivant:=suivant
 else begin
  car:=nom[1];
  case car of
   'A'..'Y': inc(car);
   'Z': begin ChercheSuivant:=nil; exit end;
   else car:='A'
  end;
  while (car<'Z') and (Dictionnaire[car]=nil) do inc(car);
  ChercheSuivant:=Dictionnaire[car];
 end;
end; {o_fichier.ChercheSuivant}

{--------------------------------------------------------------------}

function o_fichier.CherchePrecedent: fichier;
var car: char;
    f: fichier;
begin
 if precedent<>nil then CherchePrecedent:=precedent
 else begin
  car:=nom[1];
  case car of
   'A': car:=autre;
   'B'..'Z': dec(car);
   else begin CherchePrecedent:=nil; exit end;
  end;
  while (car>autre) and (Dictionnaire[car]=nil) do dec(car);
  f:=Dictionnaire[car];
  if f<>nil then while f^.suivant<>nil do f:=f^.suivant; {cherche dernier fichier de l'entre du dictionnaire}
  CherchePrecedent:=f;
 end;
end; {o_fichier.CherchePrecedent}

{--------------------------------------------------------------------}

function o_fichier.EstDoublon: boolean;
begin
 EstDoublon:=(premier_chemin^.suivant<>nil); {le fichier est dans au moins 2 chemins}
end; {o_fichier.EstDoublon}

{--------------------------------------------------------------------}

function o_doublon.Premier: doublon;
var f: fichier;
begin
 f:=inherited Premier;
 while (f<>nil) and not(f^.EstDoublon) do f:=f^.ChercheSuivant;
 Premier:=doublon(f);
end; {o_doublon.Premier}

{--------------------------------------------------------------------}

function o_doublon.ChercheSuivant: doublon;
var f: fichier;
begin
 f:=inherited ChercheSuivant;
 while (f<>nil) and not(f^.EstDoublon) do f:=f^.ChercheSuivant;
 ChercheSuivant:=doublon(f);
end; {o_doublon.ChercheSuivant}

{--------------------------------------------------------------------}

function o_doublon.CherchePrecedent: doublon;
var f: fichier;
begin
 f:=inherited CherchePrecedent;
 while (f<>nil) and not(f^.EstDoublon) do f:=f^.CherchePrecedent;
 CherchePrecedent:=doublon(f);
end; {o_doublon.CherchePrecedent}

{--------------------------------------------------------------------}

procedure o_doublon.Infos(var nombre_fichiers,nombre_fichiers_marques: word;
                          var taille_fichiers,taille_fichiers_marques: longint);
var c: chemin_fichier;
begin
 nombre_fichiers:=0; nombre_fichiers_marques:=0;
 taille_fichiers:=0; taille_fichiers_marques:=0;
 c:=premier_chemin;
 while c<>nil do with c^ do begin
  inc(nombre_fichiers); inc(taille_fichiers,taille);
  if (attribut and marque)=marque then
   begin inc(nombre_fichiers_marques); inc(taille_fichiers_marques,taille) end;
  c:=suivant;
 end;
end; {o_doublon.Infos}

{--------------------------------------------------------------------}

procedure ChercheDoublons;

const xg=16; yh=9; largeur=47; hauteur=8; {fentre recherche}
      xd=xg+largeur-1; yb=yh+hauteur-1;

var nom_chemin_courant: String80;
    fichier_courant: fichier;
    chemin_fichier_courant: chemin_fichier;
    ds,df,taille_fichiers_estimee: longint;
    cpt_fichiers: word;
    car: char;
    z: Zone;
    pause_mem: boolean;


procedure AjouteFichier(info_fichier: SearchRec; p_chemin: chemin);
var car: char;
    chemin_fichier_courant: chemin_fichier;
    fichier_courant: fichier;
begin
 car:=info_fichier.Name[1];
 if not(car in ['A'..'Z']) then car:=autre;
 fichier_courant:=Dictionnaire[car];

 if fichier_courant=nil then New(Dictionnaire[car],Init(info_fichier,p_chemin,nil))
 else begin
  while (fichier_courant^.suivant<>nil) and (fichier_courant^.nom<>info_fichier.Name) do
   fichier_courant:=fichier_courant^.suivant;
  if fichier_courant^.nom=info_fichier.Name then begin  {ce fichier existe dj, on ajoute le chemin  sa liste}
   chemin_fichier_courant:=fichier_courant^.premier_chemin;
   while chemin_fichier_courant^.suivant<>nil do chemin_fichier_courant:=chemin_fichier_courant^.suivant;
   New(chemin_fichier_courant^.suivant,Init(info_fichier,p_chemin,chemin_fichier_courant));
  end
  else New(fichier_courant^.suivant,Init(info_fichier,p_chemin,fichier_courant));
 end;
end; {AjouteFichier}


procedure ChercheArborescence;
var f: SearchRec;
    chemin_courant: chemin;
begin
 New(chemin_courant,Init(CopyR(nom_chemin_courant,Length(nom_chemin_courant)-3))); {enlve le 'X:\'}
 AffChXY(0,xg+2,yb-2,XString(nom_chemin_courant,' ',largeur-4),48+1);

 repeat
  FindFirst(nom_chemin_courant+'*.*',AnyFile-VolumeID,f);
  if DosError in [0,18] then break;
  case MessageErreur(DosError,nom_chemin_courant) of
   alt_repete,
   alt_continue:;
   alt_annule  : begin erreur_sortie:=erreur_DOS; exit end;
  end;
 until FALSE;

 while DosError=0 do begin
  AffChXY(0,2,hauteur_ecran_txt,'Mmoire: '+EntierTexte2(MemAvail-memoire_min,6),16*15+0);

  if MemAvail<memoire_min then begin
   AfficheMessageEtat('Mmoire insuffisante',pause_mem);
   pause_mem:=FALSE;
{   erreur_sortie:=erreur_memoire;}
   break;
  end;

  with f do
   if Attr<>Directory then AjouteFichier(f,chemin_courant)
   else if Name[1]<>'.' then begin
         nom_chemin_courant:=nom_chemin_courant+Name+'\';
         ChercheArborescence;
         if erreur_sortie<>0 then exit;
        end;
   repeat
    FindNext(f);
    if DosError in [0,18] then break;
    case MessageErreur(DosError,nom_chemin_courant) of
     alt_repete,
     alt_continue:;
     alt_annule  : begin erreur_sortie:=erreur_DOS; exit end;
    end;
   until FALSE;
  end;

 inc(nombre_chemins);
 AffChXY(0,xg+4,yh+2,EntierTexte2(nombre_fichiers,5),48);
 AffChXY(0,xg+4,yh+3,EntierTexte2(nombre_chemins,5),48);
 AfficheBarre(xg+15,yb-1,taille_fichiers,taille_fichiers_estimee);
 nom_chemin_courant:=FExpand(nom_chemin_courant+'..\');
end; {ChercheArborescence}


begin {ChercheDoublons}
 z.Ombre(0,xg,yh,xd,yb,48);
 Cadre(0,1,xg,yh,xd,yb,48+15,'Recherche',48+15,'');

 AffChXY(0,xg+2,yh+1,'Disque '+lecteur+':',48+14);
 AffChXY(0,xg+4,yh+2,EntierTexte2(nombre_fichiers,5)+' fichiers',48);
 AffChXY(0,xg+4,yh+3,EntierTexte2(nombre_chemins,5)+' rpertoires',48);
 LigneHorizontale(0,1,yb-3,xg+1,xd-1,48+8);

 repeat
  ds:=DiskSize(BYTE(lecteur)-64); df:=DiskFree(BYTE(lecteur)-64);
  if (ds<>-1) and (df<>-1) then break;
  case MessageErreur(f_err_pas_pret,lecteur) of
   alt_repete  :;
   alt_annule  : begin erreur_sortie:=erreur_DOS; break end;
  end;
 until FALSE;

 if erreur_sortie=0 then begin
  AffChXY(0,xg+24,yh+1,EntierTexte(ds,10)+' octets',48);
  taille_fichiers_estimee:=ds-df;
  AffChXY(0,xg+24,yh+2,EntierTexte(taille_fichiers_estimee,10)+' utiliss',48);
  AffChXY(0,xg+24,yh+3,EntierTexte(df,10)+' libres',48);
  AffChXY(0,xg+2,yb-1,'exploration',48);

  pause_mem:=TRUE;
  nom_chemin_courant:=lecteur+':\';
  ChercheArborescence;
 end;

 if erreur_sortie=0 then begin
  AfficheBarre(xg+15,yb-1,taille_fichiers_estimee,taille_fichiers_estimee);
  Pause(6);
  AffChXY(0,xg+2,yb-2,XString('analyse',' ',largeur-4),48);
  AffChXY(0,xg+2,yb-1,'fichiers  ',48);

  {comptage nombre et taille doublons}
  cpt_fichiers:=0;
  for car:=autre to 'Z' do begin
   fichier_courant:=Dictionnaire[car];
   while fichier_courant<>nil do with fichier_courant^ do begin
    inc(cpt_fichiers);
    if (cpt_fichiers and $07)=0 then AfficheBarre(xg+15,yb-1,cpt_fichiers,nombre_fichiers);
    if EstDoublon then begin
     inc(nombre_doublons);
     chemin_fichier_courant:=premier_chemin;
     while chemin_fichier_courant<>nil do with chemin_fichier_courant^ do begin
      inc(taille_doublons,taille);
      chemin_fichier_courant:=suivant;
     end;
    end;
    fichier_courant:=suivant;
   end;
  end;

  {affichage du rsultat}
  Pause(6);
  Cadre(0,1,xg,yh,xd,yb,48+15,'Bilan',48+15,'');
  EffaceZone(0,xg+2,yb-2,xd-2,yb-1,48);
  AffChXY(0,xg+13,yb-2,EntierTexte2(nombre_doublons,5)+' doublons',48+15);
  if taille_fichiers<>0 then
   AffChXY(0,xg+8,yb-1,EntierTexte(taille_doublons,10)+' octets   ('+
                       ReelTexte(taille_doublons/taille_fichiers*100,4,1)+'%)',48+15);

  AfficheMessageEtat('',TRUE);
 end;

 with z do begin Restaure(0,0,0,0); Supprime end;
end; {ChercheDoublons}

{--------------------------------------------------------------------}

procedure ChercheMinMaxDateHeure;

const xg=23; yh=11; largeur=34; hauteur=3; {fentre recherche}
      xd=xg+largeur-1; yb=yh+hauteur-1;

var d: doublon;
    c,chemin_taille_min,chemin_taille_max,
    chemin_date_heure_min,chemin_date_heure_max: chemin_fichier;
    cpt_doublons: word;
    car: char;
    z: Zone;

begin
 z.Ombre(0,xg,yh,xd,yb,48);
 Cadre(0,1,xg,yh,xd,yb,48+15,'Recherche min/max',48+15,'');

 {recherche des min/max en taille et en date/heure des doublons}
 cpt_doublons:=0;
 d:=d^.Premier;

 while d<>nil do with d^ do begin
  c:=premier_chemin;
  with c^ do attribut:=attribut or (taille_min+taille_max+
                                    date_heure_min+date_heure_max); {tous les attributs min/max par dfaut}
  chemin_taille_min:=c;
  chemin_taille_max:=c;
  chemin_date_heure_min:=c;
  chemin_date_heure_max:=c;

  while c<>nil do with c^ do begin
   if taille<chemin_taille_min^.taille then begin
    with chemin_taille_min^ do attribut:=attribut and not(taille_min);
    chemin_taille_min:=c;
    with chemin_taille_min^ do attribut:=attribut or taille_min;
   end;
   if taille>chemin_taille_max^.taille then begin
    with chemin_taille_max^ do attribut:=attribut and not(taille_max);
    chemin_taille_max:=c;
    with chemin_taille_max^ do attribut:=attribut or taille_max;
   end;
   if date_heure<chemin_date_heure_min^.date_heure then begin
    with chemin_date_heure_min^ do attribut:=attribut and not(date_heure_min);
    chemin_date_heure_min:=c;
    with chemin_date_heure_min^ do attribut:=attribut or date_heure_min;
   end;
   if date_heure>chemin_date_heure_max^.date_heure then begin
    with chemin_date_heure_max^ do attribut:=attribut and not(date_heure_max);
    chemin_date_heure_max:=c;
    with chemin_date_heure_max^ do attribut:=attribut or date_heure_max;
   end;
   c:=suivant;
  end;

  inc(cpt_doublons);
  AfficheBarre(xg+2,yh+1,cpt_doublons,nombre_doublons);
  d:=ChercheSuivant;
 end;

 Pause(6);
 VideBufferClavier;
 with z do begin Restaure(0,0,0,0); Supprime end;
end; {ChercheMinMaxDateHeure}

{--------------------------------------------------------------------}

procedure AfficheDoublons;

const car_ReadOnly: array[boolean] of char=('-','R');
      car_Hidden  : array[boolean] of char=('-','H');
      car_SysFile : array[boolean] of char=('-','S');
      car_Archive : array[boolean] of char=('-','A');

      car_special : array[boolean,boolean] of char=((' ',''),('',''));

var car_taille,car_date_heure: char;
    doublon_courant: doublon;
    chemin_doublon_courant: chemin_fichier;
    dt: DateTime;
    y,coul_fond,coul_txt: byte;
    car_gauche,car_droite: char;

begin  {AfficheDoublons}
 y:=y_haut;
 doublon_courant:=doublon_haut;

 repeat
  with doublon_courant^ do begin
   if (chemin_doublon_haut=nom_doublon) or (doublon_courant<>doublon_haut) then begin
    AffChXY2(1,2,y,XString(nom+' ^','',79),31,16+3);
    inc(y);
    chemin_doublon_courant:=premier_chemin;
   end
   else chemin_doublon_courant:=chemin_doublon_haut;

   while (chemin_doublon_courant<>nil) and (y<=y_bas) do with chemin_doublon_courant^ do begin
    UnPackTime(date_heure,dt);

    case attribut and (taille_min+taille_max) of
     taille_min: car_taille:='-';
     taille_max: car_taille:='+';
     else car_taille:=' '
    end;

    case attribut and (date_heure_min+date_heure_max) of
     date_heure_min: car_date_heure:='-';
     date_heure_max: car_date_heure:='+';
     else car_date_heure:=' '
    end;

    if chemin_doublon_courant=choix_chemin_doublon then begin
     coul_fond:=7;
     if (attribut and marque)=marque then coul_txt:=14 else coul_txt:=1;
     car_gauche:=''; car_droite:='';
    end
    else begin
     coul_fond:=1;
     if (attribut and marque)=marque then coul_txt:=14 else coul_txt:=7;
     car_gauche:=' '; car_droite:=' ';
    end;

    with dt do
     AffChXY2(1,2,y,car_gauche+'^'+
                    car_special[(attribut and traite)=traite,(attribut and erreur)=erreur]+'^'+
                    lecteur+':\'+XString(LimiteNomFichier(elem^.nom^,34)+' ','',36)+
                    EntierTexte(taille,8)+'^'+car_taille+' ^'+
                    EntierTexte2(Day,2)+'/'+EntierTexte2(Month,2)+'/'+EntierTexte2(Year,4)+'^'+
                    car_date_heure+' ^'+
                    EntierTexte2(Hour,2)+':'+EntierTexte2(Min,2+et_zeros)+'.'+EntierTexte2(Sec,2+et_zeros)+' '+
                    car_ReadOnly[(attribut_DOS and ReadOnly)=ReadOnly]+
                    car_Hidden  [(attribut_DOS and Hidden  )=Hidden  ]+
                    car_SysFile [(attribut_DOS and SysFile )=SysFile ]+
                    car_Archive [(attribut_DOS and Archive )=Archive ]+
                    ' '+car_droite,
              16*coul_fond+coul_txt,16*coul_fond+10);
    inc(y);
    chemin_doublon_courant:=suivant
   end;

   doublon_courant:=ChercheSuivant;
  end;
 until (doublon_courant=nil) or (y>y_bas);
end; {AfficheDoublons}

{--------------------------------------------------------------------}

procedure DefileHaut;
begin
 if chemin_doublon_haut=nom_doublon then begin
  doublon_haut:=doublon_haut^.CherchePrecedent; {il existe toujours...}
  chemin_doublon_haut:=doublon_haut^.premier_chemin;
  while chemin_doublon_haut^.suivant<>nil do
   chemin_doublon_haut:=chemin_doublon_haut^.suivant; {cherche dernier chemin}
 end
 else if chemin_doublon_haut^.precedent<>nil then chemin_doublon_haut:=chemin_doublon_haut^.precedent
      else chemin_doublon_haut:=nom_doublon;
end; {DefileHaut}

{--------------------------------------------------------------------}

procedure DefileBas;
begin
 if chemin_doublon_haut=nom_doublon then chemin_doublon_haut:=doublon_haut^.premier_chemin
 else if chemin_doublon_haut^.suivant<>nil then chemin_doublon_haut:=chemin_doublon_haut^.suivant
      else begin
       doublon_haut:=doublon_haut^.ChercheSuivant; {il existe toujours...}
       chemin_doublon_haut:=nom_doublon;
      end;
end; {DefileBas}

{--------------------------------------------------------------------}

procedure DeplaceHaut;
var d: doublon;
begin
 if choix_chemin_doublon^.precedent<>nil then begin
  choix_chemin_doublon:=choix_chemin_doublon^.precedent;
  dec(y_choix);
 end
 else begin
  d:=choix_doublon^.CherchePrecedent;
  if d<>nil then begin
   choix_doublon:=d;
   choix_chemin_doublon:=choix_doublon^.premier_chemin;
   while choix_chemin_doublon^.suivant<>nil do
    choix_chemin_doublon:=choix_chemin_doublon^.suivant; {cherche dernier chemin}
    dec(numero_doublon);
    dec(y_choix,2);
   end
  else begin
   chemin_doublon_haut:=nom_doublon; y_choix:=y_haut+1; {pour faire rapparatre le nom du premier doublon...}
  end;
 end;

 if y_choix<y_haut then repeat DefileHaut; inc(y_choix) until y_choix=y_haut;
end; {DeplaceHaut}

{--------------------------------------------------------------------}

procedure DeplaceBas;
var d: doublon;
begin
 if choix_chemin_doublon^.suivant<>nil then begin
  choix_chemin_doublon:=choix_chemin_doublon^.suivant;
  inc(y_choix);
 end
 else begin
  d:=choix_doublon^.ChercheSuivant;
  if d<>nil then begin
   choix_doublon:=d;
   choix_chemin_doublon:=choix_doublon^.premier_chemin;
   inc(numero_doublon);
   inc(y_choix,2);
  end;
 end;

 if y_choix>y_bas then repeat DefileBas; dec(y_choix) until y_choix=y_bas;
end; {DeplaceBas}

{--------------------------------------------------------------------}

procedure DeplacePageHaut;
var i: byte;
    anc_choix_chemin_doublon: chemin_fichier;
begin
 for i:=1 to y_bas-y_haut do begin
  anc_choix_chemin_doublon:=choix_chemin_doublon;
  DeplaceHaut;
  if choix_chemin_doublon=anc_choix_chemin_doublon then exit;
 end;
end; {DeplacePageHaut}

{--------------------------------------------------------------------}

procedure DeplacePageBas;
var i: byte;
    anc_choix_chemin_doublon: chemin_fichier;
begin
 for i:=1 to y_bas-y_haut do begin
  anc_choix_chemin_doublon:=choix_chemin_doublon;
  DeplaceBas;
  if choix_chemin_doublon=anc_choix_chemin_doublon then exit;
 end;
end; {DeplacePageBas}

{--------------------------------------------------------------------}

procedure DeplacePrecedent;
var d: doublon;
begin
 d:=choix_doublon;
 if d^.CherchePrecedent<>nil then repeat DeplaceHaut until choix_doublon<>d;
 repeat DeplaceHaut until choix_chemin_doublon^.precedent=nil;
end; {DeplacePrecedent}

{--------------------------------------------------------------------}

procedure DeplaceSuivant;
var d: doublon;
begin
 d:=choix_doublon;
 if d^.ChercheSuivant<>nil then repeat DeplaceBas until choix_doublon<>d
                           else repeat DeplaceBas until choix_chemin_doublon^.suivant=nil;
end; {DeplaceSuivant}

{--------------------------------------------------------------------}

procedure DeplacePremier;
begin
 choix_doublon:=choix_doublon^.Premier;
 choix_chemin_doublon:=choix_doublon^.premier_chemin;
 doublon_haut:=choix_doublon;
 chemin_doublon_haut:=nom_doublon;
 numero_doublon:=1;
 y_choix:=y_haut+1;
end; {DeplacePremier}

{--------------------------------------------------------------------}

procedure DeplaceDernier;
var anc_choix_doublon: doublon;
begin
 repeat
  anc_choix_doublon:=choix_doublon;
  DeplaceSuivant;
 until choix_doublon=anc_choix_doublon;
end; {DeplaceDernier}

{--------------------------------------------------------------------}

procedure ChercheInitiale(initiale: char);
const haut=-1; bas=+1;
var initiale_courante: char;
    anc_doublon: doublon;
    sens: shortint;
begin
 initiale_courante:=choix_doublon^.nom[1];
 if not(initiale_courante in ['A'..'Z']) then initiale_courante:=autre;

 if initiale<>initiale_courante then begin
  if initiale<initiale_courante then sens:=haut else sens:=bas;
  repeat
   anc_doublon:=choix_doublon;
   if sens=haut then DeplacePrecedent else DeplaceSuivant;
   initiale_courante:=choix_doublon^.nom[1];
   if not(initiale_courante in ['A'..'Z']) then initiale_courante:=autre;
   case sens of
    haut: if initiale_courante<=initiale then break;
    bas : if initiale_courante>=initiale then break;
   end;
  until choix_doublon=anc_doublon;
 end
 else begin
  DeplaceSuivant;
  if choix_doublon^.nom[1]>initiale then begin
   ChercheInitiale(CHAR(BYTE(initiale)-1));
   DeplaceSuivant;
  end;
 end;
end; {ChercheInitiale}

{--------------------------------------------------------------------}

procedure ChercheNom(saisie: boolean);

const xg=30; yh=12; largeur=21; hauteur=5; {fentre saisie}
      xd=xg+largeur-1; yb=yh+hauteur-1;

var z: Zone;
    nom: String12;
    abandon: boolean;
    doublon_initial,anc_doublon: doublon;

begin
 z.Ombre(0,xg,yh,xd,yb,16*3);
 Cadre(0,1,xg,yh,xd,yb,16*3+15,'Recherche fichier',16*3+15,'');

 if nom_recherche='' then saisie:=TRUE;

 if saisie then nom:=LitChaine(nom_recherche,xg+4,yh+2,12+1,12,FALSE,alpha+symboles_fichiers,TRUE,16*7+0,16*7+15,abandon)
           else AffChXY(0,xg+4,yh+2,XString(nom_recherche,' ',12+1),16*7+0);

 if (not(abandon) and (nom<>'')) or not(saisie) then begin
  if saisie then nom_recherche:=nom;

  doublon_initial:=choix_doublon;
  repeat
   anc_doublon:=choix_doublon;
   DeplaceSuivant;
   if choix_doublon=anc_doublon then DeplacePremier;
  until (Pos(nom_recherche,choix_doublon^.nom)<>0) or (choix_doublon=doublon_initial);
 end;

 with z do begin Restaure(0,0,0,0); Supprime end;
end; {ChercheNom}

{--------------------------------------------------------------------}

procedure MarqueDemarqueFichier;
begin
 with choix_chemin_doublon^ do
  case (attribut and marque) of
   aucun : begin
            attribut:=attribut or marque;
            if nombre_fichiers_marques=0 then inc(nombre_doublons_marques);
            inc(taille_doublons_marques,taille);
           end;
   marque: begin
            attribut:=attribut and not(marque);
            if nombre_fichiers_marques=1 then dec(nombre_doublons_marques);
            dec(taille_doublons_marques,taille);
           end;
  end;
 DeplaceBas;
end; {MarqueDemarqueFichier}

{--------------------------------------------------------------------}

procedure SupprimeDoublons;

const xg=16; yh=10; largeur=47; hauteur=6; {fentre suppression}
      xd=xg+largeur-1; yb=yh+hauteur-1;

var d: doublon;
    c: chemin_fichier;
    nombre_doublons_marques_initial,nombre_doublons_traites,
    nombre_fichiers_supprimes,nombre_fichiers_a_supprimer: word;
    elimine_doublon: boolean;
    car: char;
    z: Zone;

label fichier_suivant,doublon_suivant;

begin
 z.Ombre(0,xg,yh,xd,yb,48);
 Cadre(0,1,xg,yh,xd,yb,48+15,'Suppression',48+15,'');
 LigneHorizontale(0,1,yb-2,xg+1,xd-1,48+8);
 AffChXY(0,xg+2,yb-1,'TOTAL',48+11);

 nombre_doublons_marques_initial:=nombre_doublons_marques;
 nombre_doublons_traites:=0;
 d:=d^.Premier;

 while d<>nil do with d^ do begin
  AfficheBarre(xg+15,yb-1,nombre_doublons_traites,nombre_doublons_marques_initial);

  {comptage des fichiers  supprimer}
  nombre_fichiers_a_supprimer:=0;
  c:=premier_chemin;
  while c<>nil do with c^ do begin
   if (attribut and marque)=marque then inc(nombre_fichiers_a_supprimer);
   c:=suivant;
  end;

  if nombre_fichiers_a_supprimer<>0 then begin
   AffChXY(0,xg+2,yh+1,XString(nom,' ',12),48+15);
   nombre_fichiers_supprimes:=0;

   c:=premier_chemin;
   while c<>nil do with c^ do begin
    if (attribut and marque)=marque then begin
     AfficheBarre(xg+15,yh+1,nombre_fichiers_supprimes,nombre_fichiers_a_supprimer);
     AffChXY(0,xg+2,yh+2,lecteur+':\'+XString(LimiteNomFichier(elem^.nom^,largeur-7),' ',largeur-7),48+1);

     {suppression physique}
     repeat
      EffaceFichier(lecteur+':\'+elem^.nom^+nom);
      if f_erreur=f_ok then break;
      attribut:=erreur;
      case MessageErreur(f_erreur,lecteur+':\'+elem^.nom^+nom) of
       alt_repete  : if f_erreur=f_err_acces_ref then AttributFichier(lecteur+':\'+elem^.nom^+nom,attr_fixe,Archive);
       alt_continue: goto fichier_suivant;
       alt_annule  : goto doublon_suivant;
      end;
     until FALSE;

     {suppression logique}
     if precedent<>nil then precedent^.suivant:=suivant else premier_chemin:=suivant;
     if suivant<>nil then suivant^.precedent:=precedent;
     dec(taille_doublons,taille);
     inc(nombre_fichiers_supprimes);

     dec(taille_doublons_marques,taille);
    end;

   fichier_suivant:
    AfficheBarre(xg+15,yh+1,nombre_fichiers_supprimes,nombre_fichiers_a_supprimer);
    c:=suivant;
   end;

   {vrifie si le doublon a encore au moins 2 fichiers}
   elimine_doublon:=(premier_chemin=nil);
   if not(elimine_doublon) then
    if premier_chemin^.suivant=nil then begin  {ce doublon n'a plus qu'un fichier}
     elimine_doublon:=TRUE;
     dec(taille_doublons,premier_chemin^.taille);
    end;

   if elimine_doublon then begin
    if precedent<>nil then precedent^.suivant:=suivant
    else begin  {ce doublon tait le premier de l'entre du dictionnaire}
     car:=nom[1];
     if not(car in ['A'..'Z']) then car:=autre;
     Dictionnaire[car]:=suivant;
    end;
    if suivant<>nil then suivant^.precedent:=precedent;
    dec(nombre_doublons);
   end;

   Pause(1);
   dec(nombre_doublons_marques);
   inc(nombre_doublons_traites);
  end;

 doublon_suivant:
  AfficheBarre(xg+15,yb-1,nombre_doublons_traites,nombre_doublons_marques_initial);
  d:=ChercheSuivant;
 end;

 Pause(6);
 VideBufferClavier;
 with z do begin Restaure(0,0,0,0); Supprime end;
 ChercheMinMaxDateHeure;
end; {SupprimeDoublons}

{--------------------------------------------------------------------}

procedure DupliqueDoublons;

const xg_a=23; yh_a=10; largeur_a=34; hauteur_a=5; {fentre analyse}
      xd_a=xg_a+largeur_a-1; yb_a=yh_a+hauteur_a-1;

      xg=16; yh=9; largeur=47; hauteur=8; {fentre duplication}
      xd=xg+largeur-1; yb=yh+hauteur-1;

var d: doublon;
    c,source: chemin_fichier;
    fs,fd: Fichiers.Fichier;
    taille_source,taille_lue,taille_bloc: longint;
    nombre_doublons_marques_une_seule_fois,nombre_doublons_traites,
    nombre_fichiers_dupliques,nombre_fichiers_a_dupliquer: word;
    z: Zone;

label fichier_suivant,doublon_suivant;

begin
 {analyse les doublons et compte ceux qui sont marqus une seule fois
  (pour afficher la barre de pourcentage TOTAL duplication...)}
 z.Ombre(0,xg_a,yh_a,xd_a,yb_a,48);
 Cadre(0,1,xg_a,yh_a,xd_a,yb_a,48+15,'Analyse',48+15,'');

 nombre_doublons_marques_une_seule_fois:=nombre_doublons_marques;
 nombre_doublons_traites:=0;
 d:=d^.Premier;

 while d<>nil do with d^ do begin
  source:=nil; c:=premier_chemin;
  while c<>nil do with c^ do begin
   if (attribut and marque)=marque then
    if source=nil then source:=c else begin
     dec(nombre_doublons_marques_une_seule_fois);
     source:=nil;
     break
    end;
   c:=suivant;
  end;
  inc(nombre_doublons_traites);
  AfficheBarre(xg_a+2,yh_a+1,nombre_doublons_traites,nombre_doublons);
  AfficheBarre(xg_a+2,yh_a+3,nombre_doublons_marques_une_seule_fois,nombre_doublons_marques);
  d:=ChercheSuivant;
 end;

 Pause(6);
 with z do begin Restaure(0,0,0,0); Supprime end;
 if nombre_doublons_marques_une_seule_fois=0 then exit;

 {duplique les doublons qui ne sont marqus qu'une seule fois}
 z.Ombre(0,xg,yh,xd,yb,48);
 Cadre(0,1,xg,yh,xd,yb,48+15,'Duplication',48+15,'');
 AffChXY(0,xg+2,yh+2,'',48+14);
 AffChXY(0,xg+2,yh+3,'',48+14);
 LigneHorizontale(0,1,yb-2,xg+1,xd-1,48+8);
 AffChXY(0,xg+2,yb-1,'TOTAL',48+11);

 nombre_doublons_traites:=0;
 d:=d^.Premier;

 while d<>nil do with d^ do begin
  AfficheBarre(xg+15,yb-1,nombre_doublons_traites,nombre_doublons_marques_une_seule_fois);

  {comptage des fichiers  dupliquer}
  nombre_fichiers_a_dupliquer:=0;
  source:=nil; c:=premier_chemin;
  while c<>nil do with c^ do begin
   inc(nombre_fichiers_a_dupliquer);
   if (attribut and marque)=marque then
    if source=nil then source:=c else begin source:=nil; break end;
   c:=suivant;
  end;

  if source<>nil then begin
   AffChXY(0,xg+2,yh+1,XString(nom,' ',12),48+15);
   AffChXY(0,xg+6,yh+2,lecteur+':\'+XString(LimiteNomFichier(source^.elem^.nom^,largeur-11),' ',largeur-11),48+1);
   dec(nombre_fichiers_a_dupliquer);
   nombre_fichiers_dupliques:=0;

   c:=premier_chemin;
   while c<>nil do with c^ do begin
    AfficheBarre(xg+15,yh+1,nombre_fichiers_dupliques,nombre_fichiers_a_dupliquer);

    if c<>source then begin
     AffChXY(0,xg+6,yh+3,lecteur+':\'+XString(LimiteNomFichier(elem^.nom^,largeur-11),' ',largeur-11),48+1);

     {duplication physique}
     repeat
      fs.Ouvre(lecture,lecteur+':\'+source^.elem^.nom^+nom);
      if f_erreur=f_ok then break;
      attribut:=erreur;
      case MessageErreur(f_erreur,lecteur+':\'+source^.elem^.nom^+nom) of
       alt_repete,
       alt_continue:;
       alt_annule  : goto doublon_suivant;
      end;
     until FALSE;

     taille_source:=fs.Taille;
     taille_lue:=0;
     repeat
      AfficheBarre(xg+15,yh+4,taille_lue,taille_source);
      if taille_source-taille_lue<=taille_tampon then taille_bloc:=taille_source-taille_lue
                                                 else taille_bloc:=taille_tampon;
      repeat
       fs.Lit(tampon,taille_bloc);
       if f_erreur=f_ok then break;
       attribut:=erreur;
       case MessageErreur(f_erreur,lecteur+':\'+source^.elem^.nom^+nom) of
        alt_repete  :;
        alt_continue: break;
        alt_annule  : begin fs.Ferme; fd.Ferme; goto doublon_suivant end;
       end;
      until FALSE;

      if taille_lue=0 then  {premier passage -> cration fichier}
       repeat
        fd.Cree(ecrase,lecteur+':\'+elem^.nom^+nom);
        if f_erreur=f_ok then break;
        attribut:=erreur;
        case MessageErreur(f_erreur,lecteur+':\'+elem^.nom^+nom) of
         alt_repete  : if f_erreur=f_err_acces_ref then AttributFichier(lecteur+':\'+elem^.nom^+nom,attr_fixe,Archive);
         alt_continue: begin fs.Ferme; goto fichier_suivant end;
         alt_annule  : begin fs.Ferme; fd.Ferme; goto doublon_suivant end;
        end;
       until FALSE;

      repeat
       fd.Ecrit(tampon,taille_bloc);
       if f_erreur=f_ok then break;
       attribut:=erreur;
       case MessageErreur(f_erreur,lecteur+':\'+elem^.nom^+nom) of
        alt_repete  :;
        alt_continue: break;
        alt_annule  : begin fs.Ferme; fd.Ferme; goto doublon_suivant end;
       end;
      until FALSE;

      inc(taille_lue,taille_bloc);
     until taille_lue=taille_source;

     AfficheBarre(xg+15,yh+4,taille_lue,taille_source);
     CopieDateHeure(fs.GetHandle,fd.GetHandle);
     fs.Ferme; fd.Ferme;
     AttributFichier(lecteur+':\'+elem^.nom^+nom,attr_fixe,attribut_DOS or source^.attribut_DOS);

     {duplication logique}
     inc(taille_doublons,taille_source-taille);
     taille:=taille_source;
     date_heure:=source^.date_heure;
     attribut:=traite;
     attribut_DOS:=attribut_DOS or source^.attribut_DOS;
     inc(nombre_fichiers_dupliques);
    end;

   fichier_suivant:
    AfficheBarre(xg+15,yh+1,nombre_fichiers_dupliques,nombre_fichiers_a_dupliquer);
    c:=suivant;
   end;

   {dslection du fichier source et mise  jour des paramtres doublons marqus}
   with source^ do begin
    attribut:=aucun;
    dec(taille_doublons_marques,taille);
   end;
   dec(nombre_doublons_marques);
   inc(nombre_doublons_traites);
  end;

 doublon_suivant:
  AfficheBarre(xg+15,yb-1,nombre_doublons_traites,nombre_doublons_marques_une_seule_fois);
  d:=ChercheSuivant;
 end;

 Pause(6);
 VideBufferClavier;
 with z do begin Restaure(0,0,0,0); Supprime end;
 ChercheMinMaxDateHeure;
end; {DupliqueDoublons}

{====================================================================}

CONST CRLF=#13#10;

      aff_zone: boolean=TRUE;
      xg=12; largeur=55; xd=xg+largeur-1;

      coul_marque: array[boolean] of byte=(0,14);

var repert: String80;
    param: String12;
    anc_nbr_lignes,i,y_zone: byte;
    touche: Key;
    p: pointer;
    z: Zone;


procedure AfficheAide;
begin
 Write(titre_prog+' '+copyright+CRLF+'syntaxe : TDBL [lecteur]'+CRLF);
 halt;
end; {AfficheAide}


BEGIN
 case ParamCount of
  0: begin
      GetDir(0,repert); lecteur:=repert[1];
     end;
  1: begin
      param:=ParamStr(1);
      if param[1] in ['/','-','?'] then AfficheAide;
      lecteur:=System.UpCase(param[1]);
      if Pos(lecteur,ListeLecteurs)=0 then
       begin Writeln('Lecteur invalide: '+lecteur); halt end;
     end;
  else AfficheAide;
 end;

 anc_nbr_lignes:=NombreLignes+1;
 if CarteVGA then InitTexte(50) else InitTexte(25);
 Curseur(off);
 Clignotement(FALSE);

 VitesseClavier(0,0);
 CheckBreak:=FALSE;

 EffacePage(0,16);
 y_bas:=hauteur_ecran_txt-3;
 AffChXY2(0,1,1,' - '+titre_prog+'                         ^'+copyright+' ',240,244);
 AfficheMessageEtat('',FALSE);
 Cadre(0,1,1,y_haut-1,80,y_bas+1,16+15,'',0,'');

 Mark(p);

 ChercheDoublons;

 if erreur_sortie=0 then begin
  if nombre_doublons=0 then AfficheMessageEtat('Aucun doublon trouv!',TRUE)
  else begin
   InitEcran;
   ChercheMinMaxDateHeure;
   DeplacePremier;

   repeat
    choix_doublon^.Infos(nombre_fichiers,nombre_fichiers_marques,taille_fichiers,taille_fichiers_marques);

    if not KeyPressed then begin
     AfficheDoublons;
     if aff_zone then begin
      if y_choix<(y_haut+y_bas) div 2 then y_zone:=(y_haut+3*y_bas) div 4
                                      else y_zone:=(3*y_haut+y_bas) div 4;
      z.Ombre(1,xg,y_zone-3,xd,y_zone+3,48);
      Cadre(1,1,xg,y_zone-3,xd,y_zone+3,48+15,'Rsum',48+15,'');

      AffChXY(1,xg+2,y_zone-2,XString(choix_doublon^.nom,' ',12)+'  '+
                              EntierTexte2(nombre_fichiers,3)+' fichiers          '+
                              EntierTexte(taille_fichiers,8)+' octets',48+15);
      AffChXY2(1,xg+2,y_zone-1,'^'+EntierTexte2(numero_doublon,3)+'/'+
                               EntierTexte2(nombre_doublons,3)+'^     '+'  '+
                               EntierTexte2(nombre_fichiers_marques,3)+' fichiers marqus  '+
                               EntierTexte(taille_fichiers_marques,8)+' octets',
               48+coul_marque[nombre_fichiers_marques<>0],48+10);
      LigneHorizontale(1,1,y_zone,xg+1,xd-1,48+8);
      AffChXY2(1,xg+2,y_zone+1,'^TOTAL^       '+'  '+
                               EntierTexte2(nombre_doublons,3)+' doublons          '+
                               EntierTexte(taille_doublons,8)+' octets',48+15,48+11);
      AffChXY(1,xg+2,y_zone+2,'            '+'  '+
                              EntierTexte2(nombre_doublons_marques,3)+' doublons marqus  '+
                              EntierTexte(taille_doublons_marques,8)+' octets',
              48+coul_marque[nombre_doublons_marques<>0]);
     end;
     CopiePage(1,0);
     if aff_zone then with z do begin Restaure(1,0,0,0); Supprime end;
    end;

    touche:=UpCase(ReadKey);
    case touche of
     Up   : DeplaceHaut;
     Down : DeplaceBas;
     PgUp : DeplacePageHaut;
     PgDn : DeplacePageBas;
     Left : DeplacePrecedent;
     Right: DeplaceSuivant;
     Home : DeplacePremier;
     End_ : DeplaceDernier;

     Key('A')..Key('Z'): ChercheInitiale(CHAR(touche));

     Key('?'): ChercheNom(TRUE);
     Key('*'): ChercheNom(FALSE);

     Ins  : aff_zone:=not(aff_zone);

     Space: MarqueDemarqueFichier;

     Del  : if nombre_doublons_marques<>0 then
             if Confirme('Supprimer') then begin SupprimeDoublons; InitEcran; DeplacePremier end;
     Enter: if nombre_doublons_marques<>0 then
             if Confirme('Dupliquer') then DupliqueDoublons;

     Esc  : break;
    end;
   until choix_doublon=nil;

   if nombre_doublons=0 then AfficheMessageEtat('Aucun doublon trouv!',TRUE);
  end;
 end;

 Release(p);

 InitTexte(anc_nbr_lignes);
 VitesseClavier(1,3);
END.