{$A+,G+,N+,Q-,R-,S-}

USES Crt,Graph,FFT_U,Vesa;

CONST log2_long_echant=8; {=n}
	  long_echant     =1 shl log2_long_echant; {=2^n}
	  moitie_echant   =long_echant shr 1; {=n/2}
	  interv_freq     =50; {=1/T}
	  amplitude_max   =16384 div (long_echant div 16);

	  fin: boolean=FALSE;

	  {table pour l'chelle logarithmique (8 octaves, 16 bandes/octave)}
	  TableLog2: array[0..8*16-1] of byte
				  =( 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
					 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,
					 4, 4, 4, 4, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7,
					 8, 8, 9, 9,10,10,11,11,12,12,13,13,14,14,15,15,
					16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,
					32,34,36,38,40,42,44,46,48,50,52,54,56,58,60,62,
					64,68,72,76,80,84,88,92,96,100,104,108,112,116,120,124
				   );

	  {rsolution de l'cran}
	  XRES=1024;
	  YRES=768;

CONST ratio_trapeze=Round(0.05*(long_echant-1)); {1 bord=5% de l'chantillon}

      mode_FFT_directe=1*FFT_trapeze+0*FFT_hanning+
                       1*FFT_module+0*FFT_module2+0*FFT_moduleA;

VAR comp: array[1..3] of record ampl: integer; freq: word end;
    i: word;
	tampon_FFT: T_FFT;

    fenetre: array[T_FFT_taille] of real;
    sample,sampleF,sampleO: T_FFT_points;
    module: T_FFT_module2;

    max: longint;
    grDriver,grMode: integer;


BEGIN
 repeat
  TextMode(CO80+Font8x8);

  Writeln('chantillon: ',long_echant,' points, dure=',1000/interv_freq:4:2,' ms');
  Writeln('intervalle de frquence=',interv_freq,' Hz');
  Writeln('largeur de spectre=',long_echant*interv_freq div 2,' Hz');
  Writeln('amplitude maximale=',amplitude_max);

  Window(60,1,80,50);
  TextColor(White);
  GotoXY(1,1); Write('Signal d''entre:');
  TextColor(LightGray);
  Writeln;
  for i:=1 to 3 do with comp[i] do begin
   Writeln; Writeln('composante ',i,':');
   Write('  amplitude='); ReadLn(ampl);
   Write('  frquence='); ReadLn(freq);
  end;

  {gnre le son}
  for i:=0 to long_echant-1 do
   sample[i]:=Round(comp[1].ampl*Sin(2*Pi*comp[1].freq*i/long_echant/interv_freq)
                   -comp[2].ampl*Cos(2*Pi*comp[2].freq*i/long_echant/interv_freq)
                   +comp[3].ampl*Sin(2*Pi*comp[3].freq*i/long_echant/interv_freq)
                   );

  {multiplie par la fentre (uniquement pour l'affichage, car FFT() le fait
   mais le rsultat est inaccessible)}
  for i:=0 to long_echant-1 do fenetre[i]:=1.0;
  case mode_FFT_directe and (FFT_trapeze+FFT_hanning) of
   FFT_trapeze: for i:=0 to ratio_trapeze do begin
                 fenetre[i]:=(1-Cos(2*Pi*i/2/ratio_trapeze))/2;
                 fenetre[long_echant-1-i]:=(1-Cos(2*Pi*i/2/ratio_trapeze))/2;
                end;
   FFT_hanning: for i:=0 to long_echant-1 do fenetre[i]:=1-Cos(2*Pi*i/long_echant);
  end;
  for i:=0 to long_echant-1 do sampleF[i]:=Round(sample[i]*fenetre[i]);

  {remplit le tampon 'points' puis calcule la FFT}
  for i:=0 to long_echant-1 do tampon_FFT.points[i]:=sample[i];
  FFT(FFT_directe+mode_FFT_directe,tampon_FFT,log2_long_echant);

  {remplit le tampon 'module' s'il a t calcul, sinon on le calcule}
  case mode_FFT_directe and (FFT_module+FFT_module2+FFT_moduleA) of
   0: for i:=0 to moitie_echant-1 do with tampon_FFT.harmo[i] do
       module[i]:=Round(Sqrt(Sqr(LONGINT(hcos))+Sqr(LONGINT(hsin))));
   FFT_module : for i:=0 to moitie_echant-1 do module[i]:=tampon_FFT.module[i];
   FFT_module2: for i:=0 to moitie_echant-1 do module[i]:=tampon_FFT.module2[i];
   FFT_moduleA: for i:=0 to moitie_echant-1 do module[i]:=tampon_FFT.moduleA[i];
  end;

  Window(1,6,80,50);
  Writeln('harm  norm');
  for i:=0 to moitie_echant-1 do begin
   Write(i:3);
   if module[i]>0 then TextColor(White) else TextColor(DarkGray);
   Write(module[i]:6);
   TextColor(LightGray);
   if WhereX>6+4*9 then Writeln else Write('  ');
  end;

  {regnre le son d'origine  partir des harmoniques d'entre}
  for i:=0 to moitie_echant-1 do
   with tampon_FFT.harmo[i] do begin hsin:=0; hcos:=0 end;
  with tampon_FFT.harmo[comp[1].freq div interv_freq] do
   begin hsin:=comp[1].ampl; hcos:=0 end;
  with tampon_FFT.harmo[comp[2].freq div interv_freq] do
   begin hsin:=0; hcos:=-comp[2].ampl end;
  with tampon_FFT.harmo[comp[3].freq div interv_freq] do
   begin hsin:=comp[3].ampl; hcos:=0 end;
  FFT(FFT_inverse,tampon_FFT,log2_long_echant);
  {??????}
  {frquence maxi=(largeur de spectre)/2 ??}
  for i:=0 to moitie_echant-1 do sampleO[2*i]:=tampon_FFT.points[2*i];
  for i:=0 to moitie_echant-1 do sampleO[2*i+1]:=(sampleO[2*i]+sampleO[2*i+2]) div 2;
  {??????}

  GotoXY(60,20); Write('Espace: courbes');
  GotoXY(60,22); Write('Esc: fin');
  case Readkey of
   ' ': begin
		 InitVESA(VESA_1024x768_16,'C:\BP7\BGI','VESA16');

		 SetColor(DarkGray);
		 Line(0,(YRES div 4),(XRES-1),(YRES div 4));

		 {sample initial}
		 SetColor(Green);
		 max:=0;
		 for i:=0 to long_echant-1 do if Abs(sample[i])>max then max:=Abs(sample[i]);
		 MoveTo(0,(YRES div 4-1)-Round((YRES div 4-1)*LONGINT(sample[0])/max));
		 for i:=0 to long_echant-1 do
		  LineTo(    Round((XRES-1)*LONGINT(i)/long_echant),
				 (YRES div 4-1)-Round((YRES div 4-1)*LONGINT(sample[i])/max));

         {sample avec fentre}
         SetColor(Blue);
		 MoveTo(0,(YRES div 4-1)-Round((YRES div 4-1)*LONGINT(sampleF[0])/max));
         for i:=0 to long_echant-1 do
		  LineTo(    Round((XRES-1)*LONGINT(i)/long_echant),
				 (YRES div 4-1)-Round((YRES div 4-1)*LONGINT(sampleF[i])/max));

		 {sample d'origine aprs FFT inverse}
         SetColor(Magenta);
		 MoveTo(0,(YRES div 4-1)-Round((YRES div 4-1)*LONGINT(sampleO[0])/max));
         for i:=0 to long_echant-1 do
		  LineTo(    Round((XRES-1)*LONGINT(i)/long_echant),
				 (YRES div 4-1)-Round((YRES div 4-1)*LONGINT(sampleO[i])/max));

         {fentre seule}
         SetColor(LightGray);
         max:=0;
         for i:=0 to long_echant-1 do if Abs(fenetre[i])>max then max:=Round(Abs(fenetre[i]));
		 MoveTo(0,(YRES div 4-1)-Round((YRES div 4-1)*fenetre[0]/max));
         for i:=0 to long_echant-1 do
		  LineTo(    Round((XRES-1)*LONGINT(i)/long_echant),
				 (YRES div 4-1)-Round((YRES div 4-1)*fenetre[i]/max));

         {module, chelle linaire}
		 SetColor(LightRed);
         max:=0;
         for i:=0 to moitie_echant-1 do if module[i]>max then max:=module[i];
		 for i:=0 to moitie_echant-1 do
		  Line(Round((XRES-1)*LONGINT(i)/moitie_echant),(3*YRES div 4-1),
			   Round((XRES-1)*LONGINT(i)/moitie_echant),(3*YRES div 4-1)-Round((YRES div 4-1)*LONGINT(module[i])/max));

		 {module, chelle logarithmique}
		 SetColor(Yellow);
		 for i:=0 to moitie_echant-1 do
		  Line(Round((XRES-1)*LONGINT(i)/moitie_echant),(YRES-1),
			   Round((XRES-1)*LONGINT(i)/moitie_echant),(YRES-1)-Round((YRES div 4-1)*LONGINT(module[TableLog2[i]])/max));

         fin:=(Readkey=#27);
        end;
   #27: fin:=TRUE;
  end;
 until fin;

 TextMode(CO80);
END.
