{$A+,G+,N+,Q-,R-,S-}

USES Crt,Clavier,Graph,VESA,Util;

CONST log2_nbr_points_max=10; {=n}
      nbr_points_max=1 shl log2_nbr_points_max; {=2^n}

      {sens}
      FFT_directe=$0000;
      FFT_inverse=$0001;

      {constantes pour FFT directe}
        FFT_points =$0000; {entre: points rels (toujours!)}

        {fentres}
        FFT_rect   =$0000;
        FFT_trapeze=$0010;
        FFT_hanning=$0020;

        {type des donnes en sortie (harmoniques,module,module ou "module absolu")}
        FFT_harmo  =$0000;
        FFT_complex=$0100;
        FFT_module =$0200;
        FFT_module2=$0400;
        FFT_moduleA=$0800;

      {FFT inverse: entre=harmoniques, sortie=points rels (toujours!)}

TYPE type_d=real; {type des donnes}

     complex=record re,im: type_d end;

     T_FFT_taille=1..nbr_points_max;
     T_FFT_moitie=1..(nbr_points_max div 2);
     T_FFT_freq  =1..(nbr_points_max div 2)-1;

     T_FFT_points =array[T_FFT_taille] of type_d;  {points rels}
     T_FFT_complex=array[T_FFT_moitie] of complex; {points complexes (re,im)}
     T_FFT_harmo  =record
                    continu,bruit: type_d;         {composante continue, bruit rsiduel}
                    freq: array[T_FFT_freq] of     {composantes frquentielles harmoniques}
                           record hcos,hsin: type_d end;
                   end;
     T_FFT_module =array[T_FFT_moitie] of type_d;  {module=(hcos+hsin)}
     T_FFT_module2=array[T_FFT_moitie] of type_d;  {module=hcos+hsin}
     T_FFT_moduleA=T_FFT_module;                   {module=hcos+hsin}

     T_FFT=record case byte of
            FFT_points :(points :T_FFT_points);
            FFT_complex:(complex:T_FFT_complex);
            FFT_harmo  :(harmo  :T_FFT_harmo);
            FFT_module :(module :T_FFT_module);
            FFT_module2:(module2:T_FFT_module2);
            FFT_moduleA:(moduleA:T_FFT_moduleA);
           end;


procedure FFT(var tampon: T_FFT; log2_nbr_points: byte);

var nbr_points: word;
    index,minusindex,lowindex,highindex: word;
    temp1,temp2,w: complex;
    ch,cl: ^complex;
    baseangle,angle,temp: type_d;
    complexpoints,partitionsize,halfsize,offset: word;
    bits: byte;

function Log2(n: word): byte; assembler;
asm
 mov BX,n
 mov CX,15
@boucle:
 rcl BX,1
 jc  @fin
 loop @boucle
@fin:
 mov AL,CL
end; {Log2}

function Bitreverse(index: word; bits: byte): word; assembler;
asm
 xor AX,AX
 mov BX,index
 dec BX
 mov CL,bits
@boucle:
 shr BX,1
 rcl AX,1
 dec CL
 jnz @boucle
 inc AX
end; {Bitreverse}

procedure Swap(var a,b: complex);
var temp: complex;
begin
 temp:=a; a:=b; b:=temp;
end; {Swap}

begin  {FFT}
 nbr_points:=1 shl log2_nbr_points;

 with tampon do begin
  complexpoints:=nbr_points div 2;
  partitionsize:=complexpoints;

  repeat
   halfsize:=partitionsize div 2;
   baseangle:=2*PI/partitionsize;

   for offset:=1 to halfsize do begin
    angle:=baseangle*(offset-1); {0  angle < }
    w.re:= cos(angle);
    w.im:=-sin(angle);
    lowindex:=offset;

    repeat
     highindex:=lowindex+halfsize;
     cl:=@complex[lowindex];
     ch:=@complex[highindex];

     temp1.re:=cl^.re-ch^.re;
     temp1.im:=cl^.im-ch^.im;

     cl^.re:=cl^.re+ch^.re;
     cl^.im:=cl^.im+ch^.im;

     ch^.re:=temp1.re*w.re-temp1.im*w.im;
     ch^.im:=temp1.re*w.im+temp1.im*w.re;

     inc(lowindex,partitionsize);
    until lowindex>=complexpoints;
   end;

   partitionsize:=partitionsize div 2;
  until partitionsize=1;

  bits:=Log2(complexpoints);
  for lowindex:=1 to complexpoints do begin
   highindex:=Bitreverse(lowindex,bits);
   if highindex>lowindex then Swap(complex[lowindex],complex[highindex]);
  end;

  for index:=1 to complexpoints do begin
   complex[index].re:=complex[index].re/complexpoints;
   complex[index].im:=complex[index].im/complexpoints;
  end;

  with complex[1],harmo do begin
   continu:=(re+im)/2;
   bruit  :=(re-im)/2;
  end;

  baseangle:=-2*PI/nbr_points;

  for index:=1 to (nbr_points div 4) do begin
   minusindex:=(nbr_points div 2)-index;

   temp1.re:=complex[index+1].re+complex[minusindex+1].re;
   temp1.im:=complex[index+1].im-complex[minusindex+1].im;
   temp2.re:=complex[index+1].re-complex[minusindex+1].re;
   temp2.im:=complex[index+1].im+complex[minusindex+1].im;

   angle:=baseangle*index;
   w.re:= sin(angle);
   w.im:=-cos(angle);

   temp:=temp2.re;
   temp2.re:=temp2.re*w.re-temp2.im*w.im;
   temp2.im:=temp*w.im+temp2.im*w.re;

   harmo.freq[index].hcos:= (temp1.re+temp2.re)/2;
   harmo.freq[index].hsin:=-(temp1.im+temp2.im)/2;

   harmo.freq[minusindex].hcos:= (temp1.re-temp2.re)/2;
   harmo.freq[minusindex].hsin:=-(temp1.im-temp2.im)/2;
  end;
 end;
end; {FFT}


procedure Aff(x: type_d; n: byte);
begin
 if x=0 then SetColor(DARKGRAY)
 else if Abs(x)<exp(-n*ln(10)) then SetColor(LIGHTGRAY) else SetColor(WHITE);
 OutText(ReelTexte(x,3+n,n));
end;


CONST log2_long_echant=10;
      long_echant     =1 shl log2_long_echant;
      moitie_echant   =long_echant div 2;
      interv_freq     =50;
      duree_echant    =1/interv_freq;
      larg_spectre    =(long_echant*interv_freq) div 2;
      harmo_freq_max  =(long_echant div 2)-1;

      ratio_trapeze=0.5;

      aff_norme: boolean=TRUE;

VAR continu: type_d;
    comp: array[1..3] of record ampl,freq: type_d end;

    sample: array[0..long_echant-1] of integer;
    sampleI,sampleF,sampleO: array[0..long_echant-1] of type_d;
    fenetre: array[0..long_echant-1] of type_d;
    module: array[0..harmo_freq_max] of type_d;

    tampon_FFT: T_FFT;

    touche: Key;

    i,Y0,max: word;
    v,maxr: type_d;

BEGIN
 if not(VESAOk) then begin
  Writeln('Cette carte graphique ne supporte pas les modes vido VESA.');
  halt;
 end;

 repeat
  TextMode(CO80+Font8x8);
  TextColor(LIGHTGRAY);

  {saisie des composantes}
  Write('continu='); Readln(continu);
  for i:=1 to 3 do begin
   Writeln; Writeln('composante ',i,':');
   Write('  amplitude='); Readln(comp[i].ampl);
   Write('  frquence='); Readln(comp[i].freq);
  end;

  TextColor(WHITE);
  Writeln;
  Writeln('gnration...');

  {gnration du sample}
  for i:=0 to long_echant-1 do begin
   v:= continu
      +comp[1].ampl*sin(2*PI*comp[1].freq*i/long_echant+3)
      -comp[2].ampl*cos(2*PI*comp[2].freq*i/long_echant+7)
      +comp[3].ampl*sin(2*PI*comp[3].freq*i/long_echant-5);

   sample[i] :=Round(v);
   sampleI[i]:=v;
  end;

  Writeln('fentrage...');

  {initialisation de la fentre}

  for i:=0 to long_echant-1 do fenetre[i]:=1.0;

  {trapze modifi}
  for i:=0 to Round(ratio_trapeze*long_echant)-1 do begin
   fenetre[i]:=(1-cos(2*PI*i/Round(ratio_trapeze*long_echant)/2))/2;
   fenetre[long_echant-1-i]:=fenetre[i];
  end;

  for i:=0 to long_echant-1 do sampleF[i]:=sampleI[i]*fenetre[i];

  Writeln('calcul FFT...');

  {remplissage du tampon FFT}
  for i:=0 to long_echant-1 do tampon_FFT.points[i+1]:=sampleI[i];

  {calcul de la FFT directe}
  FFT(tampon_FFT,log2_long_echant);

  {calcule le module des harmoniques}
  with tampon_FFT.harmo do begin
   module[0]:=Sqrt(Sqr(continu)+Sqr(bruit));
   for i:=1 to harmo_freq_max do with freq[i] do
    module[i]:=Sqrt(Sqr(hcos)+Sqr(hsin));
  end;

  InitVESA(VESA_1024x768_16,'C:\BP7\BGI','VESA16');

  repeat
   ClearViewPort;

   SetColor(YELLOW);
   OutTextXY(0,GetMaxY-16,'Espace:norme<->cos,sin   C:courbes   :nouveau   Esc:fin');

   with tampon_FFT.harmo do begin
    SetColor(LIGHTGRAY);
    OutTextXY(0,0,'continu='+ReelTexte(continu,8,4));
    MoveTo(0,10); OutText('bruit  =');
    if bruit=0 then OutText(ReelTexte(bruit,8,4))
    else if Abs(bruit)<1e-4 then OutText(ReelTexte(bruit,10,8))
                            else OutText(ReelTexte(bruit,8,6));

    SetColor(WHITE);
    MoveTo(0,24);
    if aff_norme then OutText('harm  norme') else OutText('harm  cos   sin');

    for i:=1 to harmo_freq_max do with freq[i] do begin
     SetColor(CYAN);
     MoveTo(128*(i div 64),40+8*(i mod 64));
     OutText(EntierTexte2(i,3)+' ');

     if aff_norme then Aff(Sqrt(Sqr(hcos)+Sqr(hsin)),6)
     else begin Aff(hcos,2); OutText(' '); Aff(hsin,2) end;
    end;
   end;

   repeat
    touche:=UpCase(ReadKey);
   until touche in [Space,Key('C'),Enter,Esc];

   case touche of
    Space: aff_norme:=not(aff_norme);

    Key('C'): begin
               ClearViewPort;

               Y0:=GetMaxY div 3;

               SetColor(DARKGRAY);
               Line(0,Y0,GetMaxX,Y0);

               {sample entier (arrondi)}
               SetColor(CYAN);
               max:=0;
               for i:=0 to long_echant-1 do if Abs(sample[i])>max then max:=Abs(sample[i]);
               if max=0 then max:=1;
               MoveTo(0,Y0-Round(Y0*LONGINT(sample[0])/max));
               for i:=0 to long_echant-1 do
                LineTo(i,Y0-Round(Y0*LONGINT(sample[i])/max));

               {sample initial}
               SetColor(GREEN);
               maxr:=0;
               for i:=0 to long_echant-1 do if Abs(sampleI[i])>maxr then maxr:=Abs(sampleI[i]);
               if maxr=0 then maxr:=1;
               MoveTo(0,Y0-Round(Y0*sampleI[0]/maxr));
               for i:=0 to long_echant-1 do
                LineTo(i,Y0-Round(Y0*sampleI[i]/maxr));

               {sample avec fentre}
               SetColor(BLUE);
               MoveTo(0,Y0-Round(Y0*sampleF[0]/maxr));
               for i:=0 to long_echant-1 do
                LineTo(i,Y0-Round(Y0*sampleF[i]/maxr));

               {sample d'origine aprs FFT inverse}
               SetColor(MAGENTA);
               MoveTo(0,Y0-Round(Y0*sampleO[0]/maxr));
               for i:=0 to long_echant-1 do
                LineTo(i,Y0-Round(Y0*sampleO[i]/maxr));

               {fentre seule}
               SetColor(LIGHTGRAY);
               maxr:=0;
               for i:=0 to long_echant-1 do if Abs(fenetre[i])>maxr then maxr:=Round(Abs(fenetre[i]));
               if maxr=0 then maxr:=1;
               MoveTo(0,Y0-Round(Y0*fenetre[0]/maxr));
               for i:=0 to long_echant-1 do
                LineTo(i,Y0-Round(Y0*fenetre[i]/maxr));

               {module FFT}
               SetColor(LIGHTRED);
               maxr:=0;
               for i:=0 to harmo_freq_max do if module[i]>maxr then maxr:=module[i];
               for i:=0 to harmo_freq_max do
                Line(2*i,GetMaxY,2*i,GetMaxY-Round(Y0*module[i]/maxr));

               ReadKey;
              end;

    Enter: break;
    Esc  : break;
   end;
  until FALSE;
 until touche=Esc;

 TextMode(CO80);
END.
