{$A+,G+,Q-,R-,S-}

USES Crt;

{compression par mthode RLE (Run-Length Encoding) amliore

 codage: 3 cas

  1      8
 ĿĿ         octet isol
 0  valeur           pas de rptition
          longueur: 9 bits

  1  1   4       8
 ĿĿĿĿ    octet rpt
 10rpt  valeur      rptitions sur 4 bits: 0 -> 2, ..., 15 -> 17
     longueur: 14 bits

  1  1      8           8
 ĿĿĿĿ  octet rpt
 11rptition  valeur    rptitions sur 8 bits: 0 -> 18, ..., 255 -> 273
   longueur: 18 bits

}

CONST {mthodes de compression}
      RLE_STOCKAGE =0;
      RLE_NORMAL   =1;

TYPE RLE=object
          constructor Init;
          destructor  Done;

          function  Compacte  (var source; taille: word): boolean;
          procedure Decompacte(var destination);

         private
          methode : byte;  {mthode de compression}
          longueur: word;  {longueur de la zone pointe par 'donnees'}
          donnees : ^byte; {pointeur de donnes compactes}

          function  Longueur_(var source; taille: word): word;
         end;

     T_tab=array[0..0] of byte; {pour accder  (p+i)^ par p[i]}
     P_Byte=^byte;


constructor RLE.Init;
begin
 methode :=RLE_NORMAL;
 longueur:=0;
 donnees :=nil;
end; {RLE.Init}


destructor RLE.Done;
begin
 if (donnees<>nil) then begin FreeMem(donnees,longueur); donnees:=nil; end;
 longueur:=0;
 methode :=RLE_NORMAL;
end; {RLE.Done}


function RLE.Longueur_(var source; taille: word): word;

var longueur_bits: longint;
    valeur,anc_valeur: byte;
    i,nombre: word;

begin
 anc_valeur:=T_tab(source)[0];
 nombre:=0;
 longueur_bits:=0;

 for i:=0 to taille-1 do begin
  valeur:=T_tab(source)[i];

  if (valeur=anc_valeur) and (nombre<273) then inc(nombre)
  else begin
   if nombre=1 then inc(longueur_bits,1)  {'0'}
   else begin
    inc(longueur_bits,1); {'1'}
    if nombre<=17 then inc(longueur_bits,1+4)  {'0', nombre-2 }
                  else inc(longueur_bits,1+8); {'1', nombre-18}
   end;
   inc(longueur_bits,8); {anc_valeur}

   anc_valeur:=valeur;
   nombre:=1;
  end;
 end;

 if nombre=1 then inc(longueur_bits,1)  {'0'}
 else begin
  inc(longueur_bits,1); {'1'}
  if nombre<=17 then inc(longueur_bits,1+4)  {'0', nombre-2 }
                else inc(longueur_bits,1+8); {'1', nombre-18}
 end;
 inc(longueur_bits,8); {anc_valeur}

 Longueur_:=1+((longueur_bits-1) div 8);
end; {RLE.Longueur_}


function RLE.Compacte(var source; taille: word): boolean;

var valeur,anc_valeur: byte;
    i,nombre,index_destination: word;
    index_bits: byte;
    tampon: longint;

procedure EcritBits(nombre_bits: byte; valeur: word);
begin
 tampon:=tampon or (LONGINT(valeur) shl index_bits);
 inc(index_bits,nombre_bits);
 while index_bits>=8 do begin
  T_tab(donnees^)[index_destination]:=tampon;
  tampon:=tampon shr 8;
  dec(index_bits,8);
  inc(index_destination);
 end;
end;

begin
 Done;

 longueur:=Longueur_(source,taille);
 if (longueur>taille) then begin
  methode:=RLE_STOCKAGE;
  longueur:=taille;
 end;

 GetMem(donnees,longueur);
 if (donnees=nil) then begin Compacte:=FALSE; exit; end;

 if methode=RLE_STOCKAGE then begin Move(source,donnees^,longueur); Compacte:=TRUE; exit; end;

 anc_valeur:=T_tab(source)[0];
 nombre:=0;
 index_destination:=0;
 index_bits:=0;
 tampon:=0;

 for i:=0 to taille-1 do begin
  valeur:=T_tab(source)[i];

  if (valeur=anc_valeur) and (nombre<273) then inc(nombre)
  else begin
   if nombre=1 then EcritBits(1,$0)
   else begin
    EcritBits(1,$1);
    if nombre<=17 then begin EcritBits(1,$0); EcritBits(4,nombre-2 ); end
                  else begin EcritBits(1,$1); EcritBits(8,nombre-18); end;
   end;
   EcritBits(8,anc_valeur);

   anc_valeur:=valeur;
   nombre:=1;
  end;
 end;

 if nombre=1 then EcritBits(1,$0)
 else begin
  EcritBits(1,$1);
  if nombre<=17 then begin EcritBits(1,$0); EcritBits(4,nombre-2 ); end
                else begin EcritBits(1,$1); EcritBits(8,nombre-18); end;
 end;
 EcritBits(8,anc_valeur);

 if index_bits>0 then T_tab(donnees^)[index_destination]:=tampon;

 Compacte:=TRUE;
end; {RLE.Compacte}


procedure RLE.Decompacte(var destination);

var valeur: byte;
    i,nombre,index_source,index_destination: word;
    index_bits: byte;
    tampon: longint;

function LitBits(nombre_bits: byte): longint;
var valeur: byte;
begin
 while index_bits<nombre_bits do begin
  valeur:=T_tab(donnees^)[index_source];
  inc(index_source);
  tampon:=tampon or (LONGINT(valeur) shl index_bits);
  inc(index_bits,8);
 end;
 LitBits:=tampon and ((LONGINT(1) shl nombre_bits)-1);
 tampon:=tampon shr nombre_bits;
 dec(index_bits,nombre_bits);
end;

begin
 if methode=RLE_STOCKAGE then begin Move(donnees^,destination,longueur); exit; end;

 index_source:=0;
 index_destination:=0;
 index_bits:=0;
 tampon:=0;

 while index_source<longueur do begin
  if LitBits(1)=$0 then nombre:=1
  else if LitBits(1)=$0 then nombre:=LitBits(4)+2 else nombre:=LitBits(8)+18;
  valeur:=LitBits(8);

  for i:=1 to nombre do begin
   T_tab(destination)[index_destination]:=valeur;
   inc(index_destination);
  end;
 end;
end; {RLE.Decompacte}


VAR z: RLE;

BEGIN
 z.Init;
 z.Compacte(Mem[$B800:0],2*80*50);
 ReadKey;
 ClrScr;
 ReadKey;
 z.Decompacte(Mem[$B800:0]);
 ReadKey;
 z.Done;
END.
