{$A+,G+,Q-,R-,S-}

USES Clavier,Util,Texte,Graph256,BMP256,Souris,SourisT;

CONST nbr_car=5;
      nbr_coul_fond=8;
      nbr_coul_ecr =16;

      trame: array[1..nbr_car] of record car: char; tramage: real; end
             =((car:' '; tramage:0),
               (car:''; tramage:0 { calculer}),
               (car:''; tramage:0 { calculer}),
               (car:''; tramage:0 { calculer}),
               (car:''; tramage:1));

      nombre_couleurs: word=0;

TYPE PaletteTrame=array[byte] of word;

VAR couleurs: array[1..nbr_car*nbr_coul_fond*nbr_coul_ecr] of
               record
                couleur   : RVB;
                luminosite: byte;
                caractere : char;
                attribut  : byte;
               end;

    palette_txt: Palette16;

{==========================================================}

procedure CalculeTramages;

var c,n,h,l: byte;
    motif: Binaire16;

begin
 for c:=1 to nbr_car do begin
  MotifBinaire(0,trame[c].car,motif);

  {compte le nombre de pixels allums dans le motif du caractre}
  n:=0;
  for h:=1 to hauteur_car do
   for l:=0 to 7 do if (motif[h] and (1 shl l))<>0 then inc(n);

  {le coefficient de tramage est proportionnel  ce nombre}
  trame[c].tramage:=n/(hauteur_car*8);
 end;
end; {CalculeTramages}

{----------------------------------------------------------}

procedure CalculeCouleurs;

var c,f,e: byte;
    i: word;
    existe: boolean;
    couleur: RVB;

begin
 for c:=1 to nbr_car do
  for f:=0 to nbr_coul_fond-1 do
   for e:=0 to nbr_coul_ecr-1 do
    if e<>f then with palette_txt do begin
     {calcule la couleur rsultante du tramage du fond et de l'criture}
     couleur.R:=Round((1-trame[c].tramage)*palette[f].R+trame[c].tramage*palette[e].R);
     couleur.V:=Round((1-trame[c].tramage)*palette[f].V+trame[c].tramage*palette[e].V);
     couleur.B:=Round((1-trame[c].tramage)*palette[f].B+trame[c].tramage*palette[e].B);

     {teste si la couleur rsultante existe dj}
     existe:=FALSE;
     for i:=1 to nombre_couleurs do with couleur do
      if (couleurs[i].couleur.R=R) and
         (couleurs[i].couleur.V=V) and
         (couleurs[i].couleur.B=B) then begin existe:=TRUE; break; end;

     {si la couleur est nouvelle, on l'ajoute aux autres}
     if not(existe) then begin
      inc(nombre_couleurs);
      couleurs[nombre_couleurs].couleur   :=couleur;
      couleurs[nombre_couleurs].luminosite:=couleur.R+couleur.V+couleur.B;
      couleurs[nombre_couleurs].caractere :=trame[c].car;
      couleurs[nombre_couleurs].attribut  :=16*f+e;
     end;
    end;
end; {CalculeCouleurs}

{----------------------------------------------------------}

function CalculeNumeroCouleur(couleur: RVB): word;

var ecart,ecart_min: byte;
    meilleure_coul,num_coul: word;

begin
 ecart_min:=3*64;
 meilleure_coul:=1;
 for num_coul:=1 to nombre_couleurs do with couleur do begin
  ecart:=Abs(couleurs[num_coul].couleur.R-R)+
         Abs(couleurs[num_coul].couleur.V-V)+
         Abs(couleurs[num_coul].couleur.B-B);

  if ecart<ecart_min then begin ecart_min:=ecart; meilleure_coul:=num_coul; end;
 end;

 CalculeNumeroCouleur:=meilleure_coul;
end; {CalculeNumeroCouleur}

{----------------------------------------------------------}

procedure CalculePalette(palette: Palette256; var palette_trame: PaletteTrame);
var c: byte;
begin
 for c:=0 to 255 do palette_trame[c]:=CalculeNumeroCouleur(palette.palette[c]);
end; {CalculePalette}

{----------------------------------------------------------}

procedure QuickSort(debut,fin: word);
var i,j: word;
    aux: byte;
begin
 i:=debut; j:=fin; aux:=couleurs[(debut+fin) div 2].luminosite;
 repeat
  while couleurs[i].luminosite<aux do inc(i);
  while aux<couleurs[j].luminosite do dec(j);
  if i<=j then begin
   SwapVar(couleurs[i],couleurs[j],sizeof(couleurs[1]));
   inc(i); if j>0 then dec(j);
  end;
 until i>j;
 if debut<j then QuickSort(debut,j);
 if i<fin   then QuickSort(i,fin);
end; {QuickSort}

{==========================================================}

CONST nom_image: String80='C:\PROJETS\TESTS\SQ4.BMP';

      aff_zoom: boolean=FALSE;
      zoom_min=0.5;
      zoom_max=6.0;
      zoom_pas=1.05;
      zoom: real=1.0;

      auto: boolean=FALSE;
      delai=54;

VAR image: BMP;
    erreur: word;

    palette_trame: PaletteTrame;
    c,x,y,ys: byte;
    dx_z,dy_z: real;
    dx,dy,dy_i: word;

    t: longint;
    sens: shortint;

BEGIN
 if ParamCount<>0 then nom_image:=ParamStr(1);
 image.Charge(nom_image,erreur);
 if erreur<>0 then begin Writeln('erreur BMP: ',erreur); halt; end;

 InitTexte(50);
 LargeurCar(8);
 Curseur(off);

 AffCh('Calcul...');

 with image do begin
  {calcule la palette 16 couleurs optimise pour le mode texte}
  ReduitPalette(16);
  for c:=0 to 15 do palette_txt.palette[c]:=Texte.RVB(palette.palette[c]);
  palette_txt.Fixe;

  {recharge l'image d'origine (256 couleurs)}
  Charge(nom_image,erreur);

  {calcule les tramages de chaque caractre}
  CalculeTramages;

  {calcule les couleurs trames d'aprs la palette 16 couleurs}
  CalculeCouleurs;

  {trie le tableau de couleurs par luminosit croissante}
  QuickSort(1,nombre_couleurs);

  {calcule les couleurs trames correspondant aux 256 couleurs de l'image}
  CalculePalette(palette,palette_trame);

  BougeCursSourisXY(40,10);

  repeat
   dx_z:=ResX/zoom-largeur_ecran_txt;
   if dx_z>0 then dx:=Round(((Xsouris-1)*dx_z)/(largeur_ecran_txt-1))
             else dx:=0;

   dy_z:=ResY/zoom-hauteur_ecran_txt;
   if dy_z>0 then dy:=Round(((Ysouris-1)*dy_z)/(hauteur_ecran_txt-1))
             else dy:=0;

   AttendVBL2;
   for y:=1 to 50 do begin
    dy_i:=ResX*Round(zoom*(y+dy-1));
    for x:=1 to 80 do
     with couleurs[palette_trame[image^[1+Round(zoom*(x+dx-1))+dy_i]]] do
      Texte.AffCarXY(0,x,y,caractere,attribut);
   end;

   if aff_zoom then
    Texte.AffChXY(0,1,1,EntierTexte2(nombre_couleurs,3)+' / '+ReelTexte(zoom,3,1),7);

   case auto of
    FALSE: begin
            t:=Timer;
            repeat until SourisBouge or KeyPressed or (BoutonSouris<>aucun) or (Timer>t+delai);
            auto:=(Timer>t+delai);
            if auto then begin
             ys:=Ysouris;
             if ys<50 then sens:=+1 else sens:=-1;
            end;
           end;

    TRUE : begin
            BougeCursSourisXY(Xsouris,ys);
            inc(ys,sens);
            case ys of
              1: sens:=+1;
             50: sens:=-1;
            end;
            auto:=not(SourisBouge or KeyPressed or (BoutonSouris<>aucun));
           end;
   end;

   if KeyPressed then
    case ReadKey of
     Key('-'): if zoom<zoom_max then zoom:=zoom*zoom_pas;
     Key('+'): if zoom>zoom_min then zoom:=zoom/zoom_pas;

     Enter: aff_zoom:=not(aff_zoom);

     Space: begin
             Init320x200;
             FixePalette;
             Affiche($A000,0,0);

             ReadKey;

             InitTexte(50);
             LargeurCar(8);
             Curseur(off);
             palette_txt.Fixe;
            end;
     Esc: break;
    end;
  until BoutonSouris<>aucun;

  Supprime;
 end;

 InitTexte(25);
END.
