PROGRAM UUclean;
{Nettoyeur de fichiers textes encods au format UU}

{format d'un fichier source:

...
...                         _
begin 6xx nom_fichier.ext    \
M...                          \
M...                          |
.                             |
.                             | donnes utiles
.                             |
M...                          |
`                             /
end                         _/
...
...

}

{$A+,G+,Q-,R-,S-}

USES Dos;

CONST CRLF=#13#10;

VAR info: SearchRec;
    rep: DirStr;
    nom: NameStr;
    ext: ExtStr;

    temp,nom_fichier: string[12];
    nom_base: NameStr;

    f_in,f_out: Text;

    ligne: string[80];
    debut,fin: boolean;
    p: byte;

BEGIN
  Writeln(CRLF,
          'UUclean v1.0 - (c) 1999 Fabrice Couteau',CRLF,
          'Nettoyeur de fichiers encods au format UU',CRLF);

  if ParamCount<>1 then begin
    Writeln('syntaxe: UUclean nom_fichier',CRLF);
    halt(1);
  end;

  temp:='~UU_TMP~.$$$';

  FSplit(ParamStr(1),rep,nom,ext);

  FindFirst(rep+nom+ext,Archive,info);
  while DosError=0 do begin
    nom_fichier:=info.Name;

    p:=Pos('.',nom_fichier);
    if p>0 then nom_base:=Copy(nom_fichier,1,p-1) else nom_base:=nom_fichier;

    Write(nom_fichier+' ':15);

    Assign(f_in,rep+nom_fichier);
    {$I-}
    Reset(f_in);
    {$I+}
    if IOResult<>0 then begin
      Writeln('Fichier introuvable');
      continue;
    end;

    Assign(f_out,rep+temp);
    {$I-}
    Rewrite(f_out);
    {$I+}
    if IOResult<>0 then begin
      Writeln('Impossible de crer le fichier temporaire');
      continue;
    end;

    debut:=FALSE;
    fin  :=FALSE;

    while not(eof(f_in)) and not(fin) do begin
      Readln(f_in,ligne);

      if Copy(ligne,1,5)='begin' then begin
        debut:=TRUE;

        p:=Pos('.',ligne);
        if p>0 then ext:=Copy(ligne,p,4);

        ligne:=Copy(ligne,1,10)+nom_base+ext;
      end;

      if ligne='end' then fin:=TRUE;

      if debut then Writeln(f_out,ligne);
    end;

    Close(f_in);
    Close(f_out);

    if not(debut) then Writeln('"begin" non rencontr') else
      if not(fin) then Writeln('"end" non rencontr') else begin
      {$I-}
      Erase(f_in);
      {$I+}
      if IOResult<>0 then;

      {$I-}
      Rename(f_out,nom_base+'.UU');
      {$I+}
      if IOResult<>0 then begin
        Writeln('Impossible de renommer le fichier temporaire');
        continue;
      end;

      Writeln('-> ',nom_base,'.UU');
    end;

    FindNext(info);
  end;

  Assign(f_out,rep+temp);
  {$I-}
  Erase(f_out);
  {$I+}
  if IOResult<>0 then;
END.
