PROGRAM VOCRip; {Ripeur de fichiers VOC}
{$A+,G+,Q-,R-,S-}

USES Fichiers;

CONST nbr_fich_max=1024;

      un_kilo=1024;
      long_tampon=16*un_kilo;

TYPE tranche=array[1..long_tampon] of byte;

VAR nom_fichier: String80;
    nbr_fichiers_VOC: word;
    Table_offset,Table_longueur: array[1..nbr_fich_max] of LongInt;
    taille_fichier: LongInt;

{=========================================================}

procedure AnalyseFichier;

const identVOC: string[19]='Creative Voice File';

var f: Fichier;
    position,longueur_reste: LongInt;
    i,longueur: word;
    nbr_lettres: byte;
    Tampon: ^tranche;

begin
 WriteLn('Analyse du fichier '+nom_fichier+' en cours...');
 nbr_fichiers_VOC:=0;
 f.Ouvre(lecture,nom_fichier);
 if f_erreur=f_ok then begin
  taille_fichier:=f.Taille;
  position:=0;
  longueur_reste:=taille_fichier;
  repeat
   if longueur_reste>long_tampon then longueur:=long_tampon
                                 else longueur:=longueur_reste;
   GetMem(Tampon,longueur);
   f.LitPos(position,Tampon^,longueur);
   dec(longueur_reste,longueur);
   nbr_lettres:=0;
   for i:=1 to longueur do
    if Chr(Tampon^[i])=identVOC[nbr_lettres+1] then begin
     inc(nbr_lettres);
     if nbr_lettres=19 then begin
      nbr_lettres:=0;
      inc(nbr_fichiers_VOC);
      Table_offset[nbr_fichiers_VOC]:=position+i-18;
      Write('');
     end;
    end
    else nbr_lettres:=0;
   FreeMem(Tampon,longueur);
   inc(position,longueur-nbr_lettres);
  until longueur_reste=0;
  f.Ferme;
 end
 else WriteLn('Impossible de lire le fichier '+nom_fichier);
end; {AnalyseFichier}

{---------------------------------------------------------}

procedure CreeFichierVOC(numero: word);

var Tampon: array[1..128] of ^tranche;
    nom_fichier_VOC: String80;
    i,nbr_tampons,long_reste: word;
    f: Fichier;
    longueur: LongInt;
    p: pointer;

begin
 Str(numero,nom_fichier_VOC);
 nom_fichier_VOC:=nom_fichier_VOC+'.VOC';
 f.Ouvre(lecture,nom_fichier);
 if f_erreur=f_ok then with f do begin
  Mark(p); {sauvegarde le tas}
  longueur:=Table_longueur[numero];
  nbr_tampons:=1+((longueur-1) div long_tampon);
  PlacePointeur(Table_offset[numero]-1);
  for i:=1 to nbr_tampons-1 do
   begin New(Tampon[i]); Lit(Tampon[i]^,long_tampon) end;
  long_reste:=1+((longueur-1) mod long_tampon);
  New(Tampon[nbr_tampons]);
  Lit(Tampon[nbr_tampons]^,long_reste);
  Ferme;
  Cree(not(teste_existe),nom_fichier_VOC);
  if f_erreur=f_ok then begin
   for i:=1 to nbr_tampons-1 do
    Ecrit(Tampon[i]^,long_tampon);
   Ecrit(Tampon[nbr_tampons]^,long_reste);
   Ferme;
  end
  else WriteLn('Impossible de crer le fichier '+nom_fichier_VOC);
  Release(p); {restaure le tas}
 end
 else WriteLn('Impossible de lire le fichier '+nom_fichier);
end; {CreeFichierVOC}

{---------------------------------------------------------}

procedure ExtraitFichiersVOC;
var i: word;
begin
 WriteLn;
 WriteLn(nbr_fichiers_VOC,' fichier(s) VOC trouv(s) dans '+nom_fichier);
 WriteLn('Extraction des fichiers VOC en cours...');
 Table_longueur[nbr_fichiers_VOC]:=taille_fichier+1-Table_offset[nbr_fichiers_VOC];
 for i:=1 to nbr_fichiers_VOC-1 do
  Table_longueur[i]:=Table_offset[i+1]-Table_offset[i];
 for i:=1 to nbr_fichiers_VOC do CreeFichierVOC(i);
 WriteLn; WriteLn('OK!');
end; {ExtraitFichiersVOC}

{=========================================================}

BEGIN
 WriteLn('VOCRip v1.1 - (c) 1998 Fabrice Couteau');
 if ParamCount=1 then begin
  nom_fichier:=ParamStr(1);
  AnalyseFichier;
  if nbr_fichiers_VOC>0 then ExtraitFichiersVOC
   else WriteLn('Aucun fichier VOC trouv dans '+nom_fichier+' !');
 end
 else WriteLn('syntaxe: VOCRIP nom_fichier');
END.
