PROGRAM XF; {extracteur/compacteur de parties de fichiers}
{$A+,G+,Q-,R-,S-}

USES Fichiers,LZ;

TYPE T_buffer=array[1..60*1024] of char;

CONST CRLF: array[1..2] of char=#13#10;

      compacte: boolean=FALSE;
      offset: longint=0;
      nombre: word=sizeof(T_buffer);

VAR f: Fichier;
    param: string[15];
    p,i: byte;
    lettre: char;
    erreur: word;
    taille_fichier: longint;
    buffer: ^T_buffer;


procedure AfficheSyntaxe;
begin
 WriteLn(CRLF,'syntaxe: XF nom_fichier O:offset N:nombre [LZ]',CRLF,
              'Extrait "nombre" octets  partir de "offset" par rapport au dbut du fichier.',CRLF,
              'Si le paramtre LZ est prsent, les donnes extraites sont compactes',CRLF,
              'avec l''algorithme de Lempel-Ziv.',CRLF);
 halt;
end; {AfficheSyntaxe}



BEGIN
 WriteLn(CRLF,'XF v1.1 - (c) 1998 Fabrice Couteau',CRLF,
         'Extracteur/Compacteur de parties de fichiers (60ko max)');

 p:=ParamCount;
 if not(p in [3,4]) then AfficheSyntaxe;

 for i:=2 to p do begin
  param:=ParamStr(i); lettre:=UpCase(param[1]); Delete(param,1,1);
  case lettre of
   'O': begin
         Delete(param,1,1); Val(param,offset,erreur);
         if erreur<>0 then AfficheSyntaxe;
        end;
   'N': begin
         Delete(param,1,1); Val(param,nombre,erreur);
         if erreur<>0 then AfficheSyntaxe;
        end;
   'L': if UpCase(param[1])='Z' then compacte:=TRUE else AfficheSyntaxe;
  end;
 end;

 with f do begin
  Ouvre(lecture,ParamStr(1));
  if f_erreur<>f_ok then begin WriteLn('Fichier introuvable'); halt(1) end;

  taille_fichier:=Taille;
  if offset>=taille_fichier then begin WriteLn('Offset hors du fichier'); halt(2) end;

  if offset+nombre>=taille_fichier then nombre:=taille_fichier-offset;
  PlacePointeur(offset);
  GetMem(buffer,nombre);
  Lit(buffer^,nombre);
  Ferme;

  Cree(not(teste_existe),'XF.DAT');
  if f_erreur<>0 then
   begin WriteLn('Impossible de crer le fichier extrait'); halt(3) end;

  Ecrit(buffer^,nombre);
  FreeMem(buffer,nombre);
  Ferme;
 end;

 if compacte then begin
  CompLZf('XF.DAT','XF.LZ',erreur);
  if erreur<>0 then
   begin WriteLn('Impossible de crer le fichier compact'); halt(4) end;
 end;

 WriteLn('ok!',CRLF);
END.
