{$A+,G+,Q-,R-,S-}

USES Crt,Graph256,BMP256,Souris,SourisG,Util,Evirtuel;

TYPE VB=array[0..63,0..63] of byte;

VAR CouleurReelle: array[0..63] of ^VB;


procedure Bip(frequence: word);
begin
 Sound(frequence); Delay(10); NoSound;
end; {Bip}


procedure AfficheZoom(image: BMP; zoom: byte; px,py: word);
{affiche l'image zoome  partir du coin suprieur gauche (px,py)}

var x,y: word;
    zy: byte;
    pi,pe,a_pi,a_pe: ^byte;

begin
 with image do begin
  pi:=@image^[1+(px+ResX*py)];
  pe:=Ptr($A000,0);

  for y:=0 to (MaxEntier(ResY,200)-1) div zoom do begin
   for zy:=1 to zoom do begin
    a_pi:=pi; a_pe:=pe;

    for x:=0 to (MaxEntier(ResX,320)-1) div zoom do begin
     asm
      les si,pi
      mov al,es:[si]
      les di,pe

      xor ch,ch
      mov cl,zoom
      rep stosb
     end;
     inc(pe,zoom);
     inc(pi);
    end;

    pi:=a_pi; pe:=a_pe; inc(pe,320);
   end;
   inc(pi,ResX);
  end;
 end;
end; {AfficheZoom}


procedure CalculeCouleurs;
{calcule pour chaque combinaison de composantes R,V,B (0..63) la couleur
 correspondante la plus proche dans la palette relle}

var p: Palette256;
    R,V,B: byte;
    couleur,meilleure_couleur,ecart,ecart_min: byte;
    n_ecart: array[0..3*64-1] of word;
    max_ecart: word;
    som_ecart: longint;

begin
 Writeln('Calcul des couleurs... Patientez SVP (environ 2 minutes)...');
 for ecart:=0 to 3*64-1 do n_ecart[ecart]:=0;
 max_ecart:=0;

 p.Charge(0,256);

 for R:=0 to 63 do
  for V:=0 to 63 do
   for B:=0 to 63 do begin
    meilleure_couleur:=0;
    ecart_min:=3*64;

    for couleur:=0 to 255 do begin
     ecart:=abs(R-p.palette[couleur].R)+
            abs(V-p.palette[couleur].V)+
            abs(B-p.palette[couleur].B);
     if ecart<ecart_min then begin
      ecart_min:=ecart;
      meilleure_couleur:=couleur;
      if ecart_min<1 then break;
     end;
    end;

    CouleurReelle[R]^[V,B]:=meilleure_couleur;

    inc(n_ecart[ecart]);
    if n_ecart[ecart]>max_ecart then max_ecart:=n_ecart[ecart];

    if (ecart<3*8) and ((Timer and $03)=0) then
     writeln('R=',R:2,' V=',V:2,' B=',B:2,': couleur=',
             meilleure_couleur:3,' (cart=',ecart:3,': ',n_ecart[ecart]:4,')');
   end;

 Bip(440*4); Bip(440*8);

 som_ecart:=0;
 for ecart:=0 to 3*64-1 do inc(som_ecart,n_ecart[ecart]);

 ClrScr;
 for ecart:=0 to 3*64-1 do begin
  Write(#13#10,ecart:3,': ',n_ecart[ecart]:4,' (',100*LONGINT(n_ecart[ecart])/som_ecart:5:2,'%) ',
        '*':(60*LONGINT(n_ecart[ecart])) div max_ecart);
  if (ecart>0) and ((ecart mod 49)=0) then ReadKey;
 end;
 ReadKey;
end; {CalculeCouleurs}


procedure AntiAliasing(zoom: byte);
{ fonctionnement du filtre avec zoom=3:

   0 1 2 3 4 5 6 7 8
  
 0               
 1  J    K    L      Point central: E (xc,yc)
 2               
      Couleurs d'origine: J,K,L  M,E,N  O,P,Q
 3     A B C     
 4  M  D E F  N      Couleurs calcules: A=(2E+J)/3  B=(2E+K)/3  C=(2E+L)/3
 5     G H I                             D=(2E+M)/3              F=(2E+N)/3
                          G=(2E+O)/3  H=(2E+P)/3  I=(2E+Q)/3
 6               
 7  O    P    Q  
 8               
      }

var p: Palette256;
    x,y,xc,yc: word;
    E,z: byte;
    ps,pd,a_ps,a_pd: ^byte;

procedure CalculeCouleur;
{pd^=((zoom-1)*E+ps^)/zoom}
var couleur: RVB;
begin
 couleur.R:=((zoom-1)*WORD(p.palette[E].R)+p.palette[ps^].R) div zoom;
 couleur.V:=((zoom-1)*WORD(p.palette[E].V)+p.palette[ps^].V) div zoom;
 couleur.B:=((zoom-1)*WORD(p.palette[E].B)+p.palette[ps^].B) div zoom;

 pd^:=CouleurReelle[couleur.R]^[couleur.V,couleur.B];
end;

begin
 p.Charge(0,256);

 for y:=0+1 to (199 div zoom)-1 do
  for x:=0+1 to (319 div zoom)-1 do begin
   xc:=zoom*x+1; yc:=zoom*y+1;
   E:=Mem[$A000:xc+320*yc];

   pd:=Ptr($A000,(xc-1)+320*(yc-1));
   ps:=Ptr($A000,(xc-zoom)+320*(yc-zoom));

   for z:=1 to zoom do begin
    a_pd:=pd; a_ps:=ps;
                           CalculeCouleur;
    inc(pd); inc(ps,zoom); CalculeCouleur;
    inc(pd); inc(ps,zoom); CalculeCouleur;

    pd:=a_pd; ps:=a_ps;
    inc(pd,320); inc(ps,320*zoom);
   end;
  end;
end; {AntiAliasing}


procedure Filtre;
{ 
  ABC   Point central: E (xc,yc)
  
  DEF   Couleurs d'origine: A,B,C  D,F  G,H,I
  
  GHI   Couleurs calcules: E=(A+B+C+D+F+G+H+I)/8
     }

var p: Palette256;
    x,y: word;
    ps,pd: ^byte;
    sR,sV,sB: word;
    couleur: RVB;

begin
 p.Charge(0,256);

 ps:=Ptr($A000,0);            {A}
 pd:=Ptr(Segment_ev,1+320*1); {E}

 Copie_ev;

 for y:=0+1 to 199-1 do begin
  for x:=0+1 to 319-1 do begin
   sR:=0; sV:=0; sB:=0;

            couleur:=p.palette[ps^];
   inc(sR,couleur.R); {sR += A.R}
   inc(sV,couleur.V); {sV += A.V}
   inc(sB,couleur.B); {sB += A.B}

   inc(ps); couleur:=p.palette[ps^];
   inc(sR,couleur.R); {sR += B.R}
   inc(sV,couleur.V); {sV += B.V}
   inc(sB,couleur.B); {sB += B.B}

   inc(ps); couleur:=p.palette[ps^];
   inc(sR,couleur.R); {sR += C.R}
   inc(sV,couleur.V); {sV += C.V}
   inc(sB,couleur.B); {sB += C.B}

   inc(ps,320-2); couleur:=p.palette[ps^];
   inc(sR,couleur.R); {sR += D.R}
   inc(sV,couleur.V); {sV += D.V}
   inc(sB,couleur.B); {sB += D.B}

   inc(ps);

   inc(ps); couleur:=p.palette[ps^];
   inc(sR,couleur.R); {sR += F.R}
   inc(sV,couleur.V); {sV += F.V}
   inc(sB,couleur.B); {sB += F.B}

   inc(ps,320-2); couleur:=p.palette[ps^];
   inc(sR,couleur.R); {sR += G.R}
   inc(sV,couleur.V); {sV += G.V}
   inc(sB,couleur.B); {sB += G.B}

   inc(ps); couleur:=p.palette[ps^];
   inc(sR,couleur.R); {sR += H.R}
   inc(sV,couleur.V); {sV += H.V}
   inc(sB,couleur.B); {sB += H.B}

   inc(ps); couleur:=p.palette[ps^];
   inc(sR,couleur.R); {sR += I.R}
   inc(sV,couleur.V); {sV += I.V}
   inc(sB,couleur.B); {sB += I.B}

   pd^:=CouleurReelle[sR div 8]^[sV div 8,sB div 8];

   dec(ps,2*320+1); {passe au point B (qui est le A du x suivant)}
   inc(pd);
  end;
  inc(ps,2);
  inc(pd,2);
 end;

 Affiche_ev;
end; {Filtre}



CONST zoom: byte=3;

VAR nom_fichier: string[80];
    image: BMP;
    erreur: word;
    R: byte;

BEGIN
 TextMode(CO80+Font8x8);

 if ParamCount=0 then nom_fichier:='C:\PROJETS\TESTS\SQ4_.BMP'
                 else nom_fichier:=ParamStr(1);

 image.Charge(nom_fichier,erreur);
 if erreur<>0 then begin writeln('Erreur BMP: ',erreur); halt end;

 for R:=0 to 63 do New(CouleurReelle[R]);
 image.FixePalette;
 CalculeCouleurs;

 Init320x200;
 image.FixePalette;
 Cree_ev;

 repeat
  ZoneSouris(0,0,image.ResX-(320 div zoom)-1,image.ResY-(200 div zoom)-1);

  AttendVBL;
  AfficheZoom(image,zoom,Xsouris,Ysouris);
  repeat until SourisBouge or (BoutonSouris<>aucun) or KeyPressed;

  if BoutonSouris=gauche then begin
   Bip(440*2);
   AntiAliasing(zoom);
   Filtre;
   Bip(440*4);
   repeat until SourisBouge or (BoutonSouris=aucun);
  end;

  if KeyPressed then
   case ReadKey of
    '-': if zoom>2 then dec(zoom);
    '+': if zoom<5 then inc(zoom);
   end;
 until BoutonSouris=droite;

 Supprime_ev;
 for R:=0 to 63 do Dispose(CouleurReelle[R]);
 image.Supprime;

 TextMode(CO80);
END.
