PROGRAM ListePrj; {analyse les dpendances de projets Pascal/C/C++/Assembleur}
{$M 4096,0,16384}

{$A+,G+,Q-,R-,S-}

USES Dos,Util;

CONST {langages des sources}
	  L_inconnu=0; {inconnu}
	  L_pascal =1; {Turbo-Pascal}
	  L_c	   =2; {C}
	  L_cpp	   =3; {C++}
	  L_asm	   =4; {Assembleur}

	  {natures de fichier}
	  N_inconnue=0; {inconnue}
	  N_std		=1; {units Pascal Crt,Dos,... ou headers C/C++ stdlib.h,conio.h,...}
	  N_prog	=2; {programme principal}
	  N_lib		=3; {bibliothque de routines (=unit pour Pascal)}
	  N_inc		=4; {fichier inclus}

	  {erreurs}
	  ok=0;

	  {tats}
	  E_normal	=$00; {R.A.S.}
	  E_deja_aff=$01; {fichier dj affich}

	  {extensions}
	  extension: array[L_inconnu..L_asm] of string[3]=('','PAS','C','CPP','ASM');

	  {nombre maximal de fichiers (toutes natures confondues)}
	  F_max=512;

	  {fichier de configuration}
	  nom_CFG='LISTEPRJ.CFG';

	  {nombre d'identificateurs}
	  N_id=9;
	  nbr_id: byte=0;

	  {nombre de rpertoires maximum pour un identificateur}
	  N_rep=5;

	  {identificateurs et rpertoires correspondants}
	  CFG: array[1..N_id] of
			record
			 lang,nat: byte;
			 ident	: String8;
			 nbr_rep: byte;
			 repert : array[1..N_rep] of String80;
			end
		   =((lang:L_pascal; nat:N_prog ; ident:'PROG_PAS'; nbr_rep:0),
			 (lang:L_pascal; nat:N_lib	; ident:'UNIT_PAS'; nbr_rep:0),
			 (lang:L_pascal; nat:N_inc	; ident:'INC_PAS' ; nbr_rep:0),
			 (lang:L_c	   ; nat:N_prog ; ident:'PROG_C'  ; nbr_rep:0),
			 (lang:L_c	   ; nat:N_inc	; ident:'INC_C'   ; nbr_rep:0),
			 (lang:L_cpp   ; nat:N_prog ; ident:'PROG_CPP'; nbr_rep:0),
			 (lang:L_cpp   ; nat:N_inc	; ident:'INC_CPP' ; nbr_rep:0),
			 (lang:L_asm   ; nat:N_prog ; ident:'PROG_ASM'; nbr_rep:0),
			 (lang:L_asm   ; nat:N_inc	; ident:'INC_ASM' ; nbr_rep:0));

	  Space=32;
	  Tab=9;


TYPE String128=string[128];

	 T_Fichier=record
				nom: String12;
				langage,nature: byte;
				num_repert: byte;
				date_heure: longint;

				taille: longint;
				lignes: word;

				erreur: word;
				etat  : byte;
			   end;


	 T_ListeFichiers=record
					  fichier: array[1..F_max] of T_Fichier;
					  nombre,courant: word;
					 end;


VAR liste: T_ListeFichiers;

{==========================================================}

function SansEspace(chaine: string): string; assembler;
{renvoie la chane prive de ses ventuels ' ' ou tabulations}
asm
 push DS
 cld
 lds SI,chaine
 les DI,@Result
 mov BX,DI
 lodsb
 stosb
 mov CL,AL

@copie:
 or	 CL,CL
 jz	 @fin
 lodsb
 cmp AL,' '
 jne @pas_espace
 dec BYTE(ES:[BX])
 jmp @suite
 @pas_espace:
 cmp AL,Tab
 jne @pas_tab
 dec BYTE(ES:[BX])
 jmp @suite
 @pas_tab:
 stosb
 @suite:
 dec CL
 jmp @copie

@fin:
 pop DS
end; {SansEspace}

{----------------------------------------------------------}

function ChercheRepertoire(nom_fichier: String12; langage,nature: byte; var num_repert: byte): String80;
var i,r: byte;
	f: Text;
begin
 for i:=1 to N_id do with CFG[i] do
  if (lang=langage) and (nat=nature) then
   for r:=1 to nbr_rep do begin
	Assign(f,repert[r]+nom_fichier);
	{$I-}
	Reset(f);
	{$I+}
	if IOResult=ok then begin
	 num_repert:=r;
	 ChercheRepertoire:=repert[r];
	 Close(f);
	 exit;
	end;
   end;

 num_repert:=1;
 ChercheRepertoire:='';
end; {ChercheRepertoire}

{----------------------------------------------------------}

function Repertoire(numero_fichier: byte): String80;
var i: byte;
begin
 with liste.fichier[numero_fichier] do
  for i:=1 to N_id do with CFG[i] do
   if (lang=langage) and (nat=nature) then
	begin Repertoire:=repert[num_repert]; exit; end;

 Repertoire:='';
end; {Repertoire}

{----------------------------------------------------------}

procedure AjouteFichierListe(nom_fichier: String12; lang,nat: byte);

const nbr_unites=16;
	  unitesPascal: array[1..nbr_unites] of string[8]=(
	   'CRT','DOS','GRAPH','GRAPH3','OVERLAY','PRINTER','SYSTEM','TURBO3','STRINGS',
	   'WINAPI','WINCRT','WINDOS','WINPRN','WINPROCS','WINTYPES','WIN31');

	  nbr_headersC=70;
	  headersC: array[1..nbr_headersC] of string[8]=(
	   'ALLOC','ASSERT','BCD','BIOS','BIOS98','COMPLEX','CONIO','CONSTREA',
	   'CTYPE','DIR','DIRECT','DIRECTRY','DIRENT','DOS','DOSFUNC','ENV','ERRNO',
	   'EXCEPT','EXCEPTIO','EXSTRING','FCNTL','FILEDATA','FLOAT','FSTREAM',
	   'GENERIC','GRAPH','GRAPH98','GRAPHICS','I86','IO','IOMANIP','IOSTREAM',
	   'JCTYPE','JSTRING','JTIME','LIMITS','LOCALE','MALLOC','MATH','MBCTYPE',
	   'MBSTRING','MEM','MEMORY','NEW','PROCESS','SEARCH','SETJMP','SHARE',
	   'SIGNAL','STDARG','STDDEF','STDEXCEP','STDIO','STDIOBUF','STDIOSTR',
	   'STDLIB','STREAMBU','STRING','STRSTREA','TCHAR','TIME','TYPEINFO','UNISTD',
	   'UTIME','VALUES','VARARGS','_COMDEF','_DEFS','_NFILE','_NULL');

var i: byte;

begin
 with liste do begin
  if nom_fichier='' then exit;

  {teste si le fichier est standard}
  case lang of
   L_pascal: for i:=1 to nbr_unites do
			  if nom_fichier=unitesPascal[i] then begin nat:=N_std; break; end;

   L_c,
   L_cpp: for i:=1 to nbr_headersC do
  		   if nom_fichier=headersC[i]+'.H' then begin nat:=N_std; break; end;
  end;

  {vrifie si le fichier n'existe pas dj}
  for i:=1 to nombre do with fichier[i] do
   if (nom=nom_fichier) and (langage=lang) and (nature=nat) then exit;

  {ajoute le nouveau fichier}
  inc(nombre);
  with fichier[nombre] do begin
   nom	  :=nom_fichier;
   langage:=lang;
   nature :=nat;
  end;
 end;
end; {AjouteFichierListe}

{----------------------------------------------------------}

function ligne_contient_USES(ligne: String128): boolean;
{vrifie que la ligne contient la clause 'USES' correspondant  une dclaration correcte}
var p,i: byte;
begin
 p:=Pos('USES',ligne);
 if p=0 then begin ligne_contient_USES:=FALSE; exit; end;

 {avant USES, il ne peut y avoir que des espaces/tabulations, ou rien}
 for i:=1 to p-1 do
  if not(ligne[i] in [' ',CHAR(Tab)]) then begin ligne_contient_USES:=FALSE; exit; end;

 {aprs USES, il ne peut y avoir qu'un espace/tabulation, ou rien}
 if (Length(ligne)>4) and
	not(ligne[p+4] in [' ',CHAR(Tab)]) then begin ligne_contient_USES:=FALSE; exit; end;

 ligne_contient_USES:=TRUE;
end; {ligne_contient_USES}

{----------------------------------------------------------}

procedure AjouteUnitesPAS(ligne: String128);
var p: byte;
	nom_fichier: String80;
begin
 p:=Pos('USES',ligne);
 if p<>0 then Delete(ligne,1,p+5-1);

 ligne:=SansEspace(ligne);

 {limine les commentaires}
 p:=Pos('{' ,ligne); if p<>0 then ligne:=CopyL(ligne,p-1);
 p:=Pos('}' ,ligne); if p<>0 then Delete(ligne,1,p);
 p:=Pos('(*',ligne); if p<>0 then ligne:=CopyL(ligne,p-1);
 p:=Pos('*)',ligne); if p<>0 then Delete(ligne,1,p+1);

 if ligne[Length(ligne)] in [',',';'] then dec(ligne[0]);

 repeat
  p:=Pos(',',ligne);
  if p<>0 then begin
   nom_fichier:=CopyL(ligne,p-1);
   Delete(ligne,1,p);
  end
  else nom_fichier:=ligne;

  AjouteFichierListe(nom_fichier,L_pascal,N_lib);
 until p=0;
end; {AjouteUnitesPAS}

{----------------------------------------------------------}

procedure AjouteIncluPAS(ligne: String128);
var p: byte;
begin
 p:=Pos('$I ',ligne);
 Delete(ligne,1,p+3-1);

 ligne:=SansEspace(ligne);

 {isole le nom du fichier inclu}
 p:=Pos('{' ,ligne); if p<>0 then Delete(ligne,p,1);
 p:=Pos('(*',ligne); if p<>0 then Delete(ligne,p,2);
 p:=Pos('}' ,ligne); if p<>0 then ligne:=CopyL(ligne,p-1);
 p:=Pos('*)',ligne); if p<>0 then ligne:=CopyL(ligne,p-1);

 AjouteFichierListe(NomFichierSeul(ligne),L_pascal,N_inc);
end; {AjouteIncluPAS}

{----------------------------------------------------------}

procedure AjouteProgASMPAS(ligne: String128);
var p: byte;
begin
 p:=Pos('$L ',ligne);
 Delete(ligne,1,p+3-1);

 ligne:=SansEspace(ligne);

 {isole le nom du module assembleur externe}
 p:=Pos('{' ,ligne); if p<>0 then Delete(ligne,p,1);
 p:=Pos('(*',ligne); if p<>0 then Delete(ligne,p,2);
 p:=Pos('}' ,ligne); if p<>0 then ligne:=CopyL(ligne,p-1);
 p:=Pos('*)',ligne); if p<>0 then ligne:=CopyL(ligne,p-1);

 AjouteFichierListe(NomFichierSeul(ligne),L_asm,N_prog);
end; {AjouteProgASMPAS}

{----------------------------------------------------------}

procedure AjouteIncluC(ligne: String128);
var p: byte;
begin
 p:=Pos('#INCLUDE ',ligne);
 Delete(ligne,1,p+9-1);

 ligne:=SansEspace(ligne);

 {limine les commentaires}
 p:=Pos('//',ligne); if p<>0 then ligne:=CopyL(ligne,p-1);
 p:=Pos('/*',ligne); if p<>0 then ligne:=CopyL(ligne,p-1);

 {limine les symboles "" et <>}
 repeat
   p:=Pos('"',ligne);
   if p<>0 then Delete(ligne,p,1);
 until p=0;
 repeat
   p:=Pos('<',ligne);
   if p<>0 then Delete(ligne,p,1);
 until p=0;
 repeat
   p:=Pos('>',ligne);
   if p<>0 then Delete(ligne,p,1);
 until p=0;

 AjouteFichierListe(NomFichierSeul(ligne),L_c,N_inc);
end; {AjouteIncluC}

{----------------------------------------------------------}

procedure AjouteIncluASM(ligne: String128);
var p: byte;
begin
 p:=Pos('INCLUDE ',ligne);
 Delete(ligne,1,p+8-1);

 ligne:=SansEspace(ligne);

 {limine les commentaires}
 p:=Pos(';',ligne); if p<>0 then ligne:=CopyL(ligne,p-1);

 AjouteFichierListe(NomFichierSeul(ligne),L_asm,N_inc);
end; {AjouteIncluASM}

{----------------------------------------------------------}

procedure QuickSort(debut,fin: word);
var i,j: word;
	aux: String12;
begin
 with liste do begin
  i:=debut; j:=fin; aux:=fichier[(debut+fin) shr 1].nom;
  repeat
   while fichier[i].nom<aux do inc(i);
   while aux<fichier[j].nom do dec(j);
   if i<=j then begin
	SwapVar(fichier[i],fichier[j],sizeof(T_fichier));
	inc(i); if j>0 then dec(j);
   end;
  until i>j;
 end;
 if debut<j then QuickSort(debut,j);
 if i<fin	then QuickSort(i,fin);
end; {QuickSort}

{==========================================================}

CONST fin_instruction : boolean=FALSE;
	  analyse_en_cours: boolean=FALSE;

	  nombre_type: word=0;
	  taille_type: longint=0;
	  lignes_type: longint=0;

	  nombre_total: word=0;
	  taille_total: longint=0;
	  lignes_total: longint=0;


VAR f: Text;

	ligne,nom_fichier: String128;
	temp: String128 absolute nom_fichier;
	repert: String80;

	i: word;
	p,r,l,n: byte;
	dt: DateTime;

	type_fichier: string[30];

BEGIN
 {lit le fichier de configuration}
 Assign(f,nom_CFG);
 {$I-}
 Reset(f);
 {$I+}
 if IOResult<>0 then begin
  Writeln('Fichier de configuration ',nom_CFG,' introuvable !');
  Writeln('Cration d''un fichier de configuration vierge...');

  {$I-}
  Rewrite(f);
  {$I+}
  if IOResult<>0 then begin
   Writeln('Impossible de crer le fichier ',nom_CFG);
   halt(1);
  end;

  for i:=1 to N_id do Writeln(f,XString(CFG[i].ident,' ',8),' = C:\');

  Close(f);

  Writeln('Compltez les chemins d''accs aux fichiers puis relancez LISTEPRJ.');
  halt(1);
 end;

 {analyse le fichier de configuration}
 while not(Eof(f)) do begin
  Readln(f,ligne);

  ligne:=Maj(SansEspace(ligne));

  {cherche les rpertoires sources}
  for i:=1 to N_id do with CFG[i] do
   if Pos(ident+'=',ligne)<>0 then begin
	inc(nbr_id);
	Delete(ligne,1,Pos('=',ligne));

	repeat
	 inc(nbr_rep);
	 p:=Pos(',',ligne);
	 if p<>0 then begin
	  temp:=CopyL(ligne,p-1);
	  Delete(ligne,1,p);
	 end
	 else temp:=ligne;
	 if temp[Length(temp)]<>'\' then temp:=temp+'\';
	 repert[nbr_rep]:=temp;
	until (nbr_rep=N_rep) or (p=0);
	break;
   end;
 end;

 Close(f);

 if nbr_id<>N_id then begin
  Writeln('Fichier de configuration ',nom_CFG,' invalide ou incomplet');
  halt(1);
 end;

 {teste la prsence d'un paramtre}
 if ParamCount<>1 then begin
  Writeln(#13#10,'LISTEPRJ v1.2 - (c) 1998-2001 Fabrice Couteau',#13#10,
		  'Analyse les dpendances de projets Turbo-Pascal, C/C++, Assembleur',#13#10,
		  'syntaxe: LISTEPRJ <nom_fichier[.ext]>   (sans chemin)');
  halt(1);
 end;

 {ne conserve que le nom de fichier du paramtre}
 nom_fichier:=NomFichierSeul(ParamStr(1));
 p:=Pos('.',nom_fichier);
 if p<>0 then nom_fichier:=CopyL(nom_fichier,p-1);

 with liste do begin
  {initialise la liste de fichiers avec le fichier pass en paramtre}
  nombre :=1;
  courant:=1;

  {vrifie l'existence du fichier et dtermine son langage et sa nature}
  with fichier[courant] do begin
   nom	  :=nom_fichier;
   langage:=L_inconnu;
   nature :=N_inconnue;
   etat	  :=E_normal;

   for i:=1 to N_id do with CFG[i] do begin
	for r:=1 to nbr_rep do begin
	 Assign(f,repert[r]+nom+'.'+extension[lang]);
	 {$I-}
	 Reset(f);
	 {$I+}
	 erreur:=IOResult;
	 if erreur=ok then begin langage:=lang; nature:=nat; break; end;
	end;
	if erreur=ok then break;
   end;

   if erreur=ok then Close(f)
   else begin
	Writeln('Fichier introuvable (erreur ',erreur,')');
	halt(1);
   end;
  end;

  {boucle principale de traitement de la liste de fichiers}
  repeat
   with fichier[courant] do begin
	nom_fichier:=nom;
	if Pos('.',nom_fichier)=0 then nom_fichier:=nom_fichier+'.'+extension[langage];
	repert:=ChercheRepertoire(nom_fichier,langage,nature,num_repert);

	Assign(f,repert+nom_fichier);
	{$I-}
	Reset(f);
	{$I+}
	erreur:=IOResult;

	if erreur=ok then begin
	 {dtermine la date & heure}
	 GetFTime(f,date_heure);

	 taille:=0;
	 lignes:=0;

	 while not(Eof(f)) do begin
	  Readln(f,ligne);
	  ligne:=Maj(ligne);
	  inc(taille,Length(ligne)+2); {compte une ligne et le retour chariot}
	  inc(lignes);

	  case langage of
	   L_pascal: begin
				  fin_instruction:=Pos(';',ligne)<>0;
				  if Pos('''',ligne)=0 then begin
				   if ligne_contient_USES(ligne) or analyse_en_cours then begin
					AjouteUnitesPAS(ligne);
					analyse_en_cours:=not(fin_instruction);
				   end
				   else
				   if Pos('$I ',ligne)<>0 then AjouteIncluPAS(ligne)
				   else
				   if Pos('$L ',ligne)<>0 then AjouteProgASMPAS(ligne);
				  end;
				  if fin_instruction then analyse_en_cours:=FALSE;
				 end;

	   L_c,
	   L_cpp   : begin
				  if Pos('#INCLUDE ',ligne)<>0 then AjouteIncluC(ligne);
				 end;

	   L_asm   : begin
				  if Pos('INCLUDE ',ligne)<>0 then AjouteIncluASM(ligne);
				 end;
	  end;
	 end;

	 Close(f);
	end;
   end;

   inc(courant);
  until courant>nombre;

  QuickSort(1,nombre);

  {affichage de la liste de fichiers par langage/nature}
  for l:=L_pascal to L_asm do
   for n:=N_std to N_inc do begin
	nombre_type:=0;
	taille_type:=0;
	lignes_type:=0;

	for i:=1 to nombre do with fichier[i] do
	 if (langage=l) and (nature=n) and ((etat and E_deja_aff)=0) then begin
	  inc(nombre_type);
	  inc(taille_type,taille);
	  inc(lignes_type,lignes);

	  etat:=etat or E_deja_aff;

	  nom_fichier:=nom;
	  if Pos('.',nom_fichier)=0 then nom_fichier:=nom_fichier+'.'+extension[langage];

	  Write(XString(LimiteNomFichier(Maj(Repertoire(i)+nom_fichier),40),'',40),' ');

	  if erreur=ok then begin
	   UnPackTime(date_heure,dt);
	   with dt do
		Write(taille:7,' ',lignes:6,' lignes  ',
			  EntierTexte2(Day,2),'/',EntierTexte2(Month,2+et_zeros),'/',CopyR(EntierTexte2(Year,4),2),' ',
			  EntierTexte2(Hour,2),':',EntierTexte2(Min,2+et_zeros));
	  end
	  else if nature<>N_std then Write('fichier introuvable');
	  Writeln;
	 end;

	if nombre_type<>0 then begin
	 inc(nombre_total,nombre_type);
	 inc(taille_total,taille_type);
	 inc(lignes_total,lignes_type);

	 case l of
	  L_pascal: case n of
				 N_std : type_fichier:='units standard Pascal';
				 N_prog: type_fichier:='programmes Pascal';
				 N_lib : type_fichier:='units Pascal';
				 N_inc : type_fichier:='fichiers inclus Pascal';
				end;

	  L_c	  : case n of
				 N_std : type_fichier:='headers standard C';
				 N_prog: type_fichier:='programmes C';
				 N_inc : type_fichier:='headers C';
				end;

	  L_cpp	  : case n of
				 N_std : type_fichier:='headers standard C++';
				 N_prog: type_fichier:='programmes C++';
				 N_inc : type_fichier:='headers C++';
				end;

	  L_asm	  : case n of
				 N_prog: type_fichier:='modules Assembleur';
				 N_inc : type_fichier:='fichiers inclus Assembleur';
				end;
	 end;

	 Write(RepeteCar('-',40-6-Length(type_fichier)-4),' TOTAL ',type_fichier,' -> ');
	 if n=N_std then Write(nombre_type:7) else Write(taille_type:7,' ',lignes_type:6,' lignes  (',nombre_type,' fichiers)');
	 Writeln;
	end;
   end;

  if nombre_total<>0 then
   Writeln(RepeteCar(' ',40-14),' TOTAL TOUT -> ',taille_total:7,' ',lignes_total:6,' lignes  (',nombre_total,' fichiers)');
 end;
END.
