{ͻ}
{                     --== ARCHIVES.PAS ==--                       }
{                                                                      }
{ Unit pour grer les fichiers archives (ARJ, LZH, RAR, ZIP)          }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 286           Dbut d'criture 06/04/96 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT Archives;

{$A+,G+,Q-,R-,S-}

INTERFACE

{$I Types}

TYPE  Char3=array[1..3] of CHAR;
      Char4=array[1..4] of CHAR;
      Char5=array[1..5] of CHAR;


CONST {types d'archives et identificateurs}
      ARJ=1; ARJ_ID=$EA60;
      LZH=2; LZH_ID: Char3='-lh';
      RAR=3; RAR_ID: Char4='Rar!';
      ZIP=4; ZIP_ID: Char4='PK'#3#4;

      {erreur dans l'entte de l'archive}
      err_format=1;

      {constantes pour format RAR}
      HT_MarkerBlk =$72;
      HT_ArchiveHdr=$73;
      HT_FileHdr   =$74;
      HT_CommentHdr=$75;
      HT_ExtraHdr  =$76;
      HT_UnknownHdr=$78; {valeur arbitraire}


TYPE {structure informations sur un fichier archive}
     T_InfoArch=record
                 Compacteur: BYTE;
                 TailleInit,
                 TailleComp: LONGINT;
                 Ratio     : BYTE;
                 Nombre    : WORD
                end;

     {enttes des fichiers archives}

     {-- ARJ --}
     ARJ_Header=record
                 HeadID,
                 HdrSize  : WORD;
                 HeadSize,
                 VerNum,
                 MinVerNum,
                 HostOS,
                 ArjFlag,
                 Method,
                 FType,
                 Reserved : BYTE;
                 FileTime,
                 PackSize,
                 OrigSize,
                 FileCRC  : LONGINT;
                 FilePosF,
                 FileAcc,
                 HostData : WORD;
                end;

     {-- LZH --}
     LZH_Header=record
                 HeadSize,
                 HeadChk : BYTE;
                 HeadID  : Char5;
                 PackSize,
                 OrigSize,
                 FileTime: LONGINT;
                 Attr    : WORD;
                end;

     {sous-structures pour RAR}
     T_MarkerBlk =record
                  end;
     T_ArchiveHdr=record
                   Reserved1: WORD;
                   Reserved2: LONGINT;
                  end;
     T_FileHdr   =record
                   PackSize,
                   OrigSize   : LONGINT;
                   HostOS     : BYTE;
                   FileCRC,
                   FileTime   : LONGINT;
                   RARversion,
                   Method     : BYTE;
                   FileNameLen: WORD;
                   FileAttr   : LONGINT;
                  end;
     T_CommentHdr=record
                   OrigSize  : WORD;
                   RARversion,
                   Method    : BYTE;
                   CommentCRC: WORD;
                  end;
     T_ExtraHdr  =record
                  end;
     T_UnknownHdr=record
                   BlockSize: LONGINT;
                  end;

     T_HeadData=record case BYTE of
                 HT_MarkerBlk : (MarkerBlk : T_MarkerBlk);
                 HT_ArchiveHdr: (ArchiveHdr: T_ArchiveHdr);
                 HT_FileHdr   : (FileHdr   : T_FileHdr);
                 HT_CommentHdr: (CommentHdr: T_CommentHdr);
                 HT_ExtraHdr  : (ExtraHdr  : T_ExtraHdr);
                 HT_UnknownHdr: (UnknownHdr: T_UnknownHdr);
                end;

     {-- RAR --}
     RAR_Header=record
                 HeadCRC  : WORD;
                 HeadType : BYTE;
                 HeadFlags,
                 HeadSize : WORD;
                 HeadData : T_HeadData;
                end;

     {-- ZIP --}
     ZIP_Header=record
                 HeadID     : Char4;
                 Version,
                 GPBFlag,
                 Compress,
                 Date,Time  : WORD;
                 CRC32,
                 PackSize,
                 OrigSize   : LONGINT;
                 FileNameLen,
                 ExtraField : WORD;
                end;

     {type regroupant tous les autres}
     T_Mix_Header=record case BYTE of
                   ARJ:(ARJ: ARJ_Header);
                   LZH:(LZH: LZH_Header);
                   RAR:(RAR: RAR_Header);
                   ZIP:(ZIP: ZIP_Header);
                  end;

CONST Sizeof_RAR_BeginBlk = sizeof(RAR_Header)-sizeof(T_HeadData); {HeadCRC...HeadSize}

{==========================================================}

function  TypeArchive(nom_fichier: String80): BYTE;
function  InfoArchive(nom_fichier: String80; var info: T_InfoArch): WORD;
function  DecompArchive(nom_archive,nom_fichier: String80): WORD;

{==========================================================}

IMPLEMENTATION

USES Dos,Fichiers,Util;

CONST nbr_types_arch=4;

      {extensions}
      ExtensionArch: array[1..nbr_types_arch] of Char3=('ARJ','LZH','RAR','ZIP');

{==========================================================}

function TypeArchive(nom_fichier: String80): BYTE;
{renvoie le type d'archive selon l'extension: 0, ARJ, LZH, RAR ou ZIP}
var i: BYTE;
begin
 for i:=1 to nbr_types_arch do
  if PosF('.'+ExtensionArch[i],nom_fichier)<>0 then begin TypeArchive:=i; exit end;
 TypeArchive:=0;
end; {TypeArchive}

{----------------------------------------------------------}

function InfoArchive(nom_fichier: String80; var info: T_InfoArch): WORD;
{renvoie des infos sur le fichier archive}

var f: Fichier;
    header: T_Mix_Header;
    first: BOOLEAN;
    taille_fichier,taille_cumulee: LONGINT;

begin
 FillCHAR(info,sizeof(T_InfoArch),0);

 with f,info do begin
  Ouvre(lecture,nom_fichier);
  InfoArchive:=f_erreur;
  if f_erreur<>f_ok then exit;

  taille_cumulee:=0;
  taille_fichier:=Taille;

  first:=TRUE;
  Compacteur:=TypeArchive(nom_fichier);

  case Compacteur of
   ARJ: with header.ARJ do
         repeat
          Lit(header,sizeof(ARJ_Header));
          if HeadID<>ARJ_ID then begin InfoArchive:=err_format; break end;
          if HdrSize=0 then break;

          if not(first) and (OrigSize<>0) then begin
           inc(Nombre);
           inc(TailleInit,OrigSize);
           inc(TailleComp,PackSize);
          end
          else PackSize:=0;

          DeplacePointeur((HdrSize-HeadSize-2)+4+4+PackSize);
          inc(taille_cumulee,(HdrSize-HeadSize-2)+4+4+PackSize);
          first:=FALSE;
         until taille_cumulee>=taille_fichier;

   LZH: with header.LZH do
         repeat
          Lit(header,sizeof(LZH_Header));
          if Copy(HeadID,1,sizeof(LZH_ID))<>LZH_ID then begin InfoArchive:=err_format; break end;
          if HeadSize=0 then break;

          if OrigSize<>0 then begin
           inc(Nombre);
           inc(TailleInit,OrigSize);
           inc(TailleComp,PackSize);
          end;

          DeplacePointeur((HeadSize-sizeof(LZH_Header))+2+PackSize);
          inc(taille_cumulee,(HeadSize-sizeof(LZH_Header))+2+PackSize);
         until taille_cumulee>=taille_fichier;

   RAR: with header.RAR do
         repeat
          Lit(header,Sizeof_RAR_BeginBlk);
          inc(taille_cumulee,Sizeof_RAR_BeginBlk);

          case HeadType of
           HT_MarkerBlk : if LongPtr(@header)^<>LONGINT(RAR_ID) then
                           begin InfoArchive:=err_format; break end;
           HT_ArchiveHdr,
           HT_CommentHdr,
           HT_ExtraHdr  : begin
                           DeplacePointeur(HeadSize-Sizeof_RAR_BeginBlk);
                           inc(taille_cumulee,HeadSize-Sizeof_RAR_BeginBlk);
                          end;
           HT_FileHdr   : with HeadData.FileHdr do begin
                           Lit(HeadData,sizeof(T_FileHdr));
                           if OrigSize<>0 then begin
                            inc(Nombre);
                            inc(TailleInit,OrigSize);
                            inc(TailleComp,PackSize);
                           end;
                           DeplacePointeur(HeadSize-Sizeof_RAR_BeginBlk-sizeof(T_FileHdr)+PackSize);
                           inc(taille_cumulee,HeadSize-Sizeof_RAR_BeginBlk+PackSize);
                          end;

           else with HeadData.UnknownHdr do begin
                 Lit(HeadData,sizeof(T_UnknownHdr));
                 DeplacePointeur(HeadSize-Sizeof_RAR_BeginBlk-sizeof(T_UnknownHdr)+BlockSize);
                 inc(taille_cumulee,HeadSize-Sizeof_RAR_BeginBlk+BlockSize);
                end;
          end;
         until taille_cumulee>=taille_fichier;

   ZIP: with header.ZIP do
         repeat
          Lit(header,sizeof(ZIP_Header));
          if HeadID<>ZIP_ID then begin if Nombre=0 then InfoArchive:=err_format; break end;

          if OrigSize<>0 then begin
           inc(Nombre);
           inc(TailleInit,OrigSize);
           inc(TailleComp,PackSize);
          end;

          DeplacePointeur(FileNameLen+PackSize+ExtraField);
          inc(taille_cumulee,FileNameLen+PackSize+ExtraField);
         until taille_cumulee>=taille_fichier;
  end;

  if TailleInit<>0 then Ratio:=(100*TailleComp) div TailleInit;
  Ferme;
 end;
end; {InfoArchive}

{----------------------------------------------------------}

procedure INT29; assembler;
{appele par les entres/sorties de DOS pendant un Shell}
asm
 iret
end; {INT29}

{----------------------------------------------------------}

function DecompArchive(nom_archive,nom_fichier: String80): WORD;

const ProgArch: array[ARJ..ZIP] of
                 record
                  Nom  : STRING[7];
                  Param: STRING[10];
                 end

                =((Nom:'ARJ'    ; Param:'e -y'),
                  (Nom:'LHARC'  ; Param:'e'),
                  (Nom:'RAR'    ; Param:'e -std -o+'),
                  (Nom:'PKUNZIP'; Param:'-e -o'));

var ancINT29: POINTER;
    type_arch: BYTE;
    chemin_prog: String80;

begin
 type_arch:=TypeArchive(nom_archive);
 if not(type_arch in [ARJ..ZIP]) then
  begin DecompArchive:=f_err_fich_intr; exit end;

 chemin_prog:=FSearch(ProgArch[type_arch].Nom+'.EXE',GetEnv('PATH'));
 if chemin_prog='' then
  begin DecompArchive:=f_err_fich_intr; exit end;

 SwapVectors;
 SwapIntVec($29,ancINT29,@INT29);
 Exec(chemin_prog,ProgArch[type_arch].Param+' '+nom_archive+' '+RepertTemp+' '+nom_fichier);
 SwapIntVec($29,ancINT29,ancINT29);
 SwapVectors;

 if DosError=0 then DecompArchive:=DosExitCode else DecompArchive:=DosError;
end; {DecompArchive}

{==========================================================}

END.
