{
  This is a complete map of PC, XT, AT, PS/2 and EGA-installed data
  areas between 0400h and 0500h in the low memory segment put into the
  form of a Turbo Pascal 4/5/5.5 compatible UNIT.

  I found myself needing one or two of these absolute addresses from time
  to time and got tired of looking them up. Using a record structure
  declared as absolute variable relieves you of specifying the
  individual addresses for each variable, providing that all the Resrved
  areas are included too.

  I hope this saves all those Turbo Pascal programmers out there some time
  and lets them get on with the creative side of the business. Enjoy!

  David Gwillim
  159 Woodbury Road
  Hicksville, NY 11801-3030
  (516) 942-8697

  6 August 1989

  CREDITS:

  The absolute addresses for this UNIT came from "The Programmer's PC
  Sourcebook" by Thom Hogan, published by Microsoft Press.
  ISBN 1-55615-118-7. List price $24.95 USA.

  This book is very helpful (apart from a few inevitable) typos). I
  consider it an essential purchase for any programmer who has to deal
  with a PC at the hardware level.
}

UNIT BiosEqu;

INTERFACE

VAR
   BiosSeg: record
      ComBase: array[1..4] of WORD;
      LptBase: array[1..4] of WORD;
      InstalledHardware: WORD;
      POST_Status: BYTE;      { Convertible only }
      MemorySize: WORD;
      _RESERVED1: WORD;
      KeyboardControl: array[1..2] of BYTE;
      AlternateKeypadEntry: BYTE;
      KeyboardBufferHeadPtr: WORD; { points to first CHAR in type-ahead buffer }
      KeyboardBufferTailPtr: WORD; { points to last CHAR in type-ahead buffer }
      KeyboardBuffer: array[1..16] of WORD;
      FloppyRecalStatus: BYTE;
      FloppyMotorStatus: BYTE;
      FloppyMotorOffCounter: BYTE;
      FloppyPrevOpStatus: BYTE;
      FloppyControllerStatus: array[1..7] of BYTE;
      DisplayMode: BYTE;
      NumberOfColumns: WORD;
      RegenBufferLength: WORD;
      RegenBufferAddress: WORD;
      CursorPosition: array[1..8] of WORD;
      CursorType: WORD;
      CurrentDisplayPage: BYTE;
      VideoControllerBaseAddress: WORD;
      Current3x8Register: BYTE;
      Current3x9Register: BYTE;
      PointerToResetCode: POINTER;  { PS/2 only - except model 30 }
      _RESERVED2: BYTE;
      TimerCounter: LONGINT;
      TimerOverflowFlag: BYTE;  { non-zero means timer passed 24 hours }
      BreakKeyState: BYTE;
      ResetFlag: WORD;  { $1234=bypass mem test; $4321=preserve mem (PS/2) }
                         { $5678=system supended (Convertible) }
                         { $9ABC=manufacturing test (Convertible) }
                         { $ABCD=system POST loop (Convertible only) }
      FixedDiskPrevOpStatus: BYTE;
      NumberOfFixedDrives: BYTE;
      FixedDiskDriveControl: BYTE;   {XT only}
      FixedDiskControllerPort: BYTE; {XT only}
      LptTimeOut: array[1..4] of BYTE;  { [4] valid for PC, XT and AT only }
      ComTimeOut: array[1..4] of BYTE;
      KeyboardBufferStartOffsetPtr:WORD;
      KeyboardBufferEndOffsetPtr:WORD;
      VideoRows: BYTE;
      CharacterHeight: WORD;  { bytes per character }
      VideoControlStates: array[1..2] of BYTE;

      _RESERVED3: WORD;
      MediaControl: BYTE;
      FixedDiskControllerStatus: BYTE; { AT, XT after 1/10/85, PS/2 only }
      FixedDiskControllerErrorStatus: BYTE; { AT, XT after 1/10/85, PS/2 only }
      FixedDiskInterruptControl: BYTE; { AT, XT after 1/10/85, PS/2 only }
      _RESERVED4: BYTE;
      DriveMediaState: array[0..1] of BYTE;
      _RESERVED5: WORD;
      DriveCurrentCylinder: array[0..1] of BYTE;
      KeyboardModeState: BYTE;
      KeyboardLEDflags: BYTE;
      UserWaitCompleteFlagAddress: POINTER;
      UserWaitCount: LONGINT;   { micro-seconds }
      WaitActiveFlag: BYTE;
      _RESERVED6: array[1..7] of BYTE;
      VideoParameterTable: POINTER;          { EGA and PS/2 only }
      DynamicSaveArea: POINTER;              { EGA and PS/2 only }
      AlphaModeAuxCharGenerator: POINTER;    { EGA and PS/2 only }
      GraphicsModeAuxCharGenerator: POINTER; { EGA and PS/2 only }
      SecondarySaveArea: POINTER;            { PS/2 only (not Model 30) }
      _RESERVED7: array[1..4] of BYTE;
      _RESERVED8: array[1..64] of BYTE;
      PrintScreenStatus: BYTE;
   end absolute $0040:$0000;

IMPLEMENTATION

END.
