{ͻ}
{                       --== BMP256.PAS ==--                       }
{                                                                      }
{ UNIT pour afficher des images BitMap 8 bits non compresses         }
{ Rsolution max 320x200                                               }
{                                                                      }
{ AUTEURS: Fabrice Couteau et Freddy Vtel                            }
{Ķ}
{ Compatibilit: 386           Dbut d'criture ??/10/94 }
{                              Dernires modifications 26/07/98 }
{ͼ}

{$UNDEF Groupe}

{$IFNDEF Groupe}
UNIT BMP256;
{$else}
UNIT BMP256_G;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

USES VGA,Graph256,GraphX;

{$I Types}

CONST taille_BMP_max=320*200;

TYPE T_image=array[1..taille_BMP_max] of BYTE;

     {format standard}
     BMP=object
          ResX: WORD;
          ResY: BYTE;
          palette: Palette256;
          image: ^T_image;

          procedure Charge(nom_fichier: String80; var erreur: WORD);
{$IFNDEF Groupe}
          procedure Sauve (nom_fichier: String80; var erreur: WORD);
{$ENDIF}
          procedure FixePalette;
          procedure Affiche (segment,x: WORD; y: BYTE);
          procedure AfficheX(segment,x,y: WORD);
          procedure AfficheLimite(segment: WORD; x,y: INTEGER; sprite: BOOLEAN;
                                  xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);
          procedure AfficheCol(segment,x: WORD; y: BYTE; colonne: WORD);
          procedure AfficheLig(segment,x: WORD; y: BYTE; ligne: BYTE);
          procedure ReduitPalette(longueur_palette: WORD);
          function  NombreCouleurs: WORD;
          procedure Supprime;

         private
          nom_f: String80;
         end;

CONST erreur_format =1;
      erreur_memoire=6;

{==========================================================}

IMPLEMENTATION

{$IFNDEF Groupe}
USES Fichiers,Util;
{$else}
USES Fich_Grp,Util;
{$ENDIF}

TYPE T_entete_BMP=record
                   id: array[1..2] of CHAR;  { identificateur 'BM'    }
                   Taille_f: LONGINT;        { taille du fichier      }
                   W1,W2  : WORD;           { normalement = 0        }
                   OffBits: LONGINT;        { offset du 1er pixel    }
                   TailleInfo : LONGINT;    { taille du bloc d'infos }
                   Res_x,Res_y: LONGINT;    { rsolutions X et Y     }
                   Planes     : WORD;       { nb de plans = 1        }
                   NbBit      : WORD;       { nb de bits/pixel       }
                   Compression: LONGINT;    { type de compression    }
                   ImageSize  : LONGINT;
                   xPix,yPix  : LONGINT;
                   L1,L2      : LONGINT;
                   palette_BVRz: array[BYTE] of record B,V,R,z: BYTE end;
                  end;

{==========================================================}

procedure BMP.Charge(nom_fichier: String80; var erreur: WORD);
var f: Fichier;
    entete: T_entete_BMP;
    taille_image,index: WORD;
    i,long_fin_ligne: BYTE;
begin
 if (nom_f<>'') or (image<>nil) then Supprime;

 with f do begin
  Ouvre(lecture,nom_fichier);
  if f_erreur<>f_ok then begin erreur:=f_erreur; exit end;

  nom_f:=nom_fichier;
  Lit(entete,sizeof(entete));

  with entete do begin
   if (id<>'BM') or (TailleInfo<>40) or (OffBits>=Taille_f) or
      (Res_x<1) or (Res_x>320) or
      (Res_y<1) or (Res_y>200) or
      (Planes<>1) or (NbBit<>8) then begin erreur:=erreur_format; exit end;

   PlacePointeur(OffBits);
   ResX:=res_x; ResY:=res_y;
   taille_image:=ResX*ResY;

   if MaxAvail<taille_image+16 then begin erreur:=erreur_memoire; exit end;

   GetMem(image,taille_image);
   index:=taille_image+1;
   long_fin_ligne:=(4-(ResX and 3)) and 3; {0,1,2 ou 3}
   {la longueur relle d'une ligne de l'image dans le fichier dpend
    de (ResX mod 4): elle est arrondie au multiple de 4 suprieur}

   {lecture de l'image ligne par ligne}
   for i:=1 to ResY do begin
    dec(index,ResX); Lit(image^[index],ResX);
    DeplacePointeur(long_fin_ligne);
   end;

   {conversion de palette BVRz -> RVB}
   for i:=0 to 255 do with palette.palette[i] do begin
    R:=palette_BVRz[i].R shr 2;
    V:=palette_BVRz[i].V shr 2;
    B:=palette_BVRz[i].B shr 2;
   end;
  end;

  Ferme;
 end;

 erreur:=0;
end; {BMP.Charge}

{----------------------------------------------------------}

{$IFNDEF Groupe}
procedure BMP.Sauve(nom_fichier: String80; var erreur: WORD);
{sauvegarde une image dj charge sous le nom 'nom_fichier'}
var f: Fichier;
    entete: T_entete_BMP;
    index: WORD;
    i,long_fin_ligne: BYTE;
    zero: LONGINT;
begin
 if (nom_f='') or (image=nil) then begin erreur:=erreur_memoire; exit end; {pas d'image}

 with f do begin
  {recharge l'image d'origine pour rcuprer l'entte}
  Ouvre(lecture,nom_f);
  if f_erreur<>f_ok then begin erreur:=f_erreur; exit end;

  Lit(entete,sizeof(entete));
  with entete do begin
   Taille_f:=sizeof(entete)+Res_x*Res_y;
   OffBits:=sizeof(entete);

   {conversion de palette RVB -> BVRz}
   for i:=0 to 255 do with palette.palette[i] do begin
    palette_BVRz[i].R:=R shl 2;
    palette_BVRz[i].V:=V shl 2;
    palette_BVRz[i].B:=B shl 2;
    palette_BVRz[i].z:=0;
   end;
  end;

  Ferme;

  {cre le nouveau fichier}
  Cree(ecrase,nom_fichier);
  if f_erreur<>f_ok then begin erreur:=f_erreur; exit end;

  Ecrit(entete,sizeof(entete));

  index:=ResX*ResY+1;
  long_fin_ligne:=(4-(ResX and 3)) and 3; {0,1,2 ou 3}
  {la longueur relle d'une ligne de l'image dans le fichier dpend
   de (ResX mod 4): elle est arrondie au multiple de 4 suprieur}

  {sauvegarde l'image ligne par ligne}
  zero:=0;
  for i:=1 to ResY do begin
   dec(index,ResX); Ecrit(image^[index],ResX);
   Ecrit(zero,long_fin_ligne);
  end;

  Ferme;
 end;

 erreur:=0;
end; {BMP.Sauve}
{$ENDIF}

{----------------------------------------------------------}

procedure BMP.FixePalette;
begin
 palette.Fixe(0,256);
end; {BMP.FixePalette}

{----------------------------------------------------------}

procedure BMP.Affiche(segment,x: WORD; y: BYTE);
{affiche l'image BMP en (x,y) dans la zone vido commenant en 'segment',
 sans tests de dbordements}
var res_x: WORD;
    res_y: BYTE;
    ptr_image: POINTER;
begin
 res_x:=ResX; res_y:=ResY;
 ptr_image:=image;
 asm
  push DS
  cld

  mov ES,segment
  xor AL,AL
  mov AH,y
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,x              {ES:DI -> segment:x+320*y}

  mov BX,res_x
  mov AX,320
  sub AX,BX             {AX=320-ResX: incrment DI}

  mov DX,BX
  and DL,3              {DL=ResX Modulo 4}
  shr BX,2              {BL=ResX/4}
  mov DH,res_y          {DH=ResY}

  lds SI,ptr_image

  xor CH,CH
 @aff_ligne:
  mov CL,BL             {CX=ResX/4}
  DB 66h; rep movsw     {rep MOVSD}
  or DL,DL              {encore un point  afficher?}
  jz @suite             {non}
  mov CL,DL
  rep movsb             {affiche fin ligne}
 @suite:
  add DI,AX             {ligne suivante}
  dec DH
  jnz @aff_ligne

  pop DS
 end
end; {BMP.Affiche}

{----------------------------------------------------------}

procedure BMP.AfficheX(segment,x,y: WORD);
{affiche l'image BMP en (x,y) dans la page cran active sans tests de
 dbordements}

var Cmpt_Pixels_Sup: WORD; { Compteur des pixels supplmentaires }
    Nb_Boucles_x: WORD;
    Nb_Boucles_y: BYTE;
    Incrementx: WORD;      { Valeur a ajouter  DI  la fin d'une ligne }
    Incr_Fin_ligne: WORD;
    Debut_ecran,Debut_Image: WORD;
    res_x: WORD;
    res_y: BYTE;
    ptr_image: POINTER;

begin
 res_x:=ResX; res_y:=ResY;
 ptr_image:=image;
 asm
  push DS

  mov ES,segment
  mov AX,y
  mul LargeurX
  mov BX,x
  shr BX,2
  add AX,BX
  mov DI,AX              { ES:DI -> segment:(x+LargeurEcranX*y)/4 }
  mov Debut_Ecran,DI

  mov BX,res_x
  mov AX,BX
  and AX,plane_bits
  mov Cmpt_Pixels_Sup,AX { Nb de plans avec plus de pixels de large }
  mov Incr_Fin_Ligne,AX  { Incrment de fin de ligne (Pour l'image) }
  shr BX,2               { BX=ResX/4 }
  mov Nb_Boucles_x,BX    { Initialise le nombre de colonnes par plan   }
  mov AX,Largeurx
  sub AX,BX              { AX=(320-ResX)/4: incrment x (Pour l'cran) }
  mov Incrementx,AX

  mov AL,res_y
  mov Nb_Boucles_y,AL    { Initialise le nombre de lignes = ResY }

  mov CX,x
  and CX,plane_bits

  mov AX,map_mask_plane2 { Choix du 1 plan }
  shl AH,CL
  mov DX,Sequencer
  out DX,AX

  mov BH,AH              { BH <- masque des plans }
  mov BL,4               { BL Compteur des plans  }

  lds SI,ptr_image
  mov Debut_Image,SI

@Boucle_Plans:
  mov DL,Nb_Boucles_y   { Nb de lignes }

@Boucle_Lignes:
  mov CX,Nb_Boucles_x   { Nb de pixels de large par plan }
  test CL,0FCh
  jz @Copier_le_reste   { Bouclex2 si moins de 4 pixels de large }

@Bouclex1:
  movsb
  add SI,3
  movsb
  add SI,3
  movsb
  add SI,3
  movsb
  add SI,3

  sub CL,4
  test CL,0FCh     { il reste plus de 4 Pixels ? }
  jnz @Bouclex1    { oui => Boucler              }

@Copier_le_reste:
  jcxz @Prochaine_ligne

@Bouclex2:
  movsb
  add SI,3
  loop @Bouclex2

@Prochaine_ligne:
  or CX,Cmpt_Pixels_Sup { Cmpt_Pixel_sup=0 ? ( Rq: CX=0 )   }
  jz @Suite2

  movsb
  dec SI
  dec DI

@Suite2:
  add SI,Incr_Fin_Ligne
  add DI,Incrementx

  dec DL                { Encore une ligne ?     }
  jnz @Boucle_Lignes    { Oui => Prochaine ligne }

  dec BL                { Encore un plan ? }
  jz @Fin               { Non => Fin       }

  rol BH,1              { Changer de plan  }
  mov DX,SequencerData
  mov AL,BH
  out DX,AL

  cmp AL,12h            { Carry si BH=11h (si debut d'une nouvelle ligne) }
  adc Debut_Ecran,0     { Dcale l'adresse de dpart de l'cran }
  inc Debut_Image       { Se dcaler dans l'image }

  sub Cmpt_Pixels_Sup,1 { Dcrmenter Cmpt_Pixels_Sup }
  adc Cmpt_Pixels_Sup,0 { Eviter les valeurs <0 !!!   }

  mov SI,Debut_Image
  mov DI,Debut_Ecran

  jmp @Boucle_Plans

@Fin:
  pop DS
 end;
end; {BMP.AfficheX}

{----------------------------------------------------------}

procedure BMP.AfficheLimite(segment: WORD; x,y: INTEGER; sprite: BOOLEAN;
                            xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);
{affiche l'image BMP dans la zone vido commenant en 'segment'.
 (x,y) sont les coordonnes du point suprieur gauche de l'image (peuvent sortir de l'cran).
 -si 'sprite'=TRUE: l'image est affiche point par point, sauf les points
                    de couleur nulle.
 -si 'sprite'=FALSE, l'image est affiche 4 points par 4 points, sans test.
 Dans les 2 cas, l'image est affiche dans les limites de la fentre de
 coordonnes (xg,yh,xd,yb) relatives  la zone vido.}

begin
 AfficheFormeLimite(image^,segment,x,y,ResX,ResY,sprite,TRUE,MOV_,xg,yh,xd,yb);
end; {BMP.AfficheLimite}

{----------------------------------------------------------}

procedure BMP.AfficheCol(segment,x: WORD; y: BYTE; colonne: WORD);
{affiche la colonne (1..ResX) de l'image BMP en (x,y) dans
 la zone vido commenant en 'segment', sans tests de dbordements}
var res_x: WORD;
    res_y: BYTE;
    ptr_image: POINTER;
begin
 res_x:=ResX; res_y:=ResY;
 ptr_image:=image;
 asm
  push DS
  cld

  mov ES,segment
  xor AL,AL
  mov AH,y
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,x              {ES:DI -> segment:x+320*y}

  lds SI,ptr_image
  add SI,colonne
  dec SI                {DS:SI -> 'colonne' ime point de la premire ligne}

  mov AX,res_x
  dec AX                {AX=ResX-1: incrment SI}
  mov DX,320-1          {DX=319: incrment DI}

  xor CH,CH
  mov CL,res_y
  shr CL,1              {CX=ResY/2}
 @affiche_colonne:
  movsb                 {affiche un point}
  add SI,AX
  add DI,DX
  movsb                 {affiche un point}
  add SI,AX
  add DI,DX
  loop @affiche_colonne

  pop DS
 end
end; {BMP.AfficheCol}

{----------------------------------------------------------}

procedure BMP.AfficheLig(segment,x: WORD; y: BYTE; ligne: BYTE);
{affiche la ligne (1..ResY) de l'image BMP en (x,y) dans
 la zone vido commenant en 'segment', sans tests de dbordements}
var res_x: WORD;
    ptr_image: POINTER;
begin
 res_x:=ResX;
 ptr_image:=image;
 asm
  push DS
  cld

  mov ES,segment
  xor AL,AL
  mov AH,y
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,x              {ES:DI -> segment:x+320*y}

  mov CX,res_x
  mov DX,CX
  and DL,3              {DL=ResX Modulo 4}

  lds SI,ptr_image
  xor AH,AH
  mov AL,ligne
  dec AL
  mul CX                {AX=ResX*(ligne-1)}
  add SI,AX             {DS:SI -> premier point de la ligne}

  shr CX,2              {CX=ResX/4}
  DB 66h; rep movsw     {rep MOVSD}
  or DL,DL              {encore des points  afficher?}
  jz @fin               {non}
  mov CL,DL
  rep movsb             {affiche fin ligne}

 @fin:
  pop DS
 end
end; {BMP.AfficheLig}

{----------------------------------------------------------}

procedure BMP.ReduitPalette(longueur_palette: WORD);
{rduit la palette de l'image  'longueur_palette' couleurs (0..longueur_palette-1)}
var nombre_couleurs,i,n: WORD;
    c,c2,tolerance,ecart: BYTE;
    comp: RVB;
    nouv_pal: Palette256;

    pal: array[BYTE] of record
          coul: BYTE;
          lien_coul: BYTE;
          freq: WORD;
         end;

    pal2: array[BYTE] of record
           coul: BYTE;
           lum: BYTE;
          end;

    ind,ind2: array[BYTE] of BYTE;


procedure TriFreq(debut,fin: BYTE);
var i,j: BYTE;
    aux: WORD;
begin
 i:=debut; j:=fin; aux:=pal[(debut+fin) div 2].freq;
 repeat
  while pal[i].freq>aux do inc(i);
  while aux>pal[j].freq do dec(j);
  if i<=j then begin
   SwapVar(pal[i],pal[j],sizeof(pal[0]));
   inc(i); if j>0 then dec(j);
  end;
 until i>j;
 if debut<j then TriFreq(debut,j);
 if i<fin   then TriFreq(i,fin);
end; {TriFreq}


procedure TriLum(debut,fin: BYTE);
var i,j: BYTE;
    aux: BYTE;
begin
 i:=debut; j:=fin; aux:=pal2[(debut+fin) div 2].lum;
 repeat
  while pal2[i].lum<aux do inc(i);
  while aux<pal2[j].lum do dec(j);
  if i<=j then begin
   SwapVar(pal2[i],pal2[j],sizeof(pal2[0]));
   inc(i); if j>0 then dec(j);
  end;
 until i>j;
 if debut<j then TriLum(debut,j);
 if i<fin   then TriLum(i,fin);
end; {TriLum}


function NombreCoulPal: WORD;
var n: WORD;
    c: BYTE;
begin
 n:=0;
 for c:=0 to 255 do
  with pal[c] do if (lien_coul=coul) and (freq<>0) then inc(n);

 NombreCoulPal:=n;
end; {NombreCoulPal}


begin  {ReduitPalette}
 {initialisation}
 for c:=0 to 255 do with pal[c] do begin
  coul:=c;
  lien_coul:=c;
  freq:=0;
 end;

 {comptage frquentiel des couleurs de l'image}
 for i:=1 to resX*resY do inc(pal[image^[i]].freq);

 {tri suivant les frquences dcroissantes}
 TriFreq(0,255);

 tolerance:=1;

 nombre_couleurs:=NombreCoulPal;
 if nombre_couleurs<longueur_palette then longueur_palette:=nombre_couleurs;

 {rduction de la palette}
 repeat
  n:=nombre_couleurs;

  for c:=0 to 255-1 do
   if pal[c].lien_coul=pal[c].coul then begin
    with palette,comp do begin
     R:=palette[pal[c].coul].R;
     V:=palette[pal[c].coul].V;
     B:=palette[pal[c].coul].B;
    end;

    for c2:=c+1 to 255 do
     if pal[c2].lien_coul=pal[c2].coul then begin
      with palette,comp do
       ecart:=Abs(palette[pal[c2].coul].R-R)+
              Abs(palette[pal[c2].coul].V-V)+
              Abs(palette[pal[c2].coul].B-B);

      if ecart<=tolerance then begin
       pal[c2].lien_coul:=pal[c].coul;
       inc(pal[c].freq,pal[c2].freq);
       pal[c2].freq:=0;

       nombre_couleurs:=NombreCoulPal;
       if nombre_couleurs<=longueur_palette then break;
      end;
     end;
    if nombre_couleurs<=longueur_palette then break;
   end;

  if nombre_couleurs=n then inc(tolerance);

  {tri suivant les frquences dcroissantes}
  TriFreq(0,255);
 until nombre_couleurs<=longueur_palette;

 {calcul des luminosits}
 n:=0;
 for c:=0 to 255 do with pal[c] do
  if (lien_coul=coul) and (freq<>0) then begin
   pal2[n].coul:=coul;
   with palette.palette[coul] do pal2[n].lum:=R+V+B;
   inc(n);
  end;

 {tri suivant les luminosits croissantes}
 TriLum(0,longueur_palette-1);

 {redistribution de la palette}
 FillCHAR(nouv_pal,sizeof(nouv_pal),0);
 for c:=0 to nombre_couleurs-1 do nouv_pal.palette[c]:=palette.palette[pal2[c].coul];
 palette:=nouv_pal;

 {recherche des correspondances couleur <-> indice dans tableau}
 for c:=0 to 255 do for c2:=0 to 255 do
  if pal[c2].coul=c then begin ind[c]:=c2; break end;

 for c:=0 to 255 do for c2:=0 to nombre_couleurs-1 do
  if pal2[c2].coul=c then begin ind2[c]:=c2; break end;

 {recherche des couleurs terminales}
 for c:=0 to 255 do
  if pal[c].lien_coul<>pal[c].coul then begin
   c2:=pal[c].lien_coul;
   repeat
    c2:=ind[c2];
    with pal[c2] do if lien_coul=coul then break else c2:=lien_coul;
   until FALSE;
   pal[c].lien_coul:=pal[c2].coul;
  end;

 {redistribution des couleurs de l'image}
 for i:=1 to resX*resY do image^[i]:=ind2[pal[ind[image^[i]]].lien_coul];
end; {BMP.ReduitPalette}

{----------------------------------------------------------}

function BMP.NombreCouleurs: WORD;
{renvoie le nombre de couleurs rellement utilises par l'image}
var pal: array[BYTE] of WORD;
    c: BYTE;
    n: WORD;
begin
 FillCHAR(pal,sizeof(pal),0);
 for n:=1 to resX*resY do inc(pal[image^[n]]);

 n:=0;
 for c:=0 to 255 do if pal[c]<>0 then inc(n);

 NombreCouleurs:=n;
end; {BMP.NombreCouleurs}

{----------------------------------------------------------}

procedure BMP.Supprime;
begin
 if image<>nil then FreeMem(image,ResX*ResY);
 image:=nil;
 nom_f:='';
end; {BMP.Supprime}

{==========================================================}

END.
