{ͻ}
{                      --== CDAUDIO.PAS ==--                       }
{                                                                      }
{ Unit pour grer les CD audio                                        }
{                                                                      }
{ AUTEUR: Romaric Maillard                                             }
{ modifie par: Fabrice Couteau et Freddy Vtel                       }
{Ķ}
{ Compatibilit: 286           Dbut d'criture ??/??/95 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT CDAudio;

{$A+,G+,Q-,R-,S-}

INTERFACE

TYPE Request=record
              size    : BYTE;
              sub_unit: BYTE;
              cmd     : BYTE;
              status  : WORD;
              reserved: array[1..8] of BYTE;
             end;

     P_IOCTL=^T_IOCTL;
     T_IOCTL=record
                R           : Request;
                reserved    : BYTE;
                buf_ptr     : POINTER;
                buf_size    : WORD;
                start_sector: WORD;
                volume_ptr  : LONGINT;
               end;

     T_Time=record min,sec: BYTE; end;

     TCD=object
            FirstTrack,LastTrack,CurrentTrack: BYTE;
            TrackTime,CDTime: T_Time;

            {GetInfo -> CurrentTrack, TrackTime, CDTime}

            constructor SetDrive(n_drive: WORD);
            function  Letter: CHAR;
            function  Installed: BOOLEAN;
            procedure Init;
            procedure Reset;
            procedure Reset2;

            procedure GetInfo;

            function  Status: WORD;
            function  IsAudio: BOOLEAN;
            function  IsReady: BOOLEAN;
            function  IsBusy: BOOLEAN;
            function  IsOpen: BOOLEAN;
            function  IsLoaded: BOOLEAN;
            function  IsPaused: BOOLEAN;

            procedure OpenDoor;
            procedure CloseDoor;

            procedure Pause;
            procedure Stop;

            procedure FastFwd(av: WORD);
            procedure FastFwdPR;
            procedure FastRwd(ret: WORD);
            procedure FastRwdPR;

            procedure PlayTrack(track: BYTE);
            procedure GotoTrack(track: BYTE);
            procedure NextTrack;
            procedure PrevTrack;

           private
            Drive: WORD;
            total_sectors,start_sector,end_sector: LONGINT;

            function  Size: LONGINT;
            function  HeadPos(mode: BYTE): LONGINT;
            function  TrackToSector(track: BYTE): LONGINT;
            procedure AskIOCTL(cmd: BYTE; S_IOCTL: P_IOCTL);
            procedure Seek(mode: BYTE; sector: LONGINT);
            procedure Play(mode: BYTE; sector, n_sectors: LONGINT);
            procedure Suspend;
            procedure Resume;
            procedure OpenClose(cmd: BYTE);

            destructor Done;
           end;

VAR CD: TCD;

{==========================================================}

IMPLEMENTATION

USES Dos,Util;

CONST {sens des requtes IOCTL}
      IOCTL_Input =3;
      IOCTL_Output=12;

      {modes d'adressage du CD}
      Mode_HSG    =0;
      Mode_RedBook=1;

      {commandes d'ouverture/fermeture du caddy}
      CD_Open =0;
      CD_Close=5;

{==========================================================}

constructor TCD.SetDrive(n_drive: WORD);
begin
 Drive:=n_drive;
end; {SetDrive}

{----------------------------------------------------------}

function TCD.Letter: CHAR;
begin
 if Drive=0 then Letter:=#0 else Letter:=CHAR(Drive+BYTE('A'));
end; {Letter}

{----------------------------------------------------------}

function TCD.Installed: BOOLEAN;
begin
 Installed:=(Drive<>0);
end; {Installed}

{----------------------------------------------------------}

procedure TCD.Init;
var time_out: BOOLEAN;
    start_time: LONGINT;
begin
 time_out:=FALSE;
 start_time:=Timer;

 FirstTrack:=0; LastTrack:=0;
 start_sector:=0; end_sector:=0; total_sectors:=0;

 if IsOpen then exit;

 if IsLoaded then begin
  repeat time_out:=(Timer>=start_time+36); until IsReady or time_out;

  if time_out then Reset;

  IsAudio; {force un accs au CD}
 end;

 if IsReady then total_sectors:=Size;

 end_sector:=total_sectors;
 GetInfo;
end; {Init}

{----------------------------------------------------------}

procedure TCD.Reset;
var IO: T_IOCTL;
    command: BYTE;

begin
 FillCHAR(IO,sizeof(IO),0);
 IO.R.size:=sizeof(IO);
 IO.R.cmd:=IOCTL_Output;
 command:=2;
 IO.buf_ptr:=@command;
 IO.buf_size:=sizeof(command);
 AskIOCTL(IOCTL_Output,@IO);
end; {Reset}

{----------------------------------------------------------}

procedure TCD.Reset2;
type TS=record
           R: Request;
           D1,D2: LONGINT;
           NBD: BYTE;
          end;

var S: TS;
    P: POINTER;
    D: WORD;

begin
 FillCHAR(S,sizeof(S),0);
 S.R.size:=sizeof(S);
 S.R.cmd:=0;
 P:=@S;
 D:=Drive;
 asm
  les BX,P
  mov CX,D
  mov AX,1510h
  int 2Fh
 end;
end; {Reset2}

{----------------------------------------------------------}

procedure TCD.GetInfo;

type TCD_Info=record
                 command: BYTE;
                 first_track: BYTE;
                 last_track: BYTE;
                end;

     TCD_CurInfo=record
                    command: BYTE;
                    CTR_ADR: BYTE;
                    n_track: BYTE;
                    Index: BYTE;
                    TrackTime: T_Time;
                    Frame: BYTE;
                    Zero: BYTE;
                    CDTime: T_Time;
                    Aframe: BYTE;
                   end;

var IO: T_IOCTL;
    SI: TCD_Info;
    SCI: TCD_CurInfo;

begin
 if IsReady then begin
  FillCHAR(IO,sizeof(IO),0);
  IO.buf_ptr:=@SI;
  IO.buf_size:=sizeof(SI);
  SI.command:=10;
  AskIOCTL(IOCTL_Input,@IO);
  FirstTrack:=SI.first_track;
  LastTrack:=SI.last_track;

  FillCHAR(IO,sizeof(IO),0);
  IO.buf_ptr:=@SCI;
  IO.buf_size:=sizeof(SCI);
  SCI.command:=IOCTL_Output;
  AskIOCTL(IOCTL_Input,@IO);
  CurrentTrack:=(SCI.n_track shr 4)*10+(SCI.n_track and $0F); {dcode BCD}
  TrackTime:=SCI.TrackTime;
  CDTime:=SCI.CDTime;
 end
 else begin
  FirstTrack:=0;
  LastTrack:=0;
  CurrentTrack:=0;
  FillCHAR(TrackTime,sizeof(TrackTime),0);
  FillCHAR(CDTime,sizeof(CDTime),0);
 end;
end; {GetInfo}

{----------------------------------------------------------}

function TCD.Status: WORD;
type TS=record
           command: BYTE;
           status: LONGINT;
          end;

var S: TS;
    IO: T_IOCTL;

begin
 FillCHAR(IO,sizeof(IO),0);
 IO.buf_ptr:=@S;
 IO.buf_size:=sizeof(S);
 S.command:=6;
 AskIOCTL(IOCTL_Input,@IO);
 Status:=IO.R.status;
end; {Status}

{----------------------------------------------------------}

function  TCD.IsAudio: BOOLEAN;
var f: SearchRec;
begin
 FindFirst(Letter+':\*.*',AnyFile,f);
 IsAudio:=(DosError<>0) or (LastTrack>1);
end; {IsAudio}

{----------------------------------------------------------}

function TCD.IsReady: BOOLEAN;
type TS=record
           command: BYTE;
           total_sectors: LONGINT;
          end;

var S: TS;
    IO: T_IOCTL;

begin
 FillCHAR(IO,sizeof(IO),0);
 IO.buf_ptr:=@S;
 IO.buf_size:=sizeof(S);
 S.command:=8;
 AskIOCTL(IOCTL_Input,@IO);
 if ((IO.R.status and $8000)=$8000) then IsReady:=((IO.R.status and $02)=0)
                                    else IsReady:=TRUE;
end; {IsReady}

{----------------------------------------------------------}

function TCD.IsBusy: BOOLEAN;
type TS=record
           command: BYTE;
           status: LONGINT;
          end;

var S: TS;
    IO: T_IOCTL;

begin
 FillCHAR(IO,sizeof(IO),0);
 IO.buf_ptr:=@S;
 IO.buf_size:=sizeof(S);
 S.command:=6;
 AskIOCTL(IOCTL_Input,@IO);
 IsBusy:=((IO.R.status and $0200)=$0200);
end; {IsBusy}

{----------------------------------------------------------}

function TCD.IsOpen: BOOLEAN;
type TS=record
           command: BYTE;
           status: LONGINT;
          end;

var S: TS;
    IO: T_IOCTL;

begin
 FillCHAR(IO,sizeof(IO),0);
 IO.buf_ptr:=@S;
 IO.buf_size:=sizeof(S);
 S.command:=6;
 AskIOCTL(IOCTL_Input,@IO);
 IsOpen:=((S.status and $0001)=$0001);
end; {IsOpen}

{----------------------------------------------------------}

function TCD.IsLoaded: BOOLEAN;
type TS=record
           command: BYTE;
           status: LONGINT;
          end;

var S: TS;
    IO: T_IOCTL;

begin
 FillCHAR(IO,sizeof(IO),0);
 IO.buf_ptr:=@S;
 IO.buf_size:=sizeof(S);
 S.command:=6;
 AskIOCTL(IOCTL_Input,@IO);
 IsLoaded:=((S.status and $0800)=$0000);
end; {IsLoaded}

{----------------------------------------------------------}

function TCD.IsPaused: BOOLEAN;
type TS=record
           command: BYTE;
           status: WORD;
           D1,D2: LONGINT;
          end;

var S: TS;
    IO: T_IOCTL;

begin
 FillCHAR(IO,sizeof(IO),0);
 IO.buf_ptr:=@S;
 IO.buf_size:=sizeof(S);
 S.command:=15;
 AskIOCTL(IOCTL_Input,@IO);
 IsPaused:=((S.status and $0001)=$0001);
end; {IsPaused}

{----------------------------------------------------------}

procedure TCD.OpenDoor;
begin
 if not(IsOpen) then begin Stop; OpenClose(CD_Open); GetInfo; end;
end; {OpenDoor}

{----------------------------------------------------------}

procedure TCD.CloseDoor;
begin
 if IsOpen then begin OpenClose(CD_Close); Init; end;
end; {CloseDoor}

{----------------------------------------------------------}

procedure TCD.Pause;
begin
 if IsBusy and not(IsPaused) then Suspend else Resume;
end; {Pause}

{----------------------------------------------------------}

procedure TCD.Stop;
begin
 Suspend;
 GetInfo;
 GotoTrack(CurrentTrack); {revient au dbut de la piste courante}
end; {Stop}

{----------------------------------------------------------}

procedure TCD.FastFwd(av: WORD);
var Pos: LONGINT;
begin
 Pos:=HeadPos(Mode_HSG);
 if Pos<total_sectors-av then begin
  inc(Pos,av);
  Suspend;
  Play(Mode_HSG,Pos,total_sectors-Pos);
 end
 else begin
  Suspend;
  Play(Mode_HSG,1,total_sectors);
 end;
end; {FastFwd}

{----------------------------------------------------------}

procedure TCD.FastFwdPR;
var Pos: LONGINT;
begin
 Pos:=HeadPos(Mode_HSG);
 if Pos<end_sector-512 then begin
  inc(Pos,512);
  Suspend;
  Play(Mode_HSG,Pos,end_sector-Pos);
 end;
end; {FastFwdPR}

{----------------------------------------------------------}

procedure TCD.FastRwd(ret: WORD);
var Pos: LONGINT;
begin
 Pos:=HeadPos(Mode_HSG);
 if Pos>ret then begin
  dec(Pos,ret);
  Suspend;
  Play(Mode_HSG,Pos,total_sectors-Pos);
 end
 else begin
  Suspend;
  Play(Mode_HSG,1,total_sectors);
 end;
end; {FastRwd}

{----------------------------------------------------------}

procedure TCD.FastRwdPR;
var Pos: LONGINT;
begin
 Pos:=HeadPos(Mode_HSG);
 if Pos>start_sector+512 then begin
  dec(Pos,512);
  Suspend;
  Play(Mode_HSG,Pos,end_sector-Pos);
 end
 else begin
  Suspend;
  Play(Mode_HSG,start_sector,end_sector-Pos);
 end;
end; {FastRwdPR}

{----------------------------------------------------------}

procedure TCD.PlayTrack(track: BYTE);
begin
 Suspend;
 Seek(Mode_RedBook,TrackToSector(track));
 start_sector:=HeadPos(Mode_HSG);

 if track=LastTrack then end_sector:=total_sectors
 else begin
  Seek(Mode_RedBook,TrackToSector(track+1));
  end_sector:=HeadPos(Mode_HSG)-1;
 end;

 Play(Mode_HSG,start_sector,end_sector-start_sector);
end; {PlayTrack}

{----------------------------------------------------------}

procedure TCD.GotoTrack(track: BYTE);
begin
 if IsBusy and not(IsPaused) then PlayTrack(track)
 else begin
  Suspend;
  Seek(Mode_RedBook,TrackToSector(track));
 end;
end; {GotoTrack}

{----------------------------------------------------------}

procedure TCD.NextTrack;
var track: BYTE;
begin
 GetInfo;
 track:=CurrentTrack;
 if track<LastTrack then
  if IsBusy and not(IsPaused) then PlayTrack(track+1) else GotoTrack(track+1);
end; {NextTrack}

{----------------------------------------------------------}

procedure TCD.PrevTrack;
var track: BYTE;
begin
 GetInfo;
 track:=CurrentTrack;
 if track>FirstTrack then
  if IsBusy and not(IsPaused) then PlayTrack(track-1) else GotoTrack(track-1);
end; {PrevTrack}

{----------------------------------------------------------}

function TCD.Size: LONGINT;
type TS=record
           command: BYTE;
           total_sectors: LONGINT;
          end;

var S: TS;
    IO: T_IOCTL;

begin
 S.command:=8;
 FillCHAR(IO,sizeof(IO),0);
 IO.buf_ptr:=@S;
 IO.buf_size:=sizeof(S);
 AskIOCTL(IOCTL_Input,@IO);
 Size:=S.total_sectors;
end; {Size}

{----------------------------------------------------------}

function TCD.HeadPos(mode: BYTE): LONGINT;
type TS=record
           command: BYTE;
           mode: BYTE;
           head_pos: LONGINT;
          end;

var S: TS;
    IO: T_IOCTL;

begin
 S.command:=1;
 S.mode:=mode;
 FillCHAR(IO,sizeof(IO),0);
 IO.buf_ptr:=@S;
 IO.buf_size:=sizeof(S);
 AskIOCTL(IOCTL_Input,@IO);
 HeadPos:=S.head_pos;
end; {HeadPos}

{----------------------------------------------------------}

function TCD.TrackToSector(track: BYTE): LONGINT;
type TS=record
           command: BYTE;
           n_track: BYTE;
           n_sector: LONGINT;
          end;

var S: TS;
    IO: T_IOCTL;

begin
 S.command:=11;
 S.n_track:=track;
 FillCHAR(IO,sizeof(IO),0);
 IO.buf_ptr:=@S;
 IO.buf_size:=sizeof(S);
 AskIOCTL(IOCTL_Input,@IO);
 TrackToSector:=S.n_sector;
end; {TrackToSector}

{----------------------------------------------------------}

procedure TCD.AskIOCTL(cmd: BYTE; S_IOCTL: P_IOCTL);
var P: POINTER;
    D: WORD;

begin
 S_IOCTL^.R.size:=26;
 S_IOCTL^.R.cmd:=cmd;
 P:=S_IOCTL;
 D:=Drive;
 asm
  les BX,P
  mov CX,D
  mov AX,1510h
  int 2Fh
 end;
end; {AskIOCTL}

{----------------------------------------------------------}

procedure TCD.Seek(mode: BYTE; sector: LONGINT);
type TCD_Seek=record
                 R: Request;
                 mode: BYTE;
                 buf_ptr: POINTER;
                 n_sectors: WORD;
                 start_sector: LONGINT;
                end;

var VCD_Seek: TCD_Seek;
    P: POINTER;
    D: WORD;

begin
 FillCHAR(VCD_Seek,sizeof(VCD_Seek),0);
 VCD_Seek.R.size:=sizeof(VCD_Seek);
 VCD_Seek.R.cmd:=131;
 VCD_Seek.start_sector:=sector;
 VCD_Seek.mode:=mode;
 P:=@VCD_Seek;
 D:=Drive;
 asm
  les BX,P
  mov CX,D
  mov AX,1510h
  int 2Fh
 end;
 { traitement des erreurs }
end; {Seek}

{----------------------------------------------------------}

procedure TCD.Play(mode: BYTE; sector, n_sectors: LONGINT);
type TCD_Play=record
                 R: Request;
                 mode: BYTE; { mode d'adressage HSG ou Red Book }
                 start_sector: LONGINT;
                 n_sectors: LONGINT;
                end;

var VCD_Play: TCD_Play;
    P: POINTER;
    D: WORD;

begin
 FillCHAR(VCD_Play,sizeof(VCD_Play),0);
 VCD_Play.R.size:=sizeof(VCD_Play);
 VCD_Play.R.cmd:=132;
 VCD_Play.mode:=mode;
 VCD_Play.start_sector:=sector;
 VCD_Play.n_sectors:={n_sectors}$FFFF; {pour lecture continue...}
 D:=Drive;
 P:=@VCD_Play;
 asm
  les BX,P
  mov CX,D
  mov AX,1510h
  int 2Fh
 end;
 { traitement des erreurs }
end; {Play}

{----------------------------------------------------------}

procedure TCD.Suspend;
var R: Request;
    P: POINTER;
    D: WORD;

begin
 FillCHAR(R,sizeof(R),0);
 R.size:=sizeof(R);
 R.cmd:=133;
 P:=@R;
 D:=Drive;
 asm
  les BX,P
  mov CX,D
  mov AX,1510h
  int 2Fh
 end;
 { traitement des erreurs... }
end; {Suspend}

{----------------------------------------------------------}

procedure TCD.Resume;
var R: Request;
    P: POINTER;
    D: WORD;

begin
 FillCHAR(R,sizeof(R),0);
 R.size:=sizeof(R);
 R.cmd:=136;
 P:=@R;
 D:=Drive;
 asm
  les BX,P
  mov CX,D
  mov AX,1510h
  int 2Fh
 end;
 { traitement des erreurs... }
end; {Resume}

{----------------------------------------------------------}

procedure TCD.OpenClose(cmd: BYTE);
var IO: T_IOCTL;
    command: BYTE;

begin
 FillCHAR(IO,sizeof(IO),0);
 IO.R.size:=sizeof(IO);
 IO.R.cmd:=IOCTL_Output;
 command:=cmd;
 IO.buf_ptr:=@command;
 IO.buf_size:=sizeof(command);
 AskIOCTL(IOCTL_Output,@IO);
end; {OpenClose}

{----------------------------------------------------------}

destructor TCD.Done;
begin
end; {Done}

{==========================================================}

VAR L: CHAR;

BEGIN
 L:=LettreCDRom;

 if L<>#0 then begin
  CD.SetDrive(BYTE(L)-BYTE('A')); {active le premier lecteur CD trouv}
  CD.Init;
 end
 else CD.SetDrive(0);
END.
