{************************************************************************}
{                                CH669.PAS                               }
{                                                                        }
{  Loader pour les fichiers 669 (par TRAN de Renaissance) et E669.       }
{                                                                        }
{  AUTEUR: Freddy Vtel.                                                }
{                                                                        }
{                               Dbut d'criture le --/11/94             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}

{$UNDEF Groupe}

{$IFNDEF Groupe}
UNIT Ch669;
{$ELSE}
UNIT Ch669_G;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$IFNDEF Groupe}
USES Fichiers,Util,Memoire,Chutil,ModmVar,GusUnit,CRT;
{$ELSE}
USES Fich_grp,Util,Memoire,Chutil_G,ModmVar,GusUnit,CRT;
{$ENDIF}

{==========================================================}

procedure Charge_669(chemin: String80; var erreur: WORD);

{==========================================================}

IMPLEMENTATION

CONST
     Max_Samples_669=64;
     Ident669=$6669;    { 'if' }
     IdentUni669=$4E4A; { 'jn' }
TYPE
     TSizes=array[1..128] of BYTE;

     T669Header=
       record
         Ident    : WORD;
         Comment  : array[1..3, 1..36] of CHAR;
         NSamples : BYTE;
         NPatterns: BYTE;
         RepStart : BYTE;
         Sequence : Byte128;
         Tempos   : array[1..128] of BYTE;
         Lengths  : TSizes;
       end;

     T669Instrument=
       record
        Name    : array[1..13] of CHAR;
        Size    : LONGINT;
        RepStart: LONGINT;
        Replen  : LONGINT;
       end;

     T669Pattern=array[1..64,1..8] of
      record
       case BYTE of
        0: ( w1: WORD;
              b: BYTE );
        1: ( b1,b2,b3:BYTE);
       end;

     Ptr_En_tete_669=^T669Header;

{---------------------------------------------------------}

procedure Charger_pattern(VAR Sizes:TSizes;Num:WORD);

VAR
  Patt: T669Pattern;
  Pattern: Ptr_Patt;
  i,j  :WORD;
  t,n  :WORD;

begin
 for n:=1 to Num do begin
  if not ReserveUMBDOS(Segment_actuel,sizeof(T_Note)*4*8) then exit;

  Pointeur_Actuel:=Ptr(Segment_Actuel,0);
  MUS.T^.Pattern[n]:=Segment_Actuel;
  MUS.T^.Taille_Pattern[n]:=Sizes[n]+1;

  Pattern:=Pointeur_actuel;
  f_module.Lit(Patt,sizeof(Patt));
  for j:=1 to 8 do begin
    for i:=1 to 64 do with Patt[i][j] do begin
         C_Note.Instrument:=0;
         C_Note.Note:=0;
         C_Note.Volume:=255;
         C_Note.Commande:=0;
         C_Note.Parametre:=0;
         if b1<$FE then begin
            C_Note.Note:=(b1 shr 2)+2*12+1;
            C_Note.Instrument:= ((SWAP(w1) shr 4) and 63)+1;
         end;
         if b1<$FF then
            C_Note.Volume:=((b2 and 15) shl 2)+((b2 and 15) shr 2);
         C_Note.Parametre:=b3 and 15;
         C_Note.Commande:=Rien;
         if C_Note.Parametre<>0 then
            case b3 shr 4 of
              0: C_Note.Commande:=PortUp;
              1: C_Note.Commande:=PortDown;
              2: C_Note.Commande:=TonePortamento;
              3: C_Note.Commande:=FreqAdj;           { !!!!!!!!!! }
              4: begin
                  C_Note.Commande:=Vibrato;
                  C_Note.Parametre:=(C_Note.Parametre shl 4)+1;
                 end;
              5: C_Note.Commande:=SetTempo;
            end;
        if C_Note.Commande=Rien then C_Note.Parametre:=0;

        if C_Note.Instrument <>0 then SamplFlags[C_Note.Instrument]:=TRUE;
        Pattern^[j+8*(i-1)]:=C_Note;
    end;
  end;
 end;
end; {Charger_pattern}

{---------------------------------------------------------}

procedure Charger_Donnees_Samples(Num:BYTE);
VAR Instr669:T669Instrument;

begin
{ Rserve l'espace DOS pour la dfinition de samples }
 if not Allouer_Samples(Num) then exit;

 for NSmp:=1 to Num do begin
  f_module.Lit(Instr669,sizeof(Instr669));
  Nouveau_Sample;

  MOVE(Instr669.Name[1],Smp.Nom,13);
  Smp.len:=Instr669.Size;
  Smp.rep_len:=Instr669.RepLen;
  Smp.rep:=Instr669.RepStart;

  Move(Smp,MUS.T^.PtrSamples[NSmp]^,sizeof(Smp)); {Sauvegarde du Sample}
 end;
end; { Charger_Donnees_Samples }

{---------------------------------------------------------}

procedure Charger_Samples669(Num:BYTE);
var i,j: INTEGER;

begin
 Init_Charge_Sample;
 Convertir_signe:=TRUE;

 if Num>Max_Samples then Num:=Max_Samples;

 for NSmp:=1 to Num do begin
   Move(MUS.T^.PtrSamples[NSmp]^,Smp,sizeof(Smp)); { Charger le sample }
   with MUS.T^ do if Smp.len>0 then begin
      inc(Nb_instruments);
      if Smp.rep_len=65535 then Smp.rep_len:=0; { Ajustement des donnes }
      if Smp.rep_len>Smp.len then Smp.rep_len:=0;
      if Smp.rep_len+Smp.rep>Smp.len then Smp.rep:=Smp.len-Smp.rep_len;
      Smp_rep_fin:=Smp.rep+Smp.rep_len;

      Charger_Sample;
   end;  { Smp_len>0 }
   Move(Smp,MUS.T^.PtrSamples[NSmp]^,sizeof(Smp)); { Copier le sample... }
 end;    { for       }

 Fin_Charge_Sample;

end; { Charger_Samples669 }

{---------------------------------------------------------}

procedure Charge_669(chemin: String80; var erreur: WORD);

var FICH669: Ptr_En_tete_669;
    nom_fich: String12;
    Long669: BYTE;
    i:INTEGER;

begin  {Charge_669}
 erreur:=Ok;
 f_module.Ouvre(lecture,chemin);

 if f_erreur=f_ok then begin
  MUS_Efface;
  nom_fich:=NomFichierSeul(chemin);

  New(FICH669);

  f_module.LitPos(0,FICH669^,sizeof(FICH669^));

  MUS.H^.Type_Module:=T_669;                     { type de module  }
  MUS.H^.Octave_Min:=2;                          { Octaves...      }
  MUS.H^.Octave_Max:=6;
  Move(FICH669^.Comment[1,1],MUS.H^.Titre,32);   { Titre du module }

  { Titre du module }

  for i:=1 to 128 do
    if FICH669^.Sequence[i]<128 then MUS.H^.Sequence_Len:=i;

  if FICH669^.Ident<>IdentUni669 then
    Move(FICH669^.Tempos,MUS.T^.Tempo_Pattern,128);  { Placer les tempos }

  Move(FICH669^.Sequence,MUS.T^.Sequence,128);     { Copie de la squence }
  MUS.H^.Pos_de_restart:=FICH669^.Repstart+1;
  MUS.H^.Tempo_depart:=4;
  MUS.H^.Nb_de_voies:=8;
  MUS.H^.Nb_de_voies_Patt:=8;
  MUS.H^.BPM_depart:=80;        { Base 32 de seconde => 125*32/50=80 }

  Erreur_de_chargement:=Ok;

  if FICH669^.NSamples=0 then
     Erreur_de_chargement:=Err_Pas_Sample;

  if FICH669^.NSamples>Max_Samples_669 then
     Erreur_de_chargement:=Err_Format;

  if Erreur_de_chargement=Ok then
     Charger_Donnees_Samples(FICH669^.NSamples);

  if Erreur_de_chargement=Ok then
     Charger_Pattern(FICH669^.Lengths,FICH669^.NPatterns);

  if Erreur_de_chargement=Ok then
     Charger_Samples669(FICH669^.NSamples);

  Fixer_Panning(TRUE);
  FillChar(MUS.T^.Type_Voie,MUS.H^.Nb_de_voies,1); { Voies numriques... }
  Compter_Voies;

  Dispose(FICH669);

  Verifier_Module(Erreur_de_chargement);
  Erreur:=Erreur_de_chargement;
  f_module.Ferme
 end
 else Erreur:=Err_lecture;  {Impossible d'ouvrir le fichier}

 if Erreur in [Ok,Err_samples] then MUS.Chargee:=TRUE else MUS_Efface;
end; {Charge_669}

END.
