{************************************************************************}
{                                CHFAR.PAS                               }
{                                                                        }
{  Loader pour les fichiers FAR (par Daniel Potter (Farandole Tracker))  }
{                                                                        }
{  AUTEUR: Freddy Vtel.                                                }
{                                                                        }
{                               Dbut d'criture le 25/08/95             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}

{$UNDEF Groupe}

{$IFNDEF Groupe}
UNIT ChFAR;
{$ELSE}
UNIT ChFAR_G;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$IFNDEF Groupe}
USES Fichiers,Util,Memoire,Chutil,ModmVar,GusUnit,CRT;
{$ELSE}
USES Fich_grp,Util,Memoire,Chutil_G,ModmVar,GusUnit,CRT;
{$ENDIF}

{==========================================================}

procedure Charge_FAR(chemin: String80; var erreur: WORD);

{==========================================================}

IMPLEMENTATION


TYPE TFARHeader=record
                 Ident     : array[1..4]  of CHAR;   {  'far'  }
                 Titre     : array[1..40] of CHAR;
                 Ident1    : array[1..3]  of BYTE;   { 13,10,26 }
                 HdrLen    : WORD;
                 Version   : BYTE;
                 ChannMap  : array[1..16] of BYTE;
                 CurrOct   : BYTE;   {Current editing octave             }
                 CurrVoi   : BYTE;   {Current editing voice              }
                 CurrRow   : BYTE;   {Current editing row                }
                 CurrPatt  : BYTE;   {Current editing pattern            }
                 CurrOrd   : BYTE;   {Current editing order              }
                 CurrSamp  : BYTE;   {Current editing sample             }
                 CurrVol   : BYTE;   {Current editing volume             }
                 CurrTOS   : BYTE;   {Current Top Off Screen display     }
                 CurrEAS   : BYTE;   {Current editing area on the screen }
                 CurrTempo : BYTE;   {Current tempo (default tempo)      }
                 PannMap   : array[1..16] of BYTE;
                 MarkTop   : BYTE;
                 MarkBot   : BYTE;
                 Gridgr    : BYTE;   { Grid granularity                  }
                 EditMode  : BYTE;
                 TextLen   : WORD;
                end;

     T_Smp_FAR =record
                 Nom :array[1..32] of CHAR;
                 Len :LONGINT;
                 Fine: BYTE;
                 Vol : BYTE;
                 Rep : LONGINT;
                 Rep_Fin : LONGINT;
                 SType   : BYTE;
                 SLMode  : BYTE;
                end;

     T_Note_FAR=record
                 b1,b2,b3,b4: BYTE
                end;

     T_Pattern_FAR=array[1..512] of T_Note_FAR;
     Ptr_patt_FAR=^T_Pattern_FAR;

     TPattSize=array[1..256] of WORD;

VAR PattSize:^TPattSize;

{---------------------------------------------------------}

procedure Charge_Pattern;
var Nb_Colonnes:INTEGER;
    Tempo : BYTE;
    i,j   : INTEGER;
    Pattern_FAR : Ptr_patt_FAR;
    Pattern: Ptr_Patt;

begin
 GetMem(Pattern_FAR,256*4*16);   { Tampon pour le chargement de la partition }

 for i:=1 to 256 do
  if PattSize^[i]<>0 then begin
   Nb_Colonnes:=0;
   f_module.Lit(Nb_Colonnes,1);
   f_module.Lit(Tempo,1);

   Nb_Colonnes:=(PattSize^[i]-2) div (16*4);
   MUS.T^.Taille_Pattern[i]:=Nb_Colonnes;
   if not ReserveUMBDOS(Segment_Actuel,sizeof(T_Note)*Nb_Colonnes) then begin
     FreeMem(Pattern_FAR,256*4*16);
     exit;
   end;

   Pointeur_Actuel:=Ptr(Segment_Actuel,0);
   Pattern:=Pointeur_actuel;
   MUS.T^.Pattern[i]:=Segment_Actuel;
   f_module.Lit(Pattern_FAR^,(PattSize^[i]-2));

   for j:=1 to Nb_Colonnes*16 do
    with Pattern_FAR^[j] do begin
      C_Note.Commande:=(b4 shr 4);
      C_Note.Parametre:=b4 and $0F;
      case C_Note.Commande of
       $0F :C_Note.Commande:=SetTempo;
       $07 :begin
             C_Note.Commande:=VolSlide;
             C_Note.Parametre:=C_Note.Parametre shl 4;
            end;
       $08 :C_Note.Commande:=VolSlide;
       $0B :begin
             C_Note.Commande:=CPanning;
             C_Note.Parametre:=Panning_GUS_SB(C_Note.Parametre);
            end;
       else begin
             C_Note.Commande :=0;
             C_Note.Parametre:=0;
            end;
      end;

      if b1>0 then begin
        C_Note.Instrument:=b2+1;
        C_Note.Note:=b1+12*3
      end
      else begin
        C_Note.Instrument:=0;
        C_Note.Note:=0;
      end;

      if (b3 and $0F)=0 then C_Note.Volume:=255
                        else C_Note.Volume:=((b3 and $0F)-1) shl 2;

      if C_Note.Instrument <>0 then SamplFlags[C_Note.Instrument]:=TRUE;
      Pattern^[j]:=C_Note;    { Ecrire la note dans la partition }
    end
  end;

 FreeMem(Pattern_FAR,256*4*16);
end; {Charge_Pattern}

{---------------------------------------------------------}

procedure Charge_Samples_FAR;
var Smp_FAR : T_Smp_FAR;
    SFlag   : array[0..7] of BYTE;
    i       : INTEGER;
    Nb_Smp_FAR : BYTE;
begin
 Init_Charge_Sample;

 f_module.Lit(SFlag,8);
 for i:=0 to 63 do if ((SFlag[i div 8]) and (1 shl (i mod 8)))>0 then
   Nb_Smp_FAR:=i+1;

 if not Allouer_Samples(Nb_Smp_FAR) then begin
   Fin_Charge_Sample;
   exit;
 end;

 for NSmp:=1 to Nb_Smp_FAR do begin
   Nouveau_Sample;
   if ((SFlag[(NSmp-1) div 8]) and (1 shl ((NSmp-1) mod 8))) >0 then begin
     f_module.Lit(Smp_FAR,sizeof(Smp_FAR));
     Move(Smp_FAR.Nom,Smp.Nom,32); {Nom du sample }
     Smp.Len:=Smp_FAR.Len;
     if Smp_FAR.SLMode>0 then Smp.Info:=Smp.Info or M_Boucle; { Sample avec bouclage... }
     if (Smp.Len>0) then begin
       inc(Nb_instruments);
       if ((Smp.Info and M_Boucle)=0) then begin { Pas de bouclage }
         Smp.Rep:=0;
         Smp_Rep_Fin:=0;
       end
       else begin { Bouclage        }
         Smp.Rep:=Smp_FAR.Rep;
         Smp_Rep_Fin:=Smp_FAR.Rep_Fin;
       end;
       Smp.Rep_Len:=0;
       Smp.Volume:=64;
       Smp.C4Spd:=8363;

       Charger_Sample;
     end;
   end;
   Move(Smp,MUS.T^.PtrSamples[NSmp]^,sizeof(Smp)); { Copier le sample... }
 end;

 Fin_Charge_Sample;
end; { Charge_Samples_FAR }


procedure Charge_FAR(chemin: String80; var erreur: WORD);
var FichFAR  : TFARHeader;
    nom_fich : String12;
    Nb_Patt  : BYTE;
    i:INTEGER;

begin  {Charge_FAR}
 f_module.Ouvre(lecture,chemin);

 if f_erreur=f_ok then begin
  MUS_Efface;
  nom_fich:=NomFichierSeul(chemin);

  f_module.LitPos(0,FICHFAR,sizeof(FICHFAR));

  MUS.H^.Type_Module:=T_FAR;
  Move(FICHFAR.Titre,MUS.H^.Titre,32);        { Titre du module }
  MUS.H^.Tempo_depart:=4;
  MUS.H^.Nb_de_voies:=16;
  MUS.H^.Nb_de_voies_Patt:=16;
  MUS.H^.BPM_depart:=80;        { Base 32 de seconde => 125*32/50=80 }

  f_module.DeplacePointeur(FICHFAR.TextLen);
  f_module.Lit(MUS.T^.Sequence,256);
  f_module.Lit(Nb_Patt,1);
  f_module.Lit(MUS.H^.Sequence_Len,1);
  f_module.Lit(MUS.H^.Pos_de_restart,1);
  New(PattSize);
  f_module.Lit(PattSize^,256*2);

  if (FICHFAR.HdrLen-(869+FICHFAR.TextLen))>0  { en tte plus grand ? }
     then f_module.DeplacePointeur(869+FICHFAR.TextLen);
  for i:=1 to 256 do
      if (PattSize^[i]<67) and (PattSize^[i]>0) then  { 0 lignes }
         Erreur_de_chargement:=Err_format;

  if Erreur_de_chargement=Ok then Charge_Pattern;

  Dispose(PattSize);

  if Erreur_de_chargement=Ok then Charge_Samples_FAR;

{ Musique^.Octave_Min:=3;
  Musique^.Octave_Max:=5;}

  MUS.H^.Octave_Min:=0;
  MUS.H^.Octave_Max:=7;

  Fixer_Panning(TRUE);
  FillChar(MUS.T^.Type_Voie,MUS.H^.Nb_de_voies,1); { Voies numriques... }
  Compter_Voies;

  Verifier_Module(Erreur_de_chargement);
  Erreur:=Erreur_de_chargement;
  f_module.Ferme
  end
 else Erreur:=Err_lecture;  {Impossible d'ouvrir le fichier}

 if Erreur in [Ok,Err_samples] then MUS.Chargee:=TRUE else MUS_Efface;
end; {Charge_FAR}

END.
