{************************************************************************}
{                                CHMOD.PAS                               }
{                                                                        }
{  Loader pour les fichiers mod (ProTracker - Amiga  4->32 voies :))     }
{                                                                        }
{  AUTEUR: Freddy Vtel.                                                }
{                                                                        }
{                                                                        }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}

{$UNDEF Groupe}

{$IFNDEF Groupe}
UNIT ChMOD;
{$ELSE}
UNIT ChMOD_G;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$IFNDEF Groupe}
USES Fichiers,Util,Memoire,Chutil,ModmVar;
{$ELSE}
USES Fich_grp,Util,Memoire,Chutil_G,ModmVar;
{$ENDIF}

procedure Charge_MOD(chemin: String80; var erreur: WORD);

IMPLEMENTATION

TYPE Char4=array[1..4] of CHAR;

CONST inconnu=0; { identificateurs / tracker /      voies / type mod    }
                 { ---------------------------------------------------- }
                 { 'M.K.' NoiseTracker 4   T_MOD_NT    }
                 { 'M!K!' ProTracker/SoundTracker 4   T_MOD_PTST  }
                 { 'M&K&' ProTracker/SoundTracker 4   T_MOD_PTST  }
                 { '6CHN' FastTracker 1.x 6   T_MOD_FT1   }
                 { '8CHN' FastTracker 1.x 8   T_MOD_FT1   }
                 { '16CH' TakeTracker/FT 2.x16   T_MOD_TTFT2 }
                 { '32CH' TakeTracker/FT 2.x32   T_MOD_TTFT2 }
                 { 'RASP' Startrekker 4   T_MOD_ST    }
                 { 'FLT4' Startrekker 4   T_MOD_ST    }
                 { 'FLT8' Startrekker 8   T_MOD_ST    }
                 { 'OCTA' Octalyzer 8   T_MOD_OZ    }
                 { 'OKTA' Octalyser 8   T_MOD_OS    }
                 { 'CD81' Octalyser (Atari STe/Falcon) 8   T_MOD_OSAF  }
                 { 'FA04' Digital Tracker F030 4   T_MOD_DT    }
                 { 'FA08' Digital Tracker F030 8   T_MOD_DT    }
                 { 'TDZn' ?? n   T_MOD_INC   }
                 { autres  auto   T_MOD_INC   }

      nbr_ident=18;
      IdentMOD: array[1..nbr_ident] of
                 record
                  nom  : Char4;
                  voies: BYTE;
                  type_: BYTE;
                 end

                =((nom:'M.K.'; voies: 4; type_: T_MOD_NT   ),
                  (nom:'M!K!'; voies: 4; type_: T_MOD_PTST ),
                  (nom:'M&K&'; voies: 4; type_: T_MOD_PTST ),
                  (nom:'6CHN'; voies: 6; type_: T_MOD_FT1  ),
                  (nom:'8CHN'; voies: 8; type_: T_MOD_FT1  ),
                  (nom:'16CH'; voies:16; type_: T_MOD_TTFT2),
                  (nom:'32CH'; voies:32; type_: T_MOD_TTFT2),
                  (nom:'RASP'; voies: 4; type_: T_MOD_ST   ),
                  (nom:'FLT4'; voies: 4; type_: T_MOD_ST   ),
                  (nom:'FLT8'; voies: 8; type_: T_MOD_ST   ),
                  (nom:'OCTA'; voies: 8; type_: T_MOD_OZ   ),
                  (nom:'OKTA'; voies: 8; type_: T_MOD_OS   ),
                  (nom:'CD81'; voies: 8; type_: T_MOD_OSAF ),
                  (nom:'FA04'; voies: 4; type_: T_MOD_DT   ),
                  (nom:'FA08'; voies: 8; type_: T_MOD_DT   ),
                  (nom:'TDZ4'; voies: 4; type_: T_MOD_INC  ),
                  (nom:'TDZ6'; voies: 6; type_: T_MOD_INC  ),
                  (nom:'TDZ8'; voies: 8; type_: T_MOD_INC  ));

      T_MOD31=0; {31 istruments}
      T_MOD15=1; {15 istruments}


TYPE T_Instrument=record
                   Nom     : Char22;
                   Long    : WORD;
                   Finetune,
                   Vol     : BYTE;
                   Debut_b,
                   Long_b  : WORD;
                  end;

     T_En_tete_15=record
                   Nom      : Char20;
                   Samples  : array[1..15] of T_Instrument;
                   Long     : BYTE;
                   Boucle   : BYTE;
                   Sequence : Byte128;
                  end;

     T_En_tete_31=record
                   Nom      : Char20;
                   Samples  : array[1..31] of T_Instrument;
                   Long     : BYTE;
                   Boucle   : BYTE;
                   Sequence : Byte128;
                   Ident    : Char4;
                  end;

     Ptr_En_tete_15=^T_En_tete_15;
     Ptr_En_tete_31=^T_En_tete_31;

     T_Note_MOD=record case BYTE of
                 1: (l          : LONGINT);
                 2: (w1,W2      : WORD);
                 3: (b1,b2,b3,b4: BYTE);
                end;

     T_Pattern_MOD=array[1..512] of T_Note_MOD;
     Ptr_patt_MOD=^T_Pattern_MOD;

VAR  Nb_de_voies: BYTE;
     Type_MOD: BYTE;     {0:31 Instr; 1:15 Instr }
     Type_MOD_etendu: BYTE;

{---------------------------------------------------------}

procedure Convertir_pattern(Pattern_MOD: Ptr_Patt_MOD; Pattern: Ptr_Patt);
var j: INTEGER;

begin
 C_Note.Volume:=255;

 for j:=1 to 64*Nb_de_voies do
  with Pattern_MOD^[j] do begin
    C_Note.Commande:=(b3 and $F)+1;
    C_Note.Parametre:=b4;
    if C_Note.Commande=$E+1 then begin {Commande tendue}
      C_Note.Commande:=$11+(b4 shr 4);
      C_Note.Parametre:=(b4 and $F);
    end
    else
    if (C_Note.Commande=CPanning) then begin
     if C_Note.Parametre>$80 then begin
       C_Note.Commande:=Rien;
       C_Note.Parametre:=0;
     end;
    end;
    if (C_Note.Commande=Arpeggio) and (C_Note.Parametre=0) then C_Note.Commande:=Rien;
    if (C_Note.Commande in [VolSlide,PortUp,PortDown]) and (C_Note.Parametre=0) then begin
      C_Note.Commande:=Rien;
      C_Note.Parametre:=0;
    end;
    if (C_Note.Commande=SetTempo) then begin
     if (C_Note.Parametre>$1F) and (Variables^.Utiliser_BPM) then C_Note.Commande:=SetBPM;
     if (C_Note.Parametre=0  ) then C_Note.Commande:=Rien;
    end;
    C_Note.Note:=Periode2Note(b2+(WORD(b1 and $F) shl 8));
    C_Note.Instrument:=(b3 shr 4)+(b1 and 16);
    if C_Note.Instrument <>0 then SamplFlags[C_Note.Instrument]:=TRUE;
    Pattern^[j]:=C_Note;    { Ecrire la note dans la partition }
   end;
end; {Convertir_pattern}

{---------------------------------------------------------}

procedure Charge_MOD31(MOD31: Ptr_En_Tete_31; Tot_sample: BYTE);
var Nb_pattern: BYTE;
    i: INTEGER;
    Pattern_MOD: Ptr_Patt_MOD;

begin
 Erreur_de_chargement:=Err_format;

 for i:=1 to 128 do if MOD31^.sequence[i]>128 then exit; { Erreur de format }

 MUS.H^.Sequence_Len:=MOD31^.Long;
 Nb_pattern:=0;

 for i:=1 to 128 do
  if Nb_pattern<MOD31^.Sequence[i] then Nb_pattern:=MOD31^.Sequence[i];

 inc(Nb_pattern);

 Move(MOD31^.Sequence,MUS.T^.Sequence,128);

 with MUS.H^ do
  if (Pos_de_restart>Sequence_Len ) or
     (Pos_de_restart=0) then Pos_de_restart:=1;

 Erreur_de_chargement:=Err_memoire;    { Si exit, Erreur de mmoire }

{***          Charge les patterns          ***}

 GetMem(Pattern_MOD,64*4*Nb_de_voies);

 for i:=1 to Nb_pattern do begin
  if not ReserveUMBDOS(Segment_actuel,sizeof(T_Note)*4*Nb_de_voies) then begin
    FreeMem(Pattern_MOD,64*4*Nb_de_voies);
    exit;
  end;

  Pointeur_Actuel:=Ptr(Segment_Actuel,0);
  MUS.T^.Pattern[i]:=Segment_Actuel;
  f_module.Lit(Pattern_MOD^,256*Nb_de_voies);
  Convertir_pattern(Pattern_MOD,Pointeur_actuel);
 end;

 FreeMem(Pattern_MOD,64*4*Nb_de_voies);

{***         Charge les instruments         ***}

 Erreur_de_Chargement:=Ok;
 Init_Charge_Sample;

 { Rserve l'espace DOS pour la dfinition de samples }
 if not Allouer_Samples(Tot_Sample) then begin
   Fin_Charge_Sample;
   exit;
 end;

 for NSmp:=1 to Tot_sample do begin
   Nouveau_Sample;
   Move(MOD31^.Samples[NSmp].Nom[1],Smp.Nom,22); {Nom du sample }
   Smp.len:=WORD(SWAP(MOD31^.Samples[NSmp].long)) shl 1;

   with MUS.T^ do
    if Smp.len>3 then begin
      inc(Nb_instruments);

      Smp.rep:=WORD(SWAP(MOD31^.Samples[NSmp].Debut_b)) shl 1;
      Smp.rep_len:=WORD(SWAP(MOD31^.Samples[NSmp].Long_b)) shl 1;
      Smp_rep_fin:=Smp.rep+Smp.rep_len;
      Smp.Volume:=MOD31^.Samples[NSmp].vol;
      if MOD31^.Samples[NSmp].FineTune>15 then Smp.C4Spd:=8363
      else Smp.C4Spd:=FineTuneConv[MOD31^.Samples[NSmp].FineTune];

      Charger_Sample;
    end  { Smp.len>4 }
    else if Smp.len>0 then f_module.DeplacePointeur(Smp.len);

    Move(Smp,MUS.T^.PtrSamples[NSmp]^,sizeof(Smp)); { Copier le sample... }
 end;

 Fin_Charge_Sample;
end; {Charge_MOD31}

{---------------------------------------------------------}

procedure Charge_MOD15(MOD31: Ptr_En_Tete_31);
var MOD15: Ptr_En_tete_15;
    i: BYTE;
begin
 New(MOD15);
 f_module.LitPos(0,MOD15^,sizeof(MOD15^));
 MOD31^.Long:=MOD15^.long;
 MOD31^.Boucle:=MOD15^.Boucle;
 for i:=1 to 15 do MOD31^.Samples[i]:=MOD15^.Samples[i];
 MOD31^.Sequence:=MOD15^.Sequence;
 Charge_MOD31(MOD31,15);
 Dispose(MOD15);
end; {Charge_MOD15}

{---------------------------------------------------------}

procedure Charge_MOD(chemin: String80; var erreur: WORD);

var MOD31: Ptr_En_tete_31;
    Pattern_MOD: Ptr_patt_MOD;
    nom_fich: String12;

function Ident(ModIdent: Char4): BYTE;
var i: BYTE;
begin
 for i:=1 to nbr_ident do
  if ModIdent=IdentMOD[i].nom then begin Ident:=i; exit end;
 Ident:=inconnu;
end;

procedure Chercher_Nb_de_Voies(ModIdent: Char4);
var NIdent: BYTE;
    i: BYTE;
begin
 Nb_de_voies:=0;
 NIdent:=Ident(ModIdent);

 if NIdent>0 then begin
   Type_MOD:=T_MOD31;
   Nb_de_Voies:=IdentMOD[NIdent].voies;
   Type_MOD_etendu:=IdentMOD[NIdent].type_;
 end
 else begin
   Type_MOD_etendu:=T_MOD_INC;

   { recherche un nombre dans l'identificateur }
   for i:=1 to 4 do
    if ModIdent[i] in ['0'..'9'] then
     Nb_de_voies:=10*Nb_de_voies+BYTE(ModIdent[i])-BYTE('0');

   if Nb_de_voies in [4..32] then Type_MOD:=T_MOD31 else Nb_de_voies:=0;

   if (Nb_de_voies>8) and (Pos('CH',ModIdent)>1) then Type_MOD_etendu:=T_MOD_TTFT2;
 end;

 if Nb_de_voies=0 then begin Type_MOD:=T_MOD15; Nb_de_voies:=4 end;
end;


begin  {Charge_MOD}
 erreur:=Ok;
 f_module.Ouvre(lecture,chemin);

 if f_erreur=f_ok then begin
   MUS_Efface;
   New(MOD31);

   f_module.LitPos(0,MOD31^,sizeof(MOD31^));

   MUS.H^.Type_Module:=T_MOD;
   Type_MOD_etendu:=T_MOD_INC;
   Move(MOD31^.Nom,MUS.H^.Titre,20);
   Nom_fich:=NomFichierSeul(chemin);

   MUS.H^.Pos_de_restart:=MOD31^.Boucle;

   if (ExtensionSeule(Nom_fich)='WOW') or
      (ExtensionSeule(Nom_fich)='OCT') then begin
     Type_MOD:=T_MOD31;
     Nb_de_Voies:=8;
   end
   else Chercher_Nb_de_Voies(MOD31^.Ident);

   MUS.H^.Type_Module_Etendu:=Type_MOD_etendu;

   if Erreur_de_chargement=Ok then
    if Type_MOD=T_MOD31 then begin
      MUS.H^.Nb_de_voies:=Nb_de_voies;
      Charge_MOD31(MOD31,31)
    end
    else begin
      MUS.H^.Nb_de_voies:=Nb_de_voies;
      Charge_MOD15(MOD31)
    end;

   if Nb_Octaves_MOD=5 then begin
     MUS.H^.Octave_Min:=2;
     MUS.H^.Octave_Max:=6;
   end
   else begin
     MUS.H^.Octave_Min:=3;
     MUS.H^.Octave_Max:=5;
   end;

   Fixer_Panning(TRUE);
   FillChar(MUS.T^.Type_Voie,MUS.H^.Nb_de_voies,1); { Voies numriques... }
   Compter_Voies;

   Dispose(MOD31);
   Erreur:=Erreur_de_chargement;
   f_module.Ferme
 end
 else Erreur:=Err_lecture;  {Impossible d'ouvrir le fichier}

 Verifier_Module(Erreur);
 if Erreur in [Ok,Err_samples] then MUS.Chargee:=TRUE else MUS_Efface;
end; {Charge_MOD}

END.
