{************************************************************************}
{                                CHMTM.PAS                               }
{                                                                        }
{  Loader pour les fichiers MTM (MultiTracker Module).                   }
{                                                                        }
{  AUTEUR: Freddy Vetele                                                 }
{                                                                        }
{                               Dbut d'criture le 14/02/94             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}

{$UNDEF Groupe}

{$IFNDEF Groupe}
UNIT ChMTM;
{$ELSE}
UNIT ChMTM_G;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$IFNDEF Groupe}
USES Fichiers,Util,Memoire,Chutil,ModmVar,CRT;
{$ELSE}
USES Fich_grp,Util,Memoire,Chutil_G,ModmVar,CRT;
{$ENDIF}

procedure Charge_MTM(chemin: String80; var erreur: WORD);

IMPLEMENTATION


TYPE
     Char3=array[1..3] of CHAR;

CONST
     Max_Samples_MTM=31;
     MTMMagic:Char3='MTM';

TYPE
     T_En_tete_MTM=record
                    IdentMTM : Char3;     { MTM }
                    Version  : BYTE;
                    Nom      : Char20;
                    Nb_Track : WORD;
                    DernierPattern : BYTE;
                    TailleMusique  : BYTE;
                    LongExtra      : WORD;
                    NbSamples: BYTE;
                    Attibut  : BYTE;
                    Tempo    : BYTE;
                    Nb_Voies : BYTE;
                    Table_Pan: array[1..32] of BYTE;
                   end;

     T_Sample=array[1..Max_Samples_MTM] of record
               Nom     : array[1..22] of CHAR;
               Long    : LONGINT;
               Rep     : LONGINT;
               Rep_Fin : LONGINT;
               Fine   : BYTE;
               Volume : BYTE;
               Attrib : BYTE;
              end;

     T_Track_Seq=array[1..4096] of WORD;

     Ptr_En_tete_MTM=^T_En_tete_MTM;
     Ptr_Sample=^T_Sample;

     T_Note_MTM=record
                  b1,b2,b3: BYTE
                end;
     T_Track_MTM=array[1..64] of T_Note_MTM;

var FlagPattern:array[0..127] of BOOLEAN;
    Dernier_Pattern:BYTE;

{---------------------------------------------------------}

procedure Charger_Pattern_MTM(var MTM:Ptr_En_tete_MTM;Nb_de_voies:BYTE);

var Track_Seq:^T_Track_Seq;
    Taille_Seq:WORD;
    Track:WORD;                     { Index des tracks }
    Track_MTM:^T_Track_MTM;
    Track_Traduit:BOOLEAN;          { Pour viter retraduire un track     }
    N_Pattern_Traduit,N_Voie_Traduite:BYTE;
    Row:BYTE;                       { Ligne dans la partition        }
    N_Pattern,N_Voie:BYTE;          { Pattern et voies o copier le track }
    Pattern : Ptr_Patt;
    Index_Pattern:WORD;
    Debut_Track:LONGINT;    { Position de dbut des tracks !!! }
    i,j:INTEGER;

begin
 New(Track_Seq);

 { Lire le squencement des "Tracks" }
 Taille_Seq:=(Dernier_Pattern+1)*32;
 f_module.LitPos(194+37*MTM^.NbSamples+192*LONGINT(MTM^.Nb_Track),
                 Track_Seq^,Taille_Seq*2);

 { Allouer tous les Patterns         }
 for i:=0 to MTM^.DernierPattern do
  if FlagPattern[i] then begin
   if not ReserveUMBDOS(Segment_actuel,sizeof(T_Note)*4*Nb_de_voies) then begin
     Dispose(Track_Seq);
     Erreur_de_chargement:=Err_Memoire;
     exit;
   end;
   Pointeur_Actuel:=Ptr(Segment_Actuel,0);
   Fillchar(Pointeur_actuel^,64*sizeof(T_Note)*Nb_de_voies,0);
   MUS.T^.Pattern[i+1]:=Segment_Actuel;
   Pattern:=Pointeur_actuel;
  end;

 { Lecture des Tracks et conversion de la partition }
 f_module.PlacePointeur(194+37*MTM^.NbSamples);{ Place le pointeur de fichier }
                                               { au dbut des tracks          }
 C_Note.Volume:=255;
 New(Track_MTM);
 for Track:=1 to MTM^.Nb_Track do begin
   Track_Traduit:=FALSE;
   f_module.Lit(Track_MTM^,192); { Lire le "track" N Track !!}
   for i:=1 to Taille_Seq do
    if Track_Seq^[i]=Track then begin
      N_Pattern:=i div 32;
      N_Voie:=i mod 32;
      if N_Voie=0 then begin
        N_Voie:=32;
        dec(N_Pattern);
      end;

{      Writeln('Track: ',Track);
      Writeln('Position: ',i);
      Write('Pattern N',N_Pattern);
      Writeln('Voie N',N_Voie);
      repeat until Readkey=#13;}

      if (FlagPattern[N_Pattern] and (N_Voie<=Nb_de_voies)) then begin
        Pattern:=Ptr(MUS.T^.Pattern[N_Pattern+1],0);
        Index_Pattern:=N_Voie;
        for Row:=0 to 63 do
         with Track_MTM^[Row+1] do begin
          C_Note.Note:=0;
          if B1 shr 2 <> 0 then C_Note.Note:=(b1 shr 2)+2*12+1;
          C_Note.Instrument:=((b1 and 3) shl 4)+b2 shr 4;
          C_Note.Commande:=(b2 and $F)+1;
          C_Note.Parametre:=b3;
          if C_Note.Commande=$E+1 then begin {Commande tendue}
            C_Note.Commande:=$11+(b3 shr 4);
            C_Note.Parametre:=(b3 and $F)
          end;

          if (C_Note.Commande=Rien2) then begin
            C_Note.Commande:=CPanning;
            C_Note.Parametre:=Panning_GUS_SB(C_Note.Parametre);
          end;

          if (C_Note.Commande=Arpeggio) and (C_Note.Parametre=0) then C_Note.Commande:=Rien;
          if (C_Note.Commande in [VolSlide,PortUp,PortDown]) and (C_Note.Parametre=0) then begin
            C_Note.Commande:=Rien;
            C_Note.Parametre:=0
          end;
          if (C_Note.Commande=SetTempo) then begin
           if (C_Note.Parametre>$1F) then C_Note.Commande:=SetBPM;
           if (C_Note.Parametre=0  ) then C_Note.Commande:=Rien;
          end;

          if C_Note.Instrument <>0 then SamplFlags[C_Note.Instrument]:=TRUE;
          Pattern^[Index_Pattern]:=C_Note;
          inc(Index_Pattern,Nb_de_voies);
         end;
      end;
    end;
 end;

 Dispose(Track_MTM);
 Dispose(Track_Seq);
end;  { Charger_Pattern_MTM }

{---------------------------------------------------------}

procedure Charger_Samples(var MTM:Ptr_en_tete_MTM;var Table_Sample:Ptr_Sample);

begin
 Init_Charge_Sample;

 { Rserve l'espace DOS pour la dfinition de samples }
 if not Allouer_Samples(MTM^.NbSamples) then begin
   Fin_Charge_Sample;
   exit;
  end;

 Convertir_signe:=TRUE;

 f_module.PlacePointeur(194+37*MTM^.NbSamples+192*LONGINT(MTM^.Nb_Track)+
                        (Dernier_Pattern+1)*32*2+MTM^.LongExtra);

 for NSmp:=1 to MTM^.NbSamples do begin
   Nouveau_Sample;
   Move(Table_Sample^[NSmp].Nom,Smp.Nom,22);
   Smp.len:=Table_Sample^[NSmp].long;
   with MUS.T^ do
    if (Smp.len>4) and (Table_Sample^[NSmp].Attrib=0) then begin
      inc(Nb_instruments);

      Smp.rep:=Table_Sample^[NSmp].Rep;
      Smp_rep_fin:=Table_Sample^[NSmp].Rep_fin;
      Smp.Volume:=Table_Sample^[NSmp].Volume;
      if Table_Sample^[NSmp].Fine>15 then Smp.C4Spd:=8363
      else Smp.C4Spd:=FineTuneConv[Table_Sample^[NSmp].Fine];

      Charger_Sample;
    end  { Smp.len>4 }
    else if Smp.len>0 then f_module.DeplacePointeur(Smp.len);
    Move(Smp,MUS.T^.PtrSamples[NSmp]^,sizeof(Smp)); { Copier le sample... }
 end;    { for       }

 Fin_Charge_Sample;
end; { Charger_Samples }

{---------------------------------------------------------}

procedure Charge_MTM(chemin: String80; var erreur: WORD);

label Fin_Charge_MTM;

var MTM : Ptr_En_tete_MTM;
    Table_Sample : Ptr_Sample;
    Nb_de_voies  : BYTE;
    nom_fich     : String12;
    i : INTEGER;
begin
 erreur:=Ok;
 f_module.Ouvre(lecture,chemin);

 if f_erreur=f_ok then begin
  MUS_Efface;
  Nom_fich:=NomFichierSeul(chemin);         { Nom du fichier  }

  New(MTM);
  New(Table_Sample);

  f_module.LitPos(0,MTM^,sizeof(MTM^));

  with MUS.H^ do begin
   Type_Module:=T_MTM;              { type de module  }
   Octave_Min:=2;
   Octave_Max:=6;
   Move(MTM^.Nom,Titre,20);                 { Titre du module }
   Sequence_Len:=MTM^.TailleMusique+1;
   Pos_de_restart:=0;
   Tempo_depart:=6;                         {MTM^.Tempo;}
  end;

  FillChar(FlagPattern,128,0);      {Efface le tableau de flag des patterns}
  Nb_de_voies:=MTM^.Nb_voies;
  MUS.H^.Nb_de_voies:=Nb_de_voies;
  MUS.H^.Nb_de_voies_Patt:=Nb_de_voies;

  for i:=1 to MTM^.NbSamples do
    f_module.Lit(Table_Sample^[i],sizeof(Table_Sample^[1]));

  f_module.Lit(MUS.T^.Sequence,128);  { Lire la squence }

  { Lecture de la squence et dtection d'erreurs de format }

  Erreur_de_chargement:=Err_format;
  Dernier_Pattern:=0;
  if MTM^.IdentMTM<>MTMMagic then goto Fin_Charge_MTM; { Erreur dans le format }
  for i:=1 to MUS.H^.Sequence_Len do begin
    if MUS.T^.Sequence[i]>127 then goto Fin_Charge_MTM; { Erreur dans le format }
    if MUS.T^.Sequence[i]>Dernier_Pattern then Dernier_Pattern:=MUS.T^.Sequence[i];
    FlagPattern[MUS.T^.Sequence[i]]:=TRUE;
  end;
  if MTM^.NbSamples<=Max_Samples_MTM then Erreur_de_chargement:=Ok;

  if Erreur_de_Chargement=Ok then
     Charger_Pattern_MTM(MTM,Nb_de_voies); { Charge les patterns }
  if Erreur_de_Chargement=Ok then
     Charger_Samples(MTM,Table_Sample);    { Charge les samples  }

{  repeat until readkey=#13;}

  Fixer_Panning(TRUE);
  FillChar(MUS.T^.Type_Voie,MUS.H^.Nb_de_voies,1); { Voies numriques... }
  Compter_Voies;

  Dispose(Table_Sample);
  Dispose(MTM);
  Fin_Charge_MTM:        { label }

  Verifier_Module(Erreur_de_chargement);
  Erreur:=Erreur_de_chargement;
  f_module.Ferme;
 end
 else Erreur:=Err_lecture;  {Impossible d'ouvrir le fichier}

 if Erreur in [Ok,Err_samples] then MUS.Chargee:=TRUE else MUS_Efface;
end; {Charge_MTM}

END.
