{************************************************************************}
{                                CHOKT.PAS                               }
{                                                                        }
{  Loader pour les fichiers OKT ( Oktalyser - Amiga )                    }
{                                                                        }
{  AUTEUR: Freddy Vtel.                                                }
{                                                                        }
{                                                                        }
{                               Dbut d'criture le 18/07/95             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}

{$UNDEF Groupe}

{$IFNDEF Groupe}
UNIT ChOKT;
{$ELSE}
UNIT ChOKT_G;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$IFNDEF Groupe}
USES Fichiers,Util,Memoire,Chutil,ModmVAR,CRT;
{$ELSE}
USES Fich_grp,Util,Memoire,Chutil_G,ModmVAR,CRT;
{$ENDIF}

{==========================================================}

procedure Charge_OKT(chemin: String80; var erreur: WORD);

{==========================================================}

IMPLEMENTATION

TYPE
     Char4=array[1..4] of CHAR;

     T_Chunk=record
              Header :Char4;
              Taille :LONGINT;    { MOTOROLA !!! }
             end;

     T_Smp=record
            Nom     : Char20;
            Len     : LONGINT;
            Rep     : WORD;
            Rep_Len : WORD;
            Pad1    : BYTE;       {00  }
            Vol     : BYTE;       {40  }
            Pad2    : WORD;       {0001}
           end;

CONST Chunk_CMOD : Char4='CMOD';
      Chunk_SAMP : Char4='SAMP';
      Chunk_SPEE : Char4='SPEE';
      Chunk_SLEN : Char4='SLEN';
      Chunk_PLEN : Char4='PLEN';
      Chunk_PATT : Char4='PATT';
      Chunk_PBOD : Char4='PBOD';
      Chunk_SBOD : Char4='SBOD';

var Nb_pattern:BYTE;
    TChunk_Actuel : LONGINT;
    N_patt : BYTE;
    N_Smp  : BYTE;

{---------------------------------------------------------}

procedure C_CMOD;  { Channel modes } { Ok ? }
var CModes:array[1..4] of WORD;
    i:BYTE;
begin
 if TChunk_Actuel=8 then begin
  f_module.Lit(CModes,sizeof(CModes));
  MUS.H^.Nb_de_voies:=0;
  for i:=1 to 4 do begin
    CModes[i]:=SWAP(CModes[i]);       {0=>1 voie; 1 => 2 voies }
    if CModes[i]<2 then inc(MUS.H^.Nb_de_voies,CModes[i]+1)
    else Erreur_de_chargement:=Err_format;
  end;
 end else Erreur_de_chargement:=Err_format;
end; {C_CMOD}

{---------------------------------------------------------}

procedure C_SAMP(Num:BYTE);  { Sample directory }
VAR SmpOKT:T_Smp;

begin
 { Rserve l'espace DOS pour la dfinition de samples }
 if not Allouer_Samples(Num) then exit;

 for NSmp:=1 to Num do begin
  f_module.Lit(SmpOKT,sizeof(SmpOKT));
  Nouveau_Sample;

  MOVE(SmpOkt.Nom[1],Smp.Nom,20);
  Smp.len     := SWAPLB(SmpOkt.Len);
  Smp.rep_len := SWAP(SmpOKT.Rep_len) shl 1;
  Smp.rep     := SWAP(SmpOKT.Rep) shl 1;
  Smp.Volume  := SmpOKT.Vol;

  Move(Smp,MUS.T^.PtrSamples[NSmp]^,sizeof(Smp)); {Sauvegarde du Sample}
 end;
end; {C_SAMP}

{---------------------------------------------------------}

procedure C_SPEE; { Tempo de dpart } { Ok }
var t:WORD;
begin
 f_module.Lit(t,2);
 MUS.H^.Tempo_depart:=SWAP(t);
end; {C_SPEE}

{---------------------------------------------------------}

procedure C_SLEN;   { Nombre de pattern } { Ok }
var Np:WORD;
begin
 if TChunk_Actuel=2 then begin
   f_module.Lit(Np,2);
   Np:=SWAP(Np);
   if Np>255 then Erreur_de_chargement:=Err_Format
   else Nb_Pattern:=Np;
 end else Erreur_de_chargement:=Err_format;
end; {C_SLEN}

{---------------------------------------------------------}

procedure C_PLEN;   { Taille de la sequence }
var Ns:WORD;
begin
 if TChunk_Actuel=2 then begin
   f_module.Lit(Ns,2);
   Ns:=SWAP(Ns);
   if Ns>128 then Erreur_de_chargement:=Err_Format
   else MUS.H^.Sequence_Len:=Ns;
 end else Erreur_de_chargement:=Err_format;
end; {C_PLEN}

{---------------------------------------------------------}

procedure C_PATT;  { Squence }
begin
 if MUS.H^.Sequence_Len=0 then Erreur_de_chargement:=Err_format
 else begin
  f_module.Lit(MUS.T^.Sequence,MUS.H^.Sequence_Len);
 end;
end; {C_PATT}

{---------------------------------------------------------}

procedure C_PBOD; { Pattern }
type
    T_Note_OKT=record
                b1,b2,b3,b4: BYTE
               end;

    T_Pattern_OKT=array[1..512] of T_Note_OKT;

var Taille : WORD;
    POKT   : ^T_Pattern_OKT;
    Pattern: Ptr_Patt;
    i      : WORD;
    NVoies : BYTE;
    Vo,row : BYTE;

begin                { !!! Nb de lignes !!! }
 inc(N_Patt);
 f_module.Lit(Taille,2);
 Taille:=SWAP(Taille);
 NVoies:=(TChunk_Actuel-2) div (Taille*4);

 if (Taille<=64) and (Nvoies<=MUS.H^.Nb_de_voies) and (TChunk_Actuel>6) then begin
   GetMem(POKT,TChunk_Actuel-2);

   if not ReserveUMBDOS(Segment_actuel,6*4*MUS.H^.Nb_de_voies) then begin
     FreeMem(POKT,TChunk_Actuel-2);
     exit;
   end;

   Pointeur_Actuel:=Ptr(Segment_Actuel,0);
   MUS.T^.Pattern[N_Patt]:=Segment_Actuel;
   Pattern:=Pointeur_actuel;

   f_module.Lit(POKT^,TChunk_Actuel-2);

   C_Note.Volume:=255;
   i:=0;
   for Row:=0 to Taille-1 do      { Boucle sur les lignes }
    for Vo:=1 to Nvoies do begin  { Boucle sur les voies  }
     inc(i);
     with POKT^[i] do begin
      if b1=0 then begin
        C_Note.Note:=0;
        C_Note.Instrument:=0
      end
      else begin
        C_Note.Note:=b1+3*12;
        C_Note.Instrument:=b2+1
      end;

      C_Note.Commande:=Rien;
      C_Note.Parametre:=b4;
      case b3 of
        1 : C_Note.Commande := PortDown;
        2 : C_Note.Commande := PortUp;
       10 : C_Note.Commande := Arpeggio;
       11 : C_Note.Commande := Rien;       { Arpeggio 4   }
       12 : C_Note.Commande := Rien;       { Arpeggio 5   }
       13 : C_Note.Commande := Rien;       { rs_slided-p  }
       15 : C_Note.Commande := SetFilter;
       17 : C_Note.Commande := Rien;       { p-rs_slideu  }
       21 : C_Note.Commande := Rien;       { p-rs_slided  }
       25 : begin
             C_Note.Commande  := JumpPattern;
             C_Note.Parametre := (C_Note.Parametre and $F) + (C_Note.Parametre shr 4)*10 + 1;
            end;
       27 : C_Note.Commande := RetrigNote; { Release !!!! }
       28 : C_Note.Commande := SetTempo;
       30 : C_Note.Commande := Rien;       { rs_slideu-p  }
       31 : begin
             if C_Note.Parametre<=64 then begin
               C_Note.Commande := SetVolume;
             end
             else if C_Note.Parametre<$50 then begin
               C_Note.Commande  := VolSlide;
               C_Note.Parametre := C_Note.Parametre-$40;
             end
             else if C_Note.Parametre<$60 then begin
               C_Note.Commande  := VolFineDown;
               C_Note.Parametre := C_Note.Parametre-$50;
             end
             else if C_Note.Parametre<$70 then begin
               C_Note.Commande  := VolSlide;
               C_Note.Parametre := (C_Note.Parametre-$60) shl 4;
             end
             else if C_Note.Parametre<$80 then begin
               C_Note.Commande  := VolFineUp;
               C_Note.Parametre := C_Note.Parametre-$70;
             end
            end;
       else  C_Note.Commande := Rien;
      end;

      if C_Note.Instrument <>0 then SamplFlags[C_Note.Instrument]:=TRUE;
      Pattern^[MUS.H^.Nb_de_voies*Row+Vo]:=C_Note; { Ecrire la note dans la partition }
     end;
    end;

   FreeMem(POKT,TChunk_Actuel-2);
 end;
end; {C_PBOD}

{---------------------------------------------------------}

procedure C_SBOD;
begin
 inc(N_Smp);
 if N_Smp=1 then Init_Charge_Sample;

 if (N_Smp<MUS.H^.Nb_Total_Samples) then begin
   NSmp:=N_Smp;
   Move(MUS.T^.PtrSamples[NSmp]^,Smp,sizeof(Smp)); { Donnes du sample  }
   with MUS.T^ do
    if Smp.len>0 then begin
      inc(Nb_instruments);
      Smp_rep_fin:=Smp.rep+Smp.rep_len;
      Charger_Sample;                              { Charger le sample   }
    end;  { Smp_len>0 }
   Move(Smp,MUS.T^.PtrSamples[NSmp]^,sizeof(Smp)); { Copier le sample... }
 end;
 Fin_Charge_Sample;
end; {C_SBOD}

{---------------------------------------------------------}

procedure Charge_OKT(chemin: String80; var erreur: WORD);
var
   Nom_fich : String12;
   Ident    : array[1..8] of CHAR;
   Chunk    : T_Chunk;
   Position_Fichier : LONGINT;
   Taille_Fich      : LONGINT;

begin
 erreur:=Ok;
 f_module.Ouvre(lecture,chemin);

 if f_erreur=f_ok then begin
  MUS_Efface;
  Nom_fich:=NomFichierSeul(chemin);

  Taille_Fich:=f_module.Taille;    { Lire la taille du fichier }
  f_module.LitPos(0,Ident,sizeof(Ident));
  if Ident<>'OKTASONG' then Erreur_de_chargement:=Err_Format;

  Position_Fichier:=sizeof(Ident);
  Convertir_signe:=FALSE;
  Nb_Pattern:=0;
  N_Patt:=0;
  N_Smp:=0;

  if Erreur_de_chargement=Ok then repeat
   f_module.LitPOS(Position_Fichier,Chunk,sizeof(Chunk));
   TChunk_Actuel:=SwapLB(Chunk.Taille);

   if      Chunk.Header=Chunk_CMOD then C_CMOD
   else if Chunk.Header=Chunk_SAMP then C_SAMP(TChunk_Actuel div 32)
   else if Chunk.Header=Chunk_SPEE then C_SPEE
   else if Chunk.Header=Chunk_SLEN then C_SLEN
   else if Chunk.Header=Chunk_PLEN then C_PLEN
   else if Chunk.Header=Chunk_PATT then C_PATT
   else if Chunk.Header=Chunk_SPEE then C_SPEE
   else if Chunk.Header=Chunk_PBOD then C_PBOD
   else if Chunk.Header=Chunk_SBOD then C_SBOD;

   Position_Fichier:=Position_Fichier+TChunk_Actuel+8;
   if TChunk_Actuel=0 then Erreur_de_Chargement:=Err_Format;
  until (Position_fichier>Taille_fich) or not (Erreur_de_Chargement in [Ok,Err_samples]);

  Fin_Charge_Sample;

  MUS.H^.Octave_Min:=0;
  MUS.H^.Octave_Max:=7;
  Fixer_Panning(TRUE);
  FillChar(MUS.T^.Type_Voie,MUS.H^.Nb_de_voies,1); { Voies numriques... }
  Compter_Voies;

  Verifier_Module(Erreur_de_chargement);
  Erreur:=Erreur_de_chargement;
  f_module.Ferme
  end
 else Erreur:=Err_lecture;  {Impossible d'ouvrir le fichier}

 Verifier_Module(Erreur);
 if Erreur in [Ok,Err_samples] then MUS.Chargee:=TRUE else MUS_Efface;
end; {Charge_OKT}

END.
