{************************************************************************}
{                                CHPTM.PAS                               }
{                                                                        }
{  Loader pour les fichiers PTM. ( Poly Tracker )                        }
{                                                                        }
{  AUTEUR: Freddy Vtel.                                                }
{                                                                        }
{                               Dbut d'criture le 18/03/95             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}

{$UNDEF Groupe}

{$IFNDEF Groupe}
UNIT ChPTM;
{$ELSE}
UNIT ChPTM_G;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$IFNDEF Groupe}
USES Fichiers,Util,Memoire,Chutil,ModmVar,CRT;
{$ELSE}
USES Fich_grp,Util,Memoire,Chutil_G,ModmVar,CRT;
{$ENDIF}

procedure Charge_PTM(chemin: String80; var erreur: WORD);

IMPLEMENTATION

TYPE
     Char4=array[0..3] of CHAR;
     Char28=array[1..28] of CHAR;

CONST
     Max_Samples_PTM=99; { !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! }
     PTMIdent1=$101A;   {Version + Fichier Song}
     PTMSample:Char4='PTMS';
{     PTMAdlib:Char4='SCRI';}

TYPE
     T_En_tete_PTM=record
                    Nom      : array[1..28] of CHAR;
                    EofMark  : BYTE;
                    FVersion : WORD;
                    Byte1    : BYTE;
                    LongSeq  : WORD;
                    NbSampl  : WORD;      { Nombre de samples  }
                    NbPatt   : WORD;      { Nombre de pattern  }
                    NbVoies  : WORD;      { Nombre de voies    }
                    FFlags   : WORD;
                    Word1    : WORD;
                    SongID   : Char4;     { PTMF }
                    Fill1    : array[1..16]  of BYTE;  { Zone vide }
                    ChannPan : array[1..32]  of BYTE;
                    Sequence : array[1..256] of BYTE;
                    PatSeg   : array[1..128] of WORD;
                   end;

    T_PTM_Instrument=record
                      SType     : BYTE;   { 1:Sample 2:Adlib 3:Midi         }
                      DOSName   : array[1..12] of CHAR;
                      Volume    : BYTE;
                      C4Spd     : WORD;   { Frquence pour C-2 (Df 8448 Hz)}
                      SmpSeg    : WORD;   { Interne !                       }
                      FileOfs   : LONGINT;{ Position du sample              }
                      Len       : LONGINT;
                      Rep       : LONGINT;
                      RepEnd    : LONGINT;
                      GUSBegin  : LONGINT;{ Adresse de dpart GUS (Interne) }
                      GUSLStart : LONGINT;{ Dbut du bouclage GUS (Interne) }
                      GUSLEnd   : LONGINT;{ Flags GUS (Interne)             }
                      GUSLoop   : BYTE;
                      Byte1     : BYTE;
                      Nom       : Char28;
                      Id        : Char4;  { PTMS                            }
                     end;

     Ptr_En_tete_PTM=^T_En_tete_PTM;

VAR PTM : Ptr_En_tete_PTM;
    Nb_de_voies : BYTE;
    Format      : WORD;
    PosFichier  : LONGINT;

{---------------------------------------------------------}

procedure Charge_pattern(Nb_Patt: WORD);
var Patt: array[1..5000] of BYTE;
    Pattern: Ptr_Patt;

    c   : BYTE;
    i,j : WORD;
    n   : WORD;
    Row : WORD;
    Taille: WORD;
    Position_Pattern : WORD;
    Dernier_Param_E : array[1..16] of BYTE;
    Dernier_Param_VS: array[1..16] of BYTE;
    Param1 : BYTE;

label pattern_ok;

begin
 Erreur_de_chargement:=Err_memoire;    { Si exit, Erreur de mmoire }
 for n:=1 to Nb_Patt do begin
   for i:=1 to MUS.H^.Sequence_Len do
    if (MUS.T^.Sequence[i]=n-1) then goto pattern_ok;
   continue;  {passe au 'n' suivant}
   pattern_ok:
   if not ReserveUMBDOS(Segment_Actuel,sizeof(T_Note)*4*Nb_de_voies) then exit;

   Pointeur_Actuel:=Ptr(Segment_Actuel,0);
   Pattern:=Pointeur_actuel;
   MUS.T^.Pattern[n]:=Segment_Actuel;
   MUS.T^.Taille_Pattern[n]:=64;

   FillChar(Dernier_Param_E,16,0);
   FillChar(Dernier_Param_Vs,16,0);
   Fillchar(pattern^,sizeof(T_Note)*64*Nb_de_voies,0);
   for i:=1 to Nb_de_voies*64 do Pattern^[i].Volume:=255;
   Taille:=16*(PTM^.PatSeg[n+1]-PTM^.PatSeg[n]);
   f_module.LitPos(16*LONGINT(PTM^.PatSeg[n]),Patt,Taille);                        {Lire le pattern}

   for j:=1 to Nb_de_voies do begin
     i:=1;
     Row:=0;
     while (i<=Taille) and (Row<64) do begin
       c:=Patt[i];
       inc(i);
       if c=0 then inc(Row)
       else if (c and $1F)=(j-1) then begin
         {Effacer partition }
         C_Note.Commande:=Rien;
         C_Note.Parametre:=0; C_Note.Instrument:=0;
         C_Note.Note:=0; C_Note.Volume:=0;

         if (c and $20)<>0 then begin  {**** Priode et note ****}
           C_Note.Note:=Patt[i];
           if C_Note.Note=254 then C_Note.Note:=$FF   { KeyOff }
           else begin  { 10 Octaves !!!!!! }
             if (C_Note.Note>12*9) then C_Note.Note:=0;
{             if C_Note.Note<>0 then
             C_Note.Note:=PeriodArray[C_Note.Periode-1]}
           end;
           C_Note.Instrument:=Patt[i+1];

           if C_Note.Instrument <>0 then SamplFlags[C_Note.Instrument]:=TRUE;
           inc(i,2)
         end;

         if (c and $40)<>0 then begin  {**** Commande ****}
           C_Note.Parametre:=Patt[i+1];
           case Patt[i] of
              0: C_Note.Commande:=Arpeggio;
              1: begin
                  if C_Note.Parametre=0 then C_Note.Parametre:=Dernier_Param_E[j];
                  Dernier_Param_E[j]:=C_Note.Parametre;
                  if C_Note.Parametre>$E0 then begin
                   C_Note.Commande:=FinePortaDown; {Fine ou Extra Fine }
                   if C_Note.Parametre>$F0 then C_Note.Parametre:=C_Note.Parametre and $F
                   else begin
                    C_Note.Parametre:=(C_Note.Parametre and $F) shr 2;
                    if C_Note.Parametre=0 then C_Note.Commande:=Rien;
                   end;
                  end
                  else C_Note.Commande:=PortDown;
                 end;
              2: begin
                  if C_Note.Parametre=0 then C_Note.Parametre:=Dernier_Param_E[j];
                  Dernier_Param_E[j]:=C_Note.Parametre;
                  if C_Note.Parametre>$E0 then begin
                   C_Note.Commande:=FinePortaUp;  { Fine ou Extra Fine }
                   if C_Note.Parametre>$F0 then C_Note.Parametre:=C_Note.Parametre and $F
                   else begin
                    C_Note.Parametre:=(C_Note.Parametre and $F) shr 2;
                    if C_Note.Parametre=0 then C_Note.Commande:=Rien;
                   end;
                  end
                  else C_Note.Commande:=PortUp;
                 end;
              3: C_Note.Commande:=TonePortamento;
              4: C_Note.Commande:=Vibrato;
              5: C_Note.Commande:=Tone_VSlide;
              6: C_Note.Commande:=Vib_VSlide;
              7: C_Note.Commande:=Tremolo;
              9: C_Note.Commande:=SampleOffs;
            $0A: begin
                  if C_Note.Parametre=0 then C_Note.Parametre:=Dernier_Param_Vs[j];
                  Dernier_Param_Vs[j]:=C_Note.Parametre;
                  if C_Note.Parametre>$F0 then begin
                   C_Note.Commande:=VolFineDown; {Fine Down}
                   C_Note.Parametre:=C_Note.Parametre and $F
                  end
                  else
                   if ((C_Note.Parametre and $F)=$F) and (C_Note.Parametre>$F) then begin
                    C_Note.Commande:=VolFineUp;  {Fine Up}
                    C_Note.Parametre:=C_Note.Parametre shr 4
                   end
                   else C_Note.Commande:=VolSlide;
                 end;
            $0B: C_Note.Commande:=JumpPattern;
            $0C: C_Note.Commande:=SetVolume;
            $0D: C_Note.Commande:=EndPattern;
            $0E: begin                         { Sxy }
                  case (C_Note.Parametre and $F0) shr 4 of
                    0:C_Note.Commande:=SetFilter;
                    1:C_Note.Commande:=FinePortaDown;
                    2:C_Note.Commande:=FinePortaUp;
                    4:C_Note.Commande:=VibCtrl;
                    5:C_Note.Commande:=FineTune;
                    7:C_Note.Commande:=TremCtrl;
                    8:begin { Panning 0->F }
                      C_Note.Commande:=CPanning;
                      end;
                    9:C_Note.Commande:=RetrigNote;
                   $A:C_Note.Commande:=VolFineUP;
                   $B:C_Note.Commande:=VolFineDown;
                   $C:C_Note.Commande:=NoteCut;
                   $D:C_Note.Commande:=NoteDelay;
                   $E:C_Note.Commande:=PattDelay;
                   $F:C_Note.Commande:=Funkit;
                  end;
                  C_Note.Parametre:=C_Note.Parametre and $F;
                  if C_Note.Commande=CPanning then
                     C_Note.Parametre:=Panning_GUS_SB(C_Note.Parametre);
                  end;
            $0F: begin
                  C_Note.Commande:=SetTempo;
                  if C_Note.Parametre=0 then C_Note.Commande:=Rien;
                  if C_Note.Parametre>$1F then C_Note.Commande:=SetBPM;
                 end;
            $10: C_Note.Commande:=SetGVolume;
            $11: C_Note.Commande:=RetrigNote;
            $12: begin
                  C_Note.Commande:=Vibrato;   { Fine Vibrato }
                  Param1:=(C_Note.Parametre and $0F) shr 2;
                  C_Note.Parametre:=(C_Note.Parametre and $F0)+Param1;
                 end;
            else begin
                  C_Note.Commande:=Rien;
                  C_Note.Parametre:=0;
                 end;
           end;
           inc(i,2);
         end;

         if (c and $80)<>0 then begin  {**** Volume ****}
           C_Note.Volume:=Patt[i]+1;
           if C_Note.Volume>65 then C_Note.Volume:=65;
           inc(i);
          end;

         if (C_Note.Commande=CPanning) then
          if C_Note.Parametre>$80 then begin
            C_Note.Commande:=Rien;
            C_Note.Parametre:=0;
          end;

         if Row<64 then begin
           Position_Pattern:=j+Nb_de_voies*Row;
           dec(C_Note.Volume); { Attention !!! }
           Pattern^[Position_Pattern]:=C_Note;
         end;
        end
       else begin
        if (c and $20)<>0 then inc (i,2);
        if (c and $40)<>0 then inc (i,2);
        if (c and $80)<>0 then inc (i);
       end;
      end;  {while}
    end; {for j}
  end; {for n}

  Erreur_de_chargement:=Ok;
end; {Charge_pattern}

{---------------------------------------------------------}

procedure Charge_Sampl(NbSampl: WORD);
var PTMSampl: T_PTM_Instrument;
    i,j,k: INTEGER;
    PremierOffs : LONGINT;

begin
 PremierOffs:=0;

 Init_Charge_Sample;
 { Rserve l'espace DOS pour la dfinition de samples }
 if not Allouer_Samples(NbSampl) then begin
   Fin_Charge_Sample;
   exit;
 end;

 for NSmp:=1 to NbSampl do begin
   f_module.LitPos(PosFichier,PTMSampl,sizeof(PTMSampl));
   inc(PosFichier,sizeof(PTMSampl));

   Nouveau_Sample;

   Move(PTMSampl.Nom,Smp.Nom,28);
   Smp.len:=PTMSampl.Len;
   Smp.Info:=M_Delta;

   if (Smp.len>3) and ((PTMSampl.SType and $03)=1) then begin
     inc(Nb_instruments);

     if (PTMSampl.SType and $04)>0 then begin { Instrument boucl }
       Smp.rep:=PTMSampl.Rep;
       Smp_rep_Fin:=PTMSampl.RepEnd;
     end
     else begin
       Smp.rep:=0;
       Smp_rep_Fin:=0;
     end;
     if (PTMSampl.SType and $08)>0 then  { bouclage Bidi }
       Smp.Info:=Smp.Info or M_Bidi;
     if (PTMSampl.SType and $10)>0 then begin  { Sample 16 bit }
       Smp.Info:=Smp.Info or M_16Bit;
       Smp.len:=Smp.len shr 1;
       Smp.rep:=Smp.rep shr 1;
       Smp_rep_Fin:=Smp_rep_Fin shr 1;
     end;

     Smp.Volume:=PTMSampl.Volume;
     if Smp.Volume>64 then Smp.Volume:=64;
     Smp.C4Spd:=PTMSampl.C4Spd;
     if PremierOffs=0 then PremierOffs:=PTMSampl.FileOfs;

     f_module.PlacePointeur(PTMSampl.FileOfs);
     Charger_sample;
   end;

   Move(Smp,MUS.T^.PtrSamples[NSmp]^,sizeof(Smp)); { Copier le sample...  }
 end;

 PTM^.PatSeg[PTM^.NbPatt+1]:=PremierOffs div 16; { Fin du dernier pattern }

 Fin_Charge_Sample;
end; {Charge_Sampl}

{---------------------------------------------------------}

procedure Charge_PTM(chemin: String80; var erreur: WORD);

label FinChPTM;
var
    Nom_fich: String12;
    i:INTEGER;
begin
 erreur:=Ok;
 f_module.Ouvre(lecture,chemin);

 if f_erreur=f_ok then begin
  MUS_Efface;
  MUS.H^.Type_Module:=T_PTM;            { type de module  }
  nom_fich:=NomFichierSeul(chemin);

  New(PTM);
  f_module.LitPos(0,PTM^,sizeof(PTM^));
  PosFichier:=sizeof(PTM^);

  Move(PTM^.Nom,MUS.H^.Titre,28);       { Titre du module }
  MUS.H^.Octave_Min:=0;
  MUS.H^.Octave_Max:=9; { 10 Octaves }

  Nb_de_voies:=PTM^.NbVoies;
  MUS.H^.Sequence_Len:=PTM^.LongSeq;
  MUS.H^.Pos_de_restart:=1;                 { Position de bouclage         }
  MUS.H^.Nb_de_voies_Patt:=Nb_de_voies;     { Nb de voies dans un pattern  }
  MUS.H^.Nb_de_voies:=Nb_de_voies;          { Nombre rel de voies         }
  Move(PTM^.Sequence,MUS.T^.Sequence,256);

  if (PTM^.NbVoies>32) or (PTM^.NbSampl>255) or (PTM^.NbPatt>128) or
     (PTM^.LongSeq>256) or (PTM^.SongID<>'PTMF') then
     Erreur_de_chargement:=Err_Format
     else if PTM^.FVersion<>$0203 then Erreur_de_chargement:=Err_Version_Inconnue;

  FillChar(SamplFlags,sizeof(SamplFlags),1);
  if Erreur_de_chargement=Ok then
     Charge_Sampl(PTM^.NbSampl);              { Charger les samples  }

  if Erreur_de_chargement in [Ok,Err_Samples] then
     Charge_pattern(PTM^.NbPatt);             { Charger la partition }

  if Erreur in [Ok,Err_samples] then begin
   Fixer_Panning(FALSE);   { Initialise Gauche et Droite }
   FillChar(MUS.T^.Type_Voie,MUS.H^.Nb_de_voies,1); { Voies numriques... }

   if Panning_Utilisable then begin  { Table de panning }
     for i:=1 to Nb_de_voies do
       MUS.Panning[i]:=Panning_GUS_SB(PTM^.ChannPan[i] and $0F);
   end;
   Compter_Voies;
  end;

FinChPTM:
  Dispose(PTM);

  Verifier_Module(Erreur_de_chargement);
  Erreur:=Erreur_de_chargement;
  f_module.Ferme;
 end
 else Erreur:=Err_lecture;  {Impossible d'ouvrir le fichier}

 if Erreur in [Ok,Err_samples] then MUS.Chargee:=TRUE else MUS_Efface;
end; {Charge_PTM}

END.
