{************************************************************************}
{                                CHS3M.PAS                               }
{                                                                        }
{  Loader pour les fichiers S3M. (Scream Tracker 3.x de Future Crew)     }
{                                                                        }
{  AUTEUR: Freddy Vtel.                                                }
{                                                                        }
{                               Dbut d'criture le --/08/94             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}

{$UNDEF Groupe}

{$IFNDEF Groupe}
UNIT ChS3M;
{$ELSE}
UNIT ChS3M_G;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$IFNDEF Groupe}
USES Fichiers,Util,Memoire,Chutil,ModmVar,VarUnit;
{$ELSE}
USES Fich_grp,Util,Memoire,Chutil_G,ModmVar,VarUnit;
{$ENDIF}

procedure Charge_S3M(chemin: String80; var erreur: WORD);

IMPLEMENTATION

TYPE
     Char4=array[0..3] of CHAR;
     Char28=array[1..28] of CHAR;

CONST
     Version0=$1300;  { ST3.00 }
     Version1=$1301;  { ST3.01 }
     Version2=$1310;  { ST3.10 }

     Max_Samples_S3M=99;
     S3MIdent1=$101A;   {Version + Fichier Song}
     S3MSample:Char4='SCRS';
     S3MAdlib:Char4='SCRI';

TYPE
     T_En_tete_S3M=record
                    Nom      : array[1..28] of CHAR;
                    Ident1   : WORD;
                    Inconnu1 : WORD;
                    LongSeq  : WORD;
                    NbSampl  : WORD;
                    NbPatt   : WORD;
                    Flags    : WORD;      { Limites Amiga, Optim du volume...}
                    Version  : WORD;
                    Format   : WORD;      { =1 sign, =2 non sign }
                    Ident2   : Char4;     { SCRM }
                    Volume   : BYTE;      { Volume gnral         }
                    Tempo    : BYTE;      { Vitesse de dmarrage   }
                    BPM      : BYTE;      { Master Multiplier      }
                    MainVol  : BYTE;
                    UltraClR : BYTE;      { Ultra click removal    }
                    Def_Pan  : BYTE;      { Default Pan ???        }
                    Fill1    : array[1..10] of BYTE;
                    ChannMaps: array[1..32] of BYTE
                   end;

    T_S3M_Instrument=record case BOOLEAN of
                      TRUE : (
                       SType     : BYTE;  { 1:Sample 2:Adlib 3:Adlib drum  }
                       Name      : array[1..13] of CHAR;
                       Position  : WORD;
                       Len       : LONGINT;
                       Rep       : LONGINT;
                       RepEnd    : LONGINT;
                       Volume    : WORD;
                       Byte1     : BYTE;
                       Flags     : BYTE;  { +1 Boucle,+2 stereo,+4 16 bit   }
                       C4Spd     : WORD;  { Frquence pour C-2 (Df 8448 Hz)}
                       fill3     : array[1..10] of BYTE;
                       Word3     : WORD;
                       Word4     : WORD;
                       Comment   : Char28;
                       Id        : Char4;
                             );
                      FALSE : (
                       AType     : BYTE;  { 1:Sample 2:Adlib 3:Adlib drum  }
                       AName     : array[1..13] of CHAR;
                       AFill1    : array[1..2] of BYTE;
                       AData     : T_OPL2Instr;
                       AByte1    : BYTE;
                       AVolume   : BYTE;
                       AFill2    : array[1..3] of BYTE;
                       AC4Spd    : WORD;
                       AFill3    : array[1..14] of BYTE;
                       AComment  : Char28;
                       AId       : Char4;
                              )
                     end;

     Toffsets   =array[1..100] of WORD;

     Ptr_En_tete_S3M=^T_En_tete_S3M;

VAR VersionS3M:BYTE;
    Nb_de_voies: BYTE;
    Nb_reel_voies:BYTE;
    Format : WORD;

{---------------------------------------------------------}

procedure Charge_pattern(var Pattofs: Toffsets; Nb_Patt: WORD);
var Patt: array[1..5000] of BYTE;
    Pattern: Ptr_Patt;
    c   : BYTE;
    i,j : WORD;
    n   : WORD;
    Row : WORD;
    Taille: WORD;
    Position_Pattern : WORD;
    Dernier_Param_E  : array[1..16] of BYTE;
    Dernier_Param_VS : array[1..16] of BYTE;
    Param1 : BYTE;
label pattern_ok;

begin
 Erreur_de_chargement:=Err_memoire;    { Si exit, Erreur de mmoire }
 nb_reel_voies:=0;
 for n:=1 to Nb_Patt do begin
   for i:=1 to MUS.H^.Sequence_Len do
    if (MUS.T^.Sequence[i]=n-1) then goto pattern_ok;
   continue;  {passe au 'n' suivant}
   pattern_ok:
   if not ReserveUMBDOS(Segment_actuel,sizeof(T_Note)*4*Nb_de_voies) then exit;

   Pointeur_Actuel:=Ptr(Segment_Actuel,0);
   Pattern:=Pointeur_actuel;
   MUS.T^.Pattern[n]:=Segment_Actuel;;

   FillChar(Dernier_Param_E,16,0);
   FillChar(Dernier_Param_Vs,16,0);
   Fillchar(pattern^,sizeof(T_Note)*64*Nb_de_voies,0);
   for i:=1 to Nb_de_voies*64 do Pattern^[i].Volume:=255;
   f_module.LitPos(16*LONGINT(Pattofs[n]),Taille,2); {Lire la taille du pattern}
   f_module.Lit(Patt,Taille);                        {Lire le pattern}

   for j:=1 to Nb_de_voies do begin
     i:=1;
     Row:=0;
     while (i<=Taille) and (Row<64) do begin
       c:=Patt[i];
       inc(i);
       if c=0 then inc(Row)
       else if (c and $1F)=(j-1) then begin
         {Effacer partition }
         C_Note.Commande:=Rien;
         C_Note.Parametre:=0; C_Note.Instrument:=0;
         C_Note.Note:=0; C_Note.Volume:=0;

         if (c and $20)<>0 then begin
           C_Note.Note:=Patt[i];
           if C_Note.Note=254 then C_Note.Note:=$FF  { KeyOff }
           else begin
            if ((C_Note.Note and $F0) > $80) or
               ((C_Note.Note and $0F) > $0B) then C_Note.Note:=0;
            if C_Note.Note<>0 then
               C_Note.Note:=(C_Note.Note shr 4)*12+(C_Note.Note and $0F)+1;
           end;
           C_Note.Instrument:=Patt[i+1];

           if C_Note.Instrument <>0 then SamplFlags[C_Note.Instrument]:=TRUE;
           inc(i,2);
         end;

         if (c and $40)<>0 then begin
           C_Note.Volume:=Patt[i]+1;
           if C_Note.Volume>65 then C_Note.Volume:=65;
           inc(i)
         end;

         if (c and $80)<>0 then begin
           C_Note.Parametre:=Patt[i+1];
           case Patt[i] of
            1: begin
                C_Note.Commande:=SetTempo;
                if C_Note.Parametre=0 then C_Note.Commande:=Rien;
               end;
            2: C_Note.Commande:=JumpPattern;
            3: C_Note.Commande:=EndPattern;
            4: begin
                if C_Note.Parametre=0 then C_Note.Parametre:=Dernier_Param_Vs[j];
                Dernier_Param_Vs[j]:=C_Note.Parametre;
                if C_Note.Parametre>$F0 then begin
                 C_Note.Commande:=VolFineDown; {Fine Down}
                 C_Note.Parametre:=C_Note.Parametre and $F
                end
                else
                 if ((C_Note.Parametre and $F)=$F) and (C_Note.Parametre>$F) then begin
                   C_Note.Commande:=VolFineUp;  {Fine Up}
                   C_Note.Parametre:=C_Note.Parametre shr 4
                 end
                 else C_Note.Commande:=VolSlide;
               end;
            5: begin     { E }
                if C_Note.Parametre=0 then C_Note.Parametre:=Dernier_Param_E[j];
                Dernier_Param_E[j]:=C_Note.Parametre;
                if C_Note.Parametre>$E0 then begin
                 C_Note.Commande:=FinePortaDown; {Fine ou Extra Fine }
                 if C_Note.Parametre>$F0 then C_Note.Parametre:=C_Note.Parametre and $F
                 else begin
                  C_Note.Parametre:=(C_Note.Parametre and $F) shr 2;
                  if C_Note.Parametre=0 then C_Note.Commande:=Rien;
                 end;
                end
                else C_Note.Commande:=PortDown;
               end;
            6: begin
                if C_Note.Parametre=0 then C_Note.Parametre:=Dernier_Param_E[j];
                Dernier_Param_E[j]:=C_Note.Parametre;
                if C_Note.Parametre>$E0 then begin
                 C_Note.Commande:=FinePortaUp;  { Fine ou Extra Fine }
                 if C_Note.Parametre>$F0 then C_Note.Parametre:=C_Note.Parametre and $F
                 else begin
                  C_Note.Parametre:=(C_Note.Parametre and $F) shr 2;
                  if C_Note.Parametre=0 then C_Note.Commande:=Rien;
                 end;
                end
                else C_Note.Commande:=PortUp;
               end;
            7: C_Note.Commande:=TonePortamento;      { Gxx }
            8: C_Note.Commande:=Vibrato;             { Hxx }
            9: C_Note.Commande:=Tremor;              { Ixy }
            10: C_Note.Commande:=Arpeggio;           { Jxy }
            11: C_Note.Commande:=Vib_VSlide;         { Kxy }
            12: C_Note.Commande:=Tone_VSlide;        { Lxy }
            15: C_Note.Commande:=SampleOffs;         { Oxx }
            17: C_Note.Commande:=RetrigNote;         { Qxy }
            18: C_Note.Commande:=Tremolo;            { Rxy }
            19: begin                         { Sxy }
                 case (C_Note.Parametre and $F0) shr 4 of
                   0:C_Note.Commande:=SetFilter;  { S0x }
                   1:C_Note.Commande:=GlissCtrl;  { S1x }
                   2:C_Note.Commande:=FineTune;   { S2x }
                   3:C_Note.Commande:=VibCtrl;    { S3x }
                   4:C_Note.Commande:=TremCtrl;   { S4x }
                   8:begin { Panning 0->F    S8x }
                     C_Note.Commande:=CPanning;
                     end;
                  $A:C_Note.Commande:=Rien;   { SAx Stereo control }
                  $B:C_Note.Commande:=JumpLoop;   { SBx }
                  $C:C_Note.Commande:=NoteCut;    { SCx }
                  $D:C_Note.Commande:=NoteDelay;  { SDx }
                  $E:C_Note.Commande:=PattDelay;  { SEx }
                  $F:C_Note.Commande:=Funkit;     { SFx }
                 end;
                 C_Note.Parametre:=C_Note.Parametre and $F;
                 if C_Note.Commande=CPanning then
                    C_Note.Parametre:=Panning_GUS_SB(C_Note.Parametre);
                end;
            20: begin                                 { Txx }
                 C_Note.Commande:=SetBPM;              { set BPM }
                 if C_Note.Parametre<$20 then begin
                  C_Note.Commande:=Rien;
                  C_Note.Parametre:=0;
                 end;
                end;
            21: begin { Commande ST3.20 }             { Uxy }
                 C_Note.Commande:=Vibrato;    { Vibrato Fine }
                 Param1:=(C_Note.Parametre and $0F) shr 2;
                 C_Note.Parametre:=(C_Note.Parametre and $F0)+Param1;
                end;
            22: C_Note.Commande:=SetGVolume; { set Global volume (0-40) }
            else begin
                  C_Note.Commande:=Rien;
                  C_Note.Parametre:=0;
                 end;
           end;
           inc(i,2)
         end;

         if (C_Note.Commande=CPanning) then
           if C_Note.Parametre>$80 then begin
             C_Note.Commande:=Rien;
             C_Note.Parametre:=0;
           end;

         if C_Note.Note<>0 then    { Dtecter le Nb de voies }
           if Nb_reel_voies<j then Nb_reel_voies:=j;

         if Row<64 then begin
           Position_Pattern:=j+Nb_de_voies*Row;
           dec(C_Note.Volume);
           Pattern^[Position_Pattern]:=C_Note;
         end;
       end
       else begin
         if (c and $20)<>0 then inc (i,2);
         if (c and $40)<>0 then inc (i);
         if (c and $80)<>0 then inc (i,2);
       end;
      end;  {while}
    end; {for j}
  end; {for n}

  Erreur_de_chargement:=Ok;
end; {Charge_pattern}

{---------------------------------------------------------}

procedure Charge_Sampl(var Instroffs: Toffsets; NbSampl: WORD);

var S3MSampl: T_S3M_Instrument;
    i,j,k: INTEGER;

begin
 if NbSampl>Max_Samples then NbSampl:=Max_Samples;

 Init_Charge_Sample;

 { Rserve l'espace DOS pour la dfinition de samples }
 if not Allouer_Samples(NbSampl) then begin
   Fin_Charge_Sample;
   exit;
 end;

 for NSmp:=1 to NbSampl do begin
   f_module.LitPos(16*LONGINT(Instroffs[NSmp]),S3MSampl,sizeof(S3MSampl));

   Nouveau_Sample;
   if (S3MSampl.Id=S3MSample) then begin
     Move(S3MSampl.Comment,Smp.Nom,28);
     Smp.len:=S3MSampl.Len;
     Smp.Info:=0;

     if (Smp.len>3) and (S3MSampl.Flags<2) then begin {Prsent et utilis dans la partition }
       inc(Nb_instruments);

       if (S3MSampl.Flags and $01)=1 then begin  { Instrument boucl }
         Smp.rep:=S3MSampl.Rep;
         Smp_rep_Fin:=S3MSampl.RepEnd;
       end
       else begin
         Smp.rep:=0;
         Smp_rep_Fin:=0;
       end;

       Smp.Volume:=S3MSampl.Volume;
       if Smp.Volume>64 then Smp.Volume:=64;
       Smp.C4Spd:=S3MSampl.C4Spd;

       f_module.PlacePointeur(16*LONGINT(S3MSampl.Position));
       Charger_sample;
     end;
   end
   else if (S3MSampl.Id=S3MAdlib) then begin
     Move(S3MSampl.AComment,Smp.Nom,28);
     Smp.Info:=1;           { 1 => 'Sample' Adlib }
     inc(Nb_instruments);
     if (S3MSampl.SType<>2) then inc(Nb_Pas_Charge)
     else begin
       Smp.AVolume:=S3MSampl.AVolume;
       Smp.AC4Spd:=S3MSampl.AC4Spd;
       Smp.AData:=S3MSampl.AData;
       Smp.Info:=(Smp.Info or M_Charge);
     end;
   end
   else Move(S3MSampl.Comment,Smp.Nom,28);

   Move(Smp,MUS.T^.PtrSamples[NSmp]^,sizeof(Smp)); { Copier le sample... }
 end;

 Fin_Charge_Sample;
end; {Charge_Sampl}

{---------------------------------------------------------}

procedure Charge_S3M(chemin: String80; var erreur: WORD);

label FinChS3M;
var S3M: Ptr_En_tete_S3M;
    Instrofs,Pattofs: Toffsets;
    Nom_fich: String12;
    Pan_Present:BOOLEAN;
    Table_Pan:array[1..32] of BYTE;
    i:INTEGER;

begin
 erreur:=Ok;
 f_module.Ouvre(lecture,chemin);

 if f_erreur=f_ok then begin
  MUS_Efface;
  MUS.H^.Type_Module:=T_S3M;            { type de module  }
  nom_fich:=NomFichierSeul(chemin);

  New(S3M);
  Pan_Present:=FALSE;

  f_module.LitPos(0,S3M^,sizeof(S3M^));
  Erreur_de_chargement:=Ok;

  Move(S3M^.Nom,MUS.H^.Titre,28);       { Titre du module }
  f_module.Lit(MUS.T^.Sequence,S3M^.LongSeq);

    { Dtecter le premier $FF pour la fin de la squence... }
  for i:=1 to 255 do
   if MUS.T^.Sequence[i]=$FF then begin
     S3M^.LongSeq:=i-1;
     break
   end;

  for i:=1 to 32 do if S3M^.ChannMaps[i]<32 then Nb_de_voies:=i;
  if Nb_de_voies>Max_Voies then Nb_de_voies:=Max_voies;
  MUS.H^.Sequence_Len:=S3M^.LongSeq;
  MUS.H^.Pos_de_restart:=1;                 { Position de bouclage         }
  MUS.H^.Nb_de_voies_Patt:=Nb_de_voies;     { Nb de voies dans un pattern  }
  MUS.H^.Tempo_depart:=S3M^.Tempo;          { Tempo Initial                }
  MUS.H^.BPM_depart:=S3M^.BPM;              { BPM Initial                  }
  MUS.H^.Volume_General_depart:=S3M^.Volume;{ Volume gnral Initial       }

  Convertir_signe:=(S3M^.Format=2); { Samples signs ou non signs }

  { Recherche de la version du fichier... }
  if S3M^.Version<=Version0 then VersionS3M:=0
     else if S3M^.Version<Version2 then VersionS3M:=1
             else VersionS3M:=2;
  if (VersionS3M=2) and (S3M^.Def_Pan=252) then
     Pan_Present:=TRUE;
  if (VersionS3M<=1) then MUS.H^.Volume_Sl_rapide:=TRUE;

  { Gestion des Flag... }
  if (S3M^.Flags and $10)>0 then begin  { Limites Amiga }
    MUS.H^.Octave_Min:=3;
    MUS.H^.Octave_Max:=5;
  end
  else begin
    MUS.H^.Octave_Min:=0;
    MUS.H^.Octave_Max:=7;
  end;

  if (S3M^.Flags and $40)>0 then MUS.H^.Volume_Sl_rapide:=TRUE;

  if (S3M^.NbSampl>99) or (S3M^.NbPatt>100) then Erreur_de_chargement:=Err_Format
  else begin
    f_module.Lit(Instrofs,S3M^.NbSampl*2);
    f_module.Lit(Pattofs,S3M^.NbPatt*2);
    if Pan_Present then f_module.Lit(Table_Pan,32);

    Charge_pattern(Pattofs,S3M^.NbPatt);       { Charger la partition }
    MUS.H^.Nb_de_voies:=Nb_reel_voies;       { Nombre rel de voies }
  end;

  if Erreur_de_chargement=Ok then
    Charge_Sampl(Instrofs,S3M^.NbSampl);    { Charger les samples  }

  if Erreur in [Ok,Err_samples] then begin
   Fixer_Panning(FALSE);   { Initialise Gauche et Droite }
   FillChar(MUS.T^.Type_Voie,MUS.H^.Nb_de_voies,1); { Voies numriques... }
   for i:=1 to Nb_reel_voies do
     if S3M^.ChannMaps[i]<8 then MUS.Panning[i]:=P_Gauche
     else if S3M^.ChannMaps[i]<16 then MUS.Panning[i]:=P_Droite
     else if S3M^.ChannMaps[i]<25 then begin
       MUS.T^.Type_Voie[i]:=2;
       MUS.T^.Voies_Adlib[S3M^.ChannMaps[i]-15]:=i;
     end
     else MUS.T^.Type_Voie[i]:=0;

   if Pan_Present and Panning_Utilisable then     { Table de panning }
     for i:=1 to Nb_reel_voies do
       if (Table_Pan[i] and 32)>0 then
         MUS.Panning[i]:=Panning_GUS_SB(Table_Pan[i] and $0F);

   Compter_Voies;
  end;

FinChS3M:
  Dispose(S3M);

  Verifier_Module(Erreur_de_chargement);
  Erreur:=Erreur_de_chargement;
  f_module.Ferme;
 end
 else Erreur:=Err_lecture;  {Impossible d'ouvrir le fichier}

 Verifier_Module(Erreur);
 if Erreur in [Ok,Err_samples] then MUS.Chargee:=TRUE else MUS_Efface;
end; {Charge_S3M}

END.
