{************************************************************************}
{                                CHSAT.PAS                               }
{                                                                        }
{  Loader pour les fichiers SAT ( Surprise Adlib Tracker )               }
{                                                                        }
{  AUTEUR: Freddy Vtel.                                                }
{                                                                        }
{                               Dbut d'criture le 21/09/95             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}

{$UNDEF Groupe}

{$IFNDEF Groupe}
UNIT ChSAT;
{$ELSE}
UNIT ChSAT_G;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$IFNDEF Groupe}
USES Fichiers,Util,Memoire,Chutil,ModmVar,GusUnit,CRT;
{$ELSE}
USES Fich_grp,Util,Memoire,Chutil_G,ModmVar,GusUnit,CRT;
{$ENDIF}

{==========================================================}

procedure Charge_SAT(chemin: String80; var erreur: WORD);

{==========================================================}

IMPLEMENTATION

CONST NbInstSAT=31;
      Nb_VoiesSAT=9;
TYPE
    TInstrDT=record
              SFeedBack : BYTE;
              SM1,SP1   : BYTE;
              SM3,SP3   : BYTE;
              SM4,SP4   : BYTE;
              SM5,SP5   : BYTE;
              SM2,SP2   : BYTE;
             end;

     TInstrData=array[1..31] of TInstrDT;


     TInstrNom=array[1..29] of record
                b1  : BYTE;
                Nom : array[1..16] of CHAR;
               end;

     TSATHeader=record
                 Ident : array[1..4] of CHAR;
                 Vers  : BYTE;
                end;

    PtrSATInstr = ^TInstrData;
    PtrSATNom   = ^TInstrNom;

    T_Note_SAT=record
               No,Ins,Co,P1,P2:BYTE;
               end;

    T_Pattern_SAT=array[1..576] of T_Note_SAT;
    Ptr_patt_SAT=^T_Pattern_SAT;


CONST InstrVide:TInstrDT=(SFeedback:$01;SM1:$00;SP1:$00;SM3:$00;SP3:$00;
                          SM4:$F0;SP4:$F0;SM5:$00;SP5:$00;SM2:$3F;SP2:$3F);

VAR Nb_Pattern:BYTE;
    Version   :BYTE;

{---------------------------------------------------------}

procedure ChargePatt;
VAR i,j:WORD;
    Pattern_SAT:Ptr_patt_SAT;
    Pattern: Ptr_Patt;
begin
 GetMem(Pattern_SAT,64*Nb_VoiesSAT);

 for i:=1 to Nb_pattern do begin
   if not ReserveUMBDOS(Segment_Actuel,sizeof(T_Note)*4*Nb_VoiesSAT) then begin
     FreeMem(Pattern_SAT,64*Nb_VoiesSAT);
     exit;
   end;

   Pointeur_Actuel:=Ptr(Segment_Actuel,0);
   MUS.T^.Pattern[i]:=Segment_Actuel;
   Pattern:=Pointeur_actuel;

   f_module.Lit(Pattern_SAT^,320*Nb_VoiesSAT);
{   Writeln('Pattern: ',i);}
   C_Note.Volume:=255;
    for j:=1 to 64*Nb_VoiesSAT do
     with Pattern_SAT^[j] do begin
{       Write('Note: ',No,'Instr: ',Ins,'Commande: ',Co,'P1: ',P1,'P2: ',P2);
       repeat until Readkey=#13;}
       C_Note.Note:=0;
       C_Note.Commande:=Co+1;
       C_Note.Parametre:=(P1 shl 4)+P2;

       if (No<>0) then              { Priode        }
         if (Version<5) then C_Note.Note:=No+2*12
         else if No>1 then C_Note.Note:=No;

       if C_Note.Commande=$E+1 then begin {Commande tendue}
         C_Note.Commande:=$11+P1;
         C_Note.Parametre:=P2
       end;
       if (C_Note.Commande=CPanning) then begin
         C_Note.Note:=$FF;
         C_Note.Commande:=0;
       end;
       if (C_Note.Commande=Arpeggio) and (C_Note.Parametre=0) then C_Note.Commande:=Rien;
       if (C_Note.Commande in [VolSlide,PortUp,PortDown]) and (C_Note.Parametre=0) then begin
         C_Note.Commande:=Rien;
         C_Note.Parametre:=0
       end;
       if (C_Note.Commande=SetTempo) then begin
         if (C_Note.Parametre>$1F) and (Variables^.Utiliser_BPM) then C_Note.Commande:=SetBPM;
         if (C_Note.Parametre=0  ) then C_Note.Commande:=Rien;
       end;

       C_Note.Instrument:=Ins;      { Instrument     }

       if C_Note.Instrument <>0 then SamplFlags[C_Note.Instrument]:=TRUE;
       Pattern^[j]:=C_Note;    { Ecrire la note dans la partition }
     end;
 end;

 FreeMem(Pattern_SAT,64*Nb_VoiesSAT);
end; {ChargePatt}

{---------------------------------------------------------}

procedure ChargeInstr(SATInstr:PtrSATInstr;SATNom:PtrSATNom);
begin
 Init_Charge_Sample;

 { Rserve l'espace DOS pour la dfinition de samples }
 if not Allouer_Samples(NbInstSAT) then begin
   Fin_Charge_Sample;
 end;

 for NSmp:=1 to NbInstSAT do begin
   Nouveau_Sample;
   if NSmp<30 then Move(SATNom^[NSmp].Nom,Smp.Nom,16);
   Smp.Info:=1;           { 1 => 'Sample' Adlib }
   inc(Nb_instruments);
   Smp.AVolume:=64;
   Smp.AC4Spd :=8363;
   with SATInstr^[NSmp] do begin
     Smp.AData.AM1:=SM1;
     Smp.AData.AP1:=SP1;
     Smp.AData.AM2:=SM2;
     Smp.AData.AP2:=SP2;
     Smp.AData.AM3:=SM3;
     Smp.AData.AP3:=SP3;
     Smp.AData.AM4:=SM4;
     Smp.AData.AP4:=SP4;
     Smp.AData.AM5:=SM5;
     Smp.AData.AP5:=SP5;
     Smp.AData.AFeedBack:=SFeedBack;
   end;
{   Writeln(Smp.Nom,':');
   with SMP.AData do Writeln(AM1,' ',AP1,' ',AM2,' ',AP2,' ',AM3,' ',AP3,
                            ' ',AM4,' ',AP4,' ',AM5,' ',AP5,' ',AFeedback);
   repeat until Readkey=#13;}

   Smp.Info:=(Smp.Info or M_Charge);
   Move(Smp,MUS.T^.PtrSamples[NSmp]^,sizeof(Smp)); { Copier le sample... }
 end;

 Fin_Charge_Sample;
end; {ChargeInstr}

{---------------------------------------------------------}

procedure Charge_SAT(chemin: String80; var erreur: WORD);
var FichSAT  : TSATHeader;
    nom_fich : String12;
    SATInstr : PtrSATInstr;
    SATNom   : PtrSATNom;
    i        : BYTE;
    freq     : BYTE;
    Rest,SeqLen : BYTE;

begin  {Charge_SAT}
 f_module.Ouvre(lecture,chemin);

 if f_erreur=f_ok then begin
  MUS_Efface;
  New(SATInstr);
  New(SATNom);

  f_module.LitPos(0,FICHSAT,sizeof(FICHSAT));
  Version:=FichSAT.Vers;

  MUS.H^.Type_Module:=T_SAT;
  nom_fich:=NomFichierSeul(chemin);

  MUS.H^.Tempo_depart:=6;
  MUS.H^.Nb_de_voies:=9;        { 9 voies mlodiques Adlib...         }
  MUS.H^.Nb_de_voies_Patt:=9;
  MUS.H^.BPM_depart:=125;       { A ajuster !!! }

{  Writeln('Version: ',FichSAT.Vers);}
  if Version<5 then begin
    f_module.Lit(SATInstr^,sizeof(SATInstr^));
    f_module.Lit(SATNom^,sizeof(SATNom^));
  end
  else begin
    for i:=1 to 31 do begin
      f_module.Lit(SATInstr^[i],11);
      f_module.DeplacePointeur(4);
    end;
    f_module.Lit(SATNom^,sizeof(SATNom^));
  end;
  f_module.DeplacePointeur(3);
  f_module.Lit(MUS.T^.Sequence,128);  { Lire la squence }
  if Version>5 then begin
    f_module.lit(Rest,1);
    f_module.DeplacePointeur(1);
    f_module.lit(SeqLen,1);
    f_module.DeplacePointeur(1);
    f_module.Lit(Freq,1);
    f_module.DeplacePointeur(513);
  end
  else begin
    f_module.DeplacePointeur(127);
    f_module.lit(Rest,1);
    f_module.DeplacePointeur(1);
    f_module.lit(SeqLen,1);
    f_module.DeplacePointeur(1);
    f_module.Lit(Freq,1);
    f_module.DeplacePointeur(1);
  end;

{  Writeln('Restart: ',Rest);
  Writeln('SeqLen: ',SeqLen);
  Writeln('Freq: ',Freq);}

  for i:=128 downto 1 do
   if MUS.T^.Sequence[i]<>0 then begin
     MUS.H^.Sequence_len:=i;
     break;
   end;

  Nb_Pattern:=0;
  for i:=1 to MUS.H^.Sequence_Len do
    if MUS.T^.Sequence[i]>Nb_Pattern then Nb_Pattern:=MUS.T^.Sequence[i];
  inc(Nb_Pattern);
{  Writeln('Seq Len: ', Musique^.Sequence_len);
  Writeln('Nb patt: ', Nb_Pattern);

  for i:=0 to 127 do Write(Table^.Sequence[i],'-');
  repeat until Readkey=#13;}

  ChargePatt;
  {Erreur_de_chargement:=Err_format;}
  ChargeInstr(SATInstr,SATNom);

  for i:=1 to 9 do MUS.T^.Voies_Adlib[i]:=i; { Allouer les voies Adlib }
  MUS.H^.Octave_Min:=0;
  MUS.H^.Octave_Max:=7;
  Fixer_Panning(TRUE);
  FillChar(MUS.T^.Type_Voie,MUS.H^.Nb_de_voies,2); { Voies Adlib... }
  Compter_Voies;

  Verifier_Module(Erreur_de_chargement);
  Erreur:=Erreur_de_chargement;
  Dispose(SATInstr);
  Dispose(SATNom);
  f_module.Ferme
 end
 else Erreur:=Err_lecture;  {Impossible d'ouvrir le fichier}

 if Erreur in [Ok,Err_samples] then MUS.Chargee:=TRUE else MUS_Efface;
end; {Charge_SAT}

END.
