{************************************************************************}
{                                CHSTM.PAS                               }
{                                                                        }
{  Loader pour les fichiers STM (crs par PSI de Future Crew).          }
{                                                                        }
{  AUTEUR: Freddy Vtel.                                                }
{                                                                        }
{                               Dbut d'criture le --/11/93             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}

{$UNDEF Groupe}

{$IFNDEF Groupe}
UNIT ChSTM;
{$ELSE}
UNIT ChSTM_G;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$IFNDEF Groupe}
USES Fichiers,Util,Memoire,Chutil,ModmVar,CRT;
{$ELSE}
USES Fich_grp,Util,Memoire,Chutil_G,ModmVar,CRT;
{$ENDIF}

procedure Charge_STM(chemin: String80; var erreur: WORD);

IMPLEMENTATION

CONST Max_Samples_STM=31;

TYPE Char8=array[1..8] of CHAR;

     T_STM_Instrument=record
                       Nom     : array[1..14] of CHAR;
                       fill1   : WORD;
                       Long    : WORD;
                       Debut_b,
                       Fin_b   : WORD;
                       Volume  : WORD;
                       C4Spd   : WORD;
                       Fill2   : array[1..6] of BYTE
                      end;

     T_En_tete_STM=record
                    Nom         : Char20;
                    Ident       : Char8;
                    Fill1       : LONGINT;
                    Tempo       : BYTE;
                    NPatterns   : BYTE;
                    Volume      : BYTE;
                    Fill2       : array[1..13] of BYTE;
                    Instruments : array[1..31] of T_STM_Instrument;
                    Sequence    : Byte128
                   end;

     Ptr_En_tete_STM=^T_En_tete_STM;

     T_Note_STM=record
                 b1,b2,b3,b4: BYTE
                end;

     T_Pattern_STM=array[1..256] of T_Note_STM;

     Ptr_patt_STM=^T_Pattern_STM;

{---------------------------------------------------------}

procedure Convertir_pattern(Pattern_STM: Ptr_Patt_STM; Pattern: Ptr_Patt;
                            STM: Ptr_En_Tete_STM);
var j: INTEGER;

begin
 for j:=1 to 64*4 do
  with Pattern_STM^[j] do begin
    C_Note.Instrument:=0;
    C_Note.Note:=0;

    if b1<>$FF then begin
      C_Note.Note:=b1;
       if ((C_Note.Note and $F0)>$70) or
          ((C_Note.Note and $F0)<$00) or
          ((C_Note.Note and $0F)>$0B) then C_Note.Note:=0;
      C_Note.Instrument:=b2 shr 3;
    end;

    if C_Note.Instrument>Max_Samples_STM then C_Note.Instrument:=0;
    C_Note.Parametre:=b4;
    C_Note.Volume:=((b3 and $F0) shr 1)+(b2 and $07);
    if C_Note.Volume>64 then C_Note.Volume:=255;

    case (b3 and $F) of
     0: C_Note.Commande:=Rien;
     1: begin
         C_Note.Commande:=SetTempo;
         C_Note.Parametre:=b4 shr 4
        end;
     2: C_Note.Commande:=JumpPattern;
     3: C_Note.Commande:=EndPattern;
     4: C_Note.Commande:=VolSlide;
     5: C_Note.Commande:=PortDown;
     6: C_Note.Commande:=PortUp;
     7: C_Note.Commande:=TonePortamento;
     8: C_Note.Commande:=Vibrato;
     9: C_Note.Commande:=Tremor;
     10: C_Note.Commande:=Arpeggio;
     11: C_Note.Commande:=Vib_VSlide;
     else C_Note.Commande:=Rien;
    end;

    if C_Note.Note<>0 then                 { Ajustement des notes... }
    C_Note.Note:=((C_Note.Note shr 4)+2)*12+(C_Note.Note and $0F)+1;

    if C_Note.Instrument <>0 then SamplFlags[C_Note.Instrument]:=TRUE;
    Pattern^[j]:=C_Note;
  end;
end; {Convertir_pattern}

{---------------------------------------------------------}

procedure ChargeSTM(STM: Ptr_En_Tete_STM);

var Nb_pattern: BYTE;
    i,j : INTEGER;
    Pattern_STM : Ptr_Patt_STM;

begin
 MUS.H^.Sequence_Len:=0;
 for i:=1 to 128 do if STM^.Sequence[i]<99 then MUS.H^.Sequence_Len:=i;
 Move(STM^.Sequence,MUS.T^.Sequence,128);

 Nb_pattern:=STM^.Npatterns;

{***          Charge les patterns          ***}

 Erreur_de_chargement:=Err_memoire;    { Si exit, Erreur de mmoire }
 New(Pattern_STM);

 for i:=1 to Nb_pattern do begin
   if not ReserveUMBDOS(Segment_actuel,sizeof(T_Note)*4*4) then begin
     Dispose(Pattern_STM);
     exit;
   end;

   Pointeur_Actuel:=Ptr(Segment_Actuel,0);
   MUS.T^.Pattern[i]:=Segment_Actuel;
   MUS.T^.Taille_Pattern[i]:=64;

   f_module.Lit(Pattern_STM^,256*4);
   Convertir_pattern(Pattern_STM,Pointeur_actuel,STM);
 end;

 Dispose(Pattern_STM);

{***            Charge les instruments            ***}

 Erreur_de_chargement:=Ok;
 Init_Charge_Sample;

 { Rserve l'espace DOS pour la dfinition de samples }
 if not Allouer_Samples(Max_Samples_STM) then begin
   Fin_Charge_Sample;
   exit;
 end;

 for NSmp:=1 to Max_Samples_STM do begin
   Nouveau_Sample;
   Move(STM^.Instruments[NSmp].Nom[1],Smp.Nom,14);{ Sauver le nom du sample }
   Smp.len:=STM^.Instruments[NSmp].long;
   with MUS.T^ do
    if Smp.len>0 then begin
      inc(Nb_instruments);

      with STM^.Instruments[NSmp] do   { Bouclage ???? }
       if (Debut_b<>0) or (Fin_b<>65535) then begin
         Smp.Rep:=Debut_b; Smp_Rep_fin:=Fin_b;
       end
       else begin
         Smp.Rep:=0; Smp_Rep_fin:=0;
       end;
      Smp.Volume:=STM^.Instruments[NSmp].volume;
      Smp.C4Spd:=STM^.Instruments[NSmp].C4Spd;

      Charger_sample;
    end;
   Move(Smp,MUS.T^.PtrSamples[NSmp]^,sizeof(Smp)); { Copier le sample... }
 end;

 Fin_Charge_Sample;
end; {ChargeSTM}

{---------------------------------------------------------}

procedure Charge_STM(chemin: String80; var erreur: WORD);
var STM: Ptr_En_tete_STM;
    nom_fich: String12;
    Tempo:BYTE;
    i:BYTE;

begin
 erreur:=Ok;
 f_module.Ouvre(lecture,chemin);

 if f_erreur=f_ok then begin
  MUS_Efface;
  New(STM);

  f_module.LitPos(0,STM^,sizeof(STM^));

  MUS.H^.Type_Module:=T_STM;          { type de module }
  Move(STM^.nom,MUS.H^.Titre,20);
  MUS.H^.Octave_Min:=2;
  MUS.H^.Octave_Max:=6;
  nom_fich:=NomFichierSeul(chemin);

  Tempo:=(STM^.Tempo shr 4);
  if Tempo=0 then Tempo:=6;
  MUS.H^.Pos_de_restart:=1;
  MUS.H^.Tempo_depart:=Tempo;

  MUS.H^.Nb_de_voies:=4;
  MUS.H^.Nb_de_voies_Patt:=4;

  Erreur_de_chargement:=Ok;
  for i:=1 to 128 do if STM^.Sequence[i]>99 then Erreur_de_chargement:=Err_Format;
  if STM^.Npatterns>99 then Erreur_de_chargement:=Err_Format;

  if Erreur_de_chargement=Ok then ChargeSTM(STM);


  FillChar(MUS.T^.Type_Voie,MUS.H^.Nb_de_voies,1); { Voies numriques... }
  Compter_Voies;
  Fixer_Panning(TRUE);

  Dispose(STM);
  Erreur:=Erreur_de_chargement;
  f_module.Ferme;
 end
 else Erreur:=Err_lecture;  {Impossible d'ouvrir le fichier}

 if Erreur in [Ok,Err_samples] then MUS.Chargee:=TRUE else MUS_Efface;
end; {Charge_STM}

END.
