{************************************************************************}
{                                CHULT.PAS                               }
{                                                                        }
{ Loader pour les fichiers ULT (Ultra Tracker V1.0  V1.6).              }
{                                                                        }
{ AUTEUR: Freddy Vtel.                                                 }
{                                                                        }
{                               Dbut d'criture le 14/05/95             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}
        { Attention au panning pour SBPro (Pas 40h partout !!!) }

{$UNDEF Groupe}

{$IFNDEF Groupe}
UNIT ChULT;
{$ELSE}
UNIT ChULT;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$IFNDEF Groupe}
USES Fichiers,Util,Memoire,Chutil,ModmVar,CRT;
{$ELSE}
USES Fich_grp,Util,Memoire,Chutil_G,ModmVar,CRT;
{$ENDIF}

TYPE Char15=array[1..15] of CHAR;

     Char32=array[1..32] of CHAR;
const
   Commandes_ULT:array[0..15] of BYTE=(Rien,PortUp,PortDown,TonePortamento,Vibrato,UltSpecial,Rien,
                                       Tremolo,Rien,SampleOffs,VolSlide,CPanning,SetVolume,EndPattern,
                                       Extended,SetTempo);
   NbVerULT = 4;
   IdentULT : array[1..NbVerULT] of Char15=('MAS_UTrack_V001',  { 1.0 -> 1.3 }
                                            'MAS_UTrack_V002',  { v1.4 }
                                            'MAS_UTrack_V003',  { v1.5 }
                                            'MAS_UTrack_V004'); { v1.6 }

type
     HeaderULT=record
                Ident:Char15;
                Titre:Char32;
                Reserve:BYTE;
               end;

     T_Smp_ULT=record    { Versions <1.6. sinon, ajouter Dadj}
                Nom:Char32;
                Nom_Fich:array[1..12] of CHAR;
                Rep:LONGINT;
                Rep_Fin:LONGINT;
                SizeStart:LONGINT;
                SizeEnd:LONGINT;
                Volume:BYTE;
                BidiLoop:BYTE;
                FineTune:WORD;
               end;

var VersionULT:BYTE;
    Nb_Smp_ULT:BYTE;
    Nb_Voies_ULT:BYTE;
    Nb_Pattern_ULT:BYTE;
    Position_Samples:LONGINT;
    Position_Actuelle:LONGINT;
    Table_Panning_ULT:array[1..32] of BYTE;

procedure Charge_ULT(chemin: String80; var erreur: WORD);

IMPLEMENTATION

{---------------------------------------------------------}

procedure Charge_Pattern_ULT;

const Taille_Tampon=1024;

var
    Pattern_ULT:array[0..Taille_Tampon-1] of BYTE;
    Index_ULT:INTEGER;
    Index:WORD;
    Pattern: Ptr_Patt;
    N_Pattern:BYTE;
    N_Voie:BYTE;
    N_Note:BYTE;
    Position_Pattern:WORD;
    Repeter:BOOLEAN;
    Nb_Repetitions:BYTE;
    Valeur:BYTE;
    Param,Param1:BYTE;
    Commd:BYTE;
    i:BYTE;

function Lire_Valeur:BYTE;
begin
 inc(Index_ULT);
 if Index_ULT=Taille_Tampon then begin
   f_module.Lit(Pattern_ULT,Taille_Tampon);
   inc(Position_Actuelle,Taille_Tampon);
   Index_ULT:=0;
 end;
 Lire_Valeur:=Pattern_ULT[Index_ULT];
end;

procedure Traiter_Commande_ULT;
begin
 if Commd=SetVolume then begin
   Commd:=Rien;
   C_Note.Volume:=Param shr 2;
 end;
 if (Commd<>Rien) and (C_Note.Commande<>SetTempo) then begin { set Tempo prioritaire }
   C_Note.Commande:=Commd;
   C_Note.Parametre:=Param;
 end;
 if C_Note.Commande=Extended then begin
   C_Note.Commande:=SetFilter+C_Note.Parametre shr 4;
   C_Note.Parametre:=C_Note.Parametre and $0F;
   if C_Note.Commande=SetFilter then C_Note.Commande:=VibrSweep;
 end;
end;

begin
 Index_ULT:=Taille_Tampon-1;

 for N_Pattern:=1 to Nb_Pattern_ULT do begin
  if not ReserveUMBDOS(Segment_actuel,sizeof(T_Note)*4*Nb_voies_ULT) then begin
    Erreur_de_chargement:=Err_memoire;
    exit;
  end;
  Pointeur_Actuel:=Ptr(Segment_Actuel,0);
  MUS.T^.Pattern[N_Pattern]:=Segment_Actuel;
 end;

 for N_Voie:=1 to Nb_Voies_ULT do begin { Boucle sur les voies   }
  for N_Pattern:=1 to Nb_Pattern_ULT do begin { Boucle sur les pattern }
   Pattern:=Ptr(MUS.T^.Pattern[N_Pattern],0);
   N_Note:=0;
   repeat
    Valeur:=Lire_Valeur;
    if Valeur=$FC then begin
      Repeter:=TRUE;
      Nb_Repetitions:=Lire_Valeur;
      Valeur:=Lire_Valeur;
    end
    else Repeter:=FALSE;
    if Valeur in [1..60] then C_Note.Note:=Valeur+2*12
                         else C_Note.Note:=0;
    C_Note.Instrument:=Lire_Valeur;
    C_Note.Volume:=$FF;
    C_Note.Commande:=Rien;
    C_Note.Parametre:=0;

    Valeur:=Lire_Valeur;
    Param1:=Lire_Valeur;  { Invers car WORD !!! }
    Param:=Lire_Valeur;

    Commd:=Commandes_ULT[Valeur shr 4];
    Traiter_Commande_ULT;
    Commd:=Commandes_ULT[Valeur and $0F];
    Param:=Param1;
    Traiter_Commande_ULT;

    if C_Note.Commande=CPanning then
      C_Note.Parametre:=Panning_GUS_SB(C_Note.Parametre);

    Position_Pattern:=N_Voie+N_Note*Nb_Voies_ULT;
    if C_Note.Instrument <>0 then SamplFlags[C_Note.Instrument]:=TRUE;
    if Repeter then begin
      for i:=1 to Nb_Repetitions do begin
        Pattern^[Position_Pattern]:=C_Note;
        inc(Position_Pattern,Nb_Voies_ULT);
      end;
      inc(N_Note,Nb_Repetitions);
    end
    else begin
      Pattern^[Position_Pattern]:=C_Note;
      inc(N_Note);
    end;
   until N_Note>=64;

   if N_Note>64 then begin { Si le nombre de notes ne tombe pas juste, erreur ! }
     Erreur_de_Chargement:=Err_Format;
     exit;
   end;
  end; { Boucle sur les Pattern }
 end;{ Boucle sur les voies }

 dec(Position_Actuelle,Taille_Tampon);
 inc(Position_Actuelle,Index_ULT+1); { Ici,Position actuelle est sur les  }
                                     { donnes des samples                }
end;

{---------------------------------------------------------}

procedure Charge_Samples_ULT;
var Smp_ULT:T_Smp_ULT;
    Smp_ULT_Dadj:WORD;

begin
 if Nb_Smp_ULT>Max_Samples then Nb_Smp_ULT:=Max_Samples;

 Init_Charge_Sample;

 { Rserve l'espace DOS pour la dfinition de samples }
 if not Allouer_Samples(Nb_Smp_ULT) then begin
   Fin_Charge_Sample;
   exit;
  end;

 Smp_ULT_Dadj:=0;

 for NSmp:=1 to Nb_Smp_ULT do begin
   f_module.LitPos(Position_Samples,Smp_ULT,sizeof(Smp_ULT));
   inc(Position_Samples,sizeof(Smp_ULT));
   if VersionUlt=4 then begin
     Smp_ULT_Dadj:=Smp_ULT.FineTune;
     inc(Position_Samples,2);
   end;
   Nouveau_Sample;
   Move(Smp_ULT.Nom,Smp.Nom,32); {Nom du sample }
   Smp.Info:=Smp_ULT.BidiLoop;   { 16 bit, Boucle, Bidi }
   Smp.Len:=Smp_ULT.SizeEnd-Smp_ULT.SizeStart;

   f_module.PlacePointeur(Position_Actuelle);
   if (Smp.Info and M_16Bit)=0 then inc(Position_Actuelle,Smp.Len)
                               else inc(Position_Actuelle,Smp.Len*2);

   if (Smp.Len>0) then begin
     inc(Nb_instruments);
     if ((Smp.Info and M_Boucle)=0) then begin { Pas de bouclage }
       Smp.Rep:=0;
       Smp_Rep_Fin:=0;
     end
     else { Bouclage        }
      if (Smp.Info and M_16Bit)>0 then begin
        Smp.Rep:=Smp_ULT.Rep shr 1;
        Smp_Rep_Fin:=Smp_ULT.Rep_Fin shr 1;
      end
      else begin
        Smp.Rep:=Smp_ULT.Rep;
        Smp_Rep_Fin:=Smp_ULT.Rep_Fin;
      end;

     Smp.Rep_Len:=0;
     Smp.Volume:=Smp_ULT.Volume shr 2;
     Smp.C4Spd:=Smp_ULT_Dadj;

     Charger_Sample;
   end;

   Move(Smp,MUS.T^.PtrSamples[NSmp]^,sizeof(Smp)); { Copier le sample... }
 end;

 Fin_Charge_Sample;
end; { Charge_Samples_ULT }

{---------------------------------------------------------}

procedure Charge_ULT(chemin: String80; var erreur: WORD);
label Fin_Chargement_ULT;
var
   ULT : ^HeaderULT;
   i   : INTEGER;
   nom_fich: String12;

begin
 erreur:=Ok;
 f_module.Ouvre(lecture,chemin);

 if f_erreur=f_ok then begin
  MUS_Efface;
  New(ULT);
  f_module.LitPos(0,ULT^,sizeof(ULT^));

  MUS.H^.Type_Module:=T_ULT;       { type de module  }
  MUS.H^.Octave_Min:=0;
  MUS.H^.Octave_Max:=7;
  Move(ULT^.Titre,MUS.H^.Titre,20);         { Titre du module }
  Nom_fich:=NomFichierSeul(chemin);

  VersionULT:=0;
  for i:=1 to NbVerUlt do if ULT^.Ident=IdentULT[i] then VersionULT:=i;
  if VersionULT=0 then begin { Erreur, identificateur non reconnus }
    Erreur_de_chargement:=Err_lecture;
    goto Fin_Chargement_ULT;  { Je sais, c'est un goto mais c'est pratique ;)}
  end;

  Position_Samples:=49;
  if ULT^.Reserve>0 then  { Eviter le texte... }
    if VersionULT>1 then begin
      Position_Samples:=49+(ULT^.Reserve)*32;
      f_module.PlacePointeur(Position_Samples-1);
    end;

  f_module.Lit(Nb_Smp_ULT,1);  { Lire le Nb de samples... }

{  Writeln('ID: ',ULT^.Ident,' => Version ',VersionULT);
  Writeln('Titre: ',ULT^.Titre);
  Writeln('Reserve: ',ULT^.Reserve);
  Writeln('Nb de samples: ',Nb_Smp_ULT);}

  if VersionUlt=4 then Position_Actuelle:=Position_Samples+Nb_Smp_ULT*66
                  else Position_Actuelle:=Position_Samples+Nb_Smp_ULT*64;

  f_module.PlacePointeur(Position_Actuelle);
  f_module.Lit(MUS.T^.Sequence,256); { Lire la squence... }
  f_module.Lit(Nb_Voies_ULT,1);
  f_module.Lit(Nb_Pattern_ULT,1);
  inc(Nb_Voies_ULT);
  inc(Nb_Pattern_ULT);
  if Nb_Voies_ULT>32 then Erreur_de_chargement:=Err_format;
  MUS.H^.Nb_de_voies:=NB_Voies_ULT;
  MUS.H^.Nb_de_voies_Patt:=Nb_Voies_ULT;

  { Table de Panning }
  inc(Position_Actuelle,258);
  if (VersionULT>2) and (Panning_Utilisable) then begin
    inc(Position_Actuelle,Nb_Voies_ULT);
    f_module.Lit(Table_Panning_ULT,Nb_Voies_ULT);
    for i:=1 to Nb_Voies_ULT do MUS.Panning[i]:=Panning_GUS_SB(Table_Panning_ULT[i] and $0F);
  end
  else Fixer_Panning(TRUE);

  for i:=1 to 256 do { Chercher la taille de la squence }
    if MUS.T^.Sequence[i]=$FF then begin
      MUS.H^.Sequence_Len:=i-1;
      break;
    end;

  if Erreur_de_chargement=Ok then Charge_Pattern_ULT;
  if Erreur_de_chargement=Ok then Charge_Samples_ULT;

  FillChar(MUS.T^.Type_Voie,MUS.H^.Nb_de_voies,1); { Voies numriques... }
  Compter_Voies;

{  repeat until Readkey=#13;}

Fin_Chargement_ULT:
  Dispose(ULT);

  Verifier_Module(Erreur_de_chargement);
  Erreur:=Erreur_de_chargement;
  f_module.Ferme
 end
 else
 Erreur:=Err_lecture;  {Impossible d'ouvrir le fichier}

 if Erreur in [Ok,Err_samples] then MUS.Chargee:=TRUE else MUS_Efface;
end; { Charge_ULT }

END.
