{************************************************************************}
{                               CHUTIL.PAS                               }
{                                                                        }
{  Routines pour le chargement des modules (Sample, Gestion des voies...)}
{                                                                        }
{  AUTEUR: Freddy Vtel.                                                }
{                                                                        }
{                               Dbut d'criture le --/10/94             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}
{$UNDEF Groupe}
{$UNDEF AFF}

{$IFNDEF Groupe}
UNIT ChUtil;       { Procdures pour simplifier le chargement des modules }
{$ELSE}
UNIT ChUtil_G;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$IFNDEF Groupe}
USES ModmVar,Fichiers,GUSUnit,Memoire,CRT;
{$ELSE}
USES ModmVar,Fich_grp,GusUnit,Memoire,CRT;
{$ENDIF}

CONST
    Avec_EMS=TRUE;

    GF1_REG_SELECT  = $103;  (* 3X3 *)

    SET_DRAM_LOW    = $43;
    SET_DRAM_HIGH   = $44;

    TailleFinSample = 512;
    TailleMaxSample = 65535-16*4-TailleFinSample;
    TailleMaxGUS    = 255*1024;
    SizeLBlock = 22 * 1024; { Buffer pour la Gravis }
    CSInit:BOOLEAN=FALSE;   { Charge sample initialis ??? }

TYPE TTSample=array[0..65000] of SHORTINT;
     TTampon_GUS=array[1..SizeLBlock+16] of BYTE;

VAR f_module: Fichier;        { fichier actuel }

   Pointeur_actuel: POINTER;  { Pointeur des zones mmoires pour le chargement }
   Segment_Actuel : WORD;

   Erreur_de_chargement:WORD;

   NSmp :WORD;                   { N du sample actuel     }
   Convertir_signe:BOOLEAN;
   Deplacement_pointeur_fichier:WORD;

   Smp:T_Sample;                 { Informations sur le sample a charger }
   Smp_Rep_Fin:WORD;

   C_Note:T_Note;

   Nb_Instruments: BYTE;         { Gestion du nombre de samples         }
   Nb_Pas_charge : BYTE;
   SamplFlags:array[1..Max_Samples] of BOOLEAN;

   P_Gauche,P_Droite:BYTE;

   Ancien_Delta:WORD;            { Pour les samples cods en Delta !!!  }


function  Periode2Note(Periode: WORD):BYTE;
procedure Fixer_Panning(Initialiser:BOOLEAN); { Init la position des voies  }
function  Panning_GUS_SB(Panning:BYTE):BYTE;
procedure Nouveau_Sample;
function  Allouer_Samples(Nb_Samples:BYTE):BOOLEAN;
procedure Init_Charge_Sample;
procedure Ajuster_Sample;
procedure Charger_Sample;
procedure Fin_Charge_Sample;
procedure Compter_Voies;
procedure Verifier_Module(var Err:WORD);
procedure MUS_Init;                           { Efface les variables du module }
procedure MUS_Efface;                         { Effacer le module           }


{====================================================}

IMPLEMENTATION

VAR
   Pointeur_Tampon_GUS:^TTampon_GUS;  { Variables pour la GUS }
   Taille_GUS:WORD;
   Taille_pas_transferee:WORD;
   BlockSize:WORD;

procedure RAMTODRAM(Valeur_XOR:BYTE;Adresse:LONGINT);

VAR Port_Base:WORD;
    Seg_DRAM:WORD;
    Offs_DRAM:WORD;
    Seg_Tampon:WORD;
    Offs_Tampon:WORD;

begin
 Port_Base:=Ultra_Config.Base_Port+GF1_REG_SELECT;
 Seg_DRAM:=Adresse shr 16;
 Offs_DRAM:=Adresse and $FFFF;

{ Dump sample to DRAM                        }
{   DS:SI - Max 64k sample to dump to RAM.   }
{   SI:BX - DRAM location to dump to.        }
{   CX    - Max bytes to dump.               }
{   AH    - xor value.                       }

 asm
   cli
   push    CX
   mov     AH,Valeur_XOR
   mov     BX,SEG_DRAM
   mov     DI,Offs_DRAM
   mov     CX,BlockSize
   mov     DX,Port_Base
   push DS
   lds     SI,Pointeur_Tampon_GUS
   mov     AL,SET_DRAM_HIGH{ Dump upper BYTE, only do it on carry from now}
   out     DX,AL           { on.                                          }
   add     DX,2
   push    AX
   mov     AX,BX           { SI Partie haute de l'adresse }
   out     DX,AL           { 3x5 Data High }
   pop     AX
   sub     DX,2
 @MainLoop:
   mov     AL,SET_DRAM_LOW
   out     DX,AL           { 3x3 Select Register }
   inc     DX
   push    AX
   mov     AX,DI
   out     DX,AX           { 3x4 Data Low }
   pop     AX
   dec     DX
 @DumpByte:
   add     DX,4
   lodsb
   xor     AL,AH
   out     DX,AL           { 3x7 DRAM }
   sub     DX,4
   add     DI,1
   jnc     @DoLoop         { Passe a une autre banque (SI>65536)}
   inc     BX
   mov     AL,SET_DRAM_HIGH
   out     DX,AL           { 3x3 Select Register }
   add     DX,2
   push    AX
   mov     AX,BX           { SI Partie haute de l'adresse }
   out     DX,al           { 3x5 Data High }
   pop     AX
   sub     DX,2
 @DoLoop:
   loop    @MainLoop
   pop     DS
   pop     CX
   sti
 end;
end; {RAMTODRAM}

{-------------------------------------------------------------------}

function Periode2Note(periode: WORD): BYTE;
var Note,i: BYTE;
begin
 Note:=0;
 Periode:=2*Periode;

 if Periode>PeriodArray[Max_Notes-1] then
  for i:=0 to Max_Notes-1 do
   if Periode>=PeriodArray[i] then begin
     Note:=i+1;
     if (Periode>PeriodArray[i]) and
        ((Periode-PeriodArray[i])>(PeriodArray[i-1]-Periode)) then dec(Note);
     break;
   end;

 Periode2Note:=Note;
end; {Periode2Note}

{-------------------------------------------------------------------}

procedure Fixer_Panning(Initialiser:BOOLEAN);
var i:BYTE;
begin
 P_Gauche:=Panning_Gauche;
 P_Droite:=Panning_Droite;

 if Initialiser then with MUS.T^ do begin
   MUS.Panning[1]:=P_Gauche;
   for i:=2 to MUS.H^.Nb_de_voies do
    if Odd(i div 2) then MUS.Panning[i]:=P_Droite else MUS.Panning[i]:=P_Gauche;
 end;
end; {Fixer_Panning}

{-------------------------------------------------------------------}

procedure Convertir_Delta8(var Tampon;Taille:WORD);  assembler;
asm
  mov AL,BYTE(Ancien_Delta)
  push DS
  mov CX,Taille
  lds SI,Tampon

@Boucle_Delta:
  add AL,DS:[SI]
  mov DS:[SI],AL
  inc SI
  dec CX
  jnz @Boucle_Delta

  pop DS
  mov BYTE(Ancien_Delta),AL
end; {Convertir_Delta8}

{-------------------------------------------------------------------}

function Panning_GUS_SB(Panning:BYTE):BYTE;
{ Panning 0-F -> Panning 0-$80 }
var val:BYTE;
begin
 if Panning>15 then Panning:=15;
 Val:=8*(Panning+1);
 if Val=8 then Val:=0;
 Panning_GUS_SB:=Val;
end; {Panning_GUS_SB}

{-------------------------------------------------------------------}

procedure Charge_en_memoire;  { Charge le sample dans la RAM }

VAR TabSample:^TTSample absolute Pointeur_actuel;
    j:INTEGER;
    SizeDone:LONGINT;
    LoadSize:LONGINT;
    PosFSample:INTEGER;
    Pointeur_Bouclage:POINTER;
    Pointeur_Fin:POINTER;
    Pointeur_Trans:POINTER;
    TailleTransFin:INTEGER;
    HoldBite:SHORTINT;
    SRep_Len:WORD;


procedure Convertir16to8(var Source,Destination;Taille,OffsetT:WORD); assembler;
asm
  push DS
  mov CX,Taille
  lds SI,Source
  inc SI
  les DI,Destination
  add DI,OffsetT
 @Boucle_convert:
  mov AL,[SI]
  mov ES:[DI],AL
  add SI,2
  inc DI
  dec CX
  jne @Boucle_convert
  pop DS
end;

begin
 with MUS.T^ do
  if not ReserveBloc(Smp.Mem,((Smp.len+TailleFinSample) div 16)+3,Utilise_UMB,Utilise_EMS) then begin
    { Pas assez de mmoire }
    inc(Nb_Pas_Charge);
    inc(Deplacement_pointeur_fichier,Smp.Len);
    if (Smp.Info and M_16Bit>0) then inc(Deplacement_pointeur_fichier,Smp.Len);
  end
  else begin { Pas Erreur de mmoire }
    Pointeur_actuel:=Ptr(Smp.Mem.Segment,0);

    Ancien_Delta:=0;
    if (Smp.Info and M_16Bit)>0 then begin  { Convertir 16 bit => 8 Bit }
      New(Pointeur_Tampon_GUS);
      SizeDone:=0;
      LoadSize:=Smp.Len shl 1;
      while SizeDone < LoadSize do begin
        if ((LoadSize-SizeDone)>SizeLBlock) then BlockSize:=SizeLBlock
                                            else BlockSize:=LoadSize-SizeDone;

        f_module.Lit(Pointeur_Tampon_GUS^,BlockSize);

        if (Smp.Info and M_Delta)>0 then
          Convertir_Delta8(Pointeur_Tampon_GUS^,BlockSize);

        Convertir16to8(Pointeur_Tampon_GUS^,Pointeur_actuel^,Blocksize shr 1,SizeDone shr 1);
        inc(SizeDone, BlockSize);
      end;
      Dispose(Pointeur_Tampon_GUS);
      Smp.Info:=Smp.Info and not M_16Bit; { Plus 16 bit ... }
    end
    else begin  { Sample 8 bit }
      f_module.Lit(Pointeur_actuel^,Smp.Len);  { Lire le sample dans le fichier }
      Ancien_Delta:=0;
      if (Smp.Info and M_Delta)>0 then Convertir_Delta8(Pointeur_actuel^,Smp.Len);
    end;

    if Convertir_signe then
      asm
       push DS
       mov CX,WORD(Smp.len)
       lds SI,Pointeur_actuel
       mov AX,8080h
       shr CX,1
       jnc @Boucle_convert
      @Boucle_convert:
       xor [SI],AX
       add SI,2
       dec CX
       jne @Boucle_convert
       pop DS
      end;
    PosFSample:=0;

    Pointeur_Fin:=Ptr(Seg(Pointeur_actuel^)+(Smp.Len-1) shr 4,Ofs(Pointeur_actuel^)+(Smp.Len-1) mod 16);
    if Smp_Rep_Fin=0 then       { Etendre le sample avec le bouclage... }
      FillChar(Pointeur_Fin^,TailleFinSample,0)
    else begin
      SRep_Len:=Smp.Rep_Len;
      if SRep_Len>0 then begin
        dec(SRep_Len);
        dec(Smp.Rep_Len);
      end;
      PosFSample:=0;
      Pointeur_Bouclage:=Ptr(Seg(Pointeur_actuel^)+Smp.Rep shr 4,Ofs(Pointeur_actuel^)+Smp.Rep mod 16);
      Pointeur_Trans:=Pointeur_Fin;
      repeat
       if SRep_Len>=TailleFinSample then TailleTransFin:=TailleFinSample
       else
        if PosFSample+SRep_Len<TailleFinSample then TailleTransFin:=SRep_Len
        else TailleTransFin:=TailleFinSample-PosFSample;
       PosFSample:=PosFSample+TailleTransFin;
       Move(Pointeur_Bouclage^,Pointeur_Trans^,TailleTransFin);
       Pointeur_Trans:=Ptr(Seg(Pointeur_Trans^)+TailleTransFin shr 4,Ofs(Pointeur_Trans^)+TailleTransFin mod 16);
      until PosFSample>=TailleFinSample;
    end;    { Fin de l'extension du sample }

    Smp.Info:=(Smp.Info or M_Charge);
  end;
end; {Charge_en_memoire}

{-------------------------------------------------------------------}

procedure Charge_Sample_GUS;

VAR IMemLoc:LONGINT;
    SizeDone:LONGINT;
    LoadSize:LONGINT;
    HoldBite:BYTE;
    i:INTEGER;
    Test:SHORTINT;

begin
 with MUS.T^ do begin
{  Writeln('Alloc: ',Smp.Len+2,' Octets (',(Smp.Len+2) div 1024,'Ko)');}
  if not UltraMemAlloc(Smp.Len+2,IMemLoc) then begin
   inc(Nb_Pas_Charge);
   inc(Deplacement_pointeur_fichier,Smp.Len);
   if (Smp.Info and M_16Bit>0) then inc(Deplacement_pointeur_fichier,Smp.Len);
  end
  else begin
{   Writeln('Position: ',IMemLoc,'(',IMemLoc div 1024,')');}
   Smp.Info:=(Smp.Info or M_Charge);
   Smp.Adresse_GUS:=IMemLoc;
   LoadSize := Smp.Len;
   SizeDone := 0;
   Ancien_Delta:=0;

   while SizeDone < LoadSize do begin { Boucle de chargement }
    if ((LoadSize-SizeDone)>SizeLBlock) then BlockSize:=SizeLBlock
                                        else BlockSize:=LoadSize-SizeDone;

    f_module.Lit(Pointeur_Tampon_GUS^,BlockSize);
    if (Smp.Info and M_Delta)>0 then
       Convertir_Delta8(Pointeur_Tampon_GUS^,BlockSize);

    if not Convertir_signe then RAMTODRAM(  0,IMemLoc+SizeDone)
                           else RAMTODRAM($80,IMemLoc+SizeDone);
    inc(SizeDone, BlockSize);
   end;

   if (Smp.Info and M_16Bit>0) then begin
    if Smp_Rep_Fin>0 then begin { Fin du bouclage:=Debut du bouclage }
      HoldBite := UltraPeekData(Ultra_Config.Base_Port,IMemLoc+Smp.Rep-1);
      UltraPokeData(Ultra_Config.Base_Port,IMemLoc+Smp_Rep_Fin,HoldBite-1);
      HoldBite := UltraPeekData(Ultra_Config.Base_Port,IMemLoc+Smp.Rep);
      UltraPokeData(Ultra_Config.Base_Port,IMemLoc+Smp_Rep_Fin,HoldBite);
    end
    else begin { Fin+1 := Fin }
      HoldBite := UltraPeekData(Ultra_Config.Base_Port,IMemLoc+Smp.Len-2);
      UltraPokeData(Ultra_Config.Base_Port,IMemLoc+Smp.Len,HoldBite-1);
      HoldBite := UltraPeekData(Ultra_Config.Base_Port,IMemLoc+Smp.Len-1);
      UltraPokeData(Ultra_Config.Base_Port,IMemLoc+Smp.Len,HoldBite);
    end;
   end
   else begin
    if Smp_Rep_Fin>0 then begin { Fin du bouclage:=Debut du bouclage }
      HoldBite := UltraPeekData(Ultra_Config.Base_Port,IMemLoc+Smp.Rep);
      UltraPokeData(Ultra_Config.Base_Port,IMemLoc+Smp_Rep_Fin,HoldBite);
      UltraPokeData(Ultra_Config.Base_Port,IMemLoc+Smp_Rep_Fin+1,HoldBite);
    end
    else begin { Fin+1 := Fin }
      HoldBite := UltraPeekData(Ultra_Config.Base_Port,IMemLoc+Smp.Len-1);
      UltraPokeData(Ultra_Config.Base_Port,IMemLoc+Smp.Len,HoldBite);
    end;
   end;
   Smp.Info:=(Smp.Info or M_Charge);
  end;
 end;
end; {Charge_Sample_GUS}

{-------------------------------------------------------------------}

procedure Nouveau_Sample;
var Anc_Smp:POINTER;
begin
 FillChar(Smp,sizeof(Smp),0); { Efface Smp !!! }
 if NSmp>1 then begin
   Anc_Smp:=MUS.T^.PtrSamples[NSmp-1];
   MUS.T^.PtrSamples[NSmp]:=Ptr(Seg(Anc_Smp^),Ofs(Anc_Smp^)+sizeof(Smp));
 end;
end; {Nouveau_Sample}

{-------------------------------------------------------------------}

function Allouer_Samples(Nb_Samples:BYTE):BOOLEAN; { Allouer la zone mmoire pour les Samples }
var Taille_a_allouer:LONGINT;
begin
 NSmp:=0;
 Taille_a_allouer:=((Nb_Samples*sizeof(Smp)) div 16) +1;
 if not ReserveUMBDOS(MUS.SegSamples,Taille_a_allouer) then begin
   MUS.SegSamples:=0;
   Erreur_de_chargement:=Err_Memoire;
   Allouer_Samples:=FALSE;
 end
 else begin
   MUS.T^.PtrSamples[1]:=Ptr(MUS.SegSamples,0);
   Allouer_Samples:=TRUE;
   MUS.H^.Nb_Total_Samples:=Nb_Samples;
 end;
end; {Allouer_Samples}

{-------------------------------------------------------------------}

procedure Init_Charge_Sample;
var i:BYTE;
    adr_reelle:LONGINT;
    Segm,offs:LONGINT;
    Pointeur_Temp:POINTER;

begin
 if not CSInit then begin
   CSInit:=TRUE;
   Nb_instruments:=0;
   Nb_Pas_charge:=0;

 { Prparation pour le chargement dans la Gravis }
  if Variables^.Sortie_sonore=GUS then
     New(Pointeur_Tampon_GUS);   { Allouer le tampon de 32ko pour la Gravis }
 end;
end; {Init_Charge_Sample}

{-------------------------------------------------------------------}

procedure Ajuster_Sample;
begin
{$IFDEF AFF}
 Writeln('Avant Ajustement (Sample N',NSmp,')');
 Write('Info : ',Smp.Info,' ');
 if (Smp.Info and M_Charge)>0 then Write('Charg ');
 if (Smp.Info and M_Bidi)>0 then Write('Bidi ');
 if (Smp.Info and M_Boucle)>0 then Write('Boucle ');
 if (Smp.Info and M_16Bit)>0 then Write('16 bit ');
 Writeln;
 Writeln('Nom  : ',Smp.Nom);
 Writeln('Longueur: ',Smp.Len);
 Writeln('Rep     : ',Smp.Rep);
 Writeln('Rep_Len : ',Smp.Rep_Len);
 Writeln('Rep_Fin : ',Smp_Rep_Fin);
 Writeln('Volume  : ',Smp.Volume);
 Writeln('Dadj    : ',Smp.C4Spd);
{$ENDIF}

 if Smp_Rep_fin>0 then Smp.rep_len:=Smp_rep_fin-Smp.rep+1;

 Deplacement_pointeur_fichier:=0;
 if Smp_rep_fin>(Smp.len-1) then begin
   Smp_rep_fin:=(Smp.len-1);{ Smp.fin et pas Smp.len !!! }
   Smp.rep_len:=Smp_rep_fin-Smp.rep+1;
 end;
 if (Smp_rep_fin<3) or (Smp.rep_len<3) or (Smp.rep>(Smp.len-1)) then begin
   Smp.rep:=0; Smp_rep_fin:=0; Smp.rep_len:=0;
 end
 else begin
   if (Smp.Len-1)>Smp_Rep_fin then begin  { Fin du sample=fin du bouclage }
     Deplacement_Pointeur_fichier:=(Smp.Len-1)-Smp_Rep_fin;
     Smp.Len:=Smp_Rep_fin+1;
   end;
   Smp.Info:=Smp.Info or M_Boucle; { Sample avec bouclage... }
 end;

 if (Smp.len>TailleMaxSample) and (Variables^.Sortie_Sonore<>GUS) then begin
   { Tester si sample >TailleMaxSample Octets }
   Deplacement_Pointeur_fichier:=Deplacement_Pointeur_fichier+(Smp.len-TailleMaxSample);
   Smp.len:=TailleMaxSample;     { Couper le sample               }
   Smp.rep:=0;
   Smp.rep_Len:=0;
   Smp_rep_fin:=0;
   Smp.Info:=Smp.Info and not(M_Boucle); { Sample sans bouclage... }
 end;     { charger les TailleMaxSample Premiers octets }

 if (Smp.len>TailleMaxGUS) and (Variables^.Sortie_Sonore=GUS) then begin
   { Tester si sample >TailleMaxSample Octets }
   Deplacement_Pointeur_fichier:=Deplacement_Pointeur_fichier+(Smp.len-TailleMaxGUS);
   Smp.len:=TailleMaxGUS;     { Couper le sample               }
   Smp.rep:=0;
   Smp.rep_Len:=0;
   Smp_rep_fin:=0;
   Smp.Info:=Smp.Info and not(M_Boucle); { Sample sans bouclage... }
 end;     { charger les TailleMaxSample Premiers octets }

{ if (Variables^.Sortie_sonore<>GUS) and (Smp.Info and M_16Bit<>0) then Smp.Len:=0;}
end; {Ajuster_Sample}

{-------------------------------------------------------------------}

procedure Charger_Sample;
VAR
  j:INTEGER;
  Inst:^T_Sample;
begin
 Smp.Mem.Handle_EMS:=$FFFF;
 Smp.Adresse_GUS:=-1;
 Ajuster_Sample;

 if SamplFlags[NSmp] then begin
  if Smp.Len<>0 then
    if Variables^.Sortie_sonore=GUS then begin
      if (Smp.Info and M_16Bit>0) then begin {Si instrument 16 bit, taille*2 ! }
        Smp.Len:=Smp.Len shl 1;
        Smp.Rep:=Smp.Rep shl 1;
        Smp.Rep_Len:=Smp.Rep_Len shl 1;
        Smp_Rep_Fin:=Smp_Rep_Fin shl 1;
        Charge_Sample_GUS;
        Smp.Len:=Smp.Len shr 1;
        Smp.Rep:=Smp.Rep shr 1;
        Smp.Rep_Len:=Smp.Rep_Len shr 1;
        Smp.Adresse_GUS:=Smp.Adresse_GUS shr 1;
        Smp_Rep_Fin:=Smp_Rep_Fin shr 1;
        Deplacement_pointeur_fichier:=Deplacement_pointeur_fichier shl 1
      end
      else Charge_Sample_GUS;
    end
    else Charge_en_Memoire;
 end
 else begin  { Ne pas charger le sample => Dplacement dans le fichier... }
  dec(Nb_instruments);
  inc(Deplacement_pointeur_fichier,Smp.Len);
  if (Smp.Info and M_16Bit>0) then inc(Deplacement_pointeur_fichier,Smp.Len);
 end;

 {Sauter un sample ou la fin d'un gros sample }
 if Deplacement_pointeur_fichier>0 then
   f_module.DeplacePointeur(Deplacement_pointeur_fichier);

 if (Smp.Info>127) and (Smp.len>0) then
   if (Smp.Info and M_16Bit>0) then dec(Smp.len,2)
                               else dec(Smp.Len);

{$IFDEF AFF}
 Writeln('Aprs Ajuster (Sample N',NSmp,')');
 Write('Info: ',Smp.Info,' ');
 if (Smp.Info and M_Charge)>0 then Write('Charg ');
 if (Smp.Info and M_Bidi)>0 then Write('Bidi ');
 if (Smp.Info and M_Boucle)>0 then Write('Boucle ');
 if (Smp.Info and M_16Bit)>0 then Write('16 bit ');
 Writeln;
 Writeln('Longueur: ',Smp.Len);
 Writeln('Rep     : ',Smp.Rep);
 Writeln('Rep_Len : ',Smp.Rep_Len);
 Writeln('Rep_Fin : ',Smp_Rep_Fin);
 Writeln('Volume  : ',Smp.Volume);
 Writeln('Dadj    : ',Smp.C4Spd);
 if Smp.Adresse_GUS<>-1 then
   Writeln('Adresse GUS : ',Smp.Adresse_GUS)
 else begin
   Writeln('Mem.Segment : ',Smp.Mem.Segment);
   Writeln('Mem.Handle_EMS : ',Smp.Mem.Handle_EMS);
   Writeln('Mem.Nb_Pages_EMS : ',Smp.Mem.Nb_Pages_EMS);
 end;
 Writeln('Deplacement Fichier: ',Deplacement_Pointeur_Fichier);
 repeat until Readkey=#13;
{$ENDIF}
end; { Charger_sample }

{-------------------------------------------------------------------}

procedure Fin_Charge_Sample;
begin
 if CSInit then begin
  CSInit:=FALSE;
  if (Variables^.Sortie_sonore=GUS) then Dispose(Pointeur_Tampon_GUS);

  MUS.H^.Nb_Samples:=Nb_instruments;
  if Erreur_de_Chargement=Ok then begin
    if Nb_Pas_charge<>0 then Erreur_de_chargement:=Err_Samples;
    if Nb_instruments-Nb_Pas_charge=0 then Erreur_de_chargement:=Err_Pas_Sample;
  end;
  MUS.H^.nb_reel_samples:=Nb_instruments-Nb_Pas_charge;
 end;
end; {Fin_Charge_sample}

{-------------------------------------------------------------------}

procedure Compter_Voies;
var i:BYTE;
begin
 MUS.H^.Nb_Voies_Digit:=0;
 MUS.H^.Nb_Voies_Adlib:=0;
 for i:=1 to MUS.H^.Nb_de_voies do
   if MUS.T^.Type_Voie[i]=1 then inc(MUS.H^.Nb_Voies_Digit)
   else if MUS.T^.Type_Voie[i]=2 then inc(MUS.H^.Nb_Voies_Adlib);
end; {Compter_Voies}

{-------------------------------------------------------------------}

procedure Verifier_Module(var Err:WORD);
begin
 Fin_Charge_Sample;
 if Err=Ok then begin
   with MUS.H^ do begin
    if Nb_de_voies_patt=0 then Nb_de_voies_patt:=Nb_de_voies;
    if (Nb_de_voies=0) then Err:=Err_format;
   end;
 end;
end; {Verifier_Module}

{-------------------------------------------------------------------}

procedure SMP_Efface(Smp:T_Sample);  { Effacer le sample }
begin
  { Restaurer la taille du sample }
  inc(Smp.Len,1+2);
  if (Smp.Info and M_16Bit>0) then begin
   Smp.len:=Smp.Len shl 1;
   Smp.Adresse_GUS:=Smp.Adresse_GUS shl 1;
  end;
  { Effacer le sample }
  if ((Smp.Info and M_Charge)<>0) and ((Smp.Info and M_Adlib)=0) then
   if Smp.Adresse_GUS<>-1 then begin
     UltraMemFree(Smp.Len,Smp.Adresse_GUS);
   end
   else LibereBloc(Smp.Mem);
end; {SMP_Efface}

{-------------------------------------------------------------------}

procedure MUS_Init;
begin
 with MUS.T^ do begin
   FillChar(Tempo_Pattern,Max_Pattern,0);
   FillChar(Taille_Pattern,Max_Pattern,64);
   FillChar(Pattern,Max_Pattern,0);
   FillChar(PtrSamples,sizeof(PtrSamples),0);{ Efface les samples }
   FillChar(Type_Voie,sizeof(Type_Voie),0);
   FillChar(Voies_Adlib,11,0);
 end;

 FillChar(SamplFlags,sizeof(SamplFlags),0);

 with MUS.H^ do begin
   FillChar(Titre,sizeof(Titre),0);
   Vitesse_Ticks:=50;      { Nb de ticks par seconde }
   BPM_depart:=$7D;
   Tempo_Depart:=6;
   Volume_General_depart:=64;
   Volume_Sl_rapide:=FALSE;
   Nb_de_voies     :=0;
   Nb_de_voies_patt:=0;
   Nb_voies_digit  :=0;
   Nb_voies_Adlib  :=0;
   Nb_Total_Samples:=0;
   Sequence_Len    :=0;
 end;

 with Variables^ do begin
   Panning_Utilisable:=(Sortie_Sonore=GUS) or ((Utiliser_Panning and Utilise_Stereo) and (Sortie_Sonore=SBPro));
   BPM_Base:=125;
 end;

 MUS.SegSamples:=0;
 MUS.Chargee:=FALSE;
end; {MUS_Init}

{-------------------------------------------------------------------}

procedure MUS_Efface;  { Effacer les tables du module }

var Inst:^T_Sample;
    i:INTEGER;

begin
 { Libere les pattern }
 for i:=Max_Pattern downto 1 do LibereUMBDOS(MUS.T^.Pattern[i]);

 { Libere les samples }
 for i:=Max_Samples downto 1 do
   if MUS.T^.PtrSamples[i]<>nil then SMP_Efface(MUS.T^.PtrSamples[i]^);

 if MUS.SegSamples<>0 then LibereUMBDOS(MUS.SegSamples);

 MUS_Init;

 Erreur_de_Chargement:=Ok;
 Convertir_signe:=FALSE;
{ Writeln('Apres MUS_Efface');
 DisplayMem; }
end; {MUS_Efface}

END.
