{ͻ}
{                      --== CLAVIER.PAS ==--                       }
{                                                                      }
{ Unit pour grer le clavier avec les codes tendus                   }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 286           Dbut d'criture ??/??/93 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT Clavier;

{$A+,G+,Q-,R-,S-}

INTERFACE

CONST {constantes de touches - codes standards et tendus (9 bits)}
      Esc=27;
      Enter=13; CtrlEnter=10; AltEnter=20;
      Space=32;
      Bdel=8; CtrlBdel=127; AltBdel=14;

      Del=339; CtrlDel=403; AltDel=419;
      Ins=338; CtrlIns=402; AltIns=418;

      Tab=9; ShiftTab=271; CtrlTab=404; AltTab=421;

      F1=315; F2=316; F3=317; F4 =318; F5 =319; F6 =320;
      F7=321; F8=322; F9=323; F10=324; F11=325; F12=326;

      ShiftF1=340; ShiftF2=341; ShiftF3=342; ShiftF4 =343; ShiftF5 =344; ShiftF6 =345;
      ShiftF7=346; ShiftF8=347; ShiftF9=348; ShiftF10=349; ShiftF11=391; ShiftF12=392;

      CtrlF1=350; CtrlF2=351; CtrlF3=352; CtrlF4 =353; CtrlF5 =354; CtrlF6 =355;
      CtrlF7=356; CtrlF8=357; CtrlF9=358; CtrlF10=359; CtrlF11=393; CtrlF12=394;

      AltF1=360; AltF2=361; AltF3=362; AltF4 =363; AltF5 =364; AltF6 =365;
      AltF7=366; AltF8=367; AltF9=368; AltF10=369; AltF11=395; AltF12=396;

      Home=327; End_ =335;
      PgUp=329; PgDn =337;
      Left=331; Right=333;
      Up  =328; Down =336;

      CtrlHome=375; CtrlEnd  =373;
      CtrlPgUp=388; CtrlPgDn =374;
      CtrlLeft=371; CtrlRight=372;
      CtrlUp  =397; CtrlDown =401;

      AltHome=407; AltEnd  =415;
      AltPgUp=404; AltPgDn =417;
      AltLeft=411; AltRight=413;
      AltUp  =408; AltDown =416;

      AltA=286; AltB=304; AltC=302; AltD=288; AltE=274;
      AltF=289; AltG=290; AltH=291; AltI=279; AltJ=292;
      AltK=293; AltL=294; AltM=306; AltN=305; AltO=280;
      AltP=281; AltQ=272; AltR=275; AltS=287; AltT=276;
      AltU=278; AltV=303; AltW=273; AltX=301; AltY=277;
      AltZ=300;

      LettreAlt: array[AltQ..AltM] of CHAR='QWERTYUIOP    ASDFGHJKL     ZXCVBNM';

      Alt1=376; Alt2=377; Alt3=378; Alt4=379; Alt5=380;
      Alt6=381; Alt7=382; Alt8=383; Alt9=384; Alt0=385;

      ChiffreAlt: array[Alt1..Alt0] of BYTE=(1,2,3,4,5,6,7,8,9,0);

      {constantes d'tat clavier}
      ShiftD =$01;
      ShiftG =$02;
      Ctrl   =$04;
      Alt    =$08;
      ScrMode=$10;
      NumMode=$20;
      MajMode=$40;
      InsMode=$80;

      {modes d'tat correspondant aux 3 LEDs du clavier}
      LEDs=NumMode or MajMode or ScrMode;

TYPE Key=WORD;

VAR EtatClavier: BYTE absolute $40:$17;

{================================================}

function ReadKey: Key;
function KeyPressed: BOOLEAN;
function Chr(touche: Key): CHAR;
function UpCase(touche: Key): Key;

procedure ActiveMode(mode: BYTE);
procedure DesactiveMode(mode: BYTE);

procedure VideBufferClavier;
procedure VitesseClavier(delai,vitesse: BYTE);

{================================================}

IMPLEMENTATION

{================================================}

function ReadKey: Key; assembler;
{renvoie le code ASCII ou le code tendu (>256) de la touche}
asm
 mov AH,00h
 int 16h
 or  AL,AL
 jz  @code_etendu
 xor AH,AH
 jmp @fin
@code_etendu:
 mov AL,AH
 mov AH,1
@fin:
end; {ReadKey}

{------------------------------------------------}

function KeyPressed: BOOLEAN; assembler;
asm
 mov AH,01h
 int 16h
 mov AL,TRUE
 jnz @fin
 mov AL,FALSE
@fin:
end; {KeyPressed}

{------------------------------------------------}

function Chr(touche: Key): CHAR; assembler;
asm
 mov AX,touche
 or  AH,AH
 jz  @fin
 xor AL,AL
@fin:
end; {Chr}

{------------------------------------------------}

function UpCase(touche: Key): Key; assembler;
asm
 mov AX,touche
 or  AH,AH
 jnz @fin
 cmp AL,'a'
 jb  @fin
 cmp AL,'z'
 ja  @fin
 sub AL,32
@fin:
end; {UpCase}

{------------------------------------------------}

procedure ActiveMode(mode: BYTE);
{mode=ScrMode, NumMode, MajMode ou InsMode}
begin
 EtatClavier:=EtatClavier or mode;
 asm
  mov AH,01h
  int 16h       {actualise l'tat des LEDs du clavier}
 end
end; {ActiveMode}

{------------------------------------------------}

procedure DesactiveMode(mode: BYTE);
{mode=ScrMode, NumMode, MajMode ou InsMode}
begin
 EtatClavier:=EtatClavier and not(mode);
 asm
  mov AH,01h
  int 16h       {actualise l'tat des LEDs du clavier}
 end
end; {DesactiveMode}

{------------------------------------------------}

procedure VideBufferClavier; assembler;
asm
 cli
 mov DX,40h
 mov ES,DX
 mov AL,ES:[1Ch]
 mov ES:[1Ah],AL
 sti
end; {VideBufferClavier}

{------------------------------------------------}

procedure VitesseClavier(delai,vitesse: BYTE); assembler;
asm
 mov AX,0305h
 mov BH,delai
 mov BL,vitesse
 int 16h
end; {VitesseClavier}

{================================================}

END.
