{ͻ}
{                       --== DSSUnit.PAS ==--                      }
{                                                                      }
{ Unit pour la gestion de la Disney SS.                               }
{                                                                      }
{ AUTEUR: Freddy Vtel.                                               }
{Ķ}
{ Compatibilit: 286           Dbut d'criture 05/11/95 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT DSSUnit;

{$A+,G+,Q-,R-,S-}

INTERFACE

USES VarUnit,Hardware;

CONST SSOn =$04;
      SSOff=$0C;

TYPE T_DSSConfig=record
               DataP:WORD;
               StatusP:WORD;
               ControlP:WORD;
               end;

VAR DSSConfig:T_DSSConfig;

procedure Detecte_DSS(affiche: BOOLEAN);

IMPLEMENTATION

procedure DSSOn;
begin
 Port[DSSConfig.DataP]:=SSOn;  { Disney sound source On  }
end;

procedure DSSOff;
begin
 Port[DSSConfig.DataP]:=SSOff;  { Disney sound source Off }
end;

procedure DSS_Ecrire(Valeur:BYTE); assembler;
asm
  mov DX,DSSConfig.DataP    { Envoyer la valeur           }
  mov AL,Valeur
  out DX,AL

  mov DX,DSSConfig.ControlP { Envoyer Printer Select      }
  mov AL,SSOff
  out DX,AX
  push AX
  pop AX
  mov AL,SSOn
  out DX,AL
                            { Attendre                    }
  push AX
  pop AX
  push AX
  pop AX
end;

function DSS_FIFO_Vide:BOOLEAN; assembler;
asm
  mov DX,DSSConfig.StatusP
  in AL,DX
  test AL,40h
  jz @Ok
  mov AX,FALSE      { FIFO pleine }
  jmp @Fin
@Ok:
  mov AX,TRUE       { FIFO vide   }
@Fin:
end;

procedure Detecte_DSS(affiche: BOOLEAN);
var i:BYTE;
    DSS_Detectee:BOOLEAN;

begin
 Detecte_Hardware(Affiche);  { Dtecte les ports parallles }
 DSS_Detectee:=FALSE;

 for i:=1 to 3 do
  if LPT_Present[i] then with DSSConfig do begin
    DataP:=Port_LPT[i];
    StatusP:=Port_LPT[i]+1;
    ControlP:=Port_LPT[i]+2;
    DSSOn;
    if DSS_FIFO_Vide then begin{ FIFO vide => Continuer }
      for i:=1 to 32 do DSS_Ecrire($80);            { Remplir la FIFO     }
      if not DSS_FIFO_Vide then DSS_Detectee:=TRUE; { FIFO non vide => Ok }
    end;

    if DSS_Detectee then begin
      DSS_Presente:=TRUE;
      Writeln('Disney Sound Source found.');
      break;
      end;
    end;
end; {Detecte_DSS}

END.
