{ͻ}
{                        --== EMS.PAS ==--                         }
{                                                                      }
{ Unit pour grer la mmoire pagine avec un EMM version  3.0        }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 286           Dbut d'criture 14/08/95 }
{                              Dernires modifications 06/12/98 }
{ͼ}

UNIT EMS;

{$A+,G+,Q-,R-,S-}

{$DEFINE TestErr}  {mettre $UNDEF pour retirer EMSTestError (messages d'erreur)}

INTERFACE

CONST EMSok=0;
      EMSError: BYTE=EMSok; { tester aprs chaque appel  une fonction EMS}

      {pour EMSCopy et EMSSwap...}
      mem_conv=0; {mmoire conventionnelle}
      mem_EMS =1; {mmoire pagine}

TYPE {pour EMSCopy et EMSSwap...}
     EMSBlock=record
               size: LONGINT; {taille du bloc mmoire}
               source,target: record
                               mem_type: BYTE; {mem_conv ou mem_EMS}
                               id      : WORD; {si mem_EMS -> handle}
                               offset  : WORD; {dcalage du dbut de bloc}
                               address : WORD; {si mem_conv -> segment de bloc
                                                si mem_EMS  -> n page physique}
                              end;
              end;

     {pour EMSGetAllHandles...}
     EMSTable=array[1..256] of record handle,pages: WORD end;


VAR EMMVersion     : BYTE; {n de version du gestionnaire EMS (maj.min)}
    EMSPageFrameSeg: WORD; {segment de cadre des pages physiques}
    EMSPageAvail   : WORD; {nombre total de pages de 16ko disponibles}

{==============================================================}

function  EMSInit: BOOLEAN;

{$IFDEF TestErr}
procedure EMSTestError;
{$ENDIF}

function  EMSPagesFree: WORD;

procedure EMSGet(var handle: WORD; nbr_pages: WORD);
procedure EMSFree(handle: WORD);

procedure EMSMap(handle,log_page: WORD; phys_page: BYTE);
procedure EMSMap4(handle,first_log_page: WORD);
procedure EMSSaveMapping(handle: WORD);
procedure EMSRestoreMapping(handle: WORD);

function  EMSGetLogPages(handle: WORD): WORD;
function  EMSGetAllHandles(var buffer: EMSTable): WORD;

procedure EMSSaveTable(var table);
procedure EMSRestoreTable(var table);
function  EMSGetTableSize: BYTE;

procedure EMSCopy(var block: EMSBlock);
procedure EMSSwap(var block: EMSBlock);

{==============================================================}

IMPLEMENTATION

CONST EMMInt=$67; {n de l'interruption du gestionnaire EMS}

{==============================================================}

function EMSInit: BOOLEAN;
{renvoie TRUE si la mmoire EMS est disponible et initialise les donnes fixes
 sinon renvoie FALSE}

type Char8=array[1..8] of CHAR;
     Char8Ptr=^Char8;

const EMMid: Char8='EMMXXXX0'; {identificateur du gestionnaire EMS}
var EMMfound: BOOLEAN;

begin
 EMMfound:=(Char8Ptr(Ptr(MemW[0:4*EMMInt+2],10))^=EMMid);
 if EMMfound then
  asm
   mov AH,46h
   int EMMInt   {AL <- n de version en BCD}
   mov BL,AL
   and BL,00001111b
   shr AL,4
   mov CL,10
   mul CL
   add AL,BL
   mov EMMVersion,AL

   mov AH,41h
   int EMMInt
   mov EMSPageFrameSeg,BX

   mov AH,42h
   int EMMInt
   mov EMSPageAvail,DX
  end;
 EMSInit:=EMMfound;
end; {EMSInit}

{--------------------------------------------------------------}

{IMPORTANT  Toutes les procdures/fonctions qui suivent
   ne doivent tre appeles que si EMSInit=TRUE }

{--------------------------------------------------------------}

{$IFDEF TestErr}

procedure EMSTestError;
{si une erreur est apparue dans le gestionnaire EMS, affiche le message
 d'erreur correspondant et interrompt le programme}

begin
 if EMSError=EMSok then exit; {pas d'erreur}

 asm
  mov AX,03h
  int 10h
 end;
 Write('ERREUR EMM: ');

 case EMSError of
  $80: Write('Erreur interne');
  $81: Write('Dfaut de l''lectronique EMS');
  $82: Write('EMM occup');
  $83: Write('Handle incorrect');
  $84: Write('Fonction inconnue');
  $85: Write('Plus de handles libres');
  $86: Write('Contexte perdu');
  $87: Write('Impossible d''allouer toutes les pages demandes');
  $88: Write('Trop de pages demandes');
  $89: Write('Tentative d''allouer 0 page');
  $8A: Write('Numro de page logique incorrect');
  $8B: Write('Numro de page physique incorrect');
  $8C: Write('Mmoire insuffisante pour sauvegarder contexte');
  $8D: Write('Contexte dj sauvegard');
  $8E: Write('Impossible de sauvegarder contexte');
  $8F: Write('Sous-fonction inconnue');
 {quelques codes d'erreurs pour les versions  4.0}
  $90: Write('Attribut inconnu');
  $91: Write('Caractristique inconnue');
  $92: Write('Zones source et cible se recoupent');
  $93: Write('Taille suprieure  taille alloue');
  $94: Write('Zones mmoire conventionnelle et EMS se recoupent');
  $95: Write('Offset hors de la page logique');
  $96: Write('Taille bloc dpasse 1Mo');
  $97: Write('Echange impossible avec mme handle');
  $98: Write('type de mmoire inconnu');
 end;

 halt(EMSError);
end; {EMSTestError}

{$ENDIF}

{--------------------------------------------------------------}

function EMSPagesFree: WORD; assembler;
{renvoie le nombre de pages encore libres}
asm
 mov AH,42h
 int EMMInt
 mov EMSError,AH
 or  AH,AH
 jz  @ok
 xor BX,BX
@ok:
 mov AX,BX
end; {EMSPagesFree}

{--------------------------------------------------------------}

procedure EMSGet(var handle: WORD; nbr_pages: WORD); assembler;
{alloue des pages en EMS et leur affecte un handle}
asm
 mov AH,43h
 mov BX,nbr_pages
 int EMMInt
 mov EMSError,AH
 or  AH,AH
 jz  @ok
 xor DX,DX
@ok:
 les DI,handle
 mov ES:[DI],DX
end; {EMSGet}

{--------------------------------------------------------------}

procedure EMSFree(handle: WORD); assembler;
{libre toutes les pages EMS associes au handle}
asm
 mov AH,45h
 mov DX,handle
 int EMMInt
 mov EMSError,AH
end; {EMSFree}

{--------------------------------------------------------------}

procedure EMSMap(handle,log_page: WORD; phys_page: BYTE); assembler;
{fait correspondre la page logique avec la page physique}
asm
 mov AH,44h
 mov AL,phys_page
 mov BX,log_page
 mov DX,handle
 int EMMInt
 mov EMSError,AH
end; {EMSMap}

{--------------------------------------------------------------}

procedure EMSMap4(handle,first_log_page: WORD);
{"mappe" quatre pages logiques conscutives dans les quatre pages physiques}
var phys_page: BYTE;
begin
 for phys_page:=0 to 3 do EMSMap(handle,first_log_page+phys_page,phys_page);
end; {EMSMap4}

{--------------------------------------------------------------}

procedure EMSSaveMapping(handle: WORD); assembler;
{sauvegarde le contexte des pages EMS associes au handle}
asm
 mov AH,47h
 mov DX,handle
 int EMMInt
 mov EMSError,AH
end; {EMSSaveMapping}

{--------------------------------------------------------------}

procedure EMSRestoreMapping(handle: WORD); assembler;
{restaure le contexte des pages EMS associes au handle}
asm
 mov AH,48h
 mov DX,handle
 int EMMInt
 mov EMSError,AH
end; {EMSRestoreMapping}

{--------------------------------------------------------------}

function EMSGetLogPages(handle: WORD): WORD; assembler;
{renvoie le nombre de pages logiques associes au handle}
asm
 mov AH,4Ch
 mov DX,handle
 int EMMInt
 mov EMSError,AH
 or  AH,AH
 jz  @ok
 xor BX,BX
@ok:
 mov AX,BX
end; {EMSGetLogPages}

{--------------------------------------------------------------}

function EMSGetAllHandles(var buffer: EMSTable): WORD; assembler;
{renvoie le nombre de handles total et le nombre de pages associes}
asm
 mov AH,4Dh
 les DI,buffer
 int EMMInt
 mov EMSError,AH
 or  AH,AH
 jz  @ok
 xor BX,BX
@ok:
 mov AX,BX
end; {EMSGetAllHandles}

{--------------------------------------------------------------}

procedure EMSSaveTable(var table); assembler;
{sauvegarde la table de concordance pages logiques/physiques
 NE FONCTIONNE QU'A PARTIR DE LA VERSION 3.2}
asm
 mov AX,4E00h
 les DI,table
 int EMMInt
 mov EMSError,AH
end; {EMSSaveTable}

{--------------------------------------------------------------}

procedure EMSRestoreTable(var table); assembler;
{restaure la table de concordance pages logiques/physiques
 NE FONCTIONNE QU'A PARTIR DE LA VERSION 3.2}
asm
 mov AX,4E01h
 les DI,table
 int EMMInt
 mov EMSError,AH
end; {EMSRestoreTable}

{--------------------------------------------------------------}

function EMSGetTableSize: BYTE; assembler;
{renvoie la taille de la table de concordance pages logiques/physiques
 NE FONCTIONNE QU'A PARTIR DE LA VERSION 3.2}
asm
 mov AX,4E03h
 int EMMInt
 mov EMSError,AH
 or  AH,AH
 jz  @ok
 xor AL,AL
@ok:
end; {EMSGetTableSize}

{--------------------------------------------------------------}

procedure EMSCopy(var block: EMSBlock); assembler;
{copie un bloc mmoire dans un autre
 NE FONCTIONNE QU'A PARTIR DE LA VERSION 4.0}
asm
 push DS
 mov AX,5700h
 lds SI,block
 int EMMInt
 pop DS
 mov EMSError,AH
end; {EMSCopy}

{--------------------------------------------------------------}

procedure EMSSwap(var block: EMSBlock); assembler;
{change deux blocs mmoire
 NE FONCTIONNE QU'A PARTIR DE LA VERSION 4.0}
asm
 push DS
 mov AX,5701h
 lds SI,block
 int EMMInt
 pop DS
 mov EMSError,AH
end; {EMSSwap}

{==============================================================}

END.
