{ͻ}
{                      --== EVIRTUEL.PAS ==--                      }
{                                                                      }
{ Unit pour grer un cran virtuel en mode graphique 320x200 256 coul.}
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 386           Dbut d'criture ??/02/94 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT Evirtuel;

{$A+,G+,Q-,R-,S-}

INTERFACE

CONST rv=0; {transfert cran rel->virtuel pour TransfereZone_ev}
      vr=1; {transfert cran virtuel->rel pour TransfereZone_ev}

VAR Segment_ev: WORD;

{==========================================================}

procedure Cree_ev;
procedure Supprime_ev;
procedure Copie_ev;
procedure Efface_ev(couleur: BYTE);
procedure Affiche_ev;
procedure EffaceZone_ev(xg: WORD; yh: BYTE; xd: WORD; yb: BYTE; couleur: BYTE);
procedure TransfereZone_ev(sens: BYTE; xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);

{==========================================================}

IMPLEMENTATION

TYPE Ecran=array[1..320*200] of BYTE;

VAR ev: ^Ecran;

{==========================================================}

procedure Cree_ev;
begin
 New(ev);
 Segment_ev:=Seg(ev^);
end; {Cree_ev}

{----------------------------------------------------------}

procedure Supprime_ev;
begin
 Dispose(ev);
end; {Supprime_ev}

{----------------------------------------------------------}

procedure Copie_ev; assembler;
asm
 push DS
 mov ES,Segment_ev
 mov AX,0A000h
 mov DS,AX
 mov CX,320*200/4
 xor SI,SI
 xor DI,DI
 cld
 DB  66h; rep movsw      {rep movsd}
 pop DS
end; {Copie_ev}

{----------------------------------------------------------}

procedure Efface_ev(couleur: BYTE); assembler;
asm
 mov ES,Segment_ev
 mov CX,320*200/4
 mov AL,couleur
 mov AH,AL
 mov BX,AX
 DB  66h,0C1h,0E0h,010h  {shl EAX,16}
 mov AX,BX
 xor DI,DI
 cld
 DB 66h; rep stosw       {rep stosd}
end; {Efface_ev}

{----------------------------------------------------------}

procedure Affiche_ev; assembler;
asm
 push DS
 mov DS,Segment_ev
 mov AX,0A000h
 mov ES,AX
 mov CX,320*200/4
 xor SI,SI
 xor DI,DI
 cld
 DB  66h; rep movsw      {rep movsd}
 pop DS
end; {Affiche_ev}

{----------------------------------------------------------}

procedure EffaceZone_ev(xg: WORD; yh: BYTE; xd: WORD; yb: BYTE; couleur: BYTE); assembler;
{Efface une zone rectangulaire (xg,yh,xd,yb) de l'cran virtuel}
asm
 cld
 mov ES,Segment_ev

 mov AH,yh
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,xg      {ES:DI -> Segment_ev:xg+320*yh}

 mov BX,xd
 sub BX,xg
 inc BX         {BX=nombre colonnes}

 mov SI,320
 sub SI,BX      {incrment DI: SI=320-(nombre colonnes)}

 mov AL,couleur
 mov AH,AL
 mov CX,AX
 DB  66h,0C1h,0E0h,010h   {shl EAX,16}
 mov AX,CX

 mov DL,BL
 and DL,3       {DL=(nombre colonnes) modulo 4}
 shr BX,2       {BL=(nombre colonnes)/4}

 mov BH,yb
 sub BH,yh
 inc BH         {BH=nombre lignes}

 xor CH,CH
@efface_ligne_ev:
 mov CL,BL               {CL=(nombre colonnes)/4}
 DB  66h; rep stosw      {rep stosd: efface une ligne}
 or DL,DL                {encore des points  effacer?}
 jz @fin_efface_ligne_ev {non}
 mov CL,DL
 rep stosb               {copie fin de ligne}
@fin_efface_ligne_ev:
 add DI,SI               {ligne suivante}
 dec BH
 jnz @efface_ligne_ev
end; {EffaceZone_ev}

{----------------------------------------------------------}

procedure TransfereZone_ev(sens: BYTE; xg: WORD; yh: BYTE; xd: WORD; yb: BYTE); assembler;
{Transfre une zone rectangulaire (xg,yh,xd,yb)
  - de l'cran virtuel vers l'cran rel si sens=vr
  - de l'cran rel vers l'cran virtuel si sens=rv
Remarque: l'cran virtuel a la mme structure que l'cran rel (mme adressage)}
const NOP_=$90; MOVSB_=$A4; MOVSW_=$A5;
asm
 push DS
 mov ES,Segment_ev
 mov AX,0A000h
 mov DS,AX      {par dfaut, transfre cran rel->virtuel}
 cmp sens,rv
 je @debut_transfert_ev
 mov BX,ES
 mov ES,AX      {ES=A000}
 mov DS,BX      {DS=Segment_ev (transfert cran virtuel->rel)}

@debut_transfert_ev:
 cld
 mov AH,yh
 xor AL,AL
 mov SI,AX
 shr AX,2
 add SI,AX
 add SI,xg      {SI=xg+320*yh}

 mov BX,xd
 sub BX,xg
 inc BX         {BX=nombre colonnes}

 mov AL,BL
 and AL,3       {AL=(nombre colonnes) modulo 4}
 jnz @pas0
 mov WORD ptr CS:[@fin_copie],256*NOP_+NOP_
 jmp @suite
@pas0:
 cmp AL,1
 jne @pas1
 mov WORD ptr CS:[@fin_copie],256*MOVSB_+NOP_
 jmp @suite
@pas1:
 mov WORD ptr CS:[@fin_copie],256*MOVSW_+NOP_
 cmp AL,2
 je @suite
 mov WORD ptr CS:[@fin_copie+1],256*MOVSW_+MOVSB_
 je @suite

@suite:
 mov DX,320
 sub DX,BX      {incrment SI: DX=320-(nombre colonnes)}

 shr BX,2       {BL=(nombre colonnes)/4}
 mov BH,yb
 sub BH,yh
 inc BH         {BH=nombre lignes}

 xor CH,CH
@copie_ligne_ev:
 mov CL,BL      {CL=(nombre colonnes)/4}
 mov DI,SI      {destination=source}
 DB  66h; rep movsw      {rep movsd: copie une ligne}
 @fin_copie:
 nop
 nop
 add SI,DX      {ligne suivante}
 dec BH
 jnz @copie_ligne_ev

 pop DS
end; {TransfereZone_ev}

{==========================================================}

END.
