{ͻ}
{                        --== FFT_U.PAS ==--                       }
{                                                                      }
{ Unit pour calculer les transformes de Fourier directes/inverses en }
{ entiers 16 bits (nombre maximal de points=nbr_points_max).           }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 386           Dbut d'criture 01/10/95 }
{                              Dernires modifications 26/07/98 }
{ͼ}

{si SIN_CODE est dfinie, la table de sinus (QuartSin, taille: 8ko)
 est incluse dans le segment CODE,
 sinon elle est incluse dans le segment DATA}

{$DEFINE SIN_CODE}

UNIT FFT_U;

{$A+,G+,Q-,R-,S-}

INTERFACE

CONST log2_nbr_points_max=8; {=n}
      nbr_points_max=1 shl log2_nbr_points_max; {=2^n}

      {sens}
      FFT_directe=$0000;
      FFT_inverse=$0001;

      {constantes pour FFT directe}
        FFT_points =$0000; {entre: points rels (toujours!)}

        {fentres}
        FFT_rect   =$0000;
        FFT_trapeze=$0010;
        FFT_hanning=$0020;

        {type des donnes en sortie (harmoniques,module,module ou "module absolu")}
        FFT_harmo  =$0000;
        FFT_module =$0100;
        FFT_module2=$0200;
        FFT_moduleA=$0400;

      {FFT inverse: entre=harmoniques, sortie=points rels (toujours!)}


TYPE  harmo=record hcos,hsin: INTEGER end;

      T_FFT_taille=0..nbr_points_max-1;
      T_FFT_moitie=0..(nbr_points_max shr 1)-1;

      T_FFT_points =array[T_FFT_taille] of INTEGER; {points rels}
      T_FFT_harmo  =array[T_FFT_moitie] of harmo;   {hcos,hsin}
      T_FFT_module =array[T_FFT_moitie] of WORD;    {(hcos+hsin)}
      T_FFT_module2=array[T_FFT_moitie] of LONGINT; {hcos+hsin}
      T_FFT_moduleA=T_FFT_module;                   {hcos+hsin}

      T_FFT=record case BYTE of
             FFT_points :(points :T_FFT_points);
             FFT_harmo  :(harmo  :T_FFT_harmo);
             FFT_module :(module :T_FFT_module);
             FFT_module2:(module2:T_FFT_module2);
             FFT_moduleA:(moduleA:T_FFT_moduleA)
            end;

{==========================================================}

procedure FFT(mode: WORD; var tampon: T_FFT; log2_nbr_points: BYTE);

{==========================================================}

IMPLEMENTATION

{$IFNDEF SIN_CODE}
{$I QuartSin.inc}
{$ENDIF}

procedure FFT(mode: WORD; var tampon: T_FFT; log2_nbr_points: BYTE); external;
{$L FFT}

{==========================================================}

END.
