{ͻ}
{                      --== FICHIERS.PAS ==--                      }
{                                                                      }
{ Unit pour grer les fichiers DOS                                    }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 286           Dbut d'criture ??/12/93 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT Fichiers;
{$A+,G+,Q-,R-,S-}

INTERFACE

{$I Types}

CONST {modes d'accs}
      lecture          =$90;
      ecriture         =$91;
      lecture_ecriture =$92;

      {modes de cration}
      teste_existe = TRUE;
      ecrase       = FALSE;

      {codes d'erreur}
      f_ok            =  0;
      f_err_fich_intr =  2;
      f_err_ch_intr   =  3;
      f_err_trop_fich =  4;
      f_err_acces_ref =  5;
      f_err_handle    =  6;
      f_err_lecteur   = 15;
      f_err_plus_fich = 18;
      f_err_existe    = 80;
      f_err_protect   =150;
      f_err_pas_pret  =152;
      f_err_disq_plein=153;
      f_err_CRC       =154;
      f_err_donnees   =156;
      f_err_media     =157;
      f_err_secteur   =158;
      f_err_ecriture  =160;
      f_err_lecture   =161;
      f_err_disq_inut =162;

      {codes d'opration pour AttributFichier}
      attr_fixe   =1;
      attr_ajoute =2;
      attr_retire =3;
      attr_inverse=4;

      {attributs (compatibles avec Unit DOS)}
      ReadOnly  =$01;
      Hidden    =$02;
      SysFile   =$04;
      VolumeID  =$08;
      Directory =$10;
      Archive   =$20;


TYPE  Fichier=object
               procedure Ouvre(mode_acces: BYTE; nom_fichier: String80);
               procedure Cree(teste_existe_: BOOLEAN; nom_fichier: String80);
               procedure Ferme;
               procedure PlacePointeur  (position: LONGINT);
               procedure DeplacePointeur(distance: LONGINT);
               function  Pointeur: LONGINT;
               procedure Lit  (var buffer; nombre: WORD);
               procedure Ecrit(var buffer; nombre: WORD);
               procedure LitPos  (position: LONGINT; var buffer; nombre: WORD);
               procedure EcritPos(position: LONGINT; var buffer; nombre: WORD);
               function  Taille: LONGINT;
               function  GetHandle: WORD;
              private
               handle: WORD;
              end;


CONST f_erreur: WORD=f_ok; {variable  tester aprs chaque opration fichier
                            sauf: Ferme, (D)(Place)Pointeur, Taille}

{==========================================================}

procedure EffaceFichier(nom_fichier: String80);
procedure EcraseFichier(nom_fichier: String80);
procedure AttributFichier(nom_fichier: String80; code_op: BYTE; attribut: BYTE);

{==========================================================}

IMPLEMENTATION

{==========================================================}

procedure Fichier.Ouvre(mode_acces: BYTE; nom_fichier: String80);
{ouvre un fichier existant en lecture, criture ou les deux
 Remarque: le pointeur de fichier est plac sur le premier octet}
var handle_: WORD;
begin
 asm
  push DS
  cld
  push SS
  pop DS
  lea SI,nom_fichier
  xor AH,AH
  lodsb                 {AX=longueur nom_fichier}
  mov DX,SI             {DS:DX -> nom_fichier[1]}
  add SI,AX             {DS:SI -> caractre suivant le dernier}
  mov BYTE(DS:[SI]),0   {convertit nom_fichier en ASCIIZ}
  mov AH,3Dh
  mov AL,mode_acces
  int 21h               {ouvre le fichier}
  pop DS
  mov f_erreur,f_ok
  jnc @fin              {pas d'erreur}
  mov f_erreur,AX
  xor AX,AX
 @fin:
  mov handle_,AX
 end;
 handle:=handle_;
end; {Fichier.Ouvre}

{----------------------------------------------------------}

procedure Fichier.Cree(teste_existe_: BOOLEAN; nom_fichier: String80);
{cre un nouveau fichier
 si teste_existe_=TRUE: provoque une erreur 80 si le fichier existe dj
                        sinon crase l'ancien fichier
 Remarque: le pointeur de fichier est plac sur le premier octet}
var handle_: WORD;
begin
 asm
  push DS
  cld
  push SS
  pop DS
  lea SI,nom_fichier
  xor AH,AH
  lodsb                 {AX=longueur nom_fichier}
  mov DX,SI             {DS:DX -> nom_fichier[1]}
  add SI,AX             {DS:SI -> caractre suivant le dernier}
  mov BYTE(DS:[SI]),0   {convertit nom_fichier en ASCIIZ}
  mov AH,5Bh
  cmp teste_existe_,TRUE
  je @suite
  mov AH,3Ch
 @suite:
  xor CX,CX
  int 21h               {cre le fichier}
  pop DS
  mov f_erreur,f_ok
  jnc @fin              {pas d'erreur}
  mov f_erreur,AX
  xor AX,AX
 @fin:
  mov handle_,AX
 end;
 handle:=handle_;
end; {Fichier.Cree}

{----------------------------------------------------------}

procedure Fichier.Ferme;
{ferme un fichier pralablement ouvert}
var handle_: WORD;
begin
 handle_:=handle;
 asm
  mov AH,3Eh
  mov BX,handle_
  int 21h
 end;
end; {Fichier.Ferme}

{----------------------------------------------------------}

procedure Fichier.PlacePointeur(position: LONGINT);
{positionne le pointeur de fichier  l'offset voulu (0 -> premier octet)
 (position  0)}
var handle_: WORD;
begin
 handle_:=handle;
 asm
  mov AX,4200h          {position par rapport au dbut du fichier}
  mov BX,handle_
  les DX,position       {DX=mot faible}
  mov CX,ES             {CX=mot fort}
  int 21h
 end;
end; {Fichier.PlacePointeur}

{----------------------------------------------------------}

procedure Fichier.DeplacePointeur(distance: LONGINT);
{dplace le pointeur de fichier (en amont ou en aval)}
var handle_: WORD;
begin
 handle_:=handle;
 asm
  mov AX,4201h          {distance par rapport  la position courante}
  mov BX,handle_
  les DX,distance       {DX=mot faible}
  mov CX,ES             {CX=mot fort}
  int 21h
 end;
end; {Fichier.DeplacePointeur}

{----------------------------------------------------------}

function Fichier.Pointeur: LONGINT;
{renvoie la position du pointeur de fichier}
var handle_: WORD;
    p: LONGINT;
begin
 handle_:=handle;
 asm
  mov AX,4201h          {distance par rapport  la position courante}
  mov BX,handle_
  xor CX,CX
  xor DX,DX
  int 21h
  mov WORD(p),AX        {AX=mot faible}
  mov WORD(p+2),DX      {DX=mot fort}
 end;
 Pointeur:=p;
end; {Fichier.Pointeur}

{----------------------------------------------------------}

procedure Fichier.Lit(var buffer; nombre: WORD);
{lit 'nombre' octets depuis la position courante du pointeur de fichier,
 et les place  l'adresse de 'buffer'}
var handle_: WORD;
begin
 handle_:=handle;
 asm
  push DS
  mov AH,3Fh
  mov BX,handle_
  mov CX,nombre
  lds DX,buffer
  int 21h
  pop DS
  mov f_erreur,f_ok
  jnc @fin              {pas d'erreur}
  mov f_erreur,AX
 @fin:
 end;
end; {Fichier.Lit}

{----------------------------------------------------------}

procedure Fichier.Ecrit(var buffer; nombre: WORD);
{ecrit 'nombre' octets de 'buffer'  la position courante du pointeur de fichier}
var handle_: WORD;
begin
 handle_:=handle;
 asm
  push DS
  mov AH,40h
  mov BX,handle_
  mov CX,nombre
  lds DX,buffer
  int 21h
  pop DS
  jc  @erreur
  mov f_erreur,f_ok
  cmp AX,CX             {tout a t crit?}
  je  @fin
  mov AX,f_err_disq_plein
 @erreur:
  mov f_erreur,AX
 @fin:
 end;
end; {Fichier.Ecrit}

{----------------------------------------------------------}

procedure Fichier.LitPos(position: LONGINT; var buffer; nombre: WORD);
{lit 'nombre' octets depuis 'position' , et les place  l'adresse de 'buffer'}
begin
 Fichier.PlacePointeur(position); Fichier.Lit(buffer,nombre);
end; {Fichier.LitPos}

{----------------------------------------------------------}

procedure Fichier.EcritPos(position: LONGINT; var buffer; nombre: WORD);
{ecrit 'nombre' octets de 'buffer'  la position indique du pointeur de fichier}
begin
 Fichier.PlacePointeur(position); Fichier.Ecrit(buffer,nombre);
end; {Fichier.EcritPos}

{----------------------------------------------------------}

function Fichier.Taille: LONGINT;
{renvoie la taille du fichier en octets}
var handle_: WORD;
    anc_pos,t: LONGINT;
begin
 handle_:=handle;
 anc_pos:=Pointeur;
 asm
  mov AX,4202h          {distance par rapport  la fin du fichier}
  mov BX,handle_
  xor CX,CX
  xor DX,DX
  int 21h
  mov WORD(t),AX        {AX=mot faible}
  mov WORD(t+2),DX      {DX=mot fort}
 end;
 PlacePointeur(anc_pos);
 Taille:=t;
end; {Fichier.Taille}

{----------------------------------------------------------}

function Fichier.GetHandle: WORD;
{renvoie le handle du fichier}
begin
 GetHandle:=handle;
end; {Fichier.GetHandle}

{----------------------------------------------------------}

procedure EffaceFichier(nom_fichier: String80); assembler;
{efface un fichier sur disque - rcuprable avec Undelete}
asm
 push DS
 cld
 lds SI,nom_fichier
 xor AH,AH
 lodsb                  {AX=longueur nom_fichier}
 mov DX,SI              {DS:DX -> nom_fichier[1]}
 add SI,AX              {DS:SI -> caractre suivant le dernier}
 mov BYTE(DS:[SI]),0    {convertit nom_fichier en ASCIIZ}
 mov AH,41h
 int 21h                {supprime le fichier}
 pop DS
 mov f_erreur,f_ok
 jnc @fin               {pas d'erreur}
 mov f_erreur,AX
@fin:
end; {EffaceFichier}

{----------------------------------------------------------}

procedure EcraseFichier(nom_fichier: String80);
{efface un fichier sur disque - IRRECUPERABLE avec Undelete}
var f: Fichier;
begin
 with f do begin
  Cree(ecrase,nom_fichier);
  if f_erreur<>f_ok then exit;
  Ferme;                       {cre un fichier vide portant le mme nom}
  EffaceFichier(nom_fichier);
 end;
end; {EcraseFichier}

{----------------------------------------------------------}

procedure AttributFichier(nom_fichier: String80; code_op: BYTE; attribut: BYTE); assembler;
{modifie l'attribut d'un fichier: fixe, ajoute, retire, inverse}
asm
 push DS
 cld
 lds SI,nom_fichier
 xor AH,AH
 lodsb                  {AX=longueur nom_fichier}
 mov DX,SI              {DS:DX -> nom_fichier[1]}
 add SI,AX              {DS:SI -> caractre suivant le dernier}
 mov BYTE(DS:[SI]),0    {convertit nom_fichier en ASCIIZ}

 xor CH,CH
 mov CL,attribut
 mov DI,CX
 cmp code_op,attr_fixe
 je  @fixe_attribut

 mov AX,4300h
 int 21h                {lit l'attribut actuel}
 cmp code_op,attr_inverse
 je  @inverse_attribut
 cmp code_op,attr_retire
 je  @retire_attribut
@ajoute_attribut:
 or  CX,DI
 jmp @fixe_attribut
@retire_attribut:
 not DI
 and CX,DI
 jmp @fixe_attribut
@inverse_attribut:
 xor CX,DI

@fixe_attribut:
 mov AX,4301h
 int 21h                {fixe l'attribut}
 pop DS
 mov f_erreur,f_ok
 jnc @fin               {pas d'erreur}
 mov f_erreur,AX
@fin:
end; {AttributFichier}

{==========================================================}

END.
