{ͻ}
{                      --== FICH_GRP.PAS ==--                      }
{                                                                      }
{ Unit pour grer les fichiers groups en un seul avec GROUPF         }
{                                                                      }
{   IMPORTANT: - un seul fichier "groupe" peut tre ouvert  la fois ! }
{              - accs aux fichiers en LECTURE seule !                 }
{                                                                      }
{ Syntaxe compatible avec l'Unit Fichiers; ajouter dans le programme: }
{                                                                      }
{      DefinitFichierGroupe(nom_fichier);                              }
{      ...                                                             }
{      FermeFichierGroupe;                                             }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 286           Dbut d'criture ??/01/95 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT Fich_Grp;
{$A+,G+,Q-,R-,S-}

INTERFACE

{$I Types}

CONST {mode d'accs unique}
      lecture=$90;

      {codes d'erreur}
      f_ok            =  0;
      f_err_fich_intr =  2;
      f_err_ch_intr   =  3;
      f_err_trop_fich =  4;
      f_err_acces_ref =  5;
      f_err_handle    =  6;
      f_err_lecteur   = 15;
      f_err_plus_fich = 18;
      f_err_existe    = 80;
      f_err_protect   =150;
      f_err_pas_pret  =152;
      f_err_disq_plein=153;
      f_err_CRC       =154;
      f_err_donnees   =156;
      f_err_media     =157;
      f_err_secteur   =158;


TYPE Fichier=object
              Taille: LONGINT;
              procedure Ouvre(mode: BYTE; nom_fichier: String12);
              procedure Ferme;
              procedure PlacePointeur  (position: LONGINT);
              procedure DeplacePointeur(distance: LONGINT);
              procedure Lit   (var buffer; nombre: WORD);
              procedure LitPos(position: LONGINT; var buffer; nombre: WORD);
             private
              offset: LONGINT;
             end;


CONST f_erreur: WORD=f_ok; {variable  tester aprs chaque opration fichier
                            sauf: Ferme, (D)PlacePointeur, Taille}

{==========================================================}

procedure DefinitFichierGroupe(nom_fichier: String80);
procedure FermeFichierGroupe;

{==========================================================}

IMPLEMENTATION

USES Util;

VAR handle_groupe: WORD;
    nom_fichier_groupe: String80;

{==========================================================}

procedure DefinitFichierGroupe(nom_fichier: String80);
var handle_: WORD;
begin
 asm
  push DS
  cld
  push SS
  pop DS
  lea SI,nom_fichier
  xor AH,AH
  lodsb                  {AX=longueur nom_fichier}
  mov DX,SI              {DS:DX -> nom_fichier[1]}
  add SI,AX              {DS:SI -> caractre suivant le dernier}
  mov BYTE ptr DS:[SI],0 {convertit nom_fichier en ASCIIZ}
  mov AH,3Dh
  mov AL,lecture
  int 21h                {ouvre le fichier}
  pop DS
  mov f_erreur,f_ok
  jnc @fin               {pas d'erreur}
  mov f_erreur,AX
  xor AX,AX
 @fin:
  mov handle_,AX
 end;
 handle_groupe:=handle_;
 if f_erreur=f_ok then nom_fichier_groupe:=nom_fichier;
end; {DefinitFichierGroupe}

{----------------------------------------------------------}

procedure FermeFichierGroupe; assembler;
asm
 mov AH,3Eh
 mov BX,handle_groupe
 int 21h
end; {FermeFichierGroupe}

{----------------------------------------------------------}

procedure Fichier.Ouvre(mode: BYTE; nom_fichier: String12);

type T_entete=record
               Nom: String12;
               offset, longueur: LONGINT;
              end;

var i,nbr_fichiers_groupes: WORD;
    elem_entete: T_entete;


procedure LitFichierGroupe(var buffer; nombre: WORD); assembler;
asm
 push DS
 mov AH,3Fh
 mov BX,handle_groupe
 mov CX,nombre
 lds DX,buffer
 int 21h
 pop DS
 mov f_erreur,f_ok
 jnc @fin               {pas d'erreur}
 mov f_erreur,AX
@fin:
end; {LitFichierGroupe}


begin {Fichier.Ouvre}
 nom_fichier:=Maj(nom_fichier);
 asm
  mov AX,4200h
  mov BX,handle_groupe
  xor CX,CX
  xor DX,DX
  int 21h    {dbut du fichier group}
 end;
 LitFichierGroupe(nbr_fichiers_groupes,2);
 if f_erreur<>f_ok then exit;

 for i:=1 to nbr_fichiers_groupes do begin
  LitFichierGroupe(elem_entete,sizeof(T_entete));
  if Maj(elem_entete.Nom)=nom_fichier then begin
   offset:=elem_entete.offset;
   Taille:=elem_entete.longueur;
   Fichier.PlacePointeur(0);  {dbut du fichier}
   f_erreur:=f_ok;
   exit;
  end;
 end;

 f_erreur:=f_err_fich_intr; {nom_fichier n'est pas dans l'entte}
end; {Fichier.Ouvre}

{----------------------------------------------------------}

procedure Fichier.Ferme;
begin
end; {Fichier.Ferme}

{----------------------------------------------------------}

procedure Fichier.PlacePointeur(position: LONGINT);
var position_: LONGINT;
begin
 position_:=offset+position;
 asm
  mov AX,4200h           {position par rapport au dbut du fichier}
  mov BX,handle_groupe
  les DX,position_       {DX=mot faible}
  mov CX,ES              {CX=mot fort}
  int 21h
 end;
end; {Fichier.PlacePointeur}

{----------------------------------------------------------}

procedure Fichier.DeplacePointeur(distance: LONGINT); assembler;
asm
 mov AX,4201h           {distance par rapport  la position courante}
 mov BX,handle_groupe
 les DX,distance        {DX=mot faible}
 mov CX,ES              {CX=mot fort}
 int 21h
end; {Fichier.DeplacePointeur}

{----------------------------------------------------------}

procedure Fichier.Lit(var buffer; nombre: WORD); assembler;
asm
 push DS
 mov AH,3Fh
 mov BX,handle_groupe
 mov CX,nombre
 lds DX,buffer
 int 21h
 pop DS
 mov f_erreur,f_ok
 jnc @fin               {pas d'erreur}
 mov f_erreur,AX
@fin:
end; {Fichier.Lit}

{----------------------------------------------------------}

procedure Fichier.LitPos(position: LONGINT; var buffer; nombre: WORD);
begin
 Fichier.PlacePointeur(position);
 Fichier.Lit(buffer,nombre);
end; {Fichier.LitPos}

{==========================================================}

END.
