{ͻ}
{                        --== FNT16.PAS ==--                       }
{                                                                      }
{ Unit pour les fontes 16 couleurs au format FNT                      }
{ Affichages possibles en mode MCGA normal ou en mode X                }
{                                                                      }
{ AUTEURS: Fabrice Couteau et Freddy Vtel                            }
{Ķ}
{ Compatibilit: 286           Dbut d'criture 01/07/94 }
{                              Dernires modifications 26/07/98 }
{ͼ}

{$DEFINE Groupe}

{$IFNDEF Groupe}
UNIT FNT16;
{$ELSE}
UNIT FNT16_G;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$IFNDEF Groupe}
USES Fichiers,Graph256;
{$ELSE}
USES Fich_grp,Graph256;
{$ENDIF}

{$I Types}

CONST largeur_min= 8; hauteur_min= 6; {dimensions min de la matrice}
      largeur_max=28; hauteur_max=22; {dimensions max de la matrice}

      premiere_couleur_min=16; premiere_couleur_max=240;

      identFNT='FNT16c';

      err_format=1;


TYPE Palette16=array[0..15] of RVB;

     tab_donnees=array[1..largeur_max*hauteur_max*91] of BYTE;

     FNT=object
          nombre_caracteres,premiere_couleur,largeur,hauteur: BYTE;
          palette: Palette16;
          procedure Charge(nom_fichier: String80; var erreur: WORD);
          procedure Supprime;
          procedure FixePalette;
          procedure AffCarXY(segment,x: WORD; y: BYTE; car: CHAR; fond: BOOLEAN; couleur_fond: BYTE);
          procedure AffChXY (segment,x: WORD; y: BYTE; chaine: String64; fond: BOOLEAN; couleur_fond: BYTE);
          procedure AffCarXYx(segment,x,y: WORD; car: CHAR; fond: BOOLEAN; couleur_fond: BYTE);
          procedure AffChXYx (segment,x,y: WORD; chaine: String64; fond: BOOLEAN; couleur_fond: BYTE);
          procedure AffCarXYLimite(segment: WORD;
                                   x,y: INTEGER; car: CHAR; fond: BOOLEAN; couleur_fond: BYTE;
                                   xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);
          procedure AffChXYLimite (segment: WORD;
                                   x,y: INTEGER; chaine: String64; fond: BOOLEAN; couleur_fond: BYTE;
                                   xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);
         private
          table_offset: array[CHAR] of WORD;
          donnees: ^tab_donnees;
         end;

{==========================================================}

IMPLEMENTATION

USES Util,VGA,Graphx;

{==========================================================}

procedure FNT.Charge(nom_fichier: String80; var erreur: WORD);

type enteteFNT=record
                identificateur: array[1..6] of CHAR;
                nombre_caracteres,premiere_couleur,largeur,hauteur: BYTE;
                table_offset: array[CHAR] of WORD;
                palette: Palette16
               end;

var f: Fichier;
    taille_donnees: WORD;
    taille_fichier: LONGINT;
    entete: enteteFNT;

begin
 erreur:=0;
 with f do begin
  Ouvre(lecture,nom_fichier);
  if f_erreur=f_ok then begin
   taille_fichier:=Taille;
   if (taille_fichier<sizeof(enteteFNT)+largeur_min*hauteur_min) then erreur:=err_format
   else begin
    Lit(entete,sizeof(enteteFNT));
    if (entete.identificateur=identFNT) and
       (entete.nombre_caracteres in [1..91]) and
       (entete.premiere_couleur in [premiere_couleur_min..premiere_couleur_max]) and
       (entete.largeur in [largeur_min..largeur_max]) and
       (entete.hauteur in [hauteur_min..hauteur_max]) and
       (WORD(entete.nombre_caracteres*entete.largeur*entete.hauteur)=(taille_fichier-sizeof(enteteFNT))) then
     begin
      nombre_caracteres:=entete.nombre_caracteres;
      premiere_couleur:=entete.premiere_couleur;
      largeur:=entete.largeur;
      hauteur:=entete.hauteur;
      Move(entete.table_offset,table_offset,2*256);
      Move(entete.palette,palette,3*16);
      taille_donnees:=largeur*hauteur*nombre_caracteres;
      GetMem(donnees,taille_donnees);
      Lit(donnees^,taille_donnees);
     end
    else erreur:=err_format;
   end;
   f.Ferme;
   if erreur=err_format then exit;
  end;
 end;
 erreur:=f_erreur
end; {FNT.Charge}

{----------------------------------------------------------}

procedure FNT.Supprime;
begin
 FreeMem(donnees,largeur*hauteur*nombre_caracteres);
end; {FNT.Supprime}

{----------------------------------------------------------}

procedure FNT.FixePalette;
var couleur: BYTE;
begin
 AttendVBL;
 for couleur:=0 to 15 do FixeDAC(premiere_couleur+couleur,palette[couleur]);
end; {FNT.FixePalette}

{----------------------------------------------------------}

procedure FNT.AffCarXY(segment,x: WORD; y: BYTE; car: CHAR; fond: BOOLEAN; couleur_fond: BYTE);
{affiche un caractre en (x,y) dans la zone vido commenant en 'segment',
 sans tests de dbordements.
 -si 'fond'=FALSE, le caractre est affich sans fond (transparent), couleur_fond est indiffrent
 -si 'fond'=TRUE, le caractre est affich avec couleur_fond pour fond}

var offset_caractere: WORD;
    largeur_fonte,hauteur_fonte: BYTE;
    ptr_donnees: POINTER;

begin
 offset_caractere:=table_offset[car];
 largeur_fonte:=largeur; hauteur_fonte:=hauteur;
 ptr_donnees:=donnees;
 asm
  push DS
  cld

  lds SI,ptr_donnees          {DS:SI -> donnees^[0]}
  add SI,offset_caractere     {DS:SI -> donnees^[offset_caractere]}

  mov ES,segment
  mov AH,y
  xor AL,AL
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,x                    {ES:DI -> segment:x+320*y: offset coin suprieur gauche}

  mov BL,largeur_fonte        {BL=largeur}
  xor BH,BH
  mov DX,320
  sub DX,BX                   {incrment DI: DX=320-largeur}
  mov BH,hauteur_fonte        {BH=hauteur}

  xor CH,CH

  cmp fond,TRUE               {faut-il afficher un fond?}
  jne @pas_fond               {non}

  mov AH,couleur_fond

 @boucle_ligne:
  mov CL,BL                   {CX=largeur}
  @boucle_colonne:
   lodsb                      {AL=couleur du point  afficher}
   or  AL,AL                  {couleur nulle?}
   jnz @affiche_point         {non}
   mov AL,AH                  {couleur fond}
  @affiche_point:
   stosb
   loop @boucle_colonne
  mov ES:[DI],AH              {fond de la colonne intercaractre}
  add DI,DX                   {ligne suivante}
  dec BH
  jnz @boucle_ligne
  jmp @fin

 @pas_fond:

 @boucle_ligne2:
  mov CL,BL                   {CX=largeur}
  @boucle_colonne2:
   lodsb                      {AL=couleur du point  afficher}
   or  AL,AL                  {couleur nulle?}
   jz  @aff_pas_point         {oui}
   mov ES:[DI],AL
  @aff_pas_point:
   inc DI
   loop @boucle_colonne2
  add DI,DX                   {ligne suivante}
  dec BH
  jnz @boucle_ligne2

 @fin:
  pop DS
 end
end; {FNT.AffCarXY}

{----------------------------------------------------------}

procedure FNT.AffChXY(segment,x: WORD; y: BYTE; chaine: String64; fond: BOOLEAN; couleur_fond: BYTE);
{affiche une chane en (x,y) dans la zone vido commenant en 'segment', sans
 tests de dbordements.
 -si 'fond'=FALSE, la chane est affiche sans fond (transparent), couleur_fond est indiffrent
 -si 'fond'=TRUE, la chane est affiche avec couleur_fond pour fond}

var i: BYTE;
    xPos: WORD;

begin
 xPos:=x;
 for i:=1 to Length(chaine) do begin
  FNT.AffCarXY(segment,xPos,y,chaine[i],fond,couleur_fond);
  inc(xPos,largeur+1);
 end;
end; {FNT.AffChXY}

{----------------------------------------------------------}

procedure FNT.AffCarXYx(segment,x,y: WORD; car: CHAR; fond: BOOLEAN; couleur_fond: BYTE);
{affiche un caractre en (x,y) dans la page cran pointe par 'segment' (Mode x),
 sans tests de dbordements.
 -si 'fond'=FALSE, le caractre est affich sans fond (transparent), couleur_fond est indiffrent
 -si 'fond'=TRUE, le caractre est affich avec couleur_fond pour fond}

var offset_caractere: WORD;
    largeur_fonte,hauteur_fonte: BYTE;
    ptr_donnees: POINTER;

    Cmpt_Pixels_Sup: WORD; { Compteur des pixels supplmentaires }
    Nb_Boucles_x: WORD;
    Nb_Boucles_y: WORD;
    Incrementx  : WORD;  { Valeur a ajouter  DI  la fin d'une ligne }
    Incr_Fin_ligne : WORD;
    Debut_ecran,Debut_Caract: WORD;

begin
 offset_caractere:=table_offset[car];
 largeur_fonte:=largeur; hauteur_fonte:=hauteur;
 ptr_donnees:=donnees;
 asm
  push DS
  cld

  mov ES,segment
  mov AX,y
  mul Largeurx
  mov BX,x
  shr BX,2
  add AX,BX
  mov DI,AX
  mov Debut_Ecran,DI

  mov BL,largeur_fonte
  xor BH,BH
  mov AX,BX
  and AX,plane_bits
  mov Cmpt_Pixels_Sup,AX { Nb de plans avec plus de pixels de large }
  mov Incr_Fin_Ligne,AX  { Incrment de fin de ligne (Pour l'image) }
  shr BX,2              { BX=Resx/4 }
  mov Nb_Boucles_x,BX   { Initialise le nombre de colonnes par plan   }
  mov AX,Largeurx
  sub AX,BX             { AX=(320-resX)/4: incrment x (Pour l'cran) }
  mov Incrementx,AX

  mov AL,hauteur_fonte
  xor AH,AH
  mov Nb_Boucles_y,AX   { Initialise le nombre de lignes }

  mov CX,x
  and CX,plane_bits

  mov AX,map_mask_plane2 { Choix du 1 plan }
  shl AH,CL
  mov DX,Sequencer
  out DX,AX

  mov BH,AH               { BH <- masque des plans }
  mov BL,4                { BL Compteur des plans  }

  lds SI,ptr_donnees      {DS:SI -> donnees^[0]}
  add SI,offset_caractere {DS:SI -> donnees^[offset_caractere]}
  mov Debut_Caract,SI

  cmp fond,TRUE           {faut-il afficher un fond?}
  jne @pas_fond           {non}

  cmp Couleur_fond,0
  je  @Fond_zero

@fBoucle_Plans:           { Affichage avec fond <> 0 }

  mov DX,Nb_Boucles_y     { Nb de lignes }

@fBoucle_Lignes:

  mov CX,Nb_Boucles_x     { Nb de pixels de large par plan }
  test CL,0FCh
  jz  @fCopier_le_reste   { Bouclex2 si moins de 4 pixels de large }

@fBouclex1:               { Boucle "rapide" en x (x4) }
  lodsb
  add SI,3
  cmp AL,0
  jne @Aff_Point1
  mov AL,Couleur_fond  { Change la couleur du fond }
@Aff_Point1:
  stosb
  lodsb
  add SI,3
  cmp AL,0
  jne @Aff_Point2
  mov AL,Couleur_fond  { Change la couleur du fond }
@Aff_Point2:
  stosb
  lodsb
  add SI,3
  cmp AL,0
  jne @Aff_Point3
  mov AL,Couleur_fond  { Change la couleur du fond }
@Aff_Point3:
  stosb
  lodsb
  add SI,3
  cmp AL,0
  jne @Aff_Point4
  mov AL,Couleur_fond  { Change la couleur du fond }
@Aff_Point4:
  stosb

  sub CL,4
  test CL,0FCh      { il reste plus de 4 Pixels ? }
  jnz @fBouclex1    { oui => Boucler              }

@fCopier_le_reste:
  jcxz @fProchaine_ligne

@fBouclex2:
  lodsb
  add SI,3
  cmp AL,0
  jne @Aff_Point5
  mov AL,Couleur_fond
@Aff_Point5:
  stosb
  loop @fBouclex2

@fProchaine_ligne:
  or  CX,Cmpt_Pixels_Sup   { Cmpt_Pixel_sup=0 ? ( Rq: CX=0 )   }
  jz  @fSuite2

  lodsb                { Pixel supplmentaire pour qq plans }
  cmp AL,0
  jne @Aff_Point6
  mov AL,Couleur_fond  { Change la couleur du fond }
@Aff_Point6:
  stosb
  dec SI
  dec DI

@fSuite2:
  add SI,Incr_Fin_Ligne
  add DI,Incrementx

  dec DX                   { Encore une ligne ?     }
  jnz @fBoucle_Lignes      { Oui => Prochaine ligne }

  dec BL                   { Encore un plan ? }
  jz  @Fin                 { Non => Fin       }

  rol BH,1                 { Changer de plan  }
  mov DX,SequencerData
  mov AL,BH
  out DX,AL

  cmp AL,12h               { Carry si BH=11h (si debut d'une nouvelle ligne) }
  adc Debut_Ecran,0        { Dcale l'adresse de dpart de l'cran }
  inc Debut_Caract         { Se dcaler dans le caractre }

  sub Cmpt_Pixels_Sup,1    { Dcrmenter Cmpt_Pixels_Sup }
  adc Cmpt_Pixels_Sup,0    { Eviter les valeurs <0 !!!   }

  mov SI,Debut_Caract
  mov DI,Debut_Ecran

  jmp @fBoucle_Plans

@Fond_zero:               { Affichage avec fond=0 (le + rapide) }

@fzBoucle_Plans:
  mov DX,Nb_Boucles_y     { Nb de lignes }

@fzBoucle_Lignes:
  mov CX,Nb_Boucles_x     { Nb de pixels de large par plan }
  test CL,0FCh
  jz  @fzCopier_le_reste  { Bouclex2 si moins de 4 pixels de large }

@fzBouclex1:
  movsb
  add SI,3
  movsb
  add SI,3
  movsb
  add SI,3
  movsb
  add SI,3

  sub CL,4
  test CL,0FCh     { il reste plus de 4 Pixels ? }
  jnz @Bouclex1    { oui => Boucler              }

@fzCopier_le_reste:
  jcxz @fzProchaine_ligne

@fzBouclex2:
  movsb
  add SI,3
  loop @fzBouclex2

@fzProchaine_ligne:
  or  CX,Cmpt_Pixels_Sup   { Cmpt_Pixel_sup=0 ? ( Rq: CX=0 )   }
  jz  @fzSuite2

  movsb
  dec SI
  dec DI

@fzSuite2:
  add SI,Incr_Fin_Ligne
  add DI,Incrementx

  dec DX                   { Encore une ligne ?     }
  jnz @fzBoucle_Lignes     { Oui => Prochaine ligne }

  dec BL                   { Encore un plan ? }
  jz  @Fin                 { Non => Fin       }

  rol BH,1                 { Changer de plan  }
  mov DX,SequencerData
  mov AL,BH
  out DX,AL

  cmp AL,12h               { Carry si BH=11h (si debut d'une nouvelle ligne) }
  adc Debut_Ecran,0        { Dcale l'adresse de dpart de l'cran }
  inc Debut_Caract         { Se dcaler dans l'image }

  sub Cmpt_Pixels_Sup,1    { Dcrmenter Cmpt_Pixels_Sup }
  adc Cmpt_Pixels_Sup,0    { Eviter les valeurs <0 !!!   }

  mov SI,Debut_Caract
  mov DI,Debut_Ecran

  jmp @fzBoucle_Plans

@pas_fond:

@Boucle_Plans:            { Affichage sans fond }
  mov DX,Nb_Boucles_y     { Nb de lignes }

@Boucle_Lignes:
  mov CX,Nb_Boucles_x     { Nb de pixels de large par plan }
  test CL,0FCh
  jz  @Copier_le_reste    { Bouclex2 si moins de 4 pixels de large }

@Bouclex1:
  lodsb
  add SI,3
  cmp AL,0
  je  @Pas_aff1
  mov ES:[DI],AL
@Pas_aff1:
  inc DI
  lodsb
  add SI,3
  cmp AL,0
  je  @Pas_aff2
  mov ES:[DI],AL
@Pas_aff2:
  inc DI
  lodsb
  add SI,3
  cmp AL,0
  je  @Pas_aff3
  mov ES:[DI],AL
@Pas_aff3:
  inc DI
  lodsb
  add SI,3
  cmp AL,0
  je  @Pas_aff4
  mov ES:[DI],AL
@Pas_aff4:
  inc DI

  sub CL,4
  test CL,0FCh     { il reste plus de 4 Pixels ? }
  jnz @Bouclex1    { oui => Boucler              }

@Copier_le_reste:
  jcxz @Prochaine_ligne

@Bouclex2:
  lodsb
  add SI,3
  cmp AL,0
  je  @Pas_aff5
  mov ES:[DI],AL
@Pas_aff5:
  inc DI
  loop @Bouclex2

@Prochaine_ligne:
  or  CX,Cmpt_Pixels_Sup   { Cmpt_Pixel_sup=0 ? ( Rq: CX=0 )   }
  jz  @Suite2

  mov AL,[SI]
  cmp AL,0
  je  @Pas_aff6
  mov ES:[DI],AL
@Pas_aff6:

@Suite2:
  add SI,Incr_Fin_Ligne
  add DI,Incrementx

  dec DX                   { Encore une ligne ?     }
  jnz @Boucle_Lignes       { Oui => Prochaine ligne }

  dec BL                   { Encore un plan ? }
  jz  @Fin                 { Non => Fin       }

  rol BH,1                 { Changer de plan  }
  mov DX,SequencerData
  mov AL,BH
  out DX,AL

  cmp AL,12h               { Carry si BH=11h (si debut d'une nouvelle ligne) }
  adc Debut_Ecran,0        { Dcale l'adresse de dpart de l'cran }
  inc Debut_Caract         { Se dcaler dans le caractre }

  sub Cmpt_Pixels_Sup,1    { Dcrmenter Cmpt_Pixels_Sup }
  adc Cmpt_Pixels_Sup,0    { Eviter les valeurs <0 !!!   }

  mov SI,Debut_Caract
  mov DI,Debut_Ecran

  jmp @Boucle_Plans

@fin:
  pop DS
 end;
end; {FNT.AffCarXYx}

{----------------------------------------------------------}

procedure FNT.AffChXYx(segment,x,y: WORD; chaine: String64; fond: BOOLEAN; couleur_fond: BYTE);
{affiche une chane en (x,y) dans la page cran pointe par 'segment' (Mode x),
 sans tests de dbordements.
 -si 'fond'=FALSE, la chane est affiche sans fond (transparent), couleur_fond est indiffrent
 -si 'fond'=TRUE, la chane est affiche avec couleur_fond pour fond}

var i: BYTE;
    xPos: WORD;
begin
 xPos:=x;
 for i:=1 to Length(chaine) do begin
  FNT.AffCarXYx(segment,xPos,y,chaine[i],fond,couleur_fond);
  inc(xPos,largeur+1);
 end;
end; {FNT.AffChXYx}

{----------------------------------------------------------}

procedure FNT.AffCarXYLimite(segment: WORD;
                             x,y: INTEGER; car: CHAR; fond: BOOLEAN; couleur_fond: BYTE;
                             xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);
{affiche un caractre en (x,y) dans la zone vido commenant en 'segment',
 avec tests de dbordements dans la fentre (xg,yh,xd,yb).
 -si 'fond'=FALSE, il est affich sans fond (transparent), couleur_fond est indiffrent
 -si 'fond'=TRUE, il est affich avec couleur_fond pour fond}

var xg_car,yh_car,xd_car,yb_car: INTEGER;
    ptr_table_offset,ptr_donnees: POINTER;
    largeur_fonte: BYTE;

begin
 if x>=xg then xg_car:=x else xg_car:=xg;
 if x+largeur+1<=xd then xd_car:=x+largeur else xd_car:=xd;
 if y>=yh then yh_car:=y else yh_car:=yh;
 if y+hauteur<=yb then yb_car:=y+hauteur-1 else yb_car:=yb;
 if (xd_car>=xg_car) and (yb_car>=yh_car) then
  begin
   ptr_table_offset:=@table_offset;
   ptr_donnees:=donnees;
   largeur_fonte:=largeur;
   asm
    mov DX,DS

    cld

    mov ES,segment
    mov AX,yh_car
    xchg AH,AL
    mov DI,AX
    shr AX,2
    add DI,AX
    add DI,xg_car             {ES:DI -> segment:xg_car+320*yh_car: coin sup. gauche}

    mov BX,yb_car
    sub BX,yh_car
    inc BX
    mov CH,BL                 {CH=yh_car-yb_car+1: hauteur visible}

    mov BX,xd_car
    sub BX,xg_car             {BL=xd_car-xg_car: largeur visible}
                              {sans la colonne intercaractre}
    xor AH,AH
    mov AL,largeur_fonte
    sub AX,BX                 {calcule incrment SI=largeur-(largeur visible)}
    mov WORD ptr CS:[@incr_SI-2],AX    {crit incrment SI}
    mov WORD ptr CS:[@incr_SI2-2],AX   {crit incrment SI}

    mov AX,320
    sub AX,BX                 {calcule incrment DI=320-(largeur visible)}
    mov WORD ptr CS:[@incr_DI-2],AX    {crit incrment DI}
    mov WORD ptr CS:[@incr_DI2-2],AX   {crit incrment DI}

    lds SI,ptr_table_offset   {DS:SI -> table_offset[#0]}
    xor AH,AH
    mov AL,car                {AX=code ASCII caractre}
    shl AX,1
    add SI,AX                 {DS:SI -> table_offset[car]}
    lodsw                     {AX=offset caractre}
    lds SI,ptr_donnees        {DS:SI -> donnees^[0]}
    add SI,AX                 {DS:SI -> donnees^[offset_caractere]}

    add SI,xg_car
    sub SI,x                  {ajoute xg_car-x (pour dbordement  gauche)}

    mov AX,yh_car
    sub AX,y
    js @pas_deborde_haut      {si yh_car<=y, pas de dbordement en haut}
    mov CL,largeur_fonte
    mul CL
    add SI,AX                 {si yh_car>y, ajoute largeur*(yh_car-y)}

   @pas_deborde_haut:

    cmp fond,TRUE             {faut-il afficher un fond?}
    jne @pas_fond             {non}

    mov AH,couleur_fond

   @boucle_ligne:
    mov CL,BL                 {CL=largeur visible}
    or  CL,CL                 {au moins un point  afficher?}
    jz  @pas_de_point         {non}
    @boucle_colonne:
     lodsb                    {AL=couleur du point  afficher}
     or  AL,AL                {couleur nulle?}
     jnz @affiche_point       {non}
     mov AL,AH                {AL=couleur fond}
    @affiche_point:
     stosb
     dec CL
     jnz @boucle_colonne
   @pas_de_point:
    mov ES:[DI],AH            {affiche le fond de la colonne intercaractre}
    add SI,1234h
    @incr_SI:
    add DI,1234h              {ligne suivante}
    @incr_DI:
    dec CH
    jnz @boucle_ligne
    jmp @fin

   @pas_fond:

   @boucle_ligne2:
    mov CL,BL                 {CL=largeur visible}
    or  CL,CL                 {au moins un point  afficher?}
    jz  @pas_de_point2        {non}
    @boucle_colonne2:
     lodsb                    {AL=couleur du point  afficher}
     or  AL,AL                {couleur nulle?}
     jz  @affiche_pas_point   {oui}
     mov ES:[DI],AL
    @affiche_pas_point:
     inc DI
     dec CL
     jnz @boucle_colonne2
   @pas_de_point2:
    add SI,1234h
    @incr_SI2:
    add DI,1234h              {ligne suivante}
    @incr_DI2:
    dec CH
    jnz @boucle_ligne2

   @fin:
    mov DS,DX
   end;
  end;
end; {FNT.AffCarXYLimite}

{----------------------------------------------------------}

procedure FNT.AffChXYLimite(segment: WORD;
                            x,y: INTEGER; chaine: String64; fond: BOOLEAN; couleur_fond: BYTE;
                            xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);
{affiche une chane de caractres en (x,y) dans la zone vido commenant en
 'segment', avec tests de dbordements dans la fentre (xg,yh,xd,yb).
 -si 'fond'=FALSE, la chane est affiche sans fond (transparent), couleur_fond est indiffrent
 -si 'fond'=TRUE, la chane est affiche avec couleur_fond pour fond}

var i: BYTE;
    xPos: WORD;

begin
 xPos:=x;
 for i:=1 to Length(chaine) do begin
  FNT.AffCarXYLimite(segment,xPos,y,chaine[i],fond,couleur_fond,xg,yh,xd,yb);
  inc(xPos,largeur+1);
 end;
end; {FNT.AffChXYLimite}

{==========================================================}

END.
