{ͻ}
{                      --== GRAPH256.PAS ==--                      }
{                                                                      }
{ Unit pour le mode graphique MCGA 13h (320x200 256 couleurs)         }
{                                                                      }
{ AUTEURS: Fabrice Couteau et Freddy Vtel                            }
{Ķ}
{ Compatibilit: 386           Dbut d'criture ??/02/94 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT Graph256;

{$A+,G+,Q-,R-,S-}

INTERFACE

{$I Types}

CONST {filtres de couleur pour Palette256.Intensite}
      rouge=4; vert=2; bleu=1;

      {incrment automatique pour Palette256.Fondu}
      auto=0;

      {sens de transfert pour TransfereZone}
      et=0; {transfert zone cran->tampon}
      te=1; {transfert tampon->zone cran}

      {oprateurs d'affichage pour AfficheFormeLimite}
      MOV_=$88;
      ADD_=$00;
      SUB_=$28;
      XOR_=$30;
      OR_ =$08;
      AND_=$20;


TYPE RVB=record R,V,B: BYTE end;

     Palette256=object
                 palette: array[BYTE] of RVB;
                 procedure Charge(premiere: BYTE; nombre: WORD);
                 procedure Fixe  (premiere: BYTE; nombre: WORD);
                 procedure Intensite(premiere: BYTE; nombre: WORD; niveau: SHORTINT; filtre: BYTE);
                 procedure Fondu    (premiere: BYTE; nombre: WORD; increment: BYTE);
                end;

     Masque=array[1..8*8] of BYTE; {type pour AffCarXYM/AffChXYM}

     T_zone=array[1..320*200] of BYTE;
     Zone=object
           xg_: WORD; yh_: BYTE; xd_: WORD; yb_: BYTE; {xg,yh: coin suprieur gauche
                                                        xd,yb: coin infrieur droit}
           procedure Sauve(segment,xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);
           procedure Restaure(segment: WORD; dx,dy: INTEGER);
           procedure Supprime;
           procedure Ombre(segment,xg: WORD; yh: BYTE; xd: WORD; yb: BYTE; couleur: BYTE);
          private
           contenu: ^T_zone;
          end;


VAR palette_noire,palette_blanche: Palette256;

{==========================================================}

procedure Init320x200;

procedure ChargeDAC(couleur: BYTE; var comp: RVB);
procedure FixeDAC  (couleur: BYTE; comp: RVB);

procedure AffCarXY (segment,x: WORD; y: BYTE; car: CHAR; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE);
procedure AffChXY  (segment,x: WORD; y: BYTE; chaine: String64; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE);
procedure AffCarXYM(segment,x: WORD; y: BYTE; car: CHAR; tab_masque: Masque; fond: BOOLEAN; couleur_fond: BYTE);
procedure AffChXYM (segment,x: WORD; y: BYTE; chaine: String64; tab_masque: Masque; fond: BOOLEAN; couleur_fond: BYTE);
procedure AffCar5x6(segment,x: WORD; y: BYTE; car: CHAR; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE);
procedure AffCh5x6 (segment,x: WORD; y: BYTE; chaine: String64; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE);
procedure AffCar4x5(segment,x: WORD; y: BYTE; car: CHAR; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE);
procedure AffCh4x5 (segment,x: WORD; y: BYTE; chaine: String64; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE);

procedure Point(segment,x: WORD; y: BYTE; couleur: BYTE);
procedure LigneHorizontale(segment: WORD; y: BYTE; xg,xd: WORD; couleur: BYTE);
procedure LigneVerticale  (segment,x: WORD; yb,yh,couleur: BYTE);
procedure Cadre     (segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur: BYTE);
procedure CadreOmbre(segment,xg: WORD; yh: BYTE; xd: WORD; yb: BYTE; relief: BOOLEAN);
procedure Ligne(segment,x1,y1,x2,y2: WORD; couleur: BYTE);

procedure Cercle(segment,x_centre: WORD; y_centre,rayon,couleur: BYTE);
procedure Disque(segment,x_centre: WORD; y_centre,rayon,couleur: BYTE);
procedure Ellipse      (segment,x_centre: WORD; y_centre,rayon_x,rayon_y,couleur: BYTE);
procedure EllipsePleine(segment,x_centre: WORD; y_centre,rayon_x,rayon_y,couleur: BYTE);

procedure TransfereZone(segment: WORD; var tampon; sens: BYTE; xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);
procedure AfficheFormeLimite(var forme; segment: WORD;
                             x,y: INTEGER; largeur,hauteur: WORD;
                             sprite,saute_zero: BOOLEAN; operateur: BYTE;
                             xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);

procedure EffaceZone(segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur: BYTE);
procedure EffaceZoneCadreOmbre(segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur: BYTE; relief: BOOLEAN);

procedure ScrolleZoneHaut  (segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur,nbr: BYTE);
procedure ScrolleZoneBas   (segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur,nbr: BYTE);
procedure ScrolleZoneGauche(segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur,nbr: BYTE);
procedure ScrolleZoneDroite(segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur,nbr: BYTE);

{==========================================================}

IMPLEMENTATION

USES Util,VGA;

CONST Fonte5x6: array[' '..'z'] of array[1..6] of BYTE=(
                ($00,$00,$00,$00,$00,$00), { }
                ($04,$04,$04,$00,$04,$00), {!}
                ($0A,$0A,$00,$00,$00,$00), {"}
                ($0A,$1F,$0A,$1F,$0A,$00),
                ($0F,$14,$0E,$05,$1E,$00),
                ($19,$1A,$04,$0B,$13,$00),
                ($08,$14,$0D,$12,$0F,$00),
                ($02,$02,$04,$00,$00,$00),
                ($02,$04,$04,$04,$02,$00),
                ($04,$02,$02,$02,$04,$00),
                ($15,$0E,$1F,$0E,$15,$00),
                ($04,$04,$1F,$04,$04,$00),
                ($00,$00,$00,$08,$08,$10),
                ($00,$00,$1F,$00,$00,$00),
                ($00,$00,$00,$00,$04,$00),
                ($01,$02,$04,$08,$10,$00),
                ($0E,$13,$15,$19,$0E,$00),
                ($04,$0C,$04,$04,$0E,$00),
                ($1E,$01,$0E,$10,$1F,$00),
                ($1E,$01,$0E,$01,$1E,$00),
                ($02,$06,$0A,$1F,$02,$00),
                ($1F,$10,$1E,$01,$1E,$00),
                ($0E,$10,$1E,$11,$0E,$00),
                ($1F,$02,$04,$08,$08,$00),
                ($0E,$11,$0E,$11,$0E,$00),
                ($0E,$11,$0F,$01,$0E,$00),
                ($00,$04,$00,$04,$00,$00),
                ($00,$00,$04,$00,$04,$08),
                ($02,$04,$08,$04,$02,$00),
                ($00,$1F,$00,$1F,$00,$00),
                ($08,$04,$02,$04,$08,$00),
                ($0E,$11,$06,$00,$04,$00),
                ($0E,$11,$17,$15,$17,$08),
                ($0E,$11,$1F,$11,$11,$00),
                ($1E,$11,$1E,$11,$1E,$00),
                ($0F,$10,$10,$10,$0F,$00),
                ($1E,$11,$11,$11,$1E,$00),
                ($1F,$10,$1E,$10,$1F,$00),
                ($1F,$10,$1E,$10,$10,$00),
                ($0F,$10,$13,$11,$0E,$00),
                ($11,$11,$1F,$11,$11,$00),
                ($0E,$04,$04,$04,$0E,$00),
                ($03,$01,$01,$11,$0E,$00),
                ($11,$12,$1C,$12,$11,$00),
                ($10,$10,$10,$10,$1F,$00),
                ($11,$1B,$15,$11,$11,$00),
                ($11,$19,$15,$13,$11,$00),
                ($0E,$11,$11,$11,$0E,$00),
                ($1E,$11,$1E,$10,$10,$00),
                ($0E,$11,$15,$12,$0D,$00),
                ($1E,$11,$1E,$12,$11,$00),
                ($0F,$10,$0E,$01,$1E,$00),
                ($1F,$04,$04,$04,$04,$00),
                ($11,$11,$11,$11,$0E,$00),
                ($11,$11,$11,$0A,$04,$00),
                ($11,$11,$15,$1B,$11,$00),
                ($11,$0A,$04,$0A,$11,$00),
                ($11,$0A,$04,$04,$04,$00),
                ($1F,$02,$04,$08,$1F,$00),
                ($06,$04,$04,$04,$06,$00),
                ($10,$08,$04,$02,$01,$00),
                ($0C,$04,$04,$04,$0C,$00),
                ($04,$0A,$11,$00,$00,$00),
                ($00,$00,$00,$00,$00,$1F),
                ($08,$08,$04,$00,$00,$00),
                ($0E,$01,$0F,$11,$0F,$00),
                ($10,$10,$1E,$11,$1E,$00),
                ($00,$0F,$10,$10,$0F,$00),
                ($01,$01,$0F,$11,$0F,$00),
                ($0E,$11,$1F,$10,$0E,$00),
                ($06,$08,$1C,$08,$08,$00),
                ($00,$0E,$11,$0F,$01,$0E),
                ($10,$10,$1E,$11,$11,$00),
                ($04,$00,$04,$04,$04,$00),
                ($02,$00,$02,$02,$12,$0C),
                ($10,$10,$12,$1C,$12,$00),
                ($04,$04,$04,$04,$02,$00),
                ($00,$1E,$15,$15,$15,$00),
                ($00,$1E,$11,$11,$11,$00),
                ($00,$0E,$11,$11,$0E,$00),
                ($00,$1E,$11,$1E,$10,$10),
                ($00,$0F,$11,$0F,$01,$01),
                ($00,$17,$18,$10,$10,$00),
                ($0E,$10,$0C,$02,$1C,$00),
                ($08,$1E,$08,$08,$06,$00),
                ($00,$11,$11,$11,$0F,$00),
                ($00,$11,$11,$0A,$04,$00),
                ($00,$11,$15,$15,$0A,$00),
                ($00,$11,$0E,$0E,$11,$00), {x}
                ($00,$11,$11,$0F,$01,$0E), {y}
                ($00,$1F,$04,$08,$1F,$00));{z}

CONST Fonte4x5: array[' '..'?'] of array[1..5] of BYTE=(
                 ($00,$00,$00,$00,$00), { }
                 ($04,$04,$04,$00,$04), {!}
                 ($05,$05,$00,$00,$00), {"}
                 ($05,$0F,$06,$0F,$0A), {#}
                 ($07,$0A,$06,$05,$0E), { $}
                 ($00,$09,$02,$04,$09), {%}
                 ($04,$0A,$05,$0A,$0D), {&}
                 ($02,$04,$00,$00,$00), {'}
                 ($02,$04,$04,$04,$02), {(}
                 ($04,$02,$02,$02,$04), {)}
                 ($09,$06,$0F,$06,$09), {*}
                 ($00,$02,$07,$02,$00), {+}
                 ($00,$00,$00,$02,$04), {,}
                 ($00,$00,$07,$00,$00), {-}
                 ($00,$00,$00,$00,$04), {.}
                 ($00,$01,$02,$04,$08), {/}
                 ($0F,$09,$09,$09,$0F), {0}
                 ($01,$01,$01,$01,$01), {1}
                 ($0F,$01,$0F,$08,$0F), {2}
                 ($0F,$01,$0F,$01,$0F), {3}
                 ($09,$09,$0F,$01,$01), {4}
                 ($0F,$08,$0F,$01,$0F), {5}
                 ($0F,$08,$0F,$09,$0F), {6}
                 ($0F,$01,$01,$01,$01), {7}
                 ($0F,$09,$0F,$09,$0F), {8}
                 ($0F,$09,$0F,$01,$0F), {9}
                 ($00,$04,$00,$04,$00), {:}
                 ($00,$04,$00,$04,$08), {;}
                 ($02,$04,$08,$04,$02), {<}
                 ($00,$0F,$00,$0F,$00), {=}
                 ($04,$02,$01,$02,$04), {>}
                 ($06,$09,$02,$00,$02));{?}

{==========================================================}

procedure Init320x200;
begin
 AttendVBL;
 asm
  mov AX,0013h
  int 10h        {mode MCGA 320x200 256 couleurs}
 end;
 FillChar(palette_noire.palette,3*256,0);
 FillChar(palette_blanche.palette,3*256,63);
end; {Init320x200}

{----------------------------------------------------------}

procedure ChargeDAC(couleur: BYTE; var comp: RVB);
begin
 PortW[DACRead]:=couleur; {charge le ncouleur}
 with comp do   begin R:=Port[DACData]; V:=Port[DACData]; B:=Port[DACData] end;
end; {ChargeDAC}

{----------------------------------------------------------}

procedure FixeDAC(couleur: BYTE; comp: RVB);
begin
 asm
  mov AL,couleur
  mov DX,DACWrite
  out DX,AL          {charge le ncouleur}
  mov DX,DACData
  mov AL,comp.R
  out DX,AL          {fixe le rouge}
  mov AL,comp.V
  out DX,AL          {fixe le vert}
  mov AL,comp.B
  out DX,AL          {fixe le bleu}
 end
end; {FixeDAC}

{----------------------------------------------------------}

procedure Palette256.Charge(premiere: BYTE; nombre: WORD);
var ptr_palette: POINTER;
begin
 ptr_palette:=@palette;
 asm
  les DI,ptr_palette
  xor AH,AH
  mov AL,premiere
  mov DX,DACRead
  out DX,AL          {charge le ncouleur dans le DAC}
  mov BX,AX
  shl AX,1
  add AX,BX
  add DI,AX          {ES:DI -> palette[premiere]}

  mov DX,DACData
  mov CX,nombre
  mov AX,CX
  shl CX,1
  add CX,AX          {CX=3*nombre}
  cld
  rep insb           {lit les donnes}
 end;
end; {Palette256.Charge}

{----------------------------------------------------------}

procedure Palette256.Fixe(premiere: BYTE; nombre: WORD);
var ptr_palette: POINTER;
begin
 ptr_palette:=@palette;
 AttendVBL;
 asm
  push DS

  lds SI,ptr_palette
  xor AH,AH
  mov AL,premiere
  mov DX,DACWrite
  out DX,AL          {charge le ncouleur dans le DAC}
  mov BX,AX
  shl AX,1
  add AX,BX
  add SI,AX          {DS:SI -> palette[premiere]}

  mov DX,DACData
  mov CX,nombre
  mov AX,CX
  shl CX,1
  add CX,AX          {CX=3*nombre}
  cld
  rep outsb          {crit les donnes}

  pop DS
 end;
end; {Palette256.Fixe}

{----------------------------------------------------------}

procedure Palette256.Intensite(premiere: BYTE; nombre: WORD; niveau: SHORTINT; filtre: BYTE);
var couleur: BYTE;
begin
 for couleur:=0 to 255 do with palette[couleur] do begin
  if (filtre and rouge)=rouge then if (R+niveau in [0..63]) then inc(R,niveau);
  if (filtre and vert )=vert  then if (V+niveau in [0..63]) then inc(V,niveau);
  if (filtre and bleu )=bleu  then if (B+niveau in [0..63]) then inc(B,niveau);
 end;
end; {Palette256.Intensite}

{----------------------------------------------------------}

procedure Palette256.Fondu(premiere: BYTE; nombre: WORD; increment: BYTE);
var initiale,courante: Palette256;
    couleur,diff,maxdiff,i: BYTE;
begin
 courante.Charge(premiere,nombre);
 initiale:=courante;

 if increment=auto then begin  {calcule le nombre de palettes intermdiaires automatiquement}
  maxdiff:=0;
  for couleur:=premiere to premiere+nombre-1 do begin
   diff:=Abs(palette[couleur].R-courante.palette[couleur].R);
   if diff>maxdiff then maxdiff:=diff;
   diff:=Abs(palette[couleur].V-courante.palette[couleur].V);
   if diff>maxdiff then maxdiff:=diff;
   diff:=Abs(palette[couleur].B-courante.palette[couleur].B);
   if diff>maxdiff then maxdiff:=diff
  end;
 end else maxdiff:=increment; {nombre de palettes intermdiaires fix}

 for i:=1 to maxdiff do begin
  for couleur:=premiere to premiere+nombre-1 do begin
   courante.palette[couleur].R:=initiale.palette[couleur].R+i*(palette[couleur].R-initiale.palette[couleur].R) div maxdiff;
   courante.palette[couleur].V:=initiale.palette[couleur].V+i*(palette[couleur].V-initiale.palette[couleur].V) div maxdiff;
   courante.palette[couleur].B:=initiale.palette[couleur].B+i*(palette[couleur].B-initiale.palette[couleur].B) div maxdiff;
  end;
  courante.Fixe(premiere,nombre);
 end;
end; {Palette256.Fondu}

{----------------------------------------------------------}

procedure AffCarXY(segment,x: WORD; y: BYTE; car: CHAR; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE); assembler;
{pas optimis...}
asm
 push DS

 mov ES,segment
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,x                {ES:DI -> segment:x+320*y}

 mov AL,car
 mov AH,couleur
 mov BL,fond
 mov BH,couleur_fond

 mov DX,0FFA6h
 mov DS,DX               {DS=FFA6: segment table fonte systme 8x8}

 mov DX,AX
 xor DH,DH
 mov SI,DX               {SI=code ASCII du caractre}
 shl SI,3
 add SI,000Eh            {SI=offset premire ligne du caractre}

 cld

 mov DL,8
@boucle_ligne:
 lodsb                   {AL=bits contenant la ligne du caractre}
 mov DH,10000000b
 @boucle_colonne:
  test AL,DH             {faut-il afficher un point du caractre?}
  jnz @aff_point         {oui}
  cmp BL,TRUE            {faut-il afficher un fond?}
  jne @pas_aff_fond      {non}
  mov BYTE ptr ES:[DI],BH  {affiche un point du fond}
  jmp @pas_aff_fond
 @aff_point:
  mov BYTE ptr ES:[DI],AH  {affiche un point du caractre}
 @pas_aff_fond:
  inc DI
  shr DH,1
  jnz @boucle_colonne
 add DI,320-8
 dec DL
 jnz @boucle_ligne

 pop DS
end; {AffCarXY}

{----------------------------------------------------------}

procedure AffChXY(segment,x: WORD; y: BYTE; chaine: String64; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE); assembler;
{pas optimis...}
asm
 push DS

 mov ES,segment
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,x                {ES:DI -> segment:x+320*y}

 mov AH,couleur
 mov BL,fond
 mov BH,couleur_fond
 lds SI,chaine

 mov DX,0FFA6h           {DX=FFA6: segment table fonte systme 8x8}

 mov CH,AH               {CH=couleur}

 cld

 lodsb                   {AL=longueur de la chane}
 or AL,AL                {chaine vide?}
 jz @fin

@affiche_car:
 push AX                 {sauvegarde AL: nombre de caractres}
 lodsb                   {charge code ASCII du caractre}

 push DS                 {sauvegarde segment chane}
 push SI                 {sauvegarde offset chane}
 push DI                 {sauvegarde adresse RAM vido}

 mov DS,DX               {DS=FFA6: segment table fonte systme 8x8}
 xor AH,AH
 mov SI,AX               {SI=code ASCII du caractre}
 shl SI,3
 add SI,000Eh            {SI=offset premire ligne du caractre}

 mov CL,8
@boucle_ligne:
 lodsb                   {AL=bits contenant la ligne du caractre}
 mov AH,10000000b
 @boucle_colonne:
  test AL,AH             {faut-il afficher un point du caractre?}
  jnz @aff_point         {oui}
  cmp BL,TRUE            {faut-il afficher un fond?}
  jne @pas_aff_fond      {non}
  mov BYTE ptr ES:[DI],BH  {affiche un point du fond}
  jmp @pas_aff_fond
 @aff_point:
  mov BYTE ptr ES:[DI],CH  {affiche un point du caractre}
 @pas_aff_fond:
  inc DI
  shr AH,1
  jnz @boucle_colonne
 add DI,320-8
 dec CL
 jnz @boucle_ligne

 pop DI                  {restaure adresse RAM vido}
 pop SI                  {restaure offset chane}
 pop DS                  {restaure segment chane}

 add DI,8                {prochain caractre 8 pixels plus loin}
 pop AX                  {restaure AL: nombre de caractres}
 dec AL
 jnz @affiche_car

@fin:
 pop DS
end; {AffChXY}

{----------------------------------------------------------}

procedure AffCarXYM(segment,x: WORD; y: BYTE; car: CHAR; tab_masque: Masque; fond: BOOLEAN; couleur_fond: BYTE); assembler;
{pas optimis...}
asm
 push DS

 mov ES,segment
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,x                {ES:DI -> segment:x+320*y}

 mov AL,car
 mov BL,fond
 mov BH,couleur_fond
 lds DX,tab_masque
 push DX                 {empile segment et offset du masque de couleurs}
 push DS

 mov DX,0FFA6h
 mov DS,DX               {DS=FFA6: segment table fonte systme 8x8}

 mov DX,AX
 xor DH,DH
 mov SI,DX               {SI=code ASCII du caractre}
 shl SI,3
 add SI,000Eh            {SI=offset premire ligne du caractre}

 xor AH,AH               {index du masque de couleurs=0}

 cld

 mov DL,8
@boucle_ligne:
 lodsb                   {AL=bits contenant la ligne du caractre}
 mov DH,10000000b
 @boucle_colonne:
  test AL,DH             {faut-il afficher un point du caractre?}
  jnz @aff_point         {oui}
  cmp BL,TRUE            {faut-il afficher un fond?}
  jne @pas_aff_fond      {non}
  mov BYTE ptr ES:[DI],BH  {affiche un point du fond}
  jmp @pas_aff_fond
 @aff_point:
  push AX
  push DS
  push SI
  push BP
  mov AL,AH
  xor AH,AH
  mov SI,AX              {SI=index du masque de couleurs}
  mov BP,SP
  mov DS,[BP+8]          {DS=segment du masque de couleurs (DS)}
  mov BP,[BP+10]         {BP=offset du masque de couleurs (DX)}
  mov AL,BYTE ptr DS:[BP+SI]  {AL=couleur du point dans le masque}
  mov BYTE ptr ES:[DI],AL  {affiche un point du caractre}
  pop BP
  pop SI
  pop DS
  pop AX

 @pas_aff_fond:
  inc DI                 {point suivant}
  inc AH                 {incrmente l'index du masque de couleurs}
  shr DH,1
  jnz @boucle_colonne
 add DI,320-8
 dec DL
 jnz @boucle_ligne

 pop DS                  {dpile segment et offset du masque de couleurs}
 pop DX

 pop DS
end; {AffCarXYM}

{----------------------------------------------------------}

procedure AffChXYM(segment,x: WORD; y: BYTE;
                   chaine: String64; tab_masque: Masque; fond: BOOLEAN; couleur_fond: BYTE); assembler;
{pas optimis...}
asm
 push DS

 mov ES,segment
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,x                {ES:DI -> segment:x+320*y}

 mov BL,fond
 mov BH,couleur_fond
 lds DX,tab_masque
 push DX                 {empile segment et offset du masque de couleurs}
 push DS
 lds SI,chaine

 mov DX,0FFA6h           {DX=FFA6: segment table fonte systme 8x8}

 cld

 lodsb                   {AL=longueur de la chane}
 or AL,AL                {chane vide?}
 jz @fin

@affiche_car:
 push AX                 {sauvegarde AL: nombre de caractres}
 lodsb                   {charge code ASCII du caractre}

 push DS                 {sauvegarde segment chane}
 push SI                 {sauvegarde offset chane}
 push DI                 {sauvegarde adresse RAM vido}

 mov DS,DX               {DS=FFA6: segment table fonte systme 8x8}

 mov CX,AX
 xor CH,CH
 mov SI,CX               {SI=code ASCII du caractre}
 shl SI,3
 add SI,000Eh            {SI=offset premire ligne du caractre}

 xor AH,AH               {index du masque de couleurs=0}

 mov CL,8
@boucle_ligne:
 lodsb                   {AL=bits contenant la ligne du caractre}
 mov CH,10000000b
 @boucle_colonne:
  test AL,CH             {faut-il afficher un point du caractre?}
  jnz @aff_point         {oui}
  cmp BL,TRUE            {faut-il afficher un fond?}
  jne @pas_aff_fond      {non}
  mov BYTE ptr ES:[DI],BH  {affiche un point du fond}
  jmp @pas_aff_fond
 @aff_point:
  push AX
  push DS
  push SI
  push BP
  mov AL,AH
  xor AH,AH
  mov SI,AX              {SI=index du masque de couleurs}
  mov BP,SP
  mov DS,[BP+16]         {DS=segment du masque de couleurs (DS)}
  mov BP,[BP+18]         {BP=offset du masque de couleurs (DX)}
  mov AL,BYTE ptr DS:[BP+SI]  {AL=couleur du point dans le masque}
  mov BYTE ptr ES:[DI],AL  {affiche un point du caractre}
  pop BP
  pop SI
  pop DS
  pop AX
 @pas_aff_fond:
  inc DI                 {point suivant}
  inc AH                 {incrmente l'index du masque de couleurs}
  shr CH,1
  jnz @boucle_colonne
 add DI,320-8
 dec CL
 jnz @boucle_ligne

 pop DI                  {restaure adresse RAM vido}
 pop SI                  {restaure offset chane}
 pop DS                  {restaure segment chane}

 add DI,8                {prochain caractre 8 pixels plus loin}
 pop AX                  {restaure AL: nombre de caractres}
 dec AL
 jnz @affiche_car

@fin:
 pop DS                  {dpile segment et offset du masque de couleurs}
 pop DX

 pop DS
end; {AffChXYM}

{----------------------------------------------------------}

procedure AffCar5x6(segment,x: WORD; y: BYTE; car: CHAR; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE); assembler;
asm
 push DS
 cld

 mov DX,SEG Fonte5x6
 mov DS,DX
 mov SI,OFFSET Fonte5x6  {DS:SI -> Fonte5x6[' ']}

 mov ES,segment
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,x                {ES:DI -> segment:x+320*y}

 mov AL,car

 cmp AL,' '
 jb @corrige_code
 cmp AL,'z'
 jbe @code_ok
@corrige_code:
 mov AL,' '

@code_ok:
 xor AH,AH
 mov DX,AX               {DX=code ASCII}
 shl DX,1
 add DX,AX
 shl DX,1
 sub DX,6*32             {DX=6*(code ASCII-32)}
 add SI,DX               {DS:SI -> Fonte5x6[caractre]}

 mov AH,couleur

 mov DL,6

 cmp fond,TRUE           {faut-il afficher un fond?}
 jne @pas_aff_fond       {non}

 mov BH,couleur_fond

@boucle_ligne:
 lodsb                   {AL=bits contenant la ligne du caractre}
 mov DH,00010000b
 @boucle_colonne:
  test AL,DH             {faut-il afficher un point du caractre?}
  jnz @aff_point         {oui}
  mov BYTE ptr ES:[DI],BH  {affiche un point du fond}
  jmp @suite
 @aff_point:
  mov BYTE ptr ES:[DI],AH  {affiche un point du caractre}
 @suite:
  inc DI                 {point suivant}
  shr DH,1
  jnz @boucle_colonne
 add DI,320-5
 dec DL
 jnz @boucle_ligne
 jmp @fin

@pas_aff_fond:

@boucle_ligne2:
 lodsb                   {AL=bits contenant la ligne du caractre}
 mov DH,00010000b
 @boucle_colonne2:
  test AL,DH             {faut-il afficher un point du caractre?}
  jz @suite2             {non}
  mov BYTE ptr ES:[DI],AH  {affiche un point du caractre}
 @suite2:
  inc DI                 {point suivant}
  shr DH,1
  jnz @boucle_colonne2
 add DI,320-5
 dec DL
 jnz @boucle_ligne2

@fin:
 pop DS
end; {AffCar5x6}

{----------------------------------------------------------}

procedure AffCh5x6(segment,x: WORD; y: BYTE; chaine: String64; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE); assembler;
asm
 push DS
 cld

 mov ES,segment
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,x                {ES:DI -> segment:x+320*y}

 lds SI,chaine
 lodsb                   {AL=longueur chane}
 or AL,AL                {chane vide?}
 jz @fin

 mov CL,AL               {CL=longueur chane}

 cmp fond,TRUE           {faut-il afficher un fond?}
 jne @pas_aff_fond       {non}

 mov BH,couleur_fond

@affiche_car:
 lodsb                   {charge code ASCII du caractre}

 push DS                 {sauvegarde segment:offset chane}
 push SI
 push DI                 {sauvegarde adresse RAM vido}

 cmp AL,' '
 jb @corrige_code
 cmp AL,'z'
 jbe @code_ok
@corrige_code:
 mov AL,' '

@code_ok:
 mov DX,SEG Fonte5x6
 mov DS,DX
 mov SI,OFFSET Fonte5x6  {DS:SI -> Fonte5x6[' ']}

 xor AH,AH
 mov DX,AX               {DX=code ASCII}
 shl DX,1
 add DX,AX
 shl DX,1
 sub DX,6*32             {DX=6*(code ASCII-32)}
 add SI,DX               {DS:SI -> Fonte5x6[caractre]}

 mov AH,couleur

 mov CH,6
@boucle_ligne:
 lodsb                   {AL=bits contenant la ligne du caractre}
 mov DH,00010000b
 @boucle_colonne:
  test AL,DH             {faut-il afficher un point du caractre?}
  jnz @aff_point         {oui}
  mov BYTE ptr ES:[DI],BH  {affiche un point du fond}
  jmp @suite
 @aff_point:
  mov BYTE ptr ES:[DI],AH  {affiche un point du caractre}
 @suite:
  inc DI                 {point suivant}
  shr DH,1
  jnz @boucle_colonne
 mov BYTE ptr ES:[DI],BH {affiche un point du fond (sparation entre 2 caractres)}
 add DI,320-5
 dec CH
 jnz @boucle_ligne

 pop DI                  {restaure adresse RAM vido}
 pop SI
 pop DS                  {restaure segment:offset chane}

 add DI,6                {prochain caractre 6 pixels plus loin}

 dec CL                  {CL=nombre de caractres restant  afficher}
 jnz @affiche_car
 jmp @fin

@pas_aff_fond:
@affiche_car2:
 lodsb                   {charge code ASCII du caractre}

 push DS                 {sauvegarde segment:offset chane}
 push SI
 push DI                 {sauvegarde adresse RAM vido}

 cmp AL,' '
 jb @corrige_code2
 cmp AL,'z'
 jbe @code_ok2
@corrige_code2:
 mov AL,' '

@code_ok2:
 mov DX,SEG Fonte5x6
 mov DS,DX
 mov SI,OFFSET Fonte5x6  {DS:SI -> Fonte5x6[' ']}

 xor AH,AH
 mov DX,AX               {DX=code ASCII}
 shl DX,1
 add DX,AX
 shl DX,1
 sub DX,6*32             {DX=6*(code ASCII-32)}
 add SI,DX               {DS:SI -> Fonte5x6[caractre]}

 mov AH,couleur

 mov CH,6
@boucle_ligne2:
 lodsb                   {AL=bits contenant la ligne du caractre}
 mov DH,00010000b
 @boucle_colonne2:
  test AL,DH             {faut-il afficher un point du caractre?}
  jz @suite2             {non}
  mov BYTE ptr ES:[DI],AH  {affiche un point du caractre}
 @suite2:
  inc DI                 {point suivant}
  shr DH,1
  jnz @boucle_colonne2
 add DI,320-5
 dec CH
 jnz @boucle_ligne2

 pop DI                  {restaure adresse RAM vido}
 pop SI
 pop DS                  {restaure segment:offset chane}

 add DI,6                {prochain caractre 6 pixels plus loin}

 dec CL                  {CL=nombre de caractres restant  afficher}
 jnz @affiche_car2

@fin:
 pop DS
end; {AffCh5x6}

{----------------------------------------------------------}

procedure AffCar4x5(segment,x: WORD; y: BYTE; car: CHAR; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE); assembler;
asm
 push DS
 cld

 mov DX,SEG Fonte4x5
 mov DS,DX
 mov SI,OFFSET Fonte4x5  {DS:SI -> Fonte4x5[' ']}

 mov ES,segment
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,x                {ES:DI -> segment:x+320*y}

 mov AL,car

 cmp AL,' '
 jb @corrige_code
 cmp AL,'?'
 jbe @code_ok
@corrige_code:
 mov AL,' '

@code_ok:
 xor AH,AH
 mov DX,AX               {DX=code ASCII}
 shl DX,2
 add DX,AX
 sub DX,5*32             {DX=5*(code ASCII-32)}
 add SI,DX               {DS:SI -> Fonte4x5[caractre]}

 mov AH,couleur

 mov DL,5

 cmp fond,TRUE           {faut-il afficher un fond?}
 jne @pas_aff_fond       {non}

 mov BH,couleur_fond

@boucle_ligne:
 lodsb                   {AL=bits contenant la ligne du caractre}
 mov DH,00001000b
 @boucle_colonne:
  test AL,DH             {faut-il afficher un point du caractre?}
  jnz @aff_point         {oui}
  mov BYTE ptr ES:[DI],BH  {affiche un point du fond}
  jmp @suite
 @aff_point:
  mov BYTE ptr ES:[DI],AH  {affiche un point du caractre}
 @suite:
  inc DI                 {point suivant}
  shr DH,1
  jnz @boucle_colonne
 add DI,320-4
 dec DL
 jnz @boucle_ligne
 jmp @fin

@pas_aff_fond:

@boucle_ligne2:
 lodsb                   {AL=bits contenant la ligne du caractre}
 mov DH,00001000b
 @boucle_colonne2:
  test AL,DH             {faut-il afficher un point du caractre?}
  jz @suite2             {non}
  mov BYTE ptr ES:[DI],AH  {affiche un point du caractre}
 @suite2:
  inc DI                 {point suivant}
  shr DH,1
  jnz @boucle_colonne2
 add DI,320-4
 dec DL
 jnz @boucle_ligne2

@fin:
 pop DS
end; {AffCar4x5}

{----------------------------------------------------------}

procedure AffCh4x5(segment,x: WORD; y: BYTE; chaine: String64; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE); assembler;
asm
 push DS
 cld

 mov ES,segment
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,x                {ES:DI -> segment:x+320*y}

 lds SI,chaine
 lodsb                   {AL=longueur chane}
 or AL,AL                {chane vide?}
 jz @fin

 mov CL,AL               {CL=longueur chane}

 cmp fond,TRUE           {faut-il afficher un fond?}
 jne @pas_aff_fond       {non}

 mov BH,couleur_fond

@affiche_car:
 lodsb                   {charge code ASCII du caractre}

 push DS                 {sauvegarde segment:offset chane}
 push SI
 push DI                 {sauvegarde adresse RAM vido}

 cmp AL,' '
 jb @corrige_code
 cmp AL,'?'
 jbe @code_ok
@corrige_code:
 mov AL,' '

@code_ok:
 mov DX,SEG Fonte4x5
 mov DS,DX
 mov SI,OFFSET Fonte4x5  {DS:SI -> Fonte4x5[' ']}

 xor AH,AH
 mov DX,AX               {DX=code ASCII}
 shl DX,2
 add DX,AX
 sub DX,5*32             {DX=5*(code ASCII-32)}
 add SI,DX               {DS:SI -> Fonte4x5[caractre]}

 mov AH,couleur

 mov CH,5
@boucle_ligne:
 lodsb                   {AL=bits contenant la ligne du caractre}
 mov DH,00001000b
 @boucle_colonne:
  test AL,DH             {faut-il afficher un point du caractre?}
  jnz @aff_point         {oui}
  mov BYTE ptr ES:[DI],BH  {affiche un point du fond}
  jmp @suite
 @aff_point:
  mov BYTE ptr ES:[DI],AH  {affiche un point du caractre}
 @suite:
  inc DI                 {point suivant}
  shr DH,1
  jnz @boucle_colonne
 mov BYTE ptr ES:[DI],BH {affiche un point du fond (sparation entre 2 caractres)}
 add DI,320-4
 dec CH
 jnz @boucle_ligne

 pop DI                  {restaure adresse RAM vido}
 pop SI
 pop DS                  {restaure segment:offset chane}

 add DI,5                {prochain caractre 5 pixels plus loin}

 dec CL                  {CL=nombre de caractres restant  afficher}
 jnz @affiche_car
 jmp @fin

@pas_aff_fond:
@affiche_car2:
 lodsb                   {charge code ASCII du caractre}

 push DS                 {sauvegarde segment:offset chane}
 push SI
 push DI                 {sauvegarde adresse RAM vido}

 cmp AL,' '
 jb @corrige_code2
 cmp AL,'?'
 jbe @code_ok2
@corrige_code2:
 mov AL,' '

@code_ok2:
 mov DX,SEG Fonte4x5
 mov DS,DX
 mov SI,OFFSET Fonte4x5  {DS:SI -> Fonte4x5[' ']}

 xor AH,AH
 mov DX,AX               {DX=code ASCII}
 shl DX,2
 add DX,AX
 sub DX,5*32             {DX=5*(code ASCII-32)}
 add SI,DX               {DS:SI -> Fonte4x5[caractre]}

 mov AH,couleur

 mov CH,5
@boucle_ligne2:
 lodsb                   {AL=bits contenant la ligne du caractre}
 mov DH,00001000b
 @boucle_colonne2:
  test AL,DH             {faut-il afficher un point du caractre?}
  jz @suite2             {non}
  mov BYTE ptr ES:[DI],AH  {affiche un point du caractre}
 @suite2:
  inc DI                 {point suivant}
  shr DH,1
  jnz @boucle_colonne2
 add DI,320-4
 dec CH
 jnz @boucle_ligne2

 pop DI                  {restaure adresse RAM vido}
 pop SI
 pop DS                  {restaure segment:offset chane}

 add DI,5                {prochain caractre 5 pixels plus loin}

 dec CL                  {CL=nombre de caractres restant  afficher}
 jnz @affiche_car2

@fin:
 pop DS
end; {AffCh4x5}

{----------------------------------------------------------}

procedure Point(segment,x: WORD; y: BYTE; couleur: BYTE); assembler;
asm
 mov ES,segment
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,x       {ES:DI -> x+320*y}
 mov AL,couleur
 mov ES:[DI],AL
end; {Point}

{----------------------------------------------------------}

procedure LigneHorizontale(segment: WORD; y: BYTE; xg,xd: WORD; couleur: BYTE); assembler;
asm
 cld
 mov ES,segment
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,xg      {ES:DI -> segment:xg+320*y}
 mov AH,couleur
 mov AL,AH      {AL=AH=couleur}
 mov CX,xd
 sub CX,xg
 inc CX         {CX=xd-xg+1}
 shr CX,1
 jnc @pair
 stosb          {affiche premier point}
@pair:
 rep stosw      {affiche le reste}
end; {LigneHorizontale}

{----------------------------------------------------------}

procedure LigneVerticale(segment,x: WORD; yb,yh,couleur: BYTE); assembler;
asm
 mov ES,segment
 mov AH,yb
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,x       {ES:DI -> segment:x+320*y}
 mov AL,couleur {AL=couleur}
 xor CH,CH
 mov CL,yh
 sub CL,yb
 inc CL         {CX=yh-yb+1}
 cld
@boucle:
 stosb
 add DI,319     {ligne suivante}
 loop @boucle
end; {LigneVerticale}

{----------------------------------------------------------}

procedure Ligne(segment,x1,y1,x2,y2: WORD; couleur: BYTE); assembler;
var x,y: INTEGER;
    Cumul: INTEGER;
    Xincr,Yincr: INTEGER;
    Deltax,Deltay: INTEGER;
asm
  mov AX,X1
  cmp AX,X2
  jae @X1_sup_X2    {Test si X1>X2}
  mov Xincr,1
  mov BX,X2
  mov Deltax,BX     {Calcul de Deltax}
  sub Deltax,AX
  jmp @Fin_compx
@X1_sup_X2:
  mov Xincr,-1
  mov Deltax,AX
  mov BX,X2
  sub Deltax,BX
@Fin_compx:
  mov X,AX
  mov AX,Y1
  cmp AX,Y2
  jae @Y1_sup_Y2
  mov Yincr,320
  mov BX,Y2
  mov Deltay,BX     {Calcul de Deltay}
  sub Deltay,AX
  jmp @Fin_compy
@Y1_sup_Y2:
  mov Yincr,-320
  mov Deltay,AX
  mov BX,Y2
  sub Deltay,BX
@Fin_compy:
  mov Y,AX

  xor AL,AL
  mov ES,segment
  mov BX,Y
  mov AH,BL
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,X
  mov AL,couleur
  mov BYTE ptr ES:[DI],AL { Premier Point en x+320y }

  mov AX,Deltay
  cmp AX,Deltax      { Choix de la boucle }

  jb @Dely_sup_Delx
  cmp AX,1
  jbe @Fin_Ligne     { Fin si Deltay<=1 }
  shr AX,1           { AX=Deltay div 2  }
  mov DX,AX          { DX=AX=Cumul      }
  mov CX,Deltay
  dec CX             { CX=Deltay-1      }
  mov BX,Deltay      { BX=DeltaY        }
  mov AL,couleur

@Boucle1:
  add DI,Yincr

  add DX,Deltax
  cmp DX,BX
  jb @Cumul_inf_dely

  sub DX,BX
  add DI,Xincr       { Ajuster la position X }
@Cumul_inf_dely:

  mov BYTE ptr ES:[DI],AL      {Autres Points}
  loop @Boucle1

  jmp @Fin_ligne

@Dely_sup_Delx:      { si Deltay>DeltaX }
  mov DX,Deltax
  cmp DX,1
  jbe @Fin_Ligne
  mov CX,DX
  dec CX             { CX=Deltax-1 (Nb Boucles) }
  shr DX,1           { DX=Deltax div 2  }
                     { DX=Cumul         }
  mov AL,Couleur
  mov BX,DeltaX      { BX=DeltaX        }

@Boucle2:
  add DI,Xincr
  add DX,Deltay
  cmp DX,BX
  jb @Cumul_inf_delx
  sub DX,BX
  add DI,YIncr
@Cumul_inf_delx:

  mov BYTE ptr ES:[DI],AL      {Autres Points}
  loop @Boucle2

@Fin_ligne:
end; {Ligne}

{----------------------------------------------------------}

procedure Cadre(segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur: BYTE);
begin
 LigneHorizontale(segment,yh,xg,xd,couleur);
 LigneHorizontale(segment,yb,xg,xd,couleur);
 LigneVerticale(segment,xg,yh,yb,couleur);
 LigneVerticale(segment,xd,yh,yb,couleur)
end; {Cadre}

{----------------------------------------------------------}

procedure CadreOmbre(segment,xg: WORD; yh: BYTE; xd: WORD; yb: BYTE; relief: BOOLEAN);
const couleur: array[BOOLEAN] of BYTE=(15,8);
begin
 LigneHorizontale(segment,yh,xg,xd-1,couleur[relief]);
 LigneVerticale(segment,xg,yh,yb-1,couleur[relief]);
 LigneHorizontale(segment,yb,xg+1,xd,couleur[not relief]);
 LigneVerticale(segment,xd,yh+1,yb,couleur[not relief]);
 Point(segment,xd,yh,7); Point(segment,xg,yb,7)
end; {CadreOmbre}

{----------------------------------------------------------}

procedure Cercle(segment,x_centre: WORD; y_centre,rayon,couleur: BYTE);
{pas de test de dbordement, pas de correction de ratio...}
var x,y,d: INTEGER;
begin
 x:=0;
 y:=rayon;
 d:=1-2*y;
 while y>=0 do begin
  asm
   mov ES,segment
   mov AL,couleur

   mov SI,x        {SI=x}
   mov BX,y
   xchg BH,BL
   mov DX,BX
   shr BX,2
   add DX,BX       {DX=320*y}

   xor BL,BL
   mov BH,y_centre
   mov DI,BX
   shr BX,2
   add DI,BX
   add DI,x_centre {DI=x_centre+320*y_centre}

   add DI,SI
   add DI,DX       {ES:DI -> segment:(x_centre+x)+320*(y_centre+y)}
   mov ES:[DI],AL
   sub DI,SI
   sub DI,SI       {ES:DI -> segment:(x_centre-x)+320*(y_centre+y)}
   mov ES:[DI],AL
   sub DI,DX
   sub DI,DX       {ES:DI -> segment:(x_centre-x)+320*(y_centre-y)}
   mov ES:[DI],AL
   add DI,SI
   add DI,SI       {ES:DI -> segment:(x_centre+x)+320*(y_centre-y)}
   mov ES:[DI],AL
  end;
  if y+d>0 then begin dec(y); inc(d,1-2*y) end;
  if x>d   then begin inc(x); inc(d,1+2*x) end;
 end;
end; {Cercle}

{----------------------------------------------------------}

procedure Disque(segment,x_centre: WORD; y_centre,rayon,couleur: BYTE);
{pas de test de dbordement, pas de correction de ratio...}
var x,y,d: INTEGER;
begin
 x:=0;
 y:=rayon;
 d:=1-2*y;
 while y>=0 do begin
  asm
   cld
   mov ES,segment
   mov AL,couleur
   mov AH,AL

   mov SI,x        {SI=x}
   mov BX,y
   xchg BH,BL
   mov DX,BX
   shr BX,2
   add DX,BX       {DX=320*y}

   xor BL,BL
   mov BH,y_centre
   mov DI,BX
   shr BX,2
   add DI,BX
   add DI,x_centre
   sub DI,SI       {DI=(x_centre-x)+320*y_centre}

   mov BX,DI

   sub DI,DX       {ES:DI -> segment:(x_centre-x)+320*(y_centre-y)}
   stosb
   mov CX,SI
   rep stosw

   mov DI,BX

   add DI,DX       {ES:DI -> segment:(x_centre-x)+320*(y_centre+y)}
   stosb
   mov CX,SI
   rep stosw
  end;
  if y+d>0 then begin dec(y); inc(d,1-2*y) end;
  if x>d   then begin inc(x); inc(d,1+2*x) end;
 end;
end; {Disque}

{----------------------------------------------------------}

procedure Ellipse(segment,x_centre: WORD; y_centre,rayon_x,rayon_y,couleur: BYTE);
{pas de test de dbordement, pas de correction de ratio...}
var x,y,d: INTEGER;
begin
 if (rayon_x=0) or (rayon_y=0) then exit;

 x:=0;
 y:=rayon_y;
 d:=1-2*y;
 while y>=0 do begin
  asm
   mov ES,segment
   mov AL,couleur

   mov SI,x        {SI=x}
   mov BX,y
   xchg BH,BL
   mov DX,BX
   shr BX,2
   add DX,BX       {DX=320*y}

   xor BL,BL
   mov BH,y_centre
   mov DI,BX
   shr BX,2
   add DI,BX
   add DI,x_centre {DI=x_centre+320*y_centre}

   add DI,SI
   add DI,DX       {ES:DI -> segment:(x_centre+x)+320*(y_centre+y)}
   mov ES:[DI],AL
   sub DI,SI
   sub DI,SI       {ES:DI -> segment:(x_centre-x)+320*(y_centre+y)}
   mov ES:[DI],AL
   sub DI,DX
   sub DI,DX       {ES:DI -> segment:(x_centre-x)+320*(y_centre-y)}
   mov ES:[DI],AL
   add DI,SI
   add DI,SI       {ES:DI -> segment:(x_centre+x)+320*(y_centre-y)}
   mov ES:[DI],AL
  end;
  if y+d>0 then begin dec(y); inc(d,(rayon_x*(1-2*y)) div rayon_y) end;
  if x>d   then begin inc(x); inc(d,(rayon_y*(1+2*x)) div rayon_x) end;
 end;
end; {Ellipse}

{----------------------------------------------------------}

procedure EllipsePleine(segment,x_centre: WORD; y_centre,rayon_x,rayon_y,couleur: BYTE);
{pas de test de dbordement, pas de correction de ratio...}
var x,y,d: INTEGER;
begin
 if (rayon_x=0) or (rayon_y=0) then exit;

 x:=0;
 y:=rayon_y;
 d:=1-2*y;
 while y>=0 do begin
  asm
   cld
   mov ES,segment
   mov AL,couleur
   mov AH,AL

   mov SI,x        {SI=x}
   mov BX,y
   xchg BH,BL
   mov DX,BX
   shr BX,2
   add DX,BX       {DX=320*y}

   xor BL,BL
   mov BH,y_centre
   mov DI,BX
   shr BX,2
   add DI,BX
   add DI,x_centre
   sub DI,SI       {DI=(x_centre-x)+320*y_centre}

   mov BX,DI

   sub DI,DX       {ES:DI -> segment:(x_centre-x)+320*(y_centre-y)}
   stosb
   mov CX,SI
   rep stosw

   mov DI,BX

   add DI,DX       {ES:DI -> segment:(x_centre-x)+320*(y_centre+y)}
   stosb
   mov CX,SI
   rep stosw
  end;
  if y+d>0 then begin dec(y); inc(d,(rayon_x*(1-2*y)) div rayon_y) end;
  if x>d   then begin inc(x); inc(d,(rayon_y*(1+2*x)) div rayon_x) end;
 end;
end; {EllipsePleine}

{----------------------------------------------------------}

procedure TransfereZone(segment: WORD; var tampon; sens: BYTE; xg: WORD; yh: BYTE; xd: WORD; yb: BYTE); assembler;
{transfre une zone rectangulaire (xg,yh,xd,yb)
  -si sens=et: de l'cran commenant au segment 'segment' vers le tampon
  -si sens=te: du tampon vers l'cran commenant au segment 'segment'
Remarque: le tampon est continu (n'a pas la structure d'un cran!)}
const NOP_=$90; MOVSB_=$A4; MOVSW_=$A5;
asm
 push DS
 cld

 les DI,tampon
 mov DS,segment

 mov AH,yh
 xor AL,AL
 mov SI,AX
 shr AX,2
 add SI,AX
 add SI,xg        {DS:SI -> segment:xg+320*yh}
                  {par dfaut, transfert cran->tampon}
 mov BX,xd
 sub BX,xg
 inc BX           {BX=nombre colonnes}

 mov AL,BL
 and AL,3         {AL=(nombre colonnes) modulo 4}
 jnz @pas0
 mov WORD ptr CS:[@fin_copie],256*NOP_+NOP_
 mov WORD ptr CS:[@fin_copie2],256*NOP_+NOP_
 jmp @suite
@pas0:
 cmp AL,1
 jne @pas1
 mov WORD ptr CS:[@fin_copie],256*MOVSB_+NOP_
 mov WORD ptr CS:[@fin_copie2],256*MOVSB_+NOP_
 jmp @suite
@pas1:
 mov WORD ptr CS:[@fin_copie],256*MOVSW_+NOP_
 mov WORD ptr CS:[@fin_copie2],256*MOVSW_+NOP_
 cmp AL,2
 je @suite
 mov WORD ptr CS:[@fin_copie+1],256*MOVSW_+MOVSB_
 mov WORD ptr CS:[@fin_copie2+1],256*MOVSW_+MOVSB_
@suite:
 mov DX,320
 sub DX,BX        {incrment SI et DI: DX=320-(nombre colonnes)}

 shr BX,2         {BL=(nombre colonnes)/4}
 mov BH,yb
 sub BH,yh
 inc BH           {BH=nombre lignes}

 xor CH,CH

 cmp sens,te      {transfert tampon->cran?}
 je @transfert_te {oui}

@copie_ligne_et:
 mov CL,BL
 DB 66h; rep movsw   {rep movsd: copie une ligne}
 @fin_copie:
 nop
 nop
 add SI,DX        {ligne suivante}
 dec BH
 jnz @copie_ligne_et
 jmp @fin_transfert

@transfert_te:
 mov ES,segment
 mov DI,SI        {ES:DI -> segment:xg+320*yh}
 lds SI,tampon    {transfert tampon->cran}

@copie_ligne_te:
 mov CL,BL
 DB 66h; rep movsw  {rep movsd: copie une ligne}
 @fin_copie2:
 nop
 nop
 add DI,DX        {ligne suivante}
 dec BH
 jnz @copie_ligne_te

@fin_transfert:
 pop DS
end; {TransfereZone}

{----------------------------------------------------------}

procedure AfficheFormeLimite(var forme; segment: WORD;
                             x,y: INTEGER; largeur,hauteur: WORD;
                             sprite,saute_zero: BOOLEAN; operateur: BYTE;
                             xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);

{affiche la forme pointe par 'forme' dans la zone vido commenant en 'segment'.
 (x,y) sont les coordonnes du point suprieur gauche de la matrice rectangulaire
 de dimensions (largeur,hauteur). (x,y) peut sortir de l'cran...
 Si 'sprite'=TRUE:
  - la forme est affiche point par point, avec un test par point.
  - si 'saute_zero'=TRUE, les points de couleur nulle ne sont pas affichs.
  - 'operateur': c'est l'instruction d'affichage (mov,add,sub,xor,or,and).
 Si 'sprite'=FALSE:
  - la forme est affiche 4 points par 4 points, sans test.
  - 'saute_zero' et 'operateur' sont indiffrents.
 Dans tous les cas, la forme est affiche dans les limites de la fentre de
 coordonnes (xg,yh,xd,yb) relatives  la zone vido.}

const NOP_=$90;

var xg_forme,yh_forme,xd_forme,yb_forme: INTEGER;

begin
 if x>=xg then xg_forme:=x else xg_forme:=xg;
 if x+largeur<=xd then xd_forme:=x+largeur-1 else xd_forme:=xd;
 if y>=yh then yh_forme:=y else yh_forme:=yh;
 if y+hauteur<=yb then yb_forme:=y+hauteur-1 else yb_forme:=yb;
 if (xd_forme>=xg_forme) and (yb_forme>=yh_forme) then
  asm
   push DS
   cld

   lds SI,forme
   mov AX,yh_forme
   sub AX,y
   js @pas_deborde_haut
   mul largeur
   add SI,AX           {si yh_forme>y, ajoute largeur*(yh_forme-y)}
  @pas_deborde_haut:
   mov AX,xg_forme
   sub AX,x
   js @pas_deborde_gauche
   add SI,AX           {si xg_forme>x, ajoute xg_forme-x}
  @pas_deborde_gauche:
   mov ES,segment
   mov AX,320
   mul yh_forme
   add AX,xg_forme
   mov DI,AX           {ES:DI -> segment:xg_forme+320*yh_forme}

   mov AX,yb_forme
   sub AX,yh_forme
   inc AX
   mov BX,AX           {BX=nombre lignes}

   mov AX,xd_forme
   sub AX,xg_forme
   inc AX
   mov DX,AX           {DX=nombre colonnes}

   mov CX,largeur
   sub CX,DX           {incrment SI=largeur-(nombre colonnes)}
   mov WORD ptr CS:[@incr_SI-2],CX        {crit incrment SI}
   mov WORD ptr CS:[@incr_SI_2-2],CX      {crit incrment SI}

   mov CX,320
   sub CX,AX           {incrment DI=320-(nombre colonnes)}
   mov WORD ptr CS:[@incr_DI-2],CX        {crit incrment DI}
   mov WORD ptr CS:[@incr_DI_2-2],CX      {crit incrment DI}

   cmp sprite,TRUE     {affichage en mode sprite?}
   jne @aff_continu    {non}

   cmp saute_zero,TRUE
   jne @pas_saute_zero
   mov WORD ptr CS:[@code_test_zero],0C00Ah   {or AL,AL}
   mov WORD ptr CS:[@code_test_zero+2],0374h  {jz @aff_pas_point}
   jmp @suite
  @pas_saute_zero:
   mov WORD ptr CS:[@code_test_zero],256*NOP_+NOP_
   mov WORD ptr CS:[@code_test_zero+2],256*NOP_+NOP_ {remplace les 2 lignes par 4*nop}

  @suite:
   mov AL,operateur
   mov BYTE ptr CS:[@code_op+1],AL    {crit oprateur d'affichage}

   jmp @ici  {vide la queue de prlecture}
  @ici:

  @boucle_y:
   mov CX,DX           {CX=nombre colonnes}
   @boucle_x:
    lodsb              {charge couleur de la forme}
    @code_test_zero:
    or AL,AL           {nulle?}
    jz @aff_pas_point  {oui}
    @code_op:
    mov ES:[DI],AL     {oprateur d'affichage, auto-modifi}
    @aff_pas_point:
    inc DI
    loop @boucle_x
   add SI,1234h
   @incr_SI:
   add DI,1234h
   @incr_DI:
   dec BX
   jnz @boucle_y
   jmp @fin

  @aff_continu:
   mov AL,DL
   and AL,3            {AL=(nombre colonnes) Modulo 4}
   shr DX,2            {DL=(nombre colonnes)/4}
   xor CH,CH
  @aff_ligne:
    mov CL,DL
    DB 66h; rep movsw  {rep movsd}
    or  AL,AL          {encore des points  afficher?}
    jz  @fin_ligne     {non}
    mov CL,AL
    rep movsb          {affiche fin ligne}
   @fin_ligne:
    add SI,1234h
   @incr_SI_2:
    add DI,1234h
   @incr_DI_2:
    dec BX
   jnz @aff_ligne

  @fin:
   pop DS
  end;
end; {AfficheFormeLimite}

{----------------------------------------------------------}

procedure Zone.Sauve(segment,xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);
begin
 xg_:=xg; yh_:=yh; xd_:=xd; yb_:=yb;
 GetMem(contenu,(xd-xg+1)*(yb-yh+1));
 TransfereZone(segment,contenu^,et,xg,yh,xd,yb);
end; {Zone.Sauve}

{------------------------------------------------}

procedure Zone.Restaure(segment: WORD; dx,dy: INTEGER);
begin
 AfficheFormeLimite(contenu^,segment,xg_+dx,yh_+dy,(xd_-xg_+1),(yb_-yh_+1),FALSE,FALSE,MOV_,0,0,319,199);
end; {Zone.Restaure}

{------------------------------------------------}

procedure Zone.Supprime;
begin
 FreeMem(contenu,(xd_-xg_+1)*(yb_-yh_+1));
end; {Zone.Supprime}

{------------------------------------------------}

procedure Zone.Ombre(segment,xg: WORD; yh: BYTE; xd: WORD; yb: BYTE; couleur: BYTE);
begin
 Zone.Sauve(segment,xg,yh,xd+4,yb+4);
 EffaceZone(segment,xg+4,yb+1,xd+4,yb+4,0);
 EffaceZone(segment,xd+1,yh+4,xd+4,yb,0);
 EffaceZone(segment,xg,yh,xd,yb,couleur);
end; {Zone.Ombre}

{----------------------------------------------------------}

procedure EffaceZone(segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur: BYTE); assembler;
asm
 mov ES,segment
 mov AH,yh
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,xg      {ES:DI -> segment:xg+320*yh}
 mov BX,xd
 sub BX,xg
 inc BX         {BX=xd-xg+1}
 mov SI,320
 sub SI,BX      {incrment DI: SI=320-(nombre colonnes)}
 mov DX,BX
 and DL,1       {DL=(nombre colonnes) Modulo 2}
 shr BX,1       {BX=(nombre colonnes)/2}
 mov AH,couleur
 mov AL,AH      {AL=AH=couleur}
 mov DH,yb
 sub DH,yh
 inc DH         {DH=yb-yh+1}
 xor CH,CH
 cld
@boucle:
 mov CL,BL
 rep stosw      {efface ligne horizontale}
 or DL,DL       {y a-t-il encore un point  afficher?}
 jz @suite      {non}
 stosb          {affiche le dernier point}
@suite:
 add DI,SI      {ligne suivante}
 dec DH
 jnz @boucle
end; {EffaceZone}

{----------------------------------------------------------}

procedure EffaceZoneCadreOmbre(segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur: BYTE; relief: BOOLEAN);
begin
 EffaceZone(segment,xg+1,yh+1,xd-1,yb-1,couleur);
 CadreOmbre(segment,xg,yh,xd,yb,relief);
end; {EffaceZoneCadreOmbre}

{----------------------------------------------------------}

procedure ScrolleZoneHaut(segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur,nbr: BYTE); assembler;
asm
 push DS

 mov DS,segment
 mov ES,segment
 mov AH,yh
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,xg      {ES:DI -> segment:xg+320*yh}

 mov SI,DI
 mov BH,nbr
 xor BL,BL
 add SI,BX
 shr BX,2
 add SI,BX      {SI=DI+320*nbr}

 mov BX,xd
 sub BX,xg
 inc BX         {BX=xd-xg+1: nombre de colonnes}

 mov DX,320
 sub DX,BX      {incrment SI et DI: DX=320-(nombre colonnes)}
 mov WORD ptr CS:[@incr_DI-2],DX

 mov AL,BL
 and AL,3       {AL=(nombre colonnes) Modulo 4}
 shr BX,2       {BL=(nombre colonnes)/4}

 mov BH,yb
 sub BH,yh
 inc BH
 sub BH,nbr     {BH=yb-yh+1-nbr: (nombre de lignes)-nbr}

 xor CH,CH
 cld

@scrolle:
 mov CL,BL      {CX=(nombre colonnes)/4}
 DB 66h; rep movsw   {rep movsd: copie une ligne vers le haut}
 or AL,AL       {encore des points  copier?}
 jz @suite      {non}
 mov CL,AL
 rep movsb      {copie les derniers points}
@suite:
 add DI,DX
 add SI,DX      {ligne suivante}
 dec BH
 jnz @scrolle

 mov DL,AL      {DL=(nombre colonnes) Modulo 4}
 mov BH,nbr     {BH=nbr de lignes  effacer}
 mov AL,couleur {couleur d'effacement des lignes du bas}
 mov AH,AL
 mov CX,AX
 DB  66h,0C1h,0E0h,010h  {shl EAX,16}
 mov AX,CX      {EAX=couleurcouleurcouleurcouleur}
 xor CH,CH
@efface:
 mov CL,BL      {CX=(nombre colonnes)/4}
 DB 66h; rep stosw    {rep stosd: efface une ligne}
 or DL,DL       {encore des points  effacer?}
 jz @suite2     {non}
 mov CL,DL
 rep stosb      {efface les derniers points}
@suite2:
 add DI,1234h   {ligne suivante}
 @incr_DI:
 dec BH
 jnz @efface

 pop DS
end; {ScrolleZoneHaut}

{----------------------------------------------------------}

procedure ScrolleZoneBas(segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur,nbr: BYTE); assembler;
asm
 push DS

 mov DS,segment
 mov ES,segment
 mov AH,yb
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,xg      {ES:DI -> segment:xg+320*yb}

 mov SI,DI
 mov BH,nbr
 xor BL,BL
 sub SI,BX
 shr BX,2
 sub SI,BX      {SI=DI-320*nbr}

 mov BX,xd
 sub BX,xg
 inc BX         {BX=xd-xg+1: nombre de colonnes}

 mov DX,320
 add DX,BX      {dcrment SI et DI: DX=320+(nombre colonnes)}
 mov WORD ptr CS:[@decr_DI-2],DX

 mov AL,BL
 and AL,3       {AL=(nombre colonnes) Modulo 4}
 shr BX,2       {BL=(nombre colonnes)/4}

 mov BH,yb
 sub BH,yh
 inc BH
 sub BH,nbr     {BH=yb-yh+1-nbr: nombre de lignes-nbr}

 xor CH,CH
 cld

@scrolle:
 mov CL,BL      {CX=(nombre colonnes)/4}
 DB 66h; rep movsw    {rep movsd: copie une ligne vers le bas}
 or AL,AL       {encore des points  copier?}
 jz @suite      {non}
 mov CL,DL
 rep movsb      {copie les derniers points}
@suite:
 sub DI,DX
 sub SI,DX      {ligne suivante}
 dec BH
 jnz @scrolle

 mov DL,AL      {DL=(nombre colonnes) Modulo 4}
 mov BH,nbr     {BH=nbr de lignes  effacer}
 mov AL,couleur {couleur d'effacement des lignes du haut}
 mov AH,AL
 mov CX,AX
 DB  66h,0C1h,0E0h,010h  {shl EAX,16}
 mov AX,CX      {EAX=couleurcouleurcouleurcouleur}
 xor CH,CH
@efface:
 mov CL,BL      {CX=(nombre colonnes)/4}
 DB 66h; rep stosw    {rep stosd: efface une ligne}
 or DL,DL       {encore des points  effacer?}
 jz @suite2     {non}
 mov CL,DL
 rep stosb      {efface les derniers points}
@suite2:
 sub DI,1234h   {ligne suivante}
 @decr_DI:
 dec BH
 jnz @efface

 pop DS
end; {ScrolleZoneBas}

{----------------------------------------------------------}

procedure ScrolleZoneGauche(segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur,nbr: BYTE); assembler;
asm
 push DS

 mov DS,segment
 mov ES,segment
 mov AH,yh
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,xg      {ES:DI -> segment:xg+320*yh}

 xor AH,AH
 mov AL,nbr     {AX=nbr}

 mov SI,DI
 add SI,AX      {SI=DI+nbr}

 mov BX,xd
 sub BX,xg
 inc BX
 sub BX,AX      {BX=(xd-xg+1)-nbr: nombre de colonnes-nbr}

 mov AX,320
 sub AX,BX      {incrment SI et DI=320-(nombre colonnes-nbr)}

 mov DX,BX
 and DL,3       {DL=(nombre colonnes-nbr) Modulo 4}
 shr BX,2       {BL=(nombre colonnes-nbr)/4}

 mov DH,yb
 sub DH,yh
 inc DH         {DH=yb-yh+1: nombre de lignes}

 push DX

 cld
 xor CH,CH

@scrolle:
 mov CL,BL      {CX=(nombre colonnes-nbr)/4}
 DB 66h; rep movsw    {rep movsd: copie la ligne vers la gauche}
 or DL,DL       {encore des points  copier?}
 jz @suite      {non}
 mov CL,DL
 rep movsb      {copie les derniers points}
@suite:
 add SI,AX
 add DI,AX      {ligne suivante}
 dec DH
 jnz @scrolle

 pop DX

 sub DI,AX
 mov BL,nbr
 add DI,BX
 dec DI         {DI=xd+320*yb}

 mov AX,320
 sub AX,BX
 mov BX,AX      {BX=320-nbr}
 mov AL,couleur {couleur d'effacement colonnes de droite}

 mov DL,nbr
 std            {sens dcroissant}

@efface:
 mov CL,DL      {CX=nbr}
 rep stosb      {efface nbr colonnes  droite}
 sub DI,BX      {ligne suivante}
 dec DH
 jnz @efface

 pop DS
end; {ScrolleZoneGauche}

{----------------------------------------------------------}

procedure ScrolleZoneDroite(segment,xg: WORD; yh: BYTE; xd: WORD; yb,couleur,nbr: BYTE); assembler;
{!!BUG!! Ne marche pas avec rep MOVSD !!?? Problme avec effacement...}
asm
 push DS

 mov DS,segment
 mov ES,segment
 mov AH,yh
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,xd      {ES:DI -> segment:xd+320*yh}

 xor AH,AH
 mov AL,nbr     {AX=nbr}

 mov SI,DI
 sub SI,AX      {SI=DI-nbr}

 mov BX,xd
 sub BX,xg
 inc BX
 sub BX,AX      {BX=(xd-xg+1)-nbr: nombre de colonnes-nbr}

 mov AX,320
 add AX,BX      {incrment SI et DI=320+(nombre colonnes-nbr)}

 mov DX,BX
 and DL,3       {DL=(nombre colonnes-nbr) Modulo 4}
 shr BX,2       {BL=(nombre colonnes-nbr)/4}

 mov DH,yb
 sub DH,yh
 inc DH         {DH=yb-yh+1: nombre de lignes}

 push DX

 std            {sens dcroissant}
 xor CH,CH

@scrolle:
 mov CL,BL      {CX=(nombre colonnes-nbr)/4}
 DB 66h; rep movsw    {rep movsd: copie la ligne vers la droite}
 or DL,DL       {encore des points  copier?}
 jz @suite      {non}
 mov CL,DL
 rep movsb      {copie les derniers points}
@suite:
 add SI,AX
 add DI,AX      {ligne suivante}
 dec DH
 jnz @scrolle

 pop DX

 sub DI,AX
 xor BH,BH
 mov BL,nbr
 add DI,BX
 dec DI         {DI=(xg+320*yb)+nbr-1}

 mov AX,320
 sub AX,BX
 mov BX,AX      {BX=320-nbr}
 mov AL,couleur {couleur d'effacement colonnes de gauche}

 mov DL,nbr

@efface:
 mov CL,DL      {CX=nbr}
 rep stosb      {efface nbr colonnes  gauche}
 sub DI,BX      {ligne suivante}
 dec DH
 jnz @efface

 pop DS
end; {ScrolleZoneDroite}

{==========================================================}

END.
