{ͻ}
{                       --== GRAPHX.PAS ==--                       }
{                                                                      }
{ Unit pour le mode X 256 couleurs (multi-rsolutions, multi-pages)   }
{ Rq: Syntaxe compatible avec GRAPH256 (pour les routines communes)    }
{                                                                      }
{ AUTEURS: Freddy Vtel et Fabrice Couteau                            }
{Ķ}
{ Compatibilit: 386           Dbut d'criture ??/11/94 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT GraphX;

{$A+,G+,Q-,R-,S-}

{$UNDEF CALCRAPIDE}  {utilise 256+64 (pour ResX=320) ou une multiplication}

INTERFACE

{$I Types}

CONST nbr_modeX=15;

      {n modes et rsolution}
      _256x200=1;
      _256x240=2;
      _320x200=3;
      _320x240=4;
      _320x400=5;
      _320x480=6;
      _360x200=7;
      _360x240=8;
      _360x360=9;
      _360x400=10;
      _360x480=11;
      _376x282=12;
      _376x308=13;
      _376x564=14;
      _400x600=15;

      {constantes de registre+commande}
      map_mask_plane1=$0102;  { map register + plane 1         }
      map_mask_plane2=$1102;  { map register + plane 2         }
      all_planes_on  =$0F02;  { map register + all bit planes  }
      all_planes     =$0F;

      chain4_off     =$0604;  { chain 4 mode off               }
      async_reset    =$0100;  { (a)synchronous reset           }
      sequ_restart   =$0300;  { sequencer restart              }

      latches_on     =$0008;  { bit mask + data from latches   }
      latches_off    =$FF08;  { bit mask + data from cpu       }

      plane_bits     =$03;    { Masque pour le N de plan      }

      LargeurxVirt : WORD=320;
      Largeurx     : WORD=320 div 4; { Rsolution XVirt/4 }
      LargeurEcranx: WORD=320;
      HauteurEcranx: WORD=200;
      Nbr_Pagesx   : BYTE=4;

      Page_Active_x  : BYTE=1;
      Page_Aff_x     : BYTE=1;
      Segment_Actif_x: WORD=$A000;
      Segment_Aff_x  : WORD=$A000;
      Adresse_Ecran  : WORD=0;   { Adresse de dpart du CRTC }

{==========================================================}

procedure InitModexVirtuel(Mode: BYTE; XVirtuel: WORD);
procedure InitModeX(Mode: BYTE);

procedure AffCarXYx(segment,x,y: WORD; code,couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE);
procedure AffChXYx (segment,x,y: WORD; chaine: String64; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE);

procedure Pointx(segment,x,y: WORD; couleur: BYTE);
procedure LigneHorizontalex(segment,y,xg,xd: WORD; couleur: BYTE);
procedure LigneVerticalex  (segment,x,yb,yh: WORD; couleur: BYTE);
procedure Cadrex     (segment,xg,yh,xd,yb: WORD; couleur: BYTE);
procedure CadreOmbrex(segment,xg,yh,xd,yb: WORD; relief: BOOLEAN);
procedure Lignex(segment,x1,y1,x2,y2: WORD; couleur: BYTE);

procedure Cerclex(segment,x_centre,y_centre: WORD; rayon,couleur: BYTE);
procedure Disquex(segment,x_centre,y_centre: WORD; rayon,couleur: BYTE);
procedure Ellipsex      (segment,x_centre,y_centre: WORD; rayon_x,rayon_y,couleur: BYTE);
procedure EllipsePleinex(segment,x_centre,y_centre: WORD; rayon_x,rayon_y,couleur: BYTE);

procedure EffacerEcranx(segment: WORD);
procedure ActiverPage (page: BYTE);
procedure AfficherPage(page: BYTE);
procedure PlacerEcran;
procedure PermuterPages;
procedure EteindreEcran;
procedure AllumerEcran;

{==========================================================}

IMPLEMENTATION

USES Util,VGA;

CONST Segment_page: array[1..5] of WORD=($A000,$A3E8,$A7D0,$ABB8,$AFA0);
      Adresse_page: array[1..5] of WORD=(16000*0,16000*1,16000*2,16000*3,16000*4);

      left_clip_mask : array[1..4] of BYTE=($0F,$0E,$0C,$08);
      right_clip_mask: array[1..4] of BYTE=($01,$03,$07,$0F);
      Point_mask     : array[1..4] of BYTE=($01,$02,$04,$08);

      CRTC_256x200: array[1..8] of WORD
                     =($5F00,$3F01,$4202,$9F03,$4C04,$0005,$0014,$E317);

      CRTC_256x240: array[1..16] of WORD
                     =($5F00,$3F01,$4202,$9F03,$4C04,$0005,$0D06,$3E07,
                       $4109,$EA10,$AC11,$DF12,$0014,$E715,$0616,$E317);

      CRTC_320x200: array[1..2] of WORD
                     =($0014,$E317);

      CRTC_320x240: array[1..10] of WORD
                     =($0D06,$3E07,$4109,$EA10,$AC11,$DF12,$0014,$E715,$0616,$E317);

      CRTC_320x400: array[1..3] of WORD
                     =($4009,$0014,$E317);

      CRTC_320x480: array[1..10] of WORD
                     =($0D06,$3E07,$4009,$EA10,$AC11,$DF12,$0014,$E715,$0616,$E317);

      CRTC_360x200: array[1..8] of WORD
                     =($6B00,$5901,$5A02,$8E03,$5E04,$8A05,$0014,$E317);

      CRTC_360x240: array[1..16] of WORD
                     =($6B00,$5901,$5A02,$8E03,$5E04,$8A05,$0D06,$3E07,
                       $4109,$EA10,$AC11,$DF12,$0014,$E715,$0616,$E317);

      CRTC_360x360: array[1..15] of WORD
                     =($6B00,$5901,$5A02,$8E03,$5E04,$8A05,$4009,$8810,
                       $8511,$6712,$2D13,$0014,$6D15,$BA16,$E317);

      CRTC_360x400: array[1..9] of WORD
                     =($6B00,$5901,$5A02,$8E03,$5E04,$8A05,$4009,$0014,$E317);

      CRTC_360x480: array[1..17] of WORD
                     =($6B00,$5901,$5A02,$8E03,$5E04,$8A05,$0D06,$3E07,$4009,
                       $EA10,$AC11,$DF12,$2D13,$0014,$E715,$0616,$E317);

      CRTC_376x282: array[1..17] of WORD
                     =($6E00,$5D01,$5E02,$9103,$6204,$8F05,$6206,$F007,$6109,
                       $3710,$8911,$3312,$2F13,$0014,$3C15,$5C16,$E317);

      CRTC_376x308: array[1..17] of WORD
                     =($6E00,$5D01,$5E02,$9103,$6204,$8F05,$6206,$0F07,$4009,
                       $3710,$8911,$3312,$2F13,$0014,$3C15,$5C16,$E317);

      CRTC_376x564: array[1..17] of WORD
                     =($6E00,$5D01,$5E02,$9103,$6204,$8F05,$6206,$F007,$6009,
                       $3710,$8911,$3312,$2F13,$0014,$3C15,$5C16,$E317);

      CRTC_400x600: array[1..17] of WORD
                     =($7000,$6301,$6402,$9203,$6504,$8205,$7006,$F007,$6009,
                       $5B10,$8C11,$5712,$3213,$0014,$5815,$7016,$E317);

      CRTC_Data: array[1..nbr_modeX] of
                  record
                   ResX,ResY: WORD;
                   Nbr_pages: BYTE;
                   Clock,Regs: BYTE;
                   OfsValRegs: WORD
                  end
          =((ResX:256; ResY:200; Nbr_pages:5; Clock:$E3; Regs:sizeof(CRTC_256x200) div 2; OfsValRegs:Ofs(CRTC_256x200)),
            (ResX:256; ResY:240; Nbr_pages:4; Clock:$E3; Regs:sizeof(CRTC_256x240) div 2; OfsValRegs:Ofs(CRTC_256x240)),
            (ResX:320; ResY:200; Nbr_pages:4; Clock:$E3; Regs:sizeof(CRTC_320x200) div 2; OfsValRegs:Ofs(CRTC_320x200)),
            (ResX:320; ResY:240; Nbr_pages:3; Clock:$E3; Regs:sizeof(CRTC_320x240) div 2; OfsValRegs:Ofs(CRTC_320x240)),
            (ResX:320; ResY:400; Nbr_pages:2; Clock:$E3; Regs:sizeof(CRTC_320x400) div 2; OfsValRegs:Ofs(CRTC_320x400)),
            (ResX:320; ResY:480; Nbr_pages:1; Clock:$E3; Regs:sizeof(CRTC_320x480) div 2; OfsValRegs:Ofs(CRTC_320x480)),
            (ResX:360; ResY:200; Nbr_pages:3; Clock:$E7; Regs:sizeof(CRTC_360x200) div 2; OfsValRegs:Ofs(CRTC_360x200)),
            (ResX:360; ResY:240; Nbr_pages:3; Clock:$E7; Regs:sizeof(CRTC_360x240) div 2; OfsValRegs:Ofs(CRTC_360x240)),
            (ResX:360; ResY:360; Nbr_pages:2; Clock:$E7; Regs:sizeof(CRTC_360x360) div 2; OfsValRegs:Ofs(CRTC_360x360)),
            (ResX:360; ResY:400; Nbr_pages:1; Clock:$E7; Regs:sizeof(CRTC_360x400) div 2; OfsValRegs:Ofs(CRTC_360x400)),
            (ResX:360; ResY:480; Nbr_pages:1; Clock:$E7; Regs:sizeof(CRTC_360x480) div 2; OfsValRegs:Ofs(CRTC_360x480)),
            (ResX:376; ResY:282; Nbr_pages:2; Clock:$E7; Regs:sizeof(CRTC_376x282) div 2; OfsValRegs:Ofs(CRTC_376x282)),
            (ResX:376; ResY:308; Nbr_pages:2; Clock:$E7; Regs:sizeof(CRTC_376x308) div 2; OfsValRegs:Ofs(CRTC_376x308)),
            (ResX:376; ResY:564; Nbr_pages:1; Clock:$E7; Regs:sizeof(CRTC_376x564) div 2; OfsValRegs:Ofs(CRTC_376x564)),
            (ResX:400; ResY:600; Nbr_pages:1; Clock:$E7; Regs:sizeof(CRTC_400x600) div 2; OfsValRegs:Ofs(CRTC_400x600)));

{==========================================================}

{ InitModeX: Initialise le mode vido avec diffrentes rsolutions    }
{            (si XVirtuel<>0, mise en place de "colonnes virtuelles") }
{                                                                     }
{ Mode Rsolution Pages Ratio  Frquence  Test  Remarques             }
{ ---- ---------- ----- -----  ---------  ----  ---------             }
{  1 | 256 x 200    5   ?      20 MHz           \ Y dans partie haute }
{  2 | 256 x 240    4   ?      20 MHz           / X dans partie basse }
{  3  320 x 200    4   1.2    25 MHz                                 }
{  4  320 x 240    3   1      25 MHz                                 }
{  5  320 x 400    2   2.4    25 MHz                                 }
{  6  320 x 480    1   2      25 MHz                                 }
{  7  360 x 200    3   1.35   28 MHz                                 }
{  8  360 x 240    3   1.125  28 MHz                                 }
{  9  360 x 360    2   ?      28 MHz                                 }
{ 10  360 x 400    1   2.7    28 MHz                                 }
{ 11  360 x 480    1   2.25   28 MHz                                 }
{ 12  376 x 282    2   ?      30 MHz                                }
{ 13  376 x 308    2   ?      30 MHz                                }
{ 14  376 x 564    1   ?      30 MHz                                }
{ 15  400 x 600    1   ?      31.25 MHz                             }

procedure InitModexVirtuel(Mode: BYTE; XVirtuel: WORD);
{ Initialise le mode et les pages }
var Taille_page: LONGINT;
    Seg_Taille_page,OfsCRTC: WORD;
    i: BYTE;
begin
 AttendVBL;
 asm
  mov AX,0013h
  int 10h        { initialise mode 320x200 linaire 256 couleurs }
 end;

 if not(Mode in [1..nbr_modeX]) then exit;

 with CRTC_Data[Mode] do begin
  HauteurEcranX:=ResY;

  if XVirtuel=0 then begin  { XVirtuel=0 => Mode normal }
   LargeurXVirt:=ResX;
   LargeurEcranX:=LargeurXVirt;
   LargeurX:=LargeurXVirt shr 2;
   Nbr_Pagesx:=Nbr_pages;
   Taille_page:=(LONGINT(HauteurEcranX)*LargeurEcranX) shr 2;
   Seg_Taille_page:=Taille_page shr 4;
   for i:=1 to 5 do begin
    Adresse_page[i]:=0;
    Segment_page[i]:=$A000;
   end;
   for i:=2 to Nbr_Pagesx do begin
    Adresse_page[i]:=Taille_page*(i-1);
    Segment_page[i]:=$A000+Seg_Taille_page*(i-1);
   end;
  end;

  i:=Regs;
  OfsCRTC:=OfsValRegs;
  asm
   mov DX,Sequencer
   mov AX,chain4_off
   out DX,AX
   mov AX,async_reset
   out DX,AX
   mov DX,MiscOutput
   mov AL,Clock
   out DX,AL
   mov DX,Sequencer
   mov AX,sequ_restart
   out DX,AX
  end;
  UnLockCRT;
  asm
   mov DX,CRTControl
   xor CH,CH
   mov CL,i
   mov SI,OfsCRTC
   cld
   rep outsw         { Ecrit les valeurs dans les registres du CRTC }
  end
 end;

 asm
  mov DX,CRTControl
  mov AX,LargeurX     { Largeur X virtuelle! }
  shr AX,1
  mov AH,AL
  mov AL,Offset_
  out DX,AX

  mov DX,Sequencer
  mov AX,all_planes_on
  out DX,AX           { Enable writes to ALL four planes }

  mov AX,0A000h
  mov ES,AX
  xor DI,DI

  DB 66h; xor AX,AX   { xor EAX,EAX }
  mov CX,4000h
  DB 66h; rep stosw   { rep stosd: efface toute la mmoire vido }
 end;

 if Nbr_Pagesx>1 then ActiverPage(2) else ActiverPage(1);
 AfficherPage(1);
end; {InitModexVirtuel}

{--------------------------------------------------------------------}

procedure InitModex(Mode: BYTE);
begin
 InitModexVirtuel(Mode,0);
end; {InitModex}

{--------------------------------------------------------------------}

procedure Pointx(segment,x,y: WORD; couleur: BYTE); assembler;
asm
 mov ES,segment
 {$IFDEF CALCRAPIDE}
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,xg      { ES:DI -> segment: xg+320*y   }
 shr DI,2       { ES:DI -> segment:(xg+320*y)/4 }
 {$ELSE}
 mov AX,y
 mul LargeurX
 mov BX,x
 shr BX,2
 add AX,BX
 mov DI,AX
 {$ENDIF}

 mov BX,X
 and BX,plane_bits  { Choix du plan }
 mov DX,Sequencer
 mov AL,MapMask     { $02 }
 mov AH,[Offset Point_Mask+BX]
 out DX,AX

 mov AL,couleur   { Affiche le point }
 mov ES:[DI],AL
end; {Pointx}

{--------------------------------------------------------------------}

procedure AffCarXYx(segment,x,y: WORD; code,couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE); assembler;
var Debut_ecran:WORD;
    Masque_Caract:BYTE;
asm
 push DS
 mov ES,segment
 {$IFDEF CALCRAPIDE}
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,xg      { ES:DI -> segment: xg+320*y   }
 shr DI,2       { ES:DI -> segment:(xg+320*y)/4 }
 {$ELSE}
 mov AX,y
 mul Largeurx
 mov BX,x
 shr BX,2
 add AX,BX
 mov DI,AX
 {$ENDIF}
 mov Debut_Ecran,DI

 mov AX,Largeurx
 dec AX
 mov CS:[Offset @Largx1-2],AX

 mov AL,code

 mov DX,0FFA6h
 mov DS,DX               { DS=FFA6: segment table fonte systme 8x8}

 mov DX,AX
 xor DH,DH
 mov SI,DX               { SI=code ASCII du caractre}
 shl SI,3                { SI=8*code ASCII}
 add SI,000Eh            { SI=offset premire ligne du caractre}

 mov CX,x
 and CX,plane_bits

 mov AX,map_mask_plane2  { Choix du 1 plan en fonction de x }
 shl AH,CL
 mov DX,Sequencerindex
 out DX,AX

 mov Masque_Caract,10000000b

 mov BH,AH               { BH <- masque des plans }
 mov BL,4                { BL Compteur des plans  }
 mov CH,fond
 mov AH,couleur

 mov CL,8                { 8 lignes  afficher}
@boucle_ligne:
 lodsb                   { AL=bits contenant la ligne du caractre}
 mov DL,Couleur_Fond
 mov DH,Masque_Caract    { Masque pour accder aux bits}
                         { Afficher 2 points du mme plan (2*4 plans =8 !! ) }
 test AL,DH              { Faut-il afficher un point du caractre? }
 jnz @aff_point          { Oui                                     }
 cmp CH,TRUE             { Faut-il afficher un fond?               }
 jne @pas_aff_fond       { Non                                     }
 mov BYTE ptr ES:[DI],DL { Affiche un point du fond                }
 jmp @pas_aff_fond
@aff_point:
 mov BYTE ptr ES:[DI],AH { Affiche un point du caractre           }
@pas_aff_fond:
 inc DI                  { Point suivant                           }
 shr DH,4                { Dcale le masque pour accder au bit suivant}
                         { (Bit du mme plan => shr 4)                 }
 test AL,DH              { Faut-il afficher un point du caractre?     }
 jnz @aff_point1         { Oui }
 cmp CH,TRUE             { Faut-il afficher un fond? }
 jne @pas_aff_fond1      { Non }
 mov BYTE ptr ES:[DI],DL { Affiche un point du fond  }
 jmp @pas_aff_fond1
@aff_point1:
 mov BYTE ptr ES:[DI],AH { Affiche un point du caractre}
@pas_aff_fond1:

 add DI,1234h            { Ligne graphique suivante}
@Largx1:
 dec CL
 jnz @boucle_ligne       { Ligne suivante}

 dec BL                  { Encore un plan ? }
 jz @Fin                 { Non => Fin       }

 rol BH,1                { Changer de plan  }
 mov DX,SequencerData
 mov AL,BH
 out DX,AL

 cmp AL,12h              { Carry si BH=11h (si debut d'une nouvelle ligne) }
 adc Debut_Ecran,0       { Dcale l'adresse de dpart de l'cran }

 sub SI,8
 mov DI,Debut_Ecran

 shr Masque_Caract,1
 mov CL,8
 jmp @Boucle_Ligne

@Fin:
 pop DS
end; {AffCarXYx}

{----------------------------------------------------------}

procedure AffChXYx(segment,x,y: WORD; chaine: String64; couleur: BYTE; fond: BOOLEAN; couleur_fond: BYTE); assembler;
var Cmpt_Caract:BYTE;
    Debut_ecran:WORD;
    Masque_Caract:BYTE;
    Plan_depart:BYTE; { on commence toujours avec le mme plan pour chaque caractere }

asm
 push DS

 mov ES,segment
 {$IFDEF CALCRAPIDE}
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,xg      { ES:DI -> segment: xg+320*y   }
 shr DI,2       { ES:DI -> segment:(xg+320*y)/4 }
 {$ELSE}
 mov AX,y
 mul Largeurx
 mov BX,x
 shr BX,2
 add AX,BX
 mov DI,AX
 {$ENDIF}

 mov AX,Largeurx
 dec AX
 mov CS:[Offset @Largx1-2],AX

 mov AH,couleur
 mov BL,fond
 mov BH,couleur_fond
 lds SI,chaine

 cld                     { Sens croissant}

 lodsb                   { AL=longueur de la chane}
 or AL,AL                { Chaine vide?}
 jz @fin                 { Oui, on quitte}
 mov Cmpt_Caract,AL

 mov CX,x                { Calcul du Premier plan }
 and CX,plane_bits
 mov Plan_depart,CL

@affiche_car:
 lodsb                   { Charge code ASCII du caractre}

 push DS                 { Sauvegarde segment chane}
 push SI                 { Sauvegarde offset chane}
 push DI                 { Sauvegarde adresse dans la RAM vido}
 mov Debut_Ecran,DI

 mov DX,0FFA6h           { DX=FFA6: segment table fonte systme 8x8}
 mov DS,DX               { DS=FFA6: segment table fonte systme 8x8}
 xor AH,AH
 mov SI,AX               { SI=code ASCII du caractre}
 shl SI,3                { SI=8*code ASCII}
 add SI,000Eh            { SI=offset premire ligne du caractre}

 mov CL,Plan_depart

 mov AX,map_mask_plane2  { Fixe le 1 plan }
 shl AH,CL
 mov DX,Sequencerindex
 out DX,AX

 mov Masque_Caract,10000000b

 mov BH,AH               { BH <- masque des plans }
 mov BL,4                { BL Compteur des plans  }
 mov CH,fond
 mov AH,couleur

 mov CL,8                { 8 lignes  afficher}
@boucle_ligne:
 lodsb                   { AL=bits contenant la ligne du caractre}
 mov DL,Couleur_Fond
 mov DH,Masque_Caract    { Masque pour accder aux bits}
                         { Afficher 2 points du mme plan (2*4 plans =8 !! ) }
 test AL,DH              { Faut-il afficher un point du caractre?}
 jnz @aff_point          { Oui}
 cmp CH,TRUE             { Faut-il afficher un fond?}
 jne @pas_aff_fond       { Non}
 mov BYTE ptr ES:[DI],DL { Affiche un point du fond}
 jmp @pas_aff_fond
@aff_point:
 mov BYTE ptr ES:[DI],AH { Affiche un point du caractre}
@pas_aff_fond:
 inc DI                  { Point suivant}
 shr DH,4                { Dcale le masque pour accder au bit suivant}
                         { (Bit du mme plan => shr 4)                }
 test AL,DH              { Faut-il afficher un point du caractre?}
 jnz @aff_point1         { Oui}
 cmp CH,TRUE             { Faut-il afficher un fond?}
 jne @pas_aff_fond1      { Non}
 mov BYTE ptr ES:[DI],DL { Affiche un point du fond}
 jmp @pas_aff_fond1
@aff_point1:
 mov BYTE ptr ES:[DI],AH { Affiche un point du caractre}
@pas_aff_fond1:

 add DI,1234h            { Ligne graphique suivante}
@Largx1:
 dec CL
 jnz @boucle_ligne       { Ligne suivante}

 dec BL                  { Encore un plan ? }
 jz @Fin_caractere       { Non => Fin       }

 rol BH,1                { Changer de plan  }
 mov DX,SequencerData
 mov AL,BH
 out DX,AL

 cmp AL,12h              { Carry si BH=11h (si debut d'une nouvelle ligne) }
 adc Debut_Ecran,0       { Dcale l'adresse de dpart de l'cran           }

 sub SI,8                { Revenir au dbut du caractre                   }
 mov DI,Debut_Ecran

 shr Masque_Caract,1
 mov CL,8
 jmp @Boucle_Ligne

@Fin_caractere:

 pop DI                  { Restaure adresse dans la RAM vido}
 pop SI                  { Restaure offset chane}
 pop DS                  { Restaure segment chane}

 add DI,2                { Prochain caractre 8 pixels plus loin (2*4)}
 dec Cmpt_Caract         { Dcrmente le nombre de caractres}
 jnz @affiche_car        { Si non nul, caractre suivant}

@fin:
 pop DS
end; {AffChXY}


{----------------------------------------------------------}

procedure LigneHorizontalex(segment,y,xg,xd: WORD; couleur: BYTE); assembler;
asm
 cld
 mov ES,segment
 {$IFDEF CALCRAPIDE}
 mov AH,y
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,xg      { ES:DI -> segment: xg+320*y   }
 shr DI,2       { ES:DI -> segment:(xg+320*y)/4 }
 {$ELSE}
 mov AX,y
 mul Largeurx
 mov BX,xg
 shr BX,2
 add AX,BX
 mov DI,AX
 {$ENDIF}

 mov AX,Xg      { AX=Xg }
 mov BX,Xd      { BX=Xd }

 mov DX,AX
 shr DX,2       { DX=Xg/4 }

 mov CX,BX
 shr CX,2       { CX=Xd/4 }

 cmp CX,DX
 je @une_bande   { Bande de 4 Pixels }

 mov AH,couleur

 sub CX,DX               { cx = Nb de bandes-1    }
 mov SI,AX               { si = Plan de Xg        }
 and SI,plane_bits       { Chercher le N de plan }
 jz  @Pas_Afficher_Gauche

 mov DX,SequencerData
 mov AL,[Offset left_clip_mask+SI]
 out DX,AL

 mov ES:[DI],AH          { Affiche la partie gauche }

 inc DI
 dec CX
@Pas_Afficher_Gauche:
 inc CX                  { add in left band to middle block  }

 mov SI,BX               { si<-xd  }
 and SI,plane_bits       { get plane values  }
 cmp SI,0003             { plane = 3?        }
 je  @Pas_Droite         { hey, add to middle}

 mov DX,SequencerData
 mov AL,[Offset right_clip_mask+si]
 out DX,AL

 mov SI,DI               { get addr of left edge                            }
 add SI,CX               { add width-1 (bands) to point to top of right edge}
 dec SI

 mov ES:[SI],AH          { Ecrire la partie droite }

 dec CX
 jz  @Fin                { uh.. no middle bands... }

@Pas_Droite:

 mov DX,SequencerData
 mov AL,all_planes
 out DX,AL

 mov AL,AH               { colour is in high and low for stosw }

@pf_middle_loop:
 shr CX,1                { use doubleword transfer }
 jnc @pf_pair
 stosb                   { stosb si CX est impair  }
@pf_pair:
 rep stosw
 jmp @Fin

@une_bande:
 mov SI,AX                  { get left clip mask, save xg }
 and SI,plane_bits          { mask out row #              }
 mov AL,[Offset left_clip_mask+si]  { get left edge mask  }
 mov SI,BX                  { get right clip mask, save xd}
 and SI,plane_bits          { mask out row #              }
 and AL,[Offset right_clip_mask+si] { get right edge mask BYTE    }

 mov DX,SequencerData
 out DX,AL

 mov AH,Couleur
 mov ES:[DI],AH             { fill in pixels              }

@Fin:
end; {LigneHorizontalex}

{----------------------------------------------------------}

procedure LigneVerticalex(segment,x,yb,yh: WORD; couleur: BYTE); assembler;
asm
 {$IFDEF CALCRAPIDE}
 mov AH,yb
 xor AL,AL
 mov DI,AX
 shr AX,2
 add DI,AX
 add DI,X       { ES:DI -> segment: xg+320*y   }
 shr DI,2       { ES:DI -> segment:(xg+320*y)/4 }
 {$ELSE}
 mov AX,yb
 mul Largeurx
 mov BX,x
 shr BX,2
 add AX,BX
 mov DI,AX
 {$ENDIF}

 mov BX,X
 and BX,plane_bits { Choix du plan }
 mov DX,SequencerIndex
 mov AL,MapMask   { $02 }
 mov AH,[Offset Point_Mask+BX]
 out DX,AX

 mov AL,couleur {AL=couleur}
 mov CX,yh
 sub CX,yb
 inc CX         {CX=yh-yb+1}
 mov DX,Largeurx
 dec DX
 cld
@boucle:
 stosb
 add DI,DX     {ligne suivante}
 loop @boucle
end; {LigneVerticalex}

{----------------------------------------------------------}

procedure Cadrex(segment,xg,yh,xd,yb: WORD; couleur: BYTE);
begin
 LigneHorizontalex(segment,yh,xg,xd,couleur);
 LigneHorizontalex(segment,yb,xg,xd,couleur);
 LigneVerticalex(segment,xg,yh,yb,couleur);
 LigneVerticalex(segment,xd,yh,yb,couleur);
end; {Cadrex}

{----------------------------------------------------------}

procedure CadreOmbrex(segment,xg,yh,xd,yb: WORD; relief: BOOLEAN);
const couleur: array[BOOLEAN] of BYTE=(15,8);
begin
 LigneHorizontalex(segment,yh,xg,xd-1,couleur[relief]);
 LigneVerticalex(segment,xg,yh,yb-1,couleur[relief]);
 LigneHorizontalex(segment,yb,xg+1,xd,couleur[not relief]);
 LigneVerticalex(segment,xd,yh+1,yb,couleur[not relief]);
 Pointx(segment,xd,yh,7); Pointx(segment,xg,yb,7);
end; {CadreOmbrex}

{----------------------------------------------------------}

procedure Lignex(segment,x1,y1,x2,y2: WORD; couleur: BYTE);
var d,dx,dy: INTEGER;
    d_plus,d_moins: INTEGER;
    pas_x,pas_y: SHORTINT;
begin
 dx:=INTEGER(x2)-INTEGER(x1);
 dy:=INTEGER(y2)-INTEGER(y1);
 if dx=0 then pas_x:=0 else if dx>0 then pas_x:=+1 else pas_x:=-1;
 if dy=0 then pas_y:=0 else if dy>0 then pas_y:=+1 else pas_y:=-1;
 if Abs(dx)<Abs(dy) then begin  {trace verticalement}
  d:=2*pas_x*dx-pas_y*dy; d_plus:=d-pas_y*dy; d_moins:=d+pas_y*dy;
  Pointx(segment,x1,y1,couleur);
  repeat
   inc(y1,pas_y);
   if d>=0 then begin inc(x1,pas_x); inc(d,d_plus) end else inc(d,d_moins);
   Pointx(segment,x1,y1,couleur);
  until y1=y2;
 end
 else begin  {trace horizontalement}
  d:=2*pas_y*dy-pas_x*dx; d_plus:=d-pas_x*dx; d_moins:=d+pas_x*dx;
  Pointx(segment,x1,y1,couleur);
  repeat
   inc(x1,pas_x);
   if d>=0 then begin inc(y1,pas_y); inc(d,d_plus) end else inc(d,d_moins);
   Pointx(segment,x1,y1,couleur);
  until x1=x2;
 end;
end; {Lignex}

{----------------------------------------------------------}

procedure Cerclex(segment,x_centre,y_centre: WORD; rayon,couleur: BYTE);
{pas de test de dbordement, pas de correction de ratio...}
var x,y,d: INTEGER;
begin
 x:=0;
 y:=rayon;
 d:=1-2*y;
 while y>=0 do begin
  Pointx(segment,x_centre+x,y_centre+y,couleur);
  Pointx(segment,x_centre+x,y_centre-y,couleur);
  Pointx(segment,x_centre-x,y_centre+y,couleur);
  Pointx(segment,x_centre-x,y_centre-y,couleur);
  if y+d>0 then begin dec(y); d:=d+(1-2*y) end;
  if x>d   then begin inc(x); d:=d+(2*x+1) end;
 end;
end; {Cerclex}

{----------------------------------------------------------}

procedure Disquex(segment,x_centre,y_centre: WORD; rayon,couleur: BYTE);
{pas de test de dbordement, pas de correction de ratio...}
var x,y,d: INTEGER;
begin
 x:=0;
 y:=rayon;
 d:=1-2*y;
 while y>=0 do begin
  LigneVerticalex(segment,x_centre+x,y_centre-y,y_centre+y,couleur);
  LigneVerticalex(segment,x_centre-x,y_centre-y,y_centre+y,couleur);
  if y+d>0 then begin dec(y); d:=d+(1-2*y) end;
  if x>d   then begin inc(x); d:=d+(2*x+1) end;
 end;
end; {Disque}

{----------------------------------------------------------}

procedure Ellipsex(segment,x_centre,y_centre: WORD; rayon_x,rayon_y,couleur: BYTE);
{pas de test de dbordement, pas de correction de ratio...}
var x,y,d: INTEGER;
begin
 if (rayon_x=0) or (rayon_y=0) then exit;

 x:=0;
 y:=rayon_y;
 d:=1-2*y;
 while y>=0 do begin
  Pointx(segment,x_centre+x,y_centre+y,couleur);
  Pointx(segment,x_centre+x,y_centre-y,couleur);
  Pointx(segment,x_centre-x,y_centre+y,couleur);
  Pointx(segment,x_centre-x,y_centre-y,couleur);
  if y+d>0 then begin dec(y); d:=d+(rayon_x*(1-2*y) div rayon_y) end;
  if x>d   then begin inc(x); d:=d+(rayon_y*(2*x+1) div rayon_x) end;
 end;
end; {Ellipsex}

{----------------------------------------------------------}

procedure EllipsePleinex(segment,x_centre,y_centre: WORD; rayon_x,rayon_y,couleur: BYTE);
{pas de test de dbordement, pas de correction de ratio...}
var x,y,d: INTEGER;
begin
 if (rayon_x=0) or (rayon_y=0) then exit;

 x:=0;
 y:=rayon_y;
 d:=1-2*y;
 while y>=0 do begin
  LigneVerticalex(segment,x_centre+x,y_centre-y,y_centre+y,couleur);
  LigneVerticalex(segment,x_centre-x,y_centre-y,y_centre+y,couleur);
  if y+d>0 then begin dec(y); d:=d+(rayon_x*(1-2*y) div rayon_y) end;
  if x>d   then begin inc(x); d:=d+(rayon_y*(2*x+1) div rayon_x) end;
 end;
end; {EllipsePleinex}

{----------------------------------------------------------}

procedure EffacerEcranx(segment: WORD); assembler;
asm
 mov DX,Sequencer
 mov AX,all_planes_on
 out DX,AX           { Enable writes to ALL four planes }

 mov AX,HauteurEcranX
 mul LargeurX        { AX=LargeurEcranX*HauteurEcranX/4 }
 mov CX,AX
 shr CX,2            { CX=AX/4 car on crit dans les 4 plans }

 mov ES,segment
 xor DI,DI
 DB 66h; xor AX,AX   { xor EAX,EAX }
 cld
 DB 66h; rep stosw   { rep stosd: Efface l'cran }
end; {EffacerEcranx}

{--------------------------------------------------------------------}

procedure PlacerEcran;  assembler;
asm
 mov AX,Adresse_ecran
 mov BH,AL
 mov CH,AH
 mov BL,StartAddrLow
 mov CL,StartAddrHigh

 mov DX,CRTStatus
{ wait if we are currently in a vertical retrace}
@sw_wait0:                 { Attend Fin VBL      }
 in  AL,DX                 { get vga status       }
 and AL,8                  { in display mode yet? }
 jnz @sw_wait0             { if not, wait for it  }

 mov DX,CRTControl
 mov AX,BX
 out DX,AX                 { start address low              }
 mov AX,CX
 out DX,AX                 { start address high             }

{ wait for a vertical retrace to smooth out things }
 mov DX,CRTStatus
@dp_wait1:                 { Attend VBL             }
 in  AL,DX                 { get vga status          }
 and AL,8                  { vertical retrace start? }
 jz  @dp_wait1             { if not, wait for it     }
end; {PlacerEcranx}

{--------------------------------------------------------------------}

procedure ActiverPage(page: BYTE);      { Activer une page (1->4) }
begin
 Page_Active_x:=page;
 Segment_Actif_x:=Segment_page[page];
end; {ActiverPage}

{--------------------------------------------------------------------}

procedure AfficherPage(page: BYTE);     { Afficher une page (1->4) }
begin
 Page_Aff_x:=page;
 Segment_Aff_x:=Segment_page[page];
 Adresse_Ecran:=Adresse_page[page];
 PlacerEcran;
end;  {AfficherPage}

{--------------------------------------------------------------------}

procedure PermuterPages;     { Permuter la page active et la page affiche }
begin
 Adresse_Ecran:=Adresse_page[Page_Active_x];
 asm
  mov AL,Page_Active_x      {Echange la page active et la page affiche }
  xchg Page_Aff_x,AL
  xchg Page_Active_x,AL
  mov AX,Segment_Actif_x
  xchg Segment_Aff_x,AX
  xchg Segment_Actif_x,AX
  call PlacerEcran
 end;
end; {PermuterPages}

{----------------------------------------------------------}

procedure EteindreEcran; assembler;
asm
 mov DX,CRTStatus
 in  AL,DX
 mov DX,AttrControl
 mov AL,0
 out DX,AL
end; {EteindreEcran}

{----------------------------------------------------------}

procedure AllumerEcran; assembler;
asm
 mov DX,CRTStatus
 in  AL,DX
 mov DX,AttrControl
 mov AL,20h
 out DX,AL
end; {AllumerEcran}

{==========================================================}

END.
