{ͻ}
{                          --== HP.PAS ==--                        }
{                                                                      }
{ Unit pour grer le haut-parleur interne                             }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 286           Dbut d'criture 20/08/95 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT HP;

{$A+,G+,Q-,R-,S-}

INTERFACE

CONST Do_=0; Re=2; Mi=4; Fa=5; Sol=7; La=9; Si=11;
      bemol=-1; diese=+1;
      silence=64;

      Gamme: array[1..7] of BYTE=(Do_,Re,Mi,Fa,Sol,La,Si);

{==========================================================}

procedure Sound(note,octave,duree18: BYTE);

procedure Play(ch: STRING; tache_fond: BOOLEAN);
procedure StopPlay;
procedure PausePlay(pause: BOOLEAN);

{==========================================================}

IMPLEMENTATION

USES Util;

CONST {valeurs pour l'octave 9}
      FreqNote9: array[Do_..Si] of WORD
                  =(16744,17740,18795,19912,21096,22351,
                    23680,25088,26580,28160,29834,31609);

      {valeurs pour l'octave 0}
      FreqTimer0: array[Do_..Si] of WORD
                  =(36485,34437,32505,30680,28958,27333,
                    25799,24351,22984,21694,20477,19327);

      AmplitudeVibrato: array[0..18] of INTEGER
                         =(0,80,151,204,233,235,208,157,88,8,-73,-145,-200,-231,-236,-212,-163,-96,-16);

      FacteurPorta   : array[1..9] of WORD=(33005,33245,33486,33728,33973,34219,34467,34716,34968);
      FacteurPortaInv: array[1..9] of WORD=(32532,32298,32066,31835,31606,31379,31153,30929,30706);

      tempo_defaut=6; { 3 notes/seconde}
      facteur_duree_defaut=100; {dure note = 100% du tempo}
      octave_defaut=3;

      niveau_max=5; {nombre maximal d'imbrications de boucles/blocs}


VAR ancINT1C: POINTER;
    play_actif,pause_play: BOOLEAN;

    ancExitProc: POINTER;

    partition: STRING;
    index,tempo,cpt_tempo,facteur_duree,duree,cpt_duree,octave: BYTE;

    Vibrato: record
              vitesse,cpt_vitesse,amplitude: BYTE;
              frequence_base: WORD;
             end;

    Portamento: record
                 sens: SHORTINT;
                 pas,duree: BYTE;
                 frequence: WORD;
                end;

    Boucle: record
             niveau: BYTE;
             Imbric: array[1..niveau_max] of
                      record index_debut,num_boucle: BYTE end;
            end;

    Bloc: record
           niveau: BYTE;
           Imbric: array[1..niveau_max] of
                    record index_debut,index_retour: BYTE end;
           IndexDebut: array[0..9] of BYTE;
          end;

{==========================================================}

procedure ActiveHP; assembler;
asm
 in AL,61h
 or AL,00000011b
 out 61h,AL
end; {ActiveHP}

{----------------------------------------------------------}

procedure DesactiveHP; assembler;
asm
 in AL,61h
 and AL,11111100b
 out 61h,AL
end; {DesactiveHP}

{----------------------------------------------------------}

procedure FreqTimer(frequence_reelle: WORD); assembler;
const F=1193180;
asm
 mov DX,(F shr 16)
 mov AX,(F and $FFFF)
 div frequence_reelle
 out 42h,AL     {poids faible}
 mov AL,AH
 out 42h,AL     {poids fort}
end; {FreqTimer}

{----------------------------------------------------------}

procedure FreqNote(note,octave: BYTE); assembler;
asm
 xor BH,BH
 mov BL,note
 shl BX,1
 mov AX,[OFFSET FreqTimer0+BX]
 mov CL,octave
 shr AX,CL
 out 42h,AL     {poids faible}
 mov AL,AH
 out 42h,AL     {poids fort}
end; {FreqNote}

{----------------------------------------------------------}

procedure Sound(note,octave,duree18: BYTE);
{0note11, 0octave9, duree181}
begin
 FreqNote(note,octave);
 ActiveHP; Pause(duree18); DesactiveHP;
end; {Sound}

{----------------------------------------------------------}

procedure INT1C; interrupt;
{dcode la partition de Play}

const comm_rien        =0;
      comm_note        =1;
      comm_tempo       =2;
      comm_duree       =3;
      comm_octave      =4;
      comm_vibrato     =5;
      comm_portamento  =6;
      comm_bloc        =7;
      comm_debut_boucle=8;
      comm_fin_boucle  =9;
      comm_debut_bloc  =10;
      comm_fin_bloc    =11;

var c1,c2: CHAR;
    f: WORD;
    commande,anc_commande,note,valeur: BYTE;
    correction_note,correction_octave: SHORTINT;

begin
 asm
  pushf
  call ancINT1C
 end;

 if pause_play then exit;

 with Vibrato do if (vitesse<>0) and (Portamento.sens=0) then begin
  inc(cpt_vitesse,vitesse);
  FreqTimer(frequence_base*(32768+amplitude*AmplitudeVibrato[cpt_vitesse mod 19]) div 32768);
 end;

 with Portamento do if sens<>0 then begin
  if cpt_duree<duree then begin
   if sens=+1 then f:=FacteurPorta[pas] else f:=FacteurPortaInv[pas];
   frequence:=(frequence*LONGINT(f)) div 32768; FreqTimer(frequence);
  end
  else begin
   sens:=0;
   with Vibrato do begin frequence_base:=frequence; cpt_vitesse:=0 end;
  end;
 end;

 inc(cpt_tempo);
 if (cpt_tempo=tempo) or (index=1) then begin
  cpt_tempo:=0; cpt_duree:=0;
  commande:=comm_rien;
  correction_note:=0; correction_octave:=0;
  Portamento.sens:=0;

  repeat
   if index>Length(partition) then begin StopPlay; exit end;

   anc_commande:=commande;
   c1:=partition[index]; c2:=partition[index+1];
   case c1 of
    'T': commande:=comm_tempo;
    'N': begin
          commande:=comm_duree;
          facteur_duree:=10*(Ord(c2)-48);
          if facteur_duree=0 then facteur_duree:=100;
          duree:=MaxEntier((tempo*facteur_duree) div 100,1);
          inc(index);
         end;
    'O': begin
          commande:=comm_octave;
          case c2 of
           '0'..'9': octave:=Ord(c2)-48;
           '-': if octave>0 then dec(octave);
           '+': if octave<9 then inc(octave);
          end;
          inc(index);
         end;
    'V': commande:=comm_vibrato;
    '<': begin commande:=comm_portamento; Portamento.sens:=-1 end;
    '>': begin commande:=comm_portamento; Portamento.sens:=+1 end;
    'B': with Bloc do begin
          commande:=comm_bloc;
          if niveau<niveau_max then begin
           inc(niveau);
           Imbric[niveau].index_retour:=index+1;
           index:=IndexDebut[Ord(c2)-48];
          end;
         end;

    'D': begin commande:=comm_note; note:=Do_ end;
    'R': begin commande:=comm_note; note:=Re  end;
    'M': begin commande:=comm_note; note:=Mi  end;
    'F': begin commande:=comm_note; note:=Fa  end;
    'S': begin commande:=comm_note; note:=Sol end;
    'L': begin commande:=comm_note; note:=La  end;
    'C': begin commande:=comm_note; note:=Si  end;

    ' ': begin commande:=comm_note; note:=silence end;

    'b': if commande=comm_note then correction_note:=bemol;
    '#': if commande=comm_note then correction_note:=diese;
    '-': if commande=comm_note then dec(correction_octave);
    '+': if commande=comm_note then inc(correction_octave);

    '(': with Boucle do begin
          commande:=comm_debut_boucle;
          if niveau<niveau_max then begin
           inc(niveau);
           with Imbric[niveau] do begin index_debut:=index; num_boucle:=1 end;
          end;
         end;
    ')': with Boucle do begin
          commande:=comm_fin_boucle;
          if niveau>0 then with Imbric[niveau] do
           if num_boucle=(Ord(c2)-48) then begin dec(niveau); inc(index) end
                                      else begin inc(num_boucle); index:=index_debut end;
          end;

    '[': with Bloc do begin
          commande:=comm_debut_bloc;
          if niveau<niveau_max then begin
           inc(niveau);
           with Imbric[niveau] do begin index_debut:=index; index_retour:=0 end;
          end;
         end;
    ']': with Bloc do begin
          commande:=comm_fin_bloc;
          if niveau>0 then with Imbric[niveau] do begin
           if index_retour=0 then
            begin IndexDebut[Ord(c2)-48]:=index_debut; inc(index) end
           else index:=index_retour;
           dec(niveau);
          end;
         end;

    '0'..'9': if commande in [comm_tempo,comm_vibrato,comm_portamento]
               then valeur:=10*valeur+(Ord(c1)-48);
   end;
   if commande<>anc_commande then begin
    case anc_commande of
     comm_tempo: begin
                  tempo:=valeur;
                  duree:=MaxEntier((tempo*facteur_duree) div 100,1)
                 end;
     comm_vibrato: with Vibrato do
                    begin vitesse:=valeur div 10; amplitude:=valeur mod 10 end;
     comm_portamento: with Portamento do begin
                       pas:=valeur div 10; f:=valeur mod 10;
                       if f=0 then f:=10;
                       duree:=MaxEntier((tempo*f) div 10,1);
                      end;
    end;
    valeur:=0;
   end;
   inc(index);
  until (commande=comm_note) and not(partition[index] in ['b','#','-','+']);

  if note=silence then DesactiveHP
  else begin
   FreqNote(note+correction_note,octave+correction_octave);
   with Vibrato do if vitesse<>0 then begin
    cpt_vitesse:=0;
    frequence_base:=FreqNote9[note+correction_note] shr (9-(octave+correction_octave));
   end;
   with Portamento do if sens<>0 then begin
    cpt_duree:=0;
    frequence:=FreqNote9[note+correction_note] shr (9-(octave+correction_octave));
   end;
   ActiveHP;
  end;
 end
 else begin
  inc(cpt_duree);
  if cpt_duree=duree then begin cpt_duree:=0; DesactiveHP end;
 end;
end; {INT1C}

{----------------------------------------------------------}

procedure Play(ch: STRING; tache_fond: BOOLEAN);
{commandes: Tn  tempo (n1 en 1/18 sec.)
            Nn  dure note (0n9 en dizaine de % du tempo: 5->50% ... 0->100%)
            On  octave (0n9), ou O+ ou O-
            Vnm vibrato (vitesse 0n9, amplitude 0m9 en 1/16 tons)
            <nm portamento  (vitesse 1n9, dure 0n9 en dizaine de % du tempo...
            >nm portamento  (...cette commande s'applique seulement  la note qui suit)
            ()n boucle (2n9) / imbrication possible jusqu' 'niveau_max'
            []n dfinit et joue bloc (0n9) / idem^
            Bn  joue bloc (0n9) / doit se trouver aprs sa dfinition

 notes: D (do), R (R), M (Mi), F (Fa), S (Sol), L (La), C (Si)
 complments notes: b (bmol), # (dise), + (octave sup.), - (octave inf.)
 silence: " " (espace)

 Tout autre caractre peut tre utilis comme sparateur sauf avant un chiffre.

 -si tache_fond=FALSE, le programme ne reprend que lorque la musique est termine.
 -si tache_fond=TRUE, la musique est joue en arrire-plan et s'arrte quand
  l'index arrive au bout de la partition ou si StopPlay est appele; elle peut
  tre interrompue puis reprise en utilisant PausePlay.}
begin
 if play_actif then StopPlay;

 partition:=ch; index:=1;
 tempo:=tempo_defaut; cpt_tempo:=0;
 facteur_duree:=facteur_duree_defaut;
 duree:=MaxEntier((tempo*facteur_duree) div 100,1); cpt_duree:=0;
 octave:=octave_defaut;
 Vibrato.vitesse:=0;
 Boucle.niveau:=0; Bloc.niveau:=0;

 SwapIntVec($1C,ancINT1C,@INT1C);
 play_actif:=TRUE; pause_play:=FALSE;
 if not(tache_fond) then repeat until not(play_actif)
end; {Play}

{----------------------------------------------------------}

procedure StopPlay;
{arrte la lecture de la musique avec Play}
begin
 if play_actif then begin
  SwapIntVec($1C,ancINT1C,ancINT1C);
  DesactiveHP; play_actif:=FALSE;
 end;
end; {StopPlay}

{----------------------------------------------------------}

procedure PausePlay(pause: BOOLEAN);
{interrompt/reprend la lecture de la musique avec Play en tche de fond}
begin
 if play_actif then begin
  pause_play:=pause;
  if pause then DesactiveHP else ActiveHP;
 end;
end; {PausePlay}

{----------------------------------------------------------}

{$F+}
procedure ExitPlay;
begin
 ExitProc:=ancExitProc;
 StopPlay
end; {ExitPlay}
{$F-}

{==========================================================}

{initialisation de l'Unit}
begin
 ancExitProc:=ExitProc;
 ExitProc:=@ExitPlay; {installe routine de sortie}
END.
