UNIT Mapping;

{$A+,G+,Q-,R-,S-}

INTERFACE

{==========================================================}

procedure MapperRect(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                     segment,xg:WORD;yh:BYTE;xd:WORD;yb:BYTE);
procedure MapperTrapezeH(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                         segment,yh,yb,xg1,xg2,xd1,xd2:WORD);
procedure MapperTrapezeH2(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                          segment,yh,yb,xg1,xg2,xd1,xd2:WORD);
procedure MapperTrapezeV(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                         segment,xg,xd,yh1,yb1,yh2,yb2:WORD);
procedure MapperTrapeze(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                        segment,x1,y1,x2,y2,x3,y3,x4,y4:WORD);
procedure MapperTrapezeSinusH(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                              segment,yh,yb,xg,xd,ampl:WORD;phase:REAL);
procedure MapperTrapezeCercleH(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                               segment,xc,yc,r:WORD);
procedure MapperTrapezeCercleV(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                               segment,xc,yc,r:WORD);

{==========================================================}

IMPLEMENTATION

{==========================================================}

procedure MapperRect(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;segment,xg:WORD;yh:BYTE;xd:WORD;yb:BYTE);assembler;
{Cette procdure utilise des instructions 286}
{Elle mappe une image comprise entre (xgi,yhi) et (xdi,ybi) }
{sur une zone rectangulaire comprise entre (xg,yh) et (xd,yb)}
asm
   push DS
   push BP

   mov ES,segment
{Calcul de l'offset du premier point vido}
   mov AH,yh
   xor AL,AL
   mov DI,AX
   shr AX,2
   add DI,AX
   add DI,xg                    {ES:DI -> segment:x+320*y}
{Calcul de l'offset du premier point de la derniere ligne}
   mov AH,yb
   xor AL,AL
   mov SI,AX
   shr AX,2
   add SI,AX
   add SI,320
   mov WORD ptr CS:[@NouvelleLigne+2],SI
{Offset de dbut de l'image}
   lds SI,image                 {T_image -> DS:SI}
   mov AH,yhi
   xor AL,AL
   add SI,AX
   shr AX,2
   add SI,AX
   add SI,xgi

{Calcul de la largeur de l'image}
   mov CX,xd
   sub CX,xg
   inc CX
   mov WORD ptr CS:[@BoucleDeLigne+1],CX
{Calcul de la hauteur de l'image}
   mov BH,0
   mov BL,yb
   sub BL,yh
{Calcul de l'incrment en Y}
   mov DX,0
   xor AH,AH
   mov AL,ybi
   sub AL,yhi
   shl AX,8
   div BX
   mov WORD ptr CS:[@Incr_DX+2],AX
{Calcul du dcalage d'offset entre 2 lignes}
   mov AX,320
   sub AX,CX
   mov WORD ptr CS:[@Incr_DI+2],AX
{Calcul de l'incrment en X}
   mov DX,0
   mov AX,xdi
   sub AX,xgi
   shl AX,7
   div CX
   mov WORD ptr CS:[@Incr_BX+2],AX
{Ecrit la valeur initiale de SI dans le code}
   mov BP,SI
   mov WORD ptr CS:[@Calcule_BP+2],BP
   mov DX,0
   jmp @BoucleDeLigne

@BoucleDeLigne:
   mov CX,0FFFFh        {Ecrire ici la largeur du cadre}
   mov BX,0

@BoucleDeColonne:
   mov SI,BX
   shr SI,7
   add SI,BP
   movsb
@Incr_BX:
   add BX,0FFFFh        {Ecrire ici l'incrmnt en X}
   loop @BoucleDeColonne

@Incr_DX:
   add DX,0FFFFh        {Ecrire ici l'incrment en Y}

   xor AL,AL
   mov AH,DH
   mov BP,AX
   shr AX,2
   add BP,AX
@Calcule_BP:
   add BP,0FFFFh        {Ecrire ici l'offset du dbut de ligne}

@Incr_DI:
   add DI,0FFFFh        {Ecrire ici 320-largeur du cadre}
@NouvelleLigne:
   cmp DI,0FFFFh        {Ecrire ici l'offset de dbut de bas de cadre}
   jb @BoucleDeLigne

@Fin:
   pop BP
   pop DS
end; {MapperRect}

{----------------------------------------------------------}

procedure MapperTrapezeH(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                             segment,yh,yb,xg1,xg2,xd1,xd2:WORD);assembler;
{image source: pointeur Image
               limites (xgi,yhi)-(xdi,ybi)
 zone destination: segment destination
                   trapze compris entre yh et yb (cts parallles horizontaux)
                   xg1 et xd1: limites pour y=yh
                   xg2 et xd2: limites pour y=yb

               (xg1,yh) *---------* (xd1,yh)
                       /           \
                      /             \
                     /               \
           (xg2,yb) *-----------------* (xd2,yb)
}
var x: WORD;
    y:BYTE;
    n,nmax:WORD;
    dy:WORD;
    fin_DI:WORD;
    debut_ligne:WORD;
    Xincr,Yincr: INTEGER;
    Deltax,Deltay: INTEGER;
    T1,T2:array[0..320] of WORD;
asm
  push DS
  mov ES,segment

  mov AX,yh
  cmp AX,yb
  jae @yh_sup_yb
  mov Yincr,320
  mov BX,yb
  mov Deltay,BX     {Calcul de Deltay}
  sub Deltay,AX
  jmp @Fin_compy
@yh_sup_yb:
  mov Yincr,-320
  mov Deltay,AX
  mov BX,yb
  sub Deltay,BX
@Fin_compy:
  mov Y,AL

  mov AX,xg1
  cmp AX,xg2
  jae @xg1_sup_xg2    {Test si x1>x2}
  mov Xincr,1
  mov BX,xg2
  mov Deltax,BX     {Calcul de Deltax}
  sub Deltax,AX
  jmp @Fin_compx1
@xg1_sup_xg2:
  mov Xincr,-1
  mov Deltax,AX
  mov BX,xg2
  sub Deltax,BX
@Fin_compx1:
  mov X,AX

  xor AL,AL
  mov AH,Y
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,X
  xor SI,SI
  mov WORD ptr T1[SI],DI
  add SI,2

  mov AX,Deltay
  cmp AX,Deltax      { Choix de la boucle }

  jb @Dely_sup_Delx1
  cmp AX,1
  jbe @Fin_Ligne1    { Fin si Deltay<=1 }
  shr AX,1           { AX=Deltay div 2  }
  mov DX,AX          { DX=AX=Cumul      }
  mov CX,Deltay
  mov BX,Deltay      { BX=DeltaY        }

@Boucle1_1:
  add DI,Yincr

  add DX,Deltax
  cmp DX,BX
  jb @Cumul_inf_dely1

  sub DX,BX
  add DI,Xincr       { Ajuster la position X }
@Cumul_inf_dely1:
  mov WORD ptr T1[SI],DI
  add SI,2
  loop @Boucle1_1

  jmp @Fin_ligne1

@Dely_sup_Delx1:      { si Deltay>DeltaX }
  mov DX,Deltax
  cmp DX,1
  jbe @Fin_Ligne1
  mov CX,DX
  shr DX,1           { DX=Deltax div 2  }
                     { DX=Cumul         }
  mov BX,DeltaX      { BX=DeltaX        }

@Boucle2_1:
  add DI,Xincr
  add DX,Deltay
  cmp DX,BX
  jb @Cumul_inf_delx1
  sub DX,BX
  add DI,Yincr
  mov WORD ptr T1[SI],DI
  add SI,2
@Cumul_inf_delx1:
  loop @Boucle2_1

@Fin_ligne1:

  xor SI,SI

  mov AX,xd1
  cmp AX,xd2
  jae @xd1_sup_xd2    {Test si x1>x2}
  mov Xincr,1
  mov BX,xd2
  mov Deltax,BX     {Calcul de Deltax}
  sub Deltax,AX
  jmp @Fin_compx2
@xd1_sup_xd2:
  mov Xincr,-1
  mov Deltax,AX
  mov BX,xd2
  sub Deltax,BX
@Fin_compx2:
  mov X,AX

  xor AL,AL
  mov AH,Y
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,X
  xor SI,SI
  mov WORD ptr T2[SI],DI
  add SI,2

  mov AX,Deltay
  cmp AX,Deltax      { Choix de la boucle }

  jb @Dely_sup_Delx2
  cmp AX,1
  jbe @Fin_Ligne2    { Fin si Deltay<=1 }
  shr AX,1           { AX=Deltay div 2  }
  mov DX,AX          { DX=AX=Cumul      }
  mov CX,Deltay
  mov BX,Deltay      { BX=DeltaY        }

@Boucle1_2:
  add DI,Yincr

  add DX,Deltax
  cmp DX,BX
  jb @Cumul_inf_dely2

  sub DX,BX
  add DI,Xincr       { Ajuster la position X }
@Cumul_inf_dely2:
  mov WORD ptr T2[SI],DI
  add SI,2
  loop @Boucle1_2

  jmp @Fin_ligne2

@Dely_sup_Delx2:      { si Deltay>DeltaX }
  mov DX,Deltax
  cmp DX,1
  jbe @Fin_Ligne2
  mov CX,DX
  shr DX,1           { DX=Deltax div 2  }
                     { DX=Cumul         }
  mov BX,DeltaX      { BX=DeltaX        }

@Boucle2_2:
  add DI,Xincr
  add DX,Deltay
  cmp DX,BX
  jb @Cumul_inf_delx2
  sub DX,BX
  add DI,YIncr
  mov WORD ptr T2[SI],DI
  add SI,2
@Cumul_inf_delx2:

  loop @Boucle2_2

@Fin_ligne2:
   mov nmax,SI

{Offset de dbut de l'image}
   lds SI,image                 {T_image -> DS:SI}
   mov AH,yhi
   xor AL,AL
   add SI,AX
   shr AX,2
   add SI,AX
   add SI,xgi

{Calcul de la hauteur de l'image}
   mov BX,yb
   sub BX,yh
   jns @Positif
   neg BX
@Positif:
{Calcul de l'incrment en Y}
   mov DX,0
   xor AH,AH
   mov AL,ybi
   sub AL,yhi
   shl AX,8
   div BX
   mov WORD ptr CS:[@Incr_dY+1],AX

{Ecrit la valeur initiale de SI dans le code}
   mov debut_ligne,SI
   mov WORD ptr CS:[@Calcule_debut_ligne+2],SI
   mov dY,0
   mov n,0
   jmp @BoucleDeLigne

@BoucleDeLigne:
   xor BX,BX
   mov DI,n
   mov DX,WORD ptr T2[DI]
   mov fin_DI,DX
   mov DI,WORD ptr T1[DI]
{Calcul de la largeur de l'image}
   mov CX,DX
   sub CX,DI
   jz @Sauter
   jns @Largeur_Positive
   neg CX
   std
   jmp @Fin_Largeur
@Largeur_Positive:
   cld
@Fin_Largeur:
{Calcul de l'incrment en X}
   xor DX,DX
   mov AX,xdi
   sub AX,xgi

   shl AX,7
   div CX
   mov CX,debut_ligne

@BoucleDeColonne:
   mov SI,BX
   shr SI,7
   add SI,CX

   movsb

@Incr_BX:
   add BX,AX
   cmp DI,fin_DI
   jne @BoucleDeColonne

@Sauter:
   mov SI,BX
   shr SI,7
   add SI,CX
   movsb

   mov AX,dY
@Incr_dY:
   add AX,0FFFFh        {Ecrire ici l'incrment en Y}
   mov dY,AX

   xor AL,AL
   mov CX,AX
   shr AX,2
   add CX,AX
@Calcule_debut_ligne:
   add CX,0FFFFh        {Ecrire ici l'offset du dbut de ligne}
   mov debut_ligne,CX

@NouvelleLigne:
   add n,2
   mov AX,n
   cmp AX,nmax        {Ecrire ici l'offset de dbut de bas de cadre}
   jb @BoucleDeLigne

@Fin:

  pop DS
end; {MapperTrapezeH}

{----------------------------------------------------------}

procedure MapperTrapezeH2(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                             segment,yh,yb,xg1,xg2,xd1,xd2:WORD);assembler;
{image source: pointeur Image
               limites (xgi,yhi)-(xdi,ybi)
 zone destination: segment destination
                   trapze compris entre yh et yb (cts parallles horizontaux)
                   xg1 et xd1: limites pour y=yh
                   xg2 et xd2: limites pour y=yb

               (xg1,yh) *---------* (xd1,yh)
                       /           \
                      /             \
                     /               \
           (xg2,yb) *-----------------* (xd2,yb)
}
var x: WORD;
    y:BYTE;
    n,nmax:WORD;
    dy:WORD;
    fin_DI:WORD;
    debut_ligne:WORD;
    Xincr,Yincr: INTEGER;
    Deltax,Deltay: INTEGER;
    dIncr:WORD;
    T1,T2:array[0..320] of WORD;
asm
  push DS
  mov ES,segment

  mov AX,yh
  cmp AX,yb
  jae @yh_sup_yb
  mov Yincr,320
  mov BX,yb
  mov Deltay,BX     {Calcul de Deltay}
  sub Deltay,AX
  jmp @Fin_compy
@yh_sup_yb:
  mov Yincr,-320
  mov Deltay,AX
  mov BX,yb
  sub Deltay,BX
@Fin_compy:
  mov Y,AL

  mov AX,xg1
  cmp AX,xg2
  jae @xg1_sup_xg2    {Test si x1>x2}
  mov Xincr,1
  mov BX,xg2
  mov Deltax,BX     {Calcul de Deltax}
  sub Deltax,AX
  jmp @Fin_compx1
@xg1_sup_xg2:
  mov Xincr,-1
  mov Deltax,AX
  mov BX,xg2
  sub Deltax,BX
@Fin_compx1:
  mov X,AX

  xor AL,AL
  mov AH,Y
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,X
  xor SI,SI
  mov WORD ptr T1[SI],DI
  add SI,2

  mov AX,Deltay
  cmp AX,Deltax      { Choix de la boucle }

  jb @Dely_sup_Delx1
  cmp AX,1
  jbe @Fin_Ligne1    { Fin si Deltay<=1 }
  shr AX,1           { AX=Deltay div 2  }
  mov DX,AX          { DX=AX=Cumul      }
  mov CX,Deltay
  mov BX,Deltay      { BX=DeltaY        }

@Boucle1_1:
  add DI,Yincr

  add DX,Deltax
  cmp DX,BX
  jb @Cumul_inf_dely1

  sub DX,BX
  add DI,Xincr       { Ajuster la position X }
@Cumul_inf_dely1:

  mov WORD ptr T1[SI],DI
  add SI,2
  loop @Boucle1_1

  jmp @Fin_ligne1

@Dely_sup_Delx1:      { si Deltay>DeltaX }
  mov DX,Deltax
  cmp DX,1
  jbe @Fin_Ligne1
  mov CX,DX
  shr DX,1           { DX=Deltax div 2  }
                     { DX=Cumul         }
  mov BX,DeltaX      { BX=DeltaX        }

@Boucle2_1:
  add DI,Xincr
  add DX,Deltay
  cmp DX,BX
  jb @Cumul_inf_delx1
  sub DX,BX
  add DI,Yincr
  mov WORD ptr T1[SI],DI
  add SI,2
@Cumul_inf_delx1:

  loop @Boucle2_1

@Fin_ligne1:

  xor SI,SI

  mov AX,xd1
  cmp AX,xd2
  jae @xd1_sup_xd2    {Test si x1>x2}
  mov Xincr,1
  mov BX,xd2
  mov Deltax,BX     {Calcul de Deltax}
  sub Deltax,AX
  jmp @Fin_compx2
@xd1_sup_xd2:
  mov Xincr,-1
  mov Deltax,AX
  mov BX,xd2
  sub Deltax,BX
@Fin_compx2:
  mov X,AX

  xor AL,AL
  mov AH,Y
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,X
  xor SI,SI
  mov WORD ptr T2[SI],DI
  add SI,2

  mov AX,Deltay
  cmp AX,Deltax      { Choix de la boucle }

  jb @Dely_sup_Delx2
  cmp AX,1
  jbe @Fin_Ligne2    { Fin si Deltay<=1 }
  shr AX,1           { AX=Deltay div 2  }
  mov DX,AX          { DX=AX=Cumul      }
  mov CX,Deltay
  mov BX,Deltay      { BX=DeltaY        }

@Boucle1_2:
  add DI,Yincr

  add DX,Deltax
  cmp DX,BX
  jb @Cumul_inf_dely2

  sub DX,BX
  add DI,Xincr       { Ajuster la position X }
@Cumul_inf_dely2:

  mov WORD ptr T2[SI],DI
  add SI,2
  loop @Boucle1_2

  jmp @Fin_ligne2

@Dely_sup_Delx2:      { si Deltay>DeltaX }
  mov DX,Deltax
  cmp DX,1
  jbe @Fin_Ligne2
  mov CX,DX
  shr DX,1           { DX=Deltax div 2  }
                     { DX=Cumul         }
  mov BX,DeltaX      { BX=DeltaX        }

@Boucle2_2:
  add DI,Xincr
  add DX,Deltay
  cmp DX,BX
  jb @Cumul_inf_delx2
  sub DX,BX
  add DI,YIncr
  mov WORD ptr T2[SI],DI
  add SI,2
@Cumul_inf_delx2:

  loop @Boucle2_2

@Fin_ligne2:
   mov nmax,SI

{Offset de dbut de l'image}
   lds SI,image                 {T_image -> DS:SI}
   mov AH,yhi
   xor AL,AL
   add SI,AX
   shr AX,2
   add SI,AX
   add SI,xgi

{Calcul de la hauteur de l'image}
   mov BX,yb
   sub BX,yh
   jns @Positif
   neg BX
@Positif:
{Calcul de l'incrment en Y}
   mov DX,0
   xor AH,AH
   mov AL,ybi
   sub AL,yhi
   shl AX,8
   div BX
   mov WORD ptr CS:[@Incr_dY+2],AX

{Ecrit la valeur initiale de SI dans le code}
   mov debut_ligne,SI
   mov WORD ptr CS:[@Calcule_debut_ligne+2],SI
   mov dY,0
   mov dIncr,0
   mov n,0

{Calcul de l'incrment en X initial}
   mov CX,WORD ptr T2[0]
   sub CX,WORD ptr T1[0]
   xor DX,DX
   mov AX,xdi
   sub AX,xgi
   shl AX,7
   div CX
   mov BX,AX
   mov WORD ptr CS:[@Calcule_Incrx_actuel+1],BX
{Calcul de l'incrment en X final}
   mov DI,nmax
   sub DI,2
   mov CX,WORD ptr T2[DI]
   sub CX,WORD ptr T1[DI]
   xor DX,DX
   mov AX,xdi
   sub AX,xgi
   shl AX,7
   div CX
{Diffrence des incrments}
   cmp AX,BX
   jbe @IncrFinal_sup_IncrInitial

   sub AX,BX
{Calcul de l'incrment par ligne}
   shl AX,1            {passe du format 128 fois au format 256 fois}
   mov CX,nmax
   shr CX,1
   xor DX,DX
   div CX
   mov WORD ptr CS:[@Incr_dIncr+2],AX
   mov AX,BX            {AX contient l'incrment initial}
   jmp @BoucleDeLigne

@IncrFinal_sup_IncrInitial:
   sub AX,BX
   neg AX
{Calcul de l'incrment par ligne}
   shl AX,1            {passe du format 128 fois au format 256 fois}
   mov CX,nmax
   xor DX,DX
   div CX
   neg AX
   mov WORD ptr CS:[@Incr_dIncr+2],AX
   mov AX,BX            {AX contient l'incrment initial}
   jmp @BoucleDeLigne


@BoucleDeLigne:
   mov DI,n
   mov CX,WORD ptr T2[DI]
   mov fin_DI,CX
   mov DI,WORD ptr T1[DI]

   mov CX,debut_ligne
   xor BX,BX

@BoucleDeColonne:
   mov SI,BX
   shr SI,7
   add SI,CX
   movsb

@Incr_BX:
   add BX,AX
   cmp DI,fin_DI
   jne @BoucleDeColonne

@Sauter:
   mov SI,BX
   shr SI,7
   add SI,CX
   movsb

   mov BX,dIncr
@Incr_dIncr:
   add BX,0FFFFh        {Ecrire ici l'incrment d'incrment en X}
   mov dIncr,BX

{   mov AL,BH
   xor AH,AH}
   mov AX,BX
@Calcule_incrx_actuel:
   add AX,0FFFFh        {Ecrire ici l'incrment en x initial}

   mov BX,dY
@Incr_dY:
   add BX,0FFFFh        {Ecrire ici l'incrment en Y}
   mov dY,BX

   xor BL,BL
   mov CX,BX
   shr BX,2
   add CX,BX
@Calcule_debut_ligne:
   add CX,0FFFFh        {Ecrire ici l'offset du dbut de ligne}
   mov debut_ligne,CX

@NouvelleLigne:
   add n,2
   mov CX,n
   cmp CX,nmax        {Ecrire ici l'offset de dbut de bas de cadre}
   jb @BoucleDeLigne

@Fin:

  pop DS
end; {MapperTrapezeH2}

{----------------------------------------------------------}

procedure MapperTrapezeV(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                             segment,xg,xd,yh1,yb1,yh2,yb2:WORD);assembler;
{image source: pointeur Image
               limites (xgi,yhi)-(xdi,ybi)
 zone destination: segment destination
                   trapze compris entre xg et xd (cts parallles verticaux)
                   yh1 et yb1: limites pour x=xg
                   yh2 et yb2: limites pour x=xd

                   * (xg,yh1)
                   |\
                   | \
                   |  \
                   |   * (xd,yh2)
                   |   |
                   |   * (xd,yb2)
                   |  /
                   | /
                   |/
                   * (xg,yb1)
}
var x: WORD;
    y:BYTE;
    n,nmax:WORD;
    ddX:WORD;
    fin_DI:WORD;
    debut_colonne:WORD;
    Xincr,Yincr: INTEGER;
    Deltax,Deltay: INTEGER;
    T1,T2:array[0..320] of WORD;
asm
  push DS
  mov ES,segment
  cld

  mov AX,xg
  cmp AX,xd
  jae @xg_sup_xd    {Test si x1>x2}
  mov Xincr,1
  mov BX,xd
  mov Deltax,BX     {Calcul de Deltax}
  sub Deltax,AX
  jmp @Fin_compx
@xg_sup_xd:
  mov Xincr,-1
  mov Deltax,AX
  mov BX,xd
  sub Deltax,BX
@Fin_compx:
  mov X,AX

  mov AX,yh1
  cmp AX,yh2
  jae @yh1_sup_yh2
  mov Yincr,320
  mov BX,yh2
  mov Deltay,BX     {Calcul de Deltay}
  sub Deltay,AX
  jmp @Fin_compy1
@yh1_sup_yh2:
  mov Yincr,-320
  mov Deltay,AX
  mov BX,yh2
  sub Deltay,BX
@Fin_compy1:
  mov Y,AL

  xor AL,AL
  mov AH,Y
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,X
  xor SI,SI
  mov WORD ptr T1[SI],DI
  add SI,2

  mov AX,Deltay
  cmp AX,Deltax      { Choix de la boucle }

  jb @Dely_sup_Delx1
  cmp AX,1
  jbe @Fin_Ligne1    { Fin si Deltay<=1 }
  shr AX,1           { AX=Deltay div 2  }
  mov DX,AX          { DX=AX=Cumul      }
  mov CX,Deltay
  mov BX,Deltay      { BX=DeltaY        }

@Boucle1_1:
  add DI,Yincr

  add DX,Deltax
  cmp DX,BX
  jb @Cumul_inf_dely1

  sub DX,BX
  add DI,Xincr       { Ajuster la position X }
  mov WORD ptr T1[SI],DI
  add SI,2

@Cumul_inf_dely1:

  loop @Boucle1_1

  jmp @Fin_ligne1

@Dely_sup_Delx1:      { si Deltay>DeltaX }
  mov DX,Deltax
  cmp DX,1
  jbe @Fin_Ligne1
  mov CX,DX
  shr DX,1           { DX=Deltax div 2  }
                     { DX=Cumul         }
  mov BX,DeltaX      { BX=DeltaX        }

@Boucle2_1:
  add DI,Xincr
  add DX,Deltay
  cmp DX,BX
  jb @Cumul_inf_delx1
  sub DX,BX
  add DI,Yincr

@Cumul_inf_delx1:
  mov WORD ptr T1[SI],DI
  add SI,2
  loop @Boucle2_1

@Fin_ligne1:

  xor SI,SI

  mov AX,yb1
  cmp AX,yb2
  jae @yb1_sup_yb2
  mov Yincr,320
  mov BX,yb2
  mov Deltay,BX     {Calcul de Deltay}
  sub Deltay,AX
  jmp @Fin_compy2
@yb1_sup_yb2:
  mov Yincr,-320
  mov Deltay,AX
  mov BX,yb2
  sub Deltay,BX
@Fin_compy2:
  mov Y,AL

  xor AL,AL
  mov AH,Y
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,X
  xor SI,SI
  mov WORD ptr T2[SI],DI
  add SI,2

  mov AX,Deltay
  cmp AX,Deltax      { Choix de la boucle }

  jb @Dely_sup_Delx2
  cmp AX,1
  jbe @Fin_Ligne2    { Fin si Deltay<=1 }
  shr AX,1           { AX=Deltay div 2  }
  mov DX,AX          { DX=AX=Cumul      }
  mov CX,Deltay
  mov BX,Deltay      { BX=DeltaY        }

@Boucle1_2:
  add DI,Yincr

  add DX,Deltax
  cmp DX,BX
  jb @Cumul_inf_dely2
  sub DX,BX
  add DI,Xincr       { Ajuster la position X }
  mov WORD ptr T2[SI],DI
  add SI,2

@Cumul_inf_dely2:
  loop @Boucle1_2

  jmp @Fin_ligne2

@Dely_sup_Delx2:      { si Deltay>DeltaX }
  mov DX,Deltax
  cmp DX,1
  jbe @Fin_Ligne2
  mov CX,DX
  shr DX,1           { DX=Deltax div 2  }
                     { DX=Cumul         }
  mov BX,DeltaX      { BX=DeltaX        }

@Boucle2_2:
  add DI,Xincr

  add DX,Deltay
  cmp DX,BX
  jb @Cumul_inf_delx2
  sub DX,BX
  add DI,Yincr
@Cumul_inf_delx2:
  mov WORD ptr T2[SI],DI
  add SI,2
  loop @Boucle2_2

@Fin_ligne2:
   mov nmax,SI

{Offset de dbut de l'image}
   lds SI,image                 {T_image -> DS:SI}
   mov AH,yhi
   xor AL,AL
   add SI,AX
   shr AX,2
   add SI,AX
   add SI,xgi

{Calcul de la largeur de l'image}
   mov BX,xd
   sub BX,xg
   jz @Fin
   jns @Positif
   neg BX
@Positif:
{Calcul de l'incrment en X}
   mov DX,0
   mov AX,xdi
   sub AX,xgi
   shl AX,7
   div BX
   mov WORD ptr CS:[@Incr_ddX+1],AX

{Ecrit la valeur initiale de SI dans le code}
   mov debut_colonne,SI
   mov WORD ptr CS:[@Calcule_debut_colonne+1],SI
   mov ddX,0
   mov n,0
   jmp @BoucleDeColonne

@BoucleDeColonne:
   xor BX,BX
   mov DI,n
   mov DX,WORD ptr T2[DI]
   mov fin_DI,DX
   mov DI,WORD ptr T1[DI]

{Calcul de la hauteur de l'image}
   mov AX,DX
   sub AX,DI
   cmp DI,DX    {oblig car la diffrence peut tre > 32768}
   je @Sauter
   jb @Hauteur_Positive
@Hauteur_Negative:
   neg AX
   mov WORD ptr CS:[@Incr_DI+2],-321
   jmp @Fin_Hauteur

@Hauteur_Positive:
   mov WORD ptr CS:[@Incr_DI+2],319

@Fin_Hauteur:
   xor DX,DX
   mov CX,320
   div CX
   mov CX,AX
{Calcul de l'incrment en Y}
   xor DX,DX
   xor AH,AH
   mov AL,ybi
   sub AL,yhi
   shl AX,8
   div CX

   mov CX,debut_colonne
@BoucleDeLigne:
   xor DL,DL
   mov DH,BH
   mov SI,DX
   shr DX,2
   add SI,DX
   add SI,CX
   movsb
@Incr_DI:
   add DI,319

@Incr_BX:
   add BX,AX
   cmp DI,fin_DI
   jne @BoucleDeLigne
@Sauter:
   xor DL,DL
   mov DH,BH
   mov SI,DX
   shr DX,2
   add SI,DX
   add SI,CX
   movsb

   mov AX,ddX
@Incr_ddX:
   add AX,0FFFFh        {Ecrire ici l'incrment en X}
   mov ddX,AX

   shr AX,7
@Calcule_debut_colonne:
   add AX,0FFFFh        {Ecrire ici l'offset du dbut de colonne}
   mov debut_colonne,AX

   add n,2
@NouvelleColonne:
   mov AX,n
   cmp AX,nmax        {Ecrire ici l'offset de dbut de bas de cadre}
   jb @BoucleDeColonne

@Fin:

  pop DS
end; {MapperTrapezeV}

{----------------------------------------------------------}

procedure MapperTrapeze(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                             segment,x1,y1,x2,y2,x3,y3,x4,y4:WORD);assembler;
{image source: pointeur Image
               limites (xgi,yhi)-(xdi,ybi)
 zone destination: segment destination

                (x1,y1) *---------* (x3,y3)
                       /           \
                      /             \
                     /               \
            (x2,y2) *-----------------* (x4,y4)
}
var x: WORD;
    y:BYTE;
    n1,n2,nmax1,nmax2:WORD;
    ddX:WORD;
    fin_DI:WORD;
    debut_colonne:WORD;
    Xincr,Yincr: INTEGER;
    Deltax,Deltay: INTEGER;
    T1,T2,T3,T4:array[0..320] of WORD;
asm
  push DS
  mov ES,segment

  mov AX,x1
  cmp AX,x2
  jae @x1_sup_x2    {Test si x1>x2}
  mov Xincr,1
  mov BX,x2
  mov Deltax,BX     {Calcul de Deltax}
  sub Deltax,AX
  jmp @Fin_compx1
@x1_sup_x2:
  mov Xincr,-1
  mov Deltax,AX
  mov BX,x2
  sub Deltax,BX
@Fin_compx1:
  mov X,AX

  mov AX,y1
  cmp AX,y2
  jae @y1_sup_y2

  mov Yincr,320
  mov WORD ptr T3[0],AX         {AX contient encore y1}
  mov BYTE ptr CS:[@ModifieCode1],40h       {code de inc AX}
  mov BYTE ptr CS:[@ModifieCode2],40h
  mov BX,y2
  mov Deltay,BX     {Calcul de Deltay}
  sub Deltay,AX
  jmp @Fin_compy1
@y1_sup_y2:
  mov Yincr,-320
  mov BYTE ptr CS:[@ModifieCode1],48h       {code de dec AX}
  mov BYTE ptr CS:[@ModifieCode2],48h
  mov Deltay,AX
  mov BX,y2
  sub Deltay,BX
  mov WORD ptr T3[0],BX
@Fin_compy1:
  mov Y,AL

  xor AL,AL
  mov AH,Y
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,X
  xor SI,SI
  mov WORD ptr T1[SI],DI
  add SI,2

  mov AX,Deltay
  cmp AX,Deltax      { Choix de la boucle }

  jb @Dely_inf_Delx1
  cmp AX,1
  jbe @Fin_Ligne1    { Fin si Deltay<=1 }
  shr AX,1           { AX=Deltay div 2  }
  mov DX,AX          { DX=AX=Cumul      }
  mov CX,Deltay
  mov BX,Deltay      { BX=DeltaY        }
  xor AX,AX

@Boucle1_1:
  add DI,Yincr
  add DX,Deltax
  cmp DX,BX
  jb @Cumul_inf_dely1

  sub DX,BX
  add DI,Xincr       { Ajuster la position X }

@Cumul_inf_dely1:
  mov WORD ptr T1[SI],DI
  mov WORD ptr T3[SI],AX
@ModifieCode1:
  inc AX
  add SI,2
  loop @Boucle1_1

  jmp @Fin_ligne1

@Dely_inf_Delx1:      { si Deltay>DeltaX }
  mov DX,Deltax
  cmp DX,1
  jbe @Fin_Ligne1
  mov CX,DX
  shr DX,1           { DX=Deltax div 2  }
                     { DX=Cumul         }
  mov BX,DeltaX      { BX=DeltaX        }
  xor AX,AX

@Boucle2_1:
  add DI,Xincr
  add DX,Deltay
  cmp DX,BX
  jb @Cumul_inf_delx1
  sub DX,BX
  add DI,Yincr
  mov WORD ptr T1[SI],DI
  mov WORD ptr T3[SI],AX
@ModifieCode2:
  inc AX
  add SI,2

@Cumul_inf_delx1:
  loop @Boucle2_1

@Fin_ligne1:
  mov nmax1,SI

  xor SI,SI

  mov AX,x3
  cmp AX,x4
  jae @x3_sup_x4    {Test si x1>x2}
  mov Xincr,1
  mov BX,x4
  mov Deltax,BX     {Calcul de Deltax}
  sub Deltax,AX
  jmp @Fin_compx2
@x3_sup_x4:
  mov Xincr,-1
  mov Deltax,AX
  mov BX,x4
  sub Deltax,BX
@Fin_compx2:
  mov X,AX

  mov AX,y3
  cmp AX,y4
  jae @y3_sup_y4

  mov Yincr,320
  mov WORD ptr T4[0],AX         {AX contient encore y3}
  mov BYTE ptr CS:[@ModifieCode3],40h
  mov BYTE ptr CS:[@ModifieCode4],40h
  mov BX,y4
  mov Deltay,BX     {Calcul de Deltay}
  sub Deltay,AX
  jmp @Fin_compy2
@y3_sup_y4:
  mov Yincr,-320
  mov BYTE ptr CS:[@ModifieCode3],48h
  mov BYTE ptr CS:[@ModifieCode4],48h
  mov Deltay,AX
  mov BX,y4
  sub Deltay,BX
  mov WORD ptr T4[0],BX
@Fin_compy2:
  mov Y,AL

  xor AL,AL
  mov AH,Y
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,X
  xor SI,SI
  mov WORD ptr T2[SI],DI
  add SI,2

  mov AX,Deltay
  cmp AX,Deltax      { Choix de la boucle }

  jb @Dely_inf_Delx2
  cmp AX,1
  jbe @Fin_Ligne2    { Fin si Deltay<=1 }
  shr AX,1           { AX=Deltay div 2  }
  mov DX,AX          { DX=AX=Cumul      }
  mov CX,Deltay
  mov BX,Deltay      { BX=DeltaY        }
  xor AX,AX

@Boucle1_2:
  add DI,Yincr

  add DX,Deltax
  cmp DX,BX
  jb @Cumul_inf_dely2
  sub DX,BX
  add DI,Xincr       { Ajuster la position X }

@Cumul_inf_dely2:
  mov WORD ptr T2[SI],DI
  mov WORD ptr T4[SI],AX
@ModifieCode3:
  inc AX
  add SI,2
  loop @Boucle1_2

  jmp @Fin_ligne2

@Dely_inf_Delx2:      { si Deltay>DeltaX }
  mov DX,Deltax
  cmp DX,1
  jbe @Fin_Ligne2
  mov CX,DX
  shr DX,1           { DX=Deltax div 2  }
                     { DX=Cumul         }
  mov BX,DeltaX      { BX=DeltaX        }
  xor AX,AX

@Boucle2_2:
  add DI,Xincr

  add DX,Deltay
  cmp DX,BX
  jb @Cumul_inf_delx2
  sub DX,BX
  add DI,Yincr
  mov WORD ptr T2[SI],DI
  mov WORD ptr T4[SI],AX
@ModifieCode4:
  inc AX
  add SI,2

@Cumul_inf_delx2:
  loop @Boucle2_2

@Fin_ligne2:
   mov nmax2,SI

{Offset de dbut de l'image}
   lds SI,image                 {T_image -> DS:SI}
   mov AH,yhi
   xor AL,AL
   add SI,AX
   shr AX,2
   add SI,AX
   add SI,xgi

{Ecrit la valeur initiale de SI dans le code}
   mov debut_colonne,SI
   mov WORD ptr CS:[@Calcule_debut_colonne+1],SI
   mov ddX,0
   mov n1,0
   mov n2,0
   xor DX,DX
   mov AX,nmax1
   shl AX,7
   mov CX,nmax2
   div CX
   mov WORD ptr CS:[@Calcule_delta_n2+2],AX
   xor CX,CX
   sub nmax1,36
   jmp @BoucleExterne

@BoucleExterne:
   xor BX,BX

   mov DI,CX
   shr DI,7
   shl DI,1
   mov n2,DI

   mov AX,WORD ptr T4[DI]
   mov DI,n1
   sub AX,WORD ptr T3[DI]
   jns @Deltay_Positif

   mov Yincr,320
   mov Deltay,AX         {AX contient Deltay}

   jmp @FinCompy
@Deltay_Positif:
   mov Yincr,-320
   mov Deltay,AX
@FinCompy:

   shl AX,8
   mov DX,AX
   shr AX,2
   add DX,AX            {DX contient 320*Deltay}

   mov DI,n2
   mov SI,WORD ptr T2[DI]
   mov fin_DI,SI
   mov DI,n1
   mov DI,WORD ptr T1[DI]
   sub SI,DI             {SI contient le dcalage d'offset}
   sub SI,DX             {SI contient Deltax}
   jns @Deltax_Positif

   mov XIncr,-1
   mov Deltax,SI
   jmp @FinCompx

@Deltax_Positif:
   mov Xincr,1
   mov Deltax,SI
@FinCompx:

(*{Calcul de l'incrment en Y}
   xor DX,DX
   xor AH,AH
   mov AL,ybi
   sub AL,yhi
   shl AX,8
   div CX
{Calcul de l'incrment en X}
   mov DX,0
   mov AX,xdi
   sub AX,xgi
   shl AX,7
   div SI
   mov WORD ptr CS:[@Incr_ddX+1],AX*)

   pusha
   mov AX,Deltay
   cmp AX,Deltax      { Choix de la boucle }

   jb @Dely_inf_Delx3
   cmp AX,1
   jbe @Fin_Ligne3    { Fin si Deltay<=1 }
   shr AX,1           { AX=Deltay div 2  }
   mov DX,AX          { DX=AX=Cumul      }
   mov CX,Deltay
   mov BX,Deltay      { BX=DeltaY        }

@Boucle1_3:
   add DI,Yincr
   add DX,Deltax
   cmp DX,BX
   jb @Cumul_inf_dely3

   sub DX,BX
   add DI,Xincr       { Ajuster la position X }

@Cumul_inf_dely3:
   mov BYTE ptr ES:[DI],30
   loop @Boucle1_3

   jmp @Fin_ligne3

@Dely_inf_Delx3:      { si Deltay>DeltaX }
   mov DX,Deltax
   cmp DX,1
   jbe @Fin_Ligne3
   mov CX,DX
   shr DX,1           { DX=Deltax div 2  }
                     { DX=Cumul         }
   mov BX,DeltaX      { BX=DeltaX        }

@Boucle2_3:
   add DI,Xincr
   add DX,Deltay
   cmp DX,BX
   jb @Cumul_inf_delx3
   sub DX,BX
   add DI,Yincr

@Cumul_inf_delx3:
   mov BYTE ptr ES:[DI],30
   loop @Boucle2_3

@Fin_ligne3:
   popa

(*@BoucleInterne:
   xor DL,DL
   mov DH,BH
   mov SI,DX
   shr DX,2
   add SI,DX
   add SI,CX
   movsb
   add DI,319

@Incr_BX:
   add BX,AX
   cmp DI,fin_DI
   jbe @BoucleInterne*)

   mov AX,ddX
@Incr_ddX:
   add AX,0FFFFh        {Ecrire ici l'incrment en X}
   mov ddX,AX

   shr AX,7
@Calcule_debut_colonne:
   add AX,0FFFFh        {Ecrire ici l'offset du dbut de colonne}
   mov debut_colonne,AX

@Calcule_delta_n2:
   add CX,0FFFFh

   add n1,2
@NouvelleColonne:
   mov AX,n1
   cmp AX,nmax1        {Ecrire ici l'offset de dbut de bas de cadre}
   jb @BoucleExterne

@Fin:
  pop DS
end; {MapperTrapeze}

{----------------------------------------------------------}

procedure MapperTrapezeSinusH(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                                  segment,yh,yb,xg,xd,ampl:WORD;phase:REAL);
var x: WORD;
    y:BYTE;
    n,nmax:WORD;
    dy:WORD;
    fin_DI:WORD;
    debut_ligne:WORD;
    Xincr,Yincr: INTEGER;
    Deltax,Deltay: INTEGER;
    T1,T2:array[0..320] of WORD;
begin
     nmax:=yb-yh;
     for n:=0 to nmax do begin
          T1[n]:=320*n+round(ampl*sin((2*pi*n)/nmax+phase))+xg;
          T2[n]:=320*n-round(ampl*sin((2*pi*n)/nmax+phase))+xd;
     end;
     nmax:=2*nmax;
asm
  push DS
  mov ES,segment

{Offset de dbut de l'image}
   lds SI,image                 {T_image -> DS:SI}
   mov AH,yhi
   xor AL,AL
   add SI,AX
   shr AX,2
   add SI,AX
   add SI,xgi

{Calcul de la hauteur de l'image}
   mov BX,yb
   sub BX,yh
   jns @Positif
   neg BX
@Positif:
{Calcul de l'incrment en Y}
   mov DX,0
   xor AH,AH
   mov AL,ybi
   sub AL,yhi
   shl AX,8
   div BX
   mov WORD ptr CS:[@Incr_dY+1],AX

{Ecrit la valeur initiale de SI dans le code}
   mov debut_ligne,SI
   mov WORD ptr CS:[@Calcule_debut_ligne+2],SI
   mov dY,0
   mov n,0
   jmp @BoucleDeLigne

@BoucleDeLigne:
   xor BX,BX
   mov DI,n
   mov DX,WORD ptr T2[DI]
   mov fin_DI,DX
   mov DI,WORD ptr T1[DI]
{Calcul de la largeur de l'image}
   mov CX,DX
   sub CX,DI
   jz @Sauter
   jns @Largeur_Positive
   neg CX
   std
   jmp @Fin_Largeur
@Largeur_Positive:
   cld
@Fin_Largeur:
{Calcul de l'incrment en X}
   xor DX,DX
   mov AX,xdi
   sub AX,xgi

   shl AX,7
   div CX
   mov CX,debut_ligne

@BoucleDeColonne:
   mov SI,BX
   shr SI,7
   add SI,CX
   movsb

@Incr_BX:
   add BX,AX
   cmp DI,fin_DI
   jne @BoucleDeColonne

@Sauter:
   mov SI,BX
   shr SI,7
   add SI,CX
   movsb

   mov AX,dY
@Incr_dY:
   add AX,0FFFFh        {Ecrire ici l'incrment en Y}
   mov dY,AX

   xor AL,AL
   mov CX,AX
   shr AX,2
   add CX,AX
@Calcule_debut_ligne:
   add CX,0FFFFh        {Ecrire ici l'offset du dbut de ligne}
   mov debut_ligne,CX

@NouvelleLigne:
   add n,2
   mov AX,n
   cmp AX,nmax        {Ecrire ici l'offset de dbut de bas de cadre}
   jb @BoucleDeLigne

@Fin:

  pop DS
end;
end; {MapperTrapezeSinusH}

{----------------------------------------------------------}

procedure MapperTrapezeCercleH(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                                  segment,xc,yc,r:WORD);
var x: WORD;
    y:BYTE;
    n,nmax:WORD;
    dy:WORD;
    fin_DI:WORD;
    debut_ligne:WORD;
    Xincr,Yincr: INTEGER;
    Deltax,Deltay: INTEGER;
    T1,T2:array[0..320] of WORD;
    yb,yh:WORD;
    x1,y1:WORD;
begin
     nmax:=8*r;
     yh:=yc-r;
     yb:=yc+r;
     for n:=0 to nmax do begin
          x1:=round(r*sin((2*pi*n)/nmax)*1.2);
          y1:=round(r*cos((2*pi*n)/nmax));
          T1[y1+r]:=320*(y1+yc)+x1+xc;
          T2[y1+r]:=320*(y1+yc)-x1+xc;
     end;
     nmax:=4*r;
asm
  push DS
  mov ES,segment

{Offset de dbut de l'image}
   lds SI,image                 {T_image -> DS:SI}
   mov AH,yhi
   xor AL,AL
   add SI,AX
   shr AX,2
   add SI,AX
   add SI,xgi

{Calcul de la hauteur de l'image}
   mov BX,yb
   sub BX,yh
   jns @Positif
   neg BX
@Positif:
{Calcul de l'incrment en Y}
   mov DX,0
   xor AH,AH
   mov AL,ybi
   sub AL,yhi
   shl AX,8
   div BX
   mov WORD ptr CS:[@Incr_dY+1],AX

{Ecrit la valeur initiale de SI dans le code}
   mov debut_ligne,SI
   mov WORD ptr CS:[@Calcule_debut_ligne+2],SI
   mov dY,0
   mov n,0
   jmp @BoucleDeLigne

@BoucleDeLigne:
   xor BX,BX
   mov DI,n
   mov DX,WORD ptr T2[DI]
   mov fin_DI,DX
   mov DI,WORD ptr T1[DI]
{Calcul de la largeur de l'image}
   mov CX,DX
   sub CX,DI
   jz @Sauter
   jns @Largeur_Positive
   neg CX
   std
   jmp @Fin_Largeur
@Largeur_Positive:
   cld
@Fin_Largeur:
{Calcul de l'incrment en X}
   xor DX,DX
   mov AX,xdi
   sub AX,xgi

   shl AX,7
   div CX
   mov CX,debut_ligne

@BoucleDeColonne:
   mov SI,BX
   shr SI,7
   add SI,CX
   movsb

@Incr_BX:
   add BX,AX
   cmp DI,fin_DI
   jne @BoucleDeColonne

@Sauter:
   mov SI,BX
   shr SI,7
   add SI,CX
   movsb

   mov AX,dY
@Incr_dY:
   add AX,0FFFFh        {Ecrire ici l'incrment en Y}
   mov dY,AX

   xor AL,AL
   mov CX,AX
   shr AX,2
   add CX,AX
@Calcule_debut_ligne:
   add CX,0FFFFh        {Ecrire ici l'offset du dbut de ligne}
   mov debut_ligne,CX

@NouvelleLigne:
   add n,2
   mov AX,n
   cmp AX,nmax        {Ecrire ici l'offset de dbut de bas de cadre}
   jb @BoucleDeLigne

@Fin:

  pop DS
end;
end; {MapperTrapezeCercleH}

{----------------------------------------------------------}

procedure MapperTrapezeCercleV(var image;xgi:WORD;yhi:BYTE;xdi:WORD;ybi:BYTE;
                                  segment,xc,yc,r:WORD);
var x: WORD;
    y:BYTE;
    n,nmax:WORD;
    ddX:WORD;
    fin_DI:WORD;
    debut_colonne:WORD;
    Xincr,Yincr: INTEGER;
    Deltax,Deltay: INTEGER;
    T1,T2:array[0..320] of WORD;
    xg,xd:WORD;
    x1,y1:WORD;
begin
     nmax:=8*r;
     xg:=xc-r;
     xd:=xc+r;
     for n:=0 to nmax do begin
          x1:=-round(r*cos((2*pi*n)/nmax));
          y1:=-round(r*sin((2*pi*n)/nmax)*0.8);
          T1[x1+r]:=320*(yc-y1)+x1+xc;
          T2[x1+r]:=320*(yc+y1)+x1+xc;
     end;
     nmax:=4*r;
asm
  push DS
  mov ES,segment
  cld

{Offset de dbut de l'image}
   lds SI,image                 {T_image -> DS:SI}
   mov AH,yhi
   xor AL,AL
   add SI,AX
   shr AX,2
   add SI,AX
   add SI,xgi

{Calcul de la largeur de l'image}
   mov BX,xd
   sub BX,xg
   jns @Positif
   neg BX
@Positif:
{Calcul de l'incrment en X}
   mov DX,0
   mov AX,xdi
   sub AX,xgi
   shl AX,7
   div BX
   mov WORD ptr CS:[@Incr_ddX+1],AX

{Ecrit la valeur initiale de SI dans le code}
   mov debut_colonne,SI
   mov WORD ptr CS:[@Calcule_debut_colonne+1],SI
   mov ddX,0
   mov n,0
   jmp @BoucleDeColonne

@BoucleDeColonne:
   xor BX,BX
   mov DI,n
   mov DX,WORD ptr T2[DI]
   mov fin_DI,DX
   mov DI,WORD ptr T1[DI]

{Calcul de la hauteur de l'image}
   mov AX,DX
   sub AX,DI
   cmp DI,DX    {oblig car la diffrence peut tre > 32768}
   je @Sauter
   jb @Hauteur_Positive
@Hauteur_Negative:
   neg AX
   mov WORD ptr CS:[@Incr_DI+2],-321
   jmp @Fin_Hauteur

@Hauteur_Positive:
   mov WORD ptr CS:[@Incr_DI+2],319

@Fin_Hauteur:
   xor DX,DX
   mov CX,320
   div CX
   mov CX,AX
{Calcul de l'incrment en Y}
   xor DX,DX
   xor AH,AH
   mov AL,ybi
   sub AL,yhi
   shl AX,8
   div CX

   mov CX,debut_colonne
@BoucleDeLigne:
   xor DL,DL
   mov DH,BH
   mov SI,DX
   shr DX,2
   add SI,DX
   add SI,CX
   movsb
@Incr_DI:
   add DI,319

@Incr_BX:
   add BX,AX
   cmp DI,fin_DI
   jne @BoucleDeLigne
@Sauter:
   xor DL,DL
   mov DH,BH
   mov SI,DX
   shr DX,2
   add SI,DX
   add SI,CX
   movsb

   mov AX,ddX
@Incr_ddX:
   add AX,0FFFFh        {Ecrire ici l'incrment en X}
   mov ddX,AX

   shr AX,7
@Calcule_debut_colonne:
   add AX,0FFFFh        {Ecrire ici l'offset du dbut de colonne}
   mov debut_colonne,AX

   add n,2
@NouvelleColonne:
   mov AX,n
   cmp AX,nmax        {Ecrire ici l'offset de dbut de bas de cadre}
   jb @BoucleDeColonne

@Fin:

  pop DS
end;
end; {MapperTrapezeCercleV}

{==========================================================}

END.
