{************************************************************************}
{                                MM_DIV.PAS                              }
{                                                                        }
{  Unit pour Mod Master: routines diverses                              }
{                                                                        }
{  AUTEURS: Fabrice Couteau et Freddy Vtel.                            }
{                                                                        }
{                               Dbut d'criture le --/--/93             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}
UNIT MM_DIV;

{$A+,G+,Q-,R-,S-}

INTERFACE

{$I Types}

CONST clignote=TRUE; {pour InitModeTexte}

{==========================================================}

procedure InitModeTexte(clignotant: BOOLEAN);
procedure CorrigePalette(dR,dV,dB: SHORTINT; fixe: BOOLEAN);

procedure Bip(freq: WORD);

function  Extension(nom_fichier: String12): BYTE;
function  IndiceModule(nom: String12): WORD;
function  IndiceNum(n: WORD): WORD;

function  TestIdentModM(ident: String20; suffixe,v_min: String3): BOOLEAN;

procedure AfficheInfosCD(piste: String12; temps: String8);
procedure UpdateCD;

procedure SauveFichierDIR;
procedure AnalyseFichierDIR;

procedure LitFichierCFG;
procedure EcritFichierCFG;

procedure CreeFichierDesc;

procedure InitCarteSonore;
function  FreqMax(sortie,TypeSB: BYTE; stereo,DC: BOOLEAN): WORD;
procedure CorrigeParametres(sortie,TypeSB: BYTE; var freq: WORD;
                            var utDMA,utSte,utFilt,utDC: BOOLEAN; var IRQ: BYTE);

procedure Initialisation;

{==========================================================}

IMPLEMENTATION

USES Crt,Texte,Fichiers,Util,UtilSm,SourisSm,CDAudio,
     VARUnit,ModmCmd,MODMUnit,ModmVar,SBUnit,GUSUnit,
     MM_VAR,MM_AFF,MM_PROG;

{==========================================================}

procedure InitModeTexte(clignotant: BOOLEAN);
begin
 InitTexte(50);
 Curseur(off);
 Clignotement(clignotant);
 fonte_ModM.Redef(0);
 palette_ModM.Fixe;
 LargeurCar(8);
end; {InitModeTexte}

{----------------------------------------------------------}

procedure CorrigePalette(dR,dV,dB: SHORTINT; fixe: BOOLEAN);
var couleur: BYTE;
begin
 for couleur:=or_sombre to or_clair do
  with palette_ModM.palette[couleur] do begin
    R:=palette_origine[couleur].R+dR;
    V:=palette_origine[couleur].V+dV;
    B:=palette_origine[couleur].B+dB;
  end;
 if fixe then palette_ModM.Fixe;
end; {CorrigePalette}

{----------------------------------------------------------}

procedure Bip(freq: WORD);
begin
 NoSound; Sound(freq); Delay(20); NoSound
end; {Bip}

{----------------------------------------------------------}

function Extension(nom_fichier: String12): BYTE;
var i: BYTE;
begin
 for i:=1 to nbr_extensions do
  if PosF('.'+Extensions[i],nom_fichier)>0 then
   begin Extension:=i; exit end;
 Extension:=0;
end; {Extension}

{----------------------------------------------------------}

function IndiceModule(nom: String12): WORD;
{retourne l'indice du module 'nom' dans le tableau Module.Nom (0 si absent)}
var i: WORD;
begin
 if nom[1]<'M' then begin  {recherche du premier au dernier module}
   for i:=premier_module to nbr_fich do
    if Module[i].Nom=nom then begin IndiceModule:=i; exit end
 end
 else begin  {recherche du dernier au premier module}
   for i:=nbr_fich downto premier_module do
    if Module[i].Nom=nom then begin IndiceModule:=i; exit end
 end;
 IndiceModule:=0;
end; {IndiceModule}

{----------------------------------------------------------}

function IndiceNum(n: WORD): WORD;
{retourne l'indice dans le tableau Module.Nom dont le module porte le numro 'n'}
var i: WORD;
begin
 for i:=premier_module to nbr_fich do
  if Module[i].Numero=n then begin IndiceNum:=i; exit end;
 IndiceNum:=0
end; {IndiceNum}

{----------------------------------------------------------}

function TestIdentModM(ident: String20; suffixe,v_min: String3): BOOLEAN;
begin
 TestIdentModM:=(Copy(ident,1,12)=Copy(ident_ModM,1,12)) and  {Mod Master v}
                (Copy(ident,13,3)>=v_min) and  {x.x}
                (Copy(ident,16,5)=' '+suffixe+' ')  { xxx }
end; {TestIdentModM}

{----------------------------------------------------------}

procedure AfficheInfosCD(piste: String12; temps: String8);
begin
 CacheCursSouris;
 AffChXY(0,x_piste_CD ,y_piste_CD,XString(piste,' ',9),16*or_fond+cyan);
 AffChXY(0,x_chrono_CD,y_piste_CD,XString(temps,' ',5),16*or_fond+cyan);
 AffCursSouris;
end; {AfficheInfosCD}

{----------------------------------------------------------}

procedure UpdateCD;
begin
 if CD.Installed then begin
   AfficheBoutonsCD;

   if CD.IsOpen then
    begin AfficheInfosCD('open',''); exit; end; {trappe ouverte}

   if not(CD.IsLoaded) then
    begin AfficheInfosCD('no disc',''); exit; end; {trappe ferme et lecteur vide}

   {trappe ferme et lecteur non vide}

   if not(CD.IsReady) then begin {lecteur pas prt}
     CD.Init;
     AfficheBoutonsCD;

     if not(CD.IsReady) then
      begin AfficheInfosCD('not ready',''); exit; end; {lecteur pas prt}
   end;

   AfficheBoutonsCD;

   {lecteur prt et CD prsent}
   if CD.IsAudio then begin
     CD.GetInfo;
     AfficheInfosCD(EntierTexte2(CD.CurrentTrack,2)+'/'+EntierTexte2(CD.LastTrack,2),
                    EntierTexte2(CD.TrackTime.min,2)+':'+EntierTexte2(CD.TrackTime.sec,2+et_zeros));
   end
   else AfficheInfosCD('CD-Rom','');

   AfficheBoutonsCD;
 end;
end; {UpDateCD}

{----------------------------------------------------------}

procedure SauveFichierDIR;

var i: WORD;
    chaine: String20;
    f: Fichier;
    flag_vol_def: BOOLEAN;

begin
 with f do begin
   Cree(ecrase,repert+MODM+'.'+Extensions[ext_DIR]);
   if f_erreur<>f_ok then exit;

   chaine:=ident_ModM+' '+Extensions[ext_DIR]+' ';
   Ecrit(chaine[1],20);
   for i:=premier_module to nbr_fich do with Module[i] do begin
     Ecrit(Nom[0],13);
     Ecrit(Titre[1],long_max_titre_module);
     Ecrit(Volume_reel,sizeof(Volume_reel));
     flag_vol_def:=((Etat and vol_par_defaut)=vol_par_defaut);
     Ecrit(flag_vol_def,sizeof(flag_vol_def))
   end;
   Ferme
 end
end; {SauveFichierDIR}

{----------------------------------------------------------}

procedure AnalyseFichierDIR;

var i,m,n: WORD;
    chaine: String20;
    creefichierDIR,flag_vol_def: BOOLEAN;
    z: Zone;
    f: Fichier;
    s: T_dir;

begin
 with f do begin
   Ouvre(lecture,repert+MODM+'.'+Extensions[ext_DIR]);
   if f_erreur=f_ok then begin
     Lit(chaine[1],20); chaine[0]:=#20;
     if TestIdentModM(chaine,Extensions[ext_DIR],version_min_DIR) then begin
       n:=(Taille-20) div sizeof(T_dir); {nombre de modules dans MODM.DIR}
       creefichierDIR:=(n<>nbr_modules);
       PlacePointeur(20);
       for m:=1 to n do begin
         AnimeCursSouris;
         Lit(s,sizeof(s));
         i:=IndiceModule(s.Nom);
         if i<>0 then with Module[i] do begin {module existe dans la liste}
           Move(s.Titre[1],Titre[1],long_max_titre_module);
           Titre[0]:=CHAR(long_max_titre_module);
           Volume_reel:=s.Volume_reel;
           Etat:=$00;
           if s.flag_vol_def then Etat:=Etat or vol_par_defaut;
         end
         else creefichierDIR:=TRUE; {module n'est pas dans la liste}
       end;
     end
     else creefichierDIR:=TRUE; {mauvais identificateur}
     Ferme;
   end
   else creefichierDIR:=TRUE; {le fichier MODM.DIR n'existe pas}

  if creefichierDIR and AutoScan then begin
    CacheCursSouris;
    z.Sauve(0,xg_fen_analyse_mod,yh_fen_analyse_mod,xd_fen_analyse_mod,yb_fen_analyse_mod);
    ZoomFenetreOmbre(xg_fen_analyse_mod,yh_fen_analyse_mod,xd_fen_analyse_mod,yb_fen_analyse_mod,encadre);
    AffChXYc(y_txt_analyse_mod,txt_analyse_mod[Langue]+'...',16*or_fond+or_clair);
    AffCursSouris;

    for m:=premier_module to nbr_fich do with Module[m] do
     if Titre='?' then begin
       AnimeCursSouris;
       Ouvre(lecture,repert+Nom);
       if f_erreur=f_ok then begin
         Titre:=RepeteCar(' ',long_max_titre_module);
         case Extension(Nom) of
          ext_MOD,
          ext_SD0,
          ext_NST,
          ext_WOW,
          ext_OCT,
          ext_STM: LitPos( 0,Titre[1],20);
          ext_S3M: LitPos( 0,Titre[1],long_max_titre_module);
          ext_669: LitPos( 2,Titre[1],long_max_titre_module);
          ext_DTM: LitPos(22,Titre[1],20);
          ext_MTM: LitPos( 4,Titre[1],20);
          ext_ULT: LitPos(15,Titre[1],long_max_titre_module);
          ext_OKT: Titre:=XString('Amiga Oktalyser',' ',long_max_titre_module);
          ext_FAR: LitPos( 4,Titre[1],long_max_titre_module);
          ext_PTM: LitPos( 0,Titre[1],long_max_titre_module);
          ext_SAT: Titre:=XString('Adlib Tracker',' ',long_max_titre_module);
         end;
         Ferme;
       end;
       Volume_reel:=Volume_par_defaut;
       if AutoSave then Etat:=Etat or nouveau;
       Etat:=Etat or vol_par_defaut;
     end;

    RestaureZoneSuppr(0,z);
    if AutoSave then SauveFichierDIR;
  end;
 end;
end; {AnalyseFichierDIR}

{----------------------------------------------------------}

procedure LitFichierCFG;
var ident : String20;
    buffer: array[1..24] of BYTE;
    f: Fichier;
begin
 with f do begin
   Ouvre(lecture,RepertoireSeul(ParamStr(0))+MODM+'.'+Extensions[ext_CFG]);
   CFG_present:=(f_erreur=f_ok);
   if not(CFG_present) then exit;

   Lit(ident[1],20); ident[0]:=#20;
   if TestIdentModM(ident,Extensions[ext_CFG],version) and (Taille=20+sizeof(buffer)) then begin
     LitPos(20,buffer,sizeof(buffer));

     with Variables^ do begin
       Sortie_sonore:=buffer[1];
       Move(buffer[2],Frequence,2);
       Move(buffer[4],Volume_par_defaut,2);
       duree_IntroScan:=buffer[6];

       Langue          :=        (buffer[12]      ) and $01;
       LangueNote      :=        (buffer[12] shr 1) and $01;
       Utilise_Stereo  :=BOOLEAN((buffer[12] shr 2) and $01);
       Utilise_Filtre  :=BOOLEAN((buffer[12] shr 3) and $01);
       Utilise_EMS     :=BOOLEAN((buffer[12] shr 4) and $01) and EMS_presente;
       Utilise_UMB     :=BOOLEAN((buffer[12] shr 5) and $01) and UMB_presente;
       Utiliser_Fine   :=BOOLEAN((buffer[12] shr 6) and $01);
       Utiliser_BPM    :=BOOLEAN((buffer[12] shr 7) and $01);

       Utiliser_Panning      :=BOOLEAN((buffer[13]      ) and $01);
       Nb_Octaves_MOD        :=     2*((buffer[13] shr 1) and $01)+3;
       Utilise_DC            :=BOOLEAN((buffer[13] shr 2) and $01);
       Utiliser_Interpolation:=BOOLEAN((buffer[13] shr 3) and $01);
       Utilise_economiseur   :=BOOLEAN((buffer[13] shr 4) and $01);
       delai_economiseur     :=       ((buffer[13] shr 5) and $07);

       DMA_SB8    :=buffer[14] and $0F;
       DMA_SB16   :=buffer[14] shr 4;
       IRQ_SB     :=buffer[15];
       VolumeLeft :=buffer[16] and $0F;
       VolumeRight:=buffer[16] shr 4;
       Panning_Gauche:=buffer[17];
       Panning_Droite:=buffer[18];

       sensib_souris:=LimiteEntier(buffer[19],sensib_souris_min,sensib_souris_max);
       corr_R:=SHORTINT(buffer[20]);
       corr_V:=SHORTINT(buffer[21]);
       corr_B:=SHORTINT(buffer[22]);

       Jump     :=BOOLEAN((buffer[23]      ) and $01);
       Autoscan :=BOOLEAN((buffer[23] shr 1) and $01);
       Autosave :=BOOLEAN((buffer[23] shr 2) and $01) and Autoscan;
       cree_Desc:=BOOLEAN((buffer[23] shr 3) and $01);
       scan_ARJ :=BOOLEAN((buffer[23] shr 4) and $01);
       scan_LZH :=BOOLEAN((buffer[23] shr 5) and $01);
       scan_RAR :=BOOLEAN((buffer[23] shr 6) and $01);
       scan_ZIP :=BOOLEAN((buffer[23] shr 7) and $01);

       type_barres_  :=(buffer[24]      ) and $03;
       mode_spectre_ :=(buffer[24] shr 2) and $01;
       amplification_:=(buffer[24] shr 3) and $1F;
     end
   end;
   Ferme
 end
end; {LitFichierCFG}

{----------------------------------------------------------}

procedure EcritFichierCFG;
var ident : String20;
    buffer: array[1..24] of BYTE;
    f: Fichier;
begin
 with f do begin
   Cree(ecrase,RepertoireSeul(ParamStr(0))+MODM+'.'+Extensions[ext_CFG]);
   if f_erreur<>f_ok then exit;

   ident:=ident_ModM+' '+Extensions[ext_CFG]+' ';
   Ecrit(ident[1],20);

   with Variables^ do begin
     buffer[1]:=Sortie_sonore;
     Move(Frequence,buffer[2],2);
     Move(Volume_par_defaut,buffer[4],2);
     buffer[6]:=duree_IntroScan;

     buffer[12]:=(     Langue               ) or  {1 bit}
                 (     LangueNote      shl 1) or  {1 bit}
                 (BYTE(Utilise_Stereo) shl 2) or  {1 bit}
                 (BYTE(Utilise_Filtre) shl 3) or  {1 bit}
                 (BYTE(Utilise_EMS   ) shl 4) or  {1 bit}
                 (BYTE(Utilise_UMB   ) shl 5) or  {1 bit}
                 (BYTE(Utiliser_Fine ) shl 6) or  {1 bit}
                 (BYTE(Utiliser_BPM  ) shl 7);    {1 bit}

     buffer[13]:=(BYTE(Utiliser_Panning)            ) or  {1 bit}
                 (((Nb_Octaves_MOD-3) div 2)   shl 1) or  {1 bit}
                 (BYTE(Utilise_DC)             shl 2) or  {1 bit}
                 (BYTE(Utiliser_Interpolation) shl 3) or  {1 bit}
                 (BYTE(Utilise_economiseur)    shl 4) or  {1 bit}
                 (delai_economiseur            shl 5);    {3 bits}

     buffer[14]:=DMA_SB8+(DMA_SB16 shl 4);
     buffer[15]:=IRQ_SB;
     buffer[16]:=VolumeLeft+(VolumeRight shl 4);
     buffer[17]:=Panning_Gauche;
     buffer[18]:=Panning_Droite;

     buffer[19]:=sensib_souris;
     buffer[20]:=BYTE(corr_R);
     buffer[21]:=BYTE(corr_V);
     buffer[22]:=BYTE(corr_B);

     buffer[23]:=(BYTE(Jump)           ) or  {1 bit}
                 (BYTE(Autoscan)  shl 1) or  {1 bit}
                 (BYTE(Autosave)  shl 2) or  {1 bit}
                 (BYTE(cree_Desc) shl 3) or  {1 bit}
                 (BYTE(scan_ARJ)  shl 4) or  {1 bit}
                 (BYTE(scan_LZH)  shl 5) or  {1 bit}
                 (BYTE(scan_RAR)  shl 6) or  {1 bit}
                 (BYTE(scan_ZIP)  shl 7);    {1 bit}

     buffer[24]:=(type_barres_        ) or  {2 bits}
                 (mode_spectre_  shl 2) or  {1 bit}
                 (amplification_ shl 3);    {5 bits}
   end;

   Ecrit(buffer,sizeof(buffer));
   Ferme
 end
end; {EcritFichierCFG}

{----------------------------------------------------------}

procedure CreeFichierDesc;

const nom_fich_Desc: String12='DESCRIPT.ION';

var m: WORD;
    f: Fichier;
    ligne: String64;
    i: BYTE;

begin
 with f do begin
   Cree(ecrase,repert+nom_fich_Desc);
   if f_erreur=f_err_acces_ref then begin
     AttributFichier(repert+nom_fich_Desc,attr_fixe,Archive);
     Cree(ecrase,repert+nom_fich_Desc);
   end;
   if f_erreur<>f_ok then exit;

   for m:=premier_module to nbr_fich do with Module[m] do begin
     ligne:=Min(Nom)+' ';
     for i:=1 to Length(Titre) do if Titre[i]>=' ' then ligne:=ligne+Titre[i];
     ligne:=ligne+#13+#10;

     Ecrit(ligne[1],Length(ligne));
   end;

   Ferme;
   AttributFichier(repert+nom_fich_Desc,attr_fixe,Archive or Hidden);
 end;
end; {CreeFichierDesc}

{----------------------------------------------------------}

procedure InitCarteSonore;
var meilleure_sortie: BYTE;
begin
 if GUS_presente then meilleure_sortie:=GUS
 else if SBPro_presente then meilleure_sortie:=SBPro
      else if SB_presente then meilleure_sortie:=SB
           else meilleure_sortie:=HPint;

 with Variables^ do begin
   if not(CFG_present) then InitSortie(meilleure_sortie)
   else if not SortiePresente[Sortie_sonore] then InitSortie(meilleure_sortie);

   CorrigeParametres(Sortie_sonore,MMType_SB,Frequence,Utilise_DMA,Utilise_Stereo,
                     Utilise_Filtre,Utilise_DC,IRQ_SB);

   case Sortie_sonore of  {excut dans tous les cas}
    SBPro: begin
            EcrireVolume(VolumeLeft,VolumeRight);
            ReglerFiltre(Utilise_Filtre)
           end;
   end
 end
end; {InitCarteSonore}

{----------------------------------------------------------}

function FreqMax(sortie,TypeSB: BYTE; stereo,DC: BOOLEAN): WORD;
begin
 case sortie of
  Adlib: FreqMax:=21000;
  SB   : if (TypeSB>1) and DC then FreqMax:=FreqMaxSB2
                              else FreqMax:=FreqMaxSB1;
  SBPro: if stereo then FreqMax:=FreqMaxSBProStereo
                   else FreqMax:=FreqMaxSBPro;
  SB16 : FreqMax:=44100;
  else FreqMax:=22100
 end
end; {FreqMax}

{----------------------------------------------------------}

procedure CorrigeParametres(sortie,TypeSB: BYTE; var freq: WORD;
                            var utDMA,utSte,utFilt,utDC: BOOLEAN; var IRQ: BYTE);
begin
 utDMA:=(sortie in [SB,SBPro,SB16]);
 if not(sortie in [SBPro,SB16]) then begin
   utSte:=FALSE; utFilt:=FALSE;
   if IRQ>7 then IRQ:=7
 end;
 if freq>FreqMax(sortie,TypeSB,utSte,UtDC) then freq:=FreqMax(sortie,TypeSB,utSte,utDC)
end; {CorrigeParametres}

{----------------------------------------------------------}

procedure Initialisation;
var i: BYTE;
begin
 CheckBreak:=FALSE;

 for i:=1 to long_copyright do
  copyright[i]:=CHAR(BYTE(copyright[i]) xor (127+i));

 with Variables^ do begin
   Nb_boucles:=0;
   Utiliser_Fine:=TRUE;
   Utiliser_Panning:=TRUE;
   Utiliser_BPM:=TRUE;
   Utiliser_Interpolation:=TRUE;
 end;

 Utilise_EMS:=EMS_presente;
 Utilise_UMB:=UMB_presente;

 Volume_Principal:=Volume_par_defaut;
 Volume_Total:=0; {Volume rglable avec +/-}

 cree_Desc:=_4DOS;

 Randomize;
 InitRepert;

 InitProgramme;
end; {Initialisation}

{==========================================================}

END.
