{************************************************************************}
{                               MM_PARAM.PAS                             }
{                                                                        }
{  Unit pour Mod Master: routines pour la ligne de commande             }
{                                                                        }
{  AUTEUR: Fabrice Couteau.                                              }
{                                                                        }
{                               Dbut d'criture le --/--/93             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}
UNIT MM_PARAM;

{$A+,G+,Q-,R-,S-}

INTERFACE

{==========================================================}

procedure AnalyseParametres;
procedure AfficheSyntaxe;
procedure ChercheFichiers;

{==========================================================}

IMPLEMENTATION

USES Crt,Dos,Fichiers,Texte,Util,UtilSm,
     ModmVar,ModmUnit,MM_VAR,MM_DIV,MM_PLAY;

{==========================================================}

procedure AnalyseParametres;

var nbr_param,i: BYTE;
    param: STRING[2];

begin
 nbr_param:=ParamCount;
 mode_interactif:=(nbr_param=0);
 affiche_syntaxe:=(nbr_param>7);

 for i:=1 to nbr_param do begin
   param:=Maj(ParamStr(i));
   if param='?' then affiche_syntaxe:=TRUE
   else
    if param[1]='/' then begin
      case param[2] of
       'F': begin Langue:=Francais; LangueNote:=Francais end;
       'E',
       'A': begin Langue:=Anglais; LangueNote:=Anglais end;

       'R': Boucler_MOD :=TRUE;
       'I': begin IntroScan:=TRUE ; Shuffle:=FALSE end;
       'S': begin IntroScan:=FALSE; Shuffle:=TRUE  end;
       else affiche_syntaxe:=TRUE
      end;
      if i=1 then mode_interactif:=TRUE {1er param. n'est pas un fichier}
    end
    else
     if i=1 then mode_interactif:=FALSE else affiche_syntaxe:=TRUE
 end
end; {AnalyseParametres}

{----------------------------------------------------------}

procedure AfficheSyntaxe;

const CRLF=#13#10;

      Lit_mod_txt: array[langues] of STRING[15]=
                   ('Plays the modules',
                    'Lit les modules');

      Et_txt: array[langues] of STRING[3]=
              ('and',
               'et');

var i: BYTE;

begin
 Write(CRLF+ident_ModM+' '+copyright+CRLF+Lit_mod_txt[Langue]+' ');

 for i:=1 to nbr_extensions_modules do begin
   Write(Extensions[i]);
   case i of
    1..nbr_extensions_modules-2: Write(', ');
    nbr_extensions_modules-1: Write(' '+Et_txt[Langue]+' ');
    nbr_extensions_modules: Write('.')
   end;
   if WhereX>75 then Writeln
 end;

 {bidouille pour afficher des chanes de +255 caractres...
  et aussi pour conomiser le segment DATA (texte dans segment CODE)}
 case Langue of
   Anglais: asm
             push DS
             push CS
             pop DS
             lea DX,@texte
             mov AH,09h
             int 21h       {Write DOS}
             jmp @fin

            @texte:
             DB 13,10

             DB 'Syntaxes: MODM [options]                      Interactive mode with menu',13,10
             DB '          MODM module_name[.ext] [options]    Plays the specified module(s)',13,10
             DB '          MODM playlist_name[.PRG] [options]  Plays the specified playlist(s)',13,10
             DB 'module_name and playlist_name may include a path name and wildcards.',13,10

             DB 'The options available are:',13,10
             DB '  /E, /A  Runs Mod Master in English',13,10
             DB '  /F      Runs Mod Master in French',13,10
             DB '  /R      Enables the repeat feature',13,10
             DB '  /I      Enables the IntroScan feature',13,10
             DB '  /S      Enables the Shuffle feature',13,10

             DB '$'
            @fin:
             pop DS
            end;

  Francais: asm
             push DS
             push CS
             pop DS
             lea DX,@texte
             mov AH,09h
             int 21h       {Write DOS}
             jmp @fin

            @texte:
             DB 13,10

             DB 'Syntaxes: MODM [options]                      Mode interactif avec menu',13,10
             DB '          MODM nom_module[.ext] [options]     Lit le(s) module(s) spcifi(s)',13,10
             DB '          MODM nom_programme[.PRG] [options]  Lit le(s) programme(s) spcifi(s)',13,10
             DB 'nom_module et nom_programme peuvent contenir un nom de chemin et des jokers.',13,10

             DB 'Les options disponibles sont:',13,10
             DB '  /F      Lance Mod Master en Franais',13,10
             DB '  /E, /A  Lance Mod Master en Anglais',13,10
             DB '  /R      Active la fonction repeat',13,10
             DB '  /I      Active la fonction IntroScan',13,10
             DB '  /S      Active la fonction Shuffle',13,10

             DB '$'
            @fin:
             pop DS
            end
 end;
 Curseur(plat)
end; {AfficheSyntaxe}

{----------------------------------------------------------}

procedure ChercheFichiers;

var i,long_repert: BYTE;
    param: String80;


procedure LitModules(PRG: BOOLEAN);

var i: WORD;
    erreur_musique: WORD;
    erreur_traitee: BOOLEAN;
    f: Fichier;

begin
 erreur_traitee:=FALSE;

 with programme_courant do begin
   actif:=(Nombre_modules>1);
   sens:=+1;

   Numero_module:=1;
   if Nombre_modules=1 then Shuffle:=FALSE;
   if Shuffle then
    for i:=1 to (Nombre_modules div 2) do
     SwapVar(Module[i],Module[1+Random(Nombre_modules)],sizeof(T_module));

   InitModeTexte(clignote);
   CorrigePalette(corr_R,corr_V,corr_B,TRUE);

   lecture_module:=TRUE;

   repeat
    with Module[Numero_module] do begin
      Volume_reel:=Volume_par_defaut;

      f.Ouvre(lecture,repert+Nom);
      if f_erreur=f_ok then begin
        Taille:=f.Taille shr 10;  {taille en ko}
        f.Ferme;
      end;

      ChargeModule(repert+Nom,erreur_fin);

      if (erreur_fin in [Ok,Err_samples]) then begin
        if erreur_traitee then begin
          InitModeTexte(clignote);
          erreur_traitee:=FALSE;
        end;

        indice_module:=Numero_module;
        Play(erreur_musique,GestionAffMus);

        if erreur_musique<>ok then ModuleSuivant;
      end
      else begin
        InitTexte(25);

        case erreur_fin of
         err_memoire: case Langue of
                       Anglais : Writeln('Not enough memory to load ',Nom);
                       Francais: Writeln('Mmoire insuffisante pour charger ',Nom);
                      end;
         err_format : case Langue of
                       Anglais : Writeln('Invalid file format in ',Nom);
                       Francais: Writeln('Erreur de format dans ',Nom);
                      end;
         err_lecture: if PRG then
                       case Langue of
                        Anglais : Writeln('Module ',Nom,' not found');
                        Francais: Writeln('Module ',Nom,' introuvable');
                       end
                      else
                       case Langue of
                        Anglais : Writeln('Error while reading ',Nom);
                        Francais: Writeln('Erreur pendant la lecture de ',Nom);
                       end;
         err_pas_sample: case Langue of
                          Anglais : Writeln('No samples found in ',Nom);
                          Francais: Writeln('Aucun instrument dans ',Nom);
                         end;
         err_version_inconnue: case Langue of
                                Anglais : Writeln('Version not supported in ',Nom);
                                Francais: Writeln('Version non gre dans ',Nom);
                               end;
         err_non_gere: case Langue of
                        Anglais : Writeln('File format not supported in ',Nom);
                        Francais: Writeln('Format non gr dans ',Nom);
                       end;
        end;

        Delay(500);
        erreur_traitee:=TRUE;
        ModuleSuivant;
      end;
    end;
   until not(lecture_module);
 end;
end; {LitModules}


procedure GereErreursFichiers(nombre_fichiers_trouves: WORD);
begin
 case DosError of
  3: begin
      case Langue of
       Anglais : Writeln('Path not found: ',repert);
       Francais: Writeln('Chemin introuvable: ',repert);
      end;
      erreur_fin:=3
     end;

  2,18: if nombre_fichiers_trouves=0 then begin
          case Langue of
           Anglais : Writeln('File not found');
           Francais: Writeln('Fichier introuvable');
          end;
          erreur_fin:=DosError
        end
        else erreur_fin:=0;

  100,153..255: begin
                 case Langue of
                  Anglais : Writeln('Read error');
                  Francais: Writeln('Erreur de lecture');
                 end;
                 erreur_fin:=DosError
                end;

  152: begin
        case Langue of
         Anglais : Writeln('Drive not ready');
         Francais: Writeln('Lecteur pas prt');
        end;
        erreur_fin:=152
       end
 end
end; {GereErreursFichiers}


procedure ChercheModules(nom_fichier: String12);

var fich: SearchRec;

begin
 with programme_courant do begin
   Nombre_modules:=0;
   FindFirst(repert+nom_fichier,Archive or ReadOnly or Hidden,fich);

   while DosError=0 do begin
     inc(Nombre_modules);
     Module[Nombre_modules].Nom:=fich.Name;
     FindNext(fich)
   end;

   if Nombre_modules<>0 then LitModules(FALSE) else GereErreursFichiers(Nombre_modules);
 end;
end; {ChercheModules}


procedure ChercheProgrammes(nom_fichier: String12);

var fich: SearchRec;
    ident: String20;
    nbr_prog,i: WORD;
    f: Fichier;

begin
 nbr_prog:=0;
 FindFirst(repert+nom_fichier,Archive or ReadOnly or Hidden,fich);

 while DosError=0 do with f do begin
   inc(nbr_prog);

   Ouvre(lecture,repert+fich.Name);
   erreur_fin:=f_erreur; {normalement, erreur_fin=0}
   Lit(ident[1],20); ident[0]:=#20;

   if TestIdentModM(ident,Extensions[ext_PRG],version_min_PRG) then
    with programme_courant do begin
      i:=Pos('.',fich.Name);
      if i=0 then Nom:=fich.Name else Nom:=CopyL(fich.Name,i-1);

      if Copy(ident,13,3)<version_PRG_titre then begin
        Nombre_modules:=(Taille-20) div 13;
        PlacePointeur(20);
        Titre:=ident;
      end
      else begin
        Nombre_modules:=(Taille-20-sizeof(Titre)) div 13;
        PlacePointeur(20);
        Lit(Titre,sizeof(Titre));
      end;

      if not REGISTERED then
       Nombre_modules:=MinEntier(LONG_PROG_LIMIT,Nombre_modules); {bridage !!}

      for i:=1 to Nombre_modules do Lit(Module[i].Nom[0],13);
      Ferme;

      if Nombre_modules<>0 then LitModules(TRUE)
    end
   else begin
     case Langue of
      Anglais : Writeln('Invalid file format in playlist ',fich.Name);
      Francais: Writeln('Erreur de format dans le programme ',fich.Name);
     end;
     erreur_fin:=3
   end;

   FindNext(fich)
 end;

 GereErreursFichiers(nbr_prog)
end; {ChercheProgrammes}


function TrouveFichierExt(nom_fichier: String12): BYTE;

var i: BYTE;
    f: SearchRec;

begin
 for i:=1 to ext_PRG do begin
   FindFirst(repert+nom_fichier+'.'+Extensions[i],Archive or ReadOnly or Hidden,f);
   if DosError=0 then begin TrouveFichierExt:=i; exit end
 end;
 TrouveFichierExt:=0
end; {TrouveFichierExt}


begin  {ChercheFichiers}
 param:=Maj(ParamStr(1));
 i:=Length(param); long_repert:=0; repert:='';

 repeat
  if (param[i] in ['\',':']) then long_repert:=i;
  dec(i)
 until (i=0) or (long_repert>0);

 if long_repert>0 then begin
   repert:=CopyL(param,long_repert); Delete(param,1,long_repert)
 end;

 case Extension(param) of
  0: if Pos('.',param)=0 then begin {pas d'extension->recherche les ext. possibles}
       i:=TrouveFichierExt(param);
       if i>0 then param:=param+'.'+Extensions[i];
       case i of
        0: GereErreursFichiers(0);
        1..nbr_extensions_modules: ChercheModules(param);
        ext_PRG: ChercheProgrammes(param)
       end
     end
     else begin AfficheSyntaxe; halt end;
  1..nbr_extensions_modules: ChercheModules(param);
  ext_PRG: ChercheProgrammes(param)
 end
end; {ChercheFichiers}

{==========================================================}

END.
