{************************************************************************}
{                                MM_PROG.PAS                             }
{                                                                        }
{  Unit pour Mod Master: routines pour grer les programmes             }
{                                                                        }
{  AUTEUR: Fabrice Couteau.                                              }
{                                                                        }
{                               Dbut d'criture le --/--/93             }
{                               Dernires modifications le 26/07/97      }
{************************************************************************}
UNIT MM_PROG;

{$A+,G+,Q-,R-,S-}

INTERFACE

{==========================================================}

procedure InitProgramme;

procedure ChargeProgramme;
procedure SauveProgramme;

{==========================================================}

IMPLEMENTATION

USES Crt,Dos,Clavier,Fichiers,Util,UtilSm,Texte,Souris,SourisSm,
     ModmVar,MM_VAR,MM_DIV,MM_AFF;

{==========================================================}

procedure InitProgramme;
begin
 with programme_courant do begin
   Nom    :='';
   Numero_module :=0;
   Nombre_modules:=0;
   Titre  :='';
   actif  :=FALSE;
   modifie:=FALSE;
   sens   :=+1;
 end;
end; {InitProgramme}

{----------------------------------------------------------}

procedure ChargeProgramme;

const Couleur: array[BOOLEAN] of BYTE=(16*or_fond+or_moyen,16*or_fond+or_clair);

var z: Zone;
    boutonOK,boutonAnnuler: Bouton3D;
    touche: Key;

    premier,nbr_prog,choix_prog,x,y,anc_bouton_souris,msg_err: BYTE;
    i,j,n: WORD;
    defile_fenetre,bouge_ascenseur,choix_clique,
    sortie,ok: BOOLEAN;

    Prog: array[1..nbr_prog_max] of T_prog;
    nom_module: String12;
    DebutListe: array[1..haut_lst_prog_mod] of String12;
    ident: String20;
    f: SearchRec;
    fPRG: Fichier;

label relit_repert,fin_lit_PRG,annule;


procedure AfficheChoix(ch: BYTE; coul: type_coul);
const Couleur: array[1..2,type_coul] of BYTE=((16*or_fond+or_clair,16*gris_fonce+blanc),
                                              (16*or_fond+noir    ,16*gris_fonce+blanc));
var ch_nbr: STRING[3];
begin
 with Prog[ch] do begin
   if Nombre_modules=0 then ch_nbr:='---' else ch_nbr:=EntierTexte2(Nombre_modules,3);

   AffChXY2(0,x_prog_1-1,y_prog_1+ch-premier,
            ' '+XString(Nom,' ',8)+' '+
            '^'+ch_nbr+' '+
            XString(Titre,' ',long_max_titre_prog)+' ',Couleur[1,coul],Couleur[2,coul]);
 end;
end; {AfficheChoix}


procedure AfficheNomModule(n: BYTE);
begin
 AffChXY(0,x_prog_mod_1,y_prog_mod_1+n-1,XString(DebutListe[n],' ',12),Couleur[IndiceModule(DebutListe[n])>0])
end; {AfficheNomModule}


procedure CorrigePremier;
begin
 if choix_prog<premier then premier:=choix_prog;
 if choix_prog>premier+haut_lst_prog-1 then premier:=choix_prog-haut_lst_prog+1
end; {CorrigePremier}


procedure CorrigeChoix;
begin
 if choix_prog<premier then choix_prog:=premier;
 if choix_prog>premier+haut_lst_prog-1 then choix_prog:=premier+haut_lst_prog-1
end; {CorrigeChoix}


procedure DefileHaut;
begin
 if choix_prog>1 then dec(choix_prog);
 CorrigePremier
end; {DefileHaut}


procedure DefileBas;
begin
 if choix_prog<nbr_prog then inc(choix_prog);
 CorrigePremier
end; {DefileBas}


procedure DefilePageHaut;
begin
 if choix_prog>haut_lst_prog then begin
   dec(choix_prog,haut_lst_prog);
   if premier>haut_lst_prog then dec(premier,haut_lst_prog) else premier:=1
 end
 else begin choix_prog:=1; premier:=1 end
end; {DefilePageHaut}


procedure DefilePageBas;
begin
 inc(choix_prog,haut_lst_prog); inc(premier,haut_lst_prog);
 if choix_prog>nbr_prog then choix_prog:=nbr_prog;
 if nbr_prog>=haut_lst_prog then
  if premier>nbr_prog-haut_lst_prog+1 then premier:=nbr_prog-haut_lst_prog+1;
 if nbr_prog<haut_lst_prog then premier:=1
end; {DefilePageBas}


procedure QuickSort(debut,fin: WORD);
var i,j: WORD;
    aux: STRING[8];
begin
 i:=debut; j:=fin; aux:=Prog[(debut+fin) shr 1].Nom;
 repeat
  AnimeCursSouris;
  while Prog[i].Nom<aux do inc(i);
  while aux<Prog[j].Nom do dec(j);
  if i<=j then begin
    SwapVar(Prog[i],Prog[j],sizeof(T_prog));
    inc(i); if j>0 then dec(j);
   end
 until i>j;
 if debut<j then QuickSort(debut,j);
 if i<fin   then QuickSort(i,fin);
end; {QuickSort}


procedure ChercheInitiale(initiale: CHAR);
var i,j,nbr: WORD;
begin
 nbr:=0;
 for i:=1 to nbr_prog do
  if (Prog[i].Nom[1]=initiale) then begin inc(nbr); j:=i end;
 if nbr>0 then begin
   if (choix_prog>=j-nbr+1) and (choix_prog<j) then inc(choix_prog) else choix_prog:=j-nbr+1;
   CorrigePremier;
 end;
end; {ChercheInitiale}


function SupprimeProg(ch: BYTE): BOOLEAN;

var z: Zone;
    boutonOui,boutonNon: Bouton3D;
    sortie,efface: BOOLEAN;
    x,y: BYTE;
    touche: Key;

begin
 CacheCursSouris;
 z.Sauve(0,xg_fen_suppr_prog,yh_fen_suppr_prog,xd_fen_suppr_prog,yb_fen_suppr_prog);
 ZoomFenetreOmbre(xg_fen_suppr_prog,yh_fen_suppr_prog,xd_fen_suppr_prog,yb_fen_suppr_prog,encadre);
 AffChXYc(y_txt_suppr_prog,txt_supprime[Langue]+' '+Prog[ch].Nom+' ?',16*or_fond+or_clair);

 AfficheBoutonsOuiNon(yb_fen_suppr_prog-4,boutonOui,boutonNon);

 repeat
  AttendClavierSouris(TRUE,FALSE,x,y);
  if KeyPressed then begin
    touche:=ReadKey;
    efface:=boutonOui.Appuye(CHAR(touche));
    sortie:=boutonNon.Appuye(CHAR(touche)) or (touche=Esc)
  end
  else begin
    efface:=boutonOui.Clique;
    sortie:=boutonNon.Clique
  end
 until sortie or efface;

 if efface then begin
   repeat
    EffaceFichier(repert+Prog[ch].Nom+'.'+Extensions[ext_PRG]);
    if f_erreur=f_ok then break;

    case MessageErreur(f_erreur,repert+Prog[ch].Nom+'.'+Extensions[ext_PRG]) of
     alt_repete  : if f_erreur=f_err_acces_ref then
                    AttributFichier(repert+Prog[ch].Nom+'.'+Extensions[ext_PRG],attr_fixe,Archive);
     alt_continue,
     alt_annule  : break;
    end
   until FALSE;

   SupprimeProg:=(f_erreur=f_ok)
 end
 else SupprimeProg:=FALSE;

 RestaureZoneSuppr(0,z)
end; {SupprimeProg}


begin  {ChargeProgramme}
 CacheCursSouris;
 z.Sauve(0,xg_fen_charge_prog,yh_fen_charge_prog,xd_fen_charge_prog,yb_fen_charge_prog);
 ZoomFenetreOmbre(xg_fen_charge_prog,yh_fen_charge_prog,xd_fen_charge_prog,yb_fen_charge_prog,encadre);

 {cadre liste programmes}
 CadreOmbre(x_cadre_lst_prog,y_cadre_lst_prog,
            x_cadre_lst_prog+larg_cadre_lst_prog-1,y_cadre_lst_prog+haut_cadre_lst_prog-1,concave);
 AffChXY(0,x_txt_lst_prog,y_txt_lst_prog,txt_prog[Langue],16*or_fond+noir);

 LigneVerticale  (0,1,x_cadre_lst_prog+38,y_cadre_lst_prog+1,y_cadre_lst_prog+haut_lst_prog,16*or_fond+or_sombre);

 LigneHorizontale(0,1,yh_fen_charge_prog+16,xg_fen_charge_prog+2,
                      xg_fen_charge_prog+2+larg_fen_charge_prog-5,16*or_fond+or_sombre);
 AfficheBoutonsOKAnnuler(yb_fen_charge_prog-4,boutonOK,boutonAnnuler);

relit_repert:
 CacheCursSouris;

 {efface fond programmes et ascenseur}
 EffaceZone(0,xg_progs,yh_progs,xd_progs,yb_progs,16*or_fond+blanc);
 EffaceZone(0,x_fl_h_asc_prog,y_fl_h_asc_prog,x_fl_b_asc_prog+1,y_fl_b_asc_prog,16*or_fond+blanc);

 AffCursSouris;
 DefCursSouris(curs_souris_occupe);

 nbr_prog:=0;

 {lit le rpertoire courant: programmes .PRG}
 repeat
  FindFirst(repert+'*.'+Extensions[ext_PRG],Archive or ReadOnly or Hidden,f);
  if DosError in [0,18] then break;

  msg_err:=MessageErreur(DosError,repert);
  case msg_err of
   alt_repete,
   alt_continue:;
   alt_annule  : goto annule;
  end
 until FALSE;

 while (DosError=0) and (nbr_prog<nbr_prog_max) do begin
   AnimeCursSouris;
   inc(nbr_prog);
   with Prog[nbr_prog] do begin
     Nom:=CopyL(f.Name,Pos('.',f.Name)-1);
     Numero_module:=0;
     Nombre_modules:=0;
     Titre:='?';
     modifie:=FALSE;
   end;
   repeat
    FindNext(f);
    if DosError in [0,18] then break;

    msg_err:=MessageErreur(DosError,repert);
    case msg_err of
     alt_repete,
     alt_continue:;
     alt_annule  : goto annule;
    end
   until FALSE
 end;

 if nbr_prog>0 then QuickSort(1,nbr_prog);

 choix_prog:=1; premier:=1;

 defile_fenetre:=FALSE;
 bouge_ascenseur:=FALSE; choix_clique:=FALSE;

 DefCursSouris(fleche);

 sortie:=FALSE; ok:=FALSE;

 repeat
  CacheCursSouris;

  if nbr_prog>haut_lst_prog then
   AfficheAscenseur(x_fl_h_asc_prog,y_fl_h_asc_prog,haut_lst_prog,nbr_prog,premier);

  for i:=premier to premier+haut_lst_prog-1 do
   if i<=nbr_prog then AfficheChoix(i,type_coul(i=choix_prog));

  if BoutonSouris=aucun then begin
    if choix_clique and not(defile_fenetre) and (anc_bouton_souris=gauche) then ok:=TRUE;
    defile_fenetre:=FALSE; bouge_ascenseur:=FALSE; choix_clique:=FALSE
  end;

  if choix_clique then ZoneSouris(xg_progs,yh_progs-1,xd_progs,yb_progs+1)
  else
   if defile_fenetre or bouge_ascenseur then
        ZoneSouris(x_fl_h_asc_prog,y_fl_h_asc_prog,x_fl_b_asc_prog+1,y_fl_b_asc_prog)
   else ZoneSouris(1,1,largeur_ecran_txt,hauteur_ecran_txt);

  if not(defile_fenetre or bouge_ascenseur or choix_clique) then begin
    AffCursSouris;
    DefCursSouris(curs_souris_occupe);

    {recherche les 'haut_lst_prog_mod' premiers modules dans le fichier PRG}
    with fPRG,Prog[choix_prog] do begin
      repeat
       Ouvre(lecture,repert+Nom+'.'+Extensions[ext_PRG]);
       if f_erreur=f_ok then break;

       msg_err:=MessageErreur(f_erreur,repert+Nom+'.'+Extensions[ext_PRG]);
       case msg_err of
        alt_repete  :;
        alt_continue: goto fin_lit_PRG;
        alt_annule  : goto annule;
       end
      until FALSE;

      Lit(ident[1],20); ident[0]:=#20;
      if TestIdentModM(ident,Extensions[ext_PRG],version_min_PRG) then begin
        if Copy(ident,13,3)<version_PRG_titre then begin
          Nombre_modules:=(Taille-20) div 13;
          PlacePointeur(20);
          Titre:=ident;
        end
        else begin
         Nombre_modules:=(Taille-20-sizeof(Titre)) div 13;
         PlacePointeur(20);
         Lit(Titre,sizeof(Titre));
        end;

        for i:=1 to haut_lst_prog_mod do DebutListe[i]:='';
        for i:=1 to MinEntier(Nombre_modules,haut_lst_prog_mod) do begin
          AnimeCursSouris;
          Lit(DebutListe[i][0],13);
        end;

        AttendVBL;
        CacheCursSouris;

        {cadre premiers modules du programme}
        CadreOmbre(x_cadre_lst_prog_mod,y_cadre_lst_prog_mod,
                   x_cadre_lst_prog_mod+larg_cadre_lst_prog_mod-1,y_cadre_lst_prog_mod+haut_cadre_lst_prog_mod-1,
                   concave+plein);
        AffChXY(0,x_txt_prem_mod,y_txt_prem_mod,txt_prem_mod[Langue],16*or_fond+noir);

        for i:=1 to MinEntier(Nombre_modules,haut_lst_prog_mod) do AfficheNomModule(i);
      end
      else Titre:=txt_PRG_invalide[Langue];
      AfficheChoix(choix_prog,inverse);

      Ferme;
    end;
  end;

 fin_lit_PRG:
  DefCursSouris(fleche);

  AttendClavierSouris(not(defile_fenetre or bouge_ascenseur or choix_clique),ok,x,y);

  anc_bouton_souris:=BoutonSouris;
  SourisBouge:=FALSE;
  if bouge_ascenseur or (choix_clique and not(defile_fenetre)) then
   repeat until KeyPressed or SourisBouge or (BoutonSouris=aucun);

  if KeyPressed then begin
    touche:=UpCase(ReadKey);
    if (EtatClavier and (ShiftG or ShiftD))=0 then begin {aucune touche Shift appuye}
      case touche of
       Up  : DefileHaut;
       Down: DefileBas;
       PgUp: DefilePageHaut;
       PgDn: DefilePageBas;
       Home: begin choix_prog:=1; premier:=1 end;
       End_: begin
              choix_prog:=nbr_prog;
              if nbr_prog>haut_lst_prog then premier:=nbr_prog-haut_lst_prog+1
             end;
       Del : if repert[1]<>LettreCDRom then
              if SupprimeProg(choix_prog) then
               if nbr_prog>1 then goto relit_repert
                             else begin PRG_present:=FALSE; goto annule end;
      end;
      if touche>255 then touche:=0; {pour viter que les codes tendus activent un bouton}

      ok:=(touche=Enter) or boutonOK.Appuye(CHAR(touche));
      sortie:=(touche=Esc) or boutonAnnuler.Appuye(CHAR(touche));
    end
    else  {au moins une touche Shift est appuye}
     if (touche>=Key('A')) and (touche<=Key('Z')) and (nbr_prog>0) then ChercheInitiale(CHAR(touche))
  end

  else begin  {souris...}

    if (x in [xg_progs..xd_progs]) and (y in [yh_progs..yb_progs]) then
     if (premier+y-yh_progs<=nbr_prog) then
      begin choix_clique:=TRUE; choix_prog:=premier+y-yh_progs end;

    if (x in [x_fl_h_asc_prog..x_fl_h_asc_prog+1]) and (nbr_prog>haut_lst_prog) then
     case y of
      y_fl_h_asc_prog: begin defile_fenetre:=TRUE; DefileHaut; DelaiBoutonSouris(10) end;
      y_fl_b_asc_prog: begin defile_fenetre:=TRUE; DefileBas; DelaiBoutonSouris(10) end;
      y_fl_h_asc_prog+1..y_fl_b_asc_prog-1:
             begin
              premier:=1+Round((y-y_fl_h_asc_prog-1)*(nbr_prog-haut_lst_prog)/(haut_lst_prog-3));
              CorrigeChoix; bouge_ascenseur:=TRUE
             end
     end;

    if choix_clique then
     case y of
      yh_progs-1: begin defile_fenetre:=TRUE; DefileHaut; Delay(12) end;
      yb_progs+1: begin defile_fenetre:=TRUE; DefileBas ; Delay(12) end;
      else defile_fenetre:=FALSE
     end
    else begin
      ok:=boutonOK.Clique;
      sortie:=boutonAnnuler.Clique;
    end;
  end
 until sortie or ok;

 {slection et chargement du programme}
 if ok then with fPRG do begin
   CacheCursSouris;

   with Prog[choix_prog] do repeat
     Ouvre(lecture,repert+Nom+'.'+Extensions[ext_PRG]);
     if f_erreur=f_ok then break;

     msg_err:=MessageErreur(f_erreur,repert+Nom+'.'+Extensions[ext_PRG]);
     case msg_err of
      alt_repete,
      alt_continue:;
      alt_annule  : goto annule;
     end
   until FALSE;

   Lit(ident[1],20); ident[0]:=#20;
   if TestIdentModM(ident,Extensions[ext_PRG],version_min_PRG) then
    with programme_courant do begin
      Nom:=Prog[choix_prog].Nom;

      if Copy(ident,13,3)<version_PRG_titre then begin
        n:=(Taille-20) div 13;
        PlacePointeur(20);
        Titre:=ident;
      end
      else begin
        n:=(Taille-20-sizeof(Titre)) div 13;
        PlacePointeur(20);
        Lit(Titre,sizeof(Titre));
      end;

      if not REGISTERED then n:=MinEntier(n,LONG_PROG_LIMIT); {bridage !!}
      for i:=1 to nbr_fich do Module[i].Numero:=0;

      {vrifie si tous les modules existent encore -> recalcule la vraie longueur du programme}
      Nombre_modules:=0;
      for i:=1 to n do begin
        Lit(nom_module,sizeof(nom_module));
        j:=IndiceModule(nom_module);
        if j<>0 then
         begin inc(Nombre_modules); Module[j].Numero:=Nombre_modules end
      end;
      Ferme;

      modifie:=FALSE;
    end
    else Bip(8*440);

   AffCursSouris
 end;

annule:
 RestaureZoneSuppr(0,z);

 if ok then AffFenControle(FALSE);
 AfficheBoutonsModules;
end; {ChargeProgramme}

{----------------------------------------------------------}

procedure SauveProgramme;

var z: Zone;
    i: WORD;
    f: Fichier;
    msg_err: BYTE;
    nom_prog: STRING[8];
    titre_prog: STRING[long_max_titre_prog];
    abandon,mode_teste_existe: BOOLEAN;
    ident: String20;

label saisie_nom_prog,annule;

begin
 CacheCursSouris;
 z.Sauve(0,xg_fen_sauve_prog,yh_fen_sauve_prog,xd_fen_sauve_prog,yb_fen_sauve_prog);
 ZoomFenetreOmbre(xg_fen_sauve_prog,yh_fen_sauve_prog,xd_fen_sauve_prog,yb_fen_sauve_prog,encadre);

 {cadre saisie titre programme}
 CadreOmbre(x_cadre_saisie_titre_prog,y_cadre_saisie_titre_prog,
            x_cadre_saisie_titre_prog+larg_cadre_saisie_titre_prog-1,
            y_cadre_saisie_titre_prog+haut_cadre_saisie_titre_prog-1,concave);
 AffChXY(0,x_txt_titre_prog,y_txt_titre_prog,txt_titre_prog[Langue],16*or_fond+noir);

 {cadre saisie nom programme}
 CadreOmbre(x_cadre_saisie_nom_prog,y_cadre_saisie_nom_prog,
            x_cadre_saisie_nom_prog+larg_cadre_saisie_nom_prog-1,y_cadre_saisie_nom_prog+haut_cadre_saisie_nom_prog-1,concave);
 AffChXY(0,x_txt_nom_prog,y_txt_nom_prog,txt_nom_prog[Langue],16*or_fond+noir);
 AffChXY(0,x_saisie_nom_prog,y_saisie_nom_prog,' '+XString(programme_courant.Nom,' ',8+1)+' ',16*or_fond+gris_fonce);

 AffCursSouris;

 titre_prog:=LitChaine(programme_courant.Titre,
                       x_saisie_titre_prog+1,y_saisie_titre_prog,
                       long_max_titre_prog+1,long_max_titre_prog,
                       TRUE,[' '..#165],FALSE,
                       16*or_clair+gris_fonce,16*or_clair+blanc,abandon);

 if not(abandon) then with programme_courant do begin
   AffChXY(0,x_saisie_titre_prog,y_saisie_titre_prog,
           ' '+XString(titre_prog,' ',long_max_titre_prog+1)+' ',16*or_fond+gris_fonce);

   nom_prog:=Nom;

  saisie_nom_prog:

   nom_prog:=LitChaine(nom_prog,x_saisie_nom_prog+1,y_saisie_nom_prog,8+1,8,
                       TRUE,alpha+['_'],TRUE,
                       16*or_clair+gris_fonce,16*or_clair+blanc,abandon);

   if not(abandon) and (nom_prog<>'') then with f do begin
     mode_teste_existe:=teste_existe;

     repeat
      DefCursSouris(curs_souris_occupe);

      Cree(mode_teste_existe,repert+nom_prog+'.'+Extensions[ext_PRG]);
      if f_erreur=f_ok then break;

      msg_err:=MessageErreur(f_erreur,nom_prog);
      case msg_err of
       alt_repete  : case f_erreur of
                      f_err_acces_ref: AttributFichier(repert+nom_prog+'.'+Extensions[ext_PRG],attr_fixe,Archive);
                      f_err_existe   : mode_teste_existe:=ecrase;
                     end;
       alt_continue:;
       alt_change  : if f_erreur=f_err_existe then goto saisie_nom_prog;
       alt_annule  : goto annule;
      end
     until FALSE;

     Nom:=nom_prog;
     Titre:=titre_prog;

     ident:=ident_ModM+' '+Extensions[ext_PRG]+' ';
     Ecrit(ident[1],20);
     Ecrit(Titre,sizeof(Titre));
     if REGISTERED then Nombre_modules:=Nombre_modules
                   else Nombre_modules:=MinEntier(LONG_PROG_LIMIT,Nombre_modules); {bridage !!}
     for i:=1 to Nombre_modules do begin
       AnimeCursSouris;
       Ecrit(Module[IndiceNum(i)].Nom[0],13)
     end;
     Ferme;

     if f_erreur=f_ok then begin
       PRG_present:=TRUE;
       programme_courant.modifie:=FALSE;
     end;

    annule:
     DefCursSouris(fleche);
   end;
 end;

 RestaureZoneSuppr(0,z);

 if not(abandon) then AffFenControle(FALSE);
 AfficheBoutonsModules;
end; {SauveProgramme}

{==========================================================}

END.
