{************************************************************************}
{                                MM_VAR.PAS                              }
{                                                                        }
{  Unit pour Mod Master: types, constantes et variables                 }
{                                                                        }
{  AUTEURS: Fabrice Couteau et Freddy Vtel.                            }
{                                                                        }
{                               Dbut d'criture le --/--/93             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}
UNIT MM_VAR;

{$A+,G+,Q-,R-,S-}

INTERFACE

USES Texte,SourisSm,ModmVar,CDAudio;


CONST {pour le bridage...}
      REGISTERED=TRUE;    {version enregistre OUI/NON}
      LONG_PROG_LIMIT=10; {nombre de modules max. dans un programme brid}

      {langues}
      Anglais=0; Francais=1;

      {masques pour T_module.Etat}
      nouveau       =$01;
      vol_par_defaut=$02;
      deja_lu       =$04;
      invalide      =$08;

      long_max_titre_module=20;
      long_max_titre_prog  =22;


TYPE  langues=Anglais..Francais;

      type_coul=(normal,inverse);

      Char3=array[1..3] of CHAR;

      {structure pour le slecteur de fichiers}
      T_module=record
                Numero,Taille,Volume_reel: WORD;
                Nom  : STRING[14];
                Titre: STRING[long_max_titre_module];
                Etat : BYTE;
               end;

      {structure pour le slecteur de programmes et le programme courant}
      T_prog=record
              Nom  : STRING[8];
              Numero_module,Nombre_modules: WORD;
              Titre: STRING[long_max_titre_prog];
              actif,modifie: BOOLEAN;
              sens: SHORTINT; {-1: module prcdent, +1: module suivant}
             end;

      {structure pour le fichier MODM.DIR}
      T_dir=record
             Nom   : STRING[8+1+3]; {nom+'.'+extension}
             Titre : array[1..long_max_titre_module] of CHAR;
             Volume_reel  : WORD;
             flag_vol_def : BOOLEAN;
            end;


CONST {numros de version pour la compatibilit}
      version_min_DIR: array[1..3] of CHAR='2.2';
      version_min_PRG: array[1..3] of CHAR='2.0';
      version_PRG_titre: array[1..3] of CHAR='2.3'; {ajout du titre dans le format}

      {numro de version actuelle}
      version: array[1..3] of CHAR='2.3';
      ident_ModM: array[1..15] of CHAR='Mod Master v2.3';

      MODM: array[1..4] of CHAR='MODM';

      {copyright}
      long_copyright=57;
      copyright: array[1..long_copyright] of CHAR=
       {'- (c) Copyright 1993-98 Freddy Vtel & Fabrice Couteau -'}
       (#173,#161,#170,#224,#173,#165,#197,#232,#248,#240,#248,#226,#235,#229,#250,#175,#161,#168,#171,
        #160,#185,#172,#174,#183,#222,#235,#255,#255,#248,#228,#190,#201, #34,#213,#199,#207, #38,#133,
        #128,#135,#238,#200,#200,#217,#197,#206,#203,#143,#243,#222,#199,#199,#209,#212,#195,#151,#149);

      {noms des couleurs}
      noir       = 0;
      bleu       = 1;
      vert_jaune = 2;
      or_sombre  = 3; {\                                    }
      or_fond    = 4; { \ nuances pour les effets de relief }
      or_moyen   = 5; { /                                   }
      or_clair   = 6; {/                                    }
      gris       = 7; gris_clair=gris;
      gris_fonce = 8; ombre=gris_fonce;
      vert_pastel= 9;
      vert       =10;
      cyan       =11; turquoise=cyan;
      rouge      =12;
      orange     =13;
      jaune      =14;
      blanc      =15;

      {noms sorties sonores}
      nbr_sorties=9;
      Sorties: array[langues,0..nbr_sorties-1] of STRING[20]
       =(('Internal speaker',
          'Dig/Analog converter',
          'Disney Sound Source',
          'Sound Master',
          'OPL-2 (Adlib)',
          'Sound Blaster',
          'Sound Blaster Pro',
          'Sound Blaster 16',
          'Gravis UltraSound'),

         ('Haut-parleur interne',
          'Convertisseur N/A',
          'Disney Sound Source',
          'Sound Master',
          'OPL-2 (Adlib)',
          'Sound Blaster',
          'Sound Blaster Pro',
          'Sound Blaster 16',
          'Gravis UltraSound'));

      MonoStereo: array[langues,0..1] of STRING[6]=
                  (('Mono','Stereo'),
                   ('Mono','Stro'));

      {noms options configuration}
      nbr_configs=4;
      cfg_interface =0;
      cfg_repertoire=1;
      cfg_son       =2;
      cfg_divers    =3;
      Configs: array[langues,0..nbr_configs-1] of STRING[11]
       =(('Interface',
          'Directory',
          'Sound',
          'Misc.'),

         ('Interface',
          'Rpertoire',
          'Son',
          'Divers'));

      txt_aide: array[langues] of STRING[4]=('Help','Aide');

      {extensions reconnues par le slecteur de fichiers}
      ext_MOD= 1; ext_SD0= 2; ext_NST= 3; ext_WOW= 4; ext_OCT= 5;
      ext_STM= 6; ext_S3M= 7; ext_669= 8; ext_DTM= 9; ext_MTM=10;
      ext_ULT=11; ext_FAR=12; ext_OKT=13; ext_PTM=14; ext_SAT=15;

      ext_PRG=16; ext_CFG=17; ext_DIR=18; {programme, config., donnes modules}

      ext_ARJ=19; ext_LZH=20; ext_RAR=21; ext_ZIP=22;

      nbr_extensions_modules=15;
      nbr_extensions=nbr_extensions_modules+3+4;

      {noms des extensions}
      Extensions: array[1..nbr_extensions] of Char3
                   =('MOD','SD0','NST','WOW','OCT',
                     'STM','S3M','669','DTM','MTM',
                     'ULT','FAR','OKT','PTM','SAT',
                     'PRG','CFG','DIR',
                     'ARJ','LZH','RAR','ZIP');

      {couleurs associes aux extensions de modules}
      CouleursExt: array[1..nbr_extensions_modules] of BYTE
                    =(or_clair,or_clair,or_clair,or_clair,or_clair,
                      vert,vert_pastel,orange,blanc,cyan,
                      bleu,gris,or_sombre,vert_jaune,rouge);

      {nombre maximal de fichiers dans un rpertoire}
      nbr_fich_max=512;

      {types de module}
      TypeModule: array[T_MOD..T_SAT] of STRING[18]
                   =('?',
                     '?',
                     'Scream Tracker 2.0',
                     'Scream Tracker 3.x',
                     'Composer 669',
                     'Multi Tracker',
                     'Digital Tracker',
                     'Ultra Tracker',
                     'Farandole Tracker',
                     'PolyTracker',
                     'Adlib Tracker'
                    );

      {types de module tendus pour mod}
      TypeModuleMOD: array[T_MOD_INC..T_MOD_DT] of STRING[27]
                      =('?',
                        'NoiseTracker',
                        'ProTracker/SoundTracker',
                        'FastTracker 1.x',
                        'TakeTracker/FastTracker 2.x',
                        'StarTrekker',
                        'Octalyzer',
                        'Octalyser',
                        'Octalyser (Atari ST/Falcon)',
                        'Digital Tracker F030'
                       );

      {noms des commandes (20 caractres)}
      NomCommande: array[Arpeggio..Release] of STRING[20]
                 =('Arpeggio',             { 1 / 0 xy / Arpeggio}
                   'Portamento Up',        { 2 / 1 xy / Portamento Up}
                   'Portamento Down',      { 3 / 2 xy / Portamento Down}
                   'Tone Portamento',      { 4 / 3 xy / Tone Portamento}
                   'Vibrato',              { 5 / 4 xy / Vibrato}
                   'Tone Porta+Vol.Slide', { 6 / 5 xy / Tone Porta+Vol.Slide}
                   'Vibrato+Volume Slide', { 7 / 6 xy / Vibrato+Volume Slide}
                   'Tremolo',              { 8 / 7 xy / Tremolo}
                   'Panning',              { 9 / 8 xy / Panning}
                   'Sample Offset',        {10 / 9 xy / Sample Offset}
                   'Volume Slide',         {11 / A xy / Volume Slide}
                   'Jump Position',        {12 / B xy / Jump Position}
                   'Set Volume',           {13 / C xy / Set Volume}
                   'Pattern break',        {14 / D xy / Pattern break}
                   'Extended',             {15 / E  x / Extended}
                   'Set Tempo',            {16 / F xy / Set Tempo}

                   'Set Filter',           {17 / E 0x / Set Filter}
                   'Fine Portamento Up',   {18 / E 1x / Fine Portamento Up}
                   'Fine Portamento Down', {19 / E 2x / Fine Portamento Down}
                   'Glissando Control',    {20 / E 3x / Glissando Control}
                   'Vibrato Control',      {21 / E 4x / Vibrato Control}
                   'Fine Tune',            {22 / E 5x / Fine Tune}
                   'Jump Loop',            {23 / E 6x / Jump Loop}
                   'Tremolo Control',      {24 / E 7x / Tremolo Control}
                   '',                     {25 / E 8x / }
                   'Retrig Note',          {26 / E 9x / Retrig Note}
                   'Fine Volume Up',       {27 / E Ax / Fine Volume Up}
                   'Fine Volume Down',     {28 / E Bx / Fine Volume Down}
                   'Note Cut',             {29 / E Cx / Note Cut}
                   'Note Delay',           {30 / E Dx / Note Delay}
                   'Pattern Delay',        {31 / E Ex / Pattern Delay}
                   'Funk It',              {32 / E Fx / Funk It}

                   'Set BPM',              {33 / ?    / Set BPM}
                   'Set Global Volume',    {34 / ?    / Set Global Volume}
                   'Tremor',               {35 / ?    / Tremor}
                   'Frequency Adjust',     {36 / ?    / Frequency Adjust}
                   'ULT Special',          {37 / ?    / ULT Special}
                   'Vibrato Sweep',        {38 / ?    / Vibrato Sweep}
                   'Release'               {39 / ?    / Release}
                  );

      {noms des commandes (6 caractres)}
      NomCommande6: array[Arpeggio..Release] of STRING[6]
                 =('Arpegg',               { 1 / 0 xy / Arpeggio}
                   'Porta',               { 2 / 1 xy / Portamento Up}
                   'Porta',               { 3 / 2 xy / Portamento Down}
                   'TonePr',               { 4 / 3 xy / Tone Portamento}
                   'Vibrat',               { 5 / 4 xy / Vibrato}
                   'TnPrVS',               { 6 / 5 xy / Tone Porta+Vol.Slide}
                   'VibrVS',               { 7 / 6 xy / Vibrato+Volume Slide}
                   'Tremol',               { 8 / 7 xy / Tremolo}
                   'Panng' ,               { 9 / 8 xy / Panning}
                   'SmpOff',               {10 / 9 xy / Sample Offset}
                   'VolSld',               {11 / A xy / Volume Slide}
                   'JmpPos',               {12 / B xy / Jump Position}
                   'SetVol',               {13 / C xy / Set Volume}
                   'PatBrk',               {14 / D xy / Pattern break}
                   'Extend',               {15 / E  x / Extended}
                   'Tempo' ,               {16 / F xy / Set Tempo}

                   'Filter',               {17 / E 0x / Set Filter}
                   'FineP',               {18 / E 1x / Fine Portamento Up}
                   'FineP',               {19 / E 2x / Fine Portamento Down}
                   'GlissC',               {20 / E 3x / Glissando Control}
                   'VibCtr',               {21 / E 4x / Vibrato Control}
                   'FineTn',               {22 / E 5x / Fine Tune}
                   'Loop'  ,               {23 / E 6x / Jump Loop}
                   'TremoC',               {24 / E 7x / Tremolo Control}
                   '',                     {25 / E 8x / }
                   'Retrig',               {26 / E 9x / Retrig Note}
                   'FineV',               {27 / E Ax / Fine Volume Up}
                   'FineV',               {28 / E Bx / Fine Volume Down}
                   'NotCut',               {29 / E Cx / Note Cut}
                   'NotDel',               {30 / E Dx / Note Delay}
                   'PatDel',               {31 / E Ex / Pattern Delay}
                   'FunkIt',               {32 / E Fx / Funk It}

                   'SetBPM',               {33 / ?    / Set BPM}
                   'GlbVol',               {34 / ?    / Set Global Volume}
                   'Tremor',               {35 / ?    / Tremor}
                   'FrqAdj',               {36 / ?    / Frequency Adjust}
                   'ULTSpe',               {37 / ?    / ULT Special}
                   'VibSwp',               {38 / ?    / Vibrato Sweep}
                   'Releas'                {39 / ?    / Release}
                  );

      {noms des commandes (5 caractres)}
      NomCommande5: array[Arpeggio..Release] of STRING[5]
                 =('Arpeg',                { 1 / 0 xy / Arpeggio}
                   'Port',                { 2 / 1 xy / Portamento Up}
                   'Port',                { 3 / 2 xy / Portamento Down}
                   'TonPr',                { 4 / 3 xy / Tone Portamento}
                   'Vibra',                { 5 / 4 xy / Vibrato}
                   'TnPVS',                { 6 / 5 xy / Tone Porta+Vol.Slide}
                   'VibVS',                { 7 / 6 xy / Vibrato+Volume Slide}
                   'Treml',                { 8 / 7 xy / Tremolo}
                   'Panng',                { 9 / 8 xy / Panning}
                   'SmpOf',                {10 / 9 xy / Sample Offset}
                   'VolSl',                {11 / A xy / Volume Slide}
                   'JmpPs',                {12 / B xy / Jump Position}
                   'Volum',                {13 / C xy / Set Volume}
                   'PtBrk',                {14 / D xy / Pattern break}
                   'Extnd',                {15 / E  x / Extended}
                   'Tempo',                {16 / F xy / Set Tempo}

                   'Filtr',                {17 / E 0x / Set Filter}
                   'FinP',                {18 / E 1x / Fine Portamento Up}
                   'FinP',                {19 / E 2x / Fine Portamento Down}
                   'GlisC',                {20 / E 3x / Glissando Control}
                   'VibrC',                {21 / E 4x / Vibrato Control}
                   'FinTn',                {22 / E 5x / Fine Tune}
                   'Loop' ,                {23 / E 6x / Jump Loop}
                   'TremC',                {24 / E 7x / Tremolo Control}
                   '',                     {25 / E 8x / }
                   'Retrg',                {26 / E 9x / Retrig Note}
                   'FinV',                {27 / E Ax / Fine Volume Up}
                   'FinV',                {28 / E Bx / Fine Volume Down}
                   'NtCut',                {29 / E Cx / Note Cut}
                   'NtDel',                {30 / E Dx / Note Delay}
                   'PtDel',                {31 / E Ex / Pattern Delay}
                   'FnkIt',                {32 / E Fx / Funk It}

                   'BPM'  ,                {33 / ?    / Set BPM}
                   'GlVol',                {34 / ?    / Set Global Volume}
                   'Tremr',                {35 / ?    / Tremor}
                   'FqAdj',                {36 / ?    / Frequency Adjust}
                   'ULTSp',                {37 / ?    / ULT Special}
                   'VbSwp',                {38 / ?    / Vibrato Sweep}
                   'Reles'                 {39 / ?    / Release}
                  );

      {codage des notes (en demi-tons)}
      bemol=-1;
      diese=+1;

      {n note       masque binaire (pour clavier)}
      Do_=0;         m_Do =1 shl Do_;
      Dod=Do_+diese; m_Dod=1 shl Dod;
      Re =Dod+1;     m_Re =1 shl Re ;
      Reb=Re +bemol; m_Reb=1 shl Reb;
      Red=Re +diese; m_Red=1 shl Red;
      Mi =Red+1;     m_Mi =1 shl Mi ;
      Mib=Mi +bemol; m_Mib=1 shl Mib;
      Fa =Mi +1;     m_Fa =1 shl Fa ;
      Fad=Fa +diese; m_Fad=1 shl Fad;
      Sol=Fad+1;     m_Sol=1 shl Sol;
      Sob=Sol+bemol; m_Sob=1 shl Sob;
      Sod=Sol+diese; m_Sod=1 shl Sod;
      La =Sod+1;     m_La =1 shl La ;
      Lab=La +bemol; m_Lab=1 shl Lab;
      Lad=La +diese; m_Lad=1 shl Lad;
      Si =Lad+1;     m_Si =1 shl Si ;
      Sib=Si +bemol; m_Sib=1 shl Sib;

      {noms des notes}
      NomNote: array[langues,Do_..Si] of STRING[3]=
               (('C-' ,'C#' ,'D-' ,'D#' ,'E-' ,'F-' ,'F#' ,'G-' ,'G#' ,'A-' ,'A#' ,'B-' ),
                ('Do ','Do#','R ','Mib','Mi ','Fa ','Fa#','Sol','So#','La ','Sib','Si '));

      Note_KeyOff = $FF; {touche relche}
      Aff_KeyOff  = '()';

      {accords (dans la gamme de Do)}
      nbr_accords=34;
      Accord: array[1..nbr_accords] of
               record
                nom: STRING[5];
                masque: WORD;
               end

              =((nom:'maj'  ; masque:m_Do or m_Mi  or m_Sol                           ),
                (nom:'aug'  ; masque:m_Do or m_Mi  or m_Sod                           ),
                (nom:'dim'  ; masque:m_Do or m_Mib or m_Fad                           ),
                (nom:'sus'  ; masque:m_Do or m_Fa  or m_Sol                           ),
                (nom:'min'  ; masque:m_Do or m_Mib or m_Sol                           ),
                (nom:'min+5'; masque:m_Do or m_Mib or m_Sod                           ),
                (nom:'2'    ; masque:m_Do or m_Re  or m_Mi  or m_Sol                  ),
                (nom:'6'    ; masque:m_Do or m_Mi  or m_Sol or m_La                   ),
                (nom:'7'    ; masque:m_Do or m_Mi  or m_Sol or m_Sib                  ),
                (nom:'maj7' ; masque:m_Do or m_Mi  or m_Sol or m_Si                   ),
                (nom:'7-5'  ; masque:m_Do or m_Mi  or m_Fad or m_Sib                  ),
                (nom:'7+5'  ; masque:m_Do or m_Mi  or m_Sod or m_Sib                  ),
                (nom:'dim6' ; masque:m_Do or m_Mib or m_Fad or m_La                   ),
                (nom:'sus7' ; masque:m_Do or m_Fa  or m_Sol or m_Sib                  ),
                (nom:'min2' ; masque:m_Do or m_Re  or m_Mib or m_Sol                  ),
                (nom:'min6' ; masque:m_Do or m_Mib or m_Sol or m_La                   ),
                (nom:'min7' ; masque:m_Do or m_Mib or m_Sol or m_Sib                  ),
                (nom:'min+7'; masque:m_Do or m_Mib or m_Sol or m_Si                   ),
                (nom:'mi7-5'; masque:m_Do or m_Mib or m_Fad or m_Sib                  ),
                (nom:'9'    ; masque:m_Do or m_Mi  or m_Sol or m_Sib or m_Re          ),
                (nom:'maj9' ; masque:m_Do or m_Mi  or m_Sol or m_Si  or m_Re          ),
                (nom:'7-9'  ; masque:m_Do or m_Mi  or m_Sol or m_Sib or m_Dod         ),
                (nom:'7-10' ; masque:m_Do or m_Mi  or m_Sol or m_Sib or m_Red         ),
                (nom:'7+5-9'; masque:m_Do or m_Mi  or m_Sod or m_Sib or m_Dod         ),
                (nom:'9+5'  ; masque:m_Do or m_Mi  or m_Sod or m_Sib or m_Red         ),
                (nom:'6.9'  ; masque:m_Do or m_Mi  or m_Sol or m_La  or m_Re          ),
                (nom:'min9' ; masque:m_Do or m_Mib or m_Sol or m_Sib or m_Re          ),
                (nom:'mi7-9'; masque:m_Do or m_Mib or m_Sol or m_Sib or m_Dod         ),
                (nom:'mi9+7'; masque:m_Do or m_Mib or m_Sol or m_Si  or m_Re          ),
                (nom:'mi6.9'; masque:m_Do or m_Mib or m_Sol or m_La  or m_Re          ),
                (nom:'11'   ; masque:m_Do or m_Mi  or m_Sol or m_Sib or m_Re  or m_Fa ),
                (nom:'11+'  ; masque:m_Do or m_Mi  or m_Sol or m_Sib or m_Re  or m_Fad),
                (nom:'maj11'; masque:m_Do or m_Mi  or m_Sol or m_Si  or m_Re  or m_Fad),
                (nom:'min11'; masque:m_Do or m_Mib or m_Sol or m_Sib or m_Re  or m_Fa )
               );

      {nombre maximal de programmes dans le rpertoire}
      nbr_prog_max=128;

      {facteurs de correction palette RVB}
      corr_R_min=-20; corr_R_max=+15;
      corr_V_min=-20; corr_V_max=+15;
      corr_B_min=-10; corr_B_max=+35;

      {sensibilit souris}
      sensib_souris_min=10;
      sensib_souris_max=100;

      {curseur souris 'occup'}
      curs_souris_occupe=rotatif;

      {messages d'erreurs et codes}
      err_archive=16; {erreur  l'excution de Arj, Lharc, Rar ou Pkunzip}

      base_err_module =200; {code de base pour erreurs chargement module}
      base_err_musique=220; {code de base pour erreurs musique}


  {-----constantes pour les cadres/fentres---------------------}

      {caractres coins cadres}
      car_coin_cadre_sup_g='';
      car_coin_cadre_sup_d=#246;
      car_coin_cadre_inf_g=#247;
      car_coin_cadre_inf_d='';

      {caractres coins fentres}
      car_coin_fen_sup_g=#6;
      car_coin_fen_sup_d=#5;
      car_coin_fen_inf_g=#4;
      car_coin_fen_inf_d=#3;


  {-----constantes pour les ascenseurs--------------------------}

      {couleur flches}
      coul_fl_asc=16*or_fond+or_clair;
      {couleur fond}
      coul_fond_asc=16*gris_fonce+blanc;
      {couleur barre}
      coul_barre_asc=16*or_clair+blanc;
      {caractre fond et barre}
      car_asc=' ';
      {flche haute: gauche et droite}
      car_fl_hg_asc=#155; car_fl_hd_asc=#156;
      {flche basse: gauche et droite}
      car_fl_bg_asc=#157; car_fl_bd_asc=#158;


  {-----constantes pour les boutons-----------------------------}

      {couleurs: relch, appuy, lettre, relief haut/bas/coin}
      coul_bt_relache=16*or_moyen+noir;
      coul_bt_appuye =16*or_moyen+blanc;
      coul_bt_lettre =16*or_moyen+jaune;
      coul_bt_relief_h=or_clair;
      coul_bt_relief_b=or_sombre;
      coul_bt_relief_c=or_moyen;
      {caractre coin infrieur droit}
      car_bt_coin=#3;

  {-----constantes pour les cases  cocher----------------------}

      {caractres: non coche, coche, appuye}
      car_case_non_cochee=#20;
      car_case_cochee    =#21;
      car_case_appuyee   =#22;
      {couleurs: active, inactive}
      coul_case_act  =16*or_fond+orange;
      coul_case_inact=16*or_fond+or_sombre;


  {-----constantes diverses-------------------------------------}

      {caractre LED}
      car_LED=#2;
      {couleurs LED}
      couleur_LED_v : array[BOOLEAN] of BYTE=(gris_fonce,vert);
      couleur_LED_r : array[BOOLEAN] of BYTE=(gris_fonce,rouge);
      couleur_LED_vr: array[BOOLEAN,BOOLEAN] of BYTE=((gris_fonce,gris_fonce),(vert,rouge));
      {caractre copyright (c)}
      car_copyright=#23;


  {-----constantes pour curseurs (volume, mixage, ...)----------}

      {caractres: barre et curseur}
      car_barre_curs=#7; car_curs=#1;
      {couleurs: barre et curseur}
      coul_barre_curs=16*or_fond+noir; coul_curs=16*or_fond+orange;
      {couleur -,+}
      coul_plus_moins=16*or_fond+orange;


  {-----constantes pour barres-curseurs (avancement, volume)----}

      {couleurs: barre et fond barre}
      coul_barre=16*or_fond+gris_clair; coul_barre_fond=16*or_fond+noir;


  {-----constantes pour les doubles-flches  -----------------}

      {caractres: flche , flche }
      car_fl2_b='^'#31'^'; car_fl2_h='^'#30'^';
      {couleurs: bord gauche/droit et flche}
      coul_fl2_bord=16*or_sombre+or_fond; coul_fl2_fl=16*or_sombre+orange;
      {base de temps}
      base_delai_fl2=10;


  {-----coordonnes des fentres, boutons, cases, textes...-----}

      {centre de l'cran}
      x_milieu=40; y_milieu=25;


    {fentre slecteur modules}
      larg_fen_modules=50; haut_fen_modules=48;
      xg_fen_modules=1; yh_fen_modules=2;
      xd_fen_modules=xg_fen_modules+larg_fen_modules-1; yb_fen_modules=yh_fen_modules+haut_fen_modules-1;

      {nombre de modules lists visibles}
      haut_lst_modules=42;

      {rpertoire courant}
      x_nom_repert=xg_fen_modules+2; y_nom_repert=yh_fen_modules+2;
      long_repert_aff=larg_fen_modules-4; {longueur visible du nom de rpertoire}

      {nom lecteur}
      x_nom_lecteur_1=xg_fen_modules+2; y_nom_lecteur_1=yh_fen_modules+5; {premier lecteur}

      {ascenseur}
      x_fl_h_asc_modules=xg_fen_modules+46; y_fl_h_asc_modules=yh_fen_modules+4;
      x_fl_b_asc_modules=x_fl_h_asc_modules; y_fl_b_asc_modules=y_fl_h_asc_modules+haut_lst_modules-1;

      {zone modules/rpertoires}
      xg_modules=xg_fen_modules+6; yh_modules=yh_fen_modules+4;
      xd_modules=xg_modules+39-1; yb_modules=yh_modules+haut_lst_modules-1;

      {noms modules/rpertoires}
      x_module_1=xg_modules; y_module_1=yh_modules; {premier fichier/module}



    {fentre contrle}
      larg_fen_controle=30; haut_fen_controle=48;
      xg_fen_controle=51; yh_fen_controle=2;
      xd_fen_controle=xg_fen_controle+larg_fen_controle-1; yb_fen_controle=yh_fen_controle+haut_fen_controle-1;

     {cadre sortie sonore}
      larg_cadre_sortie=larg_fen_controle-2; haut_cadre_sortie=10;
      x_cadre_sortie=xg_fen_controle+1; y_cadre_sortie=yh_fen_controle+1;

      {cadre nom sortie sonore}
      larg_cadre_nom_sortie=larg_cadre_sortie-2; haut_cadre_nom_sortie=4;
      x_cadre_nom_sortie=x_cadre_sortie+1; y_cadre_nom_sortie=y_cadre_sortie+2;

      x_txt_sortie=x_cadre_nom_sortie+1; y_txt_sortie=y_cadre_nom_sortie-1;
      txt_sortie: array[langues] of STRING[13]=('Sound output',
                                                'Sortie sonore');
      x_nom_sortie=x_cadre_nom_sortie+2; y_nom_sortie=y_cadre_nom_sortie+1;
      {txt_nom_sortie -> Sorties[]}

      {bouton Change}
      x_bt_Change=x_cadre_sortie+1; y_bt_Change=y_cadre_sortie+6;
      txt_bt_Change='Cha^n^ge';

     {cadre configuration}
      larg_cadre_config=larg_fen_controle-2; haut_cadre_config=5;
      x_cadre_config=xg_fen_controle+1; y_cadre_config=yh_fen_controle+11;

      {bouton Configuration}
      x_bt_Config=x_cadre_config+1; y_bt_Config=y_cadre_config+1;
      txt_bt_Config='Confi^g^uration';

     {cadre fonctions Introscan/Shuffle}
      larg_cadre_fonct=larg_fen_controle-2; haut_cadre_fonct=5;
      x_cadre_fonct=xg_fen_controle+1; y_cadre_fonct=yh_fen_controle+16;

      {bouton Introscan}
      x_bt_Introscan=x_cadre_fonct+1; y_bt_Introscan=y_cadre_fonct+1;
      txt_bt_Introscan='^I^ntroscan';

      {bouton Shuffle}
      x_bt_Shuffle=x_cadre_fonct+16; y_bt_Shuffle=y_cadre_fonct+1;
      txt_bt_Shuffle='^S^huffle';

     {cadre programme}
      larg_cadre_prog=larg_fen_controle-2; haut_cadre_prog=15;
      x_cadre_prog=xg_fen_controle+1; y_cadre_prog=yh_fen_controle+21;

      {cadre titre programme}
      larg_cadre_titre_prog=larg_cadre_prog-2; haut_cadre_titre_prog=3;
      x_cadre_titre_prog=x_cadre_prog+1; y_cadre_titre_prog=y_cadre_prog+2;

      x_txt_prog=x_cadre_titre_prog+1; y_txt_prog=y_cadre_titre_prog-1;
      txt_prog: array[langues] of STRING[9]=('Play-list',
                                             'Programme');
      x_titre_prog=x_cadre_titre_prog+2; y_titre_prog=y_cadre_titre_prog+1; {titre}
      x_fich_prog=x_txt_prog+11; y_fich_prog=y_txt_prog; {nom fichier}

      {bouton Lecture}
      x_bt_Lecture=x_cadre_prog+1; y_bt_Lecture=y_cadre_prog+5;
      txt_bt_Lecture: array[langues] of STRING[9]=('^P^lay',
                                                   '^L^ecture');
      {bouton Tout}
      x_bt_Tout=x_cadre_prog+1; y_bt_Tout=y_cadre_prog+8;
      txt_bt_Tout: array[langues] of STRING[6]=('^A^ll',
                                                '^T^out');
      {bouton Efface}
      x_bt_Efface=x_cadre_prog+1; y_bt_Efface=y_cadre_prog+11;
      txt_bt_Efface: array[langues] of STRING[8]=('^C^lear',
                                                  '^E^fface');
      {bouton Charge}
      x_bt_Charge=x_cadre_prog+16; y_bt_Charge=y_cadre_prog+5;
      txt_bt_Charge: array[langues] of STRING[8]=('^L^oad',
                                                  '^C^harge');
      {bouton Sauve}
      x_bt_Sauve=x_cadre_prog+16; y_bt_Sauve=y_cadre_prog+8;
      txt_bt_Sauve: array[langues] of STRING[7]=('Sa^v^e',
                                                 'Sau^v^e');

      x_LED_prog=x_bt_Sauve-1; y_LED_prog=y_bt_Sauve+1; {LED programme modifi}

     {cadre CD}
      larg_cadre_CD=larg_fen_controle-2; haut_cadre_CD=11;
      x_cadre_CD=xg_fen_controle+1; y_cadre_CD=yh_fen_controle+36;

      {cadre afficheurs CD}
      larg_cadre_aff_CD=21; haut_cadre_aff_CD=3;
      x_cadre_aff_CD=x_cadre_CD+6; y_cadre_aff_CD=y_cadre_CD+1;

      x_txt_CD=x_cadre_aff_CD-4; y_txt_CD=y_cadre_aff_CD+1;
      txt_CD='CD';
      x_piste_CD=x_cadre_aff_CD+1; y_piste_CD=y_cadre_aff_CD+1;   {n piste XX/XX}
      x_chrono_CD=x_cadre_aff_CD+9; y_chrono_CD=y_cadre_aff_CD+1; {chrono XX:XX/XX:XX}

      {CD: bouton EJECTION}
      x_bt_CD_Eject=x_cadre_CD+1; y_bt_CD_Eject=y_cadre_CD+4;
      txt_bt_CD_Eject=#8;

      {CD: bouton LECTURE}
      x_bt_CD_Lecture=x_cadre_CD+10; y_bt_CD_Lecture=y_cadre_CD+4;
      txt_bt_CD_Lecture='  ';

      {CD: LED bouton Lecture}
      x_LED_Lecture=x_bt_CD_Lecture-1; y_LED_Lecture=y_bt_CD_Lecture+1;

      {CD: bouton PAUSE}
      x_bt_CD_Pause=x_cadre_CD+17; y_bt_CD_Pause=y_cadre_CD+4;
      txt_bt_CD_Pause=#1;

      {CD: bouton ARRET}
      x_bt_CD_Arret=x_cadre_CD+22; y_bt_CD_Arret=y_cadre_CD+4;
      txt_bt_CD_Arret='';

      {CD: bouton PISTE PRECEDENTE}
      x_bt_CD_Prec=x_cadre_CD+1; y_bt_CD_Prec=y_cadre_CD+7;
      txt_bt_CD_Prec=''#1;

      {CD: bouton RETOUR RAPIDE}
      x_bt_CD_Retour=x_cadre_CD+7; y_bt_CD_Retour=y_cadre_CD+7;
      txt_bt_CD_Retour='';

      {CD: bouton AVANCE RAPIDE}
      x_bt_CD_Avance=x_cadre_CD+15; y_bt_CD_Avance=y_cadre_CD+7;
      txt_bt_CD_Avance='';

      {CD: bouton PISTE SUIVANTE}
      x_bt_CD_Suiv=x_cadre_CD+21; y_bt_CD_Suiv=y_cadre_CD+7;
      txt_bt_CD_Suiv=#1'';



    {fentre change sortie sonore}
      larg_fen_sortie=69; haut_fen_sortie=22;
      xg_fen_sortie=x_milieu-(larg_fen_sortie div 2); xd_fen_sortie=xg_fen_sortie+larg_fen_sortie-1;
      yh_fen_sortie=y_milieu-(haut_fen_sortie div 2); yb_fen_sortie=yh_fen_sortie+haut_fen_sortie-1;

      {liste sorties}
      larg_cadre_sorties=24; haut_cadre_sorties=nbr_sorties+2;
      x_cadre_sorties=xg_fen_sortie+2; y_cadre_sorties=yh_fen_sortie+3;

      x_txt_sorties=x_cadre_sorties+1; y_txt_sorties=y_cadre_sorties-1;
      {txt_sorties -> txt_sortie[]}
      x_nom_sortie_1=x_cadre_sorties+2; y_nom_sortie_1=y_cadre_sorties+1; {premire sortie}

      {zone fond rglages}
      xg_fond_regl_sortie=xg_fen_sortie+27; yh_fond_regl_sortie=yh_fen_sortie+2;
      xd_fond_regl_sortie=xg_fen_sortie+66; yb_fond_regl_sortie=yh_fen_sortie+15;

      {frquence}
      larg_cadre_freq=18; haut_cadre_freq=3;
      x_cadre_freq=xg_fen_sortie+27; y_cadre_freq=yh_fen_sortie+3;

      x_txt_freq=x_cadre_freq+1; y_txt_freq=y_cadre_freq-1;
      txt_freq: array[langues] of STRING[9]=('Frequency',
                                             'Frquence');
      x_val_freq=x_cadre_freq+2; y_val_freq=y_cadre_freq+1; {valeur XXXXX}
      x_fl_freq=x_val_freq+9; y_fl_freq=y_val_freq;         {flches  }

      {port LPT}
      larg_cadre_LPT=11; haut_cadre_LPT=3;
      x_cadre_LPT=xg_fen_sortie+45; y_cadre_LPT=yh_fen_sortie+3;

      x_txt_LPT=x_cadre_LPT+1; y_txt_LPT=y_cadre_LPT-1;
      txt_LPT: array[langues] of STRING[8]=('LPT Port',
                                            'Port LPT');
      x_val_LPT=x_cadre_LPT+2; y_val_LPT=y_cadre_LPT+1; {valeur X}
      x_fl_LPT=x_val_LPT+2; y_fl_LPT=y_val_LPT;         {flches  }

      {DMA}
      larg_cadre_DMA=18; haut_cadre_DMA=4;
      x_cadre_DMA=xg_fen_sortie+27; y_cadre_DMA=yh_fen_sortie+7;

      x_txt_DMA=x_cadre_DMA+1; y_txt_DMA=y_cadre_DMA-1;
      txt_DMA='DMA';

      x_txt_canal_DMA=x_cadre_DMA+2; y_txt_canal_DMA=y_cadre_DMA+1;
      txt_canal_DMA: array[langues] of STRING[7]=('Channel',
                                                  'Canal');
      x_canal_DMA=x_txt_canal_DMA+7; y_canal_DMA=y_txt_canal_DMA; {Canal XX}
      x_fl_canal_DMA=x_canal_DMA+2; y_fl_canal_DMA=y_canal_DMA;   {flches  }

      x_txt_DC=x_txt_canal_DMA; y_txt_DC=y_txt_canal_DMA+1;
      txt_DC: array[langues] of STRING[10]=('Continuous', {?}
                                            'Continu');
      x_case_DC=x_txt_DC+11; y_case_DC=y_txt_DC;          {case O}

      {IRQ}
      larg_cadre_IRQ=12; haut_cadre_IRQ=3;
      x_cadre_IRQ=xg_fen_sortie+45; y_cadre_IRQ=yh_fen_sortie+7;

      x_txt_IRQ=x_cadre_IRQ+1; y_txt_IRQ=y_cadre_IRQ-1;
      txt_IRQ='IRQ';
      x_IRQ=x_cadre_IRQ+2; y_IRQ=y_cadre_IRQ+1; {valeur XX}
      x_fl_IRQ=x_IRQ+3; y_fl_IRQ=y_IRQ;         {flches  }

      {version SB}
      larg_cadre_vSB=10; haut_cadre_vSB=3;
      x_cadre_vSB=xg_fen_sortie+57; y_cadre_vSB=yh_fen_sortie+7;

      x_txt_vSB=x_cadre_vSB+1; y_txt_vSB=y_cadre_vSB-1;
      txt_vSB='Version';
      x_vSB=x_cadre_vSB+3; y_vSB=y_cadre_vSB+1; {valeur 1.x}

      {volumes gauche/droite SBPro...}
      larg_cadre_vol_SB=28; haut_cadre_vol_SB=4;
      x_cadre_vol_SB=xg_fen_sortie+27; y_cadre_vol_SB=yh_fen_sortie+12;

      x_txt_vol_SB=x_cadre_vol_SB+1; y_txt_vol_SB=y_cadre_vol_SB-1;
      txt_vol_SB='Volume';

      larg_curs_vol_SB=16; {largeur des curseurs volume}

      x_txt_vol_SB_g=x_cadre_vol_SB+2; y_txt_vol_SB_g=y_cadre_vol_SB+1;
      txt_vol_SB_g: array[langues] of STRING[6]=('Left',
                                                 'Gauche');
      x_vol_SB_g_moins=x_txt_vol_SB_g+7; y_vol_SB_g_moins=y_txt_vol_SB_g;   {  Gauche: -}
      xg_vol_SB_g_curs=x_vol_SB_g_moins+1;                                  {\                }
      xd_vol_SB_g_curs=xg_vol_SB_g_curs+larg_curs_vol_SB-1;                 { >Gauche: curseur}
      y_vol_SB_g_curs=y_vol_SB_g_moins;                                     {/                }
      x_vol_SB_g_plus=xd_vol_SB_g_curs+1; y_vol_SB_g_plus=y_vol_SB_g_moins; {  Gauche: +}

      x_txt_vol_SB_d=x_txt_vol_SB_g; y_txt_vol_SB_d=y_txt_vol_SB_g+1;
      txt_vol_SB_d: array[langues] of STRING[6]=('Right',
                                                 'Droite');
      x_vol_SB_d_moins=x_txt_vol_SB_d+7; y_vol_SB_d_moins=y_txt_vol_SB_d;   {  Droite: -}
      xg_vol_SB_d_curs=x_vol_SB_d_moins+1;                                  {\                }
      xd_vol_SB_d_curs=xg_vol_SB_d_curs+larg_curs_vol_SB-1;                 { >Droite: curseur}
      y_vol_SB_d_curs=y_vol_SB_d_moins;                                     {/                }
      x_vol_SB_d_plus=xd_vol_SB_d_curs+1; y_vol_SB_d_plus=y_vol_SB_d_moins; {  Droite: +}

      {son SBPro...}
      larg_cadre_son_SBPro=12; haut_cadre_son_SBPro=4;
      x_cadre_son_SBPro=xg_fen_sortie+55; y_cadre_son_SBPro=yh_fen_sortie+12;

      x_txt_son_SBPro=x_cadre_son_SBPro+1; y_txt_son_SBPro=y_cadre_son_SBPro-1;
      txt_son_SBPro: array[langues] of STRING[5]=('Sound',
                                                  'Son');
      x_txt_stereo=x_cadre_son_SBPro+2; y_txt_stereo=y_cadre_son_SBPro+1; {Stro}
      {txt_stereo -> MonoStereo[]}
      x_case_stereo=x_txt_stereo+7; y_case_stereo=y_txt_stereo;           {case O}

      x_txt_filtre=x_cadre_son_SBPro+2; y_txt_filtre=y_cadre_son_SBPro+2; {Filtre}
      txt_filtre: array[langues] of STRING[6]=('Filter',
                                               'Filtre');
      x_case_filtre=x_txt_filtre+7; y_case_filtre=y_txt_filtre;           {case O}

      {mixage Gravis}
      larg_cadre_mix_GUS=25; haut_cadre_mix_GUS=3;
      x_cadre_mix_GUS=xg_fen_sortie+27; y_cadre_mix_GUS=yh_fen_sortie+3;

      x_txt_mix_GUS=x_cadre_mix_GUS+1; y_txt_mix_GUS=y_cadre_mix_GUS-1;
      txt_mix_GUS: array[langues] of STRING[6]=('Mixing',
                                                'Mixage');
      x_txt_mix_GUS_mono=x_cadre_mix_GUS+2; y_txt_mix_GUS_mono=y_cadre_mix_GUS+1;
      {txt_mix_GUS_mono -> MonoStereo[]}
      larg_curs_mix_GUS=9;
      xg_mix_GUS_curs=x_txt_mix_GUS_mono+5;                {\        }
      xd_mix_GUS_curs=xg_mix_GUS_curs+larg_curs_mix_GUS-1; { >curseur}
      y_mix_GUS_curs=y_txt_mix_GUS_mono;                   {/        }
      x_txt_mix_GUS_stereo=xd_mix_GUS_curs+2; y_txt_mix_GUS_stereo=y_txt_mix_GUS_mono;
      {txt_mix_GUS_mono -> MonoStereo[]}



    {fentre configuration}
      larg_fen_config=62; haut_fen_config=22;
      xg_fen_config=x_milieu-(larg_fen_config div 2); xd_fen_config=xg_fen_config+larg_fen_config-1;
      yh_fen_config=y_milieu-(haut_fen_config div 2); yb_fen_config=yh_fen_config+haut_fen_config-1;

      {liste configurations}
      larg_cadre_configs=15; haut_cadre_configs=nbr_configs+2;
      x_cadre_configs=xg_fen_config+2; y_cadre_configs=yh_fen_config+3;

      x_txt_config=x_cadre_configs+1; y_txt_config=y_cadre_configs-1;
      txt_config='Configuration';
      x_nom_config_1=x_cadre_configs+2; y_nom_config_1=y_cadre_configs+1; {premire configuration}

      {zone fond rglages}
      xg_fond_regl_config=xg_fen_config+18; yh_fond_regl_config=yh_fen_config+2;
      xd_fond_regl_config=xg_fen_config+59; yb_fond_regl_config=yh_fen_config+15;

     {configuration INTERFACE}

      {vitesse souris}
      larg_cadre_vit_sou=19; haut_cadre_vit_sou=3;
      x_cadre_vit_sou=xg_fen_config+18; y_cadre_vit_sou=yh_fen_config+3;

      x_txt_vit_sou=x_cadre_vit_sou+1; y_txt_vit_sou=y_cadre_vit_sou-1;
      txt_vit_sou: array[langues] of STRING[14]=('Mouse speed',
                                                 'Vitesse souris');
      x_vit_sou=x_cadre_vit_sou+4; y_vit_sou=y_cadre_vit_sou+1; {valeur XXX}
      x_fl_vit_sou=x_vit_sou+4; y_fl_vit_sou=y_vit_sou;         {flches  }

      {palette}
      larg_cadre_pal=19; haut_cadre_pal=5;
      x_cadre_pal=xg_fen_config+18; y_cadre_pal=yh_fen_config+7;

      x_txt_pal=x_cadre_pal+1; y_txt_pal=y_cadre_pal-1;
      txt_pal='Palette';
      txt_pal_RVB: array[langues,1..3] of STRING[5]=
                    (('Red'  ,'Green','Blue'),
                     ('Rouge','Vert' ,'Bleu'));
      x_txt_pal_R=x_cadre_pal+2; y_txt_pal_R=y_cadre_pal+1; {Rouge}
      x_val_pal_R=x_txt_pal_R+6; y_val_pal_R=y_txt_pal_R;   {Rouge: valeur +/- XX}
      x_fl_pal_R=x_val_pal_R+4; y_fl_pal_R=y_val_pal_R;     {Rouge: flches  }
      x_txt_pal_V=x_cadre_pal+2; y_txt_pal_V=y_cadre_pal+2; {Vert}
      x_val_pal_V=x_txt_pal_V+6; y_val_pal_V=y_txt_pal_V;   {Vert: valeur +/- XX}
      x_fl_pal_V=x_val_pal_V+4; y_fl_pal_V=y_val_pal_V;     {Vert: flches  }
      x_txt_pal_B=x_cadre_pal+2; y_txt_pal_B=y_cadre_pal+3; {Bleu}
      x_val_pal_B=x_txt_pal_B+6; y_val_pal_B=y_txt_pal_B;   {Bleu: valeur +/- XX}
      x_fl_pal_B=x_val_pal_B+4; y_fl_pal_B=y_val_pal_B;     {Bleu: flches  }

      {conomiseur}
      larg_cadre_eco=19; haut_cadre_eco=3;
      x_cadre_eco=xg_fen_config+18; y_cadre_eco=yh_fen_config+13;

      x_txt_eco=x_cadre_eco+1; y_txt_eco=y_cadre_eco-1;
      txt_eco: array[langues] of STRING[12]=('Screen saver',
                                             'Economiseur');
      x_case_eco=x_cadre_eco+2; y_case_eco=y_cadre_eco+1; {case O}
      x_val_eco=x_case_eco+4; y_val_eco=y_case_eco;       {valeur X}
      x_txt_min_eco=x_val_eco+2; y_txt_min_eco=y_val_eco; {min.}
      txt_min_eco='min.';
      x_fl_eco=x_txt_min_eco+4; y_fl_eco=y_txt_min_eco;   {flches  }

     {configuration rpertoire}

      {cadre Autoscan/Autosave}
      larg_cadre_auto=14; haut_cadre_auto=4;
      x_cadre_auto=xg_fen_config+18; y_cadre_auto=yh_fen_config+3;

      x_donnees_mod=x_cadre_auto+1; y_donnees_mod=y_cadre_auto-1;
      txt_donnees_mod: array[langues] of STRING[15]=('Modules data',
                                                     'Donnes modules');

      {autoscan}
      x_txt_autoscan=x_cadre_auto+2; y_txt_autoscan=y_cadre_auto+1;
      txt_autoscan='Autoscan';
      x_case_autoscan=x_txt_autoscan+9; y_case_autoscan=y_txt_autoscan;
      {autosave}
      x_txt_autosave=x_cadre_auto+2; y_txt_autosave=y_cadre_auto+2;
      txt_Autosave='Autosave';
      x_case_autosave=x_txt_autosave+9; y_case_autosave=y_txt_autosave;

      {cadre option 4DOS}
      larg_cadre_opt_4Dos=18; haut_cadre_opt_4Dos=3;
      x_cadre_opt_4Dos=xg_fen_config+18; y_cadre_opt_4Dos=yh_fen_config+9;

      x_opt_4Dos=x_cadre_opt_4Dos+1; y_opt_4Dos=y_cadre_opt_4Dos-1;
      txt_opt_4Dos: array[langues] of STRING[12]=('4DOS options',
                                                  'Options 4DOS');
      {Descript.ion}
      x_txt_Desc=x_cadre_opt_4Dos+2; y_txt_Desc=y_cadre_opt_4Dos+1;
      txt_Desc='Descript.ion';
      x_case_Desc=x_txt_Desc+13; y_case_Desc=y_txt_Desc;

      {cadre archives}
      larg_cadre_arch=19; haut_cadre_arch=4+2;
      x_cadre_arch=xg_fen_config+40; y_cadre_arch=yh_fen_config+3;

      x_arch=x_cadre_arch+1; y_arch=y_cadre_arch-1;
      txt_arch='Archives';

      {types archives}
      x_txt_ARJ=x_cadre_arch+2; y_txt_ARJ=y_cadre_arch+1;
      {txt_ARJ -> Extensions[ext_ARJ]}
      txt_ARJ2='Arj';
      x_case_ARJ=x_txt_ARJ+14; y_case_ARJ=y_txt_ARJ;

      x_txt_LZH=x_cadre_arch+2; y_txt_LZH=y_cadre_arch+2;
      {txt_LZH -> Extensions[ext_LZH]}
      txt_LZH2='Lharc';
      x_case_LZH=x_txt_LZH+14; y_case_LZH=y_txt_LZH;

      x_txt_RAR=x_cadre_arch+2; y_txt_RAR=y_cadre_arch+3;
      {txt_RAR -> Extensions[ext_RAR]}
      txt_RAR2='Rar';
      x_case_RAR=x_txt_RAR+14; y_case_RAR=y_txt_RAR;

      x_txt_ZIP=x_cadre_arch+2; y_txt_ZIP=y_cadre_arch+4;
      {txt_ZIP -> Extensions[ext_ZIP]}
      txt_ZIP2='Pkunzip';
      x_case_ZIP=x_txt_ZIP+14; y_case_ZIP=y_txt_ZIP;


     {configuration son}

      {volume par dfaut}
      larg_cadre_vol_def=18; haut_cadre_vol_def=3;
      x_cadre_vol_def=xg_fen_config+18; y_cadre_vol_def=yh_fen_config+3;

      x_txt_vol_def=x_cadre_vol_def+1; y_txt_vol_def=y_cadre_vol_def-1;
      txt_vol_def: array[langues] of STRING[17]=('Default volume',
                                                 'Volume par dfaut');
      x_vol_def=x_cadre_vol_def+4; y_vol_def=y_cadre_vol_def+1; {valeur XXX %}
      x_fl_vol_def=x_vol_def+5; y_fl_vol_def=y_vol_def;         {flches  }

      {options module}
      larg_cadre_opt_mod=18; haut_cadre_opt_mod=6;
      x_cadre_opt_mod=xg_fen_config+18; y_cadre_opt_mod=yh_fen_config+7;

      x_txt_opt_mod=x_cadre_opt_mod+1; y_txt_opt_mod=y_cadre_opt_mod-1;
      txt_opt_mod: array[langues] of STRING[14]=('Module options',
                                                 'Options module');

      txt_opt_mod2: array[1..4] of STRING[11]=
                     ('Finetune','Panning','BPM','Octaves MOD');
      x_txt_fine=x_cadre_opt_mod+2; y_txt_fine=y_cadre_opt_mod+1; {Finetune}
      x_case_fine=x_txt_fine+9; y_case_fine=y_txt_fine;           {case O}
      x_txt_pann=x_cadre_opt_mod+2; y_txt_pann=y_cadre_opt_mod+2; {Panning}
      x_case_pann=x_txt_pann+9; y_case_pann=y_txt_pann;           {case O}
      x_txt_BPM=x_cadre_opt_mod+2; y_txt_BPM=y_cadre_opt_mod+3;   {BPM}
      x_case_BPM=x_txt_BPM+9; y_case_BPM=y_txt_BPM;               {case O}
      x_txt_oct_mod=x_cadre_opt_mod+2; y_txt_oct_mod=y_cadre_opt_mod+4;
      x_oct_mod=x_txt_oct_mod+13; y_oct_mod=y_txt_oct_mod;        {valeur octaves mod X}

      {interpolation}
      larg_cadre_interpol=18; haut_cadre_interpol=3;
      x_cadre_interpol=xg_fen_config+18; y_cadre_interpol=yh_fen_config+13;

      x_txt_interpol=x_cadre_interpol+1; y_txt_interpol=y_cadre_interpol+1;
      txt_interpol='Interpolation';
      x_case_interpol=x_txt_interpol+14; y_case_interpol=y_txt_interpol;

      {dure Introscan}
      larg_cadre_Introscan=13; haut_cadre_Introscan=3;
      x_cadre_Introscan=xg_fen_config+37; y_cadre_Introscan=yh_fen_config+3;

      x_txt_Introscan=x_cadre_Introscan+1; y_txt_Introscan=y_cadre_Introscan-1;
      txt_Introscan='Introscan';
      x_val_Introscan=x_cadre_Introscan+2; y_val_Introscan=y_cadre_Introscan+1; {valeur XX}
      x_fl_Introscan=x_val_Introscan+4; y_fl_Introscan=y_val_Introscan;         {flches  }

     {configuration Divers}

      {mmoire}
      larg_cadre_mem=17; haut_cadre_mem=3;
      x_cadre_mem=xg_fen_config+18; y_cadre_mem=yh_fen_config+3;

      x_txt_mem=x_cadre_mem+1; y_txt_mem=y_cadre_mem-1;
      txt_mem: array[langues] of STRING[7]=('Memory',
                                            'Mmoire');
      x_txt_UMB=x_cadre_mem+2; y_txt_UMB=y_cadre_mem+1;
      txt_UMB='UMB';
      x_case_UMB=x_txt_UMB+4; y_case_UMB=y_txt_UMB;
      x_txt_EMS=x_cadre_mem+10; y_txt_EMS=y_cadre_mem+1;
      txt_EMS='EMS';
      x_case_EMS=x_txt_EMS+4; y_case_EMS=y_txt_EMS;



    {fentre charge module}
      larg_fen_charge_mod=30; haut_fen_charge_mod=5;
      xg_fen_charge_mod=x_milieu-(larg_fen_charge_mod div 2); xd_fen_charge_mod=xg_fen_charge_mod+larg_fen_charge_mod-1;
      yh_fen_charge_mod=y_milieu-(haut_fen_charge_mod div 2); yb_fen_charge_mod=yh_fen_charge_mod+haut_fen_charge_mod-1;

      x_txt_charge_mod=xg_fen_charge_mod+4; y_txt_charge_mod=yh_fen_charge_mod+2;
      txt_charge_mod: array[langues] of STRING[7]=('Loading',
                                                   'Charge');


    {fentre dcompacte module}
      larg_fen_decomp_mod=35; haut_fen_decomp_mod=5;
      xg_fen_decomp_mod=x_milieu-(larg_fen_decomp_mod div 2); xd_fen_decomp_mod=xg_fen_decomp_mod+larg_fen_decomp_mod-1;
      yh_fen_decomp_mod=y_milieu-(haut_fen_decomp_mod div 2); yb_fen_decomp_mod=yh_fen_decomp_mod+haut_fen_decomp_mod-1;

      x_txt_decomp_mod=xg_fen_decomp_mod+4; y_txt_decomp_mod=yh_fen_decomp_mod+2;
      txt_decomp_mod: array[langues] of STRING[13]=('Decompressing',
                                                    'Dcompacte');


    {fentre test vitesse}
      larg_fen_test_vit=40; haut_fen_test_vit=5;
      xg_fen_test_vit=x_milieu-(larg_fen_test_vit div 2); xd_fen_test_vit=xg_fen_test_vit+larg_fen_test_vit-1;
      yh_fen_test_vit=y_milieu-(haut_fen_test_vit div 2); yb_fen_test_vit=yh_fen_test_vit+haut_fen_test_vit-1;

      x_txt_test_vit=xg_fen_test_vit+4; y_txt_test_vit=yh_fen_test_vit+2;
      txt_test_vit: array[langues] of STRING[16]=('in test',
                                                  'en cours de test');

      x_txt_pourcent=x_txt_test_vit; y_txt_pourcent=y_txt_test_vit;
      txt_pourcent: array[langues] of STRING[15]=('CPU-time',
                                                  'Pourcentage CPU');


    {fentre charge programme}
      larg_fen_charge_prog=64; haut_fen_charge_prog=22;
      xg_fen_charge_prog=x_milieu-(larg_fen_charge_prog div 2); xd_fen_charge_prog=xg_fen_charge_prog+larg_fen_charge_prog-1;
      yh_fen_charge_prog=y_milieu-(haut_fen_charge_prog div 2); yb_fen_charge_prog=yh_fen_charge_prog+haut_fen_charge_prog-1;

      {nombre de programmes lists visibles}
      haut_lst_prog=10;

      {liste programmes}
      larg_cadre_lst_prog=42; haut_cadre_lst_prog=haut_lst_prog+2;
      x_cadre_lst_prog=xg_fen_charge_prog+2; y_cadre_lst_prog=yh_fen_charge_prog+3;

      x_txt_lst_prog=x_cadre_lst_prog+1; y_txt_lst_prog=y_cadre_lst_prog-1;
      {txt_lst_prog -> txt_prog[]}

      {ascenseur}
      x_fl_h_asc_prog=x_cadre_lst_prog+larg_cadre_lst_prog-3; y_fl_h_asc_prog=y_cadre_lst_prog+1;
      x_fl_b_asc_prog=x_fl_h_asc_prog; y_fl_b_asc_prog=y_fl_h_asc_prog+haut_lst_prog-1;

      {noms fichiers}
      x_prog_1=x_cadre_lst_prog+2; y_prog_1=y_cadre_lst_prog+1; {premier programme}

      {zone liste programmes}
      xg_progs=x_cadre_lst_prog+1; yh_progs=y_cadre_lst_prog+1;
      xd_progs=x_fl_h_asc_prog-2; yb_progs=yh_progs+haut_lst_prog-1;

      {nombre de modules lists visibles}
      haut_lst_prog_mod=haut_lst_prog;

      {liste modules}
      larg_cadre_lst_prog_mod=16; haut_cadre_lst_prog_mod=haut_lst_prog_mod+2;
      x_cadre_lst_prog_mod=xg_fen_charge_prog+45; y_cadre_lst_prog_mod=y_cadre_lst_prog;

      x_txt_prem_mod=x_cadre_lst_prog_mod+1; y_txt_prem_mod=y_cadre_lst_prog_mod-1;
      txt_prem_mod: array[langues] of STRING[16]=('First modules',
                                                  'Premiers modules');
      x_prog_mod_1=x_cadre_lst_prog_mod+2; y_prog_mod_1=y_cadre_lst_prog_mod+1; {premier module}

      {message d'erreur}
      txt_PRG_invalide: array[langues] of STRING[20]=('Invalid PRG file',
                                                      'Format PRG incorrect');


    {fentre supprime programme}
      larg_fen_suppr_prog=30; haut_fen_suppr_prog=8;
      xg_fen_suppr_prog=x_milieu-(larg_fen_suppr_prog div 2); xd_fen_suppr_prog=xg_fen_suppr_prog+larg_fen_suppr_prog-1;
      yh_fen_suppr_prog=y_milieu-(haut_fen_suppr_prog div 2); yb_fen_suppr_prog=yh_fen_suppr_prog+haut_fen_suppr_prog-1;

      x_txt_suppr_prog=xg_fen_suppr_prog+4; y_txt_suppr_prog=yh_fen_suppr_prog+2;

      txt_supprime: array[langues] of STRING[9]=('Delete',
                                                 'Supprimer');


    {fentre sauve programme}
      larg_fen_sauve_prog=45; haut_fen_sauve_prog=8;
      xg_fen_sauve_prog=x_milieu-(larg_fen_sauve_prog div 2); xd_fen_sauve_prog=xg_fen_sauve_prog+larg_fen_sauve_prog-1;
      yh_fen_sauve_prog=y_milieu-(haut_fen_sauve_prog div 2); yb_fen_sauve_prog=yh_fen_sauve_prog+haut_fen_sauve_prog-1;

      {saisie titre du programme}
      larg_cadre_saisie_titre_prog=27; haut_cadre_saisie_titre_prog=3;
      x_cadre_saisie_titre_prog=xg_fen_sauve_prog+2; y_cadre_saisie_titre_prog=yh_fen_sauve_prog+3;

      x_txt_titre_prog=x_cadre_saisie_titre_prog+1; y_txt_titre_prog=y_cadre_saisie_titre_prog-1;
      txt_titre_prog: array[langues] of STRING[18]=('Play-list title',
                                                    'Titre du programme');
      x_saisie_titre_prog=x_cadre_saisie_titre_prog+1; y_saisie_titre_prog=y_cadre_saisie_titre_prog+1;

      {saisie nom du fichier programme}
      larg_cadre_saisie_nom_prog=13; haut_cadre_saisie_nom_prog=3;
      x_cadre_saisie_nom_prog=xg_fen_sauve_prog+30; y_cadre_saisie_nom_prog=yh_fen_sauve_prog+3;

      x_txt_nom_prog=x_cadre_saisie_nom_prog+1; y_txt_nom_prog=y_cadre_saisie_nom_prog-1;
      txt_nom_prog: array[langues] of STRING[11]=('File name',
                                                  'Nom fichier');
      x_saisie_nom_prog=x_cadre_saisie_nom_prog+1; y_saisie_nom_prog=y_cadre_saisie_nom_prog+1;



    {fentre analyse archives}
      larg_fen_info_arch=40; haut_fen_info_arch=5;
      xg_fen_info_arch=x_milieu-(larg_fen_info_arch div 2); xd_fen_info_arch=xg_fen_info_arch+larg_fen_info_arch-1;
      yh_fen_info_arch=y_milieu-(haut_fen_info_arch div 2); yb_fen_info_arch=yh_fen_info_arch+haut_fen_info_arch-1;

      x_txt_info_arch=xg_fen_info_arch+4; y_txt_info_arch=yh_fen_info_arch+2;
      txt_info_arch: array[langues] of STRING[17]=('Scanning archive',
                                                   'Analyse l''archive');


    {fentre analyse modules}
      larg_fen_analyse_mod=30; haut_fen_analyse_mod=5;
      xg_fen_analyse_mod=x_milieu-(larg_fen_analyse_mod div 2); xd_fen_analyse_mod=xg_fen_analyse_mod+larg_fen_analyse_mod-1;
      yh_fen_analyse_mod=y_milieu-(haut_fen_analyse_mod div 2); yb_fen_analyse_mod=yh_fen_analyse_mod+haut_fen_analyse_mod-1;

      x_txt_analyse_mod=xg_fen_analyse_mod+4; y_txt_analyse_mod=yh_fen_analyse_mod+2;
      txt_analyse_mod: array[langues] of STRING[19]=('Scanning modules',
                                                     'Analyse des modules');


    {fentre supprime module}
      larg_fen_suppr_mod=30; haut_fen_suppr_mod=8;
      xg_fen_suppr_mod=x_milieu-(larg_fen_suppr_mod div 2); xd_fen_suppr_mod=xg_fen_suppr_mod+larg_fen_suppr_mod-1;
      yh_fen_suppr_mod=y_milieu-(haut_fen_suppr_mod div 2); yb_fen_suppr_mod=yh_fen_suppr_mod+haut_fen_suppr_mod-1;

      x_txt_suppr_mod=xg_fen_suppr_mod+4; y_txt_suppr_mod=yh_fen_suppr_mod+2;
      {txt_suppr_mod -> txt_suppr}


    {fentre aide}
      larg_fen_aide=67; haut_fen_aide=35;
      xg_fen_aide=x_milieu-(larg_fen_aide div 2); xd_fen_aide=xg_fen_aide+larg_fen_aide-1;
      yh_fen_aide=y_milieu-(haut_fen_aide div 2); yb_fen_aide=yh_fen_aide+haut_fen_aide-1;

      {logo Mod Master}
      x_logo_aide=xg_fen_aide+2; y_logo_aide=yh_fen_aide+2;

      {nombre de lignes d'aide visibles}
      haut_lst_aide=23;

      {liste aide}
      larg_cadre_lst_aide=larg_fen_aide-4; haut_cadre_lst_aide=haut_lst_aide+2;
      x_cadre_lst_aide=xg_fen_aide+2; y_cadre_lst_aide=yh_fen_aide+7;

      {lignes d'aide}
      x_aide_1=x_cadre_lst_aide+1; y_aide_1=y_cadre_lst_aide+1; {premire ligne}


    {fentre quitter Mod Master}
      larg_fen_quitter=28; haut_fen_quitter=8;
      xg_fen_quitter=x_milieu-(larg_fen_quitter div 2); xd_fen_quitter=xg_fen_quitter+larg_fen_quitter-1;
      yh_fen_quitter=y_milieu-(haut_fen_quitter div 2); yb_fen_quitter=yh_fen_quitter+haut_fen_quitter-1;

      x_txt_quitter=xg_fen_quitter+4; y_txt_quitter=yh_fen_quitter+2;
      txt_quitter: array[langues] of STRING[7]=('exit',
                                                'Quitter');


    {**** FENETRES AFFICHEES PENDANT LA MUSIQUE ****}

    {fentre contrle musique (partie suprieure de l'cran...)}
      larg_fen_contr_mus=80; haut_fen_contr_mus=14;
      xg_fen_contr_mus=1; yh_fen_contr_mus=2;
      xd_fen_contr_mus=xg_fen_contr_mus+larg_fen_contr_mus-1; yb_fen_contr_mus=yh_fen_contr_mus+haut_fen_contr_mus-1;

      {module: nom, taille, volume, titre}
      x_txt_module=xg_fen_contr_mus+2; y_txt_module=yh_fen_contr_mus+2;
      txt_module='Module';
      x_nom_module=x_txt_module+8; y_nom_module=y_txt_module;
      x_taille_module=x_nom_module+14; y_taille_module=y_txt_module;
      x_vol_module=x_taille_module+7; y_vol_module=y_txt_module;
      x_titre_module=x_txt_module; y_titre_module=y_txt_module+1;

      {type module, nombre de voies et nombre d'instruments}
      x_txt_type=x_txt_module; y_txt_type=y_txt_module+3;
      txt_type='Type';
      x_type_module=x_txt_type+6; y_type_module=y_txt_type;
      x_voies_instr=x_txt_type; y_voies_instr=y_txt_type+1;
      txt_voies: array[langues] of STRING[8]=('channels',
                                              'voies');
      txt_instr: array[langues] of STRING[11]=('sample',
                                               'instrument');
      {mmoire libre: DOS,EMS,GUS}
      x_txt_mem_libre=x_txt_module; y_txt_mem_libre=y_txt_type+3;
      txt_mem_libre: array[langues] of STRING[9]=('Free mem.',
                                                  'Mm.libre');
      x_txt_mem_DOS=x_txt_mem_libre; y_txt_mem_DOS=y_txt_mem_libre+1;
      x_txt_mem_EMS=x_txt_mem_libre; y_txt_mem_EMS=y_txt_mem_libre+2;
      x_txt_mem_GUS=x_txt_mem_libre; y_txt_mem_GUS=y_txt_mem_libre+3;

      {programme: nom, LED, titre, nmodule, longueur, avancement (curseur et %)}
      x_txt_programme=x_txt_mem_libre+11; y_txt_programme=y_txt_mem_libre;
      {txt_programme -> txt_prog}
      x_nom_programme=x_txt_programme+11; y_nom_programme=y_txt_programme;
      x_LED_programme=x_nom_programme+10; y_LED_programme=y_nom_programme; {LED programme actif non/oui, modifi non/oui}
      x_titre_programme=x_txt_programme; y_titre_programme=y_nom_programme+1;
      x_numero_module=x_LED_programme-6; y_numero_module=y_titre_programme+1; {xxx/xxx}

      larg_curs_avanc_prog=16;
      xg_avanc_prog_curs=x_txt_programme;                           {\        }
      xd_avanc_prog_curs=xg_avanc_prog_curs+larg_curs_avanc_prog-1; { >curseur}
      y_avanc_prog_curs=y_numero_module+1;                          {/        }

      x_avanc_prog=xd_avanc_prog_curs+3; y_avanc_prog=y_avanc_prog_curs; {xxx%}

      {position,pattern,note,tempo,BPM,volume global}
      x_txt_position=xg_fen_contr_mus+36; y_txt_position=yh_fen_contr_mus+2;
      txt_position='Position';
      x_position=x_txt_position+9; y_position=y_txt_position; {xxx/xxx}

      x_txt_pattern=x_txt_position+1; y_txt_pattern=y_txt_position+1;
      txt_pattern='Pattern';
      x_pattern=x_txt_pattern+8; y_pattern=y_txt_pattern; {xxx/xxx}

      x_txt_note=x_txt_pattern+3; y_txt_note=y_txt_position+2;
      txt_note='Note';
      x_note=x_txt_note+5; y_note=y_txt_note; { xx/ xx}

      x_txt_tempo=x_txt_position+21; y_txt_tempo=y_txt_position;
      txt_tempo='Tempo';
      x_tempo=x_txt_tempo+6; y_tempo=y_txt_tempo; {xx}

      x_txt_BPM2=x_txt_pattern+22; y_txt_BPM2=y_txt_pattern;
      txt_BPM='BPM';
      x_BPM=x_txt_BPM2+4; y_BPM=y_txt_BPM2; {xxx}

      x_txt_gvol=x_txt_note+14; y_txt_gvol=y_txt_note;
      txt_gvol='Glob.vol';
      x_gvol=x_txt_gvol+9; y_gvol=y_txt_gvol; {xx}

      {barre curseur volume}
      x_txt_volume=x_txt_gvol+4; y_txt_volume=y_txt_gvol+2;
      txt_volume='-^Volume^+';
      larg_curs_volume=8;
      xg_curs_volume=x_txt_volume;                      {\        }
      xd_curs_volume=xg_curs_volume+larg_curs_volume-1; { >curseur}
      y_curs_volume=y_txt_volume+1;                     {/        }

      {fentre afficheurs chrono et symboles}
      larg_fen_afficheurs=20; haut_fen_afficheurs=3;
      xg_fen_afficheurs=x_txt_volume; yh_fen_afficheurs=y_curs_volume+2;
      xd_fen_afficheurs=xg_fen_afficheurs+larg_fen_afficheurs-1; yb_fen_afficheurs=yh_fen_afficheurs+haut_fen_afficheurs-1;

      x_avanc_module=xg_fen_afficheurs+1; y_avanc_module=yh_fen_afficheurs; {xxx%}
      x_chrono=x_avanc_module+7; y_chrono=y_avanc_module; {xx:xx/xx:xx}

      x_symb_play     =x_avanc_module    ; y_symb_play     =y_avanc_module+2;
      car_symb_play   =#16;   coul_symb_play     : array[BOOLEAN] of BYTE=(16*noir+gris_fonce,16*noir+jaune );
      x_symb_pause    =x_symb_play+2     ; y_symb_pause    =y_symb_play;
      car_symb_pause  = #1;   coul_symb_pause    : array[BOOLEAN] of BYTE=(16*noir+gris_fonce,16*noir+orange);
      x_symb_repeat   =x_symb_pause+2    ; y_symb_repeat   =y_symb_play;
      car_symb_repeat =#12;   coul_symb_repeat   : array[BOOLEAN] of BYTE=(16*noir+gris_fonce,16*noir+rouge );
      x_symb_jump     =x_symb_repeat+2   ; y_symb_jump     =y_symb_play;
      car_symb_jump   =#24;   coul_symb_jump     : array[BOOLEAN] of BYTE=(16*noir+gris_fonce,16*noir+vert  );
      x_symb_interpol =x_symb_jump+2     ; y_symb_interpol =y_symb_play;
      ch_symb_interpol: array[BOOLEAN] of STRING[2]=(#244#245,#242#243); coul_symb_interpol=16*noir+cyan;
      x_symb_introscan=x_symb_interpol+3 ; y_symb_introscan=y_symb_play;
      car_symb_introscan= #9; coul_symb_introscan: array[BOOLEAN] of BYTE=(16*noir+gris_fonce,16*noir+jaune+128);
      x_symb_shuffle  =x_symb_introscan+2; y_symb_shuffle  =y_symb_play;
      car_symb_shuffle=#10;   coul_symb_shuffle  : array[BOOLEAN] of BYTE=(16*noir+gris_fonce,16*noir+jaune );
      x_symb_fadeout  =x_symb_shuffle+2  ; y_symb_fadeout  =y_symb_play;
      car_symb_fadeout= #8;   coul_symb_fadeout  : array[BOOLEAN] of BYTE=(16*noir+gris_fonce,16*noir+rouge );
      x_symb_mute     =x_symb_fadeout+2  ; y_symb_mute  =y_symb_play;
      car_symb_mute   =#11;   coul_symb_mute     : array[BOOLEAN] of BYTE=(16*noir+gris_fonce,16*noir+rouge );

      {fentre fonctions}
      larg_fen_fonctions=11; haut_fen_fonctions=6;
      xg_fen_fonctions=x_tempo+4; yh_fen_fonctions=y_tempo;
      xd_fen_fonctions=xg_fen_fonctions+larg_fen_fonctions-1; yb_fen_fonctions=yh_fen_fonctions+haut_fen_fonctions-1;

      x_txt_pause     =xg_fen_fonctions+1; y_txt_pause     =yh_fen_fonctions; txt_pause     ='Pause';
      x_txt_repeat    =x_txt_pause       ; y_txt_repeat    =y_txt_pause+1;    txt_repeat    ='Repeat';
      x_txt_jump      =x_txt_pause       ; y_txt_jump      =y_txt_pause+2;    txt_jump      ='Jump';
      x_txt_interpol2 =x_txt_pause       ; y_txt_interpol2 =y_txt_pause+3;    txt_interpol2 ='Interpol8';
      x_txt_introscan2=x_txt_pause       ; y_txt_introscan2=y_txt_pause+4;    txt_introscan2='Introscan';
      x_txt_shuffle   =x_txt_introscan2  ; y_txt_shuffle   =y_txt_introscan2; txt_shuffle   ='Shuffle';
      x_txt_fadeout   =x_txt_pause       ; y_txt_fadeout   =y_txt_pause+5;    txt_fadeout   ='Fade';
      x_txt_mute      =x_txt_fadeout+5   ; y_txt_mute      =y_txt_fadeout;    txt_mute      ='Mute';

      coul_fonc  : array[BOOLEAN] of BYTE=(16*or_moyen+or_fond,16*or_moyen+blanc);
      coul_fonc_c: array[BOOLEAN] of BYTE=(16*or_moyen+or_fond,16*or_moyen+blanc+128); {clignotant}

      {oscillos}

      { Ŀ
           _     
          / \    
        _/   \   
              \_/
                 
         }

      {table des caractres libres}
      table_car: array[1..95+8] of CHAR=
      '`{|}~';
      {                                                caractres "de secours" (rarement utiliss) ->  }
      nombre_car_limite=sizeof(table_car);

      {dimensions de l'oscillo en caractres}
      hauteur_osc_car=6;
      largeur_osc_car_stereo=9;
      largeur_osc_car_mono=largeur_osc_car_stereo*2;
      largeur_osc_car=largeur_osc_car_mono;

      {dimensions de l'oscillo en pixels}
      hauteur_osc=8*hauteur_osc_car;
      largeur_osc_stereo=8*largeur_osc_car_stereo;
      largeur_osc_mono  =8*largeur_osc_car_mono;
      largeur_osc       =largeur_osc_mono;

      {coordonnes oscillo gauche (stro)}
      x_oscillo_g=x_txt_position; y_oscillo_g=y_txt_note+2;
      x_HP_oscillo_g=x_oscillo_g+largeur_osc_car_stereo; y_HP_oscillo_g=y_oscillo_g;

      {coordonnes oscillo droite (stro)}
      x_oscillo_d=x_oscillo_g+largeur_osc_car_stereo+2; y_oscillo_d=y_oscillo_g;
      x_HP_oscillo_d=x_oscillo_d+largeur_osc_car_stereo; y_HP_oscillo_d=y_oscillo_d;

      {coordonnes oscillo (mono)}
      x_oscillo=x_oscillo_g+2; y_oscillo=y_oscillo_g;

      {facteurs de zoom min/max et pas pour l'affichage de l'onde du sample}
      zoom_smp_min=0; {x1}
      zoom_smp_max=6; {x64}
      pas_scroll_smp=8;


    {fentre infos musique (partie infrieure de l'cran...)}
      larg_fen_infos_mus=80; haut_fen_infos_mus=34;
      xg_fen_infos_mus=1; yh_fen_infos_mus=yb_fen_contr_mus+1;
      xd_fen_infos_mus=xg_fen_infos_mus+larg_fen_infos_mus-1; yb_fen_infos_mus=yh_fen_infos_mus+haut_fen_infos_mus-1;

      {couleurs de fond d'une ligne/criture d'un numro (normal/inverse)}
      couleur_fond: array[type_coul] of BYTE=(or_fond,or_moyen);
      couleur_curs: array[type_coul] of BYTE=(gris_fonce,blanc);

      {page d'aide}

      {touches gnrales}
      haut_cadre_aide_gene=23;
      xg_cadre_aide_gene=xg_fen_infos_mus+1; yh_cadre_aide_gene=yh_fen_infos_mus+1;
      xd_cadre_aide_gene=xd_fen_infos_mus-1; yb_cadre_aide_gene=yh_cadre_aide_gene+haut_cadre_aide_gene-1;
      txt_aide_gene: array[langues] of STRING[17]=('General keys',
                                                   'Touches gnrales');
      {touches locales}
      haut_cadre_aide_loc=9;
      xg_cadre_aide_loc=xg_fen_infos_mus+1; yh_cadre_aide_loc=yb_cadre_aide_gene+1;
      xd_cadre_aide_loc=xd_fen_infos_mus-1; yb_cadre_aide_loc=yh_cadre_aide_loc+haut_cadre_aide_loc-1;
      txt_aide_loc: array[langues] of STRING[15]=('Local keys',
                                                  'Touches locales');

      {liste des instruments}
      txt_long: array[langues] of STRING[5]=('lengt',
                                             'long.');
      {modes d'affichage des oscillos: son (canal de sortie) ou instrument}
      oscillo_son=0; oscillo_instr=1;

      {liste des voies}

      {types d'affichage des barres}
      barres_pitch_mono  =1;
      barres_pitch_stereo=2;
      barres_periode     =3;


      {caractres haut-parleurs}
      car_HP_g=#29; car_HP_d=#28;
      car_HP: array[BOOLEAN] of CHAR=(car_HP_g,car_HP_d);

      {partition}

      {claviers}
      car_barre_g=#183; car_barre_d=#184; {barres verticales gauche/droite}

      {  _____________
               
               
               
        ;
        DoRMiFaSoLaSi  }

      car_clav_b_hg=car_barre_g; car_clav_b_hd=car_barre_d; {bords haut gauche/droit touche blanche}
      car_clav_b_bg=#181       ; car_clav_b_bd=#182       ; {bords bas  gauche/droit touche blanche}

      car_clav_n_hg='' ; car_clav_n_hd='' ; {bords haut gauche/droit touche noire}
      car_clav_n_bg=#185; car_clav_n_bd=#186; {bords bas  gauche/droit touche noire}

      coul_clav_b: array[BOOLEAN] of BYTE=(gris,bleu);  {couleurs touche blanche relche/enfonce}
      coul_clav_n: array[BOOLEAN] of BYTE=(noir,rouge); {couleurs touche noire   relche/enfonce}

      {spectre}

      car_barre_spectre=#19;

      {   
               
                
             
           }

      {modes mono/stro}
      spectre_mono  =0;
      spectre_stereo=1;

      {amplifications min/max avant FFT}
      ampl_spect_min=4;
      ampl_spect_max=16;

      {valeur relle maximale d'une harmonique aprs FFT}
      valeur_max=64;

      {dimensions des barres de spectre}
      hauteur_spectre_stereo=14;
      hauteur_spectre_mono  =29;
      largeur_spectre       =74;

      {coordonnes spectre gauche (stro)}
      xg_spectre_g=xg_fen_infos_mus+3; yh_spectre_g=yh_fen_infos_mus+2;
      xd_spectre_g=xg_spectre_g+largeur_spectre-1; yb_spectre_g=yh_spectre_g+hauteur_spectre_stereo-1;
      x_HP_spectre_g=xg_spectre_g-2; y_HP_spectre_g=yh_spectre_g;

      {coordonnes spectre droite (stro)}
      xg_spectre_d=xg_spectre_g; yh_spectre_d=yb_spectre_g+2;
      xd_spectre_d=xg_spectre_d+largeur_spectre-1; yb_spectre_d=yh_spectre_d+hauteur_spectre_stereo-1;
      x_HP_spectre_d=xg_spectre_d-2; y_HP_spectre_d=yh_spectre_d;

      {coordonnes spectre (mono)}
      xg_spectre=xg_spectre_g; yh_spectre=yh_spectre_g;
      xd_spectre=xg_spectre+largeur_spectre-1; yb_spectre=yh_spectre+hauteur_spectre_mono-1;

      {caractres graduations horizontales/verticales}
      car_grad_h: array[BOOLEAN] of CHAR=('.','');
      car_grad_v: array[BOOLEAN] of CHAR=('.','');


  {-----divers--------------------------------------------------}

      {palette texte 16 couleurs}
      palette_ModM: Palette16=(palette:(
             (R: 0; V: 0; B: 0), { 0 = noir       }
             (R:28; V:42; B:56), { 1 = bleu       }
             (R:46; V:62; B: 0), { 2 = vert_jaune }
             (R:20; V:20; B:14), { 3 = or_sombre  }
             (R:32; V:32; B:20), { 4 = or_fond    }
             (R:36; V:36; B:22), { 5 = or_moyen   }
             (R:44; V:44; B:26), { 6 = or_clair   }
             (R:42; V:48; B:50), { 7 = gris       }
             (R:16; V:16; B:18), { 8 = gris_fonce }
             (R:24; V:62; B:46), { 9 = vert_pastel}
             (R:14; V:56; B:18), {10 = vert       }
             (R:10; V:54; B:56), {11 = cyan       }
             (R:60; V:16; B:16), {12 = rouge      }
             (R:62; V:44; B: 4), {13 = orange     }
             (R:58; V:58; B:16), {14 = jaune      }
             (R:58; V:58; B:58)  {15 = blanc      }
            ));

      {palette originale des 4 couleurs or}
      palette_origine: array[or_sombre..or_clair] of RVB=(
             (R:20; V:20; B:14), { 3 = or_sombre}
             (R:32; V:32; B:20), { 4 = or_fond  }
             (R:36; V:36; B:22), { 5 = or_moyen }
             (R:44; V:44; B:26)  { 6 = or_clair }
            );

      {fonte texte 8x8}
      fonte_ModM: Fonte8=(fonte:(
             ($00,$00,$00,$00,$00,$00,$00,$00),  {#0}
             ($00,$EE,$EE,$EE,$EE,$EE,$EE,$00),  {#1}
             ($00,$00,$38,$7C,$7C,$38,$00,$00),  {#2}
             ($F0,$E0,$C0,$80,$00,$00,$00,$00),  {#3}
             ($0F,$07,$03,$01,$00,$00,$00,$00),  {#4}
             ($00,$00,$00,$00,$80,$C0,$E0,$F0),  {#5}
             ($00,$00,$00,$00,$01,$03,$07,$0F),  {#6}
             ($00,$00,$00,$FF,$FF,$00,$00,$00),  {#7}
             ($FF,$00,$FF,$00,$FF,$7E,$3C,$18),  {#8}
             ($A8,$AC,$AE,$AF,$AE,$AC,$A8,$00),  {#9}
             ($00,$7E,$81,$BD,$81,$7E,$00,$00),  {#10}
             ($00,$3C,$42,$42,$81,$81,$00,$00),  {#11}
             ($3C,$02,$01,$21,$62,$FC,$60,$20),  {#12}
             ($1F,$33,$3E,$30,$30,$70,$F0,$E0),  {#13}
             ($3F,$63,$7F,$63,$63,$67,$E6,$C0),  {#14}
             ($3C,$40,$80,$84,$46,$3F,$06,$04),  {#15}
             ($80,$E0,$F8,$FE,$F8,$E0,$80,$00),  {#16}
             ($02,$0E,$3E,$FE,$3E,$0E,$02,$00),  {#17}
             ($18,$3C,$7E,$18,$18,$7E,$3C,$18),  {#18}
             ($FE,$00,$FE,$00,$FE,$00,$FE,$00),  {#19}
             ($3C,$42,$81,$81,$81,$42,$3C,$00),  {#20}
             ($3C,$42,$BD,$BD,$BD,$42,$3C,$00),  {#21}
             ($3C,$7E,$E7,$C3,$E7,$7E,$3C,$00),  {#22}
             ($3C,$42,$99,$A1,$99,$42,$3C,$00),  {#23}
             ($18,$3C,$7E,$18,$18,$18,$18,$00),  {#24}
             ($18,$18,$18,$18,$7E,$3C,$18,$00),  {#25}
             ($00,$0C,$0E,$FF,$0E,$0C,$00,$00),  {#26}
             ($00,$30,$70,$FF,$70,$30,$00,$00),  {#27}
             ($06,$0A,$72,$72,$72,$72,$0A,$06),  {#28}
             ($60,$50,$4E,$4E,$4E,$4E,$50,$60),  {#29}
             ($10,$10,$38,$38,$7C,$7C,$FE,$00),  {#30}
             ($FE,$7C,$7C,$38,$38,$10,$10,$00),  {#31}
             ($00,$00,$00,$00,$00,$00,$00,$00),  { }
             ($30,$30,$30,$30,$30,$00,$30,$00),  {!}
             ($6C,$24,$48,$00,$00,$00,$00,$00),  {"}
             ($12,$12,$7F,$24,$FE,$48,$48,$00),  {#}
             ($28,$7E,$A8,$7C,$2A,$FC,$28,$00),  { $}
             ($00,$66,$AC,$D8,$36,$6A,$CC,$00),  {%}
             ($38,$6C,$38,$72,$DC,$CC,$76,$00),  {&}
             ($60,$20,$40,$00,$00,$00,$00,$00),  {'}
             ($18,$30,$60,$60,$60,$30,$18,$00),  {(}
             ($60,$30,$18,$18,$18,$30,$60,$00),  {)}
             ($00,$66,$3C,$FF,$3C,$66,$00,$00),  {*}
             ($00,$18,$18,$7E,$18,$18,$00,$00),  {+}
             ($00,$00,$00,$00,$00,$30,$10,$20),  {,}
             ($00,$00,$00,$7E,$00,$00,$00,$00),  {-}
             ($00,$00,$00,$00,$00,$30,$30,$00),  {.}
             ($06,$0C,$18,$30,$60,$C0,$80,$00),  {/}
             ($7C,$C6,$CE,$D6,$E6,$C6,$7C,$00),  {0}
             ($18,$38,$18,$18,$18,$18,$18,$00),  {1}
             ($FC,$06,$06,$7C,$C0,$C0,$FE,$00),  {2}
             ($FC,$06,$06,$7C,$06,$06,$FC,$00),  {3}
             ($0E,$1E,$36,$66,$FF,$06,$06,$00),  {4}
             ($FE,$C0,$C0,$FC,$06,$06,$FC,$00),  {5}
             ($7C,$C0,$C0,$FC,$C6,$C6,$7C,$00),  {6}
             ($FE,$06,$0C,$18,$30,$30,$30,$00),  {7}
             ($7C,$C6,$C6,$7C,$C6,$C6,$7C,$00),  {8}
             ($7C,$C6,$C6,$7E,$06,$06,$7C,$00),  {9}
             ($00,$30,$30,$00,$30,$30,$00,$00),  {:}
             ($00,$00,$30,$30,$00,$30,$10,$20),  {;}
             ($18,$30,$60,$C0,$60,$30,$18,$00),  {<}
             ($00,$00,$FC,$00,$00,$FC,$00,$00),  {=}
             ($60,$30,$18,$0C,$18,$30,$60,$00),  {>}
             ($7C,$C6,$06,$0C,$18,$00,$18,$00),  {?}
             ($7C,$C6,$9E,$B6,$9E,$C0,$78,$00),  {@}
             ($7C,$C6,$C6,$FE,$C6,$C6,$C6,$00),  {A}
             ($FC,$C6,$C6,$FC,$C6,$C6,$FC,$00),  {B}
             ($7E,$C0,$C0,$C0,$C0,$C0,$7E,$00),  {C}
             ($FC,$C6,$C6,$C6,$C6,$C6,$FC,$00),  {D}
             ($FE,$C0,$C0,$FC,$C0,$C0,$FE,$00),  {E}
             ($FE,$C0,$C0,$FC,$C0,$C0,$C0,$00),  {F}
             ($7E,$C0,$C0,$CE,$C6,$C6,$7E,$00),  {G}
             ($C6,$C6,$C6,$FE,$C6,$C6,$C6,$00),  {H}
             ($18,$18,$18,$18,$18,$18,$18,$00),  {I}
             ($06,$06,$06,$06,$06,$C6,$7C,$00),  {J}
             ($C6,$CC,$D8,$F0,$D8,$CC,$C6,$00),  {K}
             ($C0,$C0,$C0,$C0,$C0,$C0,$FE,$00),  {L}
             ($C6,$EE,$FE,$D6,$D6,$C6,$C6,$00),  {M}
             ($C6,$E6,$F6,$DE,$CE,$C6,$C6,$00),  {N}
             ($7C,$C6,$C6,$C6,$C6,$C6,$7C,$00),  {O}
             ($FC,$C6,$C6,$FC,$C0,$C0,$C0,$00),  {P}
             ($7C,$C6,$C6,$C6,$D6,$DE,$7C,$06),  {Q}
             ($FC,$C6,$C6,$FC,$D8,$CC,$C6,$00),  {R}
             ($7E,$C0,$C0,$7C,$06,$06,$FC,$00),  {S}
             ($FF,$18,$18,$18,$18,$18,$18,$00),  {T}
             ($C6,$C6,$C6,$C6,$C6,$C6,$7C,$00),  {U}
             ($C6,$C6,$C6,$C6,$6C,$38,$10,$00),  {V}
             ($C6,$C6,$D6,$D6,$FE,$EE,$44,$00),  {W}
             ($C6,$C6,$6C,$38,$6C,$C6,$C6,$00),  {X}
             ($C3,$C3,$66,$3C,$18,$18,$18,$00),  {Y}
             ($FE,$06,$0C,$18,$30,$60,$FE,$00),  {Z}
             ($78,$60,$60,$60,$60,$60,$78,$00),  {[}
             ($C0,$60,$30,$18,$0C,$06,$02,$00),  {\}
             ($78,$18,$18,$18,$18,$18,$78,$00),  {]}
             ($10,$38,$6C,$C6,$00,$00,$00,$00),  {^}
             ($00,$00,$00,$00,$00,$00,$00,$FF),  {_}
             ($30,$30,$18,$00,$00,$00,$00,$00),  {`}
             ($00,$00,$7C,$06,$7E,$C6,$7E,$00),  {a}
             ($C0,$C0,$FC,$C6,$C6,$C6,$FC,$00),  {b}
             ($00,$00,$7E,$C0,$C0,$C0,$7E,$00),  {c}
             ($06,$06,$7E,$C6,$C6,$C6,$7E,$00),  {d}
             ($00,$00,$7C,$C6,$FE,$C0,$7E,$00),  {e}
             ($1E,$30,$30,$7C,$30,$30,$30,$00),  {f}
             ($00,$00,$7E,$C6,$C6,$7E,$06,$7C),  {g}
             ($C0,$C0,$FC,$C6,$C6,$C6,$C6,$00),  {h}
             ($18,$00,$18,$18,$18,$18,$18,$00),  {i}
             ($06,$00,$06,$06,$06,$06,$C6,$7C),  {j}
             ($C0,$C0,$C6,$CC,$F8,$CC,$C6,$00),  {k}
             ($18,$18,$18,$18,$18,$18,$0C,$00),  {l}
             ($00,$00,$FC,$D6,$D6,$D6,$D6,$00),  {m}
             ($00,$00,$FC,$C6,$C6,$C6,$C6,$00),  {n}
             ($00,$00,$7C,$C6,$C6,$C6,$7C,$00),  {o}
             ($00,$00,$FC,$C6,$C6,$FC,$C0,$C0),  {p}
             ($00,$00,$7E,$C6,$C6,$7E,$06,$06),  {q}
             ($00,$00,$FC,$C6,$C0,$C0,$C0,$00),  {r}
             ($00,$00,$7E,$C0,$7C,$06,$FC,$00),  {s}
             ($10,$30,$7C,$30,$30,$30,$1C,$00),  {t}
             ($00,$00,$C6,$C6,$C6,$C6,$7E,$00),  {u}
             ($00,$00,$C6,$C6,$6C,$38,$10,$00),  {v}
             ($00,$00,$D6,$D6,$FE,$6C,$44,$00),  {w}
             ($00,$00,$C6,$6C,$38,$6C,$C6,$00),  {x}
             ($00,$00,$C6,$C6,$C6,$7E,$06,$7C),  {y}
             ($00,$00,$FE,$18,$30,$60,$FE,$00),  {z}
             ($1C,$30,$30,$60,$30,$30,$1C,$00),  {{}
             ($18,$18,$18,$00,$18,$18,$18,$00),  {|}
             ($70,$18,$18,$0C,$18,$18,$70,$00),  {}
             ($76,$DC,$00,$00,$00,$00,$00,$00),  {~}
             ($00,$10,$38,$6C,$6C,$C6,$FE,$00),  {}
             ($7E,$C0,$C0,$C0,$C0,$C0,$7E,$18),  {}
             ($6C,$00,$C6,$C6,$C6,$C6,$7E,$00),  {}
             ($18,$30,$7C,$C6,$FE,$C0,$7E,$00),  {}
             ($18,$66,$7C,$06,$7E,$C6,$7E,$00),  {}
             ($6C,$00,$7C,$06,$7E,$C6,$7E,$00),  {}
             ($30,$18,$7C,$06,$7E,$C6,$7E,$00),  {}
             ($38,$38,$7C,$06,$7E,$C6,$7E,$00),  {}
             ($00,$00,$7E,$C0,$C0,$C0,$7E,$18),  {}
             ($38,$6C,$7C,$C6,$FE,$C0,$7E,$00),  {}
             ($6C,$00,$7C,$C6,$FE,$C0,$7E,$00),  {}
             ($30,$18,$7C,$C6,$FE,$C0,$7E,$00),  {}
             ($36,$00,$18,$18,$18,$18,$18,$00),  {}
             ($3C,$66,$18,$18,$18,$18,$18,$00),  {}
             ($30,$0C,$18,$18,$18,$18,$18,$00),  {}
             ($6C,$00,$7C,$C6,$FE,$C6,$C6,$00),  {}
             ($38,$38,$7C,$C6,$FE,$C6,$C6,$00),  {}
             ($18,$30,$FE,$C0,$FC,$C0,$FE,$00),  {}
             ($00,$00,$7E,$1B,$7E,$D8,$7F,$00),  {}
             ($7E,$D8,$D8,$FE,$D8,$D8,$DE,$00),  {}
             ($38,$6C,$7C,$C6,$C6,$C6,$7C,$00),  {}
             ($6C,$00,$7C,$C6,$C6,$C6,$7C,$00),  {}
             ($30,$18,$7C,$C6,$C6,$C6,$7C,$00),  {}
             ($38,$6C,$C6,$C6,$C6,$C6,$7E,$00),  {}
             ($30,$18,$C6,$C6,$C6,$C6,$7E,$00),  {}
             ($6C,$00,$C6,$C6,$C6,$7E,$06,$7C),  {}
             ($6C,$00,$7C,$C6,$C6,$C6,$7C,$00),  {}
             ($6C,$00,$C6,$C6,$C6,$C6,$7C,$00),  {}
             ($01,$03,$07,$0F,$1F,$3F,$7F,$FF),  {}
             ($80,$C0,$E0,$F0,$F8,$FC,$FE,$FF),  {}
             ($FF,$7F,$3F,$1F,$0F,$07,$03,$01),  {}
             ($FF,$FE,$FC,$F8,$F0,$E0,$C0,$80),  {}
             ($0E,$1B,$18,$3C,$18,$18,$D8,$70),  {}
             ($18,$30,$7C,$06,$7E,$C6,$7E,$00),  {}
             ($18,$30,$18,$18,$18,$18,$18,$00),  {}
             ($18,$30,$7C,$C6,$C6,$C6,$7C,$00),  {}
             ($18,$30,$C6,$C6,$C6,$C6,$7E,$00),  {}
             ($7C,$00,$FC,$C6,$C6,$C6,$C6,$00),  {}
             ($FE,$00,$E6,$F6,$DE,$CE,$C6,$00),  {}
             ($3C,$6C,$6C,$3E,$00,$7E,$00,$00),  {}
             ($38,$6C,$6C,$38,$00,$7C,$00,$00),  {}
             ($18,$00,$18,$0C,$06,$C6,$7C,$00),  {}
             ($00,$00,$00,$FC,$C0,$C0,$00,$00),  {}
             ($00,$00,$00,$FC,$0C,$0C,$00,$00),  {}
             ($43,$C6,$CC,$DE,$33,$66,$CC,$0F),  {}
             ($43,$C6,$CC,$DB,$37,$6B,$CF,$03),  {}
             ($18,$00,$18,$18,$18,$18,$18,$00),  {}
             ($00,$33,$66,$CC,$66,$33,$00,$00),  {}
             ($00,$CC,$66,$33,$66,$CC,$00,$00),  {}
             ($22,$88,$22,$88,$22,$88,$22,$88),  {}
             ($55,$AA,$55,$AA,$55,$AA,$55,$AA),  {}
             ($DD,$77,$DD,$77,$DD,$77,$DD,$77),  {}
             ($18,$18,$18,$18,$18,$18,$18,$18),  {}
             ($18,$18,$18,$18,$F8,$18,$18,$18),  {}
             ($80,$C0,$BF,$80,$80,$80,$80,$7F),  {}
             ($01,$03,$FD,$01,$01,$01,$01,$FE),  {}
             ($80,$80,$80,$80,$80,$80,$80,$80),  {}
             ($01,$01,$01,$01,$01,$01,$01,$01),  {}
             ($0F,$0F,$0F,$0F,$0C,$0B,$0B,$07),  {}
             ($F0,$F0,$F0,$F0,$30,$D0,$D0,$E0),  {}
             ($00,$00,$FE,$06,$F6,$36,$36,$36),  {}
             ($36,$36,$F6,$06,$FE,$00,$00,$00),  {}
             ($36,$36,$36,$36,$FE,$00,$00,$00),  {}
             ($18,$18,$F8,$18,$F8,$00,$00,$00),  {}
             ($00,$00,$00,$00,$F8,$18,$18,$18),  {}
             ($18,$18,$18,$18,$1F,$00,$00,$00),  {}
             ($18,$18,$18,$18,$FF,$00,$00,$00),  {}
             ($00,$00,$00,$00,$FF,$18,$18,$18),  {}
             ($18,$18,$18,$18,$1F,$18,$18,$18),  {}
             ($00,$00,$00,$00,$FF,$00,$00,$00),  {}
             ($18,$18,$18,$18,$FF,$18,$18,$18),  {}
             ($18,$18,$1F,$18,$1F,$18,$18,$18),  {}
             ($36,$36,$36,$36,$37,$36,$36,$36),  {}
             ($36,$36,$37,$30,$3F,$00,$00,$00),  {}
             ($00,$00,$3F,$30,$37,$36,$36,$36),  {}
             ($36,$36,$F7,$00,$FF,$00,$00,$00),  {}
             ($00,$00,$FF,$00,$F7,$36,$36,$36),  {}
             ($36,$36,$37,$30,$37,$36,$36,$36),  {}
             ($00,$00,$FF,$00,$FF,$00,$00,$00),  {}
             ($36,$36,$F7,$00,$F7,$36,$36,$36),  {}
             ($18,$18,$FF,$00,$FF,$00,$00,$00),  {}
             ($36,$36,$36,$36,$FF,$00,$00,$00),  {}
             ($00,$00,$FF,$00,$FF,$18,$18,$18),  {}
             ($00,$00,$00,$00,$FF,$36,$36,$36),  {}
             ($36,$36,$36,$36,$3F,$00,$00,$00),  {}
             ($18,$18,$1F,$18,$1F,$00,$00,$00),  {}
             ($00,$00,$1F,$18,$1F,$18,$18,$18),  {}
             ($00,$00,$00,$00,$3F,$36,$36,$36),  {}
             ($36,$36,$36,$36,$FF,$36,$36,$36),  {}
             ($18,$18,$FF,$18,$FF,$18,$18,$18),  {}
             ($18,$18,$18,$18,$F8,$00,$00,$00),  {}
             ($00,$00,$00,$00,$1F,$18,$18,$18),  {}
             ($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF),  {}
             ($00,$00,$00,$00,$FF,$FF,$FF,$FF),  {}
             ($F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0),  {}
             ($0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F),  {}
             ($FF,$FF,$FF,$FF,$00,$00,$00,$00),  {}
             ($00,$00,$76,$DC,$C8,$DC,$76,$00),  {}
             ($00,$78,$CC,$F8,$CC,$F8,$C0,$C0),  {}
             ($00,$FC,$CC,$C0,$C0,$C0,$C0,$00),  {}
             ($00,$FE,$6C,$6C,$6C,$6C,$6C,$00),  {}
             ($FC,$CC,$60,$30,$60,$CC,$FC,$00),  {}
             ($00,$00,$7E,$D8,$D8,$D8,$70,$00),  {}
             ($00,$66,$66,$66,$66,$7C,$60,$C0),  {}
             ($00,$76,$DC,$18,$18,$18,$18,$00),  {}
             ($FC,$30,$78,$CC,$CC,$78,$30,$FC),  {}
             ($38,$6C,$C6,$FE,$C6,$6C,$38,$00),  {}
             ($38,$6C,$C6,$C6,$6C,$6C,$EE,$00),  {}
             ($1C,$30,$18,$7C,$CC,$CC,$78,$00),  {}
             ($00,$00,$7E,$DB,$DB,$7E,$00,$00),  {}
             ($06,$0C,$7E,$DB,$DB,$7E,$60,$C0),  {}
             ($38,$60,$C0,$F8,$C0,$60,$38,$00),  {}
             ($78,$CC,$CC,$CC,$CC,$CC,$CC,$00),  {}
             ($00,$FC,$00,$FC,$00,$FC,$00,$00),  {}
             ($30,$30,$FC,$30,$30,$00,$FC,$00),  {}
             ($38,$44,$44,$82,$01,$01,$00,$00),  {}
             ($03,$04,$04,$08,$10,$10,$E0,$00),  {}
             ($08,$28,$2A,$AA,$00,$00,$00,$00),  {}
             ($00,$00,$02,$02,$A8,$A8,$28,$20),  {}
             ($00,$00,$00,$00,$C0,$60,$30,$18),  {}
             ($18,$0C,$06,$03,$00,$00,$00,$00),  {}
             ($38,$6C,$6C,$38,$00,$00,$00,$00),  {}
             ($00,$00,$00,$18,$18,$00,$00,$00),  {}
             ($00,$00,$00,$00,$18,$00,$00,$00),  {}
             ($0F,$0C,$0C,$0C,$EC,$6C,$3C,$1C),  {}
             ($78,$6C,$6C,$6C,$6C,$00,$00,$00),  {}
             ($70,$18,$30,$60,$78,$00,$00,$00),  {}
             ($00,$00,$3C,$3C,$3C,$3C,$00,$00),  {}
             ($00,$00,$00,$00,$00,$00,$00,$00)   {}
            ));


      {logo 'mod' 3D or, largeur 80, compact LZ}
      Logo_MOD_3D: array[1..159] of WORD=(
          $4100,$101C,$7048,$C1A0,$0882,$2A0F,$64DC,$0400,$8715,$1F10,$8C4A,$7148,$C5A2,$9C88,$2408,
          $5864,$A3B1,$8CC4,$3902,$1C5E,$1159,$C2A4,$2884,$AA4F,$C94C,$A572,$82CB,$089D,$3274,$0202,
          $CD4C,$369B,$E273,$A9DC,$67B3,$4ECD,$4C64,$F472,$1449,$D027,$318C,$F267,$DA5C,$A8F3,$97C6,
          $5B50,$8D4A,$554A,$4C60,$3010,$9138,$C9E1,$0605,$AD56,$BD5C,$DD66,$D3EA,$40EB,$6128,$7EB1,
          $BB25,$ECD3,$B1D5,$E169,$74E6,$B53A,$D56E,$76BB,$A211,$4B2D,$6F70,$BEDB,$CD4B,$F082,$53AB,
          $D9F0,$28C0,$DF09,$4B74,$EC00,$A0DC,$F34F,$9DE2,$592C,$E22F,$7CC3,$FF31,$5CD5,$72D8,$CF66,
          $019B,$A67F,$BA4C,$5572,$36C5,$A305,$CB56,$B179,$D0E8,$53AD,$BE27,$BAFC,$E973,$A6DB,$AEA5,
          $4D56,$777B,$D76D,$7D07,$149F,$5BFE,$EE36,$B9E3,$F787,$FE5E,$3519,$88D0,$1E5C,$2E8E,$5CFE,
          $7462,$C8DA,$E7B3,$5286,$4DE0,$EE68,$6DDE,$EE0F,$9DFE,$CEBC,$2031,$ABD0,$5F4F,$1373,$4F1A,
          $1208,$BF9B,$BEB9,$FB7E,$F1F7,$EBB5,$FC97,$2D56,$F80C,$6956,$1624,$0056,$D01E,$589F,$1E05,
          $DFE8,$0382,$97FE,$425F,$360A,$20C8,$0F81,$A7EE,$4050);

      {logo 'MASTER' 3D or, largeur 80, compact LZ}
      Logo_MASTER_3D: array[1..210] of WORD=(
          $3700,$0019,$8541,$C1A0,$0882,$2A0F,$C84C,$20F0,$0227,$0E20,$8C44,$7028,$45A1,$0F2A,$4A27,
          $503C,$A1B1,$8CC7,$071C,$BC7A,$10E8,$C6E2,$178E,$A241,$C91C,$2092,$4EC8,$3A04,$0119,$8601,
          $CDA6,$389A,$EA6F,$C9CC,$6693,$3227,$072A,$1CF6,$13EA,$C9A8,$448A,$FE87,$087C,$E653,$A7CE,
          $613D,$1450,$B50A,$D328,$3398,$5693,$B305,$24D4,$104C,$3830,$D991,$45C9,$D86A,$3CB1,$82CB,
          $FB15,$AA54,$2844,$CD64,$45AE,$D36B,$082D,$69B8,$B2CD,$1A8D,$ABF1,$BA5E,$D538,$F59A,$6084,
          $DE22,$829B,$82C1,$DC25,$E217,$B8D9,$1F8A,$B4E7,$F1BB,$5B6E,$97C3,$66DF,$CCB6,$F2B7,$9AE1,
          $3F76,$6DD7,$791C,$E171,$9ECA,$A337,$ACE6,$B293,$D7C6,$3B9A,$9E63,$9B0C,$ED35,$ADD8,$E767,
          $8DC6,$E7F3,$2E41,$6F05,$2EDB,$D29A,$6D64,$A3DE,$2357,$3AE7,$A3F6,$E5F1,$11BE,$DF02,$5AFD,
          $6834,$C2DD,$2BAD,$BE5E,$3935,$BDCC,$C736,$ED40,$7C7A,$75F8,$E6E5,$BBBB,$9ED6,$1374,$C61A,
          $B5AB,$DE87,$1F2C,$CD3B,$92C4,$9393,$FB96,$7557,$FF75,$E5A9,$DA55,$A760,$07D9,$6086,$31E0,
          $D207,$B27F,$C7D5,$7CDD,$21B2,$D6E7,$0B4A,$1275,$751C,$01F1,$A068,$5327,$8490,$7191,$7E0E,
          $D807,$D576,$F015,$7506,$9850,$A288,$D98A,$A8B1,$5BDF,$862E,$A2E6,$6056,$07B8,$6D5F,$9E29,
          $5C28,$337C,$2082,$8FDE,$FA3E,$6368,$3981,$7862,$8C57,$F9B0,$1915,$4A7C,$B812,$92DF,$35A7,
          $9A69,$4D46,$E932,$80D8,$C258,$A370,$5272,$596A,$6A20,$665D,$E539,$5D46,$596E,$0225,$0101);

      {variations de coordonnes pour l'animation du logo 3D (dbut prog.)}
      dy_MOD1_3D: array[0..63] of WORD=(
            320,320,320,320,320,320,320,320,320,320,320,320,320,320,320,320,
            320,320,320,320,320,320,320,320,320,320,320,320,319,319,319,319,
            318,318,317,317,316,315,314,312,311,309,307,304,301,298,294,290,
            285,280,274,267,259,251,241,231,219,207,193,178,161,143,124,103);

      dy_MOD_3D: array[0..63] of WORD=(
            308,305,293,274,250,223,194,165,138,126,147,164,177,185,189,189,
            185,179,171,161,150,140,129,120,128,135,140,143,145,145,144,142,
            140,136,132,128,124,121,122,125,127,128,129,129,129,129,128,126,
            125,123,122,121,120,122,122,123,123,123,123,123,123,122,122,121);

      dy_MASTER_3D: array[0..63] of WORD=(
            400,383,363,339,314,288,262,237,215,205,223,237,248,256,261,263,
            263,261,256,251,244,237,229,222,214,207,201,204,209,213,216,217,
            218,219,218,217,216,214,212,210,207,205,203,201,201,202,203,204,
            205,205,206,205,205,205,204,204,203,202,202,201,201,200,200,201);


      {logo 'Mod Master' carr or, largeur=63, hauteur=3 (page d'aide)}
      largeur_logo_aide=63; hauteur_logo_aide=3;
      Logo_Mod_Master_Aide: array[1..189] of WORD=(
            $43DB,$46DB,$46DB,$46DF,$36DF,$46DB,$46DF,$36DF,$6404,$4020,$4020,$4020,$4020,$4020,$4020,$4020,$4020,$4020,$4020,
            $43DB,$46DB,$4020,$4020,$4020,$4020,$43DB,$46DB,$46DB,$46DF,$36DF,$46DB,$46DF,$36DF,$6404,$4020,$43DC,$46DC,$46DC,
            $46DC,$46DC,$4020,$43DC,$46DC,$46DC,$46DC,$46DC,$4020,$43DB,$46DB,$4020,$4020,$4020,$43DC,$46DC,$46DC,$46DC,$46DC,
            $4020,$43DC,$46DC,$46DC,$46DC,$46DC,$43DB,$46DB,$46DB,$4020,$43DB,$46DB,$4020,$43DB,$46DB,$4020,$43DB,$46DB,$46DF,
            $36DF,$46DB,$4020,$43DB,$46DB,$46DF,$36DF,$46DB,$4020,$4020,$4020,$4020,$43DB,$46DB,$46DB,$4020,$43DB,$46DB,$4020,
            $43DB,$46DB,$4020,$43DC,$46DC,$46DC,$36DC,$46DB,$4020,$43DB,$46DB,$46DC,$46DC,$46DC,$4020,$43DB,$46DB,$46DF,$46DF,
            $4020,$43DB,$46DB,$46DC,$36DC,$46DB,$4020,$43DB,$46DB,$4020,$43DF,$46DF,$43DB,$46DB,$46DB,$4020,$43DB,$46DB,$4020,
            $43DB,$46DB,$4020,$43DB,$46DB,$46DC,$36DC,$46DB,$4020,$43DB,$46DB,$46DC,$36DC,$46DB,$4020,$4020,$4020,$4020,$43DB,
            $46DB,$46DB,$4020,$43DB,$46DB,$4020,$43DB,$46DB,$4020,$43DB,$46DB,$46DC,$36DC,$46DB,$4020,$43DC,$46DC,$46DC,$36DC,
            $46DB,$4020,$43DB,$46DB,$46DC,$46DC,$4020,$43DB,$46DB,$46DC,$46DC,$46DC,$4020,$43DB,$46DB,$4020,$4020,$4020);


      {logo 'Mod Master' carr bleu, largeur 80, compact LZ (page de fin)}
      Logo_Mod_Master: array[1..159] of BYTE=(
          $00,$41,$00,$10,$28,$70,$5B,$80,$6D,$09,$10,$7E,$4B,$B0,$F0,$5B,$06,$85,$0C,$19,$3E,$4C,$40,$70,
          $A0,$C5,$8A,$18,$2F,$5A,$DC,$16,$09,$61,$C6,$8A,$06,$11,$42,$6C,$38,$B1,$A1,$44,$8F,$00,$B8,$05,
          $E0,$96,$80,$A5,$CB,$96,$14,$53,$AE,$84,$F9,$92,$65,$C1,$83,$09,$63,$56,$54,$59,$93,$66,$4C,$9E,
          $3E,$5F,$7E,$DC,$88,$13,$65,$C1,$8E,$3A,$01,$70,$44,$19,$32,$27,$49,$A6,$45,$23,$3A,$34,$AA,$F1,
          $A6,$C8,$A4,$4B,$B1,$22,$15,$08,$B4,$E6,$44,$AB,$39,$7B,$82,$1D,$19,$B3,$29,$42,$97,$5F,$95,$46,
          $15,$F8,$2D,$C0,$C2,$A1,$63,$B5,$52,$CD,$1A,$17,$2D,$D4,$AB,$76,$93,$66,$34,$2B,$B7,$6F,$DD,$96,
          $69,$BB,$D2,$4C,$CB,$57,$A8,$5A,$BC,$3E,$E3,$C2,$05,$10,$10);


    {-----paramtres configuration-----------------------}
    Langue    : BYTE=Francais; {langue pour les textes}
    LangueNote: BYTE=Francais; {langue pour les notes}

    Volume_par_defaut: WORD=5*50;   {volume par dfaut pour les nouveaux modules}
    duree_IntroScan: BYTE=10;       {dure Introscan en secondes}

    VolumeLeft : BYTE=15;           {volumes physiques Sound Blaster Pro}
    VolumeRight: BYTE=15;

    corr_R: SHORTINT=+6;            {facteurs de correction palette RVB}
    corr_V: SHORTINT=0;
    corr_B: SHORTINT=0;

    sensib_souris: BYTE=40;         {sensibilit souris}

    Utilise_economiseur: BOOLEAN=TRUE; {activation conomiseur}
    delai_economiseur  : BYTE=1;       {dlai conomiseur en minutes}

    Autoscan: BOOLEAN=TRUE;         {lecture & sauvegarde automatiques .DIR}
    Autosave: BOOLEAN=TRUE;

    cree_Desc: BOOLEAN=FALSE;       {crer fichier DESCRIPT.ION / 4Dos}

    scan_ARJ: BOOLEAN=TRUE;         {exploration des archives}
    scan_LZH: BOOLEAN=TRUE;
    scan_RAR: BOOLEAN=TRUE;
    scan_ZIP: BOOLEAN=TRUE;

    Chrono: BOOLEAN=TRUE;           {mode affichage temps module: chrono/compte  rebours}
    Mute  : BOOLEAN=FALSE;          {mode sourdine (volume/2)}

    type_barres_: BYTE=barres_pitch_stereo; {barres pitch/periode dans liste voies}
    mode_spectre_: BYTE=spectre_stereo;     {spectre mono/stro}
    amplification_: BYTE=ampl_spect_min+2;  {amplification pour FFT}

    {-----divers-----------------------------------------}
    recharge_module: BOOLEAN=FALSE; {recharger le dernier module aprs modif. config.}
    affiche_titre: BOOLEAN=TRUE;    {slecteur de modules: titre ou infos}

    {-----erreur fin Mod Master--------------------------}
    erreur_fin: WORD=0;


VAR {-----pour slecteur de fichiers---------------------}
    Module: array[1..nbr_fich_max] of T_module;
    nbr_fich,nbr_modules,premier_module,indice_module: WORD;

    {-----boutons fentre contrle-----------------------}
    bt_Change,
    bt_Config,
    bt_Introscan,bt_Shuffle,
    bt_Lecture,bt_Tout,bt_Efface,
    bt_Charge,bt_Sauve,
    bt_CD_Eject,bt_CD_Lecture,bt_CD_Pause,bt_CD_Arret,
    bt_CD_Prec,bt_CD_Retour,bt_CD_Avance,bt_CD_Suiv: Bouton3D;

    {-----divers-----------------------------------------}
    mode_interactif,affiche_syntaxe,
    CFG_present,PRG_present,sauve_DIR: BOOLEAN;

    lecture_module: BOOLEAN; {commande de lecture module}
    Introscan,Shuffle: BOOLEAN; {fonctions spciales}

    Fading: record actif: BOOLEAN; vitesse: BYTE; end;

    programme_courant: T_prog;

{==========================================================}

IMPLEMENTATION

END.
