{ͻ}
{                      --== MODMCMD.PAS ==--                       }
{                                                                      }
{ Unit de commande de Mod Master.                                     }
{                                                                      }
{ AUTEUR: Freddy Vtel.                                               }
{Ķ}
{ Compatibilit: 386           Dbut d'criture 04/11/95 }
{                              Dernires modifications 26/07/98 }
{ͼ}
UNIT ModmCmd;

{$A+,G+,Q-,R-,S-}

INTERFACE

USES ModmVar,VarUnit,Hardware,SBUnit,GUSUnit;

procedure Init_Tables_Modm;
procedure Fin_Tables_Modm;
procedure AjusterVolume;
procedure SoundInit(var Err_Modm: WORD);
procedure SoundEnd;
procedure InitSortie(numero_sortie: BYTE);
procedure Init_Config_Sonore;

procedure Erreur_Modm(Erreur:WORD);

{ Gestion de la squence }
procedure Position_Precedente;    { Recule d'une position dans la squence }
procedure Position_Suivante;      { Avance d'une position dans la squence }
procedure Position(Numero: BYTE); { Se placer  la position 'Numero'       }

{ Gestion des voies }
function  Voie_Active(V: BYTE): BOOLEAN;
procedure Activer_Voie(V: BYTE);
procedure Desactiver_Voie(V: BYTE);

IMPLEMENTATION

{=========================================================}

procedure Init_Tables_Modm;
var PSegment_Tampon1: WORD;
begin

 if MaxAvail<Taille_Table_Volume then begin
   asm
    mov AX,03h
    int 10h
   end;
   Writeln('not enough memory for volume table (',MaxAvail,')');
   halt;
 end;

 GetMem(Tables_Modm,Taille_Table_Volume);
 Segment_Table_Volume:=Seg(Tables_Modm^)+1;

 PSegment_Tampon1:=Segment_Table_Volume+(130*256) div 16+2;
 if (PSegment_Tampon1 mod (65536 div 16))>(4096-Taille_Tampon_DMA div 32) then
    inc(PSegment_Tampon1,Taille_Tampon_DMA div 32);

 with Variables^ do begin
   Offset_Tampon1:=(PSegment_Tampon1-Segment_Table_Volume)*16;
   Offset_Tampon2:=Offset_Tampon1+Taille_Tampon_DMA div 4;
   Seg_Table_Volume:=Segment_Table_Volume;
 end;
end; {Init_Tables_Modm}

{---------------------------------------------------------}

procedure Fin_Tables_Modm;
begin
 if Tables_Modm<>nil then begin
   FreeMem(Tables_Modm,Taille_Table_Volume);
   Tables_Modm:=nil;
 end;
end; {Fin_Tables_Modm}


{---------------------------------------------------------}

procedure Calcul_Table_Volume(Precision:BYTE; Volume:WORD); assembler;
var Coef: WORD;
    Compt_Volume: BYTE;
asm
 push DS
 xor DI,DI

 mov Compt_Volume,0
 mov AX,Volume
 mov Coef,AX
 cmp Precision,1
 je @Table_16Bit

 shr Coef,1             { * Table de volume 8 bit * }

 mov ES,Segment_table_volume

@Boucle_table_volume:
 mov BL,Compt_volume
 xor BH,BH
 mov AX,BX
 mul Coef               { Ne pas mettre une valeur >=  1024}
 mov BL,AH
 mov CX,-1

@Calcul_Table_vol:
 inc CX
 mov AX,CX              { Volume*256            }
 cbw                    { Conversion de signe   }
 imul BX
 mov ES:[DI],AH
 inc DI
 cmp CX,0FFh            { 256 Boucles           }
 jne @Calcul_Table_vol

 inc Compt_volume
 cmp Compt_volume,81h
 jne @Boucle_table_volume
 jmp @Fin_Calcul_Table_Volume

@Table_16Bit:           { * Table de volume 16 bit * }

@Boucle_table_volume16:
 mov BL,Compt_volume    { Vrifier la prcision !!!  }
 xor BH,BH
 mov AX,BX
 mul Coef               { Ne pas mettre une valeur =>  1024}
 mov BL,AH
 mov CX,-1

@Calcul_Table_vol16:
 inc CX
 mov AX,CX              { Volume*256            }
 cbw                    { Conversion de signe   }
 imul BX
 mov ES:[DI],AX
 add DI,2
 cmp CX,0FFh            { 256 Boucles           }
 jne @Calcul_Table_vol16

 inc Compt_volume
 cmp Compt_volume,41h
 jne @Boucle_table_volume16

@Fin_Calcul_Table_Volume:
 pop DS
end; {Calcul_Table_Volume}

{---------------------------------------------------------}

procedure AjusterTableGUS(Volume:WORD);
VAR Coef: REAL;
    i   : BYTE;
begin
 if Volume>480 then Volume:=480;
 if Volume>1 then Coef:=Ln(Volume)/Ln(500) else Coef:=0;
 for i:=0 to 64 do Variables^.Volume_GUS[i]:=Round(Volume_GUS1[i]*Coef);
end; {AjusterTableGUS}

{---------------------------------------------------------}

procedure AjusterVolume;  { Ajuster le volume selon le nombre de voies }
var Volume: WORD;
    N_Voies: BYTE;

begin
 if Variables^.Sortie_Stoppee then begin
   Volume:=Volume_Principal;
   with Variables^ do begin
     if Utilise_Stereo then
      if Utilise_Mixage then Volume:=Round(Volume*4/3)   { Volume*1.333.. }
                        else Volume:=Round(Volume*11/8); { Volume*1.375   }
     if MUS.H^.Nb_de_voies=0 then MUS.H^.Nb_de_voies:=4;
     N_Voies:=MUS.H^.Nb_de_voies;

     if N_Voies<4 then N_Voies:=4;
     if N_Voies>4 then
      if Sortie_sonore<>GUS then N_Voies:=4+(N_voies-4) div 3
                            else N_Voies:=4+(N_voies-4) div 4;

     Volume:=Round(Volume*4/N_voies);

     if Sortie_sonore<>GUS then Calcul_Table_Volume(0,Volume)
                           else AjusterTableGUS(Volume);
   end;
 end;
end; {AjusterVolume}

{---------------------------------------------------------}

procedure SoundInit(var Err_Modm: WORD);
var Panning_GUS : BYTE;
    Voie_GUS,i  : BYTE;
begin
 if (MUS.H^.Nb_Voies_Adlib>0) and OPL2_Presente then InitOPL2;

 case Variables^.Sortie_Sonore of
  GUS: begin        { Initialiser et Regler la balance }
        if MUS.H^.Nb_Voies_Digit>14 then UltraOpen(Ultra_Config,MUS.H^.Nb_de_voies)
                                      else UltraReset(14);
        i:=0;
        Voie_GUS:=0;
        repeat
         inc(i);
         if MUS.T^.Type_Voie[i]=1 then begin { Voie Digitale ? }
           Panning_GUS:=MUS.Panning[i];
           Panning_GUS:=Panning_GUS shr 3;
           if Panning_GUS>15 then Panning_GUS:=15;
           UltraSetBalance(Voie_GUS,Panning_GUS);
           inc(Voie_GUS)
         end;
        until i=MUS.H^.Nb_de_voies;
       end;

  Adlib: begin
          InitOPL2;
          MUS.H^.Nb_Voies_Adlib:=0;
          if MUS.H^.Nb_Voies_Digit>0 then begin
            EcrireOPL2(OPL2Test    ,$20);
            EcrireOPL2(OPL2FB_FM   ,$01);
            EcrireOPL2(OPL2AM_VIB  ,$00);
            EcrireOPL2(OPL2AM_VIB+3,$27);
            EcrireOPL2(OPL2KSL_TL  ,$00);
            EcrireOPL2(OPL2KSL_TL+3,$00);
            EcrireOPL2(OPL2AR_DR   ,$00);
            EcrireOPL2(OPL2AR_DR+3 ,$FF);
            EcrireOPL2(OPL2SL_RR   ,$00);
            EcrireOPL2(OPL2SL_RR+3 ,$0F);
            EcrireOPL2(OPL2WS      ,$00);
            EcrireOPL2(OPL2WS+3    ,$02);
            EcrireOPL2(OPL2Fnum    ,$0C);
            EcrireOPL2(OPL2Key     ,$3F);
            EcrireOPL2($BD         ,$20); { ou $E0 ???   }
          end
          else Err_Modm:=Err_Adlib;
         end;

  SMaster: begin
            InitOPL2;
            MUS.H^.Nb_Voies_Adlib:=0;
            if MUS.H^.Nb_Voies_Digit=0 then Err_Modm:=Err_Adlib;
           end;
 end;
end; {SoundInit}

{---------------------------------------------------------}

procedure SoundEnd;
begin
 if (MUS.H^.Nb_Voies_Adlib>0) and OPL2_Presente then InitOPL2;
 case Variables^.Sortie_Sonore of
  GUS: UltraReset(14);
  Adlib: InitOPL2;
 end;
end; {SoundEnd}

{---------------------------------------------------------}

procedure InitSortie(numero_sortie: BYTE);
{ Initialise la config de chaque sortie }
begin
 with Variables^ do
  begin
   case numero_sortie of
    HPint,
    CNA,
    DSS,
    Adlib,
    SMaster: Frequence:=16000;

    SB     : with SBConfig do begin
               Frequence:=22000;
               Utilise_DC:=(Type_>1);
               Port_de_Base:=Port;
               IRQ_SB:=IRQ;
               DMA_SB8:=DMA8;
               DMA_SB16:=DMA16;
               MMType_SB:=Type_; { type de carte }
             end;

    SBPro  : begin
              InitSortie(SB);
              Utilise_Stereo:=TRUE;
              Utilise_Filtre:=FALSE
             end;

    GUS    : begin
              Taille_GUS:=UltraSizeDRAM;
              Port_de_base_GUS:=Ultra_Config.Base_Port;
              IRQ_GUS:=Ultra_Config.GF1_IRQ_Num;
             end;
   end;
   Sortie_sonore:=numero_sortie
  end
end; {InitSortie}

{---------------------------------------------------------}

procedure Erreur_Modm(Erreur: WORD);  { Dtecter les erreurs }
begin
{ if not (Erreur in [Ok,Err_samples]) then
  begin
   TextMode(LastMode);
   case Erreur of
    Err_memoire   : Writeln('MODM: not enough memory to load music');
    Err_format    : Writeln('MODM: Bad format');
    Err_lecture   : Writeln('MODM: Read error (file not found)');
    Err_Pas_Sample: Writeln('MODM: No sample loaded');
   end;
   halt;
  end;}
end;   { Erreur_Modm }

{---------------------------------------------------------}

procedure Init_Config_Sonore;
var i:BYTE;

begin {Init_Config_Sonore}
 Detecte_Hardware(TRUE);
 Variables^.Port_LPT:=Port_LPT[1]; {1er port // par dfaut}

{ Detecte_DSS(TRUE);}
 DetecteSB(TRUE);

 if SBConfig.Type_<>1 then DetecteGUS(TRUE); {Chercher la GUS si <> SB v1.x}

 Variables^.OPL2_Present:=OPL2_Presente;

 SortiePresente[HPint]  :=TRUE;
 SortiePresente[CNA]    :=LPT_present[1] or LPT_present[2] or LPT_present[3] or LPT_present[4];
 SortiePresente[DSS]    :=SortiePresente[CNA];
 SortiePresente[Adlib]  :=OPL2_presente;
 SortiePresente[SMaster]:=OPL2_presente;
 SortiePresente[SB]     :=SB_presente;
 SortiePresente[SBPro]  :=SBPro_presente;
 SortiePresente[SB16]   :=SBPro_presente;  { <-- temporaire }
 SortiePresente[GUS]    :=GUS_presente;

 for i:=0 to MM_Nbr_Sorties-1 do if SortiePresente[i] then InitSortie(i);

 with Variables^ do
  if GUS_presente then Sortie_sonore:=GUS
  else if SBPro_presente then Sortie_sonore:=SBPro
       else if SB_presente then Sortie_sonore:=SB
            else Sortie_sonore:=HPint;              { Attention !! }
end; {Init_Config_Sonore}

{---------------------------------------------------------}

procedure Position_Precedente;
begin
 if not(Variables^.Musique_Term) then with Info^ do begin
   if Pos_sequence>1 then dec(Pos_sequence);
   ModifierPattern:=TRUE;
   Cmpt_tempo:=0;
 end;
end; {Position_Precedente}

{---------------------------------------------------------}

procedure Position_Suivante;
begin
 if not(Variables^.Musique_Term) then with Info^ do
  if Pos_sequence<MUS.H^.Sequence_Len then begin
    inc(Pos_sequence);
    ModifierPattern:=TRUE;
    Cmpt_tempo:=0;
  end;
end; {Position_Suivante}

{---------------------------------------------------------}

procedure Position(Numero: BYTE);
begin
 if not(Variables^.Musique_Term) then with Info^ do
  if (Numero<MUS.H^.Sequence_Len) and (Numero>0) then begin
    Pos_sequence:=Numero;
    ModifierPattern:=TRUE;
    Cmpt_tempo:=0;
  end;
end; {Position}

{---------------------------------------------------------}

function Voie_Active(V: BYTE): BOOLEAN;
begin
 if V in [1..Max_Voies] then with Info^ do
  Voie_Active:=((VControle[V] and M_Stoppee)=0)
 else Voie_Active:=FALSE;
end; {Voie_Active}

{---------------------------------------------------------}

procedure Activer_Voie(V: BYTE);
begin
 if V in [1..Max_Voies] then with Info^ do
  VControle[V]:=VControle[V] and not(M_Stoppee);
end; {Activer_Voie}

{---------------------------------------------------------}

procedure Desactiver_Voie(V: BYTE);
begin
 if V in [1..Max_Voies] then with Info^ do
  VControle[V]:=VControle[V] or (M_Stoppee or M_Pas_Active);
end; {Desactiver_Voie}

{---------------------------------------------------------}

END.
