{************************************************************************}
{                              MODMUNIT.PAS V2.2                         }
{                                                                        }
{  INTERFACE entre le Pascal et les routines sonores de Mod Master.      }
{                                                                        }
{  AUTEUR: Freddy Vtel.                                                }
{                                                                        }
{                                                                        }
{                               Dernires modifications le 16/09/99      }
{************************************************************************}
{$DEFINE MODM}

{$IFDEF MODM}
UNIT MODMUNIT; {Unit pour MODM.PAS}
{$ELSE}
UNIT MODMDEMO; {Unit pour les dmos}
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$I Types}

TYPE T_Proc = procedure;

{=========================================================}

{$IFDEF MODM}
procedure Tester_Vitesse;
procedure Pause_Module;
procedure Calcul_duree_module;
procedure Changer_Volume_Total;
procedure ChargeModule(chemin: String80; var erreur: WORD);
{$ENDIF}

procedure Play(var Err_Modm: WORD
{$IFDEF MODM}
                                 ; Routine: T_Proc
{$ENDIF}
                                                  );
function  Lancer_Sortie: BYTE;
procedure Stop_Sortie;
function  Lancer_Musique: WORD;
procedure Stop_Musique;

{=========================================================}

IMPLEMENTATION

USES Fichiers,Util,
     ModmVar,ModmCmd,VarUnit,Memoire,
     SBUnit,GUSUnit,
     ChUtil
{$IFDEF MODM}
    ,ChMOD,ChSTM,ChS3M,Ch669,ChDTM,ChMTM,ChULT,ChFAR,ChPTM,ChSAT,ChOKT,
     MM_VAR,MM_DIV,MM_Play
{$ENDIF};

{$F+}
{$IFDEF MODM}
procedure Test_Vitesse;            external;
procedure Pause_Module;            external;
procedure Calcul_duree_module;     external;
procedure Changer_Volume_Total;    external;
{$ENDIF}
procedure Cree_variable(var dest); external;
function  PLancer_Sortie: WORD;    external;
function  PLancer_Musique: WORD;   external;
{$F-}

{$L MODMPAS}

VAR SauveExit: POINTER; { Sauvegarde de l'ancienne routine de fin }

{=========================================================}

function Lancer_Sortie: BYTE;

var Err_Sort: WORD;

begin
 if Variables^.Sortie_Stoppee then begin
   if Variables^.Sortie_Sonore<>GUS then Init_Tables_Modm;
   AjusterVolume;
   SoundInit(Err_Sort);
   Err_Sort:=PLancer_Sortie;
   if Err_Sort<>Ok then begin
     Variables^.Stopper_Sortie:=FALSE;
     Variables^.Sortie_Stoppee:=TRUE;
   end;
 end
 else Err_Sort:=Ok;

 Lancer_Sortie:=Err_Sort;
end; {Lancer_Sortie}

{---------------------------------------------------------}

procedure Stop_Sortie;
begin
 with Variables^ do
  if Sortie_Stoppee then begin { Si musique termine, ne pas l'arrter }
    Stopper_Sortie:=TRUE;
    repeat until Sortie_Stoppee;
  end;
 SoundEnd;
 Variables^.Stopper_Sortie:=FALSE;
 Fin_Tables_Modm;
end;  {Stop_Sortie}

{---------------------------------------------------------}

function Lancer_Musique: WORD;
begin
 if MUS.Chargee then begin
   {$IFDEF MODM}
   Calcul_duree_module;                 { Calculer la dure de la musique }
   {$ENDIF}
   Move(MUS.Panning,Info^.VPanning,32); { Copier la position des voies    }
   Lancer_Musique:=PLancer_Musique;
 end
 else Lancer_Musique:=Err_Musique_Pas_Chargee;
end; {Lancer_Musique}

{---------------------------------------------------------}

procedure Stop_Musique;
begin
 if not Variables^.Musique_Term then Variables^.Musique_Term:=TRUE;
end; {Stop_Musique}

{---------------------------------------------------------}

procedure Play(var Err_Modm: WORD
{$IFDEF MODM}
                                 ; Routine: T_Proc
{$ENDIF}
                                                  );
begin
 Err_Modm:=Lancer_Musique;
 if Err_Modm=Ok then Err_Modm:=Lancer_Sortie;

 {$IFDEF MODM}
 if Err_Modm=Ok then Routine;
 Stop_Sortie;
 Stop_Musique;
 {$ENDIF}
end; {Play}

{---------------------------------------------------------}

{$IFDEF MODM}
procedure Tester_Vitesse;
begin
 if Variables^.Sortie_sonore<>GUS then Init_Tables_Modm;
 AjusterVolume;
 Test_Vitesse;
 if Variables^.Sortie_sonore<>GUS then Fin_Tables_Modm;
end; {Tester_Vitesse}

{---------------------------------------------------------}

procedure ChargeModule(chemin: String80; var erreur: WORD);

type TTestS3M=record
               Version: WORD;
               Ident: array[1..4] of CHAR;
              end;

var f: Fichier;

    TestS3M: TTestS3M;

begin
 Stop_Sortie; { Stopper la musique }

 case Extension(NomFichierSeul(chemin)) of
  ext_MOD: begin
            f.Ouvre(lecture,chemin);
            if f_erreur=f_ok then begin
              f.LitPos(42,TestS3M,sizeof(TestS3M));
              f.Ferme;
              with TestS3M do
               if (Ident='SCRM') and (Version<3) then Charge_S3M(chemin,erreur)
                                                 else Charge_MOD(chemin,erreur);
            end
            else erreur:=Err_lecture
           end;
  ext_NST,
  ext_WOW,
  ext_SD0,
  ext_OCT: Charge_MOD(chemin,erreur);
  ext_STM: Charge_STM(chemin,erreur);
  ext_S3M: Charge_S3M(chemin,erreur);
  ext_669: Charge_669(chemin,erreur);
  ext_DTM: Charge_DTM(chemin,erreur);
  ext_MTM: Charge_MTM(chemin,erreur);
  ext_ULT: Charge_ULT(chemin,erreur);
  ext_FAR: Charge_FAR(chemin,erreur);
  ext_OKT: Charge_OKT(chemin,erreur);
  ext_PTM: Charge_PTM(chemin,erreur);
  ext_SAT: Charge_SAT(chemin,erreur)
 end;
end; {ChargeModule}
{$ENDIF}

{---------------------------------------------------------}

{$F+}
procedure Routine_Fin;
{ Stopper la musique si fin du programme (en cas d'erreur) }
begin
 ExitProc:=SauveExit;
 Stop_Sortie;
 Stop_Musique;
 if MUS.Chargee then MUS_Efface;
end; {Routine_Fin}
{$F-}

{==========================================================}
{              Initialisation de MODMUNIT                  }
{==========================================================}

BEGIN
{ Initialise les pointeurs Mod Master }
 Cree_variable(TablePtr);

 MUS.T:=TablePtr.Table;
 if MUS.T^.Controle<>73 then begin
   Writeln('Bloc Table dcal!'); halt(1)
 end;

 Variables:=TablePtr.Variables;
 if Variables^.Controle<>73 then begin
   Writeln('Bloc Variables dcal!'); halt(1)
 end;

 Info:=TablePtr.Info;
 if Info^.Controle<>73 then begin
   Writeln('Bloc Info dcal!'); halt(1)
 end;

 MUS.H:=TablePtr.Musique;
 if MUS.H^.Controle<>73 then begin
   Writeln('Bloc Musique dcal!'); halt(1)
 end;

{ Initialise la mmoire }
 Memoire_Initialisee:=FALSE;   { Premire Initialisation !!! }
 DetecteMemoire(TRUE);
 MUS_Init;

 Variables^.Sortie_Stoppee:=TRUE;
 Variables^.Musique_Term:=TRUE;

 Utilise_EMS:=TRUE;
 Utilise_UMB:=TRUE;

{ Initialisation des sorties sonores }
 Init_Config_Sonore;

{ Initialisation de variables Mod Master }
 Nb_Octaves_Mod:=5;
 Panning_Gauche:=$20;
 Panning_Droite:=$60;
 Boucler_MOD:=FALSE;
 Jump:=FALSE;

 {$IFNDEF MODM}
 Volume_Principal:=5*50;
 {$ENDIF}

 SauveExit:=ExitProc;    { Mise en place de la routine de fin }
 ExitProc:=@Routine_Fin;
END.
