{************************************************************************}
{                               MODMVAR.PAS                              }
{                                                                        }
{  Types, constantes et variables pour Modm et Modmdemo.                 }
{                                                                        }
{  AUTEUR: Freddy Vtel.                                                }
{                                                                        }
{                                                                        }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}
UNIT ModmVar;

{$A+,G+,Q-,R-,S-}

INTERFACE

USES VARUnit;


CONST { constantes Max_... : nombres limites de voies, instruments, ...}
      Max_Voies   = 32;
      Max_Samples = 99;
      Max_Pattern = 256;   { 256 pour ULT, sinon 128 }

      Max_Octaves = 10;
      Max_Notes   = 12*Max_Octaves;

      { Masques pour les infos sur le sample }
      M_Adlib   = $01;   { instrument Adlib }
      M_NSigne  = $02;   { sign / non sign }
      M_16bit   = $04;   { 8 bits / 16 bits }
      M_Boucle  = $08;   { boucl / non boucl }
      M_Bidi    = $10;   { monodirectionnel(normal) / bidirectionnel(ping-pong) }
      M_Delta   = $20;   { codage normal / codage delta }
      M_Charge  = $80;   { instrument charg en mmoire / non charg }

      { Masques pour le contrle des voies }
      M_Pas_Active = $01;
      M_Stoppee    = $02;
      M_KeyOff     = $04;


TYPE Char32=array[1..32] of CHAR;
     Char22=array[1..22] of CHAR;
     Char20=array[1..20] of CHAR;
     Byte128=array[1..128] of BYTE;
     Byte256=array[1..256] of BYTE;

     Max_Voies_Byte   =array[1..Max_Voies] of BYTE;
     Max_Voies_Word   =array[1..Max_Voies] of WORD;
     Max_Voies_Longint=array[1..Max_Voies] of LONGINT;
     Max_Voies_Integer=array[1..Max_Voies] of INTEGER;

     Max_Samples_Byte   =array[1..Max_Samples] of BYTE;
     Max_Samples_Word   =array[1..Max_Samples] of WORD;
     Max_Samples_Longint=array[1..Max_Samples] of LONGINT;
     Max_Samples_Integer=array[1..Max_Samples] of INTEGER;

     Max_Pattern_Byte   =array[1..Max_Pattern] of BYTE;
     Max_Pattern_Word   =array[1..Max_Pattern] of WORD;
     Max_Pattern_Longint=array[1..Max_Pattern] of LONGINT;
     Max_Pattern_Integer=array[1..Max_Pattern] of INTEGER;

     T_PtrSample=^T_Sample;
     T_Sample=record case BOOLEAN of
               TRUE : (Info    : BYTE;  { type de sample, Bouclage ... }
                       Nom     : Char32;
                       Len     : LONGINT;
                       Rep     : LONGINT;
                       Rep_len : LONGINT;
                       Volume  : BYTE;
                       Fine_Tune1 : BYTE;
                       C4Spd   : WORD;
                       Adresse_GUS : LONGINT;
                       Mem     : T_BlocMem; );

               FALSE: (AInfo  : BYTE;  { type de sample, Bouclage ... }
                       ANom   : Char32;
                       AVolume: BYTE;
                       AC4Spd : WORD;
                       AData  : T_OPL2Instr;
                       ARemplissage: array[1..11] of BYTE; )
              end;


     T_Table=record
              Pattern        : Max_Pattern_Word;
              Taille_Pattern : Max_Pattern_Byte;
              Tempo_Pattern  : Max_Pattern_Byte;
              Sequence    : Max_Pattern_Byte;
              PtrSamples  : array[1..Max_Samples] of T_PtrSample;
              Type_Voie   : Max_Voies_Byte; { Rien,Sample,Adlib }
              Voies_Adlib : array[1..11] of BYTE;
              Controle    : BYTE; { Contrle de l'intgrit du bloc !!! }
             end;

     T_Variables=record
                  Frequence    : WORD;
                  OPL2_Present : BOOLEAN;
                  Sortie_sonore: BYTE;
                  Nb_boucles   : BYTE;
                  Num_Port_LPT : BYTE;  {1,2,3,4}
                  Port_LPT     : WORD;
                  Port_de_base : WORD;
                  Port_de_base_GUS: WORD;
                  Utilise_DMA,Utilise_stereo,Utilise_Mixage,Utilise_Filtre,
                  Utiliser_BPM,Utiliser_Fine,Utiliser_Panning,
                  Utiliser_Interpolation: BOOLEAN;
                  IRQ_SB,IRQ_GUS,DMA_SB8,DMA_SB16: BYTE;
                  MMType_SB  : BYTE;
                  Utilise_DC : BOOLEAN;
                  Seg_Table_Volume,Offset_Tampon1,Offset_Tampon2: WORD;
                  Vitesse_calculs_H,Vitesse_calculs_L: WORD;
                  Musique_Term   : BOOLEAN;
                  Sortie_Stoppee : BOOLEAN;
                  Stopper_Sortie : BOOLEAN;
                  BPM_Base       : WORD;
                  Commande_SB16  : BOOLEAN;
                  Volume_GUS     : array[0..64] of WORD;
                  Controle: BYTE; { Contrle de l'intgrit du bloc !!! }
                 end;

     T_Musique=record
                Titre: Char32;
                Nb_de_voies,Nb_de_voies_patt  : BYTE;
                Nb_voies_digit,Nb_voies_Adlib : BYTE;
                Nb_Total_Samples : BYTE;
                Nb_Samples       : BYTE; { Nombre de samples non vide }
                Nb_Reel_Samples  : BYTE; { Nombre de samples chargs  }
                Sequence_Len     : BYTE;
                Pos_de_restart   : BYTE;
                Tempo_depart     : BYTE;
                BPM_depart       : BYTE;
                Volume_General_depart : BYTE;
                Octave_Min,Octave_Max : BYTE;
                Type_Module       : BYTE;
                Type_Module_Etendu: BYTE; { Identificateur des modules mod }
                Volume_Sl_rapide  : BOOLEAN;
                Vitesse_Ticks     : BYTE;
                Controle          : BYTE; { Contrle de l'intgrit du bloc !!! }
               end;

     T_Info=record
             Calcul_fini       : BYTE;
             Taille_Tampon     : WORD;
             Taille_Sortie_DMA : WORD;   { !!!!!!! test }
             Tampon_Actif      : BYTE;
             Pointeur_Tampon_Joue : WORD;

             Pause          : BOOLEAN;
             Pos_note       : BYTE;  {Variables pour la lecture de la partition}
             Pos_sequence   : BYTE;
             Num_pattern    : BYTE;
             Segment_pattern: WORD;
             ModifierPattern: BOOLEAN;
             Compt_50       : WORD;

             Tempo          : BYTE;
             Cmpt_tempo     : BYTE;
             BPM            : BYTE;
             Cmpt_BPM       : WORD;

             Volume_General : BYTE;

             VControle      : Max_Voies_Byte;
             VPanning       : Max_Voies_Byte;
             VCommande      : Max_Voies_Word;
             VPeriode_part  : Max_Voies_Word;
             VPeriode_re    : Max_Voies_Word;

             VSample        : Max_Voies_Byte;
             VPtrSample     : array[1..Max_Voies] of POINTER;
             VVolume_part   : Max_Voies_Byte;
             VVolume_re     : Max_Voies_Byte;
             VVolume        : Max_Voies_Byte;
             Volume_Gauche  : Max_Voies_Byte;
             Volume_Droite  : Max_Voies_Byte;

             VOffset_actuel : Max_Voies_Word;
             VPart_decimale : Max_Voies_Byte;
             VPart_entiere  : Max_Voies_Byte;
             VAccumulateur  : Max_Voies_Byte;

             VDadj                : Max_Voies_Word;
             Adresse_Table_periode: Max_Voies_Word;
             FineTune             : Max_Voies_Byte;

             Frequence_GUS        : Max_Voies_Longint;
             GUS_Controle         : Max_Voies_Byte;
             Controle             : BYTE; { Contrle de l'intgrit du bloc !!! }
            end;

     T_Note=record
             Note : BYTE;
             Instrument,Commande: BYTE;
             Parametre,Volume   : BYTE;
            end;

     Ptr_Patt=^T_Pattern;
     T_Pattern=array[1..2048] of T_Note;

     TPeriodArray=array[0..12*Max_Octaves-1] of WORD;

     T_MUS=record
            Chargee    : BOOLEAN;
            SegSamples : WORD;
            H          : ^T_Musique;
            T          : ^T_Table;
            Panning    : Max_Voies_Byte;
           end;

CONST {Types de module}
      T_MOD = 0;   { Pro Tracker/Amiga  }
{      T_??? = 1;   { ?                  }
      T_STM = 2;   { Scream Tracker 2.0 }
      T_S3M = 3;   { Scream Tracker 3.x }
      T_669 = 4;   { Composer 669       }
      T_MTM = 5;   { Multi Tracker      }
      T_DTM = 6;   { Digital Tracker    }
      T_ULT = 7;   { Ultra Tracker      }
      T_FAR = 8;   { Farandole Tracker  }
      T_PTM = 9;   { PolyTracker        }
      T_SAT =10;   { Adlib Tracker      }

      {Types de module tendus pour mod}
      T_MOD_INC   = 0; {inconnu}
      T_MOD_NT    = 1; {NoiseTracker}
      T_MOD_PTST  = 2; {ProTracker/SoundTracker}
      T_MOD_FT1   = 3; {FastTracker 1.x}
      T_MOD_TTFT2 = 4; {TakeTracker/FastTracker 2.x}
      T_MOD_ST    = 5; {StarTrekker}
      T_MOD_OZ    = 6; {Octalyzer}
      T_MOD_OS    = 7; {Octalyser}
      T_MOD_OSAF  = 8; {Octalyser (Atari STe/Falcon)}
      T_MOD_DT    = 9; {Digital Tracker F030}

      MM_Nbr_Sorties = 9;

      {Numros des sorties sonores}
      HPint   = 0; { Haut parleur interne         }
      CNA     = 1; { DAC (Covox) sur LPTx         }
      DSS     = 2; { Disney Sound Source sur LPTx }
      SMaster = 3; { Sound Master                 }
      Adlib   = 4; { Adlib                        }
      SB      = 5; { Sound Blaster v1.X ou v2.X   }
      SBPro   = 6; { Sound Blaster Pro            }
      SB16    = 7; { Sound Blaster 16             }
      GUS     = 8; { Gravis UltraSound            }

      {Commandes de la partition}
      Rien          =0;
      Arpeggio      =1;  {0 xy}
      PortUp        =2;  {1 xy}
      PortDown      =3;  {2 xy}
      TonePortamento=4;  {3 xy}
      Vibrato       =5;  {4 xy}
      Tone_VSlide   =6;  {5 xy}
      Vib_VSlide    =7;  {6 xy}
      Tremolo       =8;  {7 xy}
      CPanning      =9;  {8 xy}
      SampleOffs    =10; {9 xy}
      VolSlide      =11; {A xy}
      JumpPattern   =12; {B xy}
      SetVolume     =13; {C xy}
      EndPattern    =14; {D xy}
      Extended      =15; {E  x}
      SetTempo      =16; {F xy}

      SetFilter     =17; {E 0x}
      FinePortaUp   =18; {E 1x}
      FinePortaDown =19; {E 2x}
      GlissCtrl     =20; {E 3x}
      VibCtrl       =21; {E 4x}
      FineTune      =22; {E 5x}
      JumpLoop      =23; {E 6x}
      TremCtrl      =24; {E 7x}
      Rien2         =25; {E 8x}
      RetrigNote    =26; {E 9x} { pour S3M xy avec x, paramtre volume slide }
      VolFineUp     =27; {E Ax}
      VolFineDown   =28; {E Bx}
      NoteCut       =29; {E Cx}
      NoteDelay     =30; {E Dx}
      PattDelay     =31; {E Ex}
      FunkIt        =32; {E Fx}

      SetBPM        =33; {        Fixer les BPM                 }
      SetGVolume    =34; {        Volume gnral (S3M)          }
      Tremor        =35; {        Tremor (STM,S3M)              }
      FreqAdj       =36; {        Ajustement de frquence (669) }
      ULTSpecial    =37;
      VibrSweep     =38; {        'Profondeur' du vibrato       }
      Release       =39; {        Key Off (SAT) !!! A programmer !!! }

      {Erreurs de chargement (erreurs non "critiques": Ok et Err_samples)}

      Ok             =0;
      Err_memoire    =1;  { Pas assez de mmoire pour charger le module }
      Err_format     =2;
      Err_lecture    =3;  { Fichier non trouv           }
      Err_samples    =4;  { Fichier non charg en entier }
      Err_Pas_Sample =5;  { Il n'y a pas de sample !!!   }
      Err_Version_Inconnue=6;  { Version du fichier non gr ... }
      Err_Non_Gere   =7;  { Format de fichier non gr   }

      {Erreurs au lancement de la musique}

      Err_Sortie_Introuvable  =1; {La sortie indique n'existe pas (Ex:LPT2)}
      Err_Frequence_Incorrecte=2; {Frquence non gre                      }
      Err_PC_Lent             =3; {PC Lent... (Pas encore programm)        }
      Err_Musique_Pas_Chargee =4; {Pas de musique charge !!!               }
      Err_SB                  =5; {La SB ne rpond plus !!!                 }
      Err_Adlib               =6; {Carte  utiliser seulement en digit      }

  { Table des priodes Amiga (et PC maintenant ;-) }
  PeriodSet : array[0..Max_Octaves-1] of array[0..11] of WORD = (
    {   C       C#      D       D#      E       F       F#      G       G#      A       A#      B  }
    ($1AC0*2,$1940*2,$17D0*2,$1680*2,$1530*2,$1400*2,$12E0*2,$11D0*2,$10D0*2,$0FE0*2,$0F00*2,$0E28*2),
    ($0D60*2,$0CA0*2,$0BE8*2,$0B40*2,$0A98*2,$0A00*2,$0970*2,$08E8*2,$0868*2,$07F0*2,$0780*2,$0714*2),
    ($06B0*2,$0650*2,$05F4*2,$05A0*2,$054C*2,$0500*2,$04B8*2,$0474*2,$0434*2,$03F8*2,$03C0*2,$038A*2),
    ($0358*2,$0328*2,$02FA*2,$02D0*2,$02A6*2,$0280*2,$025C*2,$023A*2,$021A*2,$01FC*2,$01E0*2,$01C5*2),
    ($01AC*2,$0194*2,$017D*2,$0168*2,$0153*2,$0140*2,$012E*2,$011D*2,$010D*2,$00FE*2,$00F0*2,$00E2*2),
    ($00D6*2,$00CA*2,$00BE*2,$00B4*2,$00AA*2,$00A0*2,$0097*2,$008F*2,$0087*2,$007F*2,$0078*2,$0071*2),
    ($006B*2,$0065*2,$005F*2,$005A*2,$0055*2,$0050*2,$004B*2,$0047*2,$0043*2,$003F*2,$003C*2,$0038*2),
    ($0035*2,$0032*2,$002F*2,$002D*2,$002A*2,$0028*2,$0025*2,$0023*2,$0021*2,$001F*2,$001E*2,$001C*2),
    ($0035  ,$0032  ,$002F  ,$002D  ,$002A  ,$0028  ,$0025  ,$0023  ,$0021  ,$001F  ,$001E  ,$001C  ),
    ($001A  ,$0019  ,$0017  ,$0016  ,$0015  ,$0014  ,$0012  ,$0011  ,$0010  ,$000F  ,$000F  ,$000E  ));

  Taille_Tampon_DMA=1024*4;
  Taille_Table_Volume=33500+Taille_Tampon_DMA;

  FineTuneConv: array[0..15] of WORD=
                (8363,8413,8463,8529,8581,8651,8723,8757,7895,7941,7985,8046,8107,8169,8232,8280);


CONST Tables_Modm: POINTER = nil;  { Pointeur sur la table de volume }


VAR MUS: T_MUS; { MUSIQUE }

    PeriodArray: TPeriodArray absolute PeriodSet;

    SortiePresente: array[0..MM_Nbr_Sorties-1] of BOOLEAN;

    Panning_Utilisable: BOOLEAN; {Si SBPro et calcul du panning ou GUS }

    Volume_principal: WORD;
    Segment_Table_Volume: WORD;

    TablePtr: record Table,Variables,Info,Musique: POINTER; end;

    Variables: ^T_Variables;  { Variables gnrales              }
    Info     : ^T_Info;       { Infos sur la musique,les voies...}

    Nb_Octaves_MOD: BYTE;

    { Variables utilises aussi par la partie asm }
    Boucler_MOD,Jump: BOOLEAN;

    Duree_min , Duree_sec , Duree_50 ,
    Chrono_min, Chrono_sec, Chrono_50: BYTE;

    Volume_Total: BYTE;        { Volume dans la partition }

    Test_Periodique: BYTE;   {le 50me de seconde pour l'affichage}

    { Variables d'info sur le module }
    Utilise_EMS,Utilise_UMB: BOOLEAN;

    Panning_Gauche,Panning_Droite: BYTE;
    Taille_GUS: WORD;

{==========================================================}

IMPLEMENTATION

END.
