{************************************************************************}
{                                SBUNIT.PAS                              }
{                                                                        }
{  Unit pour les cartes Sound Blaster, Sound Blaster Pro                }
{                        Sound Galaxy NX Pro, SB16 et compatibles        }
{                                                                        }
{  Aout 1995: Carte Adlib.                                               }
{                                                                        }
{  AUTEURS: Freddy Vtel, Juan Carlos Arvalo (Vangelis Tracker)        }
{           et Fabrice Couteau.                                          }
{                                                                        }
{                               Dbut d'criture le --/11/94             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}
UNIT SBUNIT;
{$A+,G+,Q-,R-,S-}

INTERFACE

CONST  { Offset des Ports I/O }
  MixAddrPortOffset  = $04;  { Mixer register port.             Write Only. }
  MixDataPortOffset  = $05;  { Mixer data port.                 Read/Write. }

  DSPResetPortOffset = $06;  { DSP Reset port.                  Write Only. }
  DSPReadPortOffset  = $0A;  { DSP Read data port.              Read  Only. }
  DSPLifePortOffset  = $0A;  { DSP Read data port.              Read  Only. }
  DSPWStatPortOffset = $0C;  { DSP Write buffer status port.    Write Only. }
  DSPWritePortOffset = $0C;  { DSP Write data port.             Write Only. }
  DSPRStatPortOffset = $0E;  { DSP Read buffer status port.     Read  Only. }
  DSP8AckPortOffset  = $0E;  {  8 bit DMA IRQ Acknowledge port. Write Only. }
  DSP16AckPortOffset = $0F;  { 16 bit DMA IRQ Acknowledge port. Write Only. }

  { Registres de la puce Mixer (SBPro) }
  mxrDataReset   =$00;
  mxrMsterVolume =$02;   { 7-5 Volume Gauche  3-1 Volume Droite          }
  mxrDACVolume   =$04;   { 7-5 Vol DAC Gauche 3-1 Vol DAC Droite       * }
  mxrFMControl   =$06;   { 6-Gauche On/Off 7- Droite On/On 3-1 Volume    }
  mxrMicroVolume =$0A;   { 2-0 Volume Micro                              }
  mxrInSetting   =$0C;   { Reglages Entre et Filtre                     }
  mxrOutSetting  =$0E;   { 1- Stereo On  5- Filtre Off                   }
  mxrMasterVolume=$22;   { 7-5 Volume Gauche  3-1 Volume Droite        * }
  mxrFMVolume    =$26;   { 7-5 Volume FM Gauche  3-1 Volume FM Droite  * }
  mxrCDVolume    =$28;   { 7-5 Volume CD Gauche  3-1 Volume CD Droite  * }
  mxrLineVolume  =$2E;   { 7-5 Volume in Gauche  3-1 Volume in Droite  * }

  { * Pour SB 16, Bits 7-4 pour Gauche et 3-0 pour Droite  }
  { Registres de la puce Mixer ( SG NX Pro) }
  mxrBass        =$46;   { 2-0 Niveau des basses                         }
  mxrTremble     =$44;   { 2-0 Niveau des aigus                          }

  { Registres de la puce Mixer (SB16) }
  mxrMasterVolumeG =$30; { 7-3 Volume Gauche                             }
  mxrMasterVolumeD =$31; { 7-3 Volume Droite                             }
  mxrDACVolumeG    =$32; { 7-3 Volume DAC Gauche                         }
  mxrDACVolumeD    =$33; { 7-3 Volume DAC Droite                         }
  mxrFMVolumeG     =$34;
  mxrFMVolumeD     =$35;
  mxrCDVolumeG     =$36;
  mxrCDVolumeD     =$37;
  mxrINVolumeG     =$38;
  mxrINVolumeD     =$39;
  mxrMicroVolume16 =$3A; { 7-3 Volume Micro                              }
  mxrPCSpeakerVol  =$3B; { 7-6 Volume PC Speaker                         }
  wxrOutControl    =$3C; {                                               }

  { Masques pour le Mixer ... }
  mxiFilterVal=$38;
  mxoFilterNeg=$20;      { Reg $0E bit 5=1 => Filtre Off                 }
  mxoStereoOn =$02;      { Reg $0E bit 1=1 => Stro On                  }

  { Registre de la puce OPL2  }
  OPL2Test   = $01;
  OPL2Timer1 = $02;
  OPL2Timer2 = $03;
  OPL2TimCtr = $04;      { Contrle des Timer.                           }
  OPL2CtrlG  = $08;      { Contrle gnral.                             }
  OPL2AM_VIB = $20;      {                                               }
  OPL2KSL_TL = $40;      { KSL et Niveau total.                          }
  OPL2AR_DR  = $60;      { Vitesse d'attaque et Vitesse de dcroissance. }
  OPL2SL_RR  = $80;      { Niveau soutenu et vitesse de relachement.     }
  OPL2Fnum   = $A0;
  OPL2Key    = $B0;
  OPL2FB_FM  = $C0;
  OPL2WS     = $E0;      { Wave Select.                                  }

  bKey = $20;            { Masque pour Key                               }

  { Commandes DSP   }
  sdcSendOneSample  = $10; { Sortie DAC Directe. (Mono, 20KHz Maxi)          }
  sdcStartLSpeedDMA = $14; { Dpart du transfer DMA Basse vitesse. (Mono, SB)}
  sdcReadOneSample  = $20; { Entre adc Directe. (Mono, 20KHz Maxi)          }
  sdcSetTimeConst   = $40; { Envoyer la frquence. (Commandes $14 et $91)    }
  sdcSetSampleRate  = $41; { Envoyer la frquence. (SB16)                    }
  sdcSetHSpeedSize  = $48; { Envoyer la taille du transfer DMA Rapide.       }
  sdcStartHSpeedDMA = $91; { Transfer DMA Haute Vitesse.                     }
  sdcTurnOnSpeaker  = $D1; { Turn on the SB speaker.                         }
  sdcTurnOffSpeaker = $D3; { Turn off the SB speaker.                        }
  sdcGetDSPVersion  = $E1; { Lire la Version du DSP.                         }
  sdcGetCopyright   = $E3; { Lire la chaine copyright de la carte.           }

  { Frquences maximum pour les cartes }
  FreqMaxSB1=22200;
  FreqMaxSB2=45400;
  FreqMaxSBPro=45400;
  FreqMaxSBProStereo=22100;

CONST  { Informations sur la carte }
  VersionSbMin : BYTE       = 0;
  VersionSbMaj : BYTE       = 0;
  VersionStrSb : STRING[ 5] = '';
  CopyrightSb  : STRING[80] = '';

  SbInitialisee  : BOOLEAN = FALSE;   { Vrai si la carte est initialise   }
  SbOk           : BOOLEAN = FALSE;   { Faux si erreur SB                  }
  NomSB : array[1..6] of STRING[30]=('Sound Blaster 1.x','Sound Blaster 2.x',
                                     'Sound Blaster Pro','Sound Blaster Pro 2.x',
                                     'Sound Galaxy NX Pro','Sound Blaster 16');

TYPE
{ type de carte : 1-Sound Blaster 1.x      }
{                 2-Sound Blaster 2.x      }
{                 3-Sound Blaster Pro      }
{                 4-Sound Blaster Pro 2.x  }
{                 5-Sound Galaxy NX Pro    }
{                 6-Sound Blaster 16       }

    TConfigSB = record
                 Port  : WORD;
                 IRQ   : BYTE;
                 DMA8  : BYTE;
                 DMA16 : BYTE;
                 Type_ : BYTE;
                end;

    TParamStr = record
                 IRQ : BYTE;
                 DMA : BYTE;
                 Type_ : BYTE;
                end;

VAR
  VersionSB : WORD absolute VersionSbMin;
  Param     : TParamStr;
  SBConfig  : TConfigSB;

{==========================================================}

{ Routines DSP Sound Blaster        }
procedure Attendre_DSP;
procedure Ecrire_DSP(Valeur: BYTE);
function  Lire_DSP: BYTE;
procedure GetSbDSPVersion;
procedure SbGetCopyrightString;
function  Init_DSP: BOOLEAN;
procedure Ecrire_DAC(Valeur:BYTE);
function  Lire_ADC:BYTE;

{ Routines pour la puce Mixer SBPro }
procedure SBEcrireRegMixer(Reg, Val: BYTE);
function  SBLireRegMixer(Reg: BYTE): BYTE;
function  DetecteMixerSBPro: BOOLEAN;
function  DetecteMixerSGPro: BOOLEAN;
function  DetecteMixerSB16 : BOOLEAN;

{ Rglages Mixer SBPro              }
procedure EcrireVolume(VolLeft,VolRight: BYTE);
procedure LireVolume(var VolLeft,VolRight: BYTE);
procedure ReglerFiltre(Position: BOOLEAN);

{ Gestion de la puce OPL2           }
procedure EcrireOPL2(Registre,Donnee: BYTE);
procedure InitOPL2;
procedure KeyOff(Voie: BYTE);           { Relacher la note (Voie 1->9) }
procedure CouperVoie(Voie: BYTE);       { Couper le son (Voie 1->9)    }
function  DetecteOPL2 : BOOLEAN;

{ Gestion de la variable BLASTER    }
function  VariableBLASTER: BOOLEAN;
procedure ChercheParametresSB(var IRQ,DMA,TypeSB: BYTE);

{ Dtection des cartes sonores et initialisation de l'Unit }
function DetecteSB(Affichage: BOOLEAN) : BOOLEAN;

{==========================================================}

IMPLEMENTATION

USES DOS,CRT,VARUnit,Util;


  { Constantes et variables 'Invisibles' (Pas dans DS)    }

CONST BLASTER: array[1..7] of CHAR='BLASTER';

  { Registres I/O }
  MixAddrPort  : WORD = $220 + MixAddrPortOffset;
  MixDataPort  : WORD = $220 + MixDataPortOffset;

  DSPResetPort : WORD = $220 + DSPResetPortOffset;
  DSPReadPort  : WORD = $220 + DSPReadPortOffset;
  DSPLifePort  : WORD = $220 + DSPLifePortOffset;
  DSPWStatPort : WORD = $220 + DSPWStatPortOffset;
  DSPWritePort : WORD = $220 + DSPWritePortOffset;
  DSPRStatPort : WORD = $220 + DSPRStatPortOffset;
  DSP8AckPort  : WORD = $220 + DSP8AckPortOffset;
  DSP16AckPort : WORD = $220 + DSP16AckPortOffset;

  BaseOLP2 = $388;
  IndiceOLP2 = BaseOLP2;
  DonneeOLP2 = BaseOLP2+1;

  OfsOp : array[1..9] of BYTE = ($00,$01,$02,$08,$09,$0A,$10,$11,$12);

VAR
  { Sauvegarde des registres OPL2 }

Old_KSL_TL1 : array[1..9] of BYTE;  {Niveau total des 9 Modulateurs.         }
Old_KSL_TL2 : array[1..9] of BYTE;  {Niveau total des 9 Porteuses.           }
Old_Key     : array[1..9] of BYTE;  {Key et valeurs de frquence des 9 Voies }
Old_FB      : array[1..9] of BYTE;  {Rtroaction et type de modulation       }

{==========================================================}

procedure Attendre_DSP; assembler;
asm
 mov SbOk,TRUE
 mov DX,DSPWritePort
 mov CX,2000
@bo_att_DSP:
 in AL,DX
 or AL,AL
 jns @Fin_bo_att_DSP
 loop @bo_att_DSP
 mov SbOk,FALSE   { Erreur SB }
@Fin_bo_att_DSP:
end; {Attendre_DSP}

{---------------------------------------------------------}

procedure Ecrire_DSP(Valeur: BYTE); assembler;
asm
 call Attendre_DSP
 mov DX,DSPWritePort
 mov AL,Valeur
 out DX,AL
end; {Ecrire_DSP}

{---------------------------------------------------------}

function Lire_DSP: BYTE; assembler;
asm
 mov SbOk,TRUE
 mov DX,DSPRStatPort
 mov CX,0
@bo_att_DSP:
 in AL,DX
 or AL,AL
 js @Fin_bo_att_DSP
 loop @bo_att_DSP
 mov SbOk,FALSE   { Erreur SB }
@Fin_bo_att_DSP:
 mov DX,DSPReadPort
 in  AL,DX
end; {Lire_DSP}

{---------------------------------------------------------}

procedure GetSbDSPVersion;
VAR  i: WORD;
     t: WORD;
     s: STRING[2];
begin
 Ecrire_DSP(sdcGetDSPVersion);
 t:=0;
 repeat
  VersionSbMaj:=Lire_DSP;
  inc(t);
 until ((VersionSbMaj<>$AA) and (SbOk)) or (t>=10);
 VersionSbMin:=Lire_DSP;

 STR(VersionSbMaj,VersionStrSb);
 VersionStrSb:=VersionStrSb+'.';
 STR(VersionSbMin,s);
 if VersionSbMin>9 then VersionStrSb:=VersionStrSb+s
                   else VersionStrSb:=VersionStrSb+'0'+s;
end; {GetSbDSPVersion}

{---------------------------------------------------------}

procedure SbGetCopyrightString;
VAR t: WORD;
begin
  Ecrire_DSP(sdcGetCopyright); { Send command. }
  t:=0;
  repeat
   CopyrightSb:=CHAR(Lire_DSP);
   inc(t);
  until ((CopyrightSb[1]<>#$AA) and SbOk) or (t=10);

  while SbOk and (Length(CopyrightSb)<80) do
   CopyrightSb:=CopyrightSb+CHAR(Lire_DSP);
  dec(CopyrightSb[0]);
end; {SbGetCopyrightString}

{---------------------------------------------------------}

function Init_DSP: BOOLEAN;
CONST ready = $AA;
VAR ct, donnee : BYTE;
begin
 PORT[DSPResetPort]:=1;
 for ct:=1 TO 100 do;
 PORT[DSPResetPort]:=0;

 donnee:=0;
 ct:=0;
 while (donnee<>ready) and (ct<100) do begin
  donnee:=PORT[DSPRStatPort];
  donnee:=PORT[DSPReadPort];
  inc(ct);
 end;
 if Donnee=Ready then Ecrire_DSP(sdcTurnOnSpeaker);
 Init_DSP:=Donnee=Ready;
end; {Init_DSP}

{---------------------------------------------------------}

procedure Ecrire_DAC(Valeur:BYTE);
begin
 Ecrire_DSP(sdcSendOneSample);   { Commande sortie directe DAC }
 Ecrire_DSP(Valeur);             { Envoyer la valeur           }
end; {Ecrire_DAC}

{---------------------------------------------------------}

function Lire_ADC:BYTE;
begin
 Ecrire_DSP(sdcReadOneSample);   { Commande lecture directe adc }
 Lire_ADC:=Lire_DSP;             { Lire la valeur               }
end; {Lire_ADC}

{=========================================================}

procedure SBEcrireRegMixer(Reg, Val: BYTE); assembler;
asm
 mov DX,MixAddrPort
 mov AL,Reg
 out DX,AL
 mov DX,MixDataPort
 mov AL,Val
 out DX,AL
end; {SbEcrireRegMixer}

{---------------------------------------------------------}

function SBLireRegMixer(Reg: BYTE): BYTE; assembler;
asm
 mov DX,MixAddrPort
 mov AL,Reg
 out DX,AL
 mov DX,MixDataPort
 in  AL,DX
end; {SbLireRegMixer}

{---------------------------------------------------------}

function DetecteMixerSBPro: BOOLEAN;
var SaveReg,NewReg: BYTE;
begin
 SaveReg:=SBLireRegMixer(mxrMasterVolume);
 SbEcrireRegMixer(mxrMasterVolume,243);
 NewReg :=SBLireRegMixer(mxrMasterVolume);
 SbEcrireRegMixer(mxrMasterVolume,SaveReg);
 Mixer_SBPro_Present:=(NewReg=243);
 DetecteMixerSBPro:=Mixer_SBPro_Present;
end; {DetecteMixerSBPro}

{---------------------------------------------------------}

function DetecteMixerSGPro: BOOLEAN;
var SaveReg,SaveReg1,NewReg,NewReg1: WORD; { Par Lecture/ecriture dans les Reg }
begin
 SaveReg:=SBLireRegMixer(mxrBass);
 SaveReg1:=SBLireRegMixer(mxrTremble);
 SbEcrireRegMixer(mxrBass,$AA);
 SbEcrireRegMixer(mxrTremble,$55);
 NewReg :=SBLireRegMixer(mxrBass);
 NewReg1:=SBLireRegMixer(mxrTremble);
 SbEcrireRegMixer(mxrBass,SaveReg);
 SbEcrireRegMixer(mxrTremble,SaveReg1);
 Mixer_SGPro_Present:=((NewReg=$AA) and (NewReg1=$55));
 DetecteMixerSGPro:=Mixer_SGPro_Present;
end; {DetecteMixerSGPro}

{---------------------------------------------------------}

function DetecteMixerSB16: BOOLEAN;
var SaveReg,SaveReg1,NewReg,NewReg1: WORD; { Par Lecture/ecriture dans les Reg }
begin
 SaveReg:=SBLireRegMixer(mxrMasterVolumeG);
 SaveReg1:=SBLireRegMixer(mxrMasterVolumeD);
 SbEcrireRegMixer(mxrMasterVolumeG,$F8);
 SbEcrireRegMixer(mxrMasterVolumeD,$F8);
 NewReg :=SBLireRegMixer(mxrMasterVolumeG);
 NewReg1:=SBLireRegMixer(mxrMasterVolumeD);
 SbEcrireRegMixer(mxrMasterVolumeG,SaveReg);
 SbEcrireRegMixer(mxrMasterVolumeD,SaveReg1);
 Mixer_SB16_Present:=((NewReg=$F8) and (NewReg1=$F8));
 DetecteMixerSB16:=Mixer_SB16_Present;
end;  {DetecteMixerSB16}

{---------------------------------------------------------}

procedure EcrireVolume(VolLeft,VolRight: BYTE);
begin
 if Mixer_SBPro_Present then
  SBEcrireRegMixer(mxrMasterVolume,(VolRight and $0F)+(VolLeft shl 4))
end; {EcrireVolume}

{---------------------------------------------------------}

procedure LireVolume(var VolLeft,VolRight: BYTE);
begin
 VolLeft:=15; VolRight:=15;
 if Mixer_SBPro_Present then begin
   VolRight:=SBLireRegMixer(mxrMasterVolume);
   VolLeft :=VolRight shr 4;
   VolRight:=VolRight and $0F
 end
end; {LireVolume}

{---------------------------------------------------------}

procedure ReglerFiltre(Position: BOOLEAN); { Filtre de sortie SBPro }
begin
 if Position then
  SbEcrireRegMixer(mxrOutSetting,(SbLireRegMixer(mxrOutSetting) and $DF)) {11011111}
 else
  SbEcrireRegMixer(mxrOutSetting,(SbLireRegMixer(mxrOutSetting) or  $20)) {00100000}
end; {ReglerFiltre}

{=========================================================}

procedure AdLibLoop; assembler;
asm
 @lp:
  in AL,DX
 loop @lp
end; {AdLibLoop}

{---------------------------------------------------------}

procedure EcrireOPL2(Registre,Donnee: BYTE); assembler;
asm
 mov DX,388h
 mov AL,Registre
 out DX,AL

 mov CX,6
 call AdLibLoop

 inc DX
 mov AL,Donnee
 out DX,AL

 dec DX
 mov CX,35
 call AdLibLoop
end; {EcrireOPL2}

{----------------------------------------------------------}

function DetecteOPL2 : BOOLEAN;
var X,X2:BYTE;
begin
 EcrireOPL2(OPL2Test,0);
 EcrireOPL2(OPL2TimCtr,$60);         {Initialiser les Compteurs    }
 EcrireOPL2(OPL2TimCtr,$80);         {Efface le registre de statut }
 Delay(10);
 X:=Port[$388];                      {Lire le statut               }
 EcrireOPL2(OPL2Timer1,$FF);         {Regle le compteur 1  255    }
 EcrireOPL2(OPL2TimCtr,$21);         {Envoie donnes + dmarre le compteur }
 Delay(10);                          {Attendre ...                 }
 X2:=Port[$388];                     {Lire le statut               }
 EcrireOPL2(OPL2TimCtr,$60);         {Init les compteurs           }
 EcrireOPL2(OPL2TimCtr,$80);
 X:= X and $E0;
 X2:= X2 and $E0;
 DetecteOPL2:=((X =$0) and (X2 =$C0));
end; {DetecteOPL2}

{---------------------------------------------------------}

procedure KeyOff(Voie: BYTE);     { Relacher la note (Voie 1->9) }
begin
 if Voie in[1..9] then
   EcrireOPL2(OPL2Key+(Voie-1),(Old_Key[Voie] and not bKey));
end; {KeyOff}

{---------------------------------------------------------}

procedure CouperVoie(Voie: BYTE); { Couper le son (Voie 1->9) }
begin
 if Voie in[1..9] then begin
   EcrireOPL2(OPL2KSL_TL+OfsOp[Voie],$3F);   { Volume modulateur  0 }
   EcrireOPL2(OPL2KSL_TL+OfsOp[Voie]+3,$3F); { Volume porteuse  0   }
   KeyOff(Voie);
 end;
end; {CouperVoie}

{---------------------------------------------------------}

procedure InitOPL2;
var i:BYTE;
begin
 for i:=1 to 9 do CouperVoie(i);
 EcrireOPL2($01,$20);           { Activer l'utilisations des formes d'onde }
 EcrireOPL2($BD,0);             { Mode mlodique 9 voies     }
end;

{=========================================================}

function VariableBLASTER: BOOLEAN;
begin
 VariableBLASTER:=(GetEnv(BLASTER)<>'')
end; {VariableBLASTER}

{----------------------------------------------------------}

procedure ChercheParametresSB(var IRQ,DMA,TypeSB: BYTE);
var chaine: STRING[20];
    i: BYTE;
begin
 chaine:=Maj(GetEnv(BLASTER));
 i:=Pos('I',chaine)+1;
 if i>1 then begin
   IRQ:=Ord(chaine[i])-48;
   if chaine[i+1]<>' ' then IRQ:=10;
   Param.IRQ:=IRQ;
   if not(IRQ in [2,5,7,10]) then IRQ:=7
 end
 else IRQ:=7;
 i:=Pos('D',chaine)+1;
 if i>1 then begin
   DMA:=Ord(chaine[i])-48;
   Param.DMA:=DMA;
   if not(DMA in [0,1,3]) then DMA:=1
 end
 else DMA:=1;
 i:=Pos('T',chaine)+1;
 if i>1 then begin
   TypeSB:=Ord(chaine[i])-48;
   Param.Type_:=TypeSB;
   case TypeSB of
    1:TypeSB:=1;   { SB 1.x     }
    2:TypeSB:=3;   { SB Pro     }
    3:TypeSB:=2;   { SB 2.x     }
    4:TypeSB:=4;   { SB Pro 2.x }
    5:TypeSB:=3;
    6:TypeSB:=6;   { SB 16      }
    else TypeSB:=2;
   end;
 end
 else TypeSB:=2;
end; {ChercheParametresSB}

{----------------------------------------------------------}

function DetecteDSP: BOOLEAN;
VAR Lst: WORD;
    Port_Trouve:BOOLEAN;
begin
 Port_Trouve:=FALSE;
 SBConfig.Port:=$210;
 Lst:=$280;

 while (not Port_Trouve) and (SBConfig.Port<=Lst) do begin
   MixAddrPort:=SBConfig.Port+MixAddrPortOffset;
   MixDataPort:=SBConfig.Port+MixDataPortOffset;

   DSPResetPort:=SBConfig.Port+DSPResetPortOffset;
   DSPReadPort :=SBConfig.Port+DSPReadPortOffset;
   DSPLifePort :=SBConfig.Port+DSPLifePortOffset;
   DSPWStatPort:=SBConfig.Port+DSPWStatPortOffset;
   DSPWritePort:=SBConfig.Port+DSPWritePortOffset;
   DSPRStatPort:=SBConfig.Port+DSPRStatPortOffset;
   DSP8AckPort :=SBConfig.Port+DSP8AckPortOffset;
   DSP16AckPort:=SBConfig.Port+DSP16AckPortOffset;

   Port_Trouve:=Init_DSP;
   if not Port_Trouve then inc(SBConfig.Port,$10);
 end;

 DetecteDSP:=Port_Trouve;
end;

{----------------------------------------------------------}

function DetecteSB(Affichage: BOOLEAN): BOOLEAN;
begin
 SBConfig.Type_:=0;

 if DetecteOPL2 then begin
   InitOPL2;
   OPL2_Presente:=TRUE;
 end;

 if DetecteDSP then begin { Dtecte le DSP }
   Init_DSP;
   SB_Presente:=TRUE;
   ChercheParametresSB(SBConfig.IRQ,SBConfig.DMA8,SBConfig.Type_);

   if DetecteMixerSBPro then begin { Dtecte la Puce Mixer (SBPro,SGPro ou Sb16) }
     SBPro_Presente:=TRUE;
     if SBConfig.Type_=6 then SB16_Presente:=TRUE { SB16 ??? }
     else begin
       if not (SBConfig.Type_ in [3,4]) then SBConfig.Type_:=3;
       if DetecteMixerSGPro then begin
         SGPro_Presente:=TRUE;
         SBConfig.Type_:=5;
       end;
     end;
   end;
 end;

 if Affichage then with SBConfig do begin
   if OPL2_Presente then Write('OPL2 found. ');
   if Type_>0 then
    Write(NomSB[Type_],' found at ',EntierHexa(Port,3)+'h',
            ' (IRQ ',IRQ,', DMA ',DMA8,'). ');
   Writeln
 end;

 DetecteSB:=SB_Presente;
end;  { DetecteSB }

{==========================================================}

END.
