{ͻ}
{                      --== SOURISB.PAS ==--                       }
{                                                                      }
{ Unit pour grer la souris en mode graphique avec un driver BGI      }
{                                                                      }
{    IMPORTANT:  charger aprs l'unit Souris !!                      }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 286           Dbut d'criture 08/07/97 }
{                              Dernires modifications 18/08/98 }
{ͼ}

UNIT SourisB;
{$A+,G+,Q-,R-,S-}

INTERFACE

{$I Types}

TYPE Binaire16=array[0..15] of BYTE;

CONST {formes curseurs pour DefCursSouris}
      fleche =0;
      sablier=1;

      curseur_fleche_16: Binaire16=($80,$C0,$E0,$F0,$F8,$FC,$FE,$FF,$FF,$FC,$9C,$0E,$0E,$07,$07,00);

      nombre_sabliers_16=15;
      curseur_sablier_16: array[0..nombre_sabliers_16-1] of Binaire16=
       (($FF,$FF,$FF,$FF,$7E,$7E,$3C,$24,$24,$24,$42,$42,$81,$81,$81,$FF),
        ($FF,$F7,$FF,$FF,$7E,$7E,$3C,$24,$2C,$24,$4A,$4A,$81,$89,$81,$FF),
        ($FF,$E3,$F7,$FF,$7E,$7E,$3C,$2C,$24,$2C,$42,$4A,$89,$81,$9D,$FF),
        ($FF,$C1,$E3,$FF,$7E,$7E,$3C,$2C,$2C,$24,$4A,$42,$89,$9D,$BF,$FF),
        ($FF,$81,$C1,$F7,$7E,$7E,$3C,$24,$2C,$2C,$42,$4A,$89,$BF,$FF,$FF),
        ($FF,$81,$81,$E3,$76,$7E,$3C,$2C,$24,$2C,$4A,$42,$9F,$FF,$FF,$FF),
        ($FF,$81,$81,$C1,$66,$7E,$3C,$24,$2C,$24,$4A,$5A,$FF,$FF,$FF,$FF),
        ($FF,$81,$81,$81,$42,$76,$3C,$2C,$24,$2C,$4A,$7E,$FF,$FF,$FF,$FF),
        ($FF,$81,$81,$81,$42,$42,$34,$34,$2C,$24,$5E,$7E,$FF,$FF,$FF,$FF),
        ($FF,$81,$81,$81,$42,$42,$24,$24,$24,$3C,$7E,$7E,$FF,$FF,$FF,$FF),
        ($3C,$42,$81,$81,$81,$42,$24,$24,$24,$3C,$7E,$FF,$FF,$FF,$7E,$3C),
        ($00,$3C,$42,$81,$81,$81,$42,$24,$3C,$7E,$FF,$FF,$FF,$7E,$3C,$00),
        ($00,$00,$00,$3C,$42,$81,$81,$BD,$7E,$FF,$FF,$7E,$3C,$00,$00,$00),
        ($00,$00,$00,$00,$3C,$7E,$FF,$FF,$7E,$BD,$42,$3C,$00,$00,$00,$00),
        ($00,$00,$3C,$7E,$FF,$FF,$FF,$7E,$24,$42,$81,$81,$42,$3C,$00,$00));

VAR Xsouris,Ysouris: WORD;
    SourisBouge: BOOLEAN;
    {!! avant d'appeler SourisBouge, il faut l'initialiser  FALSE !!}

{==========================================================}

procedure AffCursSouris;
procedure CacheCursSouris;
procedure DefCursSouris(forme_curseur: BYTE);
procedure AnimeCursSouris;

procedure InitSouris;
procedure FinSouris;

procedure EtatSouris(var x,y: WORD; boutons: BYTE);
procedure BougeCursSourisXY(x,y: WORD);

procedure ZoneSouris(xg,yh,xd,yb: WORD);

function  EstDansZone(x,y,xg,yh,xd,yb: WORD): BOOLEAN;

procedure AttendClavierSouris(attend_bouge,condition: BOOLEAN; var x,y: WORD);

{==========================================================}

IMPLEMENTATION

USES Clavier,Util,Souris,Graph;

VAR s: record
        x,y: INTEGER;

        zone: record xg,yh,xd,yb: WORD end;

        curseur: record
                  ptr: POINTER;
                  visible,change: BOOLEAN;
                  forme,index: BYTE;
                  top_anime: LONGINT;
                  fond: array[0..7+2,0..15] of BYTE;
                 end;
       end;

{==========================================================}

procedure AffCursSouris;
var dx,dy: BYTE;
    point_motif,dernier_point_motif: BOOLEAN;
begin
 with s.curseur do begin
  if visible then exit;
  change:=TRUE;

  GetImage(s.x,s.y,s.x+7+2,s.y+15,fond);

  for dy:=0 to 15 do begin
   dernier_point_motif:=FALSE;
   for dx:=0 to 7 do begin
    if (BytePtr(LONGINT(ptr)+dy)^ and ($80 shr dx))<>0 then begin
     PutPixel(s.x+dx+1,s.y+dy,WHITE);
     point_motif:=TRUE;
    end
    else point_motif:=FALSE;
    if point_motif<>dernier_point_motif then
     case point_motif of
      FALSE: PutPixel(s.x+dx+1  ,s.y+dy,BLACK);
      TRUE : PutPixel(s.x+dx+1-1,s.y+dy,BLACK);
     end;
    dernier_point_motif:=point_motif;
   end;
   if point_motif then PutPixel(s.x+7+1+1,s.y+dy,BLACK);
  end;

  change:=FALSE; visible:=TRUE;
 end;
end; {AffCursSouris}

{----------------------------------------------------------}

procedure CacheCursSouris;
begin
 with s.curseur do begin
  if not visible then exit;
  change:=TRUE;

  PutImage(s.x,s.y,fond,NORMALPUT);

  change:=FALSE; visible:=FALSE;
 end;
end; {CacheCursSouris}

{----------------------------------------------------------}

{$F+}
procedure GestEvenSouris(evenements,boutons: BYTE; posx,posy: WORD; dx,dy: INTEGER);
{procdure appele lorsque la souris bouge - met  jour le curseur}
var cv: BOOLEAN;
begin
 if not(s.curseur.change) then begin
  cv:=s.curseur.visible;
  if cv then begin AttendVBL; CacheCursSouris end;

  inc(s.x,dx); inc(s.y,dy);
  if s.x<s.zone.xg then s.x:=s.zone.xg;
  if s.x>s.zone.xd then s.x:=s.zone.xd;
  if s.y<s.zone.yh then s.y:=s.zone.yh;
  if s.y>s.zone.yb then s.y:=s.zone.yb;

  Xsouris:=s.x; Ysouris:=s.y;
  {!! Xsouris et Ysouris sont diffrentes des coordonnes renvoyes par le driver !!}

  if cv then AffCursSouris;
  asm
   mov AX,0Bh
   int 33h    {pour annuler dx et dy (sinon, pb de dplacement du curseur...)}
  end;
 end;

 SourisBouge:=TRUE;
end; {GestEvenSouris}
{$F-}

{----------------------------------------------------------}

procedure DefCursSouris(forme_curseur: BYTE);
var cv: BOOLEAN;
begin
 with s.curseur do begin
  change:=TRUE;

  if forme_curseur<>forme then index:=0;
  forme:=forme_curseur;
  top_anime:=Timer;

  cv:=visible;
  if cv then begin AttendVBL; CacheCursSouris end;

  case forme of
   fleche : ptr:=@curseur_fleche_16;
   sablier: ptr:=@curseur_sablier_16[index];
  end;

  if cv then AffCursSouris;

  change:=FALSE;
 end;
end; {DefCursSouris}

{----------------------------------------------------------}

procedure AnimeCursSouris;
begin
 with s.curseur do
  if Timer>=top_anime+2 then begin
   case forme of
    sablier: index:=(index+1) mod nombre_sabliers_16;
   end;
   DefCursSouris(forme);
  end;
end; {AnimeCursSouris}

{----------------------------------------------------------}

procedure InitSouris;
{dfinit le curseur, initialise les donnes et installe le
 gestionnaire d'vnements}
begin
 Souris.InitSouris;

 s.x:=GetMaxX div 2;
 s.y:=GetMaxY div 2;
 Xsouris:=s.x;
 Ysouris:=s.y;

 with s.zone do begin xg:=0; yh:=0; xd:=GetMaxX; yb:=GetMaxY end;

 with s.curseur do begin forme:=fleche; visible:=FALSE; change:=FALSE end;
 DefCursSouris(fleche);

 InstalleGestEvenSouris(souris_bouge,@GestEvenSouris);
end; {InitSouris}

{----------------------------------------------------------}

procedure FinSouris;
begin
 CacheCursSouris;
 DesinstGestEvenSouris;
end; {FinSouris}

{----------------------------------------------------------}

procedure EtatSouris(var x,y: WORD; boutons: BYTE);
begin
 x:=Xsouris; y:=Ysouris;
 boutons:=BoutonSouris;
end; {EtatSouris}

{----------------------------------------------------------}

procedure BougeCursSourisXY(x,y: WORD);
begin
 with s.zone do if not EstDansZone(x,y,xg,yh,xd,yb) then exit;

 CacheCursSouris;
 Xsouris:=x; Ysouris:=y;
 s.x:=x; s.y:=y;
 AffCursSouris;
end; {BougeCursSourisXY}

{----------------------------------------------------------}

procedure ZoneSouris(xg,yh,xd,yb: WORD);
begin
 CacheCursSouris;

 s.zone.xg:=xg;
 s.zone.yh:=yh;
 s.zone.xd:=xd;
 s.zone.yb:=yb;
 s.x:=LimiteEntier(s.x,s.zone.xg,s.zone.xd);
 s.y:=LimiteEntier(s.y,s.zone.yh,s.zone.yb);
 Xsouris:=s.x;
 Ysouris:=s.y;

 AffCursSouris;
end; {ZoneSouris}

{----------------------------------------------------------}

function EstDansZone(x,y,xg,yh,xd,yb: WORD): BOOLEAN;
begin
 EstDansZone:=(x>=xg) and (x<=xd) and (y>=yh) and (y<=yb);
end; {EstDansZone}

{----------------------------------------------------------}

procedure AttendClavierSouris(attend_bouge,condition: BOOLEAN; var x,y: WORD);
var x_init,y_init: WORD;
    boutons: BYTE;
begin
 VideBufferClavier;
 AffCursSouris;
 EtatSouris(x_init,y_init,boutons);

 if attend_bouge then
  repeat
   EtatSouris(x,y,boutons)
  until KeyPressed or (x<>x_init) or (y<>y_init) or (boutons=aucun);
 repeat until KeyPressed or (BoutonSouris<>aucun) or condition;

 EtatSouris(x,y,boutons);
end; {AttendClavierSouris}

{==========================================================}

END.
