{ͻ}
{                      --== SOURISG.PAS ==--                       }
{                                                                      }
{ Unit pour grer la souris en mode graphique MCGA 320x200 256 coul.  }
{                                                                      }
{    IMPORTANT:  charger aprs l'unit Souris !!                      }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 386           Dbut d'criture ??/05/94 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT SourisG;

{$A+,G+,Q-,R-,S-}

INTERFACE

{$I Types}

TYPE Bouton=object
             procedure Definit(x: WORD; y_: BYTE; titre_: String25;
                               couleur_relache,couleur_appuye,couleur_fond_: BYTE);
             procedure Affiche;
             function  Clique: BOOLEAN;
            private
             y: BYTE; xg,xd: WORD;
             titre: String25;
             couleur: array[BOOLEAN] of BYTE;
             couleur_fond: BYTE;
             appuye: BOOLEAN;
            end;

{==========================================================}

function  XSouris: WORD;
procedure EtatSouris(var x: WORD; var y,boutons: BYTE);
procedure BougeCursSourisXY(x: WORD; y: BYTE);
function  EstDansZone(x: WORD; y: BYTE; xg: WORD; yh: BYTE; xd: WORD; yb: BYTE): BOOLEAN;

function  NbrAppuisBouton(bouton: BYTE; var x: WORD; var y: BYTE): BYTE;
function  NbrRelachBouton(bouton: BYTE; var x: WORD; var y: BYTE): BYTE;
procedure ZoneSouris(xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);

procedure AttendClavierSouris(Attend_bouge,condition: BOOLEAN; var x: WORD; var y: BYTE);

{==========================================================}

IMPLEMENTATION

USES Clavier,Util,Souris,Graph256;

{==========================================================}

function Xsouris: WORD;
begin
 Xsouris:=(Souris.Xsouris shr 1);
end; {Xsouris}

{----------------------------------------------------------}

procedure EtatSouris(var x: WORD; var y,boutons: BYTE);
var x_abs,y_abs: WORD;
begin
 Souris.EtatSouris(x_abs,y_abs,boutons);
 x:=x_abs shr 1;
 y:=y_abs;
end; {EtatSouris}

{----------------------------------------------------------}

procedure BougeCursSourisXY(x: WORD; y: BYTE);
begin
 Souris.BougeCursSourisXY(x shl 1,y);
end; {BougeCursSourisXY}

{----------------------------------------------------------}

function EstDansZone(x: WORD; y: BYTE; xg: WORD; yh: BYTE; xd: WORD; yb: BYTE): BOOLEAN;
begin
 EstDansZone:=(x>=xg) and (x<=xd) and (y in [yh..yb]);
end; {EstDansZone}

{----------------------------------------------------------}

function NbrAppuisBouton(bouton: BYTE; var x: WORD; var y: BYTE): BYTE;
var x_abs,y_abs: WORD;
begin
 NbrAppuisBouton:=Souris.NbrAppuisBouton(bouton,x_abs,y_abs);
 x:=x_abs shr 1;
 y:=y_abs;
end; {NbrAppuisBouton}

{----------------------------------------------------------}

function NbrRelachBouton(bouton: BYTE; var x: WORD; var y: BYTE): BYTE;
var x_abs,y_abs: WORD;
begin
 NbrRelachBouton:=Souris.NbrRelachBouton(bouton,x_abs,y_abs);
 x:=x_abs shr 1;
 y:=y_abs;
end; {NbrRelachBouton}

{----------------------------------------------------------}

procedure ZoneSouris(xg: WORD; yh: BYTE; xd: WORD; yb: BYTE);
begin
 Souris.ZoneSouris(xg shl 1,yh,xd shl 1,yb);
end; {ZoneSouris}

{----------------------------------------------------------}

procedure AttendClavierSouris(Attend_bouge,condition: BOOLEAN; var x: WORD; var y: BYTE);
var x_init: WORD;
    y_init,boutons: BYTE;
begin
 VideBufferClavier;
 AffCursSouris;
 EtatSouris(x_init,y_init,boutons);
 if attend_bouge then
  repeat
   EtatSouris(x,y,boutons);
  until KeyPressed or (x<>x_init) or (y<>y_init) or (boutons=aucun);
 repeat until KeyPressed or (BoutonSouris<>aucun) or condition;
 EtatSouris(x,y,boutons);
end; {AttendClavierSouris}

{----------------------------------------------------------}

procedure Bouton.Definit(x: WORD; y_: BYTE; titre_: String25;
                         couleur_relache,couleur_appuye,couleur_fond_: BYTE);
begin
 titre:=titre_;
 y:=y_; xg:=x; xd:=x+6*Length(titre)-1;
 couleur[FALSE]:=couleur_relache;
 couleur[TRUE]:=couleur_appuye;
 couleur_fond:=couleur_fond_;
 appuye:=FALSE;
end; {Bouton.Definit}

{----------------------------------------------------------}

procedure Bouton.Affiche;
begin
 CacheCursSouris;
 CadreOmbre($A000,xg,y,xd+3,y+9,appuye);
 EffaceZone($A000,xg+1,y+1,xd+2,y+8,couleur_fond);
 AffCh5x6($A000,xg+2,y+2+BYTE(appuye),titre,couleur[appuye],TRUE,couleur_fond);
 AffCursSouris;
end; {Bouton.Affiche}

{----------------------------------------------------------}

function Bouton.Clique: BOOLEAN;
var xs: WORD;
    ys,bt: BYTE;
begin
 Clique:=FALSE;
 EtatSouris(xs,ys,bt);
 if (ys in [y..y+9]) and (xs>=xg) and (xs<=xd+3) then
  if bt=gauche then begin
   repeat
    EtatSouris(xs,ys,bt);
    appuye:=(ys in [y..y+9]) and (xs>=xg) and (xs<=xd+3);
    AttendVBL;
    Bouton.Affiche;
    repeat until (BoutonSouris=aucun) or SourisBouge;
   until bt=aucun;
   Clique:=appuye;
   if appuye then begin appuye:=FALSE; Bouton.Affiche end;
  end;
end; {Bouton.Clique}

{==========================================================}

END.
