{ͻ}
{                       --== TEXTE.PAS ==--                        }
{                                                                      }
{ Unit pour grer le mode texte sur cran couleur (CGA, VGA et SVGA)  }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 286           Dbut d'criture ??/10/93 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT Texte;

{$A+,G+,Q-,R-,S-}

INTERFACE

{$I Types}

CONST {variables dpendant du mode texte courant}
      delta_segment_VRAM: WORD=16+((80*25) shr 3); {variation de segment RAM vido d'une page vers la suivante}
      largeur_ecran_txt : BYTE=80;  {nombre de colonnes de l'cran texte (virtuelles si >80)}
      hauteur_ecran_txt : BYTE=25;  {nombre de lignes visibles de l'cran texte}
      largeur_car: BYTE= 9; {largeur d'un caractre en pixels}
      hauteur_car: BYTE=16; {hauteur d'un caractre en pixels}

      {dimensions max de l'cran texte en colonnes/lignes}
      largeur_ecran_max=132; {SVGA}
      hauteur_ecran_max=50;  {VGA}

      {adresse et attribut courants pour AffCar/AffCh}
      AdrTexte : WordPtr=Ptr($B800,0);
      AttrTexte: BYTE=16*0+7;

      {incrment automatique pour Palette16.Fondu}
      auto=0;

      {jeux de caractres pour ActiveJeuCar}
      car8x16=$14;
      car8x14=$11;
      car8x8 =$12;

      {tables de caractres pour PointeurTable}
      table8x16=6;
      table8x14=2;
      table8x8 =3;
      courante =0;

      {modes pour RedefCar}
      ascii  =1;
      binaire=2;

      {codes d'erreur pour .Charge_ de Palette16, FonteXX, Zone}
      err_format=1;


TYPE {type pour objets Zone et Ecran}
     VRAM=array[1..largeur_ecran_max*hauteur_ecran_max] of
           record attr: BYTE; car: CHAR end;

     Zone=object
           xg_,yh_,xd_,yb_: INTEGER; {xg_,yh_: coin suprieur gauche
                                      xd_,yb_: coin infrieur droit}
           procedure Sauve(page: BYTE; xg,yh,xd,yb: INTEGER);
           procedure Ombre(page: BYTE; xg,yh,xd,yb: INTEGER; attr: BYTE);
           procedure RestaureLimite(page: BYTE; x,y: INTEGER; xg,yh,xd,yb: BYTE);
           procedure Restaure(page: BYTE; dx,dy: SHORTINT; attr: BYTE);
           procedure DeplaceLimite(page: BYTE; dx,dy: SHORTINT; var zone_cachee: Zone; xg,yh,xd,yb: BYTE);
           procedure Deplace      (page: BYTE; dx,dy: SHORTINT; var zone_cachee: Zone);
           procedure Supprime;
           procedure Charge_(nom_fichier: String80; var erreur: WORD);
           procedure Sauve_ (nom_fichier: String80; var erreur: WORD);
          private
           taille_octets: WORD; {=2*(xd_-xg_+1)*(yb_-yh_+1)}
           contenu: ^VRAM;
          end;

     Ecran=object
           procedure Sauve(page: BYTE);
           procedure Restaure(page: BYTE);
           procedure Supprime;
          private
           contenu: ^VRAM;
          end;

     RVB=record R,V,B: BYTE end;

     Palette16=object  {VGA}
                palette: array[0..15] of RVB;
                procedure Charge;
                procedure Fixe;
                procedure Fondu(increment: BYTE);
                procedure Charge_(nom_fichier: String80; var erreur: WORD);
                procedure Sauve_ (nom_fichier: String80; var erreur: WORD);
               end;

     {types de motifs ASCII pour RedefCar}
     Ascii16=array[1..16,1..8] of CHAR; {25 lignes}
     Ascii14=array[1..14,1..8] of CHAR; {28 lignes}
     Ascii8 =array[1.. 8,1..8] of CHAR; {50 lignes}

     {types de motifs binaires pour RedefCar et objets FonteXX}
     Binaire16=array[1..16] of BYTE; {25 lignes}
     Binaire14=array[1..14] of BYTE; {28 lignes}
     Binaire8 =array[1.. 8] of BYTE; {50 lignes}

     Fonte16=object
              fonte: array[BYTE] of Binaire16;
              procedure Charge(table: BYTE);
              procedure Redef (table: BYTE);
              procedure Charge_(nom_fichier: String80; var erreur: WORD);
              procedure Sauve_ (nom_fichier: String80; var erreur: WORD);
             end;

     Fonte14=object
              fonte: array[BYTE] of Binaire14;
              procedure Charge(table: BYTE);
              procedure Redef (table: BYTE);
              procedure Charge_(nom_fichier: String80; var erreur: WORD);
              procedure Sauve_ (nom_fichier: String80; var erreur: WORD);
             end;

     Fonte8 =object
              fonte: array[BYTE] of Binaire8;
              procedure Charge(table: BYTE);
              procedure Redef (table: BYTE);
              procedure Charge_(nom_fichier: String80; var erreur: WORD);
              procedure Sauve_ (nom_fichier: String80; var erreur: WORD);
             end;


CONST palette_defaut: Palette16=(palette:(
                       (R: 0; V: 0; B: 0), {Noir}
                       (R: 0; V: 0; B:42), {Bleu}
                       (R: 0; V:42; B: 0), {Vert}
                       (R: 0; V:42; B:42), {Cyan}
                       (R:42; V: 0; B: 0), {Rouge}
                       (R:42; V: 0; B:42), {Magenta}
                       (R:42; V:21; B: 0), {Marron}
                       (R:42; V:42; B:42), {Gris clair}
                       (R:21; V:21; B:21), {Gris fonc}
                       (R:21; V:21; B:63), {Bleu clair}
                       (R:21; V:63; B:21), {Vert clair}
                       (R:21; V:63; B:63), {Cyan clair}
                       (R:63; V:21; B:21), {Rouge clair}
                       (R:63; V:21; B:63), {Magenta clair}
                       (R:63; V:63; B:21), {Jaune}
                       (R:63; V:63; B:63)  {Blanc}
                      ));

      palette_noire: Palette16=(palette:(
                      (R:0; V:0; B:0),(R:0; V:0; B:0),
                      (R:0; V:0; B:0),(R:0; V:0; B:0),
                      (R:0; V:0; B:0),(R:0; V:0; B:0),
                      (R:0; V:0; B:0),(R:0; V:0; B:0),
                      (R:0; V:0; B:0),(R:0; V:0; B:0),
                      (R:0; V:0; B:0),(R:0; V:0; B:0),
                      (R:0; V:0; B:0),(R:0; V:0; B:0),
                      (R:0; V:0; B:0),(R:0; V:0; B:0)
                     ));

      palette_blanche: Palette16=(palette:(
                        (R:63; V:63; B:63),(R:63; V:63; B:63),
                        (R:63; V:63; B:63),(R:63; V:63; B:63),
                        (R:63; V:63; B:63),(R:63; V:63; B:63),
                        (R:63; V:63; B:63),(R:63; V:63; B:63),
                        (R:63; V:63; B:63),(R:63; V:63; B:63),
                        (R:63; V:63; B:63),(R:63; V:63; B:63),
                        (R:63; V:63; B:63),(R:63; V:63; B:63),
                        (R:63; V:63; B:63),(R:63; V:63; B:63)
                       ));

{==========================================================}

procedure ActiveJeuCar(jeu_caracteres,table: BYTE); {VGA}
procedure InitTexte(lignes: BYTE); {VGA si lignes>25}
procedure InitTexteVirtuel(colonnes: BYTE); {VGA}
procedure InitTexte132(lignes: BYTE); {SVGA}
function  TesteModeTexte(var largeur,hauteur: BYTE): BYTE;

procedure Clignotement(clignote: BOOLEAN);

procedure ChargeDAC(couleur: BYTE; var comp: RVB); {VGA}
procedure FixeDAC  (couleur: BYTE; comp: RVB); {VGA}

procedure SelectJeuCar(jeu1,jeu2: BYTE); {VGA}
procedure LargeurCar(largeur: BYTE); {VGA}
function  PointeurTable(table: BYTE): POINTER; {VGA}
procedure AccedeCar; {VGA}
procedure AccedeMem; {VGA}
procedure MotifBinaire(table: BYTE; caractere: CHAR; var motif); {VGA}
procedure PointCar(caractere: CHAR; ligne,colonne: BYTE; allume: BOOLEAN); {VGA}
procedure LigneCar(caractere: CHAR; ligne: BYTE; allume: BOOLEAN); {VGA}
procedure ColonneCar(caractere: CHAR; colonne: BYTE; allume: BOOLEAN); {VGA}
procedure RedefCar(table: BYTE; premier_car: CHAR; nombre: WORD; var motif; mode: BYTE); {VGA}

procedure ChargeFonte(table: BYTE; var buffer); {VGA}
procedure RedefFonte (table: BYTE; var buffer); {VGA}
procedure ChargeFonte_(nom_fichier: String80; hauteur: BYTE; var buffer; var erreur: WORD); {VGA}
procedure SauveFonte_ (nom_fichier: String80; hauteur: BYTE; var buffer; var erreur: WORD); {VGA}

procedure ScrolleVertical(ligne: BYTE); {VGA}
procedure ScrolleHorizontal(colonne: BYTE); {VGA}
procedure PlaceEcran(xg,yh: WORD); {VGA}

procedure CursXY(page,x,y: BYTE);
function  PosX(page: BYTE): BYTE;
function  PosY(page: BYTE): BYTE;

function  PtrVRAM(page,x,y: BYTE): WordPtr;

procedure AffCarXY(page,x,y: BYTE; caractere: CHAR; attr: BYTE);
procedure AffChXY (page,x,y: BYTE; chaine: STRING; attr: BYTE);
procedure AffChXY2(page,x,y: BYTE; chaine: STRING; attr_ext,attr_int: BYTE);
procedure AffChXYmc(page,x,y: BYTE; chaine: STRING);
procedure AffCar(caractere: CHAR);
procedure AffCh(chaine: STRING);
procedure AffChE(chaine: STRING; caractere: CHAR; longueur: BYTE);

procedure LigneHorizontale(page,epaisseur,y,xg,xd,attr: BYTE);
procedure LigneVerticale  (page,epaisseur,x,yh,yb,attr: BYTE);
procedure Cadre(page,epaisseur,xg,yh,xd,yb,attr: BYTE; titre: STRING; attr_titre: BYTE; touches: String25);

function  CodeXY(page,x,y: BYTE): BYTE;
function  AttrXY(page,x,y: BYTE): BYTE;

procedure EffaceZone(page,xg,yh,xd,yb,attr: BYTE);
procedure EffacePage(page,attr: BYTE);
procedure ChangePage(page: BYTE);
procedure CopiePage (page_source,page_dest: BYTE);

procedure ScrolleZoneHaut  (page,xg,yh,xd,yb: BYTE);
procedure ScrolleZoneBas   (page,xg,yh,xd,yb: BYTE);
procedure ScrolleZoneGauche(page,xg,yh,xd,yb: BYTE);
procedure ScrolleZoneDroite(page,xg,yh,xd,yb: BYTE);

{==========================================================}

IMPLEMENTATION

USES Fichiers,Util,VGA;

CONST {table de correspondance entre n couleur et n registre DAC}
      couleurs: array[0..15] of BYTE=(0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63);

{==========================================================}

procedure ActiveJeuCar(jeu_caracteres,table: BYTE); {VGA}
{charge et active le jeu de caractres de la table (0 ou 1)}
begin
 if not(jeu_caracteres in [car8x16,car8x14,car8x8]) then jeu_caracteres:=car8x16;
 case jeu_caracteres of
  car8x16: begin hauteur_ecran_txt:=25; hauteur_car:=16 end;
  car8x14: begin hauteur_ecran_txt:=28; hauteur_car:=14 end;
  car8x8 : begin hauteur_ecran_txt:=50; hauteur_car:=8  end;
 end;
 delta_segment_VRAM:=16+((largeur_ecran_txt*hauteur_ecran_txt) shr 3);
 AttendVBL;
 asm
  mov AH,11h
  mov AL,jeu_caracteres
  mov BL,table
  and BL,00000001b      {corrige table: 0 ou 1}
  int 10h
 end;
end; {ActiveJeuCar}

{----------------------------------------------------------}

procedure InitTexte(lignes: BYTE); {VGA si lignes>25}
{initialise le mode texte 80 colonnes x 25/28/50 lignes}
begin
 asm
  mov AX,txt80_16c   {mode texte standard 80x25 16 couleurs par dfaut}
  int 10h
 end;
 largeur_ecran_txt:=80;
 if CarteVGA then begin
  if not(lignes in [25,28,50]) then lignes:=25;
  case lignes of
   25: ActiveJeuCar(car8x16,0);
   28: ActiveJeuCar(car8x14,0);
   50: ActiveJeuCar(car8x8 ,0)
  end;
  LargeurCar(9);
 end
 else begin delta_segment_VRAM:=256; hauteur_ecran_txt:=25 end;

 AdrTexte :=Ptr($B800,0);
 AttrTexte:=16*0+7;
end; {InitTexte}

{----------------------------------------------------------}

procedure InitTexteVirtuel(colonnes: BYTE); {VGA}
{fixe la longueur des lignes dans la RAM vido -> 80..254 caractres
 Remarque: le nombre de colonnes est ajust pour tre pair;
 IMPORTANT: si colonnes>80, l'affichage multi-page n'est plus valable!}
begin
 largeur_ecran_txt:=colonnes and $FE;
 asm
  mov DX,CRTControl
  mov AH,colonnes
  shr AH,1
  mov AL,Offset_
  out DX,AX         {dfinit le nombre de colonnes}
 end;
end; {InitTexteVirtuel}

{----------------------------------------------------------}

procedure InitTexte132(lignes: BYTE); {SVGA}
{initialise le mode texte 132 colonnes x 25,28,50 lignes
 REMARQUES: Ne fonctionne qu'en mode 8 pixels -> ne pas appeler LargeurCar !
            En mode 25 lignes, seule la page n0 est affiche correctement
            En mode 50 lignes, deux pages seulement sont disponibles}
begin
 asm
  mov AX,txt132_16c
  int 10h
 end;
 largeur_ecran_txt:=132;
 if not(lignes in [25,28,50]) then lignes:=25;
 case lignes of
  25: ActiveJeuCar(car8x16,0);
  28: ActiveJeuCar(car8x14,0);
  50: ActiveJeuCar(car8x8 ,0);
 end;

 AdrTexte :=Ptr($B800,0);
 AttrTexte:=16*0+7;
end; {InitTexte132}

{----------------------------------------------------------}

function TesteModeTexte(var largeur,hauteur: BYTE): BYTE; assembler;
{renvoie le n du mode texte actuel et ses dimensions en caractres}
asm
 mov AH,0Fh
 int 10h
 les DI,largeur
 mov ES:[DI],AH
 mov DX,40h
 mov ES,DX
 mov DL,ES:[84h]
 inc DL
 les DI,hauteur
 mov ES:[DI],DL
end; {TesteModeTexte}

{----------------------------------------------------------}

procedure Clignotement(clignote: BOOLEAN); assembler;
{si clignote=TRUE, les couleurs>=128 clignotent, sinon le fond est plus clair}
asm
 mov AX,1A00h {fonction 1Ah du BIOS EGA/VGA pour tester si carte EGA ou VGA}
 int 10h
 cmp AL,1Ah
 je  @egavga  {c'est une carte VGA}
 mov AH,12h
 mov BL,10h   {sous-fonction 10h de la fonction 12h du BIOS EGA/VGA}
 int 10h
 cmp BL,10h   {BL a chang?}
 jne @egavga  {oui, c'est donc une carte EGA}
 {on suppose ici que c'est une carte CGA!}
 mov AL,00101001b   {par dfaut, active le clignotement}
 cmp clignote,TRUE
 je  @suiteCGA
 mov AL,00001001b   {dsactive le clignotement}
@suiteCGA:
 mov DX,3D8h  {contrleur CRT de la carte CGA}
 out DX,AL    {fixe l'attribut}
 jmp @fin
@egavga:
 mov AX,1003h {fonction 10h du BIOS EGA/VGA pour fixer l'attribut clignotement}
 mov BL,clignote
 int 10h
@fin:
end; {Clignotement}

{----------------------------------------------------------}

procedure ChargeDAC(couleur: BYTE; var comp: RVB); {VGA}
begin
 PortW[DACRead]:=couleurs[couleur and $0F]; {charge le n de registre DAC}
 with comp do begin R:=Port[DACData]; V:=Port[DACData]; B:=Port[DACData] end;
end; {ChargeDAC}

{----------------------------------------------------------}

procedure FixeDAC(couleur: BYTE; comp: RVB); {VGA}
begin
 asm
  mov AL,couleur
  and AL,00001111b   {couleur de 0  15}
  mov BX,OFFSET couleurs
  xlat               {AL=n registre DAC correspondant  couleur}
  mov DX,DACWrite
  out DX,AL          {charge le n de couleur dans le DAC}
  mov DX,DACData
  mov AL,comp.R
  out DX,AL          {fixe le rouge}
  mov AL,comp.V
  out DX,AL          {fixe le vert}
  mov AL,comp.B
  out DX,AL          {fixe le bleu}
 end;
end; {FixeDAC}

{----------------------------------------------------------}

procedure Palette16.Charge; {VGA}
{charge la palette de 16 couleurs}
var couleur: BYTE;
begin
 for couleur:=0 to 15 do ChargeDAC(couleur,palette[couleur]);
end; {Palette16.Charge}

{----------------------------------------------------------}

procedure Palette16.Fixe; {VGA}
{fixe la palette de 16 couleurs}
var couleur: BYTE;
begin
 AttendVBL;
 for couleur:=0 to 15 do FixeDAC(couleur,palette[couleur]);
end; {Palette16.Fixe}

{----------------------------------------------------------}

procedure Palette16.Fondu(increment: BYTE); {VGA}
{fait un fondu entre la palette courante et la palette destination}
var initiale,courante: Palette16;
    couleur,diff,maxdiff,i: BYTE;
begin
 courante.Charge;
 initiale:=courante;

 if increment=auto then begin  {calcule le nombre de palettes intermdiaires automatiquement}
  maxdiff:=0;
  for couleur:=0 to 15 do begin
   diff:=Abs(palette[couleur].R-courante.palette[couleur].R);
   if diff>maxdiff then maxdiff:=diff;
   diff:=Abs(palette[couleur].V-courante.palette[couleur].V);
   if diff>maxdiff then maxdiff:=diff;
   diff:=Abs(palette[couleur].B-courante.palette[couleur].B);
   if diff>maxdiff then maxdiff:=diff;
  end;
 end
 else maxdiff:=increment; {nombre de palettes intermdiaires fix}

 for i:=1 to maxdiff do begin
  for couleur:=0 to 15 do begin
   courante.palette[couleur].R:=initiale.palette[couleur].R+i*(palette[couleur].R-initiale.palette[couleur].R) div maxdiff;
   courante.palette[couleur].V:=initiale.palette[couleur].V+i*(palette[couleur].V-initiale.palette[couleur].V) div maxdiff;
   courante.palette[couleur].B:=initiale.palette[couleur].B+i*(palette[couleur].B-initiale.palette[couleur].B) div maxdiff;
  end;
  courante.Fixe;
 end;
end; {Palette16.Fondu}

{----------------------------------------------------------}

procedure Palette16.Charge_(nom_fichier: String80; var erreur: WORD); {VGA}
{charge la palette de 16 couleurs depuis le disque (48 octets)}
var f: Fichier;
begin
 with f do begin
  Ouvre(lecture,nom_fichier);
  if f_erreur=f_ok then begin
   erreur:=0;
   if Taille=3*16 then Lit(palette,3*16) else erreur:=err_format;
   Ferme;
   if erreur=err_format then exit;
  end;
 end;
 erreur:=f_erreur;
end; {Palette16.Charge_}

{----------------------------------------------------------}

procedure Palette16.Sauve_(nom_fichier: String80; var erreur: WORD); {VGA}
{sauve la palette de 16 couleurs sur disque (48 octets)}
var f: Fichier;
begin
 with f do begin
  Cree(not(teste_existe),nom_fichier);
  if f_erreur=f_ok then begin Ecrit(palette,3*16); Ferme end;
 end;
 erreur:=f_erreur;
end; {Palette16.Sauve_}

{----------------------------------------------------------}

procedure SelectJeuCar(jeu1,jeu2: BYTE); assembler; {VGA}
{slectionne les 2 jeux de caractres affichs  l'cran (0  jeu1,jeu2  7):
 (par dfaut, jeu1=jeu2=0)
 -si jeu1=jeu2: 256 caractres, 16 couleurs d'criture
 -sinon: 512 caractres, 8 couleurs d'criture
         octet d'attribut: si bit 3=0: caractre affich avec jeu1
                           si bit 3=1: caractre affich avec jeu2}
asm
 xor AH,AH

 mov AL,jeu1
 mov BL,AL
 and AL,00000011b
 or  AH,AL
 and BL,00000100b
 shl BL,2
 or  AH,BL

 mov AL,jeu2
 mov BL,AL
 and AL,00000011b
 shl AL,2
 or  AH,AL
 and BL,00000100b
 shl BL,3
 or  AH,BL

 mov DX,Sequencer
 mov AL,CharMapSelect
 out DX,AX
end; {SelectJeuCar}

{----------------------------------------------------------}

procedure LargeurCar(largeur: BYTE); {VGA}
{fixe la largeur des caractres en pixels (8 ou 9)}
{-> NE PAS PAS APPELER EN MODE SVGA 132 colonnes !! <-}
begin
 largeur_car:=largeur;
 AttendVBL;
 asm
  mov BX,0001h      {BH=alignement horizontal (ajust  la fin)}
  cmp largeur,8     {BL=valeur pour le squenceur}
  je  @suite
  mov BX,0800h
 @suite:
  mov DX,MiscOutput
  in AL,DX
  and AL,11110011b  {passe en 640 points}
  cmp largeur,8
  je  @ecrit_largeur
  or  AL,00000100b  {passe en 720 points}
 @ecrit_largeur:
  mov DX,InputStatus0
  out DX,AL         {fixe la largeur des caractres}

  cli
  mov DX,Sequencer
  mov AX,(00000001b shl 8)+Reset
  out DX,AX         {rinitialise le squenceur}
  mov AH,BL         {00000000b: 9 points, 00000001b: 8 points}
  mov AL,ClockingMode
  out DX,AX         {fixe la largeur des caractres}
  mov AX,(00000011b shl 8)+Reset
  out DX,AX         {relance le squenceur}
  sti

  mov AX,1000h
  mov BL,13h
  int 10h           {ajuste l'cran horizontalement}
 end;
end; {LargeurCar}

{----------------------------------------------------------}

function PointeurTable(table: BYTE): POINTER; assembler; {VGA}
{renvoie un pointeur sur les matrices de caractres de la table en ROM}
asm
 mov BH,table
 cmp table,courante
 jne @suite
 mov BH,6           {table 8x16}
 cmp hauteur_ecran_txt,25
 je  @suite
 mov BH,2           {table 8x14}
 cmp hauteur_ecran_txt,28
 je  @suite
 mov BH,3           {table 8x8}
@suite:
 push BP
 mov AX,1130h
 int 10h
 mov DX,ES
 mov AX,BP      {DX:AX -> table de caractres en ROM}
 pop BP
end; {PointeurTable}

{----------------------------------------------------------}

procedure AccedeCar; assembler; {VGA}
{autorise l'accs aux tables de caractres en A000:0000
 IMPORTANT! La RAM vido ne peut plus tre adresse en B800}
asm
 cli

 mov DX,Sequencer
 mov AX,(00000100b shl 8)+MapMask
 out DX,AX      {autorise l'accs au plan de bits #2 (table de caractres)}
 mov AX,(00000111b shl 8)+MemoryMode
 out DX,AX      {dsactive le mode Odd/Even (pour lire les octets linairement)}

 mov DX,GraphControl
 mov AX,(00000010b shl 8)+ReadMapSelect
 out DX,AX      {indique le plan de bits #2}
 mov AX,(00000000b shl 8)+GraphicsMode
 out DX,AX      {dsactive le mode Odd/Even}
 mov AX,(00000100b shl 8)+Miscellaneous
 out DX,AX      {indique la taille de la RAM vido en A000: 64ko (8 tables*256 car.*32 lignes)}

 sti
end; {AccedeCar}

{----------------------------------------------------------}

procedure AccedeMem; assembler; {VGA}
{rtablit l'accs  la RAM vido en B800:0000}
asm
 cli

 mov DX,Sequencer
 mov AX,(00000011b shl 8)+MapMask
 out DX,AX      {rtablit l'accs aux plans de bits #0 et #1 (RAM vido: code/attribut)}
 mov AX,(00000011b shl 8)+MemoryMode
 out DX,AX      {ractive le mode Odd/Even (pour lire les octets en alternance)}

 mov DX,GraphControl
 mov AX,(00000000b shl 8)+ReadMapSelect
 out DX,AX      {indique le plan de bits #0}
 mov AX,(00010000b shl 8)+GraphicsMode
 out DX,AX      {ractive le mode Odd/Even}
 mov AX,(00001110b shl 8)+Miscellaneous
 out DX,AX      {indique la taille de la RAM vido en B800: 32ko (8 pages*4000 octets)}

 sti
end; {AccedeMem}

{----------------------------------------------------------}

procedure MotifBinaire(table: BYTE; caractere: CHAR; var motif); assembler; {VGA}
{renvoie dans le tampon 'motif' le motif binaire du caractre
 (compos de hauteur_car octets, du haut vers le bas)  (0  table  7)}
asm
 call AccedeCar

 push DS
 cld

 xor SI,SI
 mov BL,table
 test BL,00000100b  {table>3 ?}
 jz  @suite         {non}
 mov SI,2000h

@suite:
 and BL,00000011b   {BL=(table Modulo 4)}

 mov AL,4000h/256
 mul BL             {AX=64*(table Modulo 4)}
 xchg AH,AL         {AX=4000h*(table Modulo 4)}
 add SI,AX          {SI=offset du dbut de la table}

 xor AH,AH
 mov AL,caractere
 shl AX,5           {AX=32*code}
 add SI,AX          {SI=offset de la ligne 0 du caractre}

 xor CH,CH
 mov CL,hauteur_car
 shr CX,1           {CX=hauteur_car/2}

 mov AX,0A000h
 mov DS,AX          {DS=A000: segment des tables de caractres}

 les DI,motif
 rep movsw

 pop DS

 call AccedeMem
end; {MotifBinaire}

{----------------------------------------------------------}

procedure PointCar(caractere: CHAR; ligne,colonne: BYTE; allume: BOOLEAN); assembler; {VGA}
{allume ou teint un point dans la matrice du caractre (table n0 seulement)
 0  ligne  hauteur_car-1   et   0  colonne  7        25,28,50 lignes
 REMARQUE: ne fonctionne qu'aprs un appel  AccedeCar}
asm
 mov AX,0A000h
 mov ES,AX          {ES=A000: segment des tables de caractres}

 mov CL,colonne
 mov BL,10000000b
 shr BL,CL          {BL=80h shr colonne: masque de bits pour l'criture}

 xor AH,AH
 mov AL,caractere
 shl AX,5
 add AL,ligne       {AL=32*code_ascii+ligne}
 mov DI,AX          {DI=offset ligne}
 mov AL,ES:[DI]     {AL=motif binaire de la ligne}

 cmp allume,TRUE
 jne @eteint_point
 or  AL,BL          {allume le point}
 jmp @ecrit_motif
@eteint_point:
 not BL
 and AL,BL          {teint le point}
@ecrit_motif:
 mov ES:[DI],AL     {crit le motif binaire de la ligne}
end; {PointCar}

{----------------------------------------------------------}

procedure LigneCar(caractere: CHAR; ligne: BYTE; allume: BOOLEAN); assembler; {VGA}
{allume ou teint une ligne dans la matrice du caractre (table n0 seulement)
 0  ligne  hauteur_car-1      25,28,50 lignes
 REMARQUE: ne fonctionne qu'aprs un appel  AccedeCar}
asm
 mov AX,0A000h
 mov ES,AX          {ES=A000: segment des tables de caractres}

 xor AH,AH
 mov AL,caractere
 shl AX,5
 add AL,ligne       {AL=32*code_ascii+ligne}
 mov DI,AX          {DI=offset ligne}

 mov AL,allume
 neg AL             {AL=motif binaire d'une ligne: si allume=TRUE->FFh, sinon 00h}
 mov ES:[DI],AL     {crit le motif binaire de la ligne}
end; {LigneCar}

{----------------------------------------------------------}

procedure ColonneCar(caractere: CHAR; colonne: BYTE; allume: BOOLEAN); assembler; {VGA}
{allume ou teint une colonne dans la matrice du caractre (table n0 seulement)
 0  colonne  7        25,28,50 lignes
 REMARQUE: ne fonctionne qu'aprs un appel  AccedeCar}
asm
 mov AX,0A000h
 mov ES,AX          {ES=A000: segment des tables de caractres}

 xor AH,AH
 mov AL,caractere
 shl AX,5
 mov DI,AX          {DI=32*code_ascii: offset ligne 0 du caractre}

 mov CL,colonne
 mov BL,10000000b
 shr BL,CL          {BL=80h shr colonne: masque de bits pour l'criture}

 cld
 mov CL,hauteur_car

 cmp allume,TRUE
 je  @allume_colonne

 not BL
@eteint_colonne:
 mov AL,ES:[DI]     {AL=motif binaire de la ligne}
 and AL,BL          {teint un point}
 stosb              {crit le motif binaire de la ligne}
 dec CL
 jnz @eteint_colonne
 jmp @fin

@allume_colonne:
 mov AL,ES:[DI]     {AL=motif binaire de la ligne}
 or  AL,BL          {allume un point}
 stosb              {crit le motif binaire de la ligne}
 dec CL
 jnz @allume_colonne

@fin:
end; {ColonneCar}

{----------------------------------------------------------}

procedure RedefCar(table: BYTE; premier_car: CHAR; nombre: WORD; var motif; mode: BYTE); {VGA}
{redfinit 'nombre' caractres conscutifs  partir de 'premier_car',
 (0  table  7) en utilisant des motifs conscutifs:

 -si mode=ascii, chaque motif doit tre de type Ascii__
                                                     
                                      'hauteur_car' 
   Les caractres contenus dans le motif peuvent tre:
     -un espace (#32) ou un Null (#0), si le point est teint
     -un caractre>#32, si le point est allum

 -si mode=binaire, chaque motif doit tre de type Binaire__
                                                         
                                          'hauteur_car' 

 REMARQUE: En mode 9 pixels, pour les caractres dont le code ASCII est
           compris entre 192 (C0h) et 223 (DFh), la 8me colonne est copie
           automatiquement dans la 9me}

var motif_binaire: array[BYTE] of Binaire16; {256 caractres maxi}
    ptr_motif: POINTER;

begin
 AccedeCar;
 if mode=ascii then ptr_motif:=@motif_binaire else ptr_motif:=@motif;
 asm
  push DS
  cld

  cmp mode,ascii      {mode ASCII?}
  jne @suite          {non, mode binaire -> pas de conversion de motif}

  mov DH,BYTE(nombre)
  mov CH,hauteur_car
  lds SI,motif        {DS:SI -> motif (ASCII)}
  les DI,ptr_motif    {ES:DI -> motif_binaire}

 @boucle_caractere:
  @boucle_ligne:
   xor DL,DL          {masque de bits=0}
   mov CL,8           {CL=largeur du motif d'une ligne (8 bits)}
   @boucle_colonne:
    shl DL,1          {dcale le masque de bits  gauche}
    lodsb             {charge un caractre du motif ASCII}
    cmp AL,' '        {espace ou infrieur?}
    jbe @pas_point    {oui}
    or  DL,00000001b  {met le bit 0 du masque  1}
   @pas_point:
    dec CL
    jnz @boucle_colonne
   mov AL,DL
   stosb              {crit le masque dans motif_binaire}
   dec CH
   jnz @boucle_ligne
  dec DH
  jnz @boucle_caractere

 @suite:
  mov AX,0A000h
  mov ES,AX          {ES=A000: segment des tables de caractres}

  xor DI,DI
  mov BL,table
  test BL,00000100b  {table>3 ?}
  jz  @suite2        {non}
  mov DI,2000h

  @suite2:
  and BL,00000011b   {BL=(table Modulo 4)}

  mov AL,4000h/256
  mul BL             {AX=64*(table Modulo 4)}
  xchg AH,AL         {AX=4000h*(table Modulo 4)}
  add DI,AX          {DI=offset du dbut de la table}

  xor AH,AH
  mov AL,premier_car
  shl AX,5           {AX=32*premier_code}
  add DI,AX          {DI=offset de la ligne 0 du premier caractre}

  xor AH,AH
  mov AL,hauteur_car
  shr AX,1           {AX=hauteur_car/2}

  mov DX,32
  sub DL,hauteur_car {DX=32-hauteur_car: incrment DI}

  lds SI,ptr_motif

  mov BX,nombre
 @boucle_redef:
  mov CX,AX
  rep movsw          {redfinit un caractre}
  add DI,DX          {DI=offset de la ligne 0 du caractre suivant}
  dec BX
  jnz @boucle_redef

  pop DS
 end;
 AccedeMem;
end; {RedefCar}

{----------------------------------------------------------}

procedure ChargeFonte(table: BYTE; var buffer); assembler; {VGA}
{charge le motif des 256 caractres dans un tampon}
asm
 call AccedeCar

 mov CH,hauteur_car

 push DS
 cld

 mov AX,0A000h
 mov DS,AX          {DS=A000: segment des tables de caractres}

 xor SI,SI
 mov BL,table
 test BL,00000100b  {table>3 ?}
 jz  @suite         {non}
 mov SI,2000h

@suite:
 and BL,00000011b   {BL=(table Modulo 4)}

 mov AL,4000h/256
 mul BL             {AX=64*(table Modulo 4)}
 xchg AH,AL         {AX=4000h*(table Modulo 4)}
 add SI,AX          {SI=offset de la ligne 0 du caractre 0}

 xor AH,AH
 mov AL,CH
 shr AX,1           {AX=hauteur_car/2}

 mov DX,32
 sub DL,CH          {DX=32-hauteur_car: incrment SI}

 les DI,buffer

 mov BX,256
@boucle_charge:
 mov CX,AX
 rep movsw          {redfinit un caractre}
 add SI,DX          {SI=offset de la ligne 0 du caractre suivant}
 dec BX
 jnz @boucle_charge

 pop DS

 call AccedeMem
end; {ChargeFonte}

{----------------------------------------------------------}

procedure RedefFonte(table: BYTE; var buffer); assembler; {VGA}
{redfinit le motif des 256 caractres depuis un tampon}
asm
 call AccedeCar

 push DS
 cld

 mov AX,0A000h
 mov ES,AX          {ES=A000: segment des tables de caractres}

 xor DI,DI
 mov BL,table
 test BL,00000100b  {table>3 ?}
 jz  @suite         {non}
 mov DI,2000h

@suite:
 and BL,00000011b   {BL=(table Modulo 4)}

 mov AL,4000h/256
 mul BL             {AX=64*(table Modulo 4)}
 xchg AH,AL         {AX=4000h*(table Modulo 4)}
 add DI,AX          {DI=offset de la ligne 0 du caractre 0}

 xor AH,AH
 mov AL,hauteur_car
 shr AX,1           {AX=hauteur_car/2}

 mov DX,32
 sub DL,hauteur_car {DX=32-hauteur_car: incrment DI}

 lds SI,buffer

 mov BX,256
@boucle_charge:
 mov CX,AX
 rep movsw          {redfinit un caractre}
 add DI,DX          {DI=offset de la ligne 0 du caractre suivant}
 dec BX
 jnz @boucle_charge

 pop DS

 call AccedeMem
end; {RedefFonte}

{----------------------------------------------------------}

procedure ChargeFonte_(nom_fichier: String80; hauteur: BYTE; var buffer; var erreur: WORD); {VGA}
{charge la fonte de 256 caractres (16,14 ou 8 pixels) depuis le disque}
var f: Fichier;
begin
 with f do begin
  Ouvre(lecture,nom_fichier);
  if f_erreur=f_ok then begin
   erreur:=0;
   if (Taille=256*hauteur) then Lit(buffer,256*hauteur) else erreur:=err_format;
   Ferme;
   if erreur=err_format then exit;
  end;
 end;
 erreur:=f_erreur;
end; {ChargeFonte_}

{----------------------------------------------------------}

procedure SauveFonte_(nom_fichier: String80; hauteur: BYTE; var buffer; var erreur: WORD); {VGA}
{sauve la fonte de 256 caractres (16,14 ou 8 pixels) sur disque}
var f: Fichier;
begin
 with f do begin
  Cree(not(teste_existe),nom_fichier);
  if f_erreur=f_ok then begin Ecrit(buffer,256*hauteur); Ferme end;
 end;
 erreur:=f_erreur;
end; {SauveFonte_}

{----------------------------------------------------------}

procedure Fonte16.Charge(table: BYTE); {VGA}
begin
 ChargeFonte(table,fonte);
end; {Fonte16.Charge}

procedure Fonte16.Redef(table: BYTE); {VGA}
begin
 RedefFonte(table,fonte);
end; {Fonte16.Redef}

procedure Fonte16.Charge_(nom_fichier: String80; var erreur: WORD); {VGA}
begin
 ChargeFonte_(nom_fichier,16,fonte,erreur);
end; {Fonte16.Charge_}

procedure Fonte16.Sauve_(nom_fichier: String80; var erreur: WORD); {VGA}
begin
 SauveFonte_(nom_fichier,16,fonte,erreur);
end; {Fonte16.Sauve_}

{----------------------------------------------------------}

procedure Fonte14.Charge(table: BYTE); {VGA}
begin
 ChargeFonte(table,fonte);
end; {Fonte14.Charge}

procedure Fonte14.Redef(table: BYTE); {VGA}
begin
 RedefFonte(table,fonte);
end; {Fonte14.Redef}

procedure Fonte14.Charge_(nom_fichier: String80; var erreur: WORD); {VGA}
begin
 ChargeFonte_(nom_fichier,14,fonte,erreur);
end; {Fonte14.Charge_}

procedure Fonte14.Sauve_(nom_fichier: String80; var erreur: WORD); {VGA}
begin
 SauveFonte_(nom_fichier,14,fonte,erreur);
end; {Fonte14.Sauve_}

{----------------------------------------------------------}

procedure Fonte8.Charge(table: BYTE); {VGA}
begin
 ChargeFonte(table,fonte);
end; {Fonte8.Charge}

procedure Fonte8.Redef(table: BYTE); {VGA}
begin
 RedefFonte(table,fonte);
end; {Fonte8.Redef}

procedure Fonte8.Charge_(nom_fichier: String80; var erreur: WORD); {VGA}
begin
 ChargeFonte_(nom_fichier,8,fonte,erreur);
end; {Fonte8.Charge_}

procedure Fonte8.Sauve_(nom_fichier: String80; var erreur: WORD); {VGA}
begin
 SauveFonte_(nom_fichier,8,fonte,erreur);
end; {Fonte8.Sauve_}

{----------------------------------------------------------}

procedure ScrolleVertical(ligne: BYTE); assembler; {VGA}
{place l'adresse de base de la RAM vido sur la 1re colonne de la ligne}
asm
 cli
 mov DX,CRTControl
 xor AH,AH
 mov AL,largeur_ecran_txt
 xor BH,BH
 mov BL,ligne
 dec BL
 mul BL              {AX=largeur_ecran_txt*(ligne-1)}
 mov BL,AL
 mov AL,StartAddrHigh
 out DX,AX           {crit poids fort dcalage}
 mov AH,BL
 mov AL,StartAddrLow
 out DX,AX           {crit poids faible dcalage}
 sti
end; {ScrolleVertical}

{----------------------------------------------------------}

procedure ScrolleHorizontal(colonne: BYTE); assembler; {VGA}
{place l'adresse de base de la RAM vido sur la colonne de la 1re ligne}
asm
 cli
 mov DX,CRTControl
 mov AL,StartAddrHigh
 mov AH,0           {poids fort dcalage}
 out DX,AX
 mov AL,StartAddrLow
 mov AH,colonne
 dec AH             {poids faible dcalage}
 out DX,AX
 sti
end; {ScrolleHorizontal}

{----------------------------------------------------------}

procedure PlaceEcran(xg,yh: WORD); assembler; {VGA}
{place l'adresse de base de la RAM vido sur (xg,yh) - en pixels -
 (0,0): adresse normale
 Pour se dplacer d'un caractre horizontalement, ajouter largeur_car  xg
 Pour se dplacer d'un caractre verticalement, ajouter hauteur_car  yh}
asm
 cli                 {vite les 'sauts' si une touche est appuye, par ex.}
 call AttendVBL
 call AttendFinHBL

 mov AX,yh
 mov CH,hauteur_car
 div CH              {AL=yh/hauteur_car, AH=yh Modulo hauteur_car}

 mov CH,AH           {CH=yh Modulo hauteur_car}

 mul largeur_ecran_txt  {AX=largeur_ecran_txt*(yh/hauteur_car)}
 mov BX,AX
 mov AX,xg
 mov CL,largeur_car
 div CL              {AL=xg/largeur_car, AH=xg Modulo largeur_car}

 mov CL,AH           {CL=xg Modulo largeur_car}

 xor AH,AH
 add AX,BX           {AX=(xg/largeur_car)+largeur_ecran_txt*(yh/hauteur_car)}
 mov BL,AL

 mov DX,CRTControl
 mov AL,StartAddrHigh
 out DX,AX           {crit poids fort dcalage}
 mov AH,BL
 mov AL,StartAddrLow
 out DX,AX           {crit poids faible dcalage}

 mov DX,CRTControl
 mov AH,CH           {AH=yh Modulo hauteur_car: dcalage vertical}
 mov AL,VPelPanning
 out DX,AX           {fait un smooth vertical}

 mov DX,AttrControl
 mov AL,HPelPanning or 00100000b   {bit 5  1 sinon cran noir!}
 out DX,AL

 mov AL,CL           {AL=xg Modulo largeur_car: dcalage horizontal}
 or  AL,AL
 jnz @pas_nul
 mov AL,8+1
@pas_nul:
 dec AL
 out DX,AL           {fait un smooth horizontal}

 sti                 {autorise les interruptions}
end; {PlaceEcran}

{----------------------------------------------------------}

procedure CursXY(page,x,y: BYTE); assembler;
{quivalent de GotoXY multi-page en mode 25,28,50 lignes}
asm
 mov AH,2
 mov BH,page
 mov DH,y
 dec DH
 mov DL,x
 dec DL
 int 10h
end; {CursXY}

{----------------------------------------------------------}

function PosX(page: BYTE): BYTE; assembler;
{renvoie l'abscisse du curseur clignotant dans la page}
asm
 mov AH,3
 mov BH,page
 int 10h
 inc DL
 mov AL,DL
end; {PosX}

{----------------------------------------------------------}

function PosY(page: BYTE): BYTE; assembler;
{renvoie l'ordonne du curseur clignotant dans la page}
asm
 mov AH,3
 mov BH,page
 int 10h
 inc DH
 mov AL,DH
end; {PosY}

{----------------------------------------------------------}

function PtrVRAM(page,x,y: BYTE): WordPtr; assembler;
{renvoie un pointeur sur la mmoire vido en (x,y)}
asm
 xor AH,AH
 mov AL,page
 mul delta_segment_VRAM
 add AX,0B800h
 mov ES,AX           {ES=B800+delta_segment_VRAM*page}

 xor AH,AH
 mov AL,x
 mov BX,AX
 dec BX              {BX=x-1}
 mov AL,y
 dec AL
 mul largeur_ecran_txt  {AX=largeur_ecran_txt*(y-1)}
 add AX,BX
 shl AX,1            {AX=2*((x-1)+largeur_ecran_txt*(y-1))}
 mov DX,ES
end; {PtrVRAM}

{----------------------------------------------------------}

procedure AffCarXY(page,x,y: BYTE; caractere: CHAR; attr: BYTE);
{affiche un caractre en (x,y)}
var ptr_VRAM: POINTER;
begin
 ptr_VRAM:=PtrVRAM(page,x,y);
 asm
  les DI,ptr_VRAM
  mov AH,attr
  mov AL,caractere
  mov ES:[DI],AX
 end;
end; {AffCarXY}

{----------------------------------------------------------}

procedure AffChXY(page,x,y: BYTE; chaine: STRING; attr: BYTE);
{affiche une chane en (x,y)}
var ptr_VRAM: POINTER;
begin
 ptr_VRAM:=PtrVRAM(page,x,y);
 asm
  push DS
  cld

  les DI,ptr_VRAM
  push SS
  pop DS
  lea SI,chaine
  lodsb               {AL=longueur chane}
  or  AL,AL
  jz  @fin            {chane vide}
  mov AH,attr
  mov BL,AL

 @affiche_car:
  lodsb               {AL=code ASCII}
  stosw               {affiche un caractre}
  dec BL
  jnz @affiche_car

 @fin:
  pop DS
 end;
end; {AffChXY}

{----------------------------------------------------------}

procedure AffChXY2(page,x,y: BYTE; chaine: STRING; attr_ext,attr_int: BYTE);
{affiche une chane avec l'attribut 'attr_ext', sauf les portions de chane
 dlimites par des '^' qui sont affiches avec l'attribut 'attr_int'}
var ptr_VRAM: POINTER;
begin
 ptr_VRAM:=PtrVRAM(page,x,y);
 asm
  push DS
  cld

  les DI,ptr_VRAM
  push SS
  pop DS
  lea SI,chaine
  lodsb               {AL=longueur chane}
  or  AL,AL
  jz  @fin            {chane vide}

  mov AH,attr_ext     {AH=attribut couleur par dfaut}
  mov BH,attr_int     {BH=attribut 2me couleur}
  mov BL,AL

 @affiche_car:
  lodsb               {AL=code ASCII}
  cmp AL,'^'          {caractre de contrle '^' ?}
  je  @echange_attr   {oui}
  stosw               {affiche un caractre}
  jmp @suite
 @echange_attr:
  xchg AH,BH          {change attr_ext et attr_int}
 @suite:
  dec BL
  jnz @affiche_car

 @fin:
  pop DS
 end;
end; {AffChXY2}

{----------------------------------------------------------}

procedure AffChXYmc(page,x,y: BYTE; chaine: STRING);
{affiche une chane avec plusieurs attributs de couleur, selon le format:
  caractre de contrle: '^', suivi par la valeur de l'attribut: 0..255 }
var ptr_VRAM: POINTER;
begin
 ptr_VRAM:=PtrVRAM(page,x,y);
 asm
  push DS
  cld

  les DI,ptr_VRAM
  push SS
  pop DS
  lea SI,chaine
  lodsb               {AL=longueur chane}
  or  AL,AL
  jz  @fin            {chane vide}

  mov BL,AL

 @affiche_chaine:
  lodsb               {AL=code ASCII}
  cmp AL,'^'
  jne @affiche_car
  dec BL
  lodsb               {AL=attribut}
  mov AH,AL
  jmp @suite
 @affiche_car:
  stosw
 @suite:
  dec BL
  jnz @affiche_chaine

 @fin:
  pop DS
 end;
end; {AffChXYmc}

{----------------------------------------------------------}

procedure AffCar(caractere: CHAR); assembler;
{affiche un caractre  la position courante (AdrTexte) et avec l'attribut courant (AttrTexte)
 puis incrmente la position courante}
asm
 les DI,AdrTexte
 mov AH,AttrTexte
 mov AL,caractere
 mov ES:[DI],AX
 add WORD(AdrTexte),2
end; {AffCar}

{----------------------------------------------------------}

procedure AffCh(chaine: STRING); assembler;
{affiche une chane  la position courante (AdrTexte) et avec l'attribut courant (AttrTexte)
 puis dplace la position courante  la fin de la chane}
asm
 push DS
 cld

 les DI,AdrTexte
 mov AH,AttrTexte
 lds SI,chaine
 lodsb               {AL=longueur chane}
 xor DH,DH
 mov DL,AL
 shl DX,1
 jz  @fin            {chane vide}
 mov BL,AL

@affiche_car:
 lodsb               {AL=code ASCII}
 stosw               {affiche un caractre}
 dec BL
 jnz @affiche_car

@fin:
 pop DS

 add WORD(AdrTexte),DX
end; {AffCh}

{----------------------------------------------------------}

procedure AffChE(chaine: STRING; caractere: CHAR; longueur: BYTE); assembler;
{affiche une chane  la position courante (AdrTexte) et avec l'attribut courant (AttrTexte)
 puis dplace la position courante  la fin de la chane
 l'affichage est limit  'longueur' caractres: si la chane est plus
 courte, l'affichage est complt par 'caractere'

 c'est un raccourci pour AffCh(XString(chaine,caractere,longueur))}
asm
 push DS
 cld

 les DI,AdrTexte
 mov AH,AttrTexte
 lds SI,chaine
 lodsb              {AL=longueur chane}
 mov BL,AL
 mov DL,longueur
 mov CL,DL
 sub CL,AL
 jns @affiche_ch

 mov BL,DL
 xor CL,CL

@affiche_ch:
 or  BL,BL
 jz  @suite

@affiche_car:
 lodsb
 stosw
 dec BL
 jnz @affiche_car

@suite:
 xor CH,CH
 mov AL,caractere
 rep stosw

 pop DS

 xor DH,DH
 shl DX,1
 add WORD(AdrTexte),DX
end; {AffChE}

{----------------------------------------------------------}

procedure LigneHorizontale(page,epaisseur,y,xg,xd,attr: BYTE);
var ptr_VRAM: POINTER;
begin
 if xd<xg then exit;

 ptr_VRAM:=PtrVRAM(page,xg,y);
 asm
  les DI,ptr_VRAM
  mov AH,attr
  mov AL,''        {par dfaut, paisseur=1}
  cmp epaisseur,1
  je  @suite
  mov AL,''
 @suite:
  xor CH,CH
  mov CL,xd
  sub CL,xg
  inc CL            {CX=xd-xg+1}
  cld
  rep stosw         {affiche ligne}
 end;
end; {LigneHorizontale}

{----------------------------------------------------------}

procedure LigneVerticale(page,epaisseur,x,yh,yb,attr: BYTE);
var ptr_VRAM: POINTER;
begin
 if yb<yh then exit;

 ptr_VRAM:=PtrVRAM(page,x,yh);
 asm
  les DI,ptr_VRAM
  xor DH,DH
  mov DL,largeur_ecran_txt
  dec DL
  shl DX,1            {incrment DI: DX=2*(largeur_ecran_txt-1)}
  mov AH,attr
  mov AL,''          {par dfaut, paisseur=1}
  cmp epaisseur,1
  je  @suite
  mov AL,''
 @suite:
  mov CL,yb
  sub CL,yh
  inc CL              {CL=yb-yh+1}
  cld
 @affiche_ligne:
  stosw
  add DI,DX
  dec CL
  jnz @affiche_ligne
 end;
end; {LigneVerticale}

{----------------------------------------------------------}

procedure Cadre(page,epaisseur,xg,yh,xd,yb,attr: BYTE; titre: STRING; attr_titre: BYTE; touches: String25);
{trace un cadre de coordonnes (xg,yh,xd,yb), d'paisseur 1 ou 2, avec la couleur 'attr'
 -le titre est centr en haut du cadre, affich avec la couleur 'attr_titre'
 -la chane 'touches' est affiche dans le coin infrieur droit du cadre}

const coin1: array[1..2] of CHAR=('','');
      coin2: array[1..2] of CHAR=('','');
      coin3: array[1..2] of CHAR=('','');
      coin4: array[1..2] of CHAR=('','');
      horiz: array[1..2] of CHAR=('','');

var n: BYTE;

begin
 if xg>xd then begin n:=xg; xg:=xd; xd:=n end;
 if yh>yb then begin n:=yh; yh:=yb; yb:=n end;
 if (xd>xg) and (yb>yh) then begin
  n:=(xd-xg-1)-Length(titre);
  AffCarXY(page,xg,yh,coin1[epaisseur],attr);
  LigneHorizontale(page,epaisseur,yh,xg+1,xg+(n shr 1),attr);
  LigneHorizontale(page,epaisseur,yh,xd-n+(n shr 1),xd-n-1+(n and $FE),attr);
  if Odd(n) then AffChXY (page,xd-n+(n and $FE),yh,horiz[epaisseur]+coin2[epaisseur],attr)
            else AffCarXY(page,xd-n+(n and $FE),yh,coin2[epaisseur],attr);
  LigneVerticale(page,epaisseur,xg,yh+1,yb-1,attr);
  LigneVerticale(page,epaisseur,xd,yh+1,yb-1,attr);
  AffCarXY(page,xg,yb,coin3[epaisseur],attr);
  LigneHorizontale(page,epaisseur,yb,xg+1,xd-1,attr);
  AffCarXY(page,xd,yb,coin4[epaisseur],attr);
  AffChXY(page,xg+(n shr 1)+1,yh,titre,attr_titre);
  AffChXY(page,xd-1-Length(touches),yb,touches,attr);
 end
 else
  if xg=xd then LigneVerticale(page,epaisseur,xg,yh,yb,attr)
           else if yh=yb then LigneHorizontale(page,epaisseur,yh,xg,xd,attr);
end; {Cadre}

{----------------------------------------------------------}

function CodeXY(page,x,y: BYTE): BYTE;
{renvoie le code ASCII du caractre en (x,y)}
begin
 CodeXY:=BytePtr(PtrVRAM(page,x,y))^;
end; {CodeXY}

{----------------------------------------------------------}

function AttrXY(page,x,y: BYTE): BYTE;
{renvoie l'attribut du caractre en (x,y)}
begin
 AttrXY:=Hi(WordPtr(PtrVRAM(page,x,y))^);
end; {AttrXY}

{----------------------------------------------------------}

procedure Transfert(sens: SHORTINT;
                    source: POINTER; delta_source: INTEGER;
                    destination: POINTER; delta_dest: INTEGER; Ncol,Nlig: BYTE); assembler;
asm
 push DS
 cld
 cmp sens,+1
 je  @suite    {croissant}
 std
@suite:
 lds SI,source
 les DI,destination
 mov AX,delta_source
 mov DX,delta_dest
 mov BL,Ncol
 mov BH,Nlig
 xor CH,CH
@copie:
 mov CL,BL
 rep movsw
 add SI,AX
 add DI,DX
 dec BH
 jnz @copie
 pop DS
end; {Transfert}

{----------------------------------------------------------}

procedure Zone.Sauve(page: BYTE; xg,yh,xd,yb: INTEGER);
{sauve une zone de l'cran (les coordonnes peuvent sortir des limites)}
var L,H,Ncol,Nlig: BYTE;
    xg_zone,yh_zone,xd_zone,yb_zone: INTEGER;
    DI: WORD;
begin
 if (xd<xg) or (yb<yh) then begin taille_octets:=0; exit end;

 L:=xd-xg+1; H:=yb-yh+1; taille_octets:=2*L*H;
 xg_:=xg; yh_:=yh; xd_:=xd; yb_:=yb;
 GetMem(contenu,taille_octets);
 xg_zone:=MaxEntier(1,xg); xd_zone:=MinEntier(largeur_ecran_txt,xd);
 yh_zone:=MaxEntier(1,yh); yb_zone:=MinEntier(hauteur_ecran_txt,yb);
 if (xd_zone<xg_zone) or (yb_zone<yh_zone) then exit; {zone hors cran}

 Ncol:=xd_zone-xg_zone+1; Nlig:=yb_zone-yh_zone+1;
 DI:=0;
 if yh<1 then inc(DI,2*(1-yh)*L);
 if xg<1 then inc(DI,2*(1-xg));
 Transfert(+1,PtrVRAM(page,xg_zone,yh_zone),2*(largeur_ecran_txt-Ncol),AddPtr(contenu,DI),2*(L-Ncol),Ncol,Nlig);
end; {Zone.Sauve}

{----------------------------------------------------------}

procedure Zone.Ombre(page: BYTE; xg,yh,xd,yb: INTEGER; attr: BYTE);
{sauve une zone et affiche un rectangle d'attribut 'attr' avec une ombre sur
 les bords gauche et infrieur}
var ombre_horiz,ombre_vertic: Zone;
begin
 Zone.Sauve(page,xg,yh,xd+2,yb+1);
 with ombre_horiz do
  begin Sauve(page,xg+2,yb+1,xd+2,yb+1); Restaure(page,0,0,8); Supprime end;
 with ombre_vertic do
  begin Sauve(page,xd+1,yh+1,xd+2,yb); Restaure(page,0,0,8); Supprime end;
 EffaceZone(page,MaxEntier(1,xg),MaxEntier(1,yh),
                 MinEntier(largeur_ecran_txt,xd),MinEntier(hauteur_ecran_txt,yb),attr);
end; {Zone.Ombre}

{----------------------------------------------------------}

procedure Zone.RestaureLimite(page: BYTE; x,y: INTEGER; xg,yh,xd,yb: BYTE);
{affiche la zone en (x,y) dans les limites de la fentre (xg,yh,xd,yb)}
var L,H,Ncol,Nlig: BYTE;
    xg_zone,yh_zone,xd_zone,yb_zone: INTEGER;
    SI: WORD;
begin
 L:=xd_-xg_+1; H:=yb_-yh_+1;
 xg_zone:=MaxEntier(xg,x); xd_zone:=MinEntier(xd,x+L-1);
 yh_zone:=MaxEntier(yh,y); yb_zone:=MinEntier(yb,y+H-1);
 if (xd_zone<xg_zone) or (yb_zone<yh_zone) then exit; {zone hors cran}

 Ncol:=xd_zone-xg_zone+1; Nlig:=yb_zone-yh_zone+1;
 SI:=0;
 if y<yh then inc(SI,2*(yh-y)*L);
 if x<xg then inc(SI,2*(xg-x));
 Transfert(+1,AddPtr(contenu,SI),2*(L-Ncol),PtrVRAM(page,xg_zone,yh_zone),2*(largeur_ecran_txt-Ncol),Ncol,Nlig);
end; {Zone.RestaureLimite}

{----------------------------------------------------------}

procedure Zone.Restaure(page: BYTE; dx,dy: SHORTINT; attr: BYTE);
{restaure la zone avec un dplacement ventuel (dx,dy)
 -si attr=0, les couleurs d'origine sont conserves
 -sinon, la zone est restaure avec l'attribut 'attr'}
var ptr_contenu: POINTER;
    taille_octets_: WORD;
begin
 if taille_octets=0 then exit;

 if attr<>0 then begin
  ptr_contenu:=contenu; taille_octets_:=taille_octets;
  asm
   les DI,ptr_contenu
   inc DI              {ES:DI -> premier attribut  changer}
   cld
   mov CX,taille_octets_
   shr CX,1            {CX=nombre caractres}
   mov AL,attr
  @ecrit_attr:
   stosb               {crit attribut}
   inc DI              {saute code ASCII}
   dec CX
   jnz @ecrit_attr
  end;
 end;
 Zone.RestaureLimite(page,xg_+dx,yh_+dy,1,1,largeur_ecran_txt,hauteur_ecran_txt);
end; {Zone.Restaure}

{----------------------------------------------------------}

procedure Zone.DeplaceLimite(page: BYTE; dx,dy: SHORTINT; var zone_cachee: Zone; xg,yh,xd,yb: BYTE);
{dplace une zone sur l'cran dans les limites (xg,yh,xd,yb) et modifie ses
 coordonnes; zone_cachee doit dj contenir le fond reconvert}
begin
 with zone_cachee do
  begin RestaureLimite(page,xg_,yh_,xg,yh,xd,yb); Supprime; Sauve(page,xg_+dx,yh_+dy,xd_+dx,yb_+dy) end;
 inc(xg_,dx); inc(xd_,dx); inc(yh_,dy); inc(yb_,dy);
 Zone.RestaureLimite(page,xg_,yh_,xg,yh,xd,yb);
end; {Zone.DeplaceLimite}

{----------------------------------------------------------}

procedure Zone.Deplace(page: BYTE; dx,dy: SHORTINT; var zone_cachee: Zone);
{dplace une zone dans les limites de l'cran et modifie ses coordonnes;
 zone_cachee doit dj contenir le fond reconvert}
var SI,DI: WORD;
    L,H,LI,HI,x,y: BYTE;
    sens_copie: SHORTINT;
    ptr_contenu: POINTER;
    delta_L,delta_dx,delta_copie: INTEGER;
begin
 L:=xd_-xg_+1; H:=yb_-yh_+1;

 if (Abs(dx)<L) and (Abs(dy)<H) then begin  {intersection}
  LI:=L-Abs(dx); HI:=H-Abs(dy);
  ptr_contenu:=zone_cachee.contenu;

  {restaure}
  if dy<>0 then begin
   SI:=0; delta_L:=2*(largeur_ecran_txt-L);
   if dy>0 then begin y:=yh_ end else begin inc(SI,2*HI*L); y:=yb_+dy+1 end;
   Transfert(+1,AddPtr(ptr_contenu,SI),0,PtrVRAM(page,xg_,y),delta_L,L,Abs(dy))
  end;
  if dx<>0 then begin
   SI:=0; y:=yh_; delta_dx:=2*(largeur_ecran_txt-Abs(dx));
   if dx>0 then x:=xg_ else begin x:=xd_+dx+1; inc(SI,2*LI) end;
   if dy>0 then begin inc(SI,2*L*dy); inc(y,dy) end;
   Transfert(+1,AddPtr(ptr_contenu,SI),2*LI,PtrVRAM(page,x,y),delta_dx,Abs(dx),HI)
  end;

  {copie}
  if dy=0 then sens_copie:=Sgn(dx) else sens_copie:=Sgn(dy);
  if dx*dy>=0 then begin SI:=2*dx; DI:=0 end else begin SI:=0; DI:=-2*dx end;
  if dy<>0 then inc(SI,2*L*dy);
  if sens_copie=-1 then begin inc(SI,taille_octets-2); inc(DI,taille_octets-2) end;
  delta_copie:=2*Abs(dx)*sens_copie;
  Transfert(sens_copie,AddPtr(ptr_contenu,SI),delta_copie,AddPtr(ptr_contenu,DI),delta_copie,LI,HI);

  {sauve}
  if dy<>0 then begin
   if dy>0 then begin DI:=2*HI*L; y:=yb_+1 end else begin DI:=0; y:=yh_+dy end;
   Transfert(+1,PtrVRAM(page,xg_+dx,y),delta_L,AddPtr(ptr_contenu,DI),0,L,Abs(dy))
  end;
  if dx<>0 then begin
   DI:=0; y:=yh_;
   if dx>0 then begin x:=xd_+1; inc(DI,2*LI) end else x:=xg_+dx;
   if dy<0 then inc(DI,-2*L*dy) else inc(y,dy);
   Transfert(+1,PtrVRAM(page,x,y),delta_dx,AddPtr(ptr_contenu,DI),2*LI,Abs(dx),HI)
  end;

  with zone_cachee do begin inc(xg_,dx); inc(xd_,dx); inc(yh_,dy); inc(yb_,dy) end;
 end
 else  {pas d'intersection}
  with zone_cachee do
   begin Restaure(page,0,0,0); Supprime; Sauve(page,xg_+dx,yh_+dy,xd_+dx,yb_+dy) end;

 inc(xg_,dx); inc(xd_,dx); inc(yh_,dy); inc(yb_,dy);
 Zone.Restaure(page,0,0,0);
end; {Zone.Deplace}

{----------------------------------------------------------}

procedure Zone.Supprime;
begin
 if taille_octets>0 then FreeMem(contenu,taille_octets);
end; {Zone.Supprime}

{----------------------------------------------------------}

procedure Zone.Charge_(nom_fichier: String80; var erreur: WORD);
var f: Fichier;
begin
 with f do begin
  Ouvre(lecture,nom_fichier);
  if f_erreur=f_ok then begin
   erreur:=0;
   Lit(xg_,2); Lit(yh_,2); Lit(xd_,2); Lit(yb_,2);
   taille_octets:=2*(xd_-xg_+1)*(yb_-yh_+1);
   if (2*4+taille_octets<>Taille) or
      (xg_>xd_) or (yh_>yb_) or
      (xd_>largeur_ecran_max) or (yb_>hauteur_ecran_max) then erreur:=err_format
   else begin
    GetMem(contenu,taille_octets);
    Lit(contenu^,taille_octets);
   end;
   Ferme;
   if erreur=err_format then exit;
  end;
 end;
 erreur:=f_erreur;
end; {Zone.Charge_}

{----------------------------------------------------------}

procedure Zone.Sauve_(nom_fichier: String80; var erreur: WORD);
var f: Fichier;
begin
 with f do begin
  Cree(not(teste_existe),nom_fichier);
  if f_erreur=f_ok then begin
   Ecrit(xg_,2); Ecrit(yh_,2); Ecrit(xd_,2); Ecrit(yb_,2); {entte}
   Ecrit(contenu^,taille_octets);
   Ferme;
  end;
 end;
 erreur:=f_erreur;
end; {Zone.Sauve_}

{----------------------------------------------------------}

procedure Ecran.Sauve(page: BYTE);
{sauve la page dans un cran (25,28,50 lignes) SANS COLONNES VIRTUELLES (80!)}
begin
 New(contenu);
 Transfert(+1,PtrVRAM(page,1,1),0,contenu,0,largeur_ecran_txt,hauteur_ecran_txt);
end; {Ecran.Sauve}

{----------------------------------------------------------}

procedure Ecran.Restaure(page: BYTE);
{restaure l'cran sur une page SANS COLONNES VIRTUELLES (80!)}
begin
 Transfert(+1,contenu,0,PtrVRAM(page,1,1),0,largeur_ecran_txt,hauteur_ecran_txt);
end; {Ecran.Restaure}

{----------------------------------------------------------}

procedure Ecran.Supprime;
begin
 Dispose(contenu);
end; {Ecran.Supprime}

{----------------------------------------------------------}

procedure EffaceZone(page,xg,yh,xd,yb,attr: BYTE);
var ptr_VRAM: POINTER;
begin
 if (xd<xg) or (yb<yh) then exit;

 ptr_VRAM:=PtrVRAM(page,xg,yh);
 asm
  les DI,ptr_VRAM     {ES:DI -> coin suprieur gauche}

  mov BH,yb
  sub BH,yh
  inc BH              {BH=yb-yh+1: nombre de lignes}
  mov BL,xd
  sub BL,xg
  inc BL              {BL=xd-xg+1: nombre de colonnes}

  xor DH,DH
  mov DL,largeur_ecran_txt
  sub DL,BL
  shl DX,1            {incrment DI: DX=2*(largeur_ecran_txt-nombre colonnes)}

  mov AH,attr
  mov AL,' '

  cld
  xor CH,CH
 @efface_ligne:
  mov CL,BL           {CX=nombre de colonnes}
  rep stosw           {efface une ligne}
  add DI,DX
  dec BH
  jnz @efface_ligne
 end;
end; {EffaceZone}

{----------------------------------------------------------}

procedure EffacePage(page,attr: BYTE);
begin
 EffaceZone(page,1,1,largeur_ecran_txt,hauteur_ecran_txt,attr);
end; {EffacePage}

{----------------------------------------------------------}

procedure ChangePage(page: BYTE); assembler;
{change la page visible courante SANS COLONNES VIRTUELLES (80!)}
asm
 mov AH,5
 mov AL,page
 int 10h
end; {ChangePage}

{----------------------------------------------------------}

procedure CopiePage(page_source,page_dest: BYTE);
begin
 Transfert(+1,PtrVRAM(page_source,1,1),0,PtrVRAM(page_dest,1,1),0,largeur_ecran_txt,hauteur_ecran_txt);
end; {CopiePage}

{----------------------------------------------------------}

procedure ScrolleZoneHaut(page,xg,yh,xd,yb: BYTE);
var ptr_VRAM: POINTER;
begin
 if (xd<xg) or (yb<=yh) then exit;

 ptr_VRAM:=PtrVRAM(page,xg,yh);
 asm
  push DS
  cld

  les DI,ptr_VRAM     {ES:DI -> coin suprieur gauche}
  xor AH,AH
  mov AL,largeur_ecran_txt
  mov SI,AX
  shl SI,1
  add SI,DI           {SI=DI+2*largeur_ecran_txt: source=ligne du dessous}

  mov BH,yb
  sub BH,yh           {BH=yb-yh: nombre de lignes-1}
  mov BL,xd
  sub BL,xg
  inc BL              {BL=xd-xg+1: nombre de colonnes}

  xor DH,DH
  mov DL,largeur_ecran_txt
  sub DL,BL
  shl DX,1            {incrment SI et DI: DX=2*(largeur_ecran_txt-nombre colonnes)}

  push ES
  pop DS

  xor CH,CH
 @scrolle:
  mov CL,BL           {CX=nombre colonnes}
  rep movsw           {copie une ligne}
  add SI,DX
  add DI,DX           {ligne suivante}
  dec BH
  jnz @scrolle

  mov AL,' '          {espace}
  mov CL,BL           {CX=nombre colonnes}
 @efface:
  stosb               {efface ligne du bas}
  inc DI              {saute l'attribut}
  dec CL
  jnz @efface

  pop DS
 end;
end; {ScrolleZoneHaut}

{----------------------------------------------------------}

procedure ScrolleZoneBas(page,xg,yh,xd,yb: BYTE);
var ptr_VRAM: POINTER;
begin
 if (xd<xg) or (yb<=yh) then exit;

 ptr_VRAM:=PtrVRAM(page,xg,yb);
 asm
  push DS
  cld

  les DI,ptr_VRAM     {ES:DI -> coin infrieur gauche}
  xor AH,AH
  mov AL,largeur_ecran_txt
  mov SI,AX
  shl SI,1
  neg SI
  add SI,DI           {SI=DI-2*largeur_ecran_txt: source=ligne du dessus}

  mov BH,yb
  sub BH,yh           {BH=yb-yh: nombre de lignes-1}
  mov BL,xd
  sub BL,xg
  inc BL              {BL=xd-xg+1: nombre de colonnes}

  xor DH,DH
  mov DL,largeur_ecran_txt
  add DL,BL
  shl DX,1            {dcrment SI et DI: DX=2*(largeur_ecran_txt+nombre colonnes)}

  push ES
  pop DS

  xor CH,CH
 @scrolle:
  mov CL,BL           {CX=nombre colonnes}
  rep movsw           {copie une ligne}
  sub SI,DX
  sub DI,DX           {ligne suivante}
  dec BH
  jnz @scrolle

  mov AL,' '          {espace}
  mov CL,BL           {CX=nombre colonnes}
 @efface:
  stosb               {efface ligne du haut}
  inc DI              {saute l'attribut}
  dec CL
  jnz @efface

  pop DS
 end;
end; {ScrolleZoneBas}

{----------------------------------------------------------}

procedure ScrolleZoneGauche(page,xg,yh,xd,yb: BYTE);
var ptr_VRAM: POINTER;
begin
 if (xd<=xg) or (yb<yh) then exit;

 ptr_VRAM:=PtrVRAM(page,xg,yh);
 asm
  push DS

  les DI,ptr_VRAM     {ES:DI -> coin suprieur gauche}
  mov SI,DI
  inc SI
  inc SI              {SI=DI+2: source=colonne de droite}

  mov BH,yb
  sub BH,yh
  inc BH              {BH=yb-yh+1: nombre de lignes}
  mov BL,xd
  sub BL,xg           {BL=xd-xg: nombre de colonnes-1}
  push BX

  xor DH,DH
  mov DL,largeur_ecran_txt
  sub DL,BL
  shl DX,1            {incrment SI et DI: DX=2*(largeur_ecran_txt-(nombre colonnes-1))}

  push ES
  pop DS

  cld
  xor CH,CH
 @scrolle:
  mov CL,BL           {CX=(nombre colonnes)-1}
  rep movsw           {copie une ligne}
  add SI,DX
  add DI,DX           {ligne suivante}
  dec BH
  jnz @scrolle

  sub DI,DX
  mov AL,' '          {espace}

  std                 {sens dcroissant}
  pop BX
  mov CL,BH           {CX=nombre lignes}

  pop DS

  xor DH,DH
  mov DL,largeur_ecran_txt
  shl DX,1
  dec DX              {dcrment DI: DX=2*largeur_ecran_txt-1}

 @efface:
  stosb               {efface colonne de droite}
  sub DI,DX           {ligne suivante}
  dec CL
  jnz @efface
 end;
end; {ScrolleZoneGauche}

{----------------------------------------------------------}

procedure ScrolleZoneDroite(page,xg,yh,xd,yb: BYTE);
var ptr_VRAM: POINTER;
begin
 if (xd<=xg) or (yb<yh) then exit;

 ptr_VRAM:=PtrVRAM(page,xd,yh);
 asm
  push DS

  les DI,ptr_VRAM     {ES:DI -> coin suprieur droit}
  mov SI,DI
  dec SI
  dec SI              {SI=DI-2: source=colonne de gauche}

  mov BH,yb
  sub BH,yh
  inc BH              {BH=yb-yh+1: nombre de lignes}
  mov BL,xd
  sub BL,xg           {BL=xd-xg: nombre de colonnes-1}
  push BX

  xor DH,DH
  mov DL,largeur_ecran_txt
  add DL,BL
  shl DX,1            {incrment SI et DI: DX=2*(largeur_ecran_txt+(nombre colonnes-1))}

  push ES
  pop DS

  std                 {sens dcroissant}
  xor CH,CH
 @scrolle:
  mov CL,BL           {CX=(nombre colonnes)-1}
  rep movsw           {copie une ligne}
  add SI,DX
  add DI,DX           {ligne suivante}
  dec BH
  jnz @scrolle

  sub DI,DX
  mov AL,' '          {espace}

  pop BX
  mov CL,BH           {CX=nombre lignes}

  pop DS

  xor DH,DH
  mov DL,largeur_ecran_txt
  shl DX,1
  dec DX              {dcrment DI: DX=2*largeur_ecran_txt-1}

 @efface:
  stosb               {efface colonne de gauche}
  sub DI,DX           {ligne suivante}
  dec CL
  jnz @efface
 end;
end; {ScrolleZoneDroite}

{==========================================================}

END.
