{ͻ}
{                        --== UTILG.PAS ==--                       }
{                                                                      }
{ Unit contenant des routines diverses pour le mode graphique MCGA    }
{ 320x200 256 couleurs et la souris                                    }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 386           Dbut d'criture ??/10/94 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT UtilG;

{$A+,G+,Q-,R-,S-}

INTERFACE

USES Graph256,Util,Souris,SourisG;

CONST {constantes de caractres autoriss pour LitChaine}
      chiffres=['0'..'9'];
      majuscules=['A'..'Z'];
      minuscules=['a'..'z'];
      lettres=majuscules+minuscules;
      alpha=lettres+chiffres;
      espace=[' '];
      symboles_fichiers=['.',':','\','_','$'];


VAR {variables globales pour SelectionneFichier}
    repert: String80;
    sous_repert_parent: String12;

{==========================================================}

procedure RestaureZoneSuppr(segment: WORD; var z: Zone);

function  LitChaine(chaine_init: STRING; x: WORD; y,long_aff,long_max: BYTE; aff_bords: BOOLEAN;
                    liste_car: SetofChar; conv_maj: BOOLEAN;
                    coul_fond,coul_ecr,coul_fond_inv,coul_ecr_inv: BYTE;
                    var abandon: BOOLEAN): STRING;

procedure AfficheBoutonsOKAnnuler(x: WORD; y: BYTE; var boutonOK,boutonAnnuler: Bouton);
procedure AfficheErreur(chaine1,chaine2: String25);

procedure InitRepert;
procedure AfficheAscenseur(x_asc: WORD; y_asc,hauteur_fenetre: BYTE; longueur_liste,index_premier: WORD);
function  SelectionneFichier(titre: String25; extension: String3; hauteur_fenetre: BYTE): String80;

{==========================================================}

IMPLEMENTATION

USES Crt,Dos,Clavier;

{==========================================================}

procedure RestaureZoneSuppr(segment: WORD; var z: Zone);
begin
 CacheCursSouris;
 with z do begin Restaure(segment,0,0); Supprime end;
 AffCursSouris;
end; {RestaureZoneSuppr}

{----------------------------------------------------------}

function  LitChaine(chaine_init: STRING; x: WORD; y,long_aff,long_max: BYTE; aff_bords: BOOLEAN;
                    liste_car: SetofChar; conv_maj: BOOLEAN;
                    coul_fond,coul_ecr,coul_fond_inv,coul_ecr_inv: BYTE;
                    var abandon: BOOLEAN): STRING;

{chaine_init       : chane initiale affiche lors de la saisie
 x,y               : coordonnes de la chane saisie
 long_aff          : longueur de la portion de chane affiche
 long_max          : longueur maximale de la chane saisie
 aff_bords         : si TRUE, affiche les flches dfilantes sur les cts
 liste_car         : liste des caractres autoriss  la saisie (type ensemble)
 conv_maj          : si TRUE, convertit les minuscules en majuscules  la saisie
 coul_fond,coul_ecr: couleurs d'affichage normales (aprs dplacement)
 .._inv,.._inv     : couleurs d'affichage inverses (avant dplacement)
 abandon           : TRUE si Esc appuy, FALSE si  appuy}

const bord_gauche: array[BOOLEAN] of CHAR=(' ','<');
      bord_droit : array[BOOLEAN] of CHAR=(' ','>');

var chaine,chaine_aff: STRING;
    touche: Key;
    etat_ins_init,pos_gauche,position,ys,couleur_fond_curseur: BYTE;
    xs: WORD;
    bouge,defile,ok: BOOLEAN;


procedure DefileGauche;
begin
 if position>1 then begin
  dec(position);
  if (position<pos_gauche+(long_aff div 5)) and (pos_gauche>1) then dec(pos_gauche);
 end;
end; {DefileGauche}


procedure DefileDroite;
begin
 if position<Length(chaine)+1 then begin
  bouge:=TRUE;
  inc(position);
  if (position>pos_gauche+long_aff-(long_aff div 5)) and
     (pos_gauche<=Length(chaine)-long_aff+1) then inc(pos_gauche);
 end;
end; {DefileDroite}


begin  {LitChaine}
 chaine:=chaine_init;
 pos_gauche:=1; position:=1;
 etat_ins_init:=EtatClavier and InsMode;
 ActiveMode(InsMode); {active le mode insertion par dfaut}
 bouge:=FALSE; defile:=FALSE;
 ok:=FALSE; abandon:=FALSE;

 repeat
  chaine:=CopyL(chaine,long_max);
  chaine_aff:=Copy(chaine,pos_gauche,long_aff);

  AttendVBL;
  CacheCursSouris;
  AffCh5x6($A000,x,y,RepeteCar(' ',long_aff),coul_ecr,TRUE,coul_fond);
  if bouge then AffCh5x6($A000,x,y,chaine_aff,coul_ecr,TRUE,coul_fond)
           else AffCh5x6($A000,x,y,chaine_aff,coul_ecr_inv,TRUE,coul_fond_inv);
  if aff_bords then begin
   AffCar5x6($A000,x-5,y,bord_gauche[pos_gauche>1],15,TRUE,coul_fond);
   AffCar5x6($A000,x+6*long_aff-1,y,bord_droit[pos_gauche<Length(chaine)-long_aff+2],15,TRUE,coul_fond);
  end;

  if (EtatClavier and InsMode)=InsMode then couleur_fond_curseur:=coul_fond xor 15
                                       else couleur_fond_curseur:=coul_ecr;
  if position<=Length(chaine) then
   AffCar5x6($A000,x+6*(position-pos_gauche),y,chaine[position],coul_ecr xor 15,TRUE,couleur_fond_curseur)
  else
   AffCar5x6($A000,x+6*(position-pos_gauche),y,' ',coul_ecr xor 15,TRUE,couleur_fond_curseur);

  AttendClavierSouris(not(defile),FALSE,xs,ys);
  defile:=FALSE;

  if KeyPressed then begin                      touche:=ReadKey;
   if conv_maj then touche:=UpCase(touche);
   case touche of
    Enter: ok:=TRUE;
    Esc  : abandon:=TRUE;
    Space..255: if (CHAR(touche) in liste_car) then begin
                 if not(bouge) then begin bouge:=TRUE; chaine:='' end;
                 if (EtatClavier and InsMode)=0 then Delete(chaine,position,1);
                 Insert(CHAR(touche),chaine,position);
                 if position<long_max+1 then begin
                  inc(position);
                  if position=Length(chaine)+1 then begin
                   if (pos_gauche<=Length(chaine)-long_aff+1) then inc(pos_gauche);
                  end
                  else
                   if (position>pos_gauche+long_aff-(long_aff div 5)) then inc(pos_gauche);
                 end;
                end;
    Bdel : if position>1 then begin
            bouge:=TRUE;
            Delete(chaine,position-1,1);
            dec(position);
            if ((position<pos_gauche+(long_aff div 5)) or (position>Length(chaine)-long_aff+1)) and
               (pos_gauche>1) then dec(pos_gauche);
           end;
    Left : DefileGauche;
    Right: DefileDroite;
    Home : begin bouge:=TRUE; position:=1; pos_gauche:=1 end;
    End_ : begin
            bouge:=TRUE;
            position:=Length(chaine)+1;
            if Length(chaine)>=long_aff then pos_gauche:=Length(chaine)-long_aff+2;
           end;
    Del  : if position<Length(chaine)+1 then begin
            bouge:=TRUE;
            Delete(chaine,position,1);
            if (pos_gauche>Length(chaine)-long_aff+2) and (pos_gauche>1) then dec(pos_gauche);
           end;
   end;
  end
  else begin {souris}
   if (ys in [y..y+5]) then
    if (xs>=x-6) and (xs<=x-1) then
     begin DefileGauche; defile:=TRUE; DelaiBoutonSouris(5) end
    else
     if (xs>=x+6*long_aff-2) and (xs<=x+6*long_aff+3) then
      begin DefileDroite; defile:=TRUE; DelaiBoutonSouris(5) end
     else if (xs>=x) and (xs<=x+6*long_aff-3) and
             ((xs-x) div 6+pos_gauche<=Length(chaine)+1) then
           begin position:=(xs-x) div 6+pos_gauche; bouge:=TRUE end;
   abandon:=(BoutonSouris=droite);
  end;
 until ok or abandon;

 CacheCursSouris;
 EtatClavier:=(EtatClavier and not(InsMode)) or etat_ins_init;
 AffCh5x6($A000,x,y,chaine_aff,coul_ecr,TRUE,coul_fond);
 AffCursSouris;
 repeat until BoutonSouris=aucun;
 if abandon then chaine:=chaine_init;
 LitChaine:=chaine;
end; {LitChaine}

{----------------------------------------------------------}

procedure AfficheBoutonsOKAnnuler(x: WORD; y: BYTE; var boutonOK,boutonAnnuler: Bouton);
begin
 boutonOK.Definit(x,y,' OK ',1,3,7);
 boutonAnnuler.Definit(x+42,y,' Annuler ',0,8,7);
 BougeCursSourisXY(x+22,y+5);
 AffCursSouris;
 boutonOK.Affiche; boutonAnnuler.Affiche;
end; {AfficheBoutonsOKAnnuler}

{----------------------------------------------------------}

procedure AfficheErreur(chaine1,chaine2: String25);
var z: Zone;
    boutonOK: Bouton;
begin
 CacheCursSouris;
 z.Ombre($A000,75,70,235,118,12);
 CadreOmbre($A000,75,70,235,118,FALSE);
 AffCh5x6($A000,137,75,'Erreur',14,FALSE,0);
 AffCh5x6($A000,90,88,chaine1,0,FALSE,0);
 AffCh5x6($A000,90,95,chaine2,0,FALSE,0);
 BougeCursSourisXY(164,109);
 AffCursSouris;
 with boutonOK do begin
  Definit(142,104,' OK ',1,3,7); Affiche;
  repeat until Clique;
 end;
 RestaureZoneSuppr($A000,z);
end; {AfficheErreur}

{----------------------------------------------------------}

procedure InitRepert;
{ appeler avant le premier appel  SelectionneFichier !}
begin
 GetDir(0,repert);
 if repert[Length(repert)]<>'\' then repert:=repert+'\';
 sous_repert_parent:='';
end; {InitRepert}

{----------------------------------------------------------}

procedure AfficheAscenseur(x_asc: WORD; y_asc,hauteur_fenetre: BYTE; longueur_liste,index_premier: WORD);
{conditions: hauteur_fenetre>6
             longueur_liste>hauteur_fenetre
             1  index_premier  longueur_liste-hauteur_fenetre+1}

const fleche_haut: array[1..9,1..9] of BYTE=(
                    (15,15,15,15,15,15,15,15, 7),
                    (15, 7, 7, 7, 7, 7, 7, 7, 8),
                    (15, 7, 7, 7, 8, 7, 7, 7, 8),
                    (15, 7, 7, 8, 8, 8, 7, 7, 8),
                    (15, 7, 8, 8, 8, 8, 8, 7, 8),
                    (15, 7, 7, 8, 8, 8, 7, 7, 8),
                    (15, 7, 7, 8, 8, 8, 7, 7, 8),
                    (15, 7, 7, 7, 7, 7, 7, 7, 8),
                    ( 7, 8, 8, 8, 8, 8, 8, 8, 8)
                   );

const fleche_bas : array[1..9,1..9] of BYTE=(
                    (15,15,15,15,15,15,15,15, 7),
                    (15, 7, 7, 7, 7, 7, 7, 7, 8),
                    (15, 7, 7, 8, 8, 8, 7, 7, 8),
                    (15, 7, 7, 8, 8, 8, 7, 7, 8),
                    (15, 7, 8, 8, 8, 8, 8, 7, 8),
                    (15, 7, 7, 8, 8, 8, 7, 7, 8),
                    (15, 7, 7, 7, 8, 7, 7, 7, 8),
                    (15, 7, 7, 7, 7, 7, 7, 7, 8),
                    ( 7, 8, 8, 8, 8, 8, 8, 8, 8)
                   );

var h_asc,pos_asc: BYTE;

begin
 h_asc:=4+Round((hauteur_fenetre-1)*(7*hauteur_fenetre-20)/(longueur_liste-2)); {hauteur barre ascenseur}
 pos_asc:=1+Round((index_premier-1)*(7*hauteur_fenetre-12-h_asc)/(longueur_liste-hauteur_fenetre)); {position barre ascenseur}

 {flche vers le haut}
 TransfereZone($A000,fleche_haut,te,x_asc,y_asc,x_asc+8,y_asc+8);

 {flche vers le bas}
 TransfereZone($A000,fleche_bas,te,x_asc,y_asc+7*hauteur_fenetre-3,x_asc+8,y_asc+7*hauteur_fenetre+5);

 {zone sombre suprieure}
 EffaceZoneCadreOmbre($A000,x_asc,y_asc+8,x_asc+8,y_asc+8+pos_asc+1,7,TRUE);

 {zone sombre infrieure}
 EffaceZoneCadreOmbre($A000,x_asc,y_asc+8+pos_asc+h_asc-2,x_asc+8,y_asc+7*hauteur_fenetre-3,7,TRUE);

 {barre ascenseur}
 EffaceZoneCadreOmbre($A000,x_asc,y_asc+8+pos_asc,x_asc+8,y_asc+8+pos_asc+h_asc-1,7,FALSE);
end; {AfficheAscenseur}

{----------------------------------------------------------}

function SelectionneFichier(titre: String25; extension: String3; hauteur_fenetre: BYTE): String80;
{hauteur_fenetre=nombre de fichiers affichs (doit tre > 6 !)}

type typecoul=(normal,inverse);

const x_asc=184; y_asc=40;  {coordonnes de la flche vers le haut}

var z: Zone;
    y,y_icone: BYTE;
    x,i,premier,nbr_fich,choix_fich,erreur: WORD;
    touche: Key;
    lecteur_physique,lecteur_logique,lettre: CHAR;
    fich: SearchRec;
    Dir: array[1..512] of STRING[13];
    liste_lecteurs: String26;
    change_rep,defile_fenetre,bouge_ascenseur,choix_clique,
    ok,sortie: BOOLEAN;
    boutonOK,boutonAnnule: Bouton;


procedure ChangeLecteur(lettre: CHAR);
begin
 lecteur_physique:=lettre; lecteur_logique:=lecteur_physique;
 repert:=CheminAcces(lecteur_logique);
 sous_repert_parent:=''; change_rep:=TRUE;
end; {ChangeLecteur}


function Repertoire(index: WORD): BOOLEAN;
begin
 Repertoire:=(Dir[index][1]='\');
end; {Repertoire}


procedure AfficheChoix(ch: WORD; coul: typecoul);
const Couleur: array[BOOLEAN,typecoul] of BYTE=((1,15),(14,14));
      Fond: array[typecoul] of BYTE=(3,1);
begin
 if nbr_fich>0 then
  AffCh5x6($A000,x_asc-94,y_asc+4+7*(ch-premier),' '+XString(Dir[ch],' ',14),
           Couleur[Repertoire(ch),coul],TRUE,Fond[coul]);
end; {AfficheChoix}


procedure TestChoix;
begin
 if nbr_fich>0 then
  if Repertoire(choix_fich) then begin
   if Dir[choix_fich]='\..' then begin
    sous_repert_parent:=SousRepertoire(repert);
    repert:=FExpand(repert+'..\');
   end
   else begin
    sous_repert_parent:='';
    dec(repert[0]);
    repert:=FExpand(repert+Dir[choix_fich]+'\');
   end;
   change_rep:=TRUE;
  end
 else ok:=TRUE;
end; {TestChoix}


procedure CorrigePremier;
begin
 if choix_fich<premier then premier:=choix_fich;
 if choix_fich>premier+hauteur_fenetre-1 then premier:=choix_fich-hauteur_fenetre+1;
end; {CorrigePremier}


procedure CorrigeChoix;
begin
 if choix_fich<premier then choix_fich:=premier;
 if choix_fich>premier+hauteur_fenetre-1 then choix_fich:=premier+hauteur_fenetre-1;
end; {CorrigeChoix}


procedure DefileHaut;
begin
 if choix_fich>1 then dec(choix_fich);
 CorrigePremier;
end; {DefileHaut}


procedure DefileBas;
begin
 if choix_fich<nbr_fich then inc(choix_fich);
 CorrigePremier;
end; {DefileBas}


procedure DefilePageHaut;
begin
 if choix_fich>hauteur_fenetre then begin
  dec(choix_fich,hauteur_fenetre);
  if premier>hauteur_fenetre then dec(premier,hauteur_fenetre) else premier:=1;
 end
 else begin choix_fich:=1; premier:=1 end;
end; {DefilePageHaut}


procedure DefilePageBas;
begin
 inc(choix_fich,hauteur_fenetre); inc(premier,hauteur_fenetre);
 if choix_fich>nbr_fich then choix_fich:=nbr_fich;
 if nbr_fich>=hauteur_fenetre then
  if premier>nbr_fich-hauteur_fenetre+1 then premier:=nbr_fich-hauteur_fenetre+1;
 if nbr_fich<hauteur_fenetre then premier:=1;
end; {DefilePageBas}


procedure QuickSort(debut,fin: WORD);
var i,j: WORD;
    aux1,aux2: STRING[14];
begin
 i:=debut; j:=fin; aux1:=Dir[(debut+fin) shr 1];
 repeat
  while Dir[i]<aux1 do inc(i);
  while aux1<Dir[j] do dec(j);
  if i<=j then begin
   aux2:=Dir[i]; Dir[i]:=Dir[j]; Dir[j]:=aux2;
   inc(i); if j>0 then dec(j);
  end;
 until i>j;
 if debut<j then QuickSort(debut,j);
 if i<fin   then QuickSort(i,fin);
end; {QuickSort}


procedure ChercheInitiale(initiale: CHAR);
var i,j,nbr: WORD;
begin
 nbr:=0;
 for i:=1 to nbr_fich do
  if Dir[i][1]=initiale then begin inc(nbr); j:=i end;
 if nbr>0 then begin
  if (choix_fich>=j-nbr+1) and (choix_fich<j) then inc(choix_fich) else choix_fich:=j-nbr+1;
  CorrigePremier;
 end;
end; {ChercheInitiale}


procedure AfficheIconeLecteur(x: WORD; y,type_lecteur: BYTE);
{type_lecteur-> 0: disque dur, 1: 5"1/4, 2: 3"1/2}

const {icne disquette 3"1/2}
      lig_A=14; col_A=16;
      icone_A: array[1..lig_A,1..col_A] of BYTE=(
                ( 1, 1,15,15,15,15,15,15,15,15,15,15,15,15, 1, 1),
                ( 1, 0,15,15,15,15,15,15,15,15,15,15,15,15, 0, 1),
                ( 1, 1,15,15,15,15,15,15,15,15,15,15,15,15, 1, 1),
                ( 1, 1,15,15,15,15,15,15,15,15,15,15,15,15, 1, 1),
                ( 1, 1,15,15,15,15,15,15,15,15,15,15,15,15, 1, 1),
                ( 1, 1,15,15,15,15,15,15,15,15,15,15,15,15, 1, 1),
                ( 1, 1,15,15,15,15,15,15,15,15,15,15,15,15, 1, 1),
                ( 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1),
                ( 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1),
                ( 1, 1, 1, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 1, 1, 1),
                ( 1, 1, 1, 7, 0, 0, 7, 7, 7, 7, 7, 7, 7, 1, 1, 1),
                ( 1, 1, 1, 7, 0, 0, 7, 7, 7, 7, 7, 7, 7, 1, 1, 1),
                ( 1, 1, 1, 7, 0, 0, 7, 7, 7, 7, 7, 7, 7, 1, 1, 1),
                ( 1, 1, 1, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 1, 1, 1)
               );

      {icne disquette 5"1/4}
      lig_B=18; col_B=20;
      icone_B: array[1..lig_B,1..col_B] of BYTE=(
                ( 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
                ( 0, 0,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15, 0, 0),
                ( 0, 0,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15, 0, 0),
                ( 0, 0,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15, 0, 0),
                ( 0, 0,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15, 0, 3),
                ( 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
                ( 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
                ( 0, 0, 0, 0, 0, 0, 0, 0, 8, 8, 8, 8, 0, 0, 0, 0, 0, 0, 0, 0),
                ( 0, 0, 0, 0, 0, 0, 0, 8, 8, 3, 3, 8, 8, 0, 0, 0, 0, 0, 0, 0),
                ( 0, 0, 0, 0, 0, 0, 0, 8, 3, 3, 3, 3, 8, 0, 0, 0, 0, 0, 0, 0),
                ( 0, 0, 0, 0, 0, 0, 0, 8, 8, 3, 3, 8, 8, 0, 8, 0, 0, 0, 0, 0),
                ( 0, 0, 0, 0, 0, 0, 0, 0, 8, 8, 8, 8, 0, 0, 0, 0, 0, 0, 0, 0),
                ( 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
                ( 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0),
                ( 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0),
                ( 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0),
                ( 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0),
                ( 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0)
               );

      {icne disque dur}
      lig_C=7; col_C=24;
      icone_C: array[1..lig_C,1..col_C] of BYTE=(
                ( 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7),
                ( 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 7),
                ( 7, 8, 7, 8, 7, 8, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,12,12, 8, 7),
                ( 7, 8, 7, 8, 7, 8, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 7),
                ( 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 7),
                ( 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 7),
                ( 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7)
               );

begin
 case type_lecteur of
  lecteur_3p5 : TransfereZone($A000,icone_A,te,x,y,x+col_A-1,y+lig_A-1); {disquette 3"1/2}
  lecteur_5p25: TransfereZone($A000,icone_B,te,x,y,x+col_B-1,y+lig_B-1); {disquette 5"1/4}
  disque_dur  : TransfereZone($A000,icone_C,te,x,y,x+col_C-1,y+lig_C-1); {disque dur}
 end;
end; {AfficheIconeLecteur}


procedure AfficheIconesLecteurs;
var i,y: BYTE;
    lettre: CHAR;
begin
 y:=y_asc;
 for i:=1 to Length(liste_lecteurs) do begin
  lettre:=liste_lecteurs[i];
  case lettre of
   'A','B': begin AfficheIconeLecteur(x_asc+16,y,TypeLecteur(lettre)); inc(y,18) end;
   'C','D'..'Z': begin AfficheIconeLecteur(x_asc+16,y,0); inc(y,8) end;
  end;
  inc(y,5); if y>y_asc+7*hauteur_fenetre then break;
 end;
end; {AfficheIconesLecteurs}



begin {SelectionneFichier}
 CacheCursSouris;

 liste_lecteurs:=ListeLecteurs; lecteur_logique:=repert[1];

 z.Ombre($A000,x_asc-104,y_asc-25,x_asc+48,y_asc+7*hauteur_fenetre+30,3);
 CadreOmbre($A000,x_asc-104,y_asc-25,x_asc+48,y_asc+7*hauteur_fenetre+30,FALSE);
 AffCh5x6($A000,x_asc-32-3*Length(titre),y_asc-20,' '+titre+' ',15,FALSE,0);
 CadreOmbre($A000,x_asc-96,y_asc,x_asc-3,y_asc+7*hauteur_fenetre+5,TRUE); {cadre fichiers}
 AfficheBoutonsOKAnnuler(x_asc-74,y_asc+7*hauteur_fenetre+15,boutonOK,boutonAnnule);

 sortie:=FALSE; ok:=FALSE;
 repeat
  CacheCursSouris;

  lecteur_physique:=repert[1]; AfficheIconesLecteurs;

  AffCh5x6($A000,x_asc-70,y_asc-8,lecteur_logique+':*.'+extension,0,TRUE,3);
  EffaceZone($A000,x_asc-95,y_asc+1,x_asc-4,y_asc+7*hauteur_fenetre+4,3); {intrieur cadre fichiers}
  EffaceZone($A000,x_asc,y_asc,x_asc+8,y_asc+7*hauteur_fenetre+5,3); {fond ascenseur + flches}
  AffCursSouris;

  if repert[Length(repert)]<>'\' then repert:=repert+'\';
  nbr_fich:=0;
  FindFirst(repert+'*.*',Directory+Archive,fich);
  while DosError=0 do begin
   if fich.Name<>'.' then
    if (extension='*') or (Pos('.'+extension,fich.Name)>0)
       or (fich.Attr=Directory) then begin
     inc(nbr_fich);
     Dir[nbr_fich]:=fich.Name;
     if fich.Attr=Directory then Dir[nbr_fich]:='\'+Dir[nbr_fich];
    end;
   FindNext(fich);
  end;
  if DosError=3 then AfficheErreur('Chemin introuvable sur','le lecteur '+lecteur_physique+': verifiez');
  if DosError=152 then AfficheErreur('Lecteur '+lecteur_physique+': pas pret','Inserez une disquette');
  if not(DosError in [0,3,18,152]) then AfficheErreur('Erreur de lecture','Changez de disquette');

  choix_fich:=1; premier:=1;
  if nbr_fich>0 then begin
   for i:=1 to nbr_fich do if Repertoire(i) then Dir[i]:=#0+Dir[i]; {pour classer les rpertoires avant les fichiers}
   QuickSort(1,nbr_fich);
   for i:=1 to nbr_fich do if Dir[i][1]=#0 then Delete(Dir[i],1,1);
  end;

  if sous_repert_parent<>'' then begin
   for i:=1 to nbr_fich do
    if (Dir[i]='\'+sous_repert_parent) then begin choix_fich:=i; break end;
   CorrigePremier;
  end;

  change_rep:=FALSE; defile_fenetre:=FALSE;
  bouge_ascenseur:=FALSE; choix_clique:=FALSE;

  repeat
   CacheCursSouris; {ne pas changer! (dfilement vers le haut..)}

   if nbr_fich>hauteur_fenetre then
    AfficheAscenseur(x_asc,y_asc,hauteur_fenetre,nbr_fich,premier);

   for i:=premier to premier+hauteur_fenetre-1 do
    if (i<=nbr_fich) and (i<>choix_fich) then AfficheChoix(i,normal);
   AfficheChoix(choix_fich,inverse);

   if BoutonSouris=aucun then begin
    if choix_clique and not(defile_fenetre) then TestChoix;
    defile_fenetre:=FALSE; bouge_ascenseur:=FALSE; choix_clique:=FALSE;
   end;

   if choix_clique then ZoneSouris(x_asc-95,y_asc+1,x_asc-4,y_asc+7*hauteur_fenetre+4)
   else
    if defile_fenetre or bouge_ascenseur then ZoneSouris(x_asc,y_asc,x_asc+8,y_asc+7*hauteur_fenetre+5)
                                         else ZoneSouris(0,0,319,199);

   AttendClavierSouris(not(defile_fenetre or bouge_ascenseur or choix_clique),change_rep or ok,x,y);

   if bouge_ascenseur or (choix_clique and not(defile_fenetre)) then
    repeat until KeyPressed or SourisBouge or (BoutonSouris=aucun);

   if KeyPressed then begin
    touche:=UpCase(ReadKey);
    if (EtatClavier and (ShiftG or ShiftD))=0 then {aucune touche Shift appuye}
     case touche of
      Key('A')..Key('Z'): if Pos(CHAR(touche),liste_lecteurs)>0 then ChangeLecteur(CHAR(touche));
      Up  : DefileHaut;
      Down: DefileBas;
      PgUp: DefilePageHaut;
      PgDn: DefilePageBas;
      Home: begin choix_fich:=1; premier:=1 end;
      End_: begin
             choix_fich:=nbr_fich;
             if nbr_fich>hauteur_fenetre then premier:=nbr_fich-hauteur_fenetre+1
            end;
      CtrlPgUp: if premier>1 then begin dec(premier); CorrigeChoix end
                else DefileHaut;
      CtrlPgDn: if nbr_fich>hauteur_fenetre then
                 if premier<nbr_fich-hauteur_fenetre+1 then
                  begin inc(premier); CorrigeChoix end
                 else DefileBas
                else DefileBas;
      Enter: TestChoix;
      Esc  : sortie:=TRUE;
     end
    else  {au moins une touche Shift est appuye}
     if (touche>=Key('A')) and (touche<=Key('Z')) then ChercheInitiale(CHAR(touche));
   end
   else begin  {souris}
    if EstDansZone(x,y,x_asc-95,y_asc+4,x_asc-4,y_asc+7*hauteur_fenetre+1) then
     if (premier+((y-y_asc-4) div 7)<=nbr_fich) and (BoutonSouris=gauche) then
      begin choix_clique:=TRUE; choix_fich:=premier+((y-y_asc-4) div 7) end;
    if (x in [x_asc..x_asc+8]) and (nbr_fich>hauteur_fenetre) then
     if (y in [y_asc..y_asc+8]) then
      begin defile_fenetre:=TRUE; DefileHaut; DelaiBoutonSouris(5) end
     else
      if (y in [y_asc+7*hauteur_fenetre-3..y_asc+7*hauteur_fenetre+5]) then
       begin defile_fenetre:=TRUE; DefileBas; DelaiBoutonSouris(5) end
      else
       if (y in [y_asc+9..y_asc+7*hauteur_fenetre-4]) then begin
        premier:=1+Round((y-y_asc-9)*(nbr_fich-hauteur_fenetre)/(7*hauteur_fenetre-13));
        CorrigeChoix; bouge_ascenseur:=TRUE;
       end;
    if (x in [x_asc+15..x_asc+40]) then begin
     y_icone:=y_asc;
     for i:=1 to Length(liste_lecteurs) do begin
      lettre:=liste_lecteurs[i];
      case lettre of
       'A','B': if y in [y_icone..y_icone+18-1] then
                 begin ChangeLecteur(lettre); break end
                else inc(y_icone,18);
       'C','D'..'Z': if y in [y_icone..y_icone+8-1] then
                      begin ChangeLecteur(lettre); break end
                     else inc(y_icone,8);
      end;
      inc(y_icone,5); if y_icone>y_asc+7*hauteur_fenetre then break;
     end;
     repeat until BoutonSouris=aucun;
    end;
    if choix_clique then
     if (y in [y_asc..y_asc+3]) then
      begin defile_fenetre:=TRUE; DefileHaut; Delay(15) end
     else
      if (y in [y_asc+7*hauteur_fenetre+2..y_asc+7*hauteur_fenetre+5]) then
       begin defile_fenetre:=TRUE; DefileBas; Delay(15) end
      else defile_fenetre:=FALSE;
    if boutonOK.Clique then TestChoix;
    sortie:=boutonAnnule.Clique;
   end;
  until change_rep or sortie or ok;
 until sortie or ok;

 RestaureZoneSuppr($A000,z);
 if ok then SelectionneFichier:=repert+Dir[choix_fich]
       else SelectionneFichier:='';
end; {SelectionneFichier}

{==========================================================}

END.
