{ͻ}
{                    --== UTILT/UTILSM.PAS ==--                    }
{                                                                      }
{ Unit contenant des routines diverses pour le mode texte couleur     }
{ (CGA, VGA et SVGA) et la souris (curseur normal ou smooth)           }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 286           Dbut d'criture ??/10/94 }
{                              Dernires modifications 26/07/98 }
{ͼ}

{$DEFINE Smooth}

{$IFNDEF Smooth}
UNIT UtilT;
{$ELSE}
UNIT UtilSm;
{$ENDIF}

{$A+,G+,Q-,R-,S-}

INTERFACE

{$IFNDEF Smooth}
USES Texte,Util,Souris,SourisT;
{$ELSE}
USES Texte,Util,Souris,SourisSm;
{$ENDIF}

{$I Types}

CONST {caractres autoriss pour LitChaine}
      chiffres=['0'..'9'];
      majuscules=['A'..'Z'];
      minuscules=['a'..'z'];
      lettres=majuscules+minuscules;
      alpha=lettres+chiffres;
      espace=[' '];
      symboles_fichiers=['.',':','\','_','$'];

      {justifications pour LitNombre}
      j_gauche=1;
      j_droite=2;

      {alternatives pour MessageErreur}
      alt_repete  =1;
      alt_continue=2;
      alt_change  =3;
      alt_annule  =4;
      nombre_alt_max=alt_annule;

      {paramtres pour MessageErreur}
      msg_donnee=$100;


TYPE  alternatives=set of alt_repete..alt_annule;


VAR {variables globales pour SelectionneFichier}
    repert: String80;
    sous_repert_parent: String12;

{==========================================================}

procedure RestaureZoneSuppr(page: BYTE; var z: Zone);
procedure RestaureEcranSuppr(page: BYTE; var e: Ecran);

function  LitChaine(chaine_init: STRING; x,y,long_aff,long_max: BYTE; aff_bords: BOOLEAN;
                    liste_car: SetofChar; conv_maj: BOOLEAN;
                    attr,attr_inverse: BYTE; var abandon: BOOLEAN): STRING;

function  LitNombre(nombre_init: REAL; aff_init: BOOLEAN; x,y,long_ent,long_dec: BYTE;
                    autorise_moins: BOOLEAN; justification: BYTE;
                    attr,attr_inverse: BYTE; var abandon: BOOLEAN): REAL;

procedure AfficheBoutonsOKAnnuler(x,y: BYTE; var boutonOK,boutonAnnuler: Bouton);
procedure AfficheErreur(chaine1,chaine2: String64);
function  MessageErreur(erreur: WORD; nom_fichier: String80): BYTE;

procedure InitRepert;
procedure AfficheAscenseur(x_asc,y_asc,hauteur_fenetre: BYTE; longueur_liste,index_premier: WORD; attribut: BYTE);
function  SelectionneFichier(titre: String25; extension: String3; hauteur_fenetre: BYTE): String80;

{==========================================================}

IMPLEMENTATION

USES Crt,Dos,Clavier,Fichiers;

{==========================================================}

procedure RestaureZoneSuppr(page: BYTE; var z: Zone);
begin
 CacheCursSouris;
 with z do begin Restaure(page,0,0,0); Supprime end;
 AffCursSouris;
end; {RestaureZoneSuppr}

{----------------------------------------------------------}

procedure RestaureEcranSuppr(page: BYTE; var e: Ecran);
begin
 CacheCursSouris;
 with e do begin Restaure(page); Supprime end;
 AffCursSouris;
end; {RestaureEcranSuppr}

{----------------------------------------------------------}

function LitChaine(chaine_init: STRING; x,y,long_aff,long_max: BYTE; aff_bords: BOOLEAN;
                   liste_car: SetofChar; conv_maj: BOOLEAN;
                   attr,attr_inverse: BYTE; var abandon: BOOLEAN): STRING;

{chaine_init       : chane initiale affiche lors de la saisie
 x,y               : coordonnes de la chane saisie
 long_aff          : longueur de la portion de chane affiche
 long_max          : longueur maximale de la chane saisie
 aff_bords         : si TRUE, affiche les flches dfilantes sur les cts
 liste_car         : liste des caractres autoriss  la saisie (type ensemble)
 conv_maj          : si TRUE, convertit les minuscules en majuscules  la saisie
 attr,attr_inverse : attributs normal et inverse (avant dplacement)
 abandon          -> TRUE si Esc appuy, FALSE si  appuy}

const bord_gauche: array[BOOLEAN] of CHAR=(' ','');
      bord_droit : array[BOOLEAN] of CHAR=(' ','');

var chaine,chaine_aff: STRING;
    touche: Key;
    etat_ins_init,pos_gauche,position,xs,ys: BYTE;
    bouge,defile: BOOLEAN;


procedure DefileGauche;
begin
 if position>1 then begin
  dec(position);
  if (position<pos_gauche+(long_aff div 5)) and (pos_gauche>1) then dec(pos_gauche);
 end;
end; {DefileGauche}


procedure DefileDroite;
begin
 if position<Length(chaine)+1 then begin
  bouge:=TRUE;
  inc(position);
  if (position>pos_gauche+long_aff-(long_aff div 5)) and
     (pos_gauche<=Length(chaine)-long_aff+1) then inc(pos_gauche);
 end;
end; {DefileDroite}


begin  {LitChaine}
 chaine:=chaine_init;
 pos_gauche:=1; position:=1;
 etat_ins_init:=EtatClavier and InsMode;
 ActiveMode(InsMode); {active le mode insertion par dfaut}

 bouge:=FALSE; defile:=FALSE; abandon:=FALSE;

 repeat
  chaine:=CopyL(chaine,long_max);
  chaine_aff:=Copy(chaine,pos_gauche,long_aff);

  AttendVBL;
  CacheCursSouris;
  AffChXY(0,x,y,RepeteCar(' ',long_aff),attr);
  if bouge then AffChXY(0,x,y,chaine_aff,attr)
           else AffChXY(0,x,y,chaine_aff,attr_inverse);
  if aff_bords then begin
   AffCarXY(0,x-1,y,bord_gauche[pos_gauche>1],(attr and $F0) or 15);
   AffCarXY(0,x+long_aff,y,bord_droit[pos_gauche<Length(chaine)-long_aff+2],(attr and $F0) or 15);
  end;

  CursXY(0,x+position-pos_gauche,y);
  if (EtatClavier and InsMode)=InsMode then Curseur(plat) else Curseur(rect);

  AttendClavierSouris(not(defile),FALSE,xs,ys);
  defile:=FALSE;

  if KeyPressed then begin
   touche:=ReadKey;
   if conv_maj then touche:=UpCase(touche);
   case touche of
    Enter: break;
    Esc  : abandon:=TRUE;
    Space..255: if (CHAR(touche) in liste_car) then begin
                 if not(bouge) then begin bouge:=TRUE; chaine:='' end;
                 if (EtatClavier and InsMode)=0 then Delete(chaine,position,1);
                 Insert(CHAR(touche),chaine,position);
                 if position<long_max+1 then begin
                  inc(position);
                  if position=Length(chaine)+1 then begin
                   if (pos_gauche<=Length(chaine)-long_aff+1) then inc(pos_gauche);
                  end
                  else if (position>pos_gauche+long_aff-(long_aff div 5)) then inc(pos_gauche);
                 end;
                end;
    Bdel : if position>1 then begin
            bouge:=TRUE;
            Delete(chaine,position-1,1);
            dec(position);
            if ((position<pos_gauche+(long_aff div 5)) or (position>Length(chaine)-long_aff+1)) and
               (pos_gauche>1) then dec(pos_gauche);
           end;
    Left : DefileGauche;
    Right: DefileDroite;
    Home : begin bouge:=TRUE; position:=1; pos_gauche:=1 end;
    End_ : begin
            bouge:=TRUE;
            position:=Length(chaine)+1;
            if Length(chaine)>=long_aff then pos_gauche:=Length(chaine)-long_aff+2;
           end;
    Del  : if position<Length(chaine)+1 then begin
            bouge:=TRUE;
            Delete(chaine,position,1);
            if (pos_gauche>Length(chaine)-long_aff+2) and (pos_gauche>1) then dec(pos_gauche);
           end;
   end;
  end
  else begin  {souris}
   if ys=y then
    if xs=x-1 then begin DefileGauche; defile:=TRUE; DelaiBoutonSouris(5) end
    else
     if xs=x+long_aff then begin DefileDroite; defile:=TRUE; DelaiBoutonSouris(5) end
     else if (xs in [x..x+long_aff-1]) and
             (xs-x+pos_gauche<=Length(chaine)+1) then
           begin position:=xs-x+pos_gauche; bouge:=TRUE end;
    abandon:=(BoutonSouris=droite);
   end;
 until abandon;

 Curseur(off);
 EtatClavier:=(EtatClavier and not(InsMode)) or etat_ins_init;
 CacheCursSouris; AffChXY(0,x,y,chaine_aff,attr); AffCursSouris;
 repeat until BoutonSouris=aucun;
 if abandon then chaine:=chaine_init;
 LitChaine:=chaine;
end; {LitChaine}

{----------------------------------------------------------}

function LitNombre(nombre_init: REAL; aff_init: BOOLEAN; x,y,long_ent,long_dec: BYTE;
                   autorise_moins: BOOLEAN; justification: BYTE;
                   attr,attr_inverse: BYTE; var abandon: BOOLEAN): REAL;

{nombre_init       : nombre initial avant la saisie
 aff_init          : si TRUE, nombre initial affich
 x,y               : coordonnes de la chane saisie
 long_ent          : longueur de la partie entire
 long_dec          : longueur de la partie dcimale (0 si entier)
 autorise_moins    : si TRUE, nombres ngatifs autoriss
 justification     : alignement  gauche ou  droite
 attr,attr_inverse : attributs normal et inverse (avant dplacement)
 abandon          -> TRUE si Esc appuy, FALSE si  appuy}

var nombre: REAL;
    chaine: STRING[15];
    touche: Key;
    erreur: WORD;
    etat_ins_init,position,long_max: BYTE;
    dx: SHORTINT;
    bouge: BOOLEAN;


procedure AjouteCar(car: CHAR);
begin
 if not(bouge) then begin bouge:=TRUE; chaine:=''; position:=1 end;
 if (EtatClavier and InsMode)=0 then Delete(chaine,position,1);
 if (Length(chaine)>=1) and (position=1) and (chaine[1]='-') then exit;

 Insert(car,chaine,position);
 if position<long_max then inc(position);
end; {AjouteCar}

function Moins: BOOLEAN;
begin
 Moins:=(Pos('-',chaine)<>0);
end; {Moins}

function PosVirgule: BYTE;
begin
 PosVirgule:=Pos('.',chaine);
end; {PosVirgule}


begin {LitNombre}
 if aff_init then Str(nombre_init:1:long_dec,chaine) else chaine:='';
 case justification of
  j_gauche: position:=1;
  j_droite: position:=Length(chaine)+1;
 end;
 long_max:=long_ent; if long_dec<>0 then inc(long_max,long_dec+1);
 etat_ins_init:=EtatClavier and InsMode;
 ActiveMode(InsMode); {active le mode insertion par dfaut}
 bouge:=FALSE; abandon:=FALSE;

 repeat
  chaine:=CopyL(chaine,long_max);
  if position>long_max then position:=long_max;
  case justification of
   j_gauche: dx:=0;
   j_droite: begin dx:=long_max-Length(chaine)-1; if dx=-1 then inc(dx) end;
  end;

  AttendVBL;
  CacheCursSouris;
  AffChXY(0,x,y,RepeteCar(' ',long_max),attr);
  if bouge then AffChXY(0,x+dx,y,chaine,attr)
           else AffChXY(0,x+dx,y,chaine,attr_inverse);

  CursXY(0,x+dx+position-1,y);
  if (EtatClavier and InsMode)=InsMode then Curseur(plat) else Curseur(rect);

  AffCursSouris;
  repeat until KeyPressed or (BoutonSouris=droite);

  if KeyPressed then begin
   touche:=ReadKey;
   case touche of
    Enter: break;
    Esc  : abandon:=TRUE;
    Key('0')..Key('9'): AjouteCar(CHAR(touche));
    Key('-'): if autorise_moins then begin
               if not(bouge) then begin bouge:=TRUE; chaine:=''; position:=1 end;
               if Moins then begin Delete(chaine,1,1); if position>1 then dec(position) end
                        else begin Insert('-',chaine,1); inc(position) end;
              end;
    Key('.'),Key(','): if (long_dec<>0) and ((PosVirgule=0) or not(bouge)) then begin
                        AjouteCar('.');
                        if (PosVirgule=1) or ((PosVirgule=2) and (chaine[1]='-')) then
                         begin Insert('0',chaine,PosVirgule); inc(position) end;
                       end;
    Left : if position>1 then begin bouge:=TRUE; dec(position) end;
    Right: if position<Length(chaine)+1 then begin bouge:=TRUE; inc(position) end;
    Home : begin bouge:=TRUE; position:=1 end;
    End_ : begin bouge:=TRUE; position:=Length(chaine)+1 end;
    Bdel : if position>1 then
            begin bouge:=TRUE; Delete(chaine,position-1,1); dec(position) end;
    Del  : if position<Length(chaine)+1 then
            begin bouge:=TRUE; Delete(chaine,position,1) end;
   end;
  end
  else abandon:=TRUE;
 until abandon;

 Curseur(off);
 EtatClavier:=(EtatClavier and not(InsMode)) or etat_ins_init;
 CacheCursSouris; AffChXY(0,x+dx,y,chaine,attr); AffCursSouris;
 repeat until BoutonSouris=aucun;
 if abandon then nombre:=nombre_init else Val(chaine,nombre,erreur);
 LitNombre:=nombre;
end; {LitNombre}

{----------------------------------------------------------}

procedure AfficheBoutonsOKAnnuler(x,y: BYTE; var boutonOK,boutonAnnuler: Bouton);
begin
 boutonOK.Definit(0,x,y,' OK ',112+1,112+3,0,128);
 boutonAnnuler.Definit(0,x+9,y,' Annuler ',112,112+8,0,128);
 AffCursSouris;
 boutonOK.Affiche; boutonAnnuler.Affiche;
end; {AfficheBoutonsOKAnnuler}

{----------------------------------------------------------}

procedure AfficheErreur(chaine1,chaine2: String64);

const largeur_min=25; largeur_max=60; hauteur_init=7;

var largeur,hauteur,xg,yh,x_milieu,y_milieu: BYTE;
    boutonOK: Bouton;
    z: Zone;

begin
 largeur:=LimiteEntier(MaxEntier(Length(chaine1),Length(chaine2))+4,largeur_min,largeur_max);
 if chaine2='' then hauteur:=hauteur_init else hauteur:=hauteur_init+1;

 x_milieu:=largeur_ecran_txt div 2;
 y_milieu:=hauteur_ecran_txt div 2;
 xg:=x_milieu-(largeur div 2); yh:=y_milieu-(hauteur div 2);

 CacheCursSouris;
 z.Ombre(0,xg,yh,xg+largeur-1,yh+hauteur-1,64);
 Cadre(0,2,xg,yh,xg+largeur-1,yh+hauteur-1,64+7,' ERREUR ',64+14,'  ');
 AffChXY(0,x_milieu-(Length(chaine1) div 2),yh+2,chaine1,64+15);
 AffChXY(0,x_milieu-(Length(chaine2) div 2),yh+3,chaine2,64+15);
 AffCursSouris;
 {$IFDEF Smooth}
 DefCursSouris(fleche);
 {$ENDIF}
 Curseur(off);
 VideBufferClavier;

 with boutonOK do begin Definit(0,x_milieu-2,yh+hauteur-3,' OK ',112,112+8,0,128); Affiche end;
 repeat
  if KeyPressed then begin if ReadKey=Enter then break end
                else if boutonOK.Clique then break;
 until FALSE;

 RestaureZoneSuppr(0,z);
end; {AfficheErreur}

{----------------------------------------------------------}

function MessageErreur(erreur: WORD; nom_fichier: String80): BYTE;
{si Hi(erreur)=$00       : renvoie une alternative Rpte/continue/Change/Annule
 si Hi(erreur)=msg_donnee: renvoie une donne > nombre_alt_max

exemples:
 1. MessageErreur(f_err_fich_intr,'...') renvoie une alternative

 2. (f_erreur=f_err_pas_pret)
    MessageErreur(f_erreur+msg_donnee,'...') renvoie alt_annule ou le nouveau lecteur

signification des alternatives:
 alt_repete  : rpte l'action qui a provoqu l'erreur
 alt_continue: ignore l'erreur et poursuit l'excution
 alt_change  : revient en arrire pour essayer de corriger l'erreur
 alt_annule  : ignore l'erreur et sort du bloc courant

   ERREURS         Rpte continue Change Annule    donne
 1                                       x
 f_err_fich_intr             x            x
 f_err_ch_intr               x            x
 f_err_trop_fich                         x
 f_err_acces_ref      x       x            x
 f_err_handle                            
 f_err_lecteur                           
 f_err_plus_fich                         
 f_err_existe         x             x      x
 f_err_protect       (x)                  x
 f_err_pas_pret       x                   x    nouveau lecteur
 f_err_disq_plein     x                   x
 f_err_CRC            x       x            x
 f_err_donnees        x       x            x
 f_err_media          x       x            x
 f_err_secteur        x       x            x                }

const largeur_min=20; largeur_max=60; hauteur_init=7;
      largeur_bouton_max=8+2;

var nombre_alt,numero_alt,largeur,hauteur,xg,yh,x_milieu,y_milieu: BYTE;
    x: array[1..nombre_alt_max] of BYTE;
    ch1: STRING[35];
    ch2: String80;
    bt_Repete,bt_Continue,bt_Change,bt_Annule: Bouton;
    liste_lecteurs: String26;
    alt: alternatives;
    touche: Key;
    z: Zone;

begin
 case Lo(erreur) of
  err_format      : begin
                     ch1:='Erreur de format'; ch2:='';
                     alt:=[alt_annule];
                    end;
  f_err_fich_intr : begin
                     ch1:='Fichier introuvable'; ch2:=nom_fichier;
                     alt:=[alt_continue,alt_annule];
                    end;
  f_err_ch_intr   : begin
                     ch1:='Chemin introuvable'; ch2:=RepertoireSeul(nom_fichier);
                     alt:=[alt_continue,alt_annule];
                    end;
  f_err_trop_fich : begin
                     ch1:='Trop de fichiers ouverts'; ch2:='';
                     alt:=[alt_annule];
                    end;
  f_err_acces_ref : begin
                     ch1:='Accs au fichier refus'; ch2:=nom_fichier;
                     alt:=[alt_repete,alt_continue,alt_annule];
                    end;
  f_err_existe    : begin
                     ch1:='Fichier existe dj sous ce nom'; ch2:=nom_fichier;
                     alt:=[alt_repete,alt_change,alt_annule];
                    end;
  f_err_protect   : if nom_fichier[1]=LettreCDRom then
                     begin
                      ch1:='Impossible d''crire sur le CD-Rom'; ch2:='';
                      alt:=[alt_annule];
                     end
                    else
                     begin
                      ch1:='Disque protg en criture'; ch2:='';
                      alt:=[alt_repete,alt_annule];
                     end;
  f_err_pas_pret  : begin
                     ch1:='Lecteur '+nom_fichier[1]+' vide ou pas prt';
                     if Hi(erreur)=Hi(msg_donnee) then
                      begin ch2:='Nouveau lecteur ?'+nom_fichier[1]; alt:=[] end
                     else
                      begin ch2:=''; alt:=[alt_repete,alt_annule] end;
                    end;
  f_err_disq_plein: begin
                     ch1:='Disque '+nom_fichier[1]+' plein'; ch2:='';
                     alt:=[alt_repete,alt_annule];
                    end;
  f_err_CRC,
  f_err_donnees,
  f_err_media,
  f_err_secteur   : begin
                     ch1:='Erreur de donnes sur lecteur '+nom_fichier[1]; ch2:='';
                     alt:=[alt_repete,alt_continue,alt_annule];
                    end;
  f_err_ecriture,
  f_err_lecture   : begin
                     ch1:='Accs au lecteur '+nom_fichier[1]+' impossible'; ch2:='';
                     alt:=[alt_annule];
                    end;
  f_err_disq_inut : begin
                     ch1:='Disque '+nom_fichier[1]+' inutilisable'; ch2:='';
                     alt:=[alt_annule];
                    end;
  else begin
   ch1:='Erreur inconnue'; ch2:='';
   alt:=[alt_annule];
  end;
 end;

 nombre_alt:=0;
 if alt_repete   in alt then inc(nombre_alt);
 if alt_continue in alt then inc(nombre_alt);
 if alt_change   in alt then inc(nombre_alt);
 if alt_annule   in alt then inc(nombre_alt);

 {calcule les dimensions de la fentre en fonction de son contenu}
 largeur:=MaxEntier(LimiteEntier(MaxEntier(Length(ch1),Length(ch2))+4,largeur_min,largeur_max),
          nombre_alt*(largeur_bouton_max+4));
 if ch2='' then hauteur:=hauteur_init
 else
  if Lo(erreur)<>f_err_pas_pret then
   begin hauteur:=hauteur_init+1; ch2:=LimiteNomFichier(ch2,largeur-4) end
  else hauteur:=hauteur_init-1;

 x_milieu:=largeur_ecran_txt div 2;
 y_milieu:=hauteur_ecran_txt div 2;
 xg:=x_milieu-(largeur div 2); yh:=y_milieu-(hauteur div 2);

 CacheCursSouris;
 z.Ombre(0,xg,yh,xg+largeur-1,yh+hauteur-1,64);
 Cadre(0,2,xg,yh,xg+largeur-1,yh+hauteur-1,64+7,' ERREUR ',64+14,'');
 AffChXY(0,x_milieu-(Length(ch1) div 2),yh+2,ch1,64+15);
 AffChXY(0,x_milieu-(Length(ch2) div 2),yh+3,ch2,64+7);
 AffCursSouris;
 {$IFDEF Smooth}
 DefCursSouris(fleche);
 {$ENDIF}
 Curseur(off);
 VideBufferClavier;

 if erreur=f_err_pas_pret+msg_donnee then begin
  liste_lecteurs:=ListeLecteurs;
  CursXY(0,x_milieu-(Length(ch2) div 2)+Length(ch2)-1,yh+3);
  Curseur(plat);
  repeat
   touche:=UpCase(ReadKey);
   case touche of
    Key('A')..Key('Z'): if Pos(CHAR(touche),liste_lecteurs)<>0 then
                         begin MessageErreur:=touche; break end;
    Enter: begin MessageErreur:=BYTE(nom_fichier[1]); break end;
    Esc  : begin MessageErreur:=alt_annule; break end;
   end;
  until FALSE;
  Curseur(off);
 end
 else begin
  for numero_alt:=1 to nombre_alt do
   x[numero_alt]:=x_milieu-(largeur div 2)+1+
                  (numero_alt*(largeur-nombre_alt*largeur_bouton_max)) div (nombre_alt+1)+
                  (numero_alt-1)*largeur_bouton_max;

  {arrange les boutons dans l'ordre: Rpte continue Change Annule}
  numero_alt:=1;
  if alt_repete in alt then
   with bt_Repete do
    begin Definit(0,x[numero_alt],yh+hauteur-3,' ^R^pte ',112,112+8,112+10,0); Affiche; inc(numero_alt) end;
  if alt_continue in alt then
   with bt_Continue do
    begin Definit(0,x[numero_alt],yh+hauteur-3,' ^C^ontinue ',112,112+8,112+10,0); Affiche; inc(numero_alt) end;
  if alt_change in alt then
   with bt_Change do
    begin Definit(0,x[numero_alt],yh+hauteur-3,' C^h^ange ',112,112+8,112+10,0); Affiche; inc(numero_alt) end;
  with bt_Annule do
   begin Definit(0,x[numero_alt],yh+hauteur-3,' ^A^nnule ',112,112+8,112+10,0); Affiche; inc(numero_alt) end;

  repeat
   if KeyPressed then begin
    touche:=ReadKey;
    if alt_repete in alt then
     if bt_Repete.Appuye(CHAR(touche)) then begin MessageErreur:=alt_repete; break end;
    if alt_continue in alt then
     if bt_Continue.Appuye(CHAR(touche)) then begin MessageErreur:=alt_continue; break end;
    if alt_change in alt then
     if bt_Change.Appuye(CHAR(touche)) then begin MessageErreur:=alt_change; break end;
    if bt_Annule.Appuye(CHAR(touche)) or (touche=Esc) then begin MessageErreur:=alt_annule; break end;
   end
   else begin
    if alt_repete in alt then
     if bt_Repete.Clique then begin MessageErreur:=alt_repete; break end;
    if alt_continue in alt then
     if bt_Continue.Clique then begin MessageErreur:=alt_continue; break end;
    if alt_change in alt then
     if bt_Change.Clique then begin MessageErreur:=alt_change; break end;
    if bt_Annule.Clique then begin MessageErreur:=alt_annule; break end;
   end;
  until FALSE;
 end;

 RestaureZoneSuppr(0,z);
end; {MessageErreur}

{----------------------------------------------------------}

procedure InitRepert;
{ appeler avant le premier appel  SelectionneFichier !}
begin
 GetDir(0,repert);
 if repert[Length(repert)]<>'\' then repert:=repert+'\';
 sous_repert_parent:='';
end; {InitRepert}

{----------------------------------------------------------}

procedure AfficheAscenseur(x_asc,y_asc,hauteur_fenetre: BYTE; longueur_liste,index_premier: WORD; attribut: BYTE);
{conditions: hauteur_fenetre>5
             longueur_liste>hauteur_fenetre
             1  index_premier  longueur_liste-hauteur_fenetre+1}

var h_asc,pos_asc: BYTE;
    ptr_VRAM: POINTER;

begin
 h_asc:=1+Round((hauteur_fenetre-4)*(hauteur_fenetre-1)/(longueur_liste-2)); {hauteur barre ascenseur}
 pos_asc:=1+Round((index_premier-1)*(hauteur_fenetre-2-h_asc)/(longueur_liste-hauteur_fenetre)); {position barre ascenseur}
 ptr_VRAM:=PtrVRAM(0,x_asc,y_asc); {pointeur sur la page n0}
 asm
  cld
  les DI,ptr_VRAM

  xor DH,DH
  mov DL,largeur_ecran_txt
  shl DX,1          {incrment DI: DX=2*largeur_ecran_txt}

  mov WORD ptr ES:[DI],256*79+''
  add DI,DX
  sub DX,2

  xor CH,CH
  mov CL,pos_asc
  dec CL
  mov BL,CL         {BL=CL=pos_asc-1}
  jcxz @barre_ascenseur
  mov AX,256*8+''
 @affiche_zone_sombre_sup:
  stosw
  add DI,DX
  loop @affiche_zone_sombre_sup

 @barre_ascenseur:
  mov AH,attribut
  mov AL,''
  mov CL,h_asc
 @affiche_barre_ascenseur:
  stosw
  add DI,DX
  loop @affiche_barre_ascenseur

  mov CL,hauteur_fenetre
  dec CL
  dec CL
  sub CL,h_asc
  sub CL,BL         {CL=(hauteur_fenetre-2)-h_asc-(pos_asc-1)}
  jcxz @fleche_bas

  mov AX,256*8+''
 @affiche_zone_sombre_inf:
  stosw
  add DI,DX
  loop @affiche_zone_sombre_inf

 @fleche_bas:
  mov WORD ptr ES:[DI],256*79+''
 end;
end; {AfficheAscenseur}

{----------------------------------------------------------}

function SelectionneFichier(titre: String25; extension: String3; hauteur_fenetre: BYTE): String80;
{hauteur_fenetre=nombre de fichiers affichs (doit tre > 5 !)}
{valeur standard: hauteur_ecran_txt-11}

type typecoul=(normal,inverse);

const dx_asc=+5; y_asc=6;  {coordonnes de la flche vers le haut}

var z: Zone;
    x,y,x_milieu,msg_err: BYTE;
    i,premier,nbr_fich,choix_fich: WORD;
    touche: Key;
    lecteur_physique,lecteur_logique: CHAR;
    fich: SearchRec;
    Dir: array[1..512] of STRING[14];
    liste_lecteurs: String26;
    change_rep,defile_fenetre,bouge_ascenseur,choix_clique,
    ok,sortie: BOOLEAN;
    boutonOK,boutonAnnuler: Bouton;

label relit_lecteur,fin;


procedure ChangeLecteur(lettre: CHAR);
begin
 lecteur_physique:=lettre; lecteur_logique:=lecteur_physique;
 repert:=CheminAcces(lecteur_logique);
 sous_repert_parent:=''; change_rep:=TRUE;
end; {ChangeLecteur}


function Repertoire(index: WORD): BOOLEAN;
begin
 Repertoire:=(Dir[index][1]='\');
end; {Repertoire}


procedure AfficheChoix(ch: WORD; coul: typecoul);
const Couleur: array[BOOLEAN,typecoul] of BYTE=((48+1,16+15),(48+14,16+14));
begin
 if nbr_fich>0 then
  AffChXY(0,x_milieu+dx_asc-15,ch-premier+y_asc,' '+XString(Dir[ch],' ',14),Couleur[Repertoire(ch),coul]);
end; {AfficheChoix}


procedure TestChoix;
begin
 if nbr_fich>0 then
  if Repertoire(choix_fich) then begin
   if Dir[choix_fich]='\..' then begin
    sous_repert_parent:=SousRepertoire(repert);
    repert:=FExpand(repert+'..\');
   end
   else begin
    sous_repert_parent:='';
    dec(repert[0]);
    repert:=FExpand(repert+Dir[choix_fich]+'\');
   end;
   change_rep:=TRUE;
  end
 else ok:=TRUE;
end; {TestChoix}


procedure CorrigePremier;
begin
 if choix_fich<premier then premier:=choix_fich;
 if choix_fich>premier+hauteur_fenetre-1 then premier:=choix_fich-hauteur_fenetre+1;
end; {CorrigePremier}


procedure CorrigeChoix;
begin
 if choix_fich<premier then choix_fich:=premier;
 if choix_fich>premier+hauteur_fenetre-1 then choix_fich:=premier+hauteur_fenetre-1;
end; {CorrigeChoix}


procedure DefileHaut;
begin
 if choix_fich>1 then dec(choix_fich);
 CorrigePremier;
end; {DefileHaut}


procedure DefileBas;
begin
 if choix_fich<nbr_fich then inc(choix_fich);
 CorrigePremier;
end; {DefileBas}


procedure DefilePageHaut;
begin
 if choix_fich>hauteur_fenetre then begin
  dec(choix_fich,hauteur_fenetre);
  if premier>hauteur_fenetre then dec(premier,hauteur_fenetre) else premier:=1;
 end
 else begin choix_fich:=1; premier:=1 end;
end; {DefilePageHaut}


procedure DefilePageBas;
begin
 inc(choix_fich,hauteur_fenetre); inc(premier,hauteur_fenetre);
 if choix_fich>nbr_fich then choix_fich:=nbr_fich;
 if nbr_fich>=hauteur_fenetre then
  if premier>nbr_fich-hauteur_fenetre+1 then premier:=nbr_fich-hauteur_fenetre+1;
 if nbr_fich<hauteur_fenetre then premier:=1;
end; {DefilePageBas}


procedure QuickSort(debut,fin: WORD);
var i,j: WORD;
    aux: STRING[14];
begin
 i:=debut; j:=fin; aux:=Dir[(debut+fin) shr 1];
 repeat
  {$IFDEF Smooth}
  AnimeCursSouris;
  {$ENDIF}
  while Dir[i]<aux do inc(i);
  while aux<Dir[j] do dec(j);
  if i<=j then begin
    SwapVar(Dir[i],Dir[j],sizeof(Dir[1]));
    inc(i); if j>0 then dec(j)
  end
 until i>j;
 if debut<j then QuickSort(debut,j);
 if i<fin   then QuickSort(i,fin);
end; {QuickSort}


procedure ChercheInitiale(initiale: CHAR);
var i,j,nbr: WORD;
begin
 nbr:=0;
 for i:=1 to nbr_fich do
  if Dir[i][1]=initiale then begin inc(nbr); j:=i end;
 if nbr>0 then begin
  if (choix_fich>=j-nbr+1) and (choix_fich<j) then inc(choix_fich) else choix_fich:=j-nbr+1;
  CorrigePremier;
 end;
end; {ChercheInitiale}


procedure AfficheLettresLecteurs;
const couleur: array[BOOLEAN] of BYTE=(112+1,15);
var i: BYTE;
    lettre: CHAR;
begin
 for i:=1 to MinEntier(Length(liste_lecteurs),(hauteur_fenetre div 2)+1) do begin
  lettre:=liste_lecteurs[i];
  AffChXY(0,x_milieu+dx_asc+2,y_asc-1+2*(i-1),' '+lettre+': ',couleur[lettre=lecteur_logique]);
 end;
end; {AfficheLettresLecteurs}



begin {SelectionneFichier}
 Curseur(off);
 CacheCursSouris;

 x_milieu:=largeur_ecran_txt div 2;

 liste_lecteurs:=ListeLecteurs; lecteur_logique:=repert[1];

 z.Ombre(0,x_milieu+dx_asc-20,y_asc-3,x_milieu+dx_asc+8,y_asc+hauteur_fenetre+3,48);
 Cadre(0,1,x_milieu+dx_asc-19,y_asc-3,x_milieu+dx_asc+7,y_asc+hauteur_fenetre+3,48+1,' '+titre+' ',112,'');
 AfficheBoutonsOKAnnuler(x_milieu+dx_asc-15,y_asc+hauteur_fenetre+1,boutonOK,boutonAnnuler);

 sortie:=FALSE; ok:=FALSE;
 repeat
 relit_lecteur:

  lecteur_physique:=repert[1];
  if repert[Length(repert)]<>'\' then repert:=repert+'\';

  CacheCursSouris;

  AfficheLettresLecteurs;
  AffChXY(0,x_milieu+dx_asc-18,y_asc-2,XString(LimiteNomFichier(repert,25),' ',25),48);
  EffaceZone(0,x_milieu+dx_asc-15,y_asc,x_milieu+dx_asc-1,y_asc+hauteur_fenetre-1,48);
  Cadre(0,1,x_milieu+dx_asc-16,y_asc-1,x_milieu+dx_asc,y_asc+hauteur_fenetre,48+1,' *.'+extension+' ',48+1,'');

  AffCursSouris;
  {$IFDEF Smooth}
  DefCursSouris(sablier);
  {$ENDIF}

  nbr_fich:=0;

  repeat
   FindFirst(repert+'*.*',Directory+Archive+ReadOnly,fich);
   if DosError in [0,18] then break;
   msg_err:=MessageErreur(DosError+msg_donnee,repert);
   case msg_err of
    alt_repete,
    alt_continue:;
    alt_annule  : goto fin;
    BYTE('A')..BYTE('Z'): begin ChangeLecteur(CHAR(msg_err)); goto relit_lecteur end;
   end;
  until FALSE;

  while DosError=0 do begin
   {$IFDEF Smooth}
   AnimeCursSouris;
   {$ENDIF}
   if fich.Name<>'.' then
    if (extension='*') or (Pos('.'+extension,fich.Name)>0)
       or (fich.Attr=Directory) then begin
     inc(nbr_fich);
     Dir[nbr_fich]:=fich.Name;
     if fich.Attr=Directory then Dir[nbr_fich]:='\'+Dir[nbr_fich];
    end;
   repeat
    FindNext(fich);
    if DosError in [0,18] then break;
    msg_err:=MessageErreur(DosError+msg_donnee,repert);
    case msg_err of
     alt_repete,
     alt_continue:;
     alt_annule  : goto fin;
     BYTE('A')..BYTE('Z'): begin ChangeLecteur(CHAR(msg_err)); goto relit_lecteur end;
    end;
   until FALSE;
  end;

  choix_fich:=1; premier:=1;
  if nbr_fich>0 then begin
   for i:=1 to nbr_fich do if Repertoire(i) then Insert(#0,Dir[i],1);
   QuickSort(1,nbr_fich);
   for i:=1 to nbr_fich do if Dir[i][1]=#0 then Delete(Dir[i],1,1);
  end;

  if sous_repert_parent<>'' then begin
   for i:=1 to nbr_fich do
    if (Dir[i]='\'+sous_repert_parent) then begin choix_fich:=i; break end;
   CorrigePremier;
  end;

  change_rep:=FALSE; defile_fenetre:=FALSE;
  bouge_ascenseur:=FALSE; choix_clique:=FALSE;

  {$IFDEF Smooth}
  DefCursSouris(fleche);
  {$ENDIF}

  repeat
   {$IFNDEF Smooth}
   if (BoutonSouris=aucun) or not(defile_fenetre) then
   {$ENDIF}
   CacheCursSouris;

   if nbr_fich>hauteur_fenetre then
    AfficheAscenseur(x_milieu+dx_asc,y_asc,hauteur_fenetre,nbr_fich,premier,11);

   for i:=premier to premier+hauteur_fenetre-1 do
    if (i<=nbr_fich) and (i<>choix_fich) then AfficheChoix(i,normal);
   AfficheChoix(choix_fich,inverse);

   if BoutonSouris=aucun then begin
    {$IFNDEF Smooth}
    DefCursSouris(standard,0,0,#0);
    {$ENDIF}
    if choix_clique and not(defile_fenetre) then TestChoix;
    defile_fenetre:=FALSE; bouge_ascenseur:=FALSE; choix_clique:=FALSE;
   end;

   if choix_clique then ZoneSouris(x_milieu+dx_asc-15,y_asc-1,x_milieu+dx_asc-1,y_asc+hauteur_fenetre)
   else
    if defile_fenetre or bouge_ascenseur then ZoneSouris(x_milieu+dx_asc,y_asc,x_milieu+dx_asc,y_asc+hauteur_fenetre-1)
                                         else ZoneSouris(1,1,largeur_ecran_txt,hauteur_ecran_txt);

   AttendClavierSouris(not(defile_fenetre or bouge_ascenseur or choix_clique),change_rep or ok,x,y);

   {$IFDEF Smooth}
   SourisBouge:=FALSE;
   {$ENDIF}
   if bouge_ascenseur or (choix_clique and not(defile_fenetre)) then
    repeat until KeyPressed or SourisBouge or (BoutonSouris=aucun);

   if KeyPressed then begin
    touche:=UpCase(ReadKey);
    if (EtatClavier and (ShiftG or ShiftD))=0 then {aucune touche Shift appuye}
     case touche of
      Key('A')..Key('Z'): if Pos(CHAR(touche),liste_lecteurs)>0 then ChangeLecteur(CHAR(touche));
      Up  : DefileHaut;
      Down: DefileBas;
      PgUp: DefilePageHaut;
      PgDn: DefilePageBas;
      Home: begin choix_fich:=1; premier:=1 end;
      End_: begin
             choix_fich:=nbr_fich;
             if nbr_fich>hauteur_fenetre then premier:=nbr_fich-hauteur_fenetre+1;
            end;
      CtrlPgUp: if premier>1 then begin dec(premier); CorrigeChoix end
                else DefileHaut;
      CtrlPgDn: if nbr_fich>hauteur_fenetre then
                 if premier<nbr_fich-hauteur_fenetre+1 then
                  begin inc(premier); CorrigeChoix end
                 else DefileBas
                else DefileBas;
      Enter: TestChoix;
      Esc  : sortie:=TRUE;
     end
    else  {au moins une touche Shift est appuye}
     if (touche>=Key('A')) and (touche<=Key('Z')) then ChercheInitiale(CHAR(touche));
   end

   else begin  {souris}

    if (x in [x_milieu+dx_asc-15..x_milieu+dx_asc-1]) and (y in [y_asc..y_asc+hauteur_fenetre-1]) then
     if (premier+y-y_asc<=nbr_fich) and (BoutonSouris=gauche) then
      begin choix_clique:=TRUE; choix_fich:=premier+y-y_asc end;
     if (x=x_milieu+dx_asc) and (nbr_fich>hauteur_fenetre) then
      if y=y_asc then begin
       {$IFNDEF Smooth}
       DefCursSouris(standard,0,0,#0);
       {$ENDIF}
       defile_fenetre:=TRUE; DefileHaut; DelaiBoutonSouris(10);
      end
      else
       if y=y_asc+hauteur_fenetre-1 then begin
        {$IFNDEF Smooth}
        DefCursSouris(standard,0,0,#0);
        {$ENDIF}
        defile_fenetre:=TRUE; DefileBas; DelaiBoutonSouris(10);
       end
       else
        if (y in [y_asc+1..y_asc+hauteur_fenetre-2]) then begin
         {$IFNDEF Smooth}
         DefCursSouris(change_tout,4,11,'');
         {$ENDIF}
         premier:=1+Round((y-y_asc-1)*(nbr_fich-hauteur_fenetre)/(hauteur_fenetre-3));
         CorrigeChoix; bouge_ascenseur:=TRUE;
        end;
     if (x in [x_milieu+dx_asc+2..x_milieu+dx_asc+5]) then begin
      for i:=1 to MinEntier(Length(liste_lecteurs),(hauteur_fenetre div 2)+1) do
       if y=y_asc-1+2*(i-1) then begin
        {$IFNDEF Smooth}
        DefCursSouris(inverse_attribut,0,0,'');
        {$ENDIF}
        ChangeLecteur(liste_lecteurs[i]);
       end;
       repeat until BoutonSouris=aucun;
       {$IFNDEF Smooth}
       DefCursSouris(standard,0,0,#0);
       {$ENDIF}
      end;
     if choix_clique then
      if y=y_asc-1 then begin
       {$IFNDEF Smooth}
       DefCursSouris(garde_fond,0,15,'');
       {$ENDIF}
       defile_fenetre:=TRUE; DefileHaut; Delay(15);
      end
      else
       if y=y_asc+hauteur_fenetre then begin
        {$IFNDEF Smooth}
        DefCursSouris(garde_fond,0,15,'');
        {$ENDIF}
        defile_fenetre:=TRUE; DefileBas; Delay(15);
       end
       else begin
        {$IFNDEF Smooth}
        DefCursSouris(inverse_attribut,0,0,'');
        {$ENDIF}
        defile_fenetre:=FALSE;
       end;
    if boutonOK.Clique then TestChoix;
    sortie:=boutonAnnuler.Clique;
   end;
  until change_rep or sortie or ok;
 until sortie or ok;

fin:
 RestaureZoneSuppr(0,z);
 if ok then SelectionneFichier:=repert+Dir[choix_fich] else SelectionneFichier:='';
end; {SelectionneFichier}

{==========================================================}

END.
