{ͻ}
{                       --== VESA.PAS ==--                         }
{                                                                      }
{ Unit pour grer les modes graphiques VESA avec Graph et les BGI     }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 286           Dbut d'criture 11/07/97 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT VESA;

{$A+,G+,Q-,R-,S-}

INTERFACE

{$I Types}

CONST VESA_132x25       =$014; {0014h :  132x25  , texte}
      VESA_800x600_16   =$100; {0100h :  800x600 ,  16 couleurs}
      VESA_1024x768_16  =$101; {0101h : 1024x768 ,  16 couleurs}
      VESA_1280x1024_16 =$102; {0102h : 1280x1024,  16 couleurs}
      VESA_800x600_256  =$103; {0103h :  800x600 , 256 couleurs}
      VESA_1024x768_256 =$104; {0104h : 1024x768 , 256 couleurs}
      VESA_1280x1024_256=$105; {0105h : 1280x1024, 256 couleurs}

VAR info_vesa: record case BYTE of
                0:(signature: array[1..4] of CHAR; {'VESA'}
                   version  : record maj,min: BYTE end;
                   fabricant: CharPtr;);

                1:(buffer: array[BYTE] of BYTE;);
               end;

{==========================================================}

function VESAOk: BOOLEAN;
function Fabricant: STRING;
function InitVESA(mode: INTEGER; chemin_BGI: String80; nom_BGI: String8): BOOLEAN;

{==========================================================}

IMPLEMENTATION

USES Graph;

CONST mode_vesa: WORD=0;

{==========================================================}

function VESAOk: BOOLEAN; assembler;
asm
 mov AX,SEG info_vesa
 mov ES,AX
 mov AX,4F00h
 mov DI,OFFSET info_vesa
 int 10h
 mov BL,FALSE
 cmp AX,004Fh
 jne @fin
 mov BL,TRUE
@fin:
 mov AL,BL
end; {VESAOk}

{----------------------------------------------------------}

function Fabricant: STRING; assembler;
asm
 push DS
 lds SI,info_vesa.fabricant
 mov AX,SEG fabricant
 les DI,@Result
 mov BX,DI
 inc DI
 cld
 xor CL,CL

@boucle:
 lodsb
 or AL,AL
 jz @fin
 stosb
 inc CL
 jmp @boucle

@fin:
 mov ES:[BX],CL
 pop DS
end; {Fabricant}

{----------------------------------------------------------}

function DetectVESA: INTEGER; far; assembler;
asm
 mov AX,mode_VESA
end; {DetectVESA}

{----------------------------------------------------------}

function InitVESA(mode: INTEGER; chemin_BGI: String80; nom_BGI: String8): BOOLEAN;
var driver: INTEGER;
begin
 if mode_VESA=0 then
  if InstallUserDriver(nom_BGI,@DetectVESA)=grError then
   begin InitVESA:=FALSE; exit end;

 driver:=Detect; mode_VESA:=mode;
 InitGraph(driver,mode,chemin_BGI);

 InitVESA:=TRUE;
end; {InitVESA}

{==========================================================}

END.
