{ͻ}
{                         --== VGA.PAS ==--                        }
{                                                                      }
{ Unit pour grer la carte VGA par les ports                          }
{                                                                      }
{ AUTEUR: Fabrice Couteau                                              }
{Ķ}
{ Compatibilit: 286           Dbut d'criture ??/04/95 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT VGA;

{$A+,G+,Q-,R-,S-}

INTERFACE

CONST {adresses des ports de la carte VGA}
      MiscOutput   =$3CC;
      InputStatus0 =$3C2;
      InputStatus1 =$3BA;
      CRTStatus    =$3DA;

      CRTControl   =$3D4;
       CRTControlIndex=CRTControl;
       CRTControlData =CRTControl+1;

      Sequencer    =$3C4;
       SequencerIndex=Sequencer;
       SequencerData =Sequencer+1;

      AttrControl  =$3C0;
       AttrControlIndex=AttrControl;
       AttrControlData =AttrControl+1;

      GraphControl =$3CE;
       GraphControlIndex=GraphControl;
       GraphControlData =GraphControl+1;

      DACWrite     =$3C8;
      DACRead      =$3C7;
      DACState     =$3C7;
      DACData      =$3C9;
      DACMask      =$3C6;

      {registres du contrleur CRT}
      HTotal       =$00;
      EndHDisplay  =$01;
      StartHBlank  =$02;
      EndHBlank    =$03;
      StartHRetrace=$04;
      EndHRetrace  =$05;
      VTotal       =$06;
      Overflow     =$07;
      VPelPanning  =$08;
      MaxScanLine  =$09;
      CursorStart  =$0A;
      CursorEnd    =$0B;
      StartAddrHigh=$0C;
      StartAddrLow =$0D;
      CursorLocHigh=$0E;
      CursorLocLow =$0F;
      StartVRetrace=$10;
      EndVRetrace  =$11;
      EndVDisplay  =$12;
      Offset_      =$13;
      UnderlineLoc =$14;
      StartVBlank  =$15;
      EndVBlank    =$16;
      ModeControl  =$17;
      LineCompare  =$18;

      {registres du squenceur}
      Reset        =$00;
      ClockingMode =$01;
      MapMask      =$02;
      CharMapSelect=$03;
      MemoryMode   =$04;

      {registres du contrleur d'attributs}
      ModeControl_ =$10;
      Overscan     =$11;
      ColorPlaneEn =$12;
      HPelPanning  =$13;
      ColorSelect  =$14;

      {registres du contrleur graphique}
      SetReset     =$00;
      EnSetReset   =$01;
      ColorCompare =$02;
      FuncSelect   =$03;
      ReadMapSelect=$04;
      GraphicsMode =$05;
      Miscellaneous=$06;
      ColorDontCare=$07;
      BitMask      =$08;

{==========================================================}

procedure UnLockCRT;

procedure SetVerticalTotal(n: WORD);
procedure SetEndVerticalDisplay(n: WORD);
procedure SetStartVerticalRetrace(n: WORD);
procedure SetStartVerticalBlanking(n: WORD);
procedure SetEndHorizontalBlanking(n: BYTE);

procedure SetStartAddr(addr: WORD);
procedure SetLineCompare(ligne: WORD);

procedure SmoothVertical(decalage: BYTE);
procedure SmoothHorizontal(decalage: BYTE);

{==========================================================}

IMPLEMENTATION

{==========================================================}

procedure UnLockCRT; assembler;
{autorise l'accs aux registres 00h  07h du contrleur CRT}
asm
 mov DX,CRTControl
 mov AL,EndVRetrace
 out DX,AL
 inc DL
 in AL,DX
 and AL,01111111b { Efface le premier Bit }
 out DX,AL
end; {UnLockCRT}

{----------------------------------------------------------}

procedure SetVerticalTotal(n: WORD); assembler;
asm
 mov BX,n

 mov DX,CRTControl
 mov AL,VTotal
 mov AH,BL
 out DX,AX

 mov BL,BH      {BL=BH: partie haute de n}

 mov AL,Overflow
 out DX,AL
 inc DL
 in AL,DX
 and AL,11011110b
 and BH,00000001b
 or AL,BH       {bit 0 de Overflow = bit 8 de n}

 and BL,00000010b
 shl BL,4
 or AL,BL       {bit 5 de Overflow = bit 9 de n}

 out DX,AL
end; {SetVerticalTotal}

{----------------------------------------------------------}

procedure SetEndVerticalDisplay(n: WORD); assembler;
asm
 mov BX,n

 mov DX,CRTControl
 mov AL,EndVDisplay
 mov AH,BL
 out DX,AX

 mov BL,BH      {BL=BH: partie haute de n}

 mov AL,Overflow
 out DX,AL
 inc DL
 in AL,DX
 and AL,10111101b
 and BH,00000001b
 shl BH,1
 or AL,BH       {bit 1 de Overflow = bit 8 de n}

 and BL,00000010b
 shl BL,5
 or AL,BL       {bit 6 de Overflow = bit 9 de n}

 out DX,AL
end; {SetEndVerticalDisplay}

{----------------------------------------------------------}

procedure SetStartVerticalRetrace(n: WORD); assembler;
asm
 mov BX,n

 mov DX,CRTControl
 mov AL,StartVRetrace
 mov AH,BL
 out DX,AX

 mov BL,BH      {BL=BH: partie haute de n}

 mov AL,Overflow
 out DX,AL
 inc DL
 in AL,DX
 and AL,01111011b
 and BH,00000001b
 shl BH,2
 or AL,BH       {bit 2 de Overflow = bit 8 de n}

 and BL,00000010b
 shl BL,6
 or AL,BL       {bit 7 de Overflow = bit 9 de n}

 out DX,AL
end; {SetStartVerticalRetrace}

{----------------------------------------------------------}

procedure SetStartVerticalBlanking(n: WORD); assembler;
asm
 mov BX,n

 mov DX,CRTControl
 mov AL,StartVBlank
 mov AH,BL
 out DX,AX

 mov BL,BH      {BL=BH: partie haute de n}

 mov AL,Overflow
 out DX,AL
 inc DL
 in AL,DX
 and AL,11110111b
 and BH,00000001b
 shl BH,3
 or AL,BH       {bit 3 de Overflow = bit 8 de n}

 out DX,AL

 dec DL
 mov AL,MaxScanLine
 out DX,AL
 inc DL
 in AL,DX
 and AL,11011111b
 and BL,00000010b
 shl BL,4
 or AL,BL       {bit 5 de Maximum Scan Line = bit 9 de n}

 out DX,AL
end; {SetStartVerticalBlanking}

{----------------------------------------------------------}

procedure SetEndHorizontalBlanking(n: BYTE); assembler;
asm
 mov BL,n

 mov BH,BL
 and BH,00011111b

 mov DX,CRTControl
 mov AL,EndHBlank
 in AL,DX
 inc DL
 and AL,11100000b
 or AL,BH
 out DX,AL

 dec DL
 mov AL,EndHRetrace
 out DX,AL
 inc DL
 in AL,DX
 and AL,01111111b
 and BL,00100000b
 shl BL,2
 or AL,BL
 out DX,AL
end; {SetEndHorizontalBlanking}

{----------------------------------------------------------}

procedure SetStartAddr(addr: WORD); assembler;
{dplace le dbut de la RAM vido}
asm
 mov AX,addr
 mov BL,AL

 mov DX,CRTControl
 mov AL,StartAddrHigh
 out DX,AX
 mov AL,StartAddrLow
 mov AH,BL
 out DX,AX
end; {SetStartAddr}

{----------------------------------------------------------}

procedure SetLineCompare(ligne: WORD); assembler;
{spare l'cran en deux,  partir de la ligne indique (en pixels)
 Remarques: - la partie suprieure peut tre dcale
            - la partie infrieure est fixe}
asm
 mov BX,ligne

 mov DX,CRTControl
 mov AL,LineCompare
 mov AH,BL
 out DX,AX

 mov BL,BH      {BL=BH: partie haute de ligne}

 mov AL,Overflow
 out DX,AL
 inc DL
 in AL,DX
 and AL,11101111b
 and BH,00000001b
 shl BH,4
 or AL,BH       {bit 4 de Overflow = bit 8 de ligne}

 out DX,AL

 dec DL
 mov AL,MaxScanLine
 out DX,AL
 inc DL
 in AL,DX
 and AL,10111111b
 and BL,00000010b
 shl BL,5
 or AL,BL       {bit 6 de Maximum Scan Line = bit 9 de ligne}

 out DX,AL
end; {SetLineCompare}

{----------------------------------------------------------}

procedure SmoothVertical(decalage: BYTE); assembler;
{dcale l'cran verticalement}
{decalage: de 0  15 pixels}
asm
 mov DX,CRTControl
 mov AL,VPelPanning
 mov AH,decalage
 out DX,AX
end; {SmoothVertical}

{----------------------------------------------------------}

procedure SmoothHorizontal(decalage: BYTE); assembler;
{dcale l'cran horizontalement}
{decalage:    0 1 2 3 4 5 6 7 8  pixels
 Pel panning: 8 0 1 2 3 4 5 6 7}
asm
 mov DX,AttrControl
 mov AL,HPelPanning or 00100000b   {bit 5  1 sinon cran noir!}
 out DX,AL
 mov AL,decalage
 or AL,AL
 jnz @pas_nul
 mov AL,8+1
@pas_nul:
 dec AL
 out DX,AL
end; {SmoothHorizontal}

{==========================================================}

END.
