{************************************************************************}
{								 MM_AFF.PAS								 }
{																		 }
{  Unit pour Mod Master: routines d'affichages                          }
{																		 }
{  AUTEURS: Fabrice Couteau et Freddy Vtel.							 }
{																		 }
{								Dbut d'criture le --/--/93             }
{								Dernires modifications le 26/07/98		 }
{************************************************************************}
UNIT MM_AFF;

{$A+,G+,Q-,R-,S-}

INTERFACE

USES Souris,SourisSm;

{$I Types}

CONST {aspects pour CadreOmbre}
	  concave=$00;
	  convexe=$01;
	  plein	 =$02;

	  {aspects pour FenetreOmbre}
	  normale=$00;
	  encadre=$01;

{==========================================================}

procedure AffChXYc(y: BYTE; chaine: String80; attr: BYTE);

procedure CadreOmbre(xg,yh,xd,yb,aspect: BYTE);
procedure FenetreOmbre(xg,yh,xd,yb,aspect: BYTE);
procedure ZoomFenetreOmbre(xg,yh,xd,yb,aspect: BYTE);

procedure AfficheAscenseur(x_asc,y_asc,hauteur_fenetre: BYTE; longueur_liste,index_premier: WORD);
procedure AfficheCurseur(x,y,longueur,position: BYTE; aff_plus_moins: BOOLEAN);
procedure AfficheBarreCurseur(x,y,longueur: BYTE; car: CHAR; val_max,valeur: WORD);

procedure AfficheBoutonsOKAnnuler(y: BYTE; var boutonOK,boutonAnnuler: Bouton3D);
procedure AfficheBoutonsOuiNon(y: BYTE; var boutonOui,boutonNon: Bouton3D);

procedure AffFenModules;
procedure AffFenControle(affiche_tout: BOOLEAN);

procedure AfficheLignesHautBas;
procedure InitInterface;

procedure AfficheBoutonsModules;
procedure AfficheBoutonsCD;

function  MessageErreur(erreur: WORD; nom_fichier: String80): BYTE;

function  SupprimeModule(nom_module: String12): BOOLEAN;

procedure ChangeSortie;
procedure ChangeConfig;

procedure Aide;

procedure FonduProgressif;

procedure AfficheLogoDebut;
procedure AffichePageFin;

procedure Economiseur;

{==========================================================}

IMPLEMENTATION

USES Crt,Dos,VARUnit,Fichiers,Clavier,Util,UtilSm,Texte,VGA,LZ,
	 CDAudio,Hardware,Memoire,SBUnit,ModmVar,
	 MM_VAR,MM_DIV;

VAR {variables pour l'conomiseur}
	teste_touche,touche_appuyee: BOOLEAN;
	anc_INT09h: POINTER;

{==========================================================}

procedure AffChXYc(y: BYTE; chaine: String80; attr: BYTE);
{affichage d'une chane centre par rapport  'x_milieu'}
begin
 AffChXY(0,x_milieu-(Length(chaine) div 2),y,chaine,attr)
end; {AffChXYc}

{--------------------------------------------------------------}

procedure CadreOmbre(xg,yh,xd,yb,aspect: BYTE);

var coul_haut_gauche,coul_bas_droite: BYTE;
	ptr_VRAM: POINTER;

begin
 if (xd<xg+2) or (yb<yh+2) then exit;

 case (aspect and (concave or convexe)) of
  concave: begin coul_haut_gauche:=or_clair; coul_bas_droite:=or_sombre end;
  convexe: begin coul_haut_gauche:=or_sombre; coul_bas_droite:=or_clair end;
 end;

 if (aspect and plein)=plein then EffaceZone(0,xg+1,yh+1,xd-1,yb-1,16*or_fond+blanc);

 ptr_VRAM:=PtrVRAM(0,xg,yh);
 asm
  les DI,ptr_VRAM

  mov CH,yb
  sub CH,yh
  dec CH
  mov CL,xd
  sub CL,xg
  dec CL

  xor DH,DH
  mov DL,largeur_ecran_txt
  shl DX,1

  mov AX,256*(16*or_fond)+car_coin_cadre_sup_g
  or  AH,coul_haut_gauche
  mov ES:[DI],AX
  add DI,2

  push CX
 @bord_haut:
  mov AX,256*(16*or_fond)+''
  or  AH,coul_haut_gauche
  mov ES:[DI],AX
  add DI,2
  dec CL
  jnz @bord_haut
  pop CX

  mov AX,256*(16*or_fond)+car_coin_cadre_sup_d
  or  AH,or_moyen
  mov ES:[DI],AX
  add DI,DX

  push CX
 @bord_droit:
  mov AX,256*(16*or_fond)+''
  or  AH,coul_bas_droite
  mov ES:[DI],AX
  add DI,DX
  dec CH
  jnz @bord_droit
  pop CX

  mov AX,256*(16*or_fond)+car_coin_cadre_inf_d
  or  AH,coul_bas_droite
  mov ES:[DI],AX
  sub DI,2

  push CX
 @bord_bas:
  mov AX,256*(16*or_fond)+''
  or  AH,coul_bas_droite
  mov ES:[DI],AX
  sub DI,2
  dec CL
  jnz @bord_bas
  pop CX

  mov AX,256*(16*or_fond)+car_coin_cadre_inf_g
  or  AH,or_moyen
  mov ES:[DI],AX
  sub DI,DX

  push CX
 @bord_gauche:
  mov AX,256*(16*or_fond)+''
  or  AH,coul_haut_gauche
  mov ES:[DI],AX
  sub DI,DX
  dec CH
  jnz @bord_gauche
  pop CX
 end
end; {CadreOmbre}

{----------------------------------------------------------}

procedure FenetreOmbre(xg,yh,xd,yb,aspect: BYTE);

var ptr_VRAM: POINTER;

begin
 if (xd<xg+2) or (yb<yh+2) then exit;

 EffaceZone(0,xg+1,yh+1,xd-1,yb-1,16*or_fond+blanc);
 if (aspect and encadre)=encadre then CadreOmbre(xg+1,yh+1,xd-1,yb-1,convexe);

 ptr_VRAM:=PtrVRAM(0,xg,yh);
 asm
  les DI,ptr_VRAM

  mov CH,yb
  sub CH,yh
  dec CH
  mov CL,xd
  sub CL,xg
  dec CL

  xor DH,DH
  mov DL,largeur_ecran_txt
  shl DX,1

  mov AX,ES:[DI]
  and AH,11110000b
  or  AH,or_clair
  mov AL,car_coin_fen_sup_g
  mov ES:[DI],AX
  add DI,2

  push CX
 @bord_haut:
  mov AX,ES:[DI]
  and AH,11110000b
  or  AH,or_clair
  mov AL,''
  mov ES:[DI],AX
  add DI,2
  dec CL
  jnz @bord_haut
  pop CX

  mov AX,ES:[DI]
  and AH,11110000b
  or  AH,or_moyen
  mov AL,car_coin_fen_sup_d
  mov ES:[DI],AX
  add DI,DX

  push CX
 @bord_droit:
  mov AH,or_sombre
  mov AL,''
  mov ES:[DI],AX
  add DI,DX
  dec CH
  jnz @bord_droit
  pop CX

  mov AH,or_sombre
  mov AL,car_coin_fen_inf_d
  mov ES:[DI],AX
  sub DI,2

  push CX
 @bord_bas:
  mov AH,or_sombre
  mov AL,''
  mov ES:[DI],AX
  sub DI,2
  dec CL
  jnz @bord_bas
  pop CX

  mov AX,ES:[DI]
  and AH,11110000b
  or  AH,or_moyen
  mov AL,car_coin_fen_inf_g
  mov ES:[DI],AX
  sub DI,DX

  push CX
 @bord_gauche:
  mov AX,ES:[DI]
  and AH,11110000b
  or  AH,or_clair
  mov AL,''
  mov ES:[DI],AX
  sub DI,DX
  dec CH
  jnz @bord_gauche
  pop CX
 end
end; {FenetreOmbre}

{----------------------------------------------------------}

procedure ZoomFenetreOmbre(xg,yh,xd,yb,aspect: BYTE);

const facteur=10;

var xc,yc,i: BYTE;
	xgr,yhr,xdr,ybr, dxgr,dyhr,dxdr,dybr: REAL;

begin
 xc:=(xg+xd) div 2; yc:=(yh+yb) div 2;
 xgr:=xc-(xc-xg)/facteur; xdr:=xgr+(xd-xg+1)/facteur-1;
 yhr:=yc-(yc-yh)/facteur; ybr:=yhr+(yb-yh+1)/facteur-1;
 dxgr:=(xg-xgr)/(facteur-1); dxdr:=(xd-xdr)/(facteur-1);
 dyhr:=(yh-yhr)/(facteur-1); dybr:=(yb-ybr)/(facteur-1);
 for i:=1 to facteur do begin
   AttendVBL2;
   FenetreOmbre(Round(xgr),Round(yhr),Round(xdr),Round(ybr),aspect);
   xgr:=xgr+dxgr; xdr:=xdr+dxdr;
   yhr:=yhr+dyhr; ybr:=ybr+dybr
 end
end; {ZoomFenetreOmbre}

{----------------------------------------------------------}

procedure AfficheAscenseur(x_asc,y_asc,hauteur_fenetre: BYTE; longueur_liste,index_premier: WORD);
{conditions: hauteur_fenetre>5
			 longueur_liste>hauteur_fenetre
			 1  index_premier  longueur_liste-hauteur_fenetre+1}

var h_asc,pos_asc: BYTE;
	ptr_VRAM: POINTER;

begin
 h_asc:=1+Round((hauteur_fenetre-4)*(hauteur_fenetre-1)/(longueur_liste-2)); {hauteur barre ascenseur}
 pos_asc:=1+Round((index_premier-1)*(hauteur_fenetre-2-h_asc)/(longueur_liste-hauteur_fenetre)); {position barre ascenseur}
 ptr_VRAM:=PtrVRAM(0,x_asc,y_asc);

 asm
  cld
  les DI,ptr_VRAM

  xor DH,DH
  mov DL,largeur_ecran_txt
  sub DL,2
  shl DX,1			{incrment DI: DX=2*(largeur_ecran_txt-2)}

  mov AX,256*coul_fl_asc+car_fl_hg_asc
  stosw
  mov AL,car_fl_hd_asc
  stosw
  add DI,DX

  xor CH,CH
  mov CL,pos_asc
  dec CL
  mov BL,CL			{BL=CL=pos_asc-1}
  jcxz @barre_ascenseur
  mov AX,256*coul_fond_asc+' '
 @affiche_zone_sombre_sup:
  stosw
  stosw
  add DI,DX
  loop @affiche_zone_sombre_sup

 @barre_ascenseur:
  mov AX,256*coul_barre_asc+' '
  mov CL,h_asc
 @affiche_barre_ascenseur:
  stosw
  stosw
  add DI,DX
  loop @affiche_barre_ascenseur

  mov CL,hauteur_fenetre
  sub CL,2
  sub CL,h_asc
  sub CL,BL			{CL=(hauteur_fenetre-2)-h_asc-(pos_asc-1)}
  jcxz @fleche_bas

  mov AX,256*coul_fond_asc+' '
 @affiche_zone_sombre_inf:
  stosw
  stosw
  add DI,DX
  loop @affiche_zone_sombre_inf

 @fleche_bas:
  mov AX,256*coul_fl_asc+car_fl_bg_asc
  stosw
  mov AL,car_fl_bd_asc
  stosw
 end
end; {AfficheAscenseur}

{----------------------------------------------------------}

procedure AfficheCurseur(x,y,longueur,position: BYTE; aff_plus_moins: BOOLEAN);
begin
 AffChXY(0,x,y,RepeteCar(car_barre_curs,longueur),coul_barre_curs);
 AffCarXY(0,x+position,y,car_curs,coul_curs);
 if aff_plus_moins then begin
   AffCarXY(0,x-1,y,'-',coul_plus_moins);
   AffCarXY(0,x+longueur,y,'+',coul_plus_moins);
 end;
end; {AfficheCurseur}

{----------------------------------------------------------}

procedure AfficheBarreCurseur(x,y,longueur: BYTE; car: CHAR; val_max,valeur: WORD);
var long_barre: BYTE;
begin
 if val_max<>0 then long_barre:=(longueur*valeur) div val_max
			   else long_barre:=0;
 AffChXY2(0,x,y,RepeteCar(car,long_barre)+'^'+RepeteCar(car,longueur-long_barre),coul_barre,coul_barre_fond);
end; {AfficheBarreCurseur}

{----------------------------------------------------------}

procedure AfficheBoutonsOKAnnuler(y: BYTE; var boutonOK,boutonAnnuler: Bouton3D);

const ecart=10;
	  txt_Annule: array[langues] of STRING[8]=('^C^ancel','^A^nnule');

begin
 boutonOK	  .Definit(0,x_milieu-(ecart div 2)-6,y+1,'  ^O^K  ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 boutonAnnuler.Definit(0,x_milieu+(ecart div 2),y+1,' '+txt_Annule[Langue]+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);
 AffCursSouris;
 boutonOK.Affiche;
 boutonAnnuler.Affiche;
end; {AfficheBoutonsOKAnnuler}

{----------------------------------------------------------}

procedure AfficheBoutonsOuiNon(y: BYTE; var boutonOui,boutonNon: Bouton3D);

const ecart=6;
	  txt_Oui: array[langues] of STRING[5]=('^Y^es','^O^ui');
	  txt_Non: array[langues] of STRING[5]=('^N^o' ,'^N^on');

begin
 boutonOui.Definit(0,x_milieu-(ecart div 2)-5,y+1,' '+txt_Oui[Langue]+' ',TRUE,0,
				   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
				   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
				   car_bt_coin);

 boutonNon.Definit(0,x_milieu+(ecart div 2),y+1,' '+txt_Non[Langue]+' ',TRUE,0,
				   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
				   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
				   car_bt_coin);
 AffCursSouris;
 boutonOui.Affiche;
 boutonNon.Affiche;
end; {AfficheBoutonsOuiNon}

{----------------------------------------------------------}

procedure AffFenModules;
begin
 CacheCursSouris;

 FenetreOmbre(xg_fen_modules,yh_fen_modules,xd_fen_modules,yb_fen_modules,encadre);
 LigneHorizontale(0,1,yh_fen_modules+ 3,xg_fen_modules+2,xg_fen_modules+2+larg_fen_modules-5,16*or_fond+or_sombre);
 LigneVerticale	 (0,1,xg_fen_modules+ 5,yh_fen_modules+4,yh_fen_modules+4+haut_lst_modules-1,16*or_fond+or_sombre);
 LigneVerticale	 (0,1,xg_fen_modules+45,yh_fen_modules+4,yh_fen_modules+4+haut_lst_modules-1,16*or_fond+or_sombre);

 {intersections caractres semi-graphiques}
 AffChXY(0,xg_fen_modules+ 5,yh_fen_modules+3,'',16*or_fond+or_sombre);
 AffChXY(0,xg_fen_modules+45,yh_fen_modules+3,'',16*or_fond+or_sombre);

 AffCursSouris;

end; {AffFenModules}

{----------------------------------------------------------}

procedure AffFenControle(affiche_tout: BOOLEAN);
var ch: String25;
begin
 CacheCursSouris;

 if affiche_tout then begin
   {efface le bord gauche de la fentre (ncessaire en cas de raffichage)}
   EffaceZone(0,xg_fen_controle,yh_fen_controle,xg_fen_controle,yb_fen_controle,16*noir);

   FenetreOmbre(xg_fen_controle,yh_fen_controle,xd_fen_controle,yb_fen_controle,encadre);

   {cadre sortie sonore}
   CadreOmbre(x_cadre_sortie,y_cadre_sortie,
			  x_cadre_sortie+larg_cadre_sortie-1,y_cadre_sortie+haut_cadre_sortie-1,convexe);
   AffChXY(0,x_txt_sortie,y_txt_sortie,txt_sortie[Langue],16*or_fond+noir);

   {cadre configuration}
   CadreOmbre(x_cadre_config,y_cadre_config,
			  x_cadre_config+larg_cadre_config-1,y_cadre_config+haut_cadre_config-1,convexe);

   {cadre fonctions Introscan/Shuffle}
   CadreOmbre(x_cadre_fonct,y_cadre_fonct,
			  x_cadre_fonct+larg_cadre_fonct-1,y_cadre_fonct+haut_cadre_fonct-1,convexe);

   {cadre programme}
   CadreOmbre(x_cadre_prog,y_cadre_prog,
			  x_cadre_prog+larg_cadre_prog-1,y_cadre_prog+haut_cadre_prog-1,convexe);

   {cadre titre programme}
   CadreOmbre(x_cadre_titre_prog,y_cadre_titre_prog,
			  x_cadre_titre_prog+larg_cadre_titre_prog-1,y_cadre_titre_prog+haut_cadre_titre_prog-1,concave);
   AffChXY(0,x_txt_prog,y_txt_prog,txt_prog[Langue],16*or_fond+noir);

   {cadre CD}
   CadreOmbre(x_cadre_CD,y_cadre_CD,
			  x_cadre_CD+larg_cadre_CD-1,y_cadre_CD+haut_cadre_CD-1,convexe);

   {cadre afficheurs CD}
   CadreOmbre(x_cadre_aff_CD,y_cadre_aff_CD,
			  x_cadre_aff_CD+larg_cadre_aff_CD-1,y_cadre_aff_CD+haut_cadre_aff_CD-1,concave);
   AffChXY(0,x_txt_CD,y_txt_CD,txt_CD,16*or_fond+noir);

   AffCursSouris;

   {boutons}
   bt_Change.Affiche;
   bt_Config.Affiche;

{	with bt_Introscan do begin Active(FALSE); Affiche end;
   with bt_Shuffle	 do begin Active(FALSE); Affiche end;

   with bt_Lecture do begin Active(FALSE); Affiche end;
   with bt_Tout	   do begin Active(FALSE); Affiche end;
   with bt_Efface  do begin Active(FALSE); Affiche end;
   with bt_Charge  do begin Active(FALSE); Affiche end;
   with bt_Sauve   do begin Active(FALSE); Affiche end;}

   AfficheBoutonsCD;

   CacheCursSouris;
 end;

 {affiche rglages}

 with Variables^ do begin
   {cadre nom sortie sonore}
   CadreOmbre(x_cadre_nom_sortie,y_cadre_nom_sortie,
			  x_cadre_nom_sortie+larg_cadre_nom_sortie-1,y_cadre_nom_sortie+haut_cadre_nom_sortie-1,concave+plein);

   {nom sortie sonore}
   ch:=Sorties[Langue,sortie_sonore];
   case sortie_sonore of
	SB : ch:=ch+' v'+CHAR(48+MinEntier(MMType_SB,2))+'.x';
	GUS: ch:=ch+' '+EntierTexte2(Taille_GUS,3);
   end;

   AffChXY(0,x_nom_sortie,y_nom_sortie,ch,16*or_fond+gris_fonce);

   {infos sortie sonore}
   if sortie_sonore<>GUS then ch:=EntierTexte2(Frequence,5)
						 else ch:='44100';
   ch:=ch+' Hz ';

   case sortie_sonore of
	HPint,
	SMaster,
	Adlib,
	SB	  : ch:=ch+MonoStereo[Langue,0]; {mono}
	CNA,
	DSS	  : ch:=ch+MonoStereo[Langue,0]+' / LPT '+CHAR(48+Num_Port_LPT); {mono}
	SBPro,
	SB16  : ch:=ch+MonoStereo[Langue,BYTE(Utilise_Stereo)];
	GUS	  : ch:=ch+MonoStereo[Langue,1]; {stro}
   end;

   AffChXY(0,x_nom_sortie,y_nom_sortie+1,ch,16*or_fond+gris_fonce);
 end;

 {programme courant: nom du fichier, titre, longueur}
 with programme_courant do begin
   AffChXY2(0,x_fich_prog,y_fich_prog,XString(Nom,' ',8)+' ^('+
									  EntierTexte2(Nombre_modules,3)+')',16*or_fond+or_clair,16*or_fond+noir);
   AffChXY(0,x_titre_prog,y_titre_prog,XString(Titre,' ',long_max_titre_prog),16*or_fond+gris_fonce);
 end;

 AffCursSouris;
end; {AffFenControle}

{----------------------------------------------------------}

procedure AfficheLignesHautBas;
begin
 {ligne du haut}
 EffaceZone(0,1,1,largeur_ecran_txt,1,16*or_sombre+blanc);
 AffChXY(0,x_milieu-15,1,'-- M O D   M A S T E R  v'+version+' --',16*or_sombre+or_clair);

 {ligne du bas}
 EffaceZone(0,1,hauteur_ecran_txt,largeur_ecran_txt,hauteur_ecran_txt,16*or_sombre+blanc);
 AffChXY(0,2,hauteur_ecran_txt,copyright,16*or_sombre+or_fond);
 AffChXY(0,largeur_ecran_txt-9,hauteur_ecran_txt,'<F1>='+txt_aide[Langue],16*or_sombre+or_clair);
end; {AfficheLignesHautBas}

{----------------------------------------------------------}

procedure InitInterface;
begin
 palette_noire.Fixe;
 EffacePage(0,blanc);

 AfficheLignesHautBas;

 {initialise boutons fentre contrle}
 bt_Change	  .Definit(0,x_bt_Change+1,y_bt_Change+1,' '+txt_bt_Change+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);


 bt_Config	  .Definit(0,x_bt_Config+1,y_bt_Config+1,' '+txt_bt_Config+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);


 bt_Introscan .Definit(0,x_bt_Introscan+1,y_bt_Introscan+1,' '+txt_bt_Introscan+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 bt_Shuffle	  .Definit(0,x_bt_Shuffle+1,y_bt_Shuffle+1,' '+txt_bt_Shuffle+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);


 bt_Lecture	  .Definit(0,x_bt_Lecture+1,y_bt_Lecture+1,' '+txt_bt_Lecture[Langue]+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 bt_Tout	  .Definit(0,x_bt_Tout+1,y_bt_Tout+1,' '+txt_bt_Tout[Langue]+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 bt_Efface	  .Definit(0,x_bt_Efface+1,y_bt_Efface+1,' '+txt_bt_Efface[Langue]+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 bt_Charge	  .Definit(0,x_bt_Charge+1,y_bt_Charge+1,' '+txt_bt_Charge[Langue]+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 bt_Sauve	  .Definit(0,x_bt_Sauve+1,y_bt_Sauve+1,' '+txt_bt_Sauve[Langue]+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);


 bt_CD_Eject  .Definit(0,x_bt_CD_Eject+1,y_bt_CD_Eject+1,' '+txt_bt_CD_Eject+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 bt_CD_Lecture.Definit(0,x_bt_CD_Lecture+1,y_bt_CD_Lecture+1,' '+txt_bt_CD_Lecture+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 bt_CD_Pause  .Definit(0,x_bt_CD_Pause+1,y_bt_CD_Pause+1,' '+txt_bt_CD_Pause+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 bt_CD_Arret  .Definit(0,x_bt_CD_Arret+1,y_bt_CD_Arret+1,' '+txt_bt_CD_Arret+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 bt_CD_Prec	  .Definit(0,x_bt_CD_Prec+1,y_bt_CD_Prec+1,' '+txt_bt_CD_Prec+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 bt_CD_Retour .Definit(0,x_bt_CD_Retour+1,y_bt_CD_Retour+1,' '+txt_bt_CD_Retour+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 bt_CD_Avance .Definit(0,x_bt_CD_Avance+1,y_bt_CD_Avance+1,' '+txt_bt_CD_Avance+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 bt_CD_Suiv	  .Definit(0,x_bt_CD_Suiv+1,y_bt_CD_Suiv+1,' '+txt_bt_CD_Suiv+' ',TRUE,0,
					   coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
					   coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
					   car_bt_coin);

 AffCursSouris;

 AttendVBL;
 AffFenModules;
 AffFenControle(TRUE);

 SensibiliteSouris(sensib_souris,sensib_souris,10);
 CorrigePalette(corr_R,corr_V,corr_B,FALSE);

 palette_ModM.Fondu(auto)
end; {InitInterface}

{----------------------------------------------------------}

procedure AfficheBoutonsModules;
begin
 with bt_IntroScan do begin Active(nbr_modules<>0); Affiche end;
 with bt_Shuffle   do begin Active(nbr_modules<>0); Affiche end;

 with bt_Charge	 do begin Active(PRG_present  ); Affiche end;
 with bt_Sauve	 do begin Active(programme_courant.Nombre_modules<>0); Affiche end;
 with bt_Lecture do begin Active(programme_courant.Nombre_modules<>0); Affiche end;
 with bt_Tout	 do begin Active(nbr_modules<>0); Affiche end;
 with bt_Efface	 do begin Active(programme_courant.Nombre_modules<>0); Affiche end;

 AffCarXY(0,x_LED_prog,y_LED_prog,car_LED,16*or_fond+couleur_LED_r[programme_courant.modifie]);
end; {AfficheBoutonsModules}

{----------------------------------------------------------}

procedure AfficheBoutonsCD;
var CD_audio,playing,paused: BOOLEAN;
begin
 CD_audio:=CD.Installed and CD.IsAudio and not(CD.IsOpen) and CD.IsLoaded;
 playing :=CD_audio and CD.IsBusy and not(CD.IsPaused);
 paused	 :=CD_audio and (CD.IsPaused or CD.IsBusy);

 if CD_audio then CD.GetInfo;

 with bt_CD_Eject	do begin Active(CD.Installed); Affiche end;
 with bt_CD_Lecture do begin Active(CD_audio); Affiche end;
 with bt_CD_Prec	do begin Active(CD_audio and (CD.CurrentTrack>CD.FirstTrack)); Affiche end;
 with bt_CD_Suiv	do begin Active(CD_audio and (CD.CurrentTrack<CD.LastTrack )); Affiche end;
 with bt_CD_Retour	do begin Active(playing ); Affiche end;
 with bt_CD_Avance	do begin Active(playing ); Affiche end;
 with bt_CD_Pause	do begin Active(paused	); Affiche end;
 with bt_CD_Arret	do begin Active(paused	); Affiche end;

 AffCarXY(0,x_LED_Lecture,y_LED_Lecture,car_LED,16*or_fond+couleur_LED_v[playing]);
end; {AfficheBoutonsCD}

{----------------------------------------------------------}

function MessageErreur(erreur: WORD; nom_fichier: String80): BYTE;
{si Hi(erreur)=$00		 : renvoie une alternative Rpte/continue/Change/Annule
 si Hi(erreur)=msg_donnee: renvoie une donne > nombre_alt_max

exemples:
 1. MessageErreur(f_err_fich_intr,'...') renvoie une alternative

 2. (f_erreur=f_err_pas_pret)
	MessageErreur(f_erreur+msg_donnee,'...') renvoie alt_annule ou le nouveau lecteur

signification des alternatives:
 alt_repete	 : rpte l'action qui a provoqu l'erreur
 alt_continue: ignore l'erreur et poursuit l'excution
 alt_change	 : revient en arrire pour essayer de corriger l'erreur
 alt_annule	 : ignore l'erreur et sort du bloc courant

   ERREURS		   Rpte continue Change Annule	donne
 1					  		  		 		x
 f_err_fich_intr	  		  x		 		x
 f_err_ch_intr		  		  x		 		x
 f_err_trop_fich	  		  		 		x
 f_err_acces_ref	  x		  x		 		x
 f_err_handle		  		  		 		
 f_err_lecteur		  		  		 		
 f_err_plus_fich	  		  		 		
 f_err_existe		  x		  		 x		x
 f_err_protect		 (x)	  		 		x
 f_err_pas_pret		  x		  		 		x	 nouveau lecteur
 f_err_disq_plein	  x		  		 		x
 f_err_CRC			  x		  x		 		x
 f_err_donnees		  x		  x		 		x
 f_err_media		  x		  x		 		x
 f_err_secteur		  x		  x		 		x				 }

const largeur_min=24; largeur_max=80; hauteur_init=8;
	  largeur_bouton_max=8+2;

	  txt_bt_Repete	 : array[langues] of STRING[8]=('^R^epeat','^R^pte');
	  txt_bt_Continue							   ='^C^ontinue';
	  txt_bt_Change	 : array[langues] of STRING[8]=('^M^odify','C^h^ange');
	  txt_bt_Annule	 : array[langues] of STRING[8]=('Ca^n^cel','^A^nnule');

var nombre_alt,numero_alt,largeur,hauteur,xg,yh: BYTE;
	x: array[1..nombre_alt_max] of BYTE;
	ch1: STRING[35];
	ch2: String80;
	bt_Repete,bt_Continue,bt_Change,bt_Annule: Bouton3D;
	liste_lecteurs: String26;
	alt: alternatives;
	touche: Key;
	z: Zone;

begin
 case Lo(erreur) of
  err_format	  : begin
					 case Langue of
					  Anglais : ch1:='Invalid format';
					  Francais: ch1:='Erreur de format';
					 end;
					 ch2:='';
					 alt:=[alt_annule]
					end;
  f_err_fich_intr : begin
					 case Langue of
					  Anglais : ch1:='File not found';
					  Francais: ch1:='Fichier introuvable';
					 end;
					 ch2:=nom_fichier;
					 alt:=[alt_continue,alt_annule]
					end;
  f_err_ch_intr	  : begin
					 case Langue of
					  Anglais : ch1:='Path not found';
					  Francais: ch1:='Chemin introuvable';
					 end;
					 ch2:=RepertoireSeul(nom_fichier);
					 alt:=[alt_continue,alt_annule]
					end;
  f_err_trop_fich : begin
					 case Langue of
					  Anglais : ch1:='Too many files opened';
					  Francais: ch1:='Trop de fichiers ouverts';
					 end;
					 ch2:='';
					 alt:=[alt_annule]
					end;
  f_err_acces_ref : begin
					 case Langue of
					  Anglais : ch1:='File access denied';
					  Francais: ch1:='Accs au fichier refus';
					 end;
					 ch2:=nom_fichier;
					 alt:=[alt_repete,alt_continue,alt_annule]
					end;
  f_err_existe	  : begin
					 case Langue of
					  Anglais : ch1:='File already exists';
					  Francais: ch1:='Fichier existe dj sous ce nom';
					 end;
					 ch2:=nom_fichier;
					 alt:=[alt_repete,alt_change,alt_annule]
					end;
  f_err_protect	  : if nom_fichier[1]=LettreCDRom then
					 begin
					  case Langue of
					   Anglais : ch1:='Can''t write to CD-Rom';
					   Francais: ch1:='Impossible d''crire sur le CD-Rom';
					  end;
					  ch2:='';
					  alt:=[alt_annule]
					 end
					else
					 begin
					  case Langue of
					   Anglais : ch1:='Disk is write-protected';
					   Francais: ch1:='Disque protg en criture';
					  end;
					  ch2:='';
					  alt:=[alt_repete,alt_annule]
					 end;
  f_err_pas_pret  : begin
					 case Langue of
					  Anglais : ch1:='Drive '+nom_fichier[1]+' empty or not ready';
					  Francais: ch1:='Lecteur '+nom_fichier[1]+' vide ou pas prt';
					 end;
					 if Hi(erreur)=Hi(msg_donnee) then
					  begin
					   case Langue of
						Anglais : ch2:='New drive ?'+nom_fichier[1];
						Francais: ch2:='Nouveau lecteur ?'+nom_fichier[1];
					   end;
					   alt:=[]
					  end
					 else
					  begin ch2:=''; alt:=[alt_repete,alt_annule] end
					end;
  f_err_disq_plein: begin
					 case Langue of
					  Anglais : ch1:='Disk '+nom_fichier[1]+' full';
					  Francais: ch1:='Disque '+nom_fichier[1]+' plein';
					 end;
					 ch2:='';
					 alt:=[alt_repete,alt_annule]
					end;
  f_err_CRC,
  f_err_donnees,
  f_err_media,
  f_err_secteur	  : begin
					 case Langue of
					  Anglais : ch1:='Data error on drive '+nom_fichier[1];
					  Francais: ch1:='Erreur de donnes sur lecteur '+nom_fichier[1];
					 end;
					 ch2:='';
					 alt:=[alt_repete,alt_continue,alt_annule]
					end;
  f_err_ecriture,
  f_err_lecture	  : begin
					 case Langue of
					  Anglais : ch1:='Can''t access to drive '+nom_fichier[1];
					  Francais: ch1:='Accs au lecteur '+nom_fichier[1]+' impossible';
					 end;
					 ch2:='';
					 alt:=[alt_annule];
					end;
  f_err_disq_inut : begin
					 case Langue of
					  Anglais : ch1:='Disk '+nom_fichier[1]+' is defective';
					  Francais: ch1:='Disque '+nom_fichier[1]+' inutilisable';
					 end;
					 ch2:='';
					 alt:=[alt_annule];
					end;

  {erreurs chargement module}
  base_err_module+err_memoire:
					begin
					 case Langue of
					  Anglais : ch1:='not enough memory to load';
					  Francais: ch1:='Mmoire insuffisante pour charger';
					 end;
					 ch2:=nom_fichier;
					 alt:=[alt_annule]
					end;
  base_err_module+err_format:
					begin
					 case Langue of
					  Anglais : ch1:='Invalid file format in';
					  Francais: ch1:='Erreur de format dans';
					 end;
					 ch2:=nom_fichier;
					 alt:=[alt_annule]
					end;
  base_err_module+err_lecture:
					begin
					 case Langue of
					  Anglais : ch1:='Error while reading';
					  Francais: ch1:='Erreur pendant la lecture de';
					 end;
					 ch2:=nom_fichier;
					 alt:=[alt_annule]
					end;
  base_err_module+err_pas_sample:
					begin
					 case Langue of
					  Anglais : ch1:='No samples found in';
					  Francais: ch1:='Aucun instrument dans';
					 end;
					 ch2:=nom_fichier;
					 alt:=[alt_annule]
					end;
  base_err_module+err_version_inconnue:
					begin
					 case Langue of
					  Anglais : ch1:='Version not supported in';
					  Francais: ch1:='Version non gre dans';
					 end;
					 ch2:=nom_fichier;
					 alt:=[alt_annule]
					end;
  base_err_module+err_non_gere:
					begin
					 case Langue of
					  Anglais : ch1:='File format not supported in';
					  Francais: ch1:='Format non gr dans';
					 end;
					 ch2:=nom_fichier;
					 alt:=[alt_annule]
					end;
  base_err_module+err_archive:
					begin
					 case Langue of
					  Anglais : ch1:='Unable to decompress';
					  Francais: ch1:='Impossible de dcompacter';
					 end;
					 ch2:=nom_fichier;
					 alt:=[alt_annule]
					end;

  {erreur lancement musique}
  base_err_musique+err_musique_pas_chargee:
					begin
					 case Langue of
					  Anglais : ch1:='Song not loaded from';
					  Francais: ch1:='Musique non charge de';
					 end;
					 ch2:=nom_fichier;
					 alt:=[alt_annule]
					end;
  base_err_musique+err_SB:
					begin
					 case Langue of
					  Anglais : ch1:='Sound Blaster time-out';
					  Francais: ch1:='Erreur Sound Blaster';
					 end;
					 ch2:='';
					 alt:=[alt_annule]
					end;
  base_err_musique+err_Adlib:
					begin
					 case Langue of
					  Anglais : ch1:='Adlib not available';
					  Francais: ch1:='Adlib non disponible';
					 end;
					 ch2:='';
					 alt:=[alt_annule]
					end;
  else begin
	case Langue of
	 Anglais : ch1:='Unknown error';
	 Francais: ch1:='Erreur inconnue';
	end;
	ch2:='';
	alt:=[alt_annule]
  end
 end;

 nombre_alt:=0;
 if alt_repete	 in alt then inc(nombre_alt);
 if alt_continue in alt then inc(nombre_alt);
 if alt_change	 in alt then inc(nombre_alt);
 if alt_annule	 in alt then inc(nombre_alt);

 {calcule les dimensions de la fentre en fonction de son contenu}
 largeur:=MaxEntier(LimiteEntier(MaxEntier(Length(ch1),Length(ch2))+8,largeur_min,largeur_max),
		  nombre_alt*(largeur_bouton_max+8));
 if ch2='' then hauteur:=hauteur_init
 else
  if Lo(erreur)<>f_err_pas_pret then
   begin hauteur:=hauteur_init+2; ch2:=LimiteNomFichier(ch2,largeur-8) end
  else hauteur:=hauteur_init-1;

 xg:=x_milieu-(largeur div 2); yh:=y_milieu-(hauteur div 2);

 CacheCursSouris;

 z.Sauve(0,xg,yh,xg+largeur-1,yh+hauteur-1);
 ZoomFenetreOmbre(xg,yh,xg+largeur-1,yh+hauteur-1,encadre);

 AffChXYc(yh+2,ch1,16*or_fond+blanc);
 AffChXYc(yh+3,ch2,16*or_fond+or_clair);

 AffCursSouris;
 DefCursSouris(fleche);
 Curseur(off);
 VideBufferClavier;

 Bip(440*7); Bip(440*6);

 if erreur=f_err_pas_pret+msg_donnee then begin
   liste_lecteurs:=ListeLecteurs;
   CursXY(0,x_milieu-(Length(ch2) div 2)+Length(ch2)-1,yh+3);
   Curseur(plat);
   repeat
	touche:=UpCase(ReadKey);
	case touche of
	 Key('A')..Key('Z'): if Pos(CHAR(touche),liste_lecteurs)<>0 then
						  begin MessageErreur:=touche; break end;
	 Enter: begin MessageErreur:=BYTE(nom_fichier[1]); break end;
	 Esc  : begin MessageErreur:=alt_annule; break end
	end
   until FALSE;
   Curseur(off)
 end
 else begin
   for numero_alt:=1 to nombre_alt do
	x[numero_alt]:=x_milieu-(largeur div 2)+1+
				   (numero_alt*(largeur-nombre_alt*largeur_bouton_max)) div (nombre_alt+1)+
				   (numero_alt-1)*largeur_bouton_max;

   {arrange les boutons dans l'ordre: Rpte continue Change Annule}
   numero_alt:=1;
   if alt_repete in alt then with bt_Repete do begin
	 Definit(0,x[numero_alt],yh+hauteur-4,' '+txt_bt_Repete[Langue]+' ',TRUE,0,
			 coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
			 coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
			 car_bt_coin);
	 Affiche; inc(numero_alt)
   end;

   if alt_continue in alt then with bt_Continue do begin
	 Definit(0,x[numero_alt],yh+hauteur-4,' '+txt_bt_Continue+' ',TRUE,0,
			 coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
			 coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
			 car_bt_coin);
	 Affiche; inc(numero_alt)
   end;

   if alt_change in alt then with bt_Change do begin
	 Definit(0,x[numero_alt],yh+hauteur-4,' '+txt_bt_Change[Langue]+' ',TRUE,0,
			 coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
			 coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
			 car_bt_coin);
	 Affiche; inc(numero_alt)
   end;

   with bt_Annule do begin
	 Definit(0,x[numero_alt],yh+hauteur-4,' '+txt_bt_Annule[Langue]+' ',TRUE,0,
			 coul_bt_relache,coul_bt_appuye,coul_bt_lettre,
			 coul_bt_relief_h,coul_bt_relief_b,coul_bt_relief_c,
			 car_bt_coin);
	 Affiche; inc(numero_alt)
   end;

   repeat
	if KeyPressed then begin
	  touche:=ReadKey;
	  if alt_repete in alt then
	   if bt_Repete.Appuye(CHAR(touche)) then begin MessageErreur:=alt_repete; break end;
	  if alt_continue in alt then
	   if bt_Continue.Appuye(CHAR(touche)) then begin MessageErreur:=alt_continue; break end;
	  if alt_change in alt then
	   if bt_Change.Appuye(CHAR(touche)) then begin MessageErreur:=alt_change; break end;
	  if bt_Annule.Appuye(CHAR(touche)) or (touche=Esc) then begin MessageErreur:=alt_annule; break end
	end
	else begin
	  if alt_repete in alt then
	   if bt_Repete.Clique then begin MessageErreur:=alt_repete; break end;
	  if alt_continue in alt then
	   if bt_Continue.Clique then begin MessageErreur:=alt_continue; break end;
	  if alt_change in alt then
	   if bt_Change.Clique then begin MessageErreur:=alt_change; break end;
	  if bt_Annule.Clique then begin MessageErreur:=alt_annule; break end
	end
   until FALSE
 end;

 RestaureZoneSuppr(0,z)
end; {MessageErreur}

{----------------------------------------------------------}

function SupprimeModule(nom_module: String12): BOOLEAN;

var z: Zone;
	boutonOui,boutonNon: Bouton3D;
	sortie,efface: BOOLEAN;
	x,y: BYTE;
	touche: Key;

begin
 CacheCursSouris;
 z.Sauve(0,xg_fen_suppr_mod,yh_fen_suppr_mod,xd_fen_suppr_mod,yb_fen_suppr_mod);
 ZoomFenetreOmbre(xg_fen_suppr_mod,yh_fen_suppr_mod,xd_fen_suppr_mod,yb_fen_suppr_mod,encadre);
 AffChXYc(y_txt_suppr_mod,txt_supprime[Langue]+' '+nom_module+' ?',16*or_fond+or_clair);

 AfficheBoutonsOuiNon(yb_fen_suppr_mod-4,boutonOui,boutonNon);

 repeat
  AttendClavierSouris(TRUE,FALSE,x,y);
  if KeyPressed then begin
	touche:=ReadKey;
	efface:=boutonOui.Appuye(CHAR(touche));
	sortie:=boutonNon.Appuye(CHAR(touche)) or (touche=Esc)
  end
  else begin
	efface:=boutonOui.Clique;
	sortie:=boutonNon.Clique
  end
 until sortie or efface;

 if efface then begin
   repeat
	EffaceFichier(repert+nom_module);
	if f_erreur=f_ok then break;

	case MessageErreur(f_erreur,repert+nom_module) of
	 alt_repete	 : if f_erreur=f_err_acces_ref then
					AttributFichier(repert+nom_module,attr_fixe,Archive);
	 alt_continue,
	 alt_annule	 : break;
	end
   until FALSE;

   SupprimeModule:=(f_erreur=f_ok)
 end
 else SupprimeModule:=FALSE;

 RestaureZoneSuppr(0,z)
end; {SupprimeModule}

{----------------------------------------------------------}

procedure ChangeSortie;

const couleur: array[BOOLEAN] of BYTE=(16*or_fond+or_moyen,16*or_fond+or_clair);

var z: Zone;
	boutonOK,boutonAnnuler: Bouton3D;
	touche: Key;
	x,y,i,tmp_sortie,anc_sortie: BYTE;
	defile,ok,sortie: BOOLEAN;

	tmp_freq: WORD;

	tmp_LPT,tmp_DMA,tmp_DMA16,tmp_IRQ,
	tmp_volL,tmp_volR,
	tmp_pannG,tmp_pannD,
	tmp_MixGUS,tmp_type_SB: BYTE;

	tmp_UtDMA,tmp_UtFilt,tmp_UtSte,tmp_UtDC: BOOLEAN;

	case_DC,
	case_Stereo,case_Filtre: CaseOpt;

	fl_freq_b,fl_freq_h,
	fl_LPT_b,fl_LPT_h,
	fl_canal_DMA_b,fl_canal_DMA_h,
	fl_IRQ_b,fl_IRQ_h: ObjClic;


procedure AfficheNomSortie(numero,couleur: BYTE);
begin
 AffChXY(0,x_nom_sortie_1-1,y_nom_sortie_1+numero,' '+XString(Sorties[Langue,numero],' ',20)+' ',couleur)
end; {AfficheNomSortie}


begin  {ChangeSortie}
 CacheCursSouris;
 z.Sauve(0,xg_fen_sortie,yh_fen_sortie,xd_fen_sortie,yb_fen_sortie);
 ZoomFenetreOmbre(xg_fen_sortie,yh_fen_sortie,xd_fen_sortie,yb_fen_sortie,encadre);

 {cadre liste sorties}
 CadreOmbre(x_cadre_sorties,y_cadre_sorties,
			x_cadre_sorties+larg_cadre_sorties-1,y_cadre_sorties+haut_cadre_sorties-1,concave);
 AffChXY(0,x_txt_sorties,y_txt_sorties,txt_sortie[Langue],16*or_fond+noir);

 LigneHorizontale(0,1,yh_fen_sortie+16,xg_fen_sortie+2,xg_fen_sortie+2+larg_fen_sortie-5,16*or_fond+or_sombre);
 AfficheBoutonsOKAnnuler(yb_fen_sortie-4,boutonOK,boutonAnnuler);

 {cherche les valeurs actuelles}
 with Variables^ do begin
   tmp_sortie:=Sortie_sonore;
   tmp_freq :=Frequence;
   tmp_LPT	:=Num_Port_LPT;
   tmp_DMA	:=DMA_SB8;
   tmp_DMA16:=DMA_SB16;
   tmp_IRQ	:=IRQ_SB;
   tmp_UtFilt:=Utilise_Filtre;
   tmp_UtSte :=Utilise_Stereo;
   tmp_UtDC	 :=Utilise_DC;
   tmp_type_SB:=MMType_SB
 end;
 tmp_UtDMA:=(tmp_sortie in [SB,SBPro,SB16]);
 tmp_volL:=VolumeLeft; tmp_volR:=VolumeRight;
 tmp_pannG:=Panning_Gauche; tmp_pannD:=Panning_Droite;
 tmp_MixGUS:=8-(tmp_pannG div 8);

 {initialise les cases  cocher}
 case_DC	.Definit(0,x_case_DC,y_case_DC,
					 car_case_non_cochee,car_case_cochee,car_case_appuyee,
					 coul_case_act,coul_case_inact);

 case_Stereo.Definit(0,x_case_Stereo,y_case_Stereo,
					 car_case_non_cochee,car_case_cochee,car_case_appuyee,
					 coul_case_act,coul_case_inact);

 case_Filtre.Definit(0,x_case_Filtre,y_case_Filtre,
					 car_case_non_cochee,car_case_cochee,car_case_appuyee,
					 coul_case_act,coul_case_inact);

 {initialise les double-flches  }
 fl_freq_b	   .Definit(0,x_fl_freq	 ,y_fl_freq,car_fl2_b,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);
 fl_freq_h	   .Definit(0,x_fl_freq+3,y_fl_freq,car_fl2_h,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);

 fl_LPT_b	   .Definit(0,x_fl_LPT	,y_fl_LPT,car_fl2_b,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);
 fl_LPT_h	   .Definit(0,x_fl_LPT+3,y_fl_LPT,car_fl2_h,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);

 fl_canal_DMA_b.Definit(0,x_fl_canal_DMA  ,y_fl_canal_DMA,car_fl2_b,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);
 fl_canal_DMA_h.Definit(0,x_fl_canal_DMA+3,y_fl_canal_DMA,car_fl2_h,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);

 fl_IRQ_b	   .Definit(0,x_fl_IRQ	,y_fl_IRQ,car_fl2_b,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);
 fl_IRQ_h	   .Definit(0,x_fl_IRQ+3,y_fl_IRQ,car_fl2_h,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);

 anc_sortie:=nbr_sorties+1; {pour forcer affichage des rglages}
 defile:=FALSE;

 repeat
  CacheCursSouris;

  for i:=0 to nbr_sorties-1 do
   if (i<>tmp_sortie) then AfficheNomSortie(i,couleur[SortiePresente[i]]);
  AfficheNomSortie(tmp_sortie,16*ombre+blanc);

  {raffiche les cadres/textes des rglages}
  if tmp_sortie<>anc_sortie then begin
	AttendVBL;
	EffaceZone(0,xg_fond_regl_sortie,yh_fond_regl_sortie,xd_fond_regl_sortie,yb_fond_regl_sortie,16*or_fond+blanc);

	if tmp_sortie<>GUS then begin
	  {frquence}
	  CadreOmbre(x_cadre_freq,y_cadre_freq,
				 x_cadre_freq+larg_cadre_freq-1,y_cadre_freq+haut_cadre_freq-1,concave);
	  AffChXY(0,x_txt_freq,y_txt_freq,txt_freq[Langue],16*or_fond+noir);
	  fl_freq_b.Affiche; fl_freq_h.Affiche;
	  CacheCursSouris;
	end;

	if (tmp_sortie in [CNA,DSS]) then begin
	  {port LPT}
	  CadreOmbre(x_cadre_LPT,y_cadre_LPT,
				 x_cadre_LPT+larg_cadre_LPT-1,y_cadre_LPT+haut_cadre_LPT-1,concave);
	  AffChXY(0,x_txt_LPT,y_txt_LPT,txt_LPT[Langue],16*or_fond+noir);
	  fl_LPT_b.Affiche; fl_LPT_h.Affiche;
	  CacheCursSouris;
	end;

	if (tmp_sortie in [SB,SBPro,SB16]) then begin
	  {DMA}
	  CadreOmbre(x_cadre_DMA,y_cadre_DMA,
				 x_cadre_DMA+larg_cadre_DMA-1,y_cadre_DMA+haut_cadre_DMA-1,concave);
	  AffChXY(0,x_txt_DMA,y_txt_DMA,txt_DMA,16*or_fond+noir);
	  AffChXY(0,x_txt_canal_DMA,y_txt_canal_DMA,txt_canal_DMA[Langue],16*or_fond+or_clair);
	  AffChXY(0,x_txt_DC,y_txt_DC,txt_DC[Langue],16*or_fond+or_clair);
	  fl_canal_DMA_b.Affiche; fl_canal_DMA_h.Affiche;
	  CacheCursSouris;

	  {IRQ}
	  CadreOmbre(x_cadre_IRQ,y_cadre_IRQ,
				 x_cadre_IRQ+larg_cadre_IRQ-1,y_cadre_IRQ+haut_cadre_IRQ-1,concave);
	  AffChXY(0,x_txt_IRQ,y_txt_IRQ,txt_IRQ,16*or_fond+noir);
	  fl_IRQ_b.Affiche; fl_IRQ_h.Affiche;
	  CacheCursSouris;
	end;

	if tmp_sortie=SB then begin
	  {version SB}
	  CadreOmbre(x_cadre_vSB,y_cadre_vSB,
				 x_cadre_vSB+larg_cadre_vSB-1,y_cadre_vSB+haut_cadre_vSB-1,concave);
	  AffChXY(0,x_txt_vSB,y_txt_vSB,txt_vSB,16*or_fond+noir);
	end;

	case tmp_sortie of
	 SBPro,SB16:
			begin
			 {volume gauche/droite}
			 CadreOmbre(x_cadre_vol_SB,y_cadre_vol_SB,
						x_cadre_vol_SB+larg_cadre_vol_SB-1,y_cadre_vol_SB+haut_cadre_vol_SB-1,concave);
			 AffChXY(0,x_txt_vol_SB,y_txt_vol_SB,txt_vol_SB,16*or_fond+noir);
			 AffChXY(0,x_txt_vol_SB_g,y_txt_vol_SB_g,txt_vol_SB_g[Langue],16*or_fond+or_clair);
			 AffChXY(0,x_txt_vol_SB_d,y_txt_vol_SB_d,txt_vol_SB_d[Langue],16*or_fond+or_clair);

			 {son: stro,filtre}
			 CadreOmbre(x_cadre_son_SBPro,y_cadre_son_SBPro,
						x_cadre_son_SBPro+larg_cadre_son_SBPro-1,y_cadre_son_SBPro+haut_cadre_son_SBPro-1,concave);
			 AffChXY(0,x_txt_son_SBPro,y_txt_son_SBPro,txt_son_SBPro[Langue],16*or_fond+noir);
			 AffChXY(0,x_txt_stereo,y_txt_stereo,MonoStereo[Langue,1],16*or_fond+or_clair);
			 AffChXY(0,x_txt_filtre,y_txt_filtre,txt_filtre[Langue],16*or_fond+or_clair);
			end;
	 GUS  : begin
			 {mixage mono/stro}
			 CadreOmbre(x_cadre_mix_GUS,y_cadre_mix_GUS,
						x_cadre_mix_GUS+larg_cadre_mix_GUS-1,y_cadre_mix_GUS+haut_cadre_mix_GUS-1,concave);
			 AffChXY(0,x_txt_mix_GUS,y_txt_mix_GUS,txt_mix_GUS[Langue],16*or_fond+noir);
			 AffChXY(0,x_txt_mix_GUS_mono  ,y_txt_mix_GUS_mono	,MonoStereo[Langue,0],16*or_fond+or_clair);
			 AffChXY(0,x_txt_mix_GUS_stereo,y_txt_mix_GUS_stereo,MonoStereo[Langue,1],16*or_fond+or_clair);
			end
	end;
	anc_sortie:=tmp_sortie
  end;

  CorrigeParametres(tmp_sortie,tmp_type_SB,tmp_freq,
					tmp_UtDMA,tmp_UtSte,tmp_UtFilt,tmp_UtDC,tmp_IRQ);

  {raffiche les valeurs des rglages}
  if tmp_sortie<>GUS then
   {frquence}
   AffChXY(0,x_val_freq,y_val_freq,EntierTexte2(tmp_freq,5)+' Hz',16*or_fond+gris_fonce);

  if (tmp_sortie in [CNA,DSS]) then
   {port LPT}
   AffCarXY(0,x_val_LPT,y_val_LPT,CHAR(48+tmp_LPT),16*or_fond+gris_fonce);

  if (tmp_sortie in [SB,SBPro,SB16]) then begin
	{DMA}
	AffCarXY(0,x_canal_DMA,y_canal_DMA,CHAR(48+tmp_DMA),16*or_fond+gris_fonce);
	with case_DC do begin Coche(tmp_UtDC); Affiche end;
	CacheCursSouris;
	{IRQ}
	AffChXY(0,x_IRQ,y_IRQ,EntierTexte2(tmp_IRQ,2),16*or_fond+gris_fonce);
  end;

  if tmp_sortie=SB then
   {version SB}
   AffChXY(0,x_vSB,y_vSB,CHAR(48+MinEntier(tmp_type_SB,2))+'.x',16*or_fond+gris_fonce);

  case tmp_sortie of
   SBPro,SB16:
		begin
		 with case_Stereo do begin Coche(tmp_UtSte) ; Affiche end;
		 with case_Filtre do begin Coche(tmp_UtFilt); Affiche end;
		 CacheCursSouris;
		 {volume gauche/droite}
		 AfficheCurseur(xg_vol_SB_g_curs,y_vol_SB_g_curs,larg_curs_vol_SB,tmp_volL,TRUE);
		 AfficheCurseur(xg_vol_SB_d_curs,y_vol_SB_d_curs,larg_curs_vol_SB,tmp_volR,TRUE);
		end;
   GUS: AfficheCurseur(xg_mix_GUS_curs,y_mix_GUS_curs,larg_curs_mix_GUS,tmp_MixGUS,FALSE);
  end;

  AttendClavierSouris(not defile,FALSE,x,y);
  defile:=FALSE;

  if KeyPressed then begin
	touche:=ReadKey;
	case touche of
{	  F1..F9: begin
			  SortiePresente[touche-F1]:=not(SortiePresente[touche-F1]);
			  if not(SortiePresente[tmp_sortie]) then
			   if tmp_sortie<nbr_sorties-1 then begin
				 i:=tmp_sortie+1;
				 while not(SortiePresente[i]) and (i<nbr_sorties-1) do inc(i);
				 if SortiePresente[i] then tmp_sortie:=i
			   end;
			 end;}
	 Up	 : if tmp_sortie>0 then begin
			 i:=tmp_sortie-1;
			 while not(SortiePresente[i]) and (i>0) do dec(i);
			 if SortiePresente[i] then tmp_sortie:=i
		   end;
	 Down: if tmp_sortie<nbr_sorties-1 then begin
			 i:=tmp_sortie+1;
			 while not(SortiePresente[i]) and (i<nbr_sorties-1) do inc(i);
			 if SortiePresente[i] then tmp_sortie:=i
		   end;
	 PgUp,Home: begin
				 i:=0;
				 while not(SortiePresente[i]) do inc(i);
				 tmp_sortie:=i
				end;
	 PgDn,End_: begin
				 i:=nbr_sorties-1;
				 while not(SortiePresente[i]) do dec(i);
				 tmp_sortie:=i
				end
	end;
	if touche>255 then touche:=0; {pour viter que les codes tendus activent un bouton}

	ok:=(touche=Enter) or boutonOK.Appuye(CHAR(touche));
	sortie:=(touche=Esc) or boutonAnnuler.Appuye(CHAR(touche));
  end

  else begin {souris...}

	if (x in [x_nom_sortie_1-1..x_nom_sortie_1+larg_cadre_sorties-4]) and
	   (y in [y_nom_sortie_1..y_nom_sortie_1+nbr_sorties-1]) then
	 if SortiePresente[y-y_nom_sortie_1] then tmp_sortie:=y-y_nom_sortie_1;

	if tmp_sortie<>GUS then begin
	  {frquence}
	  if fl_freq_b.Clique and (tmp_freq>5000) then begin dec(tmp_freq,100); defile:=TRUE end
	  else
	  if fl_freq_h.Clique and
		 (tmp_freq<FreqMax(tmp_sortie,tmp_type_SB,tmp_UtSte,tmp_UtDC)) then
	   begin inc(tmp_freq,100); defile:=TRUE end
	end;

	if (tmp_sortie in [CNA,DSS]) then begin
	  {port LPT}
	  if fl_LPT_b.Clique and (tmp_LPT>1) then begin
		i:=tmp_LPT-1;
		while not(LPT_Present[i]) and (i>1) do dec(i);
		if LPT_Present[i] then begin tmp_LPT:=i; defile:=TRUE end
	  end
	  else
	  if fl_LPT_h.Clique and (tmp_LPT<4) then begin
		i:=tmp_LPT+1;
		while not(LPT_Present[i]) and (i<4) do inc(i);
		if LPT_Present[i] then begin tmp_LPT:=i; defile:=TRUE end
	  end;
	end;

	if (tmp_sortie in [SB,SBPro,SB16]) then begin
	  {DMA}
	  if fl_canal_DMA_b.Clique then begin
		case tmp_DMA of
		 0:;
		 1: tmp_DMA:=0;
		 3: tmp_DMA:=1;
		end;
		defile:=TRUE
	  end
	  else
	  if fl_canal_DMA_h.Clique then begin
		case tmp_DMA of
		 0: tmp_DMA:=1;
		 1: tmp_DMA:=3;
		 3:;
		end;
		defile:=TRUE
	  end
	  else

	  if case_DC.Cliquee then tmp_UtDC:=not(tmp_UtDC)
	  else

	  {IRQ}
	  if fl_IRQ_b.Clique then begin
		case tmp_IRQ of
		  2:;
		  5: tmp_IRQ:=2;
		  7: tmp_IRQ:=5;
		 10: tmp_IRQ:=7;
		end;
		defile:=TRUE
	  end
	  else
	  if fl_IRQ_h.Clique then begin
		case tmp_IRQ of
		  2: tmp_IRQ:=5;
		  5: tmp_IRQ:=7;
		  7: if (tmp_sortie in [SBPro,SB16]) then tmp_IRQ:=10;
		 10:;
		end;
		defile:=TRUE
	   end;
	end;

	if tmp_sortie=SB then
	 if (x in [x_vSB..x_vSB+2]) and (y=y_vSB) then
	  {version SB}
	  if tmp_type_SB<=2 then tmp_type_SB:=3-tmp_type_SB;

	case tmp_sortie of
	 SBPro,SB16:
		  begin
		   if case_Stereo.Cliquee then tmp_UtSte :=not(tmp_UtSte);
		   if case_Filtre.Cliquee then tmp_UtFilt:=not(tmp_UtFilt);

		   {volume gauche}
		   if y=y_vol_SB_g_curs then
			case x of
			 x_vol_SB_g_moins: if tmp_volL> 0 then begin dec(tmp_volL); defile:=TRUE end;
			 xg_vol_SB_g_curs..xd_vol_SB_g_curs: tmp_volL:=x-xg_vol_SB_g_curs;
			 x_vol_SB_g_plus : if tmp_volL<15 then begin inc(tmp_volL); defile:=TRUE end
			end;

		   {volume droite}
		   if y=y_vol_SB_d_curs then
			case x of
			 x_vol_SB_d_moins: if tmp_volR> 0 then begin dec(tmp_volR); defile:=TRUE end;
			 xg_vol_SB_d_curs..xd_vol_SB_d_curs: tmp_volR:=x-xg_vol_SB_d_curs;
			 x_vol_SB_d_plus : if tmp_volR<15 then begin inc(tmp_volR); defile:=TRUE end
			end;
		  end;

	 GUS: {mixage mono/stro}
		  if y=y_mix_GUS_curs then
		   case x of
			x_txt_mix_GUS_mono..x_txt_mix_GUS_mono+3: tmp_MixGUS:=0; {mono}
			xg_mix_GUS_curs..xd_mix_GUS_curs: tmp_MixGUS:=x-xg_mix_GUS_curs;
			x_txt_mix_GUS_stereo..x_txt_mix_GUS_stereo+5: tmp_MixGUS:=8; {stro}
		   end;
	end;

	ok:=boutonOK.Clique;
	sortie:=boutonAnnuler.Clique;
	if defile then DelaiBoutonSouris(10)
  end
 until ok or sortie;

 if ok then begin {sauve les nouvelles valeurs}
   with Variables^ do begin
	 Sortie_sonore:=tmp_sortie;
	 if tmp_sortie<>GUS then Frequence:=tmp_freq;
	 if (tmp_sortie in [CNA,DSS]) then begin
	   Num_Port_LPT:=tmp_LPT;
	   Port_LPT:=Hardware.Port_LPT[tmp_LPT];
	 end;
	 if (tmp_sortie in [SB,SBPro,SB16]) then begin
	   DMA_SB8:=tmp_DMA;
	   IRQ_SB:=tmp_IRQ;
	   Utilise_DC:=tmp_UtDC;
	   MMType_SB :=tmp_type_SB
	 end;
	 case tmp_sortie of
	  SBPro,SB16:
		   begin
			Utilise_Filtre:=tmp_UtFilt;
			Utilise_Stereo:=tmp_UtSte;
			VolumeLeft:=tmp_volL; VolumeRight:=tmp_volR;
			EcrireVolume(VolumeLeft,VolumeRight);
			ReglerFiltre(tmp_UtFilt);
			tmp_pannG:=$20; tmp_pannD:=$60
		   end;
	  GUS: begin tmp_pannG:=8*(8-tmp_MixGUS); tmp_pannD:=$80-tmp_pannG end
	 end;
	 CorrigeParametres(Sortie_sonore,MMType_SB,Frequence,Utilise_DMA,Utilise_Stereo,
					   Utilise_Filtre,Utilise_DC,IRQ_SB)
   end;
   Panning_Gauche:=tmp_pannG; Panning_Droite:=tmp_pannD;
   recharge_module:=TRUE
 end;

 RestaureZoneSuppr(0,z);

 if ok then AffFenControle(FALSE)
end; {ChangeSortie}

{----------------------------------------------------------}

procedure ChangeConfig;

var z: Zone;
	boutonOK,boutonAnnuler: Bouton3D;
	touche: Key;
	x,y,i,tmp_config,anc_config: BYTE;
	defile,ok,sortie: BOOLEAN;

	tmp_sensib_sou,
	tmp_vol_def,tmp_delai_eco,tmp_oct_mod,tmp_duree: BYTE;

	tmp_Autoscan,tmp_Autosave,tmp_cree_Desc,
	tmp_scan_ARJ,tmp_scan_LZH,tmp_scan_RAR,tmp_scan_ZIP,
	tmp_utFine,tmp_utPann,tmp_utBPM,
	tmp_utInt,tmp_utEco,
	tmp_utUMB,tmp_utEMS: BOOLEAN;

	tmp_corr_R,tmp_corr_V,tmp_corr_B: SHORTINT;

	case_eco,
	case_Autoscan,case_Autosave,case_Desc,
	case_ARJ,case_LZH,case_RAR,case_ZIP,
	case_fine,case_pann,case_BPM,
	case_interpol,
	case_UMB,case_EMS: CaseOpt;

	fl_vit_sou_b,fl_vit_sou_h,
	fl_eco_b,fl_eco_h,
	fl_pal_R_b,fl_pal_R_h,
	fl_pal_V_b,fl_pal_V_h,
	fl_pal_B_b,fl_pal_B_h,
	fl_vol_def_b,fl_vol_def_h,
	fl_Introscan_b,fl_Introscan_h: ObjClic;


procedure AfficheNomConfig(numero: BYTE; coul: type_coul);
const couleur: array[type_coul] of BYTE=(16*or_fond+or_clair,16*gris_fonce+blanc);
begin
 AffChXY(0,x_nom_config_1-1,y_nom_config_1+numero,' '+XString(Configs[Langue,numero],' ',11)+' ',couleur[coul])
end; {AfficheNomConfig}

function EntierTexteSigne(entier: SHORTINT): String3;
var ch: String3;
begin
 ch:=EntierTexte2(entier,1);
 if entier>0 then ch:='+'+ch;
 while Length(ch)<3 do ch:=' '+ch;
 EntierTexteSigne:=ch;
end; {EntierTexteSigne}


begin  {ChangeConfig}
 CacheCursSouris;
 z.Sauve(0,xg_fen_config,yh_fen_config,xd_fen_config,yb_fen_config);
 ZoomFenetreOmbre(xg_fen_config,yh_fen_config,xd_fen_config,yb_fen_config,encadre);

 {cadre liste configurations}
 CadreOmbre(x_cadre_configs,y_cadre_configs,
			x_cadre_configs+larg_cadre_configs-1,y_cadre_configs+haut_cadre_configs-1,concave);
 AffChXY(0,x_txt_config,y_txt_config,txt_config,16*or_fond+noir);

 LigneHorizontale(0,1,yh_fen_config+16,xg_fen_config+2,xg_fen_config+2+larg_fen_config-5,16*or_fond+or_sombre);
 AfficheBoutonsOKAnnuler(yb_fen_config-4,boutonOK,boutonAnnuler);

 {cherche les valeurs actuelles}
 tmp_sensib_sou:=sensib_souris;
 tmp_corr_R:=corr_R;
 tmp_corr_V:=corr_V;
 tmp_corr_B:=corr_B;
 tmp_utEco:=Utilise_Economiseur;
 tmp_delai_eco:=delai_economiseur;

 tmp_Autoscan:=Autoscan;
 tmp_Autosave:=Autosave;

 tmp_cree_Desc:=cree_Desc;

 tmp_scan_ARJ:=scan_ARJ;
 tmp_scan_LZH:=scan_LZH;
 tmp_scan_RAR:=scan_RAR;
 tmp_scan_ZIP:=scan_ZIP;

 tmp_vol_def:=Volume_par_defaut div 5;
 with Variables^ do begin
   tmp_utFine:=Utiliser_Fine;
   tmp_utPann:=Utiliser_Panning;
   tmp_utBPM :=Utiliser_BPM;
   tmp_utInt :=Utiliser_Interpolation
 end;
 tmp_oct_mod:=Nb_Octaves_MOD;
 tmp_duree:=duree_IntroScan;

 tmp_utUMB:=Utilise_UMB;
 tmp_utEMS:=Utilise_EMS;

 {initialise les cases  cocher}
 case_eco	  .Definit(0,x_case_eco,y_case_eco,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 case_Autoscan.Definit(0,x_case_Autoscan,y_case_Autoscan,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 case_Autosave.Definit(0,x_case_Autosave,y_case_Autosave,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 case_Desc	  .Definit(0,x_case_Desc,y_case_Desc,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 case_ARJ	  .Definit(0,x_case_ARJ,y_case_ARJ,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 case_LZH	  .Definit(0,x_case_LZH,y_case_LZH,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 case_RAR	  .Definit(0,x_case_RAR,y_case_RAR,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 case_ZIP	  .Definit(0,x_case_ZIP,y_case_ZIP,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 case_fine	  .Definit(0,x_case_fine,y_case_fine,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 case_pann	  .Definit(0,x_case_pann,y_case_pann,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 case_BPM	  .Definit(0,x_case_BPM,y_case_BPM,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 case_interpol.Definit(0,x_case_interpol,y_case_interpol,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 case_UMB	  .Definit(0,x_case_UMB,y_case_UMB,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 case_EMS	  .Definit(0,x_case_EMS,y_case_EMS,
					   car_case_non_cochee,car_case_cochee,car_case_appuyee,
					   coul_case_act,coul_case_inact);

 {initialise les double-flches  }
 fl_vit_sou_b  .Definit(0,x_fl_vit_sou	,y_fl_vit_sou,car_fl2_b,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);
 fl_vit_sou_h  .Definit(0,x_fl_vit_sou+3,y_fl_vit_sou,car_fl2_h,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);

 fl_eco_b	   .Definit(0,x_fl_eco	,y_fl_eco,car_fl2_b,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);
 fl_eco_h	   .Definit(0,x_fl_eco+3,y_fl_eco,car_fl2_h,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);

 fl_pal_R_b	   .Definit(0,x_fl_pal_R  ,y_fl_pal_R,car_fl2_b,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);
 fl_pal_R_h	   .Definit(0,x_fl_pal_R+3,y_fl_pal_R,car_fl2_h,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);

 fl_pal_V_b	   .Definit(0,x_fl_pal_V  ,y_fl_pal_V,car_fl2_b,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);
 fl_pal_V_h	   .Definit(0,x_fl_pal_V+3,y_fl_pal_V,car_fl2_h,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);

 fl_pal_B_b	   .Definit(0,x_fl_pal_B  ,y_fl_pal_B,car_fl2_b,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);
 fl_pal_B_h	   .Definit(0,x_fl_pal_B+3,y_fl_pal_B,car_fl2_h,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);

 fl_vol_def_b  .Definit(0,x_fl_vol_def	,y_fl_vol_def,car_fl2_b,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);
 fl_vol_def_h  .Definit(0,x_fl_vol_def+3,y_fl_vol_def,car_fl2_h,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);

 fl_Introscan_b.Definit(0,x_fl_Introscan  ,y_fl_Introscan,car_fl2_b,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);
 fl_Introscan_h.Definit(0,x_fl_Introscan+3,y_fl_Introscan,car_fl2_h,
						FALSE,base_delai_fl2,coul_fl2_bord,coul_fl2_fl);

 tmp_config:=cfg_interface;
 anc_config:=nbr_configs+1; {pour forcer affichage des rglages}
 defile:=FALSE;

 repeat
  CacheCursSouris;

  for i:=0 to nbr_configs-1 do
   if (i<>tmp_config) then AfficheNomConfig(i,normal);
  AfficheNomConfig(tmp_config,inverse);

  {raffiche les cadres/textes des rglages}
  if tmp_config<>anc_config then begin
	AttendVBL;
	EffaceZone(0,xg_fond_regl_config,yh_fond_regl_config,xd_fond_regl_config,yb_fond_regl_config,16*or_fond+blanc);

	case tmp_config of
	 cfg_interface:
	  begin
	   {vitesse souris}
	   CadreOmbre(x_cadre_vit_sou,y_cadre_vit_sou,
				  x_cadre_vit_sou+larg_cadre_vit_sou-1,y_cadre_vit_sou+haut_cadre_vit_sou-1,concave);
	   AffChXY(0,x_txt_vit_sou,y_txt_vit_sou,txt_vit_sou[Langue],16*or_fond+noir);
	   fl_vit_sou_b.Affiche; fl_vit_sou_h.Affiche;
	   CacheCursSouris;

	   {palette}
	   CadreOmbre(x_cadre_pal,y_cadre_pal,
				  x_cadre_pal+larg_cadre_pal-1,y_cadre_pal+haut_cadre_pal-1,concave);
	   AffChXY(0,x_txt_pal,y_txt_pal,txt_pal,16*or_fond+noir);
	   for i:=1 to 3 do
		AffChXY(0,x_txt_pal_R,y_txt_pal_R+i-1,txt_pal_RVB[Langue,i],16*or_fond+or_clair);
	   fl_pal_R_b.Affiche; fl_pal_R_h.Affiche;
	   fl_pal_V_b.Affiche; fl_pal_V_h.Affiche;
	   fl_pal_B_b.Affiche; fl_pal_B_h.Affiche;
	   CacheCursSouris;

	   {conomiseur}
	   CadreOmbre(x_cadre_eco,y_cadre_eco,
				  x_cadre_eco+larg_cadre_eco-1,y_cadre_eco+haut_cadre_eco-1,concave);
	   AffChXY(0,x_txt_eco,y_txt_eco,txt_eco[Langue],16*or_fond+noir);
	   AffChXY(0,x_txt_min_eco,y_txt_min_eco,txt_min_eco,16*or_fond+or_clair);
	   fl_eco_b.Affiche; fl_eco_h.Affiche;
	   CacheCursSouris;
	  end;

	 cfg_repertoire:
	  begin
	   {Autoscan/Autosave}
	   CadreOmbre(x_cadre_auto,y_cadre_auto,
				  x_cadre_auto+larg_cadre_auto-1,y_cadre_auto+haut_cadre_auto-1,concave);
	   AffChXY(0,x_donnees_mod,y_donnees_mod,txt_donnees_mod[Langue],16*or_fond+noir);
	   AffChXY(0,x_txt_autoscan,y_txt_autoscan,txt_autoscan,16*or_fond+or_clair);
	   AffChXY(0,x_txt_autosave,y_txt_autosave,txt_autosave,16*or_fond+or_clair);

	   {option 4DOS}
	   CadreOmbre(x_cadre_opt_4Dos,y_cadre_opt_4Dos,
				  x_cadre_opt_4Dos+larg_cadre_opt_4Dos-1,y_cadre_opt_4Dos+haut_cadre_opt_4Dos-1,concave);
	   AffChXY(0,x_opt_4Dos,y_opt_4Dos,txt_opt_4Dos[Langue],16*or_fond+noir);
	   AffChXY(0,x_txt_Desc,y_txt_Desc,txt_Desc,16*or_fond+or_clair);

	   {archives}
	   CadreOmbre(x_cadre_arch,y_cadre_arch,
				  x_cadre_arch+larg_cadre_arch-1,y_cadre_arch+haut_cadre_arch-1,concave);
	   AffChXY(0,x_arch,y_arch,txt_arch,16*or_fond+noir);
	   AffChXY2(0,x_txt_ARJ,y_txt_ARJ,Extensions[ext_ARJ]+' ^('+txt_ARJ2+')',16*or_fond+or_clair,16*or_fond+or_sombre);
	   AffChXY2(0,x_txt_LZH,y_txt_LZH,Extensions[ext_LZH]+' ^('+txt_LZH2+')',16*or_fond+or_clair,16*or_fond+or_sombre);
	   AffChXY2(0,x_txt_RAR,y_txt_RAR,Extensions[ext_RAR]+' ^('+txt_RAR2+')',16*or_fond+or_clair,16*or_fond+or_sombre);
	   AffChXY2(0,x_txt_ZIP,y_txt_ZIP,Extensions[ext_ZIP]+' ^('+txt_ZIP2+')',16*or_fond+or_clair,16*or_fond+or_sombre);
	  end;

	 cfg_son:
	  begin
	   {volume par dfaut}
	   CadreOmbre(x_cadre_vol_def,y_cadre_vol_def,
				  x_cadre_vol_def+larg_cadre_vol_def-1,y_cadre_vol_def+haut_cadre_vol_def-1,concave);
	   AffChXY(0,x_txt_vol_def,y_txt_vol_def,txt_vol_def[Langue],16*or_fond+noir);
	   fl_vol_def_b.Affiche; fl_vol_def_h.Affiche;
	   CacheCursSouris;

	   {options module}
	   CadreOmbre(x_cadre_opt_mod,y_cadre_opt_mod,
				  x_cadre_opt_mod+larg_cadre_opt_mod-1,y_cadre_opt_mod+haut_cadre_opt_mod-1,concave);
	   AffChXY(0,x_txt_opt_mod,y_txt_opt_mod,txt_opt_mod[Langue],16*or_fond+noir);
	   for i:=1 to 4 do
		AffChXY(0,x_txt_fine,y_txt_fine+i-1,txt_opt_mod2[i],16*or_fond+or_clair);

	   {interpolation}
	   CadreOmbre(x_cadre_interpol,y_cadre_interpol,
				  x_cadre_interpol+larg_cadre_interpol-1,y_cadre_interpol+haut_cadre_interpol-1,concave);
	   AffChXY(0,x_txt_interpol,y_txt_interpol,txt_interpol,16*or_fond+or_clair);

	   {dure Introscan}
	   CadreOmbre(x_cadre_Introscan,y_cadre_Introscan,
				  x_cadre_Introscan+larg_cadre_Introscan-1,y_cadre_Introscan+haut_cadre_Introscan-1,concave);
	   AffChXY(0,x_txt_Introscan,y_txt_Introscan,txt_Introscan,16*or_fond+noir);
	   fl_Introscan_b.Affiche; fl_Introscan_h.Affiche;
	   CacheCursSouris;
	  end;

	 cfg_divers:
	  begin
	   {mmoire}
	   CadreOmbre(x_cadre_mem,y_cadre_mem,
				  x_cadre_mem+larg_cadre_mem-1,y_cadre_mem+haut_cadre_mem-1,concave);
	   AffChXY(0,x_txt_mem,y_txt_mem,txt_mem[Langue],16*or_fond+noir);
	   AffChXY(0,x_txt_UMB,y_txt_UMB,txt_UMB,16*or_fond+or_clair);
	   AffChXY(0,x_txt_EMS,y_txt_EMS,txt_EMS,16*or_fond+or_clair);
	  end;
	end;
	anc_config:=tmp_config
  end;

  {raffiche les valeurs des rglages}
  case tmp_config of
   cfg_interface:
	begin
	 {vitesse souris}
	 AffChXY(0,x_vit_sou,y_vit_sou,EntierTexte2(tmp_sensib_sou,3),16*or_fond+gris_fonce);

	 {palette}
	 AffChXY(0,x_val_pal_R,y_val_pal_R,EntierTexteSigne(tmp_corr_R),16*or_fond+gris_fonce);
	 AffChXY(0,x_val_pal_V,y_val_pal_V,EntierTexteSigne(tmp_corr_V),16*or_fond+gris_fonce);
	 AffChXY(0,x_val_pal_B,y_val_pal_B,EntierTexteSigne(tmp_corr_B),16*or_fond+gris_fonce);

	 {conomiseur}
	 with case_eco do begin Coche(tmp_UtEco); Affiche end;
	 CacheCursSouris;
	 AffCarXY(0,x_val_eco,y_val_eco,CHAR(48+tmp_delai_eco),16*or_fond+gris_fonce);
	end;

   cfg_repertoire:
	begin
	 {Autoscan/Autosave}
	 with case_Autoscan do begin Coche(tmp_Autoscan); Affiche end;
	 with case_Autosave do begin Coche(tmp_Autosave); Affiche end;

	 {option 4DOS}
	 with case_Desc do begin Active(_4DOS); Coche(tmp_cree_Desc); Affiche end;

	 {archives}
	 with case_ARJ do begin Coche(tmp_scan_ARJ); Affiche end;
	 with case_LZH do begin Coche(tmp_scan_LZH); Affiche end;
	 with case_RAR do begin Coche(tmp_scan_RAR); Affiche end;
	 with case_ZIP do begin Coche(tmp_scan_ZIP); Affiche end;

	 CacheCursSouris;
	end;

   cfg_son:
	begin
	 {volume par dfaut}
	 AffChXY(0,x_vol_def,y_vol_def,EntierTexte2(tmp_vol_def,3)+'%',16*or_fond+gris_fonce);

	 {options module}
	 with case_fine do begin Coche(tmp_UtFine); Affiche end;
	 with case_pann do begin Coche(tmp_UtPann); Affiche end;
	 with case_BPM	do begin Coche(tmp_UtBPM) ; Affiche end;
	 CacheCursSouris;
	 AffCarXY(0,x_oct_mod,y_oct_mod,CHAR(48+tmp_oct_mod),16*or_fond+gris_fonce);

	 {interpolation}
	 with case_interpol do begin Coche(tmp_UtInt); Affiche end;
	 CacheCursSouris;

	 {dure Introscan}
	 AffChXY(0,x_val_Introscan,y_val_Introscan,EntierTexte2(tmp_duree,2)+'s',16*or_fond+gris_fonce);
	end;

   cfg_divers:
	begin
	 {mmoire}
	 with case_UMB do begin Active(UMB_Presente); Coche(tmp_UtUMB); Affiche end;
	 with case_EMS do begin Active(EMS_Presente); Coche(tmp_UtEMS); Affiche end;
	 CacheCursSouris;
	end;
  end;

  AttendClavierSouris(not defile,FALSE,x,y);
  defile:=FALSE;

  if KeyPressed then begin
	touche:=ReadKey;
	case touche of
	 Up		  : if tmp_config>0 then dec(tmp_config);
	 Down	  : if tmp_config<nbr_configs-1 then inc(tmp_config);
	 PgUp,Home: tmp_config:=0;
	 PgDn,End_: tmp_config:=nbr_configs-1;
	end;
	if touche>255 then touche:=0; {pour viter que les codes tendus activent un bouton}

	ok:=(touche=Enter) or boutonOK.Appuye(CHAR(touche));
	sortie:=(touche=Esc) or boutonAnnuler.Appuye(CHAR(touche));
  end

  else begin {souris...}

	if (x in [x_nom_config_1-1..x_nom_config_1+larg_cadre_configs-4]) and
	   (y in [y_nom_config_1..y_nom_config_1+nbr_configs-1]) then tmp_config:=y-y_nom_config_1;

	case tmp_config of
	 cfg_interface :
	  begin
	   {vitesse souris}
	   if fl_vit_sou_b.Clique and (tmp_sensib_sou>sensib_souris_min) then begin
		 dec(tmp_sensib_sou);
		 SensibiliteSouris(tmp_sensib_sou,tmp_sensib_sou,10);
		 defile:=TRUE;
	   end
	   else
	   if fl_vit_sou_h.Clique and (tmp_sensib_sou<sensib_souris_max) then begin
		 inc(tmp_sensib_sou);
		 SensibiliteSouris(tmp_sensib_sou,tmp_sensib_sou,10);
		 defile:=TRUE;
	   end
	   else

	   {palette}
	   if fl_pal_R_b.Clique and (tmp_corr_R>corr_R_min) then begin
		 dec(tmp_corr_R);
		 CorrigePalette(tmp_corr_R,tmp_corr_V,tmp_corr_B,TRUE);
		 defile:=TRUE;
	   end
	   else
	   if fl_pal_R_h.Clique and (tmp_corr_R<corr_R_max) then begin
		 inc(tmp_corr_R);
		 CorrigePalette(tmp_corr_R,tmp_corr_V,tmp_corr_B,TRUE);
		 defile:=TRUE;
	   end
	   else

	   if fl_pal_V_b.Clique and (tmp_corr_V>corr_V_min) then begin
		 dec(tmp_corr_V);
		 CorrigePalette(tmp_corr_R,tmp_corr_V,tmp_corr_B,TRUE);
		 defile:=TRUE;
	   end
	   else
	   if fl_pal_V_h.Clique and (tmp_corr_V<corr_V_max) then begin
		 inc(tmp_corr_V);
		 CorrigePalette(tmp_corr_R,tmp_corr_V,tmp_corr_B,TRUE);
		 defile:=TRUE;
	   end
	   else

	   if fl_pal_B_b.Clique and (tmp_corr_B>corr_B_min) then begin
		 dec(tmp_corr_B);
		 CorrigePalette(tmp_corr_R,tmp_corr_V,tmp_corr_B,TRUE);
		 defile:=TRUE;
	   end
	   else
	   if fl_pal_B_h.Clique and (tmp_corr_B<corr_B_max) then begin
		 inc(tmp_corr_B);
		 CorrigePalette(tmp_corr_R,tmp_corr_V,tmp_corr_B,TRUE);
		 defile:=TRUE;
	   end
	   else

	   {conomiseur}
	   if case_eco.Cliquee then tmp_UtEco:=not(tmp_UtEco)
	   else
	   if fl_eco_b.Clique and (tmp_delai_eco>1) then begin dec(tmp_delai_eco); defile:=TRUE; end
	   else
	   if fl_eco_h.Clique and (tmp_delai_eco<5) then begin inc(tmp_delai_eco); defile:=TRUE; end;
	  end;

	 cfg_repertoire:
	  begin
	   {Autoscan/Autosave}
	   if case_Autoscan.Cliquee then begin
		 tmp_Autoscan:=not(tmp_Autoscan);
		 if not(tmp_Autoscan) then tmp_Autosave:=FALSE;
	   end
	   else
	   if case_Autosave.Cliquee then begin
		 tmp_Autosave:=not(tmp_Autosave);
		 if tmp_Autosave then tmp_Autoscan:=TRUE;
	   end
	   else

	   {option 4DOS}
	   if case_Desc.Cliquee then tmp_cree_Desc:=not(tmp_cree_Desc)
	   else

	   {archives}
	   if case_ARJ.Cliquee then tmp_scan_ARJ:=not(tmp_scan_ARJ)
	   else
	   if case_LZH.Cliquee then tmp_scan_LZH:=not(tmp_scan_LZH)
	   else
	   if case_RAR.Cliquee then tmp_scan_RAR:=not(tmp_scan_RAR)
	   else
	   if case_ZIP.Cliquee then tmp_scan_ZIP:=not(tmp_scan_ZIP)
	  end;

	 cfg_son:
	  begin
	   {volume par dfaut}
	   if fl_vol_def_b.Clique and (tmp_vol_def>	 1) then begin dec(tmp_vol_def); defile:=TRUE end
	   else
	   if fl_vol_def_h.Clique and (tmp_vol_def<100) then begin inc(tmp_vol_def); defile:=TRUE end
	   else

	   {options module}
	   if case_fine.Cliquee then tmp_UtFine:=not(tmp_UtFine)
	   else
	   if case_pann.Cliquee then tmp_UtPann:=not(tmp_UtPann)
	   else
	   if case_BPM .Cliquee then tmp_UtBPM :=not(tmp_UtBPM )
	   else
	   if (x in [x_oct_mod-1..x_oct_mod+1]) and (y=y_oct_mod) then tmp_oct_mod:=8-tmp_oct_mod
	   else

	   {interpolation}
	   if case_interpol.Cliquee then tmp_UtInt:=not(tmp_UtInt)
	   else

	   {dure Introscan}
	   if fl_Introscan_b.Clique and (tmp_duree> 2) then begin dec(tmp_duree); defile:=TRUE; end
	   else
	   if fl_Introscan_h.Clique and (tmp_duree<30) then begin inc(tmp_duree); defile:=TRUE; end;
	  end;

	 cfg_divers:
	  begin
	   {mmoire}
	   if case_UMB.Cliquee then tmp_UtUMB:=not(tmp_UtUMB)
	   else
	   if case_EMS.Cliquee then tmp_UtEMS:=not(tmp_UtEMS);
	  end;
	end;

	ok:=boutonOK.Clique;
	sortie:=boutonAnnuler.Clique;
	if defile then DelaiBoutonSouris(10)
  end
 until ok or sortie;

 if ok then begin {sauve les nouvelles valeurs}
   sensib_souris:=tmp_sensib_sou;
   corr_R:=tmp_corr_R;
   corr_V:=tmp_corr_V;
   corr_B:=tmp_corr_B;
   Utilise_Economiseur:=tmp_utEco;
   delai_economiseur:=tmp_delai_eco;

   Autoscan:=tmp_Autoscan;
   Autosave:=tmp_Autosave;

   cree_Desc:=tmp_cree_Desc;

   scan_ARJ:=tmp_scan_ARJ;
   scan_LZH:=tmp_scan_LZH;
   scan_RAR:=tmp_scan_RAR;
   scan_ZIP:=tmp_scan_ZIP;

   Volume_par_defaut:=5*tmp_vol_def;
   with Variables^ do begin
	 Utiliser_Fine		   :=tmp_utFine;
	 Utiliser_Panning	   :=tmp_utPann;
	 Utiliser_BPM		   :=tmp_utBPM;
	 Utiliser_Interpolation:=tmp_utInt
   end;
   Nb_Octaves_MOD:=tmp_oct_mod;
   duree_IntroScan:=tmp_duree;

   Utilise_UMB:=tmp_utUMB;
   Utilise_EMS:=tmp_utEMS;

   recharge_module:=TRUE; {paramtres changs -> recharger le module si rejou}
 end;

 SensibiliteSouris(sensib_souris,sensib_souris,10);
 CorrigePalette(corr_R,corr_V,corr_B,TRUE);

 RestaureZoneSuppr(0,z);

end; {ChangeConfig}

{----------------------------------------------------------}

procedure Aide;

const S_VIDE: STRING[1]='';

	  {texte anglais}
	  S_A_01: STRING[50+2*6]='^^/^^ ^Page^/^Page^ ^Home^/^end^  Move the module selector';
	  S_A_02: STRING[52+2*4]='^Ctrl^+^Page^/^Ctrl^+^Page^     Scroll the list of modules';
	  S_A_03: STRING[57+2*2]='^Shift^+<^initial^>  Find a module name starting with initial';
	  S_A_04: STRING[56+2*1]='^Tab^  Swap the module-info display: title/size and volume';
	  S_A_05: STRING[52+2*2]='^^  Play the selected module (or left ^mouse^ button)';
	  S_A_06: STRING[60+2*2]='^Space^  Add/Remove the module from the playlist (or ^right^ bt)';
	  S_A_07: STRING[56+2*2]='^'#27'^/^'#26'^    Find the previous/next module within the playlist'; {<- car. spciaux !}
	  S_A_08: STRING[53+2*2]='^-^/^+^      Decrease/Increase the selected module volume';
	  S_A_09: STRING[50+2*1]='^'#27'Del^     set default volume to the selected module'; {<- car. spciaux !}
	  S_A_10: STRING[59+2*2]='^Ctrl^+^^ set default volume to all modules in the directory';
	  S_A_11: STRING[44+2*1]='^Del^     Delete the selected module from disk';
	  S_A_12: STRING[56+2*2]='^Ctrl^+^V^  Launch a CPU-speed test with the selected module';
	  S_A_13: STRING[32+2*2]='^Alt^+<^drive^>  Change active drive';
	  S_A_14: STRING[23+2*1]='^Esc^     exit Mod Master';

	  {texte franais}
	  S_F_01: STRING[57+2*6]='^^/^^ ^Page^/^Page^ ^Dbut^/^Fin^  Dplace le slecteur de module';
	  S_F_02: STRING[59+2*4]='^Ctrl^+^Page^/^Ctrl^+^Page^      Fait dfiler la liste de modules';
	  S_F_03: STRING[50+2*2]='^Maj^+<^initiale^>  Cherche un module par son initiale';
	  S_F_04: STRING[55+2*1]='^Tab^  Change l''affichage d''infos: titre/taille et volume'; {<- guillemets !}
	  S_F_05: STRING[57+2*2]='^^  Joue le module slectionn (ou bouton ^gauche^ souris)';
	  S_F_06: STRING[60+2*2]='^Espace^ Ajoute/Retire le module du programme (ou bout. ^droit^)';
	  S_F_07: STRING[60+2*2]='^'#27'^/^'#26'^    Cherche le module prcdent/suivant dans le programme'; {<- car. spciaux !}
	  S_F_08: STRING[57+2*2]='^-^/^+^      Diminue/Augmente le volume du module slectionn';
	  S_F_09: STRING[60+2*1]='^'#27'Suppr^   Applique le volume par dfaut au module slectionn'; {<- car. spciaux !}
	  S_F_10: STRING[57+2*2]='^Ctrl^+^^ Applique le volume par dfaut  tous les modules';
	  S_F_11: STRING[48+2*1]='^Suppr^   Supprime le module slectionn du disque';
	  S_F_12: STRING[59+2*2]='^Ctrl^+^V^  Lance un test de vitesse CPU avec le module slect.';
	  S_F_13: STRING[38+2*2]='^Alt^+<^lecteur^>  Change de lecteur actif';
	  S_F_14: STRING[25+2*1]='^Echap^   Quitte Mod Master';

	  nbr_lignes_aide=23;
	  Aide_txt: array[langues,1..nbr_lignes_aide] of ^STRING
				=((@S_A_01,
				   @S_A_02,@S_VIDE,
				   @S_A_03,@S_VIDE,
				   @S_A_04,@S_VIDE,
				   @S_A_05,@S_VIDE,
				   @S_A_06,
				   @S_A_07,@S_VIDE,
				   @S_A_08,
				   @S_A_09,
				   @S_A_10,@S_VIDE,
				   @S_A_11,@S_VIDE,
				   @S_A_12,@S_VIDE,
				   @S_A_13,@S_VIDE,
				   @S_A_14),

				  (@S_F_01,
				   @S_F_02,@S_VIDE,
				   @S_F_03,@S_VIDE,
				   @S_F_04,@S_VIDE,
				   @S_F_05,@S_VIDE,
				   @S_F_06,
				   @S_F_07,@S_VIDE,
				   @S_F_08,
				   @S_F_09,
				   @S_F_10,@S_VIDE,
				   @S_F_11,@S_VIDE,
				   @S_F_12,@S_VIDE,
				   @S_F_13,@S_VIDE,
				   @S_F_14)
				 );

var z: Zone;
	i: BYTE;

begin
 CacheCursSouris;
 z.Sauve(0,xg_fen_aide,yh_fen_aide,xd_fen_aide,yb_fen_aide);
 ZoomFenetreOmbre(xg_fen_aide,yh_fen_aide,xd_fen_aide,yb_fen_aide,encadre);

 {logo}
 for i:=1 to hauteur_logo_aide do
  Move(Logo_Mod_Master_Aide[1+(i-1)*largeur_logo_aide],PtrVRAM(0,x_logo_aide,y_logo_aide+i-1)^,2*largeur_logo_aide);

 AffChXYc(yh_fen_aide+6,copyright,16*or_fond+noir);

 {cadre lignes d'aide}
 CadreOmbre(x_cadre_lst_aide,y_cadre_lst_aide,
			x_cadre_lst_aide+larg_cadre_lst_aide-1,y_cadre_lst_aide+haut_cadre_lst_aide-1,concave);

 {texte d'aide}
 for i:=1 to nbr_lignes_aide do
  AffChXY2(0,x_aide_1,y_aide_1+(i-1),Aide_txt[Langue,i]^,16*or_fond+gris_fonce,16*or_fond+or_clair);

 AffCursSouris;

 ReadKey;

 RestaureZoneSuppr(0,z);
end; {Aide}

{----------------------------------------------------------}

procedure FonduProgressif;

const nombre_lignes=22;

	  gris: RVB=(R:42;V:42;B:42);
	  noir: RVB=(R: 0;V: 0;B: 0);

var palette: array[1..nombre_lignes] of RVB;
	i,j,k,hfc,couleur_max: BYTE;
	freq_coul: array[0..15] of WORD;
	a: WORD;

begin
 asm cli end;
 FillChar(palette,sizeof(palette),42);
 FillChar(freq_coul,sizeof(freq_coul),0);
 for a:=1 to 80*50 do inc(freq_coul[Mem[$B800:1+2*(a-1)] and $0F]);
 couleur_max:=0;
 for i:=0 to 15 do
  if freq_coul[i]>freq_coul[couleur_max] then couleur_max:=i;

 AttendVBL;
 for i:=0 to 15 do if i<>couleur_max then FixeDAC(i,noir);

 asm
  mov DX,CRTControl
  mov AL,MaxScanLine
  out DX,AL
  inc DL
  in AL,DX
  inc AL
  and AL,00011111b
  mov hfc,AL		{hauteur fonte courante}
 end;

 for i:=0 to 3*nombre_lignes do begin
   with palette[1] do begin
	 if R>0 then dec(R);
	 if V>0 then dec(V);
	 if B>0 then dec(B)
   end;
   Move(palette[1],palette[2],3*(nombre_lignes-1));
   AttendVBL2;
   for j:=1 to nombre_lignes do begin
	 FixeDAC(couleur_max,palette[j]);
	 for k:=1 to hfc do AttendHBL2
   end
 end;

{ AttendVBL;
 FixeDAC(couleur_max,gris);}
 asm sti end
end; {FonduProgressif}

{----------------------------------------------------------}

procedure AfficheLogoDebut;

const Y_MOD=30;
	  beta=0.18;
	  i0=Round(PI/2/beta)-2;

var i: BYTE;

begin
 InitTexte(50);
 Curseur(off);
 LargeurCar(8);
 Clignotement(FALSE);

 palette_noire.Fixe;

 DecompLZMem(Logo_MOD_3D,PtrVRAM(0,1,Y_MOD)^);
 DecompLZMem(Logo_MASTER_3D,PtrVRAM(0,1,1)^);

 SetStartAddr(2*largeur_ecran_txt*(Y_MOD-10));
 SetLineCompare(400);

 fonte_ModM.Redef(0);
 palette_ModM.Fixe;

 for i:=0 to 63 do PlaceEcran(0,dy_MOD1_3D[i]);
 Pause(4);

 for i:=0 to 63 do begin
   AttendVBL2;
   SetLineCompare(dy_MASTER_3D[i]);
   if i>=i0 then PlaceEcran(0,dy_MOD_3D[i])
 end;

 if not(KeyPressed) then Pause(18);
 palette_noire.Fondu(32)
end; {AfficheLogoDebut}

{----------------------------------------------------------}

procedure AffichePageFin;

const {variations de coordonnes pour la 'chute' de l'cran}
	  dy: array[0..48] of WORD=(
	  $0190,$0183,$0176,$0169,$015C,$014F,$0142,$0135,$0128,$011C,$010F,$0103,$00F7,$00EB,$00DF,
	  $00D3,$00C8,$00BD,$00B2,$00A7,$009C,$0092,$0088,$007F,$0075,$006C,$0063,$005B,$0053,$004B,
	  $0043,$003C,$0036,$002F,$0029,$0024,$001E,$001A,$0015,$0011,$000E,$000A,$0008,$0006,$0004,
	  $0003,$0002,$0001,$0000);

	  {texte anglais}
	  S_A_01: STRING[73+2*1]='This program is released as ^shareware^ !  if you like it and use it often,';
	  S_A_02: STRING[72+2*1]='you have the ^moral^ obligation to pay in return a modest amount, in order';
	  S_A_03: STRING[66+2*0]='to encourage its authors to carry on their efforts to create other';
	  S_A_04: STRING[15+2*0]='versions of it.';
	  S_A_05: STRING[71+2*2]='Please register in sending your contribution of ^80 FRF^ or ^$16^ to one of';
	  S_A_06: STRING[24+2*0]='the following addresses:';

	  S_A_07: STRING[71+2*0]='This program is a registered version, you are not allowed to distribute';
	  S_A_08: STRING[19+2*0]='it in whatever way.';
	  S_A_09: STRING[69+2*0]='You must not either modify the files supplied with it (executable and';
	  S_A_10: STRING[16+2*0]='documentations).';

	  {textes franais}
	  S_F_01: STRING[73+2*1]='Ce programme est diffus en ^shareware^ !  S''il vous satisfait et vous sert'; {<- guillemets!}
	  S_F_02: STRING[73+2*1]='rgulirement, vous avez l''obligation ^morale^ de payer en retour une somme'; {<- guillemets!}
	  S_F_03: STRING[73+2*0]='modeste, afin d''encourager ses auteurs  poursuivre leurs efforts pour en'; {<- guillemets!}
	  S_F_04: STRING[27+2*0]='produire d''autres versions.';
	  S_F_05: STRING[71+2*2]='Veuillez vous faire enregistrer en envoyant votre participation de ^80 FRF^';
	  S_F_06: STRING[31+2*0]=' l''une des adresses suivantes:'; {<- guillemets!}

	  S_F_07: STRING[71+2*0]='Ce programme est une version enregistre, vous n''tes pas autoris  le'; {<- guillemets!}
	  S_F_08: STRING[42+2*0]='distribuer sous quelque forme que ce soit.';
	  S_F_09: STRING[71+2*0]='Vous ne devez pas non plus modifier les fichiers fournis (excutable et';
	  S_F_10: STRING[16+2*0]='documentations).';

	  {textes VERSION NON ENREGISTREE}
	  hauteur_Message=6;
	  Message_txt: array[langues,1..hauteur_Message] of ^STRING
	   =((@S_A_01,@S_A_02,@S_A_03,@S_A_04,@S_A_05,@S_A_06),
		 (@S_F_01,@S_F_02,@S_F_03,@S_F_04,@S_F_05,@S_F_06));

	  {textes VERSION ENREGISTREE}
	  hauteur_Message_REG=4;
	  Message_txt_REG: array[langues,1..hauteur_Message_REG] of ^STRING
	   =((@S_A_07,@S_A_08,@S_A_09,@S_A_10),
		 (@S_F_07,@S_F_08,@S_F_09,@S_F_10));

	  Merci_txt: array[langues] of STRING[45]
	   =('    -->  Thanks for registering !!  <--',
		 '-->  Merci de vous tre enregistr !!  <--');

	  UNREGISTERED_txt: array[langues,1..2] of STRING[15]
	   =((' UNREGISTERED',
		  '  VERSION    '),
		 ('    VERSION    ',
		  'NON ENREGISTREE'));

	  Attr_inverse: array[1..hauteur_Message] of BYTE=(142,10,15,15,14,15);

	  couleur: array[0..9] of BYTE=(9,11,15,14,11,10,2,7,8,0);

var i,secondes: BYTE;
	fin_rapide: BOOLEAN;


procedure RefletCadre(xg,yh,xd,yb,couleur,couleur_reflet: BYTE);
var x_h,y_h,x_b,y_b,
	anc_x_h,anc_y_h,anc_x_b,anc_y_b: BYTE;
begin
 x_h:=xg; y_h:=yh; x_b:=xg; y_b:=yh;
 anc_x_h:=x_h; anc_y_h:=y_h; anc_x_b:=x_b; anc_y_b:=y_b;

 repeat
  AttendVBL2;
  Mem[$B800:1+2*((anc_x_h-1)+80*(anc_y_h-1))]:=couleur;
  Mem[$B800:1+2*((anc_x_b-1)+80*(anc_y_b-1))]:=couleur;
  anc_x_h:=x_h; anc_y_h:=y_h; anc_x_b:=x_b; anc_y_b:=y_b;
  Mem[$B800:1+2*((x_h-1)+80*(y_h-1))]:=couleur_reflet;
  Mem[$B800:1+2*((x_b-1)+80*(y_b-1))]:=couleur_reflet;
  if x_h<xd then inc(x_h) else inc(y_h);
  if y_b<yb then inc(y_b) else inc(x_b)
 until (x_h=xd) and (y_h=yb);

 AttendVBL2;
 Mem[$B800:1+2*((anc_x_h-1)+80*(anc_y_h-1))]:=couleur;
 Mem[$B800:1+2*((anc_x_b-1)+80*(anc_y_b-1))]:=couleur
end; {RefletCadre}


begin  {AffichePageFin}
 if erreur_fin=0 then begin
   InitTexte(25);
   Curseur(off);
   PlaceEcran(0,400);
   AttendVBL;

   DecompLZMem(Logo_Mod_Master,PtrVRAM(0,1,2)^);

   Cadre(0,1,2,1,80,19,7,'',0,'');
   LigneVerticale(0,2,80,2,18,7);
   LigneHorizontale(0,2,19,3,79,7);
   AffCarXY(0,80, 1,'',7);
   AffCarXY(0, 2,19,'',7);
   AffCarXY(0,80,19,'',7);
   AffChXY(0, 6, 6,'v'+version,12);
   AffChXY(0,14, 6,copyright,11);

   if REGISTERED then begin
	 for i:=1 to hauteur_Message_REG do
	  AffChXY(0,5,i+7,Message_txt_REG[Langue,i]^,15);
	 AffChXY(0,20,13,Merci_txt[Langue],14);
   end
   else
	for i:=1 to hauteur_Message do
	 AffChXY2(0,5,i+7,Message_txt[Langue,i]^,15,Attr_inverse[i]);

   AffChXY(0,17,15,		'Freddy Vtel'     ,11);
   AffChXY(0,19,16,		  'La Pohure'      ,11);
   AffChXY(0,12,17,'49530 Bouzill / FRANCE',11);
   AffChXY(0,16,18,	   'FreddyVe@aol.com'   ,11);

   AffChXY(0,45,15,		'Fabrice Couteau'      ,11);
   AffChXY(0,46,16,		 '47 rue Littr'       ,11);
   AffChXY(0,42,17,	 '44100 Nantes / FRANCE'   ,11);
   AffChXY(0,40,18,'Fabrice.Couteau@wanadoo.fr',11);

   GotoXY(1,21);

   for i:=0 to 48 do PlaceEcran(0,dy[i]);

   fin_rapide:=FALSE;

   if not REGISTERED then begin
	 secondes:=5;
	 repeat
	  dec(secondes);
	  for i:=0 to 9 do begin
		AffCarXY(0,10,16,CHAR(secondes+48),couleur[i]);
		VideBufferClavier;
		Delay(100);

		{ajoute une seconde d'attente si on appuie sur Esc ou }
		if KeyPressed then
		 if (ReadKey in [Esc,Enter]) and (secondes<9) then
		  begin inc(secondes); VideBufferClavier; end;

		{annule le compte  rebours si on appuie sur Ctrl+Alt}
		if (EtatClavier and (Ctrl+Alt))=Ctrl+Alt then
		 begin fin_rapide:=TRUE; secondes:=0; break; end;
	  end
	 until secondes=0;
	 AffCarXY(0,10,16,' ',0); {efface secondes}

	 for i:=1 to 2 do AffChXY(0,4,15+i,UNREGISTERED_txt[Langue,i],128+12)
   end;

   if not(fin_rapide) then RefletCadre(2,1,80,19,7,15);
 end;

 VideBufferClavier;
 Curseur(plat);
end; {AffichePageFin}

{----------------------------------------------------------}

procedure INT09h; interrupt; {pour l'conomiseur...}
begin
 asm
  pushf
  call anc_INT09h
 end;
 if teste_touche then touche_appuyee:=TRUE
end; {INT09h}

{----------------------------------------------------------}

procedure Economiseur;

const nombre_etoiles=100;
	  nombre_motifs_etoile=12;

	  premier_car_etoile=#16;
	  dernier_car_etoile=CHAR(BYTE(premier_car_etoile)+nombre_motifs_etoile-1);

	  MotifEtoile: array[1..nombre_motifs_etoile] of Binaire8=(
	   ($00,$00,$00,$10,$00,$00,$00,$00),
	   ($00,$00,$00,$18,$18,$00,$00,$00),
	   ($00,$00,$18,$3C,$3C,$18,$00,$00),
	   ($00,$18,$3E,$7E,$7E,$7C,$18,$00),
	   ($18,$7E,$7E,$FF,$FF,$7E,$7E,$18),
	   ($18,$7E,$7A,$AF,$FF,$6E,$7C,$18),
	   ($52,$1C,$7A,$AF,$FD,$6E,$38,$5A),
	   ($04,$58,$2A,$95,$A5,$52,$08,$41),
	   ($98,$45,$10,$25,$80,$44,$11,$08),
	   ($84,$10,$42,$00,$00,$80,$02,$20),
	   ($10,$81,$00,$00,$00,$00,$00,$01),
	   ($00,$00,$00,$00,$00,$00,$00,$00));

	  CouleurEtoile: array[1..nombre_motifs_etoile] of BYTE=
					 (gris,gris,gris,blanc,blanc,blanc,gris,gris,gris,jaune,gris,ombre);

	  tab_smooth: array[0..63] of BYTE=
				  (7,7,7,7,7,7,6,6,6,6,6,5,5,5,5,4,4,4,
				   3,3,3,2,2,2,1,1,1,1,0,0,0,0,
				   0,0,0,0,1,1,1,1,2,2,2,3,3,3,
				   4,4,4,5,5,5,5,6,6,6,6,6,7,7,7,7,7,7);

	  hauteur_logo=10;
	  hauteur_split_haut=hauteur_logo+1;
	  hauteur_split_bas =50-hauteur_split_haut;
	  y_split_haut=hauteur_split_bas+1;
	  y_split_bas =1;

	  largeur_logo_MOD	  =48;
	  position_logo_MOD	  =(80-largeur_logo_MOD) div 2;
	  largeur_espace	  =10;
	  largeur_logo_MASTER =80;
	  position_logo_MASTER=(80-largeur_logo_MASTER) div 2;
	  largeur_virtuelle	  =80+largeur_logo_MOD+largeur_espace+
							  largeur_logo_MASTER+largeur_espace;

var e: Ecran;

	nbr_etoiles_creees,index_scroll,index_smooth: BYTE;
	Etoile: array[1..nombre_etoiles] of record x,y,index_motif: BYTE end;

	mode_init,i: BYTE;


procedure CreeEtoile(index: BYTE);
var xe,ye: BYTE;
begin
 repeat
  xe:=1+Random(largeur_ecran_txt); ye:=1+Random(hauteur_split_bas);
  if not(CHAR(CodeXY(0,xe,ye)) in [premier_car_etoile..dernier_car_etoile]) then begin
	AffCarXY(0,xe,ye,premier_car_etoile,CouleurEtoile[1]);
	with Etoile[index] do begin
	  x:=xe; y:=ye;
	  index_motif:=0; {toile immobile par dfaut}
	end;
	exit
  end
 until FALSE
end; {CreeEtoile}


procedure BougeEtoiles;
var i: BYTE;
begin
 for i:=1 to nombre_etoiles do with Etoile[i] do
  if index_motif<>0 then begin
	inc(index_motif);
	if index_motif<=nombre_motifs_etoile then
	 AffCarXY(0,x,y,CHAR(BYTE(premier_car_etoile)+index_motif-1),CouleurEtoile[index_motif])
	else begin
	  AffCarXY(0,x,y,#0,0); {efface l'toile}
	  CreeEtoile(i)
	end
  end
  else if Random(100)=0 then index_motif:=1
end; {BougeEtoiles}


begin {Economiseur}
 mode_init:=EtatClavier and LEDs; {sauve l'tat des LEDs du clavier}
 DesactiveMode(LEDs);

 CacheCursSouris;
 e.Sauve(0);
 palette_noire.Fondu(auto);
 RedefCar(0,premier_car_etoile,nombre_motifs_etoile,MotifEtoile,binaire);

 InitTexteVirtuel(largeur_virtuelle);
 SetLineCompare(hauteur_car*hauteur_split_haut);
 SetStartAddr(largeur_ecran_txt*(y_split_haut-1));

 DecompLZMem(Logo_MOD_3D,PtrVRAM(0,1,1)^);
 for i:=hauteur_logo downto 1 do
  Move(Mem[$B800:2*(i-1)*80],PtrVRAM(0,80+1-position_logo_MOD,y_split_haut+i)^,2*80);

 DecompLZMem(Logo_MASTER_3D,PtrVRAM(0,1,1)^);
 for i:=hauteur_logo downto 1 do
  Move(Mem[$B800:2*(i-1)*80],PtrVRAM(0,80+largeur_logo_MOD+largeur_espace,y_split_haut+i)^,2*80);

 EffaceZone(0,1,1,largeur_ecran_txt,hauteur_split_bas,0); {efface le fond d'toiles}
 palette_ModM.Fixe;

 SwapIntVec($09,anc_INT09h,@INT09h);
 touche_appuyee:=FALSE;

 nbr_etoiles_creees:=0;
 index_scroll:=0; index_smooth:=0;
 repeat
  SourisBouge:=FALSE;
  AttendVBL2;
  SetStartAddr(index_scroll+largeur_ecran_txt*(y_split_haut-1));
  SmoothVertical(tab_smooth[index_smooth]);
  if nbr_etoiles_creees<nombre_etoiles then begin
	inc(nbr_etoiles_creees);
	CreeEtoile(nbr_etoiles_creees)
  end
  else if (index_scroll mod 5)=0 then BougeEtoiles;
  teste_touche:=FALSE; {car ActiveMode/DesactiveMode appellent INT09h !}
  case index_smooth mod 64 of
	0: ActiveMode(ScrMode);
   32: DesactiveMode(ScrMode)
  end;
  teste_touche:=TRUE;
  index_scroll:=(index_scroll+1) mod largeur_virtuelle;
  index_smooth:=(index_smooth+1) mod 64
 until touche_appuyee or SourisBouge;

 SwapIntVec($09,anc_INT09h,anc_INT09h);

 DesactiveMode(LEDs);

 palette_noire.Fixe;
 InitTexteVirtuel(80);
 SetLineCompare(0);
 SetStartAddr(0);
 SmoothVertical(0);
 RedefCar(0,premier_car_etoile,nombre_motifs_etoile,fonte_ModM.fonte[16],binaire);
 with e do begin Restaure(0); Supprime end;
 palette_ModM.Fondu(auto);

 EtatClavier:=mode_init;
 asm
  mov AH,01h
  int 16h		{actualise l'tat des LEDs du clavier}
 end;
 VideBufferClavier;

 AffCursSouris
end; {Economiseur}

{==========================================================}

END.
